# サンプル整理

# ディレクトリ構成

**基本方針：機能中心に再編成**

基礎的なサンプルをまとめた basic ディレクトリを新たに作成する。

公開版 2020.01 付属サンプルにおいて、物質を表わすディレクトリ名

- Cr
- BaO_Si001
- TMDC

ハイフン（ケバブケース）か？アンダースコア（スネークケース）か？ -> スネークケースに統一

- meta-gga -> meta_gga に変更する
- meta_dynamics

## 機能のまとめ方

basic : 基本サンプル

- Si2
- Si8
- bccFe

surface 分野

- Pt：すでに存在
- H-Si100-p2x1
- workfunc
- esm
- dipole

dynamics 分野

- constraints
- meta_dynamics
- molecular_dynamics
- neb
- FCP
- (dimer_method)

格子の最適化

- stress_correction を unitcell_optimization に統合
- Si_lat も格子の最適化か？マーナハン

ストレスと弾性

- stress を elastic/Si に統合

汎関数など **まとめない**

- Cr : これは PAW のサンプル、ディレクトリ名を変える
- meta_gga
- DFT+U
- TMDC : これも PBEsol など汎関数のサンプル
- hybrid : ハイブリッド汎関数
  - scdft をさらにその傘下に
- vdW
- tddft
- positron
- SpinOrbit；ディレクトリ名がキャメルケース(パスカルケース)
- opencore

dos や band

- PBAND
- pdos
- BaO_Si001 : ldos, aldos
- Unfold

【候補】フォノン

- phonon : ガンマ点
- phband

【検討中】ボルン有効電荷

- born
- uvsor/lattice
- FEF

【候補】ワニエ

- wannier
- wan90

【候補】外部プログラムとの連携

- BoltzTraP
- Bader
- wan90 : 二回目

tools ディレクトリ

- bandkpt.in ; band.pl のオプション指定が大変（パスが長い）

pp ディレクトリ

- 擬ポテンシャル

# キーワード整理

使用するキーワードを統一する。

- tetrahedral : tetrahedron
- cutoff_wf : cke_wavefunctions, che_wf
- wavefunction_solver : wf_solver
- paw : paw_switch
- internal : pucv
- max_force : delta_force
- mesh : mp_index
- on/off : yes/no, 1/0
- automatic など : 0 など (condition)

未統一

- rhombohedral or trigonal

# 正しくない記述の訂正

## 正しくないコメント

Si8 default succession = 3

## 綴りを間違えたキーワード

- atomic_oribitals
- bravis
- tetrahedoral

## namelist の終端

file_names.data にて、&END は終端記号として正しくない。「/」に修正する。

```
&fnames
 F_INP    = './nfinp.data'
 F_POT(1) = '/opt/PHASE-SYSTEM/pp/Si_ggapbe_paw_09.pp'
 F_KPOINT = './kpoint.data'
 F_DYNM   = './nfdynm.data'
 F_CHGT   = './nfchgt.data'
 F_CNST   = './nfinp.cnst.data'
 F_ENF    = './nfefn.data'
 F_ENERG  = './nfenergy.data'
 F_CNTN   = './continue.data'
 F_ZAJ    = './zaj.data'
&end
```

## 無印 davidson

現在利用は推奨されない

H-Si001-p2x1

```
wavefunction_solver{
        solvers{
            #tag   sol    till_n  prec cmix submat
                  davidson   2     off    1 off
                  RMM3      -1      on    1 on
        }
        （省略）
}
```

同サンプルの README

```
SCF
1. do "mpirun ../../bin/phase &"
2. after 20 minutes, SCF calculation will end.
```

# 擬ポテンシャルを統一

原則として、推奨擬ポテンシャルを利用する。マニュアル 411 ページの擬ポテンシャル一覧は正しくない。ソースコード中の`defaultppfiles`に従う。
原則として pp ディレクトリに格納。

例外は、XANES（穴あき）と opencore。

# サンプルの作り直し

適切でないサンプルの問題は、issues に移動。

# 非推奨機能

利用を推奨するけれども、規定値から変更することを推奨しない機能の設定は省く。もしくはその機能を紹介するためのサンプルを作成する。
「非推奨機能」をまとめたサンプルを一つだけ作る（場合がある）。

- 「!#tag」は一見コメントのようであるが、然に非ず。分かりにくいので利用しない。「#tag」を使う。
- 「max_scf_iteration」は理解せずに使うと危険。原則として、サンプルでは使用しない。（本機能が有益なサンプルにおいて、その説明を明記して利用することはこの限りでない）
- deviaton 1.83

# マニュアルとの対応

基本方針：サンプルを優先して修正してから、マニュアルをそれらに合わせる。

基本サンプル（現在の Si2 相当）を、GGA-PBE に変更する。入力ファイルに xctype を記載しない。
LDA のサンプルを別途用意する。

xctype はマニュアルの説明が不十分。LDAPW91 と GGAPBE だけしかないかのよう。
PBEsol, vdw-DF
不一致の場合の説明は、PHASE（/0 ではない）のドキュメントにあり。

# 書式

詳細までは定めない。

# 削除済みサンプル（ファイル）

- 旧 STM
- Si2/scf/input_scf_Si.data
- 中身がない（サイズゼロ）の出力ファイル；例: PBAND/MoS2-WS2/band/nfefn.data など
- DFT+U/LaVO3/orthrombic: AtomWrokには相当する結晶構造が見当たらない。計算の意図が分からない。

素性の怪しい擬ポテンシャルも削除する。

```
$ cd scf
$ mpiexec -n 2 ../../../../../bin/phase
$ cd ../band
$ ../../../../../bin/band_kpoint.pl ../../../../tools/bandkpt_fcc_xglux.in
$ mpiexec -n 2 ../../../../../bin/ekcal ne=2 nk=2
$ ../../../../../bin/band.pl nfenergy.data ../../../../tools/bandkpt_fcc_xglux.in
$ evince band_structure.eps
```

function isSCDFT() result (ret)
  use m_Const_Parameters, only : DRIVER_SC_DFT
  use m_Control_Parameters, only : driver
  implicit none
  logical :: ret
  if (driver /= DRIVER_SC_DFT) then
    ret = .false.
    return
  endif
  ret = .true.
end function isSCDFT

subroutine wd_eps0(nfcntn)
   use m_Control_Parameters, only : epsilon0, epsilon0_previous
   use m_Parallelization, only : mype
   implicit none
   integer, intent(in) :: nfcntn
   character(len('epsilon0')), parameter :: tag_epsilon0 = 'epsilon0'
   if(mype==0) then
      write(nfcntn,*) tag_epsilon0
      write(nfcntn,'(2f10.5)') epsilon0,epsilon0_previous
   end if
end subroutine wd_eps0

subroutine rd_eps0(nfcntn)
   use m_Control_Parameters, only : DP, epsilon0, epsilon0_previous
   use m_Parallelization, only : mype,mpi_comm_group,npes
   use m_Control_Parameters, only : printable, m_CtrlP_set_alpha_exx
   use m_Files, only : nfout
   implicit none
   include 'mpif.h'
   integer, intent(in) :: nfcntn
   logical             :: EOF_reach, tag_is_found
   integer             :: ierr
   real(kind=DP)       :: alp
   integer, parameter  :: len_str = 132
   character(len('epsilon0')), parameter :: tag_epsilon0 = 'epsilon0'
   character*(len_str) :: str
   if(mype == 0)then 
      call rewind_to_tag0(nfcntn,len(tag_epsilon0),tag_epsilon0 &
           &, EOF_reach, tag_is_found, str,len_str)
      if(.not.tag_is_found) then
         stop ' tag_epsilon0 is not found'
      else
         read(nfcntn,*) epsilon0,epsilon0_previous
      endif
   endif
   if(npes>1) then
      call mpi_bcast(epsilon0,1,mpi_double_precision,0,mpi_comm_group,ierr)
      call mpi_bcast(epsilon0_previous,1,mpi_double_precision,0,mpi_comm_group,ierr)
   endif
   if(epsilon0>1e-8) then
      if(printable) &
      & write(nfout,'(a,2f10.5)') ' !!** read epsilon0 and epsilon0_previous : ',epsilon0,epsilon0_previous
      alp = 1.d0/epsilon0
      call m_CtrlP_set_alpha_exx(nfout,alp)
   endif
end subroutine rd_eps0

      SUBROUTINE ZUNGTR( UPLO, N, A, LDA, TAU, WORK, LWORK, INFO )
*
*  -- LAPACK routine (version 3.0) --
*     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
*     Courant Institute, Argonne National Lab, and Rice University
*     June 30, 1999
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LWORK, N
*     ..
*     .. Array Arguments ..
      COMPLEX*16         A( LDA, * ), TAU( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  ZUNGTR generates a complex unitary matrix Q which is defined as the
*  product of n-1 elementary reflectors of order N, as returned by
*  ZHETRD:
*
*  if UPLO = 'U', Q = H(n-1) . . . H(2) H(1),
*
*  if UPLO = 'L', Q = H(1) H(2) . . . H(n-1).
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          = 'U': Upper triangle of A contains elementary reflectors
*                 from ZHETRD;
*          = 'L': Lower triangle of A contains elementary reflectors
*                 from ZHETRD.
*
*  N       (input) INTEGER
*          The order of the matrix Q. N >= 0.
*
*  A       (input/output) COMPLEX*16 array, dimension (LDA,N)
*          On entry, the vectors which define the elementary reflectors,
*          as returned by ZHETRD.
*          On exit, the N-by-N unitary matrix Q.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A. LDA >= N.
*
*  TAU     (input) COMPLEX*16 array, dimension (N-1)
*          TAU(i) must contain the scalar factor of the elementary
*          reflector H(i), as returned by ZHETRD.
*
*  WORK    (workspace/output) COMPLEX*16 array, dimension (LWORK)
*          On exit, if INFO = 0, WORK(1) returns the optimal LWORK.
*
*  LWORK   (input) INTEGER
*          The dimension of the array WORK. LWORK >= N-1.
*          For optimum performance LWORK >= (N-1)*NB, where NB is
*          the optimal blocksize.
*
*          If LWORK = -1, then a workspace query is assumed; the routine
*          only calculates the optimal size of the WORK array, returns
*          this value as the first entry of the WORK array, and no error
*          message related to LWORK is issued by XERBLA.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      COMPLEX*16         ZERO, ONE
      PARAMETER          ( ZERO = ( 0.0D+0, 0.0D+0 ),
     $                   ONE = ( 1.0D+0, 0.0D+0 ) )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            I, IINFO, J, LWKOPT, NB
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            ILAENV
      EXTERNAL           LSAME, ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA, ZUNGQL, ZUNGQR
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input arguments
*
      INFO = 0
      LQUERY = ( LWORK.EQ.-1 )
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      ELSE IF( LWORK.LT.MAX( 1, N-1 ) .AND. .NOT.LQUERY ) THEN
         INFO = -7
      END IF
*
      IF( INFO.EQ.0 ) THEN
         IF( UPPER ) THEN
            NB = ILAENV( 1, 'ZUNGQL', ' ', N-1, N-1, N-1, -1 )
         ELSE
            NB = ILAENV( 1, 'ZUNGQR', ' ', N-1, N-1, N-1, -1 )
         END IF
         LWKOPT = MAX( 1, N-1 )*NB
         WORK( 1 ) = LWKOPT
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'ZUNGTR', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 ) THEN
         WORK( 1 ) = 1
         RETURN
      END IF
*
      IF( UPPER ) THEN
*
*        Q was determined by a call to ZHETRD with UPLO = 'U'
*
*        Shift the vectors which define the elementary reflectors one
*        column to the left, and set the last row and column of Q to
*        those of the unit matrix
*
         DO 20 J = 1, N - 1
            DO 10 I = 1, J - 1
               A( I, J ) = A( I, J+1 )
   10       CONTINUE
            A( N, J ) = ZERO
   20    CONTINUE
         DO 30 I = 1, N - 1
            A( I, N ) = ZERO
   30    CONTINUE
         A( N, N ) = ONE
*
*        Generate Q(1:n-1,1:n-1)
*
         CALL ZUNGQL( N-1, N-1, N-1, A, LDA, TAU, WORK, LWORK, IINFO )
*
      ELSE
*
*        Q was determined by a call to ZHETRD with UPLO = 'L'.
*
*        Shift the vectors which define the elementary reflectors one
*        column to the right, and set the first row and column of Q to
*        those of the unit matrix
*
         DO 50 J = N, 2, -1
            A( 1, J ) = ZERO
            DO 40 I = J + 1, N
               A( I, J ) = A( I, J-1 )
   40       CONTINUE
   50    CONTINUE
         A( 1, 1 ) = ONE
         DO 60 I = 2, N
            A( I, 1 ) = ZERO
   60    CONTINUE
         IF( N.GT.1 ) THEN
*
*           Generate Q(2:n,2:n)
*
            CALL ZUNGQR( N-1, N-1, N-1, A( 2, 2 ), LDA, TAU, WORK,
     $                   LWORK, IINFO )
         END IF
      END IF
      WORK( 1 ) = LWKOPT
      RETURN
*
*     End of ZUNGTR
*
      END

module m_ES_NonCollinear
! $Id: m_ES_NonCollinear.f90 587 2018-09-27 02:25:59Z ktagami $
  use m_Const_Parameters,   only : DP, CMPLDP, zi, yes, PAI, &
       &                            BuiltIn, ByProjector, ByPawPot, ZeffApprox, &
       &                           BUCS, CARTS, CRDTYP, DELTA10, ReadFromPP
  
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot, &
       &                            kimg, nspin, ipri, iprixc, SpinOrbit_Mode

  use m_Ionic_System,       only : natm, ntyp, ityp, mag_direction0_atomtyp, &
       &                           natm2, pos, iwei, magmom_local_now
  
  use m_PseudoPotential,     only : dion_so, dion_scr_noncl, q_noncl, flg_soc, &
       &                            pot_has_soc, dion0_noncl, &
       &                            nlmt, ipaw, dion, dion_paw, q, ltp, mtp, jtp, &
       &                            nac, nac_p, nlmta_phi, &
       &                            ilmt

  use m_Parallelization,      only : ista_kngp, iend_kngp, ista_fftp, iend_fftp, &
       &                             ista_fftph, iend_fftph, &
       &                             myrank_ggacmp, nrank_ggacmp, npes, ierr, &
       &                             mpi_comm_group

  use m_Files,                 only : nfout

!!!

  use m_SpinOrbit_Potential,    only : MatU_ylm_RC_L0, MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2, MatU_ylm_RC_L3, &
       &                              dsoc

!  use m_Crystal_Structure,      only : mag_direction0_global

!  use m_Crystal_Structure,      only : nopr, op, ig01, tau, m_CS_op_in_PUCD

! === KT_add === 2014/08/04
  use m_Crystal_Structure,   only : threshold_vorticity, threshold_helicity
! ============== 2014/08/04

  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

  complex(kind=CMPLDP), allocatable :: Spinor_EigenWfn0_atomtyp(:,:,:)
  complex(kind=CMPLDP), allocatable :: Spinor_EigenWfn0_global(:,:)
  complex(kind=CMPLDP), allocatable :: factor_f( :,:,:,:,: )

  real(kind=DP) :: Global_Quantz_Axis_now(3)

contains 

! ------------------------------------------------------------------------  
!!
!!!   Spinor eigenwfns calculated from the initial mag. orientaion.
!!
! -----------------------------------------------------------------------
  subroutine m_ES_alloc_spinor_eigenwfn_0
    allocate( Spinor_EigenWfn0_atomtyp( ntyp, ndim_spinor, ndim_spinor ) )
    Spinor_EigenWfn0_atomtyp = 0.0d0
  end subroutine m_ES_alloc_spinor_eigenwfn_0

  subroutine m_ES_dealloc_spinor_eigenwfn_0
    deallocate( Spinor_EigenWfn0_atomtyp )
  end subroutine m_ES_dealloc_spinor_eigenwfn_0

  subroutine m_ES_set_spinor_eigenwfn_0
    integer :: it
    real(kind=DP) :: c_mx, c_my, c_mz
    real(kind=DP) :: theta, phi
    real(kind=DP) :: c1, s1
    complex(kind=CMPLDP) :: z1

    Do it=1, ntyp
       c_mx = mag_direction0_atomtyp( it,1 )
       c_my = mag_direction0_atomtyp( it,2 )
       c_mz = mag_direction0_atomtyp( it,3 )
!
       theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
       phi = atan2( c_my, c_mx )
!
!       write(*,*) 'cmx = ', c_mx, c_my, c_mz
!       write(*,*) 'Th phi = ', theta, phi
!
       c1 = cos( theta/2.0d0 );  s1 = sin( theta/2.0d0 )
       z1 = exp( zi *phi /2.0d0 )
!!! ------------------------------------------------------ Kai_+ ---
!!!       Spinor_EigenWfn0_atomtyp( it,1,1 ) = conjg(z1)*c1
!!!       Spinor_EigenWfn0_atomtyp( it,2,1 ) = z1 *s1
!!! ------------------------------------------------------ Kai_- ---
!!!       Spinor_EigenWfn0_atomtyp( it,1,2 ) = -conjg(z1)*s1
!!!       Spinor_EigenWfn0_atomtyp( it,2,2 ) = z1 *c1
! ------------------------------------------------------ Kai_+ ---
       Spinor_EigenWfn0_atomtyp( it,1,1 ) =  z1 *c1
       Spinor_EigenWfn0_atomtyp( it,2,1 ) = -z1 *s1
! ------------------------------------------------------ Kai_- ---
       Spinor_EigenWfn0_atomtyp( it,1,2 ) = conjg(z1) *s1
       Spinor_EigenWfn0_atomtyp( it,2,2 ) = conjg(z1) *c1
    End do
 
  end subroutine m_ES_set_spinor_eigenwfn_0

! ------------------------------------------------------------------------  
!!
!!!        Factor F defined defined by A. Coroso et al
!!!                                    see. PRB 71 (2005) 115106.
!!
! -------------------------------------------------------------------------
  subroutine m_ES_alloc_factor_fss
    allocate( factor_f( nlmt, nlmt, ndim_spinor, ndim_spinor, ntyp ) )
    factor_f = 0.0d0
  end subroutine m_ES_alloc_factor_fss

  subroutine m_ES_dealloc_factor_fss
    deallocate( factor_f )
  end subroutine m_ES_dealloc_factor_fss

  subroutine m_ES_set_factor_fss
    integer :: it
    integer :: ilmt1, ilmt2, l1, l2, m1, m2
    integer :: is1, is2

    integer :: ni, number_of_mj

    real(kind=DP) :: jval1, jval2, mj
    real(kind=DP) :: c1, c2
    complex(kind=CMPLDP) :: z1, z2, zsum

    Do it=1, ntyp

       if ( .not. pot_has_soc(it)  ) cycle

       Do ilmt1=1, nlmt
          l1 = ltp( ilmt1, it )
          m1 = mtp( ilmt1, it )
          jval1 = jtp( ilmt1, it ) -0.50d0

          Do ilmt2=1, nlmt
             l2 = ltp( ilmt2, it )
             m2 = mtp( ilmt2, it )
             jval2 = jtp( ilmt2, it ) -0.5d0
          
             if ( l1 /= l2 ) cycle
             if ( abs(jval1-jval2) < 1.0D-4 )  cycle

             number_of_mj = nint( 2*jval1 +1 )

             write(*,*) 'mj = ', number_of_mj


             Do is1=1, ndim_spinor
                Do is2=1, ndim_spinor

                   zsum = 0.0d0
                   Do ni=1, number_of_mj
                      mj = -jval1 + ni -1
                      c1 = coeff_ClebshGordan( l1, jval1, mj, is1 ) 
                      c2 = coeff_ClebshGordan( l1, jval1, mj, is2 )
                      z1 = coeff_MatUs( l1, jval1, mj, m1, is1 )
                      z2 = coeff_MatUs( l1, jval1, mj, m2, is2 )
                      zsum = zsum + c1 *z1 *c2 *conjg( z2 )
                   End do
!
                   factor_f( ilmt1, ilmt2, is1, is2, it ) = zsum
                End do
             End do
          End do
       End do
    End Do

  end subroutine m_ES_set_factor_fss

!------------------------------------------------------------------
!!
!!!     Generalizatin of Dion and q 
!!
! ----------------------------------------------------------------
  subroutine m_ES_set_Mat_q_noncl
    integer :: it

    q_noncl = 0.0d0

    if ( SpinOrbit_mode == BuiltIn ) then
       Do it=1, ntyp
          call set_q_so( it )
       End do
    else
       Do it=1, ntyp
          q_noncl( 1:nlmt, 1:nlmt, 1, it ) = q( 1:nlmt, 1:nlmt, it )
          q_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, it ) = q( 1:nlmt, 1:nlmt, it )
       End do
    endif

  contains

    subroutine set_q_so( it )
      integer, intent(in) :: it
      
      integer :: lmt1, lmt2, lmt3, lmt4
      integer :: is1, is2, is3, is4
      integer :: is_tmp
      complex(kind=CMPLDP) :: z1, zsum

      Do lmt1 = 1, nlmt
         Do lmt2 = 1, nlmt
            
            Do is_tmp = 1, ndim_chgpot
               is1 = ( is_tmp -1 ) /ndim_spinor + 1
               is2 = mod( is_tmp -1,2 ) +1
               
               zsum = 0.0d0
               
               Do lmt3 = 1, nlmt
                  Do lmt4 = 1, nlmt
                     Do is3=1, ndim_spinor
                        is4 = is3
                        z1 = q( lmt1, lmt2, it ) &
                             &   *factor_f( lmt1, lmt3, is1, is3, it ) &
                             &   *factor_f( lmt4, lmt2, is4, is2, it ) 
                        zsum = zsum + z1
                     End do
                  End do
               End do
                  !
               q_noncl( lmt1, lmt2, is_tmp, it ) = zsum
               !
            End do
         End do
      End do
    end subroutine set_q_so

  end subroutine m_ES_set_Mat_q_noncl

  subroutine m_ES_init_Mat_dion0_noncl
    integer :: it, ia
    
    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       Do ia=1, natm
          it = ityp(ia)
          call set_dion_so( ia, it )

       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
         
          call add_Dsoc_term_noncl( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then 
                                      
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
         
          call add_Dsoc_term_noncl( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          it = ityp(ia)
          dion0_noncl( 1:nlmt, 1:nlmt, 1, ia ) = dion( 1:nlmt, 1:nlmt, it )
          dion0_noncl( 1:nlmt, 1:nlmt, ndim_chgpot, ia ) &
               &                 = dion( 1:nlmt, 1:nlmt, it )
       End do
    end if

    dion_scr_noncl = dion0_noncl

  contains

    subroutine add_Dsoc_term_noncl( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion0_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) + dsoc(:,:,ia,is)
      End do
    end subroutine add_Dsoc_term_noncl

! --
    subroutine set_dion_so( ia, it )
      integer, intent (in ) :: ia, it
!
      integer :: is1, is2, is_tmp
      integer :: ilmt1, ilmt2, l1, m1, l2, m2
      real(kind=DP) :: jval1, jval2
      complex(kind=CMPLDP) :: z1, z2
      !
      Do ilmt1=1, nlmt
         l1 = ltp( ilmt1, it )
         m1 = mtp( ilmt1, it )
         jval1 = jtp( ilmt1, it )
         
         Do ilmt2=1, nlmt
            l2 = ltp( ilmt2, it )
            m2 = mtp( ilmt2, it )
            jval2 = jtp( ilmt2, it )
            
            if ( l1 /= l2 ) cycle
            if ( abs(jval1-jval2) < 1.0D-4 )  cycle
            
            z1 = dion( ilmt1, ilmt2, it )
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  is_tmp = ( is1 -1 )*ndim_spinor + is2
                  
                  z2 = z1 *factor_f( ilmt1, ilmt2, is1, is2, it )
                  dion0_noncl( ilmt1, ilmt2, is_tmp, ia ) = z2
               End do
            End do
         End do
      End do
      
    end subroutine set_dion_so

  end subroutine m_ES_init_Mat_dion0_noncl

  subroutine m_ES_update_Mat_dion0_noncl         ! for PAW
    integer :: it, ia
    complex(kind=CMPLDP), allocatable :: dion_paw_ssrep(:,:,:,:)

    allocate( dion_paw_ssrep(nlmt,nlmt,ndim_magmom,natm) )
    call m_ES_MagMom_To_DensMat_DionPaw( dion_paw, dion_paw_ssrep )

    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       stop 'kt : Not suppported spin-orbit + paw'

       Do ia=1, natm
          it = ityp(ia)
          call set_dion_so( ia, it )      !  ?????????????
       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
          call add_Dsoc_term_noncl( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then      
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
          call add_Dsoc_term_noncl( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          dion0_noncl( 1:nlmt, 1:nlmt, :, ia ) = dion_paw_ssrep( 1:nlmt, 1:nlmt, :, ia )
       End do
    end if

    dion_scr_noncl = dion0_noncl
    deallocate( dion_paw_ssrep )

  contains

    subroutine add_Dsoc_term_noncl( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion0_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) + dsoc(:,:,ia,is)
      End do
    end subroutine add_Dsoc_term_noncl

! --
    subroutine set_dion_so( ia, it )
      integer, intent (in ) :: ia, it
!
      integer :: is1, is2, is_tmp
      integer :: ilmt1, ilmt2, l1, m1, l2, m2
      real(kind=DP) :: jval1, jval2
      complex(kind=CMPLDP) :: z1, z2
      !
      Do ilmt1=1, nlmt
         l1 = ltp( ilmt1, it )
         m1 = mtp( ilmt1, it )
         jval1 = jtp( ilmt1, it )
         
         Do ilmt2=1, nlmt
            l2 = ltp( ilmt2, it )
            m2 = mtp( ilmt2, it )
            jval2 = jtp( ilmt2, it )
            
            if ( l1 /= l2 ) cycle
            if ( abs(jval1-jval2) < 1.0D-4 )  cycle
            
            z1 = dion( ilmt1, ilmt2, it )
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  is_tmp = ( is1 -1 )*ndim_spinor + is2
                  
                  z2 = z1 *factor_f( ilmt1, ilmt2, is1, is2, it )
                  dion0_noncl( ilmt1, ilmt2, is_tmp, ia ) = z2
               End do
            End do
         End do
      End do
      
    end subroutine set_dion_so

  end subroutine m_ES_update_Mat_dion0_noncl

  subroutine m_ES_set_Mat_dion_scr_noncl( VlhxcQ_l, dhub_aimag )
    real(kind=DP), intent(in) :: VlhxcQ_l( nlmt, nlmt, natm, ndim_magmom )
    real(kind=DP), optional, intent(in) :: dhub_aimag( nlmt, nlmt, natm, ndim_magmom )

    complex(kind=CMPLDP), allocatable :: vlhxcQ_ssrep( :,:,:,: )
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )
!
    integer :: ia, it

    allocate( vlhxcQ_ssrep( nlmt,nlmt,natm,ndim_magmom ) )
    vlhxcQ_ssrep = 0.0d0
!
    if ( present(dhub_aimag) ) then
       call m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_l, vlhxcQ_ssrep, dhub_aimag )
    else
       call m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_l, vlhxcQ_ssrep )
    endif
!
    call m_ES_set_Pauli_matrix( PauliMatrix )

!------------------------------------------
    dion_scr_noncl = dion0_noncl
! -------------------------------------

    if ( SpinOrbit_Mode == BuiltIn ) then      ! full-relativisitic
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_B( ia )
       End do

    else if ( SpinOrbit_Mode == ByProjector .or. &
         &    SpinOrbit_Mode == ZeffApprox ) then      ! soc by parameter
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do

    else if ( SpinOrbit_Mode == ReadFromPP .or. &
         &    SpinOrbit_Mode == ByPawPot ) then 
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do

    else                                 ! neglect soc
       Do ia=1, natm
          it = ityp(ia)
          call add_VlhxcQ_term_noncl_A( ia )
       End do
    end if

    deallocate( vlhxcQ_ssrep )
    
  contains

    subroutine add_VlhxcQ_term_noncl_A( ia )
      integer, intent (in ) :: ia
      integer is
      
      Do is=1, ndim_chgpot
         dion_scr_noncl(:,:,is,ia) = dion0_noncl(:,:,is,ia) +vlhxcQ_ssrep( :,:,ia,is)
      End do
    end subroutine add_VlhxcQ_term_noncl_A
    
    subroutine add_VlhxcQ_term_noncl_B( ia )
      integer, intent (in ) :: ia

      integer :: is1, is2, is3, is4
      integer :: lmt1, lmt2, lmt3, lmt4 
      integer :: ialph, is_tmp

      complex(kind=CMPLDP) :: zsum, z1
      
      Do lmt1 = 1, nlmt
         Do lmt2 = 1, nlmt
            
            Do is_tmp = 1, ndim_chgpot
               is1 = ( is_tmp -1 ) /ndim_spinor + 1
               is2 = mod( is_tmp -1,2 ) +1
               
               zsum = 0.0d0
               
               Do lmt3 = 1, nlmt
                  Do lmt4 = 1, nlmt
                     Do is3=1, ndim_spinor
                        Do is4=1, ndim_spinor
                           
                           Do ialph=1, ndim_magmom
                              z1 = PauliMatrix( ialph, is3, is4 ) &
                                   &     *VlhxcQ_ssrep( lmt3, lmt4, ia, ialph ) &
                                   &     *factor_f( lmt1, lmt3, is1, is3, it ) &
                                   &     *factor_f( lmt4, lmt2, is4, is2, it ) 
                              zsum = zsum + z1
                           End do
                        End do
                     End do
                  End do
               End do
!
               dion_scr_noncl(:,:,is_tmp,ia) = dion0_noncl(:,:,is_tmp,ia) +zsum
!
            End do
         End do
      End do
      
    end subroutine add_VlhxcQ_term_noncl_B
         
  end subroutine m_ES_set_Mat_dion_scr_noncl

!--------------------------------------------------------------
!!
!!!   Clebsh Gordan coeff etc defined by A. Corso et al
!!!                                    see. PRB 71 (2005) 115106.
!!
! -------------------------------------------------------------
  complex(kind=CMPLDP) function coeff_MatUs( l, j, mj, mprime, is)
    integer, intent(in) :: l, is, mprime
    real(kind=DP), intent(in) :: j, mj

    integer :: m
    complex(kind=CMPLDP) :: z1

    stop "Not checked"

    z1 = 0.0d0
    if ( abs( j -l -0.5d0 ) < 1.0D-4 ) then
       m = nint( mj - 0.5d0 )
       if ( is == 1 .and. m >=-l ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m )
       else if ( is == 2 .and. m <= l-1 ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m+1 )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m+1 )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m+1 )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m+1 )
       endif
    else if ( abs ( j -l +0.5d0 ) < 1.0D-4 ) then
       m = nint( mj + 0.5d0 )
       if ( is == 1 .and. m >=-l+1 ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m-1 )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m-1 )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m-1 )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m-1 )
       else if ( is == 2 .and. m <= l ) then
          if ( l == 0 ) z1 = MatU_ylm_RC_L0( mprime, m )
          if ( l == 1 ) z1 = MatU_ylm_RC_L1( mprime, m )
          if ( l == 2 ) z1 = MatU_ylm_RC_L2( mprime, m )
          if ( l == 3 ) z1 = MatU_ylm_RC_L3( mprime, m )
       endif
    end if

    coeff_MatUs = conjg(z1)

  end function coeff_MatUs

  real(kind=DP) function coeff_ClebshGordan( l, j, mj, is )
    integer, intent(in) :: l, is
    real(kind=DP), intent(in) :: j, mj

    real(kind=DP) :: c1
    integer :: m

    c1 = 0.0d0
    if ( abs( j -l -0.5d0 ) < 1.0D-4 ) then
       m = nint( mj - 0.5d0 )
       if ( is == 1 ) c1 = sqrt( ( l+m+1)/(2.d0*l+1.d0) )
       if ( is == 2 ) c1 = sqrt( ( l-m)/(2.d0*l+1.d0) )
    else if ( abs ( j -l +0.5d0 ) < 1.0D-4 ) then
       m = nint( mj + 0.5d0 )
       if ( is == 1 ) c1 = sqrt( ( l-m+1)/(2.d0*l+1.d0) )
       if ( is == 2 ) c1 =-sqrt( ( l+m)/(2.d0*l+1.d0) )
    endif

    coeff_ClebshGordan = c1
    return

  end function coeff_ClebshGordan

  subroutine m_ES_set_Pauli_matrix( PauliMatrix )
    complex(kind=CMPLDP), intent(out) :: &
         &                PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

    PauliMatrix = 0.0d0
    
    PauliMatrix( 1,1,1 ) = 1.0d0;     PauliMatrix( 1,2,2 ) = 1.0d0   ! Sigma 0
    PauliMatrix( 2,1,2 ) = 1.0d0;     PauliMatrix( 2,2,1 ) = 1.0d0   ! Sigma X
    PauliMatrix( 3,1,2 ) =   -zi;     PauliMatrix( 3,2,1 ) =    zi   ! Sigma Y
    PauliMatrix( 4,1,1 ) = 1.0d0;     PauliMatrix( 4,2,2 ) =-1.0d0   ! Sigma Z
    
  end subroutine m_ES_set_Pauli_matrix

! -------------------------------
  subroutine m_ES_set_Mat_hsr_with_soc( hsr_ssrep, hsi_ssrep, &
       &                                hsr_ssrep_with_soc, hsi_ssrep_with_soc )
    real(kind=DP), intent(in) :: hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in) :: hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out):: hsr_ssrep_with_soc( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out):: hsi_ssrep_with_soc( natm, nlmt, nlmt, ndim_chgpot )

    integer :: ia, it
    integer :: is1, is2, is3, is4, is_tmp, is_tmp2
    integer :: ilmt1, ilmt2, ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m1, m2, m3, m4
    real(kind=DP) :: jval1, jval2, jval3, jval4
    complex(kind=CMPLDP) :: z1, z2, z3, zsum

    Do ia=1, natm
       it = ityp(ia)
       
       Do ilmt1=1, nlmt
          l1 = ltp( ilmt1, it )
          m1 = mtp( ilmt1, it )
          jval1 = jtp( ilmt1, it )
          
          Do ilmt2=1, nlmt
             l2 = ltp( ilmt2, it )
             m2 = mtp( ilmt2, it )
             jval2 = jtp( ilmt2, it )
             
             Do is_tmp = 1, ndim_chgpot
                is1 = ( is_tmp -1 ) /ndim_spinor + 1
                is2 = mod( is_tmp -1, ndim_spinor ) +1
                
                zsum = 0.0d0
                Do ilmt3=1, nlmt
                   l3 = ltp( ilmt3, it )
                   m3 = mtp( ilmt3, it )
                   jval3 = jtp( ilmt3, it )
                   
                   if ( l1 /= l3 ) cycle
                   if ( abs(jval1-jval3) > 1.0E-4 ) cycle
                   
                   Do ilmt4=1, nlmt
                      l4 = ltp( ilmt4, it )
                      m4 = mtp( ilmt4, it )
                      jval4 = jtp( ilmt4, it )
                      
                      if ( l2 /= l4 ) cycle
                      if ( abs(jval2-jval4) > 1.0E-4 ) cycle
                      
                      Do is3=1, ndim_spinor
                         Do is4=1, ndim_spinor
                            is_tmp2 = ( is3 -1 )*ndim_spinor + is4
                            
                            z1 = factor_f( ilmt3, ilmt1, is3, is1, it )
                            z2 = factor_f( ilmt2, ilmt4, is2, is4, it )
                            
                            z3 = dcmplx( hsr_ssrep( ia, ilmt3, ilmt4, is_tmp2 ), &
                                 &       hsi_ssrep( ia, ilmt3, ilmt4, is_tmp2 ) )
                            zsum = zsum + z1 *z3 *z2
                         End do
                      End do
                   End do
                End do
                
                hsr_ssrep_with_soc( ia, ilmt1, ilmt2, is_tmp ) = real(zsum)
                hsi_ssrep_with_soc( ia, ilmt1, ilmt2, is_tmp ) = aimag(zsum)
             End do
          End do
       End do
    End Do
 end subroutine m_ES_set_Mat_hsr_with_soc
!

! ----------------------------------------------------------------------
!!
!!!   Converters between the ss-repsentaion and magmom-representaion
!!
! ----------------------------------------------------------------------
  subroutine m_ES_MagMom_to_DensMat_Gspace( Rho_MagMom, DensMat )
    real(kind=DP), intent(in)  :: Rho_MagMom( ista_kngp:iend_kngp,kimg,ndim_magmom )
    real(kind=DP), intent(out) :: DensMat(    ista_kngp:iend_kngp,kimg,ndim_chgpot )
    ! --
    !                                       note : ndim_magmom = 4 
! --
    integer i, k
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    DensMat = 0.0d0
    Do i=ista_kngp, iend_kngp
       
       Do k=1, kimg
          c_rho(k) = Rho_MagMom( i,k,1 )
          c_mx(k)  = Rho_MagMom( i,k,2 )
          c_my(k)  = Rho_MagMom( i,k,3 )
          c_mz(k)  = Rho_MagMom( i,k,4 )
       End do
       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
       ! ----
       Do k=1,  kimg
          DensMat( i,k,1 ) = c_n11(k)
          DensMat( i,k,2 ) = c_n12(k)
          DensMat( i,k,3 ) = c_n21(k)
          DensMat( i,k,4 ) = c_n22(k)
       End do
    End Do
  end subroutine m_ES_MagMom_to_DensMat_Gspace
  
! -----------------------------------------------------------------
!!
!!!  n11(G),n12(G), n21(G), n22(G) ---> n(G), mx(G), my(G), mz(G)
!!
! -----------------------------------------------------------------
  subroutine m_ES_DensMat_To_MagMom_Gspace( DensMat, Rho_MagMom )

    real(kind=DP), intent(in)   :: DensMat(    ista_kngp:iend_kngp,kimg,ndim_chgpot )
    real(kind=DP), intent(out)  :: Rho_MagMom( ista_kngp:iend_kngp,kimg,ndim_magmom )
!
    integer i, k
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
    !
    Rho_MagMom = 0.0d0
    Do i=ista_kngp, iend_kngp
       
       Do k=1,  kimg
          c_n11(k) = DensMat( i,k,1 )
          c_n12(k) = DensMat( i,k,2 )
          c_n21(k) = DensMat( i,k,3 )
          c_n22(k) = DensMat( i,k,4 )
       End do
! -------------------- real part ------
       c_rho(1) = c_n11(1) + c_n22(1)
       c_mx(1)  = c_n12(1) + c_n21(1)
       c_my(1)  = c_n21(2) - c_n12(2)
       c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
       c_rho(2) = c_n11(2) + c_n22(2)
       c_mx(2)  = c_n12(2) + c_n21(2)
       c_my(2)  =-c_n21(1) + c_n12(1)
       c_mz(2)  = c_n11(2) - c_n22(2)
! ----
       Do k=1, kimg
          Rho_MagMom( i,k,1 ) = c_rho(k)
          Rho_MagMom( i,k,2 ) = c_mx(k)
          Rho_MagMom( i,k,3 ) = c_my(k)
          Rho_MagMom( i,k,4 ) = c_mz(k)
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_Gspace

  subroutine m_ES_DensMat_To_MagMom_hsr( natm, nlmt, hsr_densmat, hsi_densmat, &
       &                                 hsr_magmom, hsi_magmom )
    integer, intent(in) :: natm, nlmt
    real(kind=DP), intent(in)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)  :: hsi_magmom(  natm, nlmt, nlmt, ndim_magmom )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_magmom = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm
             c_n11(1) = hsr_densmat( ia, lmt1, lmt2, 1 )
             c_n12(1) = hsr_densmat( ia, lmt1, lmt2, 2 )
             c_n21(1) = hsr_densmat( ia, lmt1, lmt2, 3 )
             c_n22(1) = hsr_densmat( ia, lmt1, lmt2, 4 )
             !
             c_n11(2) = hsi_densmat( ia, lmt1, lmt2, 1 )
             c_n12(2) = hsi_densmat( ia, lmt1, lmt2, 2 )
             c_n21(2) = hsi_densmat( ia, lmt1, lmt2, 3 )
             c_n22(2) = hsi_densmat( ia, lmt1, lmt2, 4 )
!
! -------------------- real part ------
             c_rho(1) = c_n11(1) + c_n22(1)
             c_mx(1)  = c_n12(1) + c_n21(1)
             c_my(1)  = c_n21(2) - c_n12(2)
             c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
             c_rho(2) = c_n11(2) + c_n22(2)
             c_mx(2)  = c_n12(2) + c_n21(2)
             c_my(2)  =-c_n21(1) + c_n12(1)
             c_mz(2)  = c_n11(2) - c_n22(2)
!
             hsr_magmom( ia, lmt1, lmt2, 1 ) = c_rho(1)
             hsr_magmom( ia, lmt1, lmt2, 2 ) = c_mx(1)
             hsr_magmom( ia, lmt1, lmt2, 3 ) = c_my(1)
             hsr_magmom( ia, lmt1, lmt2, 4 ) = c_mz(1)
!
             hsi_magmom( ia, lmt1, lmt2, 1 ) = c_rho(2)
             hsi_magmom( ia, lmt1, lmt2, 2 ) = c_mx(2)
             hsi_magmom( ia, lmt1, lmt2, 3 ) = c_my(2)
             hsi_magmom( ia, lmt1, lmt2, 4 ) = c_mz(2)
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_hsr

  subroutine m_ES_DensMat_To_MagMom_hsr0( hsr_densmat, hsi_densmat, hsr_magmom )
    real(kind=DP), intent(in)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(in)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_magmom = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm
             c_n11(1) = hsr_densmat( ia, lmt1, lmt2, 1 )
             c_n12(1) = hsr_densmat( ia, lmt1, lmt2, 2 )
             c_n21(1) = hsr_densmat( ia, lmt1, lmt2, 3 )
             c_n22(1) = hsr_densmat( ia, lmt1, lmt2, 4 )
             !
             c_n11(2) = hsi_densmat( ia, lmt1, lmt2, 1 )
             c_n12(2) = hsi_densmat( ia, lmt1, lmt2, 2 )
             c_n21(2) = hsi_densmat( ia, lmt1, lmt2, 3 )
             c_n22(2) = hsi_densmat( ia, lmt1, lmt2, 4 )
!
! -------------------- real part ------
             c_rho(1) = c_n11(1) + c_n22(1)
             c_mx(1)  = c_n12(1) + c_n21(1)
             c_my(1)  = c_n21(2) - c_n12(2)
             c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
             c_rho(2) = c_n11(2) + c_n22(2)
             c_mx(2)  = c_n12(2) + c_n21(2)
             c_my(2)  =-c_n21(1) + c_n12(1)
             c_mz(2)  = c_n11(2) - c_n22(2)

             hsr_magmom( ia, lmt1, lmt2, 1 ) = c_rho(1)
             hsr_magmom( ia, lmt1, lmt2, 2 ) = c_mx(1)
             hsr_magmom( ia, lmt1, lmt2, 3 ) = c_my(1)
             hsr_magmom( ia, lmt1, lmt2, 4 ) = c_mz(1)
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_hsr0

  subroutine m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr_magmom, hsi_magmom, &
       &                                 hsr_densmat, hsi_densmat )
    integer, intent(in) :: natm, nlmt
    real(kind=DP), intent(in)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(in)  :: hsi_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(2), c_mx(2), c_my(2), c_mz(2)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_densmat = 0.0d0
    hsi_densmat = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm

             c_rho(1) = hsr_magmom( ia, lmt1, lmt2, 1 )
             c_mx(1)  = hsr_magmom( ia, lmt1, lmt2, 2 )
             c_my(1)  = hsr_magmom( ia, lmt1, lmt2, 3 )
             c_mz(1)  = hsr_magmom( ia, lmt1, lmt2, 4 )

             c_rho(2) = hsi_magmom( ia, lmt1, lmt2, 1 )
             c_mx(2)  = hsi_magmom( ia, lmt1, lmt2, 2 )
             c_my(2)  = hsi_magmom( ia, lmt1, lmt2, 3 )
             c_mz(2)  = hsi_magmom( ia, lmt1, lmt2, 4 )

       ! -------------------- real part ------
             c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
             c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
             c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
             c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
             c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
             c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
             c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
             c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
       ! ----
             hsr_densmat( ia, lmt1, lmt2, 1 ) = c_n11(1)
             hsr_densmat( ia, lmt1, lmt2, 2 ) = c_n12(1)
             hsr_densmat( ia, lmt1, lmt2, 3 ) = c_n21(1)
             hsr_densmat( ia, lmt1, lmt2, 4 ) = c_n22(1)

             hsi_densmat( ia, lmt1, lmt2, 1 ) = c_n11(2)
             hsi_densmat( ia, lmt1, lmt2, 2 ) = c_n12(2)
             hsi_densmat( ia, lmt1, lmt2, 3 ) = c_n21(2)
             hsi_densmat( ia, lmt1, lmt2, 4 ) = c_n22(2)

          End do
       End do
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_hsr

  subroutine m_ES_MagMom_To_DensMat_hsr0( hsr_magmom, hsr_densmat, hsi_densmat )
    real(kind=DP), intent(in)  :: hsr_magmom(  natm, nlmt, nlmt, ndim_magmom )
    real(kind=DP), intent(out)   :: hsr_densmat( natm, nlmt, nlmt, ndim_chgpot )
    real(kind=DP), intent(out)   :: hsi_densmat( natm, nlmt, nlmt, ndim_chgpot )
!
    integer i, k
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    hsr_densmat = 0.0d0
    hsi_densmat = 0.0d0
    Do lmt2=1, nlmt
       Do lmt1=1, nlmt
          Do ia=1, natm

             c_rho = hsr_magmom( ia, lmt1, lmt2, 1 )
             c_mx  = hsr_magmom( ia, lmt1, lmt2, 2 )
             c_my  = hsr_magmom( ia, lmt1, lmt2, 3 )
             c_mz  = hsr_magmom( ia, lmt1, lmt2, 4 )
       ! -------------------- real part ------
             c_n11(1) = ( c_rho + c_mz ) /2.0d0
             c_n22(1) = ( c_rho - c_mz ) /2.0d0
             c_n12(1) = c_mx /2.0d0
             c_n21(1) = c_mx /2.0d0
       ! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my /2.0d0
             c_n21(2) =  c_my /2.0d0
       ! ----
             hsr_densmat( ia, lmt1, lmt2, 1 ) = c_n11(1)
             hsr_densmat( ia, lmt1, lmt2, 2 ) = c_n12(1)
             hsr_densmat( ia, lmt1, lmt2, 3 ) = c_n21(1)
             hsr_densmat( ia, lmt1, lmt2, 4 ) = c_n22(1)

             hsi_densmat( ia, lmt1, lmt2, 1 ) = c_n11(2)
             hsi_densmat( ia, lmt1, lmt2, 2 ) = c_n12(2)
             hsi_densmat( ia, lmt1, lmt2, 3 ) = c_n21(2)
             hsi_densmat( ia, lmt1, lmt2, 4 ) = c_n22(2)

          End do
       End do
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_hsr0

  subroutine m_ES_MagMom_to_DensMat_vlhxcQ0( vlhxcQ_magmom, vlhxcQ_densmat )
    real(kind=DP),        intent(in) :: vlhxcQ_magmom( nlmt, nlmt, natm, ndim_magmom )
    complex(kind=CMPLDP), intent(out):: vlhxcQ_densmat( nlmt, nlmt, natm, ndim_chgpot )
    
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    integer :: ia, lmt1, lmt2
!
!    c_rho(2) = 0.0d0;  c_mx(2) = 0.0d0;   c_my(2) = 0.0d0;   c_mz(2) = 0.0d0
!
    vlhxcQ_densmat = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho = vlhxcQ_magmom( lmt1, lmt2, ia, 1 )
             c_mx  = vlhxcQ_magmom( lmt1, lmt2, ia, 2 )
             c_my  = vlhxcQ_magmom( lmt1, lmt2, ia, 3 )
             c_mz  = vlhxcQ_magmom( lmt1, lmt2, ia, 4 )
             !
             c_n11(1) = c_rho + c_mz 
             c_n22(1) = c_rho - c_mz 
             c_n12(1) = c_mx 
             c_n21(1) = c_mx 
! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my 
             c_n21(2) =  c_my
! ----
             vlhxcQ_densmat( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End do
    End Do
  end subroutine m_ES_MagMom_to_DensMat_vlhxcQ0

  subroutine m_ES_MagMom_to_DensMat_vlhxcQ( vlhxcQ_r_magmom, vlhxcQ_densmat, &
       &                                     vlhxcQ_i_magmom )
    real(kind=DP),         intent(in) :: vlhxcQ_r_magmom( nlmt, nlmt, natm, ndim_magmom )
    real(kind=DP),optional,intent(in) :: vlhxcQ_i_magmom( nlmt, nlmt, natm, ndim_magmom )
    complex(kind=CMPLDP), intent(out):: vlhxcQ_densmat( nlmt, nlmt, natm, ndim_chgpot )

    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    integer :: ia, lmt1, lmt2

    vlhxcQ_densmat = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho(1) = vlhxcQ_r_magmom( lmt1, lmt2, ia, 1 )
             c_mx(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 2 )
             c_my(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 3 )
             c_mz(1)  = vlhxcQ_r_magmom( lmt1, lmt2, ia, 4 )
!
             if ( present(vlhxcQ_i_magmom) ) then
                c_rho(2) = vlhxcQ_i_magmom( lmt1, lmt2, ia, 1 )
                c_mx(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 2 )
                c_my(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 3 )
                c_mz(2)  = vlhxcQ_i_magmom( lmt1, lmt2, ia, 4 )
             else
                c_rho(2) = 0.0d0
                c_mx(2) = 0.0d0
                c_my(2) = 0.0d0
                c_mz(2) = 0.0d0
             endif
       ! -------------------- real part ------
             c_n11(1) = c_rho(1) + c_mz(1)
             c_n22(1) = c_rho(1) - c_mz(1)
             c_n12(1) = c_mx(1)  + c_my(2)
             c_n21(1) = c_mx(1)  - c_my(2)
       ! ---------------------- imaginary part --
             c_n11(2) = c_rho(2) + c_mz(2)
             c_n22(2) = c_rho(2) - c_mz(2)
             c_n12(2) = c_mx(2)  - c_my(1)
             c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
             vlhxcQ_densmat( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             vlhxcQ_densmat( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End do
    End Do

  end subroutine m_ES_MagMom_to_DensMat_vlhxcQ

  subroutine m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )

    real(kind=DP), intent(in):: vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
    real(kind=DP), intent(out) :: vlhxc_ssrep(ista_kngp:iend_kngp,kimg,ndim_chgpot)
!
    integer :: i, k
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    vlhxc_ssrep = 0.0d0
    Do i=ista_kngp, iend_kngp

       Do k=1, kimg
          c_rho(k) = vlhxc_l( i,k,1 )
          c_mx(k)  = vlhxc_l( i,k,2 )
          c_my(k)  = vlhxc_l( i,k,3 )
          c_mz(k)  = vlhxc_l( i,k,4 )
       End do
       ! -------------------- real part ------
       c_n11(1) = c_rho(1) + c_mz(1) 
       c_n22(1) = c_rho(1) - c_mz(1) 
       c_n12(1) = c_mx(1)  + c_my(2) 
       c_n21(1) = c_mx(1)  - c_my(2) 
       ! ---------------------- imaginary part --
       c_n11(2) = c_rho(2) + c_mz(2)
       c_n22(2) = c_rho(2) - c_mz(2)
       c_n12(2) = c_mx(2)  - c_my(1)
       c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
       Do k=1, kimg
          vlhxc_ssrep( i,k,1 ) = c_n11(k)
          vlhxc_ssrep( i,k,2 ) = c_n12(k)
          vlhxc_ssrep( i,k,3 ) = c_n21(k)
          vlhxc_ssrep( i,k,4 ) = c_n22(k)
       End do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_vlhxcl

  subroutine m_ES_DensMat_to_MagMom_vlhxcl( vlhxc_ssrep, vlhxc_l )

    real(kind=DP), intent(in) :: vlhxc_ssrep(ista_kngp:iend_kngp,kimg,ndim_chgpot)
    real(kind=DP), intent(out):: vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
!
    integer :: i, k
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    vlhxc_l = 0.0d0
    Do i=ista_kngp, iend_kngp

       Do k=1, kimg
          c_n11(k) = vlhxc_ssrep( i,k,1 )
          c_n12(k) = vlhxc_ssrep( i,k,2 )
          c_n21(k) = vlhxc_ssrep( i,k,3 )
          c_n22(k) = vlhxc_ssrep( i,k,4 )
       End do
! -------------------- real part ------
       c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
       c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
       c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
       c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
       c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
       c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
       c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
       c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
       Do k=1, kimg
          vlhxc_l( i,k,1 ) = c_rho(k)
          vlhxc_l( i,k,2 ) = c_mx(k)
          vlhxc_l( i,k,3 ) = c_my(k)
          vlhxc_l( i,k,4 ) = c_mz(k)
       End do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_vlhxcl


  subroutine m_ES_DensMat_To_MagMom_dm( dm_ssrep, dm_magmom, max2lp, max_projs )
    integer, intent(in) :: max2lp, max_projs
    complex(kind=CMPLDP), intent(in)  :: dm_ssrep( max2lp, max2lp, max_projs, &
         &                                         natm, ndim_chgpot )
    real(kind=DP), intent(out)  :: dm_magmom( max2lp, max2lp, max_projs, &
         &                                    natm, ndim_magmom )
!
    integer i, k
    integer :: ia, i1, i2, ip
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dm_magmom = 0.0d0
    Do ia=1, natm
       Do ip=1, max_projs
          Do i2=1, max2lp
             Do i1=1, max2lp

                c_n11(1) = real( dm_ssrep( i1, i2, ip, ia, 1 ) )
                c_n12(1) = real( dm_ssrep( i1, i2, ip, ia, 2 ) )
                c_n21(1) = real( dm_ssrep( i1, i2, ip, ia, 3 ) )
                c_n22(1) = real( dm_ssrep( i1, i2, ip, ia, 4 ) )

                c_n11(2) = aimag( dm_ssrep( i1, i2, ip, ia, 1 ) )
                c_n12(2) = aimag( dm_ssrep( i1, i2, ip, ia, 2 ) )
                c_n21(2) = aimag( dm_ssrep( i1, i2, ip, ia, 3 ) )
                c_n22(2) = aimag( dm_ssrep( i1, i2, ip, ia, 4 ) )

! -------------------- real part ------
                c_rho(1) = c_n11(1) + c_n22(1)
                c_mx(1)  = c_n12(1) + c_n21(1)
                c_my(1)  = c_n21(2) - c_n12(2)
                c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
                c_rho(2) = c_n11(2) + c_n22(2)
                c_mx(2)  = c_n12(2) + c_n21(2)
                c_my(2)  =-c_n21(1) + c_n12(1)
                c_mz(2)  = c_n11(2) - c_n22(2)
!
                dm_magmom( i1, i2, ip, ia, 1 )  = c_rho(1)
                dm_magmom( i1, i2, ip, ia, 2 )  = c_mx(1)
                dm_magmom( i1, i2, ip, ia, 3 )  = c_my(1)
                dm_magmom( i1, i2, ip, ia, 4 )  = c_mz(1)
             End Do
          End do
       End do
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_dm

  subroutine m_ES_MagMom_To_DensMat_porb0( nsize, porb_r_magmom, &
       &                                  porb_ssrep )

    integer, intent(in) :: nsize
    real(kind=DP), intent(in)  :: porb_r_magmom( nsize, ndim_magmom )
!    real(kind=DP), intent(in)  :: porb_i_magmom( nsize, ndim_magmom )
    complex(kind=CMPLDP), intent(out)  :: porb_ssrep( nsize, ndim_chgpot )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_ssrep = 0.0d0

    Do i=1, nsize
       c_rho(1) = porb_r_magmom( i,1 )
       c_mx(1)  = porb_r_magmom( i,2 ) 
       c_my(1)  = porb_r_magmom( i,3 ) 
       c_mz(1)  = porb_r_magmom( i,4 ) 

!       c_rho(2) = porb_i_magmom( i,1 )
!       c_mx(2)  = porb_i_magmom( i,2 )
!       c_my(2)  = porb_i_magmom( i,3 )
!       c_mz(2)  = porb_i_magmom( i,4 )
       c_rho(2) = 0.0d0
       c_mx(2)  = 0.0d0
       c_my(2)  = 0.0d0
       c_mz(2)  = 0.0d0

       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
!
       porb_ssrep( i, 1 ) = dcmplx( c_n11(1), c_n11(2) )
       porb_ssrep( i, 2 ) = dcmplx( c_n12(1), c_n12(2) )
       porb_ssrep( i, 3 ) = dcmplx( c_n21(1), c_n21(2) )
       porb_ssrep( i, 4 ) = dcmplx( c_n22(1), c_n22(2) )
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_porb0

  subroutine m_ES_MagMom_To_DensMat_porb( nsize, porb_r_magmom, porb_i_magmom, &
       &                                  porb_ssrep )

    integer, intent(in) :: nsize
    real(kind=DP), intent(in)  :: porb_r_magmom( nsize, ndim_magmom )
    real(kind=DP), intent(in)  :: porb_i_magmom( nsize, ndim_magmom )
    complex(kind=CMPLDP), intent(out)  :: porb_ssrep( nsize, ndim_chgpot )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_ssrep = 0.0d0

    Do i=1, nsize
       c_rho(1) = porb_r_magmom( i,1 )
       c_mx(1)  = porb_r_magmom( i,2 )
       c_my(1)  = porb_r_magmom( i,3 )
       c_mz(1)  = porb_r_magmom( i,4 )

       c_rho(2) = porb_i_magmom( i,1 )
       c_mx(2)  = porb_i_magmom( i,2 )
       c_my(2)  = porb_i_magmom( i,3 )
       c_mz(2)  = porb_i_magmom( i,4 )

       ! -------------------- real part ------
       c_n11(1) = ( c_rho(1) + c_mz(1) ) /2.0d0
       c_n22(1) = ( c_rho(1) - c_mz(1) ) /2.0d0
       c_n12(1) = ( c_mx(1)  + c_my(2) ) /2.0d0
       c_n21(1) = ( c_mx(1)  - c_my(2) ) /2.0d0
       ! ---------------------- imaginary part --
       c_n11(2) = ( c_rho(2) + c_mz(2) ) /2.0d0
       c_n22(2) = ( c_rho(2) - c_mz(2) ) /2.0d0
       c_n12(2) = ( c_mx(2)  - c_my(1) ) /2.0d0
       c_n21(2) = ( c_mx(2)  + c_my(1) ) /2.0d0
!
       porb_ssrep( i, 1 ) = dcmplx( c_n11(1), c_n11(2) )
       porb_ssrep( i, 2 ) = dcmplx( c_n12(1), c_n12(2) )
       porb_ssrep( i, 3 ) = dcmplx( c_n21(1), c_n21(2) )
       porb_ssrep( i, 4 ) = dcmplx( c_n22(1), c_n22(2) )
! --
    End Do
  end subroutine m_ES_MagMom_To_DensMat_porb

  subroutine m_ES_DensMat_To_MagMom_porb( nsize, porb_ssrep, porb_magmom )

    integer, intent(in) :: nsize
    complex(kind=CMPLDP), intent(in)  :: porb_ssrep( nsize, ndim_chgpot )
    real(kind=DP), intent(out)  :: porb_magmom( nsize, ndim_magmom )
!
    integer :: i
    Real(kind=DP) :: c_rho(kimg), c_mx (kimg), c_my (kimg), c_mz (kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    porb_magmom = 0.0d0
    Do i=1, nsize
       c_n11(1) = real( porb_ssrep( i, 1 ) )
       c_n12(1) = real( porb_ssrep( i, 2 ) )
       c_n21(1) = real( porb_ssrep( i, 3 ) )
       c_n22(1) = real( porb_ssrep( i, 4 ) )

       c_n11(2) = aimag( porb_ssrep( i, 1 ) )
       c_n12(2) = aimag( porb_ssrep( i, 2 ) )
       c_n21(2) = aimag( porb_ssrep( i, 3 ) )
       c_n22(2) = aimag( porb_ssrep( i, 4 ) )

! -------------------- real part ------
       c_rho(1) = c_n11(1) + c_n22(1)
       c_mx(1)  = c_n12(1) + c_n21(1)
       c_my(1)  = c_n21(2) - c_n12(2)
       c_mz(1)  = c_n11(1) - c_n22(1)
! ---------------------- imaginary part --
       c_rho(2) = c_n11(2) + c_n22(2)
       c_mx(2)  = c_n12(2) + c_n21(2)
       c_my(2)  =-c_n21(1) + c_n12(1)
       c_mz(2)  = c_n11(2) - c_n22(2)
!
       porb_magmom( i, 1 ) = c_rho(1)
       porb_magmom( i, 2 ) = c_mx(1)
       porb_magmom( i, 3 ) = c_my(1)
       porb_magmom( i, 4 ) = c_mz(1)
! --
    End Do
  end subroutine m_ES_DensMat_To_MagMom_porb

  subroutine m_ES_MagMom_to_DensMat_DionPaw( dion_magmom, dion_ssrep )
    real(kind=DP), intent(in):: dion_magmom(nlmt,nlmt,ndim_magmom,natm)
    complex(kind=CMPLDP), intent(out) :: dion_ssrep(nlmt,nlmt,ndim_chgpot,natm)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho, c_mx, c_my, c_mz
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)

    dion_ssrep = 0.0d0
    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_rho = dion_magmom( lmt1, lmt2, 1, ia )
             c_mx  = dion_magmom( lmt1, lmt2, 2, ia )
             c_my  = dion_magmom( lmt1, lmt2, 3, ia )
             c_mz  = dion_magmom( lmt1, lmt2, 4, ia )
             ! -------------------- real part ------
             c_n11(1) = c_rho + c_mz 
             c_n22(1) = c_rho - c_mz 
             c_n12(1) = c_mx
             c_n21(1) = c_mx
       ! ---------------------- imaginary part --
             c_n11(2) = 0.0d0
             c_n22(2) = 0.0d0
             c_n12(2) = -c_my
             c_n21(2) =  c_my
       ! ----
             dion_ssrep( lmt1, lmt2, 1, ia ) = dcmplx( c_n11(1), c_n11(2) )
             dion_ssrep( lmt1, lmt2, 2, ia ) = dcmplx( c_n12(1), c_n12(2) )
             dion_ssrep( lmt1, lmt2, 3, ia ) = dcmplx( c_n21(1), c_n21(2) )
             dion_ssrep( lmt1, lmt2, 4, ia ) = dcmplx( c_n22(1), c_n22(2) )
          End do
       End Do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_DionPaw

  subroutine m_ES_DensMat_to_MagMom_Dhub0( dhub_ssrep, dhub_magmom )
    complex(kind=CMPLDP), intent(in) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
    real(kind=DP), intent(out):: dhub_magmom(nlmt,nlmt,natm,ndim_magmom)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_magmom = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_n11(1) = real( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(1) = real( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(1) = real( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(1) = real( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

             c_n11(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

! -------------------- real part ------
             c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
             c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
             c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
             c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
             c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
             c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
             c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
             c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
             dhub_magmom( lmt1, lmt2, ia, 1 ) = c_rho(1)
             dhub_magmom( lmt1, lmt2, ia, 2 ) = c_mx(1)
             dhub_magmom( lmt1, lmt2, ia, 3 ) = c_my(1)
             dhub_magmom( lmt1, lmt2, ia, 4 ) = c_mz(1)
!
!             write(500,*) 'ilmt1 ilmt2 ia ', lmt1, lmt2, ia
!             write(500,*) c_rho(2), c_mx(2), c_my(2), c_mz(2)
          End do
       End Do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_Dhub0

  subroutine m_ES_DensMat_to_MagMom_Dhub( dhub_ssrep, dhub_r_magmom, dhub_i_magmom )
    complex(kind=CMPLDP), intent(in) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
    real(kind=DP), intent(out):: dhub_r_magmom(nlmt,nlmt,natm,ndim_magmom)
    real(kind=DP), intent(out):: dhub_i_magmom(nlmt,nlmt,natm,ndim_magmom)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_r_magmom = 0.0d0
    dhub_i_magmom = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt
             c_n11(1) = real( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(1) = real( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(1) = real( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(1) = real( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

             c_n11(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 1 ) )
             c_n12(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 2 ) )
             c_n21(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 3 ) )
             c_n22(2) = aimag( dhub_ssrep( lmt1, lmt2, ia, 4 ) )

! -------------------- real part ------
             c_rho(1) = ( c_n11(1) + c_n22(1) ) /2.0d0
             c_mx(1)  = ( c_n12(1) + c_n21(1) ) /2.0d0
             c_my(1)  = ( c_n21(2) - c_n12(2) ) /2.0d0
             c_mz(1)  = ( c_n11(1) - c_n22(1) ) /2.0d0
! ---------------------- imaginary part --
             c_rho(2) = ( c_n11(2) + c_n22(2) ) /2.0d0
             c_mx(2)  = ( c_n12(2) + c_n21(2) ) /2.0d0
             c_my(2)  = (-c_n21(1) + c_n12(1) ) /2.0d0
             c_mz(2)  = ( c_n11(2) - c_n22(2) ) /2.0d0
! ----
             dhub_r_magmom( lmt1, lmt2, ia, 1 ) = c_rho(1)
             dhub_r_magmom( lmt1, lmt2, ia, 2 ) = c_mx(1)
             dhub_r_magmom( lmt1, lmt2, ia, 3 ) = c_my(1)
             dhub_r_magmom( lmt1, lmt2, ia, 4 ) = c_mz(1)
! ----
             dhub_i_magmom( lmt1, lmt2, ia, 1 ) = c_rho(2)
             dhub_i_magmom( lmt1, lmt2, ia, 2 ) = c_mx(2)
             dhub_i_magmom( lmt1, lmt2, ia, 3 ) = c_my(2)
             dhub_i_magmom( lmt1, lmt2, ia, 4 ) = c_mz(2)
!
!             write(500,*) 'ilmt1 ilmt2 ia ', lmt1, lmt2, ia
!             write(500,*) c_rho(2), c_mx(2), c_my(2), c_mz(2)
          End do
       End Do
! --
    End Do

  end subroutine m_ES_DensMat_to_MagMom_Dhub
  
  subroutine m_ES_MagMom_to_DensMat_Dhub( dhub_r_magmom, dhub_i_magmom, dhub_ssrep )
    real(kind=DP), intent(in):: dhub_r_magmom(nlmt,nlmt,natm,ndim_magmom)
    real(kind=DP), intent(in):: dhub_i_magmom(nlmt,nlmt,natm,ndim_magmom)
    complex(kind=CMPLDP), intent(out) :: dhub_ssrep(nlmt,nlmt,natm,ndim_chgpot)
!
    integer :: ia, lmt1, lmt2
    Real(kind=DP) :: c_rho(kimg), c_mx(kimg), c_my(kimg), c_mz(kimg)
    Real(kind=DP) :: c_n11(kimg), c_n12(kimg), c_n21(kimg), c_n22(kimg)
!
    dhub_ssrep = 0.0d0

    Do ia=1, natm
       Do lmt2=1, nlmt
          Do lmt1=1, nlmt

             c_rho(1) = dhub_r_magmom( lmt1, lmt2, ia, 1 )
             c_mx(1)  = dhub_r_magmom( lmt1, lmt2, ia, 2 )
             c_my(1)  = dhub_r_magmom( lmt1, lmt2, ia, 3 )
             c_mz(1)  = dhub_r_magmom( lmt1, lmt2, ia, 4 )
!
             c_rho(2) = dhub_i_magmom( lmt1, lmt2, ia, 1 )
             c_mx(2)  = dhub_i_magmom( lmt1, lmt2, ia, 2 )
             c_my(2)  = dhub_i_magmom( lmt1, lmt2, ia, 3 )
             c_mz(2)  = dhub_i_magmom( lmt1, lmt2, ia, 4 )

       ! -------------------- real part ------
             c_n11(1) = c_rho(1) + c_mz(1)
             c_n22(1) = c_rho(1) - c_mz(1)
             c_n12(1) = c_mx(1)  + c_my(2)
             c_n21(1) = c_mx(1)  - c_my(2)
       ! ---------------------- imaginary part --
             c_n11(2) = c_rho(2) + c_mz(2)
             c_n22(2) = c_rho(2) - c_mz(2)
             c_n12(2) = c_mx(2)  - c_my(1)
             c_n21(2) = c_mx(2)  + c_my(1)
       ! ----
             dhub_ssrep( lmt1, lmt2, ia, 1 ) = dcmplx( c_n11(1), c_n11(2) )
             dhub_ssrep( lmt1, lmt2, ia, 2 ) = dcmplx( c_n12(1), c_n12(2) )
             dhub_ssrep( lmt1, lmt2, ia, 3 ) = dcmplx( c_n21(1), c_n21(2) )
             dhub_ssrep( lmt1, lmt2, ia, 4 ) = dcmplx( c_n22(1), c_n22(2) )

          End do
       End Do
! --
    End Do

  end subroutine m_ES_MagMom_to_DensMat_Dhub

! ------------------------------------------------------------------------
!!
!!!   Diagonalize the density matrix, obtain the local quantization axis, 
!!!                and up/down spin desity along this axis
!!
! -----------------------------------------------------------------------
  subroutine m_ES_get_Angles_MagMom_Rspace( RhoMag_R, Rot_Angles )
    Real(kind=DP), intent(in)  :: RhoMag_R(    ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: Rot_Angles( ista_fftph:iend_fftph,2 )
    
    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz
    Real(kind=DP) :: theta, phi, m_norm
    
!    real(kind=DP) :: m_norm_criteria = 5.0D-3
!    real(kind=DP) :: m_norm_criteria = 1.0D-6
!    real(kind=DP) :: m_norm_criteria = 1.0D-12
    real(kind=DP) :: m_norm_criteria = 1.0D-20

! --
    real(kind=DP) :: theta_neighbor, phi_neighbor 

! --------- initialize --
    theta_neighbor = 0.0d0
    phi_neighbor = 0.0d0
! --
!    write(940,*) 'aa '

    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );  c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );  c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then

! ---------------- original ------
!!!!!!!!          theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
!!!!!          phi = atan2(  c_my, c_mx )

! --- for test -
          theta = atan2( sqrt( c_mx**2 +c_my**2), abs(c_mz) )
          phi = atan2( abs(c_my), abs(c_mx) )

!          goto 100
          goto 120

! --- for test2 -

          if ( c_mz > 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
             phi = atan2( c_my, c_mx )
          else if ( c_mz < 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             phi = atan2( -c_my, -c_mx )
          else
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             if ( c_mx > 0.0d0 ) then
                phi = atan2( c_my,  c_mx )
             else if ( c_mx < 0.0d0 ) then
                phi = atan2( -c_my,  -c_mx )
             else
                phi = atan2( abs(c_my), c_mx )
             endif
          endif

120       continue
! --- for test3 -

!          write(940,*) i, c_n
          if ( c_mz >= 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
             phi = atan2( c_my, c_mx )
          else if ( c_mz < 0.0d0 ) then
             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
             phi = atan2( -c_my, -c_mx )
          endif

100       continue

       else
!!!!!!          theta = 0.0d0;       phi =0.0d0
          theta = theta_neighbor;  phi  = phi_neighbor
       endif
!
       theta_neighbor = theta;  phi_neighbor = phi
!!
       Rot_Angles( i, 1 ) = theta
       Rot_Angles( i, 2 ) = phi
    End do
  end subroutine m_ES_get_Angles_MagMom_Rspace

  subroutine m_ES_get_Angles_MagMom_Rspace2( RhoMag_R, Rot_Angles )
    Real(kind=DP), intent(in)  :: RhoMag_R(    ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: Rot_Angles( ista_fftph:iend_fftph,2 )
    
    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz
    Real(kind=DP) :: mmx, mmy, mmz, ctmp
    Real(kind=DP) :: theta, phi, m_norm
    
!    real(kind=DP) :: m_norm_criteria = 5.0D-3
!    real(kind=DP) :: m_norm_criteria = 1.0D-6
!    real(kind=DP) :: m_norm_criteria = 1.0D-12
    real(kind=DP) :: m_norm_criteria = 1.0D-20
! --
    real(kind=DP) :: theta_neighbor, phi_neighbor 
    real(kind=DP) :: theta0, phi0

    real(kind=DP) :: MagDirec_OnMesh_avg(3)

! --------- initialize --
    theta_neighbor = 0.0d0
    phi_neighbor = 0.0d0
! --
!    write(940,*) 'aa '

    call calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )
!
    theta0 = atan2( sqrt( MagDirec_OnMesh_avg(1)**2 &
         &             + MagDirec_OnMesh_avg(2)**2 ), MagDirec_OnMesh_avg(3) )
    phi0 = atan2( MagDirec_OnMesh_avg(2), MagDirec_OnMesh_avg(1) )
!
!    write(990,*) 'th0 ph0 = ', theta0, phi0
!    write(990,*) MagDirec_OnMesh_Avg(1), MagDirec_OnMesh_Avg(2), MagDirec_OnMesh_Avg(3)
!
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );  c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );  c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then
!
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm

          ctmp = mmx *MagDirec_OnMesh_avg(1) &
               & + mmy *MagDirec_OnMesh_avg(2) &
               & + mmz *MagDirec_OnMesh_avg(3)

          theta = atan2( sqrt( c_mx**2 +c_my**2), c_mz )
          phi = atan2( c_my, c_mx )

          if ( ctmp >= 0.0d0 ) then
          else 
!             theta = atan2( sqrt( c_mx**2 +c_my**2), -c_mz )
!             phi = atan2( -c_my, -c_mx )
             theta = PAI - theta
             phi =   PAI + phi
          endif

       else
!          theta = theta0
!          phi = phi0
          theta = theta_neighbor
          phi = phi_neighbor
       endif

       theta_neighbor = theta;  phi_neighbor = phi
!!
       Rot_Angles( i, 1 ) = theta
       Rot_Angles( i, 2 ) = phi
    End do


  contains
    
    subroutine calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      
      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  abs( RhoMag_R( i,2 ) )
         MagVectorSum(2) = MagVectorSum(2) +  abs( RhoMag_R( i,3 ) )
         MagVectorSum(3) = MagVectorSum(3) +  abs( RhoMag_R( i,4 ) )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
      endif
    end subroutine calc_averaged_mag_direc_now

  end subroutine m_ES_get_Angles_MagMom_Rspace2


  subroutine m_ES_SpinDens_Along_QuantzAxis( RhoMag_R, Rot_Angles, chgrhr_l )
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(in)  :: Rot_Angles( ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: chgrhr_l(   ista_fftph:iend_fftph,nspin )

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, c_tmp
    Real(kind=DP) :: theta, phi
    Real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    !
    chgrhr_l = 0.0d0
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       theta = Rot_Angles( i,1 );    phi   = Rot_Angles( i,2 )
!
       cos_th = cos( theta );  sin_th = sin( theta )
       cos_ph = cos( phi );    sin_ph = sin( phi )
       !
!!!!!!!!!!!!!!!!!       c_tmp = ( c_mx *cos_ph - c_my *sin_ph ) /2.0d0
       c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
       c_tmp = c_tmp *sin_th
!
       chgrhr_l( i,1 ) = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp       ! up
       chgrhr_l( i,2 ) = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp       ! down
! --
!       write(*,*) "  A ", i, theta, phi
!       write(*,*) "  B ", i, c_mz

    End do
!
    if ( iprixc >=2 ) then
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 1 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
!
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 2 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,2),i=ista_fftph,ista_fftph+17)

    endif
!
  end subroutine m_ES_SpinDens_Along_QuantzAxis

  subroutine m_ES_SpinDens_Along_QuantzAxis2( RhoMag_R, chgrhr_l, &
       &                                      quantz_axis_inversion_flg_mesh, &
       &                                      skip_flag )
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: chgrhr_l(   ista_fftph:iend_fftph,nspin )
    integer, intent(inout) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)
    logical, intent(in) :: skip_flag

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, ctmp
    real(kind=DP) :: d1, d2
    real(kind=DP) :: MagDirec_OnMesh_avg(3)
    real(kind=DP) :: mmx, mmy, mmz, m_norm
    real(kind=DP) :: m_norm_criteria = 1.0D-20
!    real(kind=DP) :: m_norm_lowlimit = 1.0D-40
    real(kind=DP) :: m_norm_lowlimit = 1.0D-30

    integer :: exit_flag
    integer :: count1, count1_sum
    integer :: count2, count2_sum

! ============
!    call calc_averaged_mag_direc_now( MagDirec_OnMesh_avg )

    call calc_averaged_mag_direc_now_A( Global_Quantz_axis_now, exit_flag )
    if ( exit_flag == 1 ) then
       call calc_averaged_mag_direc_now_B( Global_Quantz_axis_now )
    endif
! ===========

    if ( iprixc >=2 ) then
       write(nfout,'(A,3E20.10)') "!ES XC : GlobalAxis = ", Global_Quantz_axis_now(1:3)
    endif

    chgrhr_l = 0.0d0
    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
       d1 = (c_n +m_norm) /2.0d0;  d2 = ( c_n - m_norm )/2.0d0

! ---- only test, but may be important ------
       if ( skip_flag ) goto 130
       
!       if ( c_n < 0.0 ) then
!          d1 = m_norm_lowlimit;    d2 = m_norm_lowlimit
!       else
          if ( d1 < 0.0 ) d1 = m_norm_lowlimit
          if ( d2 < 0.0 ) d2 = m_norm_lowlimit
!       endif
       
130    continue
! -----------------------------------------
       if ( m_norm > m_norm_criteria ) then
!
!          mmx = c_mx / m_norm
!          mmy = c_my / m_norm
!         mmz = c_mz / m_norm
          mmx = c_mx
          mmy = c_my
          mmz = c_mz

!          ctmp = mmx *MagDirec_OnMesh_avg(1) &
!               & + mmy *MagDirec_OnMesh_avg(2) &
!               & + mmz *MagDirec_OnMesh_avg(3)
          ctmp = mmx *Global_Quantz_Axis_now(1) &
               & + mmy *Global_Quantz_Axis_now(2) &
               & + mmz *Global_Quantz_Axis_now(3)

          if ( ctmp > 0.0 ) then 
             chgrhr_l( i,1 ) = d1;  chgrhr_l( i,2 ) = d2
             quantz_axis_inversion_flg_mesh(i) = 1
          else
             chgrhr_l( i,1 ) = d2;  chgrhr_l( i,2 ) = d1
             quantz_axis_inversion_flg_mesh(i) = -1
          endif
!
       else
!!!!          d1 = ( d1 +d2 )/2.0d0;  d2 = d1
          chgrhr_l( i,1 ) = d1;  chgrhr_l( i,2 ) = d2
          quantz_axis_inversion_flg_mesh(i) = 1
       endif

    End do
!
    if ( iprixc >=2 ) then
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 1 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,1),i=ista_fftph,ista_fftph+17)
!
       write(nfout,*) '!ES XC =='
       write(nfout,*) '!ES XC :         ispin = 2 '
       write(nfout,*) '!ES XC -- chgrhr_l -- '
       write(nfout,'(" !ES XC ",6f12.6)') (chgrhr_l(i,2),i=ista_fftph,ista_fftph+17)
    endif
!
    if ( iprixc >=2 ) then
       count1 = 0;  count2 = 0
       Do i=ista_fftph, iend_fftph
          if ( quantz_axis_inversion_flg_mesh(i) ==  1 ) count1 = count1 +1
          if ( quantz_axis_inversion_flg_mesh(i) == -1 ) count2 = count2 +1
       Enddo
       call mpi_allreduce( count1, count1_sum, 1, mpi_integer, &
            &              mpi_sum, mpi_comm_group, ierr )
       call mpi_allreduce( count2, count2_sum, 1, mpi_integer, &
            &              mpi_sum, mpi_comm_group, ierr )
       write(nfout,*) 'count_sum = ', count1_sum, count2_sum
    endif

  contains

    subroutine calc_averaged_mag_direc_now_A( MagDirec_OnMesh_avg, exit_flag )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      integer, intent(out) :: exit_flag

      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  RhoMag_R( i,2 )
         MagVectorSum(2) = MagVectorSum(2) +  RhoMag_R( i,3 )
         MagVectorSum(3) = MagVectorSum(3) +  RhoMag_R( i,4 )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
         exit_flag = 0
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
         exit_flag = 1
      endif
    end subroutine calc_averaged_mag_direc_now_A

    subroutine calc_averaged_mag_direc_now_B( MagDirec_OnMesh_avg )
      real(kind=DP), intent(out) :: MagDirec_OnMesh_avg(3)
      
      real(kind=DP) :: MagVectorSum(3), MagVectorSum_mpi(3)
      real(kind=DP) :: cnorm
      integer :: i

      MagDirec_OnMesh_avg = 0.0d0

      MagVectorSum = 0.0d0
      Do i=ista_fftph, iend_fftph
         MagVectorSum(1) = MagVectorSum(1) +  abs( RhoMag_R( i,2 ) )
         MagVectorSum(2) = MagVectorSum(2) +  abs( RhoMag_R( i,3 ) )
         MagVectorSum(3) = MagVectorSum(3) +  abs( RhoMag_R( i,4 ) )
      End do

      if ( npes > 1 ) then
         call mpi_allreduce( MagVectorSum, MagVectorSum_mpi, 3, &
              &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
         MagVectorSum = MagVectorSum_mpi
      endif
!
      cnorm = MagVectorSum(1)**2 + MagVectorSum(2)**2 + MagVectorSum(3)**2
      cnorm = sqrt( cnorm )
!
      if ( cnorm > m_norm_criteria ) then
         MagDirec_OnMesh_avg = MagVectorSum / cnorm
      else
         MagDirec_OnMesh_avg(3) = 1.0d0
      endif
    end subroutine calc_averaged_mag_direc_now_B

  end subroutine m_ES_SpinDens_Along_QuantzAxis2
  
! -----------------------------------------------------------------------
!!
!!!    convert "up/down"-xc potential calculated along the quantization axis 
!!!            to the original xyz-axis basis.
!!
! -----------------------------------------------------------------------
  subroutine m_ES_cp_VxcR_to_afft( iloop, VxcPot_R, Rot_Angles, afft )
    integer, intent(in) :: iloop
    Real(kind=DP), intent(in)  :: VxcPot_R(   ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(in)  :: Rot_Angles( ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: afft( ista_fftp:iend_fftp )

    integer :: i
    Real(kind=DP) :: theta, phi
    Real(kind=DP) :: V0, dV
    Real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph

    afft = 0.0d0
    Do i=ista_fftph, iend_fftph
       theta = Rot_Angles( i,1 ); phi = Rot_Angles( i,2 )
       cos_th = cos( theta );  sin_th = sin( theta )
       cos_ph = cos( phi );    sin_ph = sin( phi )
!
       V0 = ( VxcPot_R( i,1 ) + VxcPot_R(i,2) ) /2.0d0
       dV = ( VxcPot_R( i,1 ) - VxcPot_R(i,2) ) /2.0d0
!
       select case (iloop)
       case (1)
          afft( 2*i-1 ) = v0 + dV *cos_th
       case (2)
          afft( 2*i-1 ) =  dV *cos_ph *sin_th
          afft( 2*i   ) = -dV *sin_ph *sin_th
       case (3)
          afft( 2*i-1 ) =  dV *cos_ph *sin_th
          afft( 2*i   ) =  dV *sin_ph *sin_th
       case (4)
          afft( 2*i-1 ) = v0 - dV *cos_th
       end select
    End Do
  end subroutine m_ES_cp_VxcR_to_afft

  subroutine m_ES_cp_VxcR_to_afft2( iloop, quantz_axis_inversion_flg_mesh, &
       &                            RhoMag_R, VxcPot_R, afft )
                                         ! output is in magmom rep.
    integer, intent(in) :: iloop
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)
    Real(kind=DP), intent(in)  :: RhoMag_R(   ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(in)  :: VxcPot_R(   ista_fftph:iend_fftph,nspin )
    Real(kind=DP), intent(out) :: afft( ista_fftp:iend_fftp )

    integer :: i
    Real(kind=DP) :: V0, dV
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: m_norm
    real(kind=DP) :: mmx, mmy, mmz
    real(kind=DP) :: m_norm_criteria = 1.0D-20
!!    real(kind=DP) :: m_norm_criteria = 1.0D-16
!!    real(kind=DP) :: m_norm_criteria = 1.0D-18

    afft = 0.0d0
    Do i=ista_fftph, iend_fftph
       V0 = ( VxcPot_R( i,1 ) + VxcPot_R(i,2) ) /2.0d0
       dV = ( VxcPot_R( i,1 ) - VxcPot_R(i,2) ) /2.0d0
!
       c_n  = RhoMag_R( i,1 );      c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );      c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )

       if ( m_norm > m_norm_criteria ) then
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm
       else
!          if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
!             mmx = Global_Quantz_axis_now(1)
!             mmy = Global_Quantz_axis_now(2)
!             mmz = Global_Quantz_axis_now(3)
!          else
!             mmx = -Global_Quantz_axis_now(1)
!             mmy = -Global_Quantz_axis_now(2)
!             mmz = -Global_Quantz_axis_now(3)
!          endif
          mmx = 0.0d0; mmy = 0.0d0;  mmz = 0.0d0
       endif

       select case (iloop)
       case (1)
          afft( 2*i-1 ) = v0
       case (2)
          afft( 2*i-1 ) =  dV *mmx *quantz_axis_inversion_flg_mesh(i)
       case (3)
          afft( 2*i-1 ) =  dV *mmy *quantz_axis_inversion_flg_mesh(i)
       case (4)
          afft( 2*i-1 ) =  dV *mmz *quantz_axis_inversion_flg_mesh(i)
       end select
    End Do
  end subroutine m_ES_cp_VxcR_to_afft2

  subroutine m_ES_Chgsoft_Along_QuantzAxis( RhoMag_R, chgrhr_l, &
       &                                    quantz_axis_inversion_flg_mesh )

    Real(kind=DP), intent(in)  :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    Real(kind=DP), intent(out) :: chgrhr_l( ista_fftph:iend_fftph,nspin )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

    integer :: i
    Real(kind=DP) :: c_n, c_mx, c_my, c_mz, m_norm
    real(kind=DP) :: d1, d2

    Do i=ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
       d1 = (c_n +m_norm) /2.0d0;  d2 = ( c_n - m_norm )/2.0d0
!
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          chgrhr_l(i,1) = d1
          chgrhr_l(i,2) = d2
       else
          chgrhr_l(i,1) = d2
          chgrhr_l(i,2) = d1
       endif
    End do
  end subroutine m_ES_Chgsoft_Along_QuantzAxis

  subroutine m_ES_QuantzAxis_inv_flg_atm( magmom_local, &
       &                                  quantz_axis_inversion_flg_atm )
    Real(kind=DP), intent(in)  :: magmom_local(natm,3)
    integer, intent(out) :: quantz_axis_inversion_flg_atm(natm)

    integer :: ia
    Real(kind=DP) :: c_mx, c_my, c_mz, ctmp
    real(kind=DP) :: mmx, mmy, mmz, m_norm
    real(kind=DP) :: m_norm_criteria = 1.0D-20
   !

    Do ia=1, natm
       c_mx = magmom_local( ia,1 )
       c_my = magmom_local( ia,2 )
       c_mz = magmom_local( ia,3 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       if ( m_norm > m_norm_criteria ) then
!
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm

          ctmp = mmx *Global_Quantz_Axis_now(1) &
               & + mmy *Global_Quantz_Axis_now(2) &
               & + mmz *Global_Quantz_Axis_now(3)

          if ( ctmp > 0.0 ) then
             quantz_axis_inversion_flg_atm(ia) = 1
          else
             quantz_axis_inversion_flg_atm(ia) = -1
          endif
       else
          quantz_axis_inversion_flg_atm(ia) = 1
       endif
    End do
  end subroutine m_ES_QuantzAxis_inv_flg_atm

  subroutine m_ES_Chghard_Along_QuantzAxis( hsr, hsrd,  hsr_along_QuantzAxis, &
       &                                    hsrd_along_QuantzAxis )
!
    real(kind=DP), intent(in) :: hsr( natm,nlmt,nlmt,ndim_magmom )
    real(kind=DP), intent(in) :: hsrd( natm,nlmt,nlmt,ndim_magmom,3,3 )
    real(kind=DP), intent(out) :: hsr_along_QuantzAxis( natm,nlmt,nlmt,nspin )
   real(kind=DP), intent(out) :: hsrd_along_QuantzAxis( natm,nlmt,nlmt,nspin,3,3 )

! ------
!!!!    integer, intent(in) :: quantz_axis_inversion_flg_atm(natm)
! -----
    real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    real(kind=DP) :: c_n, c_mx, c_my, c_mz, c_tmp, c1
    real(kind=DP) :: d1, d2
!
    integer :: ia, it, lmt1, lmt2, i1, i2
!
    cos_th = Global_Quantz_Axis_now(3)
    sin_th = sqrt( 1.0D0 - cos_th**2 )
!
    if ( sin_th > 0.0d0 ) then
       c1 = Global_Quantz_Axis_now(1)**2 + Global_Quantz_Axis_now(2)**2
       cos_ph = Global_Quantz_Axis_now(1) / c1
       sin_ph = Global_Quantz_Axis_now(2) / c1
    else
       cos_ph = 0.0d0;  sin_ph = 0.0d0
    endif

    Do ia=1, natm
       it = ityp(ia)
       Do lmt1=1, ilmt(it)
          Do lmt2=1, ilmt(it)

             c_n =  hsr( ia, lmt1, lmt2, 1 )
             c_mx = hsr( ia, lmt1, lmt2, 2 )
             c_my = hsr( ia, lmt1, lmt2, 3 )
             c_mz = hsr( ia, lmt1, lmt2, 4 )
!
             c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
             c_tmp = c_tmp *sin_th
!
             d1 = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp
             d2 = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp
!
             hsr_along_QuantzAxis(ia,lmt1,lmt2,1) = d1
             hsr_along_QuantzAxis(ia,lmt1,lmt2,2) = d2
          End do
       End Do
    End do
!
    Do ia=1, natm
       Do lmt1=1, ilmt(it)
          Do lmt2=1, ilmt(it)

             Do i1=1, 3
                Do i2=1, 3
                   c_n =  hsrd( ia, lmt1, lmt2, 1, i1, i2 )
                   c_mx = hsrd( ia, lmt1, lmt2, 2, i1, i2 )
                   c_my = hsrd( ia, lmt1, lmt2, 3, i1, i2 )
                   c_mz = hsrd( ia, lmt1, lmt2, 4, i1, i2 )
!
                   c_tmp = ( c_mx *cos_ph + c_my *sin_ph ) /2.0d0
                   c_tmp = c_tmp *sin_th
!
                   d1 = ( c_n + c_mz *cos_th ) /2.0d0  + c_tmp
                   d2 = ( c_n - c_mz *cos_th ) /2.0d0  - c_tmp
!
                   hsrd_along_QuantzAxis(ia,lmt1,lmt2,1,i1,i2) = d1
                   hsrd_along_QuantzAxis(ia,lmt1,lmt2,2,i1,i2) = d2
                End do
             End Do
          End do
       End Do
    End do

  end subroutine m_ES_Chghard_Along_QuantzAxis

! ------
  subroutine m_ES_GradCorr_Along_QuantzAxis( RhoMag_R, bfft_kt, &
       &                                    quantz_axis_inversion_flg_mesh )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    real(kind=DP), intent(inout) :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

! --
    integer :: i
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz
    real(kind=DP) :: cos_th, sin_th, cos_ph, sin_ph
    real(kind=DP) :: d1, d2, c_tmp
    real(kind=DP) :: m_norm
!    real(kind=DP), parameter :: m_norm_criteria = 1.0D-20
    real(kind=DP), parameter :: m_norm_criteria = 1.0D-16

    Do i = ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
!
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
       
       if ( m_norm < m_norm_criteria ) then
          d1 = ctarget_n /2.0d0;   d2 = d1
       else
          cos_th = c_mz / m_norm
          sin_th = sqrt( 1.0D0 - cos_th**2 )

          if ( sin_th > 1.0D-16 ) then
             cos_ph = ( c_mx /m_norm ) / sin_th
             sin_ph = ( c_my /m_norm ) / sin_th
          else
             cos_ph = 0.0d0;  sin_ph = 0.0d0
          endif
!
          c_tmp = ( ctarget_mx *cos_ph + ctarget_my *sin_ph )/2.0d0
          c_tmp = c_tmp *sin_th
          d1 = ( ctarget_n + ctarget_mz *cos_th ) /2.0d0 +c_tmp
          d2 = ( ctarget_n - ctarget_mz *cos_th ) /2.0d0 -c_tmp
       endif
       
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          bfft_kt(2*i,1) = d1;   bfft_kt(2*i,2) = d2
       else
          bfft_kt(2*i,1) = d2;   bfft_kt(2*i,2) = d1
       endif
    End do
    
  end subroutine m_ES_GradCorr_Along_QuantzAxis

  subroutine m_ES_GradCorr_Along_QuantzAxis2( RhoMag_R, bfft_kt, &
       &                                    quantz_axis_inversion_flg_mesh )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph,ndim_magmom )
    real(kind=DP), intent(inout) :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    integer, intent(in) :: quantz_axis_inversion_flg_mesh(ista_fftph:iend_fftph)

! --
    integer :: i
    real(kind=DP) :: c_n, c_mx, c_my, c_mz
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz
    real(kind=DP) :: d1, d2, ctmp1, da1, da2
    real(kind=DP) :: m_norm, mmx, mmy, mmz

    real(kind=DP), parameter :: m_norm_criteria = 1.0D-20
    real(kind=DP), parameter :: m_norm_criteria2 = 1.0D-12

    Do i = ista_fftph, iend_fftph
       c_n  = RhoMag_R( i,1 );    c_mx = RhoMag_R( i,2 )
       c_my = RhoMag_R( i,3 );    c_mz = RhoMag_R( i,4 )
       m_norm = sqrt( c_mx**2 + c_my**2 + c_mz**2 )
!
       da1 = (c_n +m_norm) /2.0d0;  da2 = ( c_n - m_norm )/2.0d0
!
       if ( m_norm < m_norm_criteria ) then
          mmx = 0.0d0;  mmy = 0.0d0;  mmz = 0.0d0

       else if ( m_norm < m_norm_criteria2 ) then
          if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
             mmx = Global_Quantz_Axis_now(1)
             mmy = Global_Quantz_Axis_now(2)
             mmz = Global_Quantz_Axis_now(3)
          else
             mmx = -Global_Quantz_Axis_now(1)
             mmy = -Global_Quantz_Axis_now(2)
             mmz = -Global_Quantz_Axis_now(3)
          endif

       else
          mmx = c_mx / m_norm
          mmy = c_my / m_norm
          mmz = c_mz / m_norm
       endif
!
       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
!
       ctmp1 = ctarget_mx *mmx + ctarget_my *mmy + ctarget_mz *mmz
!
       d1 = ( ctarget_n +ctmp1 ) /2.0d0
       d2 = ( ctarget_n -ctmp1 )/2.0d0
          
       if ( quantz_axis_inversion_flg_mesh(i) == 1 ) then
          bfft_kt(2*i,1) = d1;   bfft_kt(2*i,2) = d2
       else
          bfft_kt(2*i,1) = d2;   bfft_kt(2*i,2) = d1
       endif

       bfft_kt(2*i-1,1:4) = 0.0d0
       bfft_kt(2*i,3:4) = 0.0d0;

    End do

  end subroutine m_ES_GradCorr_Along_QuantzAxis2

! ===== KT_add === 2014/08/04
  subroutine m_ES_add_contrib_to_Vorticity( ixyz, bfft_kt, MagVorticity )
    integer, intent(in) :: ixyz
    real(kind=DP), intent(in)  :: bfft_kt( ista_fftp:iend_fftp,ndim_magmom )
    real(kind=DP), intent(out) :: MagVorticity( ista_fftph:iend_fftph, 3 )

    integer :: i
    real(kind=DP) :: ctarget_n, ctarget_mx, ctarget_my, ctarget_mz

    Do i = ista_fftph, iend_fftph
!       ctarget_n = bfft_kt(2*i,1)
       ctarget_mx = bfft_kt(2*i,2)
       ctarget_my = bfft_kt(2*i,3)
       ctarget_mz = bfft_kt(2*i,4)
!
       if ( ixyz == 1 ) then
          MagVorticity(i,2) = MagVorticity(i,2) -ctarget_mz
          MagVorticity(i,3) = MagVorticity(i,3) +ctarget_my
       else if ( ixyz == 2 ) then
          MagVorticity(i,3) = MagVorticity(i,3) -ctarget_mx
          MagVorticity(i,1) = MagVorticity(i,1) +ctarget_mz
       else if ( ixyz == 3 ) then
          MagVorticity(i,1) = MagVorticity(i,1) -ctarget_my
          MagVorticity(i,2) = MagVorticity(i,2) +ctarget_mx
       endif
    End Do
  end subroutine m_ES_add_contrib_to_Vorticity

  subroutine m_ES_neglect_low_Helicity( RhoMag_R, MagVorticity, Mat )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph, ndim_magmom )
    real(kind=DP), intent(in) :: MagVorticity( ista_fftph:iend_fftph, 3 )
    real(kind=DP), intent(inout) :: Mat( ista_fftph:iend_fftph )

    integer :: i, k
    real(kind=DP) :: ctmp1

    Do i=ista_fftph, iend_fftph
       ctmp1 = 0.0d0
       Do k=1, 3
          ctmp1 = ctmp1 +RhoMag_R(i,k+1)*MagVorticity(i,k)
       End do
       if ( abs(ctmp1) < threshold_helicity ) Mat(i) = 0.0d0
    End Do

  end subroutine m_ES_neglect_low_Helicity

  subroutine m_ES_neglect_low_Vorticity( RhoMag_R, MagVorticity, Mat )
    real(kind=DP), intent(in) :: RhoMag_R( ista_fftph:iend_fftph, ndim_magmom )
    real(kind=DP), intent(in) :: MagVorticity( ista_fftph:iend_fftph, 3 )
    real(kind=DP), intent(inout) :: Mat( ista_fftph:iend_fftph )

    integer :: i, k
    real(kind=DP) :: ctmp1

    Do i=ista_fftph, iend_fftph
       ctmp1 = 0.0d0
       Do k=1, 3
          ctmp1 = ctmp1 +MagVorticity(i,k)**2
       End do
       ctmp1 = sqrt(ctmp1)

       if ( ctmp1 < threshold_vorticity ) Mat(i) = 0.0d0
    End Do

  end subroutine m_ES_neglect_low_Vorticity
! ================ 2014/08/04

end module m_ES_NonCollinear

!! Last updated: 01 March 2012
!! real-time electron dynamics
!! based on the time-dependent density functional theory
!!
!! mdmain.F90      -->  rttddft_main.f90
!! rttddft_main.f90 -->  m_Control_Parameters.F90 (input parameters)
!!                  -->  m_rttddft.f90
!!
!! some unstable parts commented out, 12 Sep 2012 at isir, osaka univ.
!!

subroutine rttddft_main

use m_Const_Parameters,only : &
    DP,ON,OFF,FORCE_CONVERGED,INITIAL,CONTINUATION,FIXED_CHARGE,FIXED_CHARGE_CONTINUATION &
   ,Valence_plus_PC_Charge,VXC_AND_EXC
use m_Control_Parameters,only : &
    iconvergence,iconvergence_previous_job &
   ,sw_rttddft,time_step_max,time_step_delta,propagator_method,propagator_order
use m_IterationNumbers,only : &
    iteration, iteration_electronic
use m_Files,only : &
    nfout
use m_Kpoints,only : &
    kv3
use m_Electronic_Structure,only : &
    m_ES_energy_eigen_values_3D
use m_ES_LHXC,only : &
    m_ESlhxc_potential_3D
use m_Charge_Density,only : &
    chgq_l,m_CD_softpart_3D,m_CD_hardpart,m_CD_cp_chgq_to_chgqo
use m_XC_Potential,only : &
    vxc_l, m_XC_cal_potential_3D
use m_Total_Energy,only : &
    m_TE_total_energy
use m_ES_Intgr_VlhxcQlm,only : &
    m_ESiVQ_integrate_VlhxcQlm_3D
use m_ES_WF_by_MatDiagon,only : &
    m_ESmat_solve_Hx_eq_eSx_3D
use m_rttddft,only : &
    m_rttddft_init_occup_control,m_rttddft_init_impulse_field &
   ,m_rttddft_print_eko_occup &
   ,m_rttddft_propagate_wf_by_taylor &
   ,m_rttddft_dipole,m_rttddft_current

implicit none
integer :: i_time,it
logical :: TotalEnergy_is_Divergent

if(sw_rttddft == OFF) return
if(iconvergence < FORCE_CONVERGED .and. iconvergence_previous_job < FORCE_CONVERGED) return


write(nfout,'(/,"#### RT-TDDFT real-time electron dynamics: start ####")')

!!
!!-- Initial Electronic Structure
!!
write(nfout,'("# time_step=     0")')

call m_rttddft_init_occup_control  !<<
call m_rttddft_init_impulse_field  !<<

call m_CD_softpart_3D(nfout,kv3)
call m_CD_hardpart(nfout,kv3)
call m_CD_cp_chgq_to_chgqo

call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)
call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l)
call m_ESiVQ_integrate_VlhxcQlm_3D(nfout)

! === DEBUG by tkato 2013/02/24 ================================================
! In RTP-TDDFT, sorting in m_ES_energy_eigen_values_3D brings on difference
! to ORG_Parallel in current.
! The order of band elements on zaj_l is not match to that on occup_l.
! But, this sort is necessary for other case.
!call m_ES_energy_eigen_values_3D(nfout)
call m_ES_energy_eigen_values_3D(nfout, .true.)
! ==============================================================================
call m_TE_total_energy(nfout,.true.,kv3)
if(TotalEnergy_is_Divergent()) write(nfout,'("** WARNING: initial")')

! call m_rttddft_wd_charge      !<<
! call m_rttddft_check_wf
call m_rttddft_dipole
call m_rttddft_current

time_step: do i_time=1,time_step_max

  write(nfout,'(/,"# time_step=",i6,2x,"time=",e12.4," au =",e12.4," fs")') &
    i_time,time_step_delta*i_time,time_step_delta*i_time*0.0241888

  call IterationNumber_Setting

!!
!!-- Time-Propagation of Wavefunction
!!
  if(propagator_method==1) then
    call m_rttddft_propagate_wf_by_taylor   !<<
  elseif(propagator_method==2) then
    stop '**** ERROR(RT-TDDFT): propagator_method=2 not recommended, pls set 1 '
  else
    stop '**** ERROR(RT-TDDFT): invalid input, propagator_method '
  endif

!!
!!-- Charge Density Update
!!
  call m_CD_cp_chgq_to_chgqo
  call m_CD_softpart_3D(nfout,kv3)
  call m_CD_hardpart(nfout,kv3)

!!
!!-- Potential Update
!!
  call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)
  call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l)
  call m_ESiVQ_integrate_VlhxcQlm_3D(nfout)

!!
!!-- Energy Eigen Values (Diagonal Part)
!!
! === DEBUG by tkato 2013/02/24 ================================================
! In RTP-TDDFT, sorting in m_ES_energy_eigen_values_3D brings on difference
! to ORG_Parallel in current.
! The order of band elements on zaj_l is not match to that on occup_l.
! But, this sort is necessary for other case.
! call m_ES_energy_eigen_values_3D(nfout)
  call m_ES_energy_eigen_values_3D(nfout,.true.)
! ==============================================================================

!!
!!-- Total Energy and Ion Kinetic Energy
!!
  call m_TE_total_energy(nfout,.true.,kv3)
  if(TotalEnergy_is_Divergent()) exit time_step

!!
!!-- Print for Accuracy Check
!!
  if(i_time==1.or.mod(i_time,1000)==0.or.i_time==time_step_max) then
    call m_rttddft_print_eko_occup
  ! call m_rttddft_check_wf
  endif

!!
!!-- Calculations of Physical Quantities
!!
  call m_rttddft_dipole
  call m_rttddft_current

!!
!!-- Check Off-Diagonal Matrix Element
!!
!!  call m_ESmat_solve_Hx_eq_eSx(nfout,iteration,iteration_electronic)

!!
!!-- Calculate Force and Move Ions (velocity verlet should be selected)
!!
! call Forces
! call Move_Ions
! call Ewald_and_Structure_Factor
  call MDIterationNumber_Setting

enddo time_step

write(nfout,'("#### RT-TDDFT real-time electron dynamics: end ####",/)')

end subroutine rttddft_main

      subroutine eigen_hbk(ar,ai,lda, zr,zi,ldz, tau,ldtau, n)

      use communication_h , only : eigen_init
     &                , eigen_free
     &                , cyc1d_cyc2d
     &                , cyc2d_cyc1d

      implicit double precision(a-h,o-z),integer(i-n)

      real(8) :: ar(*), ai(*)
      real(8) :: zr(*), zi(*)
      real(8) :: tau(*)

      real(8) , allocatable :: wkr(:), wki(:)
      real(8) , pointer :: vr(:),vi(:), wr(:),wi(:)
      real(8) , pointer :: ssr(:),ssi(:)
      real(8) , pointer :: tt(:)

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'

      call eigen_init(2)
      m = 128; mm = m*(m-1)/2/1

      s0=mpi_wtime()
      lda2 = (n-1)/size_of_col+1
      na   = (n-1)/size_of_row+1
      lda2 = lda2+mod(lda2-1,2)
      na   = na  +mod(na  -1,2)
      allocate( wkr(lda2*na) )
      allocate( wki(lda2*na) )

      call cyc1d_cyc2d(n,zr(1),ldz,wkr(1),lda2,size_of_col,size_of_row,
     &                 ierr)
      call cyc1d_cyc2d(n,zi(1),ldz,wki(1),lda2,size_of_col,size_of_row,
     &                 ierr)
      call cyc1d_cyc2d(n,ar(1),lda,zr(1),lda2,size_of_col,size_of_row,
     &                 ierr)
      call cyc1d_cyc2d(n,ai(1),lda,zi(1),lda2,size_of_col,size_of_row,
     &                 ierr)

      nm = lda2
      allocate(
     &         vr(1:nm*m), vi(1:nm*m),
     &         wr(1:nm*m), wi(1:nm*m),
     &         ssr(1:max(na*m+mm,n)),
     &         ssi(1:max(na*m+mm,n)),
     &         tt(1:max(na*m+mm,n)),
     &         stat=i_stat)
      if(i_stat/=0)then
         if(myrank==1)print*,"memory allocation error."
         call mpi_abort(mpi_comm_eigen,1,ierr)
      endif

      call mpi_barrier(mpi_comm_eigen,ierr)
      call eigen_hbk_main1( 
     &       n, zr(1),zi(1), lda2,
     &       wkr(1),wki(1), lda2,
     &       tau(1),ldtau, m, mm,
     &       vr(1),vi(1), wr(1),wi(1), nm, ssr(1),ssi(1),tt(1)
     &     )
      call mpi_barrier(mpi_comm_eigen,ierr)

      call cyc2d_cyc1d(n,zr(1),ldz,wkr(1),lda2,size_of_col,size_of_row,
     &                 ierr)
      call cyc2d_cyc1d(n,zi(1),ldz,wki(1),lda2,size_of_col,size_of_row,
     &                 ierr)

      deallocate( vr,vi )
      deallocate( wr,wi )
      deallocate( ssr,ssi )
      deallocate( tt )
      deallocate( wkr,wki )

      call eigen_free(3)

#ifdef TIMER
      s1=mpi_wtime()
      if(myrank==1)then
          print*,"Exectime of \"eigen_hbk\" routine =",s1-s0,"(sec)"
!----     s1-s0,8e-9*dble(n)**3/(s1-s0),"GFLOPS"
      endif
#endif

      return
      end subroutine
!----
       subroutine eigen_hbk_main1(n,ar,ai,nma,zr,zi,nmz,tau,nmtau,
     &                          m,mm, vr,vi,wr,wi,nm,ssr,ssi,tt)
!----
      use communication_h, only : get_loop_start
     &               , get_loop_end
     &               , get_owner_node
     &               , translate_l2g
     &               , translate_g2l
     &               , bcast_dbl
     &               , reduce_dbl
!----
       implicit double precision(a-h,o-z),integer(i-n)

       real(8) :: ar(1:nma,*), ai(1:nma,*)
       real(8) :: zr(1:nmz,*), zi(1:nmz,*)
       real(8) :: tau(1:nmtau,2)

       real(8) :: vr(1:nm,*), vi(1:nm,*)
       real(8) :: wr(1:nm,*), wi(1:nm,*)

       real(8) :: ssr(*),ssi(*), tt(*)

       integer :: nodes(0:m-1)

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'
!----
       call mpi_barrier(mpi_comm_eigen,ierr)
       d1=mpi_wtime()
       dcom=0.0d0+00
!----
       i_2 = get_loop_start(1, size_of_row,my_row)
       i_3 = get_loop_end  (n, size_of_row,my_row)
       j_2 = get_loop_start(1, size_of_col,my_col)
       j_3 = get_loop_end  (n, size_of_col,my_col)

       do i_1=i_2,i_3
          do j_1=j_2,j_3
             k = (j_1-1)*size_of_col+my_col
             zi(j_1,i_1) =  zr(j_1,i_1) * tau(k,2)
             zr(j_1,i_1) =  zr(j_1,i_1) * tau(k,1)
          end do! j_1
       end do! i_1
       tau(1:n,1) = 0.0
       do i_1=i_2,i_3
          k = (i_1-1)*size_of_row+my_row
          x_root = mod(k-1,size_of_col)+1
          if ( x_root == my_col ) then
             j_1  = (k-1)/size_of_col+1
             tau(k,1) = ai(j_1,i_1)
          end if
       end do! i_1
       call reduce_dbl(tau(1,1), tau(1,2), n, mpi_comm_eigen)

       i=1
1000   i=i+1; if ( i > n ) go to 9000

       if ( tau(i,1) == 0.0d+00 ) go to 1000

1100   if ( (i+1<=n) .and. (tau(i+1,1)/=0.0d+00) ) go to 1200

1111   continue

          j_2 = get_loop_start(1,   size_of_col,my_col)
          j_3 = get_loop_end  (i-1, size_of_col,my_col)
!----
          ds=mpi_wtime()
          nodes(0) = get_owner_node(i, size_of_row, my_row)
          if ( nodes(0) == my_row ) then
             i_1 = translate_g2l(i, size_of_row, my_row)
             do j_1=j_2,j_3
                vr(j_1,1) = ar(j_1,i_1)
                vi(j_1,1) = ai(j_1,i_1)
             end do! j_1
          end if
          call bcast_dbl(vr(j_2,1), j_3-j_2+1, nodes(0), mpi_comm_row)
          call bcast_dbl(vi(j_2,1), j_3-j_2+1, nodes(0), mpi_comm_row)
          de=mpi_wtime()
          dcom=dcom+(de-ds)
!----
          i_4=mod(i_3-i_2+1,8)+i_2
          do i_1=i_2,i_4-1 !                  0
             sr0=0.0d+00
             si0=0.0d+00
             do j_1=j_2,j_3
                sr0=sr0+vr(j_1,1)*zr(j_1,i_1+0)
     &                       +vi(j_1,1)*zi(j_1,i_1+0)
                si0=si0+vr(j_1,1)*zi(j_1,i_1+0)
     &                       -vi(j_1,1)*zr(j_1,i_1+0)
             end do! j_1
             ssr(i_1+0)=sr0
             ssi(i_1+0)=si0
          end do! i_1
          do i_1=i_4,i_3,8 !             7
             sr0=0.0d+00
             si0=0.0d+00
             sr1=0.0d+00
             si1=0.0d+00
             sr2=0.0d+00
             si2=0.0d+00
             sr3=0.0d+00
             si3=0.0d+00
             sr4=0.0d+00
             si4=0.0d+00
             sr5=0.0d+00
             si5=0.0d+00
             sr6=0.0d+00
             si6=0.0d+00
             sr7=0.0d+00
             si7=0.0d+00
             do j_1=j_2,j_3
                sr0=sr0+vr(j_1,1)*zr(j_1,i_1+0)
     &                       +vi(j_1,1)*zi(j_1,i_1+0)
                si0=si0+vr(j_1,1)*zi(j_1,i_1+0)
     &                       -vi(j_1,1)*zr(j_1,i_1+0)
                sr1=sr1+vr(j_1,1)*zr(j_1,i_1+1)
     &                       +vi(j_1,1)*zi(j_1,i_1+1)
                si1=si1+vr(j_1,1)*zi(j_1,i_1+1)
     &                       -vi(j_1,1)*zr(j_1,i_1+1)
                sr2=sr2+vr(j_1,1)*zr(j_1,i_1+2)
     &                       +vi(j_1,1)*zi(j_1,i_1+2)
                si2=si2+vr(j_1,1)*zi(j_1,i_1+2)
     &                       -vi(j_1,1)*zr(j_1,i_1+2)
                sr3=sr3+vr(j_1,1)*zr(j_1,i_1+3)
     &                       +vi(j_1,1)*zi(j_1,i_1+3)
                si3=si3+vr(j_1,1)*zi(j_1,i_1+3)
     &                       -vi(j_1,1)*zr(j_1,i_1+3)
                sr4=sr4+vr(j_1,1)*zr(j_1,i_1+4)
     &                       +vi(j_1,1)*zi(j_1,i_1+4)
                si4=si4+vr(j_1,1)*zi(j_1,i_1+4)
     &                       -vi(j_1,1)*zr(j_1,i_1+4)
                sr5=sr5+vr(j_1,1)*zr(j_1,i_1+5)
     &                       +vi(j_1,1)*zi(j_1,i_1+5)
                si5=si5+vr(j_1,1)*zi(j_1,i_1+5)
     &                       -vi(j_1,1)*zr(j_1,i_1+5)
                sr6=sr6+vr(j_1,1)*zr(j_1,i_1+6)
     &                       +vi(j_1,1)*zi(j_1,i_1+6)
                si6=si6+vr(j_1,1)*zi(j_1,i_1+6)
     &                       -vi(j_1,1)*zr(j_1,i_1+6)
                sr7=sr7+vr(j_1,1)*zr(j_1,i_1+7)
     &                       +vi(j_1,1)*zi(j_1,i_1+7)
                si7=si7+vr(j_1,1)*zi(j_1,i_1+7)
     &                       -vi(j_1,1)*zr(j_1,i_1+7)
             end do! j_1
             ssr(i_1+0)=sr0
             ssi(i_1+0)=si0
             ssr(i_1+1)=sr1
             ssi(i_1+1)=si1
             ssr(i_1+2)=sr2
             ssi(i_1+2)=si2
             ssr(i_1+3)=sr3
             ssi(i_1+3)=si3
             ssr(i_1+4)=sr4
             ssi(i_1+4)=si4
             ssr(i_1+5)=sr5
             ssi(i_1+5)=si5
             ssr(i_1+6)=sr6
             ssi(i_1+6)=si6
             ssr(i_1+7)=sr7
             ssi(i_1+7)=si7
          end do! i_1

          ds=mpi_wtime()
          call reduce_dbl(ssr(i_2), tt, i_3-i_2+1, mpi_comm_col)
          call reduce_dbl(ssi(i_2), tt, i_3-i_2+1, mpi_comm_col)
          de=mpi_wtime()
          dcom=dcom+(de-ds)

          do i_1=i_2,i_3
             h0 = tau(i,1)
             if ( h0 /= 0.0d+00 ) then
                ssr(i_1) = (ssr(i_1)/h0)/h0
                ssi(i_1) = (ssi(i_1)/h0)/h0
             else
                ssr(i_1) = 0.0d+00
                ssi(i_1) = 0.0d+00
             endif
          end do! i_1

          do i_1=i_2,i_4-1 !                  0
             sr0=ssr(i_1+0)
             si0=ssi(i_1+0)
             do j_1=j_2,j_3
                zr(j_1,i_1+0)=zr(j_1,i_1+0)
     &                                           -sr0*vr(j_1,1)
     &                                           +si0*vi(j_1,1)
                zi(j_1,i_1+0)=zi(j_1,i_1+0)
     &                                           -si0*vr(j_1,1)
     &                                           -sr0*vi(j_1,1)
             end do! j_1
          end do! i_1
          do i_1=i_4,i_3,8 !             7
             sr0=ssr(i_1+0)
             si0=ssi(i_1+0)
             sr1=ssr(i_1+1)
             si1=ssi(i_1+1)
             sr2=ssr(i_1+2)
             si2=ssi(i_1+2)
             sr3=ssr(i_1+3)
             si3=ssi(i_1+3)
             sr4=ssr(i_1+4)
             si4=ssi(i_1+4)
             sr5=ssr(i_1+5)
             si5=ssi(i_1+5)
             sr6=ssr(i_1+6)
             si6=ssi(i_1+6)
             sr7=ssr(i_1+7)
             si7=ssi(i_1+7)
             do j_1=j_2,j_3
                zr(j_1,i_1+0)=zr(j_1,i_1+0)
     &                                           -sr0*vr(j_1,1)
     &                                           +si0*vi(j_1,1)
                zi(j_1,i_1+0)=zi(j_1,i_1+0)
     &                                           -si0*vr(j_1,1)
     &                                           -sr0*vi(j_1,1)
                zr(j_1,i_1+1)=zr(j_1,i_1+1)
     &                                           -sr1*vr(j_1,1)
     &                                           +si1*vi(j_1,1)
                zi(j_1,i_1+1)=zi(j_1,i_1+1)
     &                                           -si1*vr(j_1,1)
     &                                           -sr1*vi(j_1,1)
                zr(j_1,i_1+2)=zr(j_1,i_1+2)
     &                                           -sr2*vr(j_1,1)
     &                                           +si2*vi(j_1,1)
                zi(j_1,i_1+2)=zi(j_1,i_1+2)
     &                                           -si2*vr(j_1,1)
     &                                           -sr2*vi(j_1,1)
                zr(j_1,i_1+3)=zr(j_1,i_1+3)
     &                                           -sr3*vr(j_1,1)
     &                                           +si3*vi(j_1,1)
                zi(j_1,i_1+3)=zi(j_1,i_1+3)
     &                                           -si3*vr(j_1,1)
     &                                           -sr3*vi(j_1,1)
                zr(j_1,i_1+4)=zr(j_1,i_1+4)
     &                                           -sr4*vr(j_1,1)
     &                                           +si4*vi(j_1,1)
                zi(j_1,i_1+4)=zi(j_1,i_1+4)
     &                                           -si4*vr(j_1,1)
     &                                           -sr4*vi(j_1,1)
                zr(j_1,i_1+5)=zr(j_1,i_1+5)
     &                                           -sr5*vr(j_1,1)
     &                                           +si5*vi(j_1,1)
                zi(j_1,i_1+5)=zi(j_1,i_1+5)
     &                                           -si5*vr(j_1,1)
     &                                           -sr5*vi(j_1,1)
                zr(j_1,i_1+6)=zr(j_1,i_1+6)
     &                                           -sr6*vr(j_1,1)
     &                                           +si6*vi(j_1,1)
                zi(j_1,i_1+6)=zi(j_1,i_1+6)
     &                                           -si6*vr(j_1,1)
     &                                           -sr6*vi(j_1,1)
                zr(j_1,i_1+7)=zr(j_1,i_1+7)
     &                                           -sr7*vr(j_1,1)
     &                                           +si7*vi(j_1,1)
                zi(j_1,i_1+7)=zi(j_1,i_1+7)
     &                                           -si7*vr(j_1,1)
     &                                           -sr7*vi(j_1,1)
             end do! j_1
          end do! i_1
          i=i+0; goto 1000

1200      continue

            i_ng=0
            do i_1=2,m-1
               if ( (i+i_1<=n) .and. (tau(i+i_1,1)/=0.0) ) then
                  continue
               else
                  i_ng=i_ng+1
                  exit
               endif
            enddo
            if (i_ng/=0) goto 1111

          ds=mpi_wtime()
          do j=0,m-1
             nodes(j) = get_owner_node(i+j, size_of_row, my_row)
             if ( nodes(j) == my_row ) then
                i_1 = translate_g2l(i+j, size_of_row, my_row)
                j_2 = get_loop_start(1,  size_of_col,my_col)
                j_3 = get_loop_end  (i+m-2,size_of_col,my_col)
                do j_1=j_2,j_3
                   vr(j_1,j+1)=ar(j_1,i_1)
                   vi(j_1,j+1)=ai(j_1,i_1)
                end do! k
                j_2 = get_loop_start(i+j,size_of_col,my_col)
                j_3 = get_loop_end  (i+m-2,size_of_col,my_col)
!cdir novector
                do j_1=j_2,j_3
                   vr(j_1,j+1)=0.0d+00
                   vi(j_1,j+1)=0.0d+00
                end do
             end if
          end do
          j_2 = get_loop_start(1,     size_of_col,my_col)
          j_3 = get_loop_end  (i+m-2, size_of_col,my_col)
          do j=0,m-1
             call bcast_dbl(vr(1,j+1), j_3-j_2+1,
     &                      nodes(j), mpi_comm_row)
             call bcast_dbl(vi(1,j+1), j_3-j_2+1,
     &                      nodes(j), mpi_comm_row)
          enddo
          de=mpi_wtime()
          dcom=dcom+(de-ds)

          call eigen_hbk_main2(
     &           i_3, zr, zi, nmz,
     &           tau, nmtau, m, mm,
     &           vr,vi, wr,wi, nm, i, ssr,ssi,tt, dcom
     &         )

          i=i+m-1; goto 1000

       continue

9000   continue

       call mpi_barrier(mpi_comm_eigen,ierr)
#ifdef DETAIL
       d2=mpi_wtime()
       if (myrank==1) then
          print*," "
          print*,"detail of exectime in eigen_hbk "
          print*,"   time of eigen_hbk_main1=",(d2-d1),"(sec)"
          print*,"   communication in eigen_hbk_main1=",dcom,"(sec)"
!----     print*,"   ",(8d0*n*n*n)/(d2-d1)*1d-9,"gflops"
       end if
#endif

       return
       end subroutine ! eigen_hbk_main1

       subroutine eigen_hbk_main2(n, zr, zi, nmz,
     &            tau, nmtau, m, mm,
     &            vr,vi, wr,wi, nm, i, ssr,ssi, tt, dcom)
!----
      use communication_h, only : get_loop_start
     &               , get_loop_end
     &               , reduce_dbl
!----
       implicit double precision(a-h,o-z),integer(i-n)

       integer :: n, nmz, nm, i
       real(8) :: zr(nmz,*),zi(nmz,*),tau(nmtau,2)
       real(8) :: vr(nm,*),vi(nm,*),wr(nm,*),wi(nm,*)
       real(8) :: ssr(*),ssi(*), tt(*), dcom, ds, de

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'

          i_2=1
          i_3=n
          j_2 = get_loop_start(1,    size_of_col,my_col)
          j_3 = get_loop_end  (i+m-2,size_of_col,my_col)

          do iss=1,m*(m-1)/2
             ssr(iss)=0.0d0
             ssi(iss)=0.0d0
          enddo
          do j_10=j_2,j_3,128; j_4=j_10; j_5=min(j_3,j_10+128-1)
          iss=m*(m-1)/2
          do l_1=m,2,-1
          do k_1=l_1-1,1,-1
             sr0=ssr(iss)
             si0=ssi(iss)
             do j_1=j_4,j_5
             vr1=vr(j_1,l_1)
             vi1=vi(j_1,l_1)
             vr0=vr(j_1,k_1)
             vi0=vi(j_1,k_1)
             sr0=sr0+vr1*vr0+vi1*vi0
             si0=si0-vi1*vr0+vr1*vi0
             enddo
             ssr(iss)=sr0
             ssi(iss)=si0
             iss=iss-1
          enddo
          enddo
          enddo

          i_5 = i_3 - i_2 + 1
          j_5 = j_3 - j_2 + 1
          if ( j_5 > 0 .and. i_5 > 0 ) then
                 call dgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, vr(j_2    ,1       ), nm,
     &                        zr(j_2    ,i_2     ), nmz,
     &               0.0d+00, ssr(1     +mm     ), m)
                 call dgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, vi(j_2    ,1       ), nm,
     &                        zi(j_2    ,i_2     ), nmz,
     &               1.0d+00, ssr(1     +mm     ), m)

                 call dgemm('t','n',
     &               m, i_5, j_5,
     &              -1.0d+00, vi(j_2    ,1       ), nm,
     &                        zr(j_2    ,i_2     ), nmz,
     &               0.0d+00, ssi(1     +mm     ), m)
                 call dgemm('t','n',
     &               m, i_5, j_5,
     &               1.0d+00, vr(j_2    ,1       ), nm,
     &                        zi(j_2    ,i_2     ), nmz,
     &               1.0d+00, ssi(1     +mm     ), m)
          endif
!----
          ds=mpi_wtime()
          call reduce_dbl(ssr, tt, (i_3-i_2+1)*m+mm, mpi_comm_col)
          call reduce_dbl(ssi, tt, (i_3-i_2+1)*m+mm, mpi_comm_col)
          de=mpi_wtime()
          dcom=dcom+(de-ds)
!----
             iss=m*(m-1)/2
          do k_1=m,1,-1
             h0=tau(i+k_1-1,1)
          do i_1=k_1-1,1,-1
             ssr(iss)=(ssr(iss)/h0)/h0
             ssi(iss)=(ssi(iss)/h0)/h0
             iss=iss-1
          enddo
          do i_1=i_2,i_3
             ssr((i_1-i_2)*m+k_1+mm)=
     $          (ssr((i_1-i_2)*m+k_1+mm)/h0)/h0
             ssi((i_1-i_2)*m+k_1+mm)=
     $          (ssi((i_1-i_2)*m+k_1+mm)/h0)/h0
          end do! i_1
          end do! k_1
!----
          do j_10=j_2,j_3,128; j_4=j_10; j_5=min(j_3,j_10+128-1)
          do l_1=m,1,-1
             do j_1=j_4,j_5
                wr(j_1,l_1)=vr(j_1,l_1)
                wi(j_1,l_1)=vi(j_1,l_1)
             enddo
          enddo
             iss=m*(m-1)/2
          do l_1=m,2,-1
          do k_1=l_1-1,1,-1
             do j_1=j_4,j_5
                wr(j_1,k_1)=wr(j_1,k_1)
     &                     -wr(j_1,l_1)*ssr(iss)
     &                     +wi(j_1,l_1)*ssi(iss)
                wi(j_1,k_1)=wi(j_1,k_1)
     &                     -wi(j_1,l_1)*ssr(iss)
     &                     -wr(j_1,l_1)*ssi(iss)
             enddo
             iss=iss-1
          enddo
          enddo
          enddo
!----
          i_5=i_3-i_2+1
          j_5=j_3-j_2+1
          if ( j_5 > 0 .and. i_5 > 0 ) then
             call dgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, wr(j_2 ,1  ), nm,
     &                        ssr(1   +mm), m,
     &               1.0d+00, zr(j_2 ,i_2), nmz)
             call dgemm('n','n',
     &               j_5, i_5, m,
     &              +1.0d+00, wi(j_2 ,1  ), nm,
     &                        ssi(1   +mm), m,
     &               1.0d+00, zr(j_2 ,i_2), nmz)
             call dgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, wr(j_2 ,1  ), nm,
     &                        ssi(1   +mm), m,
     &               1.0d+00, zi(j_2 ,i_2), nmz)
             call dgemm('n','n',
     &               j_5, i_5, m,
     &              -1.0d+00, wi(j_2 ,1  ), nm,
     &                        ssr(1   +mm), m,
     &               1.0d+00, zi(j_2 ,i_2), nmz)
          endif

       return
       end subroutine ! eigen_hbk_main2

      module eigen_TRBAK
!$    use OMP_LIB
      implicit NONE
!=
         real(8) :: TRBK_TIME_BCAST
         real(8) :: TRBK_TIME_REDUC
         real(8) :: TRBK_TIME_FR
         real(8) :: TRBK_TIME_TRBK1
         real(8) :: TRBK_TIME_TRBK1x
         real(8) :: TRBK_TIME_TRBK1y
         real(8) :: TRBK_TIME_TRBK2
!$       integer(kind=omp_lock_kind) :: TRBK_LOCK(1:2)
         integer :: DO_OVERLAP_BCAST_LEVEL
         integer :: TRBK_TIME_COUNTER
         integer :: TRBK_TIME_INTERVAL
         integer :: TRBK_TIME_NEXT
         integer :: TRBK_SWITCHED
!=
         real(8), pointer :: TRBK_buf(:)
!=
      end module eigen_TRBAK

#ifdef ACMLFFT
  subroutine dzfft3d(mode,l,m,n,x,ldl,ldm,ldn,comm,info)
    !! ldl >= l+2 (l+3) when l is even (odd), and ldl is even.
    !! ldm >= m
    !! ldn >= n
    !! comm : real*8 dimension(3*l+6*m+6*n+2*m*n+500)
    implicit none
    integer, intent(in) :: mode !! 0: initialization, 1: transform
    integer, intent(in) :: l,m,n
    integer, intent(in) :: ldl,ldm,ldn
    real(kind=8), intent(inout) :: x(ldl*ldm*ldn)
    real(kind=8), intent(inout), target :: comm(*)
    integer, intent(out) :: info

    integer :: ldh,incm,incn,i
    integer :: lcomm1, lcomm2
    real(kind=8), pointer :: comm1(:)
    real(kind=8), pointer :: comm2(:)

    lcomm1 = 3*l+100
    lcomm2 = 2*(m*n+3*m+3*n+200)

    comm1 => comm(1:lcomm1)
    comm2 => comm(lcomm1+1:lcomm1+lcomm2)

    ldh = ldl/2
    incm = ldh
    incn = ldh*ldm

    if(mode==0) then
       call dzfft(0,l,x,comm1,info)
       if(info/=0) return
       call zfft2dx(0,1.d0,.true.,.true.,m,n, &
                  & x,incm,incn,x,incm,incn, &
                  & comm2,info)
       return
    else if(mode/=1) then
       write(*,*) 'irregular mode = ',mode
       return
    end if

    call dzfftm2(m*n,l,x,ldl,comm1,info)
    if(info/=0) return
    do i=1,l/2+1
       call zfft2dx(-1,1.d0,.true.,.true.,m,n, &
                  & x(2*i-1),incm,incn,x,incm,incn, &
                  & comm2,info)
       if(info/=0) return
    end do
  end subroutine dzfft3d
 
  subroutine zdfft3d(mode,l,m,n,x,ldl,ldm,ldn,comm,info)
    !! ldl >= l+2 (l+3) when l is even (odd), and ldl is even.
    !! ldm >= m
    !! ldn >= n
    !! comm : real*8 dimension(3*l+6*m+6*n+2*m*n+500)
    implicit none
    integer, intent(in) :: mode !! 0: initialization, 1: transform
    integer, intent(in) :: l,m,n
    integer, intent(in) :: ldl,ldm,ldn
    real(kind=8), intent(inout) :: x(ldl*ldm*ldn)
    real(kind=8), intent(inout), target :: comm(*)
    integer, intent(out) :: info

    integer :: ldh,incm,incn,i
    integer :: lcomm1, lcomm2
    real(kind=8), pointer :: comm1(:)
    real(kind=8), pointer :: comm2(:)

    lcomm1 = 3*l+100
    lcomm2 = 2*(m*n+3*m+3*n+200)

    comm1 => comm(1:lcomm1)
    comm2 => comm(lcomm1+1:lcomm1+lcomm2)

    ldh = ldl/2
    incm = ldh
    incn = ldh*ldm

    if(mode==0) then
       call dzfft(0,l,x,comm1,info)
       if(info/=0) return
       call zfft2dx(0,1.d0,.true.,.true.,m,n, &
                  & x,incm,incn,x,incm,incn, &
                  & comm2,info)
       return
    else if(mode/=1) then
       write(*,*) 'irregular mode = ',mode
       return
    end if

    do i=1,l/2+1
       call zfft2dx(1,1.d0,.true.,.true.,m,n, &
                  & x(2*i-1),incm,incn,x,incm,incn, &
                  & comm2,info)
       if(info/=0) return
    end do
    call zdfftm2(m*n,l,x,ldl,comm1,info)
  end subroutine zdfft3d

  subroutine dzfftm2(m,n,x,ld,comm,info)
    !! ld >= n+2 when n is even.
    !! ld >= n+1 when n is odd.
    implicit none
    integer, intent(in) :: m,n,ld
    real(kind=8), intent(inout) :: x(ld*m)
    real(kind=8), intent(inout) :: comm(3*n+100)
    integer, intent(out) :: info

    real(kind=8) :: y(n)
    integer :: i,j
    real(kind=8) :: s

    s = sqrt(dble(n))

    do j=0,m-1
       do i=1,n
          y(i) = x(i+ld*j)
       end do
       call dzfftm(1,n,y,comm,info)
       do i=0,n/2
          x(1+2*i+ld*j) = s*y(1+i)
       end do
       do i=1,(n-1)/2
          x(2+2*i+ld*j) = s*y(1+n-i)
       end do
       x(2+ld*j) = 0.d0
       x(n+2+ld*j) = 0.d0
    end do
  end subroutine dzfftm2

  subroutine zdfftm2(m,n,x,ld,comm,info)
    !! ld >= n+2 when n is even.
    !! ld >= n+1 when n is odd.
    implicit none
    integer, intent(in) :: m,n,ld
    real(kind=8), intent(inout) :: x(ld*m)
    real(kind=8), intent(inout) :: comm(3*n+100)
    integer, intent(out) :: info

    real(kind=8) :: y(n)
    integer :: i,j
    real(kind=8) :: s

    s = sqrt(dble(n))

    do j=0,m-1
       do i=0,n/2
          y(1+i) = x(1+2*i+ld*j)
       end do
       do i=1,(n-1)/2
          y(1+n-i) = -x(2+2*i+ld*j)
       end do
       call zdfftm(1,n,y,comm,info)
       do i=1,n
          x(i+ld*j) = s*y(i)
       end do
       x(n+1+ld*j) = 0.d0
       x(n+2+ld*j) = 0.d0
    end do
  end subroutine zdfftm2
#else
  subroutine dummy_acmlfft
  end subroutine dummy_acmlfft
#endif

      subroutine eigen_hrd_2update(
     &             ar, ai, nm,
     &             ur_x, ui_x,
     &             ur_y, ui_y,
     &             vr_x, vi_x,
     &             vr_y, vi_y,
     &             nv, m, n,
     &             ar_,ai_,n_,nm_
     &           )

!======================================================================!
!$    use omp_lib
      implicit none
!----
      real(8), intent(inout) :: ar (nm,*),  ai (nm,*)
      real(8), intent(in)    :: ur_x(nv,*), ui_x(nv,*)
      real(8), intent(in)    :: ur_y(nv,*), vi_y(nv,*)
      real(8), intent(in)    :: vr_x(nv,*), vi_x(nv,*)
      real(8), intent(in)    :: vr_y(nv,*), ui_y(nv,*)
      integer, intent(in)    :: nm, nv, m, n
      real(8) :: ar_, ai_
      integer :: n_, nm_
!----
      if ( n <= 0 ) return
!----
      call eigen_hrd_2update_body(
     &       ar(1,1), ai(1,1),
     &       nm,
     &       ur_x(1,1), ui_x(1,1), ur_y(1,1), ui_y(1,1),
     &       vr_x(1,1), vi_x(1,1), vr_y(1,1), vi_y(1,1),
     &       nv, m, n
     &     )
!----
      end subroutine
!======================================================================!
      subroutine eigen_hrd_2update_body(
     &             ar_alias_0, ai_alias_0,
     &             nma,
     &             ur, ui, uyr, uyi, vr, vi, vyr, vyi, nmv,
     &             m_size, i_base
     &           )
!----
      use communication_h, only : get_loop_start
     &               , get_loop_end
     &               , translate_l2g
!----
!$    use omp_lib
      implicit none
!----
      real(8), intent(inout) :: ar_alias_0(nma,*), ai_alias_0(nma,*)
      real(8), intent(in)    :: ur (nmv,*), ui (nmv,*)
      real(8), intent(in)    :: uyr(nmv,*), uyi(nmv,*)
      real(8), intent(in)    :: vr (nmv,*), vi (nmv,*)
      real(8), intent(in)    :: vyr(nmv,*), vyi(nmv,*)
      integer, intent(in)    :: nma, nmv, m_size, i_base
!----
      integer :: j, k0, n

      integer, parameter :: nvec = 2128
      integer, parameter :: blas_chunk = 24
      integer, parameter :: blas_nvect = 1024

      include 'trd.h'

      integer :: i_1,i_2,i_3,i_4
      integer :: j_1,j_2,j_3,j_4
      integer :: ii_1,ii_2,ii_3,ii_4
      integer :: jjj_1,jjj_2,jjj_3,jjj_4
      integer :: ii_step
!----
      integer :: local_rank, local_size
!----
      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()
!----
      n = get_loop_end  (i_base, size_of_row,my_row)
      k0 = translate_l2g(n, size_of_row,my_row)

      jjj_2 = 1 ! get_loop_start(1,      size_of_col, my_col)
      jjj_3 = get_loop_end  (k0, size_of_col,my_col)
      ii_step = 0
      do jjj_1 = jjj_2, jjj_3, blas_nvect
         jjj_4 = min(jjj_1+blas_nvect-1, jjj_3)
         k0   = translate_l2g(jjj_1, size_of_col, my_col)
         ii_2 = get_loop_start(k0,     size_of_row, my_row)
         ii_2 = max(jjj_2,ii_2)
         ii_3 = n

         do i_1=ii_2,ii_3,blas_chunk
            i_4=min(ii_3-i_1+1,blas_chunk)
            i_3 = i_1+i_4-1
            j   = translate_l2g(i_3, size_of_row, my_row)
            j_4 = get_loop_end(j, size_of_col, my_col)
            j_4 = min(j_4,jjj_4)-jjj_1+1

            ii_step = ii_step+1
            if(mod(ii_step-1,local_size)==local_rank)then

               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, ur (jjj_1,1), nmv,
     &                    vyr(i_1,1), nmv,
     &                    1.0d+00, ar_alias_0(jjj_1, i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, ui (jjj_1,1), nmv,
     &                    vyi(i_1,1), nmv,
     &                    1.0d+00, ar_alias_0(jjj_1, i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, vr (jjj_1,1), nmv,
     &                    uyr(i_1,1), nmv,
     &                    1.0d+00, ar_alias_0(jjj_1,i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, vi (jjj_1,1), nmv,
     &                    uyi(i_1,1), nmv,
     &                    1.0d+00, ar_alias_0(jjj_1,i_1), nma)

            end if

            ii_step = ii_step+1
            if(mod(ii_step-1,local_size)==local_rank)then

               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, ui (jjj_1,1), nmv,
     &                    vyr(i_1,1), nmv,
     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    1.0d+00, ur (jjj_1,1), nmv,
     &                    vyi(i_1,1), nmv,
     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    -1.0d+00, vi (jjj_1,1), nmv,
     &                    uyr(i_1,1), nmv,
     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)
               call dgemm('n','t',
     &                    j_4, i_4, m_size,
     &                    1.0d+00, vr (jjj_1,1), nmv,
     &                    uyi(i_1,1), nmv,
     &                    1.0d+00, ai_alias_0(jjj_1,i_1), nma)

            end if

         end do

      end do
!----
      return
      end subroutine
!======================================================================!

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE:  m_Total_Energy
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Total_Energy
!    ( m_TE )
! $Id: m_Total_Energy.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Charge_Density,       only : chgq_l, chgqo_l, hsr, hsro
  use m_XC_Potential,         only : vxc_l, exc,eex,ecor
  use m_XC_Potential,         only : m_XC_cal_potential
  use m_Electronic_Structure, only : nrvf_ordr, occup_l, eko_l, totch &
      &                            , band_entropy, dhub &
      &                            , m_ES_eekdif_cond &
      &                            , zaj_l, vloc_esm, m_ES_what_is_evdff_now
  use m_PseudoPotential,      only : psc_l,etot1,ilmt,ltp,mtp,epc,dion, ival &
                                    , flg_paw,ipaw &
                                    , dion_hartree,dion_vxc,dion_paw &
                                    , dion_hartree_now, dion_kin_ion &
                                    , flg_symmtry,ia2ia_symmtry_op, epc_paw
  use m_PlaneWaveBasisSet,    only : gr_l,m_pwBS_kinetic_energies,iba,kg1,igfp_l
  use m_FFT,                  only : nfftps
  use m_Crystal_Structure,    only : univol,nopr,op
  use m_Ionic_System,         only : ntyp,natm,natm2,iwei,ityp,zfm3_l &
      &                            , eewald, ihubbard &
      &                            , evdw, ntyp_vdw &
      &                            , num_regions, regions
  use m_Timing,               only : tstatc0_begin, tstatc0_end
!!$  use m_Control_Parameters,   only : af, kimg, ipri, nspin, edelta, neg &
  use m_Control_Parameters,   only : af, kimg, ipri, nspin, neg &
       &                           , num_extra_bands, printable, xctype, oneshot &
       &                           , width, way_of_smearing, icond &
       &                           , m_CtrlP_ntcnvg_incre &
       &                           , m_CtrlP_ntcnvg_clear &
       &                           , m_CtrlP_ntcnvg_reset &
       &                           , m_CtrlP_get_edelta &
       &                           , m_CtrlP_sub_ntcnvg_incre &
       &                           , m_CtrlP_solver_for_WFs_now &
       &                           , m_CtrlP_get_isolver_now &
       &                           , sub_delta_factor_is_given &
       &                           , sub_delta_factor &
       &                           , sw_dipole_correction, sw_screening_correction &
       &                           , sw_hubbard, proj_attribute &
       &                           , critical_ehub, delta_ehub &
       &                           , num_conduction_bands_lmm &
       &                           , sw_hybrid_functional, sw_eval_vexx, sw_retard_eigval_evaluation, sw_fef &
       &                           , in_line_minimization &
       &                           , sw_external_potential, ekmode, icond, sw_rsb, sw_output_xc_seperately &
       &                           , number_of_cdmixing_applied, cdmixing_names_applied &
       &                           , number_of_solvers_applied, solver_names_applied, len_solvername &
       &                           , sw_potential_mixing &
#ifdef ENABLE_ESM_PACK
       &                           , sw_esm &
#endif
       &                           , m_CtrlP_push_CDMixingNameApplied,sw_harris_functional &
       &                           , nsamp, convergence_criteria &
       &                           , sw_vdw_correction, vdw_method &
       &                           , order_mp
  use m_Kpoints,              only : qwgt,kv3,vkxyz,k_symmetry
  use m_IterationNumbers,     only : iteration, iteration_electronic,iteration_ionic
  use m_Parallelization,      only : mpi_comm_group,map_k,myrank_k,ierr,np_e &
       &                           , ista_kngp,iend_kngp,npes,mype &
       &                           , myrank_e, map_e, map_z   &
       &                           , ista_atm, iend_atm, myrank_g, nrank_g, nrank_e &
       &                           , ista_e, iend_e, istep_e
  use m_Const_Parameters,     only : Valence_plus_PC_Charge,PAI4,UP,DOWN&
       &                           , EXC_ONLY, VXC_AND_EXC, IINCRE_CRITICAL,DP,CMPLDP &
       &                           , len_tag_total_energy, tag_total_energy &
       &                           , PARABOLIC, COLD, ON, OFF &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, GAMMA, DELTA &
       &                           , MDKOSUGI, MDDAVIDSON, INITIAL, CONTINUATION, COORDINATE_CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, MATRIXDIAGON &
       &                           , DELTA_MOVING_AVERAGE, SLOPE, DELTA_V &
       &                           , VDW_DFTD3 &
       &                           , MP
  use m_Dipole,               only : edip_ion, eext_ion, vdip_l, vext_l
  use m_Screening,            only : screening
  use m_Hubbard,              only : m_Hubbard_energy
  use m_FiniteElectricField,  only : m_FEF_polarization, pmac, pmac_old
  use m_ES_ExactExchange,     only : m_ES_EXX_gather_valence_states,m_ES_EXX_energy &
       &                           , m_ES_EXX_energy2
#if 0
       &  , m_ES_EXX_gather_valence_states_k
#endif
  use m_PAW_XC_Potential,     only : m_PAW_XC_cal_potential,exc_ae,exc_ps &
       &                           , m_PAW_XC_cal_potential_sphex2 
!!$                                    , m_PAW_XC_cal_potential_sym
  use m_PAW_Hartree,          only : m_PAWH_get_dion_hartree_now
  use m_External_Potential,   only : espot_g
  use m_PAW_ChargeDensity,    only : calcGaussLegendreIntegration &
       &                            , calcSphericalHarmonicsExpansion


! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_magmom, ndim_chgpot
  use m_PseudoPotential,       only : dion0_noncl, nlmt
  use m_Charge_Density,         only : hsi
  use m_ES_NonCollinear,       only : m_ES_MagMom_To_DensMat_hsr, &
       &                              m_ES_MagMom_to_DensMat_Dhub
!
  use m_Crystal_Structure,     only :  sw_magnetic_constraint
  use m_ES_Mag_Constraint,      only : m_ES_calc_MagConstraint_Energy
  use m_Hubbard,              only : m_Hubbard_energy_noncl, &
       &                             m_Hubbard_energy2_noncl, &
       &                             m_Hubbard_energy3_noncl
! ========================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
  use m_Control_Parameters,    only : SpinOrbit_Mode
  use m_Const_Parameters,      only : ByPawPot, Neglected, CMPLDP, BuiltIn, EXECUT, &
       &                              ByProjector, ZeffApprox, ReadFromPP
  use m_SpinOrbit_Potential,   only : dsoc, m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,    only : m_SO_calc_SOC_strength_pawpot
  use m_PseudoPotential,      only : lmta,  m_PP_include_vanderbilt_pot, dion_scr_noncl
  use m_Electronic_Structure,   only : fsr_l, fsi_l, dhub_aimag
! ========================================================================== 11.0


! ======================= KT_add ================== 13.0E
  use m_Const_Parameters,   only : Fermi_Dirac
! ================================================= 13.0E

! =========== KT_add ========== 13.0U2
  use m_Control_Parameters,  only : sw_potential_mixing
! ============================= 13.0U2

#ifndef DISABLE_VDWDF
  use m_vdWDF,  only : ecnl_vdwdf
#endif

  use m_Control_Parameters,  only : m_CtrlP_get_isolver_now

! === Positron SCF ==== 2015/11/28
  use m_Control_Parameters,  only : sw_positron, npeg, positron_method
  use m_Const_Parameters,   only :  positron_GGGC
  use m_epc_potential,  only : ecorr_pztr => epc, m_epc_cal_potential, vepc_l
  use m_PlaneWaveBasisSet, only : kg1_pwf
  use m_Positron_Wave_Functions,  only : pzaj, nprvf_ordr, pchg_l, pchgo_l, pev
  use m_PlaneWaveBasisSet,    only : m_pwBS_pstrn_kinetic_energies
! ==================== 2015/11/28

  implicit none
  include 'mpif.h'

  real(kind=DP),private          :: eband ! band energy
  real(kind=DP),private          :: eband_extendedrange
  real(kind=DP),private          :: eohxc ! exchange correlation and &
  !                                         Hartree with old charge

! ==== KT_mod === 13.0U2
!!  real(kind=DP),private          :: elocal ! local potential
  real(kind=DP)            :: elocal ! local potential
! =============== 13.0U2

  real(kind=DP),private          :: eloca1
  real(kind=DP),private          :: enonlc ! non-local
!!$  real(kind=DP),private          :: ehartr ! hartree energy with new charge
  real(kind=DP)                  :: ehartr ! hartree energy with new charge
  real(kind=DP),private          :: ekinet ! kinetic energy
  real(kind=DP),private          :: eentropy ! entropic term of free energy (-TS)

  real(kind=DP),private          :: edip   ! dipole energy
  real(kind=DP),private          :: evdip  ! dipole potential
  real(kind=DP),private          :: evext  ! external potential

  real(kind=DP),private          :: etoold ! previous total energy
  real(kind=DP),private          :: edeltb = 1.d99 ! etotal - etoold
  real(kind=DP)                  :: etotal ! total free energy: F(simga)
  real(kind=DP)                  :: etotal0 ! total energy: E(sigma=0)

  real(kind=DP)                  :: eespot ! electrostatic potential

  real(kind=DP), pointer, dimension(:,:,:) :: chgqt,chgqto
  real(kind=DP), pointer, dimension(:,:,:,:) :: hsrt,hsit
  !
  ! Free energy:
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !
  ! 1. E(sigma=0) exprapolation for the cold smearing method
  !E(sigma=0) ~ (2*F(sigma)+E(sigma))/3
  !
  ! 2. E(sigma=0) exprapolation for the parabolic broadening method
  !F(sigma) = E(sigma) - sigma*S(sigma)
  !E(sigma=0) ~ (F(sigma)+E(sigma))/2
  !

  ! DFT+U
  real(kind=DP),private          :: ehub0 ! Hubbard energy
  real(kind=DP),private          :: ehub0_old = 1.d+20 ! Old Hubbard energy
  real(kind=DP),private          :: ehub1 ! Hubbard potential energy

  ! PAW
  real(kind=DP),private          :: eohxc_paw, ehartr_paw, ekin_ion_paw

  ! Hybrid functional method
  real(kind=DP),private          :: vexx,eexx

  ! Finite electric field method
  real(kind=DP),private          :: eplr  ! -EP term

! ============================== added by K. Tagami ================== 11.0
! Magnetic constraint
!
  real(kind=DP),private          :: emag0      ! magnetic constraint energy
  real(kind=DP),private          :: emag1      ! double counting energy
! ==================================================================== 11.0

! ====================================== added by K. Tagami ================ 11.0
! Spin Orbit
!
  real(kind=DP),private          :: espinorb_old, espinorb_now
! ========================================================================== 11.0

! === positron
  real(kind=DP) :: ekin_pztr, elocal_pztr, ehartr_ep, eohxc_pztr
! ===

  integer,private, parameter     :: len_str = 132
  character(len=len_str),private    ::  str

  real(kind=DP), allocatable, dimension(:) :: ehist
  integer :: ihist
  real(kind=DP) :: emova, emovaold
contains
  real(DP) function m_TE_what_is_edeltb_now()
     m_TE_what_is_edeltb_now = edeltb
  end function m_TE_what_is_edeltb_now

  subroutine m_TE_wd_total_energy_with_solvers(nfout)
    integer, intent(in) :: nfout
    logical :: display_on
    display_on = .true.
    call sumup_all_energies(nfout,exc,display_on)

  end subroutine m_TE_wd_total_energy_with_solvers

  subroutine m_TE_total_energy(nfout,display_on,kv3)
#if 0
    use m_Control_Parameters, only : sw_distribute_wf, force_exx_energy1
#else
    use m_Control_Parameters, only : force_exx_energy1
#endif
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    integer, intent(in) :: kv3
    integer :: isolver,sw_submat
    real(kind=DP) :: edeltb_now
    integer             :: id_sname = -1
    call tstatc0_begin('Total_Energy(including xc_pot) ',id_sname)
    if(sw_harris_functional == OFF)then
      chgqt => chgq_l
      chgqto => chgqo_l
      hsrt => hsr
      if(noncol) hsit => hsi
    else
      chgqt => chgqo_l
      chgqto => chgqo_l
      hsrt => hsro
      if(noncol) hsit => hsi
    endif
    call get_band_energy(kv3)
    call get_xc_and_HE_of_old_CD(vxc_l)
    call get_local_potential_energy
    call get_hubbard_energy(nfout)
    call get_nonlocal_potential_energy
    if(in_line_minimization) then
      call m_XC_cal_potential(nfout,Valence_plus_PC_Charge, chgqt, EXC_ONLY)
    else
      call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgqt,VXC_AND_EXC)
    endif
#ifdef ENABLE_ESM_PACK
    if (sw_esm==OFF) then
       call get_hartree_energy
    endif
#else
    call get_hartree_energy
#endif
    if(sw_dipole_correction ==  ON) call get_dipole_energy(vdip_l,vext_l)
    if(sw_fef == ON) then
       call m_FEF_polarization(nfout,eplr)
    endif
    if(sw_hybrid_functional == ON) then
       if(sw_eval_vexx==ON) call m_ES_EXX_energy(vexx)
       if(icond == INITIAL .or. icond == CONTINUATION .or. icond == COORDINATE_CONTINUATION .or. &
       & ((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION)&
       &                             .and. ekmode == OFF)   ) then
          edeltb_now = m_TE_what_is_edeltb_now()/natm2
!!$     write(nfout,'(" edeltb_per_atom = ", d20.12)') edeltb_per_atom
       else
          edeltb_now = m_ES_what_is_evdff_now()
       end if
       !isolver = m_CtrlP_solver_for_WFs_now(iteration_electronic,iteration_ionic,0 &
       !&                              ,edeltb_now,sw_submat)
       isolver = m_CtrlP_get_isolver_now()
       if(sw_retard_eigval_evaluation==OFF.or.isolver==MDDAVIDSON.or.isolver==MDKOSUGI.or. &
       &  force_exx_energy1.or.isolver==MATRIXDIAGON) then
#if 0
          if(sw_distribute_wf==ON)then
             call m_ES_EXX_gather_valence_states_k(nfout)
          else
             call m_ES_EXX_gather_valence_states(nfout)
          endif
#else
          call m_ES_EXX_gather_valence_states(nfout)
#endif

          call m_ES_EXX_energy(eexx)
       else
          call m_ES_EXX_energy2(eexx)
       endif
    end if
    force_exx_energy1 = .false.

    if ( sw_magnetic_constraint == ON ) call get_magnetic_constraint_energy

    call get_entropic_term(nfout)
    if(flg_paw) then
#if 0
        call get_xc_and_HE_of_old_CD_paw(nfout)
!       call get_xc_and_HE_of_old_CD_paw_sym
#endif
        if(calcSphericalHarmonicsExpansion) then
          call m_PAW_XC_cal_potential_sphex2(nfout,EXC_ONLY)
!    call m_PAW_XC_cal_potential_sphex3(nfout,VXC_AND_EXC)
        end if
        if(calcGaussLegendreIntegration)then
           call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
        endif
!!$        if(.not.flg_symmtry) then
!!$            call m_PAW_XC_cal_potential(nfout,EXC_ONLY)
!!$        else
!!$            call m_PAW_XC_cal_potential_sym(nfout,EXC_ONLY)
!!$        end if
        call m_PAWH_get_dion_hartree_now(nfout)
        call get_hartree_energy_paw(nfout)
!       call get_hartree_energy_paw_sym
!
#if 1
        call get_kinetic_local_energy_paw(nfout)
#endif        
    end if

    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          call get_local_pot_energy_pztr
          call get_xc_and_HE_of_old_CD_pztr( vepc_l )
          call get_hartree_energy_inter_ep
          call m_epc_cal_potential( nfout, chgqt )

         if (iteration_electronic==1) then
            call get_kinetic_energy_pztr_direct(nfout)
         else
            call get_kinetic_energy_pztr(nfout)
         endif
       endif
    endif

#ifdef ENABLE_ESM_PACK
! ============== KT_mod =============================== 13.0U2
!    if(sw_esm==ON.or.sw_hybrid_functional==ON)then
    if ( sw_esm==ON .or. sw_hybrid_functional==ON &
         &          .or. sw_potential_mixing==ON  &
         &          .or. sw_rsb==ON &
         &          .or. xctype=='vdwdf') then
! ===================================================== 13.0U2
       call get_kinetic_energy_directly(nfout)
    else
       if(iteration_electronic==1) then
          call get_kinetic_energy_directly(nfout)
       else
          call get_kinetic_energy(nfout)
       endif
    endif
#else
! ============== KT_mod =============================== 13.0U2
!    if(sw_hybrid_functional==ON.or.iteration_electronic==1)then
    if ( sw_hybrid_functional==ON .or. iteration_electronic==1 &
         &                        .or. sw_potential_mixing==ON &
         &                        .or. sw_rsb==ON &
         &                        .or. xctype=='vdwdf') then
! ===================================================== 13.0U2
       call get_kinetic_energy_directly(nfout)
    else
       call get_kinetic_energy(nfout)
    endif
#endif

    call sumup_all_energies(nfout,exc,display_on)

    call tstatc0_end(id_sname)
  end subroutine m_TE_total_energy

! =============================== added by K. Tagami ================= 11.0
  subroutine m_TE_total_energy_noncl(nfout,display_on,kv3)
#if 0
    use m_Control_Parameters, only : sw_distribute_wf
#endif

    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    integer, intent(in) :: kv3
    integer             :: id_sname = -1
    call tstatc0_begin('Total_Energy(including xc_pot) ',id_sname)
    if(sw_harris_functional == OFF)then
      chgqt => chgq_l
      chgqto => chgqo_l
      hsrt => hsr
      if(noncol) hsit => hsi
    else
      chgqt => chgqo_l
      chgqto => chgqo_l
      hsrt => hsro
      if(noncol) hsit => hsi
    endif

    if(sw_harris_functional == OFF)then
      chgqt => chgq_l
      chgqto => chgqo_l
      hsrt => hsr
      if(noncol) hsit => hsi
    else
      chgqt => chgqo_l
      chgqto => chgqo_l
      hsrt => hsro
      if(noncol) hsit => hsi
    endif

    call get_band_energy_noncl(kv3)
    call get_xc_and_HE_of_old_CD_noncl(vxc_l)
    call get_local_pot_energy_noncl
    call get_hubbard_energy_noncl(nfout)

#if 0
    call get_nonlocal_pot_energy_noncl
#else
    call get_nonlocal_pot_energy_noncl2
#endif

    call m_XC_cal_potential( nfout,Valence_plus_PC_Charge, chgqt, EXC_ONLY)

#ifdef ENABLE_ESM_PACK
    if (sw_esm==OFF) then
       call get_hartree_energy_noncl
    endif
#else
    call get_hartree_energy_noncl
#endif

    if(sw_dipole_correction ==  ON) then
       call get_dipole_energy_noncl(vdip_l,vext_l)
    end if

    if(sw_fef == ON) then
       write(*,*) 'Not supported : FEF ';    stop
       call m_FEF_polarization(nfout,eplr)
    endif

    if(sw_hybrid_functional == ON) then
       write(*,*) 'Not supported : hybrid '
       stop
       if(sw_eval_vexx==ON) call m_ES_EXX_energy(vexx)
#if 0
       if(sw_distribute_wf==ON)then
          call m_ES_EXX_gather_valence_states_k(nfout)
       else
          call m_ES_EXX_gather_valence_states(nfout)
       endif
#else
       call m_ES_EXX_gather_valence_states(nfout)
#endif

       call m_ES_EXX_energy(eexx)
    end if

    if ( sw_magnetic_constraint == ON ) call get_magnetic_constraint_energy

    call get_entropic_term(nfout)

    if (flg_paw) then
!       stop 'Not supported : PAW'
#if 0
       call get_xc_and_HE_old_CD_paw_noncl(nfout)
#endif
       if (calcSphericalHarmonicsExpansion) then
          call m_PAW_XC_cal_potential_sphex2(nfout,EXC_ONLY)

       end if
       if (calcGaussLegendreIntegration)then
          stop 'Not supported : Gauss Legendre in paw + noncol'
          call m_PAW_XC_cal_potential(nfout,EXC_ONLY,flg_symmtry)
       endif

       call m_PAWH_get_dion_hartree_now(nfout)
       call get_hartree_energy_paw_noncl(nfout)
#if 1
       call get_kinetic_local_energy_paw(nfout)
#endif
    end if
!
!!!#ifdef USE_ESPINORB
    if ( flg_paw ) then
       if ( SpinOrbit_Mode == ByPawPot ) then
#if 1
          call get_spinorbit_energy_noncl2(espinorb_old)
#else
          call get_spinorbit_energy_noncl3(espinorb_old)
#endif
          call m_SO_calc_SOC_strength_pawpot
          call m_SO_set_Dsoc_potential2
!
#if 1
          call get_spinorbit_energy_noncl2(espinorb_now)
#else
          call get_spinorbit_energy_noncl3(espinorb_now)
#endif
      endif
    endif

    if ( SpinOrbit_Mode == ByProjector .or. &
         &  SpinOrbit_Mode == ZeffApprox .or. &
         &  SpinOrbit_Mode == ReadFromPP ) then
#if 1
       call get_spinorbit_energy_noncl2(espinorb_now)
#else
       call get_spinorbit_energy_noncl3(espinorb_now)
#endif
    endif
!!!#endif
! 
    call get_kinetic_energy(nfout)

    call sumup_all_energies(nfout,exc,display_on)

    call tstatc0_end(id_sname)

  end subroutine m_TE_total_energy_noncl
! ==================================================================== 11.0

  subroutine get_band_energy(kv3)
    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    eband = 0.d0
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          eband = eband + occup_l(ib,ik)*eko_l(ib,ik)
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
       eband = eband_mpi
    end if
!!$    eband = eband_mpi                  ! MPI
    eband = 2*eband/kv3 * (af+1)
  end subroutine get_band_energy

! ======================================== added by K. Tagami ============== 11.0
  subroutine get_band_energy_noncl(kv3)
    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI

    eband = 0.d0

    do ik =1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          eband = eband + occup_l(ib,ik)*eko_l(ib,ik)
       end do
    end do

    if (npes > 1) then
       call mpi_allreduce( eband, eband_mpi, 1, mpi_double_precision, &
	&                  mpi_sum, mpi_comm_group, ierr ) !MPI
       eband = eband_mpi
    end if
!!$    eband = eband_mpi                  ! MPI
    eband = eband/ (kv3 /ndim_spinor )

  end subroutine get_band_energy_noncl
! ===================================================================== 11.0

  subroutine get_xc_and_HE_of_old_CD(vxc_l)
    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,nspin)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: eohxc_mpi

    eohxc = 0.d0
    do ik = 1, kimg
       do ispin = 1, nspin
          if(mype==0) then
             eohxc = eohxc + vxc_l(1,ik,ispin)*chgqt(1,ik,ispin)
             if(sw_external_potential==ON) then
                eohxc = eohxc + espot_g(1,ik,ispin)*chgqt(1,ik,ispin)
             end if
          endif
       end do
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & + (vxc_l(i,ik,1)+PAI4*chgqto(i,ik,1)/gr_l(i)**2) &
                  &   * chgqt(i,ik,1)
             if(sw_external_potential==ON) then
                eohxc = eohxc + espot_g(i,ik,1) * chgqt(i,ik,1)
             end if
             if(sw_screening_correction==ON) then
                 eohxc = eohxc &
                  & + chgqto(i,ik,1)*chgqt(i,ik,1)*screening%phik(i)
             end if
             if ( sw_positron /= OFF ) then
                if ( positron_method == positron_GGGC ) then
                   eohxc = eohxc &
                        & - (PAI4 *pchgo_l(i,ik)/gr_l(i)**2) &
                        &   * chgqt(i,ik,1)
                endif
             endif
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             eohxc = eohxc &
                  & +  (vxc_l(i,ik,UP)*chgqt(i,ik,UP)&
                  &   + vxc_l(i,ik,DOWN)*chgqt(i,ik,DOWN)) &
                  & + PAI4*(chgqto(i,ik,UP)+chgqto(i,ik,DOWN))&
                  & /gr_l(i)**2 &
                  &  *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
             if(sw_external_potential==ON) then
                eohxc = eohxc + (espot_g(i,ik,UP)*chgqt(i,ik,UP) &
                              + espot_g(i,ik,DOWN)*chgqt(i,ik,DOWN))
             end if
             if(sw_screening_correction==ON) then
                 eohxc = eohxc &
                  & + (chgqto(i,ik,UP)+chgqto(i,ik,DOWN))* &
                  &   (chgqt(i,ik,UP)+chgqt(i,ik,DOWN))*screening%phik(i)
             end if
             if ( sw_positron /= OFF ) then
                if ( positron_method == positron_GGGC ) then
                   eohxc = eohxc &
                        & - (PAI4 *pchgo_l(i,ik)/gr_l(i)**2) &
                        &    *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
                end if
             endif
          end do
       end if
    end do
    if(npes > 1) then
       call mpi_allreduce(eohxc,eohxc_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       eohxc = eohxc_mpi
    end if

    eohxc = univol*eohxc
  end subroutine get_xc_and_HE_of_old_CD

! ============================== added by K. Tagami ====================== 11.0
  subroutine get_xc_and_HE_of_old_CD_noncl(vxc_l)
    real(kind=DP), intent(in) :: vxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom)
    integer ik, is
    integer ist !mpi

    integer :: ri, ig, ni

    real(kind=DP) :: eohxc_mpi
    real(kind=DP) :: csum1, csum2

    eohxc = 0.d0

    if ( sw_external_potential == ON ) then
       stop 'kt : external_pot not supported '
    endif

    do is = 1, ndim_magmom
       do ri = 1, kimg
          do ig = ista_kngp, iend_kngp           
             eohxc = eohxc + vxc_l(ig,ri,is)*chgqt(ig,ri,is)
          end do
       end do
    end do

    do ri=1, kimg
       ist = ista_kngp
       if(ist == 1) ist = 2

       do ig=ist, iend_kngp          
         ni = 1
         csum1 = chgqt( ig, ri, ni )        
         csum2 = chgqto( ig, ri, ni )        
         eohxc = eohxc + PAI4 *csum2 /gr_l(ig)**2 *csum1

       end do
    end do

    if ( sw_screening_correction == ON ) then
       do ri=1, kimg
          ist = ista_kngp
          if(ist == 1) ist = 2
          
          do ig=ist, iend_kngp          
             ni = 1
             csum1 = chgqt( ig, ri, ni )        
             csum2 = chgqto( ig, ri, ni )        
             eohxc = eohxc + csum2 *csum1 *screening%phik(ig)
          end do
       end do
    endif

    if (npes > 1) then
       call mpi_allreduce( eohxc, eohxc_mpi, 1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr )
       eohxc = eohxc_mpi
    end if

    eohxc = univol*eohxc
  end subroutine get_xc_and_HE_of_old_CD_noncl
! ====================================================================== 11.0

  subroutine get_local_potential_energy

    integer       :: ik, it, i, ig
    real(kind=DP) :: eloca1_mpi
    real(kind=DP) :: eespot_mpi
    real(kind=DP) :: eloclr,eloclr_mpi

    eloca1 = 0.d0
    do ik = 1, kimg
       if(nspin == 1) then
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp !for mpi
                eloca1 = eloca1 &
                     & + psc_l(i,it)*zfm3_l(i,it,ik)*chgqt(i,ik,1)
                if(sw_screening_correction==ON) then
                  eloca1 = eloca1 &
                      & - ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)*chgqt(i,ik,1)
                end if
             end do
          end do
       else
          do it = 1, ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                eloca1 = eloca1 &
                     &   + psc_l(i,it)*zfm3_l(i,it,ik)&
                     &             *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
                if(sw_screening_correction==ON) then
                   eloca1 = eloca1 &
                        &   - ival(it)*Screening%phik(i)/univol*zfm3_l(i,it,ik)&
                        &             *(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
                end if
             end do
          end do
       endif
    end do
    if(npes > 1) then
       call mpi_allreduce(eloca1,eloca1_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       eloca1 = eloca1_mpi
    end if

    eloca1    = univol*eloca1
#ifdef ENABLE_ESM_PACK
    if(sw_esm==OFF) then
       elocal = eloca1 + etot1*totch
    else
       elocal = eloca1
    endif
#else
    elocal    = eloca1 + etot1*totch
#endif

#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON)then
!add the long-range part
      eloclr=0.d0
      if(nspin.eq.1)then
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgqt(ig,1,1)+aimag(vloc_esm(igfp_l(ig)))*chgqt(ig,2,1)
          enddo
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig)))*chgqt(ig,1,1)
          enddo
        endif
      else
        if(kimg==2)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,1,1)+chgqt(ig,1,2)) &
   &                     +aimag(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,2,1)+chgqt(ig,2,2))
          enddo                                           
        else if(kimg==1)then
          do ig=ista_kngp,iend_kngp
            eloclr=eloclr+dble(vloc_esm(igfp_l(ig))) &
   &                     *(chgqt(ig,1,1)+chgqt(ig,1,2))
          enddo                                           
        endif
      endif
      eloclr_mpi=0.d0
      call mpi_allreduce(eloclr,eloclr_mpi,1,&
      & mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
      eloclr = eloclr_mpi
      eloclr = univol*eloclr
      elocal = elocal + eloclr
    endif
#endif

    eespot = 0.0d0
    if(sw_external_potential==ON) then
    do ik = 1, kimg
!       do ispin = 1, nspin
!          eespot = eespot + espot_g(1,ik,ispin)*chgq_l(1,ik,ispin)
!       end do
       if(nspin == 1) then
!          do i = 2, iend_kngp
          do i = ista_kngp, iend_kngp
            eespot = eespot + espot_g(i,ik,1)*chgqt(i,ik,1)
          end do
       else if( nspin == 2 )then
!          do i = 2, iend_kngp
          do i = ista_kngp, iend_kngp
            eespot = eespot + ( espot_g(i,ik,UP)*chgqt(i,ik,UP) + espot_g(i,ik,DOWN)*chgqt(i,ik,DOWN ) )
          end do
       end if
    end do
    if(npes > 1) then
       call mpi_allreduce(eespot,eespot_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       eespot = eespot_mpi
    end if

    eespot = univol*eespot
    elocal = elocal + eespot
    end if

  end subroutine get_local_potential_energy

! ====================================== added by K. Tagami ================= 11.0
  subroutine get_local_pot_energy_noncl

    integer       :: ri, it, ig
    real(kind=DP) :: eloca1_mpi
    real(kind=DP) :: csum1

    if ( sw_external_potential == ON ) then
       stop 'kt : external_pot not supported 2 '
    endif

    eloca1 = 0.d0
    do ri = 1, kimg
      do it = 1, ntyp
         do ig = ista_kngp, iend_kngp  !for mpi
           csum1 = chgqt( ig, ri, 1 )        
           eloca1 = eloca1  + psc_l(ig,it)*zfm3_l(ig,it,ri) *csum1
         end do
      end do
    end do

    if ( sw_screening_correction == ON ) then
       do ri = 1, kimg
          do it = 1, ntyp
             do ig = ista_kngp, iend_kngp  !for mpi
                csum1 = chgqt( ig, ri, 1 )        
                eloca1 = eloca1 -ival(it) *Screening%phik(ig) /univol &
                     &           *zfm3_l(ig,it,ri) *csum1
             end do
          end do
       end do
    endif

    if (npes > 1) then
       call mpi_allreduce(eloca1,eloca1_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       eloca1 = eloca1_mpi
    end if

    eloca1    = univol*eloca1
    elocal    = eloca1 + etot1*totch

  end subroutine get_local_pot_energy_noncl
! ============================================================================ 11.0

  subroutine get_nonlocal_potential_energy
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    enonlc = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) then   
              do lmt1 = 1, ilmt(it)
                 il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                 do lmt2 = lmt1, ilmt(it)
                    il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                    if( il1 /= il2 .or. im1 /= im2) cycle
    !xocl spread do/ind_katm
                    do ia = 1, natm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion(lmt1,lmt2,it)*hsrt(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          else 
              do lmt1 = 1, ilmt(it)
                 do lmt2 = lmt1, ilmt(it)
    !xocl spread do/ind_katm
                    do ia = 1, natm
                       if(ityp(ia) /= it) cycle
                       fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                       enonlc = enonlc &
                            & + fac*dion_paw(lmt1,lmt2,ispin,ia)*hsrt(ia,lmt1,lmt2,ispin)
                    end do
    !xocl end spread
                 end do
              end do
          end if
!!$          do lmt1 = 1, ilmt(it)
!!$             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
!!$             do lmt2 = lmt1, ilmt(it)
!!$                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!$                if( il1 /= il2 .or. im1 /= im2) cycle
!!$!xocl spread do/ind_katm
!!$                do ia = 1, natm
!!$                   if(ityp(ia) /= it) cycle
!!$                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
!!$                   enonlc = enonlc &
!!$                        & + fac*dion(lmt1,lmt2,it)*hsr(ia,lmt1,lmt2,ispin)
!!$                end do
!!$!xocl end spread
!!$             end do
!!$          end do
       end do
    end do
    enonlc = enonlc*(af+1)
    !!$if(sw_hubbard==ON) enonlc = enonlc - ehub1
  end subroutine get_nonlocal_potential_energy

! ================================== added by K. Tagami =================== 11.0
  subroutine get_nonlocal_pot_energy_noncl

    integer :: it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: is
    real(kind=DP) :: fac
    real(kind=DP) :: c1, c2

    real(kind=DP), allocatable :: hsr_densmat( :,:,:,: )
    real(kind=DP), allocatable :: hsi_densmat( :,:,:,: )

    enonlc = 0.d0

! --
!   hsr (magomom) --> hsr, hs ( chgopt)
!

    allocate( hsr_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    allocate( hsi_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    hsr_densmat = 0.0d0;  hsi_densmat = 0.0d0

    call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsrt, hsit, hsr_densmat, hsi_densmat )
!
    do it = 1, ntyp
       do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

          do lmt2 = 1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)

             if ( .not. flg_paw ) then
                if ( SpinOrbit_mode == Neglected ) then
                   if ( il1 /= il2 .or. im1 /= im2 ) cycle
                else
                   if( il1 /= il2 ) cycle
                endif
             endif

             do ia = 1, natm
                if(ityp(ia) /= it) cycle

                fac = iwei(ia)

                do is= 1, ndim_chgpot
                   c1 = real( dion0_noncl( lmt1,lmt2,is,ia ) -dsoc(lmt1,lmt2,ia,is) ) &
                        &  *hsr_densmat( ia,lmt1,lmt2,is )

! ---------------
            ! ( The results seem unchanged even if 1 is changed to 0 )
! --------
#if 1     
                   c2 = aimag( dion0_noncl( lmt1,lmt2,is,ia ) ) &
                        &  *hsi_densmat( ia,lmt1,lmt2,is )
#else
!                   c2 = -aimag( dion0_noncl( lmt1,lmt2,is,ia ) ) &
!                        &  *hsi_densmat( ia,lmt1,lmt2,is )
#endif
                   c2 = 0.0d0          !!! ASMS 2015/02/20,  just in case
                   enonlc = enonlc + fac*( c1 +c2 )
                end do
             end do
          end do
       end do
    end do
!
    deallocate( hsr_densmat, hsi_densmat )

  end subroutine get_nonlocal_pot_energy_noncl

  subroutine get_nonlocal_pot_energy_noncl2  ! without SOC
    integer :: it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: is
    real(kind=DP) :: fac
    real(kind=DP) :: c1, c2

    real(kind=DP), allocatable :: hsr_densmat( :,:,:,: )
    real(kind=DP), allocatable :: hsi_densmat( :,:,:,: )

    enonlc = 0.d0

    do it = 1, ntyp
       do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
          do lmt2 = lmt1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)

             if (ipaw(it)==0 ) then
                if( il1 /= il2 .or. im1 /= im2) cycle

                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   enonlc = enonlc &
                        & + fac*dion(lmt1,lmt2,it)*hsrt(ia,lmt1,lmt2,1)
                end do
             else
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   Do is=1, ndim_magmom
                      enonlc = enonlc &
                           & + fac*dion_paw(lmt1,lmt2,is,ia)*hsrt(ia,lmt1,lmt2,is)
                   end do
                end do
             end if
          end do
       end do
    end do
  end subroutine get_nonlocal_pot_energy_noncl2
! ====================================================================== 11.0

  subroutine get_hartree_energy
    integer ik, i
    integer :: ist !mpi
    real(kind=DP) :: ehartr_mpi

    ehartr_mpi = 0.d0
    ehartr = 0.d0
    do ik = 1, kimg

       if(mype==0) then
          if(sw_screening_correction==ON) then
              ehartr_mpi  = ehartr_mpi + chgqt(1,ik,1)**2 * screening%phik(1)
          end if
       end if

       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp !for mpi
!!!!             ehartr_mpi  = ehartr_mpi + (chgq_l(i,ik,1)/gr_l(i))**2
             ehartr_mpi  = ehartr_mpi + PAI4 * (chgqt(i,ik,1)/gr_l(i))**2
             if(sw_screening_correction==ON) then
                 ehartr_mpi  = ehartr_mpi + chgqt(i,ik,1)**2 * screening%phik(i)
             end if
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
!!!!             ehartr_mpi  = ehartr_mpi &
!!!!                  &  +((chgq_l(i,ik,UP)+chgq_l(i,ik,DOWN))/gr_l(i))**2
             ehartr_mpi  = ehartr_mpi &
                  &  + PAI4 * ((chgqt(i,ik,UP)+chgqt(i,ik,DOWN))/gr_l(i))**2
             if(sw_screening_correction==ON) then
                 ehartr_mpi  = ehartr_mpi &
                  &  + (chgqt(i,ik,UP)+chgqt(i,ik,DOWN))**2 * screening%phik(i)
             end if
          end do
       end if
    end do
    call mpi_allreduce(ehartr_mpi,ehartr,1 &
         &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!!!!    ehartr    = univol*PAI4*ehartr*0.5d0
    ehartr    = univol*ehartr*0.5d0
  end subroutine get_hartree_energy

! ================================= added by K. Tagami ==================== 11.0
  subroutine get_hartree_energy_noncl
    integer ik, i
    integer :: ist !mpi
    real(kind=DP) :: ehartr_mpi

    ehartr_mpi = 0.d0
    ehartr = 0.d0

    do ik = 1, kimg
       ist = ista_kngp
       if(ist == 1) ist = 2

       do i = ist, iend_kngp !for mpi
           ehartr_mpi  = ehartr_mpi + (chgqt(i,ik,1)/gr_l(i))**2
       end do
    end do

    ehartr_mpi = ehartr_mpi *PAI4

    if ( sw_screening_correction == ON ) then
       do ik = 1, kimg
          ist = ista_kngp
          if(ist == 1) ist = 2
          
          do i = ist, iend_kngp !for mpi
             ehartr_mpi  = ehartr_mpi + chgqt(i,ik,1)**2 * screening%phik(i)
          end do
       end do
    endif

    call mpi_allreduce(ehartr_mpi,ehartr,1 &
         &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    ehartr    = univol *ehartr *0.5d0

  end subroutine get_hartree_energy_noncl
! ========================================================================= 11.0

  subroutine get_dipole_energy(vdip_l,vext_l)
    real(kind=DP), intent(in) :: vdip_l(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(in) :: vext_l(ista_kngp:iend_kngp,kimg)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: evdip_mpi
    real(kind=DP) :: evext_mpi

    evdip = 0.d0
    evext = 0.d0
    do ik = 1, kimg
       do ispin = 1, nspin
          if(mype==0) then
             evdip = evdip + vdip_l(1,ik)*chgqt(1,ik,ispin)
             evext = evext + vext_l(1,ik)*chgqt(1,ik,ispin)
          endif
       end do
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*chgqt(i,ik,1)
             evext = evext + vext_l(i,ik)*chgqt(i,ik,1)
          end do
       else if(nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             evdip = evdip + vdip_l(i,ik)*(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
             evext = evext + vext_l(i,ik)*(chgqt(i,ik,UP)+chgqt(i,ik,DOWN))
          end do
       end if
    end do
    if(npes > 1) then
       call mpi_allreduce(evdip,evdip_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       evdip = evdip_mpi
    end if
    evdip = evdip * univol
    evext = evext * univol
    edip = edip_ion + eext_ion + evdip*0.5d0 + evext
  end subroutine get_dipole_energy

! =================================== added by K. Tagami ==================== 11.0
  subroutine get_dipole_energy_noncl(vdip_l,vext_l)
    real(kind=DP), intent(in) :: vdip_l(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(in) :: vext_l(ista_kngp:iend_kngp,kimg)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: evdip_mpi
    real(kind=DP) :: evext_mpi

    evdip = 0.d0;     evext = 0.d0
    do ik = 1, kimg
      do i = ist, iend_kngp  !for mpi
         evdip = evdip + vdip_l(i,ik)*chgqt(i,ik,1)
         evext = evext + vext_l(i,ik)*chgqt(i,ik,1)
      end do
    end do
    if(npes > 1) then
       call mpi_allreduce(evdip,evdip_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       evdip = evdip_mpi
    end if
    evdip = evdip * univol
    evext = evext * univol
    edip = edip_ion + eext_ion + evdip*0.5d0 + evext

  end subroutine get_dipole_energy_noncl
! ======================================================================== 11.0

! ==== KT_add === 2015/01/30
  subroutine get_kinetic_local_energy_paw(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ismax
    real(kind=DP) :: fac

    ekin_ion_paw = 0.0d0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
    do ispin = 1, ismax, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if( il1 /= il2 .or. im1 /= im2) cycle
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ekin_ion_paw = ekin_ion_paw &
                        & + fac*dion_kin_ion(lmt1,lmt2,it)*hsrt(ia,lmt1,lmt2,ispin)
                end do
             end do
          end do
       end do
    end do
    ekin_ion_paw = ekin_ion_paw*(af+1)
  end subroutine get_kinetic_local_energy_paw
! ============ 2015/01/30

  subroutine get_kinetic_energy(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(747)
#endif
    ekinet = eband - eohxc - eloca1 - enonlc
    if(sw_dipole_correction == ON) then
       ekinet = ekinet - evdip - evext
    end if
    if(sw_hubbard==ON) then
       ekinet = ekinet - ehub1
    end if
    if(sw_hybrid_functional == ON) then
       ekinet = ekinet - vexx
    end if
! ========================= added by K. Tagami ====================== 11.0
    if ( sw_magnetic_constraint==ON ) then
       ekinet = ekinet - emag1
    endif
! =================================================================== 11.0

! === KT_add === 2014/08/01
!!!#ifdef USE_ESPINORB
    if ( noncol ) then
       if ( flg_paw ) then
          if ( SpinOrbit_Mode == ByPawPot ) then
             ekinet = ekinet -espinorb_old
          endif
       endif
       if ( SpinOrbit_Mode == ByProjector .or. &
            &  SpinOrbit_Mode == ZeffApprox .or. &
            &  SpinOrbit_Mode == ReadFromPP ) then
          ekinet = ekinet -espinorb_now
       endif
    endif
!!!#endif
! ============== 2014/08/01

    if(ipri >= 2) then
       write(nfout,'(" !D EBAND  = ",f12.5)') eband
       write(nfout,'(" !D EOHXC  = ",f12.5)') eohxc
       write(nfout,'(" !D ELOCA1 = ",f12.5)') eloca1
       write(nfout,'(" !D ENONLC = ",f12.5)') enonlc
       if(sw_dipole_correction == ON) then
          write(nfout,'(" !D EVDIP  = ",f12.5)') evdip
          write(nfout,'(" !D EVEXT  = ",f12.5)') evext
       end if
       if(sw_hubbard==ON) write(nfout,'(" !D EHUB1  = ",f12.5)') ehub1
       if(sw_hybrid_functional == ON) write(nfout,'(" !D VEXX   = ",f12.5)') vexx
    endif
#ifdef __TIMER_SUB__
    call timer_end(747)
#endif
  end subroutine get_kinetic_energy

  subroutine get_kinetic_energy_directly(nfout)
     integer,intent(in) :: nfout
     integer :: ik,ib,ig
     real(kind=DP), allocatable, dimension(:)       :: ekin
     real(kind=DP) :: ekinet_tmp,ekinet_mpi
     allocate(ekin(kg1));ekin=0.d0
     ekinet = 0.d0
     do ik=1,kv3,af+1
        call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
        if(map_k(ik)/=myrank_k)cycle
        do ib=1,np_e
           ekinet_tmp=0.d0
           if (kimg==1) then
              do ig=1,iba(ik)
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(ig)*zaj_l(ig,ib,ik,1)**2
              enddo
           else if (kimg==2) then
              do ig=1,iba(ik)
                 ekinet_tmp = ekinet_tmp+2.d0*ekin(ig)*(zaj_l(ig,ib,ik,1)**2 &
              & +zaj_l(ig,ib,ik,2)**2)
              enddo
           endif
           if(k_symmetry(ik)==GAMMA) ekinet_tmp = ekinet_tmp*2.d0
           ekinet = ekinet+occup_l(ib,ik)/dble(kv3)*ekinet_tmp
        enddo
     enddo
     if(af==1) ekinet = ekinet*2.d0
     ekinet_mpi = 0.d0
     call mpi_allreduce(ekinet,ekinet_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
     ekinet = ekinet_mpi
     deallocate(ekin)
  end subroutine get_kinetic_energy_directly

! ==== positron ===
 subroutine get_xc_and_HE_of_old_CD_pztr(vepc_l)
    real(kind=DP), intent(in) :: vepc_l(ista_kngp:iend_kngp,kimg,nspin)
    integer ik, i, ispin
    integer ist !mpi
    real(kind=DP) :: eohxc_pztr_mpi

    eohxc_pztr = 0.d0
    do ik = 1, kimg
       do ispin = 1, nspin
          if(mype==0) then
             eohxc_pztr = eohxc_pztr + vepc_l(1,ik,ispin)*pchg_l(1,ik)
          endif
       end do
       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp  !for mpi
             eohxc_pztr = eohxc_pztr &
                  & + (vepc_l(i,ik,1) -PAI4*chgqto(i,ik,1)/gr_l(i)**2) &
                  &   * pchg_l(i,ik)
          end do
       else if(nspin == 2) then
          stop "YYY"
       end if
    end do
    if(npes > 1) then
       call mpi_allreduce(eohxc_pztr,eohxc_pztr_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       eohxc_pztr = eohxc_pztr_mpi
    end if
!
    eohxc_pztr = univol *eohxc_pztr
  end subroutine get_xc_and_HE_of_old_CD_pztr

  subroutine get_kinetic_energy_pztr(nfout)
    integer,intent(in) :: nfout
    integer :: ik,ib,ig
    real(kind=DP) :: ekinet_tmp, ekinet_mpi

    ekin_pztr = 0.0
    Do ib=1, npeg
       if ( nprvf_ordr(ib) /= 1 ) cycle
       ekin_pztr = ekin_pztr + pev(ib)
    End do
    ekin_pztr = ekin_pztr  -eohxc_pztr -elocal_pztr
  end subroutine get_kinetic_energy_pztr

  subroutine get_kinetic_energy_pztr_direct(nfout)
    integer,intent(in) :: nfout
    integer :: ik,ib,ig
    real(kind=DP), allocatable, dimension(:)       :: ekin
    real(kind=DP) :: ekinet_tmp, ekinet_mpi, e1

    allocate(ekin(kg1_pwf));ekin=0.d0

    ekin_pztr = 0.d0

    call m_pwBS_pstrn_kinetic_energies(ekin)

    do ib=1, npeg
       if ( nprvf_ordr(ib) /= 1 ) cycle
       ekinet_tmp=0.d0
       if (kimg==1) then
          do ig=1, kg1_pwf
             ekinet_tmp = ekinet_tmp + ekin(ig)*pzaj(ig,ib,1)**2
          enddo
       else if (kimg==2) then
          do ig=1, kg1_pwf
             ekinet_tmp = ekinet_tmp + ekin(ig)*( pzaj(ig,ib,1)**2 &
                  &                              +pzaj(ig,ib,2)**2)
          enddo
       endif
       ekin_pztr = ekin_pztr +ekinet_tmp
    enddo
    deallocate(ekin)

  end subroutine get_kinetic_energy_pztr_direct

  subroutine get_hartree_energy_inter_ep
    integer ik, i
    integer :: ist !mpi
    real(kind=DP) :: ehartr_mpi

    ehartr_mpi = 0.d0
    ehartr_ep = 0.d0

    do ik = 1, kimg

       ist = ista_kngp
       if(ist == 1) ist = 2

       if(nspin == 1) then
          do i = ist, iend_kngp !for mpi
             ehartr_mpi  = ehartr_mpi + PAI4 *chgqt(i,ik,1) *pchg_l(i,ik) &
                  &                          /gr_l(i)**2
          end do
       else if(nspin == 2) then
          stop "PPP"
       endif
    end do
    call mpi_allreduce(ehartr_mpi,ehartr_ep,1 &
         &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

    ehartr_ep    = -univol *ehartr_ep

  end subroutine get_hartree_energy_inter_ep

  subroutine get_local_pot_energy_pztr
    integer       :: ik, it, i, ig
    real(kind=DP) :: elocal_mpi

    elocal_pztr = 0.d0
    do ik = 1, kimg
       if(nspin == 1) then
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp !for mpi
                elocal_pztr = elocal_pztr &
                     & + psc_l(i,it)*zfm3_l(i,it,ik)*pchg_l(i,ik)
             end do
          end do
       else
          stop "PPP"
       endif
    end do
    if(npes > 1) then
       call mpi_allreduce(elocal_pztr,elocal_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       elocal_pztr = elocal_mpi
    end if

    elocal_pztr    = -univol*elocal_pztr
  end subroutine get_local_pot_energy_pztr
! =====

  subroutine get_xc_and_HE_of_old_CD_paw(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer, parameter :: DEBUGPRINTLEVEL = 2
    real(kind=DP) :: fac
    eohxc_paw = 0.d0
    if(ipri>= DEBUGPRINTLEVEL) write(nfout,'(" ipaw = ",10i8)') (ipaw(it),it=1,ntyp)
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipri>= DEBUGPRINTLEVEL) then
             write(nfout,'(" it = ",i8," <<get_xc_and_HE_of_old_CD_paw>>")') it
             write(nfout,'(" ilmt(",i3,") = ",i8)') it, ilmt(it)
             do ia = 1, natm
                if(ityp(ia) /= it) cycle
                write(nfout,'(" -- dion_hartree, dion_vxc, hsr --, ispin = ",i3, " ia = ", i8," ipaw(",i3,") = ",i2)') &
                     & ispin,ia, it,ipaw(it)
                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!!                      if( il1 /= il2 .or. im1 /= im2) cycle
                      write(nfout,'(3f20.8)') dion_hartree(lmt1,lmt2,ia), dion_vxc(lmt1,lmt2,ispin,ia) &
                     &, hsrt(ia,lmt1,lmt2,ispin)
                   end do
                end do
             end do
          end if

          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ia))*hsrt(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    eohxc_paw = eohxc_paw*(af+1)
    if(ipri>=DEBUGPRINTLEVEL) write(nfout,'(" eohxc_paw = ",f20.8)') eohxc_paw
  end subroutine get_xc_and_HE_of_old_CD_paw

! ======================= added by K. Tagami ================ 11.0
  subroutine get_xc_and_HE_old_CD_paw_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer, parameter :: DEBUGPRINTLEVEL = 2
    real(kind=DP) :: fac

    eohxc_paw = 0.d0
    if(ipri>= DEBUGPRINTLEVEL) write(nfout,'(" ipaw = ",10i8)') (ipaw(it),it=1,ntyp)

    do ispin = 1, ndim_magmom

       do it = 1, ntyp

          if(ipri>= DEBUGPRINTLEVEL) then
             write(nfout,'(" it = ",i8," <<get_xc_and_HE_of_old_CD_paw>>")') it
             write(nfout,'(" ilmt(",i3,") = ",i8)') it, ilmt(it)
             do ia = 1, natm
                if(ityp(ia) /= it) cycle
                write(nfout,'(" -- dion_hartree, dion_vxc, hsr --, ispin = ",i3, " ia = ", i8," ipaw(",i3,") = ",i2)') &
                     & ispin,ia, it,ipaw(it)
                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!!                      if( il1 /= il2 .or. im1 /= im2) cycle
                      write(nfout,'(3f20.8)') dion_hartree(lmt1,lmt2,ia), dion_vxc(lmt1,lmt2,ispin,ia) &
                     & , hsrt(ia,lmt1,lmt2,ispin)
                   end do
                end do
             end do
          end if

          if (ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle       !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0

                   if ( ispin == 1 ) then
                      eohxc_paw = eohxc_paw &
                           &     + fac *( dion_hartree(lmt1,lmt2,ia) &
                           &             +dion_vxc(lmt1,lmt2,ispin,ia ) ) &
                           &           *hsrt(ia,lmt1,lmt2,ispin)
                   else
                      eohxc_paw = eohxc_paw &
                           &     + fac * dion_vxc(lmt1,lmt2,ispin,ia ) &
                           &           *hsrt(ia,lmt1,lmt2,ispin)

                   endif

                end do
!xocl end spread
             end do
          end do
       end do
    end do

    if(ipri>=DEBUGPRINTLEVEL) write(nfout,'(" eohxc_paw = ",f20.8)') eohxc_paw
  end subroutine get_xc_and_HE_old_CD_paw_noncl
! ====================================================================== 11.0
  
  subroutine get_xc_and_HE_of_old_CD_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     ! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   eohxc_paw = eohxc_paw &
                        & + fac*(dion_hartree(lmt1,lmt2,ia)+ &
                                dion_vxc(lmt1,lmt2,ispin,ja))*hsrt(ja,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    eohxc_paw = eohxc_paw*(af+1)/dble(nopr)
  end subroutine get_xc_and_HE_of_old_CD_paw_sym
  
! ================================= added by K. Tagami ============= 11.0
  subroutine get_xc_HE_old_CD_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    eohxc_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, ndim_magmom
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  

             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                   if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0

                      if ( ispin==1 ) then
                         eohxc_paw = eohxc_paw &
                              &     + fac *( dion_hartree(lmt1,lmt2,ia) &
                              &             +dion_vxc(lmt1,lmt2,ispin,ja) ) &
                              &           *hsrt(ja,lmt1,lmt2,ispin)
                      else
                         eohxc_paw = eohxc_paw &
                              &     + fac *dion_vxc(lmt1,lmt2,ispin,ja)  &
                              &           *hsrt(ja,lmt1,lmt2,ispin)
                      endif
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
       
    end do
    eohxc_paw = eohxc_paw /dble(nopr)

  end subroutine get_xc_HE_old_CD_paw_sym_noncl
! ============================================================= 11.0

  subroutine get_hartree_energy_paw(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer, parameter :: DEBUGPRINTLEVEL = 2
    real(kind=DP) :: fac
    
    if(ipri>=DEBUGPRINTLEVEL) then
       write(nfout,'(" -- iwei -- <<get_hartree_energy_paw>>")')
       write(nfout,'(10i8)') (iwei(ia),ia=1,natm)
       write(nfout,'(" -- ia, lmt1, lmt2, dion_hartree_now, -- hsr --")')
       do ia = 1, natm
          it = ityp(ia)
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle
                write(nfout,'(3i6,3d20.8)') ia, lmt1, lmt2, dion_hartree_now(lmt1,lmt2,ia) &
                     & , (hsrt(ia,lmt1,lmt2,ispin),ispin = 1, nspin/(af+1))
             end do
          end do
       end do
    end if

    ehartr_paw = 0.d0
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle    !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ia)*hsrt(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    ehartr_paw = ehartr_paw*(af+1)*0.5d0
  end subroutine get_hartree_energy_paw

! =========================== added by K. Tagami =================== 11.0
  subroutine get_hartree_energy_paw_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer, parameter :: DEBUGPRINTLEVEL = 2
    real(kind=DP) :: fac
    
    if (ipri>=DEBUGPRINTLEVEL) then
       write(nfout,'(" -- iwei -- <<get_hartree_energy_paw_noncl>>")')
       write(nfout,'(10i8)') (iwei(ia),ia=1,natm)
       write(nfout,'(" -- ia, lmt1, lmt2, dion_hartree_now, -- hsr --")')
       do ia = 1, natm
          it = ityp(ia)
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle
                write(nfout,*) ia, lmt1, lmt2, dion_hartree_now(lmt1,lmt2,ia) &
                     & , (hsrt(ia,lmt1,lmt2,ispin),ispin = 1, ndim_magmom)
             end do
          end do
       end do
    end if

    ehartr_paw = 0.d0
    do ispin = 1, 1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ia)*hsrt(ia,lmt1,lmt2,ispin)
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    ehartr_paw = ehartr_paw *0.5d0

  end subroutine get_hartree_energy_paw_noncl
! ================================================================= 11.0
  
  subroutine get_hartree_energy_paw_sym
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
    do ispin = 1, nspin, af+1
       do it = 1, ntyp
          if(ipaw(it)==0) cycle  
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!                if( il1 /= il2 .or. im1 /= im2) cycle     !! ASMS 2015/02/06
!xocl spread do/ind_katm
                do ia = 1, natm
                   if(ityp(ia) /= it) cycle
                   ja=abs(ia2ia_symmtry_op(ia,iopr))
                   fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                   ehartr_paw = ehartr_paw &
                        & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsrt(ja,lmt1,lmt2,ispin)
!print *,fac*dion_hartree_now(lmt1,lmt2,ja)*hsr(ja,lmt1,lmt2,ispin)/det,det
                end do
!xocl end spread
             end do
          end do
       end do
    end do
    
    end do
    ehartr_paw = ehartr_paw*(af+1)*0.5d0/dble(nopr)
  end subroutine get_hartree_energy_paw_sym

! ============================== added by K. Tagami ============== 11.0
  subroutine get_hartree_ene_paw_sym_noncl
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    integer :: iopr,ja
    
    ehartr_paw = 0.d0
    
    do iopr=1,nopr
    
       do ispin = 1, 1
          do it = 1, ntyp
             if(ipaw(it)==0) cycle  
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!!!!                   if( il1 /= il2 .or. im1 /= im2) cycle      !! ASMS 2015/02/06
!xocl spread do/ind_katm
                   do ia = 1, natm
                      if(ityp(ia) /= it) cycle
                      ja=abs(ia2ia_symmtry_op(ia,iopr))
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      ehartr_paw = ehartr_paw &
                           & + fac*dion_hartree_now(lmt1,lmt2,ja)*hsrt(ja,lmt1,lmt2,ispin)
                   end do
!xocl end spread
                end do
             end do
          end do
       end do
    
    end do
    ehartr_paw = ehartr_paw*0.5d0/dble(nopr)

  end subroutine get_hartree_ene_paw_sym_noncl
! ================================================================= 11.0

  subroutine get_entropic_term(nfout)
    integer, intent(in) :: nfout
#ifdef __TIMER_SUB__
    call timer_sta(748)
#endif
    eentropy = -width*band_entropy
    if(ipri >= 2) then
       write(nfout,'(" !D EENTROPY = ",f20.14)') eentropy
    endif
#ifdef __TIMER_SUB__
    call timer_end(748)
#endif
  end subroutine get_entropic_term

  subroutine get_hubbard_energy(nfout)
    integer, intent(in) :: nfout
    ehub0 = 0.d0
    ehub1 = 0.d0
    if(sw_hubbard==ON) then
      call m_Hubbard_energy(ehub0)
      call get_hubbard_potential_energy(ehub1)
    end if
    if(ipri >= 2) then
       write(nfout,'(" !D EHUB0 = ",f20.14)') ehub0
       write(nfout,'(" !D EHUB1 = ",f20.14)') ehub1
    endif
  end subroutine get_hubbard_energy

! ============================= added by K. Tagami =============== 11.0
  subroutine get_hubbard_energy_noncl(nfout)
    integer, intent(in) :: nfout

    if ( sw_hubbard == on ) then
!!       write(*,*) 'Not supported : DFT-U '

       call m_Hubbard_energy_noncl(ehub0)

!       call m_Hubbard_energy2_noncl(ehub1)
!
!       write(*,*) 'ehub0 ehu1 comp = ', ehub0, ehub1
!
!       call m_Hubbard_energy3_noncl(ehub1)
!       write(*,*) 'ehub3 = ', ehub1
!       stop

       call get_hubbard_pot_energy_noncl3(ehub1)
    end if
    if(ipri >= 2) then
       write(nfout,'(" !D EHUB0 = ",f20.14)') ehub0
       write(nfout,'(" !D EHUB1 = ",f20.14)') ehub1
    endif
  end subroutine get_hubbard_energy_noncl
! ================================================================ 11.0

  subroutine get_hubbard_potential_energy(ehub1)
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p
    real(kind=DP) :: fac
    ehub1 = 0.d0
    do ispin = 1, nspin, af+1
       do ia = 1, natm
          ih = ihubbard(ia)
          if(ih == 0) cycle
          it = ityp(ia)
          l1p = proj_attribute(ih)%l+1
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             if(il1 /= l1p) cycle
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
                fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                ehub1 = ehub1 &
                      & + fac*dhub(lmt1,lmt2,ia,ispin)*hsrt(ia,lmt1,lmt2,ispin)
             end do
          end do
       end do
    end do
    ehub1 = ehub1*(af+1)
  end subroutine get_hubbard_potential_energy

! ================================ added by K. Tagami ================= 11.0
  subroutine get_hubbard_pot_energy_noncl(ehub1)
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p

    integer :: is
    real(kind=DP) :: fac

    ehub1 = 0.d0

    do is=1, ndim_magmom
       do ia = 1, natm
          ih = ihubbard(ia)
          if(ih == 0) cycle
          it = ityp(ia)
          l1p = proj_attribute(ih)%l+1
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             if(il1 /= l1p) cycle
             do lmt2 = lmt1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
                fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                ehub1 = ehub1 &
                      & + fac*dhub(lmt1,lmt2,ia,is)*hsrt(ia,lmt1,lmt2,is)
             end do
          end do
       end do
    end do

  end subroutine get_hubbard_pot_energy_noncl

  subroutine get_hubbard_pot_energy_noncl2(ehub1)
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p

    integer :: is
    real(kind=DP) :: fac, c1, c2

    ehub1 = 0.d0

    do is=1, ndim_magmom
       do ia = 1, natm
          ih = ihubbard(ia)
          if(ih == 0) cycle
          it = ityp(ia)
          l1p = proj_attribute(ih)%l+1
          do lmt1 = 1, ilmt(it)
             il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
             if(il1 /= l1p) cycle

             do lmt2 = 1, ilmt(it)
                il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
                fac = iwei(ia)
!
                c1 = dhub( lmt1,lmt2,ia,is ) &
                     &  *hsrt( ia,lmt1,lmt2,is )
                c2 = -dhub_aimag( lmt1,lmt2,ia,is ) &
                     &  *hsit( ia,lmt1,lmt2,is )

                ehub1 = ehub1 + fac*( c1 +c2 )
             end do
          end do
       end do
    end do

  end subroutine get_hubbard_pot_energy_noncl2

  subroutine get_hubbard_pot_energy_noncl3(ehub1)
    real(kind=DP), intent(out) :: ehub1
    integer :: ispin, it,lmt1, lmt2, il1, im1, il2, im2, ia
    integer :: ih, l1p

    integer :: is
    real(kind=DP) :: fac, c1, c2
    real(kind=DP), allocatable :: hsr_densmat( :,:,:,: )
    real(kind=DP), allocatable :: hsi_densmat( :,:,:,: )
    complex(kind=CMPLDP), allocatable :: dhub_ssrep(:,:,:,:)

    ehub1 = 0.d0

    allocate( dhub_ssrep(nlmt,nlmt,natm,ndim_magmom) )
    dhub_ssrep = 0.0d0

    allocate( hsr_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    allocate( hsi_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    hsr_densmat = 0.0d0;  hsi_densmat = 0.0d0

    call m_ES_MagMom_to_DensMat_Dhub( dhub, dhub_aimag, dhub_ssrep )
    call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsrt, hsit, hsr_densmat, hsi_densmat )

    do ia = 1, natm
       ih = ihubbard(ia)
       if(ih == 0) cycle
       it = ityp(ia)
       l1p = proj_attribute(ih)%l+1
       do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
          if(il1 /= l1p) cycle

          do lmt2 = 1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
             if(il2 /= l1p) cycle
                !!$if(im1 /= im2) cycle
             fac = iwei(ia)
!
             Do is=1, ndim_chgpot
                c1 = real(  dhub_ssrep( lmt1,lmt2,ia,is ) ) &
                     &  *hsr_densmat( ia,lmt1,lmt2,is )
                c2 = aimag( dhub_ssrep( lmt1,lmt2,ia,is ) ) &
                     &  *hsi_densmat( ia,lmt1,lmt2,is )
!                c2 = -aimag( dhub_ssrep( lmt1,lmt2,ia,is ) ) &
!                     &  *hsi_densmat( ia,lmt1,lmt2,is )
                ehub1 = ehub1 + fac*( c1 +c2 )
             end do
          end do
       end do
    end do

    deallocate( hsr_densmat, hsi_densmat )
    deallocate( dhub_ssrep )

  end subroutine get_hubbard_pot_energy_noncl3
! ========================================================================== 11.0

! ============================ added by K. Tagami ========================= 11.0
  subroutine get_magnetic_constraint_energy
    if ( sw_magnetic_constraint == ON ) then
       call m_ES_calc_MagConstraint_Energy( emag1, emag0 )
    endif
  end subroutine get_magnetic_constraint_energy
! ========================================================================= 11.0

! ======================== added by K. Tagami =============== 11.0
  subroutine get_spinorbit_energy_noncl2( ene_out )
    real(kind=DP) :: ene_out

    integer :: lmt1, lmt2, il1, im1, il2, im2, it, ia
    integer :: p, q, is1, is2, istmp, ib, ik
    integer :: ierr

    real(kind=DP) :: fac
    real(kind=DP) :: c1, c2, d_factor, csum, w_n

    complex(kind=CMPLDP) :: z1, z2, ztmp, zsum

! ------------------------
    ene_out = 0.d0

    d_factor = 1.d0/ dble( kv3 /ndim_spinor )
    csum = 0.0d0
    zsum = 0.0d0
! ----------------------------------

    do ia = 1, natm
       it = ityp(ia)

       do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
          p = lmta(lmt1,ia)

          do lmt2 = 1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
             q = lmta(lmt2,ia)

             Do is1=1, ndim_spinor
                Do is2=1, ndim_spinor
                   istmp = ( is1 -1 )*ndim_spinor +is2

                   Do ik=1, kv3, ndim_spinor
                      if ( map_k(ik) /= myrank_k ) cycle

                      Do ib=1, np_e
                         w_n = occup_l(ib,ik) *d_factor

                         z1 = cmplx( fsr_l(ib,p,ik+is1-1), fsi_l(ib,p,ik+is1-1) )
                         z2 = cmplx( fsr_l(ib,q,ik+is2-1), fsi_l(ib,q,ik+is2-1) )

#if 1
! -- org
                         csum = csum + w_n *conjg(z1) *dsoc(lmt1,lmt2,ia,istmp) *z2
#else
! -- dbug
!                         csum = csum + w_n *z1 *dsoc(lmt1,lmt2,ia,istmp) *conjg(z2)
#endif
                      End do
                   End do
                end do
             end do
          end do

       End do

    End do

! ---------------
    if ( npes > 1 ) then
       call mpi_allreduce( csum, ene_out, 1, mpi_double_precision, &
            &              mpi_sum, mpi_comm_group, ierr )
    else
       ene_out = csum
    endif
! -------------

  end subroutine get_spinorbit_energy_noncl2

  subroutine get_spinorbit_energy_noncl3( ene_out )
    real(kind=DP) :: ene_out

    integer :: is, it,lmt1, lmt2, il1, im1, il2, im2, ia
    real(kind=DP) :: fac
    real(kind=DP) :: c1, c2

    real(kind=DP), allocatable :: hsr_densmat( :,:,:,: )
    real(kind=DP), allocatable :: hsi_densmat( :,:,:,: )

    ene_out = 0.d0

! --
!   hsr (magomom) --> hsr, hs ( chgopt)

    allocate( hsr_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    allocate( hsi_densmat( natm, nlmt, nlmt, ndim_chgpot ) )
    hsr_densmat = 0.0d0;  hsi_densmat = 0.0d0

    call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsrt, hsit, hsr_densmat, hsi_densmat )
! ----------
    do ia = 1, natm
       it = ityp(ia)

       do lmt1 = 1, ilmt(it)
          il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
!          p = lmta(lmt1,ia)

          do lmt2 = 1, ilmt(it)
             il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
!             q = lmta(lmt2,ia)

             fac = iwei(ia)

             do is= 1, ndim_chgpot
                c1 = real(  dsoc( lmt1,lmt2,ia,is ) ) &
                     &  *hsr_densmat( ia,lmt1,lmt2,is )
                c2 = aimag( dsoc( lmt1,lmt2,ia,is ) ) &
                     &  *hsi_densmat( ia,lmt1,lmt2,is )
                ene_out = ene_out + fac*( c1 +c2 )
             end do
          end do
       end do
    end do

    deallocate( hsr_densmat, hsi_densmat )

  end subroutine get_spinorbit_energy_noncl3
! =========================================================== 11.0

  subroutine sumup_all_energies(nfout,exc,display_on)
    integer, intent(in) :: nfout
    logical, intent(in) :: display_on
    real(kind=DP), intent(in) :: exc
    integer :: i

    real(kind=DP) :: edel
    character(len("potential_mixing")) :: tag_mixing
#ifdef __TIMER_SUB__
    call timer_sta(749)
#endif

! ===== KT_mod ==== 13.0S
!    etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
!    if(flg_paw) etotal0=etotal0-eohxc_paw+ehartr_paw+exc_ae-exc_ps
!
    if ( flg_paw ) then
#if 0
       ekin_ion_paw = enonlc -eohxc_paw      !! ??
#else
       eohxc_paw = enonlc -ekin_ion_paw      ! meaningless, this is just for output
#endif
       etotal0 = ekinet +ehartr +exc +elocal +ekin_ion_paw +eewald -epc_paw
       etotal0 = etotal0 +ehartr_paw +exc_ae -exc_ps    
    else
       etotal0 = ekinet+ehartr+exc+elocal+enonlc+eewald-epc
    endif
! ================= 13.0S

! ==== POSITRON SCF == 2015/11/28
    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          etotal0 = etotal0 +ekin_pztr +elocal_pztr +ecorr_pztr +ehartr_ep
       endif
    endif
! =================== 2015/11/28

    if(sw_dipole_correction == ON) etotal0 = etotal0 + edip
    if(sw_hubbard == ON) etotal0 = etotal0 + ehub0
    if(sw_hybrid_functional == ON) etotal0 = etotal0 + eexx
    if(sw_fef == ON) etotal0 = etotal0 + eplr
    if(ntyp_vdw>0 .or. sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) etotal0 = etotal0 + evdw
#ifndef DISABLE_VDWDF
    if ( xctype == "vdwdf" ) etotal0 = etotal0 +ecnl_vdwdf
#endif

! =============================== added by K. Tagami =================== 11.0
    if ( sw_magnetic_constraint == ON ) etotal0 = etotal0 + emag0
! ====================================================================== 11.0

! =============================== added by K. Tagami =================== 11.0
!!!#ifdef USE_ESPINORB
    if ( noncol ) then
       if ( SpinOrbit_Mode /= Neglected ) then
          etotal0 = etotal0 + espinorb_now
       endif
    endif
!!!#endif
! ====================================================================== 11.0

    if(num_regions>0)then
       do i=1,num_regions
          if(regions(i)%tally) etotal0 = etotal0+regions(i)%energy
       enddo
    endif

    etotal = etotal0+eentropy
    if(way_of_smearing == COLD) etotal0 = (2.d0*etotal+etotal0)/3.d0
    if(way_of_smearing == PARABOLIC) etotal0 = (etotal+etotal0)*0.5d0

! =============== KT_add ============================================= 13.0E
    if(way_of_smearing == Fermi_Dirac) etotal0 = (etotal+etotal0)*0.5d0
! ==================================================================== 13.0E

    if(way_of_smearing == MP)  &
    &  etotal0 = (1.d0/(dble(order_mp+2)))*(dble(order_mp+1)*etotal+etotal0)

    if(display_on .and. ipri >= 1) then
       edel = cal_edeltb()
!!$       write(nfout,600) iteration,etotal,etotal
!!$       write(nfout,600) iteration,etotal,edel
       if(number_of_cdmixing_applied<=0)  call m_CtrlP_push_CDMixingNameApplied(" ",1)
       tag_mixing = "Charge-Mixing" ;      if(sw_potential_mixing == ON) tag_mixing = "Potential-Mixing"
       if(number_of_solvers_applied == 1) then
          if(dabs(etotal) <1.e6) then
             write(nfout,91) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A, " : ",A," = ",A)') &
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)), trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e7) then
             write(nfout,92) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e8) then
             write(nfout,93) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e9) then
             write(nfout,94) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e10) then
             write(nfout,95) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e11) then
             write(nfout,96) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e12) then
             write(nfout,97) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e13) then
             write(nfout,98) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          else 
             write(nfout,99) iteration,etotal,edel,trim(solver_names_applied(1)),trim(tag_mixing),trim(cdmixing_names_applied(1))
          end if
91        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.12,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
92        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.11,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
93        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.10,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
94        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.9,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
95        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.8,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
96        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.7,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
97        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.6,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
98        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.5,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
99        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',d20.12,' EDEL = ',d14.6, ' : SOLVER = ',A, ' : ',A,' = ',A)
       else if(number_of_solvers_applied == 2) then
          if(dabs(etotal) <1.e6) then
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",F20.12,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
!!$                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
             write(nfout,81) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e7) then
             write(nfout,82) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e8) then
             write(nfout,83) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) <1.e9) then
             write(nfout,84) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e10) then
             write(nfout,85) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e11) then
             write(nfout,86) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e12) then
             write(nfout,87) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else if(dabs(etotal) < 1.e13) then
             write(nfout,88) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          else
             write(nfout,89) iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
!!$          else
!!$#ifdef FORTRAN2008
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",G0,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$#else
!!$             write(nfout,'(" TOTAL ENERGY FOR",I6," -TH ITER=",G20.13,"  edel = ",D14.6," : SOLVER = ",A," + ",A," : ",A," = ",A)') &
!!$#endif
!!$                  & iteration, etotal, edel, trim(solver_names_applied(1)),trim(solver_names_applied(2)) &
!!$                  & , trim(tag_mixing), trim(cdmixing_names_applied(1))
          end if
81        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.12,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
82        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.11,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
83        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.10,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
84        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.9,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
85        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.8,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
86        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.7,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
87        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.6,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
88        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',f20.5,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
89        format(' TOTAL ENERGY FOR',i6,' -TH ITER=',d20.12,' EDEL = ',d14.6, ' : SOLVER = ',A,' + ',A,' : ',A,' = ',A)
       else
          write(nfout,600) iteration,etotal,edel
!!$          write(nfout,*) " TOTAL ENERGY FOR ",iteration
!!$          call flush(nfout)
!!$          write(nfout,*) " -TH ITER", etotal
!!$          call flush(nfout)
!!$          write(nfout,*) "    edel = ", edel
!!$          call flush(nfout)
!!$          write(nfout,'("  TOTAL ENERGY FOR",i6," -TH ITER=",f20.8,"   edel = ",d14.6)') iteration, etotal, edel
       end if

       if(sw_output_xc_seperately==OFF)then
          if ( flg_paw ) then
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,610) ekinet,ehartr,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       else
          if ( flg_paw ) then
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc_paw,eentropy
          else
             write(nfout,615) ekinet,ehartr,eex,ecor,exc,elocal, &
                  &                   enonlc,eewald,-epc,eentropy
          endif
       endif

       if(sw_dipole_correction == ON) write(nfout,630) evdip,evext,edip
       if(sw_hubbard == ON) write(nfout,640) ehub0,ehub1
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==ON) write(nfout,650) vexx,eexx,eexx-vexx
       if(sw_hybrid_functional == ON.and.sw_eval_vexx==OFF) write(nfout,655) eexx
       if(sw_external_potential==ON) write(nfout,670) eespot
       if(sw_fef == ON) write(nfout,680) eplr
       if(ntyp_vdw>0 .or. sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) write(nfout,690) evdw
#ifndef DISABLE_VDWDF
       if ( xctype == "vdwdf" .and. ( .not. oneshot ) ) write(nfout,690) ecnl_vdwdf
#endif

       if(way_of_smearing == COLD .or. way_of_smearing == PARABOLIC &
            & .and. abs(eentropy)>=DELTA ) write(nfout,620) etotal0

! =============== KT_add =========================================== 13.0E
       if (way_of_smearing == Fermi_Dirac ) write(nfout,620) etotal0
! ================================================================== 13.0E

       if (way_of_smearing == MP) write(nfout,620) etotal0

! === DEBUG by tkato 2011/10/07 ================================================
!      if(flg_paw) &
!      write(nfout,650) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
       if(flg_paw) then
          if(dabs(exc_ae) >1.d6 .or. dabs(exc_ps)>1.d6 )then
             write(nfout,661) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          else
             write(nfout,660) eohxc_paw,ehartr_paw,exc_ae,exc_ps,exc_ae-exc_ps
          end if
       end if
! ==============================================================================

! ====================================== added by K. Tagami =============== 11.0
       if ( sw_magnetic_constraint == ON ) write(nfout,700) emag0, emag1
! ========================================================================= 11.0       

! ====================================== added by K. Tagami =============== 11.0
!!#ifdef USE_ESPINORB
       if ( flg_paw ) then
          if ( SpinOrbit_Mode == ByPawPot ) then
             write(nfout,710) espinorb_old, espinorb_now
          endif
       endif
       if ( SpinOrbit_Mode == ByProjector .or. SpinOrbit_Mode == ZeffApprox &
            &                             .or. SpinOrbit_Mode == ReadFromPP ) then
          write(nfout,720) espinorb_now
       endif
!!!#endif
! ========================================================================= 11.0       

       call flush(nfout)
    end if
#ifdef __TIMER_SUB__
    call timer_end(749)
#endif
600 FORMAT(' ','TOTAL ENERGY FOR',I6,' -TH ITER=',F0.12,2x,' edel = ',D14.6)
610 FORMAT(' KI=',F20.12,' HA=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',d20.12,' EN=',F20.12)
615 FORMAT(' KI=',F20.12,' HA=',F20.12,' EX=',d20.12,' CR=',F20.12,' XC=',F20.12,' LO=',F20.12,/ &
    &      ,' NL=',F20.12,' EW=',F20.12,' PC=',d20.12,' EN=',F20.12)
620 FORMAT(' ','PHYSICALLY CORRECT ENERGY = ',d20.12)
630 FORMAT(' VD=',F15.7,' VE=',F15.7,' ED=',F15.7)
640 FORMAT(" HE=",F15.7," HP=",F15.7)
650 FORMAT(" VEXX=",F20.12," EEXX=",F20.12," EXX-VEXX=",F20.12)
655 FORMAT(" EXX=",F20.12)
660 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',F15.7,' XC_PAW_PS=',F15.7,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
661 FORMAT(' EOHXC_PAW=',F15.7,' HA_PAW=',F15.7,/ &
            ' XC_PAW_AE=',d20.8,' XC_PAW_PS=',d20.8,/ &
            '!XC_PAW_AE-XC_PAW_PS=',F15.7)
670 FORMAT(' ES=',F20.12)
680 FORMAT(" EP=",F20.12)
690 FORMAT(" VDW=",F20.12)

! ================================== added by K. Tagami ================== 11.0
700 FORMAT(" Emag0=",F15.7," Emag1=",F15.7)
710 FORMAT(" ESpinOrb_old=",F15.7," ESpinOrb_now=",F15.7)
720 FORMAT(" ESpinOrb=",F15.7)
! ======================================================================== 11.0

  end subroutine sumup_all_energies

  function cal_edeltb() result (res)
    real(kind=DP) :: res
    res = etotal - etoold
    return
  end function cal_edeltb

  logical function m_TE_is_Divergent_core(nfout)
    integer, intent(in) :: nfout
    integer :: iincre = 0

    if(iteration_electronic == 1) iincre = 0
    !edeltb = etotal - etoold
    edeltb = cal_edeltb()
    if(ipri >= 2) write(nfout,'(" ! edeltb = ",d14.6 &
	& ," hr (= ",d14.6," hr/atom ) ( iter = ",i7," )")') edeltb,edeltb/natm2,iteration

    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
       m_TE_is_Divergent_core = .false.
       etoold = etotal
       return
    end if
    if(sw_fef == ON)then
       if(printable) write(nfout,'(a,d14.6)') ' !** delta pmac =',sum(pmac-pmac_old)/3.d0
    endif

!!$    if(edeltb > 1.d-1) then
!!$       iincre = iincre + 100
!!$    else if(edeltb > 1.d-2) then
!!$       iincre = iincre + 100
!!$    else if(edeltb >1.d-3) then
!!$       iincre = iincre + 70
!!$    else if(edeltb > 1.d-4) then
!!$       iincre = iincre + 20
!!$    else if(edeltb > 1.d-5) then
!!$       iincre = iincre + 10
!!$    else if(edeltb > 1.d-6) then
!!$       iincre = iincre + 5
!!$    else if(iincre > 0) then
!!$       iincre = iincre - 1
!!$    end if
    if(edeltb > 1.d-7 .and. iincre /= 0 .and. printable) &
         &    write(nfout,*) ' !W IINCRE is increasing as ', iincre
    if(iincre > IINCRE_CRITICAL) then
       if(printable) write(nfout,*)  ' !S IINCRE exceeds ',IINCRE_CRITICAL,'!'
       m_TE_is_Divergent_core = .true.
    else
       m_TE_is_Divergent_core = .false.
    end if
    etoold = etotal
  end function m_TE_is_Divergent_core

  subroutine m_TE_set_etotal_old
    etoold = 0.d0
  end subroutine m_TE_set_etotal_old

! --> T. Yamasaki 08 Aug. 2009 
  real(kind=DP) function m_TE_edeltb()
    m_TE_edeltb = edeltb
  end function m_TE_edeltb
! <--
  logical function m_TE_is_converged(nfout)
    integer, intent(in) :: nfout
    integer   :: ncnv
    real(kind=DP) :: edelta

    call m_CtrlP_get_edelta(edelta)

    if(dabs(edeltb) < edelta*natm2 .and. m_ES_eekdif_cond()) then
       ncnv = m_CtrlP_ntcnvg_incre()
       if(printable) write(nfout,'(" edeltb = ",d12.4, " edelta = ",d12.4 &
            & , " ntcnvg = ",i7)') edeltb, edelta, ncnv
! --> T. Yamasaki, 25 July 2008
    else if(sub_delta_factor_is_given .and. dabs(edeltb) <edelta*sub_delta_factor*natm2) then
       ncnv = m_CtrlP_sub_ntcnvg_incre()
       if(printable) write(nfout,'(" edeltb = ",d12.4, " sub_edelta = ",d12.4 &
            & , " sub_ntcnvg = ",i7)') edeltb, edelta*sub_delta_factor, ncnv
    else
! <--
       call m_CtrlP_ntcnvg_reset()! k .Mae 030808	
    end if
    m_TE_is_converged = m_CtrlP_ntcnvg_clear()
    if(m_TE_is_converged) call m_CtrlP_ntcnvg_reset()
  end function m_TE_is_converged

  function m_TE_tell_total_energy()
    real(kind=DP)::  m_TE_tell_total_energy
    m_TE_tell_total_energy = etotal
  end function m_TE_tell_total_energy

  function m_TE_tell_total_energy0()
    real(kind=DP)::  m_TE_tell_total_energy0
    m_TE_tell_total_energy0 = etotal0
  end function m_TE_tell_total_energy0

!!$! --> T. Yamasaki 17th Aug. 2009
!!$  function m_TE_tell_total_energy_mdfy()
!!$    real(kind=DP)::  m_TE_tell_total_energy_mdfy
!!$    if(sw_hubbard == ON) then
!!$       m_TE_tell_total_energy_mdfy = etotal - ehub0*0.5d0
!!$    else
!!$       m_TE_tell_total_energy_mdfy = etotal
!!$    end if
!!$  end function m_TE_tell_total_energy_mdfy
!!$! <--

  function m_TE_tell_band_energy(nfout,kv3)
    real(kind=DP)::  m_TE_tell_band_energy
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik

! ============================== modified by K. Tagami ================== 11.0
!    call sum_eigenvalues(kv3)
!
    if ( noncol ) then
      call sum_eigenvalues_noncl(kv3)
    else
      call sum_eigenvalues(kv3)
    endif
! ======================================================================= 11.0

    m_TE_tell_band_energy = eband
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_extra_bands = ",i8)') num_extra_bands

! ========================================= modified by K. Tagami ======= 11.0
!          do ik = 1, kv3
          do ik = 1, kv3, ndim_spinor
! ====================================================================== 11.0

             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_band_energy

  function m_TE_tell_extended_band_energy(nfout,kv3)
    real(kind=DP)::  m_TE_tell_extended_band_energy
    integer, intent(in) :: nfout,kv3
    integer :: ib, ik

! ============================== modified by K. Tagami ================== 11.0
!    call sum_wholeeigenvalues(nfout,kv3)
!
    if ( noncol ) then
      call sum_wholeeigenvalues_noncl(nfout,kv3)
    else
      call sum_wholeeigenvalues(nfout,kv3)
    endif
! ======================================================================= 11.0

    m_TE_tell_extended_band_energy = eband_extendedrange
    if(ipri >= 2) then
       if(map_k(ik) == myrank_k) then
          write(nfout,'(" -- sum_eigenvalues (m_TE_tell_band_energy) --")')
          write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
! ========================================= modified by K. Tagami ======= 11.0
!          do ik = 1, kv3
          do ik = 1, kv3, ndim_spinor
! ======================================================================= 11.0

             write(nfout,'("  ik = ",i5)') ik
             write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
          end do
       end if
    endif
  end function m_TE_tell_extended_band_energy

  subroutine sum_eigenvalues(kv3)
    integer, intent(in) :: kv3
    integer             :: ib, ik
    eband = 0.d0
    do ik =1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = ista_e, iend_e, istep_e                 ! MPI
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          eband = eband + eko_l(map_z(ib),ik)*occup_l(map_z(ib),ik)
       end do
    end do
    call mpi_allreduce(MPI_IN_PLACE,eband,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    eband = 2*eband/kv3 * (af+1)
  end subroutine sum_eigenvalues

! ================================- added by K. Tagami ====================== 11.0
  subroutine sum_eigenvalues_noncl(kv3)
    integer, intent(in) :: kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI

    eband = 0.d0
    do ik =1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          eband = eband + eko_l(ib,ik)*occup_l(ib,ik)
       end do
    end do
    call mpi_allreduce(eband,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
    eband = eband_mpi                  ! MPI
    eband = eband/ (kv3/ndim_spinor)
  end subroutine sum_eigenvalues_noncl
! ===================================================================== 11.0

  subroutine sum_wholeeigenvalues(nfout,kv3)
    integer, intent(in) :: nfout,kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    integer             :: iband
    real(kind=DP)       :: weight, weight0

    if(num_conduction_bands_lmm < 0) then
       iband = neg
    else
       iband = ceiling(totch/2.0) + num_conduction_bands_lmm
    end if
    if(iband > neg - num_extra_bands) iband = neg - num_extra_bands
    eband_extendedrange = 0.d0
    weight = 0.d0; weight0 = 0.d0
    do ik =1, kv3, af+1
       weight = weight + qwgt(ik)
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = ista_e, iend_e, istep_e                 ! MPI
          if(ik==1 .and. ib == 1) weight0 = weight0 + occup_l(1,ik)
!!$          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          if(nrvf_ordr(ib,ik) > iband) cycle
          eband_extendedrange = eband_extendedrange + eko_l(map_z(ib),ik)*qwgt(ik)
       end do
    end do
    if(npes > 1) then
       call mpi_allreduce(eband_extendedrange,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
       eband_extendedrange = eband_mpi                  ! MPI
       call mpi_allreduce(weight0, eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       weight0 = eband_mpi
    end if
    eband_extendedrange = (3.0-nspin) * eband_extendedrange * (af+1)
    if(ipri >= 2) then
       weight = weight * (af+1)
       write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
       write(nfout,'(" weight (sum_wholeeigenvalues) = ", f8.4, " iband = ",i10)') weight,iband
       write(nfout,'(" weight0 (occup_l)             = ", f8.4)') weight0
       write(nfout,'(" eband_extendedrange = ", f16.8, "   eband = ",f16.8)') eband_extendedrange, eband
    end if
  end subroutine sum_wholeeigenvalues

! ================================ added by K. Tagami =============== 11.0
  subroutine sum_wholeeigenvalues_noncl(nfout,kv3)
    integer, intent(in) :: nfout,kv3
    integer             :: ib, ik
    real(kind=DP)       :: eband_mpi   ! MPI
    integer             :: iband
    real(kind=DP)       :: weight, weight0

    if(num_conduction_bands_lmm < 0) then
       iband = neg
    else
       iband = ceiling(totch) + num_conduction_bands_lmm
    end if
    if(iband > neg - num_extra_bands) iband = neg - num_extra_bands
    eband_extendedrange = 0.d0
    weight = 0.d0; weight0 = 0.d0

    do ik =1, kv3, ndim_spinor
       weight = weight + qwgt(ik)
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, np_e                 ! MPI
          if(ik==1 .and. ib == 1) weight0 = weight0 + occup_l(1,ik)
!!$          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          if(nrvf_ordr(ib,ik) > iband) cycle
          eband_extendedrange = eband_extendedrange + eko_l(ib,ik)*qwgt(ik)
       end do
    end do
    if(npes > 1) then
       call mpi_allreduce(eband_extendedrange,eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
       eband_extendedrange = eband_mpi                  ! MPI
       call mpi_allreduce(weight0, eband_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       weight0 = eband_mpi
    end if

    if(ipri >= 2) then
       weight = weight * (af+1)
       write(nfout,'("   -- num_conduction_bands_lmm = ",i8)') num_conduction_bands_lmm
       write(nfout,'(" weight (sum_wholeeigenvalues) = ", f8.4, " iband = ",i10)') weight,iband
       write(nfout,'(" weight0 (occup_l)             = ", f8.4)') weight0
       write(nfout,'(" eband_extendedrange = ", f16.8, "   eband = ",f16.8)') eband_extendedrange, eband
    end if
  end subroutine sum_wholeeigenvalues_noncl
! ============================================================== 11.0

  subroutine m_TE_wd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    !!$ print *,' tag_total_energy'
    if(mype==0) then
       write(nfcntn,*) tag_total_energy
       write(nfcntn,'(2d24.16)') etotal, etoold
       !edeltb = etotal - etoold
       !edeltb = cal_edeltb()
    endif
  end subroutine m_TE_wd_total_energy

  subroutine m_TE_rd_total_energy(nfcntn)
    integer, intent(in) :: nfcntn
    logical             :: EOF_reach, tag_is_found

    if(mype==0) then
       call rewind_to_tag0(nfcntn,len_tag_total_energy,tag_total_energy &
            &, EOF_reach, tag_is_found,str,len_str)
       if(.not.tag_is_found) then
          stop ' tag_total_energy is not found'
       else
          read(nfcntn,*) etotal, etoold
          etoold = etotal
       end if
    endif
    call mpi_bcast(etotal,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(etoold,1 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)
  end subroutine m_TE_rd_total_energy

  logical function m_TE_Converged_Hubbard_Energy(nfout)
    integer, intent(in) :: nfout

    m_TE_Converged_Hubbard_Energy = .false.
    !!$if(ehub0 <= critical_ehub) then
    !!$   m_TE_Converged_Hubbard_Energy = .true.
    !!$   write(nfout,'(" Interation will be stoped &
    !!$   &because Hubbard energy is lower than ",f10.5,".")') critical_ehub
    !!$end if

    if(abs(ehub0-ehub0_old) <= delta_ehub) then
       m_TE_Converged_Hubbard_Energy = .true.
       write(nfout,'(" Interation will be stoped &
       &because Hubbard energy is converged within ",f10.5,".")') delta_ehub
    else
       ehub0_old = ehub0
    end if

  end function m_TE_Converged_Hubbard_Energy


end module m_Total_Energy

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 552 $)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: vdW-Soler
!
!  AUTHOR(S): Y. Ono
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
!********************************** Note ******************************************
! This program calculates the non-local correlation energy (Ecnl) and 
! the local correlation energy (EcLDA) as the post calculation by utilizing
! the output files from the PHASE. By adding these correlation terms as
!    E_total = E_total(GGAx) + EcLDA + Ecnl,
! the van der Waals interaction will be included into the total energy.
!
! This program follows the Dion et al's 1-shot method (so called vdW-DF), and 
! the Roman-Perez et al's convolution algorithm. Because of this convolution,
! the CPU cost in this program is reduced to O(NlogN) from the original O(N**2).
!                                 (Reference; M.Dion et al. PRL 92 (2004) 246401.)
!                         (Reference; G.Roman-Perez et al. PRL 103 (2009) 096102.)
!
!
! Periodic systems are assumed.
! The atomic units (Hartree) are used.
!
! ======= modification =====
!
!  2016/06/06 : by asms
!         The FFT normalization parameters are changed in order to be consistent
!         with the other subroutines.
!
!         rho(G) = 1/V *Int rho(r) exp(-iGr);   rho(r) = sum_{G} rho(G) exp(iGr)
!        
!         In the dicretized grids, rho(G) = FFT[rho(r)] /(na*nb*nc);
!                                  rho(r) = FFT[rho(G)]
!
!         By this, the nonlocal vdW energy is written as
!             Encl = V**2 /2 sum_{ij} sum_{G} conjg(theta(i,G))*phi(i,j,G)*theta(i,G)
!         and 
!             phi(i,j,G) = 1/V Int phi(i,j,r) exp(-iGr)
!
! =========================
!
! ++++++++ List of subroutines ++++++
! All subroutine files listed below are included in this file.
! In addition to the below list, it is necessary to link to a FFT library, for example FFTW3.
!
! CPU_TIME             : Check the calculation time.
! derivation           : Calculate the derivations of the electron density distribution.
! d_q0                 : Obtain q(rho(r)) from the electron density rho(r) and its derivations.
! spline               : Determine the function 'p(q)' for bi-cubic spline interpolation. 
!                        Here p(r) is defined as, phi(q1,q2,r12) = SUM_ab(p(qa)*p(qb)*phi(qa,qb,r12)).
! theta_ab             : Multiply theta(r) = p(r)*rho(r) by use of the given parameter qa or qb.
! RtoG                 : Calculate the Fourier transform of theta(r) within the FFT algorithm.
! phiab                : Calculate the Fourier transform of the kernel phi(r) by use of the given 
!                        parameter qa and qb. phi(r) does not depends on angular components,
!                        so that it can be done within the radial mesh.
! convolution_3d       : Calculate the integral SUM(dk*theta_a(k)*theta_b(k)*phi(k)).
! piDphi               : Calculate the local part of dr**2*rho(r1)*rho(r2)*phi(r1,r2,r12) directory.
!                        The local part includes the singular point, thus it is necessary to execute
!                        the 3D space integral directory.
! cLDA                 : Obtain the LDA version of correlation term EcLDA.
! outputs              : Output the results.
! kernel_phi           : Calculate the value of kernel phi(d1,d2).
! gauleg               : Prepare the grid points for the Gauss-Legendre integral.
!
!
!
! ++++++++ Input & Output +++++++++++
! Input files  (Both of the input files will be output by PHASE.)
!   nfchr.cube        : An electron density distribution file given by
!                       GGA(exchange only) calculation
!   nfefn.data        : The total energy given by GGA(exchange only) calculation
!
! Output   E_total(vdW-DF) = E_total(GGAx) + EcLDA + Ecnl
!   E_total(GGAx)     : Total energy given by GGA(exchange only) calculation
!   Ecnl              : Non-local Correlation energy
!   EcLDA             : LDA Correlation energy
!
!
!
! ++++++ Internal parameters ++++++++
! dq      (       )   : The smallest distance between the grid points for bi-cubic 
!                       spline interpolation. The grid points are plotted in logarithmic manner.
! lambda   (       )   : The power of dq
! nr12    (       )   : The number of the grid points for the kernel phi(r12)
! phi0    (       )   : One of the coefficients in the 'soft' function, 
!                       phi_s(r12) = phi0 + phi2*d**2 + phi4*d**4. phi2 and phi4 will be 
!                       eventually determined to match the value and the slope of phi_s and 
!                       those of phi at d=d_s, in the program.
! ds      (       )   : The connection point of phi_s and phi
! r12max  (       )   : The cutoff for r12
! rhomin  (       )   : Minimum value of electron density. 
!                       If the electron density was smaller than rhomin, then the program 
!                       will read as this minimum value in order to avoid a divergence.
! nk      (       )   : The number of the grid points plotted for the Fourier 
!                       transformed kernel phi(k)
! maxk    (       )   : The cutoff for k
!
!
!                                              Written by Youky Ono in June/2013
!**********************************************************************************
#ifndef DISABLE_VDWDF
module progress_bar
  implicit none
  logical,private :: printable = .false.
  integer,private :: iend=10
  integer,private :: uni=6
  integer,private :: j=0
  logical, dimension(0:9),private :: done

contains

  subroutine set_printable(pri)
    logical, intent(in) :: pri
    printable = pri
  end subroutine set_printable

  subroutine reset_progress()
    j = 0
    done = .false.
    if(printable) write(unit=uni,fmt="(a10)") "0%    100%"
  end subroutine reset_progress

  subroutine set_unit(un)
    integer, intent(in) :: un
    uni = un
  end subroutine set_unit

  subroutine set_end(en)
    integer, intent(in) :: en
    iend = en
  end subroutine set_end

  subroutine progress()
    use m_Const_Parameters, only : DP
    implicit none
    integer(kind=4)::k
    character(len=17)::bar="???% |          |"
    integer :: jj
    real(kind=DP) :: jjj
    j = j+1
    if(j.gt.iend) j=iend
    jj = int(10*(dble(j)/dble(iend))*0.999999d0)
    if(.not.done(jj).and.j<=iend) then
       if(printable) write(unit=uni,fmt="(a1,$)") '*'
       call flush(uni)
       done(jj) = .true.
    endif
    if(j==iend.and.printable) write(unit=uni,fmt=*)
    !     jjj = (dble(j)/dble(iend))
    !     write(unit=bar(1:3),fmt="(i3)") int(100*jjj)
    !     do k=1, jj
    !       bar(6+k:6+k)="*"
    !     enddo
    !     ! print the progress bar.
    !     write(unit=uni,fmt="(a1,a17,$)") char(13), bar
    !!     write(unit=uni,fmt="(a1,a17)") char(13), bar
    !     if (j/=iend) then
    !       flush(unit=6)
    !     else
    !       write(unit=6,fmt=*)
    !       do k=1,jj
    !          bar(6+k:6+k) = ""
    !       enddo
    !     endif
    return
  end subroutine progress

end module progress_bar

module m_vdWDF
  use m_Const_Parameters, only : DP, ON, PAI, FMAXVALLEN, LOWER, CMPLDP, DIRECT, INVERSE
  use m_Control_Parameters, only : printable,nspin,eval_kernel_by_interpolation, &
       &                           na_gl,a1,a2,dq_vdw,lambda,q0cut,ds,ndel,nphiD, &
       &                           nr12,nk,maxk, r12max,oneshot, ipri, &
       &                           sw_save_memory_vdw, kimg, iprixc, &
       &                           q0min, sw_use_WuGygi_method
  use m_Files, only : nfout
  use m_Charge_Density, only : m_CD_get_rspace_charge

  use m_FFT, only : fft_box_size_CD,fft_box_size_CD_nonpara, m_FFT_CD0,nfftp_nonpara
  use m_Crystal_Structure, only : altv,univol, rltv

  use m_Parallelization, only : npes,mype,mpi_comm_group,m_Parallel_init_mpi_nq,  &
       &                        ista_nq,iend_nq,np_nq,mp_nq,is_nq,ie_nq,nel_nq, &
       &                        map_z_nq
  use m_Timing, only : tstatc0_begin,tstatc0_end

  implicit none
  include 'mpif.h'

  real(kind=DP),parameter :: pi=PAI

  ! Physical values
  Real(kind=DP) ExGGA,Ecnl,Ecnl_12,Ecnl_12_ab,Ecnl_3,Ecnl_3s,EcLDA

  real(kind=DP) :: phi0=2.77d0 

  Integer na,nb,nc,nabc
  Real(kind=DP) :: aa(3,3),dv
  Real(kind=DP), Allocatable :: rho(:),grad(:), cgrad(:,:)
  real(kind=DP),allocatable,dimension(:) :: phi_ab

  ! Grid points
!!!! Spline curves
  Integer nq0
  real(kind=DP) :: qa,qb,q0max

!!!! The table of phidD
  real(kind=DP), allocatable, dimension(:,:) :: phidD

  ! Internal parameters
  Real(kind=DP),parameter :: rhomin=1.d-9

  ! Real-space and reciprocal-space Functions

  Complex*16, Allocatable :: theta_G(:),     &
       &                            theta_G_ab(:,:),theta_G_a(:),theta_G_b(:)
  Real(kind=DP), Allocatable :: theta_R(:),dtheta_R(:,:),ddtheta_R(:,:)

  complex(kind=DP), allocatable, dimension(:,:) :: ualpha_g1,ualpha_r1

  real(kind=DP) :: etai = 1.3d0,eta1 = 8.d0

  real(kind=DP), allocatable, dimension(:)   :: qar
  real(kind=DP), allocatable, dimension(:,:) :: q2ar

  real(kind=DP) :: rinplw
  logical :: firstcall = .true.

  integer, parameter :: FFTW_ESTIMATE = 64
  integer, parameter :: FFTW_FORWARD  = -1
  integer, parameter :: FFTW_BACKWARD = +1

  real(kind=DP), allocatable, dimension(:) :: dFdrho, dFddrho
  real(kind=DP), allocatable, dimension(:) :: rkar

  real(kind=DP) :: s_cnl1(3,3), s_cnl2(3,3), ecnl_vdwdf
  real(kind=DP) :: s_cnl1_pc(3,3), s_cnl2_pc(3,3)

  !  logical :: grad_rho_eq_0 = .true.
  logical :: grad_rho_eq_0 = .false.

! ---- extension to vdWDF2 ----
  integer :: version_no_vdwdf = 1

  real(kind=DP) :: Zab
  real(kind=DP), parameter :: Zab_0 = -0.8491d0
! ---------------------------

  logical :: lprog = .false.

contains

  integer function get_index_1D_kimg(cix,ciy,ciz,ignore_kimg)
    integer, intent(in) :: cix,ciy,ciz
    logical, intent(in), optional :: ignore_kimg
    integer :: cix2,ciy2,ciz2
    integer :: idp,mmp,nlphf
    logical :: ig
    ig = .false.
    if(present(ignore_kimg)) ig = ignore_kimg

    idp = fft_box_size_CD_nonpara(1,0)
    mmp = fft_box_size_CD_nonpara(2,0)
    if(kimg == 1 .and. .not.ig) then
       nlphf = idp/2
    else
       nlphf = idp
    end if
    if ( cix > nlphf ) then
       cix2 = idp -cix
       ciy2 = nb +2 -ciy
       ciz2 = nc +2 -ciz
       if ( ciy2 > nb ) ciy2 = ciy2 -nb
       if ( ciz2 > nc ) ciz2 = ciz2 -nc
    else
       cix2 = cix;  ciy2 = ciy; ciz2 = ciz
    endif
    get_index_1D_kimg = (ciz2-1)*mmp*nlphf +(ciy2-1)*nlphf +cix2
  end function get_index_1D_kimg

  integer function get_index_1D(cix,ciy,ciz)
    integer, intent(in) :: cix,ciy,ciz
    integer :: cix2,ciy2,ciz2
    integer :: idp,mmp,nlphf
    get_index_1D = (ciz-1)*nb*na + (ciy-1)*na + cix
  end function get_index_1D

  function get_index_3D(cir) result(ret)
    integer, intent(in) :: cir
    integer :: ret(3)
    integer :: cix,ciy,ciz
    cix = 1+(cir-1-MOD(cir-1+nb*nc,nb*nc))/(nb*nc)
    ciy = 1+(cir-nb*nc*(cix-1)-1-MOD(cir-1+nc,nc))/nc
    ciz = cir-nc*(nb*(cix-1)-1+ciy)
    ret(1) = cix
    ret(2) = ciy
    ret(3) = ciz
  end function get_index_3D

  subroutine print_vdw_parameters()
    if(printable)then
       write(nfout,'(a)')            '-- parameters for the vdW-DF calculations --'
       write(nfout,'(a,2f15.10,i8)') '   rmax, kmax, nmesh     : ',r12max,maxk,nr12
       write(nfout,'(a,3f15.10)')    '   dq, lambda, and q0cut : ',dq_vdw,lambda,q0cut
       write(nfout,'(a,2f15.10,i5)') '   q0min, q0max, nq0     : ',q0min,q0max,nq0
       write(nfout,'(a,f15.10)' )    '   ds                    : ',ds
       write(nfout,'(a,i5,2f15.10)') '   na_gl, a1, a2         : ',na_gl,a1,a2
       if(eval_kernel_by_interpolation)then
          write(nfout,'(a)')            '   kernel evaluation     : by interpolation'
          write(nfout,'(a,2i8)')        '   ndel, nphiD           : ',ndel,nphiD
       else
          write(nfout,'(a)')            '   kernel evaluation     : direct'
       endif
       write(nfout,'(A,I3)') '   sw_use_WuGygi_method : ', sw_use_WuGygi_method
    endif
  end subroutine print_vdw_parameters

  subroutine initialize_vdwdf_scf(nspin,ispin,na,nb,nc,chgr,grad_rho,version_no)
    use progress_bar, only : set_printable

    integer, intent(in) :: nspin,ispin,na,nb,nc, version_no
    real(kind=DP), dimension(na*nb*nc), intent(in) :: chgr,grad_rho

    integer :: i,cix,ciy,ciz,nrxyz,cir,cir2
    integer :: idp, mmp, nlphf, cix2, ciy2, ciz2
    real(kind=DP) :: q

    lprog = .false.
    if ( version_no == 1 ) then
       Zab = Zab_0
    else if ( version_no == 2 ) then
       Zab = Zab_0 *2.222d0
    endif

    call set_printable(printable)
    call do_cell_params()

    rinplw = 1.d0/(dble(na*nb*nc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max

    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)
    if(firstcall) call print_vdw_parameters()
    call alloc_vdw()

    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             rho(cir2) = chgr(cir)
             grad(cir2) = grad_rho(cir)
          enddo
       enddo
    enddo

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo
    call spline0(nq0,qar,q2ar)

    if (eval_kernel_by_interpolation.and.firstcall) then
       call build_lookup_table(ndel,nphiD,phidD)
    endif
    firstcall = .false.
  end subroutine initialize_vdwdf_scf

  subroutine initialize_vdwdf_oneshot(is)
    use progress_bar, only : set_printable
    integer, intent(in) :: is
    integer :: i,cir,cix,ciy,ciz,nrxyz
    real(kind=DP) :: q
    lprog = .true.
    call set_printable(printable)
    if(printable) write(nfout,'(a)') 'initialization ...'

    call do_cell_params()

    rinplw = 1.d0/(dble(na*nb*nc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max
    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)

    call alloc_vdw()
    call m_CD_get_rspace_charge(nfout,na,nb,nc,rho,is)
    call print_vdw_parameters()
    call derivation(na,nb,nc,aa,rho,dv,grad)

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo

    call spline0(nq0,qar,q2ar)

    if(eval_kernel_by_interpolation)then
       if(printable) write(nfout,'(a)') 'building the lookup table for the kernel function ...'
       call build_lookup_table(ndel,nphiD,phidD) 
       if(printable) write(nfout,'(a)') '... done'
    endif
    if(printable) write(nfout,'(a)') '... done initialization'

  end subroutine initialize_vdwdf_oneshot

  subroutine do_cell_params()
    integer :: i
    na = fft_box_size_CD(1,1)
    nb = fft_box_size_CD(2,1)
    nc = fft_box_size_CD(3,1)
    nabc = na * nb * nc
    do i=1,3
       aa(i,1:3) = altv(1:3,i)/dble(fft_box_size_CD(i,1))
    enddo
    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
         &      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
         &      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))
  end subroutine do_cell_params

  function real_index(iq,pe) result(res)
    integer, intent(in) :: iq
    integer, intent(in),optional :: pe
    integer :: res
    integer :: ii,mpe
    mpe = mype
    if(present(pe))then
       mpe = pe
    endif
    if(mpe==0)then
       res = iq
       return
    endif
    res = 0
    do ii=0,mpe-1
       res = res+nel_nq(ii) 
    enddo
    res = res+iq
    return
  end function real_index

  subroutine alloc_vdw()
    integer :: i,cix,ciy,ciz,itmp
    real(kind=DP) :: Ta,Tb,Tc, vec(3), bb(3,3)

    Allocate(rho(nabc));rho=0.d0
    allocate(grad(nabc));grad=0.d0
    Allocate(theta_G(nabc))
    Allocate(theta_R(nabc))
    if(.not.oneshot)then
       Allocate(dtheta_R(np_nq,nabc))
       Allocate(ddtheta_R(np_nq,nabc))
    endif
    Allocate(theta_G_a(nabc))
    Allocate(theta_G_b(nabc))
    allocate(phi_ab(0:nr12))
    if(eval_kernel_by_interpolation.and.firstcall) allocate(phidD(0:ndel,-1:nphiD+1))
    allocate(qar(nq0));qar = 0.d0
    allocate(q2ar(nq0,nq0));q2ar = 0.d0
    !    allocate(theta_G_ab(nq0,-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
    if(sw_save_memory_vdw) then
       allocate(theta_G_ab(np_nq,nabc))
    else
       allocate(theta_G_ab(nq0,nabc))
    endif
    if(.not.oneshot)then
       !       allocate(ualpha_g(nq0,-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2))
       !       allocate(ualpha_r(nq0,na,nb,nc))
       allocate(dFdrho(nabc))
       allocate(dFddrho(nabc))
    endif

    allocate(rkar(nabc))

#if 0
    Ta = na*DSQRT(aa(1,1)**2 + aa(1,2)**2 + aa(1,3)**2)
    Tb = nb*DSQRT(aa(2,1)**2 + aa(2,2)**2 + aa(2,3)**2)
    Tc = nc*DSQRT(aa(3,1)**2 + aa(3,2)**2 + aa(3,3)**2)
    Do ciz = -(nc/2-1),nc/2
       Do ciy = -(nb/2-1),nb/2
          Do cix = -(na/2-1),na/2
             rkar(get_index_1D(cix+na/2,ciy+nb/2,ciz+nc/2)) = &
                  &    DSQRT((dble(cix)/Ta)**2 + (dble(ciy)/Tb)**2 + (dble(ciz)/Tc)**2)
          Enddo
       Enddo
    Enddo
#else
    Do i=1, 3
       bb(1,i) = rltv(i,1) /PAI /2.0d0
       bb(2,i) = rltv(i,2) /PAI /2.0d0
       bb(3,i) = rltv(i,3) /PAI /2.0d0
    End Do

    Do ciz = -(nc/2-1),nc/2
       Do ciy = -(nb/2-1),nb/2
          Do cix = -(na/2-1),na/2
             vec(1:3) = dble(cix) *bb(1,1:3) &
                  &    +dble(ciy) *bb(2,1:3) &
                  &    +dble(ciz) *bb(3,1:3)
             rkar(get_index_1D(cix+na/2,ciy+nb/2,ciz+nc/2)) = DSQRT( vec(1)**2 +vec(2)**2 +vec(3)**2 )
          End Do
       End Do
    End Do
#endif
  end subroutine alloc_vdw

  subroutine finalize_vdwdf()
    call dealloc()

  contains
    subroutine dealloc()
      deallocate(rho)
      deallocate(grad)
      deallocate(theta_G)
      deallocate(theta_R)
      if(.not.oneshot)then
         deallocate(dtheta_R)
         deallocate(ddtheta_R)
      endif
      deallocate(theta_G_a)
      deallocate(theta_G_b)
      deallocate(phi_ab)
      if(eval_kernel_by_interpolation.and.oneshot) deallocate(phidD)
      deallocate(qar)
      deallocate(q2ar)
      deallocate(theta_G_ab)
      if(.not.oneshot)then
         !         deallocate(ualpha_g)
         !         deallocate(ualpha_r)
         deallocate(dFdrho)
         deallocate(dFddrho)
      endif
      deallocate(rkar)
      !
      if ( allocated( cgrad ) ) deallocate( cgrad )
    end subroutine dealloc
  end subroutine finalize_vdwdf

  subroutine build_lookup_table(ndel,nphiD,phidD)
    use progress_bar
    implicit none
    integer, intent(in) :: ndel,nphiD
    real(kind=DP), intent(out), dimension(0:ndel,-1:nphiD+1) :: phidD
    integer cdel,cphiD
    real(kind=DP) :: del,phiD,di,dk,tmp
    real(kind=DP) :: ddel,dphiD
    integer :: ierr
    integer :: id_sname=-1

    call tstatc0_begin('build_lookup_table ',id_sname,1)

    phidD = 0.d0
    ddel = 1.d0 /dble(ndel)
    dphiD = (q0max*eta1-q0min*etai)/(dble(nphiD))

    if(lprog) then
       call reset_progress()
       call set_end(int(floor(dble(ndel+1)/dble(npes))))
    endif

    do cdel=0,ndel
       if(mod(cdel,npes)/=mype) cycle
       if(lprog) call progress()
       do cphiD = -1,nphiD+1
          del = dble(cdel)*ddel
          phiD = q0min*etai + dble(cphiD)*dphiD
          di = phiD*(1.d0+del)
          dk = phiD*(1.d0-del)
          Call kernel_phi(di,dk,tmp)
          phidD(cdel,cphiD) = tmp
       enddo
    enddo
    if(npes>1) &
         & call mpi_allreduce(MPI_IN_PLACE,phidD,(ndel+1)*(nphiD+2),mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call tstatc0_end(id_sname)
  end subroutine build_lookup_table

  subroutine build_theta()
    use progress_bar, only : reset_progress,progress,set_end
    integer :: cqa,ierr
    integer :: id_sname = -1
    real(kind=DP),allocatable,dimension(:) :: tmpdr,tmpddr

    call tstatc0_begin('build_theta ',id_sname,1)

    !+++++++++++++++ Execute FFT for theta_R_ab ++++++++++++++++++++
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'building theta (spline coefficient x rho) and their Fourier transforms ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(npes))))
    endif
    theta_G_ab(:,:) = (0.d0,0.d0)

    if(.not.oneshot)then
       allocate(tmpdr(nabc));tmpdr=0.d0
       allocate(tmpddr(nabc));tmpddr=0.d0
       dtheta_R=0.d0;ddtheta_R=0.d0
    else
       allocate(tmpdr(1))
       allocate(tmpddr(1))
    endif
    Do cqa = ista_nq,iend_nq
       if(lprog) call progress()
       Call theta_ab(nabc,cqa,nq0,q0min,q0max,rho,grad,rhomin,theta_R,tmpdr,tmpddr)
       Call RtoG(na,nb,nc,theta_R,theta_G)
       if(sw_save_memory_vdw)then
          theta_G_ab(map_z_nq(cqa),:) = theta_G(:)
       else
          theta_G_ab(cqa,:) = theta_G(:)
       endif
       if(.not.oneshot)then
          dtheta_R  (map_z_nq(cqa),:) = tmpdr  (:)
          ddtheta_R (map_z_nq(cqa),:) = tmpddr (:)
       endif
    Enddo

    if(.not.sw_save_memory_vdw)then
       call mpi_allreduce(MPI_IN_PLACE,theta_G_ab,nq0*na*nb*nc,mpi_double_complex, &
            &    mpi_sum,mpi_comm_group,ierr) 
    endif
    deallocate(tmpdr)
    deallocate(tmpddr)

    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine build_theta

  subroutine phiab_by_interpl(ca,cb,nr12,phi_ab)
    Implicit none
    integer, intent(in) :: ca,cb,nr12
    real(kind=DP), intent(out), dimension(0:nr12) :: phi_ab

    integer :: i,cr12
    real(kind=DP) :: r12,dr12,qa,qb,qab,phiD,del,ddel,phix,phiy
    integer :: cdel,cphiD

    real(kind=DP) :: rs,di,dk,phid_s,phid_s1,d_phid_s,phi2,phi4
    real(kind=DP) :: dr=0.001d0

    real(kind=DP) :: phi1u
    integer :: id_sname=-1

    call tstatc0_begin('phiab ',id_sname,1)

    phi_ab = 0.d0
    dr12 = r12max/DBLE(nr12)
    qa = qar(ca)
    qb = qar(cb)
    qab = DSQRT(qa**2+qb**2)

    ! Coefficients phi2 and phi4 in the local part is determined to
    ! match the non-local part in value and slope at d=d_s.

    rs = ds/qab

    di = qa*rs
    dk = qb*rs
    Call kernel_phi(di,dk,phid_s)

    di = qa*(rs+dr)
    dk = qb*(rs+dr)
    Call kernel_phi(di,dk,phid_s1)

    d_phid_s = (phid_s1 - phid_s)/dr

    phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
    phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

    i = DINT((ds/qab)/dr12)
    ! Non-local part of phi_ab(r12)
    if(i.ge.nr12)return
    ddel = 1/dble(ndel)
    do cr12 = i+1,nr12
       r12 = DBLE(cr12)*dr12

       di = qa*r12
       dk = qb*r12

       del  = dabs(di-dk)/(di+dk)
       phiD = 0.5d0*(di+dk)
       cdel = DINT(del/ddel)
       cphiD = DINT(DBLE(nphiD)*(phiD-q0min*etai)/(q0max*eta1-q0min*etai))
       !     write(6,*) 'cdel, cphiD: ',cdel,cphiD
       if(cdel.ge.ndel.or.cphiD.ge.nphiD.or.cdel.lt.0.or.cphiD.lt.-1)cycle
       phix = del/ddel - dble(cdel)
       phiy = dble(nphiD)*(phiD-q0min*etai)/(q0max*eta1-q0min*etai) - dble(cphiD)
       phi1u =  (1.d0-phix)*(1.d0-phiy) * phidD(cdel  ,cphiD  ) &
            &              +       phix *(1.d0-phiy) * phidD(cdel+1,cphiD  ) &
            &              +(1.d0-phix)*   phiy  * phidD(cdel  ,cphiD+1) &
            &              +      phix *   phiy  * phidD(cdel+1,cphiD+1)
       phi_ab(cr12) = phi1u
    enddo

    ! Local part of phi_ab(r12)
    Do cr12 = 0,i
       r12 = DBLE(cr12)*dr12

       !d1 = qa*r12
       !d2 = qb*r12
       phiD = qab*r12
       phi_ab(cr12) = phi0 + phi2*phiD**2 + phi4*phiD**4
    Enddo
    call tstatc0_end(id_sname)
  end subroutine phiab_by_interpl

  !** SUBROUTINE phiab **************************************************************************
  Subroutine phiab(ca,cb,nr12,phi_ab)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer,intent(in) :: ca,cb,nr12
    Real(kind=DP),intent(out) :: phi_ab(0:nr12)

    ! Internal valuables
    Integer cr12,i
    Real(kind=DP) qab,qa,qb,r12,rs,phiD,dr12,phi2,phi4,phid_s,phid_s1,d_phid_s,d1,d2,abs_d
    Real(kind=DP) di,dk,tmp,dr
    Parameter(dr=0.001d0)
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    integer :: id_sname=-1
    call tstatc0_begin('phiab ',id_sname,1)

    dr12 = r12max/DBLE(nr12)
    qa = qar(ca)
    qb = qar(cb)
    qab = DSQRT(qa**2+qb**2)

    ! Coefficients phi2 and phi4 in the local part is determined to
    ! match the non-local part in value and slope at d=d_s.

    rs = ds/qab

    di = qa*rs
    dk = qb*rs
    Call kernel_phi(di,dk,phid_s)

    di = qa*(rs+dr)
    dk = qb*(rs+dr)
    Call kernel_phi(di,dk,phid_s1)

    d_phid_s = (phid_s1 - phid_s)/dr

    phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
    phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

    i = DINT((ds/qab)/dr12)
    ! Non-local part of phi_ab(r12)
    if(i.ge.nr12)return

    Do cr12 = i+1,nr12
       r12 = DBLE(cr12)*dr12

       di = qa*r12
       dk = qb*r12

       Call kernel_phi(di,dk,tmp)
       phi_ab(cr12) = tmp

    Enddo

    ! Local part of phi_ab(r12)
    Do cr12 = 0,i
       r12 = DBLE(cr12)*dr12

       d1 = qa*r12
       d2 = qb*r12
       phiD = qab*r12
       phi_ab(cr12) = phi0 + phi2*phiD**2 + phi4*phiD**4
    Enddo

    call tstatc0_end(id_sname) 
  End subroutine phiab
  !** End SUBROUTINE phiab **********************************************************************

  subroutine vdWdf()
    if(sw_save_memory_vdw) then
       call vdWdf_core()
       !call vdWdf_core2()
    else
       call vdWdf_core_org()
    endif
  end subroutine vdWdf

  subroutine vdWdf_core_org()
    use progress_bar
    real(kind=DP) :: fac
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    integer :: id_sname = -1
    integer :: id_sname3 = -1

    call tstatc0_begin('vdWdf_core ',id_sname,1)
    Ecnl_12 = 0.0d0
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(npes))))
    endif
    if(.not.oneshot)then
       allocate(tmpug(nabc));tmpug=0.d0
       allocate(tmpur(nabc));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    do cqaa=1,np_nq
       cqa = real_index(cqaa)
       theta_G_a(:) = theta_G_ab(cqa,:)
       if (.not.oneshot)  tmpug=(0.d0,0.d0)
       if (lprog) call progress()
       call tstatc0_begin('vdw_core_core ',id_sname3,1)
       do cqb=1,nq0
          theta_G_b(:) = theta_G_ab(cqb,:)
          fac = 1.d0
          if(eval_kernel_by_interpolation) then
             call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
          else
             Call phiab(cqa,cqb,nr12,phi_ab)
          endif
          Call convolution_3d_by_fft(&
               &    na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
          Ecnl_12 = Ecnl_12 + Ecnl_12_ab
       enddo
       call tstatc0_end(id_sname3)
       if(.not.oneshot)then
          call GtoR(na,nb,nc,tmpur,tmpug)
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(cqaa,:)
       endif
    enddo

    if(.not.oneshot)then
       if(npes>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             nabc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             nabc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)

  end subroutine vdWdf_core_org

  subroutine vdWdf_core()
    use progress_bar
    real(kind=DP) :: fac, grho, rtmp, esum
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3, cir, cix, ciy ,ciz
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1, id_sname2 = -1, id_sname3 = -1

    Ecnl_12 = 0.0d0
    esum = 0.0d0

    call tstatc0_begin('vdWdf_core ',id_sname,1)
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'

    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(npes))))
    endif

    if(npes>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nabc));theta_buf_r=(0.d0,0.d0)
    endif

    if(.not.oneshot)then
       allocate(tmpug(nabc));tmpug=0.d0
       allocate(tmpur(nabc));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    irecv = mype+1
    if(irecv.ge.npes) irecv = irecv-npes
    isend = mype-1
    if(isend.lt.0)    isend = isend+npes

    do cqaa=1,mp_nq
       cqa = real_index(cqaa)
       if (npes>1)        theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
       if (cqaa.le.np_nq) theta_G_a(:) = theta_G_ab(cqaa,:)

       if (.not.oneshot)  tmpug=(0.d0,0.d0)
       if (lprog)       call progress()

       call tstatc0_begin('vdw_core_core ',id_sname3,1)

       do i0=0,npes-1
          ipos = i0+mype
          if(ipos.ge.npes) ipos = ipos-npes
          if(ipos.lt.0)    ipos = ipos+npes

          if(cqaa.le.np_nq)then
             do i1=1,nel_nq(ipos)
                cqb = real_index(i1,ipos)
                if(npes>1)then
                   theta_G_b(:) = theta_buf_r(i1,:)
                else
                   theta_G_b(:) = theta_G_ab(i1,:)
                endif

                fac = 1.d0
                if(eval_kernel_by_interpolation) then
                   call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
                else
                   Call phiab(cqa,cqb,nr12,phi_ab)
                endif
                Call convolution_3d_by_fft( na,nb,nc,cqa,cqb,nr12,phi_ab, &
                     &                      theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
                Ecnl_12 = Ecnl_12 + Ecnl_12_ab
             enddo
          endif
          if(npes>1.and.i0.ne.npes-1)then
             call tstatc0_begin('vdWdf_core (comm) ',id_sname2,1)
             allocate(theta_buf_s(1:mp_nq,nabc))
             theta_buf_s = theta_buf_r
             call mpi_sendrecv(theta_buf_s,mp_nq*nabc,mpi_double_complex,isend,0, &
                  &            theta_buf_r,mp_nq*nabc,mpi_double_complex,irecv,0, &
                  &            mpi_comm_group,ista,ierr)
             deallocate(theta_buf_s)
             call tstatc0_end(id_sname2)
          endif
       enddo
       call tstatc0_end(id_sname3)

       if(.not.oneshot.and.cqaa.le.np_nq)then
          call GtoR(na,nb,nc,tmpur,tmpug)
#if 1
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          if ( .not. grad_rho_eq_0 ) then
             do cir = 1,nabc
                grho = grad(cir)
                rtmp = rho(cir)
                if ( grho > 1.0d-6 ) then
                   dFddrho(cir) = dFddrho(cir) &
                        &                + dble(tmpur(cir)) &
                        &                 *ddtheta_R(cqaa,cir) /grho
                endif
             end do
          endif
#else
          dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(cqaa,:)
          if ( .not. grad_rho_eq_0 ) then
             dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(cqaa,:)
          endif
#endif

          if ( iprixc >= 2 ) then
             do cir = 1,nabc
                esum = esum +dble(tmpur(cir)) *theta_R(cir)
             end do
          endif
       endif
    enddo

    if(.not.oneshot)then
       if(npes>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             nabc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             nabc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif

    if ( iprixc >=2 ) then
       esum = esum *univol *rinplw /2.0d0
       call mpi_allreduce(MPI_IN_PLACE,Esum,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       write(nfout,*) "vdw nonolocal E12 "
       write(nfout,*) "evaluation in real       space : ", esum
       write(nfout,*) "           in reciprocal space : ", ecnl_12
    endif

    if(npes>1)then
       deallocate(ista)
       deallocate(theta_buf_r)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine vdWdf_core

  subroutine vdWdf_core2()
    use progress_bar
    real(kind=DP) :: fac
    integer :: cqbb,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r
    real(kind=DP), allocatable, dimension(:,:) :: dtheta_buf
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1
    integer :: id_sname2 = -1

    call tstatc0_begin('vdWdf_core2 ',id_sname,1)
    Ecnl_12 = 0.0d0
    if(printable.and.lprog) &
         & write(nfout,'(a)') 'performing the core operation : Ecnl = sum theta_a x phi_ab x theta_b ...'
    if(lprog)then
       call reset_progress()
       call set_end(int(floor(dble(nq0)/dble(npes))))
    endif
    if(npes>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nabc));theta_buf_r=(0.d0,0.d0)
       if(.not.oneshot)then
          allocate(dtheta_buf(mp_nq,nabc));dtheta_buf=0.d0
       endif
    endif
    if(.not.oneshot)then
       allocate(tmpug(nabc));tmpug=0.d0
       allocate(tmpur(nabc));tmpur=0.d0
       !       ualpha_g = (0.d0,0.d0)
    else
       allocate(tmpug(1))
    endif
    if(.not.oneshot)then
       dFdrho=0.d0;dFddrho=0.d0
    endif

    irecv = mype+1
    if(irecv.ge.npes) irecv = irecv-npes
    isend = mype-1
    if(isend.lt.0)    isend = isend+npes

    if (npes>1) theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
    do i0=0,npes-1
       ipos = i0+mype
       if(ipos.ge.npes) ipos = ipos-npes
       if(ipos.lt.0)    ipos = ipos+npes
       do i1=1,nel_nq(ipos)
          cqa = real_index(i1,ipos)
          if(npes>1)then
             theta_G_a(:) = theta_buf_r(i1,:)
          else
             theta_G_a(:) = theta_G_ab(i1,:)
          endif
          do cqbb=1,np_nq
             theta_G_b(:) = theta_G_ab(cqbb,:)
             fac = 1.d0
             cqb = real_index(cqbb)
             if(eval_kernel_by_interpolation) then
                call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
             else
                Call phiab(cqa,cqb,nr12,phi_ab)
             endif
             Call convolution_3d_by_fft(&
                  &    na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)
             Ecnl_12 = Ecnl_12 + Ecnl_12_ab
          enddo
          if(.not.oneshot)then
             !             call mpi_allreduce(MPI_IN_PLACE,tmpug,na*nb*nc,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
             call GtoR(na,nb,nc,tmpur,tmpug)
             dFdrho(:) = dFdrho(:) + dble(tmpur(:))*dtheta_R(i1,:)
             dFddrho(:) = dFddrho(:) + dble(tmpur(:))*ddtheta_R(i1,:)
          endif
       enddo
       if(npes>1)then
          call tstatc0_begin('vdWdf_core (comm) ',id_sname2,1)
          allocate(theta_buf_s(1:mp_nq,-(nabc/2-1):nabc/2))
          theta_buf_s = theta_buf_r
          call mpi_sendrecv(theta_buf_s,mp_nq*na*nb*nc,mpi_double_complex,isend,0, &
               &             theta_buf_r,mp_nq*na*nb*nc,mpi_double_complex,irecv,0, &
               &             mpi_comm_group,ista,ierr)
          if(.not.oneshot)then
             dtheta_buf = dtheta_R
             call mpi_sendrecv(dtheta_buf,mp_nq*na*nb*nc,mpi_double_precision,isend,0, &
                  &            dtheta_R,  mp_nq*na*nb*nc,mpi_double_precision,irecv,0, &
                  &            mpi_comm_group,ista,ierr)
             dtheta_buf = ddtheta_R
             call mpi_sendrecv(dtheta_buf,mp_nq*na*nb*nc,mpi_double_precision,isend,0, &
                  &            ddtheta_R, mp_nq*na*nb*nc,mpi_double_precision,irecv,0, &
                  &            mpi_comm_group,ista,ierr)
          endif
          deallocate(theta_buf_s)
          call tstatc0_end(id_sname2)
       endif
    enddo

    if(.not.oneshot)then
       if(npes>1) then
          call mpi_allreduce(MPI_IN_PLACE,dFdrho, &
               &             na*nb*nc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          call mpi_allreduce(MPI_IN_PLACE,dFddrho, &
               &             na*nb*nc,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          deallocate(tmpur)
       endif
       deallocate(tmpug)
    endif

    if(npes>1) then
       call mpi_allreduce(MPI_IN_PLACE,Ecnl_12,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    endif
    if(npes>1)then
       deallocate(ista)
       deallocate(theta_buf_r)
       if(.not.oneshot) deallocate(dtheta_buf)
    endif
    if(printable.and.lprog) write(nfout,'(a)') '... done'
    call tstatc0_end(id_sname)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  end subroutine vdWdf_core2

  subroutine corrections()
!!$if(printable) write(nfout,'(a)') 'calculating correction terms and contribution from the LDA ...'
    if(printable.and.lprog) write(nfout,'(a)') 'calculating correction terms ...'
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    Call piDphi(Ecnl_3,Ecnl_3s)
!!$    Call cLDA(na,nb,nc,rho,rhomin,dv,EcLDA)
    !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    if(printable.and.lprog) write(nfout,'(a)') '... done'
  end subroutine corrections

  subroutine theta_ab(nxyz,ca,nq0,q0min,q0max,rho,grad,rhomin,theta_R,dtheta_R,ddtheta_R)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer, intent(in) :: nxyz,ca,nq0
    Real(kind=DP), intent(in)  :: q0min,q0max,rhomin
    Real(kind=DP), intent(in)  :: rho(nxyz),grad(nxyz)
    real(kind=DP), intent(out) :: theta_R(nxyz),dtheta_R(nxyz),ddtheta_R(nxyz)

    ! Internal valuables
    Integer cir
    Real(kind=DP) ni,dni,q0,dqdn,dqddn

    real(kind=DP),allocatable,dimension(:) :: y,y2tmp
    real(kind=DP) :: yout,y1out
    integer :: id_sname = -1

    call tstatc0_begin('theta_ab ',id_sname,1)
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    allocate(y(nq0));y=0.d0;y(ca)=1.d0
    allocate(y2tmp(nq0));y2tmp(:) = q2ar(ca,:)
    ! For the functions theta_R
    Do cir = 1,nxyz
       q0 = q0max
       ni = MAX(rho(cir),rhomin)
       dni = grad(cir)
       Call d_q0(ni,dni,q0min,q0max,q0,dqdn,dqddn)

       call cubic_spline(nq0,qar,y,y2tmp,q0,yout,y1out)
       theta_R  (cir) = yout*ni
       if(.not.oneshot)then
          dtheta_R (cir) = yout+ni*y1out*dqdn
          ddtheta_R(cir) = ni*y1out*dqddn
       endif
! ----
       if ( sw_use_WuGygi_method == ON ) then
          theta_R(cir) = theta_R(cir) *qar(ca) /q0
          if ( .not. oneshot ) then
             dtheta_R(cir) = dtheta_R(cir) *qar(ca) /q0 &
                  &                -theta_R(cir) *dqdn /q0
             ddtheta_R(cir) = ddtheta_R(cir) *qar(ca) /q0 &
                  &                -theta_R(cir) *dqddn /q0
          endif
       endif
! ----
    End do
    deallocate(y);   deallocate(y2tmp)
    call tstatc0_end(id_sname)
  end subroutine theta_ab

  !** SUBROUTINE piDphi **********************************************************************************
  Subroutine piDphi(Ecii,Ecii_s)
    implicit none


    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(out) :: Ecii,Ecii_s

    Real(kind=DP) da,db,a1,a2,dr
    Parameter (dr = 0.001d0)
    Integer  ci,cj,ck,ca,cb

    ! Gauss-Legendre integration
    Integer cD,nD
    Parameter (nD=10)
    Real(kind=DP) maxD,minD,dD,LD,PLD,LDxi(nD),LDwi(nD)
    Parameter (minD=0.d0)

    Integer  cix,ciy,ciz,cir,cjx,cjy,cjz,cjr
    Real(kind=DP)  di,dj,dk,d_di,d_dj,d_dk,eta,dx,dy,dz,n,ni,nj,nk
    Integer  i,j,k,zxp,zxm,zyp,zym,zzp,zzm
    Parameter (eta=0.00000001)

    Real(kind=DP) x,nnx,nny,nnz,nn2,r
    Real(kind=DP) nxp,nxm,nyp,nym,nzp,nzm
    Real(kind=DP) zx(-3:3),zy(-3:3),zz(-3:3),rn(3,-3:3)

    Real(kind=DP) phi

    Real(kind=DP) temp,rs,phid_s,phid_s1,d_phid_s,phi2,phi4

    ! The table of phi1D
    Integer c1D,n1D,ierr
    Parameter(n1D = 1000)
    Real(kind=DP) d1D,max1D,D,phix,phiy
    Real(kind=DP) phi1D(0:n1D+1)
    real(kind=DP) :: q0,dqdn,dqddn
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    ! Make the table of phi1D
    max1D = ds
    d1D = max1D/DBLE(n1D)
    Do c1D = 0,n1D+1
       D = DBLE(c1D)*d1D
       Call kernel_phi(D,D,phi)
       phi1D(c1D) = phi
    Enddo


    Ecii = 0
    Do cjr = 1,nabc
       if(mod(cjr,npes)/=mype) cycle
       cjx = 1+(cjr-1-MOD(cjr-1+nb*nc,nb*nc))/(nb*nc)
       cjy = 1+(cjr-nb*nc*(cjx-1)-1-MOD(cjr-1+nc,nc))/nc
       cjz = cjr-nc*(nb*(cjx-1)-1+cjy)

       n = MAX(rho(cjr),rhomin)

       Call d_q0(n,grad(cjr),q0min,q0max,q0,dqdn,dqddn)
       maxD=ds

       Call gauleg(minD,maxD,nD,LDxi,LDwi)

       temp = 0.d0
       Do cD=1,nD
          LD = LDxi(cD)

          c1D = DINT(LD/d1D)
          phix = (LD - d1D*DBLE(c1D))/d1D
          phiy = 1.d0 - phix
          temp = temp + LDwi(cD)*4.d0*pi*(LD**2) * (phiy*phi1D(c1D) + phix*phi1D(c1D+1))

       Enddo
       Ecii = Ecii + dv*0.5d0*(n**2)*temp/(q0**3)
    Enddo
    if(npes>1) call mpi_allreduce(MPI_IN_PLACE,Ecii,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

    Ecii_s = 0.d0
    Do cjr = 1,nabc
       if(mod(cjr,npes)/=mype) cycle

       n = MAX(rho(cjr),rhomin)

       Call d_q0(n,grad(cjr),q0min,q0max,q0,dqdn,dqddn)
       rs = ds/DSQRT(q0**2+q0**2)
       di = q0*rs
       dk = q0*rs
       c1D = DINT(di/d1D)
       phix = (di - d1D*DBLE(c1D))/d1D
       phiy = 1.d0 - phix
       phid_s = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

       di = q0*(rs+dr)
       dk = q0*(rs+dr)
       c1D = DINT(di/d1D)
       phix = (di - d1D*DBLE(c1D))/d1D
       phiy = 1.d0 - phix
       phid_s1 = phiy*phi1D(c1D) + phix*phi1D(c1D+1)

       d_phid_s = (phid_s1- phid_s)/dr

       phi2 = ( 2.d0/ds**2)*(phid_s-phi0) - (rs/(2.d0*ds**2))*d_phid_s
       phi4 = (-1.d0/ds**4)*(phid_s-phi0) + (rs/(2.d0*ds**4))*d_phid_s

       Ecii_s = Ecii_s + 0.5d0*4.d0*pi*dv*(n**2)*            &
            &                    (phi0*(rs**3)*(q0**0)/3.d0 +            &
            &                     phi2*(rs**5)*(q0**2)/5.d0 +            &
            &                     phi4*(rs**7)*(q0**4)/7.d0)


    Enddo
    if(npes>1) call mpi_allreduce(MPI_IN_PLACE,Ecii_s,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
  End Subroutine piDphi
  !** End SUBROUTINE piDphi **********************

  !** SUBROUTINE cLDA ****************************
  Subroutine cLDA(na,nb,nc,rho,rhomin,dv,EcLDA)
    Implicit none

    !************************ Note *********************************
    ! This Algorism follows Dion's 1-shot method.
    !
    ! This program is a subroutine.
    ! This program calculates the correlation energy from LDA.
    ! The formula is given at Eq.(58) (p.93) of 'Theory of the
    !   Inhomogeneous Electron Gas' Lundqvist, March.
    !
    !
    ! Input
    !   rho(nrxyz,nsipn) : Total density
    !
    ! Output
    !   EcLDA : Correlation energy from LDA.
    !
    !
    !                            Written by Youky Ono in 2009/Jul.
    !***************************************************************

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    integer,intent(in)  :: na,nb,nc
    real(kind=DP),intent(in)  :: rho(nabc)
    real(kind=DP),intent(in)  :: rhomin
    real(kind=DP),intent(in)  :: dv
    real(kind=DP),intent(out) :: EcLDA
    integer  cjx,cjy,cjz,cjr,ierr
    integer  i,j,k

    real(kind=DP) rs,x,aB,ec,n
    parameter (aB=1.d0) ! aB=1[a.u.]

    real(kind=DP)  e,m
    parameter (e=1.d0,m=1.d0) ! Hatree atomic unit
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++

    !---------------------- Calculation Start ----------------------
    EcLDA=0
    Do cjr = 1,nabc
       if(mod(cjr,npes)/=mype) cycle
       n = MAX(rho(cjr),rhomin)

       rs = ((3.d0/(4.d0*pi*n))**(1.d0/3.d0))/aB
       x = rs/11.4d0
       ec = -0.0666d0*0.5d0*((1.d0+x**3)*DLOG(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)

       EcLDA = EcLDA + dv*n*ec
    Enddo
    if(npes>1) call mpi_allreduce(MPI_IN_PLACE,EcLDA,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
  End Subroutine cLDA
  !** End SUBROUTINE cLDA **********************

  ! Execute FFT and transform theta_R to theta_G
  Subroutine RtoG(na,nb,nc,theta_R,theta_G)
    Implicit none

    !!include "fftw3.f"


    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer, intent(in) ::   na,nb,nc
    Integer :: cir
    Real(kind=DP) rx,ry,rz,kx,ky,kz,ra,rb,rc,ka,kb,kc,rk,r12,x,y,z,term,term1

    integer :: ca,cb,cc,cix,ciy,ciz
    Real(kind=DP) theta_R(nabc)
    Complex(kind=DP) theta_G(nabc)

    ! FFTW3 !!!
    integer(kind=DP) :: plan
    Complex(kind=DP),allocatable :: temp_R(:),temp_G(:)

    real(kind=DP), allocatable, dimension(:) :: afft
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    allocate(temp_R(nabc))
    allocate(temp_G(nabc))
    !***** FFT **************************************************
    temp_R(:) = DCMPLX(theta_R(:))

    allocate(afft(nfftp_nonpara));afft=0.d0
    call map_rho_to_afft(temp_R,afft)
    call m_FFT_CD0(nfout,afft,DIRECT)
    call map_afft_to_rho(afft,temp_G)

    ! FFTW3 !!!
!    call dfftw_plan_dft_3d(plan,na,nb,nc,temp_R(1),temp_G(1),FFTW_FORWARD,FFTW_ESTIMATE)
!    call dfftw_execute(plan)
!    call dfftw_destroy_plan(plan)
    do ca = -(na/2-1),na/2
       do cb = -(nb/2-1),nb/2
          do cc = -(nc/2-1),nc/2
             cix = MOD(ca+na,na)+1
             ciy = MOD(cb+nb,nb)+1
             ciz = MOD(cc+nc,nc)+1
             theta_G(get_index_1D(ca+na/2,cb+nb/2,cc+nc/2)) = temp_G(get_index_1D(cix,ciy,ciz)) / DBLE(nabc)
          enddo
       enddo
    enddo
    !***** END of FFT ******************************************

    deallocate(temp_R);   deallocate(temp_G)
    deallocate(afft)
  End subroutine RtoG
  !** End SUBROUTINE RtoG ***********************************************************************

  subroutine GtoR(na,nb,nc,theta_R,theta_G)
    !    include "fftw3.f"
    integer,intent(in) :: na,nb,nc
    complex(kind=DP), dimension(nabc), intent(in) :: theta_G
    complex(kind=DP), dimension(nabc), intent(out) :: theta_R

    integer :: cir,ca,cb,cc,cix,ciy,ciz
    integer(kind=DP) :: plan
    complex(kind=DP),allocatable :: temp_R(:),temp_G(:)
    real(kind=DP),allocatable,dimension(:) :: afft
    integer :: id_sname=-1
    call tstatc0_begin('GtoR ',id_sname,1)

!    allocate(temp_R(nabc))
    allocate(temp_G(nabc))
    Do ca = -(na/2-1),na/2
       Do cb = -(nb/2-1),nb/2
          Do cc = -(nc/2-1),nc/2
             cix = MOD(ca+na,na)+1
             ciy = MOD(cb+nb,nb)+1
             ciz = MOD(cc+nc,nc)+1
             temp_G(get_index_1D(cix,ciy,ciz)) = theta_G(get_index_1D(ca+na/2,cb+nb/2,cc+nc/2))
          Enddo
       Enddo
    Enddo
    allocate(afft(nfftp_nonpara));afft = 0.d0
    call map_rhog_to_afft(temp_G,afft)
    call m_FFT_CD0(nfout,afft,INVERSE)
    call map_afft_to_rhog(afft,theta_R)

    ! FFTW3 !!!
!    call dfftw_plan_dft_3d(plan,na,nb,nc,temp_G(1),temp_R(1),FFTW_BACKWARD,FFTW_ESTIMATE)
!    call dfftw_execute(plan)
!    call dfftw_destroy_plan(plan)
    !***** END of FFT ******************************************

    !    theta_R = temp_R/dble(na*nb*nc)
!    theta_R = temp_R

!    deallocate(temp_R)
    deallocate(temp_G)
    deallocate(afft)
    call tstatc0_end(id_sname)
  end subroutine GtoR

  subroutine get_phi_ab_g(nr12,phi_ab,phi_ab_g)
    !    include "fftw3.f"
    integer, intent(in) :: nr12
    real(kind=DP), dimension(0:nr12), intent(in)  :: phi_ab
    real(kind=DP), dimension(0:nr12), intent(out) :: phi_ab_g
    complex(kind=DP), allocatable, dimension(:) :: cphiab_r
    complex(kind=DP), allocatable, dimension(:) :: cphiab_g
    integer :: cr,ck
    integer(kind=DP) :: plan
    real(kind=DP) :: dd,r12,term,rk
    real(kind=DP) :: rr
    complex(kind=DP) :: zsum
    complex(kind=DP), parameter :: zi = ( 0.0d0, 1.0d0 )

    integer :: id_sname = -1
    call tstatc0_begin('get_phi_ab_g ',id_sname,1)
    allocate(cphiab_r(0:nr12));cphiab_r=0.d0
    allocate(cphiab_g(0:nr12));cphiab_g=0.d0

    dd = r12max/dble(nr12)

    do cr=0,nr12
       rr = dble(cr) *dd
       cphiab_r(cr) = dcmplx( phi_ab(cr)*rr, 0.d0 )
    enddo

#if 0
    call dfftw_plan_dft_1d(plan,nr12+1,cphiab_r,cphiab_g,FFTW_BACKWARD,FFTW_ESTIMATE)
#else
    call dfftw_plan_dft_1d( plan, nr12, cphiab_r(0:nr12-1), cphiab_g(0:nr12-1), &
         &                  FFTW_BACKWARD, FFTW_ESTIMATE )
#endif
    call dfftw_execute(plan)
    call dfftw_destroy_plan(plan)

    do ck=1,nr12
       rk = dble(ck)/r12max
       phi_ab_g(ck) = 2.d0 *dd *dimag(cphiab_g(ck))/(dble(rk))
    enddo

    Do ck = 0,0
       rk = dd * dble(ck)
       term = 0.0d0
       Do cr = 0,nr12
          r12 = dd*dble(cr)
          term = term + phi_ab(cr) * (r12**2)
       Enddo
       phi_ab_g(ck) = 4.0d0*pi*dd * term
    End do

    deallocate(cphiab_r);   deallocate(cphiab_g)

    phi_ab_g = phi_ab_g / univol

    call tstatc0_end(id_sname)

  end Subroutine get_phi_ab_g

! ===============- For stress tensor =================
  subroutine initialize_vdwdf_stress( nspin, ispin, na, nb, nc, chgr, &
       &                              grad_rho, cgrad_rho, version_no )
    use progress_bar, only : set_printable

    integer, intent(in) :: nspin,ispin,na,nb,nc, version_no
    real(kind=DP), intent(in) :: chgr(na*nb*nc), grad_rho(na*nb*nc)
    real(kind=DP), intent(in) :: cgrad_rho(na*nb*nc,3)

    integer :: i,cir,cix,ciy,ciz,nrxyz,cir2
    real(kind=DP) :: q

    if ( version_no == 1 ) then
       Zab = Zab_0
    else if ( version_no == 2 ) then
       Zab = Zab_0 *2.222d0
    endif

    call set_printable(printable)
    call do_cell_params()

    rinplw = 1.d0/(dble(nabc))
    q0max = q0cut*1.01d0
!!!    q0min = 0.09d0
    nq0 = DINT(dLOG((q0max-q0min)*(lambda-1.d0)/dq_vdw+1.d0)/dLOG(lambda))+1
    maxk = dble(nr12)/r12max

    if(firstcall) call m_Parallel_init_mpi_nq(nfout,ipri,printable,nq0)
    if(firstcall) call print_vdw_parameters()

    call alloc_vdw()
    allocate( cgrad(na*nb*nc,3)); cgrad=0.d0

    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             rho(cir2) = chgr(cir)
             grad(cir2) = grad_rho(cir)
             cgrad(cir2,1:3) = cgrad_rho(cir,1:3)
          enddo
       enddo
    enddo

    if ( grad_rho_eq_0 )  grad = 0.0d0

    do i=1,nq0
       q = q0min + dq_vdw*(lambda**DBLE(i-1)-1.d0)/(lambda-1.d0)
       qar(i) = q
    enddo
    call spline0(nq0,qar,q2ar)

    if(eval_kernel_by_interpolation.and.firstcall) &
         &             call build_lookup_table(ndel,nphiD,phidD)
    firstcall = .false.
  end subroutine initialize_vdwdf_stress

  subroutine calc_stress_contrib2( na, nb, nc, cqa, cqb, nr12, phi_ab, &
       &                           theta_G_a, theta_G_b, fac, s_tensor, tmpug )
    Implicit none

    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
    complex(kind=DP), intent(in)  :: theta_G_a(nabc)
    complex(kind=DP), intent(in)  :: theta_G_b(nabc)
    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
    real(kind=DP),    intent(in)  :: fac
    real(kind=DP), intent(inout) :: s_tensor(3,3)
    complex(kind=DP), intent(inout) :: tmpug(nabc)

    Integer  i, u, v
    Integer cir,cix,ciy,ciz,cr,ck

    Real(kind=DP) phix, phiy, Ta, Tb, Tc, bb(3,3), vec(3)
    Real(kind=DP) dk,rk,r12,term1, term2
    real(kind=DP) :: pi2rk, g1

    Real(kind=DP),allocatable :: core_G1(:), core_G2(:)
    Real(kind=DP),allocatable :: wk_x(:), wk_y(:)
    real(kind=DP) :: ctmp, z1

    integer :: id_sname = -1

    call tstatc0_begin('calc_stress_contrib2 ',id_sname,1)

    allocate(core_G1(0:nr12)); core_G1 = 0.d0
    allocate(core_G2(0:nr12)); core_G2 = 0.d0

    call get_phi_ab_g( nr12, phi_ab, core_G1 )

! ----
    dk = 1.0d0 /r12max

!    Do i=1, nr12 -1
!       z1 = ( core_G1(i) -core_G1(i-1) ) /dk
!       z2 = ( core_G1(i+1) -core_G1(i) ) /dk
!       core_G2(i) = ( z1 +z2 )/2.0d0
!    End Do

    allocate( wk_x(0:nr12) );     allocate( wk_y(0:nr12) )
    Do i=0, nr12
       wk_x(i) = dk *i
    End Do
    call init_cubic_spline( nr12+1, wk_x(0:nr12), core_G1(0:nr12), wk_y(0:nr12) )

    Do i=0, nr12
       call cubic_spline( nr12+1, wk_x(0:nr12), core_G1(0:nr12), wk_y(0:nr12), &
            &             wk_x(i), ctmp, core_G2(i) )
    End Do
    deallocate( wk_x ); deallocate( wk_y )

! ----
    s_tensor = 0.0d0

    Do i=1, 3
       bb(1,i) = rltv(i,1) /PAI /2.0d0
       bb(2,i) = rltv(i,2) /PAI /2.0d0
       bb(3,i) = rltv(i,3) /PAI /2.0d0
    End Do

    Do ciz = -(nc/2-1),nc/2
       Do ciy = -(nb/2-1),nb/2
          Do cix = -(na/2-1),na/2
             cir = get_index_1D(cix+na/2,ciy+nb/2,ciz+nc/2)
             rk   = rkar(cir)
             ck   = dint(rk/dk)
             phix = (rk - dk*DBLE(ck))/dk
             phiy = 1.0d0 - phix

             term1 = phiy*core_G1(ck) + phix*core_G1(ck+1)
             term2 = phiy*core_G2(ck) + phix*core_G2(ck+1)

             vec(1:3) = dble(cix) *bb(1,1:3) &
                  &    +dble(ciy) *bb(2,1:3) &
                  &    +dble(ciz) *bb(3,1:3)

             if ( ck > 0 ) then
                z1 = DCONJG( theta_G_a(cir) ) *theta_G_b(cir)  & 
                     &                                *term2 /rkar(cir)
                Do v=1, 3
                   Do u=1, 3
                      s_tensor(u,v) = s_tensor(u,v) +z1 *vec(u) *vec(v)
                   End Do
                End Do
             endif
             tmpug(cir) = tmpug(cir) &
                  &              +theta_G_b(cir) *term1 *univol
          Enddo
       Enddo
    Enddo

    s_tensor = s_tensor *univol

    deallocate(core_G1);    deallocate(core_G2)
    call tstatc0_end(id_sname)

  end subroutine calc_stress_contrib2

  subroutine vdWdf_stress_tensor_core()
    use progress_bar

    real(kind=DP) :: fac
    integer :: cqaa,cqa,cqb,ierr
    integer :: i,ic,i2,i3
    complex(kind=DP), allocatable, dimension(:) :: tmpug,tmpur
    complex(kind=DP), allocatable, dimension(:,:) :: theta_buf_s,theta_buf_r

    real(kind=DP) :: s_tmp(3,3), grho, rtmp

    integer :: u, v, cix, ciy, ciz,cir
    integer :: ipos,i0,i1,isend,irecv,ireq,ireqr
    integer, allocatable, dimension(:) :: ista
    integer :: id_sname = -1
    integer :: id_sname2 = -1
    integer :: id_sname3 = -1

    call tstatc0_begin('vdWdf_stres_core ',id_sname,1)

    s_cnl1 = 0.0d0;  s_cnl2 = 0.0d0

    if(npes>1)then
       allocate(ista(MPI_STATUS_SIZE))
       allocate(theta_buf_r(1:mp_nq,nabc));
       theta_buf_r=(0.d0,0.d0)
    endif

    allocate(tmpug(nabc));tmpug=0.d0
    allocate(tmpur(nabc));tmpur=0.d0
    dFdrho=0.d0;dFddrho=0.d0

    irecv = mype+1
    if(irecv.ge.npes) irecv = irecv-npes
    isend = mype-1
    if(isend.lt.0)    isend = isend+npes

    do cqaa=1,mp_nq
       cqa = real_index(cqaa)
       if (npes>1)        theta_buf_r(1:np_nq,:) = theta_G_ab(1:np_nq,:)
       if (cqaa.le.np_nq) theta_G_a(:) = theta_G_ab(cqaa,:)

       if (.not.oneshot)  tmpug=(0.d0,0.d0)

       call tstatc0_begin('vdw_stress_core_core ',id_sname3,1)

       do i0=0,npes-1
          ipos = i0+mype
          if(ipos.ge.npes) ipos = ipos-npes
          if(ipos.lt.0)    ipos = ipos+npes

          if(cqaa.le.np_nq)then
             do i1=1,nel_nq(ipos)
                cqb = real_index(i1,ipos)
                if(npes>1)then
                   theta_G_b(:) = theta_buf_r(i1,:)
                else
                   theta_G_b(:) = theta_G_ab(i1,:)
                endif
                fac = 1.d0
                if(eval_kernel_by_interpolation) then
                  call phiab_by_interpl(cqa,cqb,nr12,phi_ab)
                else
                  Call phiab(cqa,cqb,nr12,phi_ab)
                endif
                Call calc_stress_contrib2( na, nb, nc, cqa, cqb, nr12, phi_ab, &
                     &                     theta_G_a, theta_G_b, fac, s_tmp, &
                     &                     tmpug )
                s_cnl2 = s_cnl2 +s_tmp
             enddo
          endif
          if(npes>1.and.i0.ne.npes-1)then
             call tstatc0_begin('vdWdf_stress_core (comm) ',id_sname2,1)
             allocate(theta_buf_s(1:mp_nq,nabc))
             theta_buf_s = theta_buf_r
             call mpi_sendrecv(theta_buf_s,mp_nq*na*nb*nc,mpi_double_complex,isend,0, &
                 &             theta_buf_r,mp_nq*na*nb*nc,mpi_double_complex,irecv,0, &
                 &             mpi_comm_group,ista,ierr)
             deallocate(theta_buf_s)
             call tstatc0_end(id_sname2)
          endif
       enddo
       call tstatc0_end(id_sname3)

       if(.not.oneshot.and.cqaa.le.np_nq)then
          call GtoR(na,nb,nc,tmpur,tmpug)

          s_tmp = 0.0d0
          Do v=1, 3
             Do u=1, 3
                Do cir = 1,nabc
                   grho = grad(cir)
                   rtmp = rho(cir)
!                         if ( rtmp > 1.0d-6 .and. grho > 1.0d-6 ) then
                   if ( grho > 1.0d-6 ) then
                      s_tmp(u,v) = s_tmp(u,v) &
                           &      +dble(tmpur(cir)) &
                           &       *ddtheta_R(cqaa,cir) &
                           &       *cgrad(cir,u) &
                           &       *cgrad(cir,v) /grad(cir)
                   endif
                End Do
             End Do
          End Do
          s_cnl1(:,:) = s_cnl1(:,:) +s_tmp(:,:)
       endif
    enddo

    if(npes>1) then
       call mpi_allreduce( MPI_IN_PLACE, s_cnl1, 3*3, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       call mpi_allreduce( MPI_IN_PLACE, s_cnl2, 3*3, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       deallocate(tmpur)
    endif
    deallocate(tmpug)

    if(npes>1)then
       deallocate(ista);    deallocate(theta_buf_r)
    endif

    s_cnl1 = s_cnl1 *( univol *rinplw ) /univol
    s_cnl2 = s_cnl2 /2.0d0

    call tstatc0_end(id_sname)

  end subroutine vdWdf_stress_tensor_core
! ==== end for stress

  Subroutine convolution_3d_by_fft(na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,fac,Ecnl_12_ab,tmpug)

    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
    complex(kind=DP), intent(in)  :: theta_G_a(nabc)
    complex(kind=DP), intent(in)  :: theta_G_b(nabc)
    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
    real(kind=DP),    intent(in)  :: fac
    real(kind=DP),    intent(out) :: Ecnl_12_ab
    complex(kind=DP), intent(inout) :: tmpug(nabc)
    complex(kind=DP) temp_c

    Real(kind=DP)  phix,phiy,Ta,Tb,Tc

    Integer cir,ck
    Real(kind=DP) dk,rk,r12,term

    Real(kind=DP),allocatable :: core_G(:)

    real*8 :: dd

    real(kind=DP) :: pi2rk
    integer :: id_sname = -1

    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
    call tstatc0_begin('convolution_3d_by_fft ',id_sname,1)
    allocate(core_G(0:nr12));core_G=0.d0

    !      dd = r12max/dble(nr12)

    call get_phi_ab_g(nr12,phi_ab,core_G)

    dk = 1.d0/r12max
    temp_c = (0.0d0,0.0d0)
    !tmpug = 0.d0

    if(oneshot)then
       do cir = 1,nabc
          rk   = rkar(cir)
          ck   = dint(rk/dk)

          phix = (rk - dk*DBLE(ck))/dk
          phiy = 1.0d0 -phix
          term = phiy*core_G(ck) + phix*core_G(ck+1)

          temp_c = temp_c + term *DCONJG(theta_G_a(cir))   &
               &          *              theta_G_b(cir)
       enddo
    else
       do cir = 1,nabc
          rk   = rkar(cir)
          ck   = dint(rk/dk)

          phix = (rk - dk*DBLE(ck))/dk
          phiy = 1.0d0 - phix
          term = phiy*core_G(ck) + phix*core_G(ck+1)

          temp_c = temp_c + term *DCONJG(theta_G_a(cir))   &
               &           *             theta_G_b(cir)

          tmpug(cir) = tmpug(cir) &
               &              +theta_G_b(cir)*term *univol
       enddo
    endif

    temp_c = temp_c * univol**2
    Ecnl_12_ab = 0.5d0*DBLE(temp_c)*fac

    !***** End Calculate 'theta_G_a*core_G*theta_G_b'  ***********

    deallocate(core_G)

    call tstatc0_end(id_sname)

  End subroutine convolution_3d_by_fft
  !** End SUBROUTINE convolution_3d *************************************************************

!  Subroutine convolution_3d(na,nb,nc,cqa,cqb,nr12,phi_ab,theta_G_a,theta_G_b,Ecnl_12_ab)
!
!    Implicit none
!
!    !    include "fftw3.f"
!
!    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
!    integer, intent(in) :: na,nb,nc,cqa,cqb,nr12
!    complex(kind=DP), intent(in)  :: theta_G_a(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
!    complex(kind=DP), intent(in)  :: theta_G_b(-(na/2-1):na/2,-(nb/2-1):nb/2,-(nc/2-1):nc/2)
!    real(kind=DP),    intent(in)  :: phi_ab(0:nr12)
!    real(kind=DP),    intent(out) :: Ecnl_12_ab
!    real(kind=DP) :: dr12
!    complex(kind=DP) temp_c
!
!    Integer  nabc
!    Real(kind=DP)  phix,phiy,Ta,Tb,Tc
!
!    Integer cix,ciy,ciz,cr,ck
!    Real(kind=DP) dk,rk,r12,term
!
!    Real(kind=DP),allocatable :: core_G(:)
!    Real(kind=DP),allocatable :: phiab_r(:)
!
!    real(kind=DP) :: pi2rk
!    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++
!
!    allocate(core_G(0:nk-1))
!    allocate(phiab_r(0:nr12));phiab_r=0.d0
!    nabc = na*nb*nc
!
!    !    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
!    !&      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
!    !&      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))
!!
!    !    Ta = na*DSQRT(aa(1,1)**2 + aa(1,2)**2 + aa(1,3)**2)
!    !    Tb = nb*DSQRT(aa(2,1)**2 + aa(2,2)**2 + aa(2,3)**2)
!    !    Tc = nc*DSQRT(aa(3,1)**2 + aa(3,2)**2 + aa(3,3)**2)
!
!    !***** Make the core function and execute 3d-FFT by hand *****
!    dr12 = r12max/dble(nr12)
!    dk = maxk/dble(nk-1)
!
!    do cr=0,nr12
!       r12 = dr12*dble(cr)
!       phiab_r(cr) = phi_ab(cr)*r12
!    enddo
!
!    Do ck = 0,0
!       rk = dk * dble(ck)
!       term = 0
!       Do cr = 0,nr12
!          r12 = dr12*dble(cr)
!          term = term + phi_ab(cr) * (r12**2)
!       Enddo
!       core_G(ck) = 4.0d0*pi*dr12 * term
!    End do
!
!    Do ck = 1,nk-1
!       rk = dk * dble(ck)
!       pi2rk = 2.0*pi*rk
!       term = 0
!       Do cr = 0,nr12
!          r12 = dr12*dble(cr)
!          term = term + phiab_r(cr) * DSIN(pi2rk*r12)
!       Enddo
!       core_G(ck) = 2.d0 * dr12 * term / rk
!    End do
!    !***** END of Make the core function *************************
!
!    !    if(cqa==1)then
!    !       do ck=0,nr12
!    !          rk = dk * dble(ck)
!    !          write((cqa+1)*35+cqb,*) rk,core_G(ck)
!    !       enddo
!    !    endif
!    !***** Calculate 'theta_G_a*core_G*theta_G_b'  ***************
!    dk = maxk/dble(nk-1)
!    temp_c = (0.0,0.0)
!    Do cix = -(na/2-1),na/2
!       Do ciy = -(nb/2-1),nb/2
!          Do ciz = -(nc/2-1),nc/2
!
!             !rk = DSQRT((dble(cix)/Ta)**2 + (dble(ciy)/Tb)**2 + (dble(ciz)/Tc)**2)
!             rk = rkar(cix,ciy,ciz)
!             If(rk.LT.maxk) Then
!                ck = DINT(rk/dk)
!                phix = (rk - dk*DBLE(ck))/dk
!                phiy = 1.0 - phix
!                term = phiy*core_G(ck) + phix*core_G(ck+1)
!             Else
!                term = 0.0d0
!             Endif
!
!             temp_c = temp_c +                        &
!                  &             DCONJG(theta_G_a(cix,ciy,ciz)) *  &
!                  &                    theta_G_b(cix,ciy,ciz)  *  &
!                  &                  term
!          Enddo
!       Enddo
!    Enddo
!
!    temp_c = temp_c * dv*nabc
!    Ecnl_12_ab = 0.5d0*DBLE(temp_c)
!    !***** End Calculate 'theta_G_a*core_G*theta_G_b'  ***********
!
!    deallocate(core_G)
!    deallocate(phiab_r)
!
!
!  End subroutine convolution_3d
!  !** End SUBROUTINE convolution_3d *************************************************************

  Subroutine d_q0(n,dn,q0min,q0max,q0,dqdn,dqddn)
    Implicit None


    !************************ Note *********************************
    ! This program calculates q0.
    !
    ! Input
    !   rho(nrxyz,nsipn) : Total density
    !
    ! Output
    !   q0               : 
    !
    !
    !
    !                            Written by Youky Ono
    !***************************************************************



    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(in)  :: n,dn,q0min,q0max
    real(kind=DP), intent(out) :: q0,dqdn,dqddn
    Double Precision rs,x,nn2,r,term1,term2,term3,rnn2

!    Double precision  kF,exc0,exLDA,excLDA,Zab,m,h,e,GxcLDA,eta,dq
!    Parameter (Zab=-0.8491d0)

    Double precision  kF,exc0,exLDA,excLDA,m,h,e,GxcLDA,eta,dq
    Parameter (e=1.0d0,m=1.0d0)

    integer :: i
    real(kind=DP) :: s2,s,qq
    real(kind=DP) :: drsdn,dxdn,dexcdn,dsdn,dkFdn
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    nn2 = dn*dn
    rnn2 = dsqrt(nn2)
    rs = (3.d0/(4.d0*pi*n))**(1.d0/3.d0)

    ! Eq.(58), (59) (p.93-94) of Theory of the Inhomogeneous Electron gas.
    ! S.Lundqvist and N.H.March 1983 Plenum Press, NY
    x = rs/11.4d0
    GxcLDA = 0.5d0*((1.d0+x**3)*DLog(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)
    excLDA = -0.458d0/rs-0.0666d0*GxcLDA

    kF = (3.d0*pi*pi*n)**(1.d0/3.d0)

    s2 = nn2/((2.d0*kF*n)**2);s=dsqrt(s2)
    qq = -(4.d0*pi/3.d0)*excLDA-(Zab/9.d0)*s2*kF

    call hxxc(qq,q0max,q0,dq)
    q0 = max(q0,q0min)

    if(q0.eq.q0min)then
       dqdn = 0.d0;dqddn=0.d0
    else
#if 0
       drsdn  = -(3.d0/(4.d0*PAI))**(1.d0/3.d0)/3.d0*n**(-4.d0/3.d0)
       dxdn   = drsdn/11.4d0
       dexcdn = (0.458d0/(rs*rs))*drsdn &
            &   -0.0333d0*(3*x*x*dlog(1+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)*dxdn
       dkFdn  = (pi/kF)**2
!!!       dsdn   = -(rnn2/(4*kF*n*kF*n))*(dkFdn*n+kF)
       dsdn   = -(rnn2/(2*kF*n*kF*n))*(dkFdn*n+kF)
       dqdn   = -(4.d0*pi/3.d0)*dexcdn-(Zab/9.d0)*(2*s*dsdn*kF+s2*dkFdn)
       dqddn  = -(Zab/9.d0)*s/n

#else
       drsdn  = -rs /3.0d0 /n
       dxdn   = drsdn/11.4d0
       dexcdn = (0.458d0/(rs*rs))*drsdn &
            &   -0.0333d0*(3*x*x*dlog(1+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)*dxdn
       dkFdn  = kF /3.0d0 /n
       dsdn   = -s /(kF*n) *(dkFdn*n+kF)
       dqdn   = -(4.d0*pi/3.d0)*dexcdn-(Zab/9.d0)*(2*s*dsdn*kF+s2*dkFdn)
!       dqddn  = -(Zab/9.d0)*s2 *2.0 /dn *KF
       dqddn  = -(Zab/9.d0)*s/n
#endif
       dqdn   = dqdn*dq
       dqddn  = dqddn*dq
    endif
  End Subroutine d_q0
  !** End SUBROUTINE d_q0 ***********************************************************************

  subroutine hxxc(x,xc,hx,dhx)
    real(kind=DP), intent(in)  :: x,xc
    real(kind=DP), intent(out) :: hx,dhx
    integer :: i
    integer :: mc = 12
    real(kind=DP) :: summ,dsumm
    hx = 0.d0;dhx = 0.d0
    summ=0.d0;dsumm=0.d0
    do i=1,mc
       summ = summ+(x/xc)**i/dble(i)
       dsumm = dsumm+x**(i-1)/xc**i
    enddo
    hx = xc*(1.d0-dexp(-summ))
    dhx = xc*dexp(-summ)*dsumm
  end subroutine hxxc

  !** SUBROUTINE derivation *********************************************************************
  Subroutine derivation(na,nb,nc,aa,rho,dv,grad)
    Implicit none

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++

    ! The unit cell and the electron density information
    integer,intent(in) :: na,nb,nc
    real(kind=DP), intent(in) :: rho(nabc)
    Real(kind=DP), intent(in) :: aa(3,3)
    real(kind=DP), intent(in) :: dv
    real(kind=DP), intent(out) :: grad(nabc)

    ! Integers
    Integer i,j,k,cx,cy,cz,cr

    ! Internal valuables
    Integer zx(-3:3),zy(-3:3),zz(-3:3)
    Real(kind=DP) rn(3,-3:3),detr,bb(3,3)
    Real(kind=DP),allocatable ::  darho(:),dbrho(:),dcrho(:)
    real(kind=DP) :: dx,dy,dz
    !+++++++++++++++++++++ End VARIABLES +++++++++++++++++++++++++++

    allocate(darho(nabc));darho=0.d0
    allocate(dbrho(nabc));dbrho=0.d0
    allocate(dcrho(nabc));dcrho=0.d0
    !    dv = aa(1,1)*(aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2)) &
    !&      + aa(1,2)*(aa(2,3)*aa(3,1)-aa(2,1)*aa(3,3)) &
    !&      + aa(1,3)*(aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))


    Do cx = 1,na
       Do cy = 1,nb
          Do cz = 1,nc
             cr = get_index_1D(cx,cy,cz)
             Do j = -3,3
                zx(j) = MOD(2*na+(cx+j)-1,na)+1
                zy(j) = MOD(2*nb+(cy+j)-1,nb)+1
                zz(j) = MOD(2*nc+(cz+j)-1,nc)+1
                rn(1,j) = rho(get_index_1D(zx(j),cy,cz))
                rn(2,j) = rho(get_index_1D(cx,zy(j),cz))
                rn(3,j) = rho(get_index_1D(cx,cy,zz(j)))
             Enddo
             darho(cr) = (rn(1,3)-9.d0*rn(1,2)+45.d0*rn(1,1)-45.d0*rn(1,-1)+9.d0*rn(1,-2)-rn(1,-3))/(60.d0)
             dbrho(cr) = (rn(2,3)-9.d0*rn(2,2)+45.d0*rn(2,1)-45.d0*rn(2,-1)+9.d0*rn(2,-2)-rn(2,-3))/(60.d0)
             dcrho(cr) = (rn(3,3)-9.d0*rn(3,2)+45.d0*rn(3,1)-45.d0*rn(3,-1)+9.d0*rn(3,-2)-rn(3,-3))/(60.d0)
          Enddo
       Enddo
    Enddo

    detr = (aa(1,1)*aa(2,2)*aa(3,3)+aa(1,2)*aa(2,3)*aa(3,1)+aa(1,3)*aa(2,1)*aa(3,2)) &
         &- (aa(1,1)*aa(2,3)*aa(3,2)+aa(1,2)*aa(2,1)*aa(3,3)+aa(1,3)*aa(2,2)*aa(3,1))

    bb(1,1) =  (aa(2,2)*aa(3,3)-aa(2,3)*aa(3,2))/detr
    bb(2,1) = -(aa(2,1)*aa(3,3)-aa(2,3)*aa(3,1))/detr
    bb(3,1) =  (aa(2,1)*aa(3,2)-aa(2,2)*aa(3,1))/detr
    bb(1,2) = -(aa(1,2)*aa(3,3)-aa(1,3)*aa(3,2))/detr
    bb(2,2) =  (aa(1,1)*aa(3,3)-aa(1,3)*aa(3,1))/detr
    bb(3,2) = -(aa(1,1)*aa(3,2)-aa(1,2)*aa(3,1))/detr
    bb(1,3) =  (aa(1,2)*aa(2,3)-aa(1,3)*aa(2,2))/detr
    bb(2,3) = -(aa(1,1)*aa(2,3)-aa(1,3)*aa(2,1))/detr
    bb(3,3) =  (aa(1,1)*aa(2,2)-aa(1,2)*aa(2,1))/detr

    Do cr = 1,nabc
       dx = (bb(1,1)*darho(cr) + bb(1,2)*dbrho(cr) + bb(1,3)*dcrho(cr))
       dy = (bb(2,1)*darho(cr) + bb(2,2)*dbrho(cr) + bb(2,3)*dcrho(cr))
       dz = (bb(3,1)*darho(cr) + bb(3,2)*dbrho(cr) + bb(3,3)*dcrho(cr))
       grad(cr) = dsqrt(dx**2+dy**2+dz**2)
    Enddo

!    deallocate(darho)
!    deallocate(dbrho)
!    deallocate(dcrho)

  End subroutine derivation
  !** End SUBROUTINE derivation *****************************************************************

  subroutine spline0(nq0,x,y2)
    integer, intent(in) :: nq0
    real(kind=DP), intent(in),  dimension(nq0) :: x
    real(kind=DP), intent(out), dimension(nq0,nq0) :: y2
    real(kind=DP), allocatable,dimension(:) :: y,y2tmp
    integer :: i
    allocate(y(nq0));y=0.d0
    allocate(y2tmp(nq0));y2tmp=0.d0
    y2 = 0.d0
    do i=1,nq0
       y(:) = 0.d0;y(i) = 1.d0 
       call init_cubic_spline(nq0,x,y,y2tmp)
       y2(i,:) = y2tmp(:)
    enddo
    deallocate(y)
    deallocate(y2tmp)
  end subroutine spline0

  function hofy(num,denom) result(res)
    Implicit none
    real(kind=DP), intent(in) :: num,denom
    real(kind=DP) :: res
    real(kind=DP) :: gam=1.396263402d0 ! 4pi/9
    if(abs(denom)<epsilon(denom))then
       res = 1.d0
    else
       res = 1.d0-dexp(-gam*((num/denom)**2))
    endif
  end function hofy

  function Wab(a,b) result (res)
    Implicit none
    real(kind=DP), intent(in) :: a,b
    real(kind=DP) :: res
    res = 2.d0*((3.d0-a*a)*b*DCOS(b)*DSIN(a) + (3.d0-b*b)*a*DCOS(a)*DSIN(b) &
         &       + (a*a+b*b-3.d0)*DSIN(a)*DSIN(b) &
         &       - 3.d0*a*b*DCOS(a)*DCOS(b))/((a*b)**3)
  end function Wab

  function Twxyz(w,x,y,z) result (res)
    Implicit none
    real(kind=DP),intent(in) :: w,x,y,z
    real(kind=DP) :: res
    res = 0.5d0*(1.d0/(w+x)+1.d0/(y+z))*(1.d0/((w+y)*(x+z))+1.d0/((w+z)*(y+x)))
  end function Twxyz

  !** SUBROUTINE kernel_phi *********************************************************************
  Subroutine kernel_phi(di,dk,phi)
    implicit none

    !************************ Note *********************************
    ! This Algorism follows Dion's 1-shot method.
    !
    ! This program is a subroutine.
    ! This program calculates the kernel function phi.
    !
    ! Input
    !
    !
    ! Output
    !   phi              : 
    !                      
    !
    !
    !                            Written by Youky Ono in 2013/Jan.
    !***************************************************************



    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    real(kind=DP), intent(in)  :: di,dk
    real(kind=DP), intent(out) :: phi
    Integer ca,cb,nb
    Real(kind=DP) a,b,h,v1,v2,v3,v4,W,T
    Real(kind=DP) e,m
    parameter (e=1.d0,m=1.d0)
    real(kind=DP) :: dr


    ! Gauss-Legendre integration
    Real(kind=DP),allocatable, dimension(:) :: xi,wi
    Real(kind=DP) :: fac
    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++

    !---------------------- Calculation Start ----------------------
    ! Call gauleg for Gauss-Legendre integral
    allocate(xi(na_gl));xi=0.d0
    allocate(wi(na_gl));wi=0.d0
    Call gauleg(a1,a2,na_gl,xi,wi)

    phi = 0.d0
    Do ca=1,na_gl
       Do cb=1,ca
          fac=2.d0
          if(ca.eq.cb) fac=1.d0
          a = xi(ca)
          b = xi(cb)

          v1 = (a**2)/(2.d0*hofy(a,di))
          v2 = (b**2)/(2.d0*hofy(b,di))
          v3 = (a**2)/(2.d0*hofy(a,dk))
          v4 = (b**2)/(2.d0*hofy(b,dk))
          phi = phi + fac*wi(ca)*wi(cb)*(a*a*b*b)*Wab(a,b)*Twxyz(v1,v2,v3,v4)
       End Do
    End Do

    phi = phi * 2.d0 *m *(e**4)/(pi**2)
    deallocate(xi)
    deallocate(wi)
  end Subroutine kernel_phi
  !** End SUBROUTINE kernel_phi *****************************************************************

  !** SUBROUTINE gauleg **********************************************************************************
  Subroutine gauleg(x1,x2,n,xi,wi)
    Implicit none
    real(kind=DP), intent(in) :: x1,x2
    integer, intent(in) :: n
    real(kind=DP), intent(out)  ::  xi(n),wi(n)

    !++++++++++++++++++++++++++ VARIABLES ++++++++++++++++++++++++++
    Integer  m,j,i
    REAL(kind=DP)  z1,z,xm,xl,pp,p3,p2,p1,eta
    Parameter (eta=0.0000000001d0)

    !++++++++++++++++++++++++ end VARIABLES ++++++++++++++++++++++++



    !---------------------- Calculation Start ----------------------
    m=(n+1)/2
    xm=0.5d0*(x2+x1)
    xl=0.5d0*(x2-x1)

    ! === DEBUG by tkato 2014/04/22 ================================================
    z1 = 0.0d0
    ! ==============================================================================
    Do i=1,m
       z=DCOS(pi*(i-0.25d0)/(n+0.5d0))
       Do While (ABS(z-z1).GT.eta)
          p1=1.0d0
          p2=0.0d0

          Do j=1,n
             p3=p2
             P2=p1
             p1=((2.0d0*j-1.d0)*z*p2-(j-1.d0)*p3)/dble(j)
          Enddo

          pp=n*(z*p1-p2)/(z*z-1.d0)
          z1=z
          z=z1-p1/pp

       Enddo
       xi(i) = xm-xl*z
       xi(n+1-i) = xm+xl*z
       wi(i) = 2.d0*xl/((1.d0-z*z)*pp*pp)
       wi(n+1-i) = wi(i)
    Enddo
  End Subroutine gauleg
  !** End SUBROUTINE gauleg ******************************************************************************

  !** SUBROUTINE outputs ************************************************************************
  Subroutine outputs()
    Implicit none

    Ecnl = Ecnl_12 + Ecnl_3 - Ecnl_3s

    if(printable)then
       write(nfout,'(a)')  'Here are the results : '
       Write(nfout,*)  ' '
       Write(nfout,11) ExGGA
       Write(nfout,*)  ' '
       Write(nfout,12) EcLDA
       Write(nfout,13) Ecnl
       Write(nfout,14) EcLDA + Ecnl
       Write(nfout,*)  ' '
       Write(nfout,15) EcLDA + Ecnl + ExGGA
       Write(nfout,*)  ' '
11     Format('E_total(GGA exchange)      = ',F19.13)

12     Format('Ec(LDA)                    = ',F19.13)
13     Format('Ec(nl)                     = ',F19.13)
14     Format('Ec (= Ec(LDA) + Ec(nl) )   = ',F19.13)

15     Format('E_total(vdW-DF)            = ',F19.13)

       Write(nfout,*)  '                  Given in Hartree atomic units'
       Write(nfout,*)  ' '
    endif

  End Subroutine outputs
  !** End SUBROUTINE outputs ********************************************************************

  subroutine get_dFdrho_dFddrho(na,nb,nc,dFdrho_,dFddrho_)
    integer, intent(in) :: na,nb,nc
    real(kind=DP), dimension(na*nb*nc), intent(out) :: dFdrho_,dFddrho_
    integer :: i,i1,i2,i3
    dFdrho_ = dFdrho
    dFddrho_ = dFddrho
    !    dFdrho = 0.0d0;dFddrho = 0.0d0 ! this can be calculated on the fly!!
    !    do i=1,nq0
    !       dFdrho (:,:,:) = dFdrho (:,:,:) + dble(ualpha_r(i,:,:,:))*dtheta_R (i,:,:,:)/(univol*rinplw)
    !       dFddrho(:,:,:) = dFddrho(:,:,:) + dble(ualpha_r(i,:,:,:))*ddtheta_R(i,:,:,:)/(univol*rinplw)
    !    enddo

  end subroutine get_dFdrho_dFddrho

  subroutine map_rho_to_afft(rho,afft)
    complex(kind=DP), intent(in),  dimension(nabc) :: rho
    real(kind=DP), intent(out), dimension(nfftp_nonpara) :: afft
    integer :: i,cix,ciy,ciz,cir,cir2
    afft = 0.d0
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                afft(2*cir-1) = real(rho(cir2))
             else
                afft(2*cir-1) = real(rho(cir2))
                afft(2*cir)   = aimag(rho(cir2))
             endif
          enddo
       enddo
    enddo
  end subroutine map_rho_to_afft

  subroutine map_rhog_to_afft(rho,afft)
    complex(kind=DP), intent(in),  dimension(nabc) :: rho
    real(kind=DP), intent(out), dimension(nfftp_nonpara) :: afft
    integer :: i,cix,ciy,ciz,cir,cir2
    afft = 0.d0
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz,.true.)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                afft(cir) = real(rho(cir2))
             else
                afft(2*cir-1) = real(rho(cir2))
                afft(2*cir)   = aimag(rho(cir2))
             endif
          enddo
       enddo
    enddo
  end subroutine map_rhog_to_afft

  subroutine map_afft_to_rho(afft,rho)
    real(kind=DP), intent(in), dimension(nfftp_nonpara) :: afft
    complex(kind=DP), intent(out),  dimension(nabc) :: rho
    integer :: i,cix,ciy,ciz,cir,cir2
    rho = (0.d0,0.d0)
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz,.true.)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                rho(cir2) = DCMPLX(afft(cir))
             else
                rho(cir2) = DCMPLX(afft(2*cir-1),afft(2*cir))
             endif
          enddo
       enddo
    enddo
  end subroutine map_afft_to_rho

  subroutine map_afft_to_rhog(afft,rho)
    real(kind=DP), intent(in), dimension(nfftp_nonpara) :: afft
    complex(kind=DP), intent(out),  dimension(nabc) :: rho
    integer :: i,cix,ciy,ciz,cir,cir2
    rho = (0.d0,0.d0)
    do cix = 1,na
       do ciy = 1,nb
          do ciz = 1,nc
             cir = get_index_1D_kimg(cix,ciy,ciz)
             cir2 = get_index_1D(cix,ciy,ciz)
             if(kimg == 1)then
                rho(cir2) = DCMPLX(afft(2*cir-1))
             else
                rho(cir2) = DCMPLX(afft(2*cir-1),afft(2*cir))
             endif
          enddo
       enddo
    enddo
  end subroutine map_afft_to_rhog

end module m_vdWDF

#endif

       subroutine  tred1_u(
     &               a, nm,
     &               u_x, u_y, nv,
     &               u_t, v_t, i, beta)
       implicit NONE

       integer, intent(in)    ::  nm, nv, i
       real(8), intent(inout) ::  a(1:nm)
       real(8), intent(inout) ::  u_x(1:nv), u_y(1:nv)
       real(8), intent(inout) ::  u_t(*), v_t(*)
       real(8), intent(inout) ::  beta

       include 'trd.h'

       real(8)                ::  anorm2, a_n, g_n
       real(8)                ::  tt(4), ss(4), t, s

       integer                ::  x_owner_nod, x_pos
       integer                ::  y_owner_nod, y_pos
       integer                ::  j_1, j_2, j_3
       integer                ::  jj_1, jj_2, jj_3
       integer                ::  L

       include 'param.h'


       L = i-1

       x_owner_nod = loop_c_node (L, x_nnod, x_inod)
       y_owner_nod = loop_c_node (i, y_nnod, y_inod)

       x_pos       = loop_c_g2l_depth(L, x_nnod, x_inod)
       y_pos       = loop_c_g2l_depth(i, y_nnod, y_inod)

       j_2         = loop_c_start(1, x_nnod, x_inod)
       j_3         = loop_c_end  (L, x_nnod, x_inod)

!
! u=...
!
       if ( y_owner_nod == y_inod ) then
       if ( beta < ZERO ) then
          u_x(j_2:j_3) = a(j_2:j_3)
       end if
       end if

       call bcast_dbl(u_x(1), x_pos, y_owner_nod, y_COMM_WORLD)

       if ( x_owner_nod == x_inod ) then
          u_x(j_3+1:x_pos) = ZERO
       end if

       call datacast_dbl(u_y(1), u_x(1), u_t(1), v_t(1), x_pos)


       return
       end subroutine  tred1_u

       module eigen_libs
!--
!Kro      use eigen_blacs, only :  eigen_get_blacs_context
          implicit NONE   

          character(32), private ::  CodeNAME = 'EigenExa'
          character(32), private ::  Version  = '1.0 (2013.08.01)'
!--
       interface
!--
          subroutine eigen_sx( n, nvec, a, lda, w, z, ldz,
     &                         m_forward, m_backward )
          integer, intent(in)    :: n, nvec, lda, ldz
          integer, intent(in), optional :: m_forward, m_backward
          real(8), intent(inout) :: a(1:lda, *)
          real(8), intent(out)   :: w(*), z(1:ldz, *)
          end subroutine  eigen_sx
!--
       end interface

!          private ::  eigen_loop_calc

       contains
!--
!--
          subroutine eigen_initialized( flag )
          use eigen_devel
          implicit NONE
*-
          logical, intent(out) :: flag

             call eigen_get_initialized( flag )

          return
          end subroutine eigen_initialized
!--
          subroutine eigen_init( comm, order )
*-
!$        use OMP_LIB
          use MPI
          use eigen_devel
!Kro      use eigen_blacs, only : eigen_blacs_init
          implicit NONE
*-
          integer, intent(in), optional ::  comm
          character*(*), intent(in), optional ::  order
*-
          logical :: flag
          integer ::  n1, n2, n3, i, j, k, ierr
          integer :: topo_type, cart_dim, dims(2), coords(2)
          logical :: periods(2)
          integer :: old_grp, new_grp

          integer, pointer :: tmpgrid(:,:)
          integer          :: comm0
          integer          :: group0, group1, kk0(1), kk1(1)

          integer          :: local_size
!$        integer          :: th0(2), th1(2)

          character*1 :: GRID_major


             call eigen_timer_reset( )

             call eigen_initialized( flag )
          if ( flag ) then
          if ( TRD_inod == 1 ) then
             print*,"*************"
             print*,"** CAUTION **"
             print*,"*************"
             print*,"You are going to initialize EigenExa,"
             print*,"while EigenExa was not freed at last call."
             print*,"EigenExa restarts again by itself."
          end if
             call eigen_free( )
          end if

             if ( PRESENT(comm) ) then
                comm0 = comm
             else
                comm0 = MPI_COMM_WORLD
             end if
             if ( comm0 == MPI_COMM_NULL ) then
                TRD_COMM_WORLD = MPI_COMM_NULL
                x_COMM_WORLD = MPI_COMM_NULL
                y_COMM_WORLD = MPI_COMM_NULL
                z_COMM_WORLD = MPI_COMM_NULL
                TRD_nnod = 0; TRD_inod = 0
                x_nnod = 0; x_inod = 0
                y_nnod = 0; y_inod = 0
             else
                call MPI_Comm_dup( comm0, TRD_COMM_WORLD, ierr )
             end if

          if ( TRD_COMM_WORLD /= MPI_COMM_NULL ) then

             call MPI_Comm_size( TRD_COMM_WORLD, TRD_nnod, ierr )
             call MPI_Comm_rank( TRD_COMM_WORLD, TRD_inod, ierr )
             TRD_inod = TRD_inod+1

             call MPI_Topo_test( TRD_COMM_WORLD, topo_type, ierr )
             if ( topo_type == MPI_CART ) then
                call MPI_Cartdim_get( TRD_COMM_WORLD, cart_dim, ierr )
             else
                cart_dim = 1
             end if

             if ( cart_dim == 2 ) then

                call MPI_Cart_get( TRD_COMM_WORLD, cart_dim,
     &                             dims, periods, coords, ierr )
                x_nnod = dims(1)
                y_nnod = dims(2)
                x_inod = coords(1)
                y_inod = coords(2)

             GRID_major = 'R'
          if ( PRESENT(order) ) then
          if ( x_inod == 1 .AND. y_inod == 1 ) then
          if ( order(1:1) == 'C' .or. order(1:1) == 'c' ) then
             print*,"*************"
             print*,"** CAUTION **"
             print*,"*************"
             print*,"The MPI_CART you specified is based on R-major,"
             print*,"but you also specified C-major option."
             print*,"EigenExa solve this conflict by taking R-major."
             end if
          end if
          end if

          else

             x_nnod = INT(SQRT(DBLE(TRD_nnod)))
             i = 1 ! minimum factor, x_nnod must be multiple of k
             if ( MOD(TRD_nnod, i) == 0 ) then
                k = i
             else
                k = 1
             end if
             do
                if ( x_nnod <= k ) exit
                if ( MOD(x_nnod, k) == 0 .AND.
     &               MOD(TRD_nnod, x_nnod) == 0 ) exit
                x_nnod = x_nnod-1
             end do!!
             y_nnod = TRD_nnod/x_nnod

             if ( PRESENT(order) ) then
                GRID_major = order(1:1)
             else
                GRID_major = 'C'
             end if

             if ( GRID_major == 'R' .or. GRID_major == 'r' ) then
                GRID_major = 'R'
             else
                GRID_major = 'C'
             endif

             call eigen_set_grid_major( GRID_major )

             if ( GRID_major == 'R' ) then
! row-major
                x_inod =    (TRD_inod-1)/y_nnod +1
                y_inod = MOD(TRD_inod-1, y_nnod)+1
             else
! column-major
! ** EigenK adopts column-major in default
!    The process ordering on the Earth Simulator was done in the way
!    such as incrmental from internal processors to external nodes.
!    We want to make the processes, which possess a distributed vector,
!    close physically on the network connection.
!    These are the historical reason to adopt column-major.
                x_inod = MOD(TRD_inod-1, x_nnod)+1
                y_inod =    (TRD_inod-1)/x_nnod +1
             end if

          end if

             call MPI_Comm_split( TRD_COMM_WORLD, y_inod, x_inod,
     &            x_COMM_WORLD, ierr )
             call MPI_Comm_split( TRD_COMM_WORLD, x_inod, y_inod,
     &            y_COMM_WORLD, ierr )

             n1 = MAX(x_nnod, y_nnod)
             n2 = MIN(x_nnod, y_nnod)
             do
                if ( n1 == n2 ) then
                   n_common = n1
                   exit
                end if
                n3 = n1-n2
                n1 = MAX(n2, n3)
                n2 = MIN(n2, n3)
             end do!!

             if ( ASSOCIATED( p0_ ) ) then
                deallocate( p0_ )
             end if
             allocate ( p0_(1:MAX(x_nnod, y_nnod)) )

             if ( ASSOCIATED( q0_ ) ) then
                deallocate( q0_ )
             end if
             allocate ( q0_(1:MAX(x_nnod, y_nnod)) )

             p0_(:) = -1
             q0_(:) = -1
             do i = 1, x_nnod
             if ( MOD(i-1, n_common) == MOD(y_inod-1, n_common) ) then
                n1 = y_inod-i
                if ( n1 >= 0 ) then
                   do j = 1, x_nnod
                      k = +n1+(j-1)*y_nnod
                      if ( MOD(k, x_nnod) == 0 ) then
                         p0_(i) = k/x_nnod
                         q0_(i) = (j-1)
                         exit
                      end if
                   end do! j
                else
                   do j = 1, y_nnod
                      k = -n1+(j-1)*x_nnod
                      if ( MOD(k, y_nnod) == 0 ) then
                         q0_(i) = k/y_nnod
                         p0_(i) = (j-1)
                         exit
                      end if
                   end do! j
                end if
             end if
             end do! i
             p0_(:) = p0_(:)+1
             q0_(:) = q0_(:)+1


             diag_0 = 0
             diag_1 = 0
             do i = 1, y_nnod/n_common
                j = (i-1)*y_nnod+y_inod
                k = MOD(j-1, x_nnod)+1
                if ( k == x_inod ) then
                   diag_0 = i
                   diag_1 = (j-1)/x_nnod+1
                   exit
                end if
             end do! i_1


             if ( n_common > 1 ) then
                w_inod =     (x_inod-1)/ n_common +1
                z_inod = MOD((x_inod-1), n_common)+1
                w_nnod = x_nnod/n_common
                z_nnod = n_common
                call MPI_Comm_split( x_COMM_WORLD, w_inod-1, z_inod-1,
     &            z_COMM_WORLD, ierr )
                call MPI_Comm_split( x_COMM_WORLD, z_inod-1, w_inod-1,
     &            w_COMM_WORLD, ierr )
             else
                z_COMM_WORLD = MPI_COMM_SELF
                z_inod = 1
                z_nnod = 1
                w_COMM_WORLD = x_COMM_WORLD
                w_inod = x_inod
                w_nnod = x_nnod
             end if

!---- OpenMP thread check ---
!$           call MPI_Query_thread( MPI_THREAD_MODE, ierr )
!$           local_size = 1
!$OMP PARALLEL
!$OMP MASTER
!$           local_size = omp_get_num_threads( )
!$OMP END MASTER
!$OMP END PARALLEL
!$           th0(1) = local_size
!$           th0(2) = -th0(1)
!$           call MPI_Allreduce( th0, th1, 2, MPI_INTEGER, MPI_MAX,
!$   &                           TRD_COMM_WORLD, ierr )
!$           j = th1(1); k = -th1(2)
!$        if ( j /= k ) then
!$        if ( TRD_inod == 1 ) then
!$           print*,"*************"
!$           print*,"** CAUTION **"
!$           print*,"*************"
!$        print*,"EigenExa supports only homogeneous thread setting!"
!$        if ( k == 1 ) then
!$           print*,"EigenExa terminates this run."
!$        else
!$           print*,"EigenExa continues to compute, anyway."
!$        print*,"But, accuracy of the result might be unacceptable."
!$        end if
!$           print*,"*************"
!$        end if
!$           if ( k == 1 ) then
!$              call MPI_Abort( MPI_COMM_WORLD, 1, ierr )
!$           end if
!$        end if
!--------------------

!---- BLACS setup ---

#if TIMER_PRINT
             if ( x_inod == 1 .AND. y_inod == 1 ) then
                print*,"GRID major ",GRID_major," is specified."
             end if
#endif

             if ( TRD_COMM_WORLD == MPI_COMM_NULL ) then
                comm0  = MPI_COMM_SELF
                x_nnod = 1
                y_nnod = 1
             else
                comm0  = TRD_COMM_WORLD
             end if

!Kro         call Eigen_BLACS_Init( comm0, x_nnod, y_nnod,
!Kro &                           GRID_Major )

!--------------------

          else
             x_nnod = 0
             y_nnod = 0
          end if

             call eigen_set_initialized( )


          return
          end subroutine  eigen_init
!--
          subroutine eigen_free( flag )
          use MPI
          use eigen_devel
          use eigen_blacs, only : eigen_blacs_exit
          implicit NONE
          integer, intent(in), optional ::  flag
*-
          integer                ::  ierr
          logical                ::  local_flag


          call eigen_get_initialized( local_flag )

          if ( .NOT. local_flag ) then
             return
          end if

          if ( TRD_COMM_WORLD /= MPI_COMM_NULL ) then

             call MPI_Comm_free( x_COMM_WORLD, ierr )
             call MPI_Comm_free( y_COMM_WORLD, ierr )

             if ( n_common > 1 ) then
             call MPI_Comm_free( z_COMM_WORLD, ierr )
             call MPI_Comm_free( w_COMM_WORLD, ierr )
             end if

             deallocate ( p0_)
             deallocate ( q0_)

             if ( PRESENT(flag) ) then
                if ( flag == 1 ) call eigen_timer_print( )
             end if
             call eigen_timer_reset( )

          end if

             call Eigen_BLACS_Exit( )

             TRD_COMM_WORLD = MPI_COMM_WORLD

             call eigen_unset_initialized( )


          return
          end subroutine  eigen_free
!--
          subroutine eigen_get_matdims( n, nx, ny )
          use eigen_devel
          implicit NONE
          integer, intent(in)    :: n
          integer, intent(out)   :: nx, ny
*-
          integer :: NPROW, NPCOL, NB
          integer :: n1, nm, nmz, nmw, larray


             NPROW = x_nnod
             NPCOL = y_nnod

             n1 = ((n-1)/NPROW+1)
             call CSTAB_get_optdim( n1, 6, 16*4, 16*4*2, nm )

             NB  = 64
             nmz = ((n-1)/NPROW+1)
             nmz = ((nmz-1)/NB+1)*NB+1
             nmw = ((n-1)/NPCOL+1)
             nmw = ((nmw-1)/NB+1)*NB+1

             larray = MAX(nmz, nm)*nmw

             nx = nm
             ny = (larray-1)/nm+1


          return
          end subroutine  eigen_get_matdims
!--
          integer function eigen_memory_internal( n, lda, ldz, m1, m0 )
     &                     result( byte )
!$        use OMP_LIB
          use MPI
          use eigen_devel
          implicit NONE
          integer, intent(in)    :: n, lda, ldz, m1, m0
*-
          integer :: l_uv_t
          integer :: MYROW, MYCOL, NPROW, NPCOL, NP, NQ, NB
          integer :: lddz, lddw, LWORK, LIWORK
          integer :: m, na, nx, nv, nm, ierr
          integer :: local_rank, local_size

          integer, parameter     :: nm_max_L1 = 16*4
          integer, parameter     :: nm_max_L2 = 16*6

          integer :: byte_tridi
          integer :: byte_dcx
          integer :: byte_trbak

          integer, external :: NUMROC

          include 'CSTAB.h'


             local_rank = 0
             local_size = 1
!$           local_rank = omp_get_thread_num()
!$           local_size = omp_get_num_threads()

!  ===== for TRIDI ====

             nx = (n-1)/x_nnod+1 +2
             call CSTAB_get_optdim(nx, 6, nm_max_L1, nm_max_L2, nv)

             l_uv_t = MAX(2*nv,
     &                    2*(n+MAX(3,y_nnod/n_common)),
     &                    2*8*m1)

             LWORK = nm*m1+n_columns
     &             + 2*(l_uv_t+n_columns)
     &             + (nv+n_columns)
     &             + 2*(nv*2*m1+2*n_columns)
     &             + 4*(nv*local_size+n_columns)

             byte_tridi = LWORK * 8

!  ===== for DCX ====

             NB = 64
             NB = MIN(NB, N)

             NPROW = x_nnod
             NPCOL = y_nnod
             MYROW = x_inod-1
             MYCOL = y_inod-1
             NP = NUMROC( n, NB, MYROW, 0, NPROW )
             NQ = NUMROC( n, NB, MYCOL, 0, NPCOL )

             lddz = (n-1)/NPROW+1
             lddz = ((lddz-1)/NB+1)*NB
             lddw = (n-1)/NPCOL+1
             lddw = ((lddw-1)/NB+1)*NB

             nx     = (N-1)/NPCOL+1
             LWORK  = MAX(1+6*N+2*NP*(NQ+MAX(NQ,NB)), lddz*lddw, ldz*nx)
     &              + n
             LIWORK = 2+7*n+8*NPCOL

             byte_dcx = LWORK * 8 + LIWORK * 4

!  ===== for TRBAK ====

             m    = MIN(nsm, m0)
             if ( m < 1 ) m = 1

             na   = (n-1)/y_nnod+1
             na   = na  +MOD(na  -1,2)
             call CSTAB_get_optdim(lda, 9, 16*4, 16*6, nm)

             LWORK = n
     &             + 3*(MAX(nm*m,n)+n_columns)
     &             + 4*(na*m+ns0+n_columns)
     &             + m*nm
             LIWORK = MAX(((m-1)/y_nnod+1)*((n-1)/x_nnod+1),n)

             byte_trbak = LWORK * 8 + LIWORK * 4


             na = MAX(byte_tridi, byte_dcx, byte_trbak)
             call MPI_Allreduce( na, nx, 1, MPI_INTEGER,
     &                           MPI_MAX, TRD_COMM_WORLD, ierr )
             byte = nx


          return
          end function  eigen_memory_internal
!--
          subroutine eigen_get_procs( procs, x_procs, y_procs )
          use eigen_devel
          implicit NONE
          integer, intent(out)   ::  procs, x_procs, y_procs


             procs   = TRD_nnod
             x_procs = x_nnod
             y_procs = y_nnod


          return
          end subroutine  eigen_get_procs
!--
          subroutine eigen_get_id( id, x_id, y_id )
          use eigen_devel
          implicit NONE
          integer, intent(out)   ::  id, x_id, y_id


             id   = TRD_inod
             x_id = x_inod
             y_id = y_inod


          return
          end subroutine  eigen_get_id
!--
          subroutine eigen_get_comm( comm, x_comm, y_comm )
          use eigen_devel
          implicit NONE
          integer, intent(out)   ::  comm, x_comm, y_comm


             comm   = TRD_COMM_WORLD
             x_comm = x_COMM_WORLD
             y_comm = y_COMM_WORLD


          return
          end subroutine  eigen_get_comm
!--
          integer function eigen_loop_start( istart, nnod, inod )
     &            result( ret )
          implicit NONE
          integer, intent(in)    ::  istart, nnod, inod


!             ret = eigen_loop_calc( istart, nnod, inod, 1 )
             ret = (istart + nnod - 1 - inod) / nnod + 1

          return
          end function  eigen_loop_start
!--
          integer function eigen_loop_end( iend, nnod, inod )
     &            result( ret )
          implicit NONE
          integer, intent(in)    ::  iend, nnod, inod

!             ret   = eigen_loop_calc( iend, nnod, inod, 0 )
             ret = (iend + nnod - 0 - inod) / nnod + 0

          return
          end function  eigen_loop_end
!--
          integer function eigen_translate_l2g( ictr, nnod, inod )
     &            result( ret )
          implicit NONE
          integer, intent(in)    ::  ictr, nnod, inod

             ret = (ictr-1)*nnod+inod

          return
          end function  eigen_translate_l2g
!--
          integer function eigen_translate_g2l( ictr, nnod, inod )
          implicit NONE
          integer, intent(in)    ::  ictr, nnod, inod

             eigen_translate_g2l = (ictr-1)/nnod+1

          return
          end function  eigen_translate_g2l
!--
          integer function eigen_owner_node( ictr, nnod, inod )
     &            result( ret )
          implicit NONE
          integer, intent(in)    ::  ictr, nnod, inod

             ret = MOD(ictr-1, nnod)+1

          return
          end function  eigen_owner_node
!--
!          integer function eigen_loop_calc( ictr, nnod, inod, d )
!     &            result( ret )
!          implicit NONE
!          integer, intent(in)    ::  ictr, nnod, inod, d
!
!             ret = (ictr+nnod-d-inod)/nnod+d
!
!          return
!          end function  eigen_loop_calc
!--
       end module eigen_libs

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 603 $)
!
!  SUBROUINE:  Preparation_for_mpi
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_for_mpi(prepare_communicators)
! $Id: Preparation_for_mpi.F90 603 2020-04-07 03:25:30Z jkoga $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Const_Parameters,     only : INITIAL, CONTINUATION &
       &                           , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION,OFF &
       &                           , ALL_AT_ONCE, ON, DP, COORDINATE_CONTINUATION &
       &                           , ONE_BY_ONE
  use m_Kpoints,              only : kv3, kv3_ek
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel,nspin,neg,printable,ngnode_nbmx &
       &                           , flag_mpi_g_dot_r,flag_mpi_g_dot_r_k &
       &                           , icond, ekmode, fixed_charge_k_parallel, sw_rsb, neg_is_given &
       &                           , m_CtrlP_flag_mpi_G_dot_R
  use m_PlaneWaveBasisSet,    only : kg1, kgpm, nbmx, iba, kgp, kgp_reduced
#ifndef PARAMSET
  use m_Charge_Density,       only : m_CD_alloc_chgq
  use m_XC_Potential,         only : m_XC_alloc_vxc
  use m_Parallelization,      only : m_Parallel_init_mpi_mix, m_Parallel_init_mpi_snl &
       &                           , m_Parallel_init_mpi_atm, m_Parallel_init_mpi_atm2 &
       &                           , m_Parallel_init_mpi_iba, m_Parallel_init_mpi_elec &
       &                           , m_Parallel_init_mpi_kv3_ek
  use m_Parallelization,      only : m_Parallel_init_mpi_gga &
       &                           , m_Parallel_init_mpi_nbmx &
       &                           , m_Parallel_init_mpi_ffth
  use m_FFT,                  only : nfftp, nfftps, nfft
  use m_Ionic_System,         only : natm, natm2, m_IS_alloc_fxyzew
  use m_Ionic_System,         only : m_IS_alloc_zfm3
  use m_Force,                only : m_Force_alloc
#endif

! ============================== added by K. Tagami ================== 11.0&13.0XX
  use m_Control_Parameters,   only : noncol, ndim_spinor, sw_calc_ekin_density
  use m_KineticEnergy_Density,  only : m_KE_alloc_ekin_density
! ==================================================================== 11.0&13.0XX

  implicit none

  integer, intent(in) :: prepare_communicators
  integer             :: lsize
  real(kind=DP), allocatable, dimension(:,:) :: dfft_l

#ifndef PARAMSET
  call m_IS_alloc_fxyzew()
  call m_Force_alloc()
  call m_IS_alloc_zfm3()
  call m_CD_alloc_chgq()
  call m_XC_alloc_vxc()

! === KT_add ==== 13.0XX
  if ( sw_calc_ekin_density == ON ) call m_KE_alloc_ekin_density
! =============== 13.0XX

  if(prepare_communicators==ON)then
! ================================ modified by K. Tagami =================== 11.0
!     call m_Parallel_init_mpi_elec(nfout,ipriparallel,printable,neg,kv3,nspin,kg1)
!     call m_Parallel_init_mpi_snl(nfout,ipriparallel,printable,nspin)
! -
     if ( noncol ) then
!!$        if(neg_is_given) &
             call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
             &                             kv3, ndim_spinor, kg1 )
        call m_Parallel_init_mpi_snl( nfout, ipriparallel, printable, ndim_spinor )
     else
!!$        if(neg_is_given) &
             call m_Parallel_init_mpi_elec( nfout, ipriparallel, printable, neg, &
             &                             kv3, nspin, kg1 )
        call m_Parallel_init_mpi_snl( nfout, ipriparallel, printable, nspin )
     endif
! ========================================================================== 11.0 
     call m_Parallel_init_mpi_mix(nfout,ipriparallel,printable,kgpm)
     call m_Parallel_init_mpi_atm(nfout,ipriparallel,printable,natm)
     call m_Parallel_init_mpi_atm2(nfout,ipriparallel,printable,natm2)

!!!  call m_CtrlP_flag_mpi_G_dot_R(nfout,nbmx) ! -> flag_mpi_g_dot_r
     call m_Parallel_init_mpi_nbmx(nfout,ipriparallel,printable,nbmx,kg1,ngnode_nbmx,flag_mpi_g_dot_r,flag_mpi_g_dot_r_k)
     call m_Parallel_init_mpi_gga(nfout,ipriparallel,printable,nfftp,nfftps)
     if(sw_rsb==ON) call m_Parallel_init_mpi_ffth(nfout,ipriparallel,printable,nfft)

  endif

  if((icond == INITIAL .or. icond == CONTINUATION .or.  icond==COORDINATE_CONTINUATION) &
       & .or.((icond==FIXED_CHARGE.or.icond==FIXED_CHARGE_CONTINUATION).and.ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Parallel_init_mpi_iba(nfout,ipriparallel,printable,kv3,iba) ! -> np_g1k, mp_g1k
  end if
!!!!$!BRANCH_P ORG_Parallel
  if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
    & fixed_charge_k_parallel==ONE_BY_ONE) &
    & call m_Parallel_init_mpi_kv3_ek(nfout,ipriparallel,printable,kv3_ek,nspin)
!!!!$!BRANCH_P_END ORG_Parallel



#endif

end subroutine Preparation_for_mpi

subroutine Preparation_for_mpi_ek
! $Id: Preparation_for_mpi.F90 603 2020-04-07 03:25:30Z jkoga $
!                           @(#)Preparation_for_mpi.F90 1.10 03/02/19 00:49:14
  use m_Kpoints,              only : kv3
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : ipriparallel, printable
  use m_PlaneWaveBasisSet,    only : iba
  use m_Parallelization,      only : m_Parallel_init_mpi_iba

  call m_Parallel_init_mpi_iba(nfout,ipriparallel,printable,kv3,iba) !  -> np_g1k, mp_g1k

end subroutine Preparation_for_mpi_ek

subroutine Preparation_for_mpi_PAW()
  use m_Files,                only : nfout
  use m_Ionic_System,         only : natm
  use m_PseudoPotential,      only : mmesh, flg_paw
end subroutine Preparation_for_mpi_PAW

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 590 $)
!
!  SUBROUINE: Ewald_and_Structure_Factor
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
subroutine Ewald_and_Structure_Factor
! $Id: Ewald_and_Structure_Factor.F90 590 2018-11-06 04:20:58Z jkoga $
  use m_Const_Parameters, only : ON,OFF,Valence_plus_PC_Charge,VXC_AND_EXC,DP,VDW_DFTD3
  use m_Files,            only : nfout
  use m_PseudoPotential,  only : ival
#ifndef ENABLE_ESM_PACK
  use m_Control_Parameters,only : skip_alloc_phonon,printable,sw_wf_predictor,sw_charge_predictor &
    &                           , m_CtrlP_in_initialization,sw_extrapolate_charge, noncol
#else
  use m_Control_Parameters,only : skip_alloc_phonon &
    &                           , sw_esm, printable,sw_wf_predictor,sw_charge_predictor,sw_extrapolate_charge &
    &                           , m_CtrlP_in_initialization,kimg, noncol
#endif
  use m_Control_Parameters,only : vdw_method,sw_vdw_correction
  use m_PlaneWaveBasisSet,only : kgp,ngabc,kg,gr_l,igfp_l
!$$#ifdef PARA3D
  use m_Ionic_System,     only : m_IS_structure_factor_3D, m_IS_ewald_3D,eewald,fxyzew_l,natm &
     &                         , m_IS_get_extpl_factor, iatomn, ityp, ntyp_vdw, m_IS_vdw, m_IS_vdwdf3
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
!$$#endif
  use m_Ionic_System, only : num_regions, m_IS_regions
  use m_IterationNumbers, only : iteration_ionic

  use m_Charge_Density,   only : m_CD_predictor_pre,m_CD_predictor_post,chgq_l
  use m_ES_ortho,             only : m_ES_modified_gram_schmidt
  use m_XC_Potential,         only : m_XC_cal_potential_3D,vxc_l
  use m_Electronic_Structure, only : m_ES_energy_eigen_values_3D
  use m_ES_LHXC,              only : m_ESlhxc_potential_3D
  use m_ES_Intgr_VlhxcQlm,    only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_Electronic_Structure, only : vloc_esm
  use m_ES_wf_extrpl,         only : m_ES_wf_extrpl_doit

  use m_FFT,                  only : fft_box_size_CD
  implicit none

  real(kind=DP) :: alpha,beta,rms
  integer :: nextpl,iat
  real(kind=DP) :: eewald_g,eewald_r
  real(kind=DP), allocatable, dimension(:,:) :: forc_g
  real(kind=DP) :: ew_alpha
  integer :: i,j
  real(kind=DP), allocatable, dimension(:,:) :: agauss,bgauss
  real(kind=DP), dimension(2) :: alp,cc
  real(kind=DP) :: ivaltmp,alf
  real(kind=DP), allocatable, dimension(:,:) :: few_esm
  integer :: itpcc,nfftcd

!$$#ifdef PARA3D
!  call m_IS_structure_factor_3D(nfout,kgp,ngabc)
!  call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival)
  if(.not.m_CtrlP_in_initialization().and.sw_charge_predictor==ON) &
  & call m_CD_predictor_pre(nfout,printable)
  call m_IS_structure_factor_3D(nfout,kgp,ngabc_kngp_l)
  if(.not.m_CtrlP_in_initialization().and.&
    & (sw_charge_predictor==ON .or.  sw_wf_predictor==on)) then
    if(sw_extrapolate_charge==ON.or.sw_wf_predictor==ON) call m_IS_get_extpl_factor(alpha,beta,rms,nextpl)
    if(sw_charge_predictor==ON) call m_CD_predictor_post(alpha,beta,rms,nextpl,nfout,printable)
! === Use extrapolation! =======================================================
     if(sw_wf_predictor == ON) then
        call m_ES_wf_extrpl_doit(alpha,beta,rms,nextpl)
     endif
! ==============================================================================
     call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC)  ! -> vxc_l
     call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
     call m_ES_modified_gram_schmidt(nfout)
     call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ
     call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
  endif
#ifdef ENABLE_ESM_PACK
   if(sw_esm==ON)then
      nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
      if(.not.allocated(vloc_esm)) allocate(vloc_esm(nfftcd))
      vloc_esm(:) = dcmplx(0.d0,0.d0)
      allocate(agauss(natm,2));agauss=0.d0
      allocate(bgauss(natm,2));bgauss=0.d0
      do i=1,natm
         call psbhs0(nfout,nint(iatomn(ityp(i))),ivaltmp,itpcc,alp,cc)  ! -(b_PseudoPotential)
         agauss(i,1) = alp(1)
         agauss(i,2) = alp(2)
         bgauss(i,1) = cc(1)
         bgauss(i,2) = cc(2)
      enddo
      call esm_local_(nfftcd,vloc_esm,natm,2,agauss,bgauss)
      vloc_esm(:) = vloc_esm(:)*0.5d0 !Ry -> Ha
      deallocate(agauss)
      deallocate(bgauss)

      call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival,ngabc_kngp_l,alf) ! R only
      ew_alpha = (1.0d0/alf)**2
      call esm_ewald_g(ew_alpha,eewald_g)
      eewald = eewald+0.5d0*eewald_g  !Ry -> Ha

      allocate(few_esm(3,natm));few_esm=0.d0
      call esm_force_ew(ew_alpha,few_esm)
      do i=1,natm
         do j=1,3
            fxyzew_l(i,j) = fxyzew_l(i,j) + 0.5d0*few_esm(j,i) !Ry -> Ha
         enddo
      enddo
      deallocate(few_esm)
   else
      call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival,ngabc_kngp_l)
   endif
#else
  call m_IS_ewald_3D(nfout,kg,gr_l,kgp,ngabc,ival,ngabc_kngp_l)
#endif
  if(sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) call m_IS_vdwdf3(nfout)
  if(ntyp_vdw>0) call m_IS_vdw(nfout)
!$$#endif
  if(num_regions>0) call m_IS_regions(nfout)

  if(skip_alloc_phonon.and. &
 &  (sw_charge_predictor==OFF.and.sw_extrapolate_charge==OFF.and.sw_wf_predictor==OFF)) &
 &   call Initial_Electronic_Structure

end subroutine Ewald_and_Structure_Factor

! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
!
! Functions:  BeckeRoussel ex functional 
!             modified BJ  ex functional 
!
! =============================================================

! ********************************************
!
!  Becke Roussel meta-gga functinal 
!                       [ A. D. Becke et al, Phys. Rev. A 39 (1989) 3761 ]
!
! ********************************************
subroutine ex_mgga_br89( nspin, ispin, ista_r, iend_r, iskip_r, &
     &                   rho, norm_grad_rho, grad2_rho, ekin_dens, vx )
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer, intent(in) :: ispin, nspin, ista_r, iend_r, iskip_r
  real(kind=DP), intent(in) :: rho( ista_r:iend_r, ispin )
  real(kind=DP), intent(in) :: norm_grad_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: grad2_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: ekin_dens( ista_r:iend_r, nspin )
  real(kind=DP), intent(out) :: vx( ista_r:iend_r, nspin )

  integer :: is, i
  real(kind=DP) :: c1, c2, c3, c4, d1, d2, factor, coeff1
  real(kind=DP) :: val_d, val_q, val_x, val_y, val_b
  real(kind=DP) :: ctmp

  real(kind=DP), parameter :: delta1 = 1.0E-14
!  real(kind=DP), parameter :: delta1 = 1.0E-18
!  real(kind=DP), parameter :: delta1 = 1.0E-20
  
  real(kind=DP), parameter :: delta2 = 1.0E-20

  factor = ispin /2.0d0

  coeff1 = 2.0d0 /3.0d0 *PAI**(2.0d0/3.0d0)

  vx = 0.0d0

  Do is=1, ispin
     Do i=ista_r, iend_r, iskip_r
        c1 = ekin_dens(i,is) *factor
        c2 = norm_grad_rho(i,is) *factor
        c3 = rho(i,is) *factor
        c4 = grad2_rho(i,is) *factor

        if ( c3 > delta1 ) then 
           val_d = 2.0d0*c1 -c2**2 /c3 /4.0d0
        else
           val_d = 2.0d0*c1
        endif

        val_q = ( c4 -2.0d0 *val_d ) /6.0d0
        if ( c3 > delta1 .and. abs(val_q) > delta1 ) then
           val_y = coeff1 *c3**(5.0d0/3.0d0) /val_q
        else
           val_y = 0.0d0
        endif

        call determine_x_from_y_analytic( val_y, val_x )

#if 0
        if ( c3 > delta1 ) then 
           d1 = val_x**3 *exp( -val_x ) /( 8.0d0*PAI*c3 )

           if ( d1 > delta2 ) then
              val_b = d1 **(1.0d0/3.0d0)
           else
              val_b = 0.0d0
           endif
           if ( val_b > delta2 ) then
              d2 = exp( -val_x )
              vx(i,is) = -( 1.0d0 -d2 -d2*val_x/2.0d0  )/val_b
           endif
        endif
#else
        if ( abs(val_x) < 1.0D-8 ) then
           ctmp = 0.50d0
        else
           ctmp = exp( val_x/3.0d0 ) /val_x &
                &      *( 1.0d0 -exp(-val_x) -0.50d0*val_x*exp(-val_x) )
        endif
        vx(i,is) = -2.0*PAI**(1./3.)*c3**(1./3.) *ctmp
#endif        
     End Do
  End Do

contains

! ********************************************
!
!  Analytical solution of nonlinear eq. 
!           [ E. Proynov et al, Chem. Phy. Lett. 455 (2008) 103. ]
!
! ********************************************
  subroutine determine_x_from_y_analytic( val_y, val_x )
    real(kind=DP), intent(in) :: val_y
    real(kind=DP), intent(out) :: val_x

    real(kind=DP), parameter :: a1 =  1.5255251812009530D+00
    real(kind=DP), parameter :: a2 =  0.4576575543602858D+00
    real(kind=DP), parameter :: a3 =  0.4292036732051034D+00

    real(kind=DP), parameter :: b0 =  0.4771976183772063D+00
    real(kind=DP), parameter :: b1 = -1.7799813494556270D+00
    real(kind=DP), parameter :: b2 =  3.8433841862302150D+00
    real(kind=DP), parameter :: b3 = -9.5912050880518490D+00
    real(kind=DP), parameter :: b4 =  2.1730180285916720D+00
    real(kind=DP), parameter :: b5 = -30.425133851603660D+00
    real(kind=DP), parameter :: c0 =  0.7566445420735584D+00
    real(kind=DP), parameter :: c1 = -2.6363977871370960D+00
    real(kind=DP), parameter :: c2 =  5.4745159964232880D+00
    real(kind=DP), parameter :: c3 = -12.657308127108290D+00
    real(kind=DP), parameter :: c4 =  4.1250584725121360D+00
    real(kind=DP), parameter :: c5 = -30.425133957163840D+00

    real(kind=DP), parameter :: d0 = 0.00004435009886795587D+00
    real(kind=DP), parameter :: d1 = 0.58128653604457910D+00
    real(kind=DP), parameter :: d2 = 66.742764515940610D+00
    real(kind=DP), parameter :: d3 = 434.26780897229770D+00
    real(kind=DP), parameter :: d4 = 824.7765766052239000D+00
    real(kind=DP), parameter :: d5 = 1657.9652731582120D+00
    real(kind=DP), parameter :: e0 = 0.00003347285060926091D+00 
    real(kind=DP), parameter :: e1 = 0.47917931023971350D+00
    real(kind=DP), parameter :: e2 = 62.392268338574240D+00
    real(kind=DP), parameter :: e3 = 463.14816427938120D+00
    real(kind=DP), parameter :: e4 = 785.2360350104029000D+00
    real(kind=DP), parameter :: e5 = 1657.962968223273000000D+00

    real(kind=DP), parameter :: BB = 2.085749716493756D+00

    real(kind=DP) :: y1, y2, y3, y4, y5
    real(kind=DP) :: ctmp1, gy, p1y, p2y

    y1 = val_y
    y2 = val_y *y1
    y3 = val_y *y2
    y4 = val_y *y3
    y5 = val_y *y4

    if ( val_y <= 0.0d0 ) then
       ctmp1 = a1 *y1 +a2
       gy = -atan( ctmp1 ) +a3
       p1y = c0 +c1*y1 +c2*y2 +c3*y3 +c4*y4 +c5*y5
       p2y = b0 +b1*y1 +b2*y2 +b3*y3 +b4*y4 +b5*y5
    else
       ctmp1 = BB *y1
       gy = arccsch( ctmp1 ) +2.0d0
       p1y = d0 +d1*y1 +d2*y2 +d3*y3 +d4*y4 +d5*y5
       p2y = e0 +e1*y1 +e2*y2 +e3*y3 +e4*y4 +e5*y5
    endif
    
    val_x = gy *p1y /p2y
    if ( val_x < 0.0 ) val_x = 0.0d0

  end subroutine determine_x_from_y_analytic

  real*8 function arccsch(x)
    real(kind=DP), intent(in) :: x

    real(kind=DP) :: c1, c2

    c1 = 1.0d0 +sqrt( 1.0d0 +x**2 )
    c2 = c1 /abs(x)
    arccsch = log(c2)

    return
  end function arccsch
  
end subroutine ex_mgga_br89

! ********************************************
!
!  modified Becke Johnson meta-gga functinal 
!                       [ F. Tran et al, Phys. Rev. Lett. 102 (2009) 226401 ]
!
! ********************************************
subroutine set_cval_tb09( val_g, val_c )
  use m_Const_Parameters,     only : DP
  implicit none

  real(kind=DP), intent(in) :: val_g
  real(kind=DP), intent(out) :: val_c
!
  real(kind=DP), parameter :: alpha = -0.012D+00,  beta = 1.023D+00
!
  val_c = alpha + beta *sqrt( val_g )

end subroutine set_cval_tb09

subroutine ex_mgga_tb09( nspin, ispin, ista_r, iend_r, iskip_r, &
     &                    rho, norm_grad_rho, grad2_rho, ekin_dens, vx, val_c )
  use m_Const_Parameters,     only : DP,PAI
  use m_Crystal_Structure,    only : univol
  use m_Parallelization,      only : mpi_comm_group, npes, mype

  implicit none
  include 'mpif.h'

  integer, intent(in) :: ispin, nspin, ista_r, iend_r, iskip_r
  real(kind=DP), intent(in) :: rho( ista_r:iend_r, ispin )
  real(kind=DP), intent(in) :: norm_grad_rho( ista_r:iend_r, nspin)
  real(kind=DP), intent(in) :: grad2_rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: ekin_dens( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: val_c
  real(kind=DP), intent(out) :: vx( ista_r:iend_r, nspin )

!  real(kind=DP), parameter :: delta1 = 1.0E-14
!  real(kind=DP), parameter :: delta1 = 1.0E-18

  real(kind=DP), parameter :: delta1 = 1.0E-20
  real(kind=DP), parameter :: delta2 = 1.0E-20
!  real(kind=DP), parameter :: delta1 = 1.0E-10
!  real(kind=DP), parameter :: delta2 = 1.0E-10

  integer :: i, is
  real(kind=DP) :: ctmp1, fac

  vx = 0.0d0
  call ex_mgga_br89( nspin, ispin, ista_r, iend_r, iskip_r, &
     &               rho, norm_grad_rho, grad2_rho, ekin_dens, vx )

  fac = sqrt(5.0d0/12.0d0) /PAI

  Do is=1, nspin
     Do i=ista_r, iend_r, iskip_r
        if ( rho(i,is) > delta1 ) then
           ctmp1 = 2.0d0 *ekin_dens(i,is) /rho(i,is)
           if ( ctmp1 > delta2 ) then
              ctmp1 = fac *sqrt(ctmp1)
           else
              ctmp1 = 0.0d0
           endif
        else
           ctmp1 = 0.0d0
        endif

        vx(i,is) = val_c *vx(i,is) + ( 3.0d0*val_c -2.0d0 ) *ctmp1
     End do
  End Do

end subroutine ex_mgga_tb09

subroutine set_gval_tb09( nspin, ista_r, iend_r, rho, norm_grad_rho, weight, gval )
  use m_Const_Parameters,     only : DP,PAI


  use m_FFT,                  only : fft_box_size_CD_3D
  use m_Parallelization,      only : mpi_comm_group, npes, nrank_g, mpi_ke_world

  implicit none
  include 'mpif.h'

  integer, intent(in) :: nspin, ista_r, iend_r
  real(kind=DP), intent(in) :: rho( ista_r:iend_r, nspin )
  real(kind=DP), intent(in) :: norm_grad_rho( ista_r:iend_r, nspin)
  real(kind=DP), intent(in) :: weight( ista_r:iend_r )
  real(kind=DP), intent(out) :: gval

  real(kind=DP), parameter :: alpha = -0.012D+00,  beta = 1.023D+00
  real(kind=DP), parameter :: delta1 = 1.0E-20

  integer :: i, is, ierr
  real(kind=DP) :: csum_mpi, csum

  csum = 0.0d0
  Do is=1, nspin
     Do i=ista_r, iend_r
        if ( abs( rho(i,is) ) > delta1 ) then
           csum = csum + norm_grad_rho(i,is) /rho(i,is) *weight(i)
        end if
     End Do
  End Do

  if ( nspin == 2 ) csum = csum /2.0d0


#ifdef CD_FFT_ALL
    if ( npes > 1 ) then
     call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
          &              mpi_comm_group, ierr )
       csum = csum_mpi
    end if
#else
    if ( nrank_g > 1 ) then
       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
            &              mpi_ke_world, ierr )
       csum = csum_mpi
    end if
#endif
  csum = csum /product(fft_box_size_CD_3D(1:3,1))
  gval = csum

end subroutine set_gval_tb09

      SUBROUTINE MY_PDLAEDZ(ISTAGE, HBW, N, N1, ID, Q, IQ, JQ, LDQ, 
     $                       DESCQ, Z, WORK, V )
       use MPI
       use eigen_devel
       use eigen_dc
       IMPLICIT NONE
*
!     This routine is a modified routine of PDLAEDZ
!     which is contained in the ScaLAPACK
!     Modification is done by T.Imamura
*
*     .. Scalar Arguments ..
      INTEGER            ISTAGE
      INTEGER            ID, IQ, JQ, LDQ, N, N1, HBW
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * )
      DOUBLE PRECISION   Q( LDQ, * ), WORK( * ), Z( * ),
     $                   V( * )
*     ..
*
*  Purpose
*  =======
*
*  MY_PDLAEDZ Form the z-vector which consists of the last row of Q_1
*  and the first row of Q_2.
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
*
      INTEGER            COL, I, IBUF, ICTXT, IIQ, IIZ1, IIZ2, IQCOL,
     $                   IQROW, IZ, IZ1, IZ1COL, IZ1ROW, IZ2, IZ2COL,
     $                   IZ2ROW, J, JJQ, JJZ1, JJZ2, MYCOL, MYROW, N2,
     $                   NB, NBLOC, NPCOL, NPROW, NQ1, NQ2, ZSIZ, 
     $                    K
    
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN, MOD
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, INFOG2L, DAXPY
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..
      integer :: ERR_MPI
*     .. Executable Statements ..
*

*       This is just to keep ftnchek and toolpack/1 happy
       

      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      CALL INFOG2L( ID, ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      N2 = N - N1

*
!$OMP DO
      DO J = 1, N
         WORK(J) = 0D0
      END DO
!$OMP END DO
*
      IF (ISTAGE == 1) THEN
*
      DO K = 1, HBW
        CALL INFOG2L( IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW, 
     $        NPCOL, MYROW, MYCOL, IIZ1, JJZ1, IZ1ROW, IZ1COL )
        NQ1 = NUMROC( N1, NB, MYCOL, IZ1COL, NPCOL )
        IF( ( MYROW.EQ.IZ1ROW ) .AND. ( NQ1.NE.0 ) ) THEN
           I = MOD( MYCOL + NPCOL - MOD( IZ1COL, NPCOL ), NPCOL )
           NBLOC = ( NQ1-1 ) / NB + 1
!$OMP DO
           DO J = 1, NBLOC
              IZ1 = (J-1)*NB
              IZ = I*NB + 1 + (J-1)*NB*NPCOL
              ZSIZ = MIN( NB, NQ1-IZ1 )
              IF ( ZSIZ > 0 ) THEN
              IF ( K .EQ. 1 ) THEN
                 CALL DCOPY( ZSIZ, Q(IIZ1,JJZ1+IZ1), LDQ, WORK(IZ), 1)
                 CALL DSCAL( ZSIZ, V(K), WORK(IZ), 1)
              ELSE
                 CALL DAXPY( ZSIZ, V(K),
     $                       Q(IIZ1,JJZ1+IZ1), LDQ, WORK(IZ), 1)
              END IF
              END IF
           END DO
!$OMP END DO
        END IF
      END DO
*
      DO K = 1, HBW
        CALL INFOG2L( IQ-1+(ID+N1)+K-1, JQ-1+(ID+N1), DESCQ, 
     $    NPROW, NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL)
        NQ2 = NUMROC( N2, NB, MYCOL, IZ2COL, NPCOL )
        IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ2.NE.0 ) ) THEN
           I = MOD( MYCOL + NPCOL - MOD( IZ2COL, NPCOL ), NPCOL )
           NBLOC = ( NQ2-1 ) / NB + 1
!$OMP DO
           DO J = 1, NBLOC
              IZ2 = (J-1)*NB
              IZ = NB*I + N1 + 1 + (J-1)*NB*NPCOL
              ZSIZ = MIN( NB, NQ2-IZ2 )
              IF ( ZSIZ > 0 ) THEN
              IF ( K .EQ. 1 ) THEN
                 CALL DCOPY( ZSIZ, Q(IIZ2,JJZ2+IZ2), LDQ, WORK(IZ), 1)
                 CALL DSCAL( ZSIZ, V(K+HBW), WORK(IZ), 1)
              ELSE
                 CALL DAXPY( ZSIZ, V(K+HBW),
     $                       Q(IIZ2,JJZ2+IZ2), LDQ, WORK(IZ), 1)
              END IF
              END IF
           END DO
!$OMP END DO
        END IF
      END DO
*
      ELSE
*
      DO K = 1, HBW+HBW
        CALL INFOG2L(IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW,
     $           NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL )
        NQ1 = NUMROC( N, NB, MYCOL, IZ2COL, NPCOL )
        IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ1.NE.0 ) ) THEN
           I = MOD( MYCOL + NPCOL - MOD( IZ2COL, NPCOL ), NPCOL )
           NBLOC = ( NQ1-1 ) / NB + 1
!$OMP DO
           DO J = 1, NBLOC
              IZ1 = (J-1)*NB
              IZ = I*NB + 1 + (J-1)*NB*NPCOL
              ZSIZ = MIN( NB, NQ1-IZ1 )
              IF ( ZSIZ > 0 ) THEN
              IF ( K .EQ. 1 ) THEN
                 CALL DCOPY( ZSIZ, Q(IIZ2,JJZ2+IZ1), LDQ, WORK(IZ), 1)
                 CALL DSCAL( ZSIZ, V(K), WORK(IZ), 1)
              ELSE
                 CALL DAXPY( ZSIZ, V(K),
     $                       Q(IIZ2,JJZ2+IZ1), LDQ, WORK(IZ), 1)
              ENDIF
              END IF
           END DO
!$OMP END DO
        END IF
      END DO
*
      END IF
*
!$OMP BARRIER
*
! HERE, WE NEED FLOATING-SUMUP TO RETRIVE THE VECTOR WORK ONTO Z
!$OMP MASTER
      call MPI_ALLREDUCE( WORK( 1 ), Z( 1 ),
     $                       N, MPI_DOUBLE_PRECISION,
     $                       MPI_SUM, TRD_COMM_WORLD, ERR_MPI )
!$OMP END MASTER
*
!$OMP BARRIER
*
      RETURN
*

*     End of MY_PDLAEDZ
*
      END

      subroutine eigen_hrd_v(
     &             ur_x,ui_x, vr_x,vi_x, vr_y,vi_y,
     &             u_t,v_t,
     &             beta, n,x_pos,nv
     &           )
!----
      use communication_h, only : reduce_dbl
     &               , datacast_dbl
!----
      implicit none

      integer, intent(in)    :: n, nv
      real(8), intent(in)    :: ur_x(1:nv)
      real(8), intent(inout) :: vr_x(1:nv), vr_y(1:nv)
      real(8), intent(in)    :: ui_x(1:nv)
      real(8), intent(inout) :: vi_x(1:nv), vi_y(1:nv)
      real(8), intent(inout) :: u_t(1:nv),  v_t(1:nv)

!---- real(8) ::  alpha, beta, gamma, theta
      real(8) ::  alpha(1), gamma(1), theta(1)
      real(8) ::  beta
      integer ::  j_1, j_2, j_3, x_pos

      real(8) ::  vr_x0, vi_x0
      real(8) ::  ur_x0, ui_x0

      include 'trd.h'

!----
      j_2 = 1
      j_3 = n
!----
! v':= v-((u,v)/2|u|^2)u
!----
      alpha(1) = 0.0d+00
      gamma(1) = 0.0d+00
      do j_1=j_2,j_3
         gamma(1) = gamma(1)+abs(vr_x(j_1))
     &                      +abs(vi_x(j_1))
      enddo! j_1
      call reduce_dbl(gamma, theta, 1, mpi_comm_col)
      if(gamma(1)/=0.0d+00)then
         do j_1=j_2,j_3
            vr_x0 = vr_x(j_1)
            vi_x0 = vi_x(j_1)
            vr_x0 = vr_x0/(gamma(1)*beta)
            vi_x0 = vi_x0/(gamma(1)*beta)
            ur_x0 = ur_x(j_1)
            ui_x0 = ui_x(j_1)
            alpha(1)     = alpha(1)+vr_x0*ur_x0
     &                             +vi_x0*ui_x0
            vr_x(j_1) = vr_x0
            vi_x(j_1) = vi_x0
         enddo! j_1
         alpha(1) = alpha(1)*gamma(1)
      endif
      call reduce_dbl(alpha, theta, 1, mpi_comm_col)
      alpha(1) = alpha(1)/(beta+beta)
      do j_1=j_2,j_3
         vr_x0 = vr_x(j_1)
         ur_x0 = ur_x(j_1)
         vi_x0 = vi_x(j_1)
         ui_x0 = ui_x(j_1)
         vr_x0 = gamma(1)*vr_x0-alpha(1)*ur_x0
         vi_x0 = gamma(1)*vi_x0-alpha(1)*ui_x0
         vr_x(j_1) = vr_x0
         vi_x(j_1) = vi_x0
      enddo! j_1
      call datacast_dbl(vr_y(1), vr_x(1), u_t(1), v_t(1), x_pos)
      call datacast_dbl(vi_y(1), vi_x(1), u_t(1), v_t(1), x_pos)

      return
      end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_Force
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!    Further modification by T. Yamasaki   Apr/10/2007
!    Further modification by T. Yamasaki   Aug/31/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

#ifndef NO_FORCE_DGEMM
#define FORCE_DGEMM
#endif

module m_Force
! $Id: m_Force.F90 606 2020-04-15 06:45:49Z ktagami $
  use m_IterationNumbers,     only : iteration_ionic
  use m_Charge_Density,       only : chgq_l, hsr
  use m_Electronic_Structure, only : zaj_l,vlhxcQ,occup_l,eko_l &
       &                           , fsr_l,fsi_l,vlhxc_l
  use m_Realspace,            only : nmesh_rs_max
  use m_NonLocal_Potential,   only : snl,snld_rs
  use m_XC_Potential,         only : vxc_l, vxcpc_l
  use m_XC_Potential,         only : m_XC_cal_potential
  use m_Kpoints,              only : k_symmetry
  use m_PlaneWaveBasisSet,    only : ngabc, nbmx, nbase, iba, kgp, kg1, ylm_l &
       &                           , m_pwBS_sphrp2,igfp_l
  use m_PseudoPotential,      only : nlmta,q,ilmt,lmtt,lmta,ltp,mtp,isph,dl2p,modnrm&
       &                           , dion,taup,il2p,iqitg,qitg_l, psc_l, rhpcg_l, itpcc &
       &                           , ival, nqitg, nlmtt &
       &                           , m_PP_find_maximum_l,m_PP_include_vanderbilt_pot &
       &                           , m_PP_set_index_arrays1,m_PP_set_index_arrays2 &
       &                           , ipaw, dion_paw
  use m_Crystal_Structure,    only : rltv, nopr, op, univol, altv, sw_supercell_symmetry
  use m_Ionic_System,         only : natm,natm2,iwei,imdtyp,ityp,ntyp,nfcatm,cps &
       &                           , ntyp_vdw,fxyzvdw_l,imdtypxyz,iatomn &
       &                           , nopr_supercell, napt_supercell, iop_supercell
  use m_Ionic_System,         only : num_regions, regions
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : nspin, ipriforce, forccr, kimg, neg, af, nel_Ylm &
       &                           , f_tolerable_norm_error, f_tolerable_angle_error, f_tolerable_hyper_angle_error &
       &                           , sw_dipole_correction, sw_screening_correction, elec_field, sw_fef, sw_rspace &
       &                           , sw_vdw_correction, vdw_method &
#ifdef ENABLE_ESM_PACK
       &                           , m_CtrlP_cachesize, sw_hybrid_functional,sw_esm
#else
       &                           , m_CtrlP_cachesize, sw_hybrid_functional
#endif
  use m_Const_Parameters,     only : DP, zi, EXECUT, SKIP, PAI, PAI2, PAI4, DELTA, ON&
       &                           , Partial_Core_Charge, SIMPLE_CUBIC, GDIIS&
       &                           , RELAX, BONDLENGTH_FIX, BONDLENGTH_FIX_1 &
       &                           , BONDLENGTH_FIX_2, COG_FIX, HEAT_BATH, VXC_AND_EXC &
       &                           , WITHOUTTAG, WITHTAG, GAMMA &
       &                           , VDW_DFTD3
  use m_Parallelization,      only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr &
       &                           , map_k,myrank_k,np_e, ista_fs, iend_fs, ista_k, iend_k
  use m_Dipole,               only : dipole,field
  use m_Screening,            only : screening
#ifdef FORCE_DGEMM
! <-- T.Kokubo & D.Fukata, Feb. 2010
  use m_Control_Parameters,   only : nblocksize_force_is_given, nblocksize_force, nb_force_default
! -->
#endif

! =============================== added by K. Tagami ======================== 11.0
  use m_Control_Parameters,     only : noncol, ndim_spinor, ndim_magmom
  use m_PseudoPotential,        only : dion_scr_noncl, q_noncl
  use m_Const_Parameters,       only : CMPLDP
! ============================================================================ 11.0

  use m_FFT,                  only : fft_box_size_CD,nfftps
  use m_ES_nonlocal,          only : betar_dot_Psi_4_each_k_in_rs0

! === Positron ==== 2015/11/28
  use m_Control_Parameters,  only : sw_positron, positron_method
  use m_Const_Parameters,    only : Positron_GGGC, OFF
  use  m_Positron_Wave_Functions,  only : pchg_l
! ================= 2015/11/28

  use m_Control_Parameters,  only : sw_opencore
  use m_PS_opencore,  only : has_opencore, rmag_opencore_l, mag_opencore_pol

  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable, dimension(:,:)       :: forc_l
  real(kind=DP)                                    :: forcmx
  real(kind=DP), private,allocatable, dimension(:,:)   :: fnlxyz_l, flhxcq_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: force_previous
  integer, private ::                                 force_error_check_counter = 0
!  real(kind=DP), private,pointer, dimension(:,:)   :: fdip_l,fext_l
!  real(kind=DP), private,pointer, dimension(:,:)   :: ffef_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: fdip_l,fext_l
  real(kind=DP), private,allocatable, dimension(:,:)   :: ffef_l
  real(kind=DP), allocatable, dimension(:,:)   :: fexx_l

!!$  real(kind=DP), private,allocatable,target,dimension(:):: zfcos, zfsin
  integer,       private,pointer, dimension(:)     :: il3
  real(kind=DP), private,pointer, dimension(:,:)   :: work
  real(kind=DP), private,pointer, dimension(:)     :: ylm
  real(kind=DP), private,pointer, dimension(:)     :: ar, ai
  real(kind=DP), private,pointer, dimension(:,:,:) :: gr,gi ! derivative of (fsr,fsi)
  real(kind=DP), private,pointer, dimension(:,:)   :: forc_up, forc_down, forcw
  integer,       private,pointer, dimension(:)     :: ipfrc
  integer,       private  :: iteration_ionic_wd_forcmx = 0
contains
  subroutine m_Force_alloc
    if(allocated(forc_l)) deallocate(forc_l)
    allocate(forc_l(natm,3));forc_l=0.d0
    allocate(fnlxyz_l(natm,3))
    allocate(flhxcq_l(natm,3))
    if(sw_dipole_correction==ON) then
      allocate(fdip_l(natm,3))
      allocate(fext_l(natm,3))
    end if
    if(sw_fef == ON) allocate(ffef_l(natm,3))
    if(sw_hybrid_functional == ON) allocate(fexx_l(natm,3))
  end subroutine m_Force_alloc

  subroutine m_Force_sumup_and_symmetrize(nfout,fxyzew_l,napt)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: fxyzew_l
    integer,intent(in), dimension(natm,nopr+af)     :: napt
    
    integer :: ia, j, k, iat
    integer,save :: id_sname = -1

    call tstatc0_begin('m_Force_sumup_and_symmetrize ',id_sname)
#ifdef __TIMER_SUB__
    call timer_sta(1506)
#endif
    if(ipriforce >= 2) then
       write(nfout,'(" force elements ")')
       write(nfout,'(" -- forc_l (local+pcc) --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- fnlxyz_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(fnlxyz_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- fxyzew_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(fxyzew_l(ia,j),j=1,3)
       end do
       write(nfout,'(" -- flhxcq_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(flhxcq_l(ia,j),j=1,3)
       end do
       if(sw_dipole_correction==ON) then
          write(nfout,'(" -- fdip_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fdip_l(ia,j),j=1,3)
          end do
          write(nfout,'(" -- fext_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fext_l(ia,j),j=1,3)
          end do
       end if
       if(sw_fef == ON) then
          write(nfout,'(" -- ffef_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(ffef_l(ia,j),j=1,3)
          end do
       end if
       if(ntyp_vdw>0) then
          write(nfout,'(" -- fxyzvdw_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fxyzvdw_l(ia,j),j=1,3)
          end do
       end if
       if(num_regions>0) then
          write(nfout,'(" -- force from regions --")')
          do k=1,num_regions
          write(nfout,'(a,i5)') ' from region ',k
          do iat = 1, regions(k)%ntarget_atoms
             ia = regions(k)%target_atoms(iat)
             write(nfout,'(i5,3f16.8)') ia,(regions(k)%forc(ia,j),j=1,3)
          end do
          enddo
       endif
       if(sw_hybrid_functional == ON) then
          write(nfout,'(" -- fexx_l --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(fexx_l(ia,j),j=1,3)
          end do
       end if
    end if

    forc_l = forc_l + fnlxyz_l + fxyzew_l + flhxcq_l
    if(sw_dipole_correction==ON) then
       forc_l = forc_l + fdip_l + fext_l
    end if
    if(sw_fef==ON) forc_l = forc_l + ffef_l
    if(sw_hybrid_functional==ON) forc_l = forc_l + fexx_l
    if(ntyp_vdw>0 .or. sw_vdw_correction == ON .and. vdw_method == VDW_DFTD3) then
       forc_l = forc_l + fxyzvdw_l
    end if

    if(num_regions>0) then
        do k=1,num_regions
           forc_l = forc_l + regions(k)%forc
        enddo
    endif

    if(ipriforce >= 2) then
       write(nfout,'(" -- total forc_l --")')
       do ia = 1, natm
          write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
          call flush(nfout)
       end do
    end if
!!$    if(nbztyp >= SIMPLE_CUBIC) then
    if(nopr >= 2) then
       allocate(forcw(natm,3)); allocate(ipfrc(natm2))
!!$       write(6,'(" sw_supercell_symmetry = ",i8)') sw_supercell_symmetry
       call flush(6)
       if(nopr_supercell <= nopr .or. sw_supercell_symmetry /= ON) then
          call fd_symmetrize(natm2,natm,natm,napt,nopr+af,nopr,op,iwei &
               &, forc_l, forcw, ipfrc) ! -(bottom_Subroutines_para)
!!$          call fd_symmetrize(natm2,natm,natm,napt,nopr+af,op,nopr+af,nopr &
!!$               & ,iwei, forc_l, forcw, ipfrc) ! -(bottom_Subroutines_para)
       else
!!$          call fd_symmetrize(natm2,natm,natm,napt_supercell,nopr_supercell,op,nopr+af,nopr_supercell &
!!$               & ,iwei, forc_l, forcw, ipfrc, iop_supercell)
          call fd_supercell_symmetrize(natm2,natm,natm,napt_supercell,nopr_supercell,op,nopr+af,iwei &
               & ,forc_l, forcw, ipfrc, iop_supercell)
       end if
       deallocate(forcw); deallocate(ipfrc)
       if(ipriforce >= 2) then
          write(nfout,'(" -- total forc_l symmetrized --")')
          do ia = 1, natm
             write(nfout,'(i5,3f16.8)') ia,(forc_l(ia,j),j=1,3)
          end do
       end if
    end if
#ifdef __TIMER_SUB__
    call timer_end(1506)
#endif

  end subroutine m_Force_sumup_and_symmetrize

  subroutine m_Force_term_Elocal_and_Epc(nfout,pos)
    integer, intent(in) :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: pos 
    real(kind=DP), allocatable,dimension(:):: zfcos, zfsin
    integer :: ia, it, ipc
    integer :: id_sname = -1
    complex(kind=CMPLDP),allocatable,dimension(:) :: aux
    integer :: ig,ikm,kimgtmp
    real(kind=DP), allocatable, dimension(:,:) :: forc_l_esm
    real(kind=DP), allocatable, dimension(:,:) :: agauss,bgauss
    real(kind=DP), dimension(2) :: alp,cc
    real(kind=DP) :: ivaltmp
    integer :: i,j,itpcctmp,nfftcd
    call tstatc0_begin('m_Force_term_Elocal_and_Epc ', id_sname,1)
    allocate(forcw(natm,3))
    allocate(zfsin(ista_kngp:iend_kngp))
    allocate(zfcos(ista_kngp:iend_kngp))
#ifndef REMOVE_PC_FROM_FORCE
    call m_XC_cal_potential(nfout,Partial_Core_Charge,chgq_l,VXC_AND_EXC)
                                               !  -> vxcpc_l
#endif
    forcw = 0.d0
    do ia = 1, natm
       it = ityp(ia); ipc = itpcc(it)
       call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
       call force_from_Elocal_4_each_atom ! -(contained here) ->forcw
       if(ipc /= 0 ) call force_from_Epc_for_each_atom    ! -> forcw
    end do

    do ia = 1, natm
       call pucv2cart(rltv,forcw(ia,1),forcw(ia,2),forcw(ia,3))
       forc_l(ia,1:3) = forc_l(ia,1:3) + forcw(ia,1:3)
    end do

    deallocate(zfcos,zfsin)
    deallocate(forcw)

#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON)then
       nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
       allocate(aux(nfftcd));aux(:) = (0.d0,0.d0)
       allocate(agauss(natm,2))
       allocate(bgauss(natm,2))
       do i=1,natm
          call psbhs0(nfout,nint(iatomn(ityp(i))),ivaltmp,itpcctmp,alp,cc)  ! -(b_PseudoPotential)
          agauss(i,1) = alp(1)
          agauss(i,2) = alp(2)
          bgauss(i,1) = cc(1)
          bgauss(i,2) = cc(2)
       enddo
       do ig=ista_kngp,iend_kngp
         if(kimg==1)then
           if(nspin==1)then
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1),0.0d0)
           else
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1)+chgq_l(ig,1,2),0.0d0)
           endif
         else
           if(nspin==1)then
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1),chgq_l(ig,2,1))
           else
             aux(igfp_l(ig)) = dcmplx(chgq_l(ig,1,1)+chgq_l(ig,1,2),chgq_l(ig,2,1)+chgq_l(ig,2,2))
           endif
         endif
       enddo
       allocate(forc_l_esm(3,natm));forc_l_esm=0.d0
       call mpi_allreduce(MPI_IN_PLACE,aux,nfftps/kimg,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
       call esm_force_lc_(nfftcd,aux,natm,forc_l_esm,2,agauss,bgauss)
       do i=1,natm
          do j=1,3
             forc_l(i,j) = forc_l(i,j) + forc_l_esm(j,i)*0.5d0
          enddo
       enddo
       deallocate(aux)
       deallocate(forc_l_esm)
       deallocate(agauss,bgauss)
    endif
#endif

    call tstatc0_end(id_sname)
  contains
    subroutine force_from_Epc_for_each_atom
      integer :: is, i
      real(kind=DP) :: tp, weight
      real(kind=DP), dimension(3) :: f1, f2
      real(kind=DP), dimension(3) :: f1_mpi, f2_mpi ! MPI

! ============================ added by K. Tagami ===================== 11.0
      integer :: is_max
! ===================================================================== 11.0

      f1 = 0.d0
      f2 = 0.d0
      f1_mpi = 0.d0
      f2_mpi = 0.d0

#ifdef NEC_TUNE_SMP
!CDIR NOCONCUR
#endif

! =============================== added by K. Tagami ==================== 11.0
      if ( noncol ) then
         is_max = 1
      else
         is_max = nspin
      endif
! ======================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!      do is = 1, nspin
      do is = 1, is_max
! ======================================================================== 11.0

         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tp  = zfsin(i)*vxc_l(i,1,is)*rhpcg_l(i,ipc)
               f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
               f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
               f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
            end do
         else if(kimg == 2) then
!!$#ifdef NEC_TUNE_SMP
!!$!CDIR INNER
!!$#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tp  = (zfsin(i)*vxc_l(i,1,is)+zfcos(i)*vxc_l(i,2,is))&
                    &*rhpcg_l(i,ipc)
               f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
               f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
               f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
            end do
         end if
      end do

      if ( sw_opencore == ON .and. nspin == 2 ) then
         if ( has_opencore(it) == 1 ) then
            if ( noncol ) then
            else
               do is = 1, is_max
                  if ( is == 1 ) then
                     weight = 0.5d0 *mag_opencore_pol(ia,1)
                  else
                     weight = -0.5d0 *mag_opencore_pol(ia,1)
                  endif
                  
                  if ( kimg == 1 ) then
                     do i = ista_kngp, iend_kngp  !for mpi
                        tp  = zfsin(i)*vxc_l(i,1,is) *rmag_opencore_l(i,it) *weight
                        f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
                        f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
                        f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
                     end do
                  else if ( kimg == 2 ) then
                     do i = ista_kngp, iend_kngp  !for mpi
                        tp  = (zfsin(i)*vxc_l(i,1,is)+zfcos(i)*vxc_l(i,2,is))&
                             &   *rmag_opencore_l(i,it) *weight
                        f1_mpi(1) = f1_mpi(1) + tp*ngabc(i,1)
                        f1_mpi(2) = f1_mpi(2) + tp*ngabc(i,2)
                        f1_mpi(3) = f1_mpi(3) + tp*ngabc(i,3)
                     end do
                  endif
               end do
            endif
         end if
      endif

      call mpi_allreduce(f1_mpi,f1,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

! ================================ modified by K. Tagami =================== 11.0
!!      if(nspin == 2) f1 = f1/2.d0
!
      if ( noncol ) then
      else
         if(nspin == 2) f1 = f1/2.d0
      endif
! =========================================================================== 11.0

#ifndef REMOVE_PC_FROM_FORCE
      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  !for mpi
            tp  = zfsin(i)*vxcpc_l(i,1)*rhpcg_l(i,ipc)
            f2_mpi(1) = f2_mpi(1) + tp*ngabc(i,1)
            f2_mpi(2) = f2_mpi(2) + tp*ngabc(i,2)
            f2_mpi(3) = f2_mpi(3) + tp*ngabc(i,3)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  !for mpi
            tp  = (zfsin(i)*vxcpc_l(i,1)+zfcos(i)*vxcpc_l(i,2))*rhpcg_l(i,ipc)
            f2_mpi(1) = f2_mpi(1) + tp*ngabc(i,1)
            f2_mpi(2) = f2_mpi(2) + tp*ngabc(i,2)
            f2_mpi(3) = f2_mpi(3) + tp*ngabc(i,3)
         end do
!xocl end spread
      end if
      call mpi_allreduce(f2_mpi,f2,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
!!$      forcw(ia,1) = forcw(ia,1) + (f1(1)/nspin - f2(1))*univol
!!$      forcw(ia,2) = forcw(ia,2) + (f1(2)/nspin - f2(2))*univol
!!$      forcw(ia,3) = forcw(ia,3) + (f1(3)/nspin - f2(3))*univol
      forcw(ia,1) = forcw(ia,1) + (f1(1) - f2(1))*univol
      forcw(ia,2) = forcw(ia,2) + (f1(2) - f2(2))*univol
      forcw(ia,3) = forcw(ia,3) + (f1(3) - f2(3))*univol
#else
!!$      forcw(ia,1) = forcw(ia,1) + (f1(1)/nspin)*univol
!!$      forcw(ia,2) = forcw(ia,2) + (f1(2)/nspin)*univol
!!$      forcw(ia,3) = forcw(ia,3) + (f1(3)/nspin)*univol
      forcw(ia,1) = forcw(ia,1) + f1(1)*univol
      forcw(ia,2) = forcw(ia,2) + f1(2)*univol
      forcw(ia,3) = forcw(ia,3) + f1(3)*univol
#endif

    end subroutine force_from_Epc_for_each_atom

    subroutine force_from_Elocal_4_each_atom
      integer :: is, i
      real(kind=DP) :: tmp
      real(kind=DP) :: fx,fy,fz
      real(kind=DP), pointer, dimension(:) :: f1_mpi,f2_mpi ! MPI

! ============================ added by K. Tagami ===================== 11.0
      integer :: is_max
! ===================================================================== 11.0

      fx = 0.d0; fy = 0.d0; fz = 0.d0
      allocate(f1_mpi(3)); allocate(f2_mpi(3))              ! MPI

#ifdef NEC_TUNE_SMP
!CDIR NOCONCUR
#endif

! =============================== added by K. Tagami ==================== 11.0
      if ( noncol ) then
         is_max = 1
      else
         is_max = nspin
      endif
! ======================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!      do is = 1, nspin
      do is = 1, is_max
! ======================================================================== 11.0

         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tmp = zfsin(i)*chgq_l(i,1,is)*psc_l(i,it)
               if(sw_screening_correction==ON) then
                 tmp = zfsin(i)*chgq_l(i,1,is)*(psc_l(i,it)-ival(it)*screening%phik(i)/univol)
               end if
               fx = fx + tmp*ngabc(i,1)
               fy = fy + tmp*ngabc(i,2)
               fz = fz + tmp*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ista_kngp, iend_kngp  !for mpi
               tmp = (zfsin(i)*chgq_l(i,1,is)+zfcos(i)*chgq_l(i,2,is))&
                    &*psc_l(i,it)
               if(sw_screening_correction==ON) then
                 tmp = (zfsin(i)*chgq_l(i,1,is)+zfcos(i)*chgq_l(i,2,is))&
                      &*(psc_l(i,it)-ival(it)*Screening%phik(i)/univol)
               end if
               fx = fx + tmp*ngabc(i,1)
               fy = fy + tmp*ngabc(i,2)
               fz = fz + tmp*ngabc(i,3)
            end do
         end if
      end do

! == POSITRON SCF === 2015/11/28
      if ( sw_positron /= OFF ) then
         if ( positron_method == Positron_GGGC ) then
            if(kimg == 1) then
               do i = ista_kngp, iend_kngp  !for mpi
                  tmp = -zfsin(i) *pchg_l(i,1) *psc_l(i,it)
                  fx = fx + tmp*ngabc(i,1)
                  fy = fy + tmp*ngabc(i,2)
                  fz = fz + tmp*ngabc(i,3)
               end do
            else
               do i = ista_kngp, iend_kngp  !for mpi
                  tmp = -( zfsin(i) *pchg_l(i,1) +zfcos(i)*pchg_l(i,2) )&
                       &  *psc_l(i,it)
                  fx = fx + tmp*ngabc(i,1)
                  fy = fy + tmp*ngabc(i,2)
                  fz = fz + tmp*ngabc(i,3)
               end do
            endif
         endif
      endif
! ============= 2015/11/28

      f1_mpi(1) = fx; f1_mpi(2) = fy; f1_mpi(3) = fz
      call mpi_allreduce(f1_mpi,f2_mpi,3 &
           &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
      forcw(ia,1:3) = f2_mpi(1:3)*univol
      deallocate(f2_mpi); deallocate(f1_mpi)
    end subroutine force_from_Elocal_4_each_atom
  end subroutine m_Force_term_Elocal_and_Epc

  subroutine m_Force_initialize
#ifdef __TIMER_SUB__
    call timer_sta(1501)
#endif
    forc_l = 0.d0
#ifdef __TIMER_SUB__
    call timer_end(1501)
#endif
  end subroutine m_Force_initialize

  subroutine m_Force_term_drv_of_vlhxcQ(nfout,pos,napt)
    !  ----
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    integer,intent(in)                           :: nfout
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)  :: napt

    real(kind=DP), allocatable, dimension(:)                  :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:)        :: ylm_ext
    real(kind=DP), allocatable, dimension(:):: zfcos, zfsin

#ifndef _VECTOR_TUNING_
    real(kind=DP), allocatable, dimension(:,:) :: flhxcq_mpi
    real(kind=DP), allocatable, dimension(:) :: ylm_sum
    integer :: ncache, ibsize, iwidth, ibl1, ibl2, iwidthmax
#endif

#ifndef _m_Force_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif
    
! ============================ added by K. Tagami ===================== 11.0
    integer :: is_max
! ===================================================================== 11.0

    integer :: is,it,lmt1,lmt2,n,ia,mdvdb,il1,tau1,il2,tau2,ilm3,l3,iiqitg
    real(kind=DP) :: fx,fy,fz,shdg_x
    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_vlhxcQ ',id_sname,1)

    call m_PP_find_maximum_l(n)
    n = (n-1) + (n-1) + 1

    if(modnrm == EXECUT) then
       allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
       if(n**2 > nel_Ylm) then
          allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2)); ylm_ext = 0.d0
       end if
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)

#ifndef _m_Force_no_loop_exchange_
       allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
       allocate(iq2l3(nqitg))
       allocate(nc(mcritical,nqitg));nc=0
       call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
            & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)  ! -> nqitg_sp, nqitg_sp0, iq2l3,nc, maxm, mc
       allocate(nc2lmt1(mc,maxm,nqitg))
       allocate(nc2lmt2(mc,maxm,nqitg))
       allocate(nc2n(mc,maxm,nqitg))
       call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
            & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif
       
    end if

! =============================== added by K. Tagami ==================== 11.0
    if ( noncol ) then 
       is_max = ndim_magmom
    else
       is_max = nspin
    endif
! ======================================================================== 11.0

    flhxcq_l = 0.d0
#ifdef _VECTOR_TUNING_
    allocate(zfcos(ista_kngp:iend_kngp))
    allocate(zfsin(ista_kngp:iend_kngp))
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle

       do ia= 1,natm
          if(ityp(ia) /= it) cycle
          fx = 0.d0; fy = 0.d0; fz = 0.d0
          call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)

! ========================================= modified by K. Tagami ========= 11.0
!          do is = 1, nspin, af+1
          do is = 1, is_max, af+1
! ========================================================================= 11.0

#ifndef _m_Force_no_loop_exchange_
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
                   call sum_hsr_dot_gauntc(is,it,ia,iq,m)
                   if(ilm3 <= nel_Ylm) then
                      ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                   else
                      ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                   end if
                   call add_hardpart_to_flhxcq_l_core(iq,ista_kngp,iend_kngp)
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                   !   --> fx,fy,fz
                end do
             end do
#else
             do lmt1 = 1, ilmt(it)
                il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
                do lmt2 = lmt1, ilmt(it)
                   il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
                   do n = 1, il2p(lmt1,lmt2,it)
                      ilm3 = isph(lmt1,lmt2,n,it);    l3   =  il3(ilm3)
                      iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                      if(iiqitg == 0) cycle
                      call hsr_dot_gaunt(is,it,ia,lmt1,lmt2,n) 
                      if(ilm3 <= nel_Ylm) then
                         ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
                      else
                         ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
                      end if
                      call add_hardpart_to_flhxcq_l_core(iiqitg,ista_kngp,iend_kngp)
                      !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                      !   --> fx,fy,fz
                   end do ! n
                end do ! lmt2
             end do
#endif
          end do
          call pucv2cart(rltv,fx,fy,fz)
!!$       call fxyz_gsum(fx,fy,fz)
          flhxcq_l(ia,1) = fx; flhxcq_l(ia,2) = fy; flhxcq_l(ia,3) = fz
       end do
    end do
    deallocate(zfsin, zfcos)
#else

#ifndef _m_Force_no_loop_exchange_
    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) ibsize = iend_kngp - ista_kngp + 1

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       if(ipriforce >= 2) write(nfout,'(" !mForce: it = ",i8)') it
       
       if(ncache/=0) then
          iwidth = nqitg_sp(it) - nqitg_sp0(it) + 1
          if(kimg == 1) then ! qitg_l(i,iq)*ylm(iy)*zfsc1_1(iy)
             ibsize=ncache/(8*(iwidth + 1))
          else ! qitg_l(i,iq),ylm(iy),zfsc1_1(iy),zfsc2_1(iy)
             ibsize=ncache/(8*(iwidth + 2))
          endif
          if(ipriforce >= 2) write(nfout,'(" !mForce: ibsize, iwidth, ncache = ",3i8)') ibsize, iwidth, ncache
       end if

       IBLOCK: do ibl1=ista_kngp,iend_kngp,ibsize
          ibl2=ibl1+ibsize-1
          if(ibl2.gt.iend_kngp) ibl2=iend_kngp
          if(ibl2.gt.kgp) ibl2 = kgp
          allocate(ylm_sum(ibl1:ibl2))
          allocate(zfcos(ibl1:ibl2)); allocate(zfsin(ibl1:ibl2))

       do ia= 1,natm
          if(ityp(ia) /= it) cycle
          fx = 0.d0; fy = 0.d0; fz = 0.d0
          call calc_phase_div(ia)  ! -> zfsin, zfcos

! ========================================= modified by K. Tagami ========= 11.0
!          do is = 1, nspin, af+1
             do is = 1, is_max, af+1
! ========================================================================= 11.0

             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                ylm_sum = 0.d0
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
                   call sum_hsr_dot_gauntc(is,it,ia,iq,m)
                   if(ilm3 <= nel_Ylm) then
                      ylm_sum(ibl1:ibl2) = ylm_sum(ibl1:ibl2) + shdg_x*ylm_l(ibl1:ibl2,ilm3)
!!!$                      ylm => ylm_l(:,ilm3)
                   else
                      ylm_sum(ibl1:ibl2) = ylm_sum(ibl1:ibl2) + shdg_x*ylm_ext(ibl1:ibl2,ilm3)
!!!$                      ylm => ylm_ext(:,ilm3)
                   end if
!!!$                   call add_hardpart_to_flhxcq_l_core(iq,ibl1,ibl2)
!!!$                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!!$                   !   --> fx,fy,fz
                end do
                call add_hardpart_to_flhxcq_l_div(iq,ibl1,ibl2)
             end do
          end do
          call pucv2cart(rltv,fx,fy,fz)
          flhxcq_l(ia,1)=flhxcq_l(ia,1)+fx; flhxcq_l(ia,2)=flhxcq_l(ia,2)+fy; flhxcq_l(ia,3)=flhxcq_l(ia,3)+fz
       end do
       deallocate(zfsin,zfcos)
       deallocate(ylm_sum)
       end do IBLOCK
    end do
    if(npes>1) then
       allocate(flhxcq_mpi(natm,3)); flhxcq_mpi = 0.d0
       call mpi_allreduce(flhxcq_l,flhxcq_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       flhxcq_l = flhxcq_mpi
       deallocate(flhxcq_mpi)
    end if
#else
    stop ' you cannot define _m_Force_no_loop_exchange_'
#endif
#endif

!!$!xocl spread do/ind_natm
!!$    do ia = 1, natm
!!$       fx = flhxcq_l(ia,1); fy = flhxcq_l(ia,2); fz = flhxcq_l(ia,3)
!!$       call pucv2cart(rltv,fx,fy,fz)
!!$       flhxcq_l(ia,1) = fx; flhxcq_l(ia,2) = fy; flhxcq_l(ia,3) = fz
!!$    end do
!!$!xocl end spread

    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt&
            &, iwei,op,ipriforce,af,flhxcq_l,forc_up,forc_down)
       deallocate(forc_up); deallocate(forc_down)
    endif
    if(modnrm == EXECUT) then
       if(allocated(ylm_ext)) deallocate(ylm_ext)
       deallocate(il3)
#ifndef _m_Force_no_loop_exchange_
       deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif
    end if

    call tstatc0_end(id_sname)
  contains
#ifndef SX
    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
    end subroutine calc_phase_div
#endif

#ifndef _m_Force_no_loop_exchange_
    subroutine sum_hsr_dot_gauntc(is,it,ia,iq,m)
      integer, intent(in) :: is,it,ia,iq,m
      integer :: ip, lmt1, lmt2, np
      real(kind=DP) :: fac
      shdg_x = 0.d0
      do ip = 1, nc(m,iq)
         lmt1 = nc2lmt1(ip,m,iq)
         lmt2 = nc2lmt2(ip,m,iq)
         np = nc2n(ip,m,iq)
         fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
         shdg_x = shdg_x + &
              & fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,np,it)
      end do
    end subroutine sum_hsr_dot_gauntc
#else
    subroutine hsr_dot_gaunt(is,it,ia,lmt1,lmt2,n)
      integer, intent(in) :: is, it, ia, lmt1,lmt2,n
      real(kind=DP) :: fac
      
      fac = 2.d0; if(lmt1 == lmt2) fac = 1.d0
      shdg_x = fac*hsr(ia,lmt1,lmt2,is)*dl2p(lmt1,lmt2,n,it)
    end subroutine hsr_dot_gaunt

#endif
    subroutine add_hardpart_to_flhxcq_l_core(iq,ibl1,ibl2)
      integer, intent(in) :: iq,ibl1,ibl2
      integer       :: i, iy
      real(kind=DP) :: flchgq, f, tx,ty,tz, f2
      real(kind=DP),pointer,dimension(:) :: f1_mpi, f2_mpi
!!$      real(kind=DP),pointer,dimension(:) :: zfsc1, zfsc2

!!$      if(mod(l3,2) == 0) then
!!$         flchgq = fac*real(zi**(-l3))*dga*hsr(ia,lmt1,lmt2,is)
!!$         flchgq = real(zi**(-l3))*shdg_x
!!$         if(kimg == 1) then
!!$            zfsc1 => zfsin
!!$         else
!!$            f2 = 1;  zfsc1 => zfsin; zfsc2 => zfcos
!!$         end if
!!$      else
!!$         flchgq = - aimag(zi**(-l3))*shdg_x
!!$         if(kimg == 1) then
!!$            zfsc1 => zfcos
!!$         else
!!$            f2 = -1; zfsc1 => zfcos; zfsc2 => zfsin
!!$         end if
!!$      end if

      tx = 0.d0; ty = 0.d0; tz = 0.d0
      if(mod(l3,2) == 0) then
         flchgq = real(zi**(-l3))*shdg_x
         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
!!$               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(iy)
               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsin(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
               f = qitg_l(i,iq)*ylm(iy)*&
                    &(vlhxc_l(i,1,is)*zfsin(i)+vlhxc_l(i,2,is)*zfcos(i))
!!$                    &(vlhxc_l(i,1,is)*zfsc1(iy)+vlhxc_l(i,2,is)*zfsc2(iy))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      else
         flchgq = - aimag(zi**(-l3))*shdg_x
         if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
!!$               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(iy)
               f  = qitg_l(i,iq)*ylm(iy)*vlhxc_l(i,1,is)*zfcos(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
            do i = ibl1, ibl2  !for mpi
               iy = i-ista_kngp+1
               f = qitg_l(i,iq)*ylm(iy)*&
                    &(vlhxc_l(i,1,is)*zfcos(i)-vlhxc_l(i,2,is)*zfsin(i))
!!$                    &(vlhxc_l(i,1,is)*zfsc1(iy)-vlhxc_l(i,2,is)*zfsc2(iy))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      end if

      if(npes > 1) then
         allocate(f1_mpi(3)); allocate(f2_mpi(3))
         f1_mpi(1) = tx; f1_mpi(2) = ty; f1_mpi(3) = tz  ! MPI
         call mpi_allreduce(f1_mpi,f2_mpi,3 &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) ! MPI
         tx = f2_mpi(1); ty = f2_mpi(2); tz = f2_mpi(3)
         deallocate(f2_mpi); deallocate(f1_mpi)
      end if
      fx = fx + flchgq*tx*univol
      fy = fy + flchgq*ty*univol
      fz = fz + flchgq*tz*univol

    end subroutine add_hardpart_to_flhxcq_l_core

#ifndef SX
    subroutine add_hardpart_to_flhxcq_l_div(iq,ibl1,ibl2)
      integer, intent(in) :: iq,ibl1,ibl2
      integer       :: i
      real(kind=DP) :: flchgq, f, tx,ty,tz, f2
      real(kind=DP),pointer,dimension(:) :: f1_mpi, f2_mpi

      tx = 0.d0; ty = 0.d0; tz = 0.d0
      if(mod(l3,2) == 0) then
         flchgq = real(zi**(-l3))
         if(kimg == 1) then
            do i = ibl1, ibl2  !for mpi
               f  = qitg_l(i,iq)*ylm_sum(i)*vlhxc_l(i,1,is)*zfsin(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
            do i = ibl1, ibl2  !for mpi
               f = qitg_l(i,iq)*ylm_sum(i)*&
                    &(vlhxc_l(i,1,is)*zfsin(i)+vlhxc_l(i,2,is)*zfcos(i))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      else
         flchgq = - aimag(zi**(-l3))
         if(kimg == 1) then
            do i = ibl1, ibl2  !for mpi
               f  = qitg_l(i,iq)*ylm_sum(i)*vlhxc_l(i,1,is)*zfcos(i)
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         else if(kimg == 2) then
            do i = ibl1, ibl2  !for mpi
               f = qitg_l(i,iq)*ylm_sum(i)*&
                    &(vlhxc_l(i,1,is)*zfcos(i)-vlhxc_l(i,2,is)*zfsin(i))
               tx = tx + f*ngabc(i,1);  ty = ty + f*ngabc(i,2)
               tz = tz + f*ngabc(i,3)
            end do
         end if
      end if

!!$      if(npes > 1) then
!!$         allocate(f1_mpi(3)); allocate(f2_mpi(3))
!!$         f1_mpi(1) = tx; f1_mpi(2) = ty; f1_mpi(3) = tz  ! MPI
!!$         call mpi_allreduce(f1_mpi,f2_mpi,3 &
!!$              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) ! MPI
!!$         tx = f2_mpi(1); ty = f2_mpi(2); tz = f2_mpi(3)
!!$         deallocate(f2_mpi); deallocate(f1_mpi)
!!$      end if
      fx = fx + flchgq*tx*univol
      fy = fy + flchgq*ty*univol
      fz = fz + flchgq*tz*univol

    end subroutine add_hardpart_to_flhxcq_l_div
#endif
  end subroutine m_Force_term_drv_of_vlhxcQ

#ifdef FORCE_DGEMM
! <-- T.Kokubo & D.Fukata, Feb. 2010
  subroutine m_Force_term_drv_of_flmt(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer       :: id_sname = -1
    integer :: ibsize,ibl1,ibl2, is,ik,iksnl,ia,it,mdvdb,aoffset
    real(kind=DP) :: fac, fx, fy, fz

    integer, allocatable, dimension(:)       :: mil_tmp
    integer, allocatable, dimension(:,:)     :: ngabc_red
    real(kind=DP),allocatable,dimension(:,:) :: zfsin,  zfcos   ! MPI
    real(kind=DP),allocatable,dimension(:,:,:) :: ar_tmp, ai_tmp  ! MPI
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:,:,:) :: fr,fi
    real(kind=DP),dimension(3) :: tmpsum
    integer :: ii,ncount

      call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)
      allocate( gr(np_e,nlmta,3) )    ! MPI
      allocate( gi(np_e,nlmta,3) )    ! MPI
      fac = 2.d0/kv3
      fnlxyz_l = 0.d0

      if(nblocksize_force_is_given) then
         ibsize = nblocksize_force
      else
         ibsize= nb_force_default
      end if
      if(ipriforce >=2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
      allocate(   mil_tmp(nlmta)    );   mil_tmp = 0
      allocate( ngabc_red(ibsize,3) ); ngabc_red = 0
      allocate(     zfcos(ibsize,natm),      zfsin(ibsize,natm)    )
      allocate(    ar_tmp(ibsize,nlmta,3),  ai_tmp(ibsize,nlmta,3) )
      if(sw_rspace==ON)then
         allocate(fr(np_e,nlmta,ista_k:iend_k));fr=0.d0
         allocate(fi(np_e,nlmta,ista_k:iend_k));fi=0.d0
      endif
      do is = 1, nspin, af+1
         do ik = is, kv3+is-nspin,nspin
            if(map_k(ik) /= myrank_k) cycle
            iksnl = (ik-1)/nspin+1

            if(sw_rspace==ON)then
               do ii=1,3
                  fr=0.d0;fi=0.d0
                  call betar_dot_Psi_4_each_k_in_rs0(6,ista_k,iend_k,ik,zaj_l, &
               &  fr,fi,nmesh_rs_max,snld_rs(1:nmesh_rs_max,1:nlmta,ii))
                  gr(1:np_e,1:nlmta,ii) = fr(1:np_e,1:nlmta,ik)
                  gi(1:np_e,1:nlmta,ii) = fi(1:np_e,1:nlmta,ik)
               enddo
               aoffset = 0
               do ia = 1, natm
                  it = ityp(ia)
                  fx = 0.d0; fy = 0.d0; fz = 0.d0
                  mdvdb = m_PP_include_vanderbilt_pot(it)
                  if(mdvdb == EXECUT) then
                     call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                  else if(mdvdb == SKIP) then
                     call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                  end if
                  aoffset = aoffset + ilmt(it)
                  fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                  fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                  fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
               end do
            else
            do ibl1 = 1, iba(ik), ibsize
               ibl2 = ibl1+ibsize-1
               if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
               gr=0.d0
               gi=0.d0

               call substitute_ngabcred(ik)         ! ngabc,nbase                   --> ngabc_red
               call calc_phase_div()                ! pos, ngabc_red                --> zfcos, zfsin
               call pre_drv_of_betar_dot_WFs_div()  ! zfsin,zfcos,snl               --> ar_tmp,ai_tmp
               call drv_of_betar_dot_WFs_div(gr,gi) ! ar_tmp,ai_tmp,zaj_l,ngabc_red --> gr,gi

               aoffset = 0
               do ia = 1, natm
                  it = ityp(ia)
                  fx = 0.d0; fy = 0.d0; fz = 0.d0
                  mdvdb = m_PP_include_vanderbilt_pot(it)
                  if(mdvdb == EXECUT) then
                     call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                  else if(mdvdb == SKIP) then
                     call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                  end if
                  aoffset = aoffset + ilmt(it)
                  call pucv2cart(rltv,fx,fy,fz)
                  fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                  fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                  fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
                end do
            end do
            endif
         end do
      end do

      deallocate( mil_tmp, ngabc_red, zfcos, zfsin, ar_tmp, ai_tmp )
      if(sw_rspace==ON)then
         deallocate(fr)
         deallocate(fi)
      endif

      if(npes>1) then
         allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
         call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
             & , mpi_sum, mpi_comm_group,ierr)
         fnlxyz_l = fnlxyz_mpi
      end if
      if(npes>1)deallocate(fnlxyz_mpi)

      if(af /= 0) then
         allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
         call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
           & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
         deallocate(forc_down);deallocate(forc_up)
      end if

      deallocate(gi); deallocate(gr)

      if(ipriforce >= 2)  then
         write(6,'(" --- fnlxyz_l ->>")')
         do ia = 1, natm
            write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
         end do
         write(6,'(" <<- fnlxyz_l ---")')
      end if

      call tstatc0_end(id_sname)

    contains
      subroutine term_related_to_drv_of_flmt_NC
        integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i, lmt11, lmt22
        real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

        do lmt1 = 1, ilmt(it)
           lmt11 = lmt1 + aoffset
           lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)
           do lmt2 = lmt1, ilmt(it)
              lmt22 = lmt2 + aoffset
              l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)

              if ( ipaw(it) == 0 ) then
                 if(l1 /= l2 .or. m1 /= m2) cycle
                 a = dion(lmt1,lmt2,it)
              else
                 a = dion_paw(lmt1,lmt2,is,ia)
              endif
              fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac

              if(k_symmetry(ik) == GAMMA) then
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n * a *occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2 + fr1*gr(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2 + fr1*gr(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2 + fr1*gr(i,lmt22,3))
                 end do
              else
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n * a *occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2+gi(i,lmt11,1)*fi2&
             +fr1*gr(i,lmt22,1)+fi1*gi(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2+gi(i,lmt11,2)*fi2&
             +fr1*gr(i,lmt22,2)+fi1*gi(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2+gi(i,lmt11,3)*fi2&
             +fr1*gr(i,lmt22,3)+fi1*gi(i,lmt22,3))
                    end do
                 end if
           end do
        end do
      end subroutine term_related_to_drv_of_flmt_NC

      subroutine term_related_to_drv_of_flmt_VDB
        integer :: lmt1, lmta1, lmt2, lmta2, i, lmt11, lmt22
        real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
        integer       :: id_sname = -1
        call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

        do lmt1 = 1, ilmt(it)
           lmt11 = lmt1 + aoffset
           lmta1 = lmta(lmt1,ia)
           do lmt2 = lmt1, ilmt(it)
              lmt22 = lmt2 + aoffset
              lmta2 = lmta(lmt2,ia)
              fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
              if(ipaw(it)==0) then
                  a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
              else
                  a = vlhxcq(lmt1,lmt2,ia,is)+dion_paw(lmt1,lmt2,is,ia)
              end if
              if(k_symmetry(ik) == GAMMA) then
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2 + fr1*gr(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2 + fr1*gr(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2 + fr1*gr(i,lmt22,3))
                 end do
              else
                 do i = 1, np_e                                 ! MPI
                    a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                    fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                    fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                    fx  = fx - a_n * (gr(i,lmt11,1)*fr2+gi(i,lmt11,1)*fi2&
             +fr1*gr(i,lmt22,1)+fi1*gi(i,lmt22,1))
                    fy  = fy - a_n * (gr(i,lmt11,2)*fr2+gi(i,lmt11,2)*fi2&
             +fr1*gr(i,lmt22,2)+fi1*gi(i,lmt22,2))
                    fz  = fz - a_n * (gr(i,lmt11,3)*fr2+gi(i,lmt11,3)*fi2&
             +fr1*gr(i,lmt22,3)+fi1*gi(i,lmt22,3))
                 end do
              end if
           end do
        end do
        call tstatc0_end(id_sname)
      end subroutine term_related_to_drv_of_flmt_VDB

      subroutine substitute_ngabcred(ik)
        integer, intent(in) :: ik
        integer :: ig, i1
        if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
           do ig = 1, ibl2-ibl1+1
              i1 = nbase(ig+ibl1-1,ik)
              ngabc_red(ig,1) = ngabc(i1,1)
              ngabc_red(ig,2) = ngabc(i1,2)
              ngabc_red(ig,3) = ngabc(i1,3)
           end do
      end subroutine substitute_ngabcred

      subroutine calc_phase_div()
          integer :: ia, ig
          real(kind=DP) :: fx,fy,fz, ph

          do ia = 1, natm
             fx = pos(ia,1)*PAI2
             fy = pos(ia,2)*PAI2
             fz = pos(ia,3)*PAI2
             do ig = 1, ibl2-ibl1+1
                ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
                zfcos(ig,ia) = dcos(ph)
                zfsin(ig,ia) = dsin(ph)
             end do
          end do
      end subroutine calc_phase_div

      subroutine pre_drv_of_betar_dot_WFs_div()
          integer :: ia, i, t, lmt1, lmtt1, icnt, mil, fac_tmp

          icnt = 0
          if(k_symmetry(ik) == GAMMA) then
             if(kimg == 1) then   ! only ar
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  enddo
               enddo
             else if(kimg == 2) then
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     mil = mod( ltp(lmt1,it),4 )
                     if( mil.eq.1 .or. mil.eq.2 ) then
                       fac_tmp= -2.d0
                     else if( mil.eq.0 .or. mil.eq.3 ) then
                       fac_tmp=  2.d0
                     endif

                     if( mil.eq.1 .or. mil.eq.3 ) then
                         do i = ibl1, ibl2
                            ar_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ar_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ar_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                            ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         end do
                     else if( mil.eq.0 .or. mil.eq.2 ) then
                         do i = ibl1, ibl2
                            ar_tmp(i-ibl1+1,icnt,1) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ar_tmp(i-ibl1+1,icnt,2) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ar_tmp(i-ibl1+1,icnt,3) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                            ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                            ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                            ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         end do
                     endif
                  enddo
                enddo
             endif
          else
               do ia = 1, natm
                  it = ityp(ia)
                  do lmt1 = 1, ilmt(it)
                     icnt = icnt + 1
                     lmtt1 = lmtt(lmt1,it)
                     mil_tmp(icnt) = mod( ltp(lmt1,it),4 )
                      do i = ibl1, ibl2
                         ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                         ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                         ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                         ai_tmp(i-ibl1+1,icnt,1) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                         ai_tmp(i-ibl1+1,icnt,2) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                         ai_tmp(i-ibl1+1,icnt,3) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                      end do
                  enddo
                enddo
          endif
      end subroutine pre_drv_of_betar_dot_WFs_div

      subroutine drv_of_betar_dot_WFs_div(gr,gi)
        real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
        integer :: lmt1, ib, i, mil, ibl1_2
        real(kind=DP) :: br, bi, tmp1, tmp2, tmp3
        integer :: id_sname = -1
        call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

         if(k_symmetry(ik) == GAMMA) then
            if(kimg == 1) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            else if(kimg == 2) then
               ibl1_2 = max(2,ibl1)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
              &           0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
              &           1.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
              &           0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
              &           1.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
              &           0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
              &           1.d0,gr(1,1,3),np_e)
            endif
         else
            if(kimg == 1) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
            else if(kimg == 2) then
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,1),ibsize, 1.d0,gr(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,2),ibsize, 1.d0,gr(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,3),ibsize, 1.d0,gr(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,1),ibsize, 1.d0,gi(1,1,1),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,2),ibsize, 1.d0,gi(1,1,2),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
               call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,3),ibsize, 1.d0,gi(1,1,3),np_e)
            end if
            do lmt1 = 1, nlmta
               mil = mil_tmp(lmt1)
               if( mil == 1 ) then
                  do ib = 1, np_e                              ! MPI
                     tmp1 = gr(ib,lmt1,1)
                     tmp2 = gr(ib,lmt1,2)
                     tmp3 = gr(ib,lmt1,3)
                     gr(ib,lmt1,1) = -gi(ib,lmt1,1)
                     gr(ib,lmt1,2) = -gi(ib,lmt1,2)
                     gr(ib,lmt1,3) = -gi(ib,lmt1,3)
                     gi(ib,lmt1,1) = tmp1
                     gi(ib,lmt1,2) = tmp2
                     gi(ib,lmt1,3) = tmp3
                  end do
               elseif (mil == 2 ) then
                  do ib = 1, np_e                              ! MPI
                     gr(ib,lmt1,1) = - gr(ib,lmt1,1)
                     gr(ib,lmt1,2) = - gr(ib,lmt1,2)
                     gr(ib,lmt1,3) = - gr(ib,lmt1,3)
                     gi(ib,lmt1,1) = - gi(ib,lmt1,1)
                     gi(ib,lmt1,2) = - gi(ib,lmt1,2)
                     gi(ib,lmt1,3) = - gi(ib,lmt1,3)
                  end do
               elseif (mil == 3 ) then
                  do ib = 1, np_e                              ! MPI
                     tmp1 = gr(ib,lmt1,1)
                     tmp2 = gr(ib,lmt1,2)
                     tmp3 = gr(ib,lmt1,3)
                     gr(ib,lmt1,1) = gi(ib,lmt1,1)
                     gr(ib,lmt1,2) = gi(ib,lmt1,2)
                     gr(ib,lmt1,3) = gi(ib,lmt1,3)
                     gi(ib,lmt1,1) = -tmp1
                     gi(ib,lmt1,2) = -tmp2
                     gi(ib,lmt1,3) = -tmp3
                  end do
               endif
            enddo
         end if
         call tstatc0_end(id_sname)
      end subroutine drv_of_betar_dot_WFs_div
  end subroutine m_Force_term_drv_of_flmt
! -->

! ============================ added by K. Tagami ==================== 11.0
  subroutine m_Force_term_drv_of_flmt_noncl( kv3,pos,napt )
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer       :: id_sname = -1
    integer :: ibsize,ibl1,ibl2, is,ik,iksnl,ia,it,mdvdb,aoffset
    real(kind=DP) :: fac, fx, fy, fz

    integer, allocatable, dimension(:)       :: mil_tmp
    integer, allocatable, dimension(:,:)     :: ngabc_red
    real(kind=DP),allocatable,dimension(:,:) :: zfsin,  zfcos   ! MPI
    real(kind=DP),allocatable,dimension(:,:,:) :: ar_tmp, ai_tmp  ! MPI
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi

    real(kind=DP), allocatable :: gr_noncl( :,:,:,: )
    real(kind=DP), allocatable :: gi_noncl( :,:,:,: )

    call tstatc0_begin('m_Force_term_drv_of_flmt_noncl ',id_sname,1)

    allocate( gr_noncl(np_e,nlmta,3, ndim_spinor ) )    ! MPI
    allocate( gi_noncl(np_e,nlmta,3, ndim_spinor ) )    ! MPI

!!!!!!!!!!!    fac = 2.d0 / (kv3 /ndim_spinor) 
    fac = 1.d0 / (kv3 /ndim_spinor) 

    fnlxyz_l = 0.d0
    
    if(nblocksize_force_is_given) then
       ibsize = nblocksize_force
    else
       ibsize= nb_force_default
    end if
    write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt_noncl>>")') ibsize
    allocate(   mil_tmp(nlmta)    );   mil_tmp = 0
    allocate( ngabc_red(ibsize,3) ); ngabc_red = 0
    allocate(     zfcos(ibsize,natm),      zfsin(ibsize,natm)    )
    allocate(    ar_tmp(ibsize,nlmta,3),  ai_tmp(ibsize,nlmta,3) )
    
    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/nspin+1
          
       do ibl1 = 1, iba(ik), ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)

          gr_noncl = 0.d0;     gi_noncl = 0.d0
             
          call substitute_ngabcred(ik)         ! ngabc,nbase      --> ngabc_red
          call calc_phase_div()                ! pos, ngabc_red  --> zfcos, zfsin
          call pre_drv_of_betar_dot_WFs_div()  ! zfsin,zfcos,snl               --> ar_tmp,ai_tmp
          Do is=1, ndim_spinor
             call drv_of_betar_dot_WFs_div( ik+is-1, gr_noncl(:,:,:,is), &
                  &                                  gi_noncl(:,:,:,is) )
                            ! ar_tmp,ai_tmp,zaj_l,ngabc_red --> gr,gi
          End do
             
          aoffset = 0
          do ia = 1, natm
             it = ityp(ia)
             fx = 0.d0; fy = 0.d0; fz = 0.d0
             mdvdb = m_PP_include_vanderbilt_pot(it)

             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
             end if

             aoffset = aoffset + ilmt(it)
             call pucv2cart(rltv,fx,fy,fz)
             fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
             fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
             fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
          end do

       end do
    end do
    
    deallocate( mil_tmp, ngabc_red, zfcos, zfsin, ar_tmp, ai_tmp )
    
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
    
    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
            & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if
      
    deallocate(gi_noncl); deallocate(gr_noncl)
    
    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if
    
    call tstatc0_end(id_sname)

  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i, lmt11, lmt22
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP) :: zg1(3), zg2(3), zsum(3)

      do lmt1 = 1, ilmt(it)
         lmt11 = lmt1 + aoffset
         lmta1 = lmta(lmt1,ia); 

         l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)

! ==== KT_mod ======================== 2013/10/31
!!!!!!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ==================================== 2013/10/31

            lmt22 = lmt2 + aoffset
            lmta2 = lmta(lmt2,ia)

            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); 

!!!!!!            if(l1 /= l2 .or. m1 /= m2) cycle

! ==== KT_mod ======================== 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ==================================== 2013/10/31

            if (k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'

            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = dcmplx( fsr_l(i,lmta1,ik+is1-1), &
                             &       fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = dcmplx( fsr_l(i,lmta2,ik+is2-1), &
                             &       fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = dcmplx( gr_noncl(i,lmt11,:,is1), &
                             &           gi_noncl(i,lmt11,:,is1) )
                        zg2(:) = dcmplx( gr_noncl(i,lmt22,:,is2), &
                             &           gi_noncl(i,lmt22,:,is2) )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 )&
                             &              *dion_scr_noncl( lmt1,lmt2,istmp,ia )
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)
                        
                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i, lmt11, lmt22
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3
      complex(kind=CMPLDP) :: zg1(3), zg2(3), zsum(3)
      integer       :: id_sname = -1
      
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)
      
      do lmt1 = 1, ilmt(it)
         lmt11 = lmt1 + aoffset
         lmta1 = lmta(lmt1,ia)

! ==== KT_mod ======================== 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ==================================== 2013/10/31

            lmt22 = lmt2 + aoffset
            lmta2 = lmta(lmt2,ia)

! ==== KT_mod ======================== 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ==================================== 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = dcmplx( fsr_l(i,lmta1,ik+is1-1), &
                             &       fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = dcmplx( fsr_l(i,lmta2,ik+is2-1), &
                             &       fsi_l(i,lmta2,ik+is2-1) )
                        zg1(:) = dcmplx( gr_noncl(i,lmt11,:,is1), &
                             &           gi_noncl(i,lmt11,:,is1) )
                        zg2(:) = dcmplx( gr_noncl(i,lmt22,:,is2), &
                             &           gi_noncl(i,lmt22,:,is2) )

                        z3 = dion_scr_noncl( lmt1,lmt2,istmp,ia ) &
                             &  -eko_l(i,ik) *q_noncl(lmt1,lmt2,istmp,it )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 ) *z3
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)
                        
                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do

            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB
    
    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
      do ig = 1, ibl2-ibl1+1
         i1 = nbase(ig+ibl1-1,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
    end subroutine substitute_ngabcred
    
    subroutine calc_phase_div()
      integer :: ia, ig
      real(kind=DP) :: fx,fy,fz, ph
      
      do ia = 1, natm
         fx = pos(ia,1)*PAI2
         fy = pos(ia,2)*PAI2
         fz = pos(ia,3)*PAI2
         do ig = 1, ibl2-ibl1+1
            ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
            zfcos(ig,ia) = dcos(ph)
            zfsin(ig,ia) = dsin(ph)
         end do
      end do
    end subroutine calc_phase_div
    
    subroutine pre_drv_of_betar_dot_WFs_div()
      integer :: ia, i, t, lmt1, lmtt1, icnt, mil, fac_tmp
      
      icnt = 0
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then   ! only ar
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  icnt = icnt + 1
                  lmtt1 = lmtt(lmt1,it)
                  do i = ibl1, ibl2
                     ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                     ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                     ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                  end do
               enddo
            enddo
         else if(kimg == 2) then
            do ia = 1, natm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  icnt = icnt + 1
                  lmtt1 = lmtt(lmt1,it)
                  mil = mod( ltp(lmt1,it),4 )
                  if( mil.eq.1 .or. mil.eq.2 ) then
                     fac_tmp= -2.d0
                  else if( mil.eq.0 .or. mil.eq.3 ) then
                     fac_tmp=  2.d0
                  endif
                  
                  if( mil.eq.1 .or. mil.eq.3 ) then
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                        ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  else if( mil.eq.0 .or. mil.eq.2 ) then
                     do i = ibl1, ibl2
                        ar_tmp(i-ibl1+1,icnt,1) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ar_tmp(i-ibl1+1,icnt,2) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ar_tmp(i-ibl1+1,icnt,3) = -fac_tmp*zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                        ai_tmp(i-ibl1+1,icnt,1) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                        ai_tmp(i-ibl1+1,icnt,2) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                        ai_tmp(i-ibl1+1,icnt,3) =  fac_tmp*zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                     end do
                  endif
               enddo
            enddo
         endif
      else
         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               icnt = icnt + 1
               lmtt1 = lmtt(lmt1,it)
               mil_tmp(icnt) = mod( ltp(lmt1,it),4 )
               do i = ibl1, ibl2
                  ar_tmp(i-ibl1+1,icnt,1) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                  ar_tmp(i-ibl1+1,icnt,2) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                  ar_tmp(i-ibl1+1,icnt,3) = zfcos(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
                  ai_tmp(i-ibl1+1,icnt,1) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,1)
                  ai_tmp(i-ibl1+1,icnt,2) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,2)
                  ai_tmp(i-ibl1+1,icnt,3) = zfsin(i-ibl1+1,ia)*snl(i,lmtt1,iksnl)*ngabc_red(i-ibl1+1,3)
               end do
            enddo
         enddo
      endif
    end subroutine pre_drv_of_betar_dot_WFs_div

    subroutine drv_of_betar_dot_WFs_div( ik, gr, gi )
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: lmt1, ib, i, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp1, tmp2, tmp3
      integer :: id_sname = -1

      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)
      
      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
                 &           0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,1),ibsize, &
                 &           1.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
                 &           0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,2),ibsize, &
                 &           1.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,1),kg1,ai_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
                 &           0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1_2+1, 1.d0,zaj_l(ibl1_2,1,ik,2),kg1,ar_tmp(ibl1_2-ibl1+1,1,3),ibsize, &
                 &           1.d0,gr(1,1,3),np_e)
         endif
      else
         if(kimg == 1) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
         else if(kimg == 2) then
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,1),ibsize, 0.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,1),ibsize, 1.d0,gr(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,2),ibsize, 0.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,2),ibsize, 1.d0,gr(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ar_tmp(1,1,3),ibsize, 0.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1,-1.d0,zaj_l(ibl1,1,ik,2),kg1,ai_tmp(1,1,3),ibsize, 1.d0,gr(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,1),ibsize, 0.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,1),ibsize, 1.d0,gi(1,1,1),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,2),ibsize, 0.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,2),ibsize, 1.d0,gi(1,1,2),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,1),kg1,ai_tmp(1,1,3),ibsize, 0.d0,gi(1,1,3),np_e)
            call DGEMM('T','N',np_e,nlmta,ibl2-ibl1+1, 1.d0,zaj_l(ibl1,1,ik,2),kg1,ar_tmp(1,1,3),ibsize, 1.d0,gi(1,1,3),np_e)
         end if
         do lmt1 = 1, nlmta
            mil = mil_tmp(lmt1)
            if( mil == 1 ) then
               do ib = 1, np_e                              ! MPI
                  tmp1 = gr(ib,lmt1,1)
                  tmp2 = gr(ib,lmt1,2)
                  tmp3 = gr(ib,lmt1,3)
                  gr(ib,lmt1,1) = -gi(ib,lmt1,1)
                  gr(ib,lmt1,2) = -gi(ib,lmt1,2)
                  gr(ib,lmt1,3) = -gi(ib,lmt1,3)
                  gi(ib,lmt1,1) = tmp1
                  gi(ib,lmt1,2) = tmp2
                  gi(ib,lmt1,3) = tmp3
               end do
            elseif (mil == 2 ) then
               do ib = 1, np_e                              ! MPI
                  gr(ib,lmt1,1) = - gr(ib,lmt1,1)
                  gr(ib,lmt1,2) = - gr(ib,lmt1,2)
                  gr(ib,lmt1,3) = - gr(ib,lmt1,3)
                  gi(ib,lmt1,1) = - gi(ib,lmt1,1)
                  gi(ib,lmt1,2) = - gi(ib,lmt1,2)
                  gi(ib,lmt1,3) = - gi(ib,lmt1,3)
               end do
            elseif (mil == 3 ) then
               do ib = 1, np_e                              ! MPI
                  tmp1 = gr(ib,lmt1,1)
                  tmp2 = gr(ib,lmt1,2)
                  tmp3 = gr(ib,lmt1,3)
                  gr(ib,lmt1,1) = gi(ib,lmt1,1)
                  gr(ib,lmt1,2) = gi(ib,lmt1,2)
                  gr(ib,lmt1,3) = gi(ib,lmt1,3)
                  gi(ib,lmt1,1) = -tmp1
                  gi(ib,lmt1,2) = -tmp2
                  gi(ib,lmt1,3) = -tmp3
               end do
            endif
         enddo
      end if
      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div

  end subroutine m_Force_term_drv_of_flmt_noncl
! ========================================================================= 11.0

#else
  subroutine m_Force_term_drv_of_flmt(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer  :: ia,is,ik,iksnl,it,lmt1,lmtt1,il,mdvdb
    real(kind=DP) :: fac, fx, fy, fz
#ifdef SX
    real(kind=DP),allocatable,dimension(:) :: fxyz_mpi1,fxyz_mpi2  ! MPI
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
#else
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
    integer :: ibl1,ibl2,ibsize,ncache
!!$    real(kind=DP),allocatable,dimension(:,:,:) :: zaj_red ! d(ibsize,np_e,kimg)
!!$    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi, snl_red
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:) :: zfsin_red,zfcos_red  ! MPI
    integer, allocatable, dimension(:,:) :: ngabc_red
#endif
    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)

    allocate(gr(np_e,nlmta,3));allocate(gi(np_e,nlmta,3))  ! MPI

    fac = 2.d0/kv3
#ifdef SX
    allocate(ar(kg1))        ;allocate(ai(kg1))
    allocate(zfsin(nbmx)); zfsin = 0.d0
    allocate(zfcos(nbmx)); zfcos = 0.d0
    if(npes>1) then
       allocate(fxyz_mpi1(3));    allocate(fxyz_mpi2(3))      ! MPI
    end if
    do ia = 1, natm
       fx = 0.d0; fy = 0.d0; fz = 0.d0
!!$       call calc_phase2(natm,pos,ia,kgp,nbmx,ngabc,nbmx,zfcos,zfsin)
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       do is = 1, nspin, af+1
          do ik = is, kv3+is-nspin,nspin
             if(map_k(ik) /= myrank_k) cycle        ! MPI
             call calc_phase(ia,natm,pos,kgp,iba(ik),ngabc,kg1 &
                  & ,nbase(1,ik), nbmx, zfcos,zfsin) !-(b_Elec.) ->(zfcos,zfsin)
             iksnl = (ik-1)/nspin+1
             do lmt1 = 1, ilmt(it)
                lmtt1=lmtt(lmt1,it); il=ltp(lmt1,it)
                call drv_of_betar_dot_WFs(gr,gi) !(sumset)
                ! --> gr,gi : derivatives of fsr, fsi
             end do
             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB
                ! gr,gi,fsr,fsi,vlhxcq,dion,eko_l,q,occup_l --> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC
                ! gr,gi,fsr,fsi,dion,occup_l --> fx,fy,fz
             end if
          end do
       end do
       call pucv2cart(rltv,fx,fy,fz)
       if(npes >1) then
          fxyz_mpi1(1) = fx; fxyz_mpi1(2) = fy; fxyz_mpi1(3) = fz  ! MPI
          call mpi_allreduce(fxyz_mpi1,fxyz_mpi2,3,mpi_double_precision &
               & ,mpi_sum,mpi_comm_group,ierr)          ! MPI
          fx = fxyz_mpi2(1); fy = fxyz_mpi2(2); fz = fxyz_mpi2(3)  ! MPI
       end if
       fnlxyz_l(ia,1) = fx; fnlxyz_l(ia,2) = fy; fnlxyz_l(ia,3) = fz
    end do
    if(npes>1) deallocate(fxyz_mpi2,fxyz_mpi1)
    deallocate(zfcos,zfsin)
    deallocate(ai,ar)
#else
    ncache = (m_CtrlP_cachesize()*1024)*3/4

    fnlxyz_l = 0.d0
    do is = 1, nspin, af+1
       do ik = is, kv3+is-nspin,nspin
          if(ncache == 0) then
             ibsize = iba(ik)
          else
             if(k_symmetry(ik) == GAMMA) then ! core2
                if(kimg == 1) then ! ar(i):1,zaj_l(i,ib,ik,1):np_e, ngabc(i,1:3):3
                   ibsize=ncache/(8*(np_e+1) + 4*3)
                else !  ar(i),ai(i):2,zaj_l(i,ib,ik,1),zaj_l(i,ib,ik,2):np_e*2,ngabc(i,1:3):3
                   ibsize=ncache/(8*(2+np_e*2) + 4*3)
                endif
             else
                if(kimg==1) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1):np_e,ngabc(i,1:3):3
                   ibsize = ncache/(8*(2+np_e) + 4*3)
                else if(kimg == 2) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1:2):np_e*2,ngabc(i,1:3):3
                   ibsize = ncache/(8*(2+np_e*2)+4*3)
                end if
             end if
          end if
          if(ipriforce>= 2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
!!$          allocate(zaj_red(ibsize,np_e,kimg))
!!$          allocate(ngabc_red(ibsize,3))
!!$          allocate(snl_red(ibsize,nlmtt))
!!$          allocate(zfcos_red(ibsize)); zfcos_red = 0.d0
!!$          allocate(zfsin_red(ibsize)); zfsin_red = 0.d0

          if(map_k(ik) /= myrank_k) cycle
          iksnl = (ik-1)/nspin+1
          IBLOCK: do ibl1 = 1, iba(ik), ibsize
             ibl2 = ibl1+ibsize-1
             if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
             if(ipriforce>= 2) write(6,'(" ! ibl1, ibl2 = ",2i8," <<m_Force_term_drv_of_flmt>>")') ibl1,ibl2

             allocate(ngabc_red(ibl1:ibl2,3)); ngabc_red = 0
             allocate(zfcos(ibl1:ibl2))
             allocate(zfsin(ibl1:ibl2))
             allocate(ar(ibl1:ibl2))        ;allocate(ai(ibl1:ibl2))
!!$             call substitute_zajred(ik)    ! zaj_l -> zaj_red
             call substitute_ngabcred(ik)  ! ngabc,nbase -> ngabc_red
!!$             call substitute_snlred(iksnl) ! snl -> snl_red

             do ia = 1, natm
                it = ityp(ia)
                call calc_phase_div(ia) ! pos, ngabc_red -> zfcos, zfsin

                do lmt1 = 1, ilmt(it)
                   lmtt1 = lmtt(lmt1,it); il = ltp(lmt1,it)
                   call drv_of_betar_dot_WFs_div(gr,gi)
                end do

                fx = 0.d0; fy = 0.d0; fz = 0.d0
                mdvdb = m_PP_include_vanderbilt_pot(it)
                if(mdvdb == EXECUT) then
                   call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
                else if(mdvdb == SKIP) then
                   call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
                end if
                call pucv2cart(rltv,fx,fy,fz)
                fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
                fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
                fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
             end do
          deallocate(ai,ar)
          deallocate(zfsin,zfcos)
          deallocate(ngabc_red)
          end do IBLOCK
!!$          deallocate(snl_red)
!!$          deallocate(zaj_red)
       end do
    end do
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
#endif


    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
         & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if

    deallocate(gi); deallocate(gr)

    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if

    call tstatc0_end(id_sname)
  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)
         do lmt2 = lmt1, ilmt(it)
            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)

            if ( ipaw(it) == 0 ) then
               if(l1 /= l2 .or. m1 /= m2) cycle
               a = dion(lmt1,lmt2,it)
            else
               a = dion_paw(lmt1,lmt2,is,ia)
            endif
            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            
            if(k_symmetry(ik) == GAMMA) then
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n * a *occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2 + fr1*gr(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2 + fr1*gr(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2 + fr1*gr(i,lmt2,3))
               end do
            else
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n * a *occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2+gi(i,lmt1,1)*fi2&
                       &           +fr1*gr(i,lmt2,1)+fi1*gi(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2+gi(i,lmt1,2)*fi2&
                       &           +fr1*gr(i,lmt2,2)+fi1*gi(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2+gi(i,lmt1,3)*fi2&
                       &           +fr1*gr(i,lmt2,3)+fi1*gi(i,lmt2,3))
               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      integer       :: id_sname = -1
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia)
         do lmt2 = lmt1, ilmt(it)
            lmta2 = lmta(lmt2,ia)
            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
!!$            a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
            if(ipaw(it)==0) then
                a = vlhxcq(lmt1,lmt2,ia,is)+dion(lmt1,lmt2,it)
            else
                a = vlhxcq(lmt1,lmt2,ia,is)+dion_paw(lmt1,lmt2,is,ia)
            end if
            if(k_symmetry(ik) == GAMMA) then
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2 + fr1*gr(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2 + fr1*gr(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2 + fr1*gr(i,lmt2,3))
               end do
            else
               do i = 1, np_e                                 ! MPI
                  a_n = fac_n*(a - eko_l(i,ik)*q(lmt1,lmt2,it))*occup_l(i,ik)
                  fr1 = fsr_l(i,lmta1,ik); fr2 = fsr_l(i,lmta2,ik)
                  fi1 = fsi_l(i,lmta1,ik); fi2 = fsi_l(i,lmta2,ik)
                  fx  = fx - a_n * (gr(i,lmt1,1)*fr2+gi(i,lmt1,1)*fi2&
                       &           +fr1*gr(i,lmt2,1)+fi1*gi(i,lmt2,1))
                  fy  = fy - a_n * (gr(i,lmt1,2)*fr2+gi(i,lmt1,2)*fi2&
                       &           +fr1*gr(i,lmt2,2)+fi1*gi(i,lmt2,2))
                  fz  = fz - a_n * (gr(i,lmt1,3)*fr2+gi(i,lmt1,3)*fi2&
                       &           +fr1*gr(i,lmt2,3)+fi1*gi(i,lmt2,3))
               end do
            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB

#ifdef SX
    subroutine drv_of_betar_dot_WFs(gr,gi)
    real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs ',id_sname)
#ifdef HIUX
*poption parallel
#endif
      do i = 1, iba(ik)
!!$         i1 = nbase(i,ik)
!!$         ar(i) = zfcos(i1)*snl(i,lmtt1,iksnl)
!!$         ai(i) = zfsin(i1)*snl(i,lmtt1,iksnl)
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
!!$                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
!!$                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
!!$                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
!CDIR OUTERUNROLL=4
!CDIR NOLOOPCHG
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc(i1,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs
#else
!!$    subroutine substitute_zajred(ik)
!!$      integer, intent(in) :: ik
!!$      integer :: ie, ig
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(kimg==1) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1) = zaj_l(ig+ibl1-1,ie,ik,1)
!!$            end do
!!$         end do
!!$      else if(kimg==2) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1)    = zaj_l(ig+ibl1-1,ie,ik,1)
!!$               zaj_red(ig,ie,kimg) = zaj_l(ig+ibl1-1,ie,ik,kimg)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine substitute_zajred

    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(ipriforce >= 1) write(6,'(" ibl1, ibl2 = ",2i8)') ibl1, ibl2
      do ig = ibl1, ibl2
         i1 = nbase(ig,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         i1 = nbase(ig+ibl1-1,ik)
!!$         ngabc_red(ig,1) = ngabc(i1,1)
!!$         ngabc_red(ig,2) = ngabc(i1,2)
!!$         ngabc_red(ig,3) = ngabc(i1,3)
!!$      end do
    end subroutine substitute_ngabcred

!!$    subroutine substitute_snlred(iksnl)
!!$      integer, intent(in) :: iksnl
!!$      integer :: ig, lmt1
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      do lmt1 = 1, nlmtt
!!$         do ig = 1, ibl2-ibl1+1
!!$            snl_red(ig,lmt1) = snl(ig+ibl1-1,lmt1,iksnl)
!!$         end do
!!$      end do
!!$    end subroutine substitute_snlred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
!!$         zfcos_red(ig) = dcos(ph)
!!$         zfsin_red(ig) = dsin(ph)
!!$      end do
    end subroutine calc_phase_div

    subroutine drv_of_betar_dot_WFs_div(gr,gi)
      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

      do i = ibl1, ibl2
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc_red(i,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div
#endif
  end subroutine m_Force_term_drv_of_flmt

! ============================== added by K. Tagami ===================== 11.0
  subroutine m_Force_term_drv_of_flmt_noncl(kv3,pos,napt)
    integer, intent(in)                          :: kv3
    real(kind=DP), intent(in), dimension(natm,3) :: pos
    integer,intent(in), dimension(natm,nopr+af)     :: napt

    integer  :: ia,is,ik,iksnl,it,lmt1,lmtt1,il,mdvdb
    integer  :: is1
    real(kind=DP) :: fac, fx, fy, fz
#ifdef SX
    real(kind=DP),allocatable,dimension(:) :: fxyz_mpi1,fxyz_mpi2  ! MPI
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
#else
    real(kind=DP),allocatable,dimension(:) :: zfsin, zfcos  ! MPI
    integer :: ibl1,ibl2,ibsize,ncache
!!$    real(kind=DP),allocatable,dimension(:,:,:) :: zaj_red ! d(ibsize,np_e,kimg)
!!$    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi, snl_red
    real(kind=DP),allocatable,dimension(:,:) :: fnlxyz_mpi
    real(kind=DP),allocatable,dimension(:) :: zfsin_red,zfcos_red  ! MPI
    integer, allocatable, dimension(:,:) :: ngabc_red
#endif
   
    real(kind=DP), allocatable :: gr_noncl( :,:,:,: )
    real(kind=DP), allocatable :: gi_noncl( :,:,:,: )

    integer       :: id_sname = -1
    call tstatc0_begin('m_Force_term_drv_of_flmt ',id_sname,1)

    allocate(gr_noncl(np_e,nlmta,3,ndim_spinor)); gr_noncl = 0.0d0
    allocate(gi_noncl(np_e,nlmta,3,ndim_spinor)); gi_noncl = 0.0d0

!!!!!!!!    fac = 2.d0 / (kv3/ndim_spinor )
    fac = 1.d0 / (kv3/ndim_spinor )

#ifdef SX
    allocate(ar(kg1))        ;allocate(ai(kg1))
    allocate(zfsin(nbmx)); zfsin = 0.d0
    allocate(zfcos(nbmx)); zfcos = 0.d0
    if(npes>1) then
       allocate(fxyz_mpi1(3));    allocate(fxyz_mpi2(3))      ! MPI
    end if

    do ia = 1, natm
       fx = 0.d0; fy = 0.d0; fz = 0.d0
!!$       call calc_phase2(natm,pos,ia,kgp,nbmx,ngabc,nbmx,zfcos,zfsin)
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)

       do ik = 1, kv3, ndim_spinor
          if(map_k(ik) /= myrank_k) cycle        ! MPI
          call calc_phase(ia,natm,pos,kgp,iba(ik),ngabc,kg1 &
               & ,nbase(1,ik), nbmx, zfcos,zfsin) !-(b_Elec.) ->(zfcos,zfsin)
          iksnl = (ik-1)/nspin+1

          do lmt1 = 1, ilmt(it)
             lmtt1=lmtt(lmt1,it); il=ltp(lmt1,it)

             Do is1=1, ndim_spinor
                call drv_of_betar_dot_WFs( ik+is1-1, gr_noncl(:,:,:,is1), &
                     &                               gi_noncl(:,:,:,is1) ) 
                                       ! --> gr,gi : derivatives of fsr, fsi
             End do
          end do
          if(mdvdb == EXECUT) then
             call term_related_to_drv_of_flmt_VDB
                  ! gr,gi,fsr,fsi,vlhxcq,dion,eko_l,q,occup_l --> fx,fy,fz
          else if(mdvdb == SKIP) then
             call term_related_to_drv_of_flmt_NC
                   ! gr,gi,fsr,fsi,dion,occup_l --> fx,fy,fz
          end if
       end do

       call pucv2cart(rltv,fx,fy,fz)
       if(npes >1) then
          fxyz_mpi1(1) = fx; fxyz_mpi1(2) = fy; fxyz_mpi1(3) = fz  ! MPI
          call mpi_allreduce(fxyz_mpi1,fxyz_mpi2,3,mpi_double_precision &
               & ,mpi_sum,mpi_comm_group,ierr)          ! MPI
          fx = fxyz_mpi2(1); fy = fxyz_mpi2(2); fz = fxyz_mpi2(3)  ! MPI
       end if
       fnlxyz_l(ia,1) = fx; fnlxyz_l(ia,2) = fy; fnlxyz_l(ia,3) = fz
    end do
    if(npes>1) deallocate(fxyz_mpi2,fxyz_mpi1)
    deallocate(zfcos,zfsin)
    deallocate(ai,ar)
#else
    ncache = (m_CtrlP_cachesize()*1024)*3/4

    fnlxyz_l = 0.d0

    do ik = 1, kv3, ndim_spinor
       if(ncache == 0) then
          ibsize = iba(ik)
       else
          if(k_symmetry(ik) == GAMMA) then ! core2
             if(kimg == 1) then ! ar(i):1,zaj_l(i,ib,ik,1):np_e, ngabc(i,1:3):3
                ibsize=ncache/(8*(np_e+1) + 4*3)
             else !  ar(i),ai(i):2,zaj_l(i,ib,ik,1),zaj_l(i,ib,ik,2):np_e*2,ngabc(i,1:3):3
                ibsize=ncache/(8*(2+np_e*2) + 4*3)
             endif
          else
             if(kimg==1) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1):np_e,ngabc(i,1:3):3
                ibsize = ncache/(8*(2+np_e) + 4*3)
             else if(kimg == 2) then ! ar(i),ai(i):2,zaj_l(i,ib,ik,1:2):np_e*2,ngabc(i,1:3):3
                ibsize = ncache/(8*(2+np_e*2)+4*3)
             end if
          end if
       end if

       if(ipriforce>= 2) write(6,'(" ! ibsize = ",i8," <<m_Force_term_drv_of_flmt>>")') ibsize
!!$          allocate(zaj_red(ibsize,np_e,kimg))
!!$          allocate(ngabc_red(ibsize,3))
!!$          allocate(snl_red(ibsize,nlmtt))
!!$          allocate(zfcos_red(ibsize)); zfcos_red = 0.d0
!!$          allocate(zfsin_red(ibsize)); zfsin_red = 0.d0

       if(map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/nspin+1

       IBLOCK: do ibl1 = 1, iba(ik), ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iba(ik)) ibl2 = iba(ik)
          if(ipriforce>= 2) write(6,'(" ! ibl1, ibl2 = ",2i8," <<m_Force_term_drv_of_flmt>>")') ibl1,ibl2

          allocate(ngabc_red(ibl1:ibl2,3)); ngabc_red = 0
          allocate(zfcos(ibl1:ibl2))
          allocate(zfsin(ibl1:ibl2))
          allocate(ar(ibl1:ibl2))        ;allocate(ai(ibl1:ibl2))
!!$             call substitute_zajred(ik)    ! zaj_l -> zaj_red
          call substitute_ngabcred(ik)  ! ngabc,nbase -> ngabc_red
!!$             call substitute_snlred(iksnl) ! snl -> snl_red

          do ia = 1, natm
             it = ityp(ia)
             call calc_phase_div(ia) ! pos, ngabc_red -> zfcos, zfsin

             do lmt1 = 1, ilmt(it)
                lmtt1 = lmtt(lmt1,it); il = ltp(lmt1,it)

                Do is1=1, ndim_spinor
                   call drv_of_betar_dot_WFs_div( ik+is1-1, gr_noncl(:,:,:,is1), &
                        &                                   gi_noncl(:,:,:,is1) ) 
                End do

             end do

             fx = 0.d0; fy = 0.d0; fz = 0.d0
             mdvdb = m_PP_include_vanderbilt_pot(it)
             if(mdvdb == EXECUT) then
                call term_related_to_drv_of_flmt_VDB ! -> fx,fy,fz
             else if(mdvdb == SKIP) then
                call term_related_to_drv_of_flmt_NC  ! -> fx,fy,fz
             end if

             call pucv2cart(rltv,fx,fy,fz)
             fnlxyz_l(ia,1) = fnlxyz_l(ia,1) + fx
             fnlxyz_l(ia,2) = fnlxyz_l(ia,2) + fy
             fnlxyz_l(ia,3) = fnlxyz_l(ia,3) + fz
          end do
          deallocate(ai,ar)
          deallocate(zfsin,zfcos)
          deallocate(ngabc_red)
       end do IBLOCK
!!$          deallocate(snl_red)
!!$          deallocate(zaj_red)
    end do
    if(npes>1) then
       allocate(fnlxyz_mpi(natm,3)); fnlxyz_mpi = 0.d0
       call mpi_allreduce(fnlxyz_l,fnlxyz_mpi,3*natm,mpi_double_precision &
            & , mpi_sum, mpi_comm_group,ierr)
       fnlxyz_l = fnlxyz_mpi
    end if
    if(npes>1)deallocate(fnlxyz_mpi)
#endif


    if(af /= 0) then
       allocate(forc_up(natm2,3));allocate(forc_down(natm2,3))
       call forcaf2(natm,natm2,nopr+af,natm,nopr,napt &
         & ,iwei,op,ipriforce,af,fnlxyz_l ,forc_up,forc_down)
       deallocate(forc_down);deallocate(forc_up)
    end if

    deallocate(gi); deallocate(gr)

    if(ipriforce >= 2)  then
       write(6,'(" --- fnlxyz_l ->>")')
       do ia = 1, natm
          write(6,'(i8,3f20.8)') ia, fnlxyz_l(ia,1:3)
       end do
       write(6,'(" <<- fnlxyz_l ---")')
    end if

    call tstatc0_end(id_sname)
  contains

    subroutine term_related_to_drv_of_flmt_NC
      integer :: lmt1, lmta1, lmt2, lmta2, l1,m1,l2,m2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2

      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3, zg1(3), zg2(3), zsum(3)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia); l1 = ltp(lmt1,it); m1 = mtp(lmt1,it)

! === KT_mod ================= 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ============================ 2013/10/31

            l2 = ltp(lmt2,it); m2 = mtp(lmt2,it); lmta2 = lmta(lmt2,ia)

!!!!            if(l1 /= l2 .or. m1 /= m2) cycle

! === KT_mod ================= 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ============================ 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

               do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = cmplx( fsr_l(i,lmta1,ik+is1-1), fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = cmplx( fsr_l(i,lmta2,ik+is2-1), fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = cmplx( gr_noncl(i,lmt1,:,is1), gi_noncl(i,lmt1,:,is1) )
                        zg2(:) = cmplx( gr_noncl(i,lmt2,:,is2), gi_noncl(i,lmt2,:,is2) )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 )&
                             &              *dion_scr_noncl( lmt1,lmt2,istmp,ia )
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)

                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )

               end do
            end if
         end do
      end do
    end subroutine term_related_to_drv_of_flmt_NC

    subroutine term_related_to_drv_of_flmt_VDB
      integer :: lmt1, lmta1, lmt2, lmta2, i
      real(kind=DP) :: fac_n, a, a_n, fr1,fi1,fr2,fi2
      integer :: is1, is2, istmp
      complex(kind=CMPLDP) :: z1, z2, z3, zg1(3), zg2(3), zsum(3)

      integer       :: id_sname = -1
      call tstatc0_begin('term_related_to_drv_of_flmt_VDB ',id_sname)

      do lmt1 = 1, ilmt(it)
         lmta1 = lmta(lmt1,ia)

! ============ KT_mod ================= 2013/10/31
!!!         do lmt2 = lmt1, ilmt(it)
         do lmt2 = 1, ilmt(it)
! ===================================== 2013/10/31

            lmta2 = lmta(lmt2,ia)

! ============ KT_mod ================= 2013/10/31
!!!            fac_n = 2*fac; if(lmt1 == lmt2) fac_n = fac
            fac_n = fac
! ===================================== 2013/10/31

            if(k_symmetry(ik) == GAMMA) then
               stop 'Not supported : Gamma symmetry in non-collinear system'
            else

              do i = 1, np_e                                 ! MPI
                  zsum = 0.0d0
                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        istmp = ( is1 -1 )*ndim_spinor + is2

                        z1 = cmplx( fsr_l(i,lmta1,ik+is1-1), fsi_l(i,lmta1,ik+is1-1 ) )
                        z2 = cmplx( fsr_l(i,lmta2,ik+is2-1), fsi_l(i,lmta2,ik+is2-1 ) )
                        zg1(:) = cmplx( gr_noncl(i,lmt1,:,is1), gi_noncl(i,lmt1,:,is1) )
                        zg2(:) = cmplx( gr_noncl(i,lmt2,:,is2), gi_noncl(i,lmt2,:,is2) )

                        z3 = dion_scr_noncl( lmt1,lmt2,istmp,ia ) &
                             &  -eko_l(i,ik) *q_noncl(lmt1,lmt2,istmp,it )

                        zsum(:) = zsum(:) + (conjg(z1)*zg2(:) + conjg(zg1(:))*z2 ) *z3
                     End do
                  End Do

                  zsum = zsum *fac_n *occup_l(i,ik)

                  fx  = fx - real( zsum(1) )
                  fy  = fy - real( zsum(2) )
                  fz  = fz - real( zsum(3) )
               end do

            end if
         end do
      end do
      call tstatc0_end(id_sname)
    end subroutine term_related_to_drv_of_flmt_VDB

#ifdef SX
    subroutine drv_of_betar_dot_WFs(ik,gr,gi)
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs ',id_sname)
#ifdef HIUX
*poption parallel
#endif
      do i = 1, iba(ik)
!!$         i1 = nbase(i,ik)
!!$         ar(i) = zfcos(i1)*snl(i,lmtt1,iksnl)
!!$         ai(i) = zfsin(i1)*snl(i,lmtt1,iksnl)
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
!!$                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
!!$                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
!!$                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
!CDIR OUTERUNROLL=4
!CDIR NOLOOPCHG
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc(i1,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = 2, iba(ik)
                     i1 = nbase(i,ik)
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         else if(kimg == 2) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
#endif
#ifdef NEC_TUNE3
!CDIR OUTERUNROLL
!CDIR NOLOOPCHG
#endif
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = 1, iba(ik)
                  i1 = nbase(i,ik)
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc(i1,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc(i1,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc(i1,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc(i1,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc(i1,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc(i1,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
#ifdef HIUX
*poption parallel
#endif
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs
#else
!!$    subroutine substitute_zajred(ik)
!!$      integer, intent(in) :: ik
!!$      integer :: ie, ig
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(kimg==1) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1) = zaj_l(ig+ibl1-1,ie,ik,1)
!!$            end do
!!$         end do
!!$      else if(kimg==2) then
!!$         do ie = 1, np_e
!!$            do ig = 1, ibl2-ibl1+1
!!$               zaj_red(ig,ie,1)    = zaj_l(ig+ibl1-1,ie,ik,1)
!!$               zaj_red(ig,ie,kimg) = zaj_l(ig+ibl1-1,ie,ik,kimg)
!!$            end do
!!$         end do
!!$      end if
!!$    end subroutine substitute_zajred

    subroutine substitute_ngabcred(ik)
      integer, intent(in) :: ik
      integer :: ig, i1
      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      if(ipriforce >= 1) write(6,'(" ibl1, ibl2 = ",2i8)') ibl1, ibl2
      do ig = ibl1, ibl2
         i1 = nbase(ig,ik)
         ngabc_red(ig,1) = ngabc(i1,1)
         ngabc_red(ig,2) = ngabc(i1,2)
         ngabc_red(ig,3) = ngabc(i1,3)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         i1 = nbase(ig+ibl1-1,ik)
!!$         ngabc_red(ig,1) = ngabc(i1,1)
!!$         ngabc_red(ig,2) = ngabc(i1,2)
!!$         ngabc_red(ig,3) = ngabc(i1,3)
!!$      end do
    end subroutine substitute_ngabcred

!!$    subroutine substitute_snlred(iksnl)
!!$      integer, intent(in) :: iksnl
!!$      integer :: ig, lmt1
!!$      if(ibl2-ibl1+1 > ibsize) stop ' ibl2-ibl1+1 > ibsize'
!!$      do lmt1 = 1, nlmtt
!!$         do ig = 1, ibl2-ibl1+1
!!$            snl_red(ig,lmt1) = snl(ig+ibl1-1,lmt1,iksnl)
!!$         end do
!!$      end do
!!$    end subroutine substitute_snlred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: ig
      real(kind=DP) :: fx,fy,fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do ig = ibl1, ibl2
         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
         zfcos(ig) = dcos(ph)
         zfsin(ig) = dsin(ph)
      end do
!!$      do ig = 1, ibl2-ibl1+1
!!$         ph = ngabc_red(ig,1)*fx + ngabc_red(ig,2)*fy + ngabc_red(ig,3)*fz
!!$         zfcos_red(ig) = dcos(ph)
!!$         zfsin_red(ig) = dsin(ph)
!!$      end do
    end subroutine calc_phase_div

    subroutine drv_of_betar_dot_WFs_div(ik,gr,gi)
      integer, intent(in) :: ik

      real(kind=DP),intent(inout), dimension(np_e,nlmta,3) :: gr,gi
      integer :: ib, i, i1, id3, mil, ibl1_2
      real(kind=DP) :: br, bi, tmp, fac
      integer :: id_sname = -1
      call tstatc0_begin('drv_of_betar_dot_WFs_div ',id_sname)

      do i = ibl1, ibl2
         ar(i) = zfcos(i)*snl(i,lmtt1,iksnl)
         ai(i) = zfsin(i)*snl(i,lmtt1,iksnl)
      end do

      if(k_symmetry(ik) == GAMMA) then
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            ibl1_2 = max(2,ibl1)
            mil = mod(il,4)
            if(mil == 1 .or. mil == 3) then ! l: even
               if(mil == 1) fac = -2.d0; if(mil == 3) fac = 2.d0
               do ib = 1, np_e                                    ! MPI
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     bi = (ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + bi*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + bi*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + bi*ngabc_red(i,3)
                  end do
               end do
            else if(mil == 0 .or. mil == 2) then ! l: odd
               if(mil == 0) fac = 2.d0; if(mil == 2) fac = -2.d0;
               do ib = 1, np_e
                  gr(ib,lmt1,1:3) = 0.d0
                  do i = ibl1_2, ibl2
                     br = (ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2))*fac
                     gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                     gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                     gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  end do
               end do
            end if
         end if
      else
         if(kimg == 1) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1); bi = ai(i)*zaj_l(i,ib,ik,1)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         else if(kimg == 2) then
            do ib = 1, np_e                                    ! MPI
               gr(ib,lmt1,1:3) = 0.d0
               gi(ib,lmt1,1:3) = 0.d0
               do i = ibl1, ibl2
                  br = ar(i)*zaj_l(i,ib,ik,1) - ai(i)*zaj_l(i,ib,ik,2)
                  bi = ai(i)*zaj_l(i,ib,ik,1) + ar(i)*zaj_l(i,ib,ik,2)
                  gr(ib,lmt1,1) = gr(ib,lmt1,1) + br*ngabc_red(i,1)
                  gr(ib,lmt1,2) = gr(ib,lmt1,2) + br*ngabc_red(i,2)
                  gr(ib,lmt1,3) = gr(ib,lmt1,3) + br*ngabc_red(i,3)
                  gi(ib,lmt1,1) = gi(ib,lmt1,1) + bi*ngabc_red(i,1)
                  gi(ib,lmt1,2) = gi(ib,lmt1,2) + bi*ngabc_red(i,2)
                  gi(ib,lmt1,3) = gi(ib,lmt1,3) + bi*ngabc_red(i,3)
               end do
            end do
         end if
         mil = mod(il,4)
         do id3 = 1, 3
            if(mil == 1 .or. mil == 3) then
               if(mil == 1) fac = 1.d0;  if(mil == 3) fac = -1.d0
               do ib = 1, np_e                              ! MPI
                  tmp = gr(ib,lmt1,id3)
                  gr(ib,lmt1,id3) = -fac*gi(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = fac*tmp
               end do
            else if(mil == 2) then
               do ib = 1, np_e                       ! MPI
                  gr(ib,lmt1,id3) = - gr(ib,lmt1,id3)
                  gi(ib,lmt1,id3) = - gi(ib,lmt1,id3)
               end do
            end if
         end do
      end if

      call tstatc0_end(id_sname)
    end subroutine drv_of_betar_dot_WFs_div
#endif
  end subroutine m_Force_term_drv_of_flmt_noncl
! ========================================================================= 11.0

#endif

  subroutine m_Force_term_dipole()
    integer :: i,ia
    real(kind=DP) :: ed(3),ef(3),a2
#ifdef __TIMER_SUB__
    call timer_sta(1505)
#endif
    ed = 0.d0
    do i=1,3
       a2 = dot_product(altv(1:3,i),altv(1:3,i))
       ed(1:3) = ed(1:3)-PAI4*dipole(i)*altv(1:3,i)/a2
    end do
    ef = 0.d0
    do i=1,3
       ef(1:3) = ef(1:3)-2.d0*field(i)*rltv(1:3,i)
    end do
    do ia=1,natm
       fdip_l(ia,1:3) = ival(ityp(ia))*ed(1:3)
       fext_l(ia,1:3) = ival(ityp(ia))*ef(1:3)
    end do 
#ifdef __TIMER_SUB__
    call timer_end(1505)
#endif
  end subroutine m_Force_term_dipole

  subroutine m_Force_term_fef()
    integer :: ia
    do ia=1,natm
       ffef_l(ia,1:3) = ival(ityp(ia))*elec_field(1:3)
    end do
  end subroutine m_Force_term_fef


!!$  subroutine m_Force_alloc_zfsin_zfcos
!!$    allocate(zfcos(ista_kngp:iend_kngp))
!!$    allocate(zfsin(ista_kngp:iend_kngp))
!!$  end subroutine m_Force_alloc_zfsin_zfcos

!!$  subroutine m_Force_dealloc_zfsin_zfcos
!!$    deallocate(zfsin); deallocate(zfcos)
!!$  end subroutine m_Force_dealloc_zfsin_zfcos

  subroutine m_Force_cal_forcmx()
    integer       :: ia,j
    real(kind=DP) :: fca
    real(kind=DP) :: fcatmp
#ifdef __TIMER_SUB__
    call timer_sta(1507)
#endif
    forcmx = 0.d0
    if(nfcatm <= 0) then
!xocl spread do/ind_natm
!!       do ia = 1, natm
!!          if(imdtyp(ia) == RELAX .or. imdtyp(ia) > HEAT_BATH) then
!!             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
!!             if(forcmx < fca) forcmx = fca
!!          end if
!!       end do
       do ia = 1, natm
          fcatmp = 0.d0
          if(imdtypxyz(ia,1) ==0 .and. imdtypxyz(ia,2)==0 .and. imdtypxyz(ia,3)==0) cycle
          do j=1,3
             if(imdtypxyz(ia,j) == RELAX .or. imdtypxyz(ia,j) > HEAT_BATH) fcatmp = fcatmp + forc_l(ia,j)**2
          enddo
          fca = dsqrt(fcatmp)
          if(forcmx < fca) forcmx = fca
       end do
!xocl end spread sum(forcmx)
    else if(nfcatm > 0) then
!xocl spread do/ind_natm
       do ia = 1, natm
          if(imdtyp(ia) == RELAX .or. imdtyp(ia) > HEAT_BATH) then
             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
             if(forcmx < fca) forcmx = fca
          else if(imdtyp(ia) == BONDLENGTH_FIX .or. imdtyp(ia) == BONDLENGTH_FIX_1 &
               & .or. imdtyp(ia) == BONDLENGTH_FIX_2 .or. imdtyp(ia) == COG_FIX) then
             fca = dsqrt(forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2)
             if(forcmx < fca) forcmx = fca
          end if
       end do
!xocl end spread sum(forcmx)
    end if
    if(ipriforce >= 1) then
       if(iteration_ionic_wd_forcmx /= iteration_ionic) &
            & write(6,'(" !D forcmx = ",d20.12, " at the iteration_ionic of ",i8)') &
            & forcmx, iteration_ionic
       call flush(6)
       iteration_ionic_wd_forcmx = iteration_ionic
    end if
#ifdef __TIMER_SUB__
    call timer_end(1507)
#endif
  end subroutine m_Force_cal_forcmx

  logical function m_Forces_are_Converged_core()
    call m_Force_cal_forcmx()
    if(forcmx < forccr) then
       m_Forces_are_Converged_core = .true.
    else
       m_Forces_are_Converged_core = .false.
    end if
  end function m_Forces_are_Converged_core

  subroutine extract_largerforce_atoms(nforc, ndim, iatom_larger)
    integer, intent(in) :: nforc, ndim
    integer, intent(out), dimension(ndim) :: iatom_larger
    integer :: ia, ia2, ic,ic2, it
    real(kind=DP) :: sqr_forc, sqrforc_lower, tmp
    real(kind=DP), allocatable, dimension(:) :: dforce
    
    allocate(dforce(natm)); dforce = 0.d0
    do ia = 1, natm
       dforce(ia) = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
    end do
    do ia = 1, natm-1
       do ia2 = ia+1, natm
          if(dforce(ia) < dforce(ia2)) then
             sqr_forc = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = sqr_forc
          end if
       end do
    end do
    sqrforc_lower = dforce(min(nforc,natm))
    deallocate(dforce)
    allocate(dforce(ndim)); dforce = 0.d0
    ic = 0
    do ia = 1, natm
       sqr_forc = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
       if(sqr_forc >= sqrforc_lower) then
          ic = ic + 1
          if(ic > ndim) exit
          iatom_larger(ic) = ia
          dforce(ic) = sqr_forc
       end if
    end do
    do ia = 1, ndim-1
       do ia2 = ia+1, ndim
          if(dforce(ia) < dforce(ia2)) then
             tmp = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = tmp
             it = iatom_larger(ia)
             iatom_larger(ia) = iatom_larger(ia2)
             iatom_larger(ia2)  = it
          end if
       end do
    end do
    deallocate(dforce)
  end subroutine extract_largerforce_atoms

  subroutine m_Force_cal_absforc(nforc, forc_lower)
    integer, intent(in) :: nforc
    real(kind=DP), intent(out) :: forc_lower
    real(kind=DP), allocatable, dimension(:) :: dforce
!!$    integer*2 compar
    real(kind=DP) :: tmp
    integer :: ia, ia2
    allocate(dforce(natm)); dforce = 0.d0
    do ia = 1, natm
       dforce(ia) = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
    end do
    do ia = 1, natm-1
       do ia2 = ia+1, natm
          if(dforce(ia) < dforce(ia2)) then
             tmp = dforce(ia)
             dforce(ia) = dforce(ia2)
             dforce(ia2) = tmp
          end if
       end do
    end do
!!$    call qsort( dforce, natm, DP, compar)
    if(nforc < natm) then
       forc_lower = sqrt(dforce(nforc))
    else
       forc_lower = sqrt(dforce(natm))
    end if
    deallocate(dforce)
  end subroutine m_Force_cal_absforc

!!$  integer*2 function compar(a,b)
!!$    real(kind=DP) :: a,b
!!$    if(a  > b) compar = -1
!!$    if(a == b) compar = 0
!!$    if(a  < b) compar = 1
!!$    return
!!$  end function compar

  subroutine m_Force_wd_force_and_cps(nf, withorwithout, cps, ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3)
    integer :: ia

    if(mype==0) then
       if(withorwithout == WITHOUTTAG) then
          do ia = 1, natm
             write(nf,'(" ",i4,3f15.9,3f12.6)') ia &
                  &, cps(ia,1),cps(ia,2),cps(ia,3) &
                  &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3)
          end do
       else if(withorwithout == WITHTAG) then
          do ia = 1, natm
             write(nf,'(" !forc ",i4,3f12.6,3f12.6)') ia &
                  &, cps(ia,1),cps(ia,2),cps(ia,3) &
                  &, forc_l(ia,1), forc_l(ia,2), forc_l(ia,3)
          end do
       else
          write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       end if
    end if
  end subroutine m_Force_wd_force_and_cps

  subroutine m_Force_wd_force_and_cps_lim(nf, withorwithout, cps, ndim, N_FORC)
    integer, intent(in) :: nf, withorwithout,ndim, N_FORC
    real(kind=DP), intent(in) :: cps(ndim,3)
!!$    real(kind=DP), intent(in) :: forc_lower
!!$    real(kind=DP) :: sqr_forc, dforce, forc_lower
    real(kind=DP) :: dforce, forc_lower
    integer,       allocatable, dimension(:) :: iatm_larger ! d(min(ndim,N_FORC))
!!$    real(kind=DP), allocatable, dimension(:) :: dforce
    integer :: ia,ic

    if(withorwithout /= WITHOUTTAG .and. withorwithout /= WITHTAG) then
       if(mype == 0) write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       return
    end if
    if(mype==0) then
       allocate(iatm_larger(min(natm,n_forc))); iatm_larger = 0
       call extract_largerforce_atoms(n_forc,min(natm,n_forc),iatm_larger)
!!$       sqr_forc = forc_lower*forc_lower
       write(nf,'(" !forc *** ",i4," largest-force atoms ***")') min(n_forc,natm)
!!$       write(nf,'(" !forc   no    iatm     cps(1)      cps(2)      cps(3)    forc_l(1)   forc_l(2)   forc_l(3)  abs(forc_l)")')
       write(nf,'(" !forc   no    iatm",3(6x,"cps(",i1,")"),3(3x,"forc_l(",i1,")"),"  abs(forc_l)")') &
            & 1,2,3,1,2,3
       do ic = 1, min(natm,n_forc)
          ia = iatm_larger(ic)
          dforce = sqrt(forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3))
          if(withorwithout == WITHOUTTAG) then
             write(nf,'(" ",i4,i8,3f15.9,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),dforce
          else if(withorwithout == WITHTAG) then
             write(nf,'(" !forc ",i4,i8,3f12.6,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),dforce
          end if
       end do
!!$       do ia = 1, natm
!!$          if(dforce > sqr_forc) then
!!$             ic = ic + 1
!!$             if(withorwithout == WITHOUTTAG) then
!!$                write(nf,'(" ",i4,i8,3f15.9,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),sqrt(dforce)
!!$             else if(withorwithout == WITHTAG) then
!!$                write(nf,'(" !forc ",i4,i8,3f12.6,4f12.6)') ic,ia,cps(ia,1:3),forc_l(ia,1:3),sqrt(dforce)
!!$             end if
!!$          end if
!!$       end do
    end if
  end subroutine m_Force_wd_force_and_cps_lim

  subroutine m_Force_wd_force_cps_cpd(nf, withorwithout, cps, cpd,ndim)
    integer, intent(in) :: nf, withorwithout,ndim
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
    integer :: ia

    if(mype==0) then
       if(withorwithout == WITHOUTTAG) then
          do ia = 1, natm
             write(nf,'(" ",i4,3f15.9,3f12.6, 3f12.6)') ia &
                  &, cps(ia,1:3), cpd(ia,1:3), forc_l(ia,1:3)
          end do
       else if(withorwithout == WITHTAG) then
          do ia = 1, natm
             write(nf,'(" !forc ",i4,3f12.6,3f12.6,3f12.6)') ia &
                  &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3)
          end do
       else
          write(nf,'(" keyword in the argument list of m_Force_wd_force_cps_cpd is invalid")')
       end if
    end if
  end subroutine m_Force_wd_force_cps_cpd

!!$  subroutine m_Force_wd_force_cps_cpd_lim(nf, withorwithout, cps, cpd,ndim, forc_lower)
  subroutine m_Force_wd_force_cps_cpd_lim(nf, withorwithout, cps, cpd,ndim, N_FORC)
    integer, intent(in) :: nf, withorwithout,ndim, N_FORC
    real(kind=DP), intent(in) :: cps(ndim,3), cpd(ndim,3)
!!$    real(kind=DP), intent(in) :: forc_lower
!!$    real(kind=DP) :: sqr_forc, dforce, forc_lower
    real(kind=DP) :: dforce, forc_lower
    integer,       allocatable, dimension(:) :: iatm_larger ! d(min(ndim,N_FORC))
!!$    real(kind=DP), allocatable, dimension(:) :: dforce
    integer :: ia, ic

    if(withorwithout /= WITHOUTTAG .and. withorwithout /= WITHTAG) then
       if(mype == 0) write(nf,'(" keyword in the argument list of m_Force_wd_force_and_cps is invalid")')
       return
    end if
    if(mype==0) then
       allocate(iatm_larger(min(natm,n_forc))); iatm_larger = 0
       call extract_largerforce_atoms(n_forc,min(natm,n_forc),iatm_larger)
!!$       sqr_forc = forc_lower*forc_lower
       write(nf,'(" !forc ",i4," largest force atoms")') min(n_forc,natm)
!!$       write(nf,'(" !forc no iatm  cps(1)  cps(2)  cps(3)   forc_l(1)  forc_l(2)  forc_l(3) abs(forc_l)")')
       write(nf,'(" !forc   no    iatm",3(6x,"cps(",i1,")"),3(6x,"cpd(",i1,")") &
            & , 3(3x,"forc_l(",i1,")"),"  abs(forc_l)")') 1,2,3,1,2,3,1,2,3
!!$       ic = 0
       do ic = 1, min(natm,n_forc)
          ia = iatm_larger(ic)
          dforce = sqrt(forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3))
          if(withorwithout == WITHOUTTAG) then
             write(nf,'(" ",i4,i8,3f15.9,3f12.6, 4f12.6)') ic,ia,cps(ia,1:3) &
                  & ,cpd(ia,1:3), forc_l(ia,1:3),dforce
          else if(withorwithout == WITHTAG) then
             write(nf,'(" !forc ",i4,i8,3f12.6,3f12.6,4f12.6)') ic,ia,cps(ia,1:3) &
                  & ,cpd(ia,1:3), forc_l(ia,1:3),dforce
          end if
       end do
!!$       do ia = 1, natm
!!$          dforce = forc_l(ia,1)*forc_l(ia,1)+forc_l(ia,2)*forc_l(ia,2)+forc_l(ia,3)*forc_l(ia,3)
!!$          if(dforce > sqr_forc) then
!!$             ic = ic + 1
!!$             if(withorwithout == WITHOUTTAG) then
!!$                write(nf,'(" ",2i4,3f15.9,3f12.6, 4f12.6)') ic,ia,cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3), sqrt(dforce)
!!$             else if(withorwithout == WITHTAG) then
!!$                write(nf,'(" !forc ",2i4,3f12.6,3f12.6,4f12.6)') ic,ia &
!!$                     &, cps(ia,1:3),cpd(ia,1:3),forc_l(ia,1:3), sqrt(dforce)
!!$             end if
!!$          end if
!!$       end do
    end if
  end subroutine m_Force_wd_force_cps_cpd_lim

  subroutine m_Force_wd_force_sum(nf)
    integer, intent(in) :: nf
    real(kind=DP) :: force_sum(3)
    integer :: ia,j
    do j=1,3
       force_sum(j) = 0.d0
       do ia=1,natm
          force_sum(j) = force_sum(j) + forc_l(ia,j)
       end do
    end do
    write(nf,'(" !forc Sum of forces =",3(1x,f12.6))') force_sum(1:3)
  end subroutine m_Force_wd_force_sum

  subroutine alloc_force_previous()
!!$    if(.not.allocated(force_error)) then
!!$       allocate(force_error(natm,3)); force_error = 0.d0
!!$    end if
    if(.not.allocated(force_previous)) then
       allocate(force_previous(natm,3)); force_previous = 0.d0
    end if
  end subroutine alloc_force_previous

  subroutine dealloc_force_previous()
    if(allocated(force_previous)) deallocate(force_previous)
  end subroutine dealloc_force_previous
    
  subroutine m_Force_get_fec_count(fec_counter)
    integer, intent(out) :: fec_counter
    fec_counter = force_error_check_counter
  end subroutine m_Force_get_fec_count

  subroutine m_Force_clear_fec_counter()
    force_error_check_counter = 0
  end subroutine m_Force_clear_fec_counter

  logical function m_Force_error_tolerable(nfout)
    integer, intent(in) :: nfout
    real(kind=DP) ::       max_norm_error, max_angle_error, force_hyper_angle_error
    if(ipriforce >= 2)  write(nfout,'("!fec  force_error_check_counter = ",i5," forcmx = ",f16.8)') &
         & force_error_check_counter, forcmx

    if(force_error_check_counter == 0) then
       call alloc_force_previous()
       m_Force_error_tolerable = .false.
    else
       call diff_force(max_norm_error,max_angle_error,force_hyper_angle_error,forccr)
       if(          max_norm_error          <= f_tolerable_norm_error &
            & .and. max_angle_error         <= f_tolerable_angle_error &
            & .and. force_hyper_angle_error <= f_tolerable_hyper_angle_error) then
          m_Force_error_tolerable = .true.
       else
          m_Force_error_tolerable = .false.
       end if
    end if

    if(m_Force_error_tolerable) then
       call dealloc_force_previous()
       force_error_check_counter = 0
    else
       call cp_to_force_previous()
       force_error_check_counter = force_error_check_counter+1
    end if
    if(ipriforce == 1)  write(nfout,'("!fec  force_error_check_counter = ",i5," forcmx = ",f16.8)') &
         & force_error_check_counter, forcmx
  contains
    subroutine cp_to_force_previous()
      force_previous = forc_l
    end subroutine cp_to_force_previous

    subroutine diff_force(max_norm_error,max_angle_error,hyper_angle_error,f_critical)
      real(kind=DP), intent(out) :: max_norm_error,max_angle_error,hyper_angle_error
      real(kind=DP), intent(in)  :: f_critical
      real(kind=DP) :: fca, f_diff, f_error,f_angle_error,f_angle_error_deg
      real(kind=DP) :: f1,f2,f3, fnrom, fnorm_p, fprod0, fprod, fnorm_p0, fnorm, fnorm0
      real(kind=DP) :: farg
      integer :: ia, j
      max_norm_error = 0.d0
      max_angle_error = 0.d0
      hyper_angle_error = 0.d0
      if(ipriforce >= 2) write(nfout,'("!fec  natom, ",9x,"  fca, ",3x," f_diff,",3x &
           & ," f_error",3x,"angle_error((rad), (deg))")')
      fprod = 0.d0; fnrom = 0.d0; fnorm_p = 0.d0
      do ia = 1, natm
         if(imdtyp(ia) == RELAX .or. imdtyp(ia) == BONDLENGTH_FIX .or. imdtyp(ia) > HEAT_BATH) then
            fnorm0 = forc_l(ia,1)**2+forc_l(ia,2)**2+forc_l(ia,3)**2
            fca = dsqrt(fnorm0)
            f_error = 0.d0; f_diff = 0.d0; f_angle_error = 0.d0; f_angle_error_deg = 0.d0
            if(f_critical > DELTA .and. fca > f_critical ) then
               f1 = force_previous(ia,1) - forc_l(ia,1)
               f2 = force_previous(ia,2) - forc_l(ia,2)
               f3 = force_previous(ia,3) - forc_l(ia,3)
               f_diff  = dsqrt(f1*f1 + f2*f2 + f3*f3)
               f_error = f_diff/fca
               if(max_norm_error < f_error) max_norm_error = f_error

               fprod0 = force_previous(ia,1)*forc_l(ia,1) &
                    &  + force_previous(ia,2)*forc_l(ia,2) + force_previous(ia,3)*forc_l(ia,3)
               fnorm_p0 = force_previous(ia,1)**2 + force_previous(ia,2)**2 + force_previous(ia,3)**2
               fnorm_p  = fnorm_p + fnorm_p0
               fnorm    = fnorm   + fnorm0
               if(fnorm_p0 > DELTA) then
                  fnorm_p0 = dsqrt(fnorm_p0)
                  farg = min(fprod0/(fca*fnorm_p0),1.d0)
!!$                  f_angle_error = dacos(fprod0/(fca*fnorm_p0))
                  f_angle_error = dacos(farg)
                  f_angle_error_deg = f_angle_error*180.d0/PAI
                  if(max_angle_error < abs(f_angle_error)) max_angle_error = abs(f_angle_error)
               end if
               fprod = fprod + fprod0
            end if
            if(ipriforce >= 2) then
               if(f_critical > DELTA .and. fca > f_critical ) then
                  if(f_error > f_tolerable_norm_error .or. abs(f_angle_error) > f_tolerable_angle_error) then
                     write(nfout,'("!fec  ",i5,f16.8,4f12.4)') &
                          & ia, fca, f_diff, f_error, f_angle_error, f_angle_error_deg
                  else
                     write(nfout,'("!fec  ",i5,f16.8,4f12.4,"   clear")') &
                          & ia, fca, f_diff, f_error, f_angle_error, f_angle_error_deg
                  end if
               else
                  write(nfout,'("!fec  ",i5,f16.8," ****    **** : fca < f_critical")') ia,fca
               end if
            end if
         end if
      end do
      if(fnorm > DELTA .and. fnorm_p > DELTA) then
         hyper_angle_error = abs(dacos(fprod/(dsqrt(fnorm)*dsqrt(fnorm_p))))
      else
         hyper_angle_error = 0.d0
      end if
      if(ipriforce >= 2) write(nfout,'("!fec  hyper_angle_error = ",f12.4," (radian) = " &
           &                  ,f12.4," (degree)")') hyper_angle_error, hyper_angle_error*180.00/PAI
    end subroutine diff_force

  end function m_Force_error_tolerable

  subroutine m_Force_dealloc
!    if(allocated(forc_l)) deallocate(forc_l)
    if(allocated(fnlxyz_l)) deallocate(fnlxyz_l)
    if(allocated(flhxcq_l)) deallocate(flhxcq_l)
    if(allocated(fdip_l)) deallocate(fdip_l)
    if(allocated(fext_l)) deallocate(fext_l)
    if(allocated(ffef_l)) deallocate(ffef_l)
    if(allocated(fexx_l)) deallocate(fexx_l)
  end subroutine m_Force_dealloc

end module m_Force

       subroutine CSTAB_get_optdim(n_min, n_unroll,
     &                             delta_L1, delta_L2, n_opt)
       implicit none

       integer                :: n_min, n_unroll, delta_L1, delta_L2
       integer                :: n_opt, n_delta
       integer                :: n_opt2, n_delta2

       include 'CSTAB.h'

       integer                :: i,j,k


       n_opt=n_min
       do

          n_opt   = (n_opt-1)/L1_WINDOW+1
          n_opt   = (n_opt/2)*2+1
          n_opt   = n_opt*L1_WINDOW

          n_delta = 0

          do i=1,INT((n_unroll*1.2-1.0)/L1_WAY+1)

             k=mod(i*n_opt+L1_LSIZE/2,L1_LSIZE)-L1_LSIZE/2
             if(abs(k)<=delta_L1/2)then
                n_delta=(delta_L1/2-k-1)/i+1
                goto 10000
             end if

          end do

          do i=1,INT((n_unroll*1.2-1.0)/L2_WAY+1)

             k=mod(i*n_opt+L2_LSIZE/2,L2_LSIZE)-L2_LSIZE/2
             if(abs(k)<=delta_L2/2)then
                n_delta=(delta_L2/2-k-1)/i+1
                goto 10000
             end if

          end do

10000     continue

          if(n_delta==0)exit
          n_opt = n_opt + n_delta

       end do

       return
       end subroutine

       subroutine CSTAB_adjust_base(a,b,offset)
       implicit none

       real(8)                :: a(*), b(*)
       integer                :: offset

       include 'CSTAB.h'


       call get_delta(a(1),b(1),offset)
       offset=(offset/8)

       if(offset>0)then
         offset=MOD(L2_LSIZE-MOD(+offset,L2_LSIZE),L2_LSIZE)
       else
         offset=MOD(L2_LSIZE+MOD(-offset,L2_LSIZE),L2_LSIZE)
       endif

       return
       end subroutine
!
       subroutine CSTAB_adjust_page(a,b,offset)
       implicit none

       real(8)                :: a(*), b(*)
       integer                :: offset

       include 'CSTAB.h'


       call get_delta(a(1),b(1),offset)
       offset=(offset/8)
       if(offset>0)then
         offset=MOD(PAGE_LSIZE-MOD(+offset,PAGE_LSIZE),PAGE_LSIZE)
       else
         offset=MOD(PAGE_LSIZE+MOD(-offset,PAGE_LSIZE),PAGE_LSIZE)
       endif

       return
       end subroutine
!
       subroutine CSTAB_round_offset(offset)
       implicit none

       integer                :: offset

       include 'CSTAB.h'

       offset=MOD(offset,L2_LSIZE)

       return
       end subroutine
!
       subroutine CSTAB_pre_format(nx,a0,nm0,a,nm,n_,a_,nm_)
       implicit none
*
*   A0(NM0,NX) -> A_(NM_,N_) + A(NM,NX-N_)
*
       integer                :: nx, nm0, nm, n_, nm_
       real(8)                :: a0(nm0,*)
       real(8)                :: a(nm,*), a_(nm_,*)

       include 'CSTAB.h'

       integer, parameter     :: n_thread=8
       integer                :: i_thread

       integer, parameter     :: LX = (L2_SIZE/8/4)
       real(8), pointer       :: buff(:)

       allocate(buff(LX*n_thread))
       call CSTAB_pre_format_body(nx,a0,nm0,a,nm,n_,a_,nm_,buff)
       deallocate(buff)

       return
       end subroutine

       subroutine CSTAB_pre_format_body(nx,a0,nm0,a,nm,n_,a_,nm_,buff)
       implicit none
*
*   A0(NM0,NX) -> A_(NM_,N_) + A(NM,NX-N_)
*
       integer                :: nx, nm0, nm, n_, nm_
       real(8)                :: a0(nm0,*)
       real(8)                :: a(nm,*), a_(nm_,*)

       include 'CSTAB.h'

       integer, parameter     :: n_thread=8
       integer                :: i_thread

       integer, parameter     :: LX = (L2_SIZE/8/4)
       real(8)                :: buff(LX,n_thread)

       integer                ::  i_1, i_2, i_3
       integer                ::  j_1, j_2, j_3
       integer                ::  k_1, k_2, k_3, k_4
       integer                ::  kk_1
       integer                ::  MX, NN

       NN=MAX(1,MIN(nm0,nm))
       MX=(NN-1)/LX+1

       do  i_1=1,n_
          j_2=1
          j_3=MIN(nm0,nm_)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do  j_1=j_2,j_3
             buff(j_1,1)=a0(j_1,i_1)
          end do! j_1
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do  j_1=j_2,j_3
             a_(j_1,i_1)=buff(j_1,1)
          end do! j_1
       end do! i_1

       k_2=1
       k_3=nx*MX
       k_4=MOD(k_3-k_2+1,n_thread)+k_2
       do k_1=k_2,k_4-1
             i_1=(k_1-1)/MX+1
             j_2=MOD(k_1-1,MX)*LX+1
             j_3=MIN(j_2+LX-1,NN)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
             do  j_1=j_2,j_3
                a(j_1,i_1)
     &          =a0(j_1,i_1+n_)
             end do! j_1
       end do! k_1

       do kk_1=k_4,k_3,n_thread

!$OMP PARALLEL DO PRIVATE(k_1,i_1,j_1,j_2,j_3)
          do  i_thread=1,n_thread
             k_1=kk_1+i_thread-1
             i_1=(k_1-1)/MX+1
             j_2=MOD(k_1-1,MX)*LX+1
             j_3=MIN(j_2+LX-1,NN)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
             do  j_1=j_2,j_3
                buff(j_1-j_2+1,i_thread)
     &          =a0(j_1,i_1+n_)
             end do! j_1
          end do! i_thread

!$OMP PARALLEL DO PRIVATE(k_1,i_1,j_1,j_2,j_3)
          do  i_thread=1,n_thread
             k_1=kk_1+i_thread-1
             i_1=(k_1-1)/MX+1
             j_2=MOD(k_1-1,MX)*LX+1
             j_3=MIN(j_2+LX-1,NN)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
             do  j_1=j_2,j_3
                a(j_1,i_1)
     &          =buff(j_1-j_2+1,i_thread)
             end do! j_1
          end do! i_thread

       end do! k_1

       return
       end subroutine

       subroutine CSTAB_post_format(nx,a0,nm0,a,nm,n_,a_,nm_)
       implicit none
*
*   A_(NM_,N_) + A(NM,NX-N_) -> A0(NM0,NX)
*
       integer                :: nx, nm0, nm, n_, nm_
       real(8)                :: a0(*)
       real(8)                :: a(nm,*), a_(nm_,*)

       include 'CSTAB.h'

       integer, parameter     ::  n_thread=8
       integer                ::  i_thread

       integer, parameter     :: LX = (L2_SIZE/8/4)
       real(8), pointer       :: buff(:)

       allocate(buff(LX*n_thread))
       call CSTAB_post_format_body(nx,a0,nm0,a,nm,n_,a_,nm_,buff)
       deallocate(buff)

       return
       end subroutine

       subroutine CSTAB_post_format_body(nx,a0,nm0,a,nm,n_,a_,nm_,buff)
       implicit none
*
*   A_(NM_,N_) + A(NM,NX-N_) -> A0(NM0,NX)
*
       integer                :: nx, nm0, nm, n_, nm_
       real(8)                :: a0(nm0,*)
       real(8)                :: a(nm,*), a_(nm_,*)

       include 'CSTAB.h'

       integer, parameter     :: n_thread=8
       integer                :: i_thread

       integer, parameter     :: LX = (L2_SIZE/8/4)
       real(8)                :: buff(LX,n_thread)

       integer                :: i_1,i_2,i_3
       integer                :: j_1,j_2,j_3
       integer                :: k_1,k_2,k_3
       integer                :: kk_1
       integer                :: MX, NN
       integer                :: i


       NN=MAX(1,MIN(nm0,nm))
       MX=(NN-1)/LX+1

       k_2=1
       k_3=nx*MX
       do kk_1=k_3,k_2,-n_thread

!$OMP PARALLEL DO PRIVATE(k_1,i_1,j_1,j_2,j_3)
          do  i_thread=1,MIN(n_thread,kk_1-k_2+1)
             k_1=kk_1-i_thread+1
             i_1=(k_1-1)/MX+1
             j_2=MOD(k_1-1,MX)*LX+1
             j_3=MIN(j_2+LX-1,NN)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
             do j_1=j_2,j_3
                buff(j_1-j_2+1,i_thread)
     &          =a(j_1,i_1)
             enddo! j_1
          enddo! i_thread

!$OMP PARALLEL DO PRIVATE(k_1,i_1,j_1,j_2,j_3)
          do  i_thread=1,MIN(n_thread,kk_1-k_2+1)
             k_1=kk_1-i_thread+1
             i_1=(k_1-1)/MX+1
             j_2=MOD(k_1-1,MX)*LX+1
             j_3=MIN(j_2+LX-1,NN)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
             do  j_1=j_2,j_3
                a0(j_1,i_1+n_)
     &          =buff(j_1-j_2+1,i_thread)
             end do! j_1
          end do! i_thread
       end do! i_1

       do  i_1=n_,1,-1
          j_2=1
          j_3=MIN(nm0,nm_)
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do  j_1=j_2,j_3
             buff(j_1,1)=a_(j_1,i_1)
          enddo
*voption vec
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do  j_1=j_2,j_3
             a0(j_1,i_1)=buff(j_1,1)
          end do! j_1
       end do! i_1


       return
       end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_ES_initialWF
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_ES_initialWF
!    ( m_ESIW)
! $Id: m_ES_initialWF.F90 570 2017-04-21 20:34:50Z yamasaki $
!
! The original subroutine was "rndzaj", which was coded with
! referring to Dr. K. Kato's program on 2nd Jul. 1994.
!
! "rndzaj" was modified to improve the quality of random
! numbers by T. Yamasaki.    17th Oct. 1994
!
! "rndzaj" was translated into "m_ESIW_by_randomnumbers" by
! T. Yamasaki, in 1999.
!

  use m_Electronic_Structure,only : zaj_l, neordr, nrvf_ordr
  use m_ES_nonlocal         ,only : m_ES_PAO_WFs
  use m_PlaneWaveBasisSet,   only : nmatsz, iba, kg1, kg_gamma, nbase_gamma
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : kimg, neg, ipri
  use m_Const_Parameters,    only : DP, GAMMA, GAMMA_base_symmetrization
  use m_Kpoints,             only : k_symmetry
  use m_Parallelization,     only : mype,map_z,map_ek,myrank_k,map_k, ista_e, iend_e, istep_e   &
 &                                 , ista_k, iend_k , ista_g1k, iend_g1k, np_g1k, nrank_g, np_e

! ============================ added by K. Tagami ======================== 11.0
  use m_Control_Parameters,    only : noncol
  use m_ES_nonlocal,           only : m_ES_PAO_WFs_noncl
! ========================================================================= 11.0


  implicit none

!  58. m_ESIW_by_randomnumbers    <-(Initial_Electronic_Structure)
contains
  subroutine m_ESIW_by_randomnumbers(nfout,kv3,ie_start, ie_end)   !(rndzaj)
    integer, intent(in) :: nfout,kv3,ie_start,ie_end
    real(kind=DP), allocatable, dimension(:) :: zaj_t

#ifdef _DEBUG_INITIALIZATION_
    real(kind=DP)   :: a,b,p,xn
    data a,b,p/32771.d0,1234567891.d0,2147483648.d0/
#endif

    integer, allocatable, dimension(:) :: vlambda, vc, nlambda, nc, mlambda, mc

    integer :: iimg, ik, ieg, i, iegt, xp, ig1, ig2
    integer(kind=8) :: jump
    logical :: first

    integer :: id_sname = -1
    call tstatc0_begin('m_ESIW_by_randomnumbers ',id_sname)

    if(ipri >= 2) then
       write(nfout,*)
       write(nfout,'(" <<< m_ESIW_by_randomnumbers >>>")')
       write(nfout,'(" !iba(1)        = ",i6)') iba(1)
    end if

    do ik = ista_k, iend_k  ! mpi
       if(iend_k > kv3) cycle
       do ieg = ista_e,iend_e,istep_e  ! mpi
          if(ista_e < ie_start) cycle
          if(iend_e > ie_end)   cycle
             iegt = map_z(ieg)
             if(kimg == 1) then
                do i = 1, kg1
                   zaj_l(i,iegt,ik,1) = 0.d0
                end do
             else
                do i = 1, kg1
                   zaj_l(i,iegt,ik,1) = 0.d0
                   zaj_l(i,iegt,ik,2) = 0.d0
                end do
             end if
       end do
    end do

    allocate(vlambda(0:1023), vc(0:1023), nlambda(0:1023), nc(0:1023), mlambda(0:1023), mc(0:1023))
    first = .true.

#ifdef _DEBUG_NO_INVERSION_
    iimg = 1
#else
    do iimg = 1, kimg
#endif
#ifdef _DEBUG_INITIALIZATION_
       do ik = 1, kv3
          do ieg = ie_start, ie_end
             do i = 1,  iba(ik)
                xn = mod(xn*a+b,p)
                if(map_ek(ieg,ik) == mype) zaj_l(i,map_z(ieg),ik,iimg) = xn/p ! MPI
             enddo
          enddo
       enddo
#else
       do ik = ista_k, iend_k              ! mpi
          if(iend_k > kv3) cycle
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) then
             allocate(zaj_t(kg_gamma))
             do ieg = ista_e,iend_e,istep_e   ! mpi
!!$                if(ista_e < ie_start) cycle
!!$                if(iend_e > ie_end)   cycle
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
                xp = 0
                jump = kg_gamma*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
                call pran0(xp,jump,kg_gamma,zaj_t)
                if(k_symmetry(ik) == GAMMA) then
                   zaj_l(1:kg_gamma,map_z(ieg),ik,iimg) = zaj_t(1:kg_gamma)
                else if(k_symmetry(ik) == GAMMA_base_symmetrization) then
                   if(iimg == 1) then
                      do i = 2, kg_gamma
                         ig1 = nbase_gamma(i,1)
                         ig2 = nbase_gamma(i,2)
                         zaj_l(ig1,map_z(ieg),ik,iimg) = zaj_t(i)
                         zaj_l(ig2,map_z(ieg),ik,iimg) = zaj_t(i)
                      end do
                      zaj_l(1,map_z(ieg),ik,iimg) = zaj_t(1)
                   else
                      do i = 2, kg_gamma
                         ig1 = nbase_gamma(i,1)
                         ig2 = nbase_gamma(i,2)
                         zaj_l(ig1,map_z(ieg),ik,iimg) =  zaj_t(i)
                         zaj_l(ig2,map_z(ieg),ik,iimg) = -zaj_t(i)
                      end do
                      zaj_l(1,map_z(ieg),ik,iimg) = 0.d0
                   end if
                end if
                first = .false.
             end do
             deallocate(zaj_t)
          else
             do ieg = ista_e,iend_e,istep_e   ! mpi
                if(ieg < ie_start) cycle
                if(ieg > ie_end)   cycle
!!$             xn = 0.d0
!!$             jump = kg1*((ie_end-ie_start)*(kv3*(iimg-1) + (ik-1)) + (ieg-ie_start))
!!$             do i = 1, jump
!!$                xn = mod(xn*a+b,p)
!!$             end do
!!$             do i = 1, iba(ik)
!!$                xn = mod(xn*a+b,p)
!!$                zaj_l(i,map_z(ieg),ik,iimg) = xn/p ! MPI
!!$             end do
                xp = 0
                jump = kg1*((ie_end-ie_start+1)*(kv3*(iimg-1_8) + (ik-1_8)) + (ieg-ie_start))
                call pran0(xp,jump,iba(ik),zaj_l(1,map_z(ieg),ik,iimg))
                first = .false.
             end do
          end if
       end do
#endif
#ifndef _DEBUG_NO_INVERSION_
    enddo
#endif
    deallocate(mc, mlambda, nc, nlambda, vc, vlambda)

    if(ipri >= 2) write(nfout,'(" initialization of neordr and nrvf_ordr")')
! Initialization

    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle ! MPI
!!$       do i = 1, neg
       do i = ie_start, ie_end
          neordr(i,ik)    = i
          nrvf_ordr(i,ik) = i
       end do
    end do

    call tstatc0_end(id_sname)

  contains
    subroutine pran0(iseed,nstep,n1,r)
!
!  AUTHOR: T.Kokubo   Jun/15/2005
!
      implicit none

      integer :: iseed,n1
      integer(kind=8) :: nstep
      real(kind=DP) :: r(n1)

      integer, PARAMETER :: lambda=32771,c=1234567891,m=2147483647
      real(kind=DP), PARAMETER :: Minv=1.0D+00/2147483648.d0

      integer :: k,j
      integer(kind=8) :: istep,jstep,ijmp,jjmp,ijmpm,jjmpm

      if(first) then
         vlambda(0)=lambda
         vc(0)=c
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            vlambda(k)=lambda*vlambda(k-1)
            vc(k)=vc(k-1)+c*vlambda(k-1)
         enddo
         nlambda(0)=vlambda(1023)
         nc(0)=vc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            nlambda(k)=vlambda(1023)*nlambda(k-1)
            nc(k)=nc(k-1)+vc(1023)*nlambda(k-1)
         enddo
         mlambda(0)=nlambda(1023)
         mc(0)=nc(1023)
#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
         do k=1,1023
            mlambda(k)=nlambda(1023)*mlambda(k-1)
            mc(k)=mc(k-1)+nc(1023)*mlambda(k-1)
         enddo
!!$         first=.false.
      endif

      istep=nstep/1024_8
      jstep=nstep-istep*1024_8

      ijmp=istep/1024_8
      jjmp=istep-ijmp*1024_8

      ijmpm=ijmp/1024_8
      jjmpm=ijmp-ijmpm*1024_8

#ifdef SX
!cdir novector
#endif
#ifdef HIUX
*poption noparallel
#endif
      do j=1,ijmpm
         iseed=iseed*mlambda(1023)+mc(1023)
      enddo
      if(jjmpm.ne.0) then
         iseed=iseed*mlambda(jjmpm-1)+mc(jjmpm-1)
      endif
      if(jjmp.ne.0) then
         iseed=iseed*nlambda(jjmp-1)+nc(jjmp-1)
      endif
      if(jstep.ne.0) then
         iseed=iseed*vlambda(jstep-1)+vc(jstep-1)
      endif

      do j=1,n1,1024
#ifdef SX
!cdir nodep
#endif
#ifdef HIUX
*poption indep
#endif
         do k=0,min(1023,n1-j)
            r(j+k)=minv*iand(iseed*vlambda(k)+vc(k),m)
         enddo
         iseed=iseed*vlambda(k-1)+vc(k-1)
      enddo
    end subroutine pran0
  end subroutine m_ESIW_by_randomnumbers

  subroutine m_ESIW_by_atomic_orbitals(nfout,kv3,ie_start,ie_end) !(paozaj)
    integer, intent(in) :: nfout,kv3,ie_start,ie_end
    call m_ESIW_by_randomnumbers(nfout,kv3,ie_start,ie_end)
! ===================================== modified by K. Tagami ========== 11.0
!    call m_ES_PAO_WFs(nfout)
!
    if ( noncol ) then
       call m_ES_PAO_WFs_noncl(nfout)
    else
       call m_ES_PAO_WFs(nfout)
    endif
! ======================================================================= 11.0

  end subroutine m_ESIW_by_atomic_orbitals
!===============================================================================
end module m_ES_initialWF

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: hitachi_z3fft, set_length
!
!  AUTHOR(S): O. Sugino  December/22/2003
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef SRFFT
      subroutine hitachi_z3fft(afft,ftw, id,nl,nm,nn, ip1,ip2,ip3,
     & cw1,cw2,cw3, inverse_or_direct, itable_flag)
! $Id: srfft.F 570 2017-04-21 20:34:50Z yamasaki $
      implicit none
      complex*16 afft(*), ftw(*)
      integer id, nl, nm, nn
      integer ip1(3), ip2(3), ip3(3)
      complex*16 cw1(*), cw2(*), cw3(*)
      integer inverse_or_direct, itable_flag
      integer ier, nwkw
      integer ndim1, ndim2
#ifndef SRFTOUTSMP
      integer iopt(2)
      integer i
#else
      integer iopt(3)
      integer i,itop,nloops
#endif

      ndim1 = id
      ndim2 = nm
      iopt(1) = inverse_or_direct
      iopt(2) = itable_flag
      nwkw = 1
#ifndef SRFTOUTSMP
      call hzft7m(afft,ndim1,ndim2,nl,nm,nn,ip1,ip2,ip3,
     & iopt,cw1,cw2,cw3,ftw,nwkw,ier)
#else
      if(itable_flag.eq.0)then
        nloops=1
      else
        nloops=nn
      endif

*poption parallel
      do i=1,nloops
        itop=(ndim1*ndim2)*(i-1)+1
        call hzft9m(afft(itop),ndim1,ndim2,nl,nm,ip1,ip2,
     &         iopt,cw1,cw2,ftw(itop),nwkw,ier)
      enddo

      call trans_axis(ftw,afft,nl,nm,nn,nwkw)

      iopt(3)=2
      if(itable_flag.eq.0)then
        nloops=1
      else
        nloops=nm
      endif

*poption parallel
      do i=1,nloops
        itop=((nl+nwkw)*nn)*(i-1)+1
        call hzft5m(ftw(itop),nl+nwkw,nn,ip3,nl,
     &         iopt,cw3,afft(itop),ier)
      enddo

      call trans_axis(afft,ftw,nl,nn,nm,nwkw)
#endif

!ccc This loop is redundant.
      do i = 1, nm*nn
          afft(i*id) = (0.Q0,0.Q0)
      end do

      return
      end

      subroutine set_length(n, ip)
      implicit none
      integer n, ip(3)
      integer nn, lp2, lp3, lp5

      nn =n
      lp5=0
      lp3=0
      lp2=0
      do while(mod(nn,5).eq.0)
          lp5=lp5+1
          nn=nn/5
      end do
      do while(mod(nn,3).eq.0)
          lp3=lp3+1
          nn=nn/3
      end do
      do while(mod(nn,2).eq.0)
          lp2=lp2+1
          nn=nn/2
      end do
      ip(1) = lp2
      ip(2) = lp3
      ip(3) = lp5

      if(nn.ne.1) stop 'n is an improper number.'

      return
      end
#ifdef SRFTOUTSMP
      subroutine trans_axis(c1,c2,n1,n2,n3,nwkw)
      complex*16 c1(n1+nwkw,n3,n2),c2(n1+nwkw,n2,n3)

      do k=1,n3
      do j=1,n2
      do i=1,n1
        c1(i,k,j)=c2(i,j,k) 
      enddo
      enddo
      enddo

      return
      end
#endif
#endif

#ifdef NEC_TIMER
#  define START_TIMER(a) call start_timer(a)
#  define STOP_TIMER(a)  call stop_timer(a)
#else
#  define START_TIMER(a)
#  define STOP_TIMER(a)
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Forces
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Forces
! $Id: Forces.F90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Const_Parameters,  only : WITHOUTTAG, WITHTAG, ON
  use m_Parallelization,   only : mype
  use m_Control_Parameters,only : ipriforce, sw_calc_force, sw_dipole_correction &
       &                        , sw_fef, sw_hybrid_functional
  use m_Files,             only : nfout, nfdynm
  use m_IterationNumbers,  only : iteration_ionic, iteration
  use m_Kpoints,           only : kv3
  use m_Ionic_System, only : pos, napt, fxyzew_l, fxyzvdw_l
  use m_Force,        only : forc_l, fexx_l &
!!$       &                   , m_Force_alloc_zfsin_zfcos &
       &                   , m_Force_initialize &
       &                   , m_Force_sumup_and_symmetrize &
!!$       &                   , m_Force_dealloc_zfsin_zfcos &
       &                   , m_Force_cal_forcmx &
       &                   , m_Force_term_dipole &
       &                   , m_Force_term_fef &
!fj$$#ifndef PARA3D
       &                   , m_Force_term_Elocal_and_Epc &
       &                   , m_Force_term_drv_of_VlhxcQ &
       &                   , m_Force_term_drv_of_flmt  
!fj$$#endif
  use m_Phonon,       only : m_Phonon_write_forces
#ifdef __TIMER__
  use m_Parallelization,     only : mpi_comm_group
#endif
#ifdef NEC_TIMER
  use nec_timer
#endif
  use m_ES_ExactExchange, only : m_ES_EXX_Force

! ================================ added by K. Tagami ============= 11.0
  use m_Control_Parameters,      only : noncol
  use m_Force,                   only : m_Force_term_drv_of_flmt_noncl
! ================================================================ 11.0


  implicit none
  integer, save :: flag_wd_force = 0

#ifdef __TIMER__
  integer :: ierr
  call mpi_barrier(mpi_comm_group, ierr)
  call timer_sta(19)
#endif

  if(ipriforce >= 2) write(nfout,'(" -- Forces -- ")')
!!$  call m_Force_alloc_zfsin_zfcos()
  call m_Force_initialize()
!fj$$#ifndef PARA3D
START_TIMER('Force')

! ==================== modified by K. Tagami ============== 11.0
!  call m_Force_term_drv_of_flmt(kv3,pos,napt)      ! (vnlsum) ->fnlxyz_l
!
    if ( noncol ) then
      call m_Force_term_drv_of_flmt_noncl(kv3,pos,napt)
    else
      call m_Force_term_drv_of_flmt(kv3,pos,napt)      ! (vnlsum) ->fnlxyz_l
    endif
! =========================================================== 11.0

STOP_TIMER('Force')
  call m_Force_term_drv_of_VlhxcQ(nfout,pos,napt)  ! (lclchg) ->flhxcq_l
  call m_Force_term_Elocal_and_Epc(nfout,pos)      ! (force)  ->forc_l
!fj$$#endif
  if(sw_dipole_correction == ON) then
     call m_Force_term_dipole()                       ! -> fdip_l,fext_l
  end if
  if(sw_fef==ON) call m_Force_term_fef()           ! -> ffef_l
  if(sw_hybrid_functional==ON) call m_ES_EXX_Force(fexx_l)
  call m_Force_sumup_and_symmetrize(nfout,fxyzew_l,napt)
  !                         forc_l,fnlxyz_l,flhxcq_l,fxyzew_l  --> forc_l
!!$  call m_Force_dealloc_zfsin_zfcos()
  call m_Force_cal_forcmx()                        ! -> forcmx
  if(sw_calc_force == ON) call m_Phonon_write_forces()

!!$  call m_IS_evaluate_v_verlet(forc_l)
!!$

#ifdef __TIMER__
  call timer_end(19)
#endif
end subroutine Forces

!PHASEから入力された空間群の生成元および格子の情報を読み込み、保存するモジュール
!Copyright (C) 2014-2015 Ryosuke Tomita

module m_container_lattice
#include "defines.F"
  use m_commons, only: stdout, unit_matrix, pi, pi2, euler2vector, get_recip_vector
  use m_tspace_defines, only: kvector, group, lattice_parameter, num_generator_max
  use m_tspace_commons, only: get_group, get_kgroup, get_kgroup_from_gammagroup, set_kpoint_irep, set_pg_name, set_class
  use m_container_commons, only: c_state, k_state, linebuf, parser_tag, readline, readline_until_tag
  
  implicit none
!m_container_common::readline_until_tag用のタグ
  character(*), parameter::&
       kvector_tag = 'KPOINT', &
       lattice_system_tag = 'LATTICE_SYSTEM',&
       generators_tag = 'GENERATORS',&
       lattice_parameter_tag = 'BRAVAIS_LATTICE_PARAMETER',&
       lattice_vector_tag = 'PRIMITIVE_LATTICE_PARAMETER'
  
!k点を格納する変数
  type(kvector), private, target:: kpoint
!格子定数の情報を格納する
  type(lattice_parameter), private, target:: latparam
!k点群
  type(group), private, target:: kgroup
!格子変換行列、実格子または逆格子のブラベ格子及びプリミティブ格子
  DOUBLE_T, dimension(3,3), private, target:: alat_pri, alat_bra, blat_pri, blat_bra       
  DOUBLE_T, dimension(3,3), public, target:: trp2b = unit_matrix, &
       trb2p = unit_matrix, trp2b_a = unit_matrix, trb2p_a = unit_matrix
contains

!読み込んだ情報およびTSPACEの内部変数をもとにk点およびk点群の情報をモジュール内の変数に格納する
  subroutine set_kpoint_and_kgroup()
    logical, save:: isgammaset = .false.
    type(kvector), save:: k_gamma!GAMMA点
    type(group), save:: gr_gamma!GAMMA点の群
!GAMMA点の群を取得する
    if(.not.isgammaset) then
       k_gamma%comp = 0
       k_gamma%common_denom = 1
       call set_kpoint_irep(k_gamma)
       gr_gamma = get_kgroup()
       isgammaset = .true.
    end if
!k点の成分をブラベ逆格子のものに変換
    kpoint%comp = nint(matmul(kpoint%comp, trp2b))
    call set_kpoint_irep(kpoint)
!GAMMA点の群から必要な対称操作だけを取得して、k群を用意する
    kgroup = get_kgroup_from_gammagroup(gr_gamma)
    call set_pg_name(kgroup)
    call set_class(kpoint, kgroup)
  end subroutine set_kpoint_and_kgroup

!kpoint.dataの読み込み.k点の総数をnkpに、k点の成分をkps(1:4,1:nkp)に記憶する
!kps(1:4,i)はi番目のk点の成分分子x,y,zと共通分母Nを記憶する。
  subroutine read_kpoint_data(nfin, nkp, kps)
    integer, intent(in):: nfin
    integer, intent(out):: nkp
    integer, allocatable, intent(out):: kps(:,:)
    integer:: ikp
    if(readline(nfin) < 1) then
       nkp = 0
       return
    endif
    read(linebuf, *) nkp
    allocate(kps(4,nkp))
    ikp = 0
    do while(readline(nfin) > 0 .and. ikp < nkp)
       read(linebuf, *) kps(1:4, ikp+1)
       ikp = ikp + 1
    enddo
  end subroutine read_kpoint_data

!k点の読み込み
  logical function read_kpoint(nfin, reset, notag)
    integer, intent(in):: nfin
    logical, intent(in), optional:: reset, notag
    integer:: ik
    integer, save:: count = 1
    read_kpoint = .false.
    
    if(present(reset) .and. reset) count = 1
!読み込み開始処理、m_container_psicoef::read_psicoefと同様
!notagタグがないときに、KVECTORタグを読み込むまでファイル内容を読み飛ばす
    if(.not.(present(notag) .and. notag) .and. &
         readline_until_tag(nfin, kvector_tag) < 1) return
!読み込み終了処理、m_container_psicoef::read_psicoefと同様
    do ik = 1, count
       if(READERR(nfin, parser_tag)) then
          count = 1
          return
       end if
       read(linebuf, *) kpoint%index, kpoint%comp, kpoint%common_denom, kpoint%isdouble
       kpoint%name = ""
    enddo
    count = count + 1
    read_kpoint = .true.
  end function read_kpoint
  
!結晶系および生成元、反転対称性の読み込み
  logical function read_lattice_system(nfin)
    integer, intent(in):: nfin
    integer:: igen

    read_lattice_system = .false.
!読み込み開始処理、m_container_psicoef::read_psicoefと同様
    if(readline_until_tag(nfin, lattice_system_tag) < 1) return
    if(READERR(nfin, parser_tag)) return
    read(linebuf, *) latparam%lattice_type, latparam%isinversion

    if(readline_until_tag(nfin, generators_tag) < 1) return
!生成元の読み込み、最大3つ
    do igen = 1, num_generator_max
       if(READERR(nfin, parser_tag)) exit
       read(linebuf, *) latparam%index_rotation(igen), latparam%translation(:, :, igen)
       latparam%num_generator = igen
    enddo
    read_lattice_system = .true.
  end function read_lattice_system

!格子パラメータの読み込み
  logical function read_lattice_parameter(nfin)
    integer, intent(in):: nfin

    read_lattice_parameter = .false.
!読み込み開始処理、m_container_psicoef::read_psicoefと同様
    if(readline_until_tag(nfin, lattice_parameter_tag) < 1) return

!読み込み終了処理、m_container_psicoef::read_psicoefと同様
    if(READERR(nfin, parser_tag)) return
    read(linebuf, *) latparam%a, latparam%b, latparam%c
    if(READERR(nfin, parser_tag)) return
    read(linebuf, *) latparam%alpha, latparam%beta, latparam%gamma
    read_lattice_parameter = .true.
  end function read_lattice_parameter

!プリミティブ格子の読み込み(データの順番は1カラムから逆格子、4カラムから実格子)
  logical function read_lattice_primitive(nfin)
#define READLATTICE(num)\
    read(linebuf, *) blat_pri(num, :), alat_pri(num, :)

    integer, intent(in):: nfin
    read_lattice_primitive = .false.
    if(readline_until_tag(nfin, lattice_vector_tag) < 1)&
         return
    if(READERR(nfin, parser_tag)) return
    READLATTICE(1)!a_1の読み込み
    if(READERR(nfin, parser_tag)) return
    READLATTICE(2)!a_2の読み込み
    if(READERR(nfin, parser_tag)) return
    READLATTICE(3)!a_3の読み込み
    read_lattice_primitive = .true.
#undef READLATTICE
  end function read_lattice_primitive

!TSPACEの内部変数からブラベ格子ベクトルを設定する
  subroutine set_lattice_braveis
    DOUBLE_T, save:: t0 = pi/180d0
    alat_bra = euler2vector(latparam%alpha * t0,&
         latparam%beta * t0,&
         latparam%gamma * t0&
         )
    alat_bra(:, 1) = alat_bra(:, 1) * latparam%a
    alat_bra(:, 2) = alat_bra(:, 2) * latparam%b
    alat_bra(:, 3) = alat_bra(:, 3) * latparam%c
    blat_bra = get_recip_vector(alat_bra)
  end subroutine set_lattice_braveis

!読み込んだプリミティブ格子及びブラベ格子から、ブラベ格子表示のベクトルとプリミティブ格子表示のベクトルを相互変換する格子変換行列(trp2b, trb2p)を用意する
  subroutine set_trp2b
    trb2p = matmul(blat_bra, transpose(alat_pri)) /pi2! blat_bra * blat_pri^-1
    trp2b = matmul(blat_pri, transpose(alat_bra)) /pi2! blat_pri * blat_bra^-1
    trb2p_a = transpose(trp2b)
    trp2b_a = transpose(trb2p)
  end subroutine set_trp2b
 
!プリミティブ格子の読み込み、ブラベ格子および格子変換行列の設定
  logical function read_lattice_vector(nfin)
    integer, intent(in):: nfin
    read_lattice_vector = read_lattice_primitive(nfin)
    if(.not.read_lattice_vector) return
    call set_lattice_braveis
    call set_trp2b
  end function read_lattice_vector

  subroutine trans_transvector
    integer:: i, j
    DOUBLE_T:: v(3)
#ifdef DEBUG
    do i = 1, latparam%num_generator
       write(stdout, *) (latparam%translation(:, j, i), j = 1,3)
    end do
#endif
    do i = 1, latparam%num_generator
       v(:) = dble(latparam%translation(1,:,i))
       latparam%translation(1,:,i) = nint(matmul(v, trp2b_a))
       do j = 1, 3
          latparam%translation(1,j,i) = mymod(latparam%translation(1,j,i),&
               latparam%translation(2,j,i))
       end do
    end do
#ifdef DEBUG
    do i = 1, latparam%num_generator
       write(stdout, *) (latparam%translation(:, j, i), j = 1,3)
    end do
#endif
  contains
    integer function mymod(a,b)
      integer, intent(in):: a,b
      mymod = mod(abs(a), b)
      if(a < 0) mymod = -mymod
    end function mymod
  end subroutine trans_transvector

!得られたk点の情報をコピーし、それを返す
  type(k_state) function get_kstate() result(ks)
    ks%kpoint = kpoint
    ks%kgroup = kgroup
    ks%trp2b = trp2b
    ks%trb2p = trb2p
  end function get_kstate

!得られた結晶全体の情報をコピーし、それを返す
  type(c_state) function get_cstate() result(cs)
!    call trans_transvector
    cs%latparam = latparam
    cs%crystal_group = get_group()
    cs%trp2b = trp2b_a
    cs%trb2p = trb2p_a
  end function get_cstate
end module m_container_lattice

module stringModule
  implicit none
  private
  public:: readLine, strSplit
  character(len=120),dimension(:),allocatable,public:: splitStr
contains

  function readLine(unit,line)
    logical:: readLine
    integer,intent(in) :: unit
    character(len=*),intent(out):: line
    integer:: ios,pos
    character(len=1024)::buf
    do 
      read(unit,'(A1024)',iostat=ios) buf
      if(ios/=0) then
        readLine = .true.
        return
      endif
      do                              ! replace TAB with SPACE
        pos = scan(buf,'	')
        if (pos == 0) exit
        buf(pos:pos) = ' '
      enddo
      pos = scan(buf,'#')       
      if(pos/=0) buf = buf(:pos-1)               ! erase comment
      if (len_trim(buf)/=0) then
        line = trim(buf)
        readLine = .false.
        return
      endif
    enddo
  end function readLine

  subroutine strSplit(str)
    character(len=*),intent(in):: str
    integer:: i, iarg, ist,ied,i1, splitCount
    logical:: space

    if(allocated(splitStr)) deallocate(splitStr)
    splitCount = 0

    if(len_trim(str)==0) return
    i1 = len_trim(str)

    space = .true.
    iarg = 0
    do i=1,len_trim(str)
      if(space) then
        if(str(i:i)/=' ') then
          space = .false.
          iarg = iarg + 1
        endif
      else
        if(str(i:i)==' ') space = .true.
      endif
    enddo
    splitCount = iarg
    allocate(splitStr(splitCount))
    
    space = .true.
    iarg = 1
    do i=1,len_trim(str)
      if(space) then
        if(str(i:i)/=' ') then
          ist = i
          space = .false.
        endif
      else
        if(str(i:i)==' ') then
          ied = i-1
          splitStr(iarg) = str(ist:ied)
          iarg = iarg + 1
          space = .true.
        endif
      endif
    enddo
    ied = len_trim(str)
    splitStr(iarg) = str(ist:ied)
  end subroutine strSplit

end module stringModule

!program test
!  use misc
!  use stringModule
!  character(len=120):: aLine
!  integer:: i
!  read(*,'(A)') aLine
!  call strSplit(aLine)
!  do i=1,splitCount
!    write(6,*) ml, i,"<",trim(splitStr(i)),">"
!  end do
!end program test

      SUBROUTINE PDLAED1( N, N1, D, ID, Q, IQ, JQ, DESCQ, RHO, WORK,
     $                    IWORK, INFO )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            ID, INFO, IQ, JQ, N, N1
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), Q( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED1 computes the updated eigensystem of a diagonal
*  matrix after modification by a rank-one symmetric matrix,
*  in parallel.
*
*    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)
*
*     where Z = Q'u, u is a vector of length N with ones in the
*     N1 and N1 + 1 th elements and zeros elsewhere.
*
*     The eigenvectors of the original matrix are stored in Q, and the
*     eigenvalues are in D.  The algorithm consists of three stages:
*
*        The first stage consists of deflating the size of the problem
*        when there are multiple eigenvalues or if there is a zero in
*        the Z vector.  For each such occurence the dimension of the
*        secular equation problem is reduced by one.  This stage is
*        performed by the routine PDLAED2.
*
*        The second stage consists of calculating the updated
*        eigenvalues. This is done by finding the roots of the secular
*        equation via the routine SLAED4 (as called by PDLAED3).
*        This routine also calculates the eigenvectors of the current
*        problem.
*
*        The final stage consists of computing the updated eigenvectors
*        directly using the updated eigenvalues.  The eigenvectors for
*        the current problem are multiplied with the eigenvectors from
*        the overall problem.
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*
*  N1      (input) INTEGER
*          The location of the last eigenvalue in the leading
*          sub-matrix.
*          min(1,N) <= N1 <= N.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry,the eigenvalues of the rank-1-perturbed matrix.
*          On exit, the eigenvalues of the repaired matrix.
*
*  ID      (global input) INTEGER
*          Q's global row/col index, which points to the beginning
*          of the submatrix which is to be operated on.
*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*  RHO    (input) DOUBLE PRECISION
*         The subdiagonal entry used to create the rank-1 modification.
*
*  WORK    (local workspace/output) DOUBLE PRECISION array,
*          dimension 6*N + 2*NP*NQ
*
*  IWORK   (local workspace/output) INTEGER array,
*          dimension 7*N + 8*NPCOL + 2
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the ith eigenvalue.
*
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, COLTYP, IBUF, ICTOT, ICTXT, IDLMDA, IIQ,
     $                   INDCOL, INDROW, INDX, INDXC, INDXP, INDXR, INQ,
     $                   IPQ, IPQ2, IPSM, IPU, IPWORK, IQ1, IQ2, IQCOL,
     $                   IQQ, IQROW, IW, IZ, J, JC, JJ2C, JJC, JJQ, JNQ,
     $                   K, LDQ, LDQ2, LDU, MYCOL, MYROW, NB, NN, NN1,
     $                   NN2, NP, NPCOL, NPROW, NQ
*     ..
*     .. Local Arrays ..
      INTEGER            DESCQ2( DLEN_ ), DESCU( DLEN_ )
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DESCINIT, INFOG1L,
     $                   INFOG2L, PDGEMM, PDLAED2, PDLAED3, PDLAEDZ,
     $                   PDLASET, PXERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE IF( N.LT.0 ) THEN
         INFO = -1
      ELSE IF( ID.GT.DESCQ( N_ ) ) THEN
         INFO = -4
      ELSE IF( N1.GE.N ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'PDLAED1', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     The following values are  integer pointers which indicate
*     the portion of the workspace used by a particular array
*     in PDLAED2 and PDLAED3.
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
*
      CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL,
     $              IIQ, JJQ, IQROW, IQCOL )
*
      NP = NUMROC( N, DESCQ( MB_ ), MYROW, IQROW, NPROW )
      NQ = NUMROC( N, DESCQ( NB_ ), MYCOL, IQCOL, NPCOL )
*
      LDQ2 = MAX( NP, 1 )
      LDU = LDQ2
*
      IZ = 1
      IDLMDA = IZ + N
      IW = IDLMDA + N
      IPQ2 = IW + N
      IPU = IPQ2 + LDQ2*NQ
      IBUF = IPU + LDU*NQ
*     (IBUF est de taille 3*N au maximum)
*
      ICTOT = 1
      IPSM = ICTOT + NPCOL*4
      INDX = IPSM + NPCOL*4
      INDXC = INDX + N
      INDXP = INDXC + N
      INDCOL = INDXP + N
      COLTYP = INDCOL + N
      INDROW = COLTYP + N
      INDXR = INDROW + N
*
      CALL DESCINIT( DESCQ2, N, N, NB, NB, IQROW, IQCOL, ICTXT, LDQ2,
     $               INFO )
      CALL DESCINIT( DESCU, N, N, NB, NB, IQROW, IQCOL, ICTXT, LDU,
     $               INFO )
*
*     Form the z-vector which consists of the last row of Q_1 and the
*     first row of Q_2.
*
      IPWORK = IDLMDA
      CALL PDLAEDZ( N, N1, ID, Q, IQ, JQ, LDQ, DESCQ, WORK( IZ ),
     $              WORK( IPWORK ) )
*
*     Deflate eigenvalues.
*
      IPQ = IIQ + ( JJQ-1 )*LDQ
      CALL PDLAED2( ICTXT, K, N, N1, NB, D, IQROW, IQCOL, Q( IPQ ), LDQ,
     $              RHO, WORK( IZ ), WORK( IW ), WORK( IDLMDA ),
     $              WORK( IPQ2 ), LDQ2, WORK( IBUF ), IWORK( ICTOT ),
     $              IWORK( IPSM ), NPCOL, IWORK( INDX ), IWORK( INDXC ),
     $              IWORK( INDXP ), IWORK( INDCOL ), IWORK( COLTYP ),
     $              NN, NN1, NN2, IQ1, IQ2 )
*
*
*     Solve Secular Equation.
*
      IF( K.NE.0 ) THEN
         CALL PDLASET( 'A', N, N, ZERO, ONE, WORK( IPU ), 1, 1, DESCU )
         CALL PDLAED3( ICTXT, K, N, NB, D, IQROW, IQCOL, RHO,
     $                 WORK( IDLMDA ), WORK( IW ), WORK( IZ ),
     $                 WORK( IPU ), LDQ2, WORK( IBUF ), IWORK( INDX ),
     $                 IWORK( INDCOL ), IWORK( INDROW ), IWORK( INDXR ),
     $                 IWORK( INDXC ), IWORK( ICTOT ), NPCOL, INFO )
*
*     Compute the updated eigenvectors.
*
         IQQ = MIN( IQ1, IQ2 )
         IF( NN1.GT.0 ) THEN
            INQ = IQ - 1 + ID
            JNQ = JQ - 1 + ID + IQQ - 1
            CALL PDGEMM( 'N', 'N', N1, NN, NN1, ONE, WORK( IPQ2 ), 1,
     $                   IQ1, DESCQ2, WORK( IPU ), IQ1, IQQ, DESCU,
     $                   ZERO, Q, INQ, JNQ, DESCQ )
         END IF
         IF( NN2.GT.0 ) THEN
            INQ = IQ - 1 + ID + N1
            JNQ = JQ - 1 + ID + IQQ - 1
            CALL PDGEMM( 'N', 'N', N-N1, NN, NN2, ONE, WORK( IPQ2 ),
     $                   N1+1, IQ2, DESCQ2, WORK( IPU ), IQ2, IQQ,
     $                   DESCU, ZERO, Q, INQ, JNQ, DESCQ )
         END IF
*
         DO 10 J = K + 1, N
            JC = IWORK( INDX+J-1 )
            CALL INFOG1L( JQ-1+JC, NB, NPCOL, MYCOL, IQCOL, JJC, COL )
            CALL INFOG1L( JC, NB, NPCOL, MYCOL, IQCOL, JJ2C, COL )
            IF( MYCOL.EQ.COL ) THEN
               IQ2 = IPQ2 + ( JJ2C-1 )*LDQ2
               INQ = IPQ + ( JJC-1 )*LDQ
               CALL DCOPY( NP, WORK( IQ2 ), 1, Q( INQ ), 1 )
            END IF
   10    CONTINUE
      END IF
*
   20 CONTINUE
      RETURN
*
*     End of PDLAED1
*
      END

       subroutine tred1_v(u_x, v_x, v_y, nv, u_t, v_t, beta, prod_uv, i)

       implicit NONE

       integer, intent(in)    ::  nv, i
       real(8), intent(in)    ::  u_x(1:nv)
       real(8), intent(inout) ::  v_x(1:nv), v_y(1:nv)
       real(8), intent(out)   ::  u_t(*), v_t(*)
       real(8), intent(in)    ::  beta, prod_uv

       real(8)                ::  alpha, temp
!       save                       alpha

       integer                ::  x_pos, x_owner_nod
       integer                ::  y_pos, y_owner_nod
       integer                ::  j_1, j_2, j_3
       integer                ::  L
       integer                ::  n, LL, jj_1, jj_2, jj_3

!       integer, parameter     ::  VTOL = 512
       integer, parameter     ::  VTOL = 51200

       include 'trd.h'
       include 'param.h'


       L = i-1

       x_owner_nod = loop_c_node (L, x_nnod,x_inod)
       y_owner_nod = loop_c_node (i, y_nnod,y_inod)

       x_pos       = loop_c_g2l_depth(L, x_nnod,x_inod)
       y_pos       = loop_c_g2l_depth(i, y_nnod,y_inod)

       j_2         = loop_c_start(1, x_nnod,x_inod)
       j_3         = loop_c_end  (L, x_nnod,x_inod)

       n = j_3-j_2+1
       LL = (n-1)/y_nnod+1
       LL = ((LL-1)/2+1)*2

       if ( n > VTOL ) then
          jj_2 = j_2+(1+LL*(y_inod-1))-1
          jj_3 = j_2+(MIN(n,LL*y_inod))-1
       else
          jj_2 = j_2
          jj_3 = j_3
       endif
!
! v':= v-((u,v)/2|u|^2)u
!
       if ( beta /= ZERO ) then

          alpha = prod_uv/(2*beta)

!DIR$ IVDEP
          do j_1=jj_2,jj_3
             v_x(j_1) = (v_x(j_1)-alpha*u_x(j_1))/beta
          end do! j_1

          if ( n > VTOL ) then
             call allgather_dbl(v_x(jj_2), v_t(j_2), LL, y_COMM_WORLD)
             v_x(j_2:j_3) = v_t(j_2:j_3)
          end if

          call datacast_dbl(v_y(1), v_x(1), u_t(1), v_t(1), x_pos)

       else

          x_pos       = loop_c_g2l_depth(i, x_nnod,x_inod)
          y_pos       = loop_c_g2l_depth(i, y_nnod,y_inod)

          v_x(1:x_pos) = ZERO
          v_y(1:y_pos) = ZERO

       end if

! FOR attention to unexpected overflow or NAN
       j_3 = loop_c_end      (L, x_nnod, x_inod)
       n   = loop_c_g2l_depth(L, x_nnod, x_inod)
       if ( j_3 < n ) then
          v_x(j_3+1:n) = ZERO ! in case
       end if

       j_3 = loop_c_end      (L, y_nnod, y_inod)
       n   = loop_c_g2l_depth(L, y_nnod, y_inod)
       if ( j_3 < n ) then
          v_y(j_3+1:n) = ZERO ! in case
       end if


       return
       end subroutine tred1_v

      SUBROUTINE DPOTF2( UPLO, N, A, LDA, INFO )
*
*  -- LAPACK routine (version 3.1) --
*     Univ. of Tennessee, Univ. of California Berkeley and NAG Ltd..
*     November 2006
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, N
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * )
*     ..
*
*  Purpose
*  =======
*
*  DPOTF2 computes the Cholesky factorization of a real symmetric
*  positive definite matrix A.
*
*  The factorization has the form
*     A = U' * U ,  if UPLO = 'U', or
*     A = L  * L',  if UPLO = 'L',
*  where U is an upper triangular matrix and L is lower triangular.
*
*  This is the unblocked version of the algorithm, calling Level 2 BLAS.
*
*  Arguments
*  =========
*
*  UPLO    (input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored.
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (input) INTEGER
*          The order of the matrix A.  N >= 0.
*
*  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
*          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
*          n by n upper triangular part of A contains the upper
*          triangular part of the matrix A, and the strictly lower
*          triangular part of A is not referenced.  If UPLO = 'L', the
*          leading n by n lower triangular part of A contains the lower
*          triangular part of the matrix A, and the strictly upper
*          triangular part of A is not referenced.
*
*          On exit, if INFO = 0, the factor U or L from the Cholesky
*          factorization A = U'*U  or A = L*L'.
*
*  LDA     (input) INTEGER
*          The leading dimension of the array A.  LDA >= max(1,N).
*
*  INFO    (output) INTEGER
*          = 0: successful exit
*          < 0: if INFO = -k, the k-th argument had an illegal value
*          > 0: if INFO = k, the leading minor of order k is not
*               positive definite, and the factorization could not be
*               completed.
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE, ZERO
      PARAMETER          ( ONE = 1.0D+0, ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
      INTEGER            J
      DOUBLE PRECISION   AJJ
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      DOUBLE PRECISION   DDOT
      EXTERNAL           LSAME, DDOT
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGEMV, DSCAL, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, SQRT
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -4
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPOTF2', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Compute the Cholesky factorization A = U'*U.
*
         DO 10 J = 1, N
*
*           Compute U(J,J) and test for non-positive-definiteness.
*
            AJJ = A( J, J ) - DDOT( J-1, A( 1, J ), 1, A( 1, J ), 1 )
            IF( AJJ.LE.ZERO ) THEN
               A( J, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            A( J, J ) = AJJ
*
*           Compute elements J+1:N of row J.
*
            IF( J.LT.N ) THEN
               CALL DGEMV( 'Transpose', J-1, N-J, -ONE, A( 1, J+1 ),
     $                     LDA, A( 1, J ), 1, ONE, A( J, J+1 ), LDA )
               CALL DSCAL( N-J, ONE / AJJ, A( J, J+1 ), LDA )
            END IF
   10    CONTINUE
      ELSE
*
*        Compute the Cholesky factorization A = L*L'.
*
         DO 20 J = 1, N
*
*           Compute L(J,J) and test for non-positive-definiteness.
*
            AJJ = A( J, J ) - DDOT( J-1, A( J, 1 ), LDA, A( J, 1 ),
     $            LDA )
            IF( AJJ.LE.ZERO ) THEN
               A( J, J ) = AJJ
               GO TO 30
            END IF
            AJJ = SQRT( AJJ )
            A( J, J ) = AJJ
*
*           Compute elements J+1:N of column J.
*
            IF( J.LT.N ) THEN
               CALL DGEMV( 'No transpose', N-J, J-1, -ONE, A( J+1, 1 ),
     $                     LDA, A( J, 1 ), LDA, ONE, A( J+1, J ), 1 )
               CALL DSCAL( N-J, ONE / AJJ, A( J+1, J ), 1 )
            END IF
   20    CONTINUE
      END IF
      GO TO 40
*
   30 CONTINUE
      INFO = J
*
   40 CONTINUE
      RETURN
*
*     End of DPOTF2
*
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!  n   : dimension of matrix
!  ar  : matrix(real part)
!  ai  : matrix(imaginary part)
!  w   : array for eigen value
!  lda : size of array "a"
!  m0  : coefficient of blocking
!  ifl : switch flag ( 0:eigen-value and eigen-vector )
!                    ( 1:eigen-value only )
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      subroutine eigen_h(n,ar,ai,w,lda,m0,ifl)
!
      use communication_h, only : eigen_init
     &               , eigen_free
!
      implicit none
      integer, intent(in) :: n, lda, m0, ifl
      real(8), intent(inout) :: ar(lda,*), ai(lda,*), w(*)
      real(8), pointer :: zr(:), zi(:), d(:), e(:), e2(:), tau(:)
      integer :: nb, nm, nma, nmz, nmz1, nmw, nmw1, info, ierr
      integer :: nprow, npcol, i_1, istat
      real(8) :: hs0, hs1
!
      include 'mpif.h'
      include 'trd.h'
!
      call eigen_init(2)
      NPROW = size_of_col
      NPCOL = size_of_row
      call eigen_free(0)
!
      NB  = 48
      nmz = ((n-1)/NPROW+1)
      nmz = ((nmz-1)/NB+1)*NB+1
      nmw = ((n-1)/NPCOL+1)
      nmw = ((nmw-1)/NB+1)*NB+1

      nm=(n/2)*2+1

      nmz1=nm
      nmw1=((n-1)/nprocs+1)

      allocate(
     &               zr(MAX(nmz*nmw+nm+1,nmz1*nmw1)),
     &               zi(MAX(nmz*nmw+nm+1,nmz1*nmw1)),
     &               d(nm),e(nm),e2(nm),tau(2*nm),
     &               stat=istat)
      if(istat.ne.0) then
           if(myrank==1) print*,"Memory exhausted"
           call mpi_abort(mpi_comm_eigen, 1, ierr)
      endif
*
         hs0=MPI_Wtime()
         nma=lda
!----
         call eigen_hrd(n,ar,ai,nma,d,e,e2,tau,nm,m0,zr,zi)
!----
         e2(1:n)=e(1:n)
         w(1:n)=d(1:n)
!----
         call eigen_dch(n,w,e2(2),zr,nmz1,info)
!----
         nma=lda
         call eigen_hbk(ar,ai,nma, zr,zi,nmz1, tau,nm,  n)
!----
#ifdef TIMER
         hs1=MPI_Wtime()
         if(myrank==1)then
            print*," "
            print*,"Total Execution Time of eigen_h =",hs1-hs0,"(sec)"
         endif
#endif
*
         do i_1=1,(n-1)/nprocs+1
           ar(1:n,i_1)=zr(1+nmz1*(i_1-1):n+nmz1*(i_1-1))
           ai(1:n,i_1)=zi(1+nmz1*(i_1-1):n+nmz1*(i_1-1))
         enddo

         deallocate(zr,zi,d,e,e2,tau)
*
      return
      end

module m_PS_opencore
  use m_Files,  only : nfpot, nfout, m_Files_open_ps_files, m_Files_close_ps_file, &
       &               m_Files_open_mag_opencore, m_Files_close_mag_opencore, &
       &               nf_mag_core
  use m_PseudoPotential,  only : nmesh, mmesh, radr_paw, radr, wos
  use m_NonLocal_Potential, only : new_radr_and_wos

  use m_PlaneWaveBasisSet,  only : gr_l
  use m_Parallelization,  only : npes, mype, ista_kngp, iend_kngp, ista_k, mpi_comm_group
  use m_Const_Parameters,  only : DP, ON
  use m_Crystal_Structure,  only : univol
  use m_Ionic_System,  only : ivan, ntyp, iatomn, natm, ityp
  use m_Control_Parameters,  only : noncol,  core_spin_pol_factor, sw_fix_core_spin_pol
  use m_CD_Mag_Moment,   only :  RhoMag_on_atom

  use m_Control_Parameters,  only : nspin, sw_opencore, iprimagmom
  use m_Const_Parameters,  only : OFF
  use m_Ionic_System,  only : mag_moment0_atoms_is_defined, &
       &                      mag_moment0_atomtyp, mag_moment0_atoms, speciesname

  implicit none
  include 'mpif.h'
!
  integer, allocatable :: has_opencore(:)
  real(kind=DP), allocatable :: mag_opencore_pol(:,:)
  real(kind=DP), allocatable :: rmag_opencore(:,:)
  real(kind=DP), allocatable :: rmag_opencore_l(:,:)
  real(kind=DP), allocatable :: m_opencore(:)

contains

  subroutine m_PS_set_rmag_opencore
    integer :: it, ierr, nfp, i, ir
    integer :: num_core_ae_wfns, my_l
    integer, allocatable :: qnum_n_core_ae_wfns(:)
    integer, allocatable :: qnum_l_core_ae_wfns(:)
    real(kind=DP), allocatable :: psir_core_ae_wfns(:,:)
    real(kind=DP), allocatable :: enelevel_core_ae_wfns(:)
    real(kind=DP), allocatable :: focc_core_ae_wfns(:)
    real(kind=DP) :: weight

! == KT_DEBUG === 2015/06/15 == 
!    call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)  
!                                      ! this does not work properly by unknown reason.
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
! =============== 2015/06/15

    if (ierr/=0) call mpi_stop(nfout)

    if ( allocated(rmag_opencore) ) deallocate(rmag_opencore)
    if ( allocated(has_opencore) )  deallocate(has_opencore)
    if ( allocated(m_opencore) )    deallocate(m_opencore)
    allocate( rmag_opencore(mmesh,ntyp) );   rmag_opencore = 0.0d0
    allocate( has_opencore(ntyp) );   has_opencore = 0
    allocate( m_opencore(ntyp) );    m_opencore = 0.0d0

    Do it=1, ntyp
       nfp = nfpot(it)

       if ( mype == 0 ) call read_num_core_ae_wfns( nfp, num_core_ae_wfns, it )
       if ( npes > 1 ) then
          call mpi_bcast(  num_core_ae_wfns, 1, mpi_integer, 0, mpi_comm_world, ierr )
       endif
       
       if ( num_core_ae_wfns == 0 ) cycle
       
       allocate( qnum_n_core_ae_wfns( num_core_ae_wfns ) )
       allocate( qnum_l_core_ae_wfns( num_core_ae_wfns ) )
       allocate( psir_core_ae_wfns( nmesh(it),  num_core_ae_wfns ) )
       allocate( enelevel_core_ae_wfns( num_core_ae_wfns ) )
       allocate( focc_core_ae_wfns( num_core_ae_wfns ) )
       
       if ( mype == 0 ) then
          call read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh(it), &
               &                       qnum_n_core_ae_wfns, qnum_l_core_ae_wfns, &
               &                       psir_core_ae_wfns, &
               &                       enelevel_core_ae_wfns, focc_core_ae_wfns )
       endif
       
       if ( npes > 1 ) then
          call mpi_bcast( qnum_n_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( qnum_l_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_integer, 0, mpi_comm_world, ierr )
          call mpi_bcast( enelevel_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( focc_core_ae_wfns, num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
          call mpi_bcast( psir_core_ae_wfns, nmesh(it)*num_core_ae_wfns, &
               &          mpi_double_precision, 0, mpi_comm_world, ierr )
       endif
!
       Do i=1, num_core_ae_wfns
          my_l = qnum_l_core_ae_wfns(i)
          if ( my_l <= 2 ) then            ! for core-hole
             if ( abs( focc_core_ae_wfns(i) -2.0*(2*my_l +1) ) < 0.1 ) cycle

             has_opencore(it) = 1
             if ( focc_core_ae_wfns(i) <= 2*my_l +1  ) then
                weight = focc_core_ae_wfns(i)
             else
                weight =  2*(2*my_l +1) -focc_core_ae_wfns(i)
             endif
             Do ir=1, nmesh(it)
                rmag_opencore(ir,it) = weight *psir_core_ae_wfns(ir,i) **2
             End Do
             m_opencore(it) = weight
          endif
          if ( qnum_l_core_ae_wfns(i) == 3 ) then
             if ( abs( focc_core_ae_wfns(i) -14.0 ) < 0.1 ) cycle

             has_opencore(it) = 1
             if ( focc_core_ae_wfns(i) <=7  ) then
                weight = focc_core_ae_wfns(i)
             else
                weight =  14.d0 -focc_core_ae_wfns(i)
             endif
             Do ir=1, nmesh(it)
                rmag_opencore(ir,it) = weight *psir_core_ae_wfns(ir,i) **2
             End Do
             m_opencore(it) = weight
          endif
       End Do

       deallocate( qnum_n_core_ae_wfns )
       deallocate( qnum_l_core_ae_wfns )
       deallocate( psir_core_ae_wfns )
       deallocate( enelevel_core_ae_wfns )
       deallocate( focc_core_ae_wfns )

       call m_Files_close_ps_file(it)
    End Do
  end subroutine m_PS_set_rmag_opencore

  subroutine m_PS_set_pcc_opencore
    integer :: ierr, i, ir, n, it, ik
    real(kind=DP) :: gabs, fac
    real(kind=DP), allocatable :: wkx(:), wky(:)

    allocate( rmag_opencore_l( ista_kngp:iend_kngp, ntyp ) )
    rmag_opencore_l = 0.0d0

    allocate(wkx(mmesh)); wkx = 0.d0
    allocate(wky(mmesh)); wky = 0.d0
    allocate(wos(mmesh)); wos = 0

#if 1
    allocate( radr(mmesh)); radr = 0.0d0
#endif


    Do it=1, ntyp
#if 0
       call set_weight_exp( ierr, 1, nmesh(it), radr_paw(:,it), wos )
#else
       ik = ista_k
       call new_radr_and_wos(ik,it)
!       write(*,*) "wos", wos(1:5)
#endif

       if ( has_opencore(it) == 0 ) cycle
!       write(*,*) 'FFFF ', it
!       write(*,*) "FF2 ",  rmag_opencore(10,it)

       do i = ista_kngp, iend_kngp  !for mpi
          gabs = gr_l(i)
#if 0
          do n = 1, nmesh(it)
             wkx(n) = gabs * radr_paw(n,it)
          enddo
#else
          do n = 1, nmesh(it)
             wkx(n) = gabs * radr(n)
          enddo
#endif          
          call dsjnv(0,nmesh(it),wkx, wky)
          
          do  n = 1, nmesh(it)
             fac = wos(n) *rmag_opencore(n,it) /univol
             rmag_opencore_l(i,it) = rmag_opencore_l(i,it) + fac *wky(n)
          enddo
       end do
    End Do
    deallocate( wos )
    deallocate( wkx )
    deallocate( wky )
#if 1
    deallocate( radr )
#endif

  end subroutine m_PS_set_pcc_opencore

  subroutine m_PS_init_mag_opencore_pol
    integer :: ia, it
    real(kind=DP) :: cnorm, fac(3)

    if ( sw_opencore == OFF ) return
    if ( nspin == 1 ) return

    call m_PS_alloc_mag_opencore_pol

    Do ia=1, natm
       it = ityp(ia)
       if ( has_opencore(it) == 0 ) cycle

       if ( noncol ) then
          fac(1) = 0.0d0;      fac(2) = 0.0d0;     fac(3) = 1.0d0

          if ( mag_moment0_atoms_is_defined ) then
             cnorm = sqrt( mag_moment0_atoms(ia,1)**2 &
                  &      +mag_moment0_atoms(ia,2)**2 &
                  &      +mag_moment0_atoms(ia,3)**2 )
             if ( cnorm > 0.0d0 ) then
                fac(1) = mag_moment0_atoms(ia,1) /cnorm
                fac(2) = mag_moment0_atoms(ia,2) /cnorm
                fac(3) = mag_moment0_atoms(ia,3) /cnorm
             endif
          else
             cnorm = sqrt( mag_moment0_atomtyp(it,1)**2 &
                  &      +mag_moment0_atomtyp(it,2)**2 &
                  &      +mag_moment0_atomtyp(it,3)**2 )
             if ( cnorm > 0.0d0 ) then
                fac(1) = mag_moment0_atomtyp(it,1) /cnorm
                fac(2) = mag_moment0_atomtyp(it,2) /cnorm
                fac(3) = mag_moment0_atomtyp(it,3) /cnorm
             endif
          endif
          mag_opencore_pol(ia,1:3) = core_spin_pol_factor *fac(1:3)
       else
          fac(1) = 1.0d0
          if ( mag_moment0_atoms_is_defined ) then
             if ( mag_moment0_atoms(ia,1) < 0.0 ) fac(1) = -1.0d0
          else
             if ( mag_moment0_atomtyp(it,1) < 0.0 ) fac(1) = -1.0d0
          endif
          mag_opencore_pol(ia,1) = core_spin_pol_factor *fac(1)
       endif
    End do
    return
#if 0
    Do ia=1, natm
       it = ityp(ia)
       if ( has_opencore(it) == 0 ) cycle
       if ( noncol ) then
          mag_opencore_pol(ia,3) = core_spin_pol_factor
       else
          mag_opencore_pol(ia,1) = core_spin_pol_factor
       endif
    End do
#endif
  end subroutine m_PS_init_mag_opencore_pol

  subroutine m_PS_set_mag_opencore_pol
    integer :: ia, it
    real(kind=DP) :: c1, c2

    if ( sw_opencore == OFF ) return
    if ( nspin == 1 ) return
    if ( sw_fix_core_spin_pol == ON ) return

    Do ia=1, natm
       it = ityp(ia)
       if ( has_opencore(it) == 0 ) cycle

       if ( noncol ) then
          c1 = RhoMag_on_atom(ia,2)**2 +RhoMag_on_atom(ia,3)**2 +RhoMag_on_atom(ia,4)**2
          c2 = sqrt(c1)
          if ( c2 >1.0D-11 ) then
             mag_opencore_pol(ia,1) = RhoMag_on_atom(ia,2) /c2 *core_spin_pol_factor
             mag_opencore_pol(ia,2) = RhoMag_on_atom(ia,3) /c2 *core_spin_pol_factor
             mag_opencore_pol(ia,3) = RhoMag_on_atom(ia,4) /c2 *core_spin_pol_factor
          else
             mag_opencore_pol(ia,3) = core_spin_pol_factor
          endif
       else
          c1 = RhoMag_on_atom(ia,1) - RhoMag_on_atom(ia,2)
          c2 = abs(c1)
          if ( c2 >1.0D-11 ) then
             mag_opencore_pol(ia,1) = core_spin_pol_factor *c1 /c2
          else
             mag_opencore_pol(ia,1) = core_spin_pol_factor
          endif
       endif
    End Do
  end subroutine m_PS_set_mag_opencore_pol

  subroutine read_num_core_ae_wfns( nfp, nums, it )
    integer, intent(in) :: nfp, it
    integer, intent(out) :: nums

    integer :: length, ierr
    character(30) :: search_key

    nums = 0

    search_key = "CORE STATES";  length = len(search_key)
    call read_size_of_array_from_pp(nfp, nums, length, search_key, ierr)

    if ( ierr /= 0 ) then
       write(nfout,*) '----------------------'
       write(nfout,'(A,I2)') '!!! Keyword CORE STATES is not found in the PP', it
       write(nfout,*) '----------------------'
    endif

  end subroutine read_num_core_ae_wfns

  subroutine read_data_core_ae_wfns( nfp, num_core_ae_wfns, nmesh, &
       &                             qnum_n, qnum_l, psir_core, ene_level, focc )
    implicit none

    integer, intent(in) :: num_core_ae_wfns
    integer, intent(in) :: nmesh, nfp
    integer, intent(out) :: qnum_l(num_core_ae_wfns)
    integer, intent(out) :: qnum_n(num_core_ae_wfns)
    real(kind=8), intent(out) :: psir_core(nmesh, num_core_ae_wfns), &
         &                       ene_level(num_core_ae_wfns), focc(num_core_ae_wfns)

    integer :: i, n1, l1, k
    real(kind=DP) :: ene1, f1

    Do i=1, num_core_ae_wfns
       read(nfp,*) n1, l1, ene1, f1
       read(nfp,*) (psir_core(k,i),k=1,nmesh)
       !
       qnum_n(i) = n1;  qnum_l(i) = l1;  ene_level(i) = ene1;   focc(i) = f1
    End Do
  end subroutine read_data_core_ae_wfns

  subroutine read_size_of_array_from_pp( nfp, size_of_array, length, search_tag, ierr )
    implicit none

    integer, intent(in) :: nfp, length
    integer, intent(out) :: size_of_array, ierr
    character(length), intent(in) :: search_tag

    integer :: ifound
    character(30) :: line1

    size_of_array = 0;  ierr = 0

    Do while (.true.)
       read(nfp,'(a30)',end=10) line1
       ifound = index( line1, search_tag )
       if ( ifound /= 0 ) goto 20
    End do

10  ierr = 1; return

20  read(nfp,*) size_of_array

  end subroutine read_size_of_array_from_pp

  subroutine m_PS_print_core_Magmom_on_atom( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it
    real(kind=DP) :: zz
    
    if ( iprimagmom < 2 ) return
    if ( mype /= 0 ) return
    if ( sw_opencore == OFF ) return

    write(nfout,*) &
         & '! ------------ Core Charge Spin Moment at this scf step --- '

    if ( noncol ) then
       write(nfout,*) &
            & '    id      name          mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          if ( has_opencore(it) == 0 ) cycle
          write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
               &                           m_opencore(it) *mag_opencore_pol(ia,1:3)
       End Do
       
    else if ( nspin == 2 ) then
       write(nfout,*) &
            & '    id      name          mz'
       Do ia=1, natm
          it = ityp(ia)
          if ( has_opencore(it) == 0 ) cycle
          write(nfout,'(I7,6X,A5,F15.8)') ia, speciesname(it), &
               &                          m_opencore(it) *mag_opencore_pol(ia,1)
       End Do
    endif
    write(nfout,*)

  end subroutine m_PS_print_core_Magmom_on_atom

  subroutine m_PS_alloc_mag_opencore_pol
    if ( noncol ) then
       allocate( mag_opencore_pol(natm,3) )
    else
       allocate( mag_opencore_pol(natm,1) )
    endif
    mag_opencore_pol = 0.0d0
  end subroutine m_PS_alloc_mag_opencore_pol

  subroutine m_PS_dealloc_mag_opencore_pol
    deallocate( mag_opencore_pol )
  end subroutine m_PS_dealloc_mag_opencore_pol

  subroutine m_PS_wd_mag_opencore_pol
    integer :: ia, it

    if ( mype /= 0 ) return
    if ( sw_opencore == OFF ) return
    if ( nspin == 1 ) return

    call m_Files_open_mag_opencore
    if ( noncol ) then
       Do ia=1, natm
          it = ityp(ia)
          if ( has_opencore(it) == 0 ) cycle
          write(nf_mag_core,'(I7,6X,3F20.12)') ia, mag_opencore_pol(ia,1:3)
       End Do
    else
       Do ia=1, natm
          it = ityp(ia)
          if ( has_opencore(it) == 0 ) cycle
          write(nf_mag_core,'(I7,6X,F20.12)') ia, mag_opencore_pol(ia,1)
       End Do
    endif
    call m_Files_close_mag_opencore

  end subroutine m_PS_wd_mag_opencore_pol

  subroutine m_PS_rd_mag_opencore_pol
    integer :: ia, it, num, ierr, ipol_max
    if ( sw_opencore == OFF ) return
    if ( nspin == 1 ) return

    call m_PS_alloc_mag_opencore_pol
    if ( noncol ) then
       ipol_max = 3
    else
       ipol_max = 1
    endif

    if ( mype == 0 ) then
       call m_Files_open_mag_opencore
       Do ia=1, natm
          it = ityp(ia)
          if ( has_opencore(it) == 0 ) cycle
          read(nf_mag_core,*) num, mag_opencore_pol(ia,1:ipol_max)
       End Do
       call m_Files_close_mag_opencore
    endif

    call mpi_bcast( mag_opencore_pol, natm*ipol_max, mpi_double_precision, &
         &          0, mpi_comm_group, ierr )

  end subroutine m_PS_rd_mag_opencore_pol

end module m_PS_opencore

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 606 $)
!
!  MODULE: m_Hubbard
!
!  AUTHOR(S): T. Yamamoto   October/11/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!
module m_Hubbard
! $Id: m_Hubbard.f90 606 2020-04-15 06:45:49Z ktagami $
  use m_Const_Parameters,     only : DP,ON,ATOMIC_ORBITAL,SPHERICAL_HARMONICS
  use m_Files,                only : nfout
  use m_Control_Parameters,   only : nspin,ipri,printable,num_projectors &
       &                           , proj_attribute, af, projector_type &
       &                           , sw_constraint, const_site, const_alpha &
       &                           , iprihubbard
  use m_Ionic_System,         only : natm,ntyp,ityp,ihubbard
  use m_PseudoPotential,      only : prodphi,ilmt,ltp,mtp,taup,nlmt,ntau,nlmtt
  use m_Crystal_Structure,    only : op,nopr
  use m_Ionic_System,         only : napt
  use m_Orbital_Population,   only : i2lp,nyy,ilmt_yy,ommix
  use m_Electronic_Structure, only : dhub

! =============================== added by K. Tagami =============== 5.0
  use m_Const_Parameters, only :  OccMat_Type1, OccMat_Type2, FLL, AMF
  use m_Orbital_Population,   only : om
  use m_Control_Parameters,   only : occmat_type, sw_eval_energy_before_charge, &
       &                             dftu_type
! =================================================================== 5.0

! =============================== added by K. Tagami =============== 11.0
  use m_Const_Parameters, only :  CMPLDP
  use m_Control_Parameters, only : ndim_chgpot, ndim_magmom, ndim_spinor
  use m_ES_NonCollinear,  only : m_ES_MagMom_To_DensMat_porb, &
       &                         m_ES_DensMat_To_MagMom_dhub
  use m_Orbital_Population,  only : max2lp
! ================================================================== 11.0

  use m_Orbital_Population,   only : om_aimag, ommix_aimag
  use m_Electronic_Structure, only : dhub_aimag

  implicit none

! ======================== added by K. Tagami======================== 5.0
  real(kind=DP) :: Ueff_prefactor = 1.0D0
! =================================================================== 5.0

contains

  subroutine m_Hubbard_energy(energy)
    real(kind=DP), intent(out) :: energy

    integer :: is,ia,it,i1,i2,ih,ie
    real(kind=DP) :: omsum, c1, nsigma
    real(kind=DP), pointer ::  om_wk(:,:,:,:,:)
    real(kind=DP), allocatable :: delta_om(:,:)

    energy=0.d0
    if(sw_constraint == ON) return

    if ( sw_eval_energy_before_charge==ON ) then
       om_wk => ommix
    else
       om_wk => om
    endif

    do is=1,nspin,af+1
       do ia=1,natm
          ih = ihubbard(ia)
! === Debug by Intel "-check all" option! by T.Kato 2011/03/28 =================
!         ie = proj_attribute(ih)%ielem
!         if(ih /= 0) then
          if(ih /= 0) then
             ie = proj_attribute(ih)%ielem
! ==============================================================================
             it=ityp(ia)
             omsum=0.d0
!
             select case( dftu_type )
             case (FLL)
                omsum=0.d0
                do i2=1,i2lp(ih)
                   omsum = omsum +om_wk(i2,i2,ie,ia,is)
                   do i1=1,i2lp(ih)
                      omsum = omsum -om_wk(i2,i1,ie,ia,is)*om_wk(i1,i2,ie,ia,is)
                   end do
                end do
                energy = energy +0.5d0*proj_attribute(ih)%Ueff*omsum

             case (AMF)
                allocate( delta_om(max2lp,max2lp) ); delta_om = 0.0d0
                delta_om(1:i2lp(ih),1:i2lp(ih)) &
                     &  = om_wk(1:i2lp(ih),1:i2lp(ih),ie,ia,is)

                c1 = 0.0d0
                do i1=1,i2lp(ih)
                   c1 = c1 +om_wk(i1,i1,ie,ia,is)
                End do
                nsigma = c1 /( 2*proj_attribute(ih)%l +1 )
                do i1=1,i2lp(ih)
                   delta_om(i1,i1) = delta_om(i1,i1) -nsigma
                end do

                omsum=0.d0
                do i2=1,i2lp(ih)
                   do i1=1,i2lp(ih)
                      omsum = omsum +delta_om(i1,i2)*delta_om(i2,i1)
                   end do
                end do
                energy = energy -0.5d0*proj_attribute(ih)%Ueff*omsum
                deallocate( delta_om )
             end select

          end if
       end do
    end do
    energy=energy*(af+1)
    if(nspin==1) energy=energy*2.d0

! =============================== added by K. Tagami ==================== 5.0
    energy = energy *Ueff_prefactor
! ======================================================================= 5.0

  end subroutine m_Hubbard_energy

! ======================== added by K. Tagami ======================== 11.0
  subroutine m_Hubbard_energy_noncl(energy)
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is, size1
    real(kind=DP) :: nsigma
    complex(kind=CMPLDP) :: dsum

    real(kind=DP), pointer ::  om_wk_r(:,:,:,:,:), om_wk_i(:,:,:,:,:)
    complex(kind=CMPLDP), allocatable :: delta_dm(:,:,:)

    if(sw_constraint == ON) return
    energy=0.d0

    if ( sw_eval_energy_before_charge==ON ) then
       om_wk_r => ommix;       om_wk_i => ommix_aimag
    else
       om_wk_r => om;          om_wk_i => om_aimag
    endif

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          size1 = i2lp(ih)
          allocate( dmmat_r_magmom(size1,size1,ndim_magmom) ); dmmat_r_magmom = 0.0d0
          allocate( dmmat_i_magmom(size1,size1,ndim_magmom) ); dmmat_i_magmom = 0.0d0
          allocate( dmmat_ssrep(size1,size1,ndim_chgpot) );    dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( size1**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          select case( dftu_type )
          case (FLL)
             dsum=0.d0
             Do is=1, ndim_chgpot
                if ( is==1 .or. is==ndim_chgpot ) then
                   do i2=1,i2lp(ih)
                      dsum = dsum + dmmat_ssrep(i2,i2,is)
                   end do
                endif
             End do
             Do is=1, ndim_chgpot
                do i2=1,i2lp(ih)
                   do i1=1,i2lp(ih)
                      dsum = dsum - dmmat_ssrep(i1,i2,is) &
                           &        *conjg( dmmat_ssrep(i1,i2,is) )
                   end do
                end do
             End do
             energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

          case (AMF)
             allocate( delta_dm(size1,size1,ndim_chgpot) );    delta_dm = 0.0d0
             delta_dm(1:size1,1:size1,1:ndim_chgpot) &
                  &  = dmmat_ssrep(1:size1,1:size1,1:ndim_chgpot)

             dsum = 0.0d0
             Do is=1, ndim_chgpot
                if ( is==1 .or. is==ndim_chgpot ) then
                   do i2=1,i2lp(ih)
                      dsum = dsum + dmmat_ssrep(i2,i2,is)
                   end do
                endif
             End do

             nsigma = dsum /( 2*proj_attribute(ih)%l +1 ) /ndim_spinor

             Do is=1, ndim_chgpot
                if ( is==1 .or. is==ndim_chgpot ) then
                   do i2=1,i2lp(ih)
                      delta_dm(i1,i1,is) = delta_dm(i1,i1,is) -nsigma
                   end do
                endif
             End do

             dsum=0.d0
             Do is=1, ndim_chgpot
                do i2=1,i2lp(ih)
                   do i1=1,i2lp(ih)
                      dsum = dsum + delta_dm(i1,i2,is) &
                           &        *conjg( delta_dm(i1,i2,is) )
                   end do
                end do
             End do
             energy = energy -0.5d0*proj_attribute(ih)%Ueff *real(dsum)
             deallocate( delta_dm )
          end select

          deallocate( dmmat_r_magmom, dmmat_i_magmom )
          deallocate( dmmat_ssrep )
       end if
    end do

    energy = energy *Ueff_prefactor

  end subroutine m_Hubbard_energy_noncl

  subroutine m_Hubbard_energy2_noncl(energy)           ! for safety
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is, size1
    complex(kind=CMPLDP) :: dsum

    if(sw_constraint == ON) return

    energy=0.d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          dmmat_r_magmom = 0.0d0
          dmmat_i_magmom = 0.0d0
          dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          dsum=0.d0
          Do is=1, ndim_chgpot
             if ( is==1 .or. is==ndim_chgpot ) then
                do i2=1,i2lp(ih)
                   dsum = dsum + dmmat_ssrep(i2,i2,is)
                end do
             endif
          End do
          Do is=1, ndim_chgpot
             do i2=1,i2lp(ih)
                do i1=1,i2lp(ih)
                   dsum = dsum - dmmat_ssrep(i1,i2,is) &
                        &        *conjg( dmmat_ssrep(i1,i2,is) )
                end do
             end do
          End do

          energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

       end if
    end do

    energy = energy *Ueff_prefactor

    deallocate( dmmat_r_magmom, dmmat_i_magmom )
    deallocate( dmmat_ssrep )

  end subroutine m_Hubbard_energy2_noncl

  subroutine m_Hubbard_energy3_noncl(energy)           ! for safety
    real(kind=DP), intent(out) :: energy

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )
    complex(kind=CMPLDP), allocatable :: dm_large( :,: )

    integer :: ia, it,i1,i2,ih,ie
    integer :: is1, is2,  size1
    complex(kind=CMPLDP) :: dsum

    if(sw_constraint == ON) return

    energy=0.d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    allocate( dm_large( max2lp*ndim_spinor, max2lp*ndim_spinor ) )
    dm_large = 0.0d0

    do ia=1,natm
       ih = ihubbard(ia)
       if(ih /= 0) then
          ie = proj_attribute(ih)%ielem
          it=ityp(ia)

          dmmat_r_magmom = 0.0d0
          dmmat_i_magmom = 0.0d0
          dmmat_ssrep = 0.0d0

          if ( sw_eval_energy_before_charge == ON ) then
             dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)
          else
             dmmat_r_magmom(:,:,:) = om(:,:,ie,ia,:)
             dmmat_i_magmom(:,:,:) = om_aimag(:,:,ie,ia,:)
          endif
          call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
               &                            dmmat_ssrep )

          dm_large = 00.0d0

          Do is1=1, ndim_spinor
             Do is2=1, ndim_spinor
                do i1=1,i2lp(ih)
                   do i2=1,i2lp(ih)
                      dm_large( max2lp*(is1-1) +i1, max2lp*(is2-1)+i2 ) &
                           &  = dmmat_ssrep( i1,i2, (is1-1)*ndim_spinor +is2 )
                   end do
                end do
             end do
          end do

          dsum=0.d0
          Do i1=1, ndim_spinor *max2lp
             dsum = dsum + dm_large( i1,i1 )
          End do
          Do i1=1, ndim_spinor *max2lp
             Do i2=1, ndim_spinor *max2lp
                dsum = dsum - dm_large( i1,i2 )*dm_large(i2,i1)
             end do
          End do

          energy = energy + 0.5d0*proj_attribute(ih)%Ueff *real(dsum)

       end if
    end do

    energy = energy *Ueff_prefactor

    deallocate( dm_large )
    deallocate( dmmat_r_magmom, dmmat_i_magmom )
    deallocate( dmmat_ssrep )

  end subroutine m_Hubbard_energy3_noncl
! ===================================================================== 11.0

  subroutine m_Hubbard_Potential(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff

    dhub = 0.d0
    do is=1,nspin,af+1
       do ia=1,natm
          if(sw_constraint == ON .and. ia /= const_site) cycle
          ih = ihubbard(ia)
          if(ih == 0) cycle
          Ueff = proj_attribute(ih)%Ueff
          it = proj_attribute(ih)%ityp
          ie = proj_attribute(ih)%ielem
          if(projector_type == SPHERICAL_HARMONICS) then
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih)
                m1=mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih)
                m2=mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                !!$write(nfout,'("m1,t1,m2,t2=",4i3)') m1,t1,m2,t2
                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ilmt1,ilmt2,ia,is,dhub=",4i3,e12.5)') ilmt1,ilmt2,ia,is,dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ueff,ommix,prodphi=",3e12.5)') Ueff,ommix(m1,m2,ie,ia,is),prodphi(ih,t1,t2)
             end do
          else if(projector_type == ATOMIC_ORBITAL) then
             t0 = proj_attribute(ih)%t
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih)
                m1=mtp(ilmt1,it)
                t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih)
                m2=mtp(ilmt2,it)
                t2=taup(ilmt2,it)
                !!$write(nfout,'("m1,t1,m2,t2=",4i3)') m1,t1,m2,t2
                if(sw_constraint == ON) then
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   end if
                else
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                      & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                      & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ilmt1,ilmt2,ia,is,dhub=",4i3,e12.5)') ilmt1,ilmt2,ia,is,dhub(ilmt1,ilmt2,ia,is)
                !!$write(nfout,'("ie,ueff,ommix,prodphi=",i3,3e12.5)') ie,Ueff,ommix(m1,m2,ie,ia,is),prodphi(ih,t1,t2)
             end do
          end if
       end do
    end do

    if(iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential")')
       do is=1,nspin,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
             end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential

! =============================- added by K. Tagami ================ 5.0
  subroutine m_Hubbard_Potential2(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp, c1, nsigma
!
    integer :: ilmt3, ilmt4, i1
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp
!
    if(.not.allocated(dhub)) then
       write(nfout,'(" dhub is not allocated (subroutine m_Hubbard_Potential2)")')
       call flush(nfout)
       stop ' dhub is not allocated (subroutine m_Hubbard_Potential2)'
    end if
    dhub = 0.d0
    do is=1,nspin,af+1
       do ia=1,natm
          if(sw_constraint == ON .and. ia /= const_site) cycle
          ih = ihubbard(ia)
          if(ih == 0) cycle
          Ueff = proj_attribute(ih)%Ueff

          it = proj_attribute(ih)%ityp
          ie = proj_attribute(ih)%ielem
          
          t0 = proj_attribute(ih)%t

          if ( occmat_type == OCCMAT_Type1 ) then
             select case(dftu_type)
             case (0)
                do iyy=1,nyy(ih)
                   ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                   ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                   dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                end do

             case (FLL)
                do iyy=1,nyy(ih)
                   ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                   ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                   dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                end do

             case (AMF)
                c1 = 0.0d0
                do i1=1,i2lp(ih)
                   c1 = c1 +ommix(i1,i1,ie,ia,is)
               End do
                nsigma = c1 /( 2*proj_attribute(ih)%l +1 )

                do iyy=1,nyy(ih)
                   ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                   ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
!
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *( nsigma -ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                   dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                end do

             end select

          else if ( occmat_type == OCCMAT_Type2 ) then
             select case(dftu_type)
             case (0)
                t0 = proj_attribute(ih)%t
                do iyy=1,nyy(ih)
                   ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                   ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                   ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)
                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha *ctmp
                   end if
                end do

             case (FLL)
                t0 = proj_attribute(ih)%t
                do iyy=1,nyy(ih)
                   ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                   ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                   ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)

                   if(m1==m2) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is)) *ctmp
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*ctmp
                   end if
                   dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
                end do

             end select

          end if
       end do
    end do
! ======================================= addd by K. Tagami ============= 5.2
    dhub = dhub *Ueff_prefactor
! ======================================================================= 5.2

    if(iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential")')
       do is=1,nspin,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential2
! ============================================================== 5.0

! ================== added by K. Tagami ================= 11.0
  subroutine m_Hubbard_Potential2_noncl(nfout)          
!                                        This does not work properly.
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp
! 
    integer :: ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp
!
    dhub = 0.d0
    do ia=1,natm
       if(sw_constraint == ON .and. ia /= const_site) cycle

       ih = ihubbard(ia)
       if(ih == 0) cycle

       Ueff = proj_attribute(ih)%Ueff

       it = proj_attribute(ih)%ityp
       ie = proj_attribute(ih)%ielem
          
       t0 = proj_attribute(ih)%t

       Do is=1, ndim_magmom
          if ( occmat_type == OCCMAT_Type1 ) then
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                
                if (sw_constraint == ON) then        
                   if ( is==1 .and. m1==m2) then     ! uncertain
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha*prodphi(ih,t1,t2)
                   end if
                else
                   if ( is == 1 .and. m1==m2 ) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is))*prodphi(ih,t1,t2)
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*prodphi(ih,t1,t2)
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          else if ( occmat_type == OCCMAT_Type2 ) then
             t0 = proj_attribute(ih)%t
             do iyy=1,nyy(ih)
                ilmt1=ilmt_yy(1,iyy,ih); m1=mtp(ilmt1,it); t1=taup(ilmt1,it)
                ilmt2=ilmt_yy(2,iyy,ih); m2=mtp(ilmt2,it); t2=taup(ilmt2,it)
                ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)

                if (sw_constraint == ON) then
                   if ( is==1 .and. m1==m2 ) then            ! uncertain
                      dhub(ilmt1,ilmt2,ia,is)=const_alpha *ctmp
                   end if
                else
                   if ( is==1 .and. m1==m2 ) then
                      dhub(ilmt1,ilmt2,ia,is)=Ueff &
                           & *(0.5d0-ommix(m1,m2,ie,ia,is)) *ctmp
                   else
                      dhub(ilmt1,ilmt2,ia,is)=-Ueff &
                           & *ommix(m1,m2,ie,ia,is)*ctmp
                   end if
                end if
                dhub(ilmt2,ilmt1,ia,is)=dhub(ilmt1,ilmt2,ia,is)
             end do
          end if
       end do
    end do

    dhub = dhub *Ueff_prefactor

! --- for debug --
!    Do is=1, ndim_magmom
!       write(920,*) 'is = ', is
!       Do ia=1, natm
!          write(920,*) 'ia = ' , ia
!          Do ilmt1=1, ilmt(it)
!             Do ilmt2=1, ilmt(it)
!                write(920,*) 'ilmt1 ilmt2 = ' ,ilmt1, ilmt2
!                write(920,*) dhub(ilmt1,ilmt2,ia,is)
!             End do
!          End do
!       End do
!    End do
! ---------------

    if (iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential2_noncl")')
       do is=1,ndim_magmom,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if
  end subroutine m_Hubbard_Potential2_noncl

  subroutine m_Hubbard_Potential3_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia,iyy
    integer :: ilmt1,m1,t1,ilmt2,m2,t2
    integer :: ih,it,ie,t0
    real(kind=DP) :: Ueff, ctmp
! 
    integer :: ilmt3, ilmt4
    integer :: l1, l2, l3, l4, m3, m4, t3, t4, ilp

    real(kind=DP), allocatable :: dmmat_r_magmom( :,:,: )
    real(kind=DP), allocatable :: dmmat_i_magmom( :,:,: )
    complex(kind=CMPLDP), allocatable :: dmmat_ssrep( :,:,: )
!
    complex(kind=CMPLDP), allocatable :: dhub_ssrep( :,:,:,: )
!

    dhub = 0.d0

    allocate( dhub_ssrep(nlmt,nlmt,natm,ndim_magmom) )
    dhub_ssrep = 0.0d0

    allocate( dmmat_r_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_i_magmom(max2lp,max2lp,ndim_magmom) )
    allocate( dmmat_ssrep(max2lp,max2lp,ndim_chgpot) )

    do ia=1,natm
       if(sw_constraint == ON .and. ia /= const_site) cycle

       ih = ihubbard(ia)
       if(ih == 0) cycle

       Ueff = proj_attribute(ih)%Ueff

       it = proj_attribute(ih)%ityp
       ie = proj_attribute(ih)%ielem
          
       t0 = proj_attribute(ih)%t
       ilp = proj_attribute(ih)%l +1

       dmmat_r_magmom = 0.0d0;   dmmat_i_magmom = 0.0d0;  dmmat_ssrep = 0.0d0
       dmmat_r_magmom(:,:,:) = ommix(:,:,ie,ia,:)
       dmmat_i_magmom(:,:,:) = ommix_aimag(:,:,ie,ia,:)

       call m_ES_MagMom_To_DensMat_porb( max2lp**2, dmmat_r_magmom, dmmat_i_magmom, &
            &                            dmmat_ssrep )

       Do is=1, ndim_chgpot
          if ( occmat_type == OCCMAT_Type1 ) then
             select case (dftu_type)
             case (0)
                stop 'kt : not supported. '

             case (FLL)
                do ilmt1=1, ilmt(it)
                   do ilmt2=1, ilmt(it)
                      l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                      l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)

                      if ( l1 /= l2 .or. l1 /= ilp ) cycle

                      if ( (is == 1 .or. is==ndim_chgpot) .and. m1==m2 ) then
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = Ueff &
                              & *( 0.5d0 - dmmat_ssrep(m1,m2,is) )*prodphi(ih,t1,t2)
                      else
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = -Ueff &
                              & *dmmat_ssrep(m1,m2,is) *prodphi(ih,t1,t2)
                         !                           & *conjg( dmmat_ssrep(m1,m2,is) ) *prodphi(ih,t1,t2)
                      end if
                   end do
                end do

             end select

          else if ( occmat_type == OCCMAT_Type2 ) then
             t0 = proj_attribute(ih)%t

             select case (dftu_type)
             case (0)
                stop 'kt : not supported. '

             case (FLL)
                do ilmt1=1, ilmt(it)
                   do ilmt2=1, ilmt(it)
                      l1 = ltp(ilmt1,it); m1 = mtp(ilmt1,it); t1 = taup(ilmt1,it)
                      l2 = ltp(ilmt2,it); m2 = mtp(ilmt2,it); t2 = taup(ilmt2,it)

                      if ( l1 /= l2 .or. l1 /= ilp ) cycle
                      ctmp = prodphi(ih,t1,t0)*prodphi(ih,t0,t2)

                      if ( (is == 1 .or. is==ndim_chgpot) .and. m1==m2 ) then
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = Ueff &
                              & *( 0.5d0 - dmmat_ssrep(m1,m2,is) )*ctmp
                      else
                         dhub_ssrep(ilmt1,ilmt2,ia,is) = -Ueff &
                              & *dmmat_ssrep(m1,m2,is) *ctmp
                      end if
                   end do
                end do
             end select

          end if
       end do
    end do
!
    call m_ES_DensMat_to_MagMom_Dhub( dhub_ssrep, dhub, dhub_aimag )
!
    dhub = dhub *Ueff_prefactor
    dhub_aimag = dhub_aimag *Ueff_prefactor
!
    goto 1200

! --- for debug --
    Do is=1, ndim_magmom
       write(920,*) 'is = ', is
       Do ia=1, natm
          write(920,*) 'ia = ' , ia
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                write(920,*) 'ilmt1 ilmt2 = ' ,ilmt1, ilmt2
                write(920,*) dhub_ssrep(ilmt1,ilmt2,ia,is)
             End do
          End do
       End do
    End do
! ---------------

    do ia=1,natm
       do is=1, ndim_magmom

          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                write(960,*) ' ia lmt1 lmtm2 istmp = ', ia, ilmt1, ilmt2, is
                write(960,*) 'A ', dhub(ilmt1,ilmt2,ia,is), dhub(ilmt2,ilmt1,ia,is)
                write(960,*) 'B ', dhub_aimag(ilmt1,ilmt2,ia,is), dhub_aimag(ilmt2,ilmt1,ia,is)
             end do
          end do
       end do
    end do

1200 continue

    if (iprihubbard >2) then
       write(nfout,'("m_Hubbard_Potential3_noncl")')
       do is=1,ndim_magmom,af+1
          do ia=1,natm
             ih=ihubbard(ia)
             if(ih==0) cycle
             it=ityp(ia)
             write(nfout,'("is,ia,it=",3i3)') is,ia,it
             do ilmt1=1,ilmt(it)
                write(nfout,'(14f8.3)') (dhub(ilmt1,ilmt2,ia,is),ilmt2=1,ilmt(it))
              end do
          end do
       end do
    end if

    deallocate( dhub_ssrep )
    deallocate( dmmat_ssrep )
    deallocate( dmmat_r_magmom, dmmat_i_magmom )

  end subroutine m_Hubbard_Potential3_noncl
! ============================================================== 11.0

end module m_Hubbard

!!
!! Last updated: 01 Feb 2011 on asahi.nims.go.jp
!! real-time electron-ion dynamics simulation
!! time-dependent density functional theory
!!
!! 12 Sep 2012, some unstable routines removed, isir, osaka univ.
!!

module m_rttddft

use m_Const_Parameters,only : &
  &  DP,PAI,PAI2,PAI4,CMPLDP,zi,ELECTRON,DIRECT,ON,OFF,BUCS,CARTS,MAPPED &
  & ,SmallestPositiveNumber
use m_Parallelization,only : &
  &  mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr &
  & ,myrank_e,map_e,ista_e,iend_e,istep_e,myrank_k,map_k,ista_k,iend_k,np_e,map_z
use m_Control_Parameters,only : &
  &  neg,kimg,nspin,af &
  & ,sw_rttddft &
  & ,ext_ie_elec,ext_ie_hole &
  & ,ext_pulse_epsilon,ext_pulse_kx,ext_pulse_ky,ext_pulse_kz &
  & ,time_step_max,time_step_delta &
  & ,propagator_method,propagator_order
use m_Crystal_Structure,only : &
  &  altv,rltv,univol
use m_Ionic_System,only : &
  &  ntyp, iatom, ityp, iwei, natm, natm2, ityp, pos, cps
use m_FFT,only : &
  &  m_FFT_WF,m_FFT_Vlocal_W_3D,fft_box_size_WF,nfft
use m_PseudoPotential,only : &
  &  ival,ilmt,nlmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,taup,q,dion &
  & ,nloc,ntau,ntyp,mmesh,nmesh,betar,wos,lpsmax
use m_PlaneWaveBasisSet,only : &
  &  ngabc,kg1,m_pwBS_kinetic_energies,nbase,iba,igf
use m_Kpoints,only : &
  &  kv3,vkxyz,qwgt
use m_Charge_Density,only : &
  &  m_CD_softpart_3D,m_CD_hardpart,m_CD_rspace_charge &
  & ,m_CD_alloc_rspace_charge,m_CD_dealloc_rspace_charge &
  & ,chgq_l,hsr
!!---- phase_v800
!use m_Electronic_Structure,only : &
!  &  zaj_l,vlhxcQ,occup_l,eko_l,fsr_l,fsi_l,vlhxc_l &
!  & ,m_ES_Vlocal_in_Rspace,m_ES_WF_in_Rspace &
!  & ,m_ES_alloc_fft_related,m_ES_dealloc_fft_related,afft,bfft &
!  & ,m_ES_alloc_scss_etc,m_ES_dealloc_scss_etc,sc,ss,qc,qs &
!  & ,m_ES_Vnonlocal_W,vnlph_l,m_ES_betar_dot_WFs &
!  & ,m_ES_betar_dot_WFs_4_each_k,m_ES_betar_dot_WFs_4_lmta_k
!!---- phaseUnif
use m_Electronic_Structure,only : &
  &  zaj_l,vlhxcQ,occup_l,eko_l,fsr_l,fsi_l,vlhxc_l &
  & ,m_ES_Vlocal_in_Rspace_3D,m_ES_WF_in_Rspace_3D &
  & ,m_ES_alloc_fft_related,m_ES_dealloc_fft_related,afft,bfft &
  & ,vnlph_l
use m_ES_nonlocal,only : &
  &  sc,ss,qc,qs &
  & ,m_ES_Vnonlocal_W_3D &
  & ,m_ES_alloc_scss_etc_3D &
  & ,m_ES_dealloc_scss_etc &
  & ,m_ES_betar_dot_WFs_3D &
  & ,m_ES_betar_dot_WFs_4_each_k_3D &
  & ,m_ES_betar_dot_WFs_4_lmta_k_3D
!!----
use m_NonLocal_Potential,only : &
  &  snl
use m_Files,only : &
  &  nfout,nfchr,m_Files_open_nfchr
use m_Parallelization,only : mpi_kg_world, mpi_ke_world, mpi_ge_world, &
                             nel_fft_z, nel_fft_y, nel_fft_x, &
                             mp_g1k, myrank_g, ista_g1k, iend_g1k, xyz_fft_y, np_g1k
use m_FFT,            only : m_FFT_Direct_3D
use m_ES_WF_by_SDorCG,only : map_fft_to_WF_3D

implicit none
include 'mpif.h'

contains

!!
!!---- external impulse electric field at time=0+
!!     vector potential: A_ext(t) = [A0*r_i]*theta(t)
!!     electric field: E_ext(t) = -(dA(t)/dt)/c = -[A0*r_i]*delta(t)/c
!!     phi(r,t=0+) = exp(i*k_ext*r_i)*phi(r,t=0-)
!!
subroutine m_rttddft_init_impulse_field

  integer :: is,ik,ib,i1,ri,i,j,k,id,mm,nl,nm,nn,n1,n2,n3,nlhf,inew,jnew,knew,ip
  real(kind=DP) :: rx,ry,rz,dn1,dn2,dn3,denom
  complex(kind=CMPLDP) :: ctmp
  integer :: iadd, nx, ny, nz
! === FFT 3D ===================================================================
  integer :: ibsize, lsize, isrsize, fft_l_size
  real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
  real(kind=DP), allocatable, dimension(:,:) :: bfft_l
! ==============================================================================

  if(ext_pulse_epsilon==0.0.and. &
  &  ext_pulse_kx==0.0.and.ext_pulse_ky==0.0.and.ext_pulse_kz==0.0) return
! === FFT 3D ===================================================================
  ibsize = 1
  lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
  allocate(wk_bfft_l(lsize*kimg,ibsize), stat=ierr)
  allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
! ==============================================================================

  write(nfout,'(''# impulse electric field at time=0+'')')
  write(nfout,'(''# eps='',f6.3,'' kx='',f6.3,'' ky='',f6.3,'' kz='',f6.3)') &
  &  ext_pulse_epsilon,ext_pulse_kx,ext_pulse_ky,ext_pulse_kz

  call m_ES_alloc_fft_related()
  denom=1.0d0/product(fft_box_size_WF(1:3,1))
  nl=fft_box_size_WF(1,1); nm=fft_box_size_WF(2,1); nn=fft_box_size_WF(3,1)
  nx = xyz_fft_y(2,1)-xyz_fft_y(1,1)+1
  ny = xyz_fft_y(2,2)-xyz_fft_y(1,2)+1
  nz = xyz_fft_y(2,3)-xyz_fft_y(1,3)+1
! Now, kimg should not be 1!!!

  do ik=1,kv3
  if(map_k(ik) /= myrank_k) cycle
! === FFT 3D ===================================================================
  isrsize = min(lsize,mp_g1k(ik))
  fft_l_size  = nel_fft_x(myrank_g)
! ==============================================================================
  do ib=1,np_e
    call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
    do k=0,nz-1
    do j=0,ny-1
    do i=0,nx-1
! Now, kimg should not be 1!!!
      knew=k; jnew=j; inew=i
      ip=jnew+inew*ny+knew*ny*nx+1
      dn1=dble(i+xyz_fft_y(1,1)-1)/dble(nl)
      dn2=dble(j+xyz_fft_y(1,2)-1)/dble(nm)
      dn3=dble(k+xyz_fft_y(1,3)-1)/dble(nn)
      rx=altv(1,1)*dn1+altv(1,2)*dn2+altv(1,3)*dn3
      ry=altv(2,1)*dn1+altv(2,2)*dn2+altv(2,3)*dn3
      rz=altv(3,1)*dn1+altv(3,2)*dn2+altv(3,3)*dn3
      ctmp=cdexp(zi*ext_pulse_epsilon* &
        & (ext_pulse_kx*rx+ext_pulse_ky*ry+ext_pulse_kz*rz)) &
        & *dcmplx(wk_bfft_l(ip*2-1,1),wk_bfft_l(ip*2,1))
      wk_bfft_l(ip*2-1,1)=dreal(ctmp)
      wk_bfft_l(ip*2,  1)=dimag(ctmp)
    enddo
    enddo
    enddo
    call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
    call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
    do ri=1,kimg
    do i=ista_g1k(ik),iend_g1k(ik)
      iadd = i - ista_g1k(ik) + 1
      i1=kimg*iadd+(ri-kimg)
      zaj_l(iadd,ib,ik,ri)=bfft_l(i1,1)*denom
    enddo
    enddo
  enddo
  enddo
  call m_ES_dealloc_fft_related() 
! === FFT 3D ===================================================================
  deallocate(wk_bfft_l)
  deallocate(bfft_l)
! ==============================================================================
  do ik=1,kv3
    if(map_k(ik) /= myrank_k) cycle
    call m_ES_betar_dot_WFs_3D(nfout,ik)
  end do

end subroutine m_rttddft_init_impulse_field


!!
!!---- electron excitation: manual occupation control at time=0+
!!     occupation(filled-band,k) <--> occupation(empty-band,k)
!!
subroutine m_rttddft_init_occup_control

  integer :: ik,ie
  real(kind=DP) :: occup_tmp1,occup_tmp2
  real(kind=DP),allocatable,dimension(:,:) :: eko_mpi,occup_mpi,tmp_mpi

  if(ext_ie_elec==0.or.ext_ie_hole==0) return

  allocate(eko_mpi(neg,kv3)) ; eko_mpi=0.0d0
  allocate(occup_mpi(neg,kv3)) ; occup_mpi=0.0d0

  if(npes >= 2) then
    allocate(tmp_mpi(neg,kv3))
!-- occup_mpi
    tmp_mpi=0.0d0
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=occup_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    tmp_mpi = occup_mpi
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
!-- eko_mpi
    tmp_mpi=0.0d0
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=eko_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    tmp_mpi = eko_mpi
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
    deallocate(tmp_mpi)
  else
    occup_mpi=occup_l
    eko_mpi=eko_l
  endif

  if(mype==0) then
    write(nfout,'(''# time=0-'')')
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

!-- exchange occupation
  do ik=1,kv3
    occup_tmp1=occup_mpi(ext_ie_elec,ik)
    occup_tmp2=occup_mpi(ext_ie_hole,ik)
    occup_mpi(ext_ie_elec,ik)=occup_tmp2
    occup_mpi(ext_ie_hole,ik)=occup_tmp1
  enddo

  do ik=ista_k,iend_k
    do ie=1,neg
      if(map_e(ie) /= myrank_e) cycle
      occup_l(map_z(ie),ik)=occup_mpi(ie,ik)
    enddo
  enddo

  if(mype==0) then
    write(nfout,'(''# time=0+'')')
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

  deallocate(occup_mpi,eko_mpi)

end subroutine m_rttddft_init_occup_control


!!
!!---- propagator: Taylor expansion method
!!
subroutine m_rttddft_propagate_wf_by_taylor

  integer :: is,ik,ib,ie,iadd
  integer :: i,i1,iksnl,n_taylor,n_taylor_max
  real(kind=DP) :: fac,denom
  real(kind=DP),allocatable,dimension(:) :: ekin_tmp
  complex(kind=CMPLDP) :: cfac,ctmp
  complex(kind=CMPLDP),allocatable,dimension(:,:,:) :: czaj_l
  complex(kind=CMPLDP),allocatable,dimension(:) :: czaj_tmp
! === FFT 3D ===================================================================
  integer :: ibsize, lsize, isrsize, fft_l_size
  real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
  real(kind=DP), allocatable, dimension(:,:) :: bfft_l
  real(kind=DP), allocatable, dimension(:) :: afft_l
! ==============================================================================

  allocate(czaj_l(maxval(np_g1k),np_e,ista_k:iend_k)); czaj_l=(0.0d0,0.0d0)
  allocate(czaj_tmp(maxval(np_g1k))); czaj_tmp=(0.0d0,0.0d0)
  allocate(ekin_tmp(maxval(np_g1k))); ekin_tmp=0.0d0

  call m_ES_alloc_fft_related() 
! === FFT 3D ===================================================================
  ibsize = 1
  lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
  allocate(wk_bfft_l(lsize*kimg,ibsize), stat=ierr)
  allocate(bfft_l(lsize*kimg,ibsize) ,stat=ierr)
  allocate(afft_l(lsize*kimg), stat=ierr)
! ==============================================================================

  if(propagator_order<0) then
    stop '** ERROR(RTTDDFT): propagator_order should be more than zero'
  endif
  n_taylor_max=propagator_order  !! input parameters (positive integer or zero)
  cfac=-zi*time_step_delta
  fac=1.0
  denom=1.0d0/product(fft_box_size_WF(1:3,1))

!!-- n=0 term
  do ik=1,kv3
    if(map_k(ik)/=myrank_k) cycle
    do ib=1,np_e
      do i=ista_g1k(ik),iend_g1k(ik)
        iadd = i - ista_g1k(ik) + 1
        czaj_l(iadd,ib,ik)=dcmplx(zaj_l(iadd,ib,ik,1),(kimg-1)*zaj_l(iadd,ib,ik,kimg))
      enddo
    enddo
  enddo

!!-- n>1 terms
  do n_taylor=1,n_taylor_max  !! serial processing
    fac=fac/dble(n_taylor)  !! inverse of n factorial = 1/(n!)
    do is=1,nspin,af+1
      call m_ES_Vlocal_in_Rspace_3D(is,afft_l,lsize,1,OFF)
      do ik=is,kv3-nspin+is,nspin
        if(map_k(ik)/=myrank_k) cycle
! === FFT 3D ===================================================================
        isrsize = min(lsize,mp_g1k(ik))
        fft_l_size  = nel_fft_x(myrank_g)
! ==============================================================================
        call m_pwBS_kinetic_energies(ik,vkxyz,ekin_tmp)
        iksnl=(ik-1)/nspin+1
        call m_ES_Vnonlocal_W_3D(ik,iksnl,is,OFF)
        do ie=1,np_e
          ib = ie
          czaj_tmp=(0.0d0,0.0d0)
!! T|wf>
          do i=ista_g1k(ik),iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            czaj_tmp(iadd)=czaj_tmp(iadd) &
              +ekin_tmp(iadd)*dcmplx(zaj_l(iadd,ib,ik,1),(kimg-1)*zaj_l(iadd,ib,ik,kimg))
          enddo
!! V_lhxc|wf>
          call m_ES_WF_in_Rspace_3D(ik,ib,ib,ibsize,lsize,wk_bfft_l)
          call m_FFT_Vlocal_W_3D(afft_l,wk_bfft_l,lsize,ibsize,nel_fft_y(myrank_g))
          call m_FFT_Direct_3D(nfout,wk_bfft_l,lsize,ibsize)
          call map_fft_to_WF_3D(ik,lsize,ibsize,wk_bfft_l,bfft_l,isrsize,fft_l_size)
          do i=ista_g1k(ik),iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            czaj_tmp(iadd)=czaj_tmp(iadd)+dcmplx(bfft_l(2*iadd-1,1),bfft_l(2*iadd,1))*denom
          enddo
!! V_nonlocal|wf>
          do i=ista_g1k(ik),iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            czaj_tmp(iadd)=czaj_tmp(iadd) &
              +dcmplx(vnlph_l(iadd,ib,1),(kimg-1)*vnlph_l(iadd,ib,kimg))
          enddo
! czaj_l=sum_n{(1/n!)(-idtH)^n|wf>} and zaj_l=(-idtH)^n|wf>
          do i=ista_g1k(ik),iend_g1k(ik)
            iadd = i - ista_g1k(ik) + 1
            czaj_l(iadd,ib,ik)=czaj_l(iadd,ib,ik)+fac*cfac*czaj_tmp(iadd)
            zaj_l(iadd,ib,ik,1)=dreal(cfac*czaj_tmp(iadd))
            if(kimg==2) zaj_l(iadd,ib,ik,kimg)=dimag(cfac*czaj_tmp(iadd))
          enddo
        enddo
        call m_ES_betar_dot_WFs_3D(nfout,ik)
      enddo
    enddo
  enddo

!-- zaj_l(t+dt)=exp(-idtH)*zaj_l(t)
  do is=1,nspin,af+1
    do ik=is,kv3-nspin+is,nspin
      if(map_k(ik) /= myrank_k) cycle
      do ib=1,np_e
        do i=ista_g1k(ik),iend_g1k(ik)
          iadd = i - ista_g1k(ik) + 1
          zaj_l(iadd,ib,ik,1)=dreal(czaj_l(iadd,ib,ik))
          if(kimg==2) zaj_l(iadd,ib,ik,kimg)=dimag(czaj_l(iadd,ib,ik))
        enddo
      enddo
      call m_ES_betar_dot_WFs_3D(nfout,ik)
    enddo
  enddo

  call m_ES_dealloc_fft_related() 
! === FFT 3D ===================================================================
  deallocate(wk_bfft_l)
  deallocate(bfft_l)
  deallocate(afft_l)
! ==============================================================================
  deallocate(ekin_tmp)
  deallocate(czaj_tmp)
  deallocate(czaj_l)
end subroutine m_rttddft_propagate_wf_by_taylor



!!
!!---- dipole moment
!!     NOTE: Here is only valid for isolated systems,
!!     and a molecule should be located at the center of unit cell.
!!
subroutine m_rttddft_dipole
  integer :: i,ia,id,im,ip
  real(kind=DP) :: g(3),r0(3),len(3)
  real(kind=DP) :: d_ele(3),d_ion(3)
  real(kind=DP) :: d_ele_mpi(3)
  complex(kind=CMPLDP) :: ccha

  d_ele=0.0d0; d_ion=0.0d0
  r0(1)=0.0d0; r0(2)=0.0d0; r0(3)=0.0d0
  len(1)=sqrt(sum(altv(1:3,1)**2)); len(2)=sqrt(sum(altv(1:3,2)**2)); len(3)=sqrt(sum(altv(1:3,3)**2))

! electron
  do i=ista_kngp,iend_kngp
    ccha=dcmplx(chgq_l(i,1,1    ),(kimg-1)*chgq_l(i,kimg,1    )) &
      & +dcmplx(chgq_l(i,1,nspin),(kimg-1)*chgq_l(i,kimg,nspin))*(nspin-1)
    g(1)=rltv(1,1)*ngabc(i,1)+rltv(1,2)*ngabc(i,2)+rltv(1,3)*ngabc(i,3)
    g(2)=rltv(2,1)*ngabc(i,1)+rltv(2,2)*ngabc(i,2)+rltv(2,3)*ngabc(i,3)
    g(3)=rltv(3,1)*ngabc(i,1)+rltv(3,2)*ngabc(i,2)+rltv(3,3)*ngabc(i,3)
    do id=1,3
      if(id==1) then; ip=2; im=3; endif
      if(id==2) then; ip=3; im=1; endif
      if(id==3) then; ip=1; im=2; endif
      if(abs(g(ip))<1.d-10.and.abs(g(im))<1.d-10) then
        if(abs(g(id))<1.d-10) then
          d_ele(id)=d_ele(id)+len(ip)*len(im)*ccha*0.5*((r0(id)+len(id))**2.0-r0(id)**2.0)
        else
          d_ele(id)=d_ele(id)+len(ip)*len(im)*ccha &
        & *((zi*g(id)*(r0(id)+len(id))-1.0)*cdexp(zi*g(id)*(r0(id)+len(id))) &
        &  -(zi*g(id)*r0(id)-1.0)*cdexp(zi*g(id)*r0(id)))/(zi*g(id))**2.0
        endif
      endif
    enddo
  enddo
  if(npes > 1) then
    d_ele_mpi=0.0d0
    call mpi_allreduce(d_ele,d_ele_mpi,3,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    d_ele=d_ele_mpi
    call mpi_allreduce(d_ele,d_ele_mpi,3,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
    d_ele=d_ele_mpi
  endif
  d_ele=-d_ele

! ion
  do ia=1,natm
  do id=1,3
    d_ion(id)=d_ion(id)+ival(ityp(ia))*cps(ia,id)
    if(iwei(ia)/=1) &
  & d_ion(id)=d_ion(id)-ival(ityp(ia))*cps(ia,id)
  enddo
  enddo

  write(nfout,'(''P='',3f20.10)') (d_ele(id)+d_ion(id),id=1,3)
! for debug
! write(nfout,'(''# dipole moment (tot) ='',3f20.10)') (d_ele(id)+d_ion(id),id=1,3)
! write(nfout,'(''# dipole moment (ele) ='',3f20.10)') (d_ele(id),id=1,3)
! write(nfout,'(''# dipole moment (ion) ='',3f20.10)') (d_ion(id),id=1,3)

end subroutine m_rttddft_dipole


!!
!!---- current density, induced polarization, & induced vector potential
!!
subroutine m_rttddft_current
  integer :: is,ik,ib,i,nb,id,iadd
  real(kind=DP) :: g(3),fac,tmp
  complex(kind=CMPLDP) :: j_ele(3),ctmp
  complex(kind=CMPLDP) :: j_ele_mpi(3)

  real(kind=DP),save :: p_ind(3)=0.0d0
  real(kind=DP),save :: a_ind(3)=0.0d0

  j_ele=(0.0d0,0.0d0)
  do is=1,nspin,af+1
  do ik=is,kv3-nspin+is,nspin
  if(map_k(ik) /= myrank_k) cycle
  do ib=1,np_e
  fac=dble(2/nspin)*qwgt(ik)*occup_l(ib,ik)
  do i=ista_g1k(ik),iend_g1k(ik)
    iadd = i - ista_g1k(ik) + 1
    nb=nbase(i,ik)
    g(1)=vkxyz(ik,1,CARTS)+rltv(1,1)*ngabc(nb,1)+rltv(1,2)*ngabc(nb,2)+rltv(1,3)*ngabc(nb,3)
    g(2)=vkxyz(ik,2,CARTS)+rltv(2,1)*ngabc(nb,1)+rltv(2,2)*ngabc(nb,2)+rltv(2,3)*ngabc(nb,3)
    g(3)=vkxyz(ik,3,CARTS)+rltv(3,1)*ngabc(nb,1)+rltv(3,2)*ngabc(nb,2)+rltv(3,3)*ngabc(nb,3)
    ctmp=fac*dconjg(dcmplx(zaj_l(iadd,ib,ik,1),(kimg-1)*zaj_l(iadd,ib,ik,kimg))) &
                 & *dcmplx(zaj_l(iadd,ib,ik,1),(kimg-1)*zaj_l(iadd,ib,ik,kimg))
    j_ele(1)=j_ele(1)+g(1)*ctmp
    j_ele(2)=j_ele(2)+g(2)*ctmp
    j_ele(3)=j_ele(3)+g(3)*ctmp
  enddo
  enddo
  enddo
  enddo
  if(npes > 1) then
    j_ele_mpi=0.0d0
    call mpi_allreduce(j_ele,j_ele_mpi,3,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
    j_ele=j_ele_mpi
  endif
  j_ele=-j_ele

  write(nfout,'(''J='',3f20.10)') (dreal(j_ele(id)),id=1,3)
! for debug
! write(nfout,'(''# total current (ele) ='',3f20.10)') (dreal(j_ele(id)),id=1,3)

  tmp=sqrt(dimag(j_ele(1))**2.+dimag(j_ele(2))**2.+dimag(j_ele(3))**2.)
  if(tmp>1.d5*SmallestPositiveNumber) &
  &  write(nfout,'(''# WARNING: Im[J(t)]='',3f20.10)') (dimag(j_ele(id)),id=1,3)


!!-- induced polarization: dP(t)/dt = j(t)/V
!  p_ind=p_ind+dreal(j_ele)*time_step_delta/univol
!  write(nfout,'(''# induced polarization (ele) ='',3f20.10)') (p_ind(id),id=1,3)
!
!!-- **** here is not reliable ****
!!-- induced vector potential: dA(t)/dt = P(t)
!  a_ind=a_ind+p_ind*time_step_delta
!  write(nfout,'(''# induced vector potential (ele) ='',3f20.10)') (a_ind(id),id=1,3)

end subroutine m_rttddft_current


!!
!!---- for debug write: eigen values & occupations
!!
subroutine m_rttddft_print_eko_occup

  integer :: ie,ik
  real(kind=DP),allocatable,dimension(:,:) :: eko_mpi,occup_mpi,tmp_mpi

  allocate(eko_mpi(neg,kv3)) ; eko_mpi=0.0d0
  allocate(occup_mpi(neg,kv3)) ; occup_mpi=0.0d0

  if(npes >= 2) then
    allocate(tmp_mpi(neg,kv3)) ; tmp_mpi=0.0d0
!-- occup mpi
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=occup_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    tmp_mpi = occup_mpi
    call mpi_allreduce(tmp_mpi,occup_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
!-- eko mpi
    tmp_mpi = 0.0d0
    do ik=1,kv3
      if(map_k(ik) /= myrank_k) cycle
      do ie=1,neg
        if(map_e(ie) /= myrank_e) cycle
        tmp_mpi(ie,ik)=eko_l(map_z(ie),ik)
      enddo
    enddo
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_kg_world,ierr)
    tmp_mpi = eko_mpi
    call mpi_allreduce(tmp_mpi,eko_mpi,neg*kv3 &
      & ,mpi_double_precision,mpi_sum,mpi_ge_world,ierr)
    deallocate(tmp_mpi)
  else
    occup_mpi=occup_l
    eko_mpi=eko_l
  endif

  if(mype==0) then
    do ik=1,kv3
      write(nfout,'(''# occ ik='',i4)') ik
      write(nfout,'(10f8.4)') (occup_mpi(ie,ik),ie=1,neg)
      write(nfout,'(''# eko ik='',i4)') ik
      write(nfout,'(10f8.4)') (eko_mpi(ie,ik),ie=1,neg)
    enddo
  endif

  deallocate(occup_mpi,eko_mpi)

end subroutine m_rttddft_print_eko_occup



end module m_rttddft

      module  eigen_devel
!$    use OMP_LIB
      use MPI, only : MPI_COMM_WORLD, MPI_THREAD_SINGLE
      implicit NONE


         public ! default is public

!$       integer                :: MPI_THREAD_MODE = MPI_THREAD_SINGLE
         character*(8), private :: Process_Grid_Major
         logical, private       :: Eigen_initialized_flag = .FALSE.

         integer                :: TRD_inod       = 0
         integer                :: TRD_nnod       = 0
         integer                :: TRD_COMM_WORLD = MPI_COMM_WORLD

         integer                :: x_inod, x_nnod, x_COMM_WORLD,
     &                             y_inod, y_nnod, y_COMM_WORLD,
     &                             z_inod, z_nnod, z_COMM_WORLD,
     &                             w_inod, w_nnod, w_COMM_WORLD,
     &                             n_common, diag_0, diag_1

         integer, pointer       :: p0_(:), q0_(:)

         integer, parameter     :: nsx = 480
         integer, parameter     :: nsm = 256 ! 64 +32
         integer, parameter     :: ns0 = nsm * nsm + 6
         integer, parameter     :: MBAND = 2

         real(8), pointer       :: rt_timer(:,:)
         integer                :: rt_ptr(0:16)

         real(8)                :: time_bcast, time_reduce,
     &                             time_redist, time_gather


      contains


         real(8) function eigen_get_wtime( ) result(ret)
!$       use OMP_LIB
         use MPI
         implicit NONE

#ifdef _OPENMP
!$          ret = omp_get_wtime( )
#else
            ret = MPI_Wtime( )
#endif

         return
         end function  eigen_get_wtime

         subroutine eigen_set_initialized( )

            Eigen_initialized_flag = .TRUE.

         return
         end subroutine eigen_set_initialized

         subroutine eigen_unset_initialized( )

            Eigen_initialized_flag = .FALSE.

         return
         end subroutine eigen_unset_initialized

         subroutine eigen_get_initialized( flag )
         logical :: flag

            flag = Eigen_initialized_flag

         return
         end subroutine eigen_get_initialized

         subroutine eigen_set_grid_major( Major )
         character*(*) Major

            Process_Grid_Major(1:1) = Major(1:1)

         return
         end subroutine eigen_set_grid_major

         subroutine eigen_get_grid_major( Major )
         character*(*) Major

            Major(1:1) = Process_Grid_Major(1:1)

         return
         end subroutine eigen_get_grid_major

         subroutine  eigen_timer_reset( )

            time_bcast  = 0D0
            time_reduce = 0D0
            time_redist = 0D0
            time_gather = 0D0

         return
         end subroutine eigen_timer_reset

         subroutine eigen_timer_print( )

#if TIMER_PRINT
            if ( TRD_inod == 1 ) then
               print*, "COMM_STAT"
               print*, "   BCAST  :: ", time_bcast
               print*, "   REDUCE :: ", time_reduce
               print*, "   REDIST :: ", time_redist
               print*, "   GATHER :: ", time_gather
            end if
#endif

         return
         end subroutine  eigen_timer_print

!$       subroutine sync_other_than_master( TRBK_lock )
!$       use OMP_LIB
!$       integer(kind=omp_lock_kind) :: TRBK_lock(1:2)
!$       integer(kind=omp_lock_kind) :: TMP_lock(1:2)
!$
!$          if ( omp_get_num_threads() == 1 ) return
!$          if ( omp_get_thread_num() == 0 ) return
!$
!$          TMP_lock(1) = 2**omp_get_num_threads() - 2
!$
!$          call omp_set_lock( TRBK_lock(1) )
!$          TRBK_lock(2) = ibset( TRBK_lock(2), omp_get_thread_num() )
!$          call omp_unset_lock( TRBK_lock(1) )
!$
!$          do
!$             call omp_set_lock( TRBK_lock(1) )
!$             TMP_lock(2) = TRBK_lock(2)
!$             call omp_unset_lock( TRBK_lock(1) )
!$             if ( TMP_lock(1) == TMP_lock(2) ) exit
!$          end do
!$
!$       end subroutine  sync_other_than_master


      end module  eigen_devel

module m_SpinOrbit_Potential
! $Id: m_SpinOrbit_Potential.F90 606 2020-04-15 06:45:49Z ktagami $
  use m_Control_Parameters,  only : noncol, ndim_spinor, ndim_chgpot, proj_attribute, &
       &                            SpinOrbit_mode
  use m_Const_Parameters,    only : DP, CMPLDP, zi, ON, Hartree, Neglected
  use m_PseudoPotential,     only : nlmt, ltp, mtp, taup, prodphi, nlmta, ilmt, &
       &                            nloc, ntau
  use m_Ionic_System,        only : natm, itab_spinorbit_addition, ityp, ntyp, &
       &                            speciesname

! == KT_add === 13.2S
  use m_Crystal_Structure,  only : sw_fix_global_quantz_axis,  &
       &                           Global_Quantz_Axis_Fixed, &
       &                           sw_spinorbit_force_theorem
  use m_Files,  only : nfout
! ============= 13.2S

  use m_Parallelization,   only : mype

  implicit none
  include 'mpif.h'

! -----------------------------------
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L0( 2*0+1, -0:0 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L1( 2*1+1, -1:1 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L2( 2*2+1, -2:2 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L3( 2*3+1, -3:3 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L4( 2*4+1, -4:4 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L5( 2*5+1, -5:5 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L6( 2*6+1, -6:6 )
!
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L0(  0:0, 0:0, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L1( -1:1,-1:1, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L2( -2:2,-2:2, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_cmplx_ylm_L3( -3:3,-3:3, 4 )
!
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L0( 1, 1, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L1( 3, 3, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L2( 5, 5, 4 )
  complex(kind=CMPLDP) :: Mat_LS_with_real_ylm_L3( 7, 7, 4 )
! -----------------------------------
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L0( 1*2,1*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L1( 3*2,3*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L2( 5*2,5*2 )
  complex(kind=CMPLDP) :: EigenWfns_MatLS_L3( 7*2,7*2 )
! -----------------------------------
  real(kind=DP) :: EigenVals_MatLS_L0( 1*2 )
  real(kind=DP) :: EigenVals_MatLS_L1( 3*2 )
  real(kind=DP) :: EigenVals_MatLS_L2( 5*2 )
  real(kind=DP) :: EigenVals_MatLS_L3( 7*2 )
! -----
!
  Complex(kind=CMPLDP), allocatable  :: dsoc(:,:,:,:)

  real(kind=DP), allocatable :: Mat_SOC_Strength(:,:,:,:)

contains

! ============================================================
!!
!!!  Allocate and deallocate arrays
!!
!===============================================================-
  subroutine m_SO_alloc_Dsoc
    if (nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_Dsoc)'
    allocate( dsoc(nlmt,nlmt,natm,ndim_chgpot )); dsoc = 0.d0
  end subroutine m_SO_alloc_Dsoc

  subroutine m_SO_dealloc_Dsoc
    if (allocated(dsoc)) deallocate(dsoc)
  end subroutine m_SO_dealloc_Dsoc
  
  subroutine m_SO_alloc_Mat_SOC_Strenth
    allocate( Mat_SOC_Strength(nloc,ntau,ntau,natm) )
    Mat_SOC_Strength = 0.0d0
  end subroutine m_SO_alloc_Mat_SOC_Strenth

  subroutine m_SO_dealloc_Mat_SOC_Strenth
    if ( allocated( Mat_SOC_Strength) ) deallocate( Mat_SOC_Strength )
  end subroutine m_SO_dealloc_Mat_SOC_Strenth

! ========================================================================
!!
!!!   calc < Ylm Chi_s | L.S | Chi_s' Ylm' >, where Ylm is real spherical harmonics
!!
!=========================================================================
  subroutine m_SO_calc_MatLS_orb_s_to_f
    real(kind=DP) :: theta, phi
    
    theta = 0.0; phi = 0.0d0

    if ( noncol ) then
    else 
       if ( sw_spinorbit_force_theorem == ON &
            &     .and. sw_fix_global_quantz_axis == ON ) then
          theta = acos( Global_Quantz_Axis_Fixed(3))
          phi = atan2( Global_Quantz_Axis_Fixed(2), Global_Quantz_Axis_Fixed(1) )
!          write(nfout,*) "theta = ", theta, phi
       endif
    endif

    call m_SO_calc_MatLS_with_Cmplx_ylm( 0, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L0 )
    call m_SO_calc_MatLS_with_Real_ylm( 0, MatU_ylm_RC_L0, &
         &                              Mat_LS_with_cmplx_ylm_L0, &
         &                              Mat_LS_with_real_ylm_L0 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 1, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L1 )
    call m_SO_calc_MatLS_with_Real_ylm( 1, MatU_ylm_RC_L1, &
         &                              Mat_LS_with_cmplx_ylm_L1, &
         &                              Mat_LS_with_real_ylm_L1 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 2, theta, phi, &
         &                               Mat_LS_with_cmplx_ylm_L2 )
    call m_SO_calc_MatLS_with_Real_ylm( 2, MatU_ylm_RC_L2, &
         &                              Mat_LS_with_cmplx_ylm_L2, &
         &                              Mat_LS_with_real_ylm_L2 )
!
    call m_SO_calc_MatLS_with_Cmplx_ylm( 3, theta, phi, &
         &                            Mat_LS_with_cmplx_ylm_L3 )
    call m_SO_calc_MatLS_with_Real_ylm( 3, MatU_ylm_RC_L3, &
         &                              Mat_LS_with_cmplx_ylm_L3, &
         &                              Mat_LS_with_real_ylm_L3 )
  end subroutine m_SO_calc_MatLS_orb_s_to_f

  subroutine m_SO_diagonalize_MatLS
    integer :: my_l, lwork, info
    integer :: nsize, nsize0
    real(kind=DP), allocatable :: rwork(:), MatW(:)
    complex(kind=CMPLDP), allocatable :: work(:), MatA(:,:)
    integer :: m1, m2
    
    Do my_l = 1, 3                 ! p-orbital to f-orbital
       nsize0 = 2 *my_l + 1
       nsize = nsize0 *ndim_spinor

       allocate( MatA( nsize, nsize ) ); allocate( MatW( nsize ) )
       MatA = 0.0d0

       call set_Mat_A( my_l )

       lwork = max( 1, 2*nsize -1 )
       allocate( rwork( max( 1, 3*nsize -2 ) )); rwork = 0.0d0
       allocate( work(  max( 1, lwork ) )); work = 0.0d0
!
       call zheev( 'V', 'U', nsize, MatA, nsize, MatW, &
            &       work, lwork, rwork, info )
!
       if ( my_l == 1 ) EigenVals_MatLS_L1 = MatW
       if ( my_l == 2 ) EigenVals_MatLS_L2 = MatW
       if ( my_l == 3 ) EigenVals_MatLS_L3 = MatW

!       Do m1=1, nsize
!          write(*,*) 'Eigen Val m1 ', m1, MatW(m1)
!          Do m2=1, nsize
!             write(*,*) m2, m1, MatA( m2,m1 )
!          End do
!       End do

       call get_eigenwfns_with_real_ylm( my_l )
       deallocate( rwork, work, MatA, MatW )

    End Do
! --
    EigenWfns_MatLS_L0(1,1) = 1.0d0;      EigenWfns_MatLS_L0(2,2) = 1.0d0
!    stop "AAA"
    !    
  contains

    subroutine get_eigenwfns_with_real_ylm( my_l )
      integer, intent(in) :: my_l
      integer :: m1, m2, ma
      integer :: is1
      complex(kind=CMPLDP) :: z1

      Do m2=1, nsize
         Do is1=1, ndim_spinor
            Do m1=1, 2*my_l +1
               z1 = 0.0d0
               if ( my_l == 1 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 +  MatU_ylm_RC_L1( m1, ma )  &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L1( nsize0*(is1-1) +m1, m2 ) = z1
               else if ( my_l == 2 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 + MatU_ylm_RC_L2( m1, ma ) &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L2( nsize0*(is1-1) +m1, m2 ) = z1
               else if ( my_l == 3 ) then
                  Do ma=-my_l, my_l
                     z1 = z1 + MatU_ylm_RC_L3( m1,ma ) &
                          &    *MatA( nsize0*(is1-1)+ma+my_l +1, m2 )
                  End do
                  EigenWfns_MatLS_L3( nsize0*(is1-1) +m1, m2 ) = z1
               endif
            End do
         End do
      End Do
    end subroutine get_eigenwfns_with_real_ylm

    subroutine set_mat_A( my_l )
      integer, intent(in) :: my_l

      integer :: is1, is2, istmp
      integer :: m1, m2

      Do is1=1, ndim_spinor
         Do is2=1, ndim_spinor
            istmp = ( is1 -1 )*ndim_spinor + is2
            Do m1=1, nsize0
               Do m2=1, nsize0
                  
                  if ( my_l == 1 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L1( m1-my_l-1,m2-my_l-1,istmp )
                  else if ( my_l == 2 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L2( m1-my_l-1,m2-my_l-1,istmp )
                  else if ( my_l == 3 ) then
                     MatA( nsize0*(is1-1)+m1, nsize0*(is2-1)+m2 ) &
                          &    = Mat_LS_with_cmplx_ylm_L3( m1-my_l-1,m2-my_l-1,istmp )
                  endif
               End Do
            End Do
         End Do
      End do
    end subroutine set_mat_A

  end subroutine m_SO_diagonalize_MatLS

  subroutine m_SO_print_SOC_on_atoms
    integer :: l_min, l_max, t1 ,t2, it, ia, l1, num, lun
    real(kind=DP), allocatable :: guzai(:)

    if ( SpinOrbit_mode == Neglected ) return

    l_min = 2;   l_max = 4
    t1 = 1; t2 = 1

    allocate( guzai(l_min:l_max) );  guzai = 0.0d0

    lun = 1000
    if ( mype == 0 ) then
       open( unit=lun, file="SOI_phase", status="unknown", form = "formatted" )
       write(lun,'(A,8X,A,9X,A,9X,A)') "# no.  name", "p-orbital", &
            &           "d-orbital", "f-orbital  (unit eV)"
       Do ia=1, natm
          it = ityp(ia)
          Do l1=l_min, nloc
             guzai(l1) = Mat_Soc_Strength(l1,t1,t2,ia)
          End Do
          write(lun,'(I4,2X,A5,3F18.8)') ia, speciesname(it), guzai(l_min:l_max) *Hartree
       End Do
       close(lun)
! --
    end if
    deallocate( guzai )
  end subroutine m_SO_print_SOC_on_atoms

! ===================================================================
!!
!!!  set array "dsoc", zeta *< Ylm Chi_s | L.S | Chi_s' Ylm' > 
!!
!===================================================================
  subroutine m_SO_set_Dsoc_potential1     ! Dsoc  is hermitian.

    if ( noncol ) then
       call goto_noncollinear
    else
       stop 'Not supported: Spin-Orbit potential in the collinear case'
    end if

  contains 
    
    subroutine goto_noncollinear
      integer :: ia, ih, it, il, is
      integer :: iyy, ilmt1, ilmt2
      integer :: l1, l2, m1, m2, t1, t2

      real(kind=DP) :: LScoupling
      Complex(kind=CMPLDP) :: z1

      dsoc = 0.d0

      Do ia=1, natm
         ih = itab_spinorbit_addition(ia)
         if (ih == 0) cycle

         LScoupling = proj_attribute(ih)%LScoupling0 &
              &      *proj_attribute(ih)%LScoupling_scaling_factor

         it = proj_attribute(ih)%ityp
         il = proj_attribute(ih)%l
!
         Do ilmt1=1, ilmt(it)
            Do ilmt2=1, ilmt(it)
               l1 = ltp(ilmt1,it);  m1 = mtp(ilmt1,it);  t1 = taup(ilmt1,it)
               l2 = ltp(ilmt2,it);  m2 = mtp(ilmt2,it);  t2 = taup(ilmt2,it)

!!               if ( t1 /= 1 .or. t2 /= 1 ) cycle
!               if ( t1 /= t2 ) cycle

               if ( l1 == il+1 .and. l2 == l1 ) then

                  Do is=1, ndim_chgpot
                     if ( il == 0 ) then
                        z1 = Mat_LS_with_real_ylm_L0( m1, m2, is )
                     else if ( il == 1 ) then
                        z1 = Mat_LS_with_real_ylm_L1( m1, m2, is )
                     else if ( il == 2 ) then
                        z1 = Mat_LS_with_real_ylm_L2( m1, m2, is )
                     else if ( il == 3 ) then
                        z1 = Mat_LS_with_real_ylm_L3( m1, m2, is )
                     endif
                     dsoc( ilmt1,ilmt2, ia, is ) &
                          &   = LScoupling *prodphi( ih, t1, t2 ) *z1

!                     write(854,*) ilmt1, ilmt2, ia, is, dsoc( ilmt1, ilmt2, ia, is)
!                     write(855,*) ilmt1, ilmt2, ia, is, z1
                  End do
               endif
            End do
         End do
      End do

!      stop 'IIIIIIIIIIIII '

    end subroutine goto_noncollinear

  end subroutine m_SO_set_Dsoc_potential1

  subroutine m_SO_set_Dsoc_potential2
    integer :: ia, it
    integer :: ilmt1, ilmt2, l1, l2, t1, t2, m1, m2
    integer :: is, il
    complex(kind=CMPLDP) :: z1
    
    dsoc = 0.0d0
    
    Do ia=1, natm
       it = ityp(ia)
       
       Do ilmt1=1, ilmt(it)
          Do ilmt2=1, ilmt(it)
             l1 = ltp(ilmt1,it);  m1 = mtp(ilmt1,it);  t1 = taup(ilmt1,it)
             l2 = ltp(ilmt2,it);  m2 = mtp(ilmt2,it);  t2 = taup(ilmt2,it)
             
             if ( l1 /=l2  ) cycle
             il = l1 - 1
             
             Do is=1, ndim_chgpot
                if ( il == 0 ) then
                   z1 = Mat_LS_with_real_ylm_L0( m1, m2, is )
                else if ( il == 1 ) then
                   z1 = Mat_LS_with_real_ylm_L1( m1, m2, is )
                else if ( il == 2 ) then
                   z1 = Mat_LS_with_real_ylm_L2( m1, m2, is )
                else if ( il == 3 ) then
                   z1 = Mat_LS_with_real_ylm_L3( m1, m2, is )
                endif
                
                dsoc( ilmt1, ilmt2, ia, is ) &
                     &     = Mat_Soc_Strength( l1, t1, t2, ia ) *z1
             End do
          End do
       End Do
    End Do

  end subroutine m_SO_set_Dsoc_potential2

! ====================
!
!  calc < Ylm a | LS | Yl'm' b >
!
! =======================
  subroutine m_SO_calc_MatLS_with_Real_ylm( l_in, MatU_ylm_RC, &
       &                                    Mat_LS_with_cmplx_ylm, &
       &                                    Mat_LS_with_real_ylm )
    integer, intent(in) :: l_in
    Complex(kind=CMPLDP), intent(in) :: MatU_ylm_RC( 2*l_in+1, -l_in:l_in )
    complex(kind=CMPLDP), intent(in) :: &
         &    Mat_LS_with_cmplx_ylm( -l_in:l_in, -l_in:l_in, ndim_chgpot )
    complex(kind=CMPLDP), intent(out) :: &
         &    Mat_LS_with_real_ylm( 2*l_in+1, 2*l_in+1, ndim_chgpot )

    integer :: m_min, m_max
    !
    integer :: is
    integer :: m1, m2, ma, mb
!
    Complex(kind=CMPLDP) :: ztmp( ndim_chgpot )
    !
!
!    write(860,*) 'lin = ', l_in
!    write(860,*) Mat_LS_with_cmplx_ylm

    m_min = -l_in;  m_max = l_in
!
!    write(870,*) 'lin = ', l_in
!    Do m1=1, 2*l_in + 1
!       Do ma=m_min, m_max
!          write(870,*) m1, ma, MatU_ylm_RC( m1, ma )
!       End do
!    End do
!
    Do m1=1, 2 *l_in +1
       Do m2=1, 2 *l_in +1
          
          ztmp = 0.0d0
          
          Do ma = m_min, m_max
             Do mb = m_min, m_max
                Do is=1, ndim_chgpot
#if 0
                   ztmp(is) = ztmp(is) + conjg(MatU_ylm_RC( m1,ma ))&
                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
                        &                *( MatU_ylm_RC( m2,mb ) )
#else
                   ztmp(is) = ztmp(is) + MatU_ylm_RC( m1,ma )&
                        &                *Mat_LS_with_cmplx_ylm( ma,mb,is ) &
                        &                *conjg( MatU_ylm_RC( m2,mb ) )
#endif

                End do
             End do
          End do
          Mat_LS_with_real_ylm( m1,m2,: ) = ztmp(:)
       End do
    End do
  end subroutine m_SO_calc_MatLS_with_Real_ylm
  
  subroutine m_SO_calc_MatLS_with_Cmplx_ylm( l_in, theta, phi, Mat_LS_term )
    integer, intent(in) :: l_in
    real(kind=DP), intent(in) :: theta, phi
    complex(kind=CMPLDP), intent(out) :: &
         &          Mat_LS_term( -l_in:l_in, -l_in:l_in, ndim_chgpot )
    
    real(kind=DP) :: cos_th, sin_th, cos2_th_h, sin2_th_h
    real(kind=DP) :: ctmp_m, ctmp_p, ctmp_0
    
    complex(kind=CMPLDP) :: zi_phi_p, zi_phi_m
    complex(kind=CMPLDP) :: ztmp1, ztmp2, ztmp3
    
    integer :: m1, m2
    
    cos_th = cos( theta );  sin_th = sin( theta )
    cos2_th_h = cos( theta/2.0d0 )**2
    sin2_th_h = 1.0d0 - cos2_th_h
    
    zi_phi_p = exp( zi*phi );    zi_phi_m = exp( -zi*phi )

    Do m1=-l_in, l_in
       Do m2=-l_in, l_in

          if ( m2 == m1 +1 ) then
             ctmp_m = sqrt( (l_in +m1 +1.0d0) *( l_in -m1 ) )
          else
             ctmp_m = 0.0d0
          endif

          if ( m2 == m1 -1 ) then
             ctmp_p = sqrt( (l_in -m1 +1.0d0) *( l_in +m1 ) )
          else
             ctmp_p = 0.0d0
          endif
          !
          if ( m1 == m2 ) then
             ctmp_0 = dble(m1)
          else
             ctmp_0 = 0.0d0
          endif

          !
          ztmp1 =  ctmp_0 *cos_th + ctmp_p *sin_th *zi_phi_m / 2.0d0 &
               &                  + ctmp_m *sin_th *zi_phi_p / 2.0d0 

          ztmp2 = -ctmp_0 *sin_th - ctmp_p *sin2_th_h *zi_phi_m &
               &                  + ctmp_m *cos2_th_h *zi_phi_p

          ztmp3 = -ctmp_0 *sin_th + ctmp_p *cos2_th_h *zi_phi_m &
               &                  - ctmp_m *sin2_th_h *zi_phi_p
          
          Mat_LS_term( m1,m2,1 ) =  ztmp1 /2.0d0         ! (11) component
          Mat_LS_term( m1,m2,4 ) = -ztmp1 /2.0d0         ! (22) 
          Mat_LS_term( m1,m2,2 ) =  ztmp2 /2.0d0         ! (12)
          Mat_LS_term( m1,m2,3 ) =  ztmp3 /2.0d0         ! (21)
       End do
    End Do
  end subroutine m_SO_calc_MatLS_with_Cmplx_ylm

! -------------------------------------
!
!            matrix U ( index1, index2 )  
!                           index1 : px, py, pz ....
!!                          index2 : -1, 0, 1 ....
!
!             px =  1/sqrt(2) [ |1,-1> - |1, 1> ]
!             py = zi/sqrt(2) [ |1,-1> + |1, 1> ]
!             pz =  1,0>
! ---------------------------------------
  subroutine m_SO_set_MatU_ylm_RC
    Real(kind=DP) :: ctmp
    Complex(kind=CMPLDP) :: ztmp
    !
    MatU_ylm_RC_L0 = 0.0d0
    MatU_ylm_RC_L1 = 0.0d0
    MatU_ylm_RC_L2 = 0.0d0
    MatU_ylm_RC_L3 = 0.0d0
    MatU_ylm_RC_L4 = 0.0d0
    ! -------
    ctmp = 1.0d0 / sqrt(2.0d0)

! ------------------------- ktDEBUG ------------ 2012/11/12
    ztmp = -ctmp * zi
!!    ztmp = ctmp * zi
! ------------------------- ktDEBUG ------------ 2012/11/12
    !
! s-orbital
    MatU_ylm_RC_L0(  1,0 ) = 1.0d0
! p-orbital
    MatU_ylm_RC_L1(  1,-1 ) =  ctmp;    MatU_ylm_RC_L1( 1,1 ) = -ctmp
    MatU_ylm_RC_L1(  2,-1 ) =  ztmp;    MatU_ylm_RC_L1( 2,1 ) =  ztmp
    MatU_ylm_RC_L1(  3, 0 ) = 1.0d0
! d-orbital
    MatU_ylm_RC_L2(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L2(  2,-2 ) =  ctmp;    MatU_ylm_RC_L2( 2,2 ) =  ctmp
    MatU_ylm_RC_L2(  3,-2 ) =  ztmp;    MatU_ylm_RC_L2( 3,2 ) = -ztmp
    MatU_ylm_RC_L2(  4,-1 ) =  ztmp;    MatU_ylm_RC_L2( 4,1 ) =  ztmp
    MatU_ylm_RC_L2(  5,-1 ) =  ctmp;    MatU_ylm_RC_L2( 5,1 ) = -ctmp
! f-orbital
    MatU_ylm_RC_L3(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L3(  2,-1 ) =  ctmp;   MatU_ylm_RC_L3( 2,1 ) = -ctmp
    MatU_ylm_RC_L3(  3,-1 ) =  ztmp;   MatU_ylm_RC_L3( 3,1 ) =  ztmp
    MatU_ylm_RC_L3(  4,-2 ) =  ctmp;   MatU_ylm_RC_L3( 4,2 ) =  ctmp
    MatU_ylm_RC_L3(  5,-2 ) =  ztmp;   MatU_ylm_RC_L3( 5,2 ) = -ztmp
    MatU_ylm_RC_L3(  6,-3 ) =  ctmp;   MatU_ylm_RC_L3( 6,3 ) = -ctmp
    MatU_ylm_RC_L3(  7,-3 ) =  ztmp;   MatU_ylm_RC_L3( 7,3 ) =  ztmp
! g-orbital
    MatU_ylm_RC_L4(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L4(  2,-1 ) =  ctmp;   MatU_ylm_RC_L4( 2,1 ) = -ctmp
    MatU_ylm_RC_L4(  3,-1 ) =  ztmp;   MatU_ylm_RC_L4( 3,1 ) =  ztmp
    MatU_ylm_RC_L4(  4,-2 ) =  ctmp;   MatU_ylm_RC_L4( 4,2 ) =  ctmp
    MatU_ylm_RC_L4(  5,-2 ) =  ztmp;   MatU_ylm_RC_L4( 5,2 ) = -ztmp
    MatU_ylm_RC_L4(  6,-3 ) =  ctmp;   MatU_ylm_RC_L4( 6,3 ) = -ctmp
    MatU_ylm_RC_L4(  7,-3 ) =  ztmp;   MatU_ylm_RC_L4( 7,3 ) =  ztmp
    MatU_ylm_RC_L4(  8,-4 ) =  ctmp;   MatU_ylm_RC_L4( 8,4 ) =  ctmp
    MatU_ylm_RC_L4(  9,-4 ) =  ztmp;   MatU_ylm_RC_L4( 9,4 ) = -ztmp
! L=5
    MatU_ylm_RC_L5(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L5(  2,-1 ) =  ctmp;   MatU_ylm_RC_L5(  2,1 ) = -ctmp
    MatU_ylm_RC_L5(  3,-1 ) =  ztmp;   MatU_ylm_RC_L5(  3,1 ) =  ztmp
    MatU_ylm_RC_L5(  4,-2 ) =  ctmp;   MatU_ylm_RC_L5(  4,2 ) =  ctmp
    MatU_ylm_RC_L5(  5,-2 ) =  ztmp;   MatU_ylm_RC_L5(  5,2 ) = -ztmp
    MatU_ylm_RC_L5(  6,-3 ) =  ctmp;   MatU_ylm_RC_L5(  6,3 ) = -ctmp
    MatU_ylm_RC_L5(  7,-3 ) =  ztmp;   MatU_ylm_RC_L5(  7,3 ) =  ztmp
    MatU_ylm_RC_L5(  8,-4 ) =  ctmp;   MatU_ylm_RC_L5(  8,4 ) =  ctmp
    MatU_ylm_RC_L5(  9,-4 ) =  ztmp;   MatU_ylm_RC_L5(  9,4 ) = -ztmp
    MatU_ylm_RC_L5( 10,-5 ) =  ctmp;   MatU_ylm_RC_L5( 10,5 ) = -ctmp
    MatU_ylm_RC_L5( 11,-5 ) =  ztmp;   MatU_ylm_RC_L5( 11,5 ) =  ztmp
! L=6
    MatU_ylm_RC_L6(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L6(  2,-1 ) =  ctmp;   MatU_ylm_RC_L6(  2,1 ) = -ctmp
    MatU_ylm_RC_L6(  3,-1 ) =  ztmp;   MatU_ylm_RC_L6(  3,1 ) =  ztmp
    MatU_ylm_RC_L6(  4,-2 ) =  ctmp;   MatU_ylm_RC_L6(  4,2 ) =  ctmp
    MatU_ylm_RC_L6(  5,-2 ) =  ztmp;   MatU_ylm_RC_L6(  5,2 ) = -ztmp
    MatU_ylm_RC_L6(  6,-3 ) =  ctmp;   MatU_ylm_RC_L6(  6,3 ) = -ctmp
    MatU_ylm_RC_L6(  7,-3 ) =  ztmp;   MatU_ylm_RC_L6(  7,3 ) =  ztmp
    MatU_ylm_RC_L6(  8,-4 ) =  ctmp;   MatU_ylm_RC_L6(  8,4 ) =  ctmp
    MatU_ylm_RC_L6(  9,-4 ) =  ztmp;   MatU_ylm_RC_L6(  9,4 ) = -ztmp
    MatU_ylm_RC_L6( 10,-5 ) =  ctmp;   MatU_ylm_RC_L6( 10,5 ) = -ctmp
    MatU_ylm_RC_L6( 11,-5 ) =  ztmp;   MatU_ylm_RC_L6( 11,5 ) =  ztmp
    MatU_ylm_RC_L6( 12,-6 ) =  ctmp;   MatU_ylm_RC_L6( 12,6 ) =  ctmp
    MatU_ylm_RC_L6( 13,-6 ) =  ztmp;   MatU_ylm_RC_L6( 13,6 ) = -ztmp
  end subroutine m_SO_set_MatU_ylm_RC

end module m_SpinOrbit_Potential

module m_CLS_dipquad
  use m_Const_Parameters,  only : DP, CMPLDP, zi, ON, BUCS, PAI2, PAI, PAI4, &
       &                          MacroDielectric, PACS, HARTREE
  use m_PseudoPotential,    only : nlmt, nloc, ntau, radr_paw, iltpw, lppw, tppw, &
       &                           nmesh, mmesh, ltp, mtp, taup, phirpw, ilmt, psirpw, &
       &                           nlmt_add, ilmt_add, ltp_add, mtp_add, lpsmax, itau, &
       &                           lmta, lmta_add, nlmta
  use m_Ionic_System,   only :  ityp
  use m_CoreLevel_Spectrum,  only : qnum_l_to_probe, psir_core_ae_wfns, &
       &                            m_CLS_find_orb_index_to_probe, atom_to_probe, &
       &                            num_core_states, fsr_core_states, fsi_core_states, &
       &                            ene_core_states, mimic_soc_split_spectrum, &
       &                            ene_initial_state_splitting, qnum_n_to_probe

  use m_SpinOrbit_Potential,   only : MatU_ylm_RC_L0, MatU_ylm_RC_L1, &
       &                              MatU_ylm_RC_L2, MatU_ylm_RC_L3, &
       &                              MatU_ylm_RC_L4

  use m_Parallelization,    only : mype, np_e, myrank_k, map_k, map_z, &
       &                           ista_e, iend_e, istep_e, npes, mpi_comm_group, &
       &                           myrank_e, map_e

  use m_Control_Parameters, only : sw_use_add_proj, ndim_spinor, nspin, neg, noncol
  use m_Kpoints,            only : kv3_ek, kv3, qwgt_ek, num_star_of_k, star_of_k, &
       &                           iopr_k_fbz_to_ibz, trev_k_fbz_to_ibz, kv3_fbz
  use m_IterationNumbers,           only : nk_in_the_process
  use m_Electronic_Structure,  only : fsr_l, fsi_l, fsr_add_l, fsi_add_l, eko_ek, &
       &                              efermi
  use m_CS_Magnetic,         only : magmom_dir_inversion_opr_flag
  use m_Crystal_Structure,   only : op, tau, univol
  use m_Files,               only : nfepsout, m_Files_open_nfeps, m_Files_close_nfeps, &
       &                            nfout
  use m_ES_nonlocal,    only : m_ES_add_betar_dot_WFs

  implicit none
  include 'mpif.h'

  integer, private :: lmax = 4
  integer, private, parameter :: nsph_max = 25
  integer, private, parameter :: PARABOLIC_B = 1, L_TETRAHEDRON = 2, &
       &                         GAUSSIAN_B = 3, LORENTZIAN_B = 4

  real(kind=DP), parameter :: hartree_in_eV = HARTREE
  real(kind=DP), parameter :: InvHyperFineConst = 137.035999679D0

  complex(kind=CMPLDP) :: rhat_cylm(nsph_max,nsph_max,3)
  real(kind=DP) :: rhat_rylm(nsph_max,nsph_max,3)
  real(kind=DP) :: rhat2_rylm(nsph_max,nsph_max,3,3)

  real(kind=DP), allocatable :: rdipole_val_core(:,:,:)
  real(kind=DP), allocatable :: rquadrupole_val_core(:,:,:,:)

  complex(kind=CMPLDP), allocatable :: trm_dipole(:,:,:,:)
  complex(kind=CMPLDP), allocatable :: trm_quadrupole(:,:,:,:,:)

contains

! fixed_charge version
  subroutine m_CLS_alloc_transmom_ek
    allocate( trm_dipole( np_e, num_core_states, kv3_ek, 3 ) )
    allocate( trm_quadrupole( np_e, num_core_states, kv3_ek, 3, 3 ) )
    trm_dipole = 0.0d0
    trm_quadrupole = 0.0d0
  end subroutine m_CLS_alloc_transmom_ek

  subroutine m_CLS_dealloc_transmom_ek
    deallocate( trm_dipole )
    deallocate( trm_quadrupole )
  end subroutine m_CLS_dealloc_transmom_ek

  subroutine m_CLS_wd_transmom_ek
    integer :: lun

    if ( mype == 0 ) then
       lun = get_unused_unitnumber()
       open( lun, file="trans_bin.data", form="unformatted", status="unknown")
!       open( newunit=lun, file="trans_bin.data", form="unformatted", status="unknown")
    endif
    call write_trm_dipole(lun)
    call write_trm_quadrupole(lun)
    if ( mype == 0 )  close( lun )

  contains

    subroutine write_trm_dipole(lun)
      integer, intent(in) :: lun
      integer :: ik, ib1, ib2, nsize, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3) )
      zwk1 = 0.0d0

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               zwk1(ib1,ib2,ik,1:3) = trm_dipole(map_z(ib1),ib2,ik,1:3)
            End do
         End do
      End Do
      if ( npes > 1 ) then
         allocate( zwk1_mpi(neg,num_core_states,kv3_ek,3) )
         call mpi_allreduce( zwk1, zwk1_mpi, nsize*2, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         zwk1 = zwk1_mpi
         deallocate( zwk1_mpi )
      endif
      if ( mype == 0 ) then
         write(lun) 2
         write(lun) num_core_states, neg, kv3_ek
         write(lun) zwk1
      endif
      deallocate( zwk1 )
    end subroutine write_trm_dipole

    subroutine write_trm_quadrupole(lun)
      integer, intent(in) :: lun

      integer :: ik, ib1, ib2, nsize, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3 *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3,3) )
      zwk1 = 0.0d0

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               zwk1(ib1,ib2,ik,1:3,1:3) = trm_quadrupole(map_z(ib1),ib2,ik,1:3,1:3)
            End do
         End do
      End Do
      if ( npes > 1 ) then
         allocate( zwk1_mpi(neg,num_core_states,kv3_ek,3,3) )
         call mpi_allreduce( zwk1, zwk1_mpi, nsize*2, mpi_double_precision, &
              &              mpi_sum, mpi_comm_group, ierr )
         zwk1 = zwk1_mpi
         deallocate( zwk1_mpi )
      endif
      if ( mype == 0 ) then
         write(lun) 4
         write(lun) num_core_states, neg, kv3_ek
         write(lun) zwk1
      endif
      deallocate( zwk1 )
    end subroutine write_trm_quadrupole

  end subroutine m_CLS_wd_transmom_ek

  subroutine m_CLS_rd_transmom_ek
    integer :: lun

    if ( mype == 0 ) then
       lun = get_unused_unitnumber() 
       open( lun, file="trans_bin.data", form="unformatted", status="old" )
!       open( newunit=lun, file="trans_bin.data", form="unformatted", status="old" )
    endif
    call read_trm_dipole(lun)
    call read_trm_quadrupole(lun)
    if ( mype == 0 )  close( lun )

  contains

    subroutine read_trm_dipole(lun)
      integer, intent(in) :: lun
      integer :: ik, ib1, ib2, nsize, n1, n2, n3, n4, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3) )

      if ( mype == 0 ) then
         read(lun) n1
         read(lun) n2, n3, n4
         if ( n1 /= 2 ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n2 /= num_core_states ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n3 /= neg ) then
            stop "trans bin data (dipole) is different"
         endif
         if ( n4 /= kv3_ek ) then
            stop "trans bin data (dipole) is different"
         endif
         read(lun) zwk1
      endif
      call mpi_bcast( zwk1, nsize*2, mpi_double_precision, 0, mpi_comm_group, ierr )

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               trm_dipole(map_z(ib1),ib2,ik,1:3) = zwk1(ib1,ib2,ik,1:3)
            End do
         End do
      End Do
      deallocate( zwk1 )
    end subroutine read_trm_dipole

    subroutine read_trm_quadrupole(lun)
      integer, intent(in) :: lun

      integer :: ik, ib1, ib2, nsize, n1, n2, n3, n4, ierr
      complex(kind=CMPLDP), allocatable :: zwk1(:,:,:,:,:)
      complex(kind=CMPLDP), allocatable :: zwk1_mpi(:,:,:,:,:)

      nsize = num_core_states *neg *kv3_ek *3 *3
      allocate( zwk1(neg,num_core_states,kv3_ek,3,3) )

      if ( mype == 0 ) then
         read(lun) n1
         read(lun) n2, n3, n4
         if ( n1 /= 4 ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n2 /= num_core_states ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n3 /= neg ) then
            stop "trans bin data (quadrupole) is different"
         endif
         if ( n4 /= kv3_ek ) then
            stop "trans bin data (quadrupole) is different"
         endif
         read(lun) zwk1
      endif
      call mpi_bcast( zwk1, nsize*2, mpi_double_precision, 0, mpi_comm_group, ierr )

      Do ib2=1, num_core_states
         Do ik=1, kv3_ek
            Do ib1=1, neg
               if ( map_e(ib1) /= myrank_e ) cycle
               trm_quadrupole(map_z(ib1),ib2,ik,1:3,1:3) = zwk1(ib1,ib2,ik,1:3,1:3)
            End do
         End do
      End Do
      deallocate( zwk1 )
    end subroutine read_trm_quadrupole

  end subroutine m_CLS_rd_transmom_ek

  subroutine m_CLS_calc_transmom_ek
    integer :: nlmt_core
    integer :: ia, it, ik, ik2, ib1, ib2
    integer :: lmt1, lmt2, lmta2
    complex(kind=CMPLDP) :: z1, wf1, wf2
    complex(kind=CMPLDP), allocatable :: wk_fsri(:)


    nlmt_core = 2*qnum_l_to_probe+1
    allocate( wk_fsri(nlmt_core) ); wk_fsri = 0.0d0
    

    if ( sw_use_add_proj == ON ) call m_ES_add_betar_dot_WFs(nfout)

    Do ia = atom_to_probe, atom_to_probe
       it = ityp(ia)
       
       Do ik=1, kv3
          if ( map_k(ik) /= myrank_k ) cycle
          ik2 = nk_in_the_process +ik -1


          Do ib1=1, num_core_states
             wk_fsri(:) = dcmplx( fsr_core_states( ib1,:,ik ), &
                  &               fsi_core_states( ib1,:,ik ) )
             
             DO ib2=1, np_e
                
                Do lmt2=1, ilmt(it)
                   lmta2 = lmta(lmt2,ia)
                   wf2 = dcmplx( fsr_l( ib2, lmta2, ik ), &
                        &        fsi_l( ib2, lmta2, ik ) )

                   Do lmt1=1, nlmt_core
                      wf1 = wk_fsri(lmt1)
                      z1 =  conjg(wf2) *wf1
                      trm_dipole( ib2, ib1, ik2, 1:3 ) &
                           &  = trm_dipole( ib2, ib1, ik2, 1:3 ) &
                           &    + z1 *rdipole_val_core( lmt2, lmt1, 1:3 )
                      trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                           &  = trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                           &    +z1 *rquadrupole_val_core( lmt2, lmt1, 1:3, 1:3 )
                   End do
                End Do
!
                if ( sw_use_add_proj == ON ) then
                   Do lmt2=1, ilmt_add(it)
                      lmta2 = lmta_add(lmt2,ia)
                      wf2 = dcmplx( fsr_add_l( ib2, lmta2, ik ), &
                           &        fsi_add_l( ib2, lmta2, ik ) )

                      Do lmt1=1, nlmt_core
                         wf1 = wk_fsri(lmt1)
                         z1 = conjg(wf2) *wf1
                         trm_dipole( ib2, ib1, ik2, 1:3 ) &
                              &  = trm_dipole( ib2, ib1, ik2, 1:3 ) &
                              &    + z1 *rdipole_val_core( lmt2+nlmt, lmt1, 1:3 )
                         trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 )&
                              &  = trm_quadrupole( ib2, ib1, ik2, 1:3, 1:3 ) &
                              &    + z1 *rquadrupole_val_core( lmt2+nlmt, lmt1, 1:3, 1:3 )
                      End do
                   End Do
                endif
                   
             End Do
          End DO
       End Do
    End Do
    deallocate( wk_fsri )
  end subroutine m_CLS_calc_transmom_ek

  subroutine m_CLS_calc_spectr_fn_l( nstep, evec, kvec, scissor, way_BZ_int, &
       &                             occup_l_ek, ene, e_step, width, spectrum_type )
    integer, intent(in) :: nstep, way_BZ_int, spectrum_type
    real(kind=DP), intent(in) :: evec(3), kvec(3), scissor, ene(nstep), e_step, width
    real(kind=DP), intent(in) :: occup_l_ek(neg,kv3_ek)

    integer :: i, ik, jk, iopr, trev
    integer :: ib1, ib2, is, ixyz1, ixyz2, ierr
    real(kind=DP) :: evec_rotated(3), kvec_rotated(3), weight
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3)
    real(kind=DP) :: Delta03 = 1.0D-3

    complex(kind=CMPLDP) :: zrho1, zrho2
    real(kind=DP) :: trm2_E1_E1, trm2_E2_E2, trm2_E1_E2
    real(kind=DP), allocatable :: work(:)
    real(kind=DP), allocatable :: spectr_E1_E1(:), spectr_E2_E2(:), spectr_E1_E2(:)

    real*8 :: fac1, fac2, wavenum_xray

    allocate( spectr_E1_E1(nstep) ); spectr_E1_E1 = 0.0d0
    allocate( spectr_E2_E2(nstep) ); spectr_E2_E2 = 0.0d0
    allocate( spectr_E1_E2(nstep) ); spectr_E1_E2 = 0.0d0

    Do ib1=1, num_core_states

       Do ik=1, kv3_ek, ndim_spinor
          weight = kv3_ek *qwgt_ek(ik) /dble(ndim_spinor)

          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             evec_rotated = matmul( op(:,:,iopr), evec(:) )
             kvec_rotated = matmul( op(:,:,iopr), kvec(:) )
             if ( trev == 1 ) then
                evec_rotated = -evec_rotated
                kvec_rotated = -kvec_rotated
             endif

             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2

             Do ib2=ista_e, iend_e, istep_e
                occ2 = occup_l_ek(map_z(ib2),ik) /weight
                if ( 1.0D0 -occ2 < Delta03 ) cycle

!             if ( eko_ek(ib2,ik) < efermi ) cycle

                odiff = 1.0d0 -occ2

                ediff = eko_ek(ib2,ik) +scissor -ene_core_states(ib1)
                wavenum_xray = ediff /InvHyperFineConst
                fac1 = wavenum_xray /2.0d0
                fac2 = fac1 *fac1

                zrho1 = 0.0d0;      zrho2 = 0.0d0
                Do is=1, ndim_spinor
                   Do ixyz1=1, 3
                      zrho1 = zrho1 &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *evec_rotated(ixyz1)
                   End Do
                   Do ixyz1=1, 3
                      Do ixyz2=1, 3
                         zrho2 = zrho2 &
                              & + trm_quadrupole( map_z(ib2), ib1, ik+is-1,ixyz1,ixyz2 ) &
                              &   *evec_rotated(ixyz1) *kvec_rotated(ixyz2)
                      End Do
                   ENd Do
                End do

                zrho2 = zrho2 *zi

                trm2_E1_E1 = conjg( zrho1 ) *zrho1
                trm2_E2_E2 = conjg( zrho2 ) *zrho2 *fac2
                trm2_E1_E2 = ( conjg( zrho1  ) *zrho2 &
                     &         +conjg( zrho2  ) *zrho1 ) *fac1


                call add_spectral_function( ediff, odiff, trm2_E1_E1, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1 )
                call add_spectral_function( ediff, odiff, trm2_E2_E2, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2 )
                call add_spectral_function( ediff, odiff, trm2_E1_E2, &
                     &                      way_BZ_int, ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2 )
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nstep ) ); work = 0.0d0
       call mpi_allreduce( Spectr_E1_E1, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E1 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E2_E2, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E2_E2 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E1_E2, work, nstep, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E2 = work
       deallocate( work )
    endif

    fac1 = PAI4 *PAI              ! latter : i pi delta

    Spectr_E1_E1 = Spectr_E1_E1 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E2_E2 = Spectr_E2_E2 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E1_E2 = Spectr_E1_E2 /dble(kv3_fbz/nspin) /univol *fac1
    if ( nspin == 1 ) then
       Spectr_E1_E1 = Spectr_E1_E1 *2.0d0
       Spectr_E2_E2 = Spectr_E2_E2 *2.0d0
       Spectr_E1_E2 = Spectr_E1_E2 *2.0d0
    endif

    if ( qnum_l_to_probe > 0 .and. mimic_soc_split_spectrum ) then
       if ( ene_initial_state_splitting /= 0.0d0 ) then
          allocate( work(nstep ) );
          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1, work )
          Spectr_E1_E1 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2, work )
          Spectr_E2_E2 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2, work )
          Spectr_E1_E2 = work
       endif
    end if

    if ( mype == 0 ) then
       call m_Files_open_nfeps( "E1_E1" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E1, "dipole-dipole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E2_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E2_E2, &
            &           "quadrupole-quadrupole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E1_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E2, &
            &           "dipole-quadrupole" )
       call m_Files_close_nfeps
    endif

    deallocate( Spectr_E1_E1 ); deallocate( Spectr_E2_E2 ); deallocate( Spectr_E1_E2 )

  contains

    subroutine write_data( lun, nstep, e, spectr_in, word )
      integer, intent(in) :: lun, nstep
      real(kind=DP), intent(in) :: e(nstep)
      real(kind=DP), intent(in) :: spectr_in(nstep)
      character*(*), intent(in) :: word

      integer :: istep
      real(kind=DP) :: ene

      write(lun,'(A,A,A)') "# Core level spectrum ( ", trim(word), " )"
      write(lun,'(A,I4,A,I2,A,I2)') "#  atom:", atom_to_probe, &
           &                  ", orbital: n = ", qnum_n_to_probe, &
           &                           ", l =", qnum_l_to_probe
      write(lun,'(A)') "#"
      write(lun,'(A,3F10.5)') "# Polarization: ", evec(1:3)
      write(lun,'(A,3F10.5)') "# Wave vector : ", kvec(1:3)
      write(lun,'(A)') "#"
      write(lun,'(A)') "#    Energy [eV]      spectrum "
      write(lun,'(A)') "#"

      select case (spectrum_type)
      case (MacroDielectric)         ! epsilon
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep)
         End Do
      case (PACS)         ! cross section
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep) &
                 &                             *ene /InvHyperFineConst *univol
         End Do
      end select
    end subroutine write_data

  end subroutine m_CLS_calc_spectr_fn_l

  subroutine m_CLS_calc_spectr_fn_c( nstep, evec, evec2, kvec, scissor, way_BZ_int, &
       &                             occup_l_ek, ene, e_step, width, spectrum_type )
    integer, intent(in) :: nstep, way_BZ_int, spectrum_type
    real(kind=DP), intent(in) :: evec(3), kvec(3), scissor, ene(nstep), e_step, width
    real(kind=DP), intent(in) :: occup_l_ek(neg,kv3_ek)
    real(kind=DP), intent(in) :: evec2(3)

    integer :: i, ik, jk, iopr, trev
    integer :: ib1, ib2, is, ixyz1, ixyz2, ierr
    real(kind=DP) :: evec_rotated(3), kvec_rotated(3), weight
    real(kind=DP) :: evec2_rotated(3)
    real(kind=DP) :: ediff, odiff, occ1, occ2, txyz(3)
    real(kind=DP) :: Delta03 = 1.0D-3

    complex(kind=CMPLDP) :: zrho1p, zrho2p
    complex(kind=CMPLDP) :: zrho1m, zrho2m
    real(kind=DP) :: trm2p_E1_E1, trm2p_E2_E2, trm2p_E1_E2
    real(kind=DP) :: trm2m_E1_E1, trm2m_E2_E2, trm2m_E1_E2

    real(kind=DP), allocatable :: work(:,:)
    real(kind=DP), allocatable :: spectr_E1_E1(:,:), spectr_E2_E2(:,:), spectr_E1_E2(:,:)

    real*8 :: fac1, fac2, wavenum_xray

    allocate( spectr_E1_E1(nstep,2) ); spectr_E1_E1 = 0.0d0
    allocate( spectr_E2_E2(nstep,2) ); spectr_E2_E2 = 0.0d0
    allocate( spectr_E1_E2(nstep,2) ); spectr_E1_E2 = 0.0d0

    Do ib1=1, num_core_states
       Do ik=1, kv3_ek, ndim_spinor
          weight = kv3_ek *qwgt_ek(ik) /dble(ndim_spinor)
          
          Do i=1, num_star_of_k(ik)
             jk = star_of_k(ik,i)
             iopr = iopr_k_fbz_to_ibz(jk)
             trev = trev_k_fbz_to_ibz(jk)
             
             kvec_rotated = matmul( op(:,:,iopr), kvec(:) )
             evec_rotated = matmul( op(:,:,iopr), evec(:) )
             evec2_rotated = matmul( op(:,:,iopr), evec2(:) )
             if ( noncol .and. magmom_dir_inversion_opr_flag(iopr) == -1 ) then
                evec2_rotated = -evec2_rotated
             endif
             
             if ( trev == 1 ) then
                kvec_rotated = -kvec_rotated
                evec_rotated = -evec_rotated
                evec2_rotated = -evec2_rotated
             endif
             
             txyz(1:3) = tau(1:3,iopr,BUCS)*PAI2
             
             Do ib2=ista_e, iend_e, istep_e
                occ2 = occup_l_ek(map_z(ib2),ik) /weight
                if ( 1.0D0 -occ2 < Delta03 ) cycle
!             if ( eko_ek(ib2,ik) < efermi ) cycle

                odiff = 1.0d0 -occ2

                ediff = eko_ek(ib2,ik) +scissor -ene_core_states(ib1)
                wavenum_xray = ediff /InvHyperFineConst
                fac1 = wavenum_xray /2.0d0
                fac2 = fac1 *fac1

                zrho1p = 0.0d0;      zrho2p = 0.0d0
                zrho1m = 0.0d0;      zrho2m = 0.0d0
                Do is=1, ndim_spinor
                   Do ixyz1=1, 3
                      zrho1p  = zrho1p &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *( evec_rotated(ixyz1) +zi*evec2_rotated(ixyz1) )
                      zrho1m = zrho1m &
                           & + trm_dipole( map_z(ib2), ib1, ik+is-1, ixyz1 ) &
                           &   *( evec_rotated(ixyz1) -zi*evec2_rotated(ixyz1) )
                   End Do
                   Do ixyz1=1, 3
                      Do ixyz2=1, 3
                         zrho2p = zrho2p &
                              & + trm_quadrupole( map_z(ib2),ib1,ik+is-1,ixyz1,ixyz2 ) &
                              &   *(evec_rotated(ixyz1) +zi*evec2_rotated(ixyz1) ) &
                              &   *kvec_rotated(ixyz2)
                         zrho2m = zrho2m &
                              & + trm_quadrupole( map_z(ib2),ib1,ik+is-1,ixyz1,ixyz2 ) &
                              &   *(evec_rotated(ixyz1) -zi*evec2_rotated(ixyz1) ) &
                              &   *kvec_rotated(ixyz2)
                      End Do
                   ENd Do
                End do

                zrho2p = zrho2p *zi
                zrho2m = zrho2m *zi

                trm2p_E1_E1 = conjg( zrho1p ) *zrho1p/2.0d0
                trm2p_E2_E2 = conjg( zrho2p ) *zrho2p *fac2 /2.0d0
                trm2p_E1_E2 = ( conjg( zrho2p ) *zrho1p  &
                     &         +conjg( zrho1p ) *zrho2p ) *fac1 /2.0d0

                trm2m_E1_E1 = conjg( zrho1m ) *zrho1m /2.0d0
                trm2m_E2_E2 = conjg( zrho2m ) *zrho2m *fac2 /2.0d0
                trm2m_E1_E2 = ( conjg( zrho1m  ) *zrho2m &
                     &         +conjg( zrho2m  ) *zrho1m ) *fac1 /2.0d0

                call add_spectral_function( ediff, odiff, trm2m_E1_E1, way_BZ_int, &
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E1_E1, way_BZ_int, &
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E1(:,2) )

                call add_spectral_function( ediff, odiff, trm2m_E2_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E2_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E2_E2(:,2) )

                call add_spectral_function( ediff, odiff, trm2m_E1_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2(:,1) )
                call add_spectral_function( ediff, odiff, trm2p_E1_E2, way_BZ_int,&
                     &                      ene, e_step, width, &
                     &                      nstep, Spectr_E1_E2(:,2) )
             End do
          End Do
       End do
    End Do

    if ( npes > 1 ) then
       allocate( work(nstep,2) ); work = 0.0d0
       call mpi_allreduce( Spectr_E1_E1, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E1 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E2_E2, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E2_E2 = work

       work = 0.0d0
       call mpi_allreduce( Spectr_E1_E2, work, nstep*2, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       Spectr_E1_E2 = work
       deallocate( work )
    endif

    fac1 = PAI4 *PAI              ! latter : i pi delta

    Spectr_E1_E1 = Spectr_E1_E1 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E2_E2 = Spectr_E2_E2 /dble(kv3_fbz/nspin) /univol *fac1
    Spectr_E1_E2 = Spectr_E1_E2 /dble(kv3_fbz/nspin) /univol *fac1
    if ( nspin == 1 ) then
       Spectr_E1_E1 = Spectr_E1_E1 *2.0d0
       Spectr_E2_E2 = Spectr_E2_E2 *2.0d0
       Spectr_E1_E2 = Spectr_E1_E2 *2.0d0
    endif

    if ( qnum_l_to_probe > 0 .and. mimic_soc_split_spectrum ) then
       if ( ene_initial_state_splitting /= 0.0d0 ) then
          allocate( work(nstep,2) );
          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E1(:,2),work(:,2))
          Spectr_E1_E1 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E2_E2(:,2),work(:,2))
          Spectr_E2_E2 = work

          work = 0.0d0
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2(:,1),work(:,1))
          call split_spectr_by_spinorb_real( nstep, e_step, Spectr_E1_E2(:,2),work(:,2))
          Spectr_E1_E2 = work
       endif
    end if

    if ( mype == 0 ) then
       call m_Files_open_nfeps( "E1_E1" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E1, "dipole-dipole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E2_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E2_E2, &
            &           "quadrupole-quadrupole" )
       call m_Files_close_nfeps

       call m_Files_open_nfeps( "E1_E2" )
       call write_data( nfepsout, nstep, ene, Spectr_E1_E2, &
            &           "dipole-quadrupole" )
       call m_Files_close_nfeps
    endif

    deallocate( Spectr_E1_E1 ); deallocate( Spectr_E2_E2 ); deallocate( Spectr_E1_E2 )

  contains

    subroutine write_data( lun, nstep, e, spectr_in, word )
      integer, intent(in) :: lun, nstep
      real(kind=DP), intent(in) :: e(nstep)
      real(kind=DP), intent(in) :: spectr_in(nstep,2)
      character*(*), intent(in) :: word

      integer :: istep
      real(kind=DP) :: ene, c1

      write(lun,'(A,A,A)') "# Core level spectrum ( ", trim(word), " )"
      write(lun,'(A,I4,A,I2,A,I2)') "#  atom:", atom_to_probe, &
           &                  ", orbital: n = ", qnum_n_to_probe, &
           &                           ", l =", qnum_l_to_probe
      write(lun,'(A)') "#"
      write(lun,'(A,3F10.5)') "# Wave vector : ", kvec(1:3)
      write(lun,'(A)') "#"
      write(lun,'(A)') "#    Energy [eV]      spectrum (left,-)     (right,+)      (CD)"
      write(lun,'(A)') "#"

      select case (spectrum_type)
      case (MacroDielectric)         ! epsilon
         Do istep=1, nstep
            ene = e(istep)
            write(lun,'(E18.10,3E18.10E2)') ene*Hartree_in_eV, &
                 &                         spectr_in(istep,1:2), &
                 &                         spectr_in(istep,2) -spectr_in(istep,1)
         End Do
      case (PACS)         ! cross section
         Do istep=1, nstep
            ene = e(istep)
            c1 = ene /InvHyperFineConst *univol
            write(lun,'(E18.10,3E18.10E2)') ene*Hartree_in_eV, &
                 &                          c1 *spectr_in(istep,1:2), &
                 &                          c1 *(spectr_in(istep,2)-spectr_in(istep,1))
         End Do
      end select
    end subroutine write_data

  end subroutine m_CLS_calc_spectr_fn_c

  subroutine split_spectr_by_spinorb_real( nstep, e_step, spectr_in, spectr_out )
    integer, intent(in) :: nstep
    real(kind=DP), intent(in) :: e_step
    real(kind=DP), intent(in) :: spectr_in(nstep)
    real(kind=DP), intent(out) :: spectr_out(nstep)

    integer :: ngeta, istep, jstep
    real(kind=DP) :: c1, c2

    ngeta = nint( ene_initial_state_splitting /e_step )
    c1 = qnum_l_to_probe /( 2.0d0*qnum_l_to_probe +1.0d0 )
    c2 = 1.0d0 -c1

    spectr_out(:) = 0.0d0
    Do istep=1, nstep
       spectr_out(istep) = spectr_out(istep) + c2 *spectr_in(istep)
       jstep = istep +ngeta
       if ( jstep <=nstep ) then
          spectr_out(jstep) = spectr_out(jstep) + c1 *spectr_in(istep)
       endif
    End Do
  end subroutine split_spectr_by_spinorb_real

  subroutine add_spectral_function( e_center, weight, trm2, way_BZ_int, &
       &                            e, e_step, width, nstep, SpectrFn )
    integer, intent(in) :: nstep, way_BZ_int
    real(kind=DP), intent(in) :: e_center, weight, e_step, width
    real(kind=DP), intent(in) :: e(nstep)
    real(kind=DP), intent(in) :: trm2
    real(kind=DP), intent(inout) :: SpectrFn( nstep )

    real(kind=DP) :: e_low
    real(kind=DP) :: gaussian_extent = 4.0d0

    e_low = e(1)
    select case (way_BZ_int)
    case (PARABOLIC_B)
       call Parabolic_broadening      
!       stop "Does not work"
    case (L_TETRAHEDRON)
       stop "Does not work"
    case (GAUSSIAN_B)
       call Gaussian_broadening
    case (LORENTZIAN_B)
       call Lorentzian_broadening
    end select

  contains

    subroutine Parabolic_broadening      
      integer :: i
      real(kind=DP) :: c2, ctmp

      Do i=1, nstep
         call width2( e(i), e_center, width, c2, ctmp )
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c2
      End do
      
    end subroutine Parabolic_broadening

    subroutine Gaussian_broadening           ! width == sqrt(2)*sigma,
      integer :: istart, iend, i
      real(kind=DP) :: sigma, sig2, c1, c2, c3, e_min, e_max, e0

      sigma = width /sqrt(2.0d0)
      e0 = e_center -e_low
      e_min = e0 -sigma *gaussian_extent;
      e_max = e0 +sigma *gaussian_extent
      istart = nint( e_min /e_step ) +1;  iend = nint( e_max /e_step ) +1

      istart = max( 1, istart );      istart = min( nstep, istart )
      iend   = min( nstep, iend );    iend   = max( 1, iend )

      sig2 = sigma**2;   c1 = sqrt( PAI2 *sig2 )
      Do i=istart, iend
         c2 = ( e(i) -e_center )**2 /sig2 /2.0d0
         c3 = exp( -c2 ) /c1
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c3
      End do
      
    end subroutine Gaussian_broadening

    subroutine Lorentzian_broadening
      integer :: i
      real(kind=DP) :: e0, c1, c2, c3, eta
      
      eta = width /2.0d0
      !
      c3 = eta /PAI
!      e0 = e_center -e_low
      e0 = e_center

      Do i=1, nstep
         c1 = ( e(i) -e0 )**2 + eta**2
         c2 = c3 /c1
         SpectrFn(i) = SpectrFn(i) +weight *trm2 *c2
      End do
    end subroutine Lorentzian_broadening
    
  end subroutine add_spectral_function

  subroutine m_CLS_alloc_dipquad
    integer :: nlmt_val
    
    if ( sw_use_add_proj == ON ) then
       nlmt_val = nlmt +nlmt_add
    else
       nlmt_val = nlmt
    endif

    allocate( rdipole_val_core( nlmt_val, 2*qnum_l_to_probe+1, 3 ) )
    allocate( rquadrupole_val_core( nlmt_val, 2*qnum_l_to_probe+1,3,3) )
    rdipole_val_core = 0.0d0;   rquadrupole_val_core = 0.0d0;  

  end subroutine m_CLS_alloc_dipquad

  subroutine m_CLS_dealloc_dipquad
    deallocate( rdipole_val_core )
    deallocate( rquadrupole_val_core )
  end subroutine m_CLS_dealloc_dipquad

  subroutine m_CLS_set_dipquad_elements
    integer :: orb_index, it, ilt1, il1, tau1, ir, ierr
    integer :: ilmt2, il2, im2, tau2, nsph_core, nsph_val, im1
    real(kind=DP) :: c1, c2, ctmp
    real(kind=DP), allocatable :: RadIntegral_order(:,:,:), wos(:)
!
    call set_rhat_cylm
    call set_rhat_rylm
    call set_rhat2_rylm
!
    orb_index = m_CLS_find_orb_index_to_probe()
    it = ityp( atom_to_probe )
    allocate( RadIntegral_order(2,nloc,ntau) )
    allocate( wos(mmesh) )
    call set_weight_exp( ierr, 1, nmesh(it), radr_paw(:,it), wos )

    Do il1=1, lpsmax(it)
       Do tau1=1, itau(il1,it)
          c1 = 0.0d0;  c2 = 0.0d0
          Do ir=1, nmesh(it)
             ctmp = psir_core_ae_wfns(ir,orb_index) *psirpw(ir,il1,tau1,it)
             c1 = c1 +wos(ir) *ctmp *radr_paw(ir,it)
             c2 = c2 +wos(ir) *ctmp *radr_paw(ir,it)**2
          End do
          RadIntegral_order(1,il1,tau1) = c1
          RadIntegral_order(2,il1,tau1) = c2
       End Do
    End Do
          
    Do im1=1, 2*qnum_l_to_probe +1
       nsph_core = qnum_l_to_probe**2 +im1
       Do ilmt2=1, ilmt(it)        ! valence
          il2=ltp(ilmt2,it);  im2=mtp(ilmt2,it);   tau2=taup(ilmt2,it)
          nsph_val = (il2 -1)**2 +im2
          rdipole_val_core(ilmt2,im1,1:3) = RadIntegral_order(1,il2,tau2) &
               &               *rhat_rylm(nsph_val,nsph_core,1:3)
          rquadrupole_val_core(ilmt2,im1,1:3,1:3) = RadIntegral_order(2,il2,tau2) &
               &               *rhat2_rylm(nsph_val,nsph_core,1:3,1:3)
       End do
       if ( sw_use_add_proj == ON ) then
          Do ilmt2=1, ilmt_add(it)  
             il2=ltp_add(ilmt2,it);  im2=mtp_add(ilmt2,it);   tau2=1
             nsph_val = (il2 -1)**2 +im2
             rdipole_val_core(nlmt+ilmt2,im1,1:3) &
                  &              = RadIntegral_order(1,il2,tau2) &
                  &                 *rhat_rylm(nsph_val,nsph_core,1:3)
             rquadrupole_val_core(nlmt+ilmt2,im1,1:3,1:3) &
                  &              = RadIntegral_order(2,il2,tau2) &
                  &                 *rhat2_rylm(nsph_val,nsph_core,1:3,1:3)
          End do
       endif
    End Do

    deallocate( RadIntegral_order )
    deallocate( wos )
  end subroutine m_CLS_set_dipquad_elements

  subroutine set_rhat2_rylm
    integer :: ixyz1, ixyz2, i, j, k
    real(kind=DP) :: csum

    Do ixyz2=1, 3
       Do ixyz1=1, 3
          Do i=1, nsph_max
             Do j=1, nsph_max
                csum = 0.0d0
                Do k=1, nsph_max
                   csum = csum +rhat_rylm(i,k,ixyz1)*rhat_rylm(k,j,ixyz2)
                End Do
                rhat2_rylm(i,j,ixyz1,ixyz2) = csum
             End Do
          End Do
       ENd Do
    End Do
  end subroutine set_rhat2_rylm

  subroutine set_rhat_cylm         ! rhat = x^, y^, z^ ( x^=x/r )
    integer :: il, im, nsph1, nsph2, nsph3, ind1, ind2
    real(kind=DP) :: c1, c2, a1, a2, a3, a4, a5, a6
    integer :: get_nspher_cylm

    rhat_cylm = 0.0d0

    Do il=0, lmax
       c1 = (2*il+1)*(2*il+3)
       c2 = 0.0d0
       if ( il > 0 ) c2 = (2*il-1)*(2*il+1)

       Do im=-il, il
          nsph1 = get_nspher_cylm( il, im )

          if ( abs(im+1) <= il+1 ) then
             a1 =  -sqrt( (il+im+1)*(il+im+2)/c1 )
             nsph2 = get_nspher_cylm( il+1, im+1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a1 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = -a1 /2.0d0 *zi
             endif
          endif

          if ( abs(im+1) <= il-1 ) then
             a2 = sqrt( (il-im-1)*(il-im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im+1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a2 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = -a2 /2.0d0 *zi
             endif
          endif

          if ( abs(im-1) <= il+1 ) then
             a3 =  sqrt( (il-im+1)*(il-im+2)/c1 )
             nsph2 = get_nspher_cylm( il+1, im-1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a3 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = a3 /2.0d0 *zi
             endif
          endif

          if ( abs(im-1) <= il-1 ) then
             a4 =  -sqrt( (il+im-1)*(il+im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im-1 )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,1) = a4 /2.0d0
                rhat_cylm(nsph2,nsph1,2) = a4 /2.0d0 *zi
             endif
          endif

          if ( abs(im) <= il+1 ) then
             a5 =  sqrt( (il-im+1)*(il+im+1)/c1 )
             nsph2 = get_nspher_cylm( il+1, im )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,3) = a5
             endif
          endif

          if ( abs(im) <= il-1 ) then
             a6 =  sqrt( (il-im)*(il+im)/c2 )
             nsph2 = get_nspher_cylm( il-1, im )
             if ( nsph2 <= nsph_max ) then
                rhat_cylm(nsph2,nsph1,3) = a6
             endif
          endif

       End Do
    End Do
  end subroutine set_rhat_cylm

  subroutine set_rhat_rylm
    integer :: il1, il2, im1, im2, im3, im4, ind1, ind2
    integer :: nsph3, nsph4
    integer :: get_nspher_cylm
!    external :: get_nspher_cylm

    complex(kind=CMPLDP) :: zsum(3), ztmp1, ztmp2

    Do il1=0, lmax
       Do im1=1, 2*il1 +1
          ind1 = il1**2 +im1
          
          Do il2=0, lmax
             Do im2=1, 2*il2 +1
                ind2 = il2**2 +im2
                zsum = 0.0d0
                
                Do im3=-il1, il1
                   if ( il1 == 0 ) then
                      ztmp1 = MatU_ylm_RC_L0(im1,im3)
                   else if ( il1 == 1  ) then
                      ztmp1 = MatU_ylm_RC_L1(im1,im3)
                   else if ( il1 == 2  ) then
                      ztmp1 = MatU_ylm_RC_L2(im1,im3)
                   else if ( il1 == 3  ) then
                      ztmp1 = MatU_ylm_RC_L3(im1,im3)
                   else if ( il1 == 4  ) then
                      ztmp1 = MatU_ylm_RC_L4(im1,im3)
                   endif
                   
                   Do im4=-il2, il2
                      if ( il2 == 0 ) then
                         ztmp2 = MatU_ylm_RC_L0(im2,im4)
                      else if ( il2 == 1  ) then
                         ztmp2 = MatU_ylm_RC_L1(im2,im4)
                      else if ( il2 == 2  ) then
                         ztmp2 = MatU_ylm_RC_L2(im2,im4)
                      else if ( il2 == 3  ) then
                         ztmp2 = MatU_ylm_RC_L3(im2,im4)
                      else if ( il2 == 4  ) then
                         ztmp2 = MatU_ylm_RC_L4(im2,im4)
                      endif

                      nsph3 = get_nspher_cylm( il1, im3 )
                      nsph4 = get_nspher_cylm( il2, im4 )

                      zsum(1) = zsum(1) +ztmp1 *rhat_cylm(nsph3,nsph4,1) *conjg(ztmp2)
                      zsum(2) = zsum(2) +ztmp1 *rhat_cylm(nsph3,nsph4,2) *conjg(ztmp2)
                      zsum(3) = zsum(3) +ztmp1 *rhat_cylm(nsph3,nsph4,3) *conjg(ztmp2)
                   End Do
                ENd Do
                rhat_rylm(ind1,ind2,1:3) = zsum(1:3)
             End Do
          End Do
       End Do
    End Do
  end subroutine set_rhat_rylm

  integer function get_unused_unitnumber()
    integer :: i
    logical :: op
    do i=500,9999
      inquire(unit=i,opened=op)
      if( .not.op ) then
        get_unused_unitnumber = i
        return
      endif
    enddo
    stop '  insufficient file handle'
  end function get_unused_unitnumber

end module m_CLS_dipquad

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 621 $)
!
!  MODULE: m_UnitCell
!
!  AUTHOR(S): J. KOGA @ asms   
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
! 
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.  
! Functions:  [Identifier: 13.0B]  
!                 cell optimizations with angles fixed is available
!                 ( external_stress is included in the stress term )
!
! =============================================================

module m_UnitCell
! $Id: m_UnitCell.f90 621 2020-05-20 06:51:42Z jkoga $

use m_Const_Parameters, only : DP,QUENCHED_MD,STEEPEST_DESCENT,BFGS,OFF,PAI,CONST_kB, &
                             & PT_CONTROL,P_CONTROL,VELOCITY_SCALING
use m_Stress, only : m_Stress_get_stressmx,m_Stress_get_curr_stress,m_Stress_set_stressmx
use m_IterationNumbers, only : iteration_unit_cell,iteration_ionic
use m_Control_Parameters, only : nhistory_stress,printable,delta_stress,lattice_optimization_method &
                                ,max_stress,ipri,eigenvalue_threshold,sw_uniform,ipriunitcell,external_stress &
                                ,dtio,imdalg, max_mdstep
use m_Files, only : nfout,nfdynm, nflatconst, nfmetric, m_Files_flush_pcontrol_files
use m_Ionic_System, only : altv,pos,natm,cps,m_baro,target_pressure,cpd_l,qmass,tkb,ityp,amion &
                         & ,t_ctrl_method,scale_velocity, mobility_cell, control_pressure &
                         & ,sw_shift_velocities, shift_velocities, sw_average_diagonal
use m_Crystal_Structure, only : m_CS_altv_2_rltv,p2bmat,a,b,c,ca,cb,cc,il,kt_iuctype,rltv,univol,rvol, b2pmat
use m_Parallelization, only : mype,npes,mpi_comm_group

! ====================================== KT_add ============= 13.0B &13.1AS
use m_Control_Parameters,  only : sw_fix_lattice_angles, fix_angle_alpha, &
     &                            fix_angle_beta, fix_angle_gamma, &
     &                            sw_fix_lattice_lengths, fix_length_a, &
     &                            fix_length_b, fix_length_c, &
     &                            sw_neglect_stress_offdiagonal
  use m_Const_Parameters,   only : ON
! =========================================================== 13.0B &13.1AS

use m_Total_Energy, only : etotal

implicit none
include 'mpif.h'

real(kind=DP), private, dimension(3,3) :: stress_forc
real(kind=DP), private, dimension(3,3) :: stress_forc_old
real(kind=DP), private, dimension(3,3) :: stress_velocity
real(kind=DP), private, allocatable, dimension(:,:,:) :: cellvec_history
real(kind=DP), private, allocatable, dimension(:,:,:) :: stress_forc_history
real(kind=DP), private, allocatable, dimension(:) :: volume_history
real(kind=DP), private, allocatable, dimension(:) :: volume_forc_history
logical,private :: first_call = .true.
logical,private :: H0_has_been_set = .false.
character(len('unit_cell_optimization')),private,parameter :: tag_unit_cell_optimization='unit_cell_optimization'
character(len("lattice_vector")),private,parameter :: tag_lattice_vector = "lattice_vector"
character(len("pressure_control")), private, parameter :: tag_pressure_control='pressure_control'
real(kind=DP) :: maxoptforc_old=1000.d0
real(kind=DP) :: univolo

! for NPT and NPH simulation based on the metric tensor
real(kind=DP), allocatable, dimension(:,:) :: p_l
real(kind=DP), allocatable, dimension(:,:) :: p_l_lattice
real(kind=DP) :: target_temperature
real(kind=DP) :: s_thermo,p_thermo,m_thermo
real(kind=DP), dimension(3,3) :: altv_inv,metric,metric_inv,dudmetric
real(kind=DP), dimension(3,3) :: p_baro, p_baro_tmp
real(kind=DP), dimension(3,3) :: factor
real(kind=DP) :: gfree
real(kind=DP), allocatable, dimension(:,:) :: forc_l_lattice
real(kind=DP), allocatable, dimension(:,:) :: p_l_metric

integer :: nmax = 1000
real(kind=DP) :: eps = 1.d-8
real(kind=DP) :: H0

contains

function get_volume(avec,bvec,cvec) result(vol)
  real(kind=DP), dimension(3), intent(in) :: avec,bvec,cvec
  real(kind=DP), dimension(3) :: tmpvec
  real(kind=DP) :: vol
  tmpvec(1) = bvec(2)*cvec(3)-bvec(3)*cvec(2)
  tmpvec(2) = bvec(3)*cvec(1)-bvec(1)*cvec(3)
  tmpvec(3) = bvec(1)*cvec(2)-bvec(2)*cvec(1)
  vol = dot_product(avec,tmpvec)
end function get_volume

logical function m_UC_converged()
  integer :: i,j
  real(kind=DP) :: maxs,astress
  real(kind=DP), dimension(3,3) :: stress_tensor, stress_work
  real(kind=DP), dimension(3,3) :: altv_brav

  if(imdalg == PT_CONTROL .or. imdalg == P_CONTROL)then
    !m_UC_converged = .false.
    m_UC_converged = iteration_unit_cell.ge.max_mdstep
    return;
  endif
  stress_tensor = m_Stress_get_curr_stress()
  maxs = 0.d0

  if(sw_uniform==OFF)then
    do i=1,3
      do j=1,3
! ============ KT mod ============================= 13.0B
!         astress = abs(stress_tensor(i,j)-external_stress(i,j))
         astress = abs(stress_tensor(i,j))
! ================================================= 13.0B
         if(astress>maxs) maxs = astress
      enddo
    enddo
  else
! ============ KT mod ============================= 13.0B
!       maxs = maxs+abs(stress_tensor(i,i)-external_stress(i,i))
!       maxs = maxs+abs(stress_tensor(i,i))
    maxs = abs(stress_tensor(1,1)+stress_tensor(2,2)+stress_tensor(3,3))/3.0d0
! ================================================= 13.0B
  endif

! === KT_add === 13.1AS
  if ( sw_neglect_stress_offdiagonal == ON ) then
     stress_work = 0.0d0;
     stress_work(1,1) = stress_tensor(1,1)
     stress_work(2,2) = stress_tensor(2,2)
     stress_work(3,3) = stress_tensor(3,3)

     maxs = 0.0d0
     do i=1,3
        astress = sqrt( stress_work(i,1)**2 +stress_work(i,2)**2 +stress_work(i,3)**2 )
        if(astress>maxs) maxs = astress
     enddo
  endif

  if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
     call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )

     stress_work = projected_stress_along_latvecs( altv_brav, stress_tensor )
     maxs = 0.0d0

     if ( sw_fix_lattice_angles == ON ) then
        stress_work = constrain_on_force_type1( altv_brav, stress_work )
     endif
     if ( sw_fix_lattice_lengths==ON ) then
        stress_work = constrain_on_force_type2( altv_brav, stress_work )
     endif
     
     do i=1,3
        astress = sqrt( stress_work(i,1)**2 +stress_work(i,2)**2 +stress_work(i,3)**2 )
        if(astress>maxs) maxs = astress
     enddo
  endif
! ========= 13.1AS

  m_UC_converged = max_stress>maxs
  if(printable) then
    write(nfout,'(a)')         '!**'
    write(nfout,'(a)')         '!** checking convergence of the stress tensor ...'
    write(nfout,'(a,2f20.10)') '!** max(stress-external_stress), tolerance : ',maxs,max_stress
    write(nfout,'(a,l2)')      '!** convergence : ',m_UC_converged
    write(nfout,'(a)')         '!**'
  endif
end function m_UC_converged

subroutine m_UC_init()
   stress_forc = 0.0d0
   stress_forc_old = 0.0d0
   stress_velocity = 0.0d0
   allocate(cellvec_history(3,3,nhistory_stress));cellvec_history=0.d0
   allocate(stress_forc_history(3,3,nhistory_stress));stress_forc_history=0.0d0
   allocate(volume_history(nhistory_stress));volume_history=0.d0
   allocate(volume_forc_history(nhistory_stress));volume_forc_history=0.d0
end subroutine m_UC_init

subroutine m_UC_wd_cntn_data(nfcntn)
   integer,intent(in) :: nfcntn
   integer :: i,nbox
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   if(first_call.or.nbox==0) return
   if(mype==0)then
      write(nfcntn,*) tag_unit_cell_optimization
      write(nfcntn,*) 'history of the unit cell'
      do i=1,nbox
         if(sw_uniform==OFF)then
            write(nfcntn,'(3f25.15)') cellvec_history(1,1,i),cellvec_history(1,2,i),cellvec_history(1,3,i)
            write(nfcntn,'(3f25.15)') cellvec_history(2,1,i),cellvec_history(2,2,i),cellvec_history(2,3,i)
            write(nfcntn,'(3f25.15)') cellvec_history(3,1,i),cellvec_history(3,2,i),cellvec_history(3,3,i)
         else
            write(nfcntn,'(f25.15)') volume_history(i)
         endif
      enddo
      write(nfcntn,*) 'history of the force acting on the unit cell'
      do i=1,nbox
         if(sw_uniform==OFF)then
            write(nfcntn,'(3f25.15)') stress_forc_history(1,1,i),stress_forc_history(1,2,i),stress_forc_history(1,3,i)
            write(nfcntn,'(3f25.15)') stress_forc_history(2,1,i),stress_forc_history(2,2,i),stress_forc_history(2,3,i)
            write(nfcntn,'(3f25.15)') stress_forc_history(3,1,i),stress_forc_history(3,2,i),stress_forc_history(3,3,i)
         else
            write(nfcntn,'(f25.15)') volume_forc_history(i)
         endif
      enddo
      write(nfcntn,*) 'max. stress'
      write(nfcntn,'(f25.15)') m_Stress_get_stressmx()
      write(nfcntn,*) 'maxoptforc'
      write(nfcntn,'(f25.15)') maxoptforc_old
   endif
end subroutine m_UC_wd_cntn_data

subroutine m_UC_rd_cntn_data(nfcntn)
   integer, intent(in) :: nfcntn
   integer :: i,nbox,ierr
   logical             :: tag_is_found, EOF_reach
   integer,      parameter   :: len_str = 132
   character(len=len_str)       :: str
   real(kind=DP) :: strmx
   if(first_call) then
      call m_UC_init()
      first_call = .false.
   endif
   first_call = .false.
   if(mype==0)then
      if(iteration_unit_cell-1<=nhistory_stress)then
         nbox = iteration_unit_cell-1
      else
         nbox = nhistory_stress
      endif
      call rewind_to_tag0(nfcntn,len(tag_unit_cell_optimization), &
            &  tag_unit_cell_optimization & 
            &, EOF_reach, tag_is_found, str,len_str)
      if(tag_is_found)then
         read(nfcntn,*) 
         do i=1,nbox
            if(sw_uniform==OFF)then
               read(nfcntn,*) cellvec_history(1,1,i),cellvec_history(1,2,i),cellvec_history(1,3,i)
               read(nfcntn,*) cellvec_history(2,1,i),cellvec_history(2,2,i),cellvec_history(2,3,i)
               read(nfcntn,*) cellvec_history(3,1,i),cellvec_history(3,2,i),cellvec_history(3,3,i)
            else
               read(nfcntn,*) volume_history(i)
            endif
         enddo
         read(nfcntn,*)
         do i=1,nbox
            if(sw_uniform==OFF)then
               read(nfcntn,*) stress_forc_history(1,1,i),stress_forc_history(1,2,i),stress_forc_history(1,3,i)
               read(nfcntn,*) stress_forc_history(2,1,i),stress_forc_history(2,2,i),stress_forc_history(2,3,i)
               read(nfcntn,*) stress_forc_history(3,1,i),stress_forc_history(3,2,i),stress_forc_history(3,3,i)
            else
               read(nfcntn,*) volume_forc_history(i)
            endif
         enddo
         read(nfcntn,*)
         read(nfcntn,*) strmx
         read(nfcntn,*)
         read(nfcntn,*) maxoptforc_old
      endif
      call rewind_to_tag0(nfcntn,len(tag_lattice_vector),tag_lattice_vector &
           &,  EOF_reach, tag_is_found, str, len_str)
      if(tag_is_found)then
         read(nfcntn,*) altv(1,1),altv(2,1),altv(3,1)
         read(nfcntn,*) altv(1,2),altv(2,2),altv(3,2)
         read(nfcntn,*) altv(1,3),altv(2,3),altv(3,3)
      endif
   endif
   if(npes>1)then
      call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
      if(tag_is_found)then
         if(sw_uniform==OFF)then
            call mpi_bcast(cellvec_history,9*nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
            call mpi_bcast(stress_forc_history,9*nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
         else
            call mpi_bcast(volume_history,nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
            call mpi_bcast(volume_forc_history,nhistory_stress,mpi_double_precision,0,mpi_comm_group,ierr)
         endif
         call mpi_bcast(strmx,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(maxoptforc_old,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv,9,mpi_double_precision,0,mpi_comm_group,ierr)
      endif
   endif
   call m_CS_altv_2_rltv()
   call m_Stress_set_stressmx(strmx)
end subroutine m_UC_rd_cntn_data

function get_averaged_cell_forc(stress_tensor) result(res)
   real(kind=DP), dimension(:,:), intent(in) :: stress_tensor
   real(kind=DP) :: stav,exstav
   real(kind=DP) :: res
   stav = stress_tensor(1,1)+stress_tensor(2,2)+stress_tensor(3,3)
! ================ KT_mod ================= 13.0B
!   exstav = external_stress(1,1)+external_stress(2,2)+external_stress(3,3)
!   res = (stav-exstav)/3.0d0
!
   res = stav /3.0d0
! ========================================= 13.0B
end function get_averaged_cell_forc

subroutine m_UC_doit()
   integer :: i
   real(kind=DP), dimension(3,3) :: stress_tensor,stress_tensor_p
   real(kind=DP), dimension(3,3) :: stress_tensor_tmp
   real(kind=DP), dimension(3,3) :: work
   real(kind=DP), dimension(3,3) :: altv_brav
   real(kind=DP), dimension(3) :: avec,bvec,cvec
   real(kind=DP) :: vol,dv,factor,mstress
   if(first_call)then
      call m_UC_init()
      first_call = .false.
   endif
   if(printable) write(nfout,'(a)')      ' -- lattice optimization --'
   stress_tensor = m_Stress_get_curr_stress()
   stress_tensor_p = 0.0d0

   stress_forc = get_force( altv, stress_tensor )

! ================================= KT_add ================== 13.0B &13.1AS
   if ( sw_neglect_stress_offdiagonal == ON ) then
      stress_tensor_tmp = 0.0d0
      stress_tensor_tmp(1,1) = stress_tensor(1,1)
      stress_tensor_tmp(2,2) = stress_tensor(2,2)
      stress_tensor_tmp(3,3) = stress_tensor(3,3)

      stress_forc = get_force( altv, stress_tensor_tmp )
   endif
   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )
      stress_forc = get_force( altv_brav, stress_tensor )

     if ( sw_fix_lattice_angles==ON ) then
        stress_forc = constrain_on_force_type1( altv_brav, stress_forc )
     endif
     if ( sw_fix_lattice_lengths==ON ) then
        stress_forc = constrain_on_force_type2( altv_brav, stress_forc )
     endif
  endif
! =========================================================== 13.0B &13.1AS

   mstress = m_Stress_get_stressmx()
   if(printable)then
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- current lattice --'
      write(nfout,'(a,3f20.10)') '    a_vector ',altv(1,1),altv(2,1),altv(3,1)
      write(nfout,'(a,3f20.10)') '    b_vector ',altv(1,2),altv(2,2),altv(3,2)
      write(nfout,'(a,3f20.10)') '    c_vector ',altv(1,3),altv(2,3),altv(3,3)
      write(nfout,'(a)')

      write(nfout,'(a)')         ' -- current volume --'
      write(nfout,'(a,f22.12)')  '    univol ', univol
      write(nfout,'(a)')

      write(nfout,'(a,i8,a)')    ' -- stress tensor obtained from iteration_unit_cell ',iteration_unit_cell-1,' --'
      do i=1,3
         write(nfout,'(3f20.10)') stress_tensor(i,1),stress_tensor(i,2),stress_tensor(i,3)
      enddo
      write(nfout,'(a)')         ' -- current cps and pos --'
      do i=1,natm
         write(nfout,'(6f20.10)') cps(i,1),cps(i,2),cps(i,3),pos(i,1),pos(i,2),pos(i,3)
      enddo
      write(nfout,'(a,f20.10,a)') ' -- max. stress : ',mstress,' --'
      write(nfout,'(a)')
      write(nfout,'(a)')          ' -- force acting on the unit cell --'
      write(nfout,'(a,3f20.10)')  '    a_vector ',stress_forc(1,1),stress_forc(1,2),stress_forc(1,3)
      write(nfout,'(a,3f20.10)')  '    b_vector ',stress_forc(2,1),stress_forc(2,2),stress_forc(2,3)
      write(nfout,'(a,3f20.10)')  '    c_vector ',stress_forc(3,1),stress_forc(3,2),stress_forc(3,3)
      if(lattice_optimization_method==QUENCHED_MD)then
         write(nfout,'(a)')          ' -- velocity of the unit cell --'
         write(nfout,'(a,3f20.10)')  '    a_vector ',stress_velocity(1,1),stress_velocity(1,2),stress_velocity(1,3)
         write(nfout,'(a,3f20.10)')  '    b_vector ',stress_velocity(2,1),stress_velocity(2,2),stress_velocity(2,3)
         write(nfout,'(a,3f20.10)')  '    c_vector ',stress_velocity(3,1),stress_velocity(3,2),stress_velocity(3,3)
      endif
   endif

   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      altv = altv_brav
   endif

   if(sw_uniform==OFF)then
      call store_cell_and_stress()
      if(lattice_optimization_method==QUENCHED_MD .or. &
      &  lattice_optimization_method==STEEPEST_DESCENT) then
         call update_lattice()
         call update_velocities()
      else if (lattice_optimization_method==BFGS) then
         call update_lattice_by_bfgs()
      endif
   else
      avec=altv(:,1)
      bvec=altv(:,2)
      cvec=altv(:,3)
      vol = get_volume(avec,bvec,cvec)
      dv = get_averaged_cell_forc(stress_tensor)
      call store_volume(vol,dv)
      call update_volume_by_bfgs()
   endif

   if ( sw_fix_lattice_angles==ON .or. sw_fix_lattice_lengths == ON ) then
      altv_brav = altv
      call get_latvec_from_brav_to_prim( b2pmat, altv_brav, altv )
   endif

   stress_forc_old = stress_forc
   univolo = univol
   call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
   call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
   call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS

   if(printable)then
      write(nfout,'(a)')         ' -- new lattice --'
      write(nfout,'(a,3f20.10)') '    a_vector ',altv(1,1),altv(2,1),altv(3,1)
      write(nfout,'(a,3f20.10)') '    b_vector ',altv(1,2),altv(2,2),altv(3,2)
      write(nfout,'(a,3f20.10)') '    c_vector ',altv(1,3),altv(2,3),altv(3,3)
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- new volume --'
      write(nfout,'(a,f22.12)')  '    univol ', univol
      write(nfout,'(a)')
      write(nfout,'(a)')         ' -- new cps and pos --'
      do i=1,natm
         write(nfout,'(6f20.10)') cps(i,1),cps(i,2),cps(i,3),pos(i,1),pos(i,2),pos(i,3)
      enddo
!
      if ( kt_iuctype == 0 .and. ipriunitcell >=2 ) then   ! bravias
         write(nfout,'(a)')
         write(nfout,'(a)') ' --- new lattice (bravais) ---- '
         write(nfout,'(3(a,f18.12))')  '  a     = ', a, '  b    = ', b, '  c     = ', c
         write(nfout,'(3(a,f18.12))')  '  alpha = ', acos(ca)/PAI*180.0d0, &
              &                           '  beta = ', acos(cb)/PAI*180.0d0, &
              &                           '  gamma = ', acos(cc)/PAI*180.0d0
         write(nfout,'(a)')

         work(1,:) = altv(:,1);    work(2,:) = altv(:,2);    work(3,:) = altv(:,3)
         work = matmul( p2bmat, work )
         write(nfout,'(a,3f20.10)') '    avec = ',work(1,1:3)
         write(nfout,'(a,3f20.10)') '    bvec = ',work(2,1:3)
         write(nfout,'(a,3f20.10)') '    cvec = ',work(3,1:3)
         write(nfout,'(a)') ' ----------------------------- '
      endif

   endif

end subroutine m_UC_doit

function m_UC_get_univol_old() result(res)
   real(kind=DP) :: res
   res = univolo
end function m_UC_get_univol_old

subroutine get_bfgs_force(nfree,nbox,coord,forc,forc_bfgs,forc_bfgs_max)
   integer, intent(in) :: nfree
   real(kind=DP),intent(in),dimension(nfree,nbox) :: coord,forc
   real(kind=DP),intent(out),dimension(nfree) :: forc_bfgs
   real(kind=DP),intent(out) :: forc_bfgs_max
   integer :: nbox,i,j,k,info
   real(kind=DP),dimension(nfree) :: xdelta,gdelta,gdotinvh
   real(kind=DP),dimension(nfree,nfree) :: ihess
   real(kind=DP),dimension(nfree*(nfree+1)/2) :: amat
   real(kind=DP),dimension(nfree) :: eigv
   real(kind=DP),dimension(nfree,nfree) :: eigvec
   real(kind=DP),dimension(nfree*3) :: workar
   real(kind=DP) :: xgi,gihg
   logical :: corrected_eig

   ihess=0.0d0
   do i=1,nfree
      ihess(i,i)=1.0d0
   enddo
   do i=2,nbox 
      do j=1,nfree
         xdelta(j) = coord(j,i) - coord(j,i-1)
         gdelta(j) = -forc(j,i) + forc(j,i-1)
      enddo
      xgi = 1.0d0/dot_product(xdelta,gdelta)
      if(xgi<0)then
         if(printable)then
            write(nfout,'(a,i3)') '!** WARNING dx dot dg is negative for history ',i
            write(nfout,'(a)') 'skipping this update.'
         endif
         cycle
      endif
      do j=1,nfree
         gdotinvh(j)=dot_product(ihess(j,:),gdelta(:))
      enddo
      gihg = dot_product(gdelta,gdotinvh)
      do j=1,nfree
         do k=1,nfree
            ihess(j,k) = ihess(j,k)+xgi*xgi*(1.0d0/xgi+gihg)*xdelta(j)*xdelta(k) &
  &                    - (gdotinvh(j)*xdelta(k)+gdotinvh(k)*xdelta(j))*xgi
         enddo
      enddo
   enddo

!  correct bad eigenvalues present in the Hessian
!  we will always do this, since the matrix size is fixed & small
   corrected_eig=.false.
   amat=0.0d0;eigv=0.0d0;eigvec=0.0d0;workar=0.0d0
   do i=1,nfree
      do j=i,nfree
         amat(i + (j-1)*j/2) = ihess(i,j)
      enddo
   enddo
   call dspev('V','U',nfree,amat,eigv,eigvec,nfree,workar,info)
   if(printable .and. ipriunitcell>=2) write(nfout,'(a)') '--- eigenvalues for the approximate Hessian ---'
   do i=1,nfree
      if(printable.and.ipriunitcell>=2) write(nfout,'(i8,f20.10)') i,1.0d0/eigv(i)
      if (1.0d0/eigv(i)<eigenvalue_threshold)then
         eigv(i) = 1.0d0/eigenvalue_threshold
         if(printable.and.ipriunitcell>=2) write(nfout,'(a,i8,a,f20.10)') &
         &  'corrected the eigenvalue for the ',i,'-th element to : ',1.0d0/eigv(i)
         corrected_eig=.true.
      endif
   enddo
   if(corrected_eig)then
      ihess=0.d0
      do i=1,nfree
         do j=1,nfree
            do k=1,nfree
               ihess(i,j) = ihess(i,j)+eigvec(i,k)*eigvec(j,k)*eigv(k)
            enddo
         enddo
      enddo
   endif

   forc_bfgs=0.0d0
   forc_bfgs_max=0.0d0
   do i=1,nfree
      do j=1,nfree
         forc_bfgs(i) = forc_bfgs(i)+ihess(i,j)*forc(j,nbox)
      enddo
      if(abs(forc_bfgs(i))>forc_bfgs_max) forc_bfgs_max = abs(forc_bfgs(i))
   enddo

end subroutine get_bfgs_force

subroutine update_volume_by_bfgs()
   integer :: nbox 
   real(kind=DP),dimension(1) :: forc_bfgs
   real(kind=DP) :: forc_bfgs_max,factor
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   call get_bfgs_force(1,nbox,volume_history,volume_forc_history,forc_bfgs,forc_bfgs_max)
   if(printable) write(nfout,*) 'max. bfgs force : ',forc_bfgs_max
   if(maxoptforc_old*10<forc_bfgs_max)then
      if (printable) write(nfout,'(a)') &
      & 'the estimated force acting on the cell seems to be very large; &
      & update will be done by the steepest-descent method'
      factor = (1+volume_forc_history(nbox)*delta_stress)**(1.d0/3.d0)
   else
      factor = (1+forc_bfgs(1))**(1.d0/3.d0)
   endif
   altv(:,:) = altv(:,:)*factor
   maxoptforc_old = forc_bfgs_max
end subroutine update_volume_by_bfgs

subroutine update_lattice_by_bfgs()
   integer :: nbox,i,j,k,icount
   real(kind=DP),dimension(3,3) :: tmpforc
   real(kind=DP),allocatable,dimension(:,:) :: coord,forc
   real(kind=DP),dimension(9) :: forc_bfgs
   real(kind=DP) :: forc_bfgs_max
   if(iteration_unit_cell-1<=nhistory_stress)then
      nbox = iteration_unit_cell-1
   else
      nbox = nhistory_stress
   endif
   allocate(coord(9,nbox))
   allocate(forc(9,nbox))
   do i=1,nbox
      icount=0
      do j=1,3
         do k=1,3
            icount = icount + 1
            coord(icount,i) = cellvec_history(j,k,i)
            forc(icount,i)  = stress_forc_history(k,j,i)
         enddo
      enddo
   enddo

   call get_bfgs_force(9,nbox,coord,forc,forc_bfgs,forc_bfgs_max)

   tmpforc=0.0d0
   icount=0
   do i=1,3
      do j=1,3
         icount=icount+1
         tmpforc(j,i) = forc_bfgs(icount)
      enddo
   enddo
   if(printable)then
      write(nfout,'(a)') ' -- BFGS force acting on the unit cell --'
      write(nfout,'(a,3f20.10)')  '    a_vector ',tmpforc(1,1),tmpforc(1,2),tmpforc(1,3)
      write(nfout,'(a,3f20.10)')  '    b_vector ',tmpforc(2,1),tmpforc(2,2),tmpforc(2,3)
      write(nfout,'(a,3f20.10)')  '    c_vector ',tmpforc(3,1),tmpforc(3,2),tmpforc(3,3)
      write(nfout,'(a,f20.10)')   '    max: ',forc_bfgs_max
   endif
   if(maxoptforc_old*10<forc_bfgs_max)then
      if (printable) write(nfout,'(a)') &
      & 'the estimated force acting on the cell seems to be very large; &
      & update will be done by the steepest-descent method'
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + stress_forc_history(j,i,nbox)*delta_stress
         enddo
      enddo
   else
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + tmpforc(j,i)
         enddo
      enddo
   endif
   maxoptforc_old = forc_bfgs_max
   deallocate(coord)
   deallocate(forc)
end subroutine update_lattice_by_bfgs

subroutine update_velocities()
   integer :: i,j
   if(lattice_optimization_method==QUENCHED_MD)then
      stress_velocity(:,:) = stress_velocity(:,:) + 0.5*delta_stress * (stress_forc(:,:) + stress_forc_old(:,:))
      do i=1,3
         do j=1,3
            if(stress_velocity(j,i)*stress_forc(j,i)<0) then
               stress_velocity(j,i) = 0.0d0 ! quench
               if(printable) write(nfout,'(a,2i2)') 'quenched stress component : ',j,i
            endif
         enddo
      enddo
   endif
end subroutine update_velocities

subroutine store_volume(vol,dv)
   real(kind=DP),intent(in) :: vol
   real(kind=DP),intent(in) :: dv
   integer :: i
   if(iteration_unit_cell-1<=nhistory_stress)then
      volume_history(iteration_unit_cell-1) = vol
      volume_forc_history(iteration_unit_cell-1) = dv
   else
      do i=2,nhistory_stress
         volume_history(i-1) = volume_history(i)
         volume_forc_history(i-1) = volume_forc_history(i)
      enddo
      volume_history(nhistory_stress) = vol
      volume_forc_history(nhistory_stress) = dv
   endif
end subroutine store_volume

subroutine store_cell_and_stress()
   integer :: ihist,i,nn
   if(iteration_unit_cell-1<=nhistory_stress)then
      cellvec_history(:,:,iteration_unit_cell-1) = altv(:,:)
      stress_forc_history(:,:,iteration_unit_cell-1) = stress_forc(:,:)
      nn = iteration_unit_cell-1
   else
      do i=2,nhistory_stress
         cellvec_history(:,:,i-1) = cellvec_history(:,:,i)
         stress_forc_history(:,:,i-1) = stress_forc_history(:,:,i)
      enddo
      cellvec_history(:,:,nhistory_stress) = altv(:,:)
      stress_forc_history(:,:,nhistory_stress) = stress_forc(:,:)
      nn = nhistory_stress
   endif
   if(printable.and.ipriunitcell>=2) then
      write(nfout,'(a)') 'cellvec history'
      do i=1,nn
         write(nfout,'(a,i5)') 'step no ',i
         write(nfout,'(a,3f20.10)') 'avec ',cellvec_history(1,1,i),cellvec_history(2,1,i),cellvec_history(3,1,i)
         write(nfout,'(a,3f20.10)') 'bvec ',cellvec_history(1,2,i),cellvec_history(2,2,i),cellvec_history(3,2,i)
         write(nfout,'(a,3f20.10)') 'cvec ',cellvec_history(1,3,i),cellvec_history(2,3,i),cellvec_history(3,3,i)
      enddo
   endif
end subroutine store_cell_and_stress

subroutine update_lattice()
   integer :: i,j
   if(lattice_optimization_method==QUENCHED_MD)then
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + delta_stress*stress_velocity(j,i) + 0.5*stress_forc(j,i)*delta_stress*delta_stress
         enddo
      enddo
   else if (lattice_optimization_method==STEEPEST_DESCENT)then
      do i=1,3
         do j=1,3
            altv(i,j) = altv(i,j) + stress_forc(j,i)*delta_stress
         enddo
      enddo
   endif
end subroutine update_lattice

function get_force(altv_in,stress) result(ret)
   real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
   real(kind=DP), dimension(3,3) :: ret
   integer :: i
   ret = 0.0d0
   do i=1,3
! =========================== KT_mod ================== 13.0B
!      ret(1,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,1)) ! a-vec
!      ret(2,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,2)) ! b-vec
!      ret(3,i) = dot_product(stress(i,:)-external_stress(i,:),altv(:,3)) ! c-vec
!
      ret(1,i) = dot_product(stress(i,:),altv_in(:,1)) ! a-vec
      ret(2,i) = dot_product(stress(i,:),altv_in(:,2)) ! b-vec
      ret(3,i) = dot_product(stress(i,:),altv_in(:,3)) ! c-vec
! ====================================================== 13.0B
   enddo
end function get_force

function get_max(stress) result(res)
   real(kind=DP), dimension(3,3), intent(in) :: stress
   integer :: i,j
   real(kind=DP) :: res
   res=dabs(stress(1,1))
   do i=1,3
      do j=1,3
         if(dabs(stress(j,i))>res) res = dabs(stress(j,i))
      enddo
   enddo
end function get_max

! === KT_add ==== 13.1AS
function projected_stress_along_latvecs(altv_in,stress) result(ret)
  real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
  real(kind=DP), dimension(3,3) :: ret

  integer :: i
  real(kind=DP) :: normalized_lat_vec(3,3), c1
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

  ret = 0.0d0

  do i=1,3
     ret(1,i) = dot_product(stress(i,:),normalized_lat_vec(:,1)) ! a-vec
     ret(2,i) = dot_product(stress(i,:),normalized_lat_vec(:,2)) ! b-vec
     ret(3,i) = dot_product(stress(i,:),normalized_lat_vec(:,3)) ! c-vec
  enddo
end function projected_stress_along_latvecs

! =========================== KT_add ======================== 13.0B &13.1AS
function constrain_on_force_type1(altv_in,f_in) result(f_out)
  real(kind=DP), intent(in) :: f_in(3,3), altv_in(3,3)
  real(kind=DP) :: f_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  f_out = f_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_angle_alpha .and. fix_angle_beta .and. fix_angle_gamma ) then
     Do i=1, 3
        c1 = dot_product( f_out(i,:), normalized_lat_vec(:,i) )
        f_out(i,:) = c1 *normalized_lat_vec(:,i)
     End do
     return
  endif

! -----------------------------------
  if ( fix_angle_alpha ) then
     vectmp(:) = normalized_lat_vec(:,2) + normalized_lat_vec(:,3)

     Do i=2, 3
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_beta ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,3)

     Do i=1, 3, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_gamma ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,2)

     Do i=1, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( f_out(i,:), vectmp2(:) )
        f_out(i,:) = f_out(i,:) - c3 *vectmp2(:)
     End do

  endif

end function constrain_on_force_type1
! ================================================================ 13.0B

! === KT_add === 13.1AS
function constrain_on_force_type2(altv_in,f_in) result(f_out)
  real(kind=DP), intent(in) :: f_in(3,3), altv_in(3,3)
  real(kind=DP) :: f_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  f_out = f_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_length_a ) then
     c1 = dot_product( f_out(1,:), normalized_lat_vec(:,1) )
     f_out(1,:) = f_out(1,:) -c1 *normalized_lat_vec(:,1)
  endif
  if ( fix_length_b ) then
     c1 = dot_product( f_out(2,:), normalized_lat_vec(:,2) )
     f_out(2,:) = f_out(2,:) -c1 *normalized_lat_vec(:,2)
  endif
  if ( fix_length_c ) then
     c1 = dot_product( f_out(3,:), normalized_lat_vec(:,3) )
     f_out(3,:) = f_out(3,:) -c1 *normalized_lat_vec(:,3)
  endif
end function constrain_on_force_type2
! ====== 13.1AS

subroutine m_UnitCell_init_md()
  integer :: i,j
  real(kind=DP), dimension(3) :: avec,bvec,cvec
  if(.not.first_call) return
  allocate(p_l(natm,3));p_l = 0.d0
  allocate(p_l_lattice(natm,3));p_l_lattice = 0.d0
  allocate(forc_l_lattice(natm,3));forc_l_lattice = 0.d0
  allocate(p_l_metric(natm,3));p_l_metric = 0.d0
  metric = matmul(transpose(altv),altv)
  call m_UnitCell_init_md_per_step()
  m_thermo = qmass(1)
  s_thermo = 1.d0
  p_thermo = 0.d0
  p_baro = 0.d0
  p_baro_tmp = 0.d0
  target_temperature = tkb(1)/CONST_kB
!  gfree = 3*(natm-1)
  gfree = 3*(natm)
  do i=1,natm
     p_l(i,:) = amion(ityp(i)) * cpd_l(i,:) * s_thermo
  enddo
  call convert_coords(natm,p_l,altv,p_l_lattice)
  call convert_coords(natm,p_l_lattice,metric_inv,p_l_metric)
  do i=1,3
     do j=1,3
        factor(j,i) = 1.d0
        if(i.eq.j) factor(j,i) = 0.5d0
     enddo
  enddo
  first_call = .false.
end subroutine m_UnitCell_init_md

subroutine build_dudmetric()
  real(kind=DP), dimension(3,3) :: stress_tensor
  real(kind=DP) :: avstress
  integer :: i
  stress_tensor = m_Stress_get_curr_stress()
  if(sw_average_diagonal == ON) then
    avstress = 0.d0
    do i=1, 3
      avstress = avstress+stress_tensor(i,i)
    enddo
    avstress = avstress/3.d0
    do i=1, 3
      stress_tensor(i,i) = avstress
    enddo
  endif
  dudmetric = -univol * 0.5d0 * matmul(altv_inv,matmul(stress_tensor,transpose(altv_inv)))
end subroutine build_dudmetric

subroutine convert_coords(natm,inar,cmat,outar)
  integer, intent(in) :: natm
  real(kind=DP), intent(in) :: inar(natm,3)
  real(kind=DP), intent(in) :: cmat(3,3)
  real(kind=DP), intent(out) :: outar(natm,3) 
  integer :: i,j
  outar = 0.d0
  do i=1,3
     do j=1,natm
        outar(j,i)  = dot_product(cmat(i,:),inar(j,:))
     enddo
  enddo
end subroutine convert_coords

function get_kinetic_atom(natm,p_atm, mat) result(ret)
  integer, intent(in) :: natm
  real(kind=DP), intent(in), dimension(natm,3) :: p_atm
  real(kind=DP), intent(in), dimension(3,3) :: mat
  real(kind=DP) :: ret
  real(kind=DP),dimension(3) :: tmpp
  integer :: i,j
  ret = 0.d0
  do i=1,natm
     do j=1,3
        tmpp(j) = dot_product(mat(j,:),p_atm(i,:))
     enddo
     ret = ret + dot_product(p_atm(i,:),tmpp(:))/amion(ityp(i))
  enddo
  ret = 0.5d0 * ret/(s_thermo*s_thermo)
end function get_kinetic_atom

function get_kinetic_thermo(p_thermo) result (ret)
  real(kind=DP), intent(in) :: p_thermo
  real(kind=DP) :: ret
  ret = 0.5d0 * p_thermo * p_thermo /m_thermo
end function get_kinetic_thermo

function get_kinetic_baro(p_baro) result(ret)
  real(kind=DP), intent(in), dimension(3,3) :: p_baro
  real(kind=DP) :: ret 
  integer :: i
  ret = 0.d0
  do i=1,3
     ret = ret + dot_product(p_baro(i,:),p_baro(:,i))
  enddo
  ret = 0.5d0 * ret/(m_baro * univol * univol)
end function get_kinetic_baro

function get_potential_baro() result(ret)
  real(kind=DP) :: ret
  ret = target_pressure * univol
end function get_potential_baro

subroutine m_UnitCell_init_md_per_step()
  real(kind=DP), external :: deter3
  univol = sqrt(deter3(metric))
  call inver3n(3,metric,metric_inv)
  call inver3n(3,altv,altv_inv)
  call build_dudmetric()
  H0 = get_H0()
end subroutine m_UnitCell_init_md_per_step

function tensor_rank2_equals(t1,t2) result(ret)
  real(kind=DP), dimension(3,3) :: t1,t2
  logical :: ret
  integer :: i,j
  do i=1,3
     do j=1,3
        if(abs(t1(j,i)-t2(j,i)).gt.eps) then
           ret = .false.
           return
        endif
     enddo
  enddo
  ret = .true.
end function tensor_rank2_equals

subroutine metric_to_altv()
  real(kind=DP) :: r1,r2,r3,cosa,cosb,cosc,sina,sinb,sinc
  
  altv = 0.d0
  r1=dsqrt(metric(1,1))
  r2=dsqrt(metric(2,2))
  r3=dsqrt(metric(3,3))
  
  cosa=metric(2,3)/(r2*r3)
  sina=dsqrt(dabs(1.d0-cosa**2))
  cosb=metric(1,3)/(r1*r3)
  sinb=dsqrt(dabs(1d0-cosb**2))
  cosc=metric(1,2)/(r1*r2)
  sinc=dsqrt(dabs(1d0-cosc**2))

  altv(3,3)=r3
  altv(3,2)=r2*cosa
  altv(2,2)=r2*sina
  altv(3,1)=r1*cosb
  altv(2,1)=(metric(1,2)-r1*r2*cosa*cosb)/(r2*sina)
  altv(1,1)=dsqrt(dabs(metric(1,1)-altv(2,1)**2-altv(3,1)**2))

end subroutine metric_to_altv

function m_UC_get_hamiltonian() result(res)
  real(kind=DP) :: res
  real(kind=DP) :: k_atm,k_baro,k_thermo,pot_baro,pot_thermo
  logical, save :: first_call = .true.
  call m_UnitCell_init_md()
  k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
  k_baro = get_kinetic_baro(matmul(metric,p_baro))
  pot_baro = get_potential_baro()
  if(control_pressure == OFF) then
    k_baro = 0.d0
    pot_baro = 0.d0
  endif
  if(imdalg == PT_CONTROL .and. t_ctrl_method /= VELOCITY_SCALING)then
     k_thermo = get_kinetic_thermo(p_thermo)
     pot_thermo = gfree * target_temperature * CONST_kB * log(s_thermo)
  else if (imdalg == P_CONTROL .or. (imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING)) then
     k_thermo = 0.d0
     pot_thermo = 0.d0
  endif
!  res = s_thermo * (k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro)
  res = k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro
  if(.not.H0_has_been_set)then
    H0 = res
    H0_has_been_set = .true.
  endif
  res = res-H0
end function m_UC_get_hamiltonian

function get_H0() result (res)
  real(kind=DP) :: res
  real(kind=DP) :: k_atm,k_baro,k_thermo,pot_baro,pot_thermo
  k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
  k_baro = get_kinetic_baro(matmul(metric,p_baro))
  pot_baro = get_potential_baro()
  if(control_pressure == OFF) then
    k_baro = 0.d0
    pot_baro = 0.d0
  endif
  if(imdalg == PT_CONTROL .and. t_ctrl_method /= VELOCITY_SCALING)then
     k_thermo = get_kinetic_thermo(p_thermo)
     pot_thermo = gfree * target_temperature * CONST_kB * log(s_thermo)
  else if (imdalg == P_CONTROL .or. (imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING)) then
     k_thermo = 0.d0
     pot_thermo = 0.d0
  endif
!  res = s_thermo * (k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro)
  res = k_atm + etotal + k_thermo + pot_thermo + k_baro + pot_baro
  return
end function get_H0

function m_UC_get_curr_pressure() result(res)
  real(kind=DP) :: curr_pressure, res
  integer :: i
  real(kind=DP), dimension(3,3) :: stress
  curr_pressure = 2.d0 * get_kinetic_atom(natm,p_l_lattice,metric_inv)
  do i=1,3
    curr_pressure = curr_pressure - 2.d0 * dudmetric(i,i) * altv(i,i) * altv(i,i)
  enddo
  res = curr_pressure/3.d0/univol
end function m_UC_get_curr_pressure

function m_UC_get_curr_temperature() result(res)
  integer :: i
  real(kind=DP) :: ke,res
  ke = 2.d0 * get_kinetic_atom(natm,p_l_lattice,metric_inv)
  res = ke/gfree/CONST_kB
end function m_UC_get_curr_temperature

subroutine m_UC_rd_md_cntn_data(nfcntn)
   integer, intent(in) :: nfcntn  
   integer :: i,ierr
   logical             :: tag_is_found, EOF_reach
   integer,      parameter   :: len_str = 132
   character(len=len_str)       :: str

   call m_UnitCell_init_md()

   if(mype==0)then
      call rewind_to_tag0(nfcntn,len(tag_pressure_control), &
            &  tag_pressure_control, & 
            &  EOF_reach, tag_is_found, str,len_str)
      if(tag_is_found)then
         read(nfcntn,*)
         read(nfcntn,*) s_thermo
         read(nfcntn,*)
         read(nfcntn,*) p_thermo
         read(nfcntn,*)
         read(nfcntn,*) H0
         call read_33('altv',altv)      
         call read_33('altv_inv',altv_inv)
         call read_33('metric',metric)
         call read_33('metric_inv',metric_inv)
         call read_33('dudmetric',dudmetric)
         call read_33('p_baro',p_baro)
         call read_33('p_baro_tmp',p_baro_tmp)
         call read_natm3('forc_l_lattice',forc_l_lattice,allocated(forc_l_lattice))
         call read_natm3('p_l',p_l,allocated(p_l))
         call read_natm3('p_l_lattice',p_l_lattice,allocated(p_l_lattice))
         call read_natm3('p_l_metric',p_l_metric,allocated(p_l_metric))
      endif
   endif

   if(npes>1)then
      call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
      if(tag_is_found) then
         call mpi_bcast(s_thermo,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_thermo,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(H0,1,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(altv_inv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(metric,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(metric_inv,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_baro,9,mpi_double_precision,0,mpi_comm_group,ierr)
         call mpi_bcast(p_baro_tmp,9,mpi_double_precision,0,mpi_comm_group,ierr)
         if(allocated(forc_l_lattice)) &
         &  call mpi_bcast(forc_l_lattice,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         if(allocated(p_l)) &
         &  call mpi_bcast(p_l,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         if(allocated(p_l_lattice)) &
         &  call mpi_bcast(p_l_lattice,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         if(allocated(p_l_metric)) &
         &  call mpi_bcast(p_l_metric,natm*3,mpi_double_precision,0,mpi_comm_group,ierr)
         call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
         call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
         call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS
         if(iteration_unit_cell>1) then
           H0_has_been_set = .true.
         endif
      endif
   endif

   contains

   subroutine read_33(key,tensor)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(out), dimension(3,3) :: tensor
      read(nfcntn,*) 
      read(nfcntn,*) tensor(1,1),tensor(2,1),tensor(3,1)
      read(nfcntn,*) tensor(1,2),tensor(2,2),tensor(3,2)
      read(nfcntn,*) tensor(1,3),tensor(2,3),tensor(3,3)
   end subroutine read_33

   subroutine read_natm3(key,ar,allcd)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(out), dimension(natm,3) :: ar
      logical, intent(in) :: allcd
      integer :: i
      read(nfcntn,*)
      if(allcd)then
         do i=1,natm
            read(nfcntn,*) ar(i,1),ar(i,2),ar(i,3)
         enddo
      else
         do i=1,natm
            read(nfcntn,*)
         enddo
      endif
   end subroutine read_natm3

end subroutine m_UC_rd_md_cntn_data

subroutine m_UC_wd_md_cntn_data(nfcntn)
   integer, intent(in) :: nfcntn
   integer :: i
   if(first_call)then
      call m_UnitCell_init_md()
   endif
   if(mype==0)then
      write(nfcntn,*) tag_pressure_control
      write(nfcntn,*) 's_thermo'
      write(nfcntn,'(3f25.15)') s_thermo
      write(nfcntn,*) 'p_thermo'
      write(nfcntn,'(3f25.15)') p_thermo
      write(nfcntn,*) 'H0'
      write(nfcntn,'(3f25.15)') H0
      call dump_33('altv',altv)
      call dump_33('altv_inv',altv_inv)
      call dump_33('metric',metric)
      call dump_33('metric_inv',metric_inv)
      call dump_33('dudmetric',dudmetric)
      call dump_33('p_baro',p_baro)
      call dump_33('p_baro_tmp',p_baro_tmp)
      call dump_natm3('forc_l_lattice',forc_l_lattice,allocated(forc_l_lattice))
      call dump_natm3('p_l',p_l,allocated(p_l))
      call dump_natm3('p_l_lattice',p_l_lattice,allocated(p_l_lattice))
      call dump_natm3('p_l_metric',p_l_metric,allocated(p_l_metric))
   endif

   contains

   subroutine dump_33(key,tensor)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(in), dimension(3,3) :: tensor
      write(nfcntn,*) key
      write(nfcntn,'(3f25.15)') tensor(1,1),tensor(2,1),tensor(3,1)
      write(nfcntn,'(3f25.15)') tensor(1,2),tensor(2,2),tensor(3,2)
      write(nfcntn,'(3f25.15)') tensor(1,3),tensor(2,3),tensor(3,3)
   end subroutine dump_33

   subroutine dump_natm3(key,ar,allcd)
      character(len=*), intent(in) :: key
      real(kind=DP), intent(in), dimension(natm,3) :: ar
      logical, intent(in) :: allcd
      integer :: i
      write(nfcntn,*) key
      if(allcd)then
         do i=1,natm
            write(nfcntn,'(3f25.15)') ar(i,1),ar(i,2),ar(i,3)
         enddo
      else
         do i=1,natm
            write(nfcntn,'(3f25.15)') 0.d0,0.d0,0.d0
         enddo
      endif
   end subroutine dump_natm3

end subroutine m_UC_wd_md_cntn_data

! perform npt-md based on the metric tensor and Nose-Poincare thermostat
! original theory from I. Souza and J. L. Martins PRB 55 8733
! formulation from E. Herna´ndez JCP 115 10282
subroutine m_UnitCell_md(forc_l)
  real(kind=DP), intent(in), dimension(natm,3) :: forc_l
  real(kind=DP), dimension(3,3) :: p33,p_baro33,p_baro33_2,p_baro_tmp_m,p_baro_tmp2
  real(kind=DP), dimension(3,3) :: metric_tmp,metric_tmp2
  integer :: i,j
  real(kind=DP) :: k_baro,k_atm,pot_s,pot_baro,a,b,c,k_baro2,uvol2t,s_thermo_tmp,k_thermo,pot_thermo
  real(kind=DP), external :: deter3

  call m_UnitCell_init_md()

  call m_UnitCell_init_md_per_step()
  call second_half()
  call first_half()

  call post()

  contains

  subroutine post()
    integer :: i,j
    real(kind=DP),dimension(3,3) :: stress
    call convert_coords(natm,p_l_lattice,altv_inv,p_l)
    do i=1,natm 
       cpd_l(i,:) = p_l(i,:)/amion(ityp(i))/s_thermo
    enddo
  end subroutine post

  subroutine first_half()

    if(imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING) then
      call convert_coords(natm,p_l_lattice,altv_inv,p_l)
      do i=1,natm 
         cpd_l(i,:) = p_l(i,:)/amion(ityp(i))/s_thermo
      enddo
      call scale_velocity()
      do i=1,natm
         p_l(i,:) = amion(ityp(i)) * cpd_l(i,:) * s_thermo
      enddo
      call convert_coords(natm,p_l,altv,p_l_lattice)
    endif

    ! eq(18a)
    p_l_lattice(:,:) = p_l_lattice(:,:) + 0.5d0 * dtio * s_thermo * forc_l_lattice(:,:)
    ! eq(18b)
    call convert_coords(natm,p_l_lattice,metric_inv,p_l_metric)
    if(control_pressure == ON) then
    do i=1,3
       do j=1,3
          p33(j,i) = 0.5d0 * dot_product(p_l_metric(:,j),p_l_metric(:,i)/amion(ityp(:))/(s_thermo*s_thermo))
       enddo
    enddo
    p_baro_tmp = p_baro
    do i=1,nmax
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       p_baro33 = matmul(p_baro_tmp,p_baro_tmp_m)/(m_baro * univol * univol)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = 0.5d0 * get_potential_baro()
       p_baro_tmp2(:,:) = p_baro(:,:) - 0.5d0 * dtio * s_thermo *        &
       & (dudmetric(:,:) + 2.d0 * factor(:,:)*(-p33(:,:)+p_baro33(:,:) + &
       &  metric_inv(:,:)*(pot_baro - k_baro)))
       if(tensor_rank2_equals(p_baro_tmp,p_baro_tmp2)) then
          p_baro_tmp = p_baro_tmp2
          exit
       endif
       p_baro_tmp = p_baro_tmp2
       if(i .eq. nmax) then
          write(nfout,'(a)') 'failed to reach convergence for the iteration of the barostat momentum'
          call flush(nfout)
          stop
       endif
    enddo
    endif

    !eq(18c,d)
    if(imdalg == PT_CONTROL .and. t_ctrl_method /= VELOCITY_SCALING) then
       k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = get_potential_baro()
       if(control_pressure == OFF) then
           k_baro = 0.d0
           pot_baro = 0.d0
       endif
       pot_thermo = (1.d0+log(s_thermo)) * gfree * target_temperature * CONST_kB
       a = 0.25d0 * dtio/m_thermo
       b = 1.d0
       c = 0.5 * dtio * (-k_atm + pot_thermo + etotal + k_baro + pot_baro-H0) - p_thermo
       p_thermo = (-b+dsqrt(b*b-4.d0*a*c))/(2.d0*a)
       s_thermo_tmp = s_thermo * (1.d0+0.5d0*dtio*p_thermo/m_thermo)/(1.d0-0.5d0*dtio*p_thermo/m_thermo)
    else if (imdalg == P_CONTROL .or. (imdalg == PT_CONTROL .and. t_ctrl_method == VELOCITY_SCALING)) then
       s_thermo_tmp = 1.d0
       p_thermo = 0.d0
    endif

    if(control_pressure ==  ON)then
    !eq(18e)
    metric_tmp = metric
    p_baro33 = matmul(metric,matmul(p_baro_tmp,metric))/(m_baro*univol * univol)
    do i=1,nmax 
       uvol2t = dabs(deter3(metric_tmp))
       p_baro33_2 = matmul(metric_tmp,matmul(p_baro_tmp,metric_tmp))/(m_baro*uvol2t)
       metric_tmp2(:,:) = metric(:,:) + mobility_cell(:,:)*factor(:,:)*dtio &
       &                *(s_thermo*p_baro33(:,:) +s_thermo_tmp * p_baro33_2(:,:))
       if(tensor_rank2_equals(metric_tmp2,metric_tmp)) then
          metric_tmp = metric_tmp2
          exit
       endif
       metric_tmp = metric_tmp2
       if(i .eq. nmax) then
          write(nfout,'(a)') 'failed to reach convergence for the metric iteration'
          call flush(nfout)
          stop
       endif
    enddo
    metric = metric_tmp
    endif

    !eq(18f)
    do i=1,natm
       pos(i,:) = pos(i,:) + 0.5d0*dtio*(p_l_metric(i,:)/(amion(ityp(i))*s_thermo) +  &
                &                        p_l_metric(i,:)/(amion(ityp(i))*s_thermo_tmp))
    enddo

    s_thermo = s_thermo_tmp
    if(control_pressure==ON)then
    call metric_to_altv()
    call inver3n(3,metric,metric_inv)
    call inver3n(3,altv,altv_inv)
    call altv_2_rltv(altv,rltv,univol,rvol)  ! in b_CS
    call change_of_coordinate_system(altv,pos,natm,natm,cps) !-(b_I.S.) pos -> cps
    call primitive2bravais(nfout,p2bmat,altv(:,1),altv(:,2),altv(:,3),a,b,c,ca,cb,cc,il) ! in b_CS
    endif
    if(mype==0)then
      write(nflatconst,'(i10,7f20.10)') iteration_unit_cell,a,b,c, &
      &     acos(ca)/PAI*180.d0,acos(cb)/PAI*180.d0,acos(cc)/PAI*180.d0,univol
      write(nfmetric,'(i10)')     iteration_unit_cell
      write(nfmetric,'(3f20.10)') metric(1,1),metric(1,2),metric(1,3)
      write(nfmetric,'(3f20.10)') metric(2,1),metric(2,2),metric(2,3)
      write(nfmetric,'(3f20.10)') metric(3,1),metric(3,2),metric(3,3)
      call m_Files_flush_pcontrol_files()
    endif
  end subroutine first_half

  subroutine second_half()
    !eq(18g)
    if(imdalg == PT_CONTROL)then
       k_atm = get_kinetic_atom(natm,p_l_lattice,metric_inv)
       p_baro_tmp_m = matmul(metric,p_baro_tmp)
       k_baro = get_kinetic_baro(p_baro_tmp_m)
       pot_baro = get_potential_baro()
       if(control_pressure == OFF) then
          k_baro = 0.d0
          pot_baro = 0.d0
       endif
       pot_thermo = (1.d0+log(s_thermo)) * gfree * target_temperature * CONST_kB
       k_thermo = get_kinetic_thermo(p_thermo)
       p_thermo = p_thermo + 0.5d0*dtio*(k_atm - etotal - k_thermo - pot_thermo - k_baro - pot_baro + H0)
    endif

    if(control_pressure == ON)then
    !eq(18h)
    do i=1,3
       do j=1,3
          p33(j,i) = 0.5d0*dot_product(p_l_metric(:,i),p_l_metric(:,j)/amion(ityp(:))/(s_thermo*s_thermo))
       enddo
    enddo
    p_baro_tmp_m = matmul(metric,p_baro_tmp)
    p_baro33 = matmul(p_baro_tmp,p_baro_tmp_m)/(m_baro*univol * univol)
    k_baro = get_kinetic_baro(p_baro_tmp_m)
    pot_baro = 0.5d0 * get_potential_baro()
    p_baro(:,:) = p_baro_tmp(:,:) - 0.5d0 * dtio * s_thermo *            &
    & (dudmetric(:,:) + 2.d0 * factor(:,:)*(-p33(:,:)+p_baro33(:,:) +   &
    &  metric_inv(:,:)*(pot_baro - k_baro)))
    endif

    !eq(18i)
    call convert_coords(natm,forc_l,altv,forc_l_lattice)
    p_l_lattice(:,:) = p_l_lattice(:,:) + 0.5d0 * dtio * s_thermo * forc_l_lattice(:,:)
  end subroutine second_half

end subroutine m_UnitCell_md

end module m_UnitCell

logical function unitcell_can_change()
  use m_Control_Parameters, only : sw_optimize_lattice,imdalg,sw_stress_correction
  use m_Const_Parameters, only : ON,P_CONTROL, PT_CONTROL
  use m_Stress, only : m_Stress_in_correction
  implicit none
  if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL) then
     unitcell_can_change = .true.
     return
  endif
!  if(m_Stress_in_correction()) then
!     unitcell_can_change = .true.
!     return
!  endif
  if(sw_stress_correction==ON)then
    unitcell_can_change = .true.
    return
  endif
  unitcell_can_change = sw_optimize_lattice==ON
end function unitcell_can_change

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 614 $)
!
!  SUBROUINE:  check_gncpp_type, PP_construction_paramset
!             PseudoPotential_Construction, PseudoPotential_ek
!
!  AUTHOR(S): T. Yamasaki and M. Okamoto   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! =====================================================================
!   patch 10.1 by K. Tagami@adv    2011/06/18
!
!   patch 10.1:  allocation of vec_q_plus_G_LR etc for TDDFT
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef FJ_TIMER
#   define FJ_TIMER_START(a)  call timer_sta(a)
#   define FJ_TIMER_STOP(a)   call timer_end(a)
#else
#   define FJ_TIMER_START(a)
#   define FJ_TIMER_STOP(a)
#endif
subroutine PseudoPotential_Construction
! $Id: PseudoPotential_Construction.F90 614 2020-05-07 03:24:24Z jkoga $
  use m_PseudoPotential,      only : m_PP_alloc0_ps_ntyp,   m_PP_alloc_ps_ntyp &
       &                           , m_PP_dealloc_ps_ntyp  &
       &                           , m_PP_set_mmesh,        m_PP_set_nloc &
       &                           , m_PP_set_m_non0_lmtxlmt &
       &                           , m_PP_alloc_ps0,        m_PP_alloc_psc_qitg_rhpcg &
       &                           , m_PP_alloc_ps,         m_PP_check_gncpp_type &
! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
       &                           , m_PP_vanderbilt_type &
       &                           , m_PP_local_part_3D      &
       &                           , m_PP_partial_core_CD_3D &
       &                           , m_PP_rd_PP_parameters_3D &
       &                           , m_PP_wd_schgpc,        m_PP_make_index_lmtt_2_dl2p &
       &                           , m_PP_make_index_lmtt_phi &
       &                           , m_PP_make_index_lmtt_add &
       &                           , m_PP_make_index_lmtt_pao &
       &                           , m_PP_wd_variables,     m_PP_dealloc_ps &
       &                           , m_PP_rd_betar &
       &                           , m_PP_make_qorb, iflag_ft &
       &                           , m_PP_cnstrct_crotylm &
       &                           , flg_paw, m_PP_rd_PAW_parameters &
       &                           , m_PP_cnstrct_crotylm_paw &
       &                           , m_PP_check_file_format
  use m_PseudoPotential,      only : nlmta,nlmt,lmta,ilmt
  use m_Parallelization,      only : m_Parallel_init_mpi_nlmta_3D
  use m_Parallelization,      only : m_Parallel_init_mpi_kngp_exx
  use m_PseudoPotential, only : ae_wavefunctions_are_detected
  use m_PseudoPotential, only : m_PP_alloc_qitg_wan, m_PP_set_dk_wan &
                              , m_PP_alloc_qitg_fef, m_PP_set_dk_fef
  use m_Wannier,         only : nwght,ghat
  use m_Crystal_Structure,  only :  rltv

  use m_Const_Parameters,     only : INITIAL,CONTINUATION &
       &                           , FIXED_CHARGE,FIXED_CHARGE_CONTINUATION &
       &                           , ON, OFF, by_pseudo_atomic_orbitals, ALL_AT_ONCE, pp_CIAOPP, pp_PAW
  use m_Kpoints,              only : kv3, vkxyz, mp_index
  use m_NonLocal_Potential,   only : m_NLP_alloc_snl  &
                                   , m_NLP_betar_dot_PWs_diff_3D,  m_NLP_betar_dot_PWs_3D &
       &                           , m_NLP_rd_snl_3D &
       &                           , m_NLP_alloc_phig, m_NLP_phir_dot_PWs_3D &
       &                           , m_NLP_alloc_snl_add, m_NLP_add_betar_dot_PWs_3D &
       &                           , m_NLP_alloc_paog, m_NLP_paor_dot_PWs_3D &
       &                           , m_NLP_build_snl_in_rspace, m_NLP_alloc_betar_optimized
  use m_Ionic_System,         only : ityp, natm
  use m_Ionic_System,         only : ntyp, iatomn, ivan
  use m_Control_Parameters,   only : paramset,icond,istress,evaluation_eko_diff &
       &                           , sw_orb_popu, sw_use_add_proj &
       &                           , sw_phonon, sw_calc_force, ipripp, ipriparallel &
       &                           , num_projectors, projector_type, intzaj &
       &                           , sw_wannier, sw_berry_phase, corecharge_cntnbin, sw_fef &
       &                           , ekmode, fixed_charge_k_parallel, continuation_using_ppdata &
       &                           , m_CtrlP_set_ppprinted,sw_rspace, sw_rspace_hyb, sw_hybrid_functional &
       &                           , sw_ldos, sw_rspace_ldos, m_CtrlP_rspace_integ_all_OK,nmax_G_hyb
  use m_PlaneWaveBasisSet,    only : kgp,gr_l,ngshell,ngshell_range
  use m_Const_Parameters,     only : OLD,ON, SPHERICAL_HARMONICS, NO
  use m_Files,                only : m_Files_open_ps_files,m_Files_close_ps_files,nfcntn_bin &
       &                           , m_Files_open_nfcntn_bin,nfpot,nfout &
       &                           , F_CNTN_BIN_in_partitioned &
       &                           , m_Files_open_nfcntn_bin_paw, nfcntn_bin_paw &
       &                           , m_Files_open_ps_file, m_Files_close_ps_file
    
  use m_Orbital_Population,   only : m_OP_ilmt_yy,m_OP_crotylm
  use m_FiniteElectricField,  only : numef,elec_id,m_FEF_Constract_of_ftq

  use m_PAW_ChargeDensity,    only : m_PAWCD_init_surf_integration
  use m_PAW_XC_Potential,     only : m_PAW_XC_alloc_vxc
  use m_Charge_Density,       only : m_CD_alloc_chgsoft
#ifdef FJ_TIMER
  use m_Parallelization,      only : mpi_comm_group
#endif
! =================================== addded by K. Tagami =============== 5.0
  use m_Control_Parameters,   only : sw_mix_charge_hardpart
! ======================================================================= 5.0
  use m_Control_Parameters,   only : sw_hybrid_functional,m_CtrlP_set_hybrid_parameters
! ======================== Added by K. Tagami ================ 10.1
  use m_Control_Parameters,        only : sw_LinearResponse
  use m_PseudoPotential,           only : norm_q_plus_G_LR, &
       &                                  vec_q_plus_G_LR
!
  use m_LinearResponse_Qpt, only : m_LR_alloc_Vecs_q_plus_G, &
       &                           m_LR_set_Vecs_q_plus_G, &
       &                           m_LR_alloc_Qitg
! ============================================================ 10.1

! ============================== added by K. Tagami ============= 11.0
  use m_Control_Parameters,    only : noncol
  use m_PseudoPotential,    only : pot_has_soc, m_PP_check_spinorbit
! =============================================================== 11.0

! === KT_add === 2014/08/01
  use m_Orbital_QuantumNum,  only : m_OP_Qnum_init, m_OP_Qnum_read_orbital_index &
       &                          , m_OP_Qnum_orb_ind_data_num,m_OP_Qnum_read_orbital_index_it  &
       &                          , m_OP_Qnum_alloc_orb_ind_data
! ============== 2014/08/01

  use m_Realspace, only : m_RS_resolve_mesh_soft,m_RS_resolve_mesh_hard, m_RS_build_qr_clm_ylm

  use m_ES_ExactExchange, only : m_ES_EXX_set_nmax_G_hyb

  use m_FFT, only : fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara

! ==== KT_add === 2014/09/19
  use m_Control_Parameters,  only : sw_calc_ekin_density, sw_rspace_ekin_density
! =============== 2014/09/19


  implicit none

  integer       :: it, nfpp, is_gncpp , ierror
  integer  :: iprippd
#ifdef DEBUG_LDOS
  iprippd = 2
#else
  iprippd = ipripp
#endif
!!$#ifdef FJ_TIMER
!!$  integer :: ierr
!!$#endif

! ====================== KT_Test ========================= 12.5Exp
  if(sw_hybrid_functional == ON) then
     call m_CtrlP_set_hybrid_parameters
     call m_ES_EXX_set_nmax_G_hyb
     call m_Parallel_init_mpi_kngp_exx(nfout,ipriparallel,nmax_G_hyb)
  endif
! ======================================================== 12.5Exp

  call m_PP_alloc0_ps_ntyp()
  call m_PP_alloc_ps_ntyp(.true.)
  call PP_construction_paramset                !-(contained here)
  if(paramset) return
  call m_PP_dealloc_ps_ntyp
  call m_PP_alloc_ps_ntyp(.false.)

  call m_PP_alloc_ps0()
  call m_PP_alloc_psc_qitg_rhpcg()
  if(sw_wannier == ON) then
     call m_PP_alloc_qitg_wan(nwght)
     call m_PP_set_dk_wan(mp_index,ghat,rltv)
  end if
  if(sw_fef == ON) then
     call m_PP_alloc_qitg_fef(numef)
     call m_PP_set_dk_fef(mp_index,rltv,elec_id)
  end if

! ================================= Added by K. Tagami ======= 10.1
  if ( sw_LinearResponse == ON ) then
     call m_LR_alloc_Vecs_q_plus_G
     call m_LR_set_Vecs_q_plus_G
!     if ( modnrm == EXECUT ) then
        call m_LR_alloc_Qitg
!     endif
  endif
! ============================================================ 10.1

                                                  FJ_TIMER_START(29)
  if(sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK()) call m_NLP_alloc_snl()
                                                  FJ_TIMER_STOP(29)
  call m_NLP_alloc_snl_add()
  call m_NLP_alloc_phig()
  call m_NLP_alloc_paog()

  if(flg_paw .and. ekmode==ON .and. icond==FIXED_CHARGE) then
     call m_Files_open_nfcntn_bin_paw()
     call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
  end if

  if(sw_phonon == ON .and. sw_calc_force == OFF) return

  if(icond == INITIAL .or. icond == FIXED_CHARGE .or. continuation_using_ppdata == NO) then
!     call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!     if(ierror /= 0) call mpi_stop(nfout)
     call m_PP_alloc_ps()
     nfpp  = 0
     do it = 1, ntyp
        call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
        if(ierror /= 0) call mpi_stop(nfout)
        if(iprippd >= 2) write(nfout,'(" !! PP_Construction: it = ",i3)') it
        if(ivan(it) /= OLD) then
           nfpp = nfpp + 1
           call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
           if(is_gncpp == pp_PAW) then
              ae_wavefunctions_are_detected(nfpp) = .true.
              if(iprippd >= 2) write(nfout,'(" !! AE wavefunction was detected.")')
           end if

! ============================== added by K. Tagami =================== 11.0
           call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
                                                  FJ_TIMER_START(29)
           call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.false.,is_gncpp)
                                                  FJ_TIMER_STOP(29)
! ==================================================================================================
        else if(ivan(it) == OLD) then
!!$        call pseudo_potential_norm_conserving_type(it,nfpkb,nfpd,nfpcc &
!!$            & ,iatomn(it), univol,nfout,ipri)
        endif
                                                  FJ_TIMER_START(29)
        call m_PP_local_part_3D(it,nfout,gr_l,ngshell,ngshell_range)   ! (psloc), ->(vlocr,psc_l,etot1)
        call m_PP_partial_core_CD_3D(nfout,it,gr_l,paramset=.false.)
                                                  FJ_TIMER_STOP(29)
        !                                      -(m_P.P.) epseud_pc, pcc
        call m_Files_close_ps_file(it)
     enddo

     call m_PP_wd_schgpc(nfout)  ! write down schgpc
     call m_PP_make_index_lmtt_2_dl2p(nfout,paramset)
     !           -(m_PseudoPotential) ->lmtt,il2p,lmta,nlmta,nlmtt,dl2p

     if(sw_rspace==ON)then
        !!call m_NLP_resolve_mesh_for_rspace(nfout)
        call m_RS_resolve_mesh_soft(nfout)
     endif
     if (sw_hybrid_functional==ON .and. sw_rspace_hyb==ON ) then
        call m_RS_resolve_mesh_hard(nfout,fft_box_size_CD_exx,fft_box_size_CD_exx_nonpara)
        call m_RS_build_qr_clm_ylm(deriv=.true.,box_size=fft_box_size_CD_exx)
     endif

     if(sw_orb_popu == ON) then
        call m_PP_make_index_lmtt_phi(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_phi,lmta_phi,nlmta_phi,nlmtt_phi
     if(sw_use_add_proj == ON) then
        call m_PP_make_index_lmtt_add(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_add,lmta_add,nlmta_add,nlmtt_add
     if(intzaj == by_pseudo_atomic_orbitals) then
        call m_PP_make_index_lmtt_pao(nfout,paramset)
     end if
     !           -(m_PseudoPotential) ->lmtt_pao,lmta_pao,nlmta_pao,nlmtt_pao
     call m_PP_wd_variables(nfout)

! ========================= ASMS_Test =========================== 12.1
!     if(icond == INITIAL .or. (icond == FIXED_CHARGE .and. ekmode==OFF &
!!!$          & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
!          & .and. fixed_charge_k_parallel == ALL_AT_ONCE) .or. &
!          & (continuation_using_ppdata == NO .and. .not.(icond == FIXED_CHARGE .and. ekmode==ON))) then
!
     if ( icond == INITIAL &
          & .or. ( ( icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION ) &
          &                   .and. ekmode==OFF &
          &                   .and. fixed_charge_k_parallel == ALL_AT_ONCE )&  
          & .or. ( .not. ( (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) &
          &                   .and. ekmode==ON ) &
          &                   .and. continuation_using_ppdata == NO ) ) then
! =============================================================== 12.1
        if(iprippd >= 2) then
           write(nfout,'(" icond  = ",i8)') icond
           write(nfout,'(" ekmode = ",i8)') ekmode
           write(nfout,'(" fixed_charge_k_parallel = ",i8)') fixed_charge_k_parallel
           write(nfout,'(" continuation_using_ppdata = ",i8)') continuation_using_ppdata
        end if
        if(istress == OFF) then
                                                  FJ_TIMER_START(29)
           if(sw_rspace == ON) then
              call m_NLP_alloc_betar_optimized()
              call m_NLP_build_snl_in_rspace(nfout)
           end if

           if(sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK()) then
              call m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl
           end if
                                                  FJ_TIMER_STOP(29)
        else if(istress == ON) then
           call m_NLP_betar_dot_PWs_diff_3D(nfout,kv3,vkxyz) !(kbint_diff) --> snl,snld
        else
           if(iprippd >= 1) write(nfout,'("  istress =",i4," <<PseudoPotential_Construction>>")') istress
           stop ' istress is not 0 or 1'
        endif
        if(iprippd >= 2) write(nfout,'(" sw_orb_popu = ",i8)') sw_orb_popu
        if(sw_orb_popu == ON) then
           if(iprippd >= 2) write(nfout,'(" m_PP_make_qorb")')
           call m_PP_make_qorb(nfout)
           call m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> phig
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if
        if(sw_use_add_proj == ON) then
           call m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl_add
        end if
        if(intzaj == by_pseudo_atomic_orbitals) then
           call m_NLP_paor_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> paog
        end if
        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
     end if
!     if(icond==CONTINUATION.and.flg_paw) then
!         call m_Files_open_nfcntn_bin_paw()
!         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
!     end if
! ============= ASMS_DEBUG =========================== 12.1
!     if(icond==FIXED_CHARGE_CONTINUATION.and.flg_paw) then
!         call m_Files_open_nfcntn_bin_paw()
!         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
!     end if
! ============= ASMS_DEBUG =========================== 12.1
!
! ====== KT_mod ==== 13.0S
!     if( icond == FIXED_CHARGE .and. ekmode==ON ) then
!
     if( ( icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) &
          &  .and. ekmode==ON ) then
! =================13.0S

        call m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl
        if(sw_orb_popu == ON) then
           call m_PP_make_qorb(nfout)
           call m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> phig
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if

        if(sw_use_add_proj == ON) then
           call m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl_add
        end if
        if(intzaj == by_pseudo_atomic_orbitals) then
           call m_NLP_paor_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> paog
        end if

        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
     endif
!
     call m_PP_dealloc_ps
!     call m_Files_close_ps_files
  else if(icond == CONTINUATION .or. icond == FIXED_CHARGE_CONTINUATION) then
!!$  else if(icond == CONTINUATION .or. (icond == FIXED_CHARGE_CONTINUATION .and.ekmode==OFF &
!!$       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)  &
!!$       & .or. (icond == FIXED_CHARGE_CONTINUATION .and. ekmode == ON)) then
     call m_Files_open_nfcntn_bin()
!!$     if(istress == ON) call m_PP_alloc_ps_stress()
     call m_PP_rd_PP_parameters_3D(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned, kgp)
     if(iprippd >= 2) write(nfout,'(" ! PP_parameters were read!")')
     if(icond == CONTINUATION) &
          & call m_NLP_rd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
     if(icond == FIXED_CHARGE_CONTINUATION ) call m_PP_rd_betar(nfcntn_bin) !->betar

!     if(flg_paw) then
!         call m_Files_open_nfcntn_bin_paw()
!         call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
!     end if

     if(sw_orb_popu == ON .or. sw_use_add_proj == ON .or. num_projectors>0 &
          & .or. sw_berry_phase == ON .or. sw_wannier == ON &
          & .or. sw_fef == ON &
          & .or. corecharge_cntnbin == OFF) then
        iflag_ft = OFF
        if(iprippd >= 2) then
           write(nfout,'(" !pp sw_orb_popu     = ",i8)') sw_orb_popu
           write(nfout,'(" !pp sw_use_add_proj = ",i8)') sw_use_add_proj
           write(nfout,'(" !pp num_projectors  = ",i8)') num_projectors
           write(nfout,'(" !pp sw_berry_phase  = ",i8)') sw_berry_phase
           write(nfout,'(" !pp sw_wannier      = ",i8)') sw_wannier
           write(nfout,'(" !pp sw_fef          = ",i8)') sw_fef
           write(nfout,'(" !pp corecharge_cntnbin = ",i8)') corecharge_cntnbin
        end if
!        call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!        if(ierror/=0) call mpi_stop(nfout)
        call m_PP_alloc_ps()
        nfpp  = 0
        do it = 1, ntyp
           call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
           if(ierror/=0) call mpi_stop(nfout)
           if(iprippd >= 2) write(nfout,'(" !! PP_Construction for PDOS: it = ",i3)') it
           if(ivan(it) /= OLD) then
              nfpp = nfpp + 1
              call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
              if(is_gncpp == -2) then
                 !!$is_gncpp = 2
                 ae_wavefunctions_are_detected(nfpp) = .true.
!!$                 if(ipripp >= 2 ) write(nfout,'(" !! AE wavefunction was detected.")')
              end if

! ============================== added by K. Tagami =================== 11.0
              call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
              call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.false.,is_gncpp)
! ==================================================================================================
           else
           end if
!!$ASASASASAS
           call m_PP_partial_core_CD_3D(nfout,it,gr_l,.true.)
!!$ASASASASAS
           call m_Files_close_ps_file(it)
        enddo

        if(sw_orb_popu == ON) then
           call m_PP_make_index_lmtt_phi(nfout,paramset)
           call m_PP_make_qorb(nfout)
           call m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> phig
           call m_PP_cnstrct_crotylm(nfout) !-> crotylm
        end if
        if(sw_use_add_proj == ON) then
           call m_PP_make_index_lmtt_add(nfout,paramset)
           call m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl_add
        end if
        if(num_projectors > 0) then
           call m_OP_ilmt_yy
           call m_OP_crotylm(nfout)
        end if
        call m_PP_dealloc_ps
!        call m_Files_close_ps_files
     end if
  end if

! ==== DEBUG TEST ==== 2020/01/28
  if ( flg_paw ) then
     if ( icond == CONTINUATION .or. icond == FIXED_CHARGE &
          &       .or. icond == FIXED_CHARGE_CONTINUATION ) then
        call m_Files_open_nfcntn_bin_paw()
        call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
     endif
  end if
! ==== DEBUG TEST ==== 2020/01/28

  if(flg_paw) then
     call m_PAWCD_init_surf_integration
     call m_PAW_XC_alloc_vxc

     call m_CD_alloc_chgsoft
     call m_PP_cnstrct_crotylm_paw
! =============================== modified by K. Tagami ================ 5.0
!  end if

  else if ( sw_mix_charge_hardpart == ON ) then
     call m_PAWCD_init_surf_integration
     call m_PP_cnstrct_crotylm_paw
  end if
! ====================================================================== 5.0

  call m_Parallel_init_mpi_nlmta_3D(nfout,ipriparallel &
       & ,nlmta,nlmt,natm,lmta,ntyp,ilmt,ityp) ! -> np_fsri
!!$#endif

! ==== KT_add ==== 2014/08/01
!  call m_Files_open_ps_files(ivan,iatomn,ntyp,ierror)
!  if(ierror /= 0) call mpi_stop(nfout)
!  call m_OP_Qnum_init
!  call m_OP_Qnum_read_orbital_index
!  call m_Files_close_ps_files

  call m_OP_Qnum_init
  do it=1,ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     call m_OP_Qnum_orb_ind_data_num(it)
     call m_Files_close_ps_file(it)
  enddo
  call m_OP_Qnum_alloc_orb_ind_data()
  do it=1,ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     call m_OP_Qnum_orb_ind_data_num(it)
     call m_OP_Qnum_read_orbital_index_it(it)
     call m_Files_close_ps_file(it)
  enddo
! ================ 2014/08/01

contains
  subroutine PP_construction_paramset
!    call m_Files_open_ps_files(ivan, iatomn, ntyp,ierror)
!    if(ierror/=0) call mpi_stop(nfout)
    nfpp = 0
    do it = 1, ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
       if(ierror/=0) call mpi_stop(nfout)
       if(ipripp >= 2) write(nfout,'(" !!PP_construction_paramset: it = ",i3)') it
       if(ivan(it) /= OLD) then
          nfpp = nfpp + 1
           call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
           if(is_gncpp == -2) then
             !!$is_gncpp = 2
             ae_wavefunctions_are_detected(nfpp) = .true.
             if(ipripp >= 2) write(nfout,'(" !! AE wavefunction was detected.")')
           end if

! ============================== added by K. Tagami =================== 11.0
              call m_PP_check_spinorbit( nfpot(nfpp), nfout, pot_has_soc(it) )
! ===================================================================== 11.0

! === m_PP_vanderbilt_type and m_PP_vanderbilt_type_3D look the same!!! by tkato 2011/08/04 ========
                                                  FJ_TIMER_START(29)
           call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr_l,ngshell,ngshell_range,.true.,is_gncpp)
                                                  FJ_TIMER_STOP(29)
! ==================================================================================================
       else if(ivan(it) == OLD) then
!!$        call pseudo_potential_norm_conserving_type(it,nfpkb,nfpd,nfpcc &
!!$             & ,iatomn(it), univol,nfout,ipri)
       endif
           call m_PP_partial_core_CD_3D(nfout,it,gr_l,.true.)
       ! epseud_pc, pcc
       call m_Files_close_ps_file(it)
    enddo
    call m_PP_make_index_lmtt_2_dl2p(nfout,.true.) ! ->nlmt,nlmta,nlmtt
    if(sw_orb_popu == ON) then
       call m_PP_make_index_lmtt_phi(nfout,.true.)    ! ->nlmt_phi,nlmta_phi,nlmtt_phi
    end if
    if(sw_use_add_proj == ON) then
       call m_PP_make_index_lmtt_add(nfout,.true.) ! ->lmtt_add,lmta_add,nlmta_add,nlmtt_add
    end if
    if(intzaj == by_pseudo_atomic_orbitals) then
       call m_PP_make_index_lmtt_pao(nfout,.true.) ! ->lmtt_pao,lmta_pao,nlmta_pao,nlmtt_pao
    end if

    call m_PP_set_mmesh
    call m_PP_set_nloc(nfout)
    call m_PP_set_m_non0_lmtxlmt
!    call m_Files_close_ps_files
    call m_CtrlP_set_ppprinted(ON)
  end subroutine PP_construction_paramset
        
end subroutine PseudoPotential_Construction

subroutine Check_of_Pseudopotential
  use m_Const_Parameters,     only : DP, OLD
  use m_Files,                only : nfout,nfpot &
       &                           , m_Files_open_ps_file, m_Files_close_ps_file
#ifndef ENABLE_ESM_PACK
  use m_Control_Parameters,   only : ipripp &
#else
  use m_Control_Parameters,   only : ipripp, esm_qbac &
#endif
      & , neg,m_CtrlP_set_neg_properly, m_CntrlP_set_neg, m_CntrlP_set_meg
  use m_Crystal_Structure,    only : additional_charge
  use m_Ionic_System,         only : ntyp, iatom, iatomn, ivan, zeta1, qex
  use m_PseudoPotential,      only : m_PP_rd_ival
  use m_Parallelization,      only : mpi_comm_group
  use m_Ionic_System,         only : natm,ionic_charge_atomtyp, ionic_charge_atoms &
       &                           , mag_moment0_atoms_is_defined, ityp, iwei
  implicit none
  include 'mpif.h'                                      ! MPI
  integer :: it, ia, ierror, nfpp
  real(kind=DP),allocatable,dimension(:)   :: ivalt  ! d(ntyp) #valence electrons
  real(kind=DP) :: totch_t, ival
  allocate(ivalt(ntyp))
  nfpp = 0
  do it = 1, ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     if(ierror /= 0) call mpi_stop(nfout)
     if(ipripp >= 2) write(nfout,'(" !! PP_Construction: it = ",i3)') it
     if(ivan(it) /= OLD) then
        nfpp = nfpp + 1
        call m_PP_rd_ival(nfpot(nfpp),it,nfout,ival) ! -> ival
     else if(ivan(it) == OLD) then
     endif

     call mpi_bcast(ival,1,mpi_double_precision,0,mpi_comm_group,ierror)
     ivalt(it) = ival
     call m_Files_close_ps_file(it)
  end do
  totch_t = 0.d0
  do it = 1, ntyp
     totch_t = totch_t + ivalt(it)*iatom(it) + qex(it)
     write(nfout,'(" ## it = ",i5,", ivalt = ",f8.4, " iatom = ",f8.4," qex = ",f8.4)') it, ivalt(it),iatom(it),qex(it)
  end do
  call mpi_bcast(totch_t,1,mpi_double_precision,0,mpi_comm_group,ierror)
#ifdef ENABLE_ESM_PACK
  totch_t = totch_t - esm_qbac
#endif
! ===== KT_add === 2014/06/08
  totch_t = totch_t - additional_charge      ! totch is num. of electrons
! ================ 2014/06/08
#ifdef INIT_CHARGE_ATOM_BY_ATOM
    if ( mag_moment0_atoms_is_defined ) then
       do ia=1, natm
          totch_t = totch_t -ionic_charge_atoms(ia) *iwei(ia)
       end do
    else
       Do ia=1, natm
          it = ityp(ia)
          totch_t = totch_t -ionic_charge_atomtyp(it) *iwei(ia)
       end do
    endif
#else
    Do ia=1, natm
       it = ityp(ia)
       totch_t = totch_t -ionic_charge_atomtyp(it) *iwei(ia)
    end do
#endif

  if(totch_t >= neg*2.0) then
     if(ipripp >= 0) then
        write(nfout,'(" ### Warning(1309): Number of bands(neg) is insufficient:")')
        write(nfout,'("                totch = ",f10.3," >= neg*2.0 = ",f10.3)') totch_t, neg*2.0
     end if
     if(dabs(sum(zeta1)) > 0.d0) then
        call m_CtrlP_set_neg_properly(1.3*totch_t) ! -> neg
     else
        call m_CtrlP_set_neg_properly(totch_t) ! -> neg
     end if
     call m_CntrlP_set_meg(neg)
!!$     call m_CntrlP_set_neg(neg)
     if(ipripp >= 0) then
        write(nfout,'(" ### Reset value of neg = ",i8)') neg
        write(nfout,'("                totch = ",f10.3," <= neg*2.0 = ",f10.3)') totch_t, neg*2.0
     end if
  else
     if(ipripp >= 0) then
        write(nfout,'(" ###  Number of bands(neg) is sufficient:")')
        write(nfout,'("                totch = ",f10.3," < neg*2.0 = ",f10.3)') totch_t, neg*2.0
     end if
  end if

  deallocate(ivalt)
end subroutine Check_of_Pseudopotential


logical function has_uspp()
  use m_Files,                only : nfout, nfpot, m_Files_open_ps_file, m_Files_close_ps_file
  use m_Ionic_System,         only : ntyp, iatomn, ivan
  use m_PseudoPotential,      only : m_PP_alloc0_ps_ntyp, m_PP_alloc_ps_ntyp, m_PP_dealloc &
     &                             , m_PP_vanderbilt_type,m_PP_include_vanderbilt_pot      &
     &                             , m_PP_check_gncpp_type, ae_wavefunctions_are_detected
  use m_Parallelization,      only : ista_kngp, iend_kngp
  use m_Const_Parameters,     only : YES, DP
  implicit none
  include 'mpif.h'                                      ! MPI
  integer :: nfpp,it,iret,istabuf,iendbuf,ierror,is_gncpp
  integer, allocatable, dimension(:,:) :: ngsh
  real(kind=DP), allocatable, dimension(:) :: gr
  call m_PP_alloc0_ps_ntyp()
  call m_PP_alloc_ps_ntyp(.true.)
  has_uspp = .false.
  nfpp = 0
  istabuf = ista_kngp;iendbuf = iend_kngp
  ista_kngp = 1;iend_kngp=1
  allocate(gr(1))
  allocate(ngsh(1,1))
  do it = 1, ntyp
     call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierror)
     if(ierror/=0) call mpi_stop(nfout)
     nfpp = nfpp + 1
     call m_PP_check_gncpp_type(nfpot(nfpp),nfout,is_gncpp)
     if(is_gncpp == -2) then
        ae_wavefunctions_are_detected(nfpp) = .true.
     end if
     call m_PP_vanderbilt_type(nfpot(nfpp),it,nfout,gr,1,ngsh,.true.,is_gncpp,.true.)
     call m_Files_close_ps_file(it)
     iret = m_PP_include_vanderbilt_pot(it) 
     if(iret==YES) then
       has_uspp = .true.   
     endif
  enddo
  deallocate(gr)
  deallocate(ngsh)
  ista_kngp = istabuf
  iend_kngp = iendbuf
  call m_PP_dealloc()
end function has_uspp

subroutine PseudoPotential_ek
  use m_Const_Parameters,     only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, OFF, &
       &                             by_pseudo_atomic_orbitals
  use m_Control_Parameters,   only : icond, sw_orb_popu, sw_pdos, sw_use_add_proj, uvsormode,sw_rspace &
       &                            ,m_CtrlP_rspace_integ_all_OK, intzaj
  use m_Kpoints,              only : kv3, vkxyz, kv3_previous
  use m_NonLocal_Potential,   only : m_NLP_rd_snl_3D, m_NLP_betar_dot_PWs_3D &
       &                           , m_NLP_betar_dot_PWs_diff_3D &
       &                           , m_NLP_phir_dot_PWs_3D &
       &                           , m_NLP_add_betar_dot_PWs_3D &
       &                           , m_NLP_build_snl_in_rspace, m_NLP_alloc_phig &
       &                           , m_NLP_alloc_snl, m_NLP_alloc_snl_add &
       &                           , m_NLP_alloc_paog, m_NLP_paor_dot_PWs_3D
  use m_PseudoPotential,      only : m_PP_alloc_NLP, m_PP_dealloc_NLP, m_PP_betar_calculated
  use m_IterationNumbers,     only : iteration_electronic,nk_in_the_process
  use m_Files,                only : nfout, nfcntn_bin, m_Files_open_nfcntn_bin &
       &                           , F_CNTN_BIN_in_partitioned
! ======================================= Added by K. Tagami ========= 0.2
!!$  use m_Control_Parameters,   only : num_projectors, projector_type, paramset &
!!$       &                           , intzaj, by_pseudo_atomic_orbitals 
!!$  use m_Orbital_Population,   only : m_OP_ilmt_yy,m_OP_crotylm
!!$  use m_PseudoPotential,      only : m_PP_make_qorb, m_PP_cnstrct_crotylm &
!!$       &                           , m_PP_make_index_lmtt_phi &
!!$       &                           , m_PP_make_index_lmtt_add &
!!$       &                           , m_PP_make_index_lmtt_pao &
!!$       &                           , m_PP_alloc_ps, m_PP_dealloc_ps
! =====================================================================
  implicit none

  if(icond == FIXED_CHARGE &
       & .or. (icond == FIXED_CHARGE_CONTINUATION &
       &           .and.( iteration_electronic == 0 .or. kv3_previous /= kv3))) then
     call m_PP_alloc_NLP()

     if ( intzaj == by_pseudo_atomic_orbitals ) then
        call m_NLP_alloc_paog()
        call m_NLP_paor_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> paog
     end if

     if(sw_rspace == ON) then
        call m_NLP_build_snl_in_rspace(nfout)
! ----------- Revised by T.Yamasaki, 1 Aug. 2014 ---------->>
     end if
     if ( sw_rspace/=ON .or. .not. m_CtrlP_rspace_integ_all_OK() ) then
        call m_NLP_alloc_snl()
        call m_NLP_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl
! <<--------------------------------------------------------
     endif
     if ( sw_orb_popu == ON ) then
        call m_NLP_alloc_phig()
        call m_NLP_phir_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> phig
     end if
     if (sw_use_add_proj == ON ) then
        call m_NLP_alloc_snl_add()
        call m_NLP_add_betar_dot_PWs_3D(nfout,kv3,vkxyz) !(kbint) --> snl_add
     end if
     if(uvsormode == OFF) call m_PP_dealloc_NLP()
!!$     if(nk_in_the_process == 3) stop 'PseudoPotential_ek'
  else if(icond == FIXED_CHARGE_CONTINUATION) then
!!$     call m_Files_open_nfcntn_bin()
     call m_NLP_rd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned,kv3)
  end if
end subroutine PseudoPotential_ek

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
  integer, private      :: istat = 0
  integer :: idp, idp2, idp3, nlp, nmp, nnp
  integer :: sw_avoiding_odd_fftbox = ON
  integer :: sw_zero_padding = ON
  real(kind=DP),private,pointer,dimension(:)               :: cfft
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1,cw2,cw3
  real(kind=DP),private,allocatable,dimension(:)           :: trigs_WF, trigs_pWF, trigs_CD
  integer,      private,allocatable,dimension(:)           :: ifax_WF, ifax_pWF, ifax_CD
!
! ------- Positron start
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1_pstrn,cw2_pstrn,cw3_pstrn
  ! ------- Positron end
  real(kind=DP),private,allocatable, dimension(:)          :: ftw
!
  include 'mpif.h'
contains
  subroutine fft_WFCD_work_alloc
    integer :: nid,nnl,nnm,nnn
! ----> work arrays of fft for wave functions
    nid  = fft_box_size_WF(1,0);  nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
    if(ipri >= 1) write(nfout,'(" !!allocation of cw1,cw2,cw3 (fft_WFCD_work_alloc)")')
    if(kimg == 1) then
       allocate(trigs_WF(nnl+2*(nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    else if(kimg == 2) then
       allocate(trigs_WF(2*(nnl+nnm+nnn)), stat=istat)
       allocate(ifax_WF(60), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_ASLFFT")')
    end if
! ------- Positron start
! ----> and work arrays of fft for positron wave functions
    if(sw_positron /= OFF) then
       nid  = fft_box_size_pWF(1,0);  nnl  = fft_box_size_pWF(1,1)
       nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)

       if(ipri >= 1) write(nfout,'(" !!allocation of cw1_pstrn,cw2_pstrn,cw3_pstrn (fft_WFCD_work_alloc)")')
       if(kimg == 1) then
          allocate(trigs_pWF(nnl+2*(nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       else if(kimg == 2) then
          allocate(trigs_pWF(2*(nnl+nnm+nnn)), stat=istat)
          allocate(ifax_pWF(60), stat=istat)
       end if
    end if
! ------- Positron end

! ----> work arrays of ifft for the charge density
    nid = fft_box_size_CD(1,0);  nnl = fft_box_size_CD(1,1)
    nnm = fft_box_size_CD(2,1);  nnn = fft_box_size_CD(3,1)
    if(kimg == 1) then
          allocate(trigs_CD(nnl+2*(nnm+nnn)), stat=istat)
          allocate(ifax_CD(60), stat=istat)
          if(ipri >= 1) write(nfout,'(" !! CD_ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    else
          allocate(trigs_CD(2*(nnl+nnm+nnn)), stat=istat)
          allocate(ifax_CD(60), stat=istat)
       if(ipri >= 1) &
            & write(nfout,'(" !! trigs_CD and ifax_CD have been allocated, ASLFFT <<m_FFT.fft_WFCD_work_alloc>>")')
    end if
  end subroutine fft_WFCD_work_alloc

  subroutine m_FFT_alloc_WF_work
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_WF(1,0);  nnl  = fft_box_size_WF(1,1)
    nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)

    if(kimg == 1) then
       allocate(ftw(nfft), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfft), stat=istat)
    end if
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_pWF(1,0);  nnl  = fft_box_size_pWF(1,1)
    nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)

    if(kimg == 1) then
       allocate(ftw(nfft_pstrn), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfft_pstrn), stat=istat)
    end if
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
       if(istat /= 0 ) then
          if(ipri>=1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_dealloc_WF_work'
             write(nfout,*) 'stat=', istat
          end if
          stop
       end if
    end if
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: nid,nnl,nnm,nnn
    nid  = fft_box_size_CD(1,0);  nnl  = fft_box_size_CD(1,1)
    nnm  = fft_box_size_CD(2,1);  nnn  = fft_box_size_CD(3,1)
    if(kimg == 1) then
       allocate(ftw(nfftp), stat=istat)
    else if(kimg == 2) then
       allocate(ftw(nfftp), stat=istat);
    end if
    allocate(afft_CD(nfftp), stat=istat)
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
    end if
    deallocate(afft_CD, stat=istat)
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset
    integer :: nid,nnl,nnm,nnn
    integer :: nfft_t
    integer :: id_sname = -1
    call tstatc0_begin('m_FFT_setup ',id_sname)


! --- fft_box_size_WF, fft_box_size_pWF ---
    if(ipri >= 1) write(nfout,*) '!FFT_WF = ASLFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_WF(1,1),4) == 2) then
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 4
       else
          fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + 2
       end if
       fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1) + 1
       if(sw_positron /= OFF) then
          if(mod(fft_box_size_pWF(1,1),4) == 2) then
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 4
          else
             fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + 2
          end if
          fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1) + 1
       end if
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_WF(1:3,0) = fft_box_size_WF(1:3,1) + 1
       if(sw_positron /= OFF) then
          fft_box_size_pWF(1:3,0) = fft_box_size_pWF(1:3,1) + 1
       end if
    endif

! --- fft_box_size_CD ---
    if(ipri >= 1) write(nfout,*) '!FFT_CD = ASLFFT <<m_FFT_setup>>'
    if(inversion_symmetry == ON) then  ! kimg == 1
       if(mod(fft_box_size_CD(1,1),4) == 2) then
          fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 4
       else
          fft_box_size_CD(1,0) = fft_box_size_CD(1,1) + 2
       end if
       fft_box_size_CD(2:3,0) = fft_box_size_CD(2:3,1) + 1
    else if(inversion_symmetry == OFF) then ! kimg == 2
       fft_box_size_CD(1:3,0) = fft_box_size_CD(1:3,1) + 1
    endif

    fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
    nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    nfftps = nfftp

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    idp  = fft_box_size_CD(1,0)
    idp2 = fft_box_size_CD(2,0)
    idp3 = fft_box_size_CD(3,0)
    nlp  = fft_box_size_CD(1,1)
    nmp  = fft_box_size_CD(2,1)
    nnp  = fft_box_size_CD(3,1)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    nfft_t = nfft
    if(sw_positron /= OFF .and. nfft_t < nfft_pstrn) nfft_t = nfft_pstrn
    if(.not. paramset) then
       if(kimg == 1) then
          call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated
       else if(kimg == 2) then
          call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated
       end if

! Initialization of the Wave-Function FFT
       if(kimg == 1) then
          if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
             call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
          else
             call m_FFT_alloc_WF_work()   ! <ftw> is allocated
          end if
          allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
          if(istat /= 0) then
             if(ipri >= 1) then
                write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat, 'nfft =', nfft
             end if
             stop
          end if
       else if(kimg == 2) then
          if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
             call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
          else
             call m_FFT_alloc_WF_work()   ! <ftw> is allocated
          end if
          allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
          if(istat /= 0) then
             if(ipri >= 1) then
                write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat, 'nfft =', nfft
             end if
             stop
          end if
       end if

       call init_fft_coefficients_arrays_WF()

       if(kimg == 1) then
          call m_FFT_dealloc_WF_work()
          deallocate(cfft,stat=istat)
          if(istat /= 0 ) then
             if(ipri >= 1) then
                write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat
             end if
             stop
          end if
       else if(kimg == 2) then
          call m_FFT_dealloc_WF_work()
          deallocate(cfft, stat=istat)
          if(istat /= 0 ) then
             if(ipri >= 1) then
                write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat
             end if
             stop
          end if
       end if

! Initialization of the Charge-Density FFT
       call CDFFT_setup()
    endif

    call tstatc0_end(id_sname)

  contains
    subroutine init_fft_coefficients_arrays_WF()
      use m_Parallelization,   only : itask
      integer :: id, nl, nm, nn, ierr
      integer :: id_p, nl_p, nm_p, nn_p
      real(kind=DP) :: ftw(nfft+nfft_pstrn)
      integer :: id2, id3, id_p2, id_p3

      id = fft_box_size_WF(1,0)
      id2 = fft_box_size_WF(2,0)
      id3 = fft_box_size_WF(3,0)

      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         id_p = fft_box_size_pWF(1,0)
         id_p2 = fft_box_size_pWF(2,0)
         id_p3 = fft_box_size_pWF(3,0)
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         call qfr3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
              call qfr3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         endif
      else
         call hfc3fb(nl,nm,nn,cfft,id,id2,id3,0,ifax_WF,trigs_WF,ftw,itask,ierr)
         if(sw_positron /= OFF) then
              call hfc3fb(nl_p,nm_p,nn_p,cfft,id_p,id_p2,id_p3,0,ifax_pWF,trigs_pWF,ftw,itask,ierr)
         end if
      endif
    end subroutine init_fft_coefficients_arrays_WF
  end subroutine m_FFT_setup

  subroutine CDFFT_setup()
    if(kimg == 1) then
       call m_FFT_alloc_CD_box()       ! <ftw> is allocated
    else if(kimg == 2) then
       call m_FFT_alloc_CD_box()       ! <ftw> is allocated
    end if

    call init_fft_coefficients_arrays_CD()
    CD_setup_is_done = YES

    if(kimg == 1) then
       call m_FFT_dealloc_CD_box()
    else if(kimg == 2) then
       call m_FFT_dealloc_CD_box()
    end if
  contains
    subroutine init_fft_coefficients_arrays_CD
      use m_Parallelization,   only : itask
      integer :: id, nl, nm, nn, ierr
      real(kind=DP) :: ftw(nfftp)
      integer :: id2, id3

      !  ---> FFT for Charge density
      id = fft_box_size_CD(1,0)
      id2 = fft_box_size_CD(2,0)
      id3 = fft_box_size_CD(3,0)

      nl = fft_box_size_CD(1,1)
      nm = fft_box_size_CD(2,1)
      nn = fft_box_size_CD(3,1)

      if(kimg == 1) then
         call qfr3fb(nl,nm,nn,afft_CD,id,id2,id3,0,ifax_CD,trigs_CD,ftw,itask,ierr)
      else
         call hfc3fb(nl,nm,nn,afft_CD,id,id2,id3,0,ifax_CD,trigs_CD,ftw,itask,ierr)
      end if
    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    use m_Parallelization,       only : itask
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch
    complex(kind=CMPLDP),pointer,dimension(:) :: cw1_t, cw2_t, cw3_t
    integer :: id, nl, nm, nn, ier1 = 0
    real(kind=DP) :: ftw(nfft)
    integer, dimension(2) :: flag_asl_rfft      = (/-1,  1/)
    integer, dimension(2) :: flag_asl_cfft      = (/ 1, -1/)
    integer :: id2, id3
    integer :: isw

    integer :: id_sname = -1
    if(electron_or_positron == ELECTRON) then
       id = fft_box_size_WF(1,0)
       id2 = fft_box_size_WF(2,0)
       id3 = fft_box_size_WF(3,0)
       nl = fft_box_size_WF(1,1)
       nm = fft_box_size_WF(2,1)
       nn = fft_box_size_WF(3,1)
       cw1_t=>cw1; cw2_t=>cw2; cw3_t=>cw3
    else if(electron_or_positron == POSITRON) then
       id = fft_box_size_pWF(1,0)
       id2 = fft_box_size_pWF(2,0)
       id3 = fft_box_size_pWF(3,0)
       nl = fft_box_size_pWF(1,1)
       nm = fft_box_size_pWF(2,1)
       nn = fft_box_size_pWF(3,1)
       cw1_t=>cw1_pstrn; cw2_t=>cw2_pstrn; cw3_t=>cw3_pstrn
    end if

    if(electron_or_positron == ELECTRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
          if(ipri >= 2) write(nfout,*) 'size(afft)=',size(afft)
          if(ipri >= 2) write(nfout,*) 'isw=',isw
          if(ipri >= 2) write(nfout,*) 'nl,nm,nn,id,id2,id3=',nl,nm,nn,id,id2,id3
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = -flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_WF,trigs_WF,ftw,itask,ier1)
       end if
    else if(electron_or_positron == POSITRON) then
       if(kimg == 1) then
          isw = -flag_asl_rfft(inverse_or_direct)
          call qfr3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       else if(kimg == 2) then
          isw = flag_asl_cfft(inverse_or_direct)
          call hfc3bf(nl,nm,nn,afft,id,id2,id3,isw,ifax_pWF,trigs_pWF,ftw,itask,ier1)
       end if
    end if

    call sxfft_zero_padding(afft,nl,nm,nn,id,id2,id3)

    if (ier1 /= 0) then
       if(ipri>=1) write (nfout,*) ' !!(Error fft) ier1 = ',ier1
       stop
    end if
  end subroutine m_FFT_WF

  subroutine sxfft_zero_padding(afft,nl,nm,nn,nd1,nd2,nd3)
    use m_Const_Parameters, only : DP
    implicit none
    real(kind=DP), intent(out) :: afft(*)
    integer, intent(in) :: nl,nm,nn
    integer, intent(in) :: nd1,nd2,nd3
    integer :: i,j,k,ip
    integer :: nlh,ndh
    integer :: imax
    imax = nd1*nd2*nd3

    if(kimg==1) then
       nlh = nl/2
       ndh = nd1/2
       if(ipri >= 2) write(6,*) 'ASLFFT: nl,ndh=',nlh,ndh
       do j = nlh+2, ndh
          do i = 1, nd2*nn
             ip = ndh*(i-1) + j
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
       do j = nm+1, nd2
          do k = 1, nd3
             do i = 1, ndh
                ip = i + ndh*(j-1) + ndh*nd2*(k-1)
                afft(ip*2-1) = 0.d0
                afft(ip*2) = 0.d0
             end do
          end do
       end do
       do k = nn+1, nd3
          do i = 1, ndh*nd2
             ip = i + ndh*nd2*(k-1)
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
    else if(kimg==2) then
       do j = nl+1, nd1
          do i = 1, nd2*nn
             ip = nd1*(i-1) + j
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
       do j = nm+1, nd2
          do k = 1, nn
             do i = 1, nl
                ip = i + nd1*(j-1) + nd1*nd2*(k-1)
                afft(ip*2-1) = 0.d0
                afft(ip*2) = 0.d0
             end do
          end do
       end do
       do k = nn+1, nd3
          do i = 1, nd1*nd2
             ip = i + nd1*nd2*(k-1)
             afft(ip*2-1) = 0.d0
             afft(ip*2) = 0.d0
          end do
       end do
    end if
 end subroutine sxfft_zero_padding

 subroutine fft_CD_inverse_core(afft_CD)
      use m_Parallelization,   only : itask
      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      integer :: isw, ier1

      if(kimg == 1) then
         isw =  1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw = -1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_inverse_core

 subroutine fft_CD_direct_core(afft_CD)
      use m_Parallelization,   only : itask
      real(kind=DP), intent(inout) :: afft_cd(nfftp)
      integer :: isw, ier1

      if(kimg == 1) then
         isw = -1
         call qfr3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      else if(kimg == 2) then
         isw =  1
         call hfc3bf(nlp,nmp,nnp,afft_CD,idp,idp2,idp3,isw,ifax_CD,trigs_CD,ftw,itask,ier1)
      end if
      call sxfft_zero_padding(afft_CD,nlp,nmp,nnp,idp,idp2,idp3)
 end subroutine fft_CD_direct_core

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 604 $)
!
!  SUBROUINE: constrained_dynamics
!
!  AUTHOR(S): J. Koga March/24/2009 
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************

! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
!!!!!BRANCH_P ORG_Parallel
#ifndef DISABLE_CONSTRAINTS
! ==============================================================================
subroutine constrained_dynamics()
  use m_velocity_verlet, only : m_vv_increment_md_step, m_vv_do_dynamics, &
   &  m_vv_get_curr_md_step
  use m_constraints, only : &
   &  m_cnstr_get_n_reac_coords, m_cnstr_set_reac_coord, &
   &  m_cnstr_get_reac_coords_s
  use m_Control_Parameters, only : printable, icond, icond_org
  use m_Files, only : nfout
  use m_Parallelization, only : nrank_conf, mype_conf, conf_para
  use m_Const_Parameters, only : STREVL_ITERATION,REAC_ITERATION
  use m_PseudoPotential, only : mmesh
  use m_Ionic_System,    only : natm
  use m_Parallelization, only : m_Parallel_init_mpi_paw_3D

  implicit none

  include 'mpif.h'

  integer :: stat
  integer :: ireac,istart,ierr
  logical :: initialization_required
  
  call Preparation(0)                          ! Basis set, symmetry check etc.
  call Preparation_for_mpi(1)     ! mpi
  call PseudoPotential_Construction
  call  m_Parallel_init_mpi_paw_3D(nfout,natm,mmesh)
#ifdef ENABLE_ESM_PACK
  if(initialization_required())then
     call Preparation_for_ESM
  endif
#endif
  call Ewald_and_Structure_Factor
  call Initial_Electronic_Structure

  call Initial_MD_Condition()

  icond=icond_org

!!$  call constrained_dynamics_init(nfout)

  istart=m_cnstr_get_reac_coords_s()
  if(conf_para) istart=1
  reaction_coordinate: do ireac=istart,m_cnstr_get_n_reac_coords()
    if(conf_para.and.mod(ireac-1,nrank_conf)/=mype_conf) cycle reaction_coordinate
    if(m_cnstr_set_reac_coord(ireac)) cycle reaction_coordinate
    md_step: do while(m_vv_increment_md_step())
      if(printable) write(nfout,'(a,i7)') 'entering MD step no. ',m_vv_get_curr_md_step()
      stat=0
      call m_vv_do_dynamics(stat)
      if (stat==1) then ! relaxation converged
        call postproc_md_step(printable,nfout)
        exit md_step
      else if(stat==2)then ! end of program
        call postproc_reac_coord(stat)
        exit reaction_coordinate
      endif
      call postproc_md_step(printable,nfout)
      if(printable) write(nfout,'(a,i7)') 'done MD step no.     ',m_vv_get_curr_md_step()
      call Checkpoint_File(STREVL_ITERATION)
    enddo md_step
    call Stress()
    call postproc_reac_coord(stat)
    call Checkpoint_File(REAC_ITERATION)
  enddo reaction_coordinate

  call mpi_barrier(mpi_comm_world, ierr)

  call finalize()

end subroutine constrained_dynamics

subroutine postproc_md_step(printable,nfout)
  use m_constraints, only : m_cnstr_print_status
  use m_velocity_verlet, only : m_vv_io_per_step,m_vv_get_curr_md_step
  use m_Control_Parameters, only : postproc_frequency
  implicit none
  logical,intent(in) :: printable
  integer, intent(in) :: nfout
  if(printable) write(nfout,'(a)') 'doing post-proc for each MD step'
  call m_cnstr_print_status()
  call m_vv_io_per_step()
  if(postproc_frequency<=0) return
  if(mod(m_vv_get_curr_md_step(),postproc_frequency)==0)then
     call Postprocessing(.true.)
  endif
end subroutine postproc_md_step

subroutine postproc_reac_coord(stat)
  use m_constraints, only : m_cnstr_pp_reac_coords
  implicit none
  integer,intent(in) :: stat
  call m_cnstr_pp_reac_coords(stat)
end subroutine postproc_reac_coord

subroutine finalize()
  use m_routines, only : close_all_opened_files
  implicit none
  call scf_finalize()
  call constrained_dynamics_finalize()
  call close_all_opened_files()
end subroutine finalize

subroutine constrained_dynamics_dump()
  use m_Files, only : F_CNTN, nfcntn
  use m_Parallelization, only : mype
  use m_velocity_verlet, only : m_vv_wd_vv_variables
  use m_constraints, only : m_cnstr_wd_constraints
  implicit none
  if (mype/=0) return
  open(nfcntn,&
& file=F_CNTN,status='unknown',position='append')
  call m_vv_wd_vv_variables(nfcntn)
  call m_cnstr_wd_constraints(nfcntn)
  close(nfcntn)
end subroutine constrained_dynamics_dump

subroutine constrained_dynamics_finalize()
  use m_velocity_verlet, only : m_vv_finalize
  use m_constraints, only : m_cnstr_finalize
  use m_variables_for_atoms, only : m_vfa_dealloc
  implicit none
  call constrained_dynamics_dump()
  call m_vv_finalize()
  call m_cnstr_finalize()
  call m_vfa_dealloc()
end subroutine constrained_dynamics_finalize

subroutine constrained_dynamics_init(nfout)
  use m_variables_for_atoms, only : m_vfa_alloc_atoms
  use m_variables_for_dynamics, only : m_vfd_init
  use m_Files, only :  F_ZAJ_in, F_CNTN_in, F_CNTN_BIN_in, F_CHGT_in &
 &   , F_ZAJ,F_CNTN,F_CNTN_BIN,F_CHGT, nfinp, F_INP, nfcntn, open0
  use m_Const_Parameters, only : QUENCHED_MD, T_CONTROL, VERLET, DAMPED_MD, CONTINUATION, INITIAL &
 &   , formatted, check_file_name_on, old, ON, VELOCITY_SCALING
  use m_constraints, only : m_cnstr_constraints_exist, m_cnstr_initialize, &
 &      m_cnstr_parse_input, m_cnstr_rd_constraints, &
 &      F_ZAJ_org, F_CNTN_BIN_org, F_CNTN_org, F_CHGT_org
  use m_velocity_verlet, only : m_vv_init, m_vv_parse_input, &
 &      m_vv_rd_vv_variables
  use m_Parallelization, only : conf_para, sw_wdir, workdir
  use m_Control_Parameters, only: icond,imdalg,printable
  implicit none
  integer, intent(in) :: nfout
  integer ::  f_selectTop, f_selectBlock, f_openInputFile, f_closeInputFile
  integer :: iiret,i
  logical :: ex,op
  logical, allocatable, dimension(:) :: ltmp
  logical, allocatable, dimension(:) :: ltmp0
  character(len=2) :: cid
  character(len=2) :: cid_tmp
  integer :: mpierr
  integer :: ifile
  integer :: nline
  logical :: statfile_exists
  integer :: ireac
  logical :: fin

  include 'mpif.h'

  call m_vfa_alloc_atoms()
  call m_vfd_init()

  inquire(unit=nfinp,opened=op)
  if(op)close(nfinp,status='keep')
  if(sw_wdir == ON) then
    iiret = f_openInputFile(trim(workdir)//F_INP)
  else
    iiret = f_openInputFile(F_INP)
  end if
  if( iiret < 0) then
    if(printable) write(nfout,'(" !!! Error in opening of inputfile: ",a32)') F_INP
    stop
  else if(iiret > 0) then
    if(printable) write(nfout,'(" !!! There is something wrong in the input file: ",a32)') F_INP
  end if

  iiret = f_selectTop()
  iiret = f_selectBlock('structure')

  call m_cnstr_parse_input()
  if(m_cnstr_constraints_exist()) call m_cnstr_initialize()


  call m_vv_init()
  call m_vv_parse_input()

  iiret = f_selectTop()

  if(imdalg.ne.QUENCHED_MD.and. &
  &  imdalg.ne.T_CONTROL  .and. &
  &  imdalg.ne.VERLET     .and. &
  &  imdalg.ne.DAMPED_MD  .and. &
  &  imdalg.ne.VELOCITY_SCALING) then
    if(printable) write(nfout,'(a,i5,a)') '**WARN imdalg :      ',imdalg, &
                  ' not implemented (yet) for the constraints driver'
    if(printable) write(nfout,'(a,i5)')   '**WARN defaults to : ',QUENCHED_MD
    imdalg = QUENCHED_MD
    !!$stop
  endif

  F_ZAJ_org      = F_ZAJ_in
  F_CNTN_org     = F_CNTN_in
  F_CNTN_BIN_org = F_CNTN_BIN_in
  F_CHGT_org     = F_CHGT_in

!  iiret = f_closeInputFile()
  call open0(nfinp, F_INP, 'F_INP     ',    old,   formatted,check_file_name_on)

  if(icond==CONTINUATION .and. .not. conf_para)then
    call m_vv_rd_vv_variables(nfcntn,.true.)
    call m_cnstr_rd_constraints(nfcntn)
  endif

end subroutine constrained_dynamics_init

subroutine prepare_continuation_of_reac(nfcntn,sk)
  use m_Files, only : m_Files_reopen_nfcntn
  use m_Ionic_System, only : m_IS_rd_pos_and_v
  use m_velocity_verlet, only : m_vv_rd_vv_variables
  use m_constraints, only : m_cnstr_rd_constraints
  use m_IterationNumbers, only : m_Iter_rd_iteration_numbers
  use m_Total_Energy, only : m_TE_rd_total_energy
  use m_Control_Parameters, only : m_CtrlP_rd_isolver,icond
  implicit none
  integer, intent(in) :: nfcntn
  logical, intent(in) :: sk
  integer :: i
  call m_Files_reopen_nfcntn()
  if(.not.sk)then
  call m_TE_rd_total_energy(nfcntn)
  call m_CtrlP_rd_isolver(nfcntn)
  call m_Iter_rd_iteration_numbers(nfcntn,icond)
  endif
  call m_IS_rd_pos_and_v(nfcntn)
  call m_vv_rd_vv_variables(nfcntn,sk)
  call m_cnstr_rd_constraints(nfcntn)
end subroutine prepare_continuation_of_reac
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
#endif
!!!!!BRANCH_P_END ORG_Parallel
! ==============================================================================

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 1200)
!
!  MODULE: m_Positron_Wave_Functions
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!    Further modification by T. Yamasaki   April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
module m_Positron_Wave_Functions
! $Id: m_Positron_Wave_Functions.F90 472 2015-11-28 09:01:17Z ktagami $
  use m_Const_Parameters, only   : DP,POSITRON,OFF,ON,DIRECT,INVERSE, DELTAevdff, SD, MSD &
       &                         , DENSITY_ONLY, VTK, CUBE, SmallestPositiveNumber, BOHR, PAI
  use m_Control_Parameters, only : af, nspin, npeg,kimg,ipripositron &
       &                         , delta_pev, evaluation_pev_diff &
       &                         , num_extra_pev, sw_gga_p, sw_epsilon_ele, epsilon_ele &
       &                         , sw_positron_file,positron_filetype, positron_title &
       &                         , m_CtrlP_pstrn_ntcnvg_incre &
       &                         , m_CtrlP_pstrn_ntcnvg_reset &
       &                         , m_CtrlP_pstrn_ntcnvg_clear
  use m_IterationNumbers, only :   iteration_positron_wf
  use m_Timing, only :             tstatc0_begin, tstatc0_end
  use m_Files, only :              nfout, nfpstrn, nfvelec, nfeppair, nfeppair2, nfvelec_grad &
       &                         , m_Files_open_nfpstrn, m_Files_open_nfvelec &
       &                         , m_Files_open_nfeppair,m_Files_open_nfeppair2 &
       &                         , m_Files_open_nfvelec_grad &
       &                         , m_Files_close_nfpstrn,m_Files_close_nfvelec &
       &                         , m_Files_close_nfeppair,m_Files_close_nfeppair2 &
       &                         , m_Files_close_nfvelec_grad
  use m_Crystal_Structure, only  : univol
  use m_PlaneWaveBasisSet, only  : kg_pwf, kg1_pwf, igf_pstrn, igfp_l, igfp_nonpara &
       &                         , m_pwBS_pstrn_kinetic_energies
!!  use m_Electronic_Structure,only: vlhxc_l
  use m_Parallelization, only :    mype, npes, ista_kngp, iend_kngp &
       &                         , ista_sfftph, iend_sfftph, ierr, mpi_comm_group
  use m_FFT, only   :              nfft, nfftp, nfftp_nonpara, nfft_pstrn, fft_box_size_pWF &
       &                         , fft_box_size_CD, fft_box_size_CD_nonpara &
       &                         , m_FFT_alloc_pWF_work, m_FFT_dealloc_WF_work &
       &                         , m_FFT_alloc_CD_box, m_FFT_dealloc_CD_box &
       &                         , m_FFT_Vlocal_pW &
       &                         , m_FFT_W_Vlocal_W &
       &                         , m_FFT_WF, m_FFT_CD_inverse0 &
       &                         , m_FFT_coef_CD_integration
  use m_Crystal_Structure,  only : altv
  use m_Ionic_System,         only : ntyp,ityp,zfm3_l,natm2, iatomn &
       &                         , m_IS_pack_all_ions_in_uc
  use m_epc_potential, only      : tchgr_l, grad_tchgr_l, vlhxc_p
  use m_PseudoPotential, only    : rhchg_l, ival

  implicit none
  include 'mpif.h'

  real(kind=DP),allocatable,dimension(:,:,:) :: pzaj   ! positron wave functions d(kg1_pwf,npeg,kimg)
  real(kind=DP),allocatable,dimension(:,:,:) :: pzaj_old ! d(kg1_pwf,npeg,kimg)
  real(kind=DP),allocatable,dimension(:,:) ::   pchg_l ! positron charge in g-space, d(ista_kngp:iend_kngp,kimg)
  real(kind=DP),allocatable,dimension(:,:) ::   pchgo_l ! positron charge in g-space, d(ista_kngp:iend_kngp,kimg)
  real(kind=DP),allocatable,dimension(:) ::     pchr_l ! positron charge in r-space, d(ista_sfftph:iend_sfftph)
  integer, allocatable, dimension(:) ::         npeordr, nprvf_ordr !d(npeg)
  real(kind=DP),allocatable,dimension(:) ::     pev, pev1   ! d(npeg)
  real(kind=DP),private,allocatable,dimension(:) :: pevdff !d(3)

!!$  real(kind=DP),private,allocatable,dimension(:,:,:) :: vlhepc_l !d(ista_kngp:iend_kngp,kimg,nspin)
  real(kind=DP),private,allocatable, dimension(:) ::  afft, bfft, ekin, afft_mpi
  real(kind=DP),private,allocatable, dimension(:) ::  p
  real(kind=DP),private::valence_annihilation_rate,core_annihilation_rate
  real(kind=DP),private::valence_annihilation_rate_down,valence_annihilation_rate_total
  real(kind=DP),private::p_new_lifetime,p_new_lifetime_down,p_new_lifetime_total &
       &                ,p_old_lifetime,p_core_rate,p_core_rate_down

contains
  subroutine m_pWF_construct_pcharge()
    allocate(afft(nfft_pstrn)); allocate(bfft(nfft_pstrn))
    call m_FFT_alloc_pWF_work()
    pchg_l = 0.d0
    call m_pWF_WF_in_Rspace(npeordr(1),bfft)
    call pdensity() ! bfft -> afft
!!$    call m_FFT_pWF(nfout,afft,DIRECT,OFF) !  R-space -> G-space
    call m_FFT_WF(POSITRON, nfout,afft,DIRECT,OFF) !  R-space -> G-space
    call substitute_pCD_for_pchg()
    deallocate(afft); deallocate(bfft)
    call m_FFT_dealloc_WF_work()
  contains
    subroutine pdensity()
      integer :: i
      do i = 1, nfft_pstrn, 2
         afft(i) = bfft(i)**2 + bfft(i+1)**2
      end do
    end subroutine pdensity

    subroutine substitute_pCD_for_pchg()
      integer :: i, ri, i1, iend
      real(kind=DP) :: fac
      fac = 2.d0/(univol*product(fft_box_size_pWF(1:3,1)))
      do ri = 1, kimg
         iend = iend_kngp
         if( iend_kngp > kg_pwf) iend = kg_pwf
         if( ista_kngp <= iend ) then
            do i = ista_kngp, iend
               i1 = kimg*igf_pstrn(i) + (ri-kimg)
               pchg_l(i,ri) = afft(i1)*fac
            end do
         end if
      end do
#ifdef SINGLE_POSITRON
      if ( nspin == 1 ) pchg_l = pchg_l /2.0d0
#endif
    end subroutine substitute_pCD_for_pchg

  end subroutine m_pWF_construct_pcharge

  subroutine m_pWF_charge_rspace()
    integer :: i, j, ip

    call m_FFT_alloc_CD_box();    allocate(afft(nfftp_nonpara))
    if(npes >= 2) allocate(afft_mpi(nfftp_nonpara))

    afft = 0.d0
    do j = 1, kimg
       do i = ista_kngp, iend_kngp ! for mpi
#ifdef _MPIFFT_
          ip = (igfp_nonpara(i)-1)*kimg + j
#else
          ip = (igfp_l(i)-1)*kimg + j
#endif
          afft(ip) = afft(ip) + pchg_l(i,j)
       end do
    end do

    if(npes >= 2) then
       call mpi_allreduce(afft,afft_mpi,nfftp_nonpara,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       afft = afft_mpi
    endif
    call m_FFT_CD_inverse0(nfout,afft)
    call cp_afft_to_pchr_l()             ! afft -> pchr_l

    call m_pWF_core_annihilation()
    call m_pWF_valence_annihilation()
    if(npes >=2) deallocate(afft_mpi)
    deallocate(afft);  call m_FFT_dealloc_CD_box()
  contains
    subroutine cp_afft_to_pchr_l()
      integer :: i
      do i = ista_sfftph, iend_sfftph
         pchr_l(i) = afft(i*2-1)
      end do
    end subroutine cp_afft_to_pchr_l
  end subroutine m_pWF_charge_rspace

  subroutine m_pWF_copy_pzaj_to_pzaj_old()
    pzaj_old = pzaj
  end subroutine m_pWF_copy_pzaj_to_pzaj_old

  subroutine m_pWF_allocate_pzaj_etc()
    integer :: ib
    allocate(pzaj(kg1_pwf,npeg,kimg))
    allocate(pzaj_old(kg1_pwf,npeg,kimg))
    allocate(npeordr(npeg))
    allocate(nprvf_ordr(npeg))
    npeordr(1:npeg) = (/(ib,ib=1,npeg)/)
    nprvf_ordr(1:npeg) = (/(ib,ib=1,npeg)/)
    allocate(pev(1:npeg))
    allocate(pev1(1:npeg)); pev1 = 0.d0
    allocate(pevdff(3))
    allocate(pchg_l(ista_kngp:iend_kngp,kimg))
    allocate(pchgo_l(ista_kngp:iend_kngp,kimg))
    allocate(pchr_l(ista_sfftph:iend_sfftph))
  end subroutine m_pWF_allocate_pzaj_etc

  subroutine m_pWF_deallocate_pzaj_etc()
    if(allocated(pchr_l)) deallocate(pchr_l)
    if(allocated(pchg_l)) deallocate(pchg_l)
    if(allocated(pchgo_l)) deallocate(pchgo_l)
    if(allocated(pevdff)) deallocate(pevdff)
    if(allocated(pev)) deallocate(pev)
    if(allocated(pev1)) deallocate(pev1)
    if(allocated(nprvf_ordr)) deallocate(nprvf_ordr)
    if(allocated(npeordr)) deallocate(npeordr)
    if(allocated(pzaj_old)) deallocate(pzaj_old)
    if(allocated(pzaj)) deallocate(pzaj)
  end subroutine m_pWF_deallocate_pzaj_etc

  subroutine m_pWF_alloc_afft_etc()
    allocate(afft(nfft_pstrn))
    allocate(bfft(nfft_pstrn))
    allocate(ekin(kg1_pwf))
    call m_FFT_alloc_pWF_work()
  end subroutine m_pWF_alloc_afft_etc

  subroutine m_pWF_dealloc_afft_etc()
    deallocate(afft,bfft,ekin)
    call m_FFT_dealloc_WF_work()
  end subroutine m_pWF_dealloc_afft_etc

  subroutine m_pWF_IW_by_randomnumbers()
    real(kind=DP)   :: a,b,p,xn
    data a,b,p/32771.d0,1234567891.d0,2147483648.d0/

    integer :: iimg, ieg, i
    integer :: id_sname = -1
    call tstatc0_begin('m_pWF_IW_by_randomnumbers ',id_sname)

    if(ipripositron >= 2) then
       write(nfout,*)
       write(nfout,'(" <<< m_pWF_IW_by_randomnumbers >>>")')
    end if

    pzaj = 0.d0

    xn = 0.d0
!!$    do iimg = 1, kimg
    do iimg = 1, 1
       do ieg = 1, npeg
          do i = 1,  kg1_pwf
             xn = mod(xn*a+b,p)
             pzaj(i,ieg,iimg) = xn/p
          enddo
       enddo
    enddo

    call tstatc0_end(id_sname)
  end subroutine m_pWF_IW_by_randomnumbers

  subroutine m_pWF_renew_WF_by_SDorCG(nfout,isolver,precon,dtim)
    integer, intent(in) ::       nfout,isolver,precon
    real(kind=DP), intent(in) :: dtim
    integer :: is, ib
    real(kind=DP) :: vlhxc0

    call m_pWF_alloc_afft_etc()
    allocate(p(kg1_pwf))

    call m_pwBS_pstrn_kinetic_energies(ekin)
!!$    do is = 1, nspin, af+1
    is = 1
       if(isolver == MSD) call vlhxc_p_zero_term(vlhxc0,is)
       call Vlocal_in_Rspace(is,afft)
       if(isolver == SD) then
          do ib = 1, npeg
             call m_pWF_WF_in_Rspace(ib,bfft)
             call m_FFT_Vlocal_pW(afft,bfft)
!!$             call m_FFT_pWF(nfout,bfft,DIRECT,ON)
             call m_FFT_WF(POSITRON,nfout,bfft,DIRECT,ON)
             call steepest_descent_p(precon,ib,dtim,ekin,bfft,p)
          end do
       else if(isolver == MSD) then
          do ib = 1, npeg
             call m_pWF_WF_in_Rspace(ib,bfft)
             call m_FFT_Vlocal_pW(afft,bfft)
!!$             call m_FFT_pWF(nfout,bfft,DIRECT,ON)
             call m_FFT_WF(POSITRON,nfout,bfft,DIRECT,ON)
             call modified_sd_p(precon,ib,dtim,vlhxc0,ekin,bfft,p)
          end do
       end if
       call m_pWF_modified_gram_schmidt()
!!$    end do

    call m_pWF_energy_eigen_values()
    call m_pWF_sort_eigen_values()
    call m_pWF_wd_pev(nfout)

    deallocate(p)
    call m_pWF_dealloc_afft_etc()
  contains
    subroutine vlhxc_p_zero_term(vlhxc0,ispin)
      real(kind=DP), intent(out) :: vlhxc0
      integer, intent(in)        :: ispin
      
      if(mype == 0) vlhxc0 = vlhxc_p(1,1,ispin)
      call mpi_bcast(vlhxc0,1,mpi_double_precision,0,mpi_comm_group,ierr)
    end subroutine vlhxc_p_zero_term
  end subroutine m_pWF_renew_WF_by_SDorCG

  subroutine m_pWF_evolve_WFs_again(nfout,mode,dtim_old,dtim_new)
    integer, intent(in) :: nfout, mode ! ! mode = {ORTHONORMALIZATION | NORMALIZATION}
    real(kind=DP), intent(in) :: dtim_old, dtim_new
    integer :: is

    call m_pWF_alloc_afft_etc()
!!$    do is = 1, nspin, af+1
    call evolve_each_pWF_again(dtim_new,dtim_old)
    call m_pWF_modified_gram_schmidt()
!!$    end do
    call m_pWF_energy_eigen_values()
    call m_pWF_sort_eigen_values()
    call m_pWF_dealloc_afft_etc()
  end subroutine m_pWF_evolve_WFs_again

  subroutine evolve_each_pWF_again(dt_new,dt_old)
    real(kind=DP), intent(in) :: dt_new, dt_old
    integer :: ir, ib, ig
    real(kind=DP) :: dtt

    dtt = dt_new/dt_old
    do ir=1,kimg
       do ib=1, npeg
          do ig=1, kg1_pwf
             pzaj(ig,ib,ir) = (1-dtt)*pzaj_old(ig,ib,ir) + dtt*pzaj(ig,ib,ir)
          end do
       end do
    end do
  end subroutine evolve_each_pWF_again
    
  subroutine steepest_descent_p(precon,ib,dtim,ekin,VlocalpW,p)
    integer, intent(in) ::                             precon,ib
    real(kind=DP), intent(in) ::                       dtim
    real(kind=DP), intent(in), dimension(kg1_pwf) ::   ekin
    real(kind=DP), intent(in), dimension(nfft_pstrn) ::VlocalpW
    real(kind=DP),             dimension(kg1_pwf) ::   p

    integer :: i, i1
    real(kind=DP) :: evr,devr,denom,evi,e1,devi

    denom = 1.d0/product(fft_box_size_pWF(1:3,1))
    call decide_precon_factor_p(precon,ib,ekin,p) ! -> p(1:kg1_pwf)

    if(kimg==1) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1)
          devr = (ekin(i) - pev(ib))*evr + VlocalpW(i1)*denom
          pzaj(i,ib,1) = evr - p(i)*dtim*devr
       end do
    else if(kimg==2) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1); evi = pzaj(i,ib,kimg)
          e1 = ekin(i) - pev(ib)
          devr = e1*evr+VlocalpW(2*i1-1)*denom
          devi = e1*evi+VlocalpW(2*i1  )*denom
          pzaj(i,ib,1)    = evr - p(i)*dtim*devr
          pzaj(i,ib,kimg) = evi - p(i)*dtim*devi
       end do
    end if
  end subroutine steepest_descent_p

  subroutine modified_sd_p(precon,ib,dtim,vlhxc0,ekin,VlocalpW,p)
    integer, intent(in) ::                             precon,ib
    real(kind=DP), intent(in) ::                       dtim, vlhxc0
    real(kind=DP), intent(in), dimension(kg1_pwf) ::   ekin
    real(kind=DP), intent(in), dimension(nfft_pstrn) ::VlocalpW
    real(kind=DP),             dimension(kg1_pwf) ::   p

    integer :: i, i1
    real(kind=DP) :: evr,devr,denom,evi,e1,devi, wdi, fdexp

    denom = 1.d0/product(fft_box_size_pWF(1:3,1))
    call decide_precon_factor_p(precon,ib,ekin,p) ! -> p(1:kg1_pwf)

    if(kimg==1) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1)
          devr = (ekin(i) - pev(ib))*evr + VlocalpW(i1)*denom
          wdi = ekin(i) + vlhxc0 - pev(ib)
          if (dabs(wdi) < SmallestPositiveNumber) then
             pzaj(i,ib,1) = -p(i)*devr*dtim + evr
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             pzaj(i,ib,1) = (fdexp - 1) * devr/wdi + evr
          endif
       end do
    else if(kimg==2) then
       do i = 1, kg1_pwf
          i1 = igf_pstrn(i)
          evr = pzaj(i,ib,1); evi = pzaj(i,ib,kimg)
          e1 = ekin(i) - pev(ib)
          devr = e1*evr+VlocalpW(2*i1-1)*denom
          devi = e1*evi+VlocalpW(2*i1  )*denom
          wdi  = ekin(i) + vlhxc0 - pev(ib)
          if (dabs(wdi) < SmallestPositiveNumber) then
             pzaj(i,ib,1) = -p(i)*devr*dtim + evr
             pzaj(i,ib,2) = -p(i)*devi*dtim + evi
          else
             fdexp = dexp( -p(i) * wdi * dtim)
             pzaj(i,ib,1)    = (fdexp -1)*devr/wdi + evr
             pzaj(i,ib,kimg) = (fdexp -1)*devi/wdi + evi
          endif
       end do
    end if
  end subroutine modified_sd_p

  subroutine m_pWF_submat(nfout)
    integer,intent(in) :: nfout
    integer :: is
    real(kind=DP) :: damp = 1.d0

    call m_pWF_alloc_afft_etc()

    call m_pwBS_pstrn_kinetic_energies(ekin)

!!$    do is = 1, nspin, af+1
    is = 1
    call Vlocal_in_Rspace(is,afft)  ! vlhxc_p -> afft
    call evolve_pWFs_in_subspace ! (is,npeg,damp,ekin,afft,bfft)
!!$    end do
    call m_pWF_dealloc_afft_etc()
  contains
    subroutine evolve_pWFs_in_subspace ! (is,npeg,damp,ekin,afft,bfft)
      integer :: ib, i, i1, ib1, ib2, ib2to, ibto, ib1to, m
      real(DP) :: denom, dr1, di1, dr2, di2
      real(DP), allocatable, dimension(:,:,:) :: pzah, pzaj_wk ! d(kg1_pwf,npeg,kimg)
      real(DP), allocatable, dimension(:,:)   :: zmat ! d(npeg*kimg,npeg)
      real(DP), allocatable, dimension(:)     :: w1hw2, eig

      allocate(pzah(kg1_pwf,npeg,kimg)); pzah = 0.d0
      denom = 1.d0/product(fft_box_size_pWF(1:3,1))
      do ib = 1, npeg
         ibto = nprvf_ordr(ib)
         if(ibto > npeg) cycle
         call m_pWF_WF_in_Rspace(ib,bfft)
         call m_FFT_Vlocal_pW(afft,bfft)
         call m_FFT_WF(POSITRON,nfout,bfft,DIRECT,ON)
         if(kimg == 1) then
            do i = 1, kg1_pwf
               i1 = igf_pstrn(i)
               pzah(i,ib,1) = ekin(i)*pzaj(i,ib,1)+bfft(i1)*denom
            end do
         else
            do i = 1, kg1_pwf
               i1 = igf_pstrn(i)
               pzah(i,ib,1) = ekin(i)*pzaj(i,ib,1) + bfft(2*i1-1)*denom
               pzah(i,ib,2) = ekin(i)*pzaj(i,ib,2) + bfft(2*i1  )*denom
            end do
         end if
      end do

      allocate(zmat(npeg*kimg,npeg))
      allocate(w1hw2(npeg*(npeg+1)/2*kimg)); w1hw2 = 0.d0
      allocate(eig(npeg)); eig = 0.d0

      do ib1 = 1, npeg
         if(ib1 > npeg) cycle
         ib1to = npeordr(ib1)
         do ib2 = 1, npeg
            ib2to = nprvf_ordr(ib2)
            if(ib2to > ib1) cycle
            m = ib1*(ib1-1)/2 + ib2to
            if(kimg == 1) then
               do i = 1, kg1_pwf
                  w1hw2(m) = w1hw2(m) + pzah(i,ib1to,1)*pzaj(i,ib2,1)
               end do
            else
               do i = 1, kg1_pwf
                  dr1 = pzah(i,ib1to,1)
                  di1 = pzah(i,ib1to,2)
                  dr2 = pzaj(i,ib2,1)
                  di2 = pzaj(i,ib2,2)
                  w1hw2(2*m-1)=w1hw2(2*m-1)+dr1*dr2+di1*di2
                  w1hw2(2*m  )=w1hw2(2*m  )+dr1*di2-di1*dr2
               end do
            end if
         end do
      end do

      call set_hmat(npeg,w1hw2,zmat)
      deallocate(w1hw2)

      if(kimg==1) then
         call dsyev_driver(npeg,eig,zmat)
      else
         call zheev_driver(npeg,eig,zmat)
      end if

      allocate(pzaj_wk(kg1_pwf,npeg,kimg)); pzaj_wk = 0.d0
      if(kimg == 1) then
         call subspace_rotation_real(1,npeg,pzaj_wk,zmat)
      else
         call subspace_rotation_imag(1,npeg,pzaj_wk,zmat)
      end if
      pzaj = pzaj_wk
      pev = eig
      deallocate(eig)
      deallocate(pzaj_wk)
      deallocate(zmat)
      deallocate(pzah)

     if(ipripositron >= 2) then
        write(nfout,*) ' !pstrn eigen values (pev) <<evolve_pWFs_in_subspace>>'
        write(nfout,'(5x,6f12.5)') (pev(ib1),ib1=1,npeg)
     endif

    end subroutine evolve_pWFs_in_subspace

    subroutine set_hmat(npeg,w1hw2,zmat)
      integer, intent(in) :: npeg
      real(kind=DP), intent(inout) :: w1hw2(*)
      real(kind=DP), intent(out) ::   zmat(npeg*kimg,npeg)
      real(kind=DP), allocatable, dimension(:) :: w1hw2_mpi

      integer :: i,j, m, msize
      msize = npeg*(npeg+1)/2
      if(kimg == 1) then
         do j = 1, npeg
            do i = 1, j
               m = j*(j-1)/2+i
               zmat(i,j)= w1hw2(m)
            end do
         end do
      else
         do j = 1, npeg
            do i = 1, j
               m = j*(j-1)/2+i
               zmat(2*i-1,j) =  w1hw2(2*m-1)
               zmat(2*i,  j) = -w1hw2(2*m)
            end do
         end do
      end if
    end subroutine set_hmat

    subroutine dsyev_driver(ndim,eig,w1hw2)
      integer, intent(in) :: ndim
      real(kind=DP), intent(out), dimension(ndim) :: eig
      real(kind=DP), intent(inout), dimension(ndim,ndim) :: w1hw2
      character(len=1) :: JOBZ,UPLO

      integer :: lda
      integer :: lwork,liwork
      complex(kind=DP),allocatable,dimension(:) :: work
      real(kind=DP),allocatable,dimension(:) :: rwork
      real(kind=DP),allocatable,dimension(:) :: iwork
      integer :: info

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
      JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
      UPLO = 'U'
! (define lwork)

      lwork  = 1 + ndim*(6+2*ndim)
      liwork = 3 + 5*ndim

      allocate(work(lwork)); work = 0.d0
      allocate(iwork(liwork)); iwork = 0.d0

      call dsyevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,iwork,liwork,info)

      deallocate(work)
      deallocate(iwork)

    end subroutine dsyev_driver

    subroutine zheev_driver(ndim,eig,w1hw2)
      integer, intent(in):: ndim
      real(kind=DP), intent(out) ,dimension(ndim) :: eig
      real(kind=DP), intent(inout) ,dimension(ndim*2,ndim) :: w1hw2
      character(len=1) :: JOBZ,UPLO

      integer :: lda
      integer :: lwork,lrwork,liwork
      complex(kind=DP),allocatable,dimension(:) :: work
      real(kind=DP),allocatable,dimension(:) :: rwork
      real(kind=DP),allocatable,dimension(:) :: iwork
      integer :: info

      lda=ndim
!(LAPACK)  JOBZ = N : eigenvalue, V : eigenvalue + eigenvector
      JOBZ = 'V'
!(LAPACK)  UPLO = U : upper triangle matrix,  L : lower triangle matrix
      UPLO = 'U'
      lwork=ndim*(2+ndim)
      lrwork=1+ndim*(5+2*ndim)
      liwork=3+5*ndim

      allocate(work(lwork))
      allocate(rwork(lrwork))
      allocate(iwork(liwork))

      call zheevd(JOBZ,UPLO,ndim,w1hw2,lda,eig,work,lwork,rwork,lrwork,iwork,liwork,info)

      deallocate(work)
      deallocate(rwork)
      deallocate(iwork)

    end subroutine zheev_driver

    subroutine subspace_rotation_real(is,ie,zat_wk,zz)
      integer, intent(in) :: is,ie
      real(kind=DP), intent(out) :: zat_wk(kg1_pwf,npeg,kimg)
      real(kind=DP), intent(in) :: zz(npeg,is:ie)

      integer :: ib1to, ib1, ib2, ii
      do ib2=is,ie
         do ib1=1,npeg
            ib1to=npeordr(ib1)
            do ii=1,kg1_pwf
               zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+zz(ib1,ib2)*pzaj(ii,ib1to,1)
            enddo
         enddo
      enddo
    end subroutine subspace_rotation_real

    subroutine subspace_rotation_imag(is,ie,zat_wk,zz)
      integer, intent(in) :: is,ie
      real(kind=DP), intent(out) :: zat_wk(kg1_pwf,npeg,kimg)
      real(kind=DP), intent(in) :: zz(npeg*kimg,is:ie)
      integer :: ib1to, ib1, ib2, ii
      real(kind=DP) :: dr1, di1, dr2, di2

      do ib2=is,ie
         do ib1=1,npeg
            ib1to = npeordr(ib1)
            dr1=zz(2*ib1-1,ib2)
            di1=zz(2*ib1  ,ib2)
            do ii=1,kg1_pwf
               dr2=pzaj(ii,ib1to,1)
               di2=pzaj(ii,ib1to,2)
               zat_wk(ii,ib2,1)=zat_wk(ii,ib2,1)+dr1*dr2-di1*di2
               zat_wk(ii,ib2,2)=zat_wk(ii,ib2,2)+dr1*di2+di1*dr2
            enddo
         enddo! ib1 loop
      enddo! ib2 loop
    end subroutine subspace_rotation_imag
  end subroutine m_pWF_submat

  subroutine decide_precon_factor_p(precon,ib,ekin,p)
    integer,intent(in) ::                           precon,ib
    real(kind=DP),intent(in),dimension(kg1_pwf)  :: ekin
    real(kind=DP),intent(out),dimension(kg1_pwf) :: p

    integer  :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

    if(precon == ON) then
       call kinetic_energy_p(ib,ekin,ektot)
       d_ektot = 1.d0/ektot
       do i = 1, kg1_pwf
          x = ekin(i)*d_ektot
          x1 = 27 + (18 + (12 + 8*x)*x)*x
          x2 = 16*(x*x)*(x*x)
          p(i) = x1/(x1 + x2)
       end do
    else
       p = 1.d0
    end if
  end subroutine decide_precon_factor_p

  subroutine kinetic_energy_p(ib,dekin,ektot)
    integer, intent(in) :: ib
    real(kind=DP), intent(in), dimension(kg1_pwf) :: dekin
    real(kind=DP), intent(out) ::                    ektot
    integer :: i, ri
    ektot = 0.d0
    do ri = 1, kimg
       do i = 1, kg1_pwf
          ektot = ektot + dekin(i)*pzaj(i,ib,ri)*pzaj(i,ib,ri)
       end do
    end do
  end subroutine kinetic_energy_p
    

  subroutine m_pWF_modified_gram_schmidt()
    integer :: i, ito, nmax
    real(kind=DP) :: fr
    real(kind=DP),pointer, dimension(:,:) :: p1p2
    integer,      pointer, dimension(:)   :: ib2to_a, ib2back_a

    allocate(ib2to_a(npeg), ib2back_a(npeg))
    allocate(p1p2(npeg,kimg))
    do i = 1, npeg
       ito = npeordr(i)
       call WW(ito,fr)
       call normalize_pzaj(ito,fr)
       call substitute_jto_ib2back(i,nmax)
       call W1W2(ito)
       call modify_pzaj(i,ito)
    end do
    deallocate(p1p2,ib2back_a,ib2to_a)

  contains
    subroutine WW(j,fr)
      integer, intent(in) ::        j
      real(kind=DP), intent(out) :: fr

      integer ::       ri, ig
      real(kind=DP) :: fr1, fi1
      if(kimg == 1) then
         fr1 = 0.d0
         do ig = 1, kg1_pwf
            fr1 = fr1 + pzaj(ig,j,1)*pzaj(ig,j,1)
         end do
         fr = fr1
      else
         fr1 = 0.d0; fi1 = 0.d0
         do ig = 1, kg1_pwf
!!$            fr1 = fr1 + pzaj(ig,j,1)**2+pzaj(ig,j,2)**2
            fr1 = fr1 + pzaj(ig,j,1)*pzaj(ig,j,1)
            fi1 = fi1 + pzaj(ig,j,2)*pzaj(ig,j,2)
         end do
         fr = fr1 + fi1
      end if

      if(fr < 0.d0) then
         if(ipripositron >= 1) then 
            write(nfout,'(" i, ito, j = ",3i8)') i, ito, j
            write(nfout,'(" fr = ",d23.10)') fr
            if(kimg == 2) write(nfout,'(" fr1, fi1 = ",2d23.10)') fr1, fi1
         end if
         stop ' fr < 0 <<m_pWF_modified_gram_schmidt.WW>>'
      else
         fr = 1.d0/dsqrt(fr)
      end if
    end subroutine WW

    subroutine normalize_pzaj(ibo,fr)
      integer, intent(in) :: ibo
      real(kind=DP), intent(in) :: fr
      integer :: ri, i
      do ri = 1, kimg
         do i = 1, kg1_pwf
            pzaj(i,ibo,ri) = fr*pzaj(i,ibo,ri)
         end do
      end do
    end subroutine normalize_pzaj

    subroutine substitute_jto_ib2back(i,nmax)
      integer, intent(in)  :: i
      integer, intent(out) :: nmax

      integer              ::jto, j
      jto = 0
      do j = 1, npeg
         if(nprvf_ordr(j) <= i) cycle
         jto = jto + 1
         ib2to_a(jto)  = j
         ib2back_a(j)  = jto
      end do
      nmax = jto
    end subroutine substitute_jto_ib2back

    subroutine W1W2(ito)
      integer, intent(in) :: ito

      real(kind=DP) :: ar, ai
      integer :: jto, j, ia

      p1p2 = 0.d0
      if(kimg == 1) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, kg1_pwf
               p1p2(jto,1) = p1p2(jto,1) + pzaj(ia,ito,1)*pzaj(ia,j,1)
            end do
         end do
      else if(kimg == 2) then
         do jto = 1, nmax
            j = ib2to_a(jto)
            do ia = 1, kg1_pwf
               ar = pzaj(ia,ito,1)
               ai = pzaj(ia,ito,2)
               p1p2(jto,1) = p1p2(jto,1) + ar*pzaj(ia,j,1)+ai*pzaj(ia,j,2)
               p1p2(jto,2) = p1p2(jto,2) + ar*pzaj(ia,j,2)-ai*pzaj(ia,j,1)
            end do
         end do
      end if
    end subroutine W1W2

    subroutine modify_pzaj(i,ito)
      
      integer, intent(in) :: i, ito
      integer :: j, ia, jto
      real(kind=DP) :: sr, si
      do j = 1, npeg
         if(nprvf_ordr(j) <= i) cycle
         jto = ib2back_a(j)
         if(kimg == 1) then
            do ia = 1, kg1_pwf
               pzaj(ia,j,1) = pzaj(ia,j,1) - p1p2(jto,1)*pzaj(ia,ito,1)
            end do
         else if(kimg == 2) then
            do ia = 1, kg1_pwf
               sr = pzaj(ia,ito,1);         si = pzaj(ia,ito,2)
               pzaj(ia,j,1) = pzaj(ia,j,1) - p1p2(jto,1)*sr+p1p2(jto,2)*si
               pzaj(ia,j,2) = pzaj(ia,j,2) - p1p2(jto,1)*si-p1p2(jto,2)*sr
            end do
         end if
      end do
    end subroutine modify_pzaj

  end subroutine m_pWF_modified_gram_schmidt

  logical function m_pWF_pevdff()
    integer :: ib
    real(kind=DP) :: fac, tmp
    if(evaluation_pev_diff == OFF) then
       m_pWF_pevdff = .false.
       return
    end if

    pevdff = 0.d0
    fac = 1.d0/npeg
    do ib = 1, npeg
       if(nprvf_ordr(ib) > npeg- num_extra_pev) cycle
       tmp = pev(ib) - pev1(ib)
       pevdff(1) = pevdff(1) + tmp*tmp
       pevdff(2) = pevdff(2) + dabs(tmp)
       if(dabs(tmp) > DELTAevdff) &
            & pevdff(3) = pevdff(3) + dsqrt(dabs(pev1(ib)**2 - pev(ib)**2))
    end do

    pevdff(1) = dsqrt(fac*pevdff(1))
    pevdff(2) = fac*pevdff(2)
    pevdff(3) = fac*pevdff(3)

    pev1 = pev

    if(ipripositron >= 1) write(nfout,*)'lifetime: ',p_old_lifetime,p_new_lifetime
    if(max(pevdff(1),pevdff(2)) < delta_pev.and. &
         & dabs(p_old_lifetime-p_new_lifetime) < 1.d0  ) then
       ib = m_CtrlP_pstrn_ntcnvg_incre()
       if(ipripositron >= 1) &
            & write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_positron_wf,ib
    else
       call m_CtrlP_pstrn_ntcnvg_reset()
    end if
    if(ipripositron >= 1) &
         & write(nfout,'(" >> (",i6,") <pev_old-pev_new>:(",3d13.5,")")') &
         &    iteration_positron_wf, pevdff(1), pevdff(2), pevdff(3)

    p_old_lifetime=p_new_lifetime
    m_pWF_pevdff = m_CtrlP_pstrn_ntcnvg_clear()

  end function m_pWF_pevdff

  subroutine m_pWF_wd_pev(nf)
    integer, intent(in) :: nf
    integer :: ib

    if(ipripositron >= 1) then
       write(nf,*) '=== positron eigen values ==='
       write(nf,'(99(4f18.10,/))') (pev(npeordr(ib)),ib=1,npeg-num_extra_pev)
       write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
            & (pev(npeordr(ib)),ib=npeg-num_extra_pev+1, npeg)
    end if
  end subroutine m_pWF_wd_pev

!!$  subroutine m_pWF_wd_pev(nfout)
!!$    integer, intent(in) :: nfout
!!$
!!$    integer :: ib
!!$    write(nfout,'(" -- Positron Energy Eigen Values --")')
!!$    write(nfout,'(" ",99(10f8.4,/))') (pev(npeordr(ib)),ib=1,npeg)
!!$  end subroutine m_pWF_wd_pev

  subroutine m_pWF_energy_eigen_values()
    integer :: is, ib
    real(kind=DP) :: eg

!!$    allocate(afft(nfft_pstrn))
!!$    allocate(bfft(nfft_pstrn))
!!$    allocate(ekin(kg1_pwf))
!!$
!!$    call m_FFT_alloc_pWF_work()
    call m_pwBS_pstrn_kinetic_energies(ekin)
!!$    do is = 1, nspin, af+1
    is = 1
       call Vlocal_in_Rspace(is,afft) ! vlhxc_p -> afft
       if(ipripositron >= 3) then
          write(nfout,'(" afft <<m_pWF_energy_eigen_values>>")')
          write(nfout,'( 8f8.4)') (afft(ib),ib=1,100)
       end if
       do ib = 1, npeg
          call m_pWF_W_T_W(ib)  ! -> pev
          call m_pWF_WF_in_Rspace(ib,bfft)
          call m_FFT_W_Vlocal_W(POSITRON,nfft_pstrn,afft,bfft,eg)
          if(ipripositron >= 2) then
             if(ib==1) write(nfout,'(" ---- ib,  pev, eg, pev+eg <<m_pWF_energy_eigen_values>>")')
             write(nfout,'(i5,3f15.7)') ib, pev(ib),eg,pev(ib)+eg
          end if
          pev(ib) = pev(ib) + eg
       end do
!!$    end do

!!$    call m_FFT_dealloc_WF_work()
!!$    deallocate(ekin)
!!$    deallocate(bfft)
!!$    deallocate(afft)
  end subroutine m_pWF_energy_eigen_values

  subroutine m_pWF_sort_eigen_values()
    integer :: ib, jb, ibo, jbo
    real(kind=DP), parameter :: delta = 1.d-12

    npeordr(1:npeg) = (/(ib,ib=1,npeg)/)
    do ib = 1, npeg-1
       do jb = ib+1, npeg
          ibo = npeordr(ib)
          jbo = npeordr(jb)
          if(pev(jbo) < pev(ibo) - delta) then
             npeordr(jb) = ibo
             npeordr(ib) = jbo
          end if
       end do
    end do
    do ib = 1, npeg
       do jb = 1, npeg
          if(ib == npeordr(jb)) then
             nprvf_ordr(ib) = jb
             exit
          end if
       end do
    end do

  end subroutine m_pWF_sort_eigen_values

  subroutine Vlocal_in_Rspace(is,afft)
    integer, intent(in) :: is
    real(kind=DP), intent(out), dimension(nfft_pstrn) :: afft
    integer :: i
    call map_vlhxc_p_to_afft()
    if(ipripositron >= 3) then
       write(nfout,'(" afft <<Vlocal_in_Rspace>>")')
       write(nfout,'( 8f8.4)') (afft(i),i=1,100)
    end if
!!$    call m_FFT_pWF(nfout,afft,INVERSE,OFF)  ! afft -> afft
    call m_FFT_WF(POSITRON,nfout,afft,INVERSE,OFF)  ! afft -> afft
  contains
    subroutine map_vlhxc_p_to_afft()
      integer :: i,i1,ri, iend
      if(npes >= 2)  allocate(afft_mpi(nfft_pstrn))
      afft = 0.d0
      iend = iend_kngp
      if( iend > kg_pwf) iend = kg_pwf
      do ri = 1, kimg
         do i = ista_kngp, iend
            i1 = kimg*igf_pstrn(i) + (ri-kimg)
            afft(i1) = vlhxc_p(i,ri,is)
         end do
      end do
      if(ipripositron >= 3) then
         write(nfout,'(" -- vlhxc_p <<map_vlhxc_p_to_afft>>")')
         do ri = 1, kimg
            write(nfout,'(" kimg = ", i8)') kimg
            write(nfout,'(10f8.4)') (vlhxc_p(i,ri,is),i=ista_kngp,iend)
         end do
      end if
      if(npes >= 2) then
         call mpi_allreduce(afft,afft_mpi,nfft_pstrn &
              & , mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         afft = afft_mpi
      end if
      if(npes >= 2) deallocate(afft_mpi)
    end subroutine map_vlhxc_p_to_afft

  end subroutine Vlocal_in_Rspace

  subroutine m_pWF_W_T_W(ib)
    integer, intent(in) :: ib
    integer :: i, ri
    pev(ib) = 0.d0
    do ri = 1, kimg
       do i = 1, kg1_pwf
          pev(ib) = pev(ib) + ekin(i)*pzaj(i,ib,ri)**2
       end do
    end do
  end subroutine m_pWF_W_T_W

  subroutine m_pWF_WF_in_Rspace(ib,bfft)
    integer, intent(in) :: ib
    real(kind=DP), intent(inout), dimension(nfft_pstrn) :: bfft

    integer :: i,i1,ri
    bfft = 0.d0
    do ri = 1, kimg
       do i = 1, kg1_pwf
          i1 = kimg*igf_pstrn(i) + (ri-kimg)
          bfft(i1) = pzaj(i,ib,ri)
       end do
    end do
!!$    call m_FFT_pWF(nfout,bfft,INVERSE,ON)
    call m_FFT_WF(POSITRON,nfout,bfft,INVERSE,ON)
    if(ipripositron >= 3) then
       write(nfout,'(" bfft <<m_pWF_WF_in_Rspace>>")')
       write(nfout,'( 8f8.4)') (bfft(i),i=1,100)
    end if
  end subroutine m_pWF_WF_in_Rspace

  real(kind=DP) function m_pWF_tell_band_energy()
    integer :: ib
    real(kind=DP) :: eband
    eband = 0.d0
    do ib = 1, npeg
       if(nprvf_ordr(ib) > npeg - num_extra_pev ) cycle
       eband = eband + pev(ib)
    end do
    m_pWF_tell_band_energy = eband
  end function m_pWF_tell_band_energy
 
  subroutine m_pWF_core_annihilation()
    integer :: it, ri, i
    real(kind=DP) :: sss, sss_mpi
!!$    integer :: i, j, ip,idp,mmp,mnp,ipp,k,nlp,nmp,nnp,up_down &
!!$         ,inew,jnew,knew, nlphf,nmesh,n,ri,it
!!$    real(kind=DP) ::fac,fac2
!!$    real(kind=DP),allocatable,dimension(:,:,:) ::wkchr
!!$    real(kind=DP),allocatable,dimension(:,:,:) ::wkchr2
!!$    real(kind=DP),allocatable,dimension(:) ::gr_l
!!$    real(kind=DP),allocatable,dimension(:) ::radr,wos,rhcr,wky,wkx
!!$    real(kind=DP) ::sss,ssk,enhanc,sss1,sss2,gabs
!!$
!!$    rewind 501

    sss=0.d0
    do it=1,ntyp
!!$       read(501,*)nmesh
!!$       allocate(radr(1:nmesh),wos(1:nmesh),rhcr(1:nmesh),gr_l(ista_kngp:iend_kngp))
!!$       allocate(wky(1:nmesh),wkx(1:nmesh))
!!$       read(501,*)radr(1:nmesh)
!!$       read(501,*)wos(1:nmesh)
!!$       read(501,*)rhcr(1:nmesh)
!!$       read(501,*)wky(1:nmesh)
!!$       read(501,*)gr_l(ista_kngp:iend_kngp)
       do ri = 1, kimg
          do i = ista_kngp, iend_kngp 
             sss = sss + rhchg_l(i,it)*pchg_l(i,ri)*zfm3_l(i,it,ri)
          end do
       end do

       if(ipripositron >= 3) then
          if(it == 1) write(nfout,'(" -- rhchg_l, pchgq_l, zfm3_l <<m_pWF_core_annihilation>>")')
          write(nfout,'(" -- it = ",i8)') it
          write(nfout,'(" --- i, rhchg_l pchg_l zfm3_l --")')
          do i = ista_kngp, min(ista_kngp+max(10,20*ipripositron), iend_kngp)
             write(nfout,'(i8,3f20.8)') i, rhchg_l(i,it), pchg_l(i,1), zfm3_l(i,it,1)
          end do
          write(nfout,'(" sss = ",f20.8)') sss
       end if
!!$          gabs = gr_l(i)
!!$          wkx(1:nmesh) = gabs*radr(1:nmesh)
!!$          call dsjnv(0,nmesh,wkx,wky)
!!$          do ri=1,kimg
!!$             do n = 1, nmesh
!!$                fac2=rhcr(n)/radr(n)/4.d0/PAI
!!$                call enhance_0(fac2,enhanc)
!!$                fac = wos(n)*rhcr(n)/univol*enhanc
!!$                sss=sss+fac*wky(n)* pchg_l(i,ri)*zfm3_l(i,it,ri)
!!$!                sss=sss+fac*wky(n)* pchg_l(i,ri)*2.d0
!!$             end do
!!$          enddo
!!$       end do
    enddo

    if(npes >= 2) then
       call mpi_allreduce(sss,sss_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       sss = sss_mpi
    end if
!                       valence_annihilation_rate=sss1
!                       ssk=((BOHR)**3)*1.d4/(2.8d0**2)/3.d0/PAI
!    core_annihilation_rate=sss/dsqrt(4.d0*PAI)
     core_annihilation_rate=sss/2.d0*univol

#ifdef SINGLE_POSITRON
     core_annihilation_rate = sss *univol
#endif

  end subroutine m_pWF_core_annihilation

  subroutine m_pWF_valence_annihilation()
    integer :: i, j, ip,idp,mmp,mnp,ipp,k,nlp,nmp,nnp,up_down &
         & ,inew,jnew,knew, nlphf, nd1,nd2,nd3
  
    real(kind=DP),allocatable,dimension(:)     :: f2or1
    real(kind=DP),allocatable,dimension(:,:,:) :: wkchr
    real(kind=DP),allocatable,dimension(:,:,:) :: wkchr2,wkchr3, wkchr4,wkchr22,wkchr32
    real(kind=DP) ::sss,sss_down,sss_total,ssk,enhanc,sss1,sss2, sss_mpi
    allocate(f2or1(ista_sfftph:iend_sfftph))
    call m_FFT_coef_CD_integration(f2or1)

#ifdef FFTW3
    idp = fft_box_size_CD(1,1)
    mmp = fft_box_size_CD(2,1)
    mnp = fft_box_size_CD(3,1)
#else
    idp = fft_box_size_CD(1,0)
    mmp = fft_box_size_CD(2,0)
    mnp = fft_box_size_CD(3,0)
#endif
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)

    if(sw_positron_file == ON) then

    if(kimg == 1) then
       nlphf = idp/2
    else
       nlphf = idp
    end if

    if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
       nd1 = nlp; nd2 = nmp; nd3 = nnp
    else if(positron_filetype == CUBE) then
       nd1 = nnp; nd2 = nmp; nd3 = nlp
    end if
    allocate(wkchr(nd1,nd2,nd3)); wkchr = 0.d0
    allocate(wkchr2(nd1,nd2,nd3)); wkchr2 = 0.d0
    allocate(wkchr3(nd1,nd2,nd3)); wkchr3 = 0.d0
    if(nspin==2) then
       allocate(wkchr22(nd1,nd2,nd3)); wkchr22 = 0.d0
       allocate(wkchr32(nd1,nd2,nd3)); wkchr32 = 0.d0
    end if
    if(sw_gga_p == ON) then
       allocate(wkchr4(nd1,nd2,nd3)); wkchr4 = 0.d0
    end if

    up_down=1
    do i = 1, nmp
       do j = 1, nnp
          do k = 1,nlp
             if(kimg == 1 .and. k > nlphf) then
                knew = idp - k
                jnew = nnp+2 - j
                inew = nmp+2 - i
                if(jnew > nnp) then
                   jnew = jnew - nnp
                end if
                if(inew > nmp) then
                   inew = inew - nmp
                end if
             else
                knew = k; jnew = j; inew = i
             end if
             ip=nlphf*mmp*(jnew-1) + nlphf*(inew-1) + knew
             if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
!                wkchr(k,i,j) = afft(ip*2-2+up_down)
                wkchr(k,i,j) = afft(ip*2-2+up_down)/2
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) then
                   wkchr2(k,i,j) = tchgr_l(ip,1)
                   if(nspin==2) wkchr22(k,i,j) = tchgr_l(ip,2)
                   if(sw_gga_p == ON) wkchr4(k,i,j) = grad_tchgr_l(ip,1)
                end if
             else if(positron_filetype == CUBE) then
! lin
!             if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then

!                wkchr(k,i,j) = afft(ip*2-2+up_down)
                if(ip*2-2+up_down<1) cycle
                wkchr(j,i,k) = afft(ip*2-2+up_down)/2
                if(ip >= ista_sfftph .and. ip <= iend_sfftph) then
                   wkchr2(j,i,k) = tchgr_l(ip,1)
                   if(nspin==2) wkchr22(j,i,k) = tchgr_l(ip,2)       
                   if(sw_gga_p == ON) wkchr4(j,i,k) = grad_tchgr_l(ip,1)
                end if
! lin
!             end if

             end if
          end do
       end do
    end do
    if(npes>=2)then
       call mpi_allreduce(MPI_IN_PLACE,wkchr2,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(nspin==2) &
         & call mpi_allreduce(MPI_IN_PLACE,wkchr22,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       if(sw_gga_p==ON) then
          call mpi_allreduce(MPI_IN_PLACE,wkchr4,nnp*nmp*nlp,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       end if
    end if
    wkchr3 = 0.d0

    up_down=1

    if(nspin==1) then

    if(sw_epsilon_ele == OFF) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
!!$             if(kimg == 1 .and. k > nlphf) then
!!$                knew = idp - k
!!$                jnew = nnp+2 - j
!!$                inew = nmp+2 - i
!!$                if(jnew > nnp) then
!!$                   jnew = jnew - nnp
!!$                end if
!!$                if(inew > nmp) then
!!$                   inew = inew - nmp
!!$                end if
!!$             else
!!$                knew = k; jnew = j; inew = i
!!$             end if
!!$             ip=nlphf*mmp*(jnew-1) + nlphf*(inew-1) + knew
!!$             wkchr(j,i,k) = afft(ip*2-2+up_down)
!!$             wkchr2(j,i,k) = tchgr_l(ip,1)
!c --------------->
!!$             if(sw_gga_p == ON) then
!!$                call enhance_gga_0(wkchr2(j,i,k)*nspin,wkchr4(j,i,k)*nspin,enhanc)
!!$             else
                call enhance_0(wkchr2(j,i,k)*nspin,enhanc)
!!$             end if
!c <--------------
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    else if(sw_epsilon_ele == ON) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_01(wkchr2(j,i,k)*nspin,enhanc,epsilon_ele)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else if(positron_filetype == CUBE) then
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    end if

    else if(nspin==2) then
    if(sw_epsilon_ele == OFF) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_0(wkchr2(j,i,k)+wkchr22(j,i,k),enhanc)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(k,i,j) = wkchr(k,i,j)*wkchr22(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(j,i,k) = wkchr(j,i,k)*wkchr22(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    else if(sw_epsilon_ele == ON) then
       do i = 1, nmp
          do j = 1, nnp
             do k = 1, nlp
                call enhance_01(wkchr2(j,i,k)+wkchr22(j,i,k),enhanc,epsilon_ele)
                if(positron_filetype == DENSITY_ONLY .or. positron_filetype == VTK) then
                   wkchr3(k,i,j) = wkchr(k,i,j)*wkchr2(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(k,i,j) = wkchr(k,i,j)*wkchr22(k,i,j)/(nnp*nmp*nlp)*univol*enhanc
                else if(positron_filetype == CUBE) then
                   wkchr3(j,i,k) = wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                   wkchr32(j,i,k) = wkchr(j,i,k)*wkchr22(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
                end if
             end do
          end do
       end do
    end if
    end if
!end of seperate the cases of nonmagnetic and magnetic

    end if
!!$      rewind 500
!!$      read(500,*) wkchr2
!!$      sss=0.d0
!!$      sss1=0.d0
!!$      sss2=0.d0
!!$      do j=1,nnp
!!$         do i=1,nmp
!!$            do k=1,nlp
!!$               call enhance_0(wkchr2(j,i,k),enhanc)
!!$               wkchr3(j,i,k)=wkchr(j,i,k)*wkchr2(j,i,k)/(nnp*nmp*nlp)*univol*enhanc
!!$               sss=sss+wkchr3(j,i,k)
!!$               sss1=sss1+wkchr(j,i,k)/(nnp*nmp*nlp)*univol
!!$               sss2=sss2+wkchr2(j,i,k)/(nnp*nmp*nlp)*univol
!!$            enddo
!!$         enddo
!!$      enddo
!!$      write(nfout,'(" (1) sss, sss1, sss2 = ",3f12.4)') sss, sss1, sss2

!!$      write(6,'(" tchgr_l")')
!!$    do i = ista_sfftph, ista_sfftph+10
!!$         write(6,'(i3,f20.8)') i, tchgr_l(i,1)
!!$    end do

   ! wkchr  <- afft
   ! wkchr2 <- tchgr_l
      sss=0.d0
      sss1=0.d0
      sss2=0.d0
      sss_down = 0.d0
      sss_total = 0.d0

    if(nspin == 1) then
      if(sw_epsilon_ele == OFF) then
         do i = ista_sfftph, iend_sfftph
!c --------------->
!!$         if(sw_gga_p == ON) then
!!$            call enhance_gga_0(tchgr_l(i,1)*nspin,grad_tchgr_l(i,1)*nspin,enhanc)
!!$         else
            call enhance_0(tchgr_l(i,1)*nspin,enhanc)
!!$         end if
!c <--------------
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + tchgr_l(i,1)*nspin*f2or1(i)
         end do
      else if(sw_epsilon_ele == ON) then
         do i = ista_sfftph, iend_sfftph
            call enhance_01(tchgr_l(i,1)*nspin,enhanc,epsilon_ele)
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + tchgr_l(i,1)*nspin*f2or1(i)
         end do
      end if
!magnetic system,nspin=2
    else if(nspin==2) then
       if(sw_epsilon_ele == OFF) then
         do i = ista_sfftph, iend_sfftph
!c --------------->
!!$         if(sw_gga_p == ON) then
!!$            call enhance_gga_0(tchgr_l(i,1)*nspin,grad_tchgr_l(i,1)*nspin,enhanc)
!!$         else
            call enhance_0((tchgr_l(i,1)+tchgr_l(i,2)),enhanc)
!!$         end if
!c <--------------
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc     ! up_spin
            sss_down =  sss_down + afft(i*2-1)*tchgr_l(i,2)*nspin*f2or1(i)*enhanc    ! down_spin
            sss_total =  sss_total + afft(i*2-1)*(tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)*enhanc      ! total_spin
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + (tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)
         end do
      else if(sw_epsilon_ele == ON) then
         do i = ista_sfftph, iend_sfftph
            call enhance_01((tchgr_l(i,1)+tchgr_l(i,2)),enhanc,epsilon_ele)
            sss =  sss + afft(i*2-1)*tchgr_l(i,1)*nspin*f2or1(i)*enhanc     ! up_spin
            sss_down =  sss_down + afft(i*2-1)*tchgr_l(i,2)*nspin*f2or1(i)*enhanc    ! down_spin
            sss_total =  sss_total + afft(i*2-1)*(tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)*enhanc      ! total_spin
            sss1 = sss1 + afft(i*2-1)*f2or1(i)
            sss2 = sss2 + (tchgr_l(i,1)+tchgr_l(i,2))*f2or1(i)
         end do
      end if
!end of magnetic system
    end if

      if(npes >= 2) then
         call mpi_allreduce(MPI_IN_PLACE,sss,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         call mpi_allreduce(MPI_IN_PLACE,sss1,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         call mpi_allreduce(MPI_IN_PLACE,sss2,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         if(nspin==2) then
            call mpi_allreduce(MPI_IN_PLACE,sss_down,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
            call mpi_allreduce(MPI_IN_PLACE,sss_total,1,mpi_double_precision,mpi_sum, mpi_comm_group,ierr)
         end if
      end if
      if(nspin == 1) then
         sss_down = sss
         sss_total = sss
      end if

      sss  = sss/(nnp*nmp*nlp)*univol
      sss1 = sss1/(nnp*nmp*nlp)*univol
      sss2 = sss2/(nnp*nmp*nlp)*univol
      sss_down  = sss_down/(nnp*nmp*nlp)*univol
      sss_total  = sss_total/(nnp*nmp*nlp)*univol

      if(ipripositron >= 1) write(nfout,'(" (2) sss, sss1, sss2 = ",&
           & 3f12.4)') sss, sss1, sss2

      if(sw_positron_file == ON) then
         call m_Files_open_nfpstrn()
         call m_Files_open_nfvelec()
         call m_Files_open_nfeppair()
         if(nspin==2) call m_Files_open_nfeppair2()
         if(sw_gga_p == ON) call m_Files_open_nfvelec_grad()

!!$rewind 300
!!$rewind 310
!!$rewind 320
         if(mype == 0) call wdchgr(nfout,nfpstrn,1,positron_title(1))
         if(mype == 0) call wdchgr(nfout,nfvelec,2,positron_title(2))
         if(mype == 0) call wdchgr(nfout,nfeppair,3,positron_title(3))
         if(nspin==2) then
            if(mype == 0) call wdchgr(nfout,nfeppair2,5,positron_title(5))
         end if
!!$write(300,*) 'cube file of positron density'
!!$write(300,'(6e13.5)') wkchr
!!$write(310,*) 'cube file of valence electron density'
!!$write(310,'(6e13.5)') wkchr2
!!$write(320,*) 'cube file of e-p pair'
!!$write(320,'(6e13.5)') wkchr3
         if(sw_gga_p == ON) then
!!$         rewind 330
            if(mype == 0) call wdchgr(nfout,nfvelec_grad,4,positron_title(4))
!!$         write(330,*)  'cube file of gradient of valence electron density'
!!$         write(330,'(6e13.5)') wkchr4
         end if
   
         call m_Files_close_nfpstrn()
         call m_Files_close_nfvelec()
         call m_Files_close_nfeppair()
         if(nspin==2) call m_Files_close_nfeppair2()
         if(sw_gga_p == ON) call m_Files_close_nfvelec_grad()
         if(sw_gga_p == ON) deallocate(wkchr4)
         deallocate(wkchr)
         deallocate(wkchr2)
         deallocate(wkchr3)
         if(nspin==2) deallocate(wkchr22)
         if(nspin==2) deallocate(wkchr32)
      end if

     if(nspin==1) then
       valence_annihilation_rate=sss/2.d0

#ifdef SINGLE_POSITRON
       valence_annihilation_rate = sss
#endif

       ssk=((BOHR)**3)*1.d4/(2.8d0**2)/3.d0/PAI
       ssk=ssk
       sss=core_annihilation_rate+valence_annihilation_rate
       p_new_lifetime=ssk/sss
       p_core_rate=core_annihilation_rate/sss*100.d0
     else if(nspin==2) then 
        valence_annihilation_rate=sss/2.d0
        valence_annihilation_rate_down=sss_down/2.d0
        valence_annihilation_rate_total=sss_total/2.d0
        ssk=((BOHR)**3)*1.d4/(2.8d0**2)/3.d0/PAI
        ssk=ssk
        sss=core_annihilation_rate+valence_annihilation_rate
        sss_down=core_annihilation_rate+valence_annihilation_rate_down
        sss_total=core_annihilation_rate+valence_annihilation_rate_total
        p_new_lifetime=ssk/sss
        p_new_lifetime_down=ssk/sss_down
        p_new_lifetime_total=ssk/sss_total
        p_core_rate=core_annihilation_rate/sss*100.d0
        p_core_rate_down=core_annihilation_rate/sss_down*100.d0
     end if
!!$     if(ipripositron >= 1) write(nfout,*)core_annihilation_rate, valence_annihilation_rate

     deallocate(f2or1)
   contains
     subroutine wdchgr(nfout,nfchr,np,str)
       integer, intent(in) :: nfout, nfchr,np
       character(len=*), intent(in) :: str
       integer :: n1,n2,n3,i,j,k, m, iloop
       real(kind=DP) :: dn1,dn2,dn3,x,y,z
       real(kind=DP),allocatable,dimension(:,:) :: cps_full
       integer, allocatable,dimension(:) :: ityp_full

       if(positron_filetype == DENSITY_ONLY) then
          write(nfchr,9001) nlp*nmp*nnp, nlp, nmp, nnp
9001      format(' CHARGE DENSITY NE = ',i8,'(',3i5,')')
          if(np == 1) then
             write(nfchr,'(6e13.5)') wkchr
          else if(np == 2) then
             write(nfchr,'(6e13.5)') wkchr2
          else if(np == 3) then
             write(nfchr,'(6e13.5)') wkchr3
          else if(np == 4) then
             write(nfchr,'(6e13.5)') wkchr4
          else if(np == 5) then
             if(allocated(wkchr32)) &
                  & write(nfchr,'(6e13.5)') wkchr32
          end if
       else if(positron_filetype == VTK) then
          write(nfchr,'("# vtk DataFile Version 2.0")')
          if(len_trim(str) >= 1) then
             write(nfchr,*) trim(str)
          else
             write(nfchr,'(" Calculated by PHASE")')
          end if

          write(nfchr,'("ASCII")')
          write(nfchr,'("DATASET STRUCTURED_GRID")')
          write(nfchr,'("DIMENSIONS",3(1x,i5))') nlp+1,nmp+1,nnp+1
          write(nfchr,'("POINTS",1x,i7,1x,"float")') (nlp+1)*(nmp+1)*(nnp+1)
          do n1=0,nlp
             do n2=0,nmp
                do n3=0,nnp
                   dn1 = n1/dble(nlp)
                   dn2 = n2/dble(nmp)
                   dn3 = n3/dble(nnp)
                   x = altv(1,1)*dn1 + altv(1,2)*dn2 + altv(1,3)*dn3
                   y = altv(2,1)*dn1 + altv(2,2)*dn2 + altv(2,3)*dn3
                   z = altv(3,1)*dn1 + altv(3,2)*dn2 + altv(3,3)*dn3
                   write(nfchr,'(3(1x,e13.5))') x,y,z
                end do
             end do
          end do
          if(np.le.4.or.(np==5.and.allocated(wkchr32))) then
             write(nfchr,'("")')
             write(nfchr,'("POINT_DATA",1x,i7)') (nlp+1)*(nmp+1)*(nnp+1)
             write(nfchr,'("SCALARS scalars float")')
             write(nfchr,'("LOOKUP_TABLE default")')
             do n1=0,nlp
                i=n1+1
                if(n1==nlp) i=1
                do n2=0,nmp
                   j=n2+1
                   if(n2==nmp) j=1
                   do n3=0,nnp
                      k=n3+1
                      if(n3==nnp) k=1
                      if(np==1) then
                         write(nfchr,'(e13.5)') wkchr(i,j,k)
                      else if(np==2) then
                         write(nfchr,'(e13.5)') wkchr2(i,j,k)
                      else if(np==3) then
                         write(nfchr,'(e13.5)') wkchr3(i,j,k)
                      else if(np==4) then
                         write(nfchr,'(e13.5)') wkchr4(i,j,k)
                      else if(np==5) then
                         write(nfchr,'(e13.5)') wkchr32(i,j,k)
                      end if
                   end do
                end do
             end do
          end if
       else if(positron_filetype == CUBE) then
          if(len_trim(str) >= 1) then
             write(nfchr,*) trim(str)
          else
             write(nfchr,'(" Calculated by phase")')
          end if
          if(nspin == 2) then
             if(iloop == 1) then
                write(nfchr,'(" SCF Total Density  UP")')
             else
                write(nfchr,'(" SCF Total Density  DOWN")')
             end if
          else
             write(nfchr,'(" SCF Total Density")')
          end if
          x = 0.d0; y = 0.d0; z = 0.d0
          write(nfchr,'(i6,3f10.4)') natm2, x,y,z
          do i = 1, 3
             write(nfchr,'(i6,3f10.6)') fft_box_size_CD(i,1), altv(1:3,i)/dble(fft_box_size_CD(i,1))
          end do

          allocate(cps_full(natm2,3))
          allocate(ityp_full(natm2))
          call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
          do i = 1, natm2
             m = ityp_full(i)
             write(nfchr,'(i6,4f10.6)') nint(iatomn(m)), ival(m), cps_full(i,1:3)
          end do
          deallocate(ityp_full,cps_full)

          if(np==1) then
             write(nfchr,'(6e13.5)') wkchr
          else if(np==2) then
             write(nfchr,'(6e13.5)') wkchr2
          else if(np==3) then
             write(nfchr,'(6e13.5)') wkchr3
          else if(np==4) then
             write(nfchr,'(6e13.5)') wkchr4
          else if(np==5) then
             if(allocated(wkchr32)) &
                  & write(nfchr,'(6e13.5)') wkchr32
          end if
       end if
     end subroutine wdchgr
end subroutine m_pWF_valence_annihilation

subroutine m_pWF_wlifetime()

  if(ipripositron >= 1) then
  if(nspin==1)then
     write(nfout,*) '***************************************************'
     write(nfout,*)'positron lifetime(ps)', p_new_lifetime 
     write(nfout,*)'core rate',p_core_rate,'%'
     write(nfout,*)'core and valence',core_annihilation_rate, valence_annihilation_rate
     write(nfout,*) '*************************************************'
  elseif(nspin==2)then
     write(nfout,*) '******************** Majority &      Minority ****'
     write(nfout,*)'positron lifetime(ps)', p_new_lifetime,p_new_lifetime_down 
     write(nfout,*)'core rate            ',p_core_rate,p_core_rate_down,'%'
     write(nfout,*)'core and valence(up,down)',core_annihilation_rate, valence_annihilation_rate,valence_annihilation_rate_down
     write(nfout,*) '*************************************************'
  end if
  end if
end subroutine m_pWF_wlifetime

  subroutine m_pWF_update_lifetime
    if(ipripositron >= 1) write(nfout,*)'lifetime: ',p_old_lifetime,p_new_lifetime
    p_old_lifetime=p_new_lifetime
  end subroutine m_pWF_update_lifetime

  subroutine m_pWF_wd_pzaj(nfout,comment,nc)
    integer,        intent(in) :: nfout, nc
    character(len=nc), intent(in) :: comment

    character(len=5) :: a
    integer :: i, ib, ri, j
    integer, parameter :: NZAJSIZE = 20
    integer :: nelm

    if(ipripositron <= 1) return 
    write(nfout,*) comment
    a = "     "
    do ib = 1, npeg
       do ri = 1, kimg
          if(ri == 1 .and. kimg == 2) a = "(Re) "
          if(ri == 2) a = "(Im) "

          if(ri == 1) write(nfout,'(" pev(",i3,")= ",e14.6," ",a4,5e14.6)') &
               & ib,pev(ib),a,(pzaj(i,ib,ri),i=1,5)
          if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(pzaj(i,ib,ri),i=1,5)
       end do
       if(ipripositron >= 3) then
          nelm = min(kg1_pwf,NZAJSIZE)
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" pev(",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,pev(ib),a,(pzaj(i,ib,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(pzaj(i,ib,ri),i=1,5)
             write(nfout,'(35x,5e14.6)') (pzaj(i,ib,ri),i=6,nelm)

          end do
       end if
    end do
  end subroutine m_pWF_wd_pzaj
end module m_Positron_Wave_Functions

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_Stress
!
!  AUTHOR(S): H. Sawada   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! *************************************************************
!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, the following functions are added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.0B]
!                 stress terms are avaiable in the case of DFT-D2 calculations
!
! =============================================================

#ifndef NO_NONLOCAL_DGEMM
#define NONLOCAL_DGEMM
#endif

module m_Stress
  use m_Const_Parameters,     only : DP, PAI, PAI2, PAI4, SKIP, zi &
                                  &, Valence_plus_PC_Charge &
!!$ASASASASAS
!!$                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA
                                  &, EXC_ONLY,STRESS_, CRDTYP, GAMMA &
                                  &, MAPPED,NOTMAPPED, ON
  use m_Kpoints,              only : k_symmetry
  use m_PseudoPotential,      only : nlmt,nlmta,lmta,ilmt,lmtt,ltp,mtp,il2p,isph &
                                  &, iqitg,taup,dl2p &
                                  &, q,dion,psc_l,psc_diff_l &
                                  &, qitg_l,qitg_diff_l, modnrm &
                                  &, itpcc,rhpcg_l,rhpcg_diff_l,epc,etot1,ival &
                                  &, m_PP_find_maximum_l, m_PP_include_vanderbilt_pot &
                                  &, ipaw,dion_paw, flg_paw, nqitg &
                                  &, m_PP_set_index_arrays1, m_PP_set_index_arrays2

  use m_NonLocal_Potential,   only : snld
  use m_XC_Potential,         only : vxc_l, vxcpc_l, exc, s_gga1, s_gga2

#ifndef DISABLE_VDWDF
  use m_vdWDF,  only : s_cnl1, s_cnl2, s_cnl1_pc, s_cnl2_pc, ecnl_vdwdf
#endif

  use m_Charge_Density,       only : chgq_l, hsr, chgsoft
  use m_Crystal_Structure,    only : altv,rltv,univol,nopr,op, p2bmat, b2pmat
  use m_Ionic_System,         only : ntyp, natm,ityp,iwei,pos,zfm3_l,s_ew
  use m_PlaneWaveBasisSet,    only : kg1,kg,kgp,ngabc,iba,nbase,nbmx,gr_l,ylm_l &
                                  &, m_pwBS_sphrp2_3D,m_pwBS_sphrp2_diff_3D &
                                  &, ngabc_kngp_l
  use m_Electronic_Structure, only : zaj_l,occup_l,eko_l,totch &
                                  &, fsr_l,fsi_l,fsr_l_2D,fsi_l_2D &
                                  &, fsr_diff_l_2D,fsi_diff_l_2D &
                                  &, m_ES_alloc_fsri_l_2D, m_ES_dealloc_fsri_l_2D &
                                  &, m_ES_gather_f_3d_to_2d, m_ES_alloc_fsr_l_2d &
                                  &, m_ES_alloc_fsi_l_2d, m_ES_gather_f_3d_to_2d_blk &
                                  &, m_ES_dealloc_fsr_l_2d, m_ES_dealloc_fsi_l_2d &
                                  &, m_ES_alloc_fsr_diff_l_2d, m_ES_alloc_fsi_diff_l_2d &
                                  &, m_ES_dealloc_fsr_diff_l_2d, m_ES_dealloc_fsi_diff_l_2d
                                  
  use m_ES_nonlocal,          only :                                            &
 &                                   m_ES_betar_dot_WFs_4_lmta_k_3D             &
 &                                 , G_dot_R                                    &
 &                                 , m_ES_alloc_zfsincos, m_ES_dealloc_zfsincos &
 &                                 , m_ES_alloc_arai_3D, m_ES_dealloc_arai_3D   &
 &                                 , alloc_zfsincos_mpi, dealloc_zfsincos_mpi   &
 &                                 , m_ES_betar_dot_WFs_4_each_k_3D
#ifdef NONLOCAL_DGEMM
  use m_ES_nonlocal,          only : m_ES_betar_dot_Psi_k_3D_snl
#endif

  use m_Control_Parameters,   only : nspin,ipri,kimg,af,nel_Ylm,sw_screening_correction,nhistory_stress, printable &
                                  &, sw_optimize_lattice,sw_uniform &
 &                                 , ke_e0,ke_sigma,ke_a, xctype, nblocksize_gather_f_is_given, nblocksize_gather_f &
 &                                 , m_CtrlP_cachesize
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Parallelization,      only : mpi_comm_group,map_k,myrank_k,np_e,ierr,ista_k,iend_k &
                                  &, ista_kngp,iend_kngp,ista_snl,iend_snl,npes,mype &
                                  &, ista_g1k, iend_g1k, np_g1k, mpi_ke_world, mpi_kg_world  &
                                  &, mpi_ge_world,nrank_g, mpi_chg_world, ista_atm_ke, iend_atm_ke
  use m_Screening,            only : screening


! =================================== Added by K. Tagami ============== p1100
  use m_Electronic_Structure,  only : dhub
  use m_Ionic_System,          only : ihubbard
  use m_Control_Parameters,    only : proj_attribute
! ===================================================================== p1100

  use m_Control_Parameters,   only : noncol
  use m_Control_Parameters,    only : external_stress, &
       &                              sw_fix_lattice_angles, sw_vdw_correction, &
       &                              sw_fix_lattice_lengths, &
       &                              fix_angle_alpha, fix_angle_beta, fix_angle_gamma, &
       &                              fix_length_a, fix_length_b, fix_length_c, &
       &                              sw_neglect_stress_offdiagonal, &
       &                              estress_has_been_set, sw_add_vlocal_gzero
  use m_Ionic_System,          only : s_vdw

  implicit none
  include 'mpif.h'

  integer,      private,pointer, dimension(:)   :: il3
  real(kind=DP),private,pointer, dimension(:)   :: vlength,wkc
  real(kind=DP),private,pointer, dimension(:)   :: grinv,zfsin_tmp,zfcos_tmp,mzfsin_tmp
  real(kind=DP),private,pointer, dimension(:)   :: flchgq
  real(kind=DP),private,pointer, dimension(:,:) :: g,alinvt,vloc
  real(kind=DP),private,pointer, dimension(:,:) :: s_ke,s_or,s_nl
  real(kind=DP),private,pointer, dimension(:,:) :: s_h1,s_h2,s_loc1,s_loc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_xc1,s_xc2
  real(kind=DP),private,pointer, dimension(:,:) :: s_pc
  real(kind=DP),private,allocatable, dimension(:,:,:) :: fsr_diff_l,fsi_diff_l,ylmd
  real(kind=DP),private,pointer, dimension(:)   :: ylm
  real(kind=DP),private,pointer, dimension(:,:,:) :: flchgqd
  real(kind=DP),public, pointer, dimension(:,:,:,:,:,:) :: hsrd,esrd

! ========================= added by K. Tagami =========================== 11.0
  real(kind=DP),public, allocatable, dimension(:,:,:,:,:,:) :: hsid, esid
! ======================================================================== 11.0

  real(kind=DP),private,pointer, dimension(:,:) :: s_0,s_1,s_2
  real(kind=DP),private,pointer, dimension(:,:) :: s_tmp,s_up,s_dn,s
  character(len=2) ,private                     :: stress_name

! ====================== Added by K. Tagami ========================= p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_hub
! =================================================================== p1100
  real(kind=DP),private,allocatable, dimension(:,:) :: s_vdwdf

  real(kind=DP),private :: stressmx=-1
  real(kind=DP),dimension(3,3),private :: currstress

  real(kind=DP), dimension(3), private :: etot3=0.d0
  real(kind=DP), private :: univol0
  real(kind=DP) :: stress_correction = 0.d0
  character(len('stress_correction')), parameter, private :: tag_stress_correction='stress_correction'
  real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext

  interface m_Stress_in_correction
    module procedure in_correction0
    module procedure in_correction1
  end interface m_Stress_in_correction
contains
  subroutine m_Stress_alloc
    allocate(s_ke(3,3)); s_ke = 0.d0
    allocate(s_or(3,3)); s_or = 0.d0
    allocate(s_nl(3,3)); s_nl = 0.d0
    allocate(s_xc1(3,3)); s_xc1 = 0.d0
    allocate(s_xc2(3,3)); s_xc2 = 0.d0
    allocate(s_h1 (3,3)); s_h1  = 0.d0
    allocate(s_h2 (3,3)); s_h2  = 0.d0
    allocate(s_loc1(3,3)); s_loc1 = 0.d0
    allocate(s_loc2(3,3)); s_loc2 = 0.d0
    allocate(s_pc(3,3)); s_pc = 0.d0

    allocate(hsrd(natm,nlmt,nlmt,nspin,3,3)); hsrd = 0.d0
    allocate(esrd(natm,nlmt,nlmt,nspin,3,3)); esrd = 0.d0

    allocate(s_0(3,3)); s_0 = 0.d0
    allocate(s_1(3,3)); s_1 = 0.d0
    allocate(s_2(3,3)); s_2 = 0.d0
    allocate(s_tmp(3,3)); s_tmp = 0.d0
    allocate(s_up(3,3)); s_up = 0.d0
    allocate(s_dn(3,3)); s_dn = 0.d0
    allocate(s(3,3)); s = 0.d0
    allocate(alinvt(3,3)); alinvt = rltv / PAI2

! =========================================== Added by K.Tagami ==== p1100
    allocate(s_hub(3,3)); s_hub = 0.d0
! ================================================================== p1100
    allocate(s_vdwdf(3,3)); s_vdwdf = 0.d0

  end subroutine m_Stress_alloc

  subroutine m_Stress_dealloc
    deallocate(s_ke)
    deallocate(s_or)
    deallocate(s_nl)
    deallocate(s_xc1)
    deallocate(s_xc2)
    deallocate(s_h1)
    deallocate(s_h2)
    deallocate(s_loc1)
    deallocate(s_loc2)
    deallocate(s_pc)
    deallocate(hsrd)
    deallocate(esrd)

! ============================== added by K. Tagami ============= 11.0
    if ( allocated(hsid) ) deallocate(hsid)
    if ( allocated(esid) ) deallocate(esid)
! =============================================================== 11.0

    deallocate(s_0)
    deallocate(s_1)
    deallocate(s_2)
    deallocate(s_tmp)
    deallocate(s_up)
    deallocate(s_dn)
    deallocate(s)
    deallocate(alinvt)

! =========================================== Added by K.Tagami ==== p1100
    deallocate(s_hub)
! ================================================================== p1100
    deallocate(s_vdwdf)

  end subroutine m_Stress_dealloc

  subroutine m_Stress_alloc_grinv_g
    integer :: i
    real(kind=DP) :: ga,gb,gc
    allocate(grinv(ista_kngp:iend_kngp)); grinv = 0.d0
    allocate(g(ista_kngp:iend_kngp,3)); g = 0.d0
    do i = ista_kngp, iend_kngp  !for mpi
      if(gr_l(i).lt.1.0d-20) then
        grinv(i)=0.d0
      else
        grinv(i)=1.d0/gr_l(i)
      endif
    enddo
    do i = ista_kngp, iend_kngp  !for mpi
      ga = ngabc_kngp_l(i,1)
      gb = ngabc_kngp_l(i,2)
      gc = ngabc_kngp_l(i,3)
      g(i,1) = rltv(1,1)*ga+rltv(1,2)*gb+rltv(1,3)*gc
      g(i,2) = rltv(2,1)*ga+rltv(2,2)*gb+rltv(2,3)*gc
      g(i,3) = rltv(3,1)*ga+rltv(3,2)*gb+rltv(3,3)*gc
    enddo
  end subroutine m_Stress_alloc_grinv_g

  subroutine m_Stress_dealloc_grinv_g
    deallocate(grinv)
    deallocate(g)
  end subroutine m_Stress_dealloc_grinv_g

  subroutine m_Stress_ke(nfout,kv3,kp_crdtyp,vkxyz)
    integer, intent(in) :: nfout, kv3, kp_crdtyp
    real(kind=DP), intent(in), dimension(kv3,3,kp_crdtyp) :: vkxyz
    real(kind=DP)       :: fac
    integer             :: ik,i,j,ib,ig
    real(kind=DP),pointer,dimension(:,:) :: s_ke_mpi   ! MPI
    integer :: is,ie
    integer             :: id_sname = -1

    call tstatc0_begin('m_Stress_ke ',id_sname)

    allocate(s_ke_mpi(3,3))
    allocate(g(maxval(np_g1k),3)); g = 0.d0
    allocate(vlength(maxval(np_g1k))); vlength = 0.d0
    allocate(wkc(maxval(np_g1k)));  wkc  = 0.d0
    s_ke = 0.d0
    do ik = 1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle               ! MPI  
       call k_plus_G_vectors_3D(ik,kg,kg1,kv3,iba,nbase,vkxyz,ngabc,rltv&
            &,g(1,1),g(1,2),g(1,3),vlength)                            ! ->(bottom_Subr.)
       do ig = 1,np_g1k(ik)
          wkc(ig) = 1.d0 &
               &  + 2.d0*ke_a/sqrt(PAI)/ke_sigma  &
               &  * exp(-((vlength(ig)**2/2.d0-ke_e0)/ke_sigma)**2)
       end do
       if(k_symmetry(ik) == GAMMA) then
          is = 1
          if (ista_g1k(ik) == 1) is = 2
          
          do ig = is,np_g1k(ik)
             wkc(ig) = wkc(ig)*2.d0
          end do
       end if

       do i = 1, 3
       do j = 1, 3
       if(kimg.eq.1) then
          do ib = 1, np_e                           ! MPI
             do ig =1,np_g1k(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &                +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik)*zaj_l(ig,ib,ik,1)**2
             end do
          end do
       elseif(kimg.eq.2) then
          do ib = 1, np_e                           ! MPI
             do ig =1,np_g1k(ik)
                fac = wkc(ig)*g(ig,i)*(g(ig,1)*alinvt(1,j) &
                     &       +g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                s_ke(i,j) = s_ke(i,j) &
                     &        - fac*occup_l(ib,ik) &
                     &        *(zaj_l(ig,ib,ik,1)**2+zaj_l(ig,ib,ik,2)**2)
             end do
          end do
       endif
       enddo
       enddo
    enddo

    call mpi_allreduce(s_ke,s_ke_mpi,3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr) !MPI
    s_ke = s_ke_mpi  ! MPI

    s_ke=s_ke/dble(kv3)*2.d0

    stress_name = 'KI'
    if(af == 0) then
       s_0 = s_ke
       call check_stress(nfout)
    else
       s_up = s_ke
       call check_af(nfout)
    endif

    deallocate(s_ke_mpi)
    deallocate(g)
    deallocate(vlength)
    deallocate(wkc)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_ke

  subroutine m_Stress_hsr_diff(nfout,kv3)
    integer, intent(in) :: nfout,kv3
!!$ASASASASAS
    !!$integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl
    integer    :: i1,i2,ia,it,ispin,ik,i,lmt1,lmt2,lmta1,lmta2,iksnl,mapmode
!!$ASASASASAS
    integer    :: id_sname = -1
    real(kind=DP) :: fac, w_n, ek_n, c
    real(kind=DP),pointer,dimension(:,:,:,:,:,:) :: hsrd_mpi, esrd_mpi  ! MPI
    real(kind=DP),pointer,dimension(:,:,:)       :: snld_mpi            ! MPI
!!$ASASASASAS
    real(kind=DP) :: dtmp1=0.d0
    real(kind=DP) :: dtmp2=0.d0
!!$ASASASASAS
    integer         :: lnblck, lnb1, lnb2, lnsize,ib

    call tstatc0_begin('m_Stress_hsr_diff ',id_sname)

    allocate(hsrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI
    allocate(esrd_mpi(natm,nlmt,nlmt,nspin,3,3))   ! MPI

    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
!!$ASASASASAS
    call alloc_zfsincos_mpi()
!!$ASASASASAS
    allocate(fsr_diff_l(np_e,nlmta,ista_k:iend_k)); fsr_diff_l = 0.d0
    allocate(fsi_diff_l(np_e,nlmta,ista_k:iend_k)); fsi_diff_l = 0.d0

    fac = 2.d0/dble(kv3)
    hsrd = 0.d0
    esrd = 0.d0
    do i1 = 1, 3
    do i2 = 1, 3
#ifdef NONLOCAL_DGEMM
    do ispin = 1, nspin, af+1
       do ik = ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle         ! MPI
          snld_mpi => snld(:,:,:,i1,i2)   ! MPI
          call m_ES_betar_dot_Psi_k_3D_snl &
          &   (nfout,snld_mpi,zaj_l,ista_k,iend_k,ik,fsr_diff_l,fsi_diff_l)
          if(nblocksize_gather_f_is_given) then
             lnblck = nblocksize_gather_f
             if(np_e < lnblck) then
                lnblck = np_e
             end if
             if(1 > lnblck) then
                lnblck = np_e
             end if
          else
             lnblck = np_e
          end if
          call m_ES_alloc_fsr_l_2d(lnblck, nlmta)
          if(k_symmetry(ik) /= GAMMA) then
             call m_ES_alloc_fsi_l_2d(lnblck, nlmta)
          end if
          call m_ES_alloc_fsr_diff_l_2d(lnblck, nlmta)
          call m_ES_alloc_fsi_diff_l_2d(lnblck, nlmta)
          do lnb1 = 1, np_e, lnblck                          ! MPI
             lnb2=min( lnb1+lnblck-1,np_e )
             lnsize = lnb2-lnb1 + 1
             call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr_l_2D, ik, lnblck, lnb1, lnsize)
             if( k_symmetry(ik) /= GAMMA ) then
                call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi_l_2D, ik, lnblck, lnb1, lnsize)
             endif
             call m_ES_gather_f_3d_to_2d_blk(fsr_diff_l, fsr_diff_l_2D, ik, lnblck, lnb1, lnsize)
             call m_ES_gather_f_3d_to_2d_blk(fsi_diff_l, fsi_diff_l_2D, ik, lnblck, lnb1, lnsize)
             do ia = 1, natm
               it = ityp(ia)
               do ib=lnb1,lnb2
               w_n = occup_l(ib,ik) * fac
               ek_n = eko_l(ib,ik)
               do lmt1 = 1,ilmt(it)
                 lmta1    = lmta(lmt1,ia)
                 do lmt2 = lmt1,ilmt(it)
                   lmta2    = lmta(lmt2,ia)
                   if (k_symmetry(ik) /= GAMMA) then
                     dtmp1 = fsi_l_2D(ib,lmta2)
                     dtmp2 = fsi_l_2D(ib,lmta1)
                   else
                     dtmp1 = 0.d0
                     dtmp2 = 0.d0
                   endif
                   c= w_n * &
                    &     (  fsr_diff_l_2D(ib,lmta1)*fsr_l_2D(ib,lmta2) &
                    &     +  fsi_diff_l_2D(ib,lmta1)*dtmp1 &
                    &     +  fsr_diff_l_2D(ib,lmta2)*fsr_l_2D(ib,lmta1) &
                    &     +  fsi_diff_l_2D(ib,lmta2)*dtmp2 )
                   hsrd(ia,lmt1,lmt2,ispin,i1,i2)=hsrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                    &     + c
                   esrd(ia,lmt1,lmt2,ispin,i1,i2)=esrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                    &     + ek_n * c
                 enddo
               enddo
               enddo
             enddo
          enddo
          call m_ES_dealloc_fsr_l_2d()
          if(k_symmetry(ik) /= GAMMA) then
             call m_ES_dealloc_fsi_l_2d()
          end if
          call m_ES_dealloc_fsr_diff_l_2d()
          call m_ES_dealloc_fsi_diff_l_2d()
       enddo
    enddo
#else
      do ia = 1, natm
        it = ityp(ia)
!!$ASASASASAS
!!$        call G_dot_R(natm,ia,pos,kgp,nbmx,ngabc,zfcos,zfsin)
        if ( kv3/nspin == 1 ) then
          mapmode = MAPPED
          call G_dot_R(ia,mapmode,1)
        else
          mapmode = NOTMAPPED
          call G_dot_R(ia,mapmode)
        endif
!!$ASASASASAS
        do ispin = 1, nspin, af+1
        do ik = ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle         ! MPI
!          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik,.false.)

!          if(.not. allocated(fsr_l_2D)) allocate(fsr_l_2D(np_e, nlmta))
!          call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)
!          if(.not. (kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
!             if(.not. allocated(fsi_l_2D)) allocate(fsi_l_2D(np_e, nlmta))
!             call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
!          endif
          if(nblocksize_gather_f_is_given) then
             lnblck = nblocksize_gather_f
             if(np_e < lnblck) then
                lnblck = np_e
             end if
             if(1 > lnblck) then
                lnblck = np_e
             end if
          else
             lnblck = np_e
          end if
          call m_ES_alloc_fsr_l_2d(lnblck, nlmta)
          if(k_symmetry(ik) /= GAMMA) then
             call m_ES_alloc_fsi_l_2d(lnblck, nlmta)
          end if
          iksnl = (ik-1)/nspin + 1
          snld_mpi => snld(:,:,ista_snl:iend_snl,i1,i2)   ! MPI
          call m_ES_betar_dot_WFs_4_lmta_k_3D &
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,0)  ! MPI
           & (ista_k,iend_k,ik,zaj_l,ia,iksnl,snld_mpi,fsr_diff_l,fsi_diff_l,mapmode)  ! MPI
!!$ASASASASAS
!!$           & (ista_k,iend_k,ik,zaj_l,ia,snld(1,1,ista_snl,i1,i2),fsr_diff_l,fsi_diff_l)  ! MPI
          do lnb1 = 1, np_e, lnblck                          ! MPI
             lnb2=min( lnb1+lnblck-1,np_e )
             lnsize = lnb2-lnb1 + 1
             call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr_l_2D, ik, lnblck, lnb1, lnsize)
             if( k_symmetry(ik) /= GAMMA ) then
                call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi_l_2D, ik, lnblck, lnb1, lnsize)
             endif
             do ib=lnb1,lnb2
             w_n = occup_l(ib,ik) * fac
             ek_n = eko_l(ib,ik)
             do lmt1 = 1,ilmt(it)
               lmta1    = lmta(lmt1,ia)
               do lmt2 = lmt1,ilmt(it)
                 lmta2    = lmta(lmt2,ia)
!!$ASASASASAS
!          if(.not. allocated(fsr_l_2D)) allocate(fsr_l_2D(np_e, nlmta))
                 if (k_symmetry(ik) /= GAMMA) then
                   dtmp1 = fsi_l_2D(ib,lmta2)
                   dtmp2 = fsi_l_2D(ib,lmta1)
                 else
                   dtmp1 = 0.d0
                   dtmp2 = 0.d0
                 endif
!!$                 c= w_n * &
!!$                  &     (  fsr_diff_l(i,lmta1,ik)*fsr_l(i,lmta2,ik) &
!!$                  &     +  fsi_diff_l(i,lmta1,ik)*fsi_l(i,lmta2,ik) &
!!$                  &     +  fsr_diff_l(i,lmta2,ik)*fsr_l(i,lmta1,ik) &
!!$                  &     +  fsi_diff_l(i,lmta2,ik)*fsi_l(i,lmta1,ik) )
                 c= w_n * &
                  &     (  fsr_diff_l(ib,lmta1,ik)*fsr_l_2D(ib,lmta2) &
                  &     +  fsi_diff_l(ib,lmta1,ik)*dtmp1 &
                  &     +  fsr_diff_l(ib,lmta2,ik)*fsr_l_2D(ib,lmta1) &
                  &     +  fsi_diff_l(ib,lmta2,ik)*dtmp2 )
!!$ASASASASAS
                 hsrd(ia,lmt1,lmt2,ispin,i1,i2)=hsrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + c
                 esrd(ia,lmt1,lmt2,ispin,i1,i2)=esrd(ia,lmt1,lmt2,ispin,i1,i2) &
                                  &     + ek_n * c
               enddo
             enddo    ! lmt2
             enddo    ! lmt1
          enddo    ! i
       enddo    ! ik
       enddo    ! ispin
    enddo    !ia
#endif
    enddo    !i2
    enddo    !i1

    call mpi_allreduce(hsrd,hsrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call mpi_allreduce(esrd,esrd_mpi,natm*nlmt*nlmt*nspin*3*3,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    hsrd = hsrd_mpi/dble(nrank_g)
    esrd = esrd_mpi/dble(nrank_g)

!!$ASASASASAS
    call dealloc_zfsincos_mpi()
!!$ASASASASAS
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()
    deallocate(fsr_diff_l); deallocate(fsi_diff_l)
    deallocate(hsrd_mpi); deallocate(esrd_mpi)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_hsr_diff

  subroutine m_Stress_lclchg_diff(nfout)
    integer, intent(in) :: nfout
    integer    :: n,ilm3,i,it,ik,mdvdb,ia,is,mspin,i1,i2
    integer    :: lmt1,lmt2,il1,il2,tau1,tau2,l3,iiqitg
    real(kind=DP) :: fac,dga,c1,c2
    real(kind=DP), pointer, dimension(:)          :: drhodh
    real(kind=DP),allocatable,target,dimension(:) :: ylm_t
    real(kind=DP), pointer, dimension(:,:)        :: ylmd_mpi
#ifndef _m_Stress_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif
    integer :: ibl1,ibl2,nblk
    integer    :: id_sname = -1

    if(modnrm == SKIP) return

    call tstatc0_begin('m_Stress_lclchg_diff ',id_sname)

    do i1=1,3
    do i2=1,3

    allocate(drhodh(nspin))
!    allocate(zfcos_tmp(ista_kngp:iend_kngp))
!    allocate(zfsin_tmp(ista_kngp:iend_kngp))
!    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0
    allocate(vloc(ista_kngp:iend_kngp,kimg)); vloc = 0.d0

    allocate(flchgq(nspin)); flchgq = 0.d0
    allocate(flchgqd(3,3,nspin)); flchgqd = 0.d0

    do ik = 1, kimg
      do it = 1, ntyp
         do i = ista_kngp, iend_kngp  !for mpi
            vloc(i,ik)=vloc(i,ik)+psc_l(i,it)*zfm3_l(i,it,ik)
            if(sw_screening_correction==ON) then
               vloc(i,ik)=vloc(i,ik)-ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
            end if
        enddo
      enddo
    enddo

    call m_PP_find_maximum_l(n)   ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)
#ifndef _m_Stress_no_loop_exchange_
    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif
    allocate(ylmd(ista_kngp:iend_kngp,3,n**2)); ylmd = 0.d0
    allocate(ylmd_mpi(ista_kngp:iend_kngp,3)); ylmd_mpi = 0.d0
    do ilm3 = 1, n**2
       call m_pwBS_sphrp2_diff_3D(ilm3,rltv,ylmd_mpi)
       do i = ista_kngp, iend_kngp  !for mpi
          ylmd(i,1,ilm3) = ylmd_mpi(i,1)
          ylmd(i,2,ilm3) = ylmd_mpi(i,2)
          ylmd(i,3,ilm3) = ylmd_mpi(i,3)
       enddo
    end do
    deallocate(ylmd_mpi)

    if(n**2 > nel_Ylm) then
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2_3D(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  ! (ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)
    end if

#ifndef _m_Stress_no_loop_exchange_
    call blksize(n)
    do ibl1 = ista_kngp, iend_kngp, nblk
    ibl2 = ibl1+nblk-1
    if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
    allocate(zfsin_tmp(ibl1:ibl2));zfsin_tmp=0.d0
    allocate(zfcos_tmp(ibl1:ibl2));zfcos_tmp=0.d0
    allocate(mzfsin_tmp(ibl1:ibl2));mzfsin_tmp = 0.d0
!    do ia = 1, natm
    do ia = ista_atm_ke, iend_atm_ke
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2_blk(natm,pos,ia,kgp,ngabc_kngp_l,ibl1,ibl2,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
       mzfsin_tmp = -zfsin_tmp
       do iiqitg = nqitg_sp0(it), nqitg_sp(it)
          l3 = iq2l3(iiqitg)
          do m = 1, 2*l3+1
             ilm3 = l3*l3+m
             if(ilm3 <= nel_Ylm) then
                ylm => ylm_l(ibl1:ibl2,ilm3)
             else
                ylm => ylm_ext(ibl1:ibl2,ilm3)
             end if
             do ip = 1, nc(m,iiqitg)
                lmt1 = nc2lmt1(ip,m,iiqitg)
                lmt2 = nc2lmt2(ip,m,iiqitg)
                np = nc2n(ip,m,iiqitg)
                dga = dl2p(lmt1,lmt2,np,it)
                fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
                if(mod(l3,2) == 0) then
                   call even_case
                else
                   call odd_case
                endif
             enddo
          enddo
       enddo
    enddo
    deallocate(mzfsin_tmp)
    deallocate(zfsin_tmp)
    deallocate(zfcos_tmp)
    enddo
#else
    do ia = 1, natm
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(mdvdb == SKIP) cycle
       call calc_phase2(natm,pos,ia,kgp,ngabc_kngp_l,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp
       do lmt1 = 1,ilmt(it)
          il1 = ltp(lmt1,it); tau1 = taup(lmt1,it)
          do lmt2 = lmt1, ilmt(it)
            il2 = ltp(lmt2,it); tau2 = taup(lmt2,it)
            fac = 2.d0 ; if(lmt1 == lmt2) fac = 1.d0
            do n = 1, il2p(lmt1,lmt2,it)
              ilm3 = isph(lmt1,lmt2,n,it)
              l3   =  il3(ilm3)
              iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
              if(iiqitg == 0) cycle
              if(ilm3 <= nel_Ylm) then
                 ylm => ylm_l(ista_kngp:iend_kngp,ilm3)
              else
                 ylm => ylm_ext(ista_kngp:iend_kngp,ilm3)
              end if
              dga = dl2p(lmt1,lmt2,n,it)

              if (mod(il1+il2,2) == 0) then
                 call even_case
              else
                 call odd_case
              endif

            enddo
          enddo
       enddo
    enddo
#endif

!    deallocate(zfsin_tmp); deallocate(zfcos_tmp)
    deallocate(vloc)
    deallocate(flchgq); deallocate(flchgqd)
    deallocate(il3)
!    deallocate(ylm_t)
    deallocate(ylmd)
    deallocate(drhodh)
    if(allocated(ylm_ext)) deallocate(ylm_ext)
#ifndef _m_Stress_no_loop_exchange_
    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif

    enddo
    enddo

    call mpi_allreduce(mpi_in_place,s_xc1,9 &
                 &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call mpi_allreduce(mpi_in_place,s_h1,9 &
                 &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
    call mpi_allreduce(mpi_in_place,s_loc1,9 &
                 &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

    s_xc1  = s_xc1  * univol
    s_h1   = s_h1   * univol * PAI4
    s_loc1 = s_loc1 * univol

    if(af == 0) then
       s_0 = s_xc1
       stress_name = 'X1'
       call check_stress(nfout)
       s_0 = s_h1
       stress_name = 'H1'
       call check_stress(nfout)
       s_0 = s_loc1
       stress_name = 'L1'
       call check_stress(nfout)
    else
       s_up = s_xc1
       stress_name = 'X1'
       call check_af(nfout)
       s_up = s_h1
       stress_name = 'H1'
       call check_af(nfout)
       s_up = s_loc1
       stress_name = 'L1'
       call check_af(nfout)
    endif


    call tstatc0_end(id_sname)

  contains

    subroutine blksize(n)
      integer, intent(in) :: n
      integer :: ncache
      ncache = (m_CtrlP_cachesize()*1024)*3/4
      if(ncache == 0) then
         nblk = iend_kngp-ista_kngp+1
      else
         nblk=ncache/(8*(n**2))
      end if
      if (nblk<32) nblk = 1000
      !write(nfout,'(a,i8)') ' !** block size : ',nblk
    end subroutine blksize

    subroutine even_case
      do is=1,nspin,af+1
         flchgq(is) = fac*real(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac*real(zi**(-l3))*dga &
              & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfcos_tmp)
      else
         call complex_case(ilm3,iiqitg,zfcos_tmp,mzfsin_tmp)
      endif
    end subroutine even_case

    subroutine odd_case
      do is=1,nspin,af+1
         flchgq(is) = fac*aimag(zi**(-l3))*dga &
              & *hsr(ia,lmt1,lmt2,is)
         flchgqd(i1,i2,is) = fac*aimag(zi**(-l3))*dga &
              & *hsrd(ia,lmt1,lmt2,is,i1,i2)
      enddo
      if(kimg == 1) then
         call real_case(ilm3,iiqitg,zfsin_tmp)
      else
         call complex_case(ilm3,iiqitg,zfsin_tmp,zfcos_tmp)
      endif
    end subroutine odd_case
    
    subroutine real_case(ilm3,iiqitg,zf)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) :: zf
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2,c3up,c3down
      integer :: iy

      sxc1 = 0.d0;sh1=0.d0;sloc1=0.d0
      do is=1,nspin,af+1
        flchgq(is) = flchgq(is) * dble(iwei(ia))
        flchgqd(i1,i2,is) = flchgqd(i1,i2,is) * dble(iwei(ia))
      enddo

      if(nspin==1 .or. af==1) then
         mspin=(nspin+1)/nspin
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1+1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up*vxc_l(i,1,1)*zf(i)
            sh1=sh1 &
                 &  +grinv(i)**2*c3up &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin &
                 &  *zf(i)
            sloc1=sloc1 &
                 &  +c3up*zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3down = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +(c3up*vxc_l(i,1,1) &
                 &   +c3down*vxc_l(i,1,nspin)) &
                 &   *zf(i)
            sh1=sh1 &
                 &  +grinv(i)**2*(c3up+c3down) &
                 &  *(chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf(i)
            sloc1=sloc1 &
                 &  +(c3up+c3down) &
                 &  *zf(i)*vloc(i,1)
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
    end subroutine real_case

    subroutine complex_case(ilm3,iiqitg,zf1,zf2)
      integer,       intent(in) :: ilm3,iiqitg
      real(kind=DP), intent(in), dimension(ibl1:ibl2) &
           &  :: zf1,zf2
      real(kind=DP) :: sxc1,sh1,sloc1,c1,c2,c3up,c3down
      integer :: iy


      sxc1 = 0.d0;sh1=0.d0;sloc1=0.d0
      if(nspin.eq.1 .or. af.eq.1) then
         mspin=(nspin+1)/nspin
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i))
            sh1=sh1 &
                 &  +grinv(i)**2*c3up &
                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))/mspin*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))/mspin*zf2(i))
            sloc1=sloc1 &
                 &  +c3up &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      else  ! nspin ==2 and af /= 1
         do i = ibl1, ibl2  !for mpi
            iy = i - ibl1 + 1
            c1=(  g(i,1)*alinvt(1,i2) &
             &  + g(i,2)*alinvt(2,i2) &
             &  + g(i,3)*alinvt(3,i2) )  *g(i,i1) * grinv(i)
            c2=(  ylmd(i,1,ilm3)*alinvt(1,i2) &
             &  + ylmd(i,2,ilm3)*alinvt(2,i2) &
             &  + ylmd(i,3,ilm3)*alinvt(3,i2) )  *g(i,i1)
            c3up =  &
             &  - flchgq(1) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,1)*ylm(iy)*qitg_l(i,iiqitg)
            c3down = &
             &  - flchgq(nspin) &
             &  *(ylm(iy)*(qitg_l(i,iiqitg)*alinvt(i1,i2) &
             &  +qitg_diff_l(i,iiqitg)*c1) &
             &  +c2*qitg_l(i,iiqitg)) &
             &  + flchgqd(i1,i2,nspin)*ylm(iy)*qitg_l(i,iiqitg)

            sxc1=sxc1 &
                 &  +c3up &
                 &  *(vxc_l(i,1,1)*zf1(i)+vxc_l(i,2,1)*zf2(i)) &
                 &  +c3down &
                 &  *(vxc_l(i,1,nspin)*zf1(i)+vxc_l(i,2,nspin)*zf2(i))
            sh1=sh1 &
                 &  +grinv(i)**2*(c3up+c3down) &
                 &  *((chgq_l(i,1,1)+chgq_l(i,1,nspin))*zf1(i) &
                 &   +(chgq_l(i,2,1)+chgq_l(i,2,nspin))*zf2(i))
            sloc1=sloc1 &
                 &  +(c3up+c3down) &
                 &  *(zf1(i)*vloc(i,1)+zf2(i)*vloc(i,2))
         enddo
!xocl end spread sum(s_xc1),sum(s_loc1),sum(s_h1)
      endif
      s_xc1(i1,i2)  =  s_xc1(i1,i2)  + sxc1
      s_h1(i1,i2)   =  s_h1(i1,i2)   + sh1
      s_loc1(i1,i2) =  s_loc1(i1,i2) + sloc1
    end subroutine complex_case

  end subroutine m_Stress_lclchg_diff

  subroutine m_Stress_check_g12(nfout)
    integer, intent(in) :: nfout
    if(af == 0) then
       s_0 = s_gga1
       stress_name = 'G1'
       call check_stress(nfout)
       s_0 = s_gga2
       stress_name = 'G2'
       call check_stress(nfout)
    else
       s_up = s_gga1
       stress_name = 'G1'
       call check_af(nfout)
       s_up = s_gga2
       stress_name = 'G2'
       call check_af(nfout)
    endif
  end subroutine m_Stress_check_g12

  subroutine m_Stress_xc(nfout)
    integer, intent(in) :: nfout
    integer    :: is,ig,i,j,ia,it,ipc
    real(kind=DP) :: vxcp,pc
    integer    :: id_sname = -1
    integer       :: iend  !mpi
    real(kind=DP) :: vxcp_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_xc2_mpi1, s_xc2_mpi2
    real(kind=DP), pointer, dimension(:,:) :: s_pc_mpi1, s_pc_mpi2

    call tstatc0_begin('m_Stress_xc ',id_sname)

    allocate(zfcos_tmp(ista_kngp:iend_kngp))
    allocate(zfsin_tmp(ista_kngp:iend_kngp))
    zfcos_tmp = 0.d0; zfsin_tmp = 0.d0

    vxcp_mpi = 0.d0
    vxcp=0.d0
    if(kimg==1) then
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    else
       do is=1,nspin
          iend = iend_kngp
          if( iend_kngp > kg ) iend = kg
          if( ista_kngp <= iend ) then
             do i = ista_kngp, iend  !for mpi
                vxcp_mpi=vxcp_mpi+vxc_l(i,1,is)*chgsoft(i,1,is) &
                     &    +vxc_l(i,2,is)*chgsoft(i,2,is)
             enddo
          endif
!xocl end spread sum(vxcp)
       enddo
    endif
    call mpi_allreduce(vxcp_mpi,vxcp,1 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)

!    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#ifndef DISABLE_VDWDF
    s_xc2 = ( exc +ecnl_vdwdf -vxcp *univol ) *alinvt
#else
    s_xc2 = ( exc -vxcp *univol ) *alinvt
#endif

    allocate(s_xc2_mpi1(3,3)); s_xc2_mpi1 = 0.d0
    allocate(s_xc2_mpi2(3,3)); s_xc2_mpi2 = 0.d0
    allocate(s_pc_mpi1(3,3)); s_pc_mpi1 = 0.d0
    allocate(s_pc_mpi2(3,3)); s_pc_mpi2 = 0.d0

    do ia = 1, natm
    it=ityp(ia)
    if(itpcc(it).ne.0) then
       call calc_phase2(natm,pos,ia,kgp,ngabc_kngp_l,ista_kngp,iend_kngp,zfcos_tmp,zfsin_tmp)
                         ! -(b_Elec.)  -> zfcos_tmp, zfsin_tmp       
       ipc=itpcc(it)
       if(kimg==1) then
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - vxc_l(ig,1,is) * zfcos_tmp(ig) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - vxcpc_l(ig,1) * zfcos_tmp(ig) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       else
          do is=1,nspin
          do i=1,3
          do j=1,3
             do ig = ista_kngp, iend_kngp  !for mpi
                pc = (rhpcg_l(ig,ipc)*alinvt(i,j) &
                     &   +rhpcg_diff_l(ig,ipc)*grinv(ig)*g(ig,i) &
                     &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                     &    +g(ig,3)*alinvt(3,j))) &
                     &   *univol &
                     &   * dble(iwei(ia))
                s_xc2_mpi1(i,j) = s_xc2_mpi1(i,j) &
                     &   - (vxc_l(ig,1,is) * zfcos_tmp(ig) &
                     &    - vxc_l(ig,2,is) * zfsin_tmp(ig) ) * pc / nspin
                s_pc_mpi1(i,j) = s_pc_mpi1(i,j) &
                     &   - (vxcpc_l(ig,1) * zfcos_tmp(ig) &
                     &    - vxcpc_l(ig,2) * zfsin_tmp(ig) ) * pc / nspin
             enddo
          enddo
          enddo
          enddo
!xocl end spread sum(s_xc2),sum(s_pc)
       endif
    endif
    enddo

    call mpi_allreduce(s_xc2_mpi1,s_xc2_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
    call mpi_allreduce(s_pc_mpi1,s_pc_mpi2,9 &
         &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)

    s_xc2 = s_xc2 + s_xc2_mpi2
    s_pc = s_pc + s_pc_mpi2 + epc * alinvt
    deallocate(s_xc2_mpi1); deallocate(s_xc2_mpi2)
    deallocate(s_pc_mpi1); deallocate(s_pc_mpi2)

    s_0 = s_pc
    stress_name = 'PC'
    call check_stress(nfout)
    s_0 = s_xc1
    stress_name = 'X1'
    call check_stress(nfout)
    s_0 = s_xc2
    stress_name = 'X2'
    call check_stress(nfout)
    if(af == 0) then
       s_0 = s_xc1 + s_xc2 + s_gga1 + s_gga2
       stress_name = 'XC'
       call check_stress(nfout)
    else
       s_0 = s_xc2
       stress_name = 'X2'
       call check_stress(nfout)
    endif

    deallocate(zfsin_tmp); deallocate(zfcos_tmp)

    call tstatc0_end(id_sname)
  end subroutine m_Stress_xc

  subroutine m_Stress_loc(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,it,is,ik,ig
    real(kind=DP) :: rsv
    integer    :: id_sname = -1
    integer    :: ist  !mpi
    real(kind=DP), pointer, dimension(:,:) :: s_loc2_mpi
    real(kind=DP) :: rsv_mpi

! ========================= added by K. Tagami =========== 11.0
    integer :: ismax
! ======================================================== 11.0

    call tstatc0_begin('m_Stress_loc ',id_sname)

    allocate(s_loc2_mpi(3,3)); s_loc2_mpi = 0.d0

! ========================= added by K. Tagami =========== 11.0
    if ( noncol ) then
       ismax = 1
    else
       ismax = nspin
    endif
! ======================================================== 11.0

    ist = ista_kngp
    if(ista_kngp==1) ist = 2
    if ( sw_add_vlocal_gzero == ON ) ist = ista_kngp

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0
       do i=1,3
          do j=1,3
             do it=1,ntyp
                do ik=1,kimg
!                   ist = ista_kngp
!                   if(ista_kngp==1) ist = 2
                   do ig = ist, iend_kngp  !for mpi
                      s_loc2_mpi(i,j) = s_loc2_mpi(i,j) &
                           &  - univol  &
                           &    * chgq_l(ig,ik,is)*zfm3_l(ig,it,ik)*psc_diff_l(ig,it) &
                           &    * 2.d0 * g(ig,i) &
                           &    * (g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j) &
                           &      +g(ig,3)*alinvt(3,j))
                   enddo
!xocl end spread sum(s_loc2)
                enddo
             enddo
          enddo
       enddo
    enddo
    
    call mpi_allreduce( s_loc2_mpi, s_loc2, 9, &
         &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )
    deallocate(s_loc2_mpi)

    rsv_mpi = 0.d0
    rsv = 0.d0

    ist = ista_kngp
    if(ista_kngp==1) ist = 2
    if ( sw_add_vlocal_gzero == ON ) ist = ista_kngp

! ======================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ismax
! ======================================================== 11.0

      do it=1,ntyp
         do ik=1,kimg
            do ig = ist, iend_kngp  !for mpi
               rsv_mpi = rsv_mpi + chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*psc_l(ig,it)
              if(sw_screening_correction==ON) then
                  rsv_mpi = rsv_mpi - chgsoft(ig,ik,is)*zfm3_l(ig,it,ik)*ival(it)*Screening%phik(i)/univol
              end if
            enddo
         enddo
      enddo
    enddo

    call mpi_allreduce( rsv_mpi, rsv, 1, &
         &              mpi_double_precision, mpi_sum, mpi_chg_world, ierr )

    s_loc2 = s_loc2 - (etot1*totch + univol*rsv) * alinvt

    if(af == 0) then
       s_0 = s_loc1 + s_loc2
       stress_name = 'LO'
       call check_stress(nfout)
    else
       s_0 = s_loc2
       stress_name = 'L2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_loc

  subroutine m_Stress_h(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ik,ig
    integer    :: id_sname = -1
    real(kind=DP) :: eh
    integer       :: ist  !mpi
    real(kind=DP) :: eh_mpi
    real(kind=DP), pointer, dimension(:,:) :: s_h2_mpi1, s_h2_mpi2

    call tstatc0_begin('m_Stress_h ',id_sname)

    ist = ista_kngp
    if(ista_kngp==1) ist = 2

    eh = 0.d0
    do ik = 1,kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh + (chgq_l(i,ik,1)*grinv(i))**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh + ((chgq_l(i,ik,1)+chgq_l(i,ik,nspin))*grinv(i))**2
          enddo
       endif
    enddo

    do ik = 1, kimg
! ========================== modified by K. Tagami ========== 11.0
!       if(nspin.eq.1) then
       if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * chgq_l(i,ik,1)*chgsoft(i,ik,1)*grinv(i)**2
          enddo
       else if(nspin.eq.2) then
          do i = ist, iend_kngp  !for mpi
             eh = eh - 2 * (chgq_l(i,ik,1)+chgq_l(i,ik,nspin)) &
                  &  * (chgsoft(i,ik,1)+chgsoft(i,ik,nspin)) * grinv(i)**2
          enddo
      endif
    enddo

    if(npes > 1) then
       call mpi_allreduce(eh,eh_mpi,1 &
            &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
       eh = eh_mpi
    end if

    eh = univol*pai4*eh*0.5d0
    s_h2 = s_h2 + eh * alinvt

    allocate(s_h2_mpi1(3,3)); s_h2_mpi1 = 0.d0
    allocate(s_h2_mpi2(3,3)); s_h2_mpi2 = 0.d0

    do i=1,3
       do j=1,3
          do ik=1,kimg
! ========================== modified by K. Tagami ========== 11.0
!             if(nspin.eq.1) then
             if ( nspin.eq.1 .or. noncol ) then
! ============================================================ 11.0
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *chgq_l(ig,ik,1)**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             else if(nspin.eq.2) then
                do ig = ist, iend_kngp  !for mpi
                   s_h2_mpi1(i,j) = s_h2_mpi1(i,j) &
                        &   + univol*pai4 &
                        &   *(chgq_l(ig,ik,1)+chgq_l(ig,ik,nspin))**2*grinv(ig)**4 &
                        &   *g(ig,i) &
                        &   *(g(ig,1)*alinvt(1,j)+g(ig,2)*alinvt(2,j)+g(ig,3)*alinvt(3,j))
                enddo
             endif
          enddo
       enddo
    enddo

    if(npes > 1) then
       call mpi_allreduce(s_h2_mpi1,s_h2_mpi2,9 &
            &  ,mpi_double_precision,mpi_sum,mpi_chg_world,ierr)
    else
       s_h2_mpi2 = s_h2_mpi1
    end if

    s_h2 = s_h2 + s_h2_mpi2
    deallocate(s_h2_mpi1); deallocate(s_h2_mpi2)

    if(af == 0) then
       s_0 = s_h1 +s_h2
       stress_name = 'HA'
       call check_stress(nfout)
       s_0 = s_h2
       stress_name = 'H2'
       call check_stress(nfout)
    else
       s_0 = s_h2
       stress_name = 'H2'
       call check_stress(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_h

  subroutine m_Stress_ew(nfout)
    integer, intent(in) :: nfout

    s_0 = s_ew
    stress_name = 'EW'
    call check_stress(nfout)

  end subroutine m_Stress_ew

! =================================== KT_add ====================== 13.0B
  subroutine m_Stress_vdw(nfout)
    integer, intent(in) :: nfout
    integer :: i, j

    s_0 = s_vdw
    stress_name = 'VDW'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)

  end subroutine m_Stress_vdw
! ================================================================= 13.0B
#ifndef DISABLE_VDWDF
  subroutine m_Stress_vdwdf(nfout)
    integer, intent(in) :: nfout
    integer :: i, j

!    s_vdwdf = s_cnl1 +s_cnl2 -s_cnl1_pc -s_cnl2_pc
    s_vdwdf = s_cnl1 +s_cnl2
    s_0 = s_vdwdf
!
    stress_name = 'VDWDF'

!    call check_stress(nfout)
    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_0(i,j),j=1,3),i=1,3)

  end subroutine m_Stress_vdwdf
#endif

  subroutine m_Stress_nl(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_nl ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(ipaw(it)==0) then
        if(il1==il2 .and. im1==im2) then
           do ia = 1, natm
           if(ityp(ia)==it) then
              fac = 2.d0*dble(iwei(ia))
              if(lmt1==lmt2) fac = fac*0.5d0
              s_nl(i,j) = s_nl(i,j) &
                & + fac * dion(lmt1,lmt2,it) * hsrd(ia,lmt1,lmt2,ispin,i,j)

!              write(980,*) 'i j it = ', i, j, it
!              write(980,*) 'lmt1 kmt2 ia = ', lmt1, lmt2, ia
!              write(980,*) 'dion= ', dion(lmt1,lmt2,it)
!              write(980,*) 'hsrd= ', hsrd(ia,lmt1,lmt2,1,i,j), &       
!                   &                 hsrd(ia,lmt1,lmt2,2,i,j)
           endif
           enddo
!
        endif
    else
! --- Check ---
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_nl(i,j) = s_nl(i,j) &
            & + fac * dion_paw(lmt1,lmt2,ispin,ia) * hsrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_nl
       stress_name = 'NL'
       call check_stress(nfout)
    else
       s_up = s_nl
       stress_name = 'NL'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_nl

  subroutine m_Stress_or(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_or ',id_sname)

    do i = 1, 3
    do j = 1, 3
    do ispin = 1, nspin, af+1
    do it = 1, ntyp
    do lmt1 = 1, ilmt(it)
    il1 = ltp(lmt1,it)
    im1 = mtp(lmt1,it)
    do lmt2 = lmt1, ilmt(it)
    il2 = ltp(lmt2,it)
    im2 = mtp(lmt2,it)
    if(il1==il2 .and. im1==im2) then
       do ia = 1, natm
       if(ityp(ia)==it) then
          fac = 2.d0*dble(iwei(ia))
          if(lmt1==lmt2) fac = fac*0.5d0
          s_or(i,j) = s_or(i,j) &
            & + fac * q(lmt1,lmt2,it) * esrd(ia,lmt1,lmt2,ispin,i,j)
       endif
       enddo
    endif
    enddo  ! lmt2
    enddo  ! lmt1
    enddo  ! it
    enddo  ! ispin
    enddo  ! j
    enddo  ! i

    if(af == 0) then
       s_0 = s_or
       stress_name = 'OR'
       call check_stress(nfout)
    else
       s_up = s_or
       stress_name = 'OR'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_or

! =========================== Added by K. Tagami =========== p1100
  subroutine m_Stress_Hub(nfout)
    integer, intent(in) :: nfout
    integer    :: i,j,ia,it,ispin,lmt1,lmt2,il1,il2,im1,im2
!
    integer ih, l1p
!
    integer    :: id_sname = -1
    real(kind=DP) :: fac

    call tstatc0_begin('m_Stress_Hub ',id_sname)

    do i = 1, 3
       do j = 1, 3
          do ispin = 1, nspin, af+1
             do ia = 1, natm
                ih = ihubbard(ia)
                if(ih == 0) cycle
                it = ityp(ia)
                l1p = proj_attribute(ih)%l+1
                do lmt1 = 1, ilmt(it)
                   il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)
                   if(il1 /= l1p) cycle
                   do lmt2 = lmt1, ilmt(it)
                      il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)
                      if(il2 /= l1p) cycle
      !!$if(im1 /= im2) cycle
                      fac = 2.d0*iwei(ia); if(lmt1 == lmt2) fac = fac*0.5d0
                      s_hub(i,j) = s_hub(i,j) &
                           & + fac * dhub(lmt1,lmt2,ia,ispin)  &
                           &       * hsrd(ia,lmt1,lmt2,ispin,i,j)
                   end do
                end do
             end do
          end do
       enddo
    enddo
! --
!    if ( nspin==1 ) then
!       s_hub =s_hub * 2.0d0
!    endif
!    s_hub = 0.0d0
    ! --
    if(af == 0) then
       s_0 = s_hub
       stress_name = 'HU'
       call check_stress(nfout)
    else
       s_up = s_hub
       stress_name = 'HU'
       call check_af(nfout)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_Stress_Hub

  subroutine check_stress(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_0(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_stress

  subroutine check_af(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr

    s_1 = 0.d0
    s_2 = 0.d0
    s_dn = 0.d0

    do i=1,3
    do j=1,3
      do k=1,3
      s_1(i,j)=s_1(i,j)-s_up(i,k)*altv(j,k)/univol
      enddo
    enddo
    enddo

    iopr = nopr +af
    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        s_dn(i,j)=s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
      enddo
      enddo
    enddo
    enddo

    s_1 = s_1 + s_dn

    do i=1,3
    do j=1,3
      do k=1,3
      do l=1,3
        do iopr=1,nopr
        s_2(i,j)=s_2(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_1(k,l)
        enddo
      enddo
      enddo
    s_2(i,j)=s_2(i,j)/nopr
    enddo
    enddo

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',5x,A2,/,(3f20.10))') &
         &     stress_name,((s_2(i,j),j=1,3),i=1,3)
  end subroutine check_af

  subroutine m_Stress_sum(nfout)
    integer, intent(in) :: nfout
    integer             :: i,j,k,l,iopr
    real(kind=DP) :: c1
    real(kind=DP) :: altv_brav(3,3)

    s_tmp=0.d0
    s=0.d0
    if(af==0) then
       s = s_ke + s_xc1 + s_xc2 + s_gga1 + s_gga2 + s_loc1 + s_loc2 &
         &  + s_h1 + s_h2 + s_nl - s_or + s_ew

! ================================== Added by K. Tagami ======= p1100
       s = s + s_hub
! ============================================================== p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    else
       s_up = s_ke + s_xc1 + s_gga1 + s_gga2 + s_loc1 &
         &  + s_h1 + s_nl - s_or

! ================================== Added by K. Tagami ======= p1100
       s_up = s_up + s_hub
! ============================================================= p1100

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s_up(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
       iopr = nopr + af
       s_dn = 0.d0
       do i=1,3
         do j=1,3
           do k=1,3
             do l=1,3
               s_dn(i,j) = s_dn(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
             enddo
           enddo
         enddo
       enddo
       s_tmp = s_tmp + s_dn
       s = s_xc2 + s_loc2 + s_h2 + s_ew

       do i=1,3
         do j=1,3
           do k=1,3
             s_tmp(i,j) = s_tmp(i,j) - s(i,k) * altv(j,k) / univol
           enddo
         enddo
       enddo
    endif

! ================================== KT_add  =============== 13.0B
    if ( sw_vdw_correction == ON ) s_tmp = s_tmp +s_vdw
! ========================================================== 13.0B
!    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    s = 0.d0
    do i=1,3
      do j=1,3
        do k=1,3
          do l=1,3
            do iopr=1,nopr
              s(i,j) = s(i,j) + op(i,k,iopr)*op(j,l,iopr)*s_tmp(k,l)
            enddo
          enddo
        enddo
      enddo
    enddo
    s = s / nopr

    if ( xctype == "vdwdf" ) s = s +s_vdwdf

    call mpi_bcast(s,9 &
         & ,mpi_double_precision,0,mpi_comm_group,ierr)

    if(ipri >= 1) write(nfout,'(''  STRESS TENSOR'',/,(3f20.10))') &
         &     ((s(i,j),j=1,3),i=1,3)

! ============================= KT_add ======================== 13.0B
    if (ipri >= 1) then
       write(nfout,*) '-------------------------- '
       write(nfout,'(''  External STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( -external_stress(i,j),j=1,3),i=1,3)
       write(nfout,'(''  Total STRESS TENSOR'',/,(3f20.10))') &
            &            ( ( s(i,j)-external_stress(i,j),j=1,3),i=1,3)
       write(nfout,*) '-------------------------- '
    endif
! ============================================================= 13.0B

! ================================ KT_mod ================== 13.0B
!    stressmx = abs(s(1,1))
!    do i=1,3
!       do j=1,3
!          if(abs(s(j,i))>stressmx) stressmx = abs(s(j,i))
!       enddo
!    enddo
!    currstress(:,:) = s(:,:)
!    if(sw_uniform==ON)then
!       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
!    endif

    if(.not.m_Stress_in_correction()) then
      currstress = s -external_stress
      call cal_stressmx()
    endif
!
! ============= 13.1AS

! ================================================================= 13.0B

  end subroutine m_Stress_sum

  subroutine cal_stressmx()
    real(kind=DP) :: s_tmp(3,3)
    real(kind=DP) :: altv_brav(3,3)
    real(kind=DP) :: c1
    integer :: i,j
    stressmx = abs(currstress(1,1))
    do i=1,3
       do j=1,3
          if(abs(currstress(j,i))>stressmx) stressmx = abs(currstress(j,i))
       enddo
    enddo
    if ( sw_uniform == ON ) then
       stressmx = abs(currstress(1,1)+currstress(2,2)+currstress(3,3))/3.0d0
    endif

! === KT_add === 13.1AS
    if ( sw_neglect_stress_offdiagonal == ON ) then
       s_tmp = 0.0d0
       s_tmp(1,1) = currstress(1,1)
       s_tmp(2,2) = currstress(2,2)
       s_tmp(3,3) = currstress(3,3)

       stressmx = 0.0d0
       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif

    if ( sw_fix_lattice_angles == ON .or. sw_fix_lattice_lengths == ON ) then
       call get_latvec_from_prim_to_brav( p2bmat, altv, altv_brav )

       s_tmp = projected_stress_along_latvecs( altv_brav, currstress )
       stressmx = 0.0d0

       if ( sw_fix_lattice_angles == ON ) then
          s_tmp = constrain_on_stress_type1( altv_brav, s_tmp )
       endif
       if ( sw_fix_lattice_lengths == ON ) then
          s_tmp = constrain_on_stress_type2( altv_brav, s_tmp )
       endif

       do i=1,3
          c1 = sqrt( s_tmp(i,1)**2 +s_tmp(i,2)**2 +s_tmp(i,3)**2 )
          if ( c1 > stressmx ) stressmx = c1
       enddo
    endif
! ============= 13.1AS
  end subroutine cal_stressmx


  function m_Stress_get_stressmx() result(res)
     real(kind=DP) :: res
     res = stressmx
  end function m_Stress_get_stressmx

  subroutine m_Stress_set_stressmx(strmx)
    real(kind=DP), intent(in) :: strmx
    stressmx = strmx
  end subroutine m_Stress_set_stressmx

  function m_Stress_get_curr_stress() result(res)
     real(kind=DP), dimension(3,3) :: res
     res = currstress
  end function m_Stress_get_curr_stress

! === KT_add ==== 13.1AS
function projected_stress_along_latvecs(altv_in,stress) result(ret)
  real(kind=DP), dimension(3,3), intent(in) :: stress, altv_in
  real(kind=DP), dimension(3,3) :: ret

  integer :: i
  real(kind=DP) :: normalized_lat_vec(3,3), c1
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

  ret = 0.0d0

  do i=1,3
     ret(1,i) = dot_product(stress(i,:),normalized_lat_vec(:,1)) ! a-vec
     ret(2,i) = dot_product(stress(i,:),normalized_lat_vec(:,2)) ! b-vec
     ret(3,i) = dot_product(stress(i,:),normalized_lat_vec(:,3)) ! c-vec
  enddo
end function projected_stress_along_latvecs

function constrain_on_stress_type1(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_angle_alpha .and. fix_angle_beta .and. fix_angle_gamma ) then
     Do i=1, 3
        c1 = dot_product( s_out(i,:), normalized_lat_vec(:,i) )
        s_out(i,:) = c1 *normalized_lat_vec(:,i)
     End do
     return
  endif

! -----------------------------------
  if ( fix_angle_alpha ) then
     vectmp(:) = normalized_lat_vec(:,2) + normalized_lat_vec(:,3)

     Do i=2, 3
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_beta ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,3)

     Do i=1, 3, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do
  endif

! -----------------------------------
  if ( fix_angle_gamma ) then
     vectmp(:) = normalized_lat_vec(:,1) + normalized_lat_vec(:,2)

     Do i=1, 2
        c1 = dot_product( vectmp(:), normalized_lat_vec(:,i) )
        vectmp2(:) = vectmp(:) - c1*normalized_lat_vec(:,i)

        c2 = sqrt( vectmp2(1)**2 + vectmp2(2)**2 + vectmp2(3)**2 )
        vectmp2 = vectmp2 /c2

        c3 = dot_product( s_out(i,:), vectmp2(:) )
        s_out(i,:) = s_out(i,:) - c3 *vectmp2(:)
     End do

  endif

end function constrain_on_stress_type1

function constrain_on_stress_type2(altv_in,s_in) result(s_out)
  real(kind=DP), intent(in) :: s_in(3,3), altv_in(3,3)
  real(kind=DP) :: s_out(3,3)

  integer :: i
  real(kind=DP) :: c1, c2, c3
  real(kind=DP) :: normalized_lat_vec(3,3), vectmp(3), vectmp2(3)
!
  s_out = s_in
!
  Do i=1, 3
     c1 = sqrt( altv_in(1,i)**2 +altv_in(2,i)**2 + altv_in(3,i)**2 )
     normalized_lat_vec(:,i) = altv_in(:,i) / c1
  End do

! -----------------------------------
  if ( fix_length_a ) then
     c1 = dot_product( s_out(1,:), normalized_lat_vec(:,1) )
     s_out(1,:) = s_out(1,:) -c1 *normalized_lat_vec(:,1)
  endif
  if ( fix_length_b ) then
     c1 = dot_product( s_out(2,:), normalized_lat_vec(:,2) )
     s_out(2,:) = s_out(2,:) -c1 *normalized_lat_vec(:,2)
  endif
  if ( fix_length_c ) then
     c1 = dot_product( s_out(3,:), normalized_lat_vec(:,3) )
     s_out(3,:) = s_out(3,:) -c1 *normalized_lat_vec(:,3)
  endif
end function constrain_on_stress_type2
! ====== 13.1AS

subroutine m_Stress_correction(nfout,cntn)
  use m_IterationNumbers, only : iteration_stress_correction
  use m_Total_Energy, only: etotal0
  use m_Crystal_Structure, only : univol
  use m_Control_Parameters, only : gmax_org,decut_stress_correction,external_stress
  implicit none
  integer, intent(in) :: nfout
  logical, intent(in), optional :: cntn
  real(kind=DP) :: ecut,idelta_v,e1,e2,s1,s2
  logical :: from_cntn
  logical, save :: evaluated_correction = .false.
  if (evaluated_correction) return
  from_cntn = .false.
  if(present(cntn)) from_cntn = cntn
  if(iteration_stress_correction>=1 .and. iteration_stress_correction <= 2)then
    etot3(iteration_stress_correction) = etotal0
    univol0 = univol
  endif
  if(iteration_stress_correction == 2 .and. .not. from_cntn .or. &
  & (from_cntn.and.iteration_stress_correction>=3)) then !eval stress correction
    ecut = gmax_org*gmax_org
    idelta_v = -ecut/(1.5d0*univol0*decut_stress_correction)
    e1 = -etot3(1)
    e2 =  etot3(2)
    s1 = -e1*idelta_v
    s2 = -e2*idelta_v
    stress_correction = (s1+s2)*0.5d0
    if(printable) then
       write(nfout,'(a,f20.15)')  ' !** Pulay stress : ',stress_correction
    endif
    external_stress(1,1) = stress_correction
    external_stress(2,2) = stress_correction
    external_stress(3,3) = stress_correction
    estress_has_been_set = .true.
    evaluated_correction = .true.
  endif
end subroutine m_Stress_correction

function m_Stress_get_correction() result(res)
  implicit none
  real(kind=DP) :: res
  res = stress_correction
  return
end function m_Stress_get_correction

logical function in_correction0()
  use m_Const_Parameters, only : OFF
  use m_Control_Parameters, only : sw_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  in_correction0 = in_correction1(2)
end function in_correction0

logical function in_correction1(ncount)
  use m_Const_Parameters, only : OFF
  use m_Control_Parameters, only : sw_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: ncount
  if(sw_stress_correction == OFF) then
    in_correction1 = .false.
    return
  endif
  in_correction1 = iteration_stress_correction <= ncount
  return
end function in_correction1

function m_Stress_decut_for_correction() result(ret)
  use m_Const_Parameters, only : OFF,DP
  use m_Control_Parameters, only : sw_stress_correction, decut_stress_correction
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  real(kind=DP) :: ret
  if(sw_stress_correction == OFF)then
     ret = 0.d0
     return
  endif
  if(iteration_stress_correction == 1) then
     ret = -decut_stress_correction
  else if (iteration_stress_correction == 2) then
     ret = +decut_stress_correction
  else
     ret = 0.d0
  endif
  return
end function m_Stress_decut_for_correction

subroutine m_Stress_wd_cdata_4_correction(nfcntn)
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: nfcntn
  if(mype==0)then
     write(nfcntn,*) tag_stress_correction 
     write(nfcntn,'(i8)') iteration_stress_correction
     write(nfcntn,'(4f20.10)') etot3(1),etot3(2),etot3(3),univol0
     write(nfcntn,'(l2)') estress_has_been_set
     write(nfcntn,'(3f20.10)') currstress(1,1),currstress(1,2),currstress(1,3)
     write(nfcntn,'(3f20.10)') currstress(2,1),currstress(2,2),currstress(2,3)
     write(nfcntn,'(3f20.10)') currstress(3,1),currstress(3,2),currstress(3,3)
  endif
end subroutine m_Stress_wd_cdata_4_correction

subroutine m_Stress_rd_cdata_4_correction(nfout,nfcntn)
  use m_IterationNumbers, only : iteration_stress_correction
  implicit none
  integer, intent(in) :: nfout,nfcntn
  integer,      parameter   :: len_str = 132
  character(len=len_str)    :: str
  logical             :: tag_is_found, EOF_reach
  integer :: ierr
  if(mype==0)then
     call rewind_to_tag0(nfcntn,len(tag_stress_correction),tag_stress_correction &
          &, EOF_reach, tag_is_found, str,len_str)
     if(.not.tag_is_found)then
       write(nfout,'(a)') '!** '//trim(tag_stress_correction)//' does not exist'
     else
       read(nfcntn,*) iteration_stress_correction
       read(nfcntn,*) etot3(1),etot3(2),etot3(3),univol0
       read(nfcntn,*) estress_has_been_set
       read(nfcntn,*) currstress(1,1),currstress(1,2),currstress(1,3)
       read(nfcntn,*) currstress(2,1),currstress(2,2),currstress(2,3)
       read(nfcntn,*) currstress(3,1),currstress(3,2),currstress(3,3)
     endif
  endif
  if(npes>1)then
     call mpi_bcast(tag_is_found,1,mpi_logical,0,mpi_comm_group,ierr)
     if(tag_is_found)then
        call mpi_bcast(iteration_stress_correction,1,mpi_integer,0,mpi_comm_group,ierr)
        call mpi_bcast(etot3,3,mpi_double_precision,0,mpi_comm_group,ierr)
        call mpi_bcast(univol0,1,mpi_double_precision,0,mpi_comm_group,ierr)
        call mpi_bcast(estress_has_been_set,1,mpi_logical,0,mpi_comm_group,ierr)
        call mpi_bcast(currstress,9,mpi_double_precision,0,mpi_comm_group,ierr)
     endif
  endif
end subroutine m_Stress_rd_cdata_4_correction

end module m_Stress

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver: 801)
!
!  MODULE: m_ES_nonlocal
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DGEMM__
#   define __TIMER_DGEMM_START(a)  call timer_sta(a)
#   define __TIMER_DGEMM_STOP(a)   call timer_end(a)
#else
#   define __TIMER_DGEMM_START(a)
#   define __TIMER_DGEMM_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_NONLOCAL_DGEMM
#define NONLOCAL_DGEMM
#endif

module m_ES_nonlocal
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process &
       &                         , iteration, nkgroup
  use m_NonLocal_Potential, only : snl,snl_add,phig,paog, norm_phig &
!       &                         , nmesh_rs,nmesh_rs_max,meshx_rs,meshy_rs,meshz_rs,meshxyz_rs,snl_rs &
!       &                         , meshxyz_rs_conjg,nmesh_rs_h,meshxyz_rs_h,map_h,nmesh_rs_max_h,snl_rs_h
       &                         , snl_rs, snl_rs_h
  use m_Realspace,          only : nmesh_rs,nmesh_rs_max,meshx_rs,meshy_rs,meshz_rs,meshxyz_rs,meshxyz_rs_conjg &
       &                         , nmesh_rs_h,meshxyz_rs_h,map_h,nmesh_rs_max_h
  use m_PlaneWaveBasisSet,  only : ngabc,kg1,nbase,nbmx,iba,igf
  use m_PseudoPotential,    only : ilmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,q,dion,taup &
       &                         , ilmt_phi,nlmt_phi,nlmtt_phi,nlmta_phi &
       &                         , lmta_phi,lmtt_phi,ltp_phi, mtp_phi, taup_phi &
       &                         , ilmt_add,nlmt_add,nlmtt_add,nlmta_add &
       &                         , lmta_add,lmtt_add,ltp_add,mtp_add &
       &                         , ilmt_pao,nlmt_pao,nlmtt_pao,nlmta_pao &
       &                         , lmta_pao,lmtt_pao,ltp_pao,mtp_pao,ibpao &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , m_PP_include_vanderbilt_pot &
       &                         , ipaw, dion_paw, q_phirt_pw, ia2ia_symmtry_op_inv &
       &                         , irorb, nrorb, crorb
  use m_Crystal_Structure,  only : op, nopr, univol
  use m_Kpoints,            only : kv3, kv3_ek,k_symmetry,vkxyz, sw_force_kpt_inside_bz
  use m_Ionic_System,       only : ntyp, natm, iwei, ityp, pos
  use m_FFT,                only : nfft &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , fft_box_size_WF, m_FFT_WF
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : nspin,ipri, ipribetar &
       &                         , kimg, neg, meg, af &
       &                         , m_CtrlP_cachesize &
       &                         , sw_use_add_proj &
       &                         , flag_mpi_g_dot_r, flag_mpi_g_dot_r_k &
       &                         , nblocksize_betar_dot_wfs_nlmta  &
       &                         , nblocksize_betar_nlmta_is_given &
       &                         , nblocksize_betar_dot_wfs, nblocksize_vnonlocal_w &
       &                         , nblocksize_betar_is_given &
       &                         , nblocksize_vnonlocal_is_given &
       &                         , nblocksize_betar_npe_is_given &
       &                         , nblocksize_betar_dot_wfs_npe  &
       &                         , sw_rspace,sw_save_memory, m_CtrlP_realspace_integ_OK &
       &                         , nblocksize_rspace_betar, sw_rspace_v &
       &                         , nblocksize_rspace_v
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, PAI2 &
       &                         , GAMMA, MAPPED, NOTMAPPED, BUCS, DIRECT, ELECTRON, INVERSE
  use m_Parallelization,    only : mype &
       &                         , myrank_e,map_e,ista_e,iend_e,istep_e &
       &                         , map_z,np_e,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_snl, iend_snl &
       &                         , ng_nbmx, ista_nbmx, mpi_nbmx_world &
       &                         , np_nbmx, mp_nbmx &
       &                         , ng_nbmx_k, ista_nbmx_k, mpi_nbmx_world_k &
!!$       &                         , np_nbmx_k, mp_nbmx_k &
       &                         , ista_kg1_k, np_kg1_k, mp_kg1_k &
       &                         , nbmx_ext, ierr, ista_atm,iend_atm
  use m_Electronic_Structure, only : zaj_l,  fsr_l, fsi_l , fsr_add_l, fsi_add_l &
       &                           , eko_l, vnlph_l, vlhxcQ, compr_l, compi_l    &
       &                           , fsr_l_2D_k, fsi_l_2D_k, neordr, nrvf_ordr

  use m_Control_Parameters,   only : nblocksize_vnonlocal_w_nlmta_is_given            &
 &                                 , nblocksize_vnonlocal_w_nlmta                     &
 &                                 , nblocksize_vnonlocal_w_f_is_given                &
 &                                 , nblocksize_vnonlocal_w_f
  use m_FFT,                  only : m_FFT_W_Vlocal_W_3D
  use m_Parallelization,      only : lrank, nbsn, nbsn_sta, nbsn_end, neg_g           &
 &                                 , nbs_num, nbsn_num, nbs_sta, nbs_end              &
 &                                 , mpi_kg_world, mpi_ke_world           &
 &                                 , myrank_g, nrank_g &
 &                                 , ista_g1k, iend_g1k, np_g1k, mp_g1k   &
 &                                 , nis_g1k, nie_g1k, nel_g1k               &
 &                                 , nis_e, nel_fs, nis_fs, np_fs        &
 &                                 , ista_fs, iend_fs     
  use m_PlaneWaveBasisSet,    only : m_pwBS_kinetic_energies_3D
  use m_Electronic_Structure, only : fsr_l_2D, fsi_l_2D         &
 &                                 , fsr_ball, fsi_ball         &
 &                                 , m_ES_gather_f_3d_to_2d_blk &
 &                                 , m_ES_alloc_fsr_l_2d        &
 &                                 , m_ES_alloc_fsi_l_2d        &
 &                                 , m_ES_dealloc_fsr_l_2d      &
 &                                 , m_ES_dealloc_fsi_l_2d
  use m_PlaneWaveBasisSet,   only : ngabc_kngp_l, ngabc_kngp_B_l
  use m_Electronic_Structure,only :  afft,bfft 

  use m_Electronic_Structure, only : m_ES_WF_in_Rspace_3D, m_ES_WF_2D_psi

!<<----

! ============================ added by K. Tagami =================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor, SpinOrbit_mode, sw_hubbard, &
       &                             orb_popu_method, sw_band_unfolding, &
       &                             band_unfolding_active
  use m_PseudoPotential,      only : dion_scr_noncl, q_noncl, taup_pao
  use m_ES_NonCollinear,      only : m_ES_alloc_spinor_eigenwfn_0, &
       &                             m_ES_dealloc_spinor_eigenwfn_0, &
       &                             m_ES_set_spinor_eigenwfn_0, &
       &                             Spinor_EigenWfn0_atomtyp
  use m_SpinOrbit_Potential,  only : EigenWfns_MatLS_L0, &
       &                            EigenWfns_MatLS_L1, &
       &                            EigenWfns_MatLS_L2, &
       &                            EigenWfns_MatLS_L3
  use m_SpinOrbit_Potential,   only : EigenVals_MatLS_L0, &
       &                            EigenVals_MatLS_L1, &
       &                            EigenVals_MatLS_L2, &
       &                            EigenVals_MatLS_L3
  use m_Const_Parameters,    only : Neglected, BuiltIn, ByProjector, ByPawPot, &
       &                            ZeffApprox, ReadFromPP
! ================================================================== 11.0

  use m_PlaneWaveBasisSet,   only :  GVec_on_refcell

  implicit none

! === DEBUG by tkato for restart!!! 2012/02/12 =================================
! integer                                             :: npesize
  integer                                             :: npesize = 0
! ==============================================================================

  real(kind=DP),        allocatable,dimension(:)      :: zfcos, zfsin  !d(nbmx_ext)
  real(kind=DP),        allocatable,dimension(:)      :: zfcos_mpi,zfsin_mpi !d(mp_nbmx)
!!$  real(kind=DP),        allocatable,dimension(:)      :: zfcos_mpi_k, zfsin_mpi_k !d(mp_nbmx_k)
  real(kind=DP),private,allocatable,dimension(:)      :: ar, ai

  real(kind=DP), allocatable, target, dimension(:)    :: sc, ss, qc, qs
  real(kind=DP), allocatable, target, dimension(:)    :: sc_l

  integer, private, parameter                         :: sw_timing_2ndlevel = ON

#ifdef NONLOCAL_DGEMM
  real(kind=DP),        allocatable,dimension(:,:)    :: wk_zfcos, wk_zfsin  !d(nbmx_ext)
!!$  integer      ,allocatable,dimension(:)              :: lmtt_tmp
  real(kind=DP),private,allocatable,dimension(:,:)    :: wk_ar,  wk_ai
  real(kind=DP),allocatable,dimension(:,:)            :: bp_tmp1,  bp_tmp2
!!$  real(kind=DP),allocatable,dimension(:)              :: ia_tmp
  logical :: DGEMM_DEBUG = .false.
#endif

  real(kind=DP),          allocatable, dimension(:,:) :: pre_sc_without, pre_ss_without

#ifdef SX
  integer,private                                     :: nb_vnonlocal_default = 5000  ! TY 26Aug2009
  integer,private                                     :: nb_betar_default     = 10000 ! TY
#else
  integer,private                                     :: nb_vnonlocal_default = 1000  ! TY 26Aug2009
  integer,private                                     :: nb_betar_default     = 32    ! TY
#endif

  integer, allocatable, dimension(:)                  :: full_to_dist,dist_to_full

  logical, allocatable, dimension(:)                  :: mapl
  integer                                             :: nonzero_fft_elements
  integer, allocatable, dimension(:)                  :: revmap
  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  contains


  subroutine m_ES_alloc_scss_etc_3D()
    allocate(sc_l(1:maxval(np_g1k(:))))
  end subroutine m_ES_alloc_scss_etc_3D

  subroutine m_ES_dealloc_scss_etc()
    if(allocated(qs)) deallocate(qs)
    if(allocated(qc)) deallocate(qc)
    if(allocated(ss)) deallocate(ss)
    if(allocated(sc)) deallocate(sc)
    if(allocated(sc_l)) deallocate(sc_l)
    call m_FFT_dealloc_WF_work()
  end subroutine m_ES_dealloc_scss_etc


  subroutine m_ES_alloc_afft_scss_etc_3D()
! === DEBUG by tkato 2011/07/12 ================================================
!   allocate(afft(nfft))
!   allocate(bfft(nfft))
! Why are these lines comments???
    allocate(afft(nfft))
    allocate(bfft(nfft))
! ==============================================================================
    call m_ES_alloc_scss_etc_3D()
  end subroutine m_ES_alloc_afft_scss_etc_3D

  subroutine m_ES_dealloc_afft_scss_etc()
    call m_ES_dealloc_scss_etc()
    if(allocated(bfft)) deallocate(bfft)
    if(allocated(afft)) deallocate(afft)
  end subroutine m_ES_dealloc_afft_scss_etc

  subroutine alloc_zfsincos_mpi()
    if(flag_mpi_g_dot_r) then
       allocate(zfcos_mpi(mp_nbmx))
       allocate(zfsin_mpi(mp_nbmx))
    end if
  end subroutine alloc_zfsincos_mpi

  subroutine dealloc_zfsincos_mpi()
    if(flag_mpi_g_dot_r) deallocate(zfsin_mpi,zfcos_mpi)
  end subroutine dealloc_zfsincos_mpi

!!$  subroutine alloc_zfsincos_mpi_k()
!!$    if(flag_mpi_g_dot_r_k) then
!!$       allocate(zfcos_mpi_k(mp_nbmx_k))
!!$       allocate(zfsin_mpi_k(mp_nbmx_k))
!!$    end if
!!$  end subroutine alloc_zfsincos_mpi_k

!!$  subroutine dealloc_zfsincos_mpi_k
!!$    if(flag_mpi_g_dot_r_k) then
!!$       deallocate(zfcos_mpi_k)
!!$       deallocate(zfsin_mpi_k)
!!$    end if
!!$  end subroutine dealloc_zfsincos_mpi_k

  subroutine alloc_zfsincos(ibsize)
    integer, intent(in) :: ibsize
    allocate(zfsin(ibsize))
    allocate(zfcos(ibsize))
  end subroutine alloc_zfsincos

  subroutine dealloc_zfsincos
    deallocate(zfcos,zfsin)
  end subroutine dealloc_zfsincos


  subroutine dealloc_arai
    deallocate(ai,ar)
  end subroutine dealloc_arai

  subroutine m_ES_alloc_zfsincos(ik)
    integer, intent(in) :: ik
    if(ik == 0) then
! ============================== modified by K. Tagami =============== 11.0
!       if(kv3/nspin == 1) then
!          allocate(zfcos(iba(1)))
!          allocate(zfsin(iba(1)))
!       else
!          allocate(zfcos(nbmx_ext))
!          allocate(zfsin(nbmx_ext))
!       end if

       if ( noncol ) then
         if ( kv3/ndim_spinor == 1 ) then
            allocate(zfcos(iba(1)));  allocate(zfsin(iba(1)))
         else
            allocate(zfcos(nbmx_ext));  allocate(zfsin(nbmx_ext))
         endif
       else
         if ( kv3/nspin == 1 ) then
            allocate(zfcos(iba(1)));  allocate(zfsin(iba(1)))
         else
            allocate(zfcos(nbmx_ext));  allocate(zfsin(nbmx_ext))
         endif
       end if
! ==================================================================== 11.0
    else
       allocate(zfcos(iba(ik)))
       allocate(zfsin(iba(ik)))
    end if
! ================================= added by K. Tagami ============= 11.0
    zfcos = 0.0d0;  zfsin = 0.0d0
! ================================================================== 11.0
  end subroutine m_ES_alloc_zfsincos

  subroutine m_ES_dealloc_zfsincos()
    if(allocated(zfsin)) deallocate(zfsin)
    if(allocated(zfcos)) deallocate(zfcos)
  end subroutine m_ES_dealloc_zfsincos

  subroutine m_ES_alloc_arai_3D(ik)
    integer, intent(in) :: ik
    allocate(ar(maxval(np_g1k)))
    allocate(ai(maxval(np_g1k)))
  end subroutine m_ES_alloc_arai_3D

  subroutine m_ES_dealloc_arai_3D()
    deallocate(ar,ai)
  end subroutine m_ES_dealloc_arai_3D

#ifdef NONLOCAL_DGEMM
  subroutine alloc_wkzfsincos(ibsize)
    integer, intent(in) :: ibsize
    integer             :: ichkalloc
    allocate(wk_zfsin(ibsize,natm), stat=ichkalloc)
    allocate(wk_zfcos(ibsize,natm), stat=ichkalloc)
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate wk_zfsin or wk_zfcos in alloc_wkzfsincos', ibsize, natm
      stop
    endif
  end subroutine alloc_wkzfsincos

  subroutine alloc_wkzfsincos_red(ibsize,natmsize)
    integer, intent(in) :: ibsize, natmsize
    integer             :: ichkalloc
    allocate(wk_zfsin(ibsize,natmsize), stat=ichkalloc)
    allocate(wk_zfcos(ibsize,natmsize), stat=ichkalloc)
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate wk_zfsin or wk_zfcos in alloc_wkzfsincos_red', ibsize, natm
      stop
    endif
    wk_zfsin = 0.d0; wk_zfcos = 0.d0
  end subroutine alloc_wkzfsincos_red

  subroutine dealloc_wkzfsincos
    deallocate(wk_zfcos,wk_zfsin)
  end subroutine dealloc_wkzfsincos

  subroutine alloc_wkarai(ibsize,ibsize2)
    integer, intent(in) :: ibsize, ibsize2
    integer             :: ichkalloc
    allocate( wk_ar(ibsize,ibsize2),stat=ichkalloc )
    allocate( wk_ai(ibsize,ibsize2),stat=ichkalloc )
    if( ichkalloc /= 0 ) then
      write(nfout,*) ' could not allocate wk_ar or wk_ai in alloc_wkarai ', ibsize, ibsize2
      stop
    endif
    wk_ar=0.d0
    wk_ai=0.d0
  end subroutine alloc_wkarai

  subroutine dealloc_wkarai
    deallocate( wk_ai, wk_ar)
  end subroutine dealloc_wkarai

  subroutine alloc_wkbp(ik,LD11,LD12)
    integer , intent(in) :: ik,LD11,LD12
    integer             :: ichkalloc
    if(k_symmetry(ik) == GAMMA) then
       allocate( bp_tmp1(LD11,LD12)  ,stat=ichkalloc )
    else
       allocate( bp_tmp1(LD11,LD12)  ,stat=ichkalloc )
       allocate( bp_tmp2(LD11,LD12)  ,stat=ichkalloc )
    end if
    if( ichkalloc /= 0 ) then
      write(nfout,*) ' could not allocate bp_tmp in alloc_wkbp ', LD11, LD12
      stop
    endif
  end subroutine alloc_wkbp

  subroutine dealloc_wkbp(ik)
    integer, intent(in) :: ik
    if(k_symmetry(ik) == GAMMA) then
       deallocate( bp_tmp1)
    else
       deallocate( bp_tmp1,bp_tmp2)
    end if
  end subroutine dealloc_wkbp

!!$  subroutine alloc_wkother(icnt)
!!$    integer,intent(in) :: icnt
!!$    integer             :: ichkalloc
!!$    allocate(lmtt_tmp(icnt), stat=ichkalloc )
!!$    allocate(   ia_tmp(icnt), stat=ichkalloc )
!!$    if( ichkalloc /= 0 ) then
!!$      write(nfout,*) 'could not allocate work-array in alloc_wkother', icnt
!!$      stop
!!$    endif
!!$  end subroutine alloc_wkother

!!$  subroutine dealloc_wkother
!!$    deallocate( ia_tmp )
!!$    deallocate( lmtt_tmp)
!!$  end subroutine dealloc_wkother
#endif


#ifdef NONLOCAL_DGEMM

!------------------------------------------------------------------------------
!------------------------------------------------------------------------------

  subroutine m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
    integer, intent(in) :: ik,iksnl,ispin
    integer, intent(in) :: switch_of_eko_part

    integer :: mdvdb, it, ia, lmt2
    integer :: ibl1,ibl2,ibsize
    integer :: ichkalloc
    integer :: id_sname = -1
!!  real(kind=DP),allocatable,dimension(:,:) :: wk_sc_without,  wk_ss_without
    real(kind=DP),allocatable,dimension(:,:) :: wk_sc_with,     wk_ss_with,     wk_qc_with,     wk_qs_with
    real(kind=DP),allocatable,dimension(:,:) :: fsr_tmp_without, fsi_tmp_without
    real(kind=DP),allocatable,dimension(:,:) :: fsr_tmp_with   , fsi_tmp_with
    integer,allocatable,dimension(:) :: lmt2_tmp_without, ia_tmp_without, lmta2_tmp_without
    integer,allocatable,dimension(:) :: lmt2_tmp_with,    ia_tmp_with,    lmta2_tmp_with
    integer,allocatable,dimension(:) :: il2_tmp_without,  im2_tmp_without
    integer,allocatable,dimension(:) :: il2_tmp_with,     im2_tmp_with
    integer :: icnt_without  , icnt_with , icblk , icbl1 , icbl2
    logical :: mdvdb_EXECUT = .false.
    integer, save :: ibsize_print = OFF
    integer,save :: pre_proc_switch = 999
    integer,save :: pre_proc_ik     = 0
    logical :: chg_cond
!!  integer :: ist
    integer :: lnblck, lnsize, lnb1, lnb2
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace

    flag_in_realspace = .false.
    if(sw_rspace == ON) then
       if(m_CtrlP_realspace_integ_OK()) flag_in_realspace = .true.
    end if

    if(ipri >= 2 .and. sw_rspace == ON .and. .not. flag_in_realspace) write(nfout,&
       & '(" sw_rspace = ON, but the realspace integration is not installed in the solver now applied. ")')

    if(flag_in_realspace) then
       if(allocated(vnlph_l)) then
          if(size(vnlph_l,1) .ne. np_g1k(ik)) then
             deallocate(vnlph_l)
             allocate(vnlph_l(np_g1k(ik),np_e,kimg))
          end if
       else
          allocate(vnlph_l(np_g1k(ik),np_e,kimg))
       end if
       call Vnonlocal_W_in_realspace(ik,ispin,switch_of_eko_part)
    else
! ========================================================================================
    call tstatc0_begin('m_ES_Vnonlocal_W_3D ',id_sname,level=1)
! --> T. Yamasaki, 26th Aug. 2009
!!$    ibsize=5000
                                                                __TIMER_SUB_START(201)
    if(nblocksize_vnonlocal_is_given) then
       ibsize = nblocksize_vnonlocal_w
    else
       ibsize= nb_vnonlocal_default
       if(ipri >= 2 .and. ibsize_print == OFF) then
          write(nfout,'(" !ibsize(=nblocksize_vnonlocal_w) (m_ES_Vnonlocal_W) = ",i8)') ibsize
!!$             ibsize_print = ON
       end if
    end if
! <--
    if(nblocksize_vnonlocal_w_nlmta_is_given) then
       icblk = nblocksize_vnonlocal_w_nlmta
    else
       icblk = nlmta
       if(ipri >= 2 .and. ibsize_print == OFF) then
          write(nfout,'(" !icblk(=nblocksize_vnonlocal_w_nlmta) (m_ES_Vnonlocal_W) = ",i8)') icblk
       end if
    end if

#ifdef _NONLOCAL_MEMORY_KEEP_
    if ((pre_proc_switch .eq. switch_of_eko_part) .and. (pre_proc_ik .eq. ik)) then
       chg_cond = .false.
    else
       chg_cond = .true.
    endif
#else
    chg_cond = .true.
#endif
    if(nblocksize_vnonlocal_w_f_is_given) then
       lnblck = nblocksize_vnonlocal_w_f
       if(np_e < lnblck) then
          lnblck = np_e
       end if
       if(1 > lnblck) then
          lnblck = np_e
       end if
    else
       lnblck = np_e
       if(ipri >= 1 .and. ibsize_print == OFF) then
          write(nfout,'(" !lnblck(=nblocksize_vnonlocal_w_f) (m_ES_Vnonlocal_W) = ",i8)') lnblck
       end if
    end if

    icnt_without=0
    icnt_with=0

    allocate( lmt2_tmp_without(nlmta), stat=ichkalloc ) ;  lmt2_tmp_without=0
    allocate(   ia_tmp_without(nlmta), stat=ichkalloc ) ;    ia_tmp_without=0
    allocate(lmta2_tmp_without(nlmta), stat=ichkalloc ) ; lmta2_tmp_without=0
    allocate( lmt2_tmp_with(nlmta),    stat=ichkalloc ) ;     lmt2_tmp_with=0
    allocate(   ia_tmp_with(nlmta),    stat=ichkalloc ) ;       ia_tmp_with=0
    allocate(lmta2_tmp_with(nlmta),    stat=ichkalloc ) ;    lmta2_tmp_with=0
    allocate( il2_tmp_without(nlmta),  stat=ichkalloc ) ;   il2_tmp_without=0
    allocate( im2_tmp_without(nlmta),  stat=ichkalloc ) ;   im2_tmp_without=0
    allocate( il2_tmp_with(nlmta),     stat=ichkalloc ) ;      il2_tmp_with=0
    allocate( im2_tmp_with(nlmta),     stat=ichkalloc ) ;      im2_tmp_with=0
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate work-array in m_ES_Vnonlocal_W', nlmta
      stop
    endif

    call pre_m_ES_Vnonlocal_W( icnt_without, icnt_with )

    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       if(mdvdb == EXECUT) then
         mdvdb_EXECUT = .true.
         exit
       endif
    end do

#ifdef _NONLOCAL_MEMORY_KEEP_
    if (chg_cond) then
       if (allocated(pre_sc_without)) deallocate(pre_sc_without)
       if (allocated(pre_ss_without)) deallocate(pre_ss_without)
       allocate( pre_sc_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_sc_without=0.d0
       allocate( pre_ss_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_ss_without=0.d0
       if( ichkalloc /= 0 ) then
         write(nfout,*) 'could not allocate work-array1 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
         stop
       endif
    endif
#else
    allocate( pre_sc_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_sc_without=0.d0
    allocate( pre_ss_without(np_g1k(ik),icnt_without), stat=ichkalloc ) ;   pre_ss_without=0.d0
    if( ichkalloc /= 0 ) then
      write(nfout,*) 'could not allocate work-array1 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
      stop
    endif
#endif

    if (ibsize .gt. np_g1k(ik)) then
       ibsize = np_g1k(ik)
    endif
    call alloc_wkzfsincos(ibsize)

!!  allocate( wk_sc_without(ibsize,icnt_without), stat=ichkalloc ) ;   wk_sc_without=0.d0
!!  allocate( wk_ss_without(ibsize,icnt_without), stat=ichkalloc ) ;   wk_ss_without=0.d0
!x  allocate( fsr_tmp_without(np_e,min(icblk,icnt_without)) ,stat=ichkalloc ) ; fsr_tmp_without=0.d0
    allocate( fsr_tmp_without(lnblck,min(icblk,icnt_without)) ,stat=ichkalloc ) ; fsr_tmp_without=0.d0
    allocate( wk_sc_with(ibsize,min(icblk,icnt_with)),       stat=ichkalloc ) ;      wk_sc_with=0.d0
    allocate( wk_ss_with(ibsize,min(icblk,icnt_with)),       stat=ichkalloc ) ;      wk_ss_with=0.d0
!x  allocate( fsr_tmp_with(np_e,min(icblk,icnt_with)),       stat=ichkalloc ) ;    fsr_tmp_with=0.d0
    allocate( fsr_tmp_with(lnblck,min(icblk,icnt_with)),       stat=ichkalloc ) ;    fsr_tmp_with=0.d0
!x  call m_ES_alloc_fsr_l_2d()
    call m_ES_alloc_fsr_l_2d(lnblck,nlmta)

    if( ichkalloc /= 0 ) then
       write(nfout,'(" ibsize, icblk, icnt_without, icnt_with = ", 4i8)') ibsize, icblk, icnt_without, icnt_with
       write(nfout,'(" np_e, nlmta = ", 2i8)') np_e, nlmta
      write(nfout,*) 'could not allocate work-array2 in m_ES_Vnonlocal_W', ibsize, icnt_without, icnt_with, np_e
      stop ' could not allocate work-array2 in m_ES_Vnonlocal_W (2)'
    endif

    if( k_symmetry(ik) /= GAMMA ) then
!x    allocate( fsi_tmp_without(np_e,icnt_without), stat=ichkalloc )
!x    allocate( fsi_tmp_with(np_e,min(icblk,icnt_with))      , stat=ichkalloc )
!x    call m_ES_alloc_fsi_l_2d()
      allocate( fsi_tmp_without(lnblck,icnt_without), stat=ichkalloc )
      allocate( fsi_tmp_with(lnblck,min(icblk,icnt_with))      , stat=ichkalloc )
      call m_ES_alloc_fsi_l_2d(lnblck,nlmta)
      fsi_tmp_without=0.d0
      fsi_tmp_with=0.d0
      if( ichkalloc /= 0 ) then
        write(nfout,*) 'could not allocate work-array3 in m_ES_Vnonlocal_W', np_e,icnt_without,icnt_with
        stop
      endif
    endif

    if(mdvdb_EXECUT) then
      allocate( wk_qc_with(ibsize,min(icblk,icnt_with)), stat=ichkalloc ) ; wk_qc_with=0.d0
      allocate( wk_qs_with(ibsize,min(icblk,icnt_with)), stat=ichkalloc ) ; wk_qs_with=0.d0
      if( ichkalloc /= 0 ) then
        write(nfout,*) 'could not allocate work-array4 in m_ES_Vnonlocal_W', icnt_without, icnt_with, natm
        stop
      endif
    endif
!
!
! Revised by T. Yamasaki, September 2008
!
   if(DGEMM_DEBUG) write(nfout,*)' DGEMM_debug Vnonlocal :', &
                   icnt_without,icnt_with, nlmta, ibsize, kimg, k_symmetry(ik), GAMMA
   if(ibsize_print == OFF .and. ipri >= 1) then
     write(nfout,*)'<<m_ES_Vnonlocal_W>>'
     write(nfout,'(" mype = ",i3, " ibsize, np_e, icnt_with, icnt_without, iba(ik)/ibsize = " &
    &   ,5i8," <<m_ES_Vnonlocal_W>>")') mype, ibsize, np_e, icnt_with, icnt_without, iba(ik)/ibsize
     write(nfout,*)'myrank_e=',myrank_e,'myrank_e=',myrank_e,'myrank_g=',myrank_g, &
    &             'ik=',ik,'ispin=',ispin,'switch_of_eko_part=',switch_of_eko_part
     write(nfout,*)'np_e=',np_e,'iba(ik)=',iba(ik),'ibsize=',ibsize,'nlmta=',nlmta,&
    &             'iksnl=',iksnl,'kimg=',kimg,' chg_cond=',chg_cond
     write(nfout,*)'ista_g1k(ik)=',ista_g1k(ik),'iend_g1k(ik)=',iend_g1k(ik), &
    &             'np_g1k(ik)=',np_g1k(ik),    'mp_g1k(ik)=',mp_g1k(ik)
     write(nfout,*)'ista_e=',ista_e,'iend_e=',iend_e, 'neg=',neg,' lnblck=',lnblck
     write(nfout,*)'icnt_with=',icnt_with,'icnt_without=',icnt_without,'icblk=',icblk, &
    &             'k_symmetry(ik)=',k_symmetry(ik),'GAMMA=',GAMMA,'iteration=',iteration
     ibsize_print = ON
   end if

!!   call gather_f_3d_to_2d(fsr_l_3D, fsr_l_2D)
!x   call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)
!x   if( k_symmetry(ik) /= GAMMA ) then
!!      call gather_f_3d_to_2d(fsi_l_3D, fsi_l_2D)
!x      call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
!x   endif
     if (allocated(vnlph_l)) then
       if (size(vnlph_l,1) .ne. np_g1k(ik)) then
          deallocate(vnlph_l)   
          allocate(vnlph_l(np_g1k(ik),np_e,kimg))
       endif
     else
        allocate(vnlph_l(np_g1k(ik),np_e,kimg))
     endif

     vnlph_l = 0.0d0

  do lnb1 = 1, np_e, lnblck
     lnb2=min( lnb1+lnblck-1,np_e )
     lnsize = lnb2-lnb1 + 1

     call m_ES_gather_f_3d_to_2d_blk(fsr_l, fsr_l_2D, ik, lnblck, lnb1, lnsize)
     if( k_symmetry(ik) /= GAMMA ) then
        call m_ES_gather_f_3d_to_2d_blk(fsi_l, fsi_l_2D, ik, lnblck, lnb1, lnsize)
     endif

     do ibl1=ista_g1k(ik),iend_g1k(ik),ibsize
        ibl2=min( ibl1+ibsize-1,iend_g1k(ik) )
        call calc_phase_blk(ik,ibl1,ibl2)
        if( icnt_with .gt. 0 ) then
           do icbl1 = 1 , icnt_with , icblk
              icbl2 = min( icbl1+icblk-1,icnt_with )
              call Vnonlocal_W_part_with_blk_3D( ibl1,ibl2,icnt_with )
              call add_vnlph_l_with_eko_blk_3D(  ibsize,ibl1,ibl2,icnt_with, vnlph_l )
           enddo
        endif
        if( icnt_without .gt. 0 ) then
           do icbl1 = 1 , icnt_without , icblk
              icbl2 = min( icbl1+icblk-1,icnt_without )
              call Vnonlocal_W_part_without_blk_3D( ibl1,ibl2,icnt_without)
              call add_vnlph_l_without_eko_blk_3D(  ibsize,ibl1,ibl2,icnt_without,vnlph_l)
           enddo
        endif
     enddo

   enddo

    deallocate( lmt2_tmp_without,ia_tmp_without,lmta2_tmp_without,il2_tmp_without,im2_tmp_without )
    deallocate( lmt2_tmp_with,   ia_tmp_with,   lmta2_tmp_with,   il2_tmp_with,   im2_tmp_with    )
!!  deallocate( wk_sc_without,   wk_ss_without                   )
    deallocate( wk_sc_with,      wk_ss_with                      )
    deallocate( fsr_tmp_without, fsr_tmp_with )
    call m_ES_dealloc_fsr_l_2d()
    if(mdvdb_EXECUT) then
       deallocate( wk_qc_with,  wk_qs_with )
    endif
    if( k_symmetry(ik) /= GAMMA ) then
       deallocate( fsi_tmp_without, fsi_tmp_with )
       call m_ES_dealloc_fsi_l_2d()
    endif
    call dealloc_wkzfsincos()
#ifndef _NONLOCAL_MEMORY_KEEP_
    deallocate(pre_sc_without)
    deallocate(pre_ss_without)
#endif
    pre_proc_switch = switch_of_eko_part
    pre_proc_ik     = ik

    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(201)
! === rspace on 3D_Parallel ==============================================================
    end if
! ========================================================================================
  contains
    subroutine pre_m_ES_Vnonlocal_W( icnt_without, icnt_with )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer,intent(inout) :: icnt_without, icnt_with
                                                                __TIMER_SUB_START(202)
                                                                __TIMER_DO_START(209)
      do ia = 1, natm
         it = ityp(ia)
         mdvdb = m_PP_include_vanderbilt_pot(it)
         if(switch_of_eko_part == OFF) mdvdb= SKIP
         if( mdvdb==SKIP ) then
            do lmt2 = 1, ilmt(it)
               icnt_without = icnt_without + 1
               lmt2_tmp_without(icnt_without)  = lmt2
               ia_tmp_without(icnt_without)    =   ia
               lmta2_tmp_without(icnt_without) = lmta(lmt2,ia)
               il2_tmp_without(icnt_without)   =  ltp(lmt2,it)
               im2_tmp_without(icnt_without)   =  mtp(lmt2,it)
            enddo
         elseif( mdvdb==EXECUT ) then
            do lmt2 = 1, ilmt(it)
               icnt_with = icnt_with + 1
               lmt2_tmp_with(icnt_with)  = lmt2
               ia_tmp_with(icnt_with)    =   ia
               lmta2_tmp_with(icnt_with) = lmta(lmt2,ia)
               il2_tmp_with(icnt_with)   =  ltp(lmt2,it)
               im2_tmp_with(icnt_with)   =  mtp(lmt2,it)
            enddo
         endif
      enddo
                                                                __TIMER_DO_STOP(209)
                                                                __TIMER_SUB_STOP(202)
    end subroutine pre_m_ES_Vnonlocal_W

    subroutine calc_phase_blk(ik,ibl1,ibl2)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer, intent(in) :: ik, ibl1, ibl2
      integer :: i, nb, ia
      real(kind=DP) :: ph, f1, f2, f3
      integer :: id_sname0 = -1
                                                                __TIMER_SUB_START(204)
      if(sw_timing_2ndlevel == ON) call tstatc0_begin('calc_phase_blk ',id_sname0)

!cdir outerunroll=16
                                                                __TIMER_DO_START(213)
!fj!OCL SERIAL
!OCL NOFLTLD
      do i = ibl1, ibl2
         nb = nbase(i,ik)
!fj!OCL PARALLEL
         do ia=1,natm
            f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
            ph = ngabc(nb,1)*f1+ngabc(nb,2)*f2+ngabc(nb,3)*f3
            wk_zfcos(i-ibl1+1,ia) = dcos(ph)
            wk_zfsin(i-ibl1+1,ia) = dsin(ph)
         enddo
      enddo
                                                                __TIMER_DO_STOP(213)
      if(sw_timing_2ndlevel == ON) call tstatc0_end(id_sname0)
                                                                __TIMER_SUB_STOP(204)
    end subroutine calc_phase_blk

    subroutine Vnonlocal_W_part_without_blk_3D(iblk1,iblk2,icnt_without)
!
! (FUJITSU), December 2009
!

      integer, intent(in) :: iblk1,iblk2, icnt_without
      integer       :: lmt1, lmtt1, il1, im1, il11, mdl
      integer       :: ia, i, lmta2, il2, im2, lmt2, ic, iadd, icadd
      real(kind=DP) :: tmp
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(207)
      call tstatc0_begin('Vnonlocal_W_part_without_blk_3D ',id_sname)

!!      wk_sc_without = 0.d0
!!      wk_ss_without = 0.d0

!!      do ic = 1, icnt_without
                                                                __TIMER_DO_START(226)
!$OMP PARALLEL DO SCHEDULE(RUNTIME) DEFAULT(none)    &
!$OMP             SHARED(icbl1,icbl2,ia_tmp_without,ityp,lmta2_tmp_without,il2_tmp_without,  &
!$OMP                    im2_tmp_without,lmt2_tmp_without,fsr_tmp_without,fsr_l_2D,k_symmetry, &
!$OMP                    ik,fsi_tmp_without,fsi_l_2D,lnsize,ilmt,lmtt,ltp,mtp,dion,dion_paw,vlhxcQ, &
!$OMP                    ispin,iwei,iblk1,iblk2,pre_sc_without,wk_zfcos,snl,iksnl,pre_ss_without, &
!$OMP                    wk_zfsin,ista_g1k,q,chg_cond,lnblck,np_e,lnb1,ipaw)   &
!$OMP             PRIVATE(ic,ia,it,lmta2,il2,im2,lmt2,icadd,lmt1,lmtt1,il1,im1,il11,  &
!$OMP                     mdl,tmp,i,iadd)
!OCL NOFLTLD
        do ic = icbl1, icbl2
           ia   = ia_tmp_without(ic)
           it   = ityp(ia)
           lmta2= lmta2_tmp_without(ic)
           il2  = il2_tmp_without(ic)
           im2  = im2_tmp_without(ic)
           lmt2 = lmt2_tmp_without(ic)
           icadd = ic-icbl1+1
!x         fsr_tmp_without(1:np_e,icadd) = fsr_l_2D(1:np_e,lmta2)
           fsr_tmp_without(1:lnsize,icadd) = fsr_l_2D(1:lnsize,lmta2)
           if(k_symmetry(ik) /= GAMMA) then
!x            fsi_tmp_without(1:np_e,icadd) = fsi_l_2D(1:np_e,lmta2)
              fsi_tmp_without(1:lnsize,icadd) = fsi_l_2D(1:lnsize,lmta2)
           endif

           if (.not. chg_cond) then
              cycle
           endif

!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
           if (lnblck /= np_e) then
              if (lnb1 /= 1) then
                 cycle
              end if
           end if
!xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx

           do lmt1 = 1,ilmt(it)
              lmtt1 = lmtt(lmt1,it)
              il1   = ltp(lmt1,it)
              im1   = mtp(lmt1,it)
              il11  = il1 - 1
              mdl   = mod(il11,4)
              if(il1 == il2 .and. im1 == im2) then
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 endif
! ==============================================================================
              else
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 end if
! ==============================================================================
              endif
              tmp = tmp * iwei(ia)
              if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
              if(mdl == 0 .or. mdl == 2) then
!fj                                                                __TIMER_DO_START(227)
                 do i =  iblk1, iblk2
!!                  wk_sc_without(i-iblk1+1,ic) = wk_sc_without(i-iblk1+1,ic) + tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
!!                  wk_ss_without(i-iblk1+1,ic) = wk_ss_without(i-iblk1+1,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    iadd = i-ista_g1k(ik)+1
                    pre_sc_without(iadd,ic) = pre_sc_without(iadd,ic) + tmp*wk_zfcos(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                    pre_ss_without(iadd,ic) = pre_ss_without(iadd,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                 enddo
!fj                                                                __TIMER_DO_STOP(227)
              else if(mdl == 1 .or. mdl == 3) then
!fj                                                                __TIMER_DO_START(228)
                 do i =  iblk1, iblk2
!!                  wk_sc_without(i-iblk1+1,ic) = wk_sc_without(i-iblk1+1,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
!!                  wk_ss_without(i-iblk1+1,ic) = wk_ss_without(i-iblk1+1,ic) - tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    iadd = i-ista_g1k(ik)+1
                    pre_sc_without(iadd,ic) = pre_sc_without(iadd,ic) - tmp*wk_zfsin(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                    pre_ss_without(iadd,ic) = pre_ss_without(iadd,ic) - tmp*wk_zfcos(i-iblk1+1,ia)*snl(iadd,lmtt1,iksnl)
                 enddo
!fj                                                                __TIMER_DO_STOP(228)
              endif
           end do
        end do
                                                                __TIMER_DO_STOP(226)

!!$                                                                __TIMER_DO_START(227)
!!$                                                                __TIMER_DO_START(228)
!!$                                                                __TIMER_DO_STOP(228)
!!$                                                                __TIMER_DO_STOP(227)

        call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(207)
    end subroutine Vnonlocal_W_part_without_blk_3D

    subroutine Vnonlocal_W_part_with_blk_3D(iblk1,iblk2,icnt_with)
!
! (FUJITSU), December 2009
!

      integer, intent(in) :: iblk1,iblk2, icnt_with
      integer       :: lmt1, lmtt1, il1, im1, il11, mdl
      integer       :: ia, i, lmta2, il2, im2, lmt2, ic, icadd
      real(kind=DP) :: tmp
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(205)
      call tstatc0_begin('Vnonlocal_W_part_with_blk_3D ',id_sname)

        wk_sc_with = 0.d0
        wk_ss_with = 0.d0
        wk_qc_with = 0.d0
        wk_qs_with = 0.d0

!!      do ic = 1, icnt_with
                                                                __TIMER_DO_START(214)
!#ifdef USE_PROF
!  call timer_sta(214)
!#endif
!$OMP PARALLEL DO SCHEDULE(RUNTIME) DEFAULT(none)    &
!$OMP             SHARED(icbl1,icbl2,ia_tmp_with,ityp,lmta2_tmp_with,il2_tmp_with,  &
!$OMP                    im2_tmp_with,lmt2_tmp_with,fsr_tmp_with,fsr_l_2D,k_symmetry, &
!$OMP                    ik,fsi_tmp_with,fsi_l_2D,lnsize,ilmt,lmtt,ltp,mtp,dion,dion_paw,ipaw,vlhxcQ, &
!$OMP                    ispin,iwei,iblk1,iblk2,wk_sc_with,wk_zfcos,snl,iksnl,wk_ss_with, &
!$OMP                    wk_zfsin,ista_g1k,q,wk_qc_with,wk_qs_with)   &
!$OMP             PRIVATE(ic,ia,it,lmta2,il2,im2,lmt2,icadd,lmt1,lmtt1,il1,im1,il11,  &
!$OMP                     mdl,tmp,i)
!OCL NOFLTLD
        do ic = icbl1, icbl2
           ia   = ia_tmp_with(ic)
           it   = ityp(ia)
           lmta2= lmta2_tmp_with(ic)
           il2  = il2_tmp_with(ic)
           im2  = im2_tmp_with(ic)
           lmt2 = lmt2_tmp_with(ic)
           icadd = ic-icbl1+1
!x         fsr_tmp_with(1:np_e,icadd) = fsr_l_2D(1:np_e,lmta2)
           fsr_tmp_with(1:lnsize,icadd) = fsr_l_2D(1:lnsize,lmta2)
           if(k_symmetry(ik) /= GAMMA) then
!x            fsi_tmp_with(1:np_e,icadd) = fsi_l_2D(1:np_e,lmta2)
              fsi_tmp_with(1:lnsize,icadd) = fsi_l_2D(1:lnsize,lmta2)
           endif

           do lmt1 = 1,ilmt(it)
              lmtt1 = lmtt(lmt1,it)
              il1   = ltp(lmt1,it)
              im1   = mtp(lmt1,it)
              il11  = il1 - 1
              mdl   = mod(il11,4)
              if(il1 == il2 .and. im1 == im2) then
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 endif
! ==============================================================================
              else
! === DEBUG by tkato 2011/10/05 ================================================
!                tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 if(ipaw(it)==0) then
                    tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
                 else
                    tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
                 end if
! ==============================================================================
              endif
              tmp = tmp * iwei(ia)
              if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
!fj                                                              __TIMER_DO_START(215)
              if(mdl == 0 .or. mdl == 2) then
                 do i =  iblk1, iblk2
                    wk_sc_with(i-iblk1+1,icadd) = wk_sc_with(i-iblk1+1,icadd) &
                     &+ tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    wk_ss_with(i-iblk1+1,icadd) = wk_ss_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                 enddo
              else if(mdl == 1 .or. mdl == 3) then
                 do i =  iblk1, iblk2
                    wk_sc_with(i-iblk1+1,icadd) = wk_sc_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    wk_ss_with(i-iblk1+1,icadd) = wk_ss_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                 enddo
              endif
!fj                                                              __TIMER_DO_STOP(215)
!fj                                                              __TIMER_DO_START(216)
              if( il1 == il2 .and. im1 == im2) then
                 tmp = q(lmt1,lmt2,it)*iwei(ia)
                 if(mdl == 2 .or. mdl == 3) tmp = -1*tmp
                 if(mdl == 0 .or. mdl == 2) then
                    do i =  iblk1, iblk2
                       wk_qc_with(i-iblk1+1,icadd) = wk_qc_with(i-iblk1+1,icadd) &
                     &+ tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                       wk_qs_with(i-iblk1+1,icadd) = wk_qs_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    enddo
                 else if(mdl == 1 .or. mdl == 3) then
                    do i =  iblk1, iblk2
                       wk_qc_with(i-iblk1+1,icadd) = wk_qc_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfsin(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                       wk_qs_with(i-iblk1+1,icadd) = wk_qs_with(i-iblk1+1,icadd) &
                     &- tmp*wk_zfcos(i-iblk1+1,ia)*snl(i-ista_g1k(ik)+1,lmtt1,iksnl)
                    enddo
                 end if
              end if
!fj                                                              __TIMER_DO_STOP(216)
           end do
        end do
                                                                __TIMER_DO_STOP(214)

!!$                                                                __TIMER_DO_START(215)
!!$                                                                __TIMER_DO_START(216)
!!$                                                                __TIMER_DO_STOP(216)
!!$                                                                __TIMER_DO_STOP(215)
        call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(205)
    end subroutine Vnonlocal_W_part_with_blk_3D

    subroutine add_vnlph_l_with_eko_blk_3D(ibsize,ibl1,ibl2,icnt_with,vnlph)
!
! (FUJITSU), December 2009
!
      integer, intent(in) :: ibsize, ibl1, ibl2, icnt_with
      real(kind=DP), intent(inout), dimension(np_g1k(ik),np_e,kimg) :: vnlph
      integer          :: ic, ib
      integer       :: icsize , ista , icnt_size
      real(kind=DP) :: alpha, beta
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(206)
      call tstatc0_begin('add_vnlph_l_with_eko_blk_3D ',id_sname)

      ista = ibl1-ista_g1k(ik)+1
      icnt_size = icbl2-icbl1+1

      if(kimg == 1) then
         icsize=ibl2-ibl1+1
         alpha= 1.d0;  beta= 1.d0

                                                                __TIMER_DGEMM_START(217)
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )

         alpha=-1.d0;  beta= 1.d0
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_ss_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_ss_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
                                                                __TIMER_DGEMM_STOP(217)

!!       do ic = 1, icnt_with
                                                                __TIMER_DO_START(223)
         do ic = icbl1, icbl2
!x          do ib = 1, np_e                                           ! MPI
            do ib = 1, lnsize                                         ! MPI
!x             fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
!x             fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
               fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
            enddo
         enddo
                                                                __TIMER_DO_STOP(223)

         alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(218)
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
         alpha= 1.d0;  beta= 1.d0
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,wk_qs_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik) )
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
        &              wk_qs_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik) )
                                                                __TIMER_DGEMM_STOP(218)
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(219)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &             wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &             wk_ss_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(219)

!!          do ic = 1, icnt_with
                                                                __TIMER_DO_START(224)
!OCL NOFLTLD
            do ic = icbl1, icbl2
!x             do ib = 1, np_e                                           ! MPI
               do ib = 1, lnsize                                         ! MPI
!x                fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
                  fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               enddo
            enddo
                                                                __TIMER_DO_STOP(224)
            alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(220)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(220)
         else
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(221)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_sc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_ss_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_sc_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_sc_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_ss_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_ss_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(221)

!!          do ic = 1, icnt_with
                                                                __TIMER_DO_START(225)
            do ic = icbl1, icbl2
!x             do ib = 1, np_e                                           ! MPI
               do ib = 1, lnsize                                         ! MPI
!x                fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
!x                fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib,ik)
                  fsi_tmp_with(ib,ic-icbl1+1) = fsi_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
                  fsr_tmp_with(ib,ic-icbl1+1) = fsr_tmp_with(ib,ic-icbl1+1)*eko_l(ib+lnb1-1,ik)
               enddo
            enddo
                                                                __TIMER_DO_STOP(225)

            alpha=-1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(222)
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qc_with,ibsize, fsi_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qc_with,ibsize,fsi_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x         &              alpha,wk_qs_with,ibsize, fsr_tmp_with,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha, &
           &              wk_qs_with,ibsize,fsr_tmp_with,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(222)
         end if
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(206)
    end subroutine add_vnlph_l_with_eko_blk_3D

    subroutine add_vnlph_l_without_eko_blk_3D(ibsize,ibl1,ibl2,icnt_without,vnlph)
!
! (FUJITSU), December 2009
!
      integer, intent(in) :: ibsize, ibl1, ibl2, icnt_without
      real(kind=DP), intent(inout), dimension(np_g1k(ik),np_e,kimg) :: vnlph
      integer       :: icsize, ista, icnt_size
      real(kind=DP) :: alpha, beta
      integer :: id_sname = -1
      call tstatc0_begin('add_vnlph_l_without_eko_blk_3D ',id_sname)
                                                                __TIMER_SUB_START(208)

      ista = ibl1+1-ista_g1k(ik)
      icnt_size = icbl2-icbl1+1

!!    wk_sc_without(1:ibsize,1:icnt_without) = pre_sc_without(ista:ista+ibsize-1,1:icnt_without)
!!    wk_ss_without(1:ibsize,1:icnt_without) = pre_ss_without(ista:ista+ibsize-1,1:icnt_without)

      if(kimg == 1) then
         icsize=ibl2-ibl1+1
         alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(229)
!!       call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &              alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &              np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))

         alpha=-1.d0;  beta= 1.d0
!!       call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &              alpha,wk_ss_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x       call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &              alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
         call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &              np_g1k(ik),fsi_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(229)
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(230)
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,1),np_g1k(ik))
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik),fsr_tmp_without,lnblck,beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(230)
         else
            icsize=ibl2-ibl1+1
            alpha= 1.d0;  beta= 1.d0
                                                                __TIMER_DGEMM_START(231)
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik), fsr_tmp_without,lnblck, beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha=-1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,1),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik), fsi_tmp_without,lnblck, beta,vnlph(ista,lnb1,1),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_sc_without,ibsize, fsi_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_sc_without(ista,icbl1),np_g1k(ik), fsi_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_sc_without(ista,icbl1), &
        &                 np_g1k(ik), fsi_tmp_without,lnblck, beta,vnlph(ista,lnb1,2),np_g1k(ik))
            alpha= 1.d0;  beta= 1.d0
!!          call DGEMM__('N','T', icsize,np_e,icnt_without, &
!!      &                 alpha,wk_ss_without,ibsize, fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
!x          call DGEMM__('N','T', icsize,np_e,icnt_size, &
!x      &                 alpha,pre_ss_without(ista,icbl1),np_g1k(ik), fsr_tmp_without,np_e, beta,vnlph(ista,1,2),np_g1k(ik))
            call DGEMM__('N','T', icsize,lnsize,icnt_size,alpha,pre_ss_without(ista,icbl1), &
        &                 np_g1k(ik), fsr_tmp_without,lnblck, beta,vnlph(ista,lnb1,2),np_g1k(ik))
                                                                __TIMER_DGEMM_STOP(231)
         end if
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(208)
    end subroutine add_vnlph_l_without_eko_blk_3D

  end subroutine m_ES_Vnonlocal_W_3D

!!! else NONLOCAL_DGEMM
#else

  subroutine m_ES_Vnonlocal_W_3D(ik,iksnl,ispin,switch_of_eko_part)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!

    integer, intent(in) :: ik,iksnl,ispin
    integer, intent(in) :: switch_of_eko_part

    print *,"ERROR : Not Support Multi Dimension Para on DGEM"
    MPI_ABORT(mpi_comm_world, 140, ik)

  end subroutine m_ES_Vnonlocal_W_3D
#endif
!! #ifdef NONLOCAL_DGEMM end



  subroutine m_ES_wd_fsr_fsi()
    integer :: ik
    if(ipri >= 2) then
       write(nfout,'(" --- fsr_l, fsi_l ---")')
       do ik = ista_k, iend_k                              ! MPI
          call wd_fsr_fsi_3D(ik)    ! MPI
       end do
    end if
  end subroutine m_ES_wd_fsr_fsi


  subroutine G_dot_R(ia,mapmode,ik)
    integer, intent(in) :: ia,mapmode
    integer, intent(in), optional :: ik
    integer :: i, i1, ip
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1

    call tstatc0_begin('G_dot_R ',id_sname)
    f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
    if(.not.allocated(nbase)) stop ' nbase is not allocated'
    if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
       do i = 1, np_g1k(ik)
          i1 = nbase(i+ista_g1k(ik)-1,ik)
          grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    else
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
       do i = 1, np_nbmx
          ip = i + ista_nbmx -1
          grt = ngabc(ip,1)*f1+ngabc(ip,2)*f2+ngabc(ip,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine G_dot_R

  subroutine G_dot_R_map_div(ia,ik,ibl1,ibl2)
    integer, intent(in) :: ia,ik,ibl1,ibl2
    integer :: i, i1
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1
    call tstatc0_begin('G_dot_R_map_div ',id_sname)

    f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
    if(.not.allocated(nbase)) stop ' nbase is not allocated'

    if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
       zfcos = 0.0D0;   zfsin = 0.0D0
       do i = 1, ibl2-ibl1+1
          i1 = nbase(i+ibl1-1,ik)
          if ( sw_force_kpt_inside_bz == ON ) then
             if ( GVec_on_refcell(i1,ik) == 0 ) cycle
          else
             if ( GVec_on_refcell(i1,1) == 0 ) cycle
          endif
          grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    else
!!$    do i = 1, iba(ik)
       do i = 1, ibl2-ibl1+1
          i1 = nbase(i+ibl1-1,ik)
          grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
          zfcos(i) = dcos(grt)
          zfsin(i) = dsin(grt)
       end do
    endif
    call tstatc0_end(id_sname)
  end subroutine G_dot_R_map_div

#ifdef NONLOCAL_DGEMM
  subroutine G_dot_R_map_blk_3D(ik,ibl1,ibl2,ia1,ia2)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!

    integer, intent(in) :: ik,ibl1,ibl2, ia1,ia2
    integer :: ia, i, i1
    real(kind=DP) :: grt, f1, f2, f3
    integer :: id_sname = -1
                                                                __TIMER_SUB_START(410)

    if(.not.allocated(nbase)) stop ' nbase is not allocated'
    call tstatc0_begin('G_dot_R_map_blk ',id_sname)

   if ( sw_band_unfolding == ON .and. band_unfolding_active ) then
       wk_zfcos = 0.0D0;     wk_zfsin = 0.0D0
       do i = ibl1, ibl2
          i1 = nbase(i+ista_g1k(ik)-1,ik)
          if ( sw_force_kpt_inside_bz == ON ) then
             if ( GVec_on_refcell(i1,ik) == 0 ) cycle
          else
             if ( GVec_on_refcell(i1,1) == 0 ) cycle
          endif
          do ia=ia1,ia2
             f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
             grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
             wk_zfcos(i-ibl1+1,ia-ia1+1) = dcos(grt)
             wk_zfsin(i-ibl1+1,ia-ia1+1) = dsin(grt)
          end do
       end do
    else
!cdir outerunroll=16
       do i = ibl1, ibl2
          !f       i1 = nbase(i,ik)
          i1 = nbase(i+ista_g1k(ik)-1,ik)
!!$       do ia=1,natm
          do ia=ia1,ia2
             f1 = pos(ia,1)*PAI2; f2 = pos(ia,2)*PAI2; f3 = pos(ia,3)*PAI2
             grt = ngabc(i1,1)*f1+ngabc(i1,2)*f2+ngabc(i1,3)*f3
             wk_zfcos(i-ibl1+1,ia-ia1+1) = dcos(grt)
             wk_zfsin(i-ibl1+1,ia-ia1+1) = dsin(grt)
          end do
       end do
    endif
    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(410)
  end subroutine G_dot_R_map_blk_3D
#endif
!! #ifdef NONLOCAL_DGEMM end



!kukan 4
  subroutine m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik,dealloc_fs2d)
    integer, intent(in) :: nfout,ik
    logical, intent(in), optional :: dealloc_fs2d
    integer :: mod_ball = ON
    call m_ES_betar_dot_Psi_4_each_k_3D(nfout,zaj_l,ista_k,iend_k,ik,fsr_l,fsi_l,mod_ball,dealloc_fs2d)
  end subroutine m_ES_betar_dot_WFs_4_each_k_3D

#ifdef NONLOCAL_DGEMM
  subroutine m_ES_betar_dot_Psi_4_each_k_3D(nfout,psi_l,k1,k2,ik,bpr_l,bpi_l,mod_ball,dealloc_fs2d)
    integer, intent(in)    :: nfout, k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg):: psi_l ! MPI
    real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l, bpi_l !MPI
    integer, intent(in), optional :: mod_ball
    logical, intent(in), optional :: dealloc_fs2d
    call m_ES_betar_dot_Psi_k_3D_snl(nfout,snl,psi_l,k1,k2,ik,bpr_l,bpi_l,mod_ball,dealloc_fs2d)
  end subroutine m_ES_betar_dot_Psi_4_each_k_3D

  subroutine m_ES_betar_dot_Psi_k_3D_snl(nfout,snl,psi_l,k1,k2,ik,bpr_l,bpi_l,mod_ball,dealloc_fs2d)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, October 2009 : Mblock
!
    use m_Parallelization,only      : ball_buff, ball_addr
! === DEBUG by tkato 2014/08/08 ==========================================================
    use m_Electronic_Structure, only : m_ES_gather_f_3d_to_2d
! ========================================================================================

    integer, intent(in)    :: nfout, k1,k2,ik
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg):: psi_l ! MPI
    real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l, bpi_l !MPI
    integer, intent(in), optional :: mod_ball
    logical, intent(in), optional :: dealloc_fs2d
    logical :: deallocfs2d

    integer :: iksnl, ibsize, iend
    integer :: datasize

    integer :: ia, it, lmt1, msize, msize_target, msizemax, msizesum, natm_redmax
    integer :: ibl1,ibl2, ia1, ia2
    integer :: LD11,  LD12
    logical :: tran1
!!$    integer, allocatable, dimension(:) :: mil
    real(kind=DP), allocatable, dimension(:,:,:) :: psi_ri
!f
!   real(kind=DP),allocatable, dimension(:,:) :: fsr_l_2D,fsi_l_2D
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_l,wk_fsi_l
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_ball,wk_fsi_ball
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_2D,wk_fsi_2D
    real(kind=DP),allocatable, dimension(:,:) :: fsrt,fsit
    integer :: i, j, k, n

    integer :: id_sname = -1
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace


    flag_in_realspace = .false.
    if(sw_rspace == ON) then
       if(m_CtrlP_realspace_integ_OK()) flag_in_realspace = .true.
    end if

    if(flag_in_realspace) then
       allocate(fsrt(np_e,nlmta));fsrt=0.d0
!       if(k_symmetry(ik) /= GAMMA)then
          allocate(fsit(np_e,nlmta));fsit=0.d0
!       endif
       call betar_dot_Psi_4_each_k_in_rs(nfout,k1,k2,ik,psi_l,fsrt,fsit)
       do i=ista_fs,iend_fs
          bpr_l(1:np_e,i-ista_fs+1,ik) = fsrt(1:np_e,i)
          if(k_symmetry(ik) /= Gamma) then
             bpi_l(1:np_e,i-ista_fs+1,ik) = fsit(1:np_e,i)
          endif
       enddo
       deallocate(fsrt)
       !if(k_symmetry(ik) /= GAMMA) deallocate(fsit)
       deallocate(fsit)
       if(present(mod_ball) .and. mod_ball == ON) then
          allocate(wk_fsr_l(np_fs,np_e))
          allocate(wk_fsr_ball(np_fs,neg))
          if(k_symmetry(ik) /= GAMMA) then
             allocate(wk_fsi_l(np_fs,np_e))
             allocate(wk_fsi_ball(np_fs,neg))
          endif
          do i=1,np_e
            do j=1,np_fs
              wk_fsr_l(j,i)=bpr_l(i,j,ik)
              if(k_symmetry(ik) /= GAMMA) wk_fsi_l(j,i)=bpi_l(i,j,ik)
            enddo
          enddo
          call mpi_allgatherv(wk_fsr_l,np_fs*np_e,mpi_double_precision,wk_fsr_ball(1,1),ball_buff,&
          & ball_addr,mpi_double_precision,mpi_kg_world,ierr)
          if(k_symmetry(ik) /= GAMMA)call mpi_allgatherv(wk_fsi_l,np_fs*np_e,mpi_double_precision,&
                                 &wk_fsi_ball,ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
!OCL NOFLTLD
          do i=1,neg
            do j=1,np_fs
              fsr_ball(i,j,ik)=wk_fsr_ball(j,i)
              if(k_symmetry(ik) /= GAMMA) fsi_ball(i,j,ik)=wk_fsi_ball(j,i)
            enddo
          enddo
          deallocate(wk_fsr_l,wk_fsr_ball)
          !if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
          if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
       end if

       call m_ES_alloc_fsr_l_2d(np_e,nlmta)
       call m_ES_gather_f_3d_to_2d(fsr_l, fsr_l_2D, ik)

       if(k_symmetry(ik) /= GAMMA) then
         call m_ES_alloc_fsi_l_2d(np_e, nlmta)
         call m_ES_gather_f_3d_to_2d(fsi_l, fsi_l_2D, ik)
       endif
    else
! ========================================================================================
                                                                __TIMER_SUB_START(401)
    call tstatc0_begin('betar_dot_WFs ',id_sname,level=1)
    iksnl = (ik-1)/nspin + 1

!f    fsr_l(:,:,ik) = 0.d0
!f    if(k_symmetry(ik) /= GAMMA) fsi_l(:,:,ik) = 0.d0

!---
    if( nblocksize_betar_npe_is_given) then
       npesize = nblocksize_betar_dot_wfs_npe
       if( npesize > np_e) npesize = np_e
    else
       npesize = np_e
    end if

!FF    call m_ES_alloc_fsr_l_2d()
    if(allocated(fsr_l_2D)) deallocate(fsr_l_2D)
    call m_ES_alloc_fsr_l_2d(npesize,nlmta)
    allocate(wk_fsr_2D(npesize,np_fs))
    fsr_l_2D = 0.0d0
!----------

    allocate(wk_fsr_l(np_fs,np_e))
! === for np_fs == 0 ===========================================================
!   allocate(wk_fsr_ball(np_fs,neg))
    allocate(wk_fsr_ball(max(np_fs,1),neg))
! ==============================================================================
    if(k_symmetry(ik) /= GAMMA) then
!FF        call m_ES_alloc_fsi_l_2d()
    if(allocated(fsi_l_2D)) deallocate(fsi_l_2D)
    call m_ES_alloc_fsi_l_2d(npesize,nlmta)
    fsi_l_2D = 0.0d0
        allocate(wk_fsi_l(np_fs,np_e))
        allocate(wk_fsi_ball(np_fs,neg))
        allocate(wk_fsi_2D(npesize,np_fs))
    endif

    call set_msize() ! -> ibsize, msize_target, msizemax, natm_redmax

   do n = 1,np_e,npesize
    call alloc_wkzfsincos_red(ibsize,natm_redmax)
    call alloc_wkarai(ibsize,msizemax)
!!$    call alloc_wkother(msizemax)
!!$    allocate(mil(msizemax))
!FF    allocate(psi_ri(ibsize,np_e,kimg))
    allocate(psi_ri(ibsize,npesize,kimg))

!----
!   do ibl1 = 1, np_g1k(ik), ibsize
!          ibl2 = min( ibl1+ibsize-1, np_g1k(ik) )
!          call cpzaj_l_to_psi_ri(ibl1,ibl2)
!-----
    ia1 = 1
    msizesum = 0
    Mblock: do
       msize = ilmt(ityp(ia1))
       do ia = ia1+1, natm
          it = ityp(ia)
          msize = msize + ilmt(it)
          if(msize > msize_target) exit
       end do
       ia2 = ia-1

       call pre_lmta_k_blk(msize,LD11,LD12) !  -> msize, LD11, LD12
       call alloc_wkbp(ik,LD11,LD12)
       bp_tmp1=0.d0
       if(k_symmetry(ik) /= GAMMA) bp_tmp2=0.d0

       do ibl1 = 1, np_g1k(ik), ibsize
          ibl2 = min( ibl1+ibsize-1, np_g1k(ik) )
          call cppsi_l_to_psi_ri(ibl1,ibl2,n)
          call G_dot_R_map_blk_3D(ik,ibl1,ibl2, ia1,ia2) ! pos(ia,1:3), ngabc -> wk_zfcos,wk_zfsin
          call m_ES_betar_dot_WFs_4_lmta_k_blk_3D(ik,ibsize,ibl1,ibl2,psi_ri &
               & ,iksnl,snl, msize,LD11,tran1,ia1,ia2) !  --> bp_tmp1, bp_tmp2
       end do

! === DEBUG by tkato 2011/07/12 ================================================
!      call post_lmta_k_blk(ista_k,iend_k, fsr_l_2D,fsi_l_2D)
       if(k_symmetry(ik) /= GAMMA) then
          call post_lmta_k_blk(ista_k,iend_k,n,fsr_l_2D,fsi_l_2D)
       else
          call post_lmta_k_blk(ista_k,iend_k,n,fsr_l_2D)
       endif
! ==============================================================================
       msizesum = msizesum+msize

       call dealloc_wkbp(ik)
       ia1 = ia2+1
       if(ia1 > natm) exit Mblock
    end do Mblock
!----
!   end do
!----

    if(ipribetar >= 2) call wd_fsr_fsi_3D(ik)

    deallocate(psi_ri)
!!$    call dealloc_wkother()
    call dealloc_wkarai()
    call dealloc_wkzfsincos()


!f reduce_scatter f
!modify2010
   if(nrank_g > 1) then
                                                 __TIMER_COMM_START_w_BARRIER(mpi_ke_world,419)
!    call mpi_reduce_scatter(fsr_l_2D,fsr_l(n,1,ik),nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
!    if(k_symmetry(ik) /= GAMMA) call mpi_reduce_scatter(fsi_l_2D,fsi_l(n,1,ik),nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call mpi_reduce_scatter(fsr_l_2D,wk_fsr_2D,nel_fs*npesize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    if(k_symmetry(ik) /= GAMMA) call mpi_reduce_scatter(fsi_l_2D,wk_fsi_2D,nel_fs*npesize,&
                                    & mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                 __TIMER_COMM_STOP(419)
     iend = n+npesize-1
     if(iend >= np_e) iend=np_e
!OCL NOFLTLD
     do i = n,iend
     do j = 1,np_fs
        bpr_l(i,j,ik) = wk_fsr_2D(i-n+1,j)
        if(k_symmetry(ik) /= GAMMA)bpi_l(i,j,ik) = wk_fsi_2D(i-n+1,j)
     enddo;enddo
   else
     iend = n+npesize-1
     if(iend >= np_e) iend=np_e
     do i = n,iend
     do j = 1,np_fs
        bpr_l(i,j,ik) = fsr_l_2D(i-n+1,j)
        if(k_symmetry(ik) /= GAMMA)bpi_l(i,j,ik) = fsi_l_2D(i-n+1,j)
     enddo;enddo
!     fsr_l(:,:,ik)=fsr_l_2D(:,:)
!     if(k_symmetry(ik) /= GAMMA) fsi_l(:,:,ik)=fsi_l_2D(:,:)
   endif

  enddo ! npesize

  call tstatc0_end(id_sname)

! for eigen value sort 
  if(present(mod_ball) .and. mod_ball == ON) then
                                                 __TIMER_COMM_START(420)
  do i=1,np_e
    do j=1,np_fs
      wk_fsr_l(j,i)=bpr_l(i,j,ik)
      if(k_symmetry(ik) /= GAMMA) wk_fsi_l(j,i)=bpi_l(i,j,ik)
    enddo
  enddo
                                                 __TIMER_COMM_STOP(420)
                                                 __TIMER_COMM_START_w_BARRIER(mpi_kg_world,421)
  call mpi_allgatherv(&
       & wk_fsr_l,np_fs*np_e,mpi_double_precision,wk_fsr_ball(1,1),ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
  if(k_symmetry(ik) /= GAMMA)call mpi_allgatherv(wk_fsi_l,np_fs*np_e,mpi_double_precision,&
! === DEBUG for -check all =====================================================
!                                 &wk_fsi_ball(1,1),ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
                                  &wk_fsi_ball,ball_buff,ball_addr,mpi_double_precision,mpi_kg_world,ierr)
! ==============================================================================
                                                 __TIMER_COMM_STOP(421)
                                                 __TIMER_COMM_START(422)
!OCL NOFLTLD
  do i=1,neg
    do j=1,np_fs
      fsr_ball(i,j,ik)=wk_fsr_ball(j,i)
      if(k_symmetry(ik) /= GAMMA) fsi_ball(i,j,ik)=wk_fsi_ball(j,i)
    enddo
  enddo
                                                 __TIMER_COMM_STOP(422)

   end if

   deallocate(wk_fsr_l,wk_fsr_ball)
   if(k_symmetry(ik) /= GAMMA) deallocate(wk_fsi_l,wk_fsi_ball)
   deallocfs2d = .true.
   if(present(dealloc_fs2d)) deallocfs2d = dealloc_fs2d

   if(deallocfs2d)then
    deallocate(fsr_l_2D)
    if(k_symmetry(ik) /= GAMMA) deallocate(fsi_l_2D)
   end if
                                                                __TIMER_SUB_STOP(401)
! === rspace on 3D_Parallel ==============================================================
    end if
! ========================================================================================

   contains
     subroutine cppsi_l_to_psi_ri(ibl1,ibl2,np)
       integer, intent(in) :: ibl1,ibl2,np
       integer :: ip, i, ri, iend
                                                                __TIMER_SUB_START(402)
                                                                __TIMER_DO_START(423)
       iend = np+npesize-1
       if(iend >= np_e ) iend = np_e
       do ri = 1, kimg
          do i = np, iend
             do ip = ibl1, ibl2
                psi_ri(ip-ibl1+1,i-np+1,ri) = psi_l(ip,i,ik,ri)
             end do
          end do
       end do
                                                                __TIMER_DO_STOP(423)
                                                                __TIMER_SUB_STOP(402)
     end subroutine cppsi_l_to_psi_ri

     subroutine set_msize()
       integer :: ncache, N, K, M, ia_i, ia_f, msize
       integer, save :: msize_print = OFF
                                                                __TIMER_SUB_START(403)

       if( nblocksize_betar_is_given) then
          ibsize = nblocksize_betar_dot_wfs
       else
          ibsize = nb_betar_default
          if(ipri >= 1 .and. msize_print == OFF) then
             write(nfout,'(" !ibsize(=nblocksize_betar_w) (m_ES_betar_dot_Psi_4_each_k_3D) = ",i8)') ibsize
          end if
       end if
!f
       if( ibsize == 0 ) ibsize = np_g1k(ik)
!f
!!$    ibsize=10000
    if( nblocksize_betar_nlmta_is_given) then
       M = nblocksize_betar_dot_wfs_nlmta
       if(M > nlmta) M = nlmta
    else
       ncache = (m_CtrlP_cachesize()*1024)*3/4
!F       if(ncache == 0) then
!F          M = nlmta
!F       else
          K = ibsize
          N = np_e
          if(kimg == 1) then
             if(k_symmetry(ik) == GAMMA) then
                M = (ncache - K*N*8)/((K+N)*8)
             else 
                M = (ncache - K*N*8)/((K+N)*16)
             endif
          else
             if(k_symmetry(ik) == GAMMA) then
                M = (ncache - K*N*16)/((2*K+N)*8)
             else
                M = (ncache - K*N*16)/((K+N)*16)
             end if
          endif
          if(M > nlmta) M = nlmta
!F       endif
!!$$!!$$!!
!F       M = nlmta
!!$$!!$$!!
    endif
       msize_target = M
       if(msize_target<np_e) msize_target = np_e
       if(msize_target < ilmt(1)) msize_target = ilmt(1)
       if(ipri>=1) then
          if(msize_print == OFF) then
             write(nfout,'(" mype = ",i3, " np_e, msize_target, nlmta, ibsize, np_g1k(ik)/ibsize = ",5i8 &
                  & ," <<m_ES_betar_dot_Psi_4_each_k_3D>>")') &
                  & mype, np_e, msize_target, nlmta, ibsize, np_g1k(ik)/ibsize
          end if
       end if

!F       if(ncache == 0) then
!F          msizemax = nlmta
!F          natm_redmax = natm
!F       else
          natm_redmax = 0
          msizemax = 0
          ia_i = 1
!!$          if(msize_target < ilmt(1)) then
!!$             msize = nlmta
!!$             msizemax = msize
!!$          else
             Mblock: do
                msize = ilmt(ityp(ia_i))
                do ia = ia_i+1, natm
                   it = ityp(ia)
                   msize = msize + ilmt(it)
                   if(msize > msize_target) exit
                end do
                if(ia <= natm) then
                   msize = msize - ilmt(it)
                end if
                ia_f = ia - 1
                if(ia_f - ia_i + 1 > natm_redmax) natm_redmax = ia_f -ia_i + 1
                if(msize > msizemax) msizemax = msize
                if(ipri >= 1) then
                   if(msize_print == OFF) &
                        & write(nfout,'(" ia_i, ia_f, msize = ",3i8)') ia_i, ia_f, msize
                end if
                ia_i = ia_f+1
                if(ia_i > natm) exit Mblock
             end do Mblock
!!$          end if
          if(ipri>=1) then
             if(msize_print == OFF) &
                  & write(nfout,'(" mype = ",i3, " msizemax, natm_redmax = ",2i8)') mype, msizemax, natm_redmax
          end if
!F       end if
       msize_print = ON
!!$$!!$$!!
!F       msizemax = nlmta
!F       natm_redmax = natm
!!$$!!$$!!
                                                                __TIMER_SUB_STOP(403)
     end subroutine set_msize

     subroutine pre_lmta_k_blk(msize,LD11,LD12)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
       integer,intent(out) :: msize,LD11, LD12
       integer :: icnt, ia, it, lmt1
                                                                __TIMER_SUB_START(404)

       icnt = 0
!!$       do ia = 1, natm
       do ia = ia1, ia2
          it = ityp(ia)
          do lmt1 = 1, ilmt(it)
             icnt = icnt+1
!!$             mil(icnt) = mod( ltp(lmt1,it),4)
!!$             lmtt_tmp(icnt) = lmtt(lmt1,it)
!!$             ia_tmp(icnt) = ia-ia1+1
          end do
       end do
       msize = icnt
       if(npesize .gt. msize) then
          LD11 = npesize ; LD12 = msize
          tran1 = .true.
       else
          LD11 = msize ; LD12 = npesize
          tran1 = .false.
       end if
#ifdef SX
       if( mod(LD11,2) .eq. 0) LD11 = LD11+1
#endif
                                                                __TIMER_SUB_STOP(404)
     end subroutine pre_lmta_k_blk

    subroutine post_lmta_k_blk( k1,k2,np,bpr_l,bpi_l)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, Octover 2009 : multipication of i^L is removed
      integer,intent(in)  :: k1,k2,np
!f      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2)  ::  bpr_l,bpi_l  ! MPI
! === DEBUG by tkato 2011/07/12 ================================================
!     real(kind=DP),intent(out),dimension(np_e,nlmta)  ::  bpr_l,bpi_l  ! MPI
      real(kind=DP),intent(out),dimension(npesize,nlmta)          :: bpr_l
      real(kind=DP),intent(out),dimension(npesize,nlmta),optional :: bpi_l
! ==============================================================================
      integer :: j,ib, iend
                                                                __TIMER_SUB_START(405)
                                                                __TIMER_DO_START(424)
       iend = np+npesize-1
       if(iend >= np_e ) iend = np_e

      if(k_symmetry(ik) == GAMMA) then  !! betar_dot_WFs_core2_blk
         if(tran1) then
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) = bp_tmp1(ib,j)
                  bpr_l(ib,j+msizesum) = bp_tmp1(ib,j)
!!                  bpr_l(ib,j+msizesum) = bpr_l(ib,j+msizesum) + bp_tmp1(ib,j)
               enddo
            enddo
         else
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) = bp_tmp1(j,ib)
                  bpr_l(ib,j+msizesum) = bp_tmp1(j,ib)
!!                  bpr_l(ib,j+msizesum) = bpr_l(ib,j+msizesum) + bp_tmp1(j,ib)
               enddo
            enddo
         endif
      else
         if(tran1) then
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) =  bp_tmp1(ib,j)
!f                  bpi_l(ib,j+msizesum,ik) =  bp_tmp2(ib,j)
                  bpr_l(ib,j+msizesum) =  bp_tmp1(ib,j)
                  bpi_l(ib,j+msizesum) =  bp_tmp2(ib,j)
!!                  bpr_l(ib,j+msizesum) =  bpr_l(ib,j+msizesum) + bp_tmp1(ib,j)
!!                  bpi_l(ib,j+msizesum) =  bpi_l(ib,j+msizesum) + bp_tmp2(ib,j)
               end do
            end do
          else
!cdir nodep
            do j = 1, msize
               do ib = 1, npesize
!f                  bpr_l(ib,j+msizesum,ik) =  bp_tmp1(j,ib)
!f                  bpi_l(ib,j+msizesum,ik) =  bp_tmp2(j,ib)
                  bpr_l(ib,j+msizesum) =  bp_tmp1(j,ib)
                  bpi_l(ib,j+msizesum) =  bp_tmp2(j,ib)
!!                  bpr_l(ib,j+msizesum) =  bpr_l(ib,j+msizesum) + bp_tmp1(j,ib)
!!                  bpi_l(ib,j+msizesum) =  bpi_l(ib,j+msizesum) + bp_tmp2(j,ib)
               end do
            end do
          endif
       end if
                                                                __TIMER_DO_STOP(424)
                                                                __TIMER_SUB_STOP(405)
    end subroutine post_lmta_k_blk

  end subroutine m_ES_betar_dot_Psi_k_3D_snl
#else
  subroutine m_ES_betar_dot_Psi_4_each_k_3D(nfout,ik)
    integer, intent(in)    :: nfout, ik
    integer :: ia, iksnl, mapmode

    print *,"ERROR : Not Support Multi Dimension Para on DGEM"
    MPI_ABORT(mpi_comm_world, 141, ik)

  end subroutine m_ES_betar_dot_Psi_4_each_k_3D
#endif
!! #ifdef NONLOCAL_DGEMM end


  subroutine m_ES_betar_dot_WFs_4_lmta_k_3D(k1,k2,ik,psi_l,ia,iksnl,snl_or_snld,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!!$    real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l ! MPI
!!$    real(kind=DP),intent(inout),dimension(np_e,np_fs,k1:k2) :: bpr_l,bpi_l ! MPI
    real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l ! MPI
! === DEBUG by tkato 2011/08/31 ================================================
!   real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
! ==============================================================================

    integer                    ::it, lmt1, lmtt1, lmta1, il1
    integer :: id_sname = -1
#ifndef SX
! NEC tune ------------------------------->
    integer :: ibl1,ibl2,ibsize,ncache
    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) then
       ibsize = iend_g1k(ik) - ista_g1k(ik) + 1
    else
    if(k_symmetry(ik) == GAMMA) then ! core2
      if(kimg == 1) then ! ar(i):1,psi_l(i,ib,ik,1):np_e or
                         ! ar(i):1,psi_l(i,ib,ik,2):np_e
        ibsize=ncache/(8*(np_e+1))
      else !  ar(i),ai(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,2):np_e*2  or
           !  ai(i),ar(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,2):np_e*2
        ibsize=ncache/(8*(2+np_e*2))
      endif
    else ! ar(i),ai(i):2,psi_l(i,ib,ik,1),psi_l(i,ib,ik,1):np_e*2
      ibsize=ncache/(8*(2+np_e*2))
    endif
    end if
! nec debug
!  write(6,887) 'ik=',ik,' np_e=',np_e,' iba(ik)=',iba(ik),' ibsize=',ibsize,&
!      ' ncache=',ncache
! 887 format(a,i3,a,i4,a,i6,a,i6,a,i8)
! NEC tune ------------------------------->
#endif

    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_3D ',id_sname)

    it    = ityp(ia)
#ifndef SX
! NEC tune ------------------------------->
    do ibl1=ista_g1k(ik),iend_g1k(ik),ibsize
    ibl2=ibl1+ibsize-1
    if(ibl2.gt.iend_g1k(ik)) ibl2=iend_g1k(ik)
! nec debug
!  write(6,888) 'ibl1,ibl2=',ibl1,ibl2,' iba(ik)=',iba(ik)
! 888 format(a,2i6,a,i6)
! NEC tune <-------------------------------
#endif
    do lmt1 = 1, ilmt(it)
       lmtt1 = lmtt(lmt1,it)
       lmta1 = lmta(lmt1,ia)
       il1   = ltp(lmt1,it)
!!$       do so = 1, mso+1
!!$          lmtt1 = lmtt0*mso - (mso-so)
!!$          lmta1 = lmta1*mso - (mso-so)
!!$          lmtt1 = nlmtt*(so-1) + lmtt0
!!$          lmta1 = nlmta*(so-1) + lmta0
       call G_dot_R_mult_snl(snl_or_snld)   ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2(il1,psi_l,bpr_l)  ! lmta1, ar,ai,psi_l -> bpr_l
       else
          call betar_dot_WFs_core(psi_l,bpr_l,bpi_l) ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bpr_l,bpi_l
#ifdef SX
! NEC tune ------------------------------->
          call multiple_i_l()                 !   i**l*( )
#else
          if(ibl2.eq.iend_g1k(ik))then
            call multiple_i_l()                 !   i**l*( )
          endif
! NEC tune <-------------------------------
#endif
       end if
    end do
#ifndef SX
! NEC tune ------------------------------->
    end do
! NEC tune <-------------------------------
#endif
    call tstatc0_end(id_sname)
  contains
    subroutine G_dot_R_mult_snl(snl_or_snld)
! === DEBUG by tkato 2011/08/31 ================================================
!     real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
! ==============================================================================
      integer :: i, i1, iadd
#ifdef BETAR_GAMMA_TUNE
      integer :: mil
#endif
      integer :: id_sname = -1
      call tstatc0_begin('G_dot_R_mult_snl ',id_sname)

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
#ifdef BETAR_GAMMA_TUNE
         mil = mod(il1,4)
         if(mapmode == MAPPED) then
            if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
               if(mil == 1 .or. mil == 3) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                    ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                    ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                     ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                     ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else if(mil == 2 .or. mil == 0) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     ar(1) = 0.d0
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                    ai(iadd) = -zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                    ar(iadd) =  zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                     ai(iadd) = -zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                     ar(iadd) =  zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               end if
            else
               if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                  ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
               endif
               do i = ibl1, ibl2
                  iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!                 ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!                 ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
                  ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
                  ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
               end do
            end if
         else
            if(kimg==2 .and. k_symmetry(ik) == GAMMA) then
               if(mil == 1 .or. mil ==3) then
                  if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                     i1    = nbase(1,ik)
                     ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
                     i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                    ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                    ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                     ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                     ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else if(mil == 2 .or. mil == 0) then
                  if(ista_g1k(ik).eq.1)then
                     ar(1) = 0.d0
                  endif
                  do i = ibl1, ibl2
                     iadd = i - ista_g1k(ik) + 1
                     i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                    ai(iadd) = -zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                    ar(iadd) =  zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                     ai(iadd) = -zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                     ar(iadd) =  zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
                  end do
               else
               end if
            else
               if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
                  i1    = nbase(1,ik)
                  ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
               endif
               do i = ibl1, ibl2
                  iadd = i - ista_g1k(ik) + 1
                  i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!                 ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!                 ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
                  ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
                  ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
               end do
            end if
         end if
#else
         if(mapmode == MAPPED) then
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1) then
               ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
!              ai(iadd) = zfsin(i)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         else
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               i1    = nbase(1,ik)
               ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
!              ai(iadd) = zfsin(i1)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end if
#endif
         if(ipri>=3 ) then
            write(nfout,'(" --- ar --- <<G_dot_R_mult_snl>>")')
            write(nfout,'(5f20.10)') (ar(i),i=1,iend_g1k(ik)-ista_g1k(ik)+1)
            write(nfout,'(" --- ai --- <<G_dot_R_mult_snl>>")')
            write(nfout,'(5f20.10)') (ai(i),i=1,iend_g1k(ik)-ista_g1k(ik)+1)
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               ar(1) = zfcos(1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         else
#ifdef SX
! NEC tune ------------------------------->
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            if(ibl1.ne.1 .and. ibl2.eq.iend_g1k(ik) .and. ista_g1k(ik).eq.1)then
               i1    = nbase(1,ik)
               ar(1) = zfcos(i1)*snl_or_snld(1,lmtt1,iksnl)
            endif
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = ibl1, ibl2
! NEC tune <-------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               i1    = nbase(i,ik)
! === DEBUG by tkato 2011/08/31 ================================================
!              ar(iadd) = zfcos(i1)*snl_or_snld(i,lmtt1,iksnl)
               ar(iadd) = zfcos(i1)*snl_or_snld(iadd,lmtt1,iksnl)
! ==============================================================================
            end do
         end if
      end if
      call tstatc0_end(id_sname)
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core(psi_l,bpr_l,bpi_l)
      real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!      real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l, bpi_l ! MPI
      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l, bpi_l ! MPI
      real(kind=DP) :: bpr, bpi
      integer       :: ib, i, iadd

      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core ',id_sname)

#ifndef SX
! NEC tune --------------------------->
!      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
!      bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      if(ibl1.eq.ista_g1k(ik))then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
         bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif
! NEC tune <---------------------------
#endif

! nec debug
!      write(6,999) 'np_e=',np_e,' ik=',ik,' iba(ik)=',iba(ik),' k1,k2=',k1,&
!         ',',k2,' kimg=',kimg,' ibl1,ibl2=',ibl1,',',ibl2,' lmta1=',lmta1
! 999 format(a,i3,a,i1,a,i5,a,i1,a,i1,a,i1,a,i5,a,i5,a,i5)

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
         do ib = 1, np_e ! MPI
#ifdef SX
! NEC tune ------------------------------------------>
            bpr = 0.d0; bpi = 0.d0
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = ibl1, ibl2
! NEC tune <------------------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)
               bpi = bpi + ai(iadd)*psi_l(iadd,ib,ik,1)
!!$               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(i)*psi_l(i,ib,ik,1)
!!$               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(i)*psi_l(i,ib,ik,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
#ifndef SX
         if(ibl2 .eq. iend_g1k(ik)) then
#endif
            call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
         endif
#endif
      else if(kimg == 2) then
!!$#ifdef _VECTOR_TUNING_
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
         do ib = 1, np_e ! MPI
#ifdef SX
! NEC tune ------------------------------------------>
            bpr = 0.d0; bpi = 0.d0
            do i = ista_g1k(ik), iend_g1k(ik)
#else
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = ibl1, ibl2
! NEC tune <------------------------------------------
#endif
               iadd = i - ista_g1k(ik) + 1
               bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)-ai(iadd)*psi_l(iadd,ib,ik,2)
               bpi = bpi + ai(iadd)*psi_l(iadd,ib,ik,1)+ar(iadd)*psi_l(iadd,ib,ik,2)
!!$               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
!!$               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
#ifndef SX
         if(ibl2 .eq. iend_g1k(ik)) then
#endif
            call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
         endif
#endif
!$#else
!!$         do ib = 1, np_e                   ! MPI
!!$            bpr = 0.d0; bpi = 0.d0
!!$            do i = 1, iba(ik)
!!$               bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
!!$               bpi = bpi + ai(i)*psi_l(i,ib,ik,1)
!!$            end do
!!$            do i = 1, iba(ik)
!!$               bpr = bpr - ai(i)*psi_l(i,ib,ik,2)
!!$               bpi = bpi + ar(i)*psi_l(i,ib,ik,2)
!!$            end do
!!$            bpr_l(ib,lmta1,ik) = bpr
!!$            bpi_l(ib,lmta1,ik) = bpi
!!$         end do
!!$#endif
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1,psi_l,bpr_l)
      integer, intent(in) :: il1
      real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l ! MPI
!!$      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l ! MPI
!      real(kind=DP),intent(out),dimension(np_e,np_fs,k1:k2) :: bpr_l ! MPI
      real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) :: bpr_l ! MPI
      integer       :: ib, i, mil, iadd
      real(kind=DP) :: bpr, fp

#ifndef SX
! NEC tune ------------------------------->
      integer :: ibl1_2
#endif
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core2 ',id_sname)

#ifdef SX
      bpr_l(1:np_e,lmta1,ik) = 0.d0 ! MPI
#else
      if(ibl1.eq.1) then
        ibl1_2=2
      else
        ibl1_2=ibl1
      endif
      if(ibl1.eq.ista_g1k(ik))then
        bpr_l(1:np_e,lmta1,ik) = 0.d0 ! MPI
      endif
! NEC tune <-------------------------------
#endif
      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1)
               end do
#ifdef SX
! NEC tune ------------------------------->
               if(ista_g1k(ik) == 1) then
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
               else
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
               endif
#else
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
#else
               if(ibl2.eq.iend_g1k(ik))then
                  bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         end if
      else if(kimg == 2) then
#ifdef BETAR_GAMMA_TUNE

            do ib = 1, np_e
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1) - ai(iadd)*psi_l(iadd,ib,ik,2)
               end do
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif

            end do
            if(ibl2 .eq. iend_g1k(ik)) then
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
            endif
#else
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ar(iadd)*psi_l(iadd,ib,ik,1) - ai(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               if(ista_g1k(ik) == 1) then
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
               else
                  bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
               endif
#else
               if(ibl2.eq.iend_g1k(ik))then
                  if(ista_g1k(ik) == 1) then
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
                  else
                     bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr)
                  endif
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
#ifdef SX
! NEC tune ------------------------------->
               bpr = 0.d0
               do i = max(2,ista_g1k(ik)), iend_g1k(ik)
#else
               bpr = bpr_l(ib,lmta1,ik)
               do i = ibl1_2, ibl2
! NEC tune <-------------------------------
#endif
                  iadd = i - ista_g1k(ik) + 1
                  bpr = bpr + ai(iadd)*psi_l(iadd,ib,ik,1) + ar(iadd)*psi_l(iadd,ib,ik,2)
               end do
#ifdef SX
! NEC tune ------------------------------->
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
#else
               if(ibl2.eq.iend_g1k(ik))then
                  bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
               else
                  bpr_l(ib,lmta1,ik) = bpr
               endif
! NEC tune <-------------------------------
#endif
            end do
#ifndef SX
            if(ibl2 .eq. iend_g1k(ik)) then
#endif
               call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
#ifndef SX
            endif
#endif
         end if
#endif
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_3D

  subroutine m_ES_betar_dot_WFs_4_lmta_k_div(k1,k2,ik,ibsize,ibl1,ibl2,psi_l,ia,iksnl,snl_or_snld,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ibsize,ibl1,ibl2, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) ::  psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta,k1:k2) ::  bpr_l,bpi_l  ! MPI
    real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld

    integer                    ::it, lmt1, lmtt1, lmta1, il1
    integer :: id_sname = -1
    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_div ',id_sname)

    it    = ityp(ia)

    do lmt1 = 1, ilmt(it)
       lmtt1 = lmtt(lmt1,it)
       lmta1 = lmta(lmt1,ia)
       il1   = ltp(lmt1,it)
       call G_dot_R_mult_snl(snl_or_snld)   ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2(il1,psi_l,bpr_l)  ! lmta1, ar,ai,psi_l -> bpr_l
       else
          call betar_dot_WFs_core(psi_l,bpr_l,bpi_l) ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bpr_l,bpi_l
#ifndef BETAR_GAMMA_TUNE
          if(ibl2.eq.iba(ik))then
            call multiple_i_l()                 !   i**l*( )
          endif
#endif
       end if
    end do
    call tstatc0_end(id_sname)

  contains
    subroutine G_dot_R_mult_snl(snl_or_snld)
      real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      integer :: i
#ifdef BETAR_GAMMA_TUNE
      integer :: mil
      real(kind=DP) :: fp
#endif
      integer :: id_sname = -1
      call tstatc0_begin('G_dot_R_mult_snl ',id_sname)

      if(mapmode /= MAPPED) then
         stop ' mapmode /= MAPPED <<G_dot_R_mult_snl in m_ES_betar_dot_WFs_4_lmta_k_div>>'
      end if

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
#ifdef BETAR_GAMMA_TUNE
         mil = mod(il1,4)
         if(k_symmetry(ik) == GAMMA) then
            if(mil == 0 .or. mil == 1) then
               fp = 2.d0
            else if(mil == 2 .or. mil == 3) then
               fp = -2.d0
            end if
            if(mil == 0 .or. mil == 2) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
               if(ibl1 == 1) then
                  ar(1) = 0.d0; ai(1) = 0.d0
               end if
            else if(mil == 1 .or. mil == 3) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = -fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
               if(ibl1 == 1) then
                  ar(1) = ar(1)*0.5d0; ai(1) = 0.d0
               end if
            end if
         else
            if(mil == 0 .or. mil == 1) then
               fp = 1.d0
            else if(mil == 2 .or. mil == 3) then
               fp = -1.d0
            end if
            if(mil == 0 .or. mil == 2) then
               do i = 1, ibl2-ibl1+1
                  ar(i) =  fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = -fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
            else if(mil == 1 .or. mil == 3) then
               do i = 1, ibl2-ibl1+1
                  ar(i) = fp*zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
                  ai(i) = fp*zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
               end do
            end if
!!$            do i = 1, ibl2-ibl1+1
!!$               ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
!!$               ai(i) = zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
!!$            end do
         end if
#else
         do i = 1, ibl2-ibl1+1
            ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
            ai(i) = zfsin(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
         end do
#endif
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         do i = 1, ibl2-ibl1+1
            ar(i) = zfcos(i)*snl_or_snld(i+ibl1-1,lmtt1,iksnl)
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core(psi_l,bpr_l,bpi_l)
      real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) :: psi_l        ! MPI
      real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l,bpi_l  ! MPI
      real(kind=DP) :: bpr, bpi
      integer       :: ib, i
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core ',id_sname)

      if(ibl1.eq.1)then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
         bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif

      if(kimg == 1) then
         do ib = 1, np_e                   ! MPI
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)
               bpi = bpi + ai(i)*psi_l(i,ib,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
      else if(kimg == 2) then
         do ib = 1, np_e                   ! MPI
            bpr = bpr_l(ib,lmta1,ik)
            bpi = bpi_l(ib,lmta1,ik)
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)-ai(i)*psi_l(i,ib,2)
               bpi = bpi + ai(i)*psi_l(i,ib,1)+ar(i)*psi_l(i,ib,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr
            bpi_l(ib,lmta1,ik) = bpi
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo
      integer :: id_sname = -1
      call tstatc0_begin('multiple_i_l ',id_sname)

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
      call tstatc0_end(id_sname)
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1,psi_l,bpr_l)
      integer, intent(in) :: il1
      real(kind=DP),intent(in), dimension(ibsize,np_e,kimg) :: psi_l        ! MPI
      real(kind=DP),intent(inout),dimension(np_e,nlmta,k1:k2) :: bpr_l  ! MPI
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      integer :: ibl1_2
      integer :: id_sname = -1
      call tstatc0_begin('betar_dot_WFs_core2 ',id_sname)

      if(ibl1.eq.1) then
         bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      endif

#ifdef BETAR_GAMMA_TUNE
      if(kimg == 1) then
         do ib = 1, np_e
            bpr = 0.d0
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1)
            end do
            bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + bpr
         end do
      else if(kimg == 2) then
         do ib = 1, np_e
            bpr = 0.d0
            do i = 1, ibl2-ibl1+1
               bpr = bpr + ar(i)*psi_l(i,ib,1) + ai(i)*psi_l(i,ib,2)
            end do
            bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + bpr
         end do
      end if
#else
      if(ibl1.eq.1) then
        ibl1_2=2
      else
        ibl1_2=1
      endif

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if

      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,1)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
               if(ibl1 == 1) bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*psi_l(1,ib,1)*ar(1)
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
            do ib = 1, np_e
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ar(i)*psi_l(i,ib,1) - ai(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
               if(ibl1 == 1) bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*psi_l(1,ib,1)*ar(1)
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
            do ib = 1, np_e
               bpr = bpr_l(ib,lmta1,ik)
               bpr = 0.d0
               do i = ibl1_2, ibl2-ibl1+1
                  bpr = bpr + ai(i)*psi_l(i,ib,1) + ar(i)*psi_l(i,ib,2)
               end do
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + fp*2.d0*bpr
            end do
         end if
      end if
#endif
      call tstatc0_end(id_sname)
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_div

#ifdef NONLOCAL_DGEMM

  subroutine m_ES_betar_dot_WFs_4_lmta_k_blk_3D(ik,ibsize,ibl1,ibl2,psi_l,iksnl,snl_or_snld &
       &                               ,msize,LD11, tran1, ia1, ia2 )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
    integer, intent(in) :: ik, ibsize,ibl1,ibl2, iksnl
    integer, intent(in) :: msize,LD11,ia1,ia2
    logical, intent(in) :: tran1
    real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) ::  psi_l
!f    real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) ::  snl_or_snld
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(np_g1k(ik),nlmtt,iksnl:iksnl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(kg1,nlmtt,iksnl:iksnl) ::  snl_or_snld
    integer :: id_sname = -1
                                                                __TIMER_SUB_START(406)
!!$    integer :: id_sname2 = -1
    call tstatc0_begin('m_ES_betar_dot_WFs_4_lmta_k_blk ',id_sname)

!!$    if(npes > 1) then
!!$       call tstatc0_begin('mpi_barrier(betar_dot_WFs) ',id_sname2)
!!$       call mpi_barrier(mpi_k_world(myrank_k),ierr)
!!$       call tstatc0_end(id_sname2)
!!$    end if

       call G_dot_R_mult_snl_blk(snl_or_snld)      ! lmtt1, exp(iGR), zfcos,zfsin,snl_or_snld ->ar,ai
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFs_core2_blk(ibsize,tran1,psi_l )  ! lmta1, ar,ai,psi_l -> bp_tmp1
       else
          call betar_dot_WFs_core_blk (ibsize,tran1, psi_l )  ! lmta1, sum(c(k+G)exp(iGR)*snl() ,ar,ai,psi_l -> bp_tmp1, bp_tmp2
       end if

    call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(406)
  contains
    subroutine G_dot_R_mult_snl_blk(snl_or_snld)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, Octover 2009 : mapping algorithm with the subroutine "post_lmta_k_blk"
!
!f      real(kind=DP),intent(in), dimension(kg1,nlmtt,ista_snl:iend_snl) :: snl_or_snld
      real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt,ista_snl:iend_snl) :: snl_or_snld
!    real(kind=DP),intent(in), dimension(np_g1k(ik),nlmtt,iksnl:iksnl) ::  snl_or_snld
!    real(kind=DP),intent(in), dimension(kg1,nlmtt,iksnl:iksnl) ::  snl_or_snld
      integer :: j, i
      integer :: mil0, ia, it, lmt1, lt
      real(kind=DP) :: fp, fp0
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(407)
      call tstatc0_begin('G_dot_R_mult_snl_blk ',id_sname)

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(k_symmetry(ik) == GAMMA) then
            fp0 = 2.d0
         else
            fp0 = 1.d0
         end if

         j = 0
                                                                __TIMER_DO_START(425)
         do ia = 1, ia2-ia1+1
            it = ityp(ia+ia1-1)
            do lmt1 = 1, ilmt(it)
               j = j + 1
               mil0 = mod(ltp(lmt1,it),4)
               lt = lmtt(lmt1,it)
               if(mil0 == 0 .or. mil0 == 1) then
                  fp = fp0
               else if(mil0 == 2 .or. mil0 == 3) then
                  fp = -fp0
               end if
               if(k_symmetry(ik) == GAMMA) then
                  if(mil0 == 0 .or. mil0 == 2) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                     if(ibl1 == 1 .and. myrank_g == 0) then
                        wk_ar(1, j) = 0.d0; wk_ai(1, j) = 0.d0
                     end if
                  else if(mil0 == 1 .or. mil0 == 3) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = -fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                     if(ibl1 == 1 .and. myrank_g == 0) then
                        wk_ar(1, j) = wk_ar(1,j)*0.5d0; wk_ai(1, j) = 0.d0
                     end if
                  end if
               else
                  if(mil0 == 0 .or. mil0 == 2) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) =  fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = -fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                  else if(mil0 == 1 .or. mil0 == 3) then
                     do i = 1, ibl2-ibl1+1
                        wk_ar(i,j) = fp*wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                        wk_ai(i,j) = fp*wk_zfsin(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
                     end do
                  end if
               end if
            end do
         end do
                                                                __TIMER_DO_STOP(425)
      else ! if(kimg== 1 .and. k_symmetry(ik) == GAMMA) then
         j = 0
                                                                __TIMER_DO_START(426)
         do ia = 1, ia2-ia1+1
            it = ityp(ia+ia1-1)
            do lmt1 = 1, ilmt(it)
               j = j+1
               lt = lmtt(lmt1,it)
               do i = 1, ibl2-ibl1+1
                  wk_ar(i,j) = wk_zfcos(i,ia)*snl_or_snld(i+ibl1-1,lt,iksnl)
               end do
            end do
         end do
                                                                __TIMER_DO_STOP(426)
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(427)
    end subroutine G_dot_R_mult_snl_blk

    subroutine betar_dot_WFs_core_blk( ibsize, tran1,  psi_l )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer,intent(in)  :: ibsize
      logical, intent(in)  :: tran1
      real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) :: psi_l
      integer       :: icsize, M, LDA, LDB
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(408)
      call tstatc0_begin('betar_dot_WFs_core_blk ',id_sname)

      M = msize
      icsize = ibl2-ibl1+1
      LDA = ibsize;   LDB = ibsize
      if(kimg == 1) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(411)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ai,LDA,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(411)
         else
                                                              __TIMER_DGEMM_START(412)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ai,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(412)
         end if
      else if(kimg == 2) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(413)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize,-1.d0,psi_l(1,1,2),LDB,wk_ai,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,1),LDB,wk_ai,LDA,1.d0,bp_tmp2,LD11)
            call DGEMM__('T','N',npesize,M,icsize, 1.d0,psi_l(1,1,2),LDB,wk_ar,LDA,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(413)
         else
                                                              __TIMER_DGEMM_START(414)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize,-1.d0,wk_ai,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ai,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp2,LD11)
            call DGEMM__('T','N',M,npesize,icsize, 1.d0,wk_ar,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp2,LD11)
                                                              __TIMER_DGEMM_STOP(414)
         endif
      end if
      call tstatc0_end(id_sname)
                                                                __TIMER_SUB_STOP(408)
    end subroutine betar_dot_WFs_core_blk

    subroutine betar_dot_WFs_core2_blk( ibsize, tran1,  psi_l )
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
!
      integer, intent(in)  :: ibsize
      logical, intent(in)  :: tran1
      real(kind=DP),intent(in), dimension(ibsize,npesize,kimg) :: psi_l  ! MPI

      integer       :: icsize, M, LDA, LDB
      integer :: id_sname = -1
                                                                __TIMER_SUB_START(409)
      call tstatc0_begin('betar_dot_WFs_core2_blk ',id_sname)

      icsize = ibl2-ibl1+1
      M = msize
      LDA = ibsize; LDB = ibsize
      if(kimg == 1) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(415)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(415)
         else
                                                              __TIMER_DGEMM_START(416)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(416)
         endif
      else if(kimg==2) then
         if(tran1) then
                                                              __TIMER_DGEMM_START(417)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,1),LDB,wk_ar,LDA,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',npesize,M,icsize,1.d0,psi_l(1,1,2),LDB,wk_ai,LDA,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(417)
         else
                                                              __TIMER_DGEMM_START(418)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ar,LDA,psi_l(1,1,1),LDB,1.d0,bp_tmp1,LD11)
            call DGEMM__('T','N',M,npesize,icsize,1.d0,wk_ai,LDA,psi_l(1,1,2),LDB,1.d0,bp_tmp1,LD11)
                                                              __TIMER_DGEMM_STOP(418)
         end if
      end if
      call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(409)
    end subroutine betar_dot_WFs_core2_blk
  end subroutine m_ES_betar_dot_WFs_4_lmta_k_blk_3D


#endif
!! #ifdef NONLOCAL_DGEMM end

  subroutine m_ES_add_betar_dot_WFs(nfout)
    integer, intent(in)    :: nfout

    integer ia, ik, iksnl, mapmode
    integer     :: id_sname = -1

    if(sw_use_add_proj == OFF) return

    call tstatc0_begin('m_ES_add_betar_dot_WFs ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_add_betar_dot_WFs --")')
    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
! ================================== modified by K. Tagami ============= 11.0
!       if(kv3/nspin == 1) then
!          call G_dot_R_map(ia,1)
!          mapmode = MAPPED
!       else
!          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
!          mapmode = NOTMAPPED
!       end if
          if ( kv3/nspin == 1) then
            mapmode = MAPPED
            call G_dot_R(ia,mapmode,1)
         else
            mapmode = NOTMAPPED
            call G_dot_R(ia,mapmode)
         end if
! ====================================================================== 11.0

       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI

! ================================= modified by K. Tagami ============== 11.0
!          iksnl = (ik-1)/nspin + 1
!
          if ( noncol ) then
            iksnl = ( ik-1 ) / ndim_spinor + 1
          else
            iksnl = (ik-1)/nspin + 1
          endif
! ====================================================================== 11.0

          call m_ES_add_betar_dot_WFs_4_lmta_k(ista_k,iend_k,ik,zaj_l,ia,iksnl,snl_add,fsr_add_l,fsi_add_l,mapmode)
       end do
    end do
    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()
    if(ipri >= 2) then
       write(nfout,'(" --- fsr_add_l, fsi_add_l ---")')
       do ik = ista_k, iend_k                              ! MPI
          call wd_fsr_fsi_add(ik)                          ! MPI
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ES_add_betar_dot_WFs

  subroutine wd_fsr_fsi_add(ik)
    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- fsr_add --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (fsr_add_l(map_z(it),ia,ik),ia=1,nlmta_add)
       end do
    else
       write(nfout,'(" -- fsr_add, fsi_add --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (fsr_add_l(map_z(it),ia,ik),fsi_add_l(map_z(it),ia,ik),ia=1,nlmta_add)!MPI
       end do
    end if
  end subroutine wd_fsr_fsi_add

  subroutine m_ES_add_betar_dot_WFs_4_lmta_k(k1,k2,ik,psi_l,ia,iksnl,snl_add,bpr_l,bpi_l,mapmode)
    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_add,k1:k2) ::    bpr_l,bpi_l  ! MPI
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_add,ista_snl:iend_snl) :: snl_add

    integer                    ::it, lmt1, lmtt1, lmta1, il1

    it    = ityp(ia)
    do lmt1 = 1, ilmt_add(it)
       lmtt1 = lmtt_add(lmt1,it)
       lmta1 = lmta_add(lmt1,ia)
       il1   = ltp_add(lmt1,it)
       call G_dot_R_mult_snl()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call betar_dot_WFS_core2(il1)
       else
          call betar_dot_WFs_core() ! sum(c(k+G)exp(iGR)*snl_add()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_snl()
      integer :: i, i1, iadd

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA)) then
         if(mapmode == MAPPED) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               ar(iadd) = zfcos(i)*snl_add(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i)*snl_add(iadd,lmtt1,iksnl)
            end do
         else
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1 = nbase(i,ik)
               ar(iadd) = zfcos(i1)*snl_add(iadd,lmtt1,iksnl)
               ai(iadd) = zfsin(i1)*snl_add(iadd,lmtt1,iksnl)
            end do
         end if
      else ! if(kimg == 1 .and. k_symmetry(ik) == GAMMA) then
         if(mapmode == MAPPED) then
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               ar(iadd) = zfcos(i)*snl_add(iadd,lmtt1,iksnl)
            end do
         else
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               i1 = nbase(i,ik)
               ar(iadd) = zfcos(i1)*snl_add(iadd,lmtt1,iksnl)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_snl

    subroutine betar_dot_WFs_core()
      integer       :: ib, i, iadd

      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI
      bpi_l(1:np_e,lmta1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
         do ib = 1, np_e                   ! MPI
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(iadd)*psi_l(iadd,ib,ik,1)
               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(iadd)*psi_l(iadd,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         do ib = 1, np_e                   ! MPI
            do i = ista_g1k(ik), iend_g1k(ik)
               iadd = i - ista_g1k(ik) + 1
               bpr_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik) + ar(iadd)*psi_l(iadd,ib,ik,1)-ai(iadd)*psi_l(iadd,ib,ik,2)
               bpi_l(ib,lmta1,ik) = bpi_l(ib,lmta1,ik) + ai(iadd)*psi_l(iadd,ib,ik,1)+ar(iadd)*psi_l(iadd,ib,ik,2)
            end do
         end do
      end if
      call mpi_allreduce(MPI_IN_PLACE,bpr_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      call mpi_allreduce(MPI_IN_PLACE,bpi_l(1,lmta1,ik),np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
    end subroutine betar_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            bpr_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpi_l(ib,lmta1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = bpi_l(ib,lmta1,ik)
            bpi_l(ib,lmta1,ik) = -bpr_l(ib,lmta1,ik)
            bpr_l(ib,lmta1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine betar_dot_WFs_core2(il1)
      integer, intent(in) :: il1

      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      bpr_l(1:np_e,lmta1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               bpr_l(ib,lmta1,ik) = fp*2.d0*bpr
            end do
         end if
      end if
    end subroutine betar_dot_WFs_core2
  end subroutine m_ES_add_betar_dot_WFs_4_lmta_k


  subroutine add_overlap_phirt_psirpw
    integer :: ik, ia, it, lmt1, lmt2, p, q, s
    integer :: il1, il2, im1, im2, t1, t2
    integer :: ikphig
    real(kind=DP) :: ctmp, c1

    Do ik=1, kv3
       if ( map_k(ik) /= myrank_k ) cycle

       ikphig = ( ik -1 )/nspin +1

       Do ia=1, natm
          it = ityp(ia)

          Do lmt1=1, ilmt_phi(it)
             il1=ltp_phi(lmt1,it);  im1 = mtp_phi(lmt1,it);  t1 = taup_phi(lmt1,it)
             p = lmta_phi(lmt1,ia);  s = lmtt_phi(lmt1,it)
             c1 = sqrt( norm_phig( s,ikphig ) )

             Do lmt2=1, ilmt(it)
                il2=ltp(lmt2,it);  im2 = mtp(lmt2,it);  t2 = taup(lmt2,it)
                if ( il1 /= il2 ) cycle
                if ( im1 /= im2 ) cycle

                q = lmta(lmt2,ia)
                ctmp = q_phirt_pw(il1,t1,t2,it) /c1

                if ( k_symmetry(ik) == GAMMA ) then
                   compr_l(:,p,1,ik) = compr_l(:,p,1,ik) &
                        &              +ctmp *fsr_l(:,q,ik) 
                else
                   compr_l(:,p,1,ik) = compr_l(:,p,1,ik) +ctmp *fsr_l(:,q,ik)
                   compi_l(:,p,1,ik) = compi_l(:,p,1,ik) +ctmp *fsi_l(:,q,ik)
                endif
             End Do
          End Do
       End Do
    End Do
  end subroutine add_overlap_phirt_psirpw

  subroutine set_compri_if_anfiferro
    integer :: ik, iorb, jorb, mm, iopr

    iopr = nopr +af

    Do ik=1, kv3, af+1
       if ( map_k(ik) /= myrank_k ) cycle

       compr_l( :,:,1,ik+1 ) = 0.d0
       compi_l( :,:,1,ik+1 ) = 0.d0

       if (k_symmetry(ik) == GAMMA) then
          do iorb=1,nlmta_phi
             do mm=1,nrorb(iorb,iopr)
                jorb = irorb(mm,iorb,iopr)
                compr_l( :,iorb,1,ik+1 ) = compr_l( :,iorb,1,ik+1 ) &
                     &                   + compr_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
             end do
          end do
       else
          do iorb=1,nlmta_phi
             do mm=1,nrorb(iorb,iopr)
                jorb=irorb(mm,iorb,iopr)
                compr_l( :,iorb,1,ik+1 ) = compr_l( :,iorb,1,ik+1 ) &
                     &                   + compr_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
                compi_l( :,iorb,1,ik+1 ) = compi_l( :,iorb,1,ik+1 ) &
                     &                   + compi_l( :,jorb,1,ik )*crorb(mm,iorb,iopr)
             end do
          end do
      endif
    end Do

  end subroutine set_compri_if_anfiferro

  subroutine wd_compr_compi(ik)
    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- compr --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (compr_l(map_z(it),ia,1,ik),ia=1,nlmta_phi)!MPI
       end do
    else
       write(nfout,'(" -- compr, compi --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
          write(nfout,'(6d12.4)') (compr_l(map_z(it),ia,1,ik),compi_l(map_z(it),ia,1,ik),ia=1,nlmta_phi)!MPI
       end do
    end if
  end subroutine wd_compr_compi

  subroutine m_ES_phir_dot_WFs_3D(nfout)
    integer, intent(in)    :: nfout

    integer ia, ik, ikphig, mapmode
    integer     :: id_sname = -1
    call tstatc0_begin('m_ES_phir_dot_WFs_3D ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_phir_dot_WFs_3D --")')
    call m_ES_alloc_zfsincos(0)
    call m_ES_alloc_arai_3D(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
! ============================ modified by K. Tagami ================ 11.0
!       if(kv3/nspin == 1) then
!          call G_dot_R_map(ia,1)
!          mapmode = MAPPED
!       else
!          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
!          mapmode = NOTMAPPED
!       end if
!
       if(kv3/nspin == 1) then
!!$          call G_dot_R_map(ia,1)
          mapmode = MAPPED
          call G_dot_R(ia,mapmode,1)
       else
!!$          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
          mapmode = NOTMAPPED
          call G_dot_R(ia,mapmode)
       end if
! ====================================================================== 11.0

       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI
! ==================================== modified by K. Tagami ============ 11.0
!          ikphig = (ik-1)/nspin + 1
          if ( noncol ) then
            ikphig = (ik-1)/ndim_spinor + 1
          else
            ikphig = (ik-1)/nspin + 1
          endif
! ====================================================================== 11.0          

          call m_ES_phir_dot_WFs_4_lmta_k_3D( ista_k, iend_k, ik, zaj_l, ia, ikphig, &
               &                           phig, nopr, compr_l, compi_l, mapmode )
       end do
    end do

    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_arai_3D()
    call m_ES_dealloc_zfsincos()

    if ( orb_popu_method == 2 )  call add_overlap_phirt_psirpw
    if ( af == 1 ) call set_compri_if_anfiferro

    if(ipri >= 2) then
       write(nfout,'(" --- compr_l, compi_l ---")')
       do ik = ista_k, iend_k                            ! MPI
          call wd_compr_compi(ik)                        ! MPI
       end do
    end if
    call tstatc0_end(id_sname)
  end subroutine m_ES_phir_dot_WFs_3D

  subroutine m_ES_phir_dot_WFs_4_lmta_k_3D( k1, k2, ik, psi_l, ia, ikphig, phig, &
       &                                 nopr, cr_l, ci_l, mapmode )
    integer, intent(in)    :: k1,k2, ik, ia, ikphig, mapmode, nopr
    real(kind=DP),intent(in), dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_phi,nopr,k1:k2) ::    cr_l,ci_l  ! MPI
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_phi,ista_snl:iend_snl) :: phig

    integer                    ::it, lmt1, lmtt1, lmta1, il1, ierr

    it    = ityp(ia)
    do lmt1 = 1, ilmt_phi(it)
       lmtt1 = lmtt_phi(lmt1,it)
       lmta1 = lmta_phi(lmt1,ia)
       il1   = ltp_phi(lmt1,it)
       call G_dot_R_mult_phig()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call phir_dot_WFs_core2(il1) ! sum(c(k+G)exp(iGR)*phig()
       else
          call phir_dot_WFs_core() ! sum(c(k+G)exp(iGR)*phig()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_phig()
      integer :: i, i1, iadd

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, np_g1k(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, np_g1k(ik)
               i1    = nbase(i+ista_g1k(ik)-1,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, np_g1k(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, np_g1k(ik)
               i1    = nbase(i+ista_g1k(ik)-1,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_phig

    subroutine phir_dot_WFs_core()
      integer       :: ib, i
      real(kind=DP), allocatable, dimension(:) :: cr,ci
      allocate(cr(np_e));cr=0.0d0
      allocate(ci(np_e));ci=0.d0
      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI
      ci_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
         do ib = 1, np_e                   ! MPI
            do i = 1, np_g1k(ik)
               cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)
               ci(ib) = ci(ib) + ai(i)*psi_l(i,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 2, np_g1k(ik)
                  cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = cr(ib)*2.d0 + ar(1)*psi_l(1,ib,ik,1)-ai(1)*psi_l(1,ib,ik,2)
            end do
         else
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 1, np_g1k(ik)
                  cr(ib) = cr(ib) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
                  ci(ib) = ci(ib) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
               end do
            end do
         end if
      end if
      call mpi_allreduce(MPI_IN_PLACE,cr,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      call mpi_allreduce(MPI_IN_PLACE,ci,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      cr_l(1:np_e,lmta1,1,ik) = cr(1:np_e)
      ci_l(1:np_e,lmta1,1,ik) = ci(1:np_e)
      deallocate(cr,ci)
    end subroutine phir_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            cr_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -ci_l(ib,lmta1,1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine phir_dot_WFs_core2(il1)
      integer, intent(in) :: il1
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp
      real(kind=DP), allocatable, dimension(:) :: cr
      allocate(cr(np_e));cr=0.d0
      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e                   ! MPI
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               cr(ib) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, np_g1k(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr(ib) = fp*2.d0*bpr
            end do
         end if
      end if
      call mpi_allreduce(MPI_IN_PLACE,cr,np_e,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_ke_world,ierr)
      cr_l(:,lmta1,1,ik) = cr(:)
      deallocate(cr)
    end subroutine phir_dot_WFs_core2
  end subroutine m_ES_phir_dot_WFs_4_lmta_k_3D

  subroutine m_ES_phir_dot_WFs_4_lmta_k( k1, k2, ik, psi_l, ia, ikphig, phig, &
       &                                 nopr, cr_l, ci_l, mapmode )
    integer, intent(in)    :: k1,k2, ik, ia, ikphig, mapmode, nopr
    real(kind=DP),intent(in), dimension(kg1,np_e,k1:k2,kimg) :: psi_l        ! MPI
    real(kind=DP),intent(out),dimension(np_e,nlmta_phi,nopr,k1:k2) ::    cr_l,ci_l  ! MPI
    real(kind=DP),intent(in), dimension(kg1,nlmtt_phi,ista_snl:iend_snl) :: phig

    integer                    ::it, lmt1, lmtt1, lmta1, il1

    it    = ityp(ia)
    do lmt1 = 1, ilmt_phi(it)
       lmtt1 = lmtt_phi(lmt1,it)
       lmta1 = lmta_phi(lmt1,ia)
       il1   = ltp_phi(lmt1,it)
       call G_dot_R_mult_phig()             ! exp(iGR)
       if(k_symmetry(ik) == GAMMA) then
          call phir_dot_WFs_core2(il1) ! sum(c(k+G)exp(iGR)*phig()
       else
          call phir_dot_WFs_core() ! sum(c(k+G)exp(iGR)*phig()
          call multiple_i_l()                 !   i**l*( )
       end if
    end do
  contains
    subroutine G_dot_R_mult_phig()
      integer :: i, i1

      if(kimg == 2 .or. (kimg ==1 .and. k_symmetry(ik) /= GAMMA) ) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, iba(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, iba(ik)
               i1    = nbase(i,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
               ai(i) = zfsin(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      else  ! if(kimg == 1 .and. k_symmetry == GAMMA) then
         if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
            do i = 1, iba(ik)
               ar(i) = zfcos(i)*phig(i,lmtt1,ikphig)
            end do
         else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
            do i = 1, iba(ik)
               i1    = nbase(i,ik)
               ar(i) = zfcos(i1)*phig(i,lmtt1,ikphig)
            end do
         end if
      end if
    end subroutine G_dot_R_mult_phig

    subroutine phir_dot_WFs_core()
      integer       :: ib, i

      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI
      ci_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
         do ib = 1, np_e                   ! MPI
            do i = 1, iba(ik)
               cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)
               ci_l(ib,lmta1,1,ik) = ci_l(ib,lmta1,1,ik) + ai(i)*psi_l(i,ib,ik,1)
            end do
         end do
      else if(kimg == 2) then
         if(k_symmetry(ik) == GAMMA) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 2, iba(ik)
                  cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)*2.d0 + ar(1)*psi_l(1,ib,ik,1)-ai(1)*psi_l(1,ib,ik,2)
            end do
         else
#ifdef VPP
*vocl loop, unroll(4)
#endif
            do ib = 1, np_e                   ! MPI
               do i = 1, iba(ik)
                  cr_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik) + ar(i)*psi_l(i,ib,ik,1)-ai(i)*psi_l(i,ib,ik,2)
                  ci_l(ib,lmta1,1,ik) = ci_l(ib,lmta1,1,ik) + ai(i)*psi_l(i,ib,ik,1)+ar(i)*psi_l(i,ib,ik,2)
               end do
            end do
         end if
      end if
    end subroutine phir_dot_WFs_core

    subroutine multiple_i_l
      integer mil, ib
      real(kind=DP) :: tempo

      mil = mod(il1,4)
      if(mil == 2) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = -tempo
         end do
      else if(mil == 3) then
         do ib = 1, np_e                 ! MPI
            cr_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -ci_l(ib,lmta1,1,ik)
         end do
      else if(mil == 0) then
         do ib = 1, np_e                 ! MPI
            tempo = ci_l(ib,lmta1,1,ik)
            ci_l(ib,lmta1,1,ik) = -cr_l(ib,lmta1,1,ik)
            cr_l(ib,lmta1,1,ik) = tempo
         end do
      end if
    end subroutine multiple_i_l

    subroutine phir_dot_WFs_core2(il1)
      integer, intent(in) :: il1
      integer       :: ib, i, mil
      real(kind=DP) :: bpr, fp

      cr_l(1:np_e,lmta1,1,ik) = 0.d0        ! MPI

      mil = mod(il1,4)
      if(mil == 0 .or. mil == 1) then
         fp = 1.d0
      else if(mil == 2 .or. mil == 3) then
         fp = -1.d0
      end if
      if(kimg == 1) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e                   ! MPI
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1)
               end do
               cr_l(ib,lmta1,1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*2.d0*bpr
            end do
         end if
      else if(kimg == 2) then
         if(mil == 1 .or. mil == 3) then ! l = 0, 4, 8, ... or 2, 6, 10, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ar(i)*psi_l(i,ib,ik,1) - ai(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*(2.d0*bpr + psi_l(1,ib,ik,1)*ar(1))
            end do
         else if(mil == 2 .or. mil == 0) then ! l = 1, 5, 9, ... or 3, 7, 11, ...
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
            do ib = 1, np_e
               bpr = 0.d0
               do i = 2, iba(ik)
                  bpr = bpr + ai(i)*psi_l(i,ib,ik,1) + ar(i)*psi_l(i,ib,ik,2)
               end do
               cr_l(ib,lmta1,1,ik) = fp*2.d0*bpr
            end do
         end if
      end if
    end subroutine phir_dot_WFs_core2
  end subroutine m_ES_phir_dot_WFs_4_lmta_k


  subroutine m_ES_PAO_WFs_3D(nfout)

    integer, intent(in)    :: nfout

    integer ia, ik, iksnl, mapmode
    integer     :: id_sname = -1

    call tstatc0_begin('m_ES_PAO_WFs ',id_sname,level=1)

    if(ipri >= 2) write(nfout,'(" -- m_ES_PAO_WFs --")')
    call m_ES_alloc_zfsincos(0)
    call alloc_zfsincos_mpi()
    do ia = 1, natm
       if(kv3/nspin == 1) then
!!$          call G_dot_R_map(ia,1)
          mapmode = MAPPED
          call G_dot_R(ia,mapmode,1)
       else
!!$          call G_dot_R_mpi(ia) ! pos(ia,1:3), ngabc -> zfcos,zfsin
          mapmode = NOTMAPPED
          call G_dot_R(ia,mapmode)
       end if
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI
          iksnl = (ik-1)/nspin + 1
          call m_ES_PAO_WFs_4_lmta_k_3D(ista_k,iend_k,ik,ia,iksnl,paog,zaj_l,mapmode)
       end do
    end do
    call dealloc_zfsincos_mpi()
    call m_ES_dealloc_zfsincos()
    call tstatc0_end(id_sname)
  end subroutine m_ES_PAO_WFs_3D

  subroutine m_ES_PAO_WFs_4_lmta_k_3D(k1,k2,ik,ia,iksnl,paog,psi_l,mapmode)

    integer, intent(in)    :: k1,k2, ik, ia, iksnl, mapmode
    real(kind=DP),intent(in), dimension(maxval(np_g1k),nlmtt_pao,ista_snl:iend_snl) :: paog ! MPI
    real(kind=DP),intent(out), dimension(maxval(np_g1k),ista_e:iend_e,k1:k2,kimg) :: psi_l        ! MPI

    integer                    ::it, lmt1, lmtt1, lmta1, il1, ib, ib2

    it    = ityp(ia)
    do lmt1 = 1, ilmt_pao(it)
       lmtt1 = lmtt_pao(lmt1,it)
       lmta1 = lmta_pao(lmt1,ia)
       il1   = ltp_pao(lmt1,it)
       ib    = ibpao(lmta1)
       ib2   = 0
       if(ib < 0) then
          ib = abs(ib)
          ib2 = ib + 1
       end if
       if(ib >= ista_e .and. ib <= iend_e) then
          call G_dot_R_mult_paog(ib,.true.)             ! exp(iGR)
       end if
       if(ib2 >= ista_e .and. ib2 <= iend_e) then
          call G_dot_R_mult_paog(ib2,.false.)             ! exp(iGR)
       end if
    end do
  contains
    subroutine G_dot_R_mult_paog(ib,fcos)
      integer, intent(in) :: ib
      logical, intent(in) :: fcos
      integer :: i, i1, mil
      if(kimg==1) then
         if(fcos) then
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfcos(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfcos(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         else
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfsin(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfsin(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         end if
      else
         mil = mod(il1,4)
         if(mil == 1 .or. mil == 3) then
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = zfcos(i)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) = zfsin(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = zfcos(i1)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) = zfsin(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         else
            if(mapmode == MAPPED) then
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO
#endif
               do i = 1, np_g1k(ik)
                  psi_l(i,ib,ik,1) = -zfsin(i)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) =  zfcos(i)*paog(i,lmtt1,iksnl)
               end do
            else
#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(i1)
#endif
               do i = 1, np_g1k(ik)
                  i1    = nbase(i+ista_g1k(ik)-1,ik)
                  psi_l(i,ib,ik,1) = -zfsin(i1)*paog(i,lmtt1,iksnl)
                  psi_l(i,ib,ik,2) =  zfcos(i1)*paog(i,lmtt1,iksnl)
               end do
            end if
         end if
      end if
    end subroutine G_dot_R_mult_paog

  end subroutine m_ES_PAO_WFs_4_lmta_k_3D

  subroutine wd_fsr_fsi_3D(ik)

    integer, intent(in) :: ik
    integer :: it, ia
    if(k_symmetry(ik) == GAMMA) then
       write(nfout,'(" -- fsr --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
! === DEBUG by tkato 2013/08/28 ================================================
!         write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),ia=1,nlmta)!MPI
          write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),ia=1,np_fs)!MPI
! ==============================================================================
       end do
    else
       write(nfout,'(" -- fsr, fsi --")')
       do it = 1, neg
          if(map_e(it) /= myrank_e) cycle                  ! MPI
          write(nfout,'(" ik = ",i8," ib = ",i8)') ik, it
! === DEBUG by tkato 2013/08/28 ================================================
!         write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),fsi_l(map_z(it),ia,ik),ia=1,nlmta)!MPI
          write(nfout,'(6d12.4)') (fsr_l(map_z(it),ia,ik),fsi_l(map_z(it),ia,ik),ia=1,np_fs)!MPI
! ==============================================================================
       end do
    end if
    call flush(nfout)
  end subroutine wd_fsr_fsi_3D

  subroutine m_ES_betar_dot_WFs_3D(nfout,ik)
!
! Revised by T. Kokubo & D. Fukata (NEC), September 2009
! Revised by T. Yamasaki, October 2009 : Mblock
!
    use m_Parallelization,only      : ball_buff, ball_addr

    integer, intent(in)    :: nfout, ik
    integer :: iksnl, ibsize
    integer :: datasize

    integer :: ia, it, lmt1, msize, msize_target, msizemax, msizesum, natm_redmax
    integer :: ibl1,ibl2, ia1, ia2
    integer :: LD11,  LD12
    logical :: tran1
!!$    integer, allocatable, dimension(:) :: mil
    real(kind=DP), allocatable, dimension(:,:,:) :: psi_ri
!f
!   real(kind=DP),allocatable, dimension(:,:) :: fsr_l_2D,fsi_l_2D
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_l,wk_fsi_l
    real(kind=DP),allocatable, dimension(:,:) :: wk_fsr_ball,wk_fsi_ball
    integer :: i, j, k 

    integer :: id_sname = -1
! === rspace on 3D_Parallel ==============================================================
    logical :: flag_in_realspace
    call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)
  end subroutine m_ES_betar_dot_WFs_3D

  subroutine build_fft_map(nfft,kimg)
    integer, intent(in) :: nfft,kimg
    integer :: ia,nma,im
    if(.not.allocated(mapl)) allocate(mapl(nfft/2))
    mapl = .false.
    do ia=ista_atm,iend_atm
       nma = nmesh_rs(ia) 
       do im=1,nma
          mapl(meshxyz_rs(im,ia)) = .true.
       enddo
    enddo
    nonzero_fft_elements = 0
    do ia=ista_atm,iend_atm
       nma = nmesh_rs(ia) 
       do im=1,nma
          if(mapl(meshxyz_rs(im,ia))) nonzero_fft_elements = nonzero_fft_elements + 1
       enddo
    enddo
    write(0,*) 'nfft, nonzero_fft_elements ',nfft,nonzero_fft_elements
  end subroutine build_fft_map

  subroutine allreduce_wf(lsize,kimg,nfft,ibsize,psi_l,bff)
    integer, intent(in) :: lsize,kimg,nfft,ibsize
    real(kind=DP), dimension(lsize*kimg,ibsize), intent(in) :: psi_l
    real(kind=DP), dimension(nfft,ibsize), intent(out) :: bff
    integer :: imesh,i,j,ierr,ib
    integer :: id_sname = -1
    call tstatc0_begin('allreduce_wf ',id_sname)
    bff = 0.d0
    do ib=1,ibsize
    do imesh=1,lsize
       i = 2*dist_to_full(imesh)
       j = 2*imesh
       bff(i-1,ib) = psi_l(j-1,ib)
       bff(i,ib)   = psi_l(j,ib)
    enddo
    enddo
    call mpi_allreduce(mpi_in_place,bff,nfft*ibsize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
    call tstatc0_end(id_sname)
  end subroutine allreduce_wf

  subroutine betar_dot_Psi_4_each_k_in_rs(nfout,k1,k2,ik,psi_l,bpr_l,bpi_l)
    integer,intent(in) :: nfout 
    integer,intent(in) :: k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l
    real(kind=DP),intent(out),dimension(np_e,nlmta) :: bpr_l, bpi_l
    call betar_dot_Psi_4_each_k_in_rs0(nfout,k1,k2,ik,psi_l,bpr_l,bpi_l,nmesh_rs_max,snl_rs)
  end subroutine betar_dot_Psi_4_each_k_in_rs

  subroutine betar_dot_Psi_4_each_k_in_rs0(nfout,k1,k2,ik,psi_l,bprt,bpit,nsnl,snlsnl)
    use m_Parallelization,    only : nel_fft_z, nel_fft_y, nel_fft_x,ista_lmta,iend_lmta
    integer,intent(in) :: nfout 
    integer,intent(in) :: k1,k2,ik
    real(kind=DP),intent(in),dimension(maxval(np_g1k),np_e,k1:k2,kimg) :: psi_l
    real(kind=DP),intent(out),dimension(np_e,nlmta) :: bprt, bpit
    integer, intent(in) :: nsnl
    real(kind=DP), intent(in), dimension(nsnl,ista_lmta:iend_lmta) :: snlsnl
    integer :: ia,ib
    real(kind=DP),allocatable,dimension(:,:) :: cos_kr,sin_kr
#ifdef MULT_PHASE_RSPACE
    real(kind=DP),allocatable,dimension(:) :: cos_a,sin_a
#endif
    real(kind=DP), allocatable, dimension(:,:) :: bff
    real(kind=DP), allocatable, dimension(:,:) :: wk_bfft_l
    real(kind=DP), allocatable, dimension(:,:) :: rrr, iii
    integer :: id_sname = -1
    integer :: ib1, ib2, ibsize, isrsize, lsize, iesize, ierr,i,j
    logical, save :: initialized = .false.
    call tstatc0_begin('betar_dot_Psi_4_each_k_in_rs ',id_sname,level=1)
    if(.not.initialized)then
    call build_fft_map(nfft,kimg)
    initialized = .true.
    endif
    lsize = max(maxval(nel_fft_x(:)),maxval(nel_fft_y(:)),maxval(nel_fft_z(:)))
!    if(.not.initialized) then
!       call build_fft_map(lsize,nfft,kimg)
!       initialized = .true.
!    endif
    ibsize = nblocksize_rspace_betar
    if(ibsize<1) ibsize = 1
    if(ibsize>np_e) ibsize = np_e
!    if (nblocksize_fftw_is_given) then
!       ibsize = nblocksize_fftw
!       if(ibsize < 1) ibsize = 1
!    endif

    call alloc_work_arrays()
    call k_dot_r(ik,cos_kr,sin_kr)
#ifdef MULT_PHASE_RSPACE
    call k_dot_pos(ik,cos_a,sin_a)
#endif
    do ib1=1,np_e, ibsize
       !ib2 = min(ib1+ibsize-1,np_e)
       ib2 = min(ibsize,np_e+1-ib1)
       call m_ES_WF_2D_psi(ik,wk_bfft_l,psi_l,min(ibsize+ib1-1,np_e),ib1,k1,k2,ibsize,lsize,INVERSE,bff)
!       call m_ES_WF_in_Rspace_3D(k1,k2,ik,ib1,ib2,ibsize,lsize,psi_l,wk_bfft_l)
!       call allreduce_wf(lsize,kimg,nfft,ibsize,wk_bfft_l,bff)
       do ia=ista_atm,iend_atm
          call betar_dot_Psi_atm_band_pre(bff,ia)
          call betar_dot_Psi_atm_band(ia)
       enddo
    enddo
    
    if(nrank_g>1)then
       call mpi_allreduce(mpi_in_place,bprt,np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       if(k_symmetry(ik) /= GAMMA) then
          call mpi_allreduce(mpi_in_place,bpit,np_e*nlmta,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       endif
    endif

    call dealloc_work_arrays()
    call tstatc0_end(id_sname)

    !write(nfout,'(a)') 'fsr fsr '
    !do i=1,np_e
    !   write(nfout,'(a,i8)') 'band ',i
    !   write(nfout,'(5f20.10)') (bprt(i,j),j=1,nlmta)
    !enddo
    contains

    subroutine alloc_work_arrays()
       allocate(wk_bfft_l(lsize*kimg,ibsize))
       allocate(bff(nfft,ibsize));bff=0.d0
       allocate(cos_kr(nmesh_rs_max,natm));cos_kr=0.d0
       allocate(sin_kr(nmesh_rs_max,natm));sin_kr=0.d0
#ifdef MULT_PHASE_RSPACE
       allocate(cos_a(natm));cos_a=0.d0
       allocate(sin_a(natm));sin_a=0.d0
#endif
       allocate(rrr(nmesh_rs_max,ibsize)); rrr = 0.0d0
       allocate(iii(nmesh_rs_max,ibsize)); iii = 0.0d0
    end subroutine alloc_work_arrays

    subroutine dealloc_work_arrays()
       deallocate(wk_bfft_l)
       deallocate(bff)
       deallocate(cos_kr)
       deallocate(sin_kr)
#ifdef MULT_PHASE_RSPACE
       deallocate(cos_a)
       deallocate(sin_a)
#endif
       deallocate(rrr)
       deallocate(iii)
    end subroutine dealloc_work_arrays

    subroutine betar_dot_Psi_atm_band_pre(bff,iatm)
       real(kind=DP),dimension(nfft,ibsize),intent(in) :: bff
       integer,intent(in) :: iatm
       integer :: lmt1,i,lmta1,imesh,nma,it,ib
       real(kind=DP) :: s,bpr,bpi
       real(kind=DP) :: fac,cosa,sina,rr,ii,psr,psi
       real(kind=DP), allocatable, dimension(:) :: cos_krt,sin_krt
#ifdef USE_DDOT
       real(kind=DP) :: ddot
#endif
       integer :: id_sname=-1
       call tstatc0_begin('betar_dot_Psi_atm_band_pre ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
       nma = nmesh_rs(iatm)
       it = ityp(iatm)
#ifdef MULT_PHASE_RSPACE
       cosa = cos_a(iatm)
       sina = sin_a(iatm)
#endif
       allocate(cos_krt(nma));cos_krt(:) = cos_kr(:,iatm)
       allocate(sin_krt(nma));sin_krt(:) = sin_kr(:,iatm)
!       do ib=ib1,ib2
       do ib=1,ib2
       if(kimg==1)then
          do i=1,nma
             imesh   = 2*meshxyz_rs(i,iatm)
#ifdef MULT_PHASE_RSPACE
             psr = bff(imesh-1,ib)
             psi = bff(imesh,ib)*meshxyz_rs_conjg(i,iatm)
             rr = psr*cosa-psi*sina
             ii = psi*cosa+psr*sina
#else
             rr = bff(imesh-1,ib)
             ii = bff(imesh,ib)*meshxyz_rs_conjg(i,iatm)
#endif
             rrr(i,ib) = rr*cos_krt(i)-ii*sin_krt(i) 
             iii(i,ib) = ii*cos_krt(i)+rr*sin_krt(i)
          enddo
       else
          do i=1,nma
             imesh   = 2*meshxyz_rs(i,iatm)
#ifdef MULT_PHASE_RSPACE
             psr = bff(imesh-1,ib)
             psi = bff(imesh,ib)
             rr = psr*cosa-psi*sina
             ii = psi*cosa+psr*sina
#else
             rr = bff(imesh-1,ib)
             ii = bff(imesh,ib)
#endif
             rrr(i,ib) = rr*cos_krt(i)-ii*sin_krt(i) 
             iii(i,ib) = ii*cos_krt(i)+rr*sin_krt(i)
          enddo
       endif
       enddo
       deallocate(cos_krt,sin_krt)
       call tstatc0_end(id_sname)
    end subroutine betar_dot_Psi_atm_band_pre

    subroutine betar_dot_Psi_atm_band(iatm)
       integer,intent(in) :: iatm
       integer :: lmt1,i,lmta1,imesh,nma,it,ib,iband
       real(kind=DP) :: s,bpr,bpi
       real(kind=DP) :: fac,cosa,sina,rr,ii,psr,psi
#ifdef USE_DDOT
       real(kind=DP) :: ddot
#endif
       integer :: id_sname=-1
       call tstatc0_begin('betar_dot_Psi_atm_band ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
       nma = nmesh_rs(iatm)
       it = ityp(iatm)
#ifdef NO_DGEMM_RSPACE
       do ib=1,ib2
          iband = ib+ib1-1
          do lmt1=1,ilmt(it)
             lmta1 = lmta(lmt1,iatm)
#ifdef USE_DDOT
             bprt(iband,lmta1) = fac*ddot(nma,snlsnl(1:nma,lmta1),1,rrr(1:nma,ib),1)
#else
             bprt(iband,lmta1) = fac*dot_product(snlsnl(1:nma,lmta1),rrr(1:nma,ib))
#endif
          enddo
       enddo
#else
       call dgemm('T','N',ib2,ilmt(it),nma,fac,rrr,nmesh_rs_max,snlsnl(1:nma,lmta(1,iatm)) &
                     ,nmesh_rs_max,0.d0,bprt(ib1,lmta(1,iatm)),np_e)
#endif
       if(k_symmetry(ik) /= GAMMA)then
#ifdef NO_DGEMM_RSPACE
       do ib=1,ib2
          iband = ib+ib1-1
          do lmt1=1,ilmt(it)
             lmta1 = lmta(lmt1,iatm)
#ifdef USE_DDOT
             bpit(iband,lmta1) = fac*ddot(nma,snlsnl(1:nma,lmta1),1,iii(1:nma,ib),1)
#else
             bpit(iband,lmta1) = fac*dot_product(snlsnl(1:nma,lmta1),iii(1:nma,ib))
#endif
          enddo
       enddo
#else
       call dgemm('T','N',ib2,ilmt(it),nma,fac,iii,nmesh_rs_max,snlsnl(1:nma,lmta(1,iatm)) &
                     ,nmesh_rs_max,0.d0,bpit(ib1,lmta(1,iatm)),np_e)
#endif
       endif
       call tstatc0_end(id_sname)
    end subroutine betar_dot_Psi_atm_band

  end subroutine betar_dot_Psi_4_each_k_in_rs0

  subroutine Vnonlocal_W_in_realspace(ik,ispin,switch_of_eko_part)
    use m_Electronic_Structure, only : m_ES_gather_f_3d_to_2d
    integer, intent(in) :: ik,ispin
    integer, intent(in) :: switch_of_eko_part
    integer :: mdvdb, it, ia, lmt2, lmta2, il2, im2,nma
    real(kind=DP),allocatable,dimension(:,:) :: vnlr1d,vnli1d
    real(kind=DP),allocatable,dimension(:) :: sc,qc
    real(kind=DP),allocatable,dimension(:,:) :: sc_lmta,qc_lmta
    real(kind=DP),allocatable,dimension(:,:) :: cos_kr,sin_kr
#ifdef MULT_PHASE_RSPACE
    real(kind=DP),allocatable,dimension(:) :: cos_a,sin_a
#endif
    real(kind=DP),allocatable,dimension(:,:) :: bff
    real(kind=DP),allocatable,dimension(:,:) :: bffb,fsrt,fsit
    integer :: ib,ierr,ii,ib2
    integer :: ibl1,ibl2,nbsize,ibsize
    integer :: id_sname = -1,id_sname2=-1,id_sname3=-1
    call tstatc0_begin('Vnonlocal_W_in_realspace ',id_sname,level=1)
    do it = 1, ntyp
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       if(mdvdb == EXECUT) exit
    end do
    
    ibsize = nblocksize_rspace_v
    if(ibsize<1) ibsize = 1
    if(ibsize>np_e) ibsize = np_e
    call alloc_arrays()
    call m_ES_gather_f_3d_to_2d(fsr_l, fsrt, ik)
    if(k_symmetry(ik) /= GAMMA) then
      call m_ES_gather_f_3d_to_2d(fsi_l, fsit, ik)
    endif
    call k_dot_r(ik,cos_kr,sin_kr)
#ifdef MULT_PHASE_RSPACE
    call k_dot_pos(ik,cos_a,sin_a)
#endif
    Loop_natm0: do ia=ista_atm,iend_atm
       if(kimg==1)then
          nma = nmesh_rs_h(ia)
       else
          nma = nmesh_rs(ia)
       endif
       it = ityp(ia)
       mdvdb = m_PP_include_vanderbilt_pot(it)
       if(switch_of_eko_part == OFF) mdvdb= SKIP
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          il2   = ltp(lmt2,it)
          im2   = mtp(lmt2,it)
          call part_sum_over_lmt1_rs()
       enddo
    end do Loop_natm0

    do ib=1,np_e,ibsize
       bff=0.d0
       ib2 = min(ibsize,np_e+1-ib)
       Loop_natm1: do ia=ista_atm,iend_atm
          it = ityp(ia)
          mdvdb = m_PP_include_vanderbilt_pot(it)
          if(switch_of_eko_part == OFF) mdvdb= SKIP
          vnlr1d = 0.d0
          vnli1d = 0.d0
          if(kimg==1)then
             nma = nmesh_rs_h(ia)
          else
             nma = nmesh_rs(ia)
          endif
          if(mdvdb==SKIP)then
             call add_vnlph_l_without_eko_part_rs()
          else
             call add_vnlph_l_with_eko_part_rs()
          endif
          call multiply_phase()
          call map_vnl_to_bff()
       end do Loop_natm1
       if(nrank_g>1)then
         call mpi_allreduce(mpi_in_place,bff,nfft*ibsize,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
       endif
       call Vnonlocal_W_to_Gspace()
    enddo
    call dealloc_arrays()

    call tstatc0_end(id_sname)

    contains

    subroutine alloc_arrays()
       integer :: nmm
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       allocate(vnlr1d(nmm,ibsize));vnlr1d=0.d0
       allocate(vnli1d(nmm,ibsize));vnli1d=0.d0
       allocate(sc_lmta(nmm,nlmta));sc_lmta=0.d0
       if(mdvdb==EXECUT)then
          allocate(qc_lmta(nmm,nlmta));qc_lmta=0.d0
       endif
       allocate(cos_kr(nmesh_rs_max,natm));cos_kr=0.d0
       allocate(sin_kr(nmesh_rs_max,natm));sin_kr=0.d0
#ifdef MULT_PHASE_RSPACE
       allocate(cos_a(natm));cos_a=0.d0
       allocate(sin_a(natm));sin_a=0.d0
#endif
       if(sw_save_memory==ON)then
          allocate(bff(nfft,ibsize));bff=0.d0
       else
          allocate(bffb(nfft,np_e));bffb=0.d0
       endif
       allocate(fsrt(np_e,nlmta));fsrt=0.d0
       allocate(fsit(np_e,nlmta));fsit=0.d0
    end subroutine alloc_arrays

    subroutine dealloc_arrays()
       deallocate(vnlr1d)
       deallocate(vnli1d)
       deallocate(sc_lmta)
       if(allocated(qc_lmta)) deallocate(qc_lmta)
       deallocate(bff)
       deallocate(cos_kr)
       deallocate(sin_kr)
#ifdef MULT_PHASE_RSPACE
       deallocate(cos_a)
       deallocate(sin_a)
#endif
       deallocate(fsrt)
       deallocate(fsit)
    end subroutine dealloc_arrays

    subroutine part_sum_over_lmt1_rs()
       integer       :: lmta1,lmt1, il1, im1, i
       real(kind=DP) :: tmp,rr,ii
       real(kind=DP),pointer,dimension(:,:) :: snlt
       integer :: id_sname = -1
       call tstatc0_begin('part_sum_over_lmt1_rs ',id_sname,level=1)
       if(sw_save_memory/=ON)then
          sc = 0.d0
          if(mdvdb == EXECUT) then
             qc = 0.d0
          endif
       else
          sc_lmta(:,lmta2) = 0.d0
          if(mdvdb == EXECUT) then
             qc_lmta(:,lmta2) = 0.d0
          endif
       endif
       if(kimg==1)then
          snlt => snl_rs_h
       else
          snlt => snl_rs
       endif
       do lmt1 = 1,ilmt(it)
          lmta1 = lmta(lmt1,ia)
          il1   = ltp(lmt1,it)
          im1   = mtp(lmt1,it)
          if(il1 == il2 .and. im1 == im2) then
             if(ipaw(it)==0) then
                 tmp = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
             else
                 tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
             end if
          else
             if(ipaw(it)==0) then
                 tmp = vlhxcQ(lmt1,lmt2,ia,ispin)
             else
                 tmp = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
             end if
          endif
          do i=1,nma
             sc_lmta(i,lmta2) = sc_lmta(i,lmta2)+tmp*snlt(i,lmta1)
          enddo
          if(mdvdb == EXECUT .and. il1 == il2 .and. im1 == im2) then
             tmp = q(lmt1,lmt2,it)
             do i=1,nma
                qc_lmta(i,lmta2) = qc_lmta(i,lmta2) + tmp*snlt(i,lmta1)
             enddo
          end if
       end do

       call tstatc0_end(id_sname)
    end subroutine part_sum_over_lmt1_rs

    subroutine add_vnlph_l_with_eko_part_rs()
       integer :: i,iband,ib1,nmm
       real(kind=DP) :: fr,fi,e
       real(kind=DP), allocatable, dimension(:,:) :: fre,fie
       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_with_eko_part_rs ',id_sname,level=1)
#ifdef NO_DGEMM_RSPACE
       do ib1=1,ib2
       iband = ib+ib1-1
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          fr = fsrt(iband,lmta2)
          e = eko_l(iband,ik)
          do i=1,nma
             vnlr1d(i,ib1) = vnlr1d(i,ib1)+fr*(sc_lmta(i,lmta2)-e*qc_lmta(i,lmta2))
          enddo
          if(k_symmetry(ik)/=GAMMA) then
             fi = fsit(iband,lmta2)
             do i=1,nma
                vnli1d(i,ib1) = vnli1d(i,ib1)+fi*(sc_lmta(i,lmta2)-e*qc_lmta(i,lmta2))
             enddo
          endif
       enddo
       enddo
#else
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       allocate(fre(ib2,ilmt(it)));fre=0.d0
       if(k_symmetry(ik) /= GAMMA) allocate(fie(ib2,ilmt(it)));fie=0.d0
       do ib1=1,ib2
          iband = ib+ib1-1
          do lmt2 = 1, ilmt(it)
             lmta2 = lmta(lmt2,ia)
             fre(ib1,lmt2) = -fsrt(iband,lmta2)*eko_l(iband,ik)
             if(k_symmetry(ik) /= GAMMA) fie(ib1,lmt2) = -fsit(iband,lmta2)*eko_l(iband,ik)
          enddo
       enddo
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsrt(ib,lmta(1,ia)),np_e,0.d0,vnlr1d,nmm)
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,qc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fre,ib2,1.d0,vnlr1d,nmm)
       deallocate(fre)
       if(k_symmetry(ik) /= GAMMA) then
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsit(ib,lmta(1,ia)),np_e,0.d0,vnli1d,nmm)
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,qc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fie,ib2,1.d0,vnli1d,nmm)
          deallocate(fie)
       endif
#endif
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_with_eko_part_rs

    subroutine add_vnlph_l_without_eko_part_rs()
       real(kind=DP) :: fr,fi
       integer :: i,iband,ib1,nmm
       integer :: id_sname = -1
       call tstatc0_begin('add_vnlph_l_without_eko_part_rs ',id_sname,level=1)
#ifdef NO_DGEMM_RSPACE
       do ib1=1,ib2
       iband = ib1+ib-1
       do lmt2 = 1, ilmt(it)
          lmta2 = lmta(lmt2,ia)
          fr = fsrt(iband,lmta2)
          do i=1,nma
             vnlr1d(i,ib1) = vnlr1d(i,ib1)+fr*sc_lmta(i,lmta2)
          enddo
          if(k_symmetry(ik)/=GAMMA) then
             fi = fsit(iband,lmta2)
             do i=1,nma
                vnli1d(i,ib1) = vnli1d(i,ib1)+fi*sc_lmta(i,lmta2)
             enddo
          endif
       enddo
       enddo
#else
       nmm = nmesh_rs_max
       if(kimg==1) nmm = nmesh_rs_max_h
       call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsrt(ib,lmta(1,ia)),np_e,0.d0,vnlr1d,nmm)
       if(k_symmetry(ik) /= GAMMA) then
          call dgemm('N','T',nma,ib2,ilmt(it),1.d0,sc_lmta(1,lmta(1,ia)),nmesh_rs_max &
                     , fsit(ib,lmta(1,ia)),np_e,0.d0,vnli1d,nmm)
       endif
#endif
       call tstatc0_end(id_sname)
    end subroutine add_vnlph_l_without_eko_part_rs

    subroutine multiply_phase()
       integer :: i,iband,ib1
       real(kind=DP) :: rr,ii
       real(kind=DP) :: cosa,sina,fac
       integer :: id_sname = -1
       call tstatc0_begin('multiply_phase ',id_sname,level=1)
       fac = dsqrt(univol)/dble(fft_box_size_WF(1,1)*fft_box_size_WF(2,1)*fft_box_size_WF(3,1))
#ifdef MULT_PHASE_RSPACE
       cosa =  cos_a(ia)
       sina = -sin_a(ia)
#endif

       if(kimg==1)then
          do ib1=1,ib2
          do i=1,nma
#ifdef MULT_PHASE_RSPACE
             rr = cosa*vnlr1d(i,ib1)-sina*vnli1d(i,ib1)
             ii = sina*vnlr1d(i,ib1)+cosa*vnli1d(i,ib1)
#else
             rr = vnlr1d(i,ib1)
             ii = vnli1d(i,ib1)
#endif
             vnlr1d(i,ib1) = (rr*cos_kr(map_h(i,ia),ia)+ii*sin_kr(map_h(i,ia),ia))*fac
             vnli1d(i,ib1) = (ii*cos_kr(map_h(i,ia),ia)-rr*sin_kr(map_h(i,ia),ia))*fac
          enddo
          enddo
       else
          do ib1=1,ib2
          do i=1,nma
#ifdef MULT_PHASE_RSPACE
             rr = cosa*vnlr1d(i,ib1)-sina*vnli1d(i,ib1)
             ii = sina*vnlr1d(i,ib1)+cosa*vnli1d(i,ib1)
#else
             rr = vnlr1d(i,ib1)
             ii = vnli1d(i,ib1)
#endif
             vnlr1d(i,ib1) = (rr*cos_kr(i,ia)+ii*sin_kr(i,ia))*fac
             vnli1d(i,ib1) = (ii*cos_kr(i,ia)-rr*sin_kr(i,ia))*fac
          enddo
          enddo
       endif
       call tstatc0_end(id_sname)
    end subroutine multiply_phase

    subroutine map_vnl_to_bff()
       integer :: i,i1,iband,ib1
       integer :: id_sname=-1
       call tstatc0_begin('map_vnl_to_bff ',id_sname,level=1)
       if(kimg==1)then 
          do ib1=1,ib2
          do i=1,nma
             i1 = 2*meshxyz_rs_h(i,ia)
             bff(i1-1,ib1) = bff(i1-1,ib1) + vnlr1d(i,ib1)
             bff(i1,ib1)   = bff(i1,ib1)   - vnli1d(i,ib1)
          enddo
          enddo
       else
          do ib1=1,ib2
          do i=1,nma
             i1 = 2*meshxyz_rs(i,ia)
             bff(i1-1,ib1) = bff(i1-1,ib1) + vnlr1d(i,ib1)
             bff(i1,ib1)   = bff(i1,ib1)   + vnli1d(i,ib1)
          enddo
          enddo
       endif
       call tstatc0_end(id_sname)
    end subroutine map_vnl_to_bff

    subroutine Vnonlocal_W_to_Gspace()
       integer :: i,i1,ri,iband,ib1
       integer :: id_sname = -1
       call tstatc0_begin('Vnonlocal_W_to_Gspace ',id_sname)
       do ib1=1,ib2
       iband = ib1+ib-1
       vnlph_l(:,iband,:) = 0.d0
       call m_FFT_WF(ELECTRON,nfout,bff(1:nfft,ib1),DIRECT,ON)
       do ri=1,kimg
          do i=ista_g1k(ik),iend_g1k(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             vnlph_l(i-ista_g1k(ik)+1,iband,ri) = bff(i1,ib1)
          enddo
       enddo
       enddo
       call tstatc0_end(id_sname)
    end subroutine Vnonlocal_W_to_Gspace

  end subroutine Vnonlocal_W_in_realspace

  subroutine k_dot_r(ik,zc_ar,zs_ar)
    integer, intent(in) :: ik
    real(kind=DP),dimension(nmesh_rs_max,natm),intent(out) :: zc_ar,zs_ar
    integer :: ia,i
    real(kind=DP) :: inl,inm,inn
    real(kind=DP) :: rx,ry,rz,kdr
    integer :: id_sname = -1
    call tstatc0_begin('k_dot_r ',id_sname,level=1)
    inl = 1.d0/dble(fft_box_size_WF(1,1))
    inm = 1.d0/dble(fft_box_size_WF(2,1))
    inn = 1.d0/dble(fft_box_size_WF(3,1))
    do ia=ista_atm,iend_atm
       do i=1,nmesh_rs(ia)
          rx = dble(meshx_rs(i,ia))*inl
          ry = dble(meshy_rs(i,ia))*inm
          rz = dble(meshz_rs(i,ia))*inn
          kdr = (rx*vkxyz(ik,1,BUCS)+ry*vkxyz(ik,2,BUCS)+rz*vkxyz(ik,3,BUCS))*PAI2
          zc_ar(i,ia) = dcos(kdr)
          zs_ar(i,ia) = dsin(kdr)
       enddo
    enddo
  end subroutine k_dot_r

#ifdef MULT_PHASE_RSPACE
  subroutine k_dot_pos(ik,zc,zs)
    integer, intent(in) :: ik
    real(kind=DP),dimension(natm),intent(out) :: zc,zs
    real(kind=DP) :: kdp
    integer :: ia
    do ia=1,natm
       kdp = (pos(ia,1)*vkxyz(ik,1,BUCS)+pos(ia,2)*vkxyz(ik,2,BUCS)+pos(ia,3)*vkxyz(ik,3,BUCS))*PAI2
       zc(ia) =  dcos(kdp)
       zs(ia) = -dsin(kdp)
    enddo
  end subroutine k_dot_pos

#endif

end module m_ES_nonlocal

       subroutine matrix_adjust_s( n, a, b, nm )
       implicit NONE
       integer, intent(in)    :: n, nm
       real(8), intent(in)    :: a(1:n, *)
       real(8), intent(out)   :: b(1:nm, *)


          call matrix_adjust( n, a, n, b, nm )


       return
       end subroutine matrix_adjust_s
!---
       subroutine matrix_adjust( n, a, nma, b, nmb )
       use eigen_libs
       implicit NONE
!--
       integer, intent(in)    :: n, nma, nmb
       real(8), intent(in)    :: a(1:nma, *)
       real(8), intent(out)   :: b(1:nmb, *)

       integer                :: nnod, x_nnod, y_nnod
       integer                :: inod, x_inod, y_inod

       integer                :: i, i_1, i_2, i_3
       integer                :: j, j_1, j_2, j_3


          call eigen_get_procs( nnod, x_nnod, y_nnod )
          call eigen_get_id   ( inod, x_inod, y_inod )

          ! x_nnod = The number of rows
          ! y_nnod = The number of columns

          j_2 = eigen_loop_start( 1, x_nnod, x_inod )
          j_3 = eigen_loop_end  ( n, x_nnod, x_inod )
          i_2 = eigen_loop_start( 1, y_nnod, y_inod )
          i_3 = eigen_loop_end  ( n, y_nnod, y_inod )

          do i_1 = i_2, i_3
             i = eigen_translate_l2g( i_1, y_nnod, y_inod )
             do j_1 = j_2, j_3
                j = eigen_translate_l2g( j_1, x_nnod, x_inod )
                b(j_1, i_1) = a(j, i)
             end do
          end do


       return
       end subroutine matrix_adjust

      subroutine tred1_init(a, nm, n,
     &              d_out, e_out, ne,
     &              u_t, v_t, nv)
!$    use OMP_LIB
      implicit NONE

      integer, intent(in)    :: nm, n, ne, nv
      real(8), intent(inout) :: a(1:nm, *)
      real(8), intent(out)   :: d_out(*)
      real(8), intent(out)   :: e_out(1:ne, *)
      real(8), intent(in)    :: u_t(*), v_t(*)

      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  i, j

      integer                :: kx
      integer                :: local_size, local_rank

      real(8), pointer       :: u0_z(:),v0_z(:)
      real(8), pointer       :: u1_z(:),v1_z(:)
      integer                :: offset1, offset2
      integer                :: offset3, offset4
      common/tred_au_common/    u0_z, v0_z, u1_z, v1_z,
     &                          offset1, offset2, offset3, offset4

      include 'trd.h'
      include 'param.h'
      include 'CSTAB.h'


      d_out(1:n)    = ZERO
      e_out(1:n,1)  = ZERO
      e_out(1:n,2)  = ZERO

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (n, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         do i_1=i_2,i_3,i_4
!           j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
!           j_1 = loop_c_g2l_depth(j, x_nnod,x_inod)
            j   = (i_1-1)*y_nnod+y_inod
            j_1 = (j-1)/x_nnod+1
            d_out(j) = a(j_1,i_1)
         end do! i_1
      end if

      i_2 = loop_c_start(1, y_nnod,y_inod)
      i_3 = loop_c_end  (n, y_nnod,y_inod)
      do i_1=i_2,i_3
         j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
         j_2 = loop_c_start(j+1, x_nnod,x_inod)
         do j_1=j_2,nm
            a(j_1,i_1) = ZERO
         end do! j_1
         if ( j > n ) then
         do j_1=j_2,nm
            a(1:nm,i_1) = ZERO
         end do! j_1
         end if
      end do! i_1

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      allocate(u0_z(nv*local_size+n_columns),
     &         v0_z(nv*local_size+n_columns))
      allocate(u1_z(nv*local_size+n_columns),
     &         v1_z(nv*local_size+n_columns))
      call CSTAB_adjust_base(u0_z(1), u_t(1), offset1)
      call CSTAB_adjust_base(v0_z(1), v_t(1), offset2)
      call CSTAB_adjust_base(u1_z(1), u_t(1), offset3)
      call CSTAB_adjust_base(v1_z(1), v_t(1), offset4)
      kx =  (L1_WINDOW/8)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
      offset1 = offset1 + kx * 1
      offset2 = offset2 + kx * 2
      offset3 = offset3 + kx * 3
      offset4 = offset4 + kx * 4
      call CSTAB_round_offset(offset1)
      call CSTAB_round_offset(offset2)
      call CSTAB_round_offset(offset3)
      call CSTAB_round_offset(offset4)

      return
      end subroutine tred1_init


      subroutine tred1_final(a, nm, n, d_out, e_out, ne, u_t)

      implicit NONE

      integer, intent(in)    :: nm, ne, n
      real(8), intent(inout) :: a(1:nm, *)
      real(8), intent(out)   :: d_out(*)
      real(8), intent(out)   :: e_out(1:ne, *)
      real(8), intent(out)   :: u_t(*)

      integer                ::  x_pos, x_owner_nod
      integer                ::  y_pos, y_owner_nod
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  i, j, k, L
      real(8)                ::  t

      real(8), pointer       :: u0_z(:),v0_z(:)
      real(8), pointer       :: u1_z(:),v1_z(:)
      integer                :: offset1, offset2
      integer                :: offset3, offset4
      common/tred_au_common/    u0_z, v0_z, u1_z, v1_z,
     &                          offset1, offset2, offset3, offset4

      include 'trd.h'
      include 'param.h'


      if ( n >= 2 ) then
         do i = 2+MOD(n,2), 2, -1
            L = i-1
            y_owner_nod = loop_c_node (i, y_nnod,y_inod)
            x_owner_nod = loop_c_node (L, x_nnod,x_inod)
            if ( y_owner_nod == y_inod
     &         .AND. x_owner_nod == x_inod ) then
               i_1 = loop_c_g2l_depth(i, y_nnod,y_inod)
               j_1 = loop_c_g2l_depth(L, x_nnod,x_inod)
               e_out(i,1)  =  a(j_1,i_1)
               a(j_1,i_1)  =  ZERO
            end if
            L = i-2; if ( L < 1 ) cycle
            y_owner_nod = loop_c_node (i, y_nnod,y_inod)
            x_owner_nod = loop_c_node (L, x_nnod,x_inod)
            if ( y_owner_nod == y_inod
     &         .AND. x_owner_nod == x_inod ) then
               i_1 = loop_c_g2l_depth(i, y_nnod,y_inod)
               j_1 = loop_c_g2l_depth(L, x_nnod,x_inod)
               e_out(i,2)  =  a(j_1,i_1)
               a(j_1,i_1)  =  ZERO
            end if
         end do
      end if

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = loop_c_end  (n, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         do i_1=i_2,i_3,i_4
            j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
            j_1 = loop_c_g2l_depth(j, x_nnod,x_inod)
            t          = d_out(j)
            d_out(j)   = a(j_1,i_1)
            a(j_1,i_1) = t
         end do! i_1
      end if

      call reduce_dbl(d_out(1),   u_t(1), n, 1, TRD_COMM_WORLD)
      call reduce_dbl(e_out(1,1), u_t(1), n, 1, TRD_COMM_WORLD)
      call reduce_dbl(e_out(1,2), u_t(1), n, 1, TRD_COMM_WORLD)

      deallocate(u0_z, v0_z)
      deallocate(u1_z, v1_z)


      return
      end subroutine tred1_final

module m_Fcp
  use m_Const_Parameters,   only : DP,T_CONTROL,VELOCITY_SCALING,CONST_kB, &
     STEEPEST_DESCENT,VERLET,OFF,QUENCHED_MD,BFGS,GDIIS,ANEW,RENEW,ON
  use m_Control_Parameters, only : fcp_mass,fcp_temperature,fcp_mu,fcp_qmass, &
     iprifcp,printable,dtio,fcp_relax_crit,imdalg,mode_fi_coefficient,kqnmditer_p, &
     c_forc_prop_region_high,c_forc_prop_region_low,factor_prop_region,gdiis_hownew, &
     eigenvalue_threshold,sw_optimize_alpha,sw_correct_eigenvalue
  use m_Files,              only : nfout
  use m_IterationNumbers,   only : iteration_ionic
  use m_Ionic_System,       only : t_ctrl_method
  use m_Electronic_Structure, only : cps => totch, efermi
  implicit none
  private

  ! md_thermo
  real(kind=DP) :: cpd_l

  real(kind=DP) :: cpqr(2)
  real(kind=DP) :: forcp
  
  real(kind=DP) :: ekr
  real(kind=DP) :: tkb,cprv,frsv
  real(kind=DP) :: ekina,ekinq,ekbt,ega

  logical :: lfirst = .true.

  ! CG2
  integer, save :: iter_CG = 1, iter_linmin = 1, iter_CG_max = 1

  ! md
  real(kind=DP) :: cpd_old
  real(kind=DP) :: fi_coefficient = 1.d0

  ! GDIIS, BFGS
  real(kind=DP),allocatable,dimension(:)   :: u_l ! d(kqnmditer_p)
  real(kind=DP),allocatable,dimension(:)   :: w_l ! d(kqnmditer_p)
  real(kind=DP)                            :: fc_l
  integer      ,allocatable,dimension(:)   :: ncrspd ! d(kqnmditer_p)
  real(kind=DP),allocatable,dimension(:,:) :: f_gdiis ! d(kqnmditer_p,kqnmditer_p)
  real(kind=DP),allocatable,dimension(:,:) :: f_wk ! d(kqnmditer_p**2,2)
  real(kind=DP),allocatable,dimension(:)   :: f_rslv ! d(kqnmditer_p**2)
  real(kind=DP),allocatable,dimension(:)   :: g,e_wk,ww1,etot_trial
  real(kind=DP)                            :: forc_g
  integer, allocatable, dimension(:)       :: ip ! d(kqnmditer_p)
  integer, parameter                       :: UNIT = 1
  integer, save                            :: iter_gdiis = 0
  integer, save                            :: if_allocated = 0
  real(kind=DP) :: min_alpha = 1.d0,max_alpha = 2.0d0
  real(kind=DP) :: wolfe_c1=1.d-4,wolfe_c2=0.9

  ! NEB
  integer :: num_of_images
  type image_type
     real(kind=DP) :: cps      = 0.0d0
     real(kind=DP) :: cps0     = 0.0d0
     real(kind=DP) :: force    = 0.0d0
     real(kind=DP) :: force0   = 0.0d0
     real(kind=DP) :: velocity = 0.0d0
  end type image_type
  type(image_type), allocatable :: neb_image(:)
  logical, save :: cps_initialized = .false.

  public :: m_Fcp_md_thermo, m_Fcp_cg, m_Fcp_CG_reset, m_Fcp_cg2, &
     m_Fcp_Converged, m_Fcp_md, m_Fcp_gdiis, m_Fcp_gdiis_reset, &
     m_Fcp_create_replica, m_Fcp_set_neb_replica_totch, &
     m_Fcp_set_neb_replica_force, m_Fcp_update_neb, m_Fcp_replica_Converged, &
     m_Fcp_set_neb_parameter, m_Fcp_allreduce_neb_force, &
     m_Fcp_write_down_totch_replica, m_Fcp_read_totch_replica, &
     m_Fcp_initialize_neb_totch, m_Fcp_print_status

contains

!  Nose-Hoover, Velocity Scaling 

  subroutine initialize_fcp()
    implicit none
    cpqr  = 0.0d0
    forcp = 0.0d0
    cprv  = 0.0d0
    frsv  = 0.0d0
    tkb   = fcp_temperature * CONST_kB
    cpd_l = dsqrt( tkb / fcp_mass )
  end subroutine initialize_fcp

  subroutine m_Fcp_md_thermo()
    implicit none
    real(kind=DP) :: forc_l
    integer       :: mdalg

    if( lfirst ) then
       call initialize_fcp()
       lfirst = .false.
    end if

    forc_l = fcp_mu - efermi

    mdalg = T_CONTROL

    ! --> Velocities at iteration_ionic-th step 
    if(iteration_ionic == 1) then
       call forcrsv(cpd_l,tkb,frsv)
       !  -(b_Ionic_System)(cpd_l,tkb)->(frsv(=force on the thermostat coordinate))
    else
        call vlcty_accrd2_vVerlet(mdalg,forc_l)    !-(m_Ionic_System) ->(cpd_l) 
    end if
!!$ 2011.06.06
    if(t_ctrl_method.ne.VELOCITY_SCALING) call heatrsv()
!!$ 2011.06.06
         ! natm-(ifix_P_ifree):= #atoms in a heat bath
         ! -(m_Ionic_System) (cpd_l,cpqr,frsv,tkb)->(cpd_l,cpqr,frsv)
    forcp = forc_l
    call ekina_ekinq_ekbt_and_ega(mdalg)          !-(m_Ionic_System) ->(ekina,..)
    !     <== Kinetic and thermostat energies at iteration_ionic-th step
    call evolve_crdn_ACCRD2_vVerlet(forc_l)       !-(m_Ionic_System) ->(cps)
    !     <== Coordinates at (iteration_ionic+1)-th step
    call evolve_cprv                                    !-(m_Ionic_System) ->(cprv)

    if(t_ctrl_method == VELOCITY_SCALING)then
       call scale_velocity()
    endif

    !if(iprifcp >= 1) then
    !   write(nfout, '(" FCP : Fermi Energy = ",F20.8)') efermi
    !   write(nfout, '(" FCP : Target Mu    = ",F20.8)') fcp_mu
    !   write(nfout, '(" FCP : Total Charge = ",F20.8)') cps
    !end if

  end subroutine m_Fcp_md_thermo

  subroutine m_Fcp_print_status()
    if(iprifcp >= 1) then
       write(nfout, '("FCP : Fermi Energy = ",F20.8)') efermi
       write(nfout, '("FCP : Target Mu    = ",F20.8)') fcp_mu
       write(nfout, '("FCP : Total Charge = ",F20.8)') cps
    end if
  end subroutine m_Fcp_print_status

  subroutine forcrsv(cpd_l,tkb,frsv)
    implicit none
    real(kind=DP),intent(in)  :: cpd_l
    real(kind=DP),intent(in)  :: tkb
    real(kind=DP),intent(out) :: frsv

    frsv = cpd_l*cpd_l*fcp_mass-3.d0*tkb
    return
  end subroutine forcrsv

  subroutine vlcty_accrd2_vVerlet(mdalg,forc_l)
    implicit none
    integer      , intent(in) :: mdalg
    real(kind=DP), intent(in) :: forc_l
    real(kind=DP)        :: cpdxyz,frcxyz
    real(kind=DP)        :: dtz

    cpdxyz = cpd_l
    frcxyz = (forc_l + forcp)/2.d0
    cpd_l  = cpdxyz + dtio/fcp_mass*frcxyz

    if(mdalg == T_CONTROL) then
       dtz = dtio*cpqr(1)/2.d0
       cpd_l = cpd_l - dtz*cpdxyz
    end if

  end subroutine vlcty_accrd2_vVerlet

  subroutine heatrsv()
    ! OUTPUT : cpd_l,cpqr,frsv
    implicit none

    real(kind=DP) :: cpdcor,cpqrpre,cpqrcor,fchk

    integer,       parameter :: mmin = 5, mmax = 100
    real(kind=DP), parameter :: eps = 1.d-12
    integer                  :: ic
    real(kind=DP)            :: dtz

    cpdcor = cpd_l

    cpqrcor = cpqr(2) + 2*dtio/fcp_qmass*frsv
    cpqr(2)  = cpqr(1)
    cpqr(1)  = cpqr(1) + 0.5*dtio/fcp_qmass*frsv

! +++++ predictor-corrector method +++++
    PREDICTOR_CORRECTOR: do ic = 1, mmax
       cpqrpre= cpqrcor
       dtz = 1 + dtio*0.5*cpqrpre
       cpdcor= cpd_l/dtz  

       call forcrsv(cpdcor,tkb,frsv)         ! -(b_Ionic_System) ->(frsv)

       cpqrcor= cpqr(1)+frsv*dtio/fcp_qmass*0.5

       if(ic <= mmin) cycle
     
       fchk = dabs(cpqrpre/cpqrcor - 1.d0)
       if(fchk >= eps) cycle PREDICTOR_CORRECTOR

       go to 300
    end do PREDICTOR_CORRECTOR

    if(printable) then
       write(nfout,'(" ! Warning in fcp_heatrsv ***")')
       write(nfout,'(" FCP cpqrpre, cpqrcor = ",2d20.12)') &
          cpqrpre,cpqrcor
    end if
    stop

300 continue
    if(printable) then
       write(nfout,'(" FCP ic, cpqrcor, fchk= ",i1,d12.4,d12.4)') ic,cpqrcor,fchk
    end if

! ++++++++++++++++++++++++++++++++++++++++++++++++++

    cpd_l   = cpdcor
    cpqr(1) = cpqrcor
    
  end subroutine heatrsv

  subroutine ekina_ekinq_ekbt_and_ega(mdalg)
    implicit none
    integer,intent(in) :: mdalg
    real(kind=DP)      :: tkin
    ekr   = 0.d0   !d(nrsv)
    ekina = 0.d0
    ekbt  = 0.d0
    ekinq = 0.d0

    tkin  = cpd_l*cpd_l*fcp_mass*0.5d0
    ekina = ekina + tkin

    ekr   = ekr + tkin
    ekbt  = ekbt + 3*tkb*cprv

    ekinq = ekinq + fcp_qmass/2.d0 * cpqr(1)*cpqr(1)
    if(mdalg == T_CONTROL) then
       ekr = ekr/1.5d0
    end if

    ega = ekina + ekinq + ekbt

    if(printable) then
       write(nfout,'(" ***** ",i6,"-th time step ; ega= ",1pe16.7 /&
            &," ekina, ekinq, ekbt for FCP",3e16.7)') &
            & iteration_ionic, ega, ekina, ekinq, ekbt
       write(nfout,'(" tkb, ekr= ",2e16.7)') tkb,ekr
    end if

    if(iprifcp >= 2 .and. printable) then
       write(nfout,'(" ! *** cps for FCP ***")')
       write(nfout,'(" ",1f20.10)') cps
       write(nfout,'(" ! *** cprv, cpqr for FCP ***")')
       write(nfout,'(" ",2f20.10)') cprv,cpqr(1)
    end if
  end subroutine ekina_ekinq_ekbt_and_ega

  subroutine evolve_crdn_ACCRD2_vVerlet(forc_l)
    implicit none
    real(kind=DP),intent(in) :: forc_l
    real(kind=DP) :: dtm, dtz

!---*----*----*----*----*----> Velocity Verlet
    dtm = dtio/fcp_mass/2.d0
    cps = cps+dtio*(cpd_l+dtm*forc_l)
!---*----*----*----*----*----< Velocity Verlet
    dtz= dtio*dtio*cpqr(1)/2.d0
    cps= cps - dtz*cpd_l

  end subroutine evolve_crdn_ACCRD2_vVerlet

  subroutine evolve_cprv
    implicit none
    cprv =  cprv+dtio*(cpqr(1) + 0.5d0*dtio/fcp_qmass*frsv)
    if(printable) write(nfout,'(" FCP cprv = ",1d12.4)') cprv
  end subroutine evolve_cprv

  subroutine scale_velocity()
    implicit none
    real(kind=DP) :: tkin
    integer :: imdt

    tkin = cpd_l*cpd_l * fcp_mass*0.5d0

    if(tkin.gt.1e-12) then
       cpd_l = cpd_l * dsqrt(0.5d0*tkb/tkin)
    end if

    if(iprifcp >= 1) then
       write(nfout,'(a)') 'scaled the FCP velocities'
       write(nfout,'(" !! tkin = ",d20.8)') tkin
       write(nfout,'(" !! tkb  = ",d20.8)') tkb
       write(nfout,'(" !! dsqrt(0.5d0*tkb/tkin) = ",d20.8)') dsqrt(0.5d0*tkb/tkin)
    end if
  end subroutine scale_velocity

! CG

  subroutine m_Fcp_cg()
    implicit none
    real(kind=DP) :: forc_l
    real(kind=DP) :: etotal

    logical, save :: finit = .true., fconv = .false.
    integer, save :: itime = 1
    real(kind=DP), save :: e0,e1,e2,e3
    real(kind=DP), save :: dt1,dt2,dt3
    real(kind=DP), save :: de1,de2,de3
    real(kind=DP), save :: hvec,g0vec,g1vec,cps0

    if(printable) write(nfout,*) 'FCP gCG: iter=',iteration_ionic,' itime=',itime

    forc_l = fcp_mu - efermi
    etotal = forc_l ** 2

    if(finit) then
       hvec  = forc_l
       g0vec = hvec
       finit = .false.
    end if

    if(itime == 1) then
       call first()
       itime = 2
    else if(itime == 2) then
       e2 = etotal
       call deriv_energy(de2,hvec)
       if(de2 > 0.d0 .or. e2 > e0 ) then
          call estimate_min(dt1,dt2,e1,e2,de1,de2,fconv)
          itime = 3
       else
      !debug
          if(printable) write(nfout,*) 'FCP gCG:== Second (dt2)=='
      !end debug
          e1 = e2
          de1 = de2
          dt1 = dt2
          dt2 = 2*dt1
          cpd_l = dt2 * hvec
          cps = cps0 + cpd_l
      !debug
      ! if(printable)
      ! write(nfout,*) 'gCG:cpd_l:'
      ! do ia=1,natm
      !    write(nfout,'("gCG:",i3,3(1x,f17.9))') ia,cpd_l(ia,1:3)
      ! end do
      ! write(nfout,*) 'gCG:cps:'
      ! do ia=1,natm
      !    write(nfout,'("gCG:",i3,3(1x,f17.9))') ia,cps(ia,1:3)
      ! end do
      ! end if
      !end debug
       end if
    else
       call estimate_min(dt1,dt2,e1,e2,de1,de2,fconv)
       itime = itime + 1
       if(fconv) then
          g1vec = forc_l
          call conjugate_grad(hvec,g0vec,g1vec)
          call first()
          itime = 2
          fconv = .false.
       end if
    end if

  contains
    
    subroutine first()
      implicit none
      !debug
           if(printable) write(nfout,*) 'FCP gCG:== First (dt1)=='
      !end debug
      cps0 = cps
      e0 = etotal
      dt1 = 0.d0
      e1 = e0
      call deriv_energy(de1,hvec)
      dt2 = 1.d0
      cpd_l = dt2 * hvec

      cps = cps0 + cpd_l
      !debug
      ! if(printable)
      ! write(nfout,*) 'gCG:cpd_l:'
      ! do ia=1,natm
      !    write(nfout,'("gCG:",i3,3(1x,f17.9))') ia,cpd_l(ia,1:3)
      ! end do
      ! write(nfout,*) 'gCG:cps:'
      ! do ia=1,natm
      !    write(nfout,'("gCG:",i3,3(1x,f17.9))') ia,cps(ia,1:3)
      ! end do
      ! end if
      !end debug
    end subroutine first

    subroutine deriv_energy(de,hvec)
      implicit none
      real(kind=DP), intent(out) :: de
      real(kind=DP), intent(in) :: hvec
      
      de = - forc_l*hvec

    end subroutine deriv_energy

    subroutine estimate_min(dt1,dt2,e1,e2,de1,de2,fconv)
      implicit none
      real(kind=DP), intent(inout) :: dt1,dt2,e1,e2,de1,de2
      logical, intent(out) :: fconv

      real(kind=DP), save :: dt3,e3,de3
      real(kind=DP) :: c1,c2,c3,c4
      real(kind=DP) :: ddt,sdt,pdt2,pdt3,sq,dtm,dtp
      real(kind=DP) :: dfp,dfm,fp,fm
      logical, save :: finit = .true.

      if(.not.finit) then
         e3 = etotal
         call deriv_energy(de3,hvec)
         !debug
         if(printable) then
           write(nfout,*) 'FCP gCG:== Estimate Emin (old dt1,dt2) =='
           write(nfout,*) 'FCP gCG:dt1=',dt1,' e1=',e1
           write(nfout,*) 'FCP gCG:de1=',de1
           write(nfout,*) 'FCP gCG:dt2=',dt2,' e2=',e2
           write(nfout,*) 'FCP gCG:de2=',de2
           write(nfout,*) 'FCP gCG:dt3=',dt3,' e3=',e3
           write(nfout,*) 'FCP gCG:de3=',de3
!           write(nfout,*) 'FCP gCG:etol=',etol
         end if
         !end debug
         if(abs(forc_l) .le. fcp_relax_crit) then
            fconv = .true.
            finit = .true.
            return
         end if 
         if(de3 > 0.d0 .or. e3 > e1) then
            e2 = e3
            de2 = de3
            dt2 = dt3
         else
            e1 = e3
            de1 = de3
            dt1 = dt3
         end if
      end if
      finit = .false.
      !debug
      if(printable) then
        write(nfout,*) 'FCP gCG:== Estimate Emin (new dt1,dt2) =='
        write(nfout,*) 'FCP gCG:dt1=',dt1,' dt2=',dt2
        write(nfout,*) 'FCP gCG: e1=',e1,' e2=',e2
        write(nfout,*) 'FCP gCG:de1=',de1,' de2=',de2
      end if
      !end debug

      ddt = dt1 - dt2
      sdt = dt1 + dt2
      pdt2 = dt1*dt1
      pdt3 = dt1*pdt2
      c1 = ((de1+de2)*ddt-2.d0*(e1-e2))/ddt**3  
      c2 = 0.5d0*(de1-de2-3.d0*c1*ddt*sdt)/ddt
      c3 = de1 - 3.d0*c1*pdt2 - 2.d0*c2*dt1
      c4 = e1 - c1*pdt3 - c2*pdt2 - c3*dt1

!!$ASASASASASAS
!!$      sq = c2+sqrt(c2*c2-3.d0*c1*c3)
      sq = c2*c2-3.d0*c1*c3
      if (sq > 0.d0) then
         sq = sqrt(sq)
      else
         write(nfout,*) 'FCP gCG: Warning! Cannot estimate the minimum.'
         sq = 0.d0
      endif
      sq = sq + c2
!!$ASASASASASAS
      dtp = -c3/sq
      dtm = -sq/(3.d0*c1)

      dfp = 3.d0*c1*dtp**2+2.d0*c2*dtp+c3
      dfm = 3.d0*c1*dtm**2+2.d0*c2*dtm+c3

      fp = c1*dtp**3+c2*dtp**2+c3*dtp+c4
      fm = c1*dtm**3+c2*dtm**2+c3*dtm+c4
      
      !debug
      if(printable) then
        write(nfout,*) 'FCP gCG:== Estimate Emin (c1,c2,c3) =='
        write(nfout,*) 'FCP gCG: c1=',c1,' c2=',c2
        write(nfout,*) 'FCP gCG: c3=',c3,' c4=',c4
        write(nfout,*) 'FCP gCG:dtp=',dtp,' dtm=',dtm
        write(nfout,*) 'FCP gCG:dfp=',dfp,' dfm=',dfm
        write(nfout,*) 'FCP gCG: fp=',fp,' fm=',fm
      end if
      !end debug

      if(dtp >= dt1 .and. dtp <= dt2) then
         dt3 = dtp
      else if(dtm >= dt1 .and. dtm <= dt2) then
         dt3 = dtm
      else
        !!stop 'I cant estimated dt3 at which the total energy is minimum'
        write(nfout,*) 'FCP gCG: Warning! line-minimization failed'
        dt3 = 1.d0
      end if

      cpd_l = dt3 * hvec
      cps = cps0 + cpd_l

      !debug
      if(printable) then
       write(nfout,*) 'FCP gCG:== Estimate Emin (dt3) =='
       write(nfout,*) 'FCP gCG:dt1=',dt1,' dt2=',dt2
       write(nfout,*) 'FCP gCG:dtp=',dtp
       write(nfout,*) 'FCP gCG:dtm=',dtm
       write(nfout,*) 'FCP gCG:dt3=',dt3
      ! write(nfout,*) 'FCP gCG:cpd_l:'
      ! write(nfout,'("FCP gCG:",1x,f17.9)') cpd_l
      ! write(nfout,*) 'FCP gCG:cps:'
      ! write(nfout,'("FCP gCG:",1x,f17.9)') cps
      end if
      !end debug

    end subroutine estimate_min

    subroutine conjugate_grad(hvec,g0vec,g1vec)
      implicit none
      real(kind=DP), intent(inout) :: hvec,g0vec
      real(kind=DP), intent(in) :: g1vec

      real(kind=DP) :: gg,gam

      gg = g0vec**2
      gam = (g1vec-g0vec)*g1vec
      if(gg > 1.d-10*gam) then
         gam = gam/gg
      else
         gam = 1.d0
      end if

      hvec  = g1vec + gam * hvec
      g0vec = g1vec

      !debug
      if(printable) then
       write(nfout,*) 'FCP gCG:== CG =='
       write(nfout,*) 'FCP gCG:gam=',gam
       write(nfout,*) 'FCP gCG:gg=',gg
       write(nfout,*) 'FCP gCG: H (conjugate_grad)'
       write(nfout,'("FCP gCG:",1x,f17.9)') hvec
       write(nfout,*) 'FCP gCG: G'
       write(nfout,'("FCP gCG:",1x,f17.9)') g0vec
      end if
      !end debug

    end subroutine conjugate_grad

  end subroutine m_Fcp_cg

! CG2

  subroutine m_Fcp_CG_reset()
    implicit none
    iter_CG = 1
    iter_linmin = 1
    iter_CG_max = 1
  end subroutine m_Fcp_CG_reset

  subroutine m_Fcp_cg2()
    implicit none
    real(kind=DP) :: forc_l

    real(kind=DP), save :: alpha, alpha2, gamma
    real(kind=DP), save :: f_para1, f_para2, f_para3
    real(kind=DP), save :: vec_h_norm
    real(kind=DP), save :: vec_g, vec_h
    real(kind=DP), save ::       f_total0
    real(kind=DP), save :: cps1, f_total1
    real(kind=DP), save :: cps2, f_total2

    forc_l = fcp_mu - efermi

    f_total0 = forc_l

    if ( ( iter_CG .eq. 1 ) .and. ( iter_linmin .eq. 1 ) ) then
       call first_cg_step()
    else if ( iter_linmin .eq. 2 ) then
       f_para2 = f_total0*sign(1.0d0,vec_h)
       if(printable) write(nfout,'(a18,2f10.6)') ' FCP CG2: F_parallel =', f_para1, f_para2
       if ( abs(f_para2) .lt. f_para1*0.2d0 ) then
          if(printable) write(nfout,*) 'FCP CG2: F_parallel is small. Then linmin finished.'
          if ( iter_CG .lt. iter_CG_max ) then
             if(printable) write(nfout,*) 'FCP CG2: Go next_cg_step'
             call next_cg_step()
          else
             if(printable) write(nfout,*) 'FCP CG2: Reach to max_CG_step. Go first_cg_step'
             call first_cg_step()
          endif
       else
          call linmin_set_new_cps()
       endif
    else
       f_para3 = f_total0*sign(1.0d0,vec_h)
       if(printable) write(nfout,'(a18,3f10.6)') ' CG2: F_parallel =', f_para1, f_para2, f_para3
       f_para3 = abs(f_para3)
       f_para2 = abs(f_para2)
       if ( ( f_para3 .lt. f_para2 ) .and. ( f_para3 .lt. f_para1 ) ) then
          if ( f_para3 .lt. f_para1*0.2d0 ) then
             if(printable) write(nfout,*) 'FCP CG2: F_parallel is small. Then linmin finished.'
             if ( iter_CG .lt. iter_CG_max ) then
                if(printable) write(nfout,*) 'FCP CG2: Go next_cg_step'
                call next_cg_step()
             else
                if(printable) write(nfout,*) 'FCP CG2: Reach to max_CG_step. Go first_cg_step'
                call first_cg_step()
             endif
          else
             if(printable)then
                write(nfout,*) 'FCP CG2: CG procedure is failed !!'
                write(nfout,*) 'FCP CG2: f_para3 must be less than f_para1*0.2d0.'
                write(nfout,*) 'FCP CG2: Then, new CG procedure starts.'
             endif
             call first_cg_step()
          endif
       else
          if(printable)then
             write(nfout,*) 'FCP CG2: Linmin calc is failed !!'
             write(nfout,*) 'FCP CG2: The 3rd point is not a minimum.'
             write(nfout,*) 'FCP CG2: Then, new CG procedure starts from the 2nd point.'
          endif
          call first_cg_step_from_cps2()
       endif
    endif

  contains

    subroutine first_cg_step()
      implicit none
      f_total1 = f_total0
      vec_g = f_total1
      vec_h = vec_g
      cps1 = cps
      vec_h_norm = abs( vec_h )
      call set_alpha()
      cps = cps1 + vec_h * alpha
      f_para1 = f_total1*sign(1.0d0,vec_h)
      if ( f_para1 .gt. 0.08d0 ) then
         iter_CG_max = 1
      else
         iter_CG_max = 5
      endif
      iter_CG = 1
      iter_linmin = 2
      write(nfout,'(a28,i2,a18,i2)') ' FCP CG2: Next step is iter_CG =', iter_CG, ' and iter_linmin =', iter_linmin
    end subroutine first_cg_step

    subroutine set_alpha()
      implicit none
      if      ( vec_h_norm .lt. 0.004d0 ) then
         alpha = 3.5d0
      else if ( vec_h_norm .lt. 0.007d0 ) then
         alpha = 3.0d0
      else if ( vec_h_norm .lt. 0.010d0 ) then
         alpha = 2.5d0
      else if ( vec_h_norm .lt. 0.015d0 ) then
         alpha = 2.0d0
      else if ( vec_h_norm .lt. 0.020d0 ) then
         alpha = 1.5d0
      else
         alpha = 1.0d0
      endif
    end subroutine set_alpha

    subroutine next_cg_step()
      f_total1 = f_total0
      !     gamma = sum(f_total1(:,:)**2) / sum(vec_g(:,:)**2)
      gamma = (f_total1-vec_g)*f_total1 / vec_g**2
      vec_g = f_total1
      vec_h = vec_g + gamma * vec_h
      cps1 = cps
      vec_h_norm = abs(vec_h)
      call set_alpha()
      cps = cps1 + vec_h * alpha
      f_para1 = f_total1*sign(1.0d0,vec_h)
      iter_CG = iter_CG + 1
      iter_linmin = 2
      write(nfout,'(a28,i2,a18,i2)') ' FCP CG2: Next step is iter_CG =', iter_CG, ' and iter_linmin =', iter_linmin
    end subroutine next_cg_step

    subroutine linmin_set_new_cps()
      implicit none
      cps2 = cps
      f_total2 = f_total0
      alpha2 = f_para1 * alpha / ( f_para1 - f_para2 )
      write(nfout,*) 'FCP CG2: alpha(force ) =', alpha2
      if ( alpha2 .lt. 0.0d0 ) then
         write(nfout,*) 'FCP CG2: Linmin calc is strange !!'
         write(nfout,*) 'FCP CG2: Alpha must be positive !!'
         write(nfout,'(a13,f15.10)') ' FCP CG2: Alpha =', alpha2
         write(nfout,*) 'FCP CG2: New CG step start from the 2nd point.'
         call first_cg_step()
      else
         if ( alpha2 .gt. 10.0d0*alpha ) then
            write(nfout,*) 'FCP CG2: Linmin calculated.'
            write(nfout,'(a22,f15.10)') ' FCP CG2: Original alpha =', alpha2
            write(nfout,*) 'FCP CG2: Alpha is too large, then, adjusted.'
            alpha2 = 10.0d0*alpha
         endif
         write(nfout,'(a13,f15.10)') ' FCP CG2: Alpha =', alpha2
         cps = cps1 + vec_h * alpha2
         iter_linmin = 3
         write(nfout,'(a28,i2,a18,i2)') ' FCP CG2: Next step is iter_CG =', iter_CG, ' and iter_linmin =', iter_linmin
      endif
    end subroutine linmin_set_new_cps

    subroutine first_cg_step_from_cps2()
      implicit none
      f_total1 = f_total2
      vec_g = f_total1
      vec_h = vec_g
      cps1 = cps2
      vec_h_norm = abs(vec_h)
      call set_alpha()
      cps = cps1 + vec_h * alpha
      f_para1 = f_total1*vec_h/abs(vec_h)
      iter_CG = 1
      iter_linmin = 2
      write(nfout,'(a28,i2,a18,i2)') ' FCP CG2: Next step is iter_CG =', iter_CG, ' and iter_linmin =', iter_linmin
    end subroutine first_cg_step_from_cps2

    !! jn_130104

  end subroutine m_Fcp_cg2

  logical function m_Fcp_Converged()
    implicit none
    m_Fcp_Converged = ( abs( fcp_mu - efermi ) < fcp_relax_crit )
    return
  end function m_Fcp_Converged

! QUENCH

  subroutine m_Fcp_md(mdalg)
    integer, intent(in)     :: mdalg
    real(kind=DP) :: forc_l

    forc_l = fcp_mu - efermi
    
    if (mdalg .ne. VERLET) then
       cpd_old = cpd_l
       if(iprifcp >= 1) then
          write(nfout,'(" -- FCP cpd_l, cpd_old (before evolve_velocities)--")')
          write(nfout,'(f18.5)') cpd_l
       end if
       if(imdalg == STEEPEST_DESCENT .and. mode_fi_coefficient == OFF) then
          fi_coefficient = get_fi_coefficient(abs(forc_l))
          if(iprifcp >= 1) write(nfout,'(a19,f20.10)') ' fi_coefficient =  ', fi_coefficient
       end if
       call evolve_velocities(mdalg,forc_l) !-(m_Ionic_System)  cpd_l = cpd_l + dtio/mass * forc_l
    end if

    ! <<--
    if(mdalg == QUENCHED_MD) call quench_velocities(forc_l) ! -->cpd_l
    
    cps = cps + dtio*cpd_l

    return
  end subroutine m_Fcp_md

  subroutine evolve_velocities(mdalg,forc_l)
    implicit none
    integer, intent(in) :: mdalg
    real(kind=DP), intent(inout) :: forc_l
    
    real(kind=DP) :: fac, frc, rm, pdot
    real(kind=DP) :: f_dot_v, vec_norm2, force_t_norm
    real(kind=DP) :: force_t_para, force_t_vert

    if(mdalg == STEEPEST_DESCENT) then
       cpd_l=forc_l/dtio*fi_coefficient                   !! moving force cal
    else
       fac = dtio/fcp_mass
       frc = forc_l
       if (mdalg == VERLET .and. iteration_ionic == 1)  then
          !!cpd_l(ia,1:3) = fac*frc(1:3) / 2.d0
          !!cpd_old(ia,1:3) = -cpd_l(ia,1:3)
          cpd_l = cpd_l + 0.5d0*fac*frc
       else
          cpd_l = cpd_l + fac*frc
       endif
    end if

  end subroutine evolve_velocities

  real(kind=DP) function get_fi_coefficient(force_t_norm)
    implicit none
    real(kind=DP), intent(in) :: force_t_norm
    if(force_t_norm < 0.008d0) then
       get_fi_coefficient = 3.5d0
    else if (force_t_norm < 0.02d0) then
       get_fi_coefficient = 2.5d0
    else if (force_t_norm < 0.05d0) then
       get_fi_coefficient = 1.5d0
    else
       get_fi_coefficient = 0.8d0
    end if
  end function get_fi_coefficient

  subroutine quench_velocities(forc_l) 
    implicit none
    real(kind=DP), intent(in) :: forc_l
    real(kind=DP) :: cpd_parallel, cpd_vertical, f, fv, fcpd, v
    v = (cpd_old + cpd_l)*0.5
    fv = forc_l*v
    if(fv < 0.d0) then
       if(printable) write(nfout,'(" FCP ---<<quench_velocity>>")')
       cpd_l = 0.d0
    end if
    
  end subroutine quench_velocities

! GDIIS, BFGS

  subroutine m_Fcp_gdiis_alloc(mode_init,if_allocated)
    implicit none
    integer, intent(in) ::  mode_init
    integer, intent(out) :: if_allocated
    integer ::             i,j
    real(kind=DP) ::       fac
    if(kqnmditer_p <= 0) stop ' FCP kqnmditer_p is illegal (m_Fcp_gdiis_alloc)'
    if(printable) write(nfout,'(" !! FCP kqnmditer_p = ",i6," <<m_Fcp_gdiis_alloc>>")') kqnmditer_p
    if(.not.allocated(u_l)) allocate(u_l(kqnmditer_p));u_l=0.d0
    if(.not.allocated(w_l)) allocate(w_l(kqnmditer_p));w_l=0.d0
    if(mode_init == UNIT) then
       fac = 1.d0
    else
       fac = dtio*dtio/fcp_mass
    end if
    fc_l = -fac

    if(.not.allocated(ncrspd)) allocate(ncrspd(kqnmditer_p))
    ncrspd(:) = (/(i,i=1,kqnmditer_p)/)
    if(.not.allocated(f_gdiis)) allocate(f_gdiis(kqnmditer_p,kqnmditer_p))
    if(.not.allocated(g)) allocate(g(kqnmditer_p))
    if(.not.allocated(f_wk)) allocate(f_wk(kqnmditer_p*kqnmditer_p,2))
    if(.not.allocated(f_rslv)) allocate(f_rslv(kqnmditer_p*kqnmditer_p))
    if(.not.allocated(e_wk)) allocate(e_wk(kqnmditer_p*kqnmditer_p))
    if(.not.allocated(ww1)) allocate(ww1(kqnmditer_p))
    if(.not.allocated(ip)) allocate(ip(kqnmditer_p))
    if_allocated = 1
  end subroutine m_Fcp_gdiis_alloc

  subroutine m_Fcp_gdiis_reset()
    implicit none
    iter_gdiis = 0
    if(if_allocated==0) return
    call m_Fcp_gdiis_dealloc(if_allocated)
  end subroutine m_Fcp_gdiis_reset

  subroutine m_Fcp_gdiis_dealloc(if_allocated)
    implicit none
    integer, intent(out) :: if_allocated
    deallocate(ip);
    deallocate(ww1);   deallocate(e_wk);    deallocate(f_rslv)
    deallocate(f_wk);   deallocate(g);     deallocate(f_gdiis)
    deallocate(ncrspd);   deallocate(w_l)
    deallocate(u_l)
    if_allocated = 0
  end subroutine m_Fcp_gdiis_dealloc

  subroutine m_Fcp_gdiis()
    implicit none
    real(kind=DP) :: forcmx,etotal
    real(kind=DP) :: forc_l

    integer       :: m, mode_init = 0,it,nsum,icount,icon, imd_t
    real(kind=DP) :: c_dist, forcmx_mdfy

    forc_l = fcp_mu - efermi
    etotal = forc_l ** 2

    forcmx = fcp_relax_crit
    forcmx_mdfy = forcmx

    iter_gdiis = iter_gdiis + 1
    if(if_allocated == 0) call m_Fcp_gdiis_alloc(mode_init,if_allocated)

    forc_g = forc_l
    m = mod(iter_gdiis,kqnmditer_p)
    if(m == 0) m = kqnmditer_p

    call d_fc_l(mode_init,forcmx_mdfy) ! -> fc_l
    call rot_ncrspd(nsum)  ! -> ncrspd, nsum
    it = ncrspd(nsum)
    if(it == 0) it = 1
    call stor_cps_forc(it) ! cps,forc_g -> u_l, w_l
    if (imdalg==GDIIS)then
       if(nsum > 1) then
          call gdiis_mat(nsum) ! ncrspd,w_l -> f_gdiis
          call getmatinv(nsum,icon) ! -> f_gdiis := f_gdiis^(-1)
          if(icon == 0) then
             call gdiis_g(nsum)   ! -> g
             call opt_forc(nsum)  ! -> forc_g := sum_{it}(g(it)*w_l(,ncrspd(it))
!!$                call mdfy_forc(forcmx,forcmx_mdfy2)
             if(iprifcp >= 2 .and. printable) call forc_check(" --- FCP new force ---")
             if(iprifcp >= 1) call cmp_fop_fin(it)
             call opt_geom(nsum)  ! -> cps := sum_{it}(g(it)*u_l(,ncrspd(it))
          else   ! when icon /= 0, f_gdiis matrix is singular
             if(printable) write(nfout,'(" !! FCP f_gdiis matrix is singular <<m_Fcp_gdiis>>")')
             call m_Fcp_md(QUENCHED_MD)
          end if
       end if

       cpd_l = -fc_l/dtio*forc_g
       cps   = cps + dtio*cpd_l

    else if(imdalg==BFGS) then
       call do_bfgs(nsum)
    end if
    if(imdalg==GDIIS)then
       if(iprifcp >= 2 .and. printable) call cps_check(" --- FCP new coordinates ---") ! cps

       c_dist = 0.3d0
       call cps_damp(c_dist,it,icount)
       if(icount >= 1 .and. iprifcp >= 1 .and. printable) then
          call cps_check(" --- FCP new (damped) coordinates ---") ! cps
       endif
    endif

    if(iprifcp >= 2 .and. printable) call cpd_check(" --- FCP velocity ---") ! cpd_l

  contains

    subroutine do_bfgs(nsum)
      implicit none
      integer, intent(in) :: nsum
      integer :: i,j,k,i1,j1,itr0,itr1,info
      real(DP) :: xgi,gihg
      real(kind=DP) :: gdelta,xdelta
      logical :: corrected_eig
      real(DP) :: gdotinvh
      real(DP) :: tmpforc
      real(DP) :: ihess
      real(DP) :: amat
      real(DP) :: eigv
      real(DP) :: eigvec
      real(DP) :: workar
      real(DP) :: maxoptforc,tmpmaxoptforc
      real(DP),save :: maxoptforc_old=1000.d0
      real(DP),save :: energy_old = 0.0d0
      real(DP),save :: force_old  = 0.0d0
      real(DP),save :: alpha_bfgs = 1.0d0
      logical, save :: lfirst = .true.
      integer :: icounti,icountj
      real(DP) :: c1,c2,mina,maxa,incre
      real(DP) :: tmpsum1,tmpsum2,e0,f0
      c1 = wolfe_c1
      c2 = wolfe_c2
      mina = min_alpha
      maxa = max_alpha
      incre = 1.1d0
      xdelta=0.d0
      gdelta=0.d0
      gdotinvh=0.d0
      tmpforc=0.d0
      ihess=0.d0
      if(sw_correct_eigenvalue==ON)then
         amat=0.d0
         eigv=0.0d0
         eigvec=0.0d0
         workar=0.0d0
      endif

      !      build inverse of the Hessian
      ihess = 1.0d0
      do i=2,nsum
         itr1 = ncrspd(i)
         itr0 = ncrspd(i-1)
         icountj=0

         icountj=icountj+1
         xdelta =  u_l(itr1)-u_l(itr0)
         gdelta = -w_l(itr1)+w_l(itr0)
         xgi = 1.0d0/(xdelta*gdelta)
         if(xgi<0)then
            if(printable .and. iprifcp>=2)then
               write(nfout,'(a,i3)') '!** WARNING FCP dx dot dg is negative for history ',itr1
               write(nfout,'(a)') 'skipping this update.'
            endif
            cycle
         endif
         gdotinvh = ihess*gdelta
         gihg = gdelta*gdotinvh
         ihess = ihess+xgi*xgi*(1.0d0/xgi+gihg)*xdelta*xdelta &
            - (gdotinvh*xdelta+gdotinvh*xdelta)*xgi
      enddo

      !      correct bad eigenvalues present in the Hessian 
      if(sw_correct_eigenvalue==ON)then
         corrected_eig=.false.
         amat = ihess
         call dspev('V','U',1,amat,eigv,eigvec,1,workar,info)
         if(printable .and. iprifcp>=2) write(nfout,'(a)') '--- FCP eigenvalues for the approximate Hessian ---'
         if(printable.and.iprifcp>=2) write(nfout,'(f20.10)') 1.0d0/eigv
         if (1.0d0/eigv<eigenvalue_threshold)then
            eigv = 1.0d0/eigenvalue_threshold
            if(printable.and.iprifcp>=2) write(nfout,'(a,f20.10)') &
               &  'corrected the eigenvalue : ',1.0d0/eigv
            corrected_eig=.true.
         endif
         if(corrected_eig)then
            ihess = ihess+eigvec*eigvec*eigv
         endif
      endif

      !      H^-1 dot g
      tmpforc = - ihess*forc_l
      tmpmaxoptforc=abs(tmpforc)
      if(tmpmaxoptforc>maxoptforc)maxoptforc=tmpmaxoptforc
      
      if(printable .and. iprifcp>=1) then
         write(nfout,'(a,f20.10)') 'FCP max. optimal force obtained from the BFGS update : ',maxoptforc
      endif

      if(sw_optimize_alpha == ON) then
         if( lfirst ) then
            lfirst = .false.
         else
            tmpsum1 = force_old*tmpforc
            tmpsum2 = forc_l*tmpforc
            e0 = energy_old + c1*alpha_bfgs*tmpsum1
            f0 = -c2*tmpsum1
            if(e0>etotal .and. f0>abs(tmpsum2))then
               alpha_bfgs = alpha_bfgs*incre
            else 
               alpha_bfgs = alpha_bfgs/incre
            endif
            if(alpha_bfgs>maxa) alpha_bfgs = maxa
            if(alpha_bfgs<mina) alpha_bfgs = mina
            if(printable)then
               write(nfout,'(a,2f20.10)') 'FCP Wolfe condition  i) : ',e0,etotal
               write(nfout,'(a,2f20.10)') 'FCP Wolfe condition ii) : ',f0,abs(tmpsum2)
               write(nfout,'(a,f20.10)')  'FCP new alpha           : ',alpha_bfgs
            endif
         endif

         energy_old = etotal
         force_old  = forc_l
      endif

      if(maxoptforc_old*10<maxoptforc)then
         if (printable) write(nfout,'(a)') 'FCP the estimated force seems to be very large; &
            & update will be done by the steepest-descent method'
         cps = cps+forc_l
      else
         tmpsum1=0.d0
         tmpsum2=0.d0
         cps = cps-alpha_bfgs*tmpforc
      endif
      maxoptforc_old = maxoptforc

    end subroutine do_bfgs

    subroutine rot_ncrspd(nsum)
      implicit none
      integer, intent(out) :: nsum
      integer ::              nbox, istrbr, itemp
      nbox = (iter_gdiis-1)/kqnmditer_p
      if(gdiis_hownew == ANEW) then
         istrbr = nbox*kqnmditer_p + 1
      else if (gdiis_hownew == RENEW) then
         if(nbox == 0) then
            istrbr = 1
         else
            istrbr = iter_gdiis - (kqnmditer_p-1)
            itemp = ncrspd(1)
            do it = 1, kqnmditer_p-1
               ncrspd(it) = ncrspd(it+1)
            end do
            ncrspd(kqnmditer_p) = itemp
         end if
      end if
      nsum = iter_gdiis - istrbr + 1
      if(iprifcp >= 2 .and. printable) then
         write(nfout,'(" -- FCP rot_ncrspd -- ")')
         write(nfout,'("   i  : ",8i8)') (it,it=1,nsum)
         write(nfout,'("ncrspd: ",8i8)') (ncrspd(it),it=1,nsum)
      end if
    end subroutine rot_ncrspd

    subroutine d_fc_l(mode_init,forcmx)
      implicit none
      integer      , intent(in) :: mode_init
      real(kind=DP), intent(in) :: forcmx
      if(forcmx >= c_forc_prop_region_high) then
         if(mode_init == UNIT) then
            fc_l = -1.d0
         else
            fc_l = -dtio*dtio/fcp_mass
         end if
      else if(forcmx >= c_forc_prop_region_low) then
         fc_l = - factor_prop_region/forcmx
         if(dabs(fc_l) < 1.d0) then
            fc_l = -1.d0
         end if
      end if
    end subroutine d_fc_l

    subroutine stor_cps_forc(it)
      implicit none
      integer, intent(in) :: it
      u_l(it) = cps
      w_l(it) = forc_g
    end subroutine stor_cps_forc

    subroutine gdiis_mat(nsum)
      implicit none
      integer, intent(in) :: nsum

      integer ::             it, jt, itcrspd, jtcrspd
      real(kind=DP) ::       xmul

      do it = 1, nsum
         itcrspd = ncrspd(it)
         do jt = it, nsum
            jtcrspd = ncrspd(jt)
            xmul = w_l(jtcrspd)*w_l(itcrspd)
            f_gdiis(it,jt) = xmul
            if(jt /= it) f_gdiis(jt,it) = f_gdiis(it,jt)
         end do
         if(iprifcp >= 2 .and. printable) then
            if(it == 1) write(nfout,'(" -- FCP f_gdiis -- ")')
            write(nfout,'( 6d12.4)') (f_gdiis(it,jt),jt=1,nsum)
         end if
      end do
    end subroutine gdiis_mat

    subroutine getmatinv(nsum,icon)
      implicit none
      integer ,intent(in) ::  nsum
      integer, intent(out) :: icon

      real(kind=DP) :: div
      integer ::       it, jt, ipfr, ipto
#ifdef _GDIIS_MAT_CHECK_
      integer ::       kt, ik_count, kj_count
#endif

      div = 1.0/f_gdiis(1,1)
      do it = 1, nsum
         do jt = 1, nsum
            ipto = it + (jt-1)*nsum
            f_wk(ipto, 1) = f_gdiis(it,jt)*div
#ifdef _GDIIS_MAT_CHECK_
            f_wk(ipto, 2) = f_gdiis(it,jt)*div
#endif
            if(it == jt) then
               e_wk(ipto) = 1.d0
            else
               e_wk(ipto) = 0.d0
            end if
         end do
      end do

      call rdecomp(nsum,f_wk(1,1),ww1,ip,icon)

      if(icon /= 0) then
         if(printable) then
            write(nfout,'("  FCP [f_wk] after rdecomp <<m_Fcp_gdiis_getmatinv>>")')
            do it = 1, nsum
               write(nfout,'(" f_wk(:,",i3," ) = ",8d12.4)') it,(f_wk(it+(jt-1)*nsum,1),jt=1,nsum)
            end do
            write(nfout,'(" ip = ",8i6)') (ip(ipto),ipto=1,nsum)
            write(nfout,*) ' FCP LU decomposition is impossible. <<m_Fcp_gdiis.getmatinv>>'
         end if
         return
!!$         stop ' LU decompoition is impossible <<m_Fcp_gdiis_getmatinv>>'
      else
         call rsolve(nsum,nsum,f_wk(1,1),e_wk,f_rslv,ip)
      endif
#ifdef _GDIIS_MAT_CHECK_
      ! ----------- checking of inversion matrix ------------>
      if(printable) then
         write(nfout,*) ' -- FCP below should equal to a unit matrix --'
         do it = 1, nsum
            ww1 = 0.d0
            do jt = 1, nsum
               do kt = 1, nsum
                  ik_count = (kt-1)*nsum + it
                  kj_count = (jt-1)*nsum + kt
                  ww1(jt) = ww1(jt) + f_wk(ik_count,2)*f_rslv(kj_count)
               enddo
            enddo
            write(nfout,9009) it,(ww1(jt),jt=1,nsum)
         enddo
9009     format(i3,8f8.4,/,3x,8f8.4,/,3x,8f8.4,/3x,8f8.4)
      end if
      ! <--------------------------------------------------
#endif

      do jt = 1, nsum
         do it = 1, nsum
            ipfr = it + (jt-1)*nsum
            f_gdiis(it,jt) = f_rslv(ipfr)
         end do
      end do

      if(iprifcp >= 2 .and. printable) then
         write(nfout,*) ' **inverse matrix**'
         do jt = 1, nsum
            write(nfout,9008) jt,(f_gdiis(it,jt),it=1,nsum)
         enddo
      end if
9008  format(i3,(6d12.4))

    end subroutine getmatinv

    subroutine gdiis_g(nsum)
      implicit none
      integer, intent(in) :: nsum
      real(kind=DP) ::       alpha_fac
      integer ::             it,jt
      alpha_fac = 0.d0
      do it = 1, nsum
         do jt = 1, nsum
            alpha_fac = alpha_fac + f_gdiis(it,jt)
         end do
      end do
      alpha_fac = 1.d0/alpha_fac

      g = 0.d0
      do it = 1, nsum
         do jt = 1, nsum
            g(it) = g(it) + alpha_fac*f_gdiis(it,jt)
         end do
      end do

      if(iprifcp >= 2 .and. printable) then
         write(nfout,*) ' ---- FCP alpha_fac     ----'
         write(nfout,9008) alpha_fac
         write(nfout,*) ' ---- a(1:',nsum,') ----'
         write(nfout,9008) (g(it),it=1,nsum)
      end if
9008  format(8f20.12)
    end subroutine gdiis_g

    subroutine opt_forc(nsum)
      implicit none
      integer, intent(in) :: nsum
      integer ::             it, itcrspd

      forc_g = 0.d0
      do it = 1, nsum
         itcrspd = ncrspd(it)
         forc_g = forc_g + g(it)*w_l(itcrspd)
      end do
    end subroutine opt_forc

    subroutine opt_geom(nsum)
      implicit none
      integer, intent(in) :: nsum
      integer ::             ifc, itcrspd

      cps = 0.d0
      do ifc = 1, nsum
         itcrspd = ncrspd(ifc)
         cps = cps + g(ifc)*u_l(itcrspd)
      end do

    end subroutine opt_geom

    subroutine cmp_fop_fin(it)
      implicit none
      integer, intent(in) :: it
      real(kind=DP) :: xmul, xmul_input_f
      xmul = forc_g**2
      xmul_input_f = w_l(it)**2
      if(printable) write(nfout,*) ' FCP norm of optimal force = ', xmul
      if(printable) write(nfout,*) ' FCP norm of input   force = ', xmul_input_f
    end subroutine cmp_fop_fin

    subroutine cps_damp(c_dist,it,icount)
      implicit none
      real(kind=DP), intent(in) :: c_dist
      integer, intent(in) ::      it
      integer ,intent(out) ::     icount
      real(kind=DP) :: df

      icount = 0
      df = cps - u_l(it)
      if(df > c_dist) then
         icount = icount + 1
         cps = u_l(it) + c_dist
      else if(df < -c_dist) then
         icount = icount + 1
         cps = u_l(it) - c_dist
      end if

    end subroutine cps_damp
    
    subroutine forc_check(name)
      character(len=*),intent(in) :: name
      write(nfout,'("FCP ",a40)') name
      write(nfout,'(f20.12)') forc_g
    end subroutine forc_check

    subroutine cps_check(name)
      character(len=*),intent(in) :: name
      write(nfout,'("FCP ",a40)') name
      write(nfout,'(f20.12)') cps
    end subroutine cps_check

    subroutine cpd_check(name)
      character(len=*),intent(in) :: name
      write(nfout,'("FCP ",a40)') name
      write(nfout,'(f20.12)') cpd_l
    end subroutine cpd_check

  end subroutine m_Fcp_gdiis

! NEB

  subroutine m_Fcp_create_replica(nimage)
    use m_Control_Parameters, only : fcp_tot_charge_first, fcp_tot_charge_last
    implicit none
    integer, intent(in) :: nimage
    logical, save :: initialized = .false. 

    num_of_images = nimage
    ALLOCATE( neb_image( nimage ) )

  end subroutine m_Fcp_create_replica

  subroutine m_Fcp_initialize_neb_totch()
    use m_Control_Parameters, only : fcp_tot_charge_first, fcp_tot_charge_last
    implicit none
    integer       :: n, i
    real(kind=DP) :: first, last

    if( cps_initialized ) then
       return
    end if
    cps_initialized = .true.
    
    first = fcp_tot_charge_first
    last  = fcp_tot_charge_last
    n = num_of_images
    DO i = 1, n
       neb_image(i)%cps = cps + ( first * (n - i) + last * (i - 1) ) / (n - 1)
    END DO
    neb_image(:)%cps0 = neb_image(:)%cps

  end subroutine m_Fcp_initialize_neb_totch

  subroutine m_Fcp_set_neb_replica_totch(i)
    implicit none
    integer, intent(in) :: i
    cps = neb_image(i)%cps
  end subroutine m_Fcp_set_neb_replica_totch

  subroutine m_Fcp_set_neb_replica_force(i)
    implicit none
    integer, intent(in) :: i
    neb_image(i)%force = fcp_mu - efermi
  end subroutine m_Fcp_set_neb_replica_force

  subroutine m_Fcp_update_neb(dt, time_integral)
    use m_Parallelization , only : mype
    use m_Files           , only : nfneb
    implicit none
    real(8)     , intent(in) :: dt
    character(*), intent(in) :: time_integral

    integer :: i
    real(8) :: mass
    real(8) :: r, r0, r1, v, v1, f, f0, unitf

    if (mype==0) write(nfneb,*) 'FCP coordinate update...'

    do i = 2, num_of_images-1

       neb_image(i)%cps0 = neb_image(i)%cps

       r  = neb_image(i)%cps
       r0 = neb_image(i)%cps0
       v  = neb_image(i)%velocity
       f  = neb_image(i)%force
       f0 = neb_image(i)%force0
       mass = fcp_mass

       select case(time_integral)
       case('steepest_descent')
          r1 = r + dt*f
          v = 0.0d0
       case('verlet')
          r1 = 2.0d0*r - r0 + dt*dt*f/mass
          v1 = (r1-r)/(2.0d0*dt)
          v = 0.0d0
          if( v1*f >= 0.0d0) then
             if( abs(f) /= 0.0d0 ) then
                v = f * v1/f
             end if
          end if
       case('velocity_verlet')
          v1 = v + 0.5d0*dt*(f0+f)/mass
          v = 0.0d0
          unitf=0.d0
          if( abs(f) /= 0 ) unitf=f/abs(f)
          if( v1*unitf >= 0.0d0) then
             v = v1
          else
             if (mype==0) write(nfneb,'(a,i6)') 'FCP quenched velocity'
          end if
          r1 = r + v*dt + f*dt**2/mass
       end select

       neb_image(i)%cps      = r1
       neb_image(i)%velocity = v

       if ( mype==0 ) then
          write(nfneb,*) ' image: ', i
          write(nfneb,*) '  cps, cps0, cps-cps0 '
          write(nfneb,'(2f10.5,e11.3)') neb_image(i)%cps, neb_image(i)%cps0, &
             neb_image(i)%cps - neb_image(i)%cps0
       endif

    end do

  end subroutine m_Fcp_update_neb

  logical function m_Fcp_replica_Converged()
    implicit none
    m_Fcp_replica_Converged = all( abs( neb_image(2:num_of_images)%force ) < fcp_relax_crit )
    return
  end function m_Fcp_replica_Converged

  subroutine m_Fcp_set_neb_parameter(itr)
    implicit none
    integer, intent(in) :: itr
    if( itr == 1 ) return
    neb_image(:)%force0 = neb_image(:)%force
    neb_image(:)%force  = 0.0d0
  end subroutine m_Fcp_set_neb_parameter

  subroutine m_Fcp_allreduce_neb_force(nrank_r)
    use m_Parallelization,      only : mpi_comm_group
    implicit none
    integer, intent(in) :: nrank_r
    integer i
    integer mype, npes, mpi_err
    real(8),allocatable :: work1(:)

    include 'mpif.h'

    if (nrank_r.lt.1) return

    call mpi_comm_size(mpi_comm_group,npes,mpi_err)

    allocate(work1(num_of_images));work1=0.d0
    call mpi_allreduce(neb_image(:)%force,work1,num_of_images, &
       mpi_double_precision,mpi_sum,mpi_comm_world,mpi_err)
    neb_image(:)%force = work1(:)
    deallocate(work1)

    ! temporary    npes = ne*nk
    neb_image(:)%force = neb_image(:)%force/npes

  end subroutine m_Fcp_allreduce_neb_force

  subroutine m_Fcp_write_down_totch_replica(i)
    use m_Files, only : nfnebcntn
    implicit none
    integer, intent(in) :: i

    write(nfnebcntn,*) '(totch)'
    write(nfnebcntn,'(d24.16)') neb_image(i)%cps

  end subroutine m_Fcp_write_down_totch_replica

  subroutine m_Fcp_read_totch_replica(i)
    use m_Files, only : nfnebcntn
    implicit none
    integer, intent(in) :: i

    read(nfnebcntn,*)
    read(nfnebcntn,*) neb_image(i)%cps

    neb_image(i)%cps0 = neb_image(i)%cps

    cps_initialized = .true.

  end subroutine m_Fcp_read_totch_replica

end module m_Fcp

      SUBROUTINE PDSYEVD( JOBZ, UPLO, N, A, IA, JA, DESCA, W, Z, IZ, JZ,
     $                    DESCZ, WORK, LWORK, IWORK, LIWORK, INFO )
*
*  -- ScaLAPACK routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     March 14, 2000
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            IA, INFO, IZ, JA, JZ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCA( * ), DESCZ( * ), IWORK( * )
      DOUBLE PRECISION   A( * ), W( * ), WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PDSYEVD computes  all the eigenvalues and eigenvectors
*  of a real symmetric matrix A by calling the recommended sequence
*  of ScaLAPACK routines.
*
*  In its present form, PDSYEVD assumes a homogeneous system and makes
*  no checks for consistency of the eigenvalues or eigenvectors across
*  the different processes.  Because of this, it is possible that a
*  heterogeneous system may return incorrect results without any error
*  messages.
*
*  Arguments
*  =========
*
*     NP = the number of rows local to a given process.
*     NQ = the number of columns local to a given process.
*
*  JOBZ    (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only;     (NOT IMPLEMENTED YET)
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (global input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (global input) INTEGER
*          The number of rows and columns to be operated on, i.e. the
*          order of the distributed submatrix sub( A ). N >= 0.
*
*  A       (local input/workspace) block cyclic DOUBLE PRECISION array,
*          global dimension (N, N), local dimension ( LLD_A,
*          LOCc(JA+N-1) )
*          On entry, the symmetric matrix A.  If UPLO = 'U', only the
*          upper triangular part of A is used to define the elements of
*          the symmetric matrix.  If UPLO = 'L', only the lower
*          triangular part of A is used to define the elements of the
*          symmetric matrix.
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  IA      (global input) INTEGER
*          A's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JA      (global input) INTEGER
*          A's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCA   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix A.
*
*  W       (global output) DOUBLE PRECISION array, dimension (N)
*          If INFO=0, the eigenvalues in ascending order.
*
*  Z       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Z, LOCc(JZ+N-1) )
*          Z contains the orthonormal eigenvectors
*          of the symmetric matrix A.
*
*  IZ      (global input) INTEGER
*          Z's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JZ      (global input) INTEGER
*          Z's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCZ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*          DESCZ( CTXT_ ) must equal DESCA( CTXT_ )
*
*  WORK    (local workspace/output) DOUBLE PRECISION array,
*          dimension (LWORK)
*          On output, WORK(1) returns the workspace required.
*
*  LWORK   (local input) INTEGER
*          LWORK >= MAX( 1+6*N+2*NP*NQ, TRILWMIN ) + 2*N
*          TRILWMIN = 3*N + MAX( NB*( NP+1 ), 3*NB )
*          NP = NUMROC( N, NB, MYROW, IAROW, NPROW )
*          NQ = NUMROC( N, NB, MYCOL, IACOL, NPCOL )
*
*          If LWORK = -1, the LWORK is global input and a workspace
*          query is assumed; the routine only calculates the minimum
*          size for the WORK array.  The required workspace is returned
*          as the first element of WORK and no error message is issued
*          by PXERBLA.
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if LIWORK > 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          LIWORK = 7*N + 8*NPCOL + 2
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  Alignment requirements
*  ======================
*
*  The distributed submatrices sub( A ), sub( Z ) must verify
*  some alignment properties, namely the following expression
*  should be true:
*  ( MB_A.EQ.NB_A.EQ.MB_Z.EQ.NB_Z .AND. IROFFA.EQ.ICOFFA .AND.
*    IROFFA.EQ.0 .AND.IROFFA.EQ.IROFFZ. AND. IAROW.EQ.IZROW)
*    with IROFFA = MOD( IA-1, MB_A )
*     and ICOFFA = MOD( JA-1, NB_A ).
*
*  Further Details
*  ======= =======
*
*  Contributed by Francoise Tisseur, University of Manchester.
*
*  Reference:  F. Tisseur and J. Dongarra, "A Parallel Divide and
*              Conquer Algorithm for the Symmetric Eigenvalue Problem
*              on Distributed Memory Architectures",
*              SIAM J. Sci. Comput., 6:20 (1999), pp. 2223--2236.
*              (see also LAPACK Working Note 132)
*                http://www.netlib.org/lapack/lawns/lawn132.ps
*
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY, UPPER
      INTEGER            IACOL, IAROW, ICOFFA, ICOFFZ, ICTXT, IINFO,
     $                   INDD, INDE, INDE2, INDTAU, INDWORK, INDWORK2,
     $                   IROFFA, IROFFZ, ISCALE, LIWMIN, LLWORK,
     $                   LLWORK2, LWMIN, MYCOL, MYROW, NB, NP, NPCOL,
     $                   NPROW, NQ, OFFSET, TRILWMIN
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. Local Arrays ..
*     ..
      INTEGER            IDUM1( 2 ), IDUM2( 2 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2P, NUMROC
      DOUBLE PRECISION   PDLAMCH, PDLANSY
      EXTERNAL           LSAME, INDXG2P, NUMROC, PDLAMCH, PDLANSY
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DSCAL, PCHK1MAT,
     $                   PDLARED1D, PDLASCL, PDLASET, PDORMTR, PDSTEDC,
     $                   PDSYTRD, PXERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, ICHAR, MAX, MIN, MOD, SQRT
*     ..
*     .. Executable Statements ..
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Quick return
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Test the input arguments.
*
      CALL BLACS_GRIDINFO( DESCZ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
*
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE
         CALL CHK1MAT( N, 3, N, 3, IA, JA, DESCA, 7, INFO )
         CALL CHK1MAT( N, 3, N, 3, IZ, JZ, DESCZ, 12, INFO )
         IF( INFO.EQ.0 ) THEN
            UPPER = LSAME( UPLO, 'U' )
            NB = DESCA( NB_ )
            IROFFA = MOD( IA-1, DESCA( MB_ ) )
            ICOFFA = MOD( JA-1, DESCA( NB_ ) )
            IROFFZ = MOD( IZ-1, DESCZ( MB_ ) )
            ICOFFZ = MOD( JZ-1, DESCZ( NB_ ) )
            IAROW = INDXG2P( IA, NB, MYROW, DESCA( RSRC_ ), NPROW )
            IACOL = INDXG2P( JA, NB, MYCOL, DESCA( CSRC_ ), NPCOL )
            NP = NUMROC( N, NB, MYROW, IAROW, NPROW )
            NQ = NUMROC( N, NB, MYCOL, IACOL, NPCOL )
*
            LQUERY = ( LWORK.EQ.-1 )
            TRILWMIN = 3*N + MAX( NB*( NP+1 ), 3*NB )
            LWMIN = MAX( 1+6*N+2*NP*NQ, TRILWMIN ) + 2*N
            LIWMIN = 7*N + 8*NPCOL + 2
            WORK( 1 ) = DBLE( LWMIN )
            IWORK( 1 ) = LIWMIN
            IF( .NOT.LSAME( JOBZ, 'V' ) ) THEN
               INFO = -1
            ELSE IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
               INFO = -2
            ELSE IF( IROFFA.NE.ICOFFA .OR. ICOFFA.NE.0 ) THEN
               INFO = -6
            ELSE IF( IROFFA.NE.IROFFZ .OR. ICOFFA.NE.ICOFFZ ) THEN
               INFO = -10
            ELSE IF( DESCA( M_ ).NE.DESCZ( M_ ) ) THEN
               INFO = -( 1200+M_ )
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 700+NB_ )
            ELSE IF( DESCZ( MB_ ).NE.DESCZ( NB_ ) ) THEN
               INFO = -( 1200+NB_ )
            ELSE IF( DESCA( MB_ ).NE.DESCZ( MB_ ) ) THEN
               INFO = -( 1200+MB_ )
            ELSE IF( DESCA( CTXT_ ).NE.DESCZ( CTXT_ ) ) THEN
               INFO = -( 1200+CTXT_ )
            ELSE IF( DESCA( RSRC_ ).NE.DESCZ( RSRC_ ) ) THEN
               INFO = -( 1200+RSRC_ )
            ELSE IF( DESCA( CSRC_ ).NE.DESCZ( CSRC_ ) ) THEN
               INFO = -( 1200+CSRC_ )
            ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -14
            ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -16
            END IF
         END IF
         IF( UPPER ) THEN
            IDUM1( 1 ) = ICHAR( 'U' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'L' )
         END IF
         IDUM2( 1 ) = 2
         IF( LWORK.EQ.-1 ) THEN
            IDUM1( 2 ) = -1
         ELSE
            IDUM1( 2 ) = 1
         END IF
         IDUM2( 2 ) = 14
         CALL PCHK1MAT( N, 3, N, 3, IA, JA, DESCA, 7, 2, IDUM1, IDUM2,
     $                  INFO )
      END IF
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( ICTXT, 'PDSYEVD', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Set up pointers into the WORK array
*
      INDTAU = 1
      INDE = INDTAU + N
      INDD = INDE + N
      INDE2 = INDD + N
      INDWORK = INDE2 + N
      LLWORK = LWORK - INDWORK + 1
      INDWORK2 = INDD
      LLWORK2 = LWORK - INDWORK2 + 1
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
      SAFMIN = PDLAMCH( DESCA( CTXT_ ), 'Safe minimum' )
      EPS = PDLAMCH( DESCA( CTXT_ ), 'Precision' )
      SMLNUM = SAFMIN / EPS
      BIGNUM = ONE / SMLNUM
      RMIN = SQRT( SMLNUM )
      RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
      ANRM = PDLANSY( 'M', UPLO, N, A, IA, JA, DESCA, WORK( INDWORK ) )
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PDLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
      END IF
*
*     Reduce symmetric matrix to tridiagonal form.
*
*
      CALL PDSYTRD( UPLO, N, A, IA, JA, DESCA, WORK( INDD ),
     $              WORK( INDE2 ), WORK( INDTAU ), WORK( INDWORK ),
     $              LLWORK, IINFO )
*
*     Copy the values of D, E to all processes.
*
      CALL PDLARED1D( N, IA, JA, DESCA, WORK( INDD ), W,
     $                WORK( INDWORK ), LLWORK )
*
      CALL PDLARED1D( N, IA, JA, DESCA, WORK( INDE2 ), WORK( INDE ),
     $                WORK( INDWORK ), LLWORK )
*
      CALL PDLASET( 'Full', N, N, ZERO, ONE, Z, 1, 1, DESCZ )
*
      IF( UPPER ) THEN
         OFFSET = 1
      ELSE
         OFFSET = 0
      END IF
      CALL PDSTEDC( 'I', N, W, WORK( INDE+OFFSET ), Z, IZ, JZ, DESCZ,
     $              WORK( INDWORK2 ), LLWORK2, IWORK, LIWORK, INFO )
*
      CALL PDORMTR( 'L', UPLO, 'N', N, N, A, IA, JA, DESCA,
     $              WORK( INDTAU ), Z, IZ, JZ, DESCZ, WORK( INDWORK2 ),
     $              LLWORK2, IINFO )
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, ONE / SIGMA, W, 1 )
      END IF
*
      RETURN
*
*     End of PDSYEVD
*
      END

! ================================= added by K. Tagami  ==================== 5.0
subroutine Renewal_of_Hubbard_Parameters()
  use m_Files,               only : nfout
  use m_Ionic_System,        only : natm
  use m_Const_Parameters,     only : OFF, ON, DP
  use m_Control_Parameters,      only :  sw_eval_Ueff_using_edelta, &
       &                                 sw_eval_Ueff_using_iter, &
       &                                 iteration_for_Ueff_starting, &
       &                                 edelta_for_Ueff_starting, &
       &                                 Ueff_transition_period
  use m_IterationNumbers,     only : iteration_electronic
  use m_Total_Energy,         only : m_TE_what_is_edeltb_now
  use m_Hubbard,             only : Ueff_prefactor

  use m_Control_Parameters,   only : printable

  implicit none

  real(kind=DP) :: edeltab_per_atom
!
! -------------------- 
  edeltab_per_atom = m_TE_what_is_edeltb_now() / natm
  edeltab_per_atom = abs(edeltab_per_atom )

  if ( sw_eval_Ueff_using_edelta==ON .or. sw_eval_Ueff_using_iter==ON ) then
    call set_new_Ueff_prefactor
  endif

contains

  subroutine set_new_Ueff_prefactor

    integer,save :: iteration0_save = 0
    integer, save :: Start_Ueff_Transition = OFF

    Ueff_prefactor = 1.0D0
    if ( sw_eval_Ueff_using_iter == ON ) then
       Ueff_prefactor = dble( iteration_electronic - iteration_for_Ueff_starting ) &
            &          / dble(Ueff_transition_period)
       
       if ( Ueff_prefactor < 0.0 ) Ueff_prefactor = 0.0D0
       if ( Ueff_prefactor > 1.0 ) Ueff_prefactor = 1.0D0
       
    else if ( sw_eval_Ueff_using_edelta == ON ) then
       
       if ( Start_Ueff_Transition == OFF ) then
          Ueff_prefactor = 0.0D0
          if ( edeltab_per_atom < edelta_for_Ueff_starting ) then
             iteration0_save = iteration_electronic
             Start_Ueff_Transition = ON
          endif
       endif
       
       if ( Start_Ueff_Transition == ON ) then
          Ueff_prefactor = dble( iteration_electronic - iteration0_save ) &
               &          / dble(Ueff_transition_period)
          
          if ( Ueff_prefactor < 0.0 ) Ueff_prefactor = 0.0D0
          if ( Ueff_prefactor > 1.0 ) Ueff_prefactor = 1.0D0
       endif
    endif
    if ( printable ) then
       write(nfout,*)  '!== * Ueff_prefactor_now = ', &
            &        iteration_electronic, Ueff_prefactor
    endif

  end subroutine set_new_Ueff_prefactor

end subroutine Renewal_of_Hubbard_Parameters

      module communication_h
      implicit none

      include 'mpif.h'

      public  :: send_dbl
      private :: isend_dbl
      public  :: recv_dbl
      private :: irecv_dbl
      private :: wait_dbl
      public  :: bcast_dbl
      public  :: reduce_dbl
      public  :: get_loop_start
      public  :: get_loop_end
      public  :: translate_l2g
      public  :: translate_g2l
      public  :: get_owner_node
      public  :: loop_c
      public  :: eigen_init
      public  :: eigen_free
      public  :: datacast_dbl
      public  :: cyc1d_cyc2d
      public  :: cyc2d_cyc1d
      private :: ierr

      integer :: ierr

      contains
!----
      subroutine send_dbl(buf, n, idest, icom)
      implicit none

      integer, intent(in)    :: n, idest, icom
      real(8), intent(inout) :: buf(1:n)

      call mpi_send(buf, n, mpi_double_precision,
     &              idest-1, 1, icom, ierr)

      return
      end subroutine ! send_dbl
!----
      subroutine isend_dbl(buf, n, idest, ireq, icom)
      implicit none

      integer, intent(in)    :: n, idest, icom
      integer, intent(inout) :: ireq
      real(8), intent(inout) :: buf(1:n)

      call mpi_isend(buf,n,mpi_double_precision,
     &               idest-1, 1, icom, ireq, ierr)

      return
      end subroutine ! isend_dbl
!----
      subroutine recv_dbl(buf, n, isrc, icom)
      implicit none

      integer, intent(in)    :: n, isrc, icom
      real(8), intent(inout) :: buf(1:n)
      integer                :: status(mpi_status_size)

      call mpi_recv(buf, n, mpi_double_precision,
     &              isrc-1, 1, icom, status, ierr)

      return
      end subroutine ! recv_dbl
!----
      subroutine irecv_dbl(buf, n, isrc, ireq, icom)
      implicit none

      integer, intent(in)    :: n, isrc, icom
      integer, intent(inout) :: ireq
      real(8), intent(inout) :: buf(1:n)

      call mpi_irecv(buf, n, mpi_double_precision,
     &               isrc-1, 1, icom, ireq, ierr)

      return
      end subroutine ! irecv_dbl
!----
      subroutine wait_dbl(ireq)
      implicit none

      integer, intent(inout) :: ireq

      integer                :: status(mpi_status_size)

      call mpi_wait(ireq, status, ierr)

      return
      end subroutine ! wait_dbl
!----
      subroutine bcast_dbl(buf, n, iroot, icom)
      implicit none

      integer, intent(in)    :: n, iroot, icom
      real(8), intent(inout) :: buf(1:n)

      real(8) ::    d1, d2
      real(8) ::    time_bcast, time_reduce, time_redist
      common /stat/ time_bcast, time_reduce, time_redist

#ifdef TIMER
      call mpi_barrier(icom,ierr)
      d1=mpi_wtime()
#endif

      call mpi_bcast(buf, n, mpi_double_precision,
     &               iroot-1, icom, ierr)

#ifdef TIMER
      d2=mpi_wtime()
      time_bcast=time_bcast+(d2-d1)
#endif

      return
      end subroutine ! bcast_dbl
!----
      subroutine reduce_dbl(buf, wrk, n, icom)
      implicit none

      integer, intent(in)    :: n, icom
      real(8), intent(inout) :: buf(1:n), wrk(1:n)

      real(8) ::    d1, d2
      real(8) ::    time_bcast, time_reduce, time_redist
      common /stat/ time_bcast, time_reduce, time_redist

#ifdef TIMER
      call mpi_barrier(icom,ierr)
      d1=mpi_wtime()
#endif

      call mpi_allreduce(buf, wrk, n, mpi_double_precision,
     &                   mpi_sum, icom, ierr)
      buf(1:n) = wrk(1:n)

#ifdef TIMER
      d2=mpi_wtime()
      time_reduce=time_reduce+(d2-d1)
#endif

      return
      end subroutine ! reduce_dbl
!----
      integer function get_loop_start(istart, nnod, inod)
      implicit none

      integer, intent(in)    :: istart, nnod, inod

      get_loop_start = (istart+nnod-1-inod)/nnod+1

      return
      end function ! get_loop_start
!----
      integer function get_loop_end(iend, nnod, inod)
      implicit none

      integer, intent(in)    :: iend, nnod, inod

      get_loop_end   = (iend  +nnod  -inod)/nnod+0

      return
      end function ! get_loop_end
!----
      integer function translate_l2g(ictr, nnod, inod)
      implicit none

      integer, intent(in)    :: ictr, nnod, inod

      translate_l2g   = (ictr-1)*nnod+inod

      return
      end function ! translate_l2g
!----
      integer function get_owner_node(ictr, nnod, inod)
      implicit none

      integer, intent(in)    :: ictr, nnod, inod

      get_owner_node   = mod(ictr-1,nnod)+1

      return
      end function ! get_owner_node
!----
      integer function translate_g2l(ictr, nnod, inod)
      implicit none

      integer, intent(in)    :: ictr, nnod, inod

      translate_g2l   = (ictr-1)/nnod+1

      return
      end function ! translate_g2l
!----
      subroutine loop_c(istart, iend, idoctr, isize, nnod, inod)
      implicit none

      integer, intent(inout) :: istart, iend, idoctr
      integer, intent(in)    :: isize, nnod, inod

      integer                :: istart0, iend0, idoctr0
      integer                :: istart1, iend1

!---- integer, external      :: get_loop_start, get_loop_end

      if ( istart > iend ) then
         istart=1; iend=0; idoctr=0
         return
      end if
      if ( nnod == 1 ) then
         idoctr=istart
         return
      end if

      istart1 = max(istart,1    )
      iend1   = min(iend  ,isize)

      istart = get_loop_start(istart1,nnod,inod)
      iend   = get_loop_end  (iend1,  nnod,inod)
      idoctr = (istart-1)*nnod+inod

      return
      end subroutine ! loop_c
!----

      subroutine eigen_init(ndim)
      implicit none

      include 'trd.h'

      integer                ::  ndim
      integer                ::  n1, n2, n3, i, j, k, ierr
      integer                ::  base_comm, base_inod, base_nnod

!---- integer, parameter     ::  cluster_const = 2 ! test case
      integer, parameter     ::  cluster_const = 8 ! es

      call mpi_comm_size(mpi_comm_eigen, nprocs, ierr)
      call mpi_comm_rank(mpi_comm_eigen, myrank, ierr)
      myrank = myrank+1

      if ( ndim == 1 ) then
         size_of_col = 1 !! fixed
      else if ( nprocs < cluster_const**2 ) then
         size_of_col = int(sqrt(dble(nprocs)))
         do
            if ( size_of_col == 1 ) exit
            if ( mod(nprocs,size_of_col) == 0 ) exit
            size_of_col = size_of_col-1
         end do!!
         else
!----
            size_of_col = int(sqrt(dble(nprocs)))
         if ( mod(nprocs,cluster_const) == 0 ) then
            do
               if ( size_of_col <= cluster_const ) exit
               if ( mod(size_of_col,cluster_const) == 0 .and.
     &              mod(nprocs,size_of_col) == 0 ) exit
                  size_of_col = size_of_col-1
            end do!!
         else
            size_of_col = 1
         end if
!----
      endif
      size_of_row = nprocs/size_of_col
!----
!---- if(myrank==1)print*,"pe partition = ",size_of_col,size_of_row
!----
      my_col = mod(myrank-1, size_of_col)+1
      my_row =    (myrank-1)/size_of_col +1

      call mpi_comm_split(mpi_comm_eigen,my_row,my_col,
     &                    mpi_comm_col,ierr)
      call mpi_comm_split(mpi_comm_eigen,my_col,my_row,
     &                    mpi_comm_row,ierr)

!----
      if ( mod(size_of_col,cluster_const) == 0 ) then
         base_nnod = size_of_col
         base_inod = my_col
         base_comm = mpi_comm_col
      else
         base_nnod = nprocs
         base_inod = myrank
         base_comm = mpi_comm_eigen
      endif

      es_cluster = cluster_const
      es_icnod = mod(base_inod-1, es_cluster)+1
      es_ignod =    (base_inod-1)/es_cluster +1
      call mpi_comm_split(base_comm,es_ignod,es_icnod,
     &                    es_ccomm_world,ierr)
      call mpi_comm_split(base_comm,es_icnod,es_ignod,
     &                    es_gcomm_world,ierr)
      call mpi_comm_size(es_ccomm_world, es_ncnod, ierr)
      call mpi_comm_size(es_gcomm_world, es_ngnod, ierr)
!----

      n1 = max(size_of_col,size_of_row)
      n2 = min(size_of_col,size_of_row)
      do
         if ( n1 == n2 ) then
            n_common = n1
            exit
         end if
         n3 = n1-n2
         n1 = max(n2,n3)
         n2 = min(n2,n3)
      end do!!


      p0_ = -1
      q0_ = -1
      do i=1,size_of_col
         if ( mod(i-1,n_common) == mod(my_row-1,n_common) ) then
            n1 = my_row-i
            if ( n1 >= 0 ) then
               do j=1,size_of_col
                  k = +n1+(j-1)*size_of_row
                  if ( mod(k,size_of_col) == 0 ) then
                     p0_(i) = k/size_of_col
                     q0_(i) = (j-1)
                     exit
                  end if
               end do! j
            else
               do j=1,size_of_row
                  k = -n1+(j-1)*size_of_col
                  if ( mod(k,size_of_row) == 0 ) then
                     q0_(i) = k/size_of_row
                     p0_(i) = (j-1)
                     exit
                  end if
               end do! j
            end if
         end if
      end do! i
      p0_ = p0_+1
      q0_ = q0_+1


      diag_0 = 0
      do i=1,size_of_row/n_common
         j = (i-1)*size_of_row+my_row
         k = mod(j-1,size_of_col)+1
         if ( k == my_col ) then
            diag_0 = i
            exit
         end if
      end do! i_1


      return
      end subroutine ! eigen_init
!----
      subroutine eigen_free(flag)
      implicit none

      include 'trd.h'

      integer :: flag

      real(8) ::    time_bcast, time_reduce, time_redist
      common /stat/ time_bcast, time_reduce, time_redist

      call mpi_comm_free(mpi_comm_col,ierr)
      call mpi_comm_free(mpi_comm_row,ierr)
!----
      call mpi_comm_free(es_ccomm_world,ierr)
      call mpi_comm_free(es_gcomm_world,ierr)
!----
#ifdef DETAIL
      if ( flag == 2 .and. myrank == 1 ) then
         print*, " "
         print*, "detail of exectime in \"eigen_dch\""
         print*, "  communication time in \"eigen_dch\""
      endif
      if ( flag == 3 .and. myrank == 1 ) then
         print*, "  communication time in \"eigen_hbk\""
      endif
      if ( flag >= 1 .and. flag <=3 .and. myrank == 1 ) then
         print*, "   bcast       :: ", time_bcast,"(sec)"
         print*, "   reduce      :: ", time_reduce,"(sec)"
         print*, "   redist      :: ", time_redist,"(sec)"
      endif
#endif

      return
      end subroutine ! eigen_free
!----
      subroutine datacast_dbl(u_y, u_x, u_t, u_s, n)
      implicit none

      integer, intent(in)    :: n
      real(8), intent(inout) :: u_y(1:n), u_x(1:n), u_t(1:n), u_s(1:n)

      include 'trd.h'

      integer                :: nx, ny, ic, i, j, k
      integer                :: req(1024), x_snod, y_snod
      integer                :: his_rank, her_rank

      real(8) ::    d1, d2
      real(8) ::    time_bcast, time_reduce, time_redist
      common /stat/ time_bcast, time_reduce, time_redist

#ifdef TIMER
      call mpi_barrier(mpi_comm_col,ierr)
      d1=mpi_wtime()
#endif

      if ( size_of_col == 1 ) then
         if ( size_of_row == 1 ) then
            u_y(1:n) = u_x(1:n)
         else
            ny = (n-1)/size_of_row+1
            do i=1,ny
               j = my_row+size_of_row*(i-1)
               u_y(i) = u_x(j)
            end do! i
         end if
         return
      end if

      if ( size_of_col == size_of_row ) then
         if ( my_col == my_row ) then
            u_y(1:n) = u_x(1:n)
         end if
         call bcast_dbl(u_y, n, my_row, mpi_comm_col)
         return
      end if

      x_snod = size_of_col/n_common
      y_snod = size_of_row/n_common

      if ( p0_(my_col) > 0 ) then

         nx = (n-p0_(my_col))/y_snod+1
         do i=1,nx
            j = p0_(my_col)+y_snod*(i-1)
            k = q0_(my_col)+x_snod*(i-1)
            u_t(i) = u_x(j)
            u_y(k) = u_x(j)
!----       print*,"i am",myrank,"sdrv ",myrank
         end do! i

         do ic=1,x_snod-1

!----
! receiving message : length    = ifloor(n/y_snod)
!                   : #sender   = size_of_col-1
!----
            his_rank = mod(my_col-1+size_of_col+ic*n_common,
     &                     size_of_col)+1
            ny = (n-p0_(his_rank))/y_snod+1
!----       print*,"i am",myrank,"recv ",(his_rank-1)*size_of_row+my_row
            call irecv_dbl(u_s, ny, his_rank, req(ic), mpi_comm_col)

!----
! sending message   : length    = ifloor(n/y_snod)
!                   : #receiver = size_of_col-1
!----
            her_rank = mod(my_col-1+size_of_col-ic*n_common,
     &                     size_of_col)+1
            call send_dbl(u_t, nx, her_rank, mpi_comm_col)
!----       print*,"i am",myrank,"send ",(her_rank-1)*size_of_row+my_row

            call wait_dbl(req(ic))

            do i=1,ny
               k = q0_(his_rank)+x_snod*(i-1)
               u_y(k) = u_s(i)
            end do! i

         end do! ic

         do ic=1,n_common-1
            her_rank = mod(my_col-1 +size_of_col +ic,size_of_col)+1
!----       print*,"i am",myrank,"send ",(her_rank-1)*size_of_row+my_row
            call isend_dbl(u_y, n, her_rank, req(ic), mpi_comm_col)
            call wait_dbl(req(ic))
         end do! ic

      else

         i = mod(my_row-1,n_common)
         j = mod(my_col-1,n_common)
         ic = mod(j-i+n_common,n_common)
         his_rank = mod(my_col-1 +size_of_col -ic,size_of_col)+1
!----    print*,"i am",myrank,"recv ",(his_rank-1)*size_of_row+my_row
         call recv_dbl(u_y, n, his_rank, mpi_comm_col)

      end if

#ifdef TIMER
      d2=mpi_wtime()
      time_redist=time_redist+(d2-d1)
#endif

      return
      end subroutine ! datacast_dbl
!----
      subroutine cyc1d_cyc2d(n,a,lda,b,ldb,size_of_col,size_of_row,iret)
      implicit none
!----
      integer                 :: n,lda,ldb,iret
      real(8)                 :: a(lda,1), b(ldb,1)
      integer                 :: size_of_col, size_of_row
!----
      real(8), pointer        :: work(:,:)
      integer                 :: world_size, my_rank, sq_size
      integer                 :: his_rank, her_rank
      integer                 :: his_posx, her_posx
      integer                 :: his_posy, her_posy
      integer                 :: my_posx, my_posy, my_posu, my_posv
      integer                 :: size_s,size_r
      integer                 :: nws, nqs
      integer                 :: i,j,k, ic,jc,kc,lc,id
!----
      integer                 :: status(mpi_status_size)
      integer                 :: type
      integer                 :: comm
      integer                 :: tag
      integer                 :: req
      integer                 :: error
      include 'commtxt.h'
!----
      iret = 0
!----
      if ( n > lda ) then
         iret = 1
         return
      end if
!----
!---- [*,world_size] --> [size_of_row,size_of_col]
!----     a(lda,nws) --> b(ldb,nqs)
!----
      comm = mpi_comm_eigen
      type = mpi_double_precision
      tag  = 10000
!----
      call mpi_comm_size(comm,world_size,error)
      call mpi_comm_rank(comm,my_rank,error)
      my_rank = my_rank+1
!---- sq_size=int(sqrt(dble(world_size)))
!----
!---- size_of_row = sq_size
!---- size_of_col = world_size / size_of_row
      if ( size_of_col*size_of_row /= world_size ) then
         iret = 3
         return
      end if
!----
      nws = (n-1)/world_size+1
      nqs = (n-1)/size_of_col+1
      if ( nqs > ldb ) then
         iret = 2
         return
      end if
!----
!---- if ( size_of_col > 1 ) then
      allocate(work(ldb,size_of_col), stat=error)
      if ( error /= 0 ) then
         iret = -1
         return
      end if
!---- end if
!----
      my_posx = mod(my_rank-1, size_of_col) + 1
      my_posy =    (my_rank-1)/size_of_col  + 1
      my_posu = mod(my_rank-1, size_of_row) + 1
      my_posv =    (my_rank-1)/size_of_row  + 1
!----
!----
      call mpi_barrier(comm,error)
!----
      do ic=1,nws
!----
         kc = my_rank+(ic-1)*world_size
         if ( kc <= n ) then
!----
            do id=1,size_of_col
               his_posx = mod(my_posv+id-2,size_of_col)+1
               size_s   =    (n-his_posx)/size_of_col+1
               do i=1,size_s
                  j = his_posx+(i-1)*size_of_col
                  work(i,id) = a(j,ic)
               end do
            end do
!----
         end if
!----
!---- bucket algorithm
!----
         do id=1,size_of_col
!----
            his_posx = mod(my_posv+id-2,size_of_col)+1
            his_rank =    (his_posx-1)*1+(my_posu-1)*size_of_col+1

            if ( kc <= n ) then
               size_s = (n-his_posx)/size_of_col+1
            else
               size_s = 0
            end if

            if ( size_s > 0 ) then
               call mpi_isend(work(1,id),size_s,type,
     &                        his_rank-1,tag,comm,req,error)
!----          print*,"i am",my_rank,"send ",his_rank,work(1:size_s,id)
            end if
!----
            her_posx = mod(my_posx-1+size_of_col-id+1,size_of_col)+1
            her_rank =    (her_posx-1)*size_of_row+(my_posy-1)*1+1

            lc = her_rank+(ic-1)*world_size

            if ( lc <= n ) then
               size_r = (n-my_posx)/size_of_col+1
            else
               size_r = 0
            end if

            if ( size_r > 0 ) then
               jc = her_posx+(ic-1)*size_of_col
               call mpi_recv(b(1,jc),size_r,type,
     &                       her_rank-1,tag,comm,status,error)
!----          print*,"i am",my_rank,"recv ",her_rank,b(1:size_r,jc),jc
            end if
!----
            if ( size_s > 0 ) then
               call mpi_wait(req,status,error)
            end if
!----
         end do

      end do
!----
!---- call mpi_barrier(comm,error)
!----
!---- if ( size_of_col > 1 ) then
      deallocate(work)
!---- end if
!----
      return
      end subroutine
!----
      subroutine cyc2d_cyc1d(n,a,lda,b,ldb,size_of_col,size_of_row,iret)
      implicit none
!----
      integer                 :: n,lda,ldb,iret
      real(8)                 :: a(lda,1), b(ldb,1)
      integer                 :: size_of_col, size_of_row
!----
      real(8), pointer        :: work(:,:)
      integer                 :: world_size, my_rank, sq_size
      integer                 :: his_rank, her_rank
      integer                 :: his_posx, her_posx
      integer                 :: his_posy, her_posy
      integer                 :: my_posx, my_posy, my_posu, my_posv
      integer                 :: size_s,size_r
      integer                 :: nws, nqs
      integer                 :: i,j,k, ic,jc,kc,lc,id
!----
      integer                 :: status(mpi_status_size)
      integer                 :: type
      integer                 :: comm
      integer                 :: tag
      integer                 :: req
      integer                 :: error

      include 'commtxt.h'
!----
      iret = 0
!----
      if ( n > lda ) then
         iret = 1
         return
      end if
!----
!---- [*,world_size] <-- [size_of_row,size_of_col]
!---- a(lda,nws) <-- b(ldb,nqs)
!----
      comm = mpi_comm_eigen
      type = mpi_double_precision
      tag  = 10000
!----
      call mpi_comm_size(comm,world_size,error)
      call mpi_comm_rank(comm,my_rank,error)
      my_rank = my_rank+1
!---- sq_size = int(sqrt(dble(world_size)))
!----
!---- size_of_row = sq_size
!---- size_of_col = world_size / size_of_row
      if ( size_of_col*size_of_row /= world_size ) then
         iret = 3
         return
      end if
!----
      nws = (n-1)/world_size+1
      nqs = (n-1)/size_of_col+1
      if ( nqs > ldb ) then
         iret = 2
         return
      end if
!----
!---- if ( size_of_col > 1 ) then
      allocate(work(ldb,size_of_col), stat=error)
      if ( error /= 0 ) then
         iret = -1
         return
      end if
!---- end if
!----
      my_posx = mod(my_rank-1, size_of_col) + 1
      my_posy =    (my_rank-1)/size_of_col  + 1
      my_posu = mod(my_rank-1, size_of_row) + 1
      my_posv =    (my_rank-1)/size_of_row  + 1
!----
!----
      call mpi_barrier(comm,error)
!----
      do ic=1,nws
!----
         kc = my_rank+(ic-1)*world_size
!----
!---- bucket algorithm
!----
         do id=1,size_of_col
!----
            her_posx = mod(my_posx-1+size_of_col-id+1,size_of_col)+1
            her_rank =    (her_posx-1)*size_of_row+(my_posy-1)*1+1

            lc = her_rank+(ic-1)*world_size
            if ( lc <= n ) then
               size_r = (n-my_posx)/size_of_col+1
            else
               size_r = 0
            end if

            if ( size_r > 0 ) then
               jc = her_posx+(ic-1)*size_of_col
               call mpi_isend(b(1,jc),size_r,type,
     &                        her_rank-1,tag,comm,req,error)
!----          print*,"i am",my_rank,"recv ",her_rank,b(1:size_r,jc)
            end if
!----
            his_posx = mod(my_posv+id-2,size_of_col)+1
            his_rank =    (his_posx-1)*1+(my_posu-1)*size_of_col+1

            if ( kc <= n ) then
               size_s = (n-his_posx)/size_of_col+1
            else
               size_s = 0
            end if

            if ( size_s > 0 ) then
               call mpi_recv(work(1,id),size_s,type,
     &                       his_rank-1,tag,comm,status,error)
!----          print*,"i am",my_rank,"send ",his_rank,work(1:size_s,id)
            end if
!----
            if ( size_r>0)then
               call mpi_wait(req,status,error)
            end if
!----
         end do

         if ( kc <= n ) then
            do id=1,size_of_col
               his_posx = mod(my_posv+id-2,size_of_col)+1
               size_s   =    (n-his_posx)/size_of_col+1
               do i=1,size_s
                  j = his_posx+(i-1)*size_of_col
                  a(j,ic) = work(i,id)
               end do
            end do
         end if
!----
      end do
!----
      call mpi_barrier(comm,error)
!----
!---- if ( size_of_col > 1 ) then
      deallocate(work)
!---- end if
!----
      return
      end subroutine

      end module communication_h

      SUBROUTINE MY_PDLAEDZ(COMPZ, HBW, N, N1, ID, Q, IQ, JQ, LDQ, 
     $                       DESCQ, Z, WORK, V )

       IMPLICIT NONE
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            ID, IQ, JQ, LDQ, N, N1, HBW
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * )
      DOUBLE PRECISION   Q( LDQ, * ), WORK( * ), Z( * ),
     $                   V( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAEDZ Form the z-vector which consists of the last row of Q_1
*  and the first row of Q_2.
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
*
      INTEGER            COL, I, IBUF, ICTXT, IIQ, IIZ1, IIZ2, IQCOL,
     $                   IQROW, IZ, IZ1, IZ1COL, IZ1ROW, IZ2, IZ2COL,
     $                   IZ2ROW, J, JJQ, JJZ1, JJZ2, MYCOL, MYROW, N2,
     $                   NB, NBLOC, NPCOL, NPROW, NQ1, NQ2, ZSIZ, 
     $                    K
    
     
     
*       .. Local Arrays
*        ..
        DOUBLE PRECISION   TEMP( N )
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN, MOD
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, INFOG2L, DAXPY
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..
*     .. Executable Statements ..
*

*       This is just to keep ftnchek and toolpack/1 happy
       

      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      CALL INFOG2L( ID, ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      N2 = N - N1

      
      IF (COMPZ == 'F') GOTO 50
*
*     Z = Q'*V,  Q = DirectSum(Q1, Q2)
*

*
*     Form z1 which consist of the last two rows of Q1
*
      DO K = 1, HBW
        CALL INFOG2L( IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW, 
     $        NPCOL, MYROW, MYCOL, IIZ1, JJZ1, IZ1ROW, IZ1COL )
        NQ1 = NUMROC( N1, NB, MYCOL, IZ1COL, NPCOL )
        IF( ( MYROW.EQ.IZ1ROW ) .AND. ( NQ1.NE.0 ) ) THEN
           CALL DCOPY( NQ1, Q( IIZ1, JJZ1 ), LDQ, WORK, 1 )
           DO J = 1, NQ1
               WORK(J) = V(K) * WORK(J)
           END DO

           IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL )
     $        CALL DGESD2D( ICTXT, NQ1, 1, WORK, NQ1, IQROW, IQCOL )
        END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z1
*
        IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
           COL = IZ1COL
           DO 20 I = 0, NPCOL - 1
              NQ1 = NUMROC( N1, NB, COL, IZ1COL, NPCOL )
              IF( NQ1.GT.0 ) THEN
                 IF( IZ1ROW.NE.IQROW .OR. COL.NE.IQCOL ) THEN
                    IBUF = N1 + 1
                    CALL DGERV2D( ICTXT, NQ1, 1, WORK( IBUF ), NQ1,
     $                        IZ1ROW, COL )
                 ELSE
                    IBUF = 1
                 END IF
                 IZ1 = 0
                 IZ = I*NB + 1
                 NBLOC = ( NQ1-1 ) / NB + 1
                 DO 10 J = 1, NBLOC
                    ZSIZ = MIN( NB, NQ1-IZ1 )
                    CALL DCOPY( ZSIZ, WORK( IBUF+IZ1 ), 1, 
     $                          TEMP( IZ ), 1 )
                    IZ1 = IZ1 + NB
                    IZ = IZ + NB*NPCOL
10               CONTINUE
              END IF
              COL = MOD( COL+1, NPCOL )
20         CONTINUE
*
*          ADD THE NEW RECEIVED VECTOR TO Z
*
           IF (K .EQ. 1) THEN
                CALL DCOPY(N1, TEMP, 1, Z, 1)
            ELSE
                CALL DAXPY(N1, 1.0D+0, TEMP, 1, Z, 1)
            ENDIF
        END IF
      END DO
*
*     Form z2 which consist of the first 2 rows of Q2
*

      DO K = 1, HBW
        CALL INFOG2L( IQ-1+( ID+N1 ) + K - 1, JQ-1+( ID+N1 ), DESCQ, 
     $    NPROW, NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL)
        NQ2 = NUMROC( N2, NB, MYCOL, IZ2COL, NPCOL )
        IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ2.NE.0 ) ) THEN
           CALL DCOPY( NQ2, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
           DO J = 1, NQ2
               WORK(J) = V(K+HBW) * WORK(J)
           END DO
           IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL )
     $        CALL DGESD2D( ICTXT, NQ2, 1, WORK, NQ2, IQROW, IQCOL )
        END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z2
*
        IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
           COL = IZ2COL
           DO 40 I = 0, NPCOL - 1
              NQ2 = NUMROC( N2, NB, COL, IZ2COL, NPCOL )
              IF( NQ2.GT.0 ) THEN
                 IF( IQROW.NE.IZ2ROW .OR. IQCOL.NE.COL ) THEN
                    IBUF = 1 + N2
                    CALL DGERV2D( ICTXT, NQ2, 1, WORK( IBUF ), NQ2,
     $                            IZ2ROW, COL )
                 ELSE
                    IBUF = 1
                 END IF
                 IZ2 = 0
                 IZ = NB*I + N1 + 1
                 NBLOC = ( NQ2-1 ) / NB + 1
                 DO 30 J = 1, NBLOC
                    ZSIZ = MIN( NB, NQ2-IZ2 )
                    CALL DCOPY( ZSIZ, WORK( IBUF+IZ2 ), 1, 
     $                          TEMP( IZ ), 1 )
                    IZ2 = IZ2 + NB
                    IZ = IZ + NB*NPCOL
   30            CONTINUE
              END IF
              COL = MOD( COL+1, NPCOL )
   40      CONTINUE
*
*          ADD THE NEW RECEIVED VECTOR TO Z
*
           IF (K .EQ. 1) THEN
                CALL DAXPY(N2, 0.0D+0, Z(N1+1), 1, TEMP(N1+1), 1)
                CALL DCOPY(N2, TEMP(N1+1), 1, Z(N1+1), 1)
            ELSE
                CALL DAXPY(N2, 1.0D+0, TEMP(N1+1), 1, Z(N1+1), 1)
            ENDIF

        END IF
      END DO

      GOTO 100

50    CONTINUE

*
*     Q'*V, Q is a dense matrix
*     Need to sum up the 4 rows: IQ-1+(ID+N1-2)  ... IQ-1+(ID+N1+1)
*     that usually not on the same node
*

      DO K = 1, HBW*HBW

          CALL INFOG2L(IQ-1+(ID+N1-1-HBW+K), JQ-1+ID, DESCQ, NPROW,
     $           NPCOL, MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL )

          NQ1 = NUMROC( N, NB, MYCOL, IZ2COL, NPCOL )

          IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ1.NE.0 ) ) THEN
             CALL DCOPY( NQ1, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
             DO J = 1, NQ1
                 WORK (J) = V(K) * WORK (J)
             END DO
        

             IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL )
     $          CALL DGESD2D( ICTXT, NQ1, 1, WORK, NQ1, IQROW, IQCOL )
          END IF

*
*     Proc (IQROW, IQCOL) receive the parts of z1
*
          IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN

             COL = IZ2COL
             DO 70 I = 0, NPCOL - 1
                NQ1 = NUMROC( N, NB, COL, IZ2COL, NPCOL )
                IF( NQ1.GT.0 ) THEN
                   IF( IZ2ROW.NE.IQROW .OR. COL.NE.IQCOL ) THEN
                      IBUF = N1 + 1
                      CALL DGERV2D( ICTXT, NQ1, 1, WORK( IBUF ), NQ1,
     $                          IZ2ROW, COL )
                   ELSE
                      IBUF = 1
                   END IF
                   IZ1 = 0
                   IZ = I*NB + 1
                   NBLOC = ( NQ1-1 ) / NB + 1
                   DO 60 J = 1, NBLOC
                      ZSIZ = MIN( NB, NQ1-IZ1 )
                      CALL DCOPY( ZSIZ, WORK( IBUF+IZ1 ), 1, 
     $                            TEMP( IZ ), 1 )
                      IZ1 = IZ1 + NB
                      IZ = IZ + NB*NPCOL
   60              CONTINUE
                END IF
                COL = MOD( COL+1, NPCOL )
   70        CONTINUE


*
*             ADD THE NEW RECEIVED VECTOR TO Z
*

              IF (K .EQ. 1) THEN
!                 CALL DAXPY(N, 0.0D+0, Z, 1, TEMP, 1)
                  CALL DCOPY(N, TEMP, 1, Z, 1)

              ELSE
                  CALL DAXPY(N, 1.0D+0, TEMP, 1, Z, 1)
              ENDIF

          END IF

      END DO


100   CONTINUE
*
*     proc(IQROW,IQCOL) broadcast Z=(Z1,Z2)
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         CALL DGEBS2D( ICTXT, 'All', ' ', N, 1, Z, N )
      ELSE
         CALL DGEBR2D( ICTXT, 'All', ' ', N, 1, Z, N, IQROW, IQCOL )
      END IF


      RETURN
*

*     End of PDLAEDZ
*
      END

!=======================================================================
subroutine Potential_Mixing
! $Id: Potential_Mixing.F90 593 2019-06-20 03:47:31Z jkoga $

  use m_Const_Parameters,    only : DP,SIMPLE,BROYD1,BROYD2,DFP,PULAY,RMM2P,ON &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, CONTINUATION, SKIP

  use m_Charge_Density,      only : m_CD_check

  use m_Potential_mixing,     only : m_Pot_simple_mixing, m_Pot_prepare_precon, &
       &                             m_Pot_mix_broyden2, m_Pot_mix_pulay, &
       &                             m_Pot_simple_mixing_vhsr, &
       &                             m_Pot_set_array_vnonlocal, &
       &                             m_Pot_cp_vnonlocal_to_old
  use m_Ionic_System,        only : natm
  use m_Total_Energy,        only : m_TE_what_is_edeltb_now, m_TE_wd_total_energy_with_solvers
  use m_Control_Parameters,  only : c_precon,waymix,intzaj,icond &
       &                          , tag_solver_of_WF_is_found &
       &                          , tag_charge_mixing_is_found &
       &                          , iprichargemixing, nspin, af &
       &                          , m_CtrlP_rmx_now &
       &                          , m_CtrlP_solver_for_WFs_now &
       &                          , m_CtrlP_set_rmx &
       &                          , m_CtrlP_waymix_now &
       &                          , m_CtrlP_set_mix_parameter &
       &                          , m_CtrlP_clear_cdmixing_applied &
       &                          , sw_hubbard, sw_modified_TFW_functional
  use m_Files,               only : nfout
  use m_IterationNumbers,    only : iteration_electronic, iteration_ionic &
       &                          , m_Iter_cmix_reset
  use m_PseudoPotential,     only : flg_paw, modnrm

  use m_Const_Parameters,    only : OFF
  use m_Control_Parameters,  only : sw_mix_charge_hardpart, ekmode
  use m_Potential_mixing,   only : m_Pot_mix_broyden2_with_vhsr, &
       &                             m_Pot_mix_pulay_with_vhsr,  &
       &                             m_Pot_simple_mixing_hard, &
       &                             m_Pot_add_vnonlocal_to_vlhxcQ, &
       &                             vnonlocal_i, vnonlocal_r
  use m_IterationNumbers,     only : iteration, iteration_for_cmix, iteration_electronic
  use m_Orbital_Population,    only :  m_OP_cp_om_to_ommix

  use m_Control_Parameters,   only : noncol, SpinOrbit_mode
  use m_Charge_Density,       only : m_CD_check_noncl, m_CD_check
  use m_CD_Mag_Moment,        only : m_CD_calc_ChgMagMom_in_sphere, &
       &                             m_CD_print_ChgMagmom_on_atom, &
       &                             m_CD_estim_magmom_local, &
       &                             m_CD_print_magmom_local, &
       &                             m_CD_set_rad_cov_now, &
       &                             m_CD_set_rad_cov_default, &
       &                             sw_monitor_atomcharge
  use m_Const_Parameters,      only : Neglected
#ifndef WO_OP_MOMENT
  use m_OP_Moment,             only : m_OP_calc_orbmom_from_OCC
#endif

  use m_Electronic_Structure,   only : m_ES_cp_vlhxcQ_to_old, m_ES_cp_vlhxc_to_old, &
       &                               vlhxcQ, dhub
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_ES_NonCollinear,   only : m_ES_update_Mat_dion0_noncl, &
       &                          m_ES_set_Mat_dion_scr_noncl

  implicit none

  real(kind=DP) :: rmxt
  real(kind=DP) :: edeltb_per_atom
  integer,save  :: waymix_at_Potmix_previous = 0
  integer       :: waymix_at_Potmix
  logical       :: ini = .false.
  real(kind=DP) :: rmxt_tot, rmxt_hard
#ifdef __TIMER_SUB__
  call timer_sta(1101)
#endif

  call m_CtrlP_clear_cdmixing_applied()

  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return

! ------------------------------------------------------------
! --- copy the last potential to old ones, and calc the latest potential 
!

#if 0
  if ( iteration <= 1 .or. (icond==CONTINUATION .and. .not.ini))then
     call m_Pot_set_array_vnonlocal          ! vnonlocal = dhub + ....
     ini = .true.
  endif

  if ( sw_modified_TFW_functional == OFF ) then
!!!     call m_ES_cp_vlhxc_to_old
     if ( sw_mix_charge_hardpart == ON ) call m_Pot_cp_vnonlocal_to_old
  endif

#endif

  call m_Pot_set_array_vnonlocal
! ------------------------------------------------------------

  edeltb_per_atom = m_TE_what_is_edeltb_now()/natm 
  waymix_at_Potmix = m_CtrlP_waymix_now(iteration_electronic, iteration_ionic &
       &                             , edeltb_per_atom)
  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     if(waymix_at_Potmix_previous /= waymix_at_Potmix) call m_Iter_cmix_reset()
  end if

  rmxt = m_CtrlP_rmx_now(iteration_electronic, iteration_ionic)
  call m_CtrlP_set_mix_parameter()

  if(c_precon) call m_Pot_prepare_precon(nfout,rmxt)
  if(iprichargemixing >= 2) &
       & write(6,'(" waymix_at_Potmix = ",i4," rmxt = ",f8.4)') waymix_at_Potmix, rmxt


  call push_pot_mixing_name_applied(waymix_at_Potmix)
! ------------------------------------------------------------
! --- main part of potential mixnig 
! 
  rmxt_tot = rmxt;       rmxt_hard = rmxt

#if 0
  if ( sw_mix_charge_hardpart == ON ) then
     call mix_potential_with_hardpart()      ! does not work properly.
  else
     call mix_potential()
  endif

#else
  call mix_potential()
  if ( sw_mix_charge_hardpart == ON ) call mix_potential_only_hardpart         
#endif
! ------------------------------------------------------------

! ------------------------------------------------------------
! --- update vlhxcQ and related variables
!
  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ
  call m_Pot_add_vnonlocal_to_vlhxcQ

  if ( noncol ) then
     if ( flg_paw ) then
        if ( ekmode==ON .or. iteration_electronic >= 1 ) then
           call m_ES_update_Mat_dion0_noncl
        endif
     endif
     call m_ES_set_Mat_dion_scr_noncl( VlhxcQ, vnonlocal_i )
  endif

! ================================== modified by K. Tagami ========== 11.0
  if ( noncol ) then
     call m_CD_check_noncl(nfout)

     if ( .not. flg_paw ) call m_CD_estim_magmom_local(nfout)
     call m_CD_print_magmom_local(nfout)

     call m_CD_calc_ChgMagMom_in_sphere
     call m_CD_print_ChgMagmom_on_atom(nfout)

     if ( SpinOrbit_mode /= Neglected ) then
#ifndef WO_OP_MOMENT
        if ( sw_hubbard == ON ) call m_OP_calc_orbmom_from_OCC
#endif
     endif

  else
     call m_CD_check(nfout)
! ============================ KT_add ========== 13.0U
     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_calc_ChgMagMom_in_sphere
        call m_CD_print_ChgMagmom_on_atom(nfout)
     endif
! ============================================== 13.0U

  endif
! =================================================================== 11.0

  if(tag_solver_of_WF_is_found .and. tag_charge_mixing_is_found) then
     waymix_at_Potmix_previous = waymix_at_Potmix
  end if

#ifdef __TIMER_SUB__
    call timer_end(1101)
#endif

! ========== KT_add ========== 13.0U2
  if ( sw_modified_TFW_functional == ON ) call ThomasFermiWeiz_loop
! ============================ 13.0U2
  
  call m_TE_wd_total_energy_with_solvers(nfout)

contains

  subroutine mix_potential()
    mixing_way: select case(waymix_at_Potmix)
    case (SIMPLE)
       call m_Pot_simple_mixing(nfout,rmxt_tot)
    case (BROYD2)
       call m_Pot_mix_broyden2(rmxt_tot)
    case (PULAY)
       call m_Pot_mix_pulay(nfout,rmxt_tot)
    case default
       stop ' ! waymix is invalid'
    end select mixing_way

  end subroutine mix_potential

  subroutine mix_potential_only_hardpart
     call m_Pot_simple_mixing_vhsr(nfout,rmxt)
   end subroutine mix_potential_only_hardpart

  subroutine mix_potential_with_hardpart()

    mixing_way: select case(waymix_at_Potmix)

    case (SIMPLE)
       call m_Pot_simple_mixing( nfout,rmxt_tot )
       call m_Pot_simple_mixing_hard( nfout, rmxt_hard )

    case (BROYD2)
       call m_Pot_mix_broyden2_with_vhsr(rmxt_tot)

    case (PULAY)
       call m_Pot_mix_pulay_with_vhsr(nfout,rmxt_tot)

    case default
       stop ' ! waymix is invalid'
    end select mixing_way
  end subroutine mix_potential_with_hardpart

end subroutine Potential_Mixing

subroutine push_pot_mixing_name_applied(waymix)
  use m_Const_Parameters,   only :  SIMPLE , BROYD2, PULAY
  use m_Control_Parameters, only :  m_CtrlP_push_CDMixingNameApplied, len_cdmixingname
  implicit none
  integer, intent(in) :: waymix
  character(len=len_cdmixingname) :: cdmixname
  character*20 :: name
  integer :: len_char
  name = ""
  solver: select case(waymix)
  case (SIMPLE)
     name = "SIMPLE"
  case (BROYD2)
     name = "BROYD2"
  case (PULAY)
     name = "PULAY"
  case default
     name = "notDefined"
  end select solver
  len_char = len_trim(name)
  cdmixname = ""
  cdmixname(1:min(len_char,len_cdmixingname)) = name(1:min(len_char,len_cdmixingname))
  call m_CtrlP_push_CDMixingNameApplied(cdmixname,len_cdmixingname)
end subroutine push_pot_mixing_name_applied

       subroutine tred1_local_2update0(
     &               w, nm,
     &               ux, uy, vx, vy, nv, uxx, anorm2,
     &               i_base, i)
!
       implicit none
!
       integer, intent(in)    ::  nm, nv
       real(8), intent(inout) ::  w(1:nm)
       real(8), intent(in)    ::  ux(1:nv),uy(1:nv)
       real(8), intent(in)    ::  vx(1:nv),vy(1:nv)
       real(8), intent(out)   ::  uxx(1:nv),anorm2
       integer, intent(in)    ::  i_base, i
!
       integer                ::  k_1
       integer                ::  j, k, l
!
       integer                ::  i_1, i_2, i_3, i_4
       integer                ::  j_1, j_2, j_3, j_4
       integer                ::  l_1, l_2, l_3, l_4
       integer                ::  jj_1, jj_2, jj_3, jj_4
       integer                ::  LX
!
       include 'trd.h'
       include 'param.h'
       include 'CSTAB.h'
!
       real(8)                :: u_x, v_x
       real(8)                :: uy0, vy0
       real(8)                :: uy1, vy1
       real(8)                :: uy2, vy2
       real(8)                :: uy3, vy3
       real(8)                :: w0
       real(8)                :: w1
       real(8)                :: w2
       real(8)                :: w3
       real(8)                :: s, temp
       integer                :: ierr


          k_1 = i - i_base
          if ( k_1 <= 1 ) return
!
          L = i - 1
          i_2 = loop_c_start(L, y_nnod,y_inod)
          i_3 = loop_c_end  (L, y_nnod,y_inod)
          if ( i_2 > i_3 ) return

          j_2 = loop_c_start(1, x_nnod,x_inod)
          j_3 = loop_c_end  (L-1, x_nnod,x_inod)

          i_1=i_2

          uy0 = uy(i_1+0)
          vy0 = vy(i_1+0)

          anorm2 = ZERO
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do j_1=j_2,j_3
             u_x = ux(j_1)
             v_x = vx(j_1)
             w0 = w(j_1)
     &              -(u_x*vy0)
     &              -(v_x*uy0)
!             anorm2 = anorm2 + w0**2
             w(j_1) = w0
             uxx(j_1) = w0
          end do! j_1

          j_2 = loop_c_start(L, x_nnod,x_inod)
          j_3 = loop_c_end  (L, x_nnod,x_inod)
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
          do j_1=j_2,j_3
             u_x = ux(j_1)
             v_x = vx(j_1)
             w0 = w(j_1)
     &              -(u_x*vy0)
     &              -(v_x*uy0)
             w(j_1) = w0
          end do! j_1

       return
       end subroutine ! tred1_local_2update

subroutine Epsilon_Paramset
  use m_Const_Parameters    ,  only : MESH
  use m_Kpoints             ,  only : way_ksample
  use m_Epsilon_ek          ,  only : auto_mode, nppcorr, way_BZintegral, e_high

  auto_mode=1
  nppcorr = 2
  e_high=3.0d0
  if(way_ksample == MESH) then
     way_BZintegral= 2
  else
     way_BZintegral= 1
  end if  
end subroutine Epsilon_Paramset

      SUBROUTINE PDSTEDC( COMPZ, N, D, E, Q, IQ, JQ, DESCQ, WORK, LWORK,
     $                    IWORK, LIWORK, INFO )
*
*  -- ScaLAPACK routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     March 13, 2000
*
*     .. Scalar Arguments ..
      CHARACTER          COMPZ
      INTEGER            INFO, IQ, JQ, LIWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), Q( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*  PDSTEDC computes all eigenvalues and eigenvectors of a
*  symmetric tridiagonal matrix in parallel, using the divide and
*  conquer algorithm.
*
*  This code makes very mild assumptions about floating point
*  arithmetic. It will work on machines with a guard digit in
*  add/subtract, or on those binary machines without guard digits
*  which subtract like the Cray X-MP, Cray Y-MP, Cray C-90, or Cray-2.
*  It could conceivably fail on hexadecimal or decimal machines
*  without guard digits, but we know of none.  See DLAED3 for details.
*
*  Arguments
*  =========
*
*  COMPZ   (input) CHARACTER*1
*          = 'N':  Compute eigenvalues only.    (NOT IMPLEMENTED YET)
*          = 'I':  Compute eigenvectors of tridiagonal matrix also.
*          = 'V':  Compute eigenvectors of original dense symmetric
*                  matrix also.  On entry, Z contains the orthogonal
*                  matrix used to reduce the original matrix to
*                  tridiagonal form.            (NOT IMPLEMENTED YET)
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E       (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.
*
*  Q       (local output) DOUBLE PRECISION array,
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace/output) DOUBLE PRECISION array,
*          dimension (LWORK)
*          On output, WORK(1) returns the workspace needed.
*
*  LWORK   (local input/output) INTEGER,
*          the dimension of the array WORK.
*          LWORK = 6*N + 2*NP*NQ
*          NP = NUMROC( N, NB, MYROW, DESCQ( RSRC_ ), NPROW )
*          NQ = NUMROC( N, NB, MYCOL, DESCQ( CSRC_ ), NPCOL )
*
*          If LWORK = -1, the LWORK is global input and a workspace
*          query is assumed; the routine only calculates the minimum
*          size for the WORK array.  The required workspace is returned
*          as the first element of WORK and no error message is issued
*          by PXERBLA.
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          On exit, if LIWORK > 0, IWORK(1) returns the optimal LIWORK.
*
*  LIWORK  (input) INTEGER
*          The dimension of the array IWORK.
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  Further Details
*  ======= =======
*
*  Contributed by Francoise Tisseur, University of Manchester.
*
*  Reference:  F. Tisseur and J. Dongarra, "A Parallel Divide and
*              Conquer Algorithm for the Symmetric Eigenvalue Problem
*              on Distributed Memory Architectures",
*              SIAM J. Sci. Comput., 6:20 (1999), pp. 2223--2236.
*              (see also LAPACK Working Note 132)
*                http://www.netlib.org/lapack/lawns/lawn132.ps
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LQUERY
      INTEGER            ICOFFQ, IIQ, IPQ, IQCOL, IQROW, IROFFQ, JJQ,
     $                   LDQ, LIWMIN, LWMIN, MYCOL, MYROW, NB, NP,
     $                   NPCOL, NPROW, NQ
      DOUBLE PRECISION   ORGNRM
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2P, NUMROC
      DOUBLE PRECISION   DLANST
      EXTERNAL           INDXG2P, LSAME, NUMROC, DLANST
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, CHK1MAT, DLASCL, DSTEDC,
     $                   INFOG2L, PDLAED0, PDLASRT, PXERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          DBLE, MOD
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      LDQ = DESCQ( LLD_ )
      NB = DESCQ( NB_ )
      NP = NUMROC( N, NB, MYROW, DESCQ( RSRC_ ), NPROW )
      NQ = NUMROC( N, NB, MYCOL, DESCQ( CSRC_ ), NPCOL )
      INFO = 0
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 600+CTXT_ )
      ELSE
         CALL CHK1MAT( N, 2, N, 2, IQ, JQ, DESCQ, 8, INFO )
         IF( INFO.EQ.0 ) THEN
            NB = DESCQ( NB_ )
            IROFFQ = MOD( IQ-1, DESCQ( MB_ ) )
            ICOFFQ = MOD( JQ-1, DESCQ( NB_ ) )
            IQROW = INDXG2P( IQ, NB, MYROW, DESCQ( RSRC_ ), NPROW )
            IQCOL = INDXG2P( JQ, NB, MYCOL, DESCQ( CSRC_ ), NPCOL )
            LWMIN = 6*N + 2*NP*NQ
            LIWMIN = 2 + 7*N + 8*NPCOL
*
            WORK( 1 ) = DBLE( LWMIN )
            IWORK( 1 ) = LIWMIN
            LQUERY = ( LWORK.EQ.-1 .OR. LIWORK.EQ.-1 )
            IF( .NOT.LSAME( COMPZ, 'I' ) ) THEN
               INFO = -1
            ELSE IF( N.LT.0 ) THEN
               INFO = -2
            ELSE IF( IROFFQ.NE.ICOFFQ .OR. ICOFFQ.NE.0 ) THEN
               INFO = -5
            ELSE IF( DESCQ( MB_ ).NE.DESCQ( NB_ ) ) THEN
               INFO = -( 700+NB_ )
            ELSE IF( LWORK.LT.LWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -10
            ELSE IF( LIWORK.LT.LIWMIN .AND. .NOT.LQUERY ) THEN
               INFO = -12
            END IF
         END IF
      END IF
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'PDSTEDC', -INFO )
         RETURN
      ELSE IF( LQUERY ) THEN
         RETURN
      END IF
*
*     Quick return
*
      IF( N.EQ.0 )
     $   GO TO 10
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      IF( N.EQ.1 ) THEN
         IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL )
     $      Q( 1 ) = ONE
         GO TO 10
      END IF
*
*     If N is smaller than the minimum divide size NB, then
*     solve the problem with the serial divide and conquer
*     code locally.
*
      IF( N.LE.NB ) THEN
         IF( ( MYROW.EQ.IQROW ) .AND. ( MYCOL.EQ.IQCOL ) ) THEN
            IPQ = IIQ + ( JJQ-1 )*LDQ
            CALL DSTEDC( 'I', N, D, E, Q( IPQ ), LDQ, WORK, LWORK,
     $                   IWORK, LIWORK, INFO )
            IF( INFO.NE.0 ) THEN
               INFO = ( N+1 ) + N
               GO TO 10
            END IF
         END IF
         GO TO 10
      END IF
*
*     If P=NPROW*NPCOL=1, solve the problem with DSTEDC.
*
      IF( NPCOL*NPROW.EQ.1 ) THEN
         IPQ = IIQ + ( JJQ-1 )*LDQ
         CALL DSTEDC( 'I', N, D, E, Q( IPQ ), LDQ, WORK, LWORK, IWORK,
     $                LIWORK, INFO )
         GO TO 10
      END IF
*
*     Scale matrix to allowable range, if necessary.
*
      ORGNRM = DLANST( 'M', N, D, E )
      IF( ORGNRM.NE.ZERO ) THEN
         CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N, 1, D, N, INFO )
         CALL DLASCL( 'G', 0, 0, ORGNRM, ONE, N-1, 1, E, N-1, INFO )
      END IF
*
      CALL PDLAED0( N, D, E, Q, IQ, JQ, DESCQ, WORK, IWORK, INFO )
*
*     Sort eigenvalues and corresponding eigenvectors
*
      CALL PDLASRT( 'I', N, D, Q, IQ, JQ, DESCQ, WORK, LWORK, IWORK,
     $              LIWORK, INFO )
*
*           Scale back.
*
      IF( ORGNRM.NE.ZERO )
     $   CALL DLASCL( 'G', 0, 0, ONE, ORGNRM, N, 1, D, N, INFO )
*
   10 CONTINUE
*
      IF( LWORK.GT.0 )
     $   WORK( 1 ) = DBLE( LWMIN )
      IF( LIWORK.GT.0 )
     $   IWORK( 1 ) = LIWMIN
      RETURN
*
*     End of PDSTEDC
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: anlmes packuc initid setowh initai mvnbr sortsa sortsa_2
!             bsort dsort swapio getmin getmin_2 caldst calttl distbs
!             patmbr gtrcmt gtbrmt posatm gtnabc gtwscr wdmesp dwinly2
!             exstak
!
!  AUTHOR(S): T. Yamasaki   February/08/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_Ldos_f77.F 633 2020-12-01 05:11:03Z jkoga $
C   *********************************
C     by T.Yamasaki
C           10th Jun 1992
C     revised 14th Nov 1992
C   *********************************
C --------------------------------------------
C
C       modified by T. Yamasaki, 17th Nov 1992 
C       modified by T. Yamasaki, 18th Jan 2004
C       modified by T. Yamasaki, 08th Feb 2004
C
C         this subroutine is specified for the case of the system
C        which has the inversion symmetry.
C
C
      subroutine anlmes_ac(ista_atm,iend_atm,nfout,ipri,nmesh,ac_mesh 
     &              ,nac_mesh,ifxrh,ifyrh,ifxr,ifyr,ifzr
     &              ,altv,rltv,catxyz,katm2,crtdst_aldos,delta_dist
     &              ,catoms,ioddst,dstnc,cnmesh,nmmax)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit none
      integer ista_atm,iend_atm
      integer nfout,ipri,nmesh,ifxrh, ifyrh, ifxr, ifyr, ifzr, katm2
      integer ac_mesh(katm2,nmesh,3)
      integer nac_mesh(katm2)
      real*8 altv(3,3), rltv(3,3)
      real*8 catxyz(katm2,3),catoms(katm2,3)
      real*8 crtdst_aldos, delta_dist
      integer ioddst(katm2+1, *)
      real*8 dstnc(katm2)
      logical cnmesh
      integer nmmax
c
      integer INITIA, IAAX, IBAX, ICAX
      parameter (INITIA = 1)
      parameter (IAAX = 1, IBAX = 2, ICAX = 3 )
      real*8 ttl(6)

      integer nabc(3), nmabc(3), onwhca(3,2)
      real*8 abcmes(3)
      real*8 dface(3),dline(2,3)
      real*8 offset(3)

      real*8 dx,dy,dz
      real*8 cella,cellb,cellc
      integer ix,iy,iz

      real*8 wscr
      real*8 dm
      integer i,  ia, iatom, icount, ii
      integer :: ixx,iyy,izz,iix,iiy,iiz
      real*8, allocatable, dimension(:,:) :: catomst

      allocate(catomst(katm2,3))
      wscr = crtdst_aldos
      dx = 1.d0/dble(ifxr)
      dy = 1.d0/dble(ifyr)
      dz = 1.d0/dble(ifzr)
      cella = dx*sqrt(altv(1,1)**2+altv(2,1)**2+altv(3,1)**2)
      cellb = dy*sqrt(altv(1,2)**2+altv(2,2)**2+altv(3,2)**2)
      cellc = dz*sqrt(altv(1,3)**2+altv(2,3)**2+altv(3,3)**2)
      ixx=nint(wscr/cella)
      iyy=nint(wscr/cellb)
      izz=nint(wscr/cellc)
      if(mod(ixx,2)/=0) ixx = ixx+1
      if(mod(iyy,2)/=0) iyy = iyy+1
      if(mod(izz,2)/=0) izz = izz+1
      if(ixx.gt.ifxr/2) ixx=ifxr/2
      if(iyy.gt.ifyr/2) iyy=ifyr/2
      if(izz.gt.ifzr/2) izz=ifzr/2
      if(ipri>=2) write(nfout,'(a,7f10.5)') 'wscr cellabc w/c '
     & ,wscr,cella,cellb,cellc,wscr/cella,wscr/cellb,wscr/cellc
      if(ipri>=2) write(nfout,'(a,3i8)') 
     &            ' !** ix   iy   iz   ',ixx,iyy,izz
      if(ipri>=2) write(nfout,'(a,3i8)') 
     &            ' !** ifxr ifyr ifzr ',ifxr,ifyr,ifzr
      call calttl(ipri,altv,ttl)
      call distbs(nfout,ipri,altv,rltv,dface,dline)
C
      call posatm(catxyz,katm2,katm2,rltv,catoms)
c
      call packuc(catoms,katm2,katm2)

      nmmax = 0
      do ia=ista_atm,iend_atm
         icount = 0
         do ix=-ixx,ixx
            iix = ix
            if(ix<=0) iix = iix+ifxr
            abcmes(1) = ix*dx
            do iy=-iyy,iyy
               iiy = iy
               if(iy<=0) iiy = iiy+ifyr
               abcmes(2) = iy*dy
               do iz=-izz,izz
                  iiz = iz
                  if(iz<=0) iiz = iiz+ifzr
                  abcmes(3) = iz*dz
                  offset(:) = catoms(ia,:)
                  do i=1,3
                     if(abcmes(i)>1) abcmes(i) = abcmes(i)-1
                     if(abcmes(i)<0) abcmes(i) = abcmes(i)+1
                  enddo
                  do i=1,3
                  catomst(1:katm2,i) = catoms(1:katm2,i)-offset(i)
                  enddo
                  call packuc(catomst,katm2,katm2)
                  call getmin_2(nfout,catomst,katm2,abcmes,ttl,wscr
     &                ,delta_dist,iatom)
                  if(iatom.eq.ia ) then
                     icount = icount+1
                     if(.not.cnmesh)then
                        do i=1,3
                           ac_mesh(ia,icount,1) = iix
                           ac_mesh(ia,icount,2) = iiy
                           ac_mesh(ia,icount,3) = iiz
                        enddo
                     endif
                  endif
               enddo
            enddo
         enddo
         if(icount>nmmax) then
            nmmax = icount
         endif
         if(.not.cnmesh)then
            nac_mesh(ia) = icount
         endif
      enddo
      deallocate(catomst)
c
      return
      end
C --------------------------------------------------------

      subroutine anlmes(nfout,ipri,mesh,ifxrh,ifyrh,ifxr,ifyr,ifzr
     &              ,altv,rltv,catxyz,katm2,crtdst_aldos,delta_dist
     &              ,catoms,ioddst,dstnc)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit none
      integer nfout,ipri,ifxrh, ifyrh, ifxr, ifyr, ifzr, katm2
      integer mesh(ifxrh,ifyrh,ifzr)
      real*8 altv(3,3), rltv(3,3)
      real*8 catxyz(katm2,3),catoms(katm2,3)
      real*8 crtdst_aldos, delta_dist
      integer ioddst(katm2+1, *)
      real*8 dstnc(katm2)
c
      integer INITIA, IAAX, IBAX, ICAX
      parameter (INITIA = 1)
      parameter (IAAX = 1, IBAX = 2, ICAX = 3 )
      real*8 ttl(6)
c$$$      dimension nabc(3), abcmes(3), onwhca(3,2), nmabc(3)
      integer nabc(3), nmabc(3), onwhca(3,2)
      real*8 abcmes(3)
      real*8 dface(3),dline(2,3)
c$$$      common/bdist/dface(3),dline(2,3)
c$$$      common/bcunt/icount_eq, icount_h, icount_1, icount_2

      real*8 wscr, dx1,dx2,dx3
      integer i, n1ax, n2ax, n3ax, ic, ib, ia, iatom, i_all, isp, icount

      wscr = crtdst_aldos

      if(ipri >= 1) 
     &     write(nfout,'(" !!ldos, dimension of mesh = ",3i8)')
     &          ifxrh, ifyrh, ifzr

      call calttl(ipri,altv,ttl)
      call distbs(nfout,ipri,altv,rltv,dface,dline)
C
      call posatm(catxyz,katm2,katm2,rltv,catoms)
c
      call packuc(catoms,katm2,katm2)
      if(ipri >= 1) then
         write(nfout,'(" !!ldos *** packuc ***")')
         do i = 1, katm2
            write(nfout,9003) i
     &           ,catxyz(i,1), catxyz(i,2), catxyz(i,3)
     &           ,catoms(i,1),catoms(i,2),catoms(i,3)
 9003       format(i4,2('(',3f16.8,')'))
         end do
      end if
C
      call gtnabc(nabc,ifxr,ifyr,ifzr)
      if(ipri >= 2) then
         write(nfout,*) ' !!ldos nabc(1 - 3) = ',nabc(1),nabc(2),nabc(3)
         write(nfout,*) ' !!ldos *** gtnabc ***'
      end if

c$$$      call gtwscr(nfout,altv,wscr)
      if(ipri >= 1) 
     &     write(nfout,*) ' !!ldos *** gtwscr *** , wscr = ', wscr
C
      n1ax = ICAX
      dx1 = 1.0/dble(nabc(n1ax))
      n2ax = IBAX
      dx2 = 1.0/dble(nabc(n2ax))
      n3ax = IAAX
      dx3 = 1.0/dble(ifxr)
C
      if(ipri >= 2) 
     &     write(nfout,'(" !!ldos: dx1,n1ax,dx2,n2ax,dx3,n3ax = "
     &                  ,3(f8.4,i4))') dx1,n1ax,dx2,n2ax,dx3,n3ax
C
#ifndef _FAST_WAY_
      do 1001 ic = 1, nabc(n1ax)
         nmabc(n1ax) = ic
         abcmes(n1ax) = (ic-1)*dx1
         do 1002 ib = 1, nabc(n2ax)
            nmabc(n2ax) = ib
            abcmes(n2ax) = (ib-1)*dx2
            do 1003 ia = 1, nabc(n3ax)
               nmabc(n3ax) = ia
               abcmes(n3ax) = (ia-1)*dx3
#ifdef DEBUG
               write(nfout,'(" !!ldos ia,ib,ic = ", 3i5)') ia,ib,ic
#endif
               call getmin_2(nfout,catoms, katm2, abcmes, ttl
     &              ,wscr, delta_dist
     &              ,iatom)
               mesh(nmabc(1),nmabc(2),nmabc(3)) = iatom
#ifdef DEBUG
               write(nfout,9005) ia, ib, ic, iatom
     &              ,abcmes(n1ax),abcmes(n2ax),abcmes(n3ax)
     &              ,catoms(iatom,1),catoms(iatom,2),catoms(iatom,3)
#endif
 1003       continue
 1002    continue
 1001 continue

#else
      call rsreal(ICAX, abcmes)

      call initid(nfout,ioddst(1,INITIA), katm2+1, katm2)

      call setowh(onwhca, n1ax, n2ax)

      do 1 ic = 1, nabc(n1ax)
         nmabc(n1ax) = ic
         abcmes(n1ax) = (ic-1)*dx1
c         write(nfout,*) ' *** ( ic = ',ic,' ) ***'
         call mvnbr(catoms(1,n1ax), katm2,abcmes(n1ax), 
     &        ioddst(1,INITIA), katm2+1)
c$$$         call sortsa(nfout,catoms(1,1),katm2,abcmes,ttl,onwhca(1,1),
c$$$     &               wscr,ioddst(1,INITIA),katm2+1,
c$$$     &               ioddst(1,INITIA+n1ax),dstnc)
C$$ASASASASAS
C$$$         call sortsa_2(nfout,catoms(1,1),katm2,abcmes,ttl,onwhca(1,1)
C$$$    &        ,wscr,dface,dline,ioddst(1,INITIA),katm2+1
C$$$    &        ,ioddst(1,INITIA+n1ax),dstnc)
         call sortsa_2(nfout,ipri,catoms(1,1),katm2,abcmes,ttl   !USAMI
     &        ,onwhca(1,1),wscr,dface,dline,ioddst(1,INITIA)
     &        ,katm2+1,ioddst(1,INITIA+n1ax),dstnc)
C$$ASASASASAS
C
         do 2 ib = 1, nabc(n2ax)
C           write(nfout,*) '   ***** ( ib = ', ib,' ) *****'
            nmabc(n2ax) = ib
            abcmes(n2ax) = (ib-1)*dx2
            call mvnbr(catoms(1,n2ax), katm2, abcmes(n2ax),
     &           ioddst(1,INITIA+n1ax),katm2+1)
c$$$            call sortsa(nfout,catoms(1,1),katm2,abcmes,ttl,onwhca(1,2),
c$$$     &                  wscr,ioddst(1,INITIA+n1ax),katm2+1,
c$$$     &                  ioddst(1,INITIA+n2ax),dstnc)
C$$ASASASASAS            call sortsa_2(nfout,catoms(1,1),katm2,abcmes,ttl,onwhca(1,2)
C$$ASASASASAS     &           ,wscr,dface,dline,ioddst(1,INITIA+n1ax),katm2+1
C$$ASASASASAS     &           ,ioddst(1,INITIA+n2ax),dstnc)
            call sortsa_2(nfout,ipri,catoms(1,1),katm2,abcmes,ttl !USAMI
     &           ,onwhca(1,2),wscr,dface,dline,ioddst(1,INITIA+n1ax)
     &           ,katm2+1,ioddst(1,INITIA+n2ax),dstnc)
C$$ASASASASAS
            do 3 ia = 1, nabc(n3ax)
               nmabc(n3ax) = ia
               abcmes(n3ax) = (ia-1)*dx3
               call getmin(nfout,n3ax,catoms(1,1), katm2, abcmes, ttl,
     &              wscr,ioddst(1,INITIA+n2ax),
     &              katm2+1,dstnc, iatom)
               mesh(nmabc(1),nmabc(2),nmabc(3)) = iatom
#ifdef DEBUG
               write(nfout,9005) ia, ib, ic, iatom
     &              ,abcmes(n1ax),abcmes(n2ax),abcmes(n3ax)
     &              ,catoms(iatom,1),catoms(iatom,2),catoms(iatom,3)
 9005          format('(',3i3,') (',i4,',',3f6.3,' )',3f6.3)
#endif
 3          continue
 2       continue
 1    continue
#endif
c
      if(ipri >= 3) then
         i_all = 0
         do 2001 isp = 1, katm2 + 1
            icount = 0
            do 2002 ic = 1, nabc(3)
               do 2003 ib = 1, nabc(2)
                  do 2004 ia = 1, nabc(1)
                     if(mesh(ia,ib,ic).eq.isp) icount = icount + 1
 2004             continue
 2003          continue
 2002       continue
            write(nfout,*) ' !D (isp ) ',isp,' : ', icount
            i_all = i_all + icount
 2001    continue
         write(nfout,*) ' !D i_all = ', i_all
#ifdef DEBUG_MESH
         write(nfout,*) ' !D mesh '
         do 11 ic = 1, nabc(3)
            do 12 ib = 1, nabc(2)
               write(nfout,9002) (mesh(ia,ib,ic),ia = 1, nabc(1))
 12         continue
 11      continue
 9002    format(16i4)
#endif
      end if
      return
      end
C --------------------------------------------------------
C
C        anlmesl: coded by T.Yamasaki 6th Apr. 2017
C 
C --------------------------------------------------------
      subroutine anlmesl(nfout,ipri,meshl,ifxrh,ifyrh,ifxr,ifyr,ifzr
     &              ,winlay,mlayer,normal_axis,nmeshlay)
      implicit none
      integer nfout,ipri,ifxrh, ifyrh, ifxr, ifyr, ifzr, mlayer
      integer normal_axis
      integer meshl(ifxrh,ifyrh,ifzr),nmeshlay(mlayer)
      real*8  winlay(mlayer,2)
c
      integer IAAX, IBAX, ICAX
      parameter (IAAX = 1, IBAX = 2, ICAX = 3 )
      integer nabc(3), nmabc(3)
      real*8 abcmes(3)

      real*8  dx1,dx2,dx3
      integer i, n1ax, n2ax, n3ax, ic, ib, ia, i_all, isp, icount,ilayer

      if(ipri >= 1) 
     &     write(nfout,'(" !!ldos, dimension of meshl = ",3i8)')
     &          ifxrh, ifyrh, ifzr

      call gtnabc(nabc,ifxr,ifyr,ifzr)

      n1ax = ICAX
      dx1 = 1.0/dble(nabc(n1ax))
      n2ax = IBAX
      dx2 = 1.0/dble(nabc(n2ax))
      n3ax = IAAX
      dx3 = 1.0/dble(ifxr)
C
      if(ipri >= 2) 
     &     write(nfout,'(" !!ldos: dx1,n1ax,dx2,n2ax,dx3,n3ax = "
     &                  ,3(f8.4,i4))') dx1,n1ax,dx2,n2ax,dx3,n3ax
C
      do 1001 ic = 1, nabc(n1ax)
         nmabc(n1ax) = ic
         abcmes(n1ax) = (ic-1)*dx1
         do 1002 ib = 1, nabc(n2ax)
            nmabc(n2ax) = ib
            abcmes(n2ax) = (ib-1)*dx2
            do 1003 ia = 1, nabc(n3ax)
               nmabc(n3ax) = ia
               abcmes(n3ax) = (ia-1)*dx3
#ifdef DEBUG
               write(nfout,'(" !!ldos ia,ib,ic = ", 3i5)') ia,ib,ic
#endif
               call getmin_layer(nfout,winlay, mlayer
     &              ,normal_axis,abcmes,ilayer)
               meshl(nmabc(1),nmabc(2),nmabc(3)) = ilayer
#ifdef DEBUG
               write(nfout,9005) ia, ib, ic, ilayer
     &              ,abcmes(n1ax),abcmes(n2ax),abcmes(n3ax)
 9005          format('(',3i3,') (',i4,',',3f6.3,' )',3f6.3)
#endif
 1003       continue
 1002    continue
 1001 continue

      i_all = 0
      do 2001 isp = 1, mlayer
         icount = 0
         do 2002 ic = 1, nabc(3)
            do 2003 ib = 1, nabc(2)
               do 2004 ia = 1, nabc(1)
                  if(meshl(ia,ib,ic).eq.isp) icount = icount + 1
 2004          continue
 2003       continue
 2002    continue
         if(ipri >= 1) write(nfout,*) ' !D (isp ) ',isp,' : ', icount
         i_all = i_all + icount
         nmeshlay(isp) = icount
 2001 continue
         
      if(ipri>=1) then
         write(nfout,*) ' !D i_all = ', i_all
#ifdef DEBUG_MESH
         write(nfout,*) ' !D meshl '
         do 11 ic = 1, nabc(3)
            do 12 ib = 1, nabc(2)
               write(nfout,9003) ib,ic
               write(nfout,9002) (meshl(ia,ib,ic),ia = 1, nabc(1))
 12         continue
 11      continue
 9003    format("ib,ic = ",2i4)
 9002    format(16i4)
#endif
      end if
      return
      end
C --------------------------------------------------------
C
C        packuc: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine packuc(catom,matom,natom)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      dimension catom(matom,3)
      do 1 k = 1, 3
         do 2 i = 1, natom
            n = catom(i,k)
            catom(i,k) = catom(i,k) - n
            if(catom(i,k).lt.0.0) catom(i,k) = catom(i,k) + 1.0
 2       continue
 1    continue
      return
      end
C --------------------------------------------------------
C
C        initid: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine initid(nfout,ioddst,m,n)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit none
      integer nfout,m,n, ioddst(m)
      integer i
      if(m.lt.n+1) then
         write(nfout,*) ' **** invalid array size (at sub. initid) ****'
         write(nfout,*) '         ( m = ',m,', n = ',n,')'
         stop
      endif
      do 1 i = 1, n
         ioddst(i) = i
 1    continue
      ioddst(m) = n
      return
      end
C --------------------------------------------------------
C
C        setowh: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine setowh(onwhca, n1, n2)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      integer ON, OFF
      parameter (ON = 1, OFF = 0)
      integer onwhca
      dimension onwhca(3,2)
      dimension nord(3)
      data nord/1,2,3/
      call initai(onwhca,6, OFF)
      onwhca(nord(n1),1) = ON
      onwhca(nord(n1),2) = ON
      onwhca(nord(n2),2) = ON
      return
      end
C --------------------------------------------------------
C
C        initai: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine initai(narray,m,nvalue)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      dimension narray(m)
      do 1 i = 1, m
         narray(i) = nvalue
 1    continue
      return
      end
C --------------------------------------------------------
C
C        mvnbr: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine mvnbr(catom,m,pmesh,ioddst,modst)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      dimension catom(m)
      dimension ioddst(modst)
C
      do 1 i = 1, ioddst(modst)
         ip = ioddst(i)
         d = catom(ip) - pmesh
         if(d.gt.0.5) then
            catom(ip) = catom(ip) - 1.0
         else if(d.lt.-0.5) then
            catom(ip) = catom(ip) + 1.0
         endif
 1    continue
      return
      end
C --------------------------------------------------------
C
C        sortsa: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine sortsa(nfout,catom,mcatm,abcmes,ttl,onwhca,wscr,
     &                  iodfrm, moddst,iodto,dstnc)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      integer nfout
      integer ON, OFF, onwhca
      parameter (ON = 1, OFF = 0)
      parameter (IAAX = 1, IBAX = 2, ICAX = 3 )
      dimension catom(mcatm,3), abcmes(3), ttl(6)
      dimension onwhca(3), iodfrm(moddst), iodto(moddst)
      dimension dstnc(mcatm)
      data icount/-20/
C
      icount = icount + 1
C
      katom = 0
      do 1 i = 1, iodfrm(moddst)
         jatom = iodfrm(i)
         if(onwhca(IAAX).eq.OFF) then
            x = 0.0
         else
            x = catom(jatom,IAAX) - abcmes(IAAX)
         endif
C
         if(onwhca(IBAX).eq.OFF) then
            y = 0.0
         else
            y = catom(jatom,IBAX) - abcmes(IBAX)
         endif
C
         if(onwhca(ICAX).eq.OFF) then
            z = 0.0
         else
            z = catom(jatom,ICAX) - abcmes(ICAX)
         endif
C
         xdst = ttl(1)*x*x + ttl(2)*y*y + ttl(3)*z*z
     &        + ttl(4)*x*y + ttl(5)*y*z + ttl(6)*z*x
         dstnc(jatom) = dsqrt(xdst)
         if(dstnc(jatom) .lt. wscr) then
            katom = katom + 1
            iodto(katom) = jatom
         endif
 1    continue
      iodto(moddst) = katom
C
c      if(icount.lt.4) then
      if(icount.lt.0) then
         write(nfout,*) ' *** iodto(before dsort) = ',
     &        iodto(moddst), ' ***'
         do 11 j = 1, iodto(moddst)
            jatom = iodto(j)
            write(nfout,9001) jatom, (catom(jatom,i), i = 1, 3),
     &           (abcmes(i),i=1,3),dstnc(jatom)
 11      continue
 9001    format(' !!ldos ','(',3f8.4,') (',3f8.4,')',f8.4)
      endif
C
      call bsort(iodto, moddst, dstnc, mcatm)
C
C     call dsort(nfout,iodto, moddst, dstnc, mcatm)
C
c      if(icount.lt.4) then
      if(icount.lt.0) then
         write(nfout,'(" !!ldos --- iodto(after dsort) = ",i6," ---")') &
     &        iodto(moddst)
         do 21 j = 1, iodto(moddst)
            jatom = iodto(j)
            write(nfout,9001) jatom,(catom(jatom,i),i = 1, 3),
     &           (abcmes(i),i=1,3),dstnc(jatom)
 21      continue
      endif
C
      return
      end
C --------------------------------------------------------
C
C        sortsa: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
C$$ASASASASAS
C$$      subroutine sortsa_2(nfout,catom,mcatm,abcmes,ttl,onwhca,wscr
C$$     &     ,dface,dline,iodfrm, moddst,iodto,dstnc)
      subroutine sortsa_2(nfout,ipri,catom,mcatm,abcmes,ttl,onwhca,wscr
     &     ,dface,dline,iodfrm, moddst,iodto,dstnc)
C$$ASASASASAS
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8(a-h,o-z)
      integer ON, OFF, onwhca
      parameter (ON = 1, OFF = 0)
      parameter (IAAX = 1, IBAX = 2, ICAX = 3 )
      integer Case_D, Case_L, case
      parameter (Case_D = 1, Case_L = 2)
      dimension catom(mcatm,3), abcmes(3), ttl(6)
      dimension onwhca(3), iodfrm(moddst), iodto(moddst)
      dimension dstnc(mcatm), dface(3), dline(2,3)
      data icount/-20/
C
      icount = icount + 1
C
      if(onwhca(1)+onwhca(2)+onwhca(3).eq.ON) then
         case = Case_D
         if(onwhca(IAAX).eq.ON) then
            ipnt = IAAX
         else if(onwhca(IBAX).eq.ON) then
            ipnt = IBAX
         else
            ipnt = ICAX
         endif
      else if(onwhca(1)+onwhca(2)+onwhca(3).eq.2*ON) then
         case = Case_L
      else
         stop ' !E onwhca error'
      endif
c
      katom = 0
      if(case.eq.Case_D) then
         do 1 i = 1, iodfrm(moddst)
         jatom = iodfrm(i)
         alpha = catom(jatom,ipnt) - abcmes(ipnt)
         xdst = alpha*dface(ipnt)
         dstnc(jatom) = dabs(xdst)
         if(dstnc(jatom) .lt. wscr) then
            katom = katom + 1
            iodto(katom) = jatom
         endif
 1       continue
      else if(case.eq.Case_L) then
         do 11 i = 1, iodfrm(moddst)
         jatom = iodfrm(i)
         alpha = catom(jatom,1) - abcmes(1)
         beta  = catom(jatom,2) - abcmes(2)
         gamma = catom(jatom,3) - abcmes(3)
         if(onwhca(1).eq.OFF) then
            dh = beta*dline(1,1) + gamma*dline(2,1)
            x = -dh
            y = beta
            z = gamma
         else if(onwhca(2).eq.OFF) then
            dh = alpha*dline(1,2) + gamma*dline(2,2)
            x = alpha
            y = -dh
            z = gamma
         else if(onwhca(3).eq.OFF) then
            dh = alpha*dline(1,3) + beta*dline(2,3)
            x = alpha
            y = beta
            z = -dh
         endif
         xdst = ttl(1)*x*x + ttl(2)*y*y + ttl(3)*z*z
     &        + ttl(4)*x*y + ttl(5)*y*z + ttl(6)*z*x
         dstnc(jatom) = dsqrt(xdst)
         if(dstnc(jatom) .lt. wscr) then
            katom = katom + 1
            iodto(katom) = jatom
         endif
 11      continue
      endif
      iodto(moddst) = katom
C
C$$ASASASASAS
C$$      if(icount.lt.0) then
      if(ipri >= 2 .and. icount.lt.0) then
C$$ASASASASAS
         write(nfout,*) ' *** iodto(before dsort) = ',
     &        iodto(moddst), ' ***'
         do 21 j = 1, iodto(moddst)
            jatom = iodto(j)
            write(nfout,9001) jatom, (catom(jatom,i), i = 1, 3),
     &           (abcmes(i),i=1,3),dstnc(jatom)
 21      continue
 9001    format(' !!ldos ',i4,'(',3f8.4,') (',3f8.4,')',f8.4)
      endif
C
      call bsort(iodto, moddst, dstnc, mcatm)
C
C     call dsort(nfout,iodto, moddst, dstnc, mcatm)
C
c      if(icount.lt.4) then
C$$ASASASASAS
C$$      if(icount.lt.0) then
      if(ipri >= 2 .and. icount.lt.0) then
C$$ASASASASAS
         write(nfout,*) ' --- iodto(after dsort) = ',
     &        iodto(moddst),' ---'
         do 31 j = 1, iodto(moddst)
            jatom = iodto(j)
            write(nfout,9001) jatom,(catom(jatom,i),i = 1, 3),
     &           (abcmes(i),i=1,3),dstnc(jatom)
 31      continue
      endif
C
      return
      end
C --------------------------------------------------------
C
C        bsort: coded by T.Yamasaki 13th Oct. 1992
C 
C --------------------------------------------------------
      subroutine bsort(iodto, moddst, dstnc, mcatm)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension iodto(moddst), dstnc(mcatm)
C
      nelemt = iodto(moddst)
C
      do 1 i = 1, nelemt-1
         pbas = dstnc(iodto(i))
         pmin = pbas
         do 2 j = i+1, nelemt
            p = dstnc(iodto(j))
            if(p.lt.pmin) then
               pmin = p
               jmin = j
            endif
 2       continue
         if(pmin.lt.pbas) then
            k = iodto(i)
            iodto(i) = iodto(jmin)
            iodto(jmin) = k
         endif
 1    continue
      return
      end
C --------------------------------------------------------
C
C        dsort: coded by T.Yamasaki 8th Oct. 1992
C 
C --------------------------------------------------------
      subroutine dsort(nfout,iodto, moddst, dstnc, mcatm)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer h, t
      parameter (mstack = 60)
      dimension iodto(moddst), dstnc(mcatm)
C
      dimension ISH(0:MSTACK), IST(0:MSTACK)
c
      mmax = mcatm
C
      nstack = 0
      is = 0
      h = 1
C
      nelemn = iodto(moddst)
      t = nelemn
 1001 continue
      if(h.ge.t) then
         if(is.ge.0) then
            if(is.gt.mstack) call exstak
            h = ish(is)
            t = ish(is)
         endif
         is = is - 1
      else
         np = (h+t)/2 + 0.5
         if(np.gt.mmax) write(nfout,*) ' !!ldos warning *** np > nmax'
         p = dstnc(iodto(np))
         i = h
         j = t
C
         if(np.ne.t) then
            call swapio(iodto,np,t)
         endif
 1000    continue
         if(j.lt.i) goto 2000
 1002    continue
         if(dstnc(iodto(j)).ge.p) then
            j = j - 1
            if(j.lt.h) goto 1000
            goto 1002
         endif
 1003    continue
         if(dstnc(iodto(i)).lt.p) then
            i = i + 1
            goto 1003
         endif
         if(i.lt.j) then
            call swapio(iodto,i,j)
            i = i + 1
            j = j - 1
         endif
         goto 1000
 2000    continue
C
         if(i.ne.t) then
            call swapio(iodto,i,t)
         endif
C
         if(i.lt.t) then
            is = is + 1
            if(is.gt.nstack) nstack = nstack + 1
            if(is.gt.mstack) call exstak
            ish(is) = i + 1
            ist(is) = t
         endif
         t = j
      endif
      if(is.ge.0) goto 1001
C
      return
      end
C --------------------------------------------------------
C
C        swapio: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine swapio(iodto,i,j)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension iodto(*)
      k = iodto(i)
      iodto(i) = iodto(j)
      iodto(j) = k
      return
      end
C --------------------------------------------------------
C
C        getmin: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine getmin(nfout,n3ax,catom,matom,abcmes,ttl,wscr,
     &                  ioddst,moddst,dstnc,iatom)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer nfout
      dimension catom(matom,3),abcmes(3),ttl(6)
      dimension ioddst(moddst),dstnc(matom)
      data delta/1.d-5/
      data icycle/0/
c
      if(ioddst(moddst).lt.1) then
         iatom = matom+1
         return
      endif
      call mvnbr(catom(1,n3ax),matom,abcmes(n3ax)
     &     ,ioddst,moddst)
#ifdef DEBUG
      write(nfout,*) ' !!ldos === ioddst(after dsort) = ',
     &     ioddst(moddst),' ==='
 9001 format(' !!ldos ',i4,'(',3f8.4,') (',3f8.4,')',f8.4)
      do 21 j = 1, ioddst(moddst)
      jatom = ioddst(j)
      write(nfout,9001) jatom,(catom(jatom,i),i = 1, 3),
     &     (abcmes(i),i=1,3),dstnc(jatom)
 21   continue
#endif
      call caldst(nfout,catom,matom,ioddst(1),abcmes,ttl,dst)
      dmin = dst
      iatom = ioddst(1)
      if(ioddst(moddst).ge.2) then
         do 1 i = 2, ioddst(moddst)
         ip = ioddst(i)
         if(dmin.lt.dstnc(ip)) then
            goto 1001
         endif
         call caldst(nfout,catom,matom,ip,abcmes,ttl,dst)
         if(dst.lt.dmin) then
            dmin = dst
            iatom = ip
         endif
C           if(dst.lt.dstnc(ip)) then
C             return
C           endif
 1       continue
 1001    continue
      endif
      if(dmin.gt.wscr) iatom = matom+1
      return
      end
C --------------------------------------------------------
C
C        getmin: coded by T.Yamasaki 10th Jun 1992
C 
C --------------------------------------------------------
      subroutine getmin_2(nfout,catom,matom,abcmes,ttl
     &     ,wscr,delta_dist,iatom)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer nfout
      dimension catom(matom,3),abcmes(3),ttl(6)
      real*8 dst

c$$$      real*8 rnd
      data icount/0/
c$$$      integer save icount = 0
c
      call caldst(nfout,catom,matom,1,abcmes,ttl,dst)
      dmin = dst

#ifdef DEBUG
      write(nfout,'(" !!ldos dist(",i4,") = ",f12.8)') 1, dst
#endif
      iatom = 1
      do 1 i = 2, matom
      ip = i
      call caldst(nfout,catom,matom,ip,abcmes,ttl,dst)

#ifdef DEBUG
      write(nfout,'(" !!ldos dist(",i4,") = ",f12.8)') i, dst
#endif
      if(dabs(dst-dmin) .lt. delta_dist) then
         icount = icount + 1
         if(mod(icount,2) == 0) then
c$$$         rnd = rand(0)
c$$$         write(nfout,'(" !!ldos icount = ",i8," rnd = ",f12.8)')
c$$$     &        icount, rnd
c$$$         if(rnd < 0.5d0) then
            dmin = dst
            iatom = ip
         end if
      else if(dst.lt.dmin) then
         dmin = dst
         iatom = ip
      endif
 1    continue
      if(dmin.gt.wscr) iatom = matom + 1
      return
      end

      subroutine getmin_3(nfout,catom,matom,abcmes,ttl
     &     ,wscr,delta_dist,iatom,dm)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer nfout
      dimension catom(matom,3),abcmes(3),ttl(6)
      real*8 dst

c$$$      real*8 rnd
      data icount/0/
c$$$      integer save icount = 0
c
      call caldst(nfout,catom,matom,1,abcmes,ttl,dst)
      dmin = dst

#ifdef DEBUG
      write(nfout,'(" !!ldos dist(",i4,") = ",f12.8)') 1, dst
#endif
      iatom = 1
      do 1 i = 2, matom
      ip = i
      call caldst(nfout,catom,matom,ip,abcmes,ttl,dst)

#ifdef DEBUG
      write(nfout,'(" !!ldos dist(",i4,") = ",f12.8)') i, dst
#endif
      if(dabs(dst-dmin) .lt. delta_dist) then
         icount = icount + 1
         if(mod(icount,2) == 0) then
c$$$         rnd = rand(0)
c$$$         write(nfout,'(" !!ldos icount = ",i8," rnd = ",f12.8)')
c$$$     &        icount, rnd
c$$$         if(rnd < 0.5d0) then
            dmin = dst
            iatom = ip
         end if
      else if(dst.lt.dmin) then
         dmin = dst
         iatom = ip
      endif
 1    continue
      if(dmin.gt.wscr) iatom = matom + 1
      dm = dmin
      return
      end

C --------------------------------------------------------
C
C        getmin_layer: coded by T.Yamasaki 7th Apr 2017
C 
C --------------------------------------------------------
      subroutine getmin_layer(nfout,winlay,mlayer,normal_axis
     &     ,abcmes,ilayer)
c
      implicit real*8 (a-h,o-z)
      integer nfout,mlayer
      dimension winlay(mlayer,2),abcmes(3)

      ilayer = 0
      dd = abcmes(normal_axis)
      do 1 i = 1, mlayer
         zmin = winlay(i,1)
         zmax = winlay(i,2)
         if(dd-zmin>0.5) zmin=zmin+1.0
         if(dd-zmin<-0.5) zmin=zmin-1.0
         if(dd-zmax>0.5) zmax=zmax+1.0
         if(dd-zmax<-0.5) zmax=zmax-1.0
         if(zmin<=dd .and. dd< zmax) then
            ilayer = i
            goto 2
         end if
 1    continue
 2    continue
      if(ilayer > mlayer) ilayer = 0

      return
      end
C --------------------------------------------------------
C
C        caldst: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine caldst(nfout,catom,matom,ip,abcmes,ttl,dst)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer nfout
      dimension catom(matom,3),ttl(6),abcmes(3)
      dimension xyz(3)
C      write(nfout,*) ' *** abcmes(1-3) = '
C     &      ,abcmes(1),abcmes(2),abcmes(3),' ***'
C      write(nfout,*) ' *** ip = ', ip
c$$$      do 1 i = 1, 3
c$$$         xyz(i) = catom(ip,i) - abcmes(i)
c$$$ 1    continue
c$$$      xdst =  ttl(1)*xyz(1)*xyz(1) 
c$$$     &     + ttl(2)*xyz(2)*xyz(2)
c$$$     &     + ttl(3)*xyz(3)*xyz(3)
c$$$     &     + ttl(4)*xyz(1)*xyz(2)
c$$$     &     + ttl(5)*xyz(2)*xyz(3)
c$$$     &     + ttl(6)*xyz(3)*xyz(1)
c$$$C
c$$$      dst = dsqrt(xdst)
c
      dst = 1.d9
      do 11 k = -1, 1
      xyz(3) = catom(ip,3) - abcmes(3) + k
      do 12 j = -1, 1
      xyz(2) = catom(ip,2) - abcmes(2) + j
      do 13 i = -1, 1
      xyz(1) = catom(ip,1) - abcmes(1) + i
c$$$      if(i*j*k.ne.0) then
#ifdef _ORTHOGONAL_
      xdst = ttl(1)*xyz(1)**2
     &     + ttl(2)*xyz(2)**2
     &     + ttl(3)*xyz(3)**2
#else
      xdst = ttl(1)*xyz(1)**2
     &     + ttl(2)*xyz(2)**2
     &     + ttl(3)*xyz(3)**2
     &     + ttl(4)*xyz(1)*xyz(2)
     &     + ttl(5)*xyz(2)*xyz(3)
     &     + ttl(6)*xyz(3)*xyz(1)
#endif
      xdst = dsqrt(xdst)
      if(xdst.lt.dst) dst = xdst
 13   continue
 12   continue
 11   continue
c      
      return
      end
C --------------------------------------------------------
C
C        calttl: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine calttl(ipri,brmt,ttl)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension brmt(3,3),ttl(6)
      do 11 j = 1, 6
         ttl(j) = 0.d0
 11   continue
      do 1 j = 1, 3
         jj = mod(j+1,3)
         if(jj.eq.0) jj = 3
         do 2 i = 1, 3
            ttl(j) = ttl(j) + brmt(i,j)*brmt(i,j)
            ttl(j+3) = ttl(j+3) + 2.d0*brmt(i,j)*brmt(i,jj)
 2       continue
 1    continue
      if(ipri>=1) write(6,9001) (ttl(j),j = 1, 6)
 9001 format(' !!ldos (ttl(1-6)) = (',6f12.4,')')
C
      return
      end
C --------------------------------------------------------
C
C        distbs: coded by T.Yamasaki 21st Apr 1996
C 
C --------------------------------------------------------
      subroutine distbs(nfout,ipri,brmt, rcmt, dface, dline)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      integer nfout, ipri
      dimension brmt(3,3),rcmt(3,3), dface(3), dline(2,3)
c
c   checking of orthogonality
      if(ipri >= 2) then
         write(nfout,'(" !!ldos: -- checking of orthogonality --")')
         do i = 1, 3
            do j = 1, 3
               prod = 0.d0
               do 3 k = 1, 3
                  prod = prod + brmt(k,i)*rcmt(k,j)
 3             continue
               write(nfout,'(" !!ldos - product of brmt and rcmt -")')
               write(nfout,'(" !!ldos i = ",i5," j = ",i5
     &                                 ," prod = ",f20.12)') i, j, prod
            end do
         end do
      end if
c
      do 11 i = 1, 3
         p = 0.d0
         d = 0.d0
         do 12 j = 1, 3
            p = p + brmt(j,i)*rcmt(j,i)
            d = d + rcmt(j,i)*rcmt(j,i)
 12      continue
         dface(i) = p/dsqrt(d)
 11   continue
c
      if(ipri >= 2) then
         write(nfout,9001) (dface(j),j = 1, 3)
 9001    format(' !!ldos (dface(1-3)) = (',3f12.4,')')
      end if
c
      do 21 i = 1, 3
         d = 0.d0
         do 32 k = 1, 3
            d = d + brmt(k,i)*brmt(k,i)
 32      continue
         do 22 j = 1, 2
            jj = i+j
            jj = mod(jj,3)
            if(jj .eq. 0) jj = 3
            p = 0.d0
            do 23 k = 1, 3
               p = p + brmt(k,jj)*brmt(k,i)
 23         continue
            if(i.eq.2) then
               dline(3-j,i) = p/d
            else
               dline(j,i) = p/d
            endif
 22      continue
 21   continue

      if(ipri >= 1) then
         write(nfout,9002) ((dline(j,i),j=1,2),i=1,3)
 9002    format(' !!ldos (dline(1-2,1-3)) = ,',3('(',2f12.4,')'))
      end if
C
      return
      end
C --------------------------------------------------------
C
C        patmbr: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine patmbr(catxyz,matom,natom,rcmt,catom)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      parameter (LBRAVS = 1, LCARTS = 2, MCORDS = 2)
      dimension catxyz(matom,3),catom(matom,3)
      dimension rcmt(3,3),work(3)
C
      pi2 = 8.d0*datan(1.d0)
C
      do 1 i = 1, natom
         do 2 j = 1, 3
            work(j) = 0.d0
            do 3 k = 1, 3
               work(j) = work(j) + rcmt(k,j)*catxyz(i,k)/pi2
 3          continue
 2       continue
         catom(i,1) = work(1)
         catom(i,2) = work(2)
         catom(i,3) = work(3)
C
 1    continue
C
      return
      end
C --------------------------------------------------------
C
C        gtrcmt: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine gtrcmt(brmt,rcmt)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension brmt(3,3),rcmt(3,3)
C
      do 1 i = 1, 3
         j = mod(i,3) + 1
         k = mod(i+1,3) + 1
         do 2 ii = 1, 3
            jj = mod(ii,3) + 1
            kk = mod(ii+1,3) + 1
            rcmt(ii,i) = brmt(jj,j)*brmt(kk,k)
     &                 - brmt(kk,j)*brmt(jj,k)
 2       continue
 1    continue
C
      volunt = 0.d0
      do 11 i = 1, 3
         volunt = volunt + brmt(i,1)*rcmt(i,1)
 11   continue
C
      do 21 i = 1, 3
         do 22 j = 1, 3
            rcmt(j,i) = rcmt(j,i)/volunt
 22      continue
 21   continue
C
      write(6,9212) ((rcmt(j,i),i=1,3),j=1,3)
 9212 format(/' !!ldos rcmt-matrix',3(/3f10.5))
      return
      end
C --------------------------------------------------------
C
C        gtbrmt: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine gtbrmt(brmt)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension brmt(3,3)
      do 1 j = 1, 3
         do 2 i = 1, 3
            brmt(i,j) = 0.d0
 2       continue
 1    continue
      brmt(1,1) = 14.49568901
      brmt(2,2) = 14.49568901
      brmt(3,3) = 51.25
C
      return
      end
C --------------------------------------------------------
C
C        posatm: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine posatm(catxyz,matom,natom,rcmt,catom)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension catxyz(matom,3), catom(matom,3)
      dimension rcmt(3,3)
C
      call patmbr(catxyz,matom,natom,rcmt,catom)
C
c      write(6,9001) ((catxyz(ia,j),j = 1, 3),ia = 1, natom)
c 9001 format(' *** catxyz ***',99(/3f12.4))
C
c      write(6,9002) ((catom(ia,j),j = 1, 3),ia = 1, natom)
c 9002 format(' *** catoms(in BRAVaiS) ***',99(/3f12.4))

      return
      end
C --------------------------------------------------------
C
C        gtnabc: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
      subroutine gtnabc(nabc,mesha,meshb,meshc)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension nabc(3)
C
      nabc(1) = mesha
      nabc(2) = meshb
      nabc(3) = meshc
C
      return
      end
C --------------------------------------------------------
C
C        gtwscr: coded by T.Yamasaki 8th Oct 1992
C 
C --------------------------------------------------------
c$$$      subroutine gtwscr(nfout,brmt,wscr)
c$$$c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
c$$$      implicit real*8 (a-h,o-z)
c$$$      integer nfout
c$$$      dimension brmt(3,3)
c$$$C
c$$$c$$$      z = 0.2
c$$$c$$$      wscr = z * brmt(1,1)
c$$$c$$$      if(wscr.lt.5.0) then
c$$$c$$$         wscr = 5.d0
c$$$c$$$      endif
c$$$      wscr = 6.0d0
c$$$      write(nfout,*) ' !!ldos **** polyhedral critical radius = ', wscr
c$$$c        unit is a.u.
c$$$c
c$$$      return
c$$$      end
C -------------
      subroutine wdmesp(mesh,ifxr,ifyr,ifzr,nfile)
c                           @(#)anlmes.f 9.2 01/05/14 20:51:42
      implicit real*8 (a-h,o-z)
      dimension mesh(ifxr,ifyr,ifzr)
C
      mt = ifxr*ifyr*ifzr
C
      write(nfile,*) ' CHARGE DENSITY NE = ', mt,' ( ',
     &     ifyr,ifzr,ifxr, ' )'
C
      write(nfile,9001)
     &    (((mesh(i,j,k), j = 1, ifyr), k = 1, ifzr),i = 1, ifxr)
 9001 format(20i4)
C
      return
      end
C ----------------------------------------------
C       Nov. 17th 1992 by T.Yamasaki
C
C       modified by T. Yamasaki, 09th Feb 2004
C ----------------------------------------------
C                           %Z%%M% %I% %E% %U%
      subroutine dwinly2(kimg,catxyz,matom,natom,winlay,mlayer,nlayer
     &                 ,numlay,nhatom,maxhv,slicing_selection,deltaz
     &                 ,crtdst_winlay,nfout)
      implicit none
      integer kimg,matom,natom,mlayer,nlayer,nhatom,slicing_selection

c$$$      parameter ( crtdst = 3.5 )
      real*8 catxyz(matom,3),winlay(mlayer,2)
      integer numlay(nhatom)
      real*8 maxhv
      real*8 deltaz, crtdst_winlay
      integer nfout

      real*8 tmp, maxv, zmin
      integer i, nl

      integer REGULAR_INTERVALS, BY_ATOMIC_POSITION
      parameter ( REGULAR_INTERVALS = 1, BY_ATOMIC_POSITION = 2)

      if(kimg .eq.1) maxv = maxhv*2
      if(kimg .eq.2) maxv = maxhv

      call rsreal(mlayer*2, winlay)
      if(slicing_selection .eq. REGULAR_INTERVALS) then
         write(nfout,'(" !!ldos slicing_selection = EAZY")')
         if(kimg .eq. 1) then
            winlay(1,1) = 0.d0
            winlay(mlayer,2) = maxhv
            do i = 1, nlayer
              winlay(i,2) = deltaz*i
              if(winlay(i,2) .gt. maxhv) winlay(i,2) = maxhv
              if(i+1 .le. mlayer) winlay(i+1,1) = winlay(i,2)
            enddo
         else if(kimg .eq. 2) then
            zmin = maxv*30
            do i = 1, nhatom
              if(zmin .gt. catxyz(i,1)) zmin = catxyz(i,1)
            enddo
            winlay(1,1) = zmin - crtdst_winlay
            winlay(mlayer,2) = winlay(1,1) + maxv
            do i = 1, nlayer
              winlay(i,2) = winlay(i,1) + deltaz
              if(winlay(i,2) .gt. winlay(mlayer,2))
     &             winlay(i,2) = winlay(mlayer,2)
              if(i+1. le. mlayer) winlay(i+1,1) = winlay(i,2)
            enddo
         endif
      else if(slicing_selection .eq. BY_ATOMIC_POSITION) then
         write(nfout,'(" !!ldos slicing_selection = BY_ATOMS")')
            
         do i = 1, mlayer
           winlay(i,1) = +maxv*30
           winlay(i,2) = -maxv*30
         enddo

         do i = 1, nhatom
           nl = numlay(i)
           if(winlay(nl,1) .gt. catxyz(i,1)) winlay(nl,1) = catxyz(i,1)
           if(winlay(nl,2) .lt. catxyz(i,1)) winlay(nl,2) = catxyz(i,1)
         enddo
c           winlay(nl,1) : minimum z among nl-th layer atomic coordinates
c           winlay(nl,2) : maxmum  z among nl-th layer atomic coordinates
c
         write(nfout,*)
     &        ' !!ldos a range of atomic positions of each layer ****'
         do i = 1, nlayer
           write(nfout,9001) i, winlay(i,1), winlay(i,2)
         enddo
C
         tmp = winlay(1,1) - crtdst_winlay
         if(kimg .eq. 2) then
            if(tmp .lt. winlay(nlayer,2) - maxhv ) then
c     ( a unit cell has no vacuum region )
               winlay(1,1) = (winlay(1,1) + winlay(nlayer,2)-maxv)*0.5
               winlay(nlayer,2) = winlay(1,1)+maxv
               winlay(mlayer,1) = winlay(1,1)
               winlay(mlayer,2) = winlay(1,1)
            else
c     ( a unit cell has a vacuum region)
               winlay(1,1) = winlay(1,1) - crtdst_winlay
               winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
               winlay(mlayer,1) = winlay(nlayer,2)
               winlay(mlayer,2) = winlay(1,1) + maxv
            endif
         else if(kimg .eq. 1) then
            winlay(1,1)      = 0
            winlay(mlayer,2) = maxhv
            winlay(nlayer,2) = winlay(nlayer,2) + crtdst_winlay
            winlay(mlayer,1) = winlay(nlayer,2)
         endif

         do i = 1, nlayer-1
           winlay(i,2) = (winlay(i,2) + winlay(i+1,1))*0.5
           winlay(i+1,1) = winlay(i,2)
         enddo
      endif

      write(nfout,*) ' !!ldos     no,        min,           max '
      do i = 1, nlayer
      write(nfout,9001) i, winlay(i,1), winlay(i,2)
      enddo
      if(mlayer.gt.nlayer) then
         write(nfout,9001) mlayer, winlay(mlayer,1), winlay(mlayer,2)
      endif
 9001 format(' !!ldos ',i4,2f20.8)
C
      return
      end
c -- * -- 1 -- * -- 2 -- * -- 3 -- * -- 4 -- * -- 5 -- * -- 6 -- * -- 7
c                           @(#)exstak.f 9.1 97/09/10 20:34:10
c
c ----- subroutine exstak ---------------------------------------------
c
c                        1994 6/26    by yamasaki takahiro
c
      subroutine exstak
c
      write(6,*) ' !!ldos == error   at exstak == '
      write(6,*) ' !!ldos   shortage of stack size '
      write(6,*) ' !!ldos   expande stack size '
      stop
      end

module m_ES_ChargeState
  use m_Const_Parameters,   only : DP, PAI, PAI2, PAI4, FMAXVALLEN, NOCONV, ON, OFF, &
       &                           LOWER, Hartree, Bohr

  use m_Control_Parameters, only : kimg, noncol, nspin, iprichgdefect, &
       &                           sw_calc_extfnv_correction
  use m_Ionic_System,       only : natm, natm2, pos, ntyp, zfm3_l, ityp, iatomn, &
       &                           m_IS_pack_all_ions_in_uc, iatom
  use m_Crystal_Structure,  only : altv, rltv, univol
  use m_Parallelization,    only : ista_kngp, iend_kngp, ista_atm, iend_atm, &
       &                            mype, npes, mpi_comm_group, ierr
  use m_PseudoPotential,    only : psc_l, ival
  use m_Charge_Density,     only : chgq_l
  use m_PlaneWaveBasisSet,  only : kgp, kg, gr_l, ngabc, kgp_reduced, igfp_l
  use m_Electronic_Structure, only : totch

  use m_FFT,    only : m_FFT_CD_inverse0, nfftp_nonpara, fft_box_size_CD_nonpara, &
       &               fft_box_size_CD

  use m_Files,  only : nfout, m_Files_open_electrosta_pot, &
       &                      m_Files_close_electrosta_pot, nf_elecpot_bin, &
       &                      m_Files_open_electrosta_pot_ref, &
       &                      m_Files_close_electrosta_pot_ref, nf_elecpot_bin_ref
  use m_CD_Mag_Moment,  only : rad_cov


  implicit none

  include 'mpif.h'
  integer istatus(mpi_status_size)

! -------------------------------------------------------

  character(len("Postprocessing")),private,parameter :: tag_postprocessing    = "postprocessing"
  character(len("charged_defect")),private,parameter :: &
       &         tag_charged_defect    = "charged_defect"

  character(len("dielectric_constant")),private,parameter :: &
       & tag_dielectric_const = "dielectric_constant"
  character(len("exx")),private,parameter :: tag_exx = "exx"
  character(len("eyy")),private,parameter :: tag_eyy = "eyy"
  character(len("ezz")),private,parameter :: tag_ezz = "ezz"
  character(len("exy")),private,parameter :: tag_exy = "exy"
  character(len("eyz")),private,parameter :: tag_eyz = "eyz"
  character(len("ezx")),private,parameter :: tag_ezx = "ezx"

  character(len("position")),private,parameter :: tag_position  = "position"
  character(len("atom_id")),private,parameter :: tag_atom_id = "atom_id"
  character(len("x")),private,parameter :: tag_x = "x"
  character(len("y")),private,parameter :: tag_y = "y"
  character(len("z")),private,parameter :: tag_z = "z"

  integer :: atomid_defect
  logical :: atomid_is_set = .false.
  real(kind=DP) :: q, eps(3,3), pos_defect(3)

  character(len("electrostatic_potential")),private,parameter ::  &
       &       tag_electrostatic_potential  = "electrostatic_potential"
  character(len("electrostatic_pot")),private,parameter ::  &
       &       tag_electrostatic_pot  = "electrostatic_pot"
  character(len("sw_write_electrostatic_pot")),private,parameter :: &
       &        tag_sw_write_electrostatic_pot = "sw_write_electrostatic_pot"
  integer :: sw_write_electrostatic_pot = OFF

  character(len("format")),private,parameter :: tag_pot_format  = "format"
  character(len("cube")),private,parameter :: tag_cube  = "cube"
  character(len("atoms")),private,parameter :: tag_atoms = "atoms"

  character(len("unit")),private,parameter :: tag_pot_unit  = "unit"
  character(len("Hartree")),private,parameter :: tag_Hartree  = "hartree"
  character(len("Rydberg")),private,parameter :: tag_Rydberg  = "rydberg"
  character(len("eV")),private,parameter :: tag_eV  = "ev"

  integer, parameter :: CUBE = 1, ATOMS = 2
  integer, parameter :: in_Hartree = 0, in_Rydberg = 1, in_eV = 2
  integer :: pot_format = CUBE, pot_unit = in_eV

  character(len("correction")),private,parameter ::  tag_correction = "correction"

  character(len("sw_calc_extfnv_correction")),private,parameter :: &
       &        tag_sw_calc_extfnv_correction = "sw_calc_extfnv_correction"
!  integer :: sw_calc_extfnv_correction = OFF

  real(kind=DP), allocatable :: potdiff_on_grid(:,:,:), potdiff_on_atoms(:)
  real(kind=DP), allocatable :: Vpc_on_grid(:,:,:), Vpc_on_atoms(:)

contains

  subroutine m_ESCS_read_param
    integer, parameter :: LEN_TITLE = 80
    integer :: f_selectBlock, f_getStringValue, f_getRealValue, f_getIntValue
    integer :: f_selectParentBlock, f_selectTop

    integer :: iret
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: rstr

    iret = f_selectTop()

    if ( f_selectBlock( tag_postprocessing ) == 0 ) then

       if ( f_selectBlock( tag_electrostatic_pot ) == 0 &
            & .or. f_selectBlock( tag_electrostatic_potential ) == 0 ) then
          if ( f_getIntValue( tag_sw_write_electrostatic_pot, iret ) == 0 ) then
             sw_write_electrostatic_pot = iret
             if ( mype == 0 ) &
                  &  write(nfout,*) "** sw_write_electrostatic_pot is ", iret
          endif
          
          iret = f_getStringValue( tag_pot_format,rstr,LOWER )
          if ( rstr == tag_cube ) then
             pot_format = CUBE
          else if ( rstr == tag_atoms ) then
             pot_format = ATOMS
          endif
          
          iret = f_getStringValue( tag_pot_unit,rstr,LOWER )
          if ( rstr == tag_Hartree ) then
             pot_unit = in_Hartree
          else if ( rstr == tag_Rydberg ) then
             pot_unit = in_Rydberg
          else if ( rstr == tag_eV ) then
             pot_unit = in_eV
          endif
          
          if ( mype == 0 ) then
             write(nfout,*) "** pot_format is ", pot_format
             write(nfout,*) "** pot_unit is ", pot_unit
          endif
          iret = f_selectParentBlock()
       endif

       if ( f_selectBlock( tag_charged_defect ) == 0 ) then

          if ( mype == 0 ) write(nfout,*) "=== Info: Charged Defect Analysis ==="
             
          if ( f_selectBlock( tag_correction ) == 0 ) then
             if ( f_getIntValue( tag_sw_calc_extfnv_correction, iret ) == 0 ) then
                sw_calc_extfnv_correction = iret
                if ( mype == 0 ) &
                     &  write(nfout,*) "** sw_calc_extfnv_correction is ", iret
             endif

             if ( f_selectBlock( tag_dielectric_const ) == 0 ) then
                if ( f_getRealValue( tag_exx, dret, '') == 0 ) eps(1,1) = dret
                if ( f_getRealValue( tag_eyy, dret, '') == 0 ) eps(2,2) = dret
                if ( f_getRealValue( tag_ezz, dret, '') == 0 ) eps(3,3) = dret
                if ( f_getRealValue( tag_exy, dret, '') == 0 ) eps(1,2) = dret
                if ( f_getRealValue( tag_eyz, dret, '') == 0 ) eps(2,3) = dret
                if ( f_getRealValue( tag_ezx, dret, '') == 0 ) eps(3,1) = dret
                eps(2,1) = eps(1,2);  eps(3,2) = eps(2,3);    eps(1,3) = eps(3,1)
                iret = f_selectParentBlock()
             else
                eps = 0.0d0;
                eps(1,1) = 1.0d0;  eps(2,2) = 1.0d0;  eps(3,3) = 1.0d0
             endif
             
             if ( f_selectBlock( tag_position ) == 0 ) then
                if ( f_getIntValue( tag_atom_id, iret ) == 0 ) then
                   atomid_defect = iret;      atomid_is_set = .true.
                endif
                if ( f_getRealValue( tag_x, dret, '') == 0 ) pos_defect(1) = dret
                if ( f_getRealValue( tag_y, dret, '') == 0 ) pos_defect(2) = dret
                if ( f_getRealValue( tag_z, dret, '') == 0 ) pos_defect(3) = dret
                iret = f_selectParentBlock()
             else
                pos_defect = 0.0d0       ! origin
             endif
! bin nomi saiyou ?

             if ( mype == 0 ) then
                if ( sw_calc_extfnv_correction == ON ) then
                   if ( atomid_is_set ) then
                      write(nfout,*) "** defect atom_id      :", atomid_defect
                   else
                      write(nfout,*) "** defect position (x) :", pos_defect(1)
                      write(nfout,*) "**                 (y) :", pos_defect(2)
                      write(nfout,*) "**                 (z) :", pos_defect(3)
                   endif
                   write(nfout,*) "** dielectric tensor (xx) :", eps(1,1)
                   write(nfout,*) "**                   (yy) :", eps(2,2)
                   write(nfout,*) "**                   (zz) :", eps(3,3)
                endif
             endif

             iret = f_selectParentBlock()
          endif

!          q = additional_charge

          iret = f_selectParentBlock()
       end if
       iret = f_selectParentBlock()

    end if

  end subroutine m_ESCS_read_param

! =================
  subroutine m_ESCS_wd_electrostatic_pot
    integer :: nlp, nmp, nnp, lun
    character*72 :: file1
    real(kind=DP), allocatable :: pot_now(:,:), pot_on_grid(:,:,:), pot_on_atoms(:)

    allocate( pot_now(ista_kngp:iend_kngp,kimg) );   pot_now = 0.0d0
    call set_electrocstatic_pot_Gspace( pot_now )

!    lun = 1000;  file1 = "./Potential.bin"
!    call wd_pot_bin( lun, file1, pot_now )

    call m_Files_open_electrosta_pot
    lun = nf_elecpot_bin
    call wd_pot_bin( lun, pot_now )

    call m_Files_close_electrosta_pot

    if ( pot_format == CUBE ) then
       nlp = fft_box_size_CD(1,1)
       nmp = fft_box_size_CD(2,1)
       nnp = fft_box_size_CD(3,1)
       allocate( pot_on_grid(nnp,nmp,nlp) ); pot_on_grid = 0.0d0
       call set_electrostatic_pot_on_grid( pot_now, nlp, nmp, nnp, pot_on_grid )

       lun = 1000;  file1 = "./electrostatic_pot.cube"
       call wd_pot_cube( lun, file1, nlp, nmp, nnp, pot_on_grid, &
            &            "Local+Hartree potential" )
       deallocate( pot_on_grid )

    else if ( pot_format == ATOMS ) then
       allocate( pot_on_atoms(natm) ); pot_on_atoms = 0.0d0
       call set_electrostatic_pot_on_atoms( pot_now, pot_on_atoms )

       lun = 1000;  file1 = "./electrostatic_pot.atoms"
       call wd_pot_on_atoms( lun, file1, pot_on_atoms, &
            &                "Local+Hartree potential" )
       deallocate( pot_on_atoms )

    endif

    deallocate( pot_now )
   
  end subroutine m_ESCS_wd_electrostatic_pot
  
  subroutine m_ESCS_wd_Madelung_pot      ! assuming Madelung pot is already calculated.
    integer :: nlp, nmp, nnp, lun
    character*72 :: file1

    if ( pot_format == CUBE ) then
       nlp = fft_box_size_CD(1,1)
       nmp = fft_box_size_CD(2,1)
       nnp = fft_box_size_CD(3,1)

       lun = 1000;  file1 = "./Madelung_pot.cube"
       call wd_pot_cube( lun, file1, nlp, nmp, nnp, Vpc_on_grid, &
            &            "Madelung pot." )

    else if ( pot_format == ATOMS ) then
       lun = 1000;  file1 = "./Madelung_pot.atoms"
       call wd_pot_on_atoms( lun, file1, Vpc_on_atoms, "Madelung pot." )
    endif
  end subroutine m_ESCS_wd_Madelung_pot

  subroutine set_electrocstatic_pot_Gspace( pot_wk )
    real(kind=DP), intent(out) :: pot_wk(ista_kngp:iend_kngp,kimg)
    integer :: ist, is, ik, i, it
    
    ist = ista_kngp
    if(ist == 1) ist = 2

    do ik = 1, kimg
       if ( noncol .or. nspin == 1 ) then
          do i = ist, iend_kngp  !for mpi
             pot_wk(i,ik) = PAI4*chgq_l(i,ik,1)/gr_l(i)**2
          end do
       else if (nspin == 2) then
          do i = ist, iend_kngp  !for mpi
             pot_wk(i,ik) = PAI4*(chgq_l(i,ik,1)+chgq_l(i,ik,2))/gr_l(i)**2
          end do
       endif
       do it = 1, ntyp
          do i = ista_kngp, iend_kngp  !for mpi
             pot_wk(i,ik) = pot_wk(i,ik)+psc_l(i,it)*zfm3_l(i,it,ik)
          end do
       end do
    end do
  end subroutine set_electrocstatic_pot_Gspace

  subroutine set_electrostatic_pot_on_grid( pot_wk, nlp, nmp, nnp, pot_on_grid )
    integer, intent(in) :: nlp, nmp, nnp
    real(kind=DP), intent(in) ::  pot_wk(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(out) :: pot_on_grid(nnp,nmp,nlp)

    real(kind=DP), allocatable, dimension(:)       :: afft, bfft
    real(kind=DP), allocatable, dimension(:)       :: afft_mpi1

    allocate( afft(nfftp_nonpara) );      afft = 0.0d0
    allocate( afft_mpi1(nfftp_nonpara) ); afft_mpi1 = 0.0d0

    call map_density_to_fft_box
    call m_FFT_CD_inverse0(nfout,afft)
    call set_data_on_grid( nlp, nmp, nnp, pot_on_grid )

    deallocate( afft );   deallocate( afft_mpi1 )

  contains
 
    subroutine map_density_to_fft_box
      integer :: j, i, ip, it
      
      afft_mpi1 = 0.d0
      do j = 1, kimg
         do i = ista_kngp, iend_kngp
            if(kgp_reduced < i) cycle
#ifdef _MPIFFT_
            ip = (igfp_nonpara(i)-1)*kimg + j
#else
            ip = (igfp_l(i)-1)*kimg + j
#endif
            afft_mpi1(ip) = afft_mpi1(ip) +pot_wk(i,j)
         end do
      end do

      if(npes >= 2) then
         call mpi_allreduce(afft_mpi1,afft,nfftp_nonpara,mpi_double_precision &
              &  ,mpi_sum,mpi_comm_group,ierr)
      else
         afft = afft_mpi1
      end if
    end subroutine map_density_to_fft_box

    subroutine set_data_on_grid( nlp, nmp, nnp, wkchr )
      integer, intent(in) :: nlp, nmp, nnp
      real(kind=DP), intent(out) :: wkchr(nnp,nmp,nlp)

      integer :: idp, mmp, up_down
      integer :: inew, jnew, knew, i, j, k, ip, nlphf
      real(kind=DP) :: s1, s2, sratio
      integer, parameter :: UP = 1 , DOWN = 2

      idp = fft_box_size_CD_nonpara(1,0)
      mmp = fft_box_size_CD_nonpara(2,0)

      if(kimg == 1) then
         nlphf = idp/2
      else
         nlphf = idp
      end if

! -- checking of symmetric or anti-symmetric about the charge densities
      s1 = 0.d0; s2 = 0.d0
      do ip = 1, nlphf*mmp*nnp,2
         s1 = s1 +dabs(afft(ip));     s2 = s2 +dabs(afft(ip+1))
      end do
!      if(ipri >= 2) write(nfout,'(" s1 = ",d14.6," s2 = ",d14.6)') s1, s2
      if(s1 > s2) then
!         if(ipri >= 2) &
!              & write(nfout,*) ' The function of pot. density is analyzed as symmetric.'
         up_down = UP;      sratio = s2/s1
      else
!         if(ipri >= 2) &
!              & write(nfout,*) ' The function of pot. density is analyzed as anti-symmetric.'
         up_down = DOWN;     sratio = s1/s2
      endif
!      if(ipri >= 2) write(nfout,*) ' !ratio = ', sratio
!      if(ipri >= 2) write(nfout,9001) nlp*nmp*nnp, nlp, nmp, nnp
!9001  format(' Pot. DENSITY NE = ',i8,'(',3i5,')')

!      if(ipri >= 2) write(nfout,*) ' !D FFT cube mapping start'
      do i = 1, nmp
         do j = 1, nnp
            do k = 1, nlp
               if(kimg == 1 .and. k > nlphf) then
                  knew = idp - k;   jnew = nnp+2 -j;   inew = nmp+2 -i
                  if(jnew > nnp) jnew = jnew -nnp
                  if(inew > nmp) inew = inew -nmp
               else
                  knew = k; jnew = j; inew = i
               end if
               ip = nlphf*mmp*(jnew-1) +nlphf*(inew-1) +knew
               wkchr(j,i,k) = afft(ip*2-2+up_down)
            end do
         end do
      end do
    end subroutine set_data_on_grid

  end subroutine set_electrostatic_pot_on_grid

  subroutine wd_pot_cube( lun, file1, nlp, nmp, nnp, wkchr, comment )
    integer, intent(in) :: lun, nlp, nmp, nnp
    character*72, intent(in) :: file1
    character*(*), intent(in) :: comment
    real(kind=DP), intent(in) :: wkchr(nnp,nmp,nlp)

    integer :: natm3, i, j, k, m
    integer :: boxsize(3), factor
    real(kind=DP) :: x, y, z, trans(3)

    integer, allocatable :: ityp_full(:)
    real(kind=DP), allocatable ::  cps_full(:,:) ,pos_full(:,:)
    
    if (mype /= 0) return

    open( lun, file=file1, status="unknown", form="formatted" )

    write(lun,'(A)') "Calculated by phase"
    if ( pot_unit == in_Rydberg ) then
       write(lun,'(A,A)') trim(adjustl(comment)), " in Rydberg"
    else if ( pot_unit == in_eV ) then
       write(lun,'(A,A)') trim(adjustl(comment)), " in eV"
    else
       write(lun,'(A,A)') trim(adjustl(comment)), " in Hartree"
    endif
    
    allocate(cps_full(natm2,3))
    allocate(ityp_full(natm2))
    call m_IS_pack_all_ions_in_uc(ityp_full,cps_full)
    
    natm3 = natm2
    
    x = 0.d0; y = 0.d0; z = 0.d0
    write(lun,'(i6,3f15.4)') natm3, x,y,z
    do i=1,3
       boxsize(i) = fft_box_size_CD(i,1)
    enddo
    do i = 1, 3
       write(lun,'(i6,3f12.6)') boxsize(i), altv(1:3,i)/dble(fft_box_size_CD(i,1))
    end do
    
    trans = 0.d0
    do i = 1, natm2
       m = ityp_full(i)
       cps_full(i,:) = cps_full(i,:)+trans(:)
       write(lun,'(i6,1x,f10.6,3(1x,f12.6))') &
            &        nint(iatomn(m)), iatomn(m), cps_full(i,1:3)
    end do
    deallocate(ityp_full,cps_full)
    
    factor = 1.0d0
    if ( pot_unit == in_Rydberg ) then
       factor = 2.0d0
    else if ( pot_unit == in_eV ) then
       factor = Hartree
    endif
    
    do i = 1, nlp
       do j = 1, nmp
          write(lun,'(6e13.5)') (wkchr(k,j,i)*factor,k=1,nnp)  
       end do
    end do

  end subroutine wd_pot_cube

  subroutine set_electrostatic_pot_on_atoms( pot_wk, pot_on_atoms )
    real(kind=DP), intent(in) ::  pot_wk(ista_kngp:iend_kngp,kimg)
    real(kind=DP), intent(out) :: pot_on_atoms(natm)

    integer :: ia, ist, i, it
    real(kind=DP) :: csum, d1, fac1r, fac1i
    real(kind=DP) :: rad1, fac2, gr, normG, normG3, vecG(3), vol

    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: pot_on_atom(:), pot_mpi(:)

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

    Do ia=1, natm
       it = ityp(ia)
       rad1 = rad_cov(ia)
       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )
       if ( ista_kngp == 1 ) then
          ist = 2
       else
          ist = ista_kngp
       endif

       csum = 0.0d0
       Do i=ist, iend_kngp
          VecG(1) = rltv(1,1)*ngabc(i,1) +rltv(1,2)*ngabc(i,2) +rltv(1,3)*ngabc(i,3)
          VecG(2) = rltv(2,1)*ngabc(i,1) +rltv(2,2)*ngabc(i,2) +rltv(2,3)*ngabc(i,3)
          VecG(3) = rltv(3,1)*ngabc(i,1) +rltv(3,2)*ngabc(i,2) +rltv(3,3)*ngabc(i,3)

          normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
          normG3 = normG**3

          fac1r = zfcos(i);   fac1i = zfsin(i)

          gr = normG *rad1
          fac2 = -gr *cos(gr) + sin(gr)
          fac2 = fac2 *PAI4 /normG3

          if ( kimg == 1 ) then
             d1 = pot_wk(i,1) *fac1r
          else
             d1 = pot_wk(i,1) *fac1r -pot_wk(i,kimg)*fac1i
          endif
          csum = csum +d1 *fac2
       End Do
       vol = PAI4 /3.0 *rad1**3
       Pot_on_atoms(ia) = csum /vol
    End Do

    deallocate( zfcos, zfsin )

    if ( npes > 1 ) then
       allocate( pot_mpi(natm) ); pot_mpi = 0.0d0
       call mpi_allreduce( pot_on_atoms, pot_mpi, natm, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       pot_on_atoms = pot_mpi
       deallocate( pot_mpi )
    endif
  end subroutine set_electrostatic_pot_on_atoms
  
  subroutine wd_pot_on_atoms( lun, file1, pot_on_atoms, comment )
    integer, intent(in) :: lun
    character*72, intent(in) :: file1
    character*(*), intent(in) :: comment
    real(kind=DP), intent(in) :: pot_on_atoms(natm)

    integer :: i
    real(kind=DP) :: factor

    factor = 1.0d0
    if ( pot_unit == in_Rydberg ) then
       factor = 2.0d0
    else if ( pot_unit == in_eV ) then
       factor = Hartree
    endif

    if ( mype == 0 ) then
       open( unit=lun, file=file1, status="unknown", form="formatted" )
       if ( pot_unit == in_Rydberg ) then
          write(lun,'(A,A)') trim(adjustl(comment)), " in Rydberg"
       else if ( pot_unit == in_eV ) then
          write(lun,'(A,A)') trim(adjustl(comment)), " in eV"
       else
          write(lun,'(A,A)') trim(adjustl(comment)), " in Hartree"
       endif
       Do i=1, natm
          write(lun,'(I5,4F20.10)') i, pos(i,1:3),pot_on_atoms(i) *factor
       End Do
       close(lun)
    endif

  end subroutine wd_pot_on_atoms
! =================

  subroutine wd_pot_bin( lun, pot_wk )
    integer, intent(in) :: lun
    real(kind=DP), intent(in) :: pot_wk(ista_kngp:iend_kngp,kimg)

    integer :: i, ik, ierr
    real(kind=DP), allocatable :: pot_mpi1(:,:), pot_mpi2(:,:)

    if ( npes > 1 ) then
       allocate( pot_mpi1(kgp,kimg) );  pot_mpi1 = 0.0d0
       allocate( pot_mpi2(kgp,kimg) );  pot_mpi2 = 0.0d0
       do ik = 1, kimg
          do i = ista_kngp, iend_kngp
             pot_mpi1(i,ik) = pot_wk(i,ik)
          end do
       end do
       call mpi_allreduce( pot_mpi1, pot_mpi2, kgp*kimg, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       if (mype == 0) then
          write(lun) pot_mpi2
       endif
       deallocate(pot_mpi1);  deallocate(pot_mpi2)
    else
       write(lun) pot_wk
    endif
  end subroutine wd_pot_bin

  subroutine rd_pot_bin( lun, pot_wk ) 
    integer, intent(in) :: lun
    real(kind=DP), intent(out) :: pot_wk(ista_kngp:iend_kngp,kimg)

    integer :: i, ik, ierr
    real(kind=DP), allocatable :: pot_mpi1(:,:), pot_mpi2(:,:)

    if ( npes > 1 ) then
       allocate( pot_mpi1(kgp,kimg) );  pot_mpi1 = 0.0d0
       if (mype == 0) then
          read(lun) pot_mpi1
       endif
       call mpi_bcast( pot_mpi1, kgp*kimg, mpi_double_precision, 0, mpi_comm_group, ierr )
       do ik = 1, kimg
          do i = ista_kngp, iend_kngp
             pot_wk(i,ik) = pot_mpi1(i,ik)
          end do
       end do
       deallocate(pot_mpi1)
    else
       if (mype == 0) then
          read(lun) pot_wk
       endif
    endif
  end subroutine rd_pot_bin

! ===========================
  subroutine m_ESCS_calc_pot_diff
    integer :: nlp, nmp, nnp, lun
    character*72 :: file1

    real(kind=DP), allocatable :: pot_ref(:,:), pot_wk(:,:)

    allocate( pot_wk(ista_kngp:iend_kngp,kimg) );    pot_wk = 0.0d0
    call set_electrocstatic_pot_Gspace( pot_wk )

    allocate( pot_ref(ista_kngp:iend_kngp,kimg) );    pot_ref = 0.0d0

    call m_Files_open_electrosta_pot_ref()
    call rd_pot_bin( nf_elecpot_bin_ref, pot_ref )
    call m_Files_close_electrosta_pot_ref()

    pot_wk = pot_wk -pot_ref
    deallocate(pot_ref)

    nlp = fft_box_size_CD(1,1);  
    nmp = fft_box_size_CD(2,1);
    nnp = fft_box_size_CD(3,1)       
    allocate( potdiff_on_grid(nnp,nmp,nlp) );  potdiff_on_grid = 0.0d0
    call set_electrostatic_pot_on_grid( pot_wk, nlp, nmp, nnp, potdiff_on_grid )

    allocate( potdiff_on_atoms(natm) );  potdiff_on_atoms = 0.0d0
    call set_electrostatic_pot_on_atoms( pot_wk, potdiff_on_atoms )

    deallocate(pot_wk)
    
  end subroutine m_ESCS_calc_pot_diff

! ================================    
  subroutine m_ESCS_finalize
    if ( allocated( potdiff_on_grid )  ) deallocate( potdiff_on_grid )
    if ( allocated( potdiff_on_atoms ) ) deallocate( potdiff_on_atoms )
    if ( allocated( Vpc_on_grid )  ) deallocate( Vpc_on_grid )
    if ( allocated( Vpc_on_atoms ) ) deallocate( Vpc_on_atoms )
  end subroutine m_ESCS_finalize

  subroutine m_ESCS_wd_extfnv_correction  ! auto
    integer :: nlp, nmp, nnp, lun, it
    character*72 :: file1
    real(kind=DP) :: Epc, zion_sum

    if ( atomid_is_set ) then
       pos_defect(1:3) = pos( atomid_defect,1:3 )
    endif

    zion_sum = 0.0d0
    Do it=1, ntyp
       zion_sum = zion_sum +ival(it) *iatom(it)
    End Do
    q = zion_sum -totch   

    call m_ESCS_calc_pot_diff         ! pot_diff in Gspace

    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)       
    allocate( Vpc_on_grid(nnp,nmp,nlp) ); Vpc_on_grid = 0.0d0
    allocate( Vpc_on_atoms(natm) ); Vpc_on_atoms = 0.0d0

    call calc_extended_fnv_correction( Epc )

    if ( mype == 0 ) then
       write(nfout,*) 
       write(nfout,*) "=== Result: Charged Defect Analysis ==="
       write(nfout,'(A,F10.5)')    "    Ecorr     = Epc -q *dV"
       write(nfout,'(A,F10.5)')    "       q      = ", q
       write(nfout,'(A,F20.10,A)') "    Epc       = ", Epc *Hartree, " eV"
    endif

    lun = 1000;  file1 = "./defect_pot_correction.direction"
    if ( mype == 0 ) call calc_correction_cube( lun, file1 )

    lun = 1000;  file1 = "./defect_pot_correction.atoms"
    if ( mype == 0 ) call calc_correction_atoms( lun, file1 )

    write(nfout,*)

  contains

    subroutine calc_correction_cube( lun, file1 )
      integer, intent(in) :: lun
      character*72, intent(in) :: file1

      integer :: i, j, k
      integer :: nlp, nmp, nnp, ic(3)
      character*72 :: file_out
      real(kind=DP) :: vec_A(3), vec_B(3), vec_C(3), c1, c2, c3, r1, emax, emin
      real(kind=DP), allocatable :: pot_dir1(:,:), pot_dir2(:,:), pot_dir3(:,:)

      vec_A(1:3) = altv(1:3,1)
      vec_B(1:3) = altv(1:3,2)
      vec_C(1:3) = altv(1:3,3)
!
      nlp = fft_box_size_CD(1,1)
      nmp = fft_box_size_CD(2,1)
      nnp = fft_box_size_CD(3,1)       
!
      allocate( pot_dir1(nlp,2) );  pot_dir1 = 0.0d0
      allocate( pot_dir2(nmp,2) );  pot_dir2 = 0.0d0
      allocate( pot_dir3(nnp,2) );  pot_dir3 = 0.0d0
!
      Do i=1, nlp
         Do j=1, nmp
            Do k=1, nnp
               c1 = -potdiff_on_grid(k,j,i) *Hartree    ! -1 is from sign of electron
               c2 = Vpc_on_grid(k,j,i) *Hartree
                                                    
               pot_dir1(i,1) = pot_dir1(i,1) +c1
               pot_dir2(j,1) = pot_dir2(j,1) +c1
               pot_dir3(k,1) = pot_dir3(k,1) +c1
               pot_dir1(i,2) = pot_dir1(i,2) +c2
               pot_dir2(j,2) = pot_dir2(j,2) +c2
               pot_dir3(k,2) = pot_dir3(k,2) +c2
            End Do
         End Do
      End Do
!
      pot_dir1 = pot_dir1 /dble(nmp) /dble(nnp)
      pot_dir2 = pot_dir2 /dble(nnp) /dble(nlp)
      pot_dir3 = pot_dir3 /dble(nlp) /dble(nmp)

! direc vecA
      r1 = sqrt( Vec_A(1)**2 +Vec_A(2)**2 +Vec_A(3)**2 ) *Bohr
      file_out = trim(adjustl(file1)) // "_1"
      open( unit=lun, file=file_out, status="unknown", form="formatted" )
      write(lun,'(A,4X,A,5X,A,10X,A)') "#  dist. (Ang)", "pot_diff (eV)", &
           &         "Vpc (eV)", "pot_diff -Vpc (eV)"
      Do i=1, nlp
         c1 = r1 *(i-1) /dble(nlp)
         c2 = pot_dir1(i,1);    c3 = pot_dir1(i,2)
         write(lun,'(F10.5,3F18.8)') c1, c2, c3, c2-c3
      End Do
      close(lun)

! direc vecB
      r1 = sqrt( Vec_B(1)**2 +Vec_B(2)**2 +Vec_B(3)**2 ) *Bohr
      file_out = trim(adjustl(file1)) // "_2"
      open( unit=lun, file=file_out, status="unknown", form="formatted" )
      write(lun,'(A,4X,A,5X,A,10X,A)') "#  dist. (Ang)", "pot_diff (eV)", &
           &         "Vpc (eV)", "pot_diff -Vpc (eV)"
      Do i=1, nmp
         c1 = r1 *(i-1) /dble(nmp)
         c2 = pot_dir2(i,1);   c3 = pot_dir2(i,2)
         write(lun,'(F10.5,3F18.8)') c1, c2, c3, c2-c3
      End Do
      close(lun)

! direc vecC
      r1 = sqrt( Vec_C(1)**2 +Vec_C(2)**2 +Vec_C(3)**2 ) *Bohr
      file_out = trim(adjustl(file1)) // "_3"
      open( unit=lun, file=file_out, status="unknown", form="formatted" )
      write(lun,'(A,4X,A,5X,A,10X,A)') "#  dist. (Ang)", "pot_diff (eV)", &
           &         "Vpc (eV)", "pot_diff -Vpc (eV)"
      Do i=1, nnp
         c1 = r1 *(i-1) /dble(nnp)
         c2 = pot_dir3(i,1);     c3 = pot_dir3(i,2)
         write(lun,'(4F10.5,3F18.8)') c1, c2, c3, c2-c3
      End Do
      close(lun)
! 
      if ( q > 0 ) then
         emin = 1.0D10;   ic(1) = 1
         Do i=1, nlp
            if ( pot_dir1(i,2) < emin ) then
               emin = pot_dir1(i,2);      ic(1) = i
            endif
         End Do
         emin = 1.0D10;   ic(2) = 1
         Do i=1, nmp
            if ( pot_dir2(i,2) < emin ) then
               emin = pot_dir2(i,2);      ic(2) = i
            endif
         End Do
         emin = 1.0D10;   ic(3) = 1
         Do i=1, nnp
            if ( pot_dir3(i,2) < emin ) then
               emin = pot_dir3(i,2);      ic(3) = i
            endif
         End Do
      else
         emax = -1.0D10;   ic(1) = 1
         Do i=1, nlp
            if ( pot_dir1(i,2) > emax ) then
               emax = pot_dir1(i,2);      ic(1) = i
            endif
         End Do
         emax = -1.0D10;   ic(2) = 1
         Do i=1, nmp
            if ( pot_dir2(i,2) > emax ) then
               emax = pot_dir2(i,2);      ic(2) = i
            endif
         End Do
         emax = -1.0D10;   ic(3) = 1
         Do i=1, nnp
            if ( pot_dir3(i,2) > emax ) then
               emax = pot_dir3(i,2);      ic(3) = i
            endif
         End Do
      endif

      c1 = ( pot_dir1(ic(1),1) -pot_dir1(ic(1),2) ) &
           & + ( pot_dir2(ic(2),1) -pot_dir2(ic(2),2) ) &
           & + ( pot_dir3(ic(3),1) -pot_dir3(ic(3),2) )
      c2 = c1 /3.0d0
      c3 = Epc *Hartree -q *c2

!      if ( iprichgdefect > 1 ) then
         write(nfout,'(A)') "  << if planar avarage is used >>"
         write(nfout,'(A,F20.10,A)') "    dV        = ", c2, " eV"
         write(nfout,'(A,F20.10,A)') "    Ecorr     = ", c3, " eV"
!      endif

      deallocate( pot_dir1 );   deallocate( pot_dir2 );  deallocate( pot_dir3 )

    end subroutine calc_correction_cube

    subroutine calc_correction_atoms( lun, file1 )
      integer, intent(in) :: lun
      character*72, intent(in) :: file1

      integer :: i, nx, ny, nz, num
      real(kind=DP) :: dist_min, dist, vec(3), rws
      real(kind=DP) :: x1, y1, z1, c1, c2, c3, csum
      real(kind=DP) :: vec_A(3), vec_B(3), vec_C(3)
      
      dist_min = 1.0D10
      Do i=1, 3
         vec(1:3) = altv(1:3,i) /2.0d0
         dist = sqrt( vec(1)**2 +vec(2)**2 +vec(3)**2 )
         dist_min = min( dist, dist_min )
      End Do
      rws = dist_min
!
      vec_A(1:3) = altv(1:3,1)
      vec_B(1:3) = altv(1:3,2)
      vec_C(1:3) = altv(1:3,3)
!
      num = 0 ; csum = 0.0d0

      open( unit=lun, file=file1, status="unknown", form="formatted" )
      write(lun,'(A,3X,A,4X,A,5X,A,10X,A)') "# no.", "dist. (Ang)", "pot_diff (eV)", &
           &         "Vpc (eV)", "pot_diff -Vpc (eV)"

      Do i=1, natm
         dist_min = 1.0D10
         Do nx=-1, 1
            Do ny=-1, 1
               Do nz=-1, 1
                  x1 = ( pos(i,1) -pos_defect(1) +nx )*vec_A(1) &
                       & +( pos(i,2) -pos_defect(2) +ny )*vec_B(1) &
                       & +( pos(i,3) -pos_defect(3) +nz )*vec_C(1)
                  y1 = ( pos(i,1) -pos_defect(1) +nx )*vec_A(2) &
                       & +( pos(i,2) -pos_defect(2) +ny )*vec_B(2) &
                       & +( pos(i,3) -pos_defect(3) +nz )*vec_C(2)
                  z1 = ( pos(i,1) -pos_defect(1) +nx )*vec_A(3) &
                       & +( pos(i,2) -pos_defect(2) +ny )*vec_B(3) &
                       & +( pos(i,3) -pos_defect(3) +nz )*vec_C(3)
                  dist = sqrt( x1**2 +y1**2 +z1**2 )
                  dist_min = min( dist, dist_min )
               End do
            End Do
         End Do

#if 0
         c1 = ( Epc +q*Vpc_on_atoms(i) ) *Hartree
         c2 =  q *potdiff_on_atoms(i) *Hartree      ! (-q) *(-1);
                                                    !    -1 is from sign of electron
         c3 = c1 +c2
#else
         c3 = ( -potdiff_on_atoms(i) -Vpc_on_atoms(i) ) *Hartree
#endif
         if ( dist_min > rws +0.1 ) then
            num = num +1;   csum = csum +c3
         endif
         write(lun,'(I5,F10.5,3F18.8)') i, dist_min*Bohr, &
              &                          -potdiff_on_atoms(i) *Hartree, &
              &                           Vpc_on_atoms(i) *Hartree, &
              &                         (-potdiff_on_atoms(i)-Vpc_on_atoms(i) )*Hartree
      End Do

!      write(nfout,*)
      write(nfout,'(A)') "  << if site avarage is used >>"
      write(nfout,'(A,F20.10,A)') "      ( Rad_ws = ", rws *Bohr, " Ang. )"

      if ( num > 0 ) then
         c2 = csum /dble(num)
         c3 = Epc *Hartree -q *c2
!         if ( iprichgdefect > 1 ) then
            write(nfout,'(A,F20.10,A)') "    dV        = ", c2, " eV"
!         endif
         write(nfout,'(A,F20.10,A)')    "    Ecorr     = ", c3, " eV"

         write(lun,*) 
         write(lun,'(A,F20.10)') "# Correction energy (eV):", c3
      endif
      close(lun)

    end subroutine calc_correction_atoms

  end subroutine m_ESCS_wd_extfnv_correction

  subroutine calc_extended_fnv_correction( Epc_aniso )
    real(kind=DP), intent(out) :: Epc_aniso

    integer :: neibrd, newldg, alen(3)
    real(kind=DP) :: gamma, alf
    real(kind=DP) :: epsinv(3,3), det_eps
    real(kind=DP) :: Vpc_r, Vpc_g0
!
    real(kind=DP), parameter :: rsphere_radius = 12.5d0
    real(kind=DP), parameter :: phi            =  6.0d0
!
    real(kind=DP), allocatable :: rr(:), rxyz(:,:)
!
    integer :: i, nlp, nmp, nnp
    real(kind=DP) :: alpha_r, c1

    call calc_epsinv( eps, det_eps, epsinv )
    call decide_rxyz_size( rsphere_radius, alen, neibrd )
    allocate( rxyz(neibrd,3) );    allocate( rr(neibrd) )
  
    call substitute_rxyz( alen, neibrd, rxyz, rr )
    deallocate(rr)
  
    call decide_alf( alen, rsphere_radius, phi, alf, det_eps )   ! -> alf
    call decide_newldg( alf, phi, newldg, det_eps ) ! -> newldg = #Gvectors for summation
!
    gamma = 1.0d0 /alf
!
    call calc_Vpc_aniso_Rspace( q, gamma, neibrd, rxyz, det_eps, epsinv, Vpc_r )
    call calc_Vpc_aniso_Gspace0( q, gamma, newldg, eps, det_eps, Vpc_g0 )
!
    Epc_aniso = -q /2.0d0 *( Vpc_r +Vpc_g0 )

    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)       
    call calc_Vpc_aniso_Gspace1_grid( q, gamma, newldg, eps, pos_defect, &
         &                            nlp, nmp, nnp, Vpc_on_grid )
    Vpc_on_grid = Vpc_r +Vpc_on_grid

    call calc_Vpc_aniso_Gspace1_atoms( q, gamma, newldg, eps, det_eps, pos_defect, &
         &                             Vpc_on_atoms )
    Vpc_on_atoms = Vpc_r +Vpc_on_atoms

    deallocate(rxyz);  

  end subroutine calc_extended_fnv_correction

  subroutine decide_alf( alen, rsphere_radius, phi, alf, det_eps )
    integer, intent(in) :: alen(3)
    real(kind=DP), intent(in) :: rsphere_radius, phi, det_eps
    real(kind=DP), intent(out) ::alf

    real(kind=DP) :: xalen(3), aamin, c1

    c1 = det_eps **(1./3.)
    xalen = alen*(abs(int(rsphere_radius/alen)) + 1)
#if 0
    aamin = minval(xalen) /sqrt(c1)
#else
    aamin = minval(xalen) 
#endif
    alf = aamin/phi
!    if(printable) write(nfout,'("  alf = ",f12.6," aamin = ",f12.6)') alf, aamin
  end subroutine decide_alf

  subroutine decide_newldg( alf, phi, newldg, det_eps )
    real(kind=DP), intent(in) :: alf, phi, det_eps
    integer, intent(out) :: newldg

    integer :: i
    integer :: iend, newldg_mpi  !mpi
    real(kind=DP) :: c1

    newldg_mpi= 1;    newldg= 1
!    if(printable) write(nfout,'(" ! kg = ",i9)') kg

    c1 = det_eps **(1./3.)

    iend = iend_kngp
    if( iend > kg ) iend = kg
    if( ista_kngp <= iend ) then
       do i = ista_kngp, iend  !for mpi
#if 0
         if ( alf*gr_l(i)*c1 < phi*2.d0 ) newldg_mpi = i
#else
         if ( alf*gr_l(i) < phi*2.d0 ) newldg_mpi = i
#endif
       end do
    endif
    if (npes > 1) then
       call mpi_allreduce(newldg_mpi,newldg,1,mpi_integer,mpi_max,mpi_comm_group,ierr)
    else
       newldg = newldg_mpi
    end if
    if (newldg.eq.kg+1) then
!       if(printable) write(nfout,'(" **warn alf is too small: alf=",d20.10)') alf
       stop
    endif
!    if (printable) write(nfout,440) newldg
440 format(' ',' newldg = ',i8)
  end subroutine decide_newldg

  subroutine decide_rxyz_size( rsphere_radius, alen, neibrd )
    real(kind=DP), intent(in)  :: rsphere_radius
    integer,       intent(out) :: alen(3), neibrd

    integer :: i
    real(kind=DP) :: a

    do i = 1, 3
       a = dabs((rltv(1,i)*altv(1,i)+rltv(2,i)*altv(2,i)+rltv(3,i)*altv(3,i))&
            & /dsqrt(rltv(1,i)*rltv(1,i)+rltv(2,i)*rltv(2,i)+rltv(3,i)*rltv(3,i)))
       alen(i) = abs(int(rsphere_radius/a)) +1
    enddo
    neibrd = (alen(1)*2+1)*(alen(2)*2+1)*(alen(3)*2+1)

  end subroutine decide_rxyz_size

  subroutine substitute_rxyz( alen, neibrd, rxyz, rr )
    integer, intent(in) :: neibrd, alen(3)
    real(kind=DP), intent(out) :: rxyz(neibrd,3), rr(neibrd)

    integer :: i, j, k, mm
    real(kind=DP) :: f(3)

    mm = 0
    do i = -alen(1), alen(1)
       do j = -alen(2), alen(2)
          do k = -alen(3), alen(3)
             f(1) = i; f(2) = j; f(3) = k
             mm = mm + 1
             rxyz(mm,1:3) = matmul(altv,f)
             rr(mm) = dsqrt(dot_product(rxyz(mm,1:3),rxyz(mm,1:3)))
          enddo
       enddo
    enddo
    call hpsort(neibrd,neibrd,rxyz,rr)

  end subroutine substitute_rxyz

  subroutine calc_epsinv( eps, det, epsinv )
    real(kind=DP), intent(in) :: eps(3,3)
    real(kind=DP), intent(out) :: epsinv(3,3), det
!
    real(kind=DP) :: c11, c12, c13, c21, c22, c23, c31, c32, c33
    real(kind=DP) :: m11, m12, m13, m21, m22, m23, m31, m32, m33

    c11 = eps(1,1);   c12 = eps(1,2);   c13 = eps(1,3)
    c21 = eps(2,1);   c22 = eps(2,2);   c23 = eps(2,3)
    c31 = eps(3,1);   c32 = eps(3,2);   c33 = eps(3,3)

    det = c11*c22*c33 +c12*c23*c31 +c13*c21*c32 &
         &   -c13*c22*c31 -c12*c21*c33 -c11*c23*c32
    
    m11 = ( c22*c33 -c23*c32 ) /det
    m12 =-( c12*c33 -c13*c32 ) /det
    m13 = ( c12*c23 -c13*c22 ) /det
    m21 =-( c21*c33 -c23*c31 ) /det
    m22 = ( c11*c33 -c13*c31 ) /det
    m23 =-( c11*c23 -c13*c21 ) /det
    m31 = ( c21*c32 -c22*c31 ) /det
    m32 =-( c11*c32 -c12*c31 ) /det
    m33 = ( c11*c22 -c12*c21 ) /det
!
    epsinv(1,1) = m11;    epsinv(1,2) = m12;     epsinv(1,3) = m13
    epsinv(2,1) = m21;    epsinv(2,2) = m22;     epsinv(2,3) = m23
    epsinv(3,1) = m31;    epsinv(3,2) = m32;     epsinv(3,3) = m33

  end subroutine calc_epsinv
  
  subroutine calc_Vpc_aniso_Rspace( q, gamma, neibrd, rxyz, det_eps, epsinv, pot )
    integer, intent(in) :: neibrd
    real(kind=DP), intent(in) :: rxyz(neibrd,3)
    real(kind=DP), intent(in) :: q, gamma, det_eps, epsinv(3,3)
    real(kind=DP), intent(out) :: pot

    integer :: in, n1, n2
    real(kind=DP) :: csum1, csum2, r1, c1
    
    csum1 = 0.0d0
    do in = 2, neibrd
       r1 = 0.0d0
       Do n1=1, 3
          Do n2=1, 3
             r1 = r1 +rxyz(in,n1) *epsinv(n1,n2) *rxyz(in,n2)
          End do
       End Do
       c1 = erfc( gamma*r1 ) /r1 
       csum1 = csum1 +c1
    End do
    csum1 = csum1 /sqrt( det_eps )
!
    csum2 = -PAI /univol /gamma**2
!
    pot = q *( csum1 +csum2 )

  end subroutine calc_Vpc_aniso_Rspace
  
  subroutine calc_Vpc_aniso_Gspace0( q, gamma, newldg, eps, det_eps, pot )
    real(kind=DP), intent(in) :: q, gamma, eps(3,3), det_eps
    real(kind=DP), intent(out) :: pot
    integer, intent(in) :: newldg
!
    integer :: ist, iend, in, k, n1, n2
    real(kind=DP) :: csum, csum_mpi, c1, gvec(3)
!  
    ist = ista_kngp
    if (ist == 1) ist = 2

    iend = iend_kngp
    if ( iend > newldg ) iend = newldg

    csum = 0.0d0

    if( ist <= iend ) then
       do in = ist, iend  !for mpi
          Do k=1, 3
             gvec(k) = rltv(k,1) *ngabc(in,1) +rltv(k,2)*ngabc(in,2) &
                  &  + rltv(k,3) *ngabc(in,3)
          End Do
          c1 = 0.0d0
          Do n1=1, 3
             Do n2=1, 3
                c1 = c1 +gvec(n1) *eps(n1,n2) *gvec(n2)
             End Do
          End do
          csum = csum +exp( -c1 /gamma**2 /4.0d0 ) /c1
       End do
    endif

    if (npes > 1) then
       call mpi_allreduce( csum, csum_mpi, 1, mpi_double_precision, mpi_sum, &
            &              mpi_comm_group, ierr )
       csum = csum_mpi
    end if
    pot = PAI4 *q /univol *csum -2.0d0 *gamma *q /sqrt( PAI *det_eps )

  end subroutine calc_Vpc_aniso_Gspace0

  subroutine calc_Vpc_aniso_Gspace1_atoms( q, gamma, newldg, eps, det_eps, pos_defect, &
       &                                   pot_on_atom )
    real(kind=DP), intent(in) :: q, gamma, eps(3,3), pos_defect(3), det_eps
    real(kind=DP), intent(inout) :: pot_on_atom(natm)
    integer, intent(in) :: newldg
!
    integer :: ist, iend, in, k, n1, n2, ia
    real(kind=DP) :: csum, c1, phs, gvec(3), vec_r(3)
    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: weight(:), work(:)
!  
    ist = ista_kngp
    if (ist == 1) ist = 2

    iend = iend_kngp
    if ( iend > newldg ) iend = newldg

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

    allocate( weight(ista_kngp:iend_kngp) );  weight = 0.0d0

    if ( ist <= iend ) then
       do in = ist, iend  !for mpi
          Do k=1, 3
             gvec(k) = rltv(k,1) *ngabc(in,1) +rltv(k,2)*ngabc(in,2) &
                  &  + rltv(k,3) *ngabc(in,3)
          End Do
          c1 = 0.0d0
          Do n1=1, 3
             Do n2=1, 3
                c1 = c1 +gvec(n1) *eps(n1,n2) *gvec(n2)
             End Do
          End do
          weight(in) = exp( -c1 /gamma**2 /4.0d0 ) /c1
       end do
    end if

    Do ia=1, natm
       vec_r(:) = pos(ia,:) -pos_defect(:)
       call calc_phase2( 1, vec_r, 1, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )
       csum = 0.0d0
       do in=ist, iend
          csum = csum +weight(in) *zfcos(in)
       end do
#if 0
       pot_on_atom(ia) = q *PAI4 /univol *csum &
            &         -2.0d0 *gamma *q /sqrt( PAI *det_eps )
#else
       pot_on_atom(ia) = q *PAI4 /univol *csum 
#endif
    End Do
    deallocate( zfcos, zfsin )

    if ( npes > 1 ) then
       allocate( work(natm) ); work = 0.0d0
       call mpi_allreduce( pot_on_atom, work, natm, mpi_double_precision, mpi_sum, &
            &              mpi_comm_group, ierr )
       pot_on_atom = work
       deallocate( work )
    endif
    deallocate( weight )

  end subroutine calc_Vpc_aniso_Gspace1_atoms

  subroutine calc_Vpc_aniso_Gspace1_grid( q, gamma, newldg, eps, pos_defect, &
       &                                  nlp, nmp, nnp, pot_on_grid )
    real(kind=DP), intent(in) :: q, gamma, eps(3,3), pos_defect(3)
    real(kind=DP), intent(inout) :: pot_on_grid(nnp,nmp,nlp)
    integer, intent(in) :: newldg, nlp, nmp, nnp
!
    integer :: i, j, k
    integer :: ist, iend, in, n1, n2
    real(kind=DP) :: csum, c1, c2, phs, gvec(3)
    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: pot_wk(:,:), work(:,:,:)
!  
    ist = ista_kngp
    if (ist == 1) ist = 2

    iend = iend_kngp
    if ( iend > newldg ) iend = newldg

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0
    allocate( pot_wk(ista_kngp:iend_kngp,kimg) ); pot_wk = 0.0d0

    call calc_phase2( 1, pos_defect, 1, kgp, ngabc, ista_kngp, iend_kngp, &
         &            zfcos, zfsin )

    if ( ist <= iend ) then
       do in = ist, iend  !for mpi
          Do k=1, 3
             gvec(k) = rltv(k,1) *ngabc(in,1) +rltv(k,2)*ngabc(in,2) &
                  &  + rltv(k,3) *ngabc(in,3)
          End Do
          c1 = 0.0d0
          Do n1=1, 3
             Do n2=1, 3
                c1 = c1 +gvec(n1) *eps(n1,n2) *gvec(n2)
             End Do
          End do
          c2 = exp( -c1 /gamma**2 /4.0d0 ) /c1
          pot_wk(in,1) =  c2 *zfcos(in)
          pot_wk(in,2) = -c2 *zfsin(in)
       end do
    end if
!
    call set_electrostatic_pot_on_grid( pot_wk, nlp, nmp, nnp, pot_on_grid )
    pot_on_grid = pot_on_grid *q *PAI4 /univol

    deallocate( zfcos, zfsin )
    deallocate( pot_wk )

  end subroutine calc_Vpc_aniso_Gspace1_grid

end module m_ES_ChargeState

!
! =========== Contributions ===================================
!
! Through the courtesy of contributors, this module is added.
!
! Company:  ASMS Co.,Ltd.
! Functions:  [Identifier: 13.1R]
!       Raman tensor/spectrum calculation
!
! Note:
!       In order to work the whole functions, LIB_ASMS_RAMAN is required.
!
! =============================================================

module m_Raman
  use m_Control_Parameters, only : sw_lo_to_splitting, sw_phonon_oneshot, &
       &                           printable, ipriphonon, &
       &                           sw_phonon_with_epsilon, sw_calc_dielectric_tensor, &
       &                           num_phonon_calc_mode, sw_excitation, &
       &                           sw_phonon, sw_calc_force, sw_use_add_proj, sw_raman

  use m_Const_Parameters, only : DP, ON, OFF, FMAXVALLEN, LOWER, PAI4, CMPLDP

  use m_Crystal_Structure, only : univol, op
  use m_Files,  only : nfout, nfeps_ph, nfoptical_coeff, nframan_spectra, &
       &               m_Files_open_nfeps_phonon, &
       &               m_Files_open_nfoptical_coeff, &
       &               m_Files_open_nframan_spectra

  use m_Ionic_System,       only : num_force_data, &
       &                           displaced_atom, displacement, u, &
       &                           natm,ionic_mass, speciesname, &
       &                           istart_phonon, iend_phonon, &
       &                           natm_prim, norder, sw_polynomial_fit, &
       &                           num_force_calc, iconf, &
       &                           napt_phonon, iequconf, &
       &                           iopr_equconf

  use m_Parallelization,    only : mype,npes,ierr, mpi_comm_group
  use m_BP_Properties,      only : zeff

  use m_IterationNumbers, only : iteration_ionic, iteration_electronic

  implicit none
  include 'mpif.h'

! ---- 
! method 
!
  character(len("raman") ), private, parameter :: &
       &                    tag_raman = "raman"
  character(len("scheme") ), private, parameter :: &
       &                     tag_raman_calc_scheme = "scheme"
  character(len("classical") ), private, parameter :: &
       &                     tag_classical = "classical"
!
  character(len("sw_raman") ), private, parameter :: &
       &                    tag_sw_raman = "sw_raman"
  character(len("sw_phonon_with_epsilon") ), private, parameter :: &
       &                    tag_sw_phonon_with_epsilon = "sw_phonon_with_epsilon"
  character(len("sw_calc_dielectric_tensor") ), private, parameter :: &
       &                    tag_sw_calc_dielectric_tensor = "sw_calc_dielectric_tensor"
  character(len("sw_froehlich_correction") ), private, parameter :: &
       &                    tag_sw_froehlich_correction = "sw_froehlich_correction"
  character(len("optical_coeff_from_file") ), private, parameter :: &
       &                    tag_optical_coeff_from_file = "optical_coeff_from_file"
!
!!!  integer :: sw_phonon_with_epsilon = OFF
!!  integer :: sw_calc_dielectric_tensor = OFF
  integer :: sw_froehlich_correction = OFF
  integer :: optical_coeff_from_file = OFF
!
  real(kind=DP), allocatable :: dielectric_tensors(:,:,:)
  real(kind=DP), allocatable :: dielectric_tensor0(:)
  real(kind=DP), allocatable :: dielectric_tensor_data(:,:)
  real(kind=DP), allocatable :: Mat_dEps_dR(:,:,:)
  real(kind=DP), allocatable :: Raman_susceptibility(:,:,:)
  real(kind=DP) :: nonl_op_coeff_rchi2(3,3,3)
!
! ---- 
! crystal type
!
  integer, parameter :: SingleCrystal = 1, PolyCrystal = 2
  integer :: Crystal_Type = SingleCrystal
!
  character(len("crystal_type") ), private, parameter :: &
       &                    tag_crystal_type = "crystal_type"
  character(len("single") ), private, parameter :: tag_single_crystal = "single"
  character(len("poly") ), private, parameter ::   tag_poly_crystal = "poly"
  character(len("powder") ), private, parameter ::   tag_powder = "powder"
!
! ---- 
! propagation of photon
!
  character(len("tag_x") ), private, parameter ::   tag_x = "x"
  character(len("tag_y") ), private, parameter ::   tag_y = "y"
  character(len("tag_z") ), private, parameter ::   tag_z = "z"

  character(len("propagation") ), private, parameter ::  &
       &                                 tag_propagation = "propagation"
  character(len("incoming") ), private, parameter ::  &
       &                                 tag_incoming = "incoming"
  character(len("incident") ), private, parameter ::  &
       &                                 tag_incident = "incident"
  character(len("outgoing") ), private, parameter ::  &
       &                                 tag_outgoing = "outgoing"
  character(len("scattered") ), private, parameter ::  &
       &                                 tag_scattered = "scattered"

  character(len("direction_in") ), private, parameter ::  &
       &                                 tag_direction_in = "direction_in"
  character(len("direction_out") ), private, parameter :: &
       &                                 tag_direction_out="direction_out"
  character(len("kx") ), private, parameter :: tag_kx = "kx"
  character(len("ky") ), private, parameter :: tag_ky = "ky"
  character(len("kz") ), private, parameter :: tag_kz = "kz"
!
  real(kind=DP) :: photon_k_in(3)  = (/ 0.0d0, 0.0d0, 1.0d0 /)
  real(kind=DP) :: photon_k_out(3) = (/ 0.0d0, 0.0d0,-1.0d0 /)

! ---- 
! laser
!
  character(len=FMAXVALLEN) :: rstr
  character(len("tag_laser") ), private, parameter ::   tag_laser = "laser"
  character(len("tag_photon") ), private, parameter ::  tag_photon = "photon"

  character(len("wavelength") ), private, parameter :: tag_wavelength = "wavelength"
!
  real(kind=DP), parameter :: wavelength_green1 = 514.5d0         ! nm
  real(kind=DP) :: wavelength = wavelength_green1
  real(kind=DP) :: omega_L

! ----
! polarization vectors
!
  character(len("polarization") ), private, parameter :: &
       &                  tag_polarization = "polarization"
!
  character(len("nonorthogonal_component") ), private, parameter :: &
       &                  tag_nonorthogonal_component = "nonorthogonal_component"
!
  character(len("rotation") ), private, parameter ::&
       &                   tag_rotation = "rotation"
  character(len("angle_dependence") ), private, parameter ::&
       &                   tag_angle_dependence = "angle_dependence"
  character(len("num_rot_angles") ), private, parameter ::&
       &                   tag_num_rot_angles = "num_rot_angles"
  character(len("angle_0") ), private, parameter ::&
       &                     tag_angle0 = "angle_0"
  character(len("angle_1") ), private, parameter ::&
       &                     tag_angle1 = "angle_1"
  character(len("parallel_or_normal") ), private, parameter ::&
       &                   tag_parallel_or_normal = "parallel_or_normal"
!
  integer :: polar_parallel_or_normal = 0
  integer :: num_rot_angles = 0
  integer, parameter :: max_num_rot_angles = 10
!
  real(kind=DP) :: nonorthogonal_component = 0.0d0
  real(kind=DP) :: rot_angle0 = 0.0d0, rot_angle1 = 0.0d0
  real(kind=DP) :: rot_angles( max_num_rot_angles )
! --
!  unpolarized config (single crystal)
!
  character(len("calc_unpolarized_config") ), private, parameter :: &
       &                   tag_calc_unpolarized_config = "calc_unpolarized_config"

  logical :: calc_unpolarized_config = .false.

! ----
! spectrum
!
  character(len("spectrum") ), private, parameter :: tag_spectrum = "spectrum"
  character(len("linewidth") ), private, parameter :: tag_linewidth = "linewidth"
  character(len("hwhm") ), private, parameter :: tag_hwhm = "hwhm"
!
  character(len("freq_pitch") ), private, parameter :: tag_freq_pitch = "freq_pitch"
  character(len("resolution") ), private, parameter :: tag_freq_resol = "resolution"
!
  real(kind=DP) :: raman_spectra_hwhm = 5.0d0                ! in cm-1
  real(kind=DP) :: raman_spectra_freq_pitch = 1.0d0          ! in cm-1

! ---
! temperature
!
  character(len("temperature") ), private, parameter :: tag_temperature = "temperature"
  character(len("temp") ), private, parameter :: tag_temp = "temp"
!
  real(kind=DP) :: raman_spectra_temperature = 0.0d0         ! in Kelvin


! ----
! general
!
  integer, parameter :: nqvec = 1

  integer :: nmodes
  real(kind=DP) :: qdir(nqvec,3)
  real(kind=DP) :: dielectric(3,3)

contains

  subroutine m_Raman_read_nfinp
    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue, f_getStringValue
    integer :: f_selectParentBlock, f_selectTop
    integer :: i
    real(kind=DP) :: dret, c1
    character(len=FMAXVALLEN) :: cret

    logical :: tf

    if( f_selectBlock( tag_raman ) == 0) then
! === 2015/10/19
       if ( f_getIntValue( tag_sw_raman, iret) == 0 ) sw_raman = iret
       if ( sw_raman == OFF ) return

       if ( sw_phonon == ON ) sw_phonon_with_epsilon = on
! === 2015/10/19

       if ( f_getIntValue( tag_sw_phonon_with_epsilon, iret) == 0) & 
            &  sw_phonon_with_epsilon = iret
       
       if ( sw_phonon_with_epsilon == ON ) then
          sw_excitation = ON
          write(nfout,*) "!** sw_excitation is turned on"
! === 2015/10/19
          sw_use_add_proj = ON
          write(nfout,*) "!** sw_use_add_proj is turned on"
! === 2015/10/19
       endif

       if ( f_getStringValue( tag_raman_calc_scheme, rstr, LOWER) == 0 ) then
          call strncmp0( tag_classical, trim(rstr), tf )
          if(tf) sw_phonon_with_epsilon = on
       endif
       
! === 2015/10/19
       if ( sw_phonon_with_epsilon == ON ) then
          if ( sw_calc_force == ON ) sw_calc_dielectric_tensor = ON
       endif
! === 2015/10/19

       if ( f_getIntValue( tag_sw_calc_dielectric_tensor, iret) == 0) & 
            &  sw_calc_dielectric_tensor = iret
       
       if ( f_getIntValue( tag_optical_coeff_from_file, iret) == 0) &
            &  optical_coeff_from_file = iret
       
       if ( f_getIntValue( tag_sw_froehlich_correction, iret) == 0) &
            &  sw_froehlich_correction = iret
!
       if( f_getStringValue( tag_crystal_type, rstr, LOWER) == 0 ) then
          call set_crystal_type( trim(rstr), crystal_type )
       endif

       if( f_getRealValue( tag_temperature, dret,'') == 0 &
            &  .or. f_getRealValue( tag_temp, dret,'') == 0 ) then
          raman_spectra_temperature = dret            ! in Kelvin
          if ( raman_spectra_temperature < 0.0 ) then
             raman_spectra_temperature = 0.0d0
          endif
       endif

       if ( f_selectBlock( tag_propagation ) == 0 ) then
          if( f_getIntValue( tag_direction_in, iret ) == 0 ) then
             call set_direction_of_light( iret, photon_k_in )
          endif
          if( f_getIntValue( tag_direction_out, iret ) == 0 ) then
             call set_direction_of_light( iret, photon_k_out )
          endif
          if ( f_selectBlock( tag_incoming ) == 0 &
               & .or. f_selectBlock( tag_incident ) == 0 ) then
             if( f_getRealValue( tag_kx, dret, '' ) == 0 ) photon_k_in(1) = dret
             if( f_getRealValue( tag_ky, dret, '' ) == 0 ) photon_k_in(2) = dret
             if( f_getRealValue( tag_kz, dret, '' ) == 0 ) photon_k_in(3) = dret
             call set_direction_of_light2( photon_k_in )
             iret = f_selectParentBlock()
          end if
          if ( f_selectBlock( tag_outgoing ) == 0 &
               & .or. f_selectBlock( tag_scattered ) == 0 ) then
             if( f_getRealValue( tag_kx, dret, '' ) == 0 ) photon_k_out(1) = dret
             if( f_getRealValue( tag_ky, dret, '' ) == 0 ) photon_k_out(2) = dret
             if( f_getRealValue( tag_kz, dret, '' ) == 0 ) photon_k_out(3) = dret
             call set_direction_of_light2( photon_k_out )
             iret = f_selectParentBlock()
          endif
          iret = f_selectParentBlock()
       endif

       if ( f_selectBlock( tag_polarization ) == 0 ) then

          if ( f_getRealValue( tag_nonorthogonal_component, dret, '' ) == 0 ) then
             if ( dret > -1 .and. dret < 1 ) then
                nonorthogonal_component = dret
             endif
          endif

          if ( f_selectBlock( tag_angle_dependence ) == 0 &
               &       .or. f_selectBlock( tag_rotation ) == 0 ) then

             if ( f_getIntValue( tag_num_rot_angles, iret ) == 0 ) then
                if ( iret > 0 .and. iret <= max_num_rot_angles ) num_rot_angles = iret
             endif
             
             if ( num_rot_angles > 1 ) then
                if( f_getRealValue( tag_angle0, dret,'') == 0 ) rot_angle0 = dret
                if( f_getRealValue( tag_angle1, dret,'') == 0 ) rot_angle1 = dret
                
                c1 = ( rot_angle1 -rot_angle0 ) /dble( num_rot_angles -1 )
                Do i=1, num_rot_angles
                   rot_angles(i) = rot_angle0 +c1*(i-1)
                End do
                
             else if ( num_rot_angles == 1 ) then
                if ( f_getRealValue( tag_angle0, dret, '' ) == 0 )  rot_angle0 = dret
                rot_angles(1) = rot_angle0
             endif

             if ( f_getIntValue( tag_parallel_or_normal, iret ) == 0 ) then
                if ( iret == 0 .or. iret == 1 ) then
                   polar_parallel_or_normal = iret
                endif
             endif
             iret = f_selectParentBlock()

          endif

          if ( f_getIntValue( tag_calc_unpolarized_config, iret ) == 0 ) then
             if ( iret == 1 ) calc_unpolarized_config = .true.
          endif
          iret = f_selectParentBlock()
       end if
! ---
       if ( f_selectBlock( tag_laser ) == 0 ) then
          if( f_getRealValue( tag_wavelength, dret,'') == 0 ) then
             wavelength = dret         ! in nm
          endif

          if ( wavelength < 0.0 )  wavelength = wavelength_green1
! --
          iret = f_selectParentBlock()
       endif

       if( f_selectBlock( tag_spectrum ) == 0) then
          if( f_getRealValue( tag_hwhm, dret,'') == 0 &
               &  .or. f_getRealValue( tag_linewidth, dret,'') == 0 ) then
             raman_spectra_hwhm = dret                                   ! in cm-1
             if ( raman_spectra_hwhm < 0.0 ) raman_spectra_hwhm = 5.0d0
          endif

          if( f_getRealValue( tag_freq_pitch, dret,'') == 0 &
               &  .or. f_getRealValue( tag_freq_resol, dret,'') == 0 ) then

             raman_spectra_freq_pitch = dret            ! in cm-1
             if ( raman_spectra_freq_pitch < 0.0 ) then
                raman_spectra_freq_pitch = raman_spectra_hwhm *0.1d0
             endif
          else		      
             raman_spectra_freq_pitch = raman_spectra_hwhm *0.1d0
          endif
          iret = f_selectParentBlock()
       endif

       omega_L = 45.56335D0 /wavelength       ! in hartree

       iret = f_selectParentBlock()
    end if

  end subroutine m_Raman_read_nfinp

  subroutine m_Raman_initialize( kvec_dir )
    real(kind=DP), intent(out) :: kvec_dir(3)

    real(kind=DP) :: dnorm

    if ( sw_phonon_with_epsilon == OFF ) return
    
    if ( crystal_type == SingleCrystal ) then
       kvec_dir = photon_k_out -photon_k_in
       dnorm = sqrt(sum(kvec_dir(1:3)**2))

       if(abs(dnorm) < 1.d-10) then
          kvec_dir = -photon_k_in;      dnorm = 1.d0
       end if
       kvec_dir(1:3) = kvec_dir(1:3)/dnorm
    endif

    qdir(1,:) = kvec_dir(:)
! ----
    if ( sw_froehlich_correction == ON ) optical_coeff_from_file = ON
    if ( optical_coeff_from_file == ON ) call m_Raman_read_optical_coeff

    if ( sw_froehlich_correction == ON )  sw_lo_to_splitting = ON     ! ???????
!
  end subroutine m_Raman_initialize

  subroutine m_Raman_print_param
    if ( sw_raman == OFF ) return
    if ( sw_phonon_with_epsilon == OFF ) return

    write(nfout,'(A)') '!** ----- RAMAN setup ----- '
    write(nfout,*) '!** sw_phonon_with_epsilon = ', sw_phonon_with_epsilon
    write(nfout,*) '!** sw_calc_dielectric_tensor = ', sw_calc_dielectric_tensor
    write(nfout,*) '!** sw_froehlich_correction = ', sw_froehlich_correction
      
    write(nfout,*) '!** crystal_type = ', crystal_type
    write(nfout,'(A,F15.8)') '!** temperature [K] = ', &
         &                     raman_spectra_temperature

    write(nfout,'(A)') '!** propagation :'
    write(nfout,'(A,3F15.8)') '!** photon_k_in  = ', photon_k_in
    write(nfout,'(A,3F15.8)') '!** photon_k_out = ', photon_k_out
    write(nfout,'(A,3F15.8)') '!** qdir = ', qdir(1,:)

    if ( crystal_type == SingleCrystal ) then
       write(nfout,'(A)') '!** polarization :'
       write(nfout,'(A,F15.8)') '!** non-orthogonal component = ', &
            &                   nonorthogonal_component
       write(nfout,'(A,I0)') '!** polar_parallel_or_normal = ', polar_parallel_or_normal
       write(nfout,'(A,I0)') '!** num_rot_angles = ', num_rot_angles
       if ( num_rot_angles > 0 ) then
          write(nfout,'(A,2F15.8)') '!** First, Last = ', rot_angle0, rot_angle1
       endif
       if ( num_rot_angles == 0 ) then
          write(nfout,*) '!** calc_unpolarized_config = ', calc_unpolarized_config
       endif
    endif

    write(nfout,'(A)') '!** laser :'
    write(nfout,'(A,F15.8)') '!** wavelength [nm] = ', wavelength

    write(nfout,'(A)') '!** spectrum :'
    write(nfout,'(A,F15.8)') '!** Half width half maximum of spectr [cm-1] = ', &
         &                     raman_spectra_hwhm
    write(nfout,'(A,F15.8)') '!** Freq. pitch of spectra [cm-1] = ', &
         &                     raman_spectra_freq_pitch
    write(nfout,'(A)') '!** -----------------------'

  end subroutine m_Raman_print_param

  subroutine set_crystal_type( rstr, crystal_type )
    character(len=FMAXVALLEN),intent(in) :: rstr
    integer, intent(out) :: crystal_type
    logical :: tf

    call strncmp0( tag_single_crystal, trim(rstr), tf )
    if(tf) crystal_type = SingleCrystal

    call strncmp0( tag_poly_crystal, trim(rstr), tf )
    if(tf) crystal_type = PolyCrystal

    call strncmp0( tag_powder, trim(rstr), tf )
    if(tf) crystal_type = PolyCrystal

  end subroutine set_crystal_type

  subroutine set_direction_of_light( nn, direction )
    integer :: nn
    real(kind=DP), intent(out) :: direction(3)

    direction = 0.0d0

    if ( nn ==  1 ) direction(1) =  1.0d0
    if ( nn ==  2 ) direction(2) =  1.0d0
    if ( nn ==  3 ) direction(3) =  1.0d0
    if ( nn == -1 ) direction(1) = -1.0d0
    if ( nn == -2 ) direction(2) = -1.0d0
    if ( nn == -3 ) direction(3) = -1.0d0

    if ( direction(1)**2 +direction(2)**2 + direction(3)**2 < 1.0E-4 ) then
       direction(3) = 1.0d0
    endif
  end subroutine set_direction_of_light

  subroutine set_direction_of_light2( direction )
    real(kind=DP), intent(inout) :: direction(3)
    real(kind=DP) :: c1

    c1 = direction(1)**2 +direction(2)**2 + direction(3)**2
    if ( c1 < 1.0E-4 ) then
       direction = 0.0d0;  direction(3) = 1.0d0
    else
       direction = direction /sqrt(c1)
    endif
  end subroutine set_direction_of_light2

  subroutine m_Raman_write_dielec_tensors
    integer :: i,ic

    if (.not.allocated(dielectric_tensor_data)) then
       allocate(dielectric_tensor_data(6,num_force_data))
       ic = iconf(iteration_ionic)
       dielectric_tensor_data(1,ic) = dielectric(1,1)
       dielectric_tensor_data(2,ic) = dielectric(2,2)
       dielectric_tensor_data(3,ic) = dielectric(3,3)
       dielectric_tensor_data(4,ic) = dielectric(1,2)
       dielectric_tensor_data(5,ic) = dielectric(1,3)
       dielectric_tensor_data(6,ic) = dielectric(2,3)
    endif
    
    if ( mype /= 0 ) return
    
    if(iteration_ionic == 1) then 
       call m_Files_open_nfeps_phonon(.false.)     ! new file (asms)
       if(istart_phonon == 1) then
          if(sw_phonon_oneshot == ON) then
             write(nfeps_ph,'(4(1x,i7),3A)') num_force_calc, norder, sw_polynomial_fit, &
                  &                          num_phonon_calc_mode, &
                  &                          "  : num_force_calc, norder, ", &
                  &                          " sw_polynomial_fit, ", &
                  &                          " num_phonon_calc_mode"
          else
             write(nfeps_ph,'(3(1x,i7),A)') num_force_calc, norder, sw_polynomial_fit, &
                  &  "  : num_force_calc, norder, sw_polynomial_fit"
          end if
       end if
    else
       call m_Files_open_nfeps_phonon(.true.)     ! append (asms)
    endif

    write(nfeps_ph,'(i4,3(1x,e25.12),2i6,2A)') displaced_atom, displacement(1:3),&
         &                                    iteration_ionic, iteration_electronic, &
         &                                    " : displaced_atom, displacement(1:3), ", &
         &                                    "iteration_ionic,iteration_electronic"
  
#if 0
    write(nfeps_ph,'(3F20.15)') dielectric(1,1), dielectric(2,2), &
         &                      dielectric(3,3), dielectric(1,2), &
         &                      dielectric(1,3), dielectric(2,3)
#else
    write(nfeps_ph,'(5X,3F22.15)') dielectric(1,1), dielectric(1,2), dielectric(1,3)
    write(nfeps_ph,'(5X,3F22.15)') dielectric(2,1), dielectric(2,2), dielectric(2,3)
    write(nfeps_ph,'(5X,3F22.15)') dielectric(3,1), dielectric(3,2), dielectric(3,3)
#endif
    call flush(nfeps_ph)

  end subroutine m_Raman_write_dielec_tensors

  subroutine m_Raman_read_dielec_tensors()
#ifdef WINDOWS
    use ifport
#endif
    implicit none
    
    ! local variables
    integer :: n,i,ia,ja,ind,j,ic,iopr
    integer :: istart,idummy
    character(len=5) :: num

    integer :: n1, n2, m1, m2
    real(kind=DP) :: cmat1(3,3), cmat2(3,3), ctmp

    if(ipriphonon>=1) write(nfout,*) '<< m_Raman_read_dielectric_tensors >> Reading '
    call flush(nfout)
    
    nmodes = natm_prim*3
    allocate(dielectric_tensors(6,nmodes,norder*2))
    allocate(dielectric_tensor0(6))
    
    num_force_data = nmodes*norder*2
    if(sw_polynomial_fit == ON) num_force_data = num_force_data + 1
    if(.not.allocated(dielectric_tensor_data)) then
       allocate(dielectric_tensor_data(6,num_force_data))
    endif
    
    if(mype == 0) then
       call m_Files_open_nfeps_phonon(.false.)
       rewind nfeps_ph
       
       read(nfeps_ph,*) num_force_calc, norder, sw_polynomial_fit
       do i=1,num_force_calc
          read(nfeps_ph,*) displaced_atom,displacement(1:3)
          ic = iconf(i)
#if 0
#else
          read(nfeps_ph,*) cmat1(1,1), cmat1(1,2), cmat1(1,3)
          read(nfeps_ph,*) cmat1(2,1), cmat1(2,2), cmat1(2,3)
          read(nfeps_ph,*) cmat1(3,1), cmat1(3,2), cmat1(3,3)
          dielectric_tensor_data(1,ic) = cmat1(1,1)
          dielectric_tensor_data(2,ic) = cmat1(2,2)
          dielectric_tensor_data(3,ic) = cmat1(3,3)
          dielectric_tensor_data(4,ic) = cmat1(1,2)
          dielectric_tensor_data(5,ic) = cmat1(1,3)
          dielectric_tensor_data(6,ic) = cmat1(2,3)
#endif

#if 0
          if ( mype == 0 ) then
             write(*,*) 'ic = ',ic
             write(*,*) dielectric_tensor_data(1,ic)
             write(*,*) dielectric_tensor_data(2,ic)
             write(*,*) dielectric_tensor_data(3,ic)
             write(*,*) dielectric_tensor_data(4,ic)
             write(*,*) dielectric_tensor_data(5,ic)
             write(*,*) dielectric_tensor_data(6,ic)
          endif
#endif
       end do
    end if

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic = ",2i8)') i, ic

       if (ic == 0) cycle

       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr

       cmat1(1,1) = dielectric_tensor_data(1,ic)
       cmat1(2,2) = dielectric_tensor_data(2,ic)
       cmat1(3,3) = dielectric_tensor_data(3,ic)
       cmat1(1,2) = dielectric_tensor_data(4,ic)
       cmat1(1,3) = dielectric_tensor_data(5,ic)
       cmat1(2,3) = dielectric_tensor_data(6,ic)

       cmat1(2,1) = cmat1(1,2)
       cmat1(3,1) = cmat1(1,3)
       cmat1(3,2) = cmat1(2,3)

       Do n1=1, 3
          Do n2=1, 3
             ctmp = 0.0d0
             Do m1=1, 3
                Do m2=1, 3
                   ctmp = ctmp + op(n1,m1,iopr) *cmat1(m1,m2) *op(n2,m2,iopr)
                End do
             End do
             cmat2(n1,n2) = ctmp
          End do
       End Do

       dielectric_tensor_data(1,i) = cmat2(1,1)
       dielectric_tensor_data(2,i) = cmat2(2,2)
       dielectric_tensor_data(3,i) = cmat2(3,3)
       dielectric_tensor_data(4,i) = cmat2(1,2)
       dielectric_tensor_data(5,i) = cmat2(1,3)
       dielectric_tensor_data(6,i) = cmat2(2,3)
    end do

    if ( ipriphonon >=2 ) then
       if ( mype == 0) then
          write(nfout,*) '** dielectroc_tensor_data after rotation'
          Do ic=1, num_force_data
             write(nfout,*) '** ic = ',ic
             write(nfout,*) dielectric_tensor_data(1,ic)
             write(nfout,*) dielectric_tensor_data(2,ic)
             write(nfout,*) dielectric_tensor_data(3,ic)
             write(nfout,*) dielectric_tensor_data(4,ic)
             write(nfout,*) dielectric_tensor_data(5,ic)
             write(nfout,*) dielectric_tensor_data(6,ic)
          End Do
       endif
    endif

    if(sw_polynomial_fit == ON) then
       ind=1
       dielectric_tensor0(1:6) = dielectric_tensor_data(1:6,ind)
    else
       ind=0
    end if

    do i=1,nmodes
       do n=1,norder*2
          ind = ind+1
          dielectric_tensors(1:6,i,n) = dielectric_tensor_data(1:6,ind)
       end do
    end do
    
    if(npes>1) then
       call mpi_bcast(dielectric_tensors,6*nmodes*norder*2,mpi_double_precision, &
            &         0,mpi_comm_group,ierr)
       call mpi_bcast(dielectric_tensor0,6,mpi_double_precision,0,mpi_comm_group,ierr) 
    end if
    
    if(ipriphonon>=1) write(nfout,*) '<< m_Raman_read_dielectric_tensors >>: Read'

    call flush(nfout)

    return
  end subroutine m_Raman_read_dielec_tensors

  subroutine m_Raman_calc_Mat_dEps_dR          ! @PHONON-GAMMA
    integer :: is,nc,ind,i,j, k
    real(kind=DP) :: ui,x, csum(3,3)
    real(kind=DP), allocatable :: cmat(:,:) !dim(nc,nc)
    real(kind=DP), allocatable :: fvec(:) !dim(nc)

    real(kind=DP), allocatable :: TmpMat(:,:)

    if ( .not. allocated( Mat_dEps_dR ) ) then
       allocate( Mat_dEps_dR( 3, 3, nmodes ) )
    endif

    allocate( TmpMat( 6, nmodes) ) ; TmpMat = 0.0d0

    if(sw_polynomial_fit == ON) then
       nc = norder*2+1
       allocate(cmat(nc,nc)); cmat = 0.d0
       allocate(fvec(nc))
       cmat(1:nc,1) = 1.d0
       ind = 1
       do is = -norder,norder
          if(is==0) cycle
          ind=ind+1
          x = u/dble(is)
          do i=2,nc
             cmat(ind,i) = x**(i-1)
          end do
       end do

       do j=1, 6
          do i=1,nmodes
             fvec(1) = dielectric_tensor0(j)
             fvec(2:nc) = dielectric_tensors(j,i,1:nc-1)
             TmpMat(j,i) = polyfit_diff(nc,cmat,fvec)
          end do
       end do
    else
       ui=dble(norder)/u
       if(printable .and. ipriphonon>=2) then
          write(nfout,*) 'u=',u
          write(nfout,*) 'ui= norder/u =',ui
       endif
       if(norder == 1) then
          ui = 0.5d0*ui
          do j=1, 6
             do i=1,nmodes
                TmpMat(j,i) = ( dielectric_tensors(j,i,2) &
                     &              -dielectric_tensors(j,i,1) )*ui
             end do
          end do
       else if(norder == 2) then
          ui = ui/12.d0
          do j=1, 6
             do i=1,nmodes
                TmpMat(j,i) = ( -8.d0 *dielectric_tensors(j,i,1) &
                     &               +      dielectric_tensors(j,i,2) &
                     &               -      dielectric_tensors(j,i,3) &
                     &               +8.d0 *dielectric_tensors(j,i,4) )*ui
             end do
          end do
       else
          stop 'Your inputed norder is not supported for the differencial approximation.'
       end if
    end if

    Do i=1, nmodes
       Mat_dEps_dR(1,1,i) = TmpMat(1,i)
       Mat_dEps_dR(2,2,i) = TmpMat(2,i)
       Mat_dEps_dR(3,3,i) = TmpMat(3,i)
       Mat_dEps_dR(1,2,i) = TmpMat(4,i)
       Mat_dEps_dR(1,3,i) = TmpMat(5,i)
       Mat_dEps_dR(2,3,i) = TmpMat(6,i)

       Mat_dEps_dR(2,1,i) = TmpMat(4,i)
       Mat_dEps_dR(3,1,i) = TmpMat(5,i)
       Mat_dEps_dR(3,2,i) = TmpMat(6,i)
    End do

#ifdef USE_ASMS_RAMAN
    call ASMS_Raman_setup( nfout, nframan_spectra, natm, univol, &
     &                     crystal_type, omega_L, &
     &                     photon_k_in, photon_k_out, &
     &                     raman_spectra_hwhm, raman_spectra_freq_pitch, &
     &                     raman_spectra_temperature, &
     &                     nonorthogonal_component, &
     &                     calc_unpolarized_config, &
     &                     num_rot_angles, rot_angles, &
     &                     polar_parallel_or_normal, &
     &                     qdir, dielectric, nonl_op_coeff_rchi2 )
#endif

#ifdef USE_ASMS_RAMAN
    if ( sw_froehlich_correction == ON ) then
       call ASMS_Raman_add_Froelich_term( ipriphonon, Zeff, nmodes, Mat_dEps_dR )
    endif
#endif

! --- accoustic sum rule --
    Do k=1, 3
       csum = 0.0d0
       Do i=1, natm
          j = (i-1)*3 +k
          csum(:,:) = csum(:,:) + Mat_dEps_dR(:,:,j)
       End do
       csum = csum /dble(natm)

       Do i=1, natm
          j = (i-1)*3 +k
          Mat_dEps_dR(:,:,j) = Mat_dEps_dR(:,:,j) -csum(:,:)
       End do
    End Do

#if 0
    if ( mype == 0 ) then
       Do i=1, nmodes
          write(*,*) 'BMode : ', i
          write(*,*) Mat_dEps_dR(1,i)
          write(*,*) Mat_dEps_dR(2,i)
          write(*,*) Mat_dEps_dR(3,i)
          write(*,*) Mat_dEps_dR(4,i)
          write(*,*) Mat_dEps_dR(5,i)
          write(*,*) Mat_dEps_dR(6,i)
       End do
    end if
#endif
 
    deallocate( TmpMat )

  end subroutine m_Raman_calc_Mat_dEps_dR

  subroutine m_Raman_read_optical_coeff
    integer :: i, j, k, n1, n2, n3

    if ( mype /= 0 ) goto 100

    call m_Files_open_nfoptical_coeff( .false. )
    read(nfoptical_coeff,*) 
    read(nfoptical_coeff,*) 
    Do i=1, 3
       Do j=1, 3
          read(nfoptical_coeff,*) n1, n2, dielectric(i,j)
       End do
    End do
!
    read(nfoptical_coeff,*,end=2) 
    read(nfoptical_coeff,*) 
    Do i=1, 3
       Do j=1, 3
          Do k=1, 3
             read(nfoptical_coeff,*) n1, n2, n3, nonl_op_coeff_rchi2(i,j,k)
          End do
       End do
    End do

2   close(nfoptical_coeff)

100 continue

    if(npes>1) then
       call mpi_bcast( dielectric, 3*3, mpi_double_precision, &
            &          0, mpi_comm_group, ierr )
       call mpi_bcast( nonl_op_coeff_rchi2, 3*3*3, mpi_double_precision, &
            &          0, mpi_comm_group, ierr )
    end if

  end subroutine m_Raman_read_optical_coeff

  subroutine m_Raman_calc_susceptibility( nmodes, omega, modes, &
       &                                  mode_active, mode_irr_rep )
    integer, intent(in) :: nmodes
    real(kind=DP), intent(in) :: omega( nmodes, nqvec )
    complex(kind=CMPLDP), intent(in) :: modes( nmodes, nmodes, nqvec )
    character(len=3), intent(in) :: mode_irr_rep( nmodes, nqvec )
    character(len=4), intent(in) :: mode_active( nmodes, nqvec )

!    if(sw_lo_to_splitting == ON) return

#ifdef USE_ASMS_RAMAN
    if ( mype == 0 ) then
       call m_Files_open_nframan_spectra()
       call ASMS_Raman_calc_susceptibility( nmodes, omega, modes, &
            &                                 mode_active, mode_irr_rep, &
            &                                 Mat_dEps_dR, ionic_mass )
       close( nframan_spectra )
    endif
#else
    stop "Raman: Not supported kt"
#endif

  end subroutine m_Raman_calc_susceptibility

! ===- utility ===
  function polyfit_diff(nd,mat,vec)
    real(kind=DP) :: polyfit_diff

    integer, intent(in) :: nd
    real(kind=DP), intent(in) :: mat(nd,nd)
    real(kind=DP), intent(in) :: vec(nd)
    
! local variables
    integer :: ipiv(nd),info,i
    real(kind=DP) :: a(nd,nd),b(nd)
    real(kind=DP) :: x0,df
    real(kind=DP) :: xold
    real(kind=DP) :: eps = 1.d-10
    
    real(kind=DP) :: ux

    a = mat;   b = vec

    call dgesv(nd,1,a,nd,ipiv,b,nd,info)
    if(info .ne. 0 ) then
       if(printable) write(nfout,*) 'LAPACK routine DGETRS failure: info=',info
       stop 'LAPACK routine DGETRS failure'
    end if

    x0 = 0.d0
    df = diff_polyfunc(nd,b,x0)
    polyfit_diff = df

  end function polyfit_diff

  function polyfunc(nd,b,x)
    real(kind=DP) :: polyfunc
    
    integer, intent(in) :: nd
    real(kind=DP), intent(in) :: b(nd),x

    integer :: i
    real(kind=DP) :: f

    f = b(1)
    do i=2,nd
       f = f + b(i)*x**(i-1)
    end do
    polyfunc = f

  end function polyfunc

  function diff_polyfunc(nd,b,x)
    real(kind=DP) :: diff_polyfunc
    
    integer, intent(in) :: nd
    real(kind=DP), intent(in) :: b(nd),x

    integer :: i
    real(kind=DP) :: df

    df = b(2)
    do i=3,nd
       df = df + b(i)*dble(i-1)*x**(i-2)
    end do
    diff_polyfunc = df
    
  end function diff_polyfunc
! =====

end module m_Raman

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 581 $)
!
!  MODULE: m_ES_LHXC
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif

module m_ES_LHXC
! $Id: m_ES_LHXC.F90 581 2018-08-01 08:38:42Z jkoga $
  use m_Electronic_Structure, only : vlhxc_l, vloc_esm
  use m_PlaneWaveBasisSet,    only : kg,kgp,gr_l
  use m_PseudoPotential,      only : psc_l, ival
  use m_Ionic_System,         only : ntyp, zfm3_l
  use m_Timing,               only : tstatc0_begin, tstatc0_end
#ifdef ENABLE_ESM_PACK
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential &
  &                                , sw_esm, convergence_criteria
#else
  use m_Control_Parameters,   only : nspin, ipri,iprivlhxcq, kimg, sw_dipole_correction &
                                   , sw_screening_correction, sw_external_potential, convergence_criteria
#endif
  use m_Const_Parameters,     only : DP, PAI4, UP, DOWN, ON, OFF, CMPLDP, DELTA_V
  use m_Parallelization,      only : ista_kngp, iend_kngp, mype, myrank_g, mpi_comm_group
  use m_Crystal_Structure,    only : univol
  use m_Dipole,               only : vdip_l, vext_l
  use m_Dipole,               only : m_Dipole_potential, m_Dipole_calc
  use m_Screening,            only : screening
  use m_External_Potential,   only : espot_g

! ========================== added by K. Tagami ===================== 11.0
  use m_Control_Parameters,   only : ndim_chgpot, ndim_magmom
! =================================================================== 11.0

  use m_Charge_Density,       only : chgq_l

  use m_FFT,                  only : fft_box_size_CD
  use m_PlaneWaveBasisSet,    only : igfp_l

! === POSITRON SCF === 2015/11/28
  use m_Control_Parameters,   only : sw_positron, positron_method
  use m_Const_Parameters,     only : positron_GGGC
  use m_Positron_Wave_Functions,        only :  pchg_l
! ==================== 2015/11/28

  implicit none
  real(kind=DP) :: vmax
  include 'mpif.h'
!  61. m_ESlhxc_potential
contains
  subroutine m_ESlhxc_potential(nfout,chg,vxc)
    integer, intent(in)       :: nfout
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,nspin)
    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,nspin)
    complex(kind=CMPLDP),allocatable :: vhar(:)
    complex(kind=CMPLDP),allocatable, dimension(:,:) :: chgc
    real(kind=DP) :: ehar
    integer :: is,ik,i,it
    integer :: ist,ip
    integer :: ig
    integer :: nfftcd,ierr
    integer :: id_sname = -1,id_sname2=-1

    call tstatc0_begin('m_ESlhxc_potential ',id_sname,1)
    vlhxc_l = 0.d0
    ist = ista_kngp
    if(ist == 1) ist = 2
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       nfftcd = fft_box_size_CD(1,0)*fft_box_size_CD(2,0)*fft_box_size_CD(3,0)
       allocate(vhar(nfftcd));vhar=(0.d0,0.d0)
!       allocate(chgc(iend_kngp-ista_kngp+1,nspin));chgc=(0.d0,0.d0)
       allocate(chgc(kgp,nspin));chgc=(0.d0,0.d0)
       if(kimg==1)then
          do ig=ista_kngp,iend_kngp
!             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),0.d0)
             chgc(ig,1:nspin) = dcmplx(chg(ig,1,1:nspin),0.d0)
          enddo
       else
          do ig=ista_kngp,iend_kngp
!             chgc(ig-ista_kngp+1,1:nspin) = dcmplx(chg(ig,1,1:nspin),chg(ig,2,1:nspin))
             chgc(ig,1:nspin) = dcmplx(chg(ig,1,1:nspin),chg(ig,2,1:nspin))
          enddo
       endif
       call mpi_allreduce(mpi_in_place,chgc,kgp*nspin,mpi_double_complex,mpi_sum,mpi_comm_group,ierr)
       call tstatc0_begin('esm_hartree ',id_sname2,1)
       call esm_hartree(chgc,ehar,vhar)
       call tstatc0_end(id_sname2)
       vhar(:) = 0.5d0*vhar(:) !Ry -> Ha
       deallocate(chgc)
    endif
#endif
    do is = 1, nspin
       do ik = 1, kimg
          if(mype==0) vlhxc_l(1,ik,is)   = vxc(1,ik,is)
          if(mype==0 .and. sw_external_potential==ON) then
             vlhxc_l(1,ik,is) = vxc(1,ik,is) + espot_g(1,ik,is)
          end if
#ifdef ENABLE_ESM_PACK
          if(nspin == 1.and.sw_esm==OFF) then
#else
          if(nspin == 1) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*chg(i,ik,is)/gr_l(i)**2
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) &
                        & +PAI4*chg(i,ik,is)/gr_l(i)**2
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + chg(i,ik,is)*screening%phik(i)
                end if
             end do
#ifdef ENABLE_ESM_PACK
          else if(nspin == 2.and.sw_esm==OFF) then
#else
          else if(nspin == 2) then
#endif
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) &
                     & +PAI4*(chg(i,ik,UP)+chg(i,ik,DOWN))/gr_l(i)**2
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) &
                        & +PAI4*(chg(i,ik,UP)+chg(i,ik,DOWN))/gr_l(i)**2
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + (chg(i,ik,UP)+chg(i,ik,DOWN))*screening%phik(i)
                end if
             end do
#ifdef ENABLE_ESM_PACK
          else if (sw_esm == ON)then
             do i = ist, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vxc(i,ik,is) 
                if(sw_external_potential==ON) then
                   vlhxc_l(i,ik,is) = vxc(i,ik,is) + espot_g(i,ik,is) 
                end if
                if(sw_screening_correction==ON) then
                   vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                        + chg(i,ik,is)*screening%phik(i)
                end if
             end do
#endif
          endif
          do it    = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) &
                     & = vlhxc_l(i,ik,is)+psc_l(i,it)*zfm3_l(i,it,ik)
                if(sw_screening_correction==ON) then
                  vlhxc_l(i,ik,is) &
                       & = vlhxc_l(i,ik,is) - ival(it)*screening%phik(i)/univol*zfm3_l(i,it,ik)
                end if
             end do
          end do
#ifdef ENABLE_ESM_PACK
          if(sw_esm==ON)then
             if(ik==1)then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,1,is) = vlhxc_l(i,1,is)+dble(vhar(igfp_l(i)))+dble(vloc_esm(igfp_l(i)))
                enddo
             else if(ik==2) then
                do i=ista_kngp,iend_kngp
                   vlhxc_l(i,2,is) = vlhxc_l(i,2,is)+aimag(vhar(igfp_l(i)))+aimag(vloc_esm(igfp_l(i)))
                enddo
             endif
          endif
#endif
       end do
    end do
#ifdef ENABLE_ESM_PACK
    if(sw_esm==ON) then
       deallocate(vhar)
    endif
#endif
    if(sw_dipole_correction==ON) then
       call m_Dipole_calc(nfout)
       call m_Dipole_potential(nfout,chg)
       do is = 1, nspin
          do ik = 1, kimg
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) + vdip_l(i,ik) + vext_l(i,ik)
             end do
          end do
       end do
    end if

! === POSITRON SCF === 2015/11/28
    if ( sw_positron /= OFF ) then
       if ( positron_method == Positron_GGGC ) then
          if ( nspin == 2 ) stop "UUU"
          do is = 1, nspin
             do ik = 1, kimg
                if(nspin == 1) then
                   do i = ist, iend_kngp  !for mpi
                      vlhxc_l(i,ik,is) = vlhxc_l(i,ik,is) &
                           &             -PAI4*pchg_l(i,ik)/gr_l(i)**2
                   end do
                end if
             end do
          end do
       end if
    endif
! ============== 2015/11/28

    if(iprivlhxcq >= 2) call m_ESlhxc_wd_vlhxc(nfout)
    call tstatc0_end(id_sname)
  end subroutine m_ESlhxc_potential

! ================================ addd by K. Tagami ================= 11.0
  subroutine m_ESlhxc_potential_noncl(nfout,chg,vxc)
    integer, intent(in)       :: nfout
    real(kind=DP), intent(in) :: chg(ista_kngp:iend_kngp,kimg,ndim_magmom)
    real(kind=DP), intent(in) :: vxc(ista_kngp:iend_kngp,kimg,ndim_magmom)

    integer :: is,ik,i,it
    integer :: ist
    integer :: id_sname = -1

    call tstatc0_begin('m_ESlhxc_potential_noncl ',id_sname)
    vlhxc_l = 0.d0

!    goto 200

!    goto 120                ! neglect vxc part

! *********** Vxc part *******************
    do is = 1, ndim_magmom
      do ik = 1, kimg
         do i = ista_kngp, iend_kngp              !for mpi
            vlhxc_l(i,ik,is) = vxc(i,ik,is)
         End do
      End do
    End do

120 continue
!    goto 200
!    goto 300

! ***********  Hartree part *************

    ist = ista_kngp
    if(ist == 1) ist = 2
    Do ik = 1, kimg
       do i = ist, iend_kngp  !for mpi
          vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
               &           +PAI4* chg(i,ik,1) /gr_l(i)**2
       end do
    End do
!--- screening correction ----
    if (sw_screening_correction==ON) then
       Do ik = 1, kimg
          do i = ist, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                  &           + chg(i,ik,1) *screening%phik(i)
          end do
       End do
    endif

200 continue
! *********** local pot *****************
    Do ik = 1, kimg
       do it = 1,ntyp
          do i = ista_kngp, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                  &           + psc_l(i,it)*zfm3_l(i,it,ik)
          end do
       end do
    end do
!--- screening correction ----
    if (sw_screening_correction==ON) then
       Do ik = 1, kimg
          do it = 1,ntyp
             do i = ista_kngp, iend_kngp  !for mpi
                vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) &
                     &          -ival(it) *screening%phik(i) /univol &
                     &                    *zfm3_l(i,it,ik)
             end do
          end do
       end do
    endif

300 continue

! --------------------------- The followings are uncertain .... ----
    if(sw_dipole_correction==ON) then
       call m_Dipole_calc(nfout)
       call m_Dipole_potential(nfout,chg)

       do ik = 1, kimg
          do i = ista_kngp, iend_kngp  !for mpi
             vlhxc_l(i,ik,1) = vlhxc_l(i,ik,1) + vdip_l(i,ik) + vext_l(i,ik)
          end do
       end do
    end if
! =---------------------------------------------------------------
    if(iprivlhxcq >= 2) call m_ESlhxc_wd_vlhxc_noncl(nfout)

    call tstatc0_end(id_sname)

  end subroutine m_ESlhxc_potential_noncl
! ========================================================================= 11.0

  subroutine m_ESlhxc_wd_vlhxc(nfout)

    integer, intent(in) :: nfout
    integer :: ispin, i, is, ie, ri
    is = ista_kngp
    ie = min(is+20, iend_kngp)
    do ispin = 1, nspin
       if(nspin == 2) write(nfout,'(" !lhxc ispin = ",i5)') ispin
       write(nfout,'(" vlhxc_l")')
       do ri = 1, kimg
          if(kimg == 1 .and. ri == 1) write(nfout,*) '       real part'
          if(ri == 2)                 write(nfout,*) '       imaginary part'
          write(nfout,'(" ",4d20.12)') (vlhxc_l(i,ri,ispin),i=is,ie) ! MPI
       end do
    end do
  end subroutine m_ESlhxc_wd_vlhxc

! ========================= added by K. Tagami ==================== 11.0
  subroutine m_ESlhxc_wd_vlhxc_noncl(nfout)
    integer, intent(in) :: nfout
    integer :: ispin, i, is, ie, ri

    is = ista_kngp
    ie = min(is+20, iend_kngp)

    do ispin = 1, ndim_magmom
       if(nspin == 2) write(nfout,'(" !lhxc ispin = ",i5)') ispin
       write(nfout,'(" vlhxc_l")')
       do ri = 1, kimg
          if(kimg == 1 .and. ri == 1) write(nfout,*) '       real part'
          if(ri == 2)                 write(nfout,*) '       imaginary part'
          write(nfout,'(" ",4d20.12)') (vlhxc_l(i,ri,ispin),i=is,ie) ! MPI
       end do
    end do

  end subroutine m_ESlhxc_wd_vlhxc_noncl
! ================================================================= 11.0


end module m_ES_LHXC

!=======================================================================
!
!  SOFTWARE NAME : PHASE (ver. 7.01)
!
!  SUBROUINE: Renewal_of_Hubbard_Potential
!
!  AUTHOR(S): T. Yamamoto   May/08/2005
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
! ==========================
!     patch 0.1 by K. Tagami @adv    2009/04/21
!
!     patch 0.1 : commented out an if sentence for band calculation with DFT+U
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Renewal_of_Hubbard_Potential()
! $Id: Renewal_of_Hubbard_Potential.f90 376 2014-06-17 07:48:31Z jkoga $
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_add_dhub_to_vlhxcQ
  use m_Files,               only : nfout
  use m_Hubbard,             only : m_Hubbard_Potential
  use m_Control_Parameters,  only : icond
  use m_Const_Parameters,    only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION

! ================================== K. Tagami ================== 5.0
  use m_Hubbard,             only : m_Hubbard_Potential2
! =============================================================== 5.0

! ============================ added by K. Tagami ================ 11.0
  use m_Control_Parameters,   only : noncol
  use m_ES_NonCollinear,      only : m_ES_set_Mat_dion_scr_noncl
  use m_Electronic_Structure,  only : vlhxcQ, dhub_aimag
  use m_Hubbard,             only : m_Hubbard_Potential2_noncl, &
       &                            m_Hubbard_Potential3_noncl
! ===================================================================== 11.0


  implicit none
 
! =========================== Modified by K. Tagami ============= 0.1
!!!  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return
! ==============================================================

  
! =================================== modifed by K. Tagami ============ 11.0
!  call m_Hubbard_Potential2(nfout)       ! -> dhub

  if ( noncol ) then
!!!!!!!     call m_Hubbard_Potential2_noncl(nfout)    
     call m_Hubbard_Potential3_noncl(nfout)    
  else
     call m_Hubbard_Potential2(nfout)       ! -> dhub
  endif
! ====================================================================== 11.0

  call m_ESiVQ_add_dhub_to_vlhxcQ(nfout)! vlhxcQ = vlhxcQ + dhub
  
! ================================= added by K. Tagami ================ 11.0
  if ( noncol ) then
     call m_ES_set_Mat_dion_scr_noncl( VlhxcQ, dhub_aimag )
  endif
! ===================================================================== 11.0

end subroutine Renewal_of_Hubbard_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 604 $)
!
!  SUBROUINE: Renewal_of_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!


subroutine Renewal_of_Potential()
! $Id: Renewal_of_Potential.F90 604 2020-04-09 05:52:05Z jkoga $
  use m_Charge_Density,      only : chgq_l 
  use m_Const_Parameters,    only : Valence_plus_PC_Charge, VXC_AND_EXC &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ON, OFF
  use m_Control_Parameters,  only : nspin, af, kimg, icond, ekmode
  use m_Electronic_Structure,only : vlhxc_l,  vlhxcQ
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_ES_LHXC,             only : m_ESlhxc_potential_3D
  use m_ES_Mag_Constraint,    only : m_ES_add_MagConstraintPot_chgql, &
       &                             m_ES_add_MagConstraintPot_hsr
  use m_Files,               only : nfout
  use m_PAW_Hartree,         only : m_PAWH_get_dion_hartree
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential &
                                  , m_PAW_XC_get_dion_vxc &
                                  , m_PAW_XC_allocation, m_PAW_XC_deallocation
! === DEBUG to make 3D_Parallel. by tkato 2011/07/18 ===========================
!                                 , m_PAW_XC_cal_potential_sym &
! ==============================================================================
  use m_PseudoPotential,     only : m_PP_get_dion_paw,flg_symmtry, flg_paw
  use m_XC_Potential,        only : vxc_l         &
 &                                , m_XC_cal_potential_3D
! === DEBUG by tkato 2011/10/05 ================================================
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential_sphex2
  use m_PAW_ChargeDensity,   only : calcGaussLegendreIntegration &
                                   ,calcSphericalHarmonicsExpansion
!===============================================================================
  use m_Crystal_Structure,   only : sw_magnetic_constraint

  use m_Control_Parameters,  only : sw_opencore, nspin
  use m_PS_Opencore,  only : m_PS_set_mag_opencore_pol

  implicit none

  if ( sw_opencore == ON .and. nspin == 2 ) then
     call m_PS_set_mag_opencore_pol
  endif

  call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)

! === DEBUG by tkato 2011/10/05 ================================================
! if(flg_paw) then
!===============================================================================

! === DEBUG by tkato 2011/10/05 ================================================
!    call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)

  call m_PAW_XC_allocation(nfout)
  if(calcSphericalHarmonicsExpansion) then
     call m_PAW_XC_cal_potential_sphex2(nfout,VXC_AND_EXC)
  end if

  if(calcGaussLegendreIntegration)then
     call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
  end if
#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif
! ==============================================================================

! === DEBUG by tkato 2011/10/05 ================================================
  if(flg_paw) then
!===============================================================================
     call m_PAW_XC_get_dion_vxc(nfout)
     !call m_PAW_XC_get_dion_vxc_dbg(nfout)

  endif

  call m_PAW_XC_deallocation(nfout)

  call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l

! ================================ added by K. Tagami ============== 11.0&13.0U
!
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_chgql
  endif
!
! ================================================================= 11.0&13.0U

  call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ

  if(flg_paw)then
     call m_PAWH_get_dion_hartree(nfout)
     call m_PP_get_dion_paw(nfout)
  endif

! ================================ added by K. Tagami ============== 11.0&13.0U
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_hsr
  endif
! ================================================================= 11.0&13.0U
end subroutine Renewal_of_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 604 $)
!
!  SUBROUINE: Renewal_of_Potential
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Renewal_of_Potential()
! $Id: Renewal_of_Potential.F90 604 2020-04-09 05:52:05Z jkoga $
  use m_ES_Intgr_VlhxcQlm,   only : m_ESiVQ_integrate_VlhxcQlm
  use m_ES_LHXC,             only : m_ESlhxc_potential
  use m_Charge_Density,      only : chgq_l
  use m_XC_Potential,        only : m_XC_cal_potential, vxc_l
  use m_Control_Parameters,  only : icond
  use m_Const_Parameters,    only : Valence_plus_PC_Charge, VXC_AND_EXC &
       &                          , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                          , ON
  use m_Files,               only : nfout
  use m_PAW_Hartree,         only : m_PAWH_get_dion_hartree
  use m_PAW_XC_Potential,    only : m_PAW_XC_cal_potential &
                                    ,m_PAW_XC_cal_potential_sphex2 &
                                    ,m_PAW_XC_get_dion_vxc
  use m_PAW_ChargeDensity,   only : calcGaussLegendreIntegration &
                                    ,calcSphericalHarmonicsExpansion
  use m_PseudoPotential,     only : m_PP_get_dion_paw,flg_symmtry, flg_paw

! ================================= added by K. Tagami =============== 11.0&13.0U
  use m_Control_Parameters,   only : noncol
  use m_Electronic_Structure,  only : vlhxcQ,vlhxc_l
  use m_Parallelization,       only : ista_kngp,iend_kngp
  use m_ES_NonCollinear,      only : m_ES_set_Mat_dion_scr_noncl, &
       &                             m_ES_update_Mat_dion0_noncl
  use m_ES_LHXC,              only : m_ESlhxc_potential_noncl
!
  use m_ES_Mag_Constraint,    only : m_ES_add_MagConstraintPot_chgql, &
       &                             m_ES_add_MagConstraintPot_hsr
  use m_PAW_XC_Potential,    only : m_PAW_XC_get_dion_vxc_noncl, &
       &                             m_PAW_XC_get_dion_vxc_noncl2, &
       &                             m_PAW_XC_get_dion_vxc_noncl3
  use m_PseudoPotential,     only : m_PP_get_dion_paw_noncl
  use m_IterationNumbers,    only : iteration_electronic
  use m_Crystal_Structure,   only : level_of_projection_paw_charge,&
       &                            sw_magnetic_constraint
! ==================================================================== 11.0&13.0U

! ================================= added by K. Tagami =============== 11.0
  use m_Control_Parameters,   only : SpinOrbit_mode, ekmode, sw_hubbard
  use m_SpinOrbit_Potential,  only : m_SO_set_Dsoc_potential2
  use m_Const_Parameters,    only : ByPawPot, ON, OFF
  use m_SpinOrbit_RadInt,    only : m_SO_calc_SOC_strength_pawpot
! ==================================================================== 11.0

  use m_Control_Parameters,  only : sw_opencore, nspin
  use m_PS_Opencore,  only : m_PS_set_mag_opencore_pol

  implicit none

!!$  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return

  if ( sw_opencore == ON .and. nspin == 2 ) then
     call m_PS_set_mag_opencore_pol
  endif

  call m_XC_cal_potential(nfout,Valence_plus_PC_Charge,chgq_l,VXC_AND_EXC)
                                              ! (xcfft) -> vxc_l
! ====================== added by K. Tagami ================= 11.0
  if ( noncol ) then
     if ( ekmode==OFF .and. iteration_electronic < 1 ) goto 100
  endif
! ========================================================== 11.0

  if(calcSphericalHarmonicsExpansion) then
    call m_PAW_XC_cal_potential_sphex2(nfout,VXC_AND_EXC)
#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif
!    call m_PAW_XC_cal_potential_sphex3(nfout,VXC_AND_EXC)
  end if
  if(calcGaussLegendreIntegration)then
!!!$  if(flg_paw) then
     call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC,flg_symmtry)
!!!$  if(flg_symmtry) then
!!!$    call m_PAW_XC_cal_potential_sym(nfout,VXC_AND_EXC)
!!!$  else
!!!$    call m_PAW_XC_cal_potential(nfout,VXC_AND_EXC)
!!!$  end if
  end if

! ============================= modified by K. Tagami ============= 11.0
!  if(flg_paw) call m_PAW_XC_get_dion_vxc(nfout)
  if (flg_paw) then

     if ( noncol ) then
        select case(level_of_projection_paw_charge)
        case (1)
           call m_PAW_XC_get_dion_vxc_noncl(nfout)
        case (2)
           call m_PAW_XC_get_dion_vxc_noncl2(nfout)
        case (3)
           call m_PAW_XC_get_dion_vxc_noncl3(nfout)
        end select

     else
        call m_PAW_XC_get_dion_vxc(nfout)
     endif
  endif
! ================================================================= 11.0

! =================== added by K. Tagami ================== 11.0
100 continue
! ========================================================= 11.0

#ifdef _MEMORY_CONSUMPTION_CHECK_
     call memsize(nfout)
#endif

!! if(flg_paw) call m_PAW_XC_get_dion_vxc(nfout)
!! call m_PAW_XC_get_dion_vxc_dbg(nfout)

! ================================ modified by K. Tagami ============== 11.0
!!  call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l

  if ( noncol ) then
     call m_ESlhxc_potential_noncl(nfout,chgq_l,vxc_l)
  else
     call m_ESlhxc_potential(nfout,chgq_l,vxc_l) ! (stlhxc) -> vlhxc_l
  endif
! ====================================================================== 11.0

! ================================ added by K. Tagami ============== 11.0&13.0U
!
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_chgql
  endif
!
! ================================================================= 11.0&13.0U

  call m_ESiVQ_integrate_VlhxcQlm(nfout) ! (lclchh) -> vlhxcQ

! ======================== modified by K. Tagami =============== 11.0
!  if(flg_paw)then
!     call m_PAWH_get_dion_hartree(nfout)
!     call m_PP_get_dion_paw(nfout)
!  endif

  if (flg_paw) then
     if ( noncol ) then
        if ( iteration_electronic >= 1 .or. ekmode == ON ) then
           call m_PAWH_get_dion_hartree(nfout)
           call m_PP_get_dion_paw_noncl(nfout)

           if ( SpinOrbit_Mode == ByPawPot ) then
              call m_SO_calc_SOC_strength_pawpot
              call m_SO_set_Dsoc_potential2
           endif
        endif

     else
        call m_PAWH_get_dion_hartree(nfout)
        call m_PP_get_dion_paw(nfout)
     endif
  endif
! ============================================================ 11.0

! ================================ added by K. Tagami ============== 11.0&13.0U
  if ( sw_magnetic_constraint == ON .and. ekmode == OFF ) then
     call m_ES_add_MagConstraintPot_hsr
  endif
! ================================================================= 11.0&13.0U

! ================================= added by K. Tagami ================ 11.0
  if ( noncol ) then
     if ( flg_paw ) then
        if ( ekmode==ON .or. iteration_electronic >= 1 ) then 
           call m_ES_update_Mat_dion0_noncl
        endif
     endif
     if ( sw_hubbard == OFF ) call m_ES_set_Mat_dion_scr_noncl( VlhxcQ )
  endif
! ===================================================================== 11.0

end subroutine Renewal_of_Potential

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 614 $)
!
!  SUBROUINE:  MDiterationNumber_Setting, MDiterationNumber_Setting_ep,
!             IterationNumber_Setting, IterationNumber_Setting_g,
!             KpointNumber_Setting, KpointNumber_Setting2
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May 2004
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: IterationNumbers_Setting.f90 614 2020-05-07 03:24:24Z jkoga $
subroutine MDiterationNumber_Setting
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &, m_Iter_electronic_reset
  use m_Control_Parameters, only : m_CtrlP_reset_dtim_1Dsearch
  implicit none

  call m_CtrlP_reset_dtim_1Dsearch()
  call m_Iter_mdIterN_increment
  call m_Iter_electronic_reset
end subroutine MDiterationNumber_Setting

subroutine SCDFTiterationNumber_Setting
  use m_IterationNumbers,   only : m_Iter_scdftIterN_increment &
       &, m_Iter_electronic_reset, m_Iter_reset_iter_ionic
  use m_Control_Parameters, only : m_CtrlP_reset_dtim_1Dsearch, m_CtrlP_reset_iconvergence
  implicit none

  call m_CtrlP_reset_dtim_1Dsearch()
  call m_Iter_scdftIterN_increment
  call m_Iter_electronic_reset
  call m_Iter_reset_iter_ionic()
  call m_CtrlP_reset_iconvergence()
end subroutine SCDFTiterationNumber_Setting

subroutine MDiterationNumber_Setting2
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &, m_Iter_electronic_reset,iteration_electronic,m_Iter_reset_iter_ionic &
       &, m_Iter_unitcell_increment &
       &, m_Iter_stress_correction_incre
  use m_Control_Parameters, only : m_CtrlP_reset_dtim_1Dsearch, sw_optimize_lattice &
       &, m_CtrlP_reset_iconvergence,imdalg, sw_stress_correction
  use m_Const_Parameters, only : ON, PT_CONTROL, P_CONTROL
  use m_Stress, only : m_Stress_in_correction, m_Stress_correction
  use m_Files, only : nfout
  implicit none
  logical :: Rightafter_stress_correction
  if(sw_optimize_lattice==ON .or. imdalg == PT_CONTROL .or. imdalg == P_CONTROL)then
     call m_Iter_electronic_reset
     if(sw_optimize_lattice == ON) call m_Iter_reset_iter_ionic()
     if(.not.m_Stress_in_correction(2)) call m_Iter_unitcell_increment()
     call m_CtrlP_reset_iconvergence()
  endif
end subroutine MDiterationNumber_Setting2

logical function Rightafter_stress_correction()
  use m_IterationNumbers, only  : iteration_stress_correction
  implicit none
  Rightafter_stress_correction = iteration_stress_correction == 4
end function

subroutine MDiterationNumber_Setting_pre
  use m_IterationNumbers,   only : m_Iter_electronic_reset, m_Iter_stress_correction_incre
  use m_Control_Parameters, only : m_CtrlP_reset_iconvergence, sw_stress_correction
  use m_Const_Parameters, only : ON
  use m_Stress, only : m_Stress_in_correction, m_Stress_correction
  use m_Files, only : nfout
  implicit none
  if(sw_stress_correction == ON .and. m_Stress_in_correction(4)) then
     call m_Stress_correction(nfout)
     call m_Iter_electronic_reset
     call m_Iter_stress_correction_incre()
     call m_CtrlP_reset_iconvergence()
  endif
end subroutine MDiterationNumber_Setting_pre

subroutine MDiterationNumber_Setting3
  use m_Const_Parameters,   only : DRIVER_URAMP
  use m_Control_Parameters, only : driver
  use m_IterationNumbers,   only : m_Iter_electronic_reset,m_Iter_reset_iter_ionic &
       &, m_Iter_uramp_increment
  use m_Control_Parameters, only : driver, m_CtrlP_reset_iconvergence
  implicit none
  if(driver == DRIVER_URAMP)then
     call m_Iter_electronic_reset
     call m_Iter_reset_iter_ionic()
     call m_Iter_uramp_increment()
     call m_CtrlP_reset_iconvergence()
  endif
end subroutine MDiterationNumber_Setting3

subroutine MDiterationNumber_Setting_ep
  use m_IterationNumbers,   only : m_Iter_mdIterN_increment&
       &                         , m_Iter_total_increment
  implicit none
  call m_Iter_mdIterN_increment()
  call m_Iter_total_increment()
end subroutine MDiterationNumber_Setting_ep

subroutine IterationNumber_Setting
  use m_Control_Parameters,only: icond, ipritiming0&
       &                       , iprijobstatus, jobstatus_series, jobstatus_format, driver
  use m_IterationNumbers, only : m_Iter_electronic_incre &
       &                       , m_Iter_total_increment &
       &                       , iteration, first_iteration_of_this_job &
       &                       , iteration_electronic, iteration_ionic &
       &                       , iteration_unit_cell, iteration_uramp, iteration_scdft
  use m_Timing,           only : tstatc_wd, tstatc_wd0, tstatc_init, tstatc_iter &
       &                       , m_Timing_wd_status
  use m_Const_Parameters, only : INITIAL, CONTINUATION &
       &                       , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                       , START, ITERATIVE, ON, OFF, DRIVER_URAMP
  use m_Files,            only : nfstatus,nfout &
       &                       , m_Files_open_nfstatus &
       &                       , m_Files_close_nfstatus &
       &                       , m_Files_skiptoend
  implicit none
  integer :: it, status_wdmode
  logical :: unitcell_can_change,Uramping,isSCDFT

  call tstatc_iter(iteration, first_iteration_of_this_job)
  it = iteration
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) it = iteration_electronic
  if(iteration == first_iteration_of_this_job) then
     call tstatc_wd0
     call flush(nfout)
  else
     if(ipritiming0 >= 1) call tstatc_wd(it)
  end if
  call tstatc_init

  if(iprijobstatus >=1 ) then
     call m_Files_open_nfstatus()
     if(iteration == first_iteration_of_this_job) then
        status_wdmode = START
     else
        status_wdmode = ITERATIVE
        if(jobstatus_series == ON) then
           call m_Files_skiptoend(nfstatus)
        else
        end if
     end if
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          & ,iteration,iteration_ionic,iteration_electronic)
     call m_Files_close_nfstatus()
  end if

  call m_Iter_electronic_incre()
  call m_Iter_total_increment()

  if(iprijobstatus >=1 ) then
     if(.not.unitcell_can_change()) then
       if(Uramping()) then
          write(nfout,'(" ---- iteration(total, uramp, ionic, electronic) = ",4i8," ----")') &
          & iteration, iteration_uramp, iteration_ionic, iteration_electronic
       else if (isSCDFT()) then
          write(nfout,'(" ---- iteration(total, scdft, ionic, electronic) = ",4i8," ----")') &
          & iteration, iteration_scdft, iteration_ionic, iteration_electronic
       else
          write(nfout,'(" ---- iteration(total, ionic, electronic) = ",3i8," ----")') &
          & iteration, iteration_ionic, iteration_electronic
       endif
     else
       write(nfout,'(" ---- iteration(total, unitcell, ionic, electronic) = ",4i8," ----")') &
          & iteration, iteration_unit_cell,iteration_ionic, iteration_electronic
     endif
  end if

end subroutine IterationNumber_Setting

subroutine IterationNumber_Setting_g()
  use m_Control_Parameters,only: icond,ipritiming0
  use m_IterationNumbers, only : iteration, first_iteration_of_this_job &
       &                       , iteration_electronic &
       &                       , m_Iter_total_increment &
       &                       , m_Iter_electronic_incre
  use m_Timing          , only : tstatc_wd, tstatc_wd0, tstatc_init, tstatc_iter
  use m_Const_Parameters, only : INITIAL, CONTINUATION, FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  implicit none
  integer :: it

  call tstatc_iter(iteration, first_iteration_of_this_job)
  it = iteration
  if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) it = iteration_electronic
  if(iteration_electronic == 0) then
     call tstatc_wd0()
  else
     if(ipritiming0 >= 1) call tstatc_wd(it)
  end if
  call tstatc_init()

  call m_Iter_electronic_incre()
  call m_Iter_total_increment()

end subroutine IterationNumber_Setting_g

subroutine IterationNumber_reset()
  use m_Timing          , only : tstatc_init
  use m_IterationNumbers, only : m_Iter_electronic_reset

  call m_Iter_electronic_reset()
  call tstatc_init()
end subroutine IterationNumber_reset

subroutine KpointNumber_Setting()
  use m_IterationNumbers, only : nk_in_the_process, first_kpoint_in_this_job &
       &                       , iteration_electronic, first_iteration_electronic &
       &                       , m_Iter_nk_incre &
       &                       , m_Iter_wd_electronic &
       &                       , m_Iter_wd_nk &
       &                       , m_Iter_electronic_reset &
       &                       , m_Iter_electronic_set
  use m_Control_Parameters,only: nspin, ipriekzaj, m_CtrlP_ntcnvg_reset
  use m_Files,only             : nfout

! ===================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor

  implicit none
! =========================================================== 11.0

  call m_CtrlP_ntcnvg_reset()
! =================================== modified by K. Tagami ======== 11.0
!!  call m_Iter_nk_incre(nspin)
  if ( noncol ) then
    call m_Iter_nk_incre(ndim_spinor)
  else
    call m_Iter_nk_incre(nspin)
  endif
! ================================================================== 11.0

  if(nk_in_the_process == first_kpoint_in_this_job) then
     call m_Iter_electronic_set()
  else
     call m_Iter_electronic_reset()
  end if
  if(ipriekzaj <= 0) call m_Iter_electronic_reset()
  call m_Iter_wd_nk(nfout)
  call m_Iter_wd_electronic(nfout)
  
end subroutine KpointNumber_Setting

subroutine KpointNumber_Setting2()
  use m_IterationNumbers, only : nk_in_the_process, first_kpoint_in_this_job &
       &                       , iteration_electronic, first_iteration_electronic &
       &                       , m_Iter_nk_incre2 &
       &                       , m_Iter_wd_electronic &
       &                       , m_Iter_wd_nk2 &
       &                       , m_Iter_electronic_reset &
       &                       , m_Iter_electronic_set
!!$       &                       , m_Iter_nkgroup_set
  use m_Control_Parameters,only: nspin, ipriekzaj, m_CtrlP_ntcnvg_reset
  use m_Kpoints, only          : kv3, kv3_ek
  use m_Files,only             : nfout

! ===================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor

  implicit none
! =========================================================== 11.0

  call m_CtrlP_ntcnvg_reset()

! ======================================= added by K. Tagami ============ 11.0
!  call m_Iter_nk_incre2(nspin,kv3_ek)
  if ( noncol ) then
    call m_Iter_nk_incre2( ndim_spinor,kv3_ek )
  else
    call m_Iter_nk_incre2( nspin,kv3_ek )
  endif
! ====================================================================== 11.0

  if(nk_in_the_process == first_kpoint_in_this_job) then
     call m_Iter_electronic_set()
!!$     call m_Iter_nkgroup_set(kv3)
  else
     call m_Iter_electronic_reset()
  end if
  if(ipriekzaj <= 0) call m_Iter_electronic_reset()
  call m_Iter_wd_nk2(nfout,kv3)
  call m_Iter_wd_electronic(nfout)
  
end subroutine KpointNumber_Setting2

!!$subroutine pIterationNumber_Setting()
!!$  use m_IterationNumbers, only : m_Iter_positron_set()
!!$  implicit none
!!$  call m_Iter_positron_set()
!!$end subroutine pIterationNumber_Setting

       subroutine trbakwy(n, a, nma0, z, nmz0, e, m0)
       implicit double precision(a-h,o-z),integer(i-n)
       real(8) :: a(*)
       real(8) :: z(*)
       real(8) :: e(*)

       real(8) , pointer :: w(:),d(:)
       real(8) , pointer :: v(:)
       real(8) , pointer :: tt(:), ss(:)

       real(8) :: d1, d2

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'
       include 'CSTAB.h'
*
       nma  = nma0
       nmz  = nmz0
       m    = MIN(nsm,m0)
       if ( m < 1 ) m = 1
*
       call datacast_init(2)
*
       na   = (n-1)/y_nnod+1
       na   = na  +MOD(na  -1,2)
       call CSTAB_get_optdim(nma,9,16*4,16*6,nm)
*
       allocate(
     &          d(1:n),
     &          v(1:MAX(nm*m,n)+n_columns),
     &          ss(1:na*m+nsm*nsm+n_columns),
     &          tt(1:na*m+nsm*nsm+n_columns),
     &          stat=i_stat)
       if(i_stat/=0)then
         if(TRD_inod==1)print*,"Memory allocation error."
         call mpi_abort(TRD_COMM_WORLD,1,ierr)
       endif
*
       d = 0.0D0
       v = 0.0D0
       ss = 0.0D0
       tt = 0.0D0
*
       call CSTAB_adjust_base(v(1), z(1), i_v)
       call CSTAB_adjust_base(ss(1), z(1), i_s)
       call CSTAB_adjust_base(tt(1), z(1), i_t)
          kx = (L1_WINDOW/4)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/4)
       i_v = i_v + kx*1
       i_s = i_s + kx*2
       i_t = i_t + kx*3
       call CSTAB_round_offset(i_v)
       call CSTAB_round_offset(i_s)
       call CSTAB_round_offset(i_t)
*
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d1 = MPI_Wtime()
!$OMP PARALLEL
       call trbakwy_body( n,
     $      a(1), nma,
     $      z(1), nmz,
     $      e(1), d(1), v(1+i_v), nm, m, ss(1+i_s), tt(1+i_t), na )
!$OMP END PARALLEL
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d2 = MPI_Wtime()
*
       deallocate( d )
       deallocate( v )
       deallocate( ss )
       deallocate( tt )
*
       call datacast_free(1)

       IF(TRD_inod==1)print*,"TRBAKWY",d2-d1
*
       return
       end
*
*
*
       subroutine trbakwy_body(n, a,nma, z,nmz, e,d,
     &             v,nm, m, ss,tt, nss)

       implicit double precision(a-h,o-z),integer(i-n)

       real(8) :: a(1:nma,*)
       real(8) :: z(1:nmz,*)
       real(8) :: e(1:n)
       real(8) :: d(1:n)

       real(8) :: v(1:nm,*)

       real(8) :: ss(*), tt(*)

       include 'mpif.h'
!$     include 'omp_lib.h'
       include 'trd.h'
*
       real(8) :: vv(nsx,nsm)
       integer :: nodes(0:nsm-1)

       real(8), pointer :: wk(:)

*
!$OMP MASTER
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d1=MPI_Wtime()
       dcom=0.0D0+00
       dx = 0.0; dy = 0.0

       lwk=((m-1)/y_nnod+1)*((n-1)/x_nnod+1)
       allocate(wk(lwk))
!$OMP END MASTER
*
       i_2 = loop_c_start(2, y_nnod,y_inod)
       i_3 = loop_c_end  (n, y_nnod,y_inod)
*
       nx = MIN(MOD(n-2+1,m)+2-1,n)
*
!$OMP MASTER
       d(1:n)=0.0
       do i_1=i_2,i_3
!          i = loop_c_l2g_depth(i_1, y_nnod,y_inod)
          i = (i_1-1)*y_nnod+y_inod
          l = i-1
!          x_root = loop_c_node(l, x_nnod,x_inod)
          x_root = MOD(l-1,x_nnod)+1
          if ( x_root == x_inod ) then
!          j_1 = loop_c_g2l_depth(l, x_nnod,x_inod)
             j_1  = (l-1)/x_nnod+1
             d(i) = a(j_1,i_1)
          end if
       end do! i_1
       call reduce_dbl( d, v, n, 1, TRD_COMM_WORLD )
       do i=2,n
          if ( e(i) == 0.0D+00 ) then
             s0 = 0.0
          else
             s0 = (1.0D0/d(i))/e(i)
          end if
          d(i) = s0
       end do! i
!$OMP END MASTER
*
       i_2 = loop_c_start(1, y_nnod,y_inod)
       i_3 = loop_c_end  (n, y_nnod,y_inod)

       do i=2,nx
*
!$OMP BARRIER
*
          if ( e(i) == 0.0 ) cycle
*
          j_2 = loop_c_start(1,   x_nnod,x_inod)
          j_3 = loop_c_end  (i-1, x_nnod,x_inod)
          i_4=MOD(i_3-i_2+1,4)+i_2
*
!$OMP MASTER
          ds=MPI_Wtime()
          nodes(0) = loop_c_node(i, y_nnod, y_inod)
          if ( nodes(0) == y_inod ) then
             i_1 = loop_c_g2l_depth(i, y_nnod, y_inod)
             do j_1=j_2,j_3
                v(j_1,1) = a(j_1,i_1)
             end do! j_1
          end if
          call bcast_dbl(v(j_2,1), j_3-j_2+1, nodes(0), y_COMM_WORLD)
          de=MPI_Wtime()
          dcom=dcom+(de-ds)
!$OMP END MASTER
*
!$OMP BARRIER
*
!$OMP MASTER
          if ( i_4 == i_2 + 1 ) then
             i_1 = i_2
             s0=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v(j_1,1)*z(j_1,i_1+0)
             end do! j_1
             ss(i_1+0)=s0
          end if
          if ( i_4 == i_2 + 2 ) then
             i_1 = i_2
             s0=0.0D+00
             s1=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v(j_1,1)*z(j_1,i_1+0)
                s1=s1+v(j_1,1)*z(j_1,i_1+1)
             end do! j_1
             ss(i_1+0)=s0
             ss(i_1+1)=s1
          end if
          if ( i_4 == i_2 + 3 ) then
             i_1 = i_2
             s0=0.0D+00
             s1=0.0D+00
             s2=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v(j_1,1)*z(j_1,i_1+0)
                s1=s1+v(j_1,1)*z(j_1,i_1+1)
                s2=s2+v(j_1,1)*z(j_1,i_1+2)
             end do! j_1
             ss(i_1+0)=s0
             ss(i_1+1)=s1
             ss(i_1+2)=s2
          end if
!$OMP END MASTER
!$OMP DO
          do i_1=i_4,i_3,4 !             3
             s0=0.0D+00
             s1=0.0D+00
             s2=0.0D+00
             s3=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v(j_1,1)*z(j_1,i_1+0)
                s1=s1+v(j_1,1)*z(j_1,i_1+1)
                s2=s2+v(j_1,1)*z(j_1,i_1+2)
                s3=s3+v(j_1,1)*z(j_1,i_1+3)
             end do! j_1
             ss(i_1+0)=s0
             ss(i_1+1)=s1
             ss(i_1+2)=s2
             ss(i_1+3)=s3
          end do! i_1
!$OMP END DO

!$OMP BARRIER

!$OMP MASTER
          ds=MPI_Wtime()
          call reduce_dbl(ss(i_2),tt, i_3-i_2+1, 1, x_COMM_WORLD)
          de=MPI_Wtime()
          dcom=dcom+(de-ds)

          s0 = d(i)
          do i_1=i_2,i_3
             ss(i_1) = ss(i_1) * s0
          end do! i_1
!$OMP END MASTER

!$OMP BARRIER

          j_2 = loop_c_start(1,   x_nnod,x_inod)
          j_3 = loop_c_end  (i-1, x_nnod,x_inod)
          i_4=MOD(i_3-i_2+1,4)+i_2

!$OMP MASTER
          if ( i_4 == i_2 + 1 ) then
             i_1 = i_2
             s0 = ss(i_1+0)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
             end do! j_1
          end if
          if ( i_4 == i_2 + 2 ) then
             i_1 = i_2
             s0 = ss(i_1+0)
             s1 = ss(i_1+1)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
             end do! j_1
          end if
          if ( i_4 == i_2 + 3 ) then
             i_1 = i_2
             s0 = ss(i_1+0)
             s1 = ss(i_1+1)
             s2 = ss(i_1+2)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
                z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v(j_1,1)
             end do! j_1
          end if
!$OMP END MASTER
!$OMP DO
          do i_1=i_4,i_3,4 !             3
             s0 = ss(i_1+0)
             s1 = ss(i_1+1)
             s2 = ss(i_1+2)
             s3 = ss(i_1+3)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v(j_1,1)
                z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v(j_1,1)
                z(j_1,i_1+3) = z(j_1,i_1+3) + s3 * v(j_1,1)
             end do! j_1
          end do! i_1
!$OMP ENDDO
*
!$OMP BARRIER
*
       end do
*
       do i=nx+1, n, m

*
!$OMP BARRIER
*
!$OMP MASTER
          ds=MPI_Wtime()

       call trbakwy_datacast(m, i, a, nma, v, nm, wk)

       IF(.FALSE.)THEN
        IF ( m > y_nnod ) THEN

          do j=0,m-1
             nodes(j) = loop_c_node(i+j, y_nnod, y_inod)
          enddo

          do iy=1,y_nnod

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, iy)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                if ( y_inod == iy ) then
                   do j_1=j_2,j_3
                      wk(k0+j_1) = a(j_1,i_1)
                   end do! k
                endif
                k0=k0+(j_3-j_2+1)
             endif
             enddo

             call bcast_dbl(wk, k0, iy, y_COMM_WORLD)

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, iy)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = wk(k0+j_1)
                end do! k
                k0=k0+(j_3-j_2+1)
                j_2 = loop_c_start(i+j,  x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = 0.0D+00
                end do
             endif
             enddo

          enddo

        ELSE

          do j=0,m-1
             nodes(j) = loop_c_node(i+j, y_nnod, y_inod)
             if ( nodes(j) == y_inod ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, y_inod)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = a(j_1,i_1)
                end do! k
                j_2 = loop_c_start(i+j,  x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
!CDIR NOVECTOR
                do j_1=j_2,j_3
                   v(j_1,j+1) = 0.0D+00
                end do
             end if
          end do
          j_2 = loop_c_start(1,     x_nnod,x_inod)
          j_3 = loop_c_end  (i+m-2, x_nnod,x_inod)
          do j=0,m-1
             call bcast_dbl(v(1,j+1), j_3-j_2+1,
     &                      nodes(j), y_COMM_WORLD)
          enddo

        ENDIF
       ENDIF

          de=MPI_Wtime()
          dcom=dcom+(de-ds)
!$OMP END MASTER
*
!$OMP BARRIER
*
          call trbakwy_body2(i_3, z, nmz,
     $         d, e, v, vv, nm, m, i, ss, tt, nss, dcom, dx, dy)
*
!$OMP BARRIER
*
       end do
*
!$OMP MASTER
       deallocate(wk)
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d2=MPI_Wtime()
       if ( 1 == TRD_inod ) then
          print*,"TRBAK=",(d2-d1)
          print*,"COMM=",dcom
          print*,"   ",(2d0*n*n*n)/(d2-d1)*1d-9,"GFLOPS"
          print*,"   ",(1d0*n*n*n)/(dx)*1d-9,"GFLOPS"
          print*,"   ",(1d0*n*n*n)/(dy)*1d-9,"GFLOPS"
       end if
!$OMP END MASTER
*
*
       return
       end subroutine

       subroutine trbakwy_datacast(m, i, a, nm, v, nv, wk)

       implicit NONE

       integer, intent(in)   :: m, i, nm, nv
       real(8), intent(in)   :: a(nm,*)
       real(8), intent(out)  :: wk(*)
       real(8), intent(out)  :: v(nv,*)
 
       include 'trd.h'

       integer :: j, iy, k0
       integer :: i_1
       integer :: j_1, j_2, j_3
       integer :: nodes(0:nsm-1)

       IF ( m > y_nnod ) THEN

          do j=0,m-1
             nodes(j) = loop_c_node(i+j, y_nnod, y_inod)
          enddo

          do iy=1,y_nnod

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, iy)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                if ( y_inod == iy ) then
                   do j_1=j_2,j_3
                      wk(k0+j_1) = a(j_1,i_1)
                   end do! k
                endif
                k0=k0+(j_3-j_2+1)
             endif
             enddo

             call bcast_dbl(wk, k0, iy, y_COMM_WORLD)

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, iy)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = wk(k0+j_1)
                end do! k
                k0=k0+(j_3-j_2+1)
                j_2 = loop_c_start(i+j,  x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = 0.0D+00
                end do
             endif
             enddo

          enddo

        ELSE

          do j=0,m-1
             nodes(j) = loop_c_node(i+j, y_nnod, y_inod)
             if ( nodes(j) == y_inod ) then
                i_1 = loop_c_g2l_depth(i+j, y_nnod, y_inod)
                j_2 = loop_c_start(1,    x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1,j+1) = a(j_1,i_1)
                end do! k
                j_2 = loop_c_start(i+j,  x_nnod,x_inod)
                j_3 = loop_c_end  (i+m-2,x_nnod,x_inod)
!CDIR NOVECTOR
                do j_1=j_2,j_3
                   v(j_1,j+1) = 0.0D+00
                end do
             end if
          end do
          j_2 = loop_c_start(1,     x_nnod,x_inod)
          j_3 = loop_c_end  (i+m-2, x_nnod,x_inod)
          do j=0,m-1
             call bcast_dbl(v(1,j+1), j_3-j_2+1,
     &                      nodes(j), y_COMM_WORLD)
          enddo

        ENDIF

      end subroutine

         subroutine eigen_sx(n, a, lda, w, z, ldz, m)
         implicit NONE
*-
         integer, intent(in)    :: n, lda, ldz, m
         real(8), intent(inout) :: a(lda,*), w(*), z(ldz,*)
         real(8), pointer       :: d(:), e(:), e2(:)
*-
         real(8)                :: hs0, hs1, s0, s1
         integer                :: m0, nb, nme
         integer                :: my_rank, world_size, INFO, ierr

         include 'mpif.h'
         include 'trd.h'
*-
!Kro
         call errset(320, 256, 256, 0, 0, 320)
         call errset(323, 256, 256, 0, 0, 323)
         hs0 = MPI_Wtime()
*-
         nme = ((n-1)/2+1)*2
         allocate(d(1:n), e(1:nme*2), e2(1:nme*2))
*-
#IFDEF PHASE
!        call datacast_init(2)
#ENDIF
         world_size = TRD_nnod
         my_rank    = TRD_inod-1
*-
         s0 = MPI_Wtime()

            call tred1(n, a(1,1), lda, d(1), e(1), nme, m)

         s1 = MPI_Wtime()

         if(my_rank==0)then
            print*,"TRD-BLK",n," ",s1-s0," ",
     &               1*dble(n)**3*4/3/(s1-s0)*1D-9,"GFLOPS"
            print*,"TRD-BLK-INFO",n," ",m
         endif
         call flush(6)
*-
         s0 = MPI_Wtime()

            e2(0*nme+1:0*nme+N-1) = e(0*nme+2:0*nme+N)
            e2(0*nme+N) = 0
            e2(1*nme+1:1*nme+N-2) = e(1*nme+3:1*nme+N)
            e2(1*nme+N-1) = 0
            e2(1*nme+N) = 0
            w(1:n)=d(1:n)

            call dcx(n, w(1), e2(1), nme, z(1,1), ldz, INFO)

         s1 = MPI_Wtime()

         if(my_rank==0)then
            print*,"D&C",s1-s0,"ERRCODE=",INFO
         endif
         call flush(6)
*-
         s0 = MPI_Wtime()

            m0 = 128
            nb = 1
            call trbakwy(n, a(1,1), lda, z(1,1), ldz,
     $                   e(1+nme), m0)

         s1 = MPI_Wtime()

         if(my_rank==0)then
             print*,"TRDBAK",n,s1-s0,2e-9*dble(n)**3/(s1-s0),"GFLOPS"
         endif
         call flush(6)
*-
         hs1 = MPI_Wtime()
*
         if(my_rank==0)then
            print*,"Total",hs1-hs0,10e-9*dble(n)**3/3/(hs1-hs0),"GFLOPS"
         endif
         call flush(6)
*-
#IFDEF PHASE
!        call datacast_free(0)
#ENDIF
         deallocate(d, e, e2)
*-
         end subroutine

module m_CD_Mag_Moment
! $Id: m_CD_Mag_Moment.f90 634 2020-12-22 12:17:00Z ktagami $
  use m_Control_Parameters,    only : noncol, ndim_magmom, kimg, iprimagmom, ON, OFF
  use m_Const_Parameters,     only : DP, PAI4, Bohr

  use m_Ionic_System,         only : ntyp, natm, ityp, pos, cps, &
       &                             magmom_local_now, iatomn, speciesname
  use m_Crystal_Structure,    only : rltv, altv

  use m_PlaneWaveBasisSet,    only : ngabc, kgp
  use m_Parallelization,      only : ista_kngp, iend_kngp, ierr, npes, mype, &
       &                             mpi_comm_group
  use m_PseudoPotential,      only : dl2p, ilmt

  use m_Charge_Density,       only : chgq_l, hsr

  use m_Files,                only : nfout

  use m_Crystal_Structure,   only : sw_magnetic_constraint
  use m_Control_Parameters,  only : sw_modified_TFW_functional, sw_opencore, &
       &                            sw_calc_extfnv_correction

! ==== KT_add ==== 2014/08/29, 2016/09/14
  use m_Const_Parameters,   only : CMPLDP
  use m_Control_Parameters,  only : ndim_spinor, ndim_chgpot, sw_use_add_proj, &
       &                            sw_use_contracted_psir, nspin, proj_attribute, &
       &                            num_projectors
  use m_PseudoPotential,   only : nlmt, ltp, mtp, taup, nlmt_add, ltp_add, mtp_add, &
       &                          ilmt_add, mmesh, radr, wos, nmesh, &
       &                          psir_val, lpsmax, nloc, itau, ntau, &
       &                          nlmta, nlmta_add, lmta, lmta_add
  use m_ES_Noncollinear,  only :  m_ES_set_Pauli_Matrix, m_ES_MagMom_To_DensMat_hsr
  use m_Charge_Density,       only : hsi, hsr_add, hsi_add
  use m_Parallelization,    only : ista_k
  use m_NonLocal_Potential, only : new_radr_and_wos
  use m_Orbital_QuantumNum,  only :  max_num_orb_index, num_orb_index_data, &
       &                             qnum_n_orb_index, qnum_l_orb_index, &
       &                             qnum_tau_orb_index
! ================ 2014/08/29, 2016/09/14

  implicit none

  include 'mpif.h'
!  integer istatus(mpi_status_size)

  integer :: sw_monitor_atomcharge = OFF

  real(kind=DP), allocatable :: rad_cov(:)
  real(kind=DP), allocatable :: RhoMag_on_atom(:,:)

  real(kind=DP) :: rad_cov_default(120)

! ==== KT_add ==== 2014/08/29
  real(kind=DP), allocatable :: product_psir_val(:,:,:,:)
! ================ 2014/08/29

contains
  
  subroutine m_CD_set_sw_monitor_atomcharge
    if ( noncol ) then
       sw_monitor_atomcharge = ON
    else
       if ( sw_magnetic_constraint == ON ) then
          sw_monitor_atomcharge = ON
       endif
    endif

    if ( sw_calc_extfnv_correction == ON ) sw_monitor_atomcharge = ON
    if ( sw_opencore == ON ) sw_monitor_atomcharge = ON
    if ( sw_modified_TFW_functional == ON ) sw_monitor_atomcharge = ON

    if ( npes > 1 ) then
       call mpi_bcast( iprimagmom, 1, mpi_integer, 0, mpi_comm_group, ierr )
    endif
    if ( iprimagmom >= 2 ) sw_monitor_atomcharge = ON

  end subroutine m_CD_set_sw_monitor_atomcharge

  subroutine m_CD_set_proj_radius
    integer :: i, it

    do i = 1, num_projectors
       it = proj_attribute(i)%ityp
       if ( it <= 0 ) cycle

       proj_attribute(i)%radius = rad_cov_default( nint(iatomn(it)) )
       proj_attribute(i)%radius_was_defined = .true.

       if ( mype == 0 ) then
          write(nfout,'(A,I5,A,F15.8)') "** The radius of ", i, &
               &         "-th projector is set to ", proj_attribute(i)%radius
       endif
    end do
  end subroutine m_CD_set_proj_radius

  subroutine m_CD_alloc_rad_cov
    if ( .not. allocated( rad_cov) ) then
       allocate( rad_cov(natm) ); rad_cov = 0.0d0
    endif
  end subroutine m_CD_alloc_rad_cov

  subroutine m_CD_set_rad_cov_default
    integer :: ia, it, inum

! -------------------
!  Ref. "Molecular Single-Bond Covalent Radii for Elements 1-118". 
!        Chemistry: A European Journal 15 (2009) 186.
! -------------------

    call set_table_rad_cov(   1,  32,  46, 133, 102,  85,  75,  71,  63,  64,  67 )
    call set_table_rad_cov(  11, 155, 139, 126, 116, 111, 103,  99,  96, 196, 171 )
    call set_table_rad_cov(  21, 148, 136, 134, 122, 119, 116, 111, 110, 112, 118 )
    call set_table_rad_cov(  31, 124, 124, 121, 116, 114, 117, 210, 185, 163, 154 )
    call set_table_rad_cov(  41, 147, 138, 128, 125, 125, 120, 128, 136, 142, 140 )
    call set_table_rad_cov(  51, 140, 136, 133, 131, 232, 196, 180, 163, 176, 174 )
    call set_table_rad_cov(  61, 173, 172, 168, 169, 168, 167, 166, 165, 164, 170 )
    call set_table_rad_cov(  71, 162, 152, 146, 137, 131, 129, 122, 123, 124, 133 )
    call set_table_rad_cov(  81, 144, 144, 151, 145, 147, 142, 223, 201, 186, 175 )
    call set_table_rad_cov(  91, 169, 170, 171, 172, 166, 166, 166, 168, 165, 167 )
    call set_table_rad_cov( 101, 173, 176, 161, 157, 149, 143, 141, 134, 129, 128 )
    call set_table_rad_cov( 111, 121, 122, 136, 143, 162, 175, 165, 157, 500, 500 )

    call convert_unit_to_bohr

  contains

    subroutine convert_unit_to_bohr
      rad_cov_default = rad_cov_default / 1.0D2 / Bohr  
                                 ! Note : original data is in the unit of pm.
    end subroutine convert_unit_to_bohr

    subroutine set_table_rad_cov( istart, d1, d2, d3, d4, d5, d6, d7, d8, d9, d10 )
      integer, intent(in) :: istart
      integer, intent(in) :: d1, d2, d3, d4, d5, d6, d7, d8, d9, d10

      rad_cov_default( istart    ) = dble(d1)
      rad_cov_default( istart +1 ) = dble(d2)
      rad_cov_default( istart +2 ) = dble(d3)
      rad_cov_default( istart +3 ) = dble(d4)
      rad_cov_default( istart +4 ) = dble(d5)
      rad_cov_default( istart +5 ) = dble(d6)
      rad_cov_default( istart +6 ) = dble(d7)
      rad_cov_default( istart +7 ) = dble(d8)
      rad_cov_default( istart +8 ) = dble(d9)
      rad_cov_default( istart +9 ) = dble(d10)
    end subroutine set_table_rad_cov

  end subroutine m_CD_set_rad_cov_default

  subroutine m_CD_alloc_RhoMag_on_atom
    if ( .not. allocated( RhoMag_on_atom) ) allocate( RhoMag_on_atom(natm,ndim_magmom) )
    RhoMag_on_atom = 0.0d0
  end subroutine m_CD_alloc_RhoMag_on_atom

  subroutine m_CD_set_rad_cov_now
    integer :: ia, ja, it1, it2, inum
    integer :: nx, ny, nz

    real(kind=DP) :: x1, y1, z1, dist
    real(kind=DP) :: c1, ctmp
    real(kind=DP), allocatable :: dist_min_among_atomtypes(:,:)

    logical, save :: First = .true.

    if ( First ) then
       Do ia=1, natm
          it1 = ityp(ia)
          inum = iatomn(it1)
          rad_cov(ia) = rad_cov_default(inum)
       End do
       First = .false.
    endif

    if ( .not. allocated(dist_min_among_atomtypes) ) then
       allocate( dist_min_among_atomtypes(ntyp,ntyp) )
    endif
    dist_min_among_atomtypes = 10.0d0

    Do ia=1, natm-1
       it1 = ityp(ia)
       Do ja =ia+1, natm
          it2 = ityp(ja)
!
          c1 = rad_cov(ia) + rad_cov(ja)

          Do nx=-1, 1
             Do ny=-1, 1
                Do nz=-1, 1
                   x1 = cps(ja,1) -cps(ia,1) +altv(1,1)*nx +altv(1,2)*ny +altv(1,3)*nz
                   y1 = cps(ja,2) -cps(ia,2) +altv(2,1)*nx +altv(2,2)*ny +altv(2,3)*nz
                   z1 = cps(ja,3) -cps(ia,3) +altv(3,1)*nx +altv(3,2)*ny +altv(3,3)*nz
!
                   dist = sqrt( x1**2 +y1**2 +z1**2 )
                   if ( dist < c1 ) then
                      ctmp = dist /c1
                      rad_cov(ia) = rad_cov(ia) *ctmp
                      rad_cov(ja) = rad_cov(ja) *ctmp
                   endif
                End do
             End do
          End do
       End do
    End Do

    if ( iprimagmom >= 3 ) then
       write(nfout,*) '! ------ info : Rad_cov ------ '
       write(nfout,*) '  atmo no.   rad_cov '
       Do ia=1, natm
          write(nfout,'(I7,F15.8)')   ia, rad_cov(ia)
       End do
       write(nfout,*) '! ---------------------------- '
    endif

  end subroutine m_CD_set_rad_cov_now

  subroutine m_CD_calc_ChgMagMom_in_sphere
    integer :: i, ia, is, it, ist
    real(kind=DP) :: rad1, fac1r, fac1i, fac2
    real(kind=DP) :: VecG(3), normG, normG3, gr, d1

    real(kind=DP), allocatable :: zfcos(:), zfsin(:)
    real(kind=DP), allocatable :: RhoMag_on_atom_mpi(:,:)

    RhoMag_on_atom = 0.0d0

    allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
    allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0

    Do ia=1, natm
       it = ityp(ia)
       rad1 = rad_cov(ia)

       call calc_phase2( natm, pos, ia, kgp, ngabc, ista_kngp, iend_kngp, &
            &            zfcos, zfsin )

       if ( ista_kngp == 1 ) then
          ist = 2
       else
          ist = ista_kngp
       endif

       Do i=ist, iend_kngp

          VecG(1) = rltv(1,1)*ngabc(i,1) +rltv(1,2)*ngabc(i,2) +rltv(1,3)*ngabc(i,3)
          VecG(2) = rltv(2,1)*ngabc(i,1) +rltv(2,2)*ngabc(i,2) +rltv(2,3)*ngabc(i,3)
          VecG(3) = rltv(3,1)*ngabc(i,1) +rltv(3,2)*ngabc(i,2) +rltv(3,3)*ngabc(i,3)
          
          normG = sqrt( VecG(1)**2 +VecG(2)**2 +VecG(3)**2 )
          normG3 = normG**3

          fac1r = zfcos(i); fac1i = zfsin(i)
!
          gr = normG *rad1
          fac2 = -gr *cos(gr) + sin(gr)
          fac2 = fac2 *PAI4 /normG3
!
          Do is=1, ndim_magmom
             if ( kimg == 1 ) then
                d1 = chgq_l(i,1,is)*fac1r
             else
                d1 = chgq_l(i,1,is)*fac1r -chgq_l(i,kimg,is)*fac1i
             endif
             RhoMag_on_atom(ia,is) = RhoMag_on_atom(ia,is) + d1 *fac2
          End do

       End do

       if ( mype == 0 ) then
          fac2 = PAI4 /3.0d0 *rad1**3
             
          Do is=1, ndim_magmom
             d1 = chgq_l(1,1,is)
             RhoMag_on_atom(ia,is) = RhoMag_on_atom(ia,is) + d1 *fac2
          End do
       endif
       
    End Do
!
    deallocate( zfcos, zfsin )

    if ( npes > 1 ) then
       allocate( RhoMag_on_atom_mpi(natm,ndim_magmom) ); RhoMag_on_atom_mpi = 0.0d0
       call mpi_allreduce( RhoMag_on_atom, RhoMag_on_atom_mpi, natm*ndim_magmom, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       RhoMag_on_atom = RhoMag_on_atom_mpi
       deallocate( RhoMag_on_atom_mpi )
    endif
    
  end subroutine m_CD_calc_ChgMagMom_in_sphere

  subroutine m_CD_print_ChgMagmom_on_atom( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it

    if ( iprimagmom < 2 ) return
    if ( mype /= 0 ) return

    write(nfout,*) &
         & '! ------------ Local Charge/Spin Moment (in sphere) at this scf step --- '

    if ( noncol ) then
       write(nfout,*) &
            & '    id      name          tot            mx             my             mz'
       Do ia=1, natm
          it = ityp(ia)
          write(nfout,'(I7,6X,A5,4F15.8)') ia, speciesname(it), &
               &                          RhoMag_on_atom(ia,1), &
               &                          RhoMag_on_atom(ia,2), &
               &                          RhoMag_on_atom(ia,3), &
               &                          RhoMag_on_atom(ia,4)
       End Do

    else
       if ( ndim_magmom == 1 ) then
          write(nfout,*) &
               & '    id      name          tot'
          Do ia=1, natm
             it = ityp(ia)
             write(nfout,'(I7,6X,A5,F15.8)') ia, speciesname(it), &
                  &                          RhoMag_on_atom(ia,1)
          End Do

       else if ( ndim_magmom == 2 ) then
          write(nfout,*) &
               & '    id      name          tot            mz'
          Do ia=1, natm
             it = ityp(ia)
             write(nfout,'(I7,6X,A5,2F15.8)') ia, speciesname(it), &
                  &                          RhoMag_on_atom(ia,1)+RhoMag_on_atom(ia,2),&
                  &                          RhoMag_on_atom(ia,1)-RhoMag_on_atom(ia,2)
          End Do
       endif

    endif

!    write(nfout,*) '! ---------------------------------------------'
    write(nfout,*)

  end subroutine m_CD_print_ChgMagmom_on_atom

! ------------------------------------------
  subroutine m_CD_estim_magmom_local( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it, lmt1, lmt2, is
    real(kind=DP) :: sum, fac

!--
    Do ia=1, natm
       it = ityp(ia)

       Do is=2, ndim_magmom
          sum = 0.0d0
          Do lmt1=1, ilmt(it)
             Do lmt2=lmt1, ilmt(it)
                fac=2.d0;if(lmt1.eq.lmt2) fac=1.d0
                sum = sum + fac *hsr( ia, lmt1, lmt2, is )*dl2p(lmt1,lmt2,1,it)
             End do
          End do
!
          magmom_local_now(ia,is-1) = sum
       End do
    End Do

  end subroutine m_CD_estim_magmom_local

! === KT_add === 2014/08/25
  subroutine m_CD_calc_SpinMagMom_method2
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

    if ( iprimagmom < 3 ) return

    call m_ES_set_Pauli_Matrix( PauliMatrix )

    call contrib_hardpart
    if ( sw_use_add_proj == ON ) call contrib_hardpart_add_proj

    call print_magmom

  contains

    subroutine contrib_hardpart
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP) :: sum, fac, spinmom(3)
!
      complex(kind=CMPLDP) :: z1
!
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
      allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )
!--
      Do ia=1, natm
         it = ityp(ia)

         spinmom = 0.0d0
         
         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor +is2
               
               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                     
                     if ( il1 /= il2 ) cycle
                     if ( im1 /= im2 ) cycle
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                     if ( sw_use_contracted_psir == ON ) then
                        z1 = z1 *product_psir_val( il1, it1, it2, it )
                     endif

                     spinmom(1) = spinmom(1) + z1 *PauliMatrix(2,is2,is1)
                     spinmom(2) = spinmom(2) + z1 *PauliMatrix(3,is2,is1)
                     spinmom(3) = spinmom(3) + z1 *PauliMatrix(4,is2,is1)
                  End do
               End Do
            End do
         End do
         magmom_local_now(ia,1) = spinmom(1)
         magmom_local_now(ia,2) = spinmom(2)
         magmom_local_now(ia,3) = spinmom(3)
      End Do
      
      deallocate( hsr_ssrep ); deallocate( hsi_ssrep )
    end subroutine contrib_hardpart

    subroutine contrib_hardpart_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2
      real(kind=DP) :: sum, fac, spinmom(3)
!
      complex(kind=CMPLDP) :: z1
!
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
      allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsr_ssrep = 0.0d0
      allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); hsi_ssrep = 0.0d0

      call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
           &                           hsr_ssrep, hsi_ssrep )
!--
      Do ia=1, natm
         it = ityp(ia)

         spinmom = 0.0d0
         
         Do is1=1, ndim_spinor
            Do is2=1, ndim_spinor
               istmp = ( is1 -1 )*ndim_spinor +is2
               
               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1
                     
                     if ( il1 /= il2 ) cycle
                     if ( im1 /= im2 ) cycle
                     
                     z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                          &       hsi_ssrep(ia,lmt1,lmt2,istmp) )

                     spinmom(1) = spinmom(1) + z1 *PauliMatrix(2,is2,is1)
                     spinmom(2) = spinmom(2) + z1 *PauliMatrix(3,is2,is1)
                     spinmom(3) = spinmom(3) + z1 *PauliMatrix(4,is2,is1)
                  End do
               End Do
            End do
         End do
         magmom_local_now(ia,1) = magmom_local_now(ia,1) +spinmom(1)
         magmom_local_now(ia,2) = magmom_local_now(ia,2) +spinmom(2)
         magmom_local_now(ia,3) = magmom_local_now(ia,3) +spinmom(3)
      End Do
      
      deallocate( hsr_ssrep ); deallocate( hsi_ssrep )
    end subroutine contrib_hardpart_add_proj

    subroutine print_magmom
      integer :: ia, it

      write(nfout,*) &
           & '! ------------ Local Spin Moment (method2) at this scf step --- '
      write(nfout,*) &
           & '    id      name          mx             my             mz'
      Do ia=1, natm
         it = ityp(ia)
         write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
              &                         magmom_local_now(ia,1), &
              &                         magmom_local_now(ia,2), &
              &                         magmom_local_now(ia,3)
      End Do
      write(nfout,*)

    end subroutine print_magmom

  end subroutine m_CD_calc_SpinMagMom_method2
! =============== 2014/08/25

  subroutine m_CD_print_magmom_local( nfout )
    integer, intent(in) :: nfout

    integer :: ia, it

    if ( iprimagmom < 3 ) return

    write(nfout,*) &
         & '! ------------ Local Spin Moment (hard part) at this scf step --- '
    write(nfout,*) &
         & '    id      name          mx             my             mz'
    Do ia=1, natm
       it = ityp(ia)
       write(nfout,'(I7,6X,A5,3F15.8)') ia, speciesname(it), &
            &                         magmom_local_now(ia,1), &
            &                         magmom_local_now(ia,2), &
            &                         magmom_local_now(ia,3)
    End Do
    write(nfout,*)

  end subroutine m_CD_print_magmom_local

! ===== KT_add ===== 2014/08/29
  subroutine m_CD_calc_product_psir_val
    integer :: it, ik, ilmt1, il1, tau1, tau2, ir
    real(kind=DP) :: csum, factor, rcut
    real(kind=DP), allocatable :: tmp_fn(:)

    allocate( tmp_fn(mmesh) );  allocate( radr(mmesh) );  allocate( wos(mmesh) )

    Do it=1, ntyp
       ik = ista_k
       call new_radr_and_wos(ik,it)                 ! --> radr, wos

       rcut = rad_cov_default( nint(iatomn(it) ))  ! Revised according to a report from ASMS Co.ltd, 10 March 2016.

       Do il1=1, lpsmax(it)
!          if ( il1 == iloc(it) ) cycle

          Do tau1=1, itau(il1,it)
             tmp_fn = 0.0d0
             Do ir=1, nmesh(it)
                tmp_fn(ir) = psir_val(ir,il1,tau1,it) *exp( -radr(ir)/rcut)
             End do

             csum = 0.0d0
             Do ir=1, nmesh(it)
                csum = csum + wos(ir) *tmp_fn(ir)**2
             End do

             factor = 1.0d0 /sqrt(csum)

             psir_val(:,il1,tau1,it) = 0.0d0
             do ir = 1,nmesh(it)
                psir_val(ir,il1,tau1,it) = tmp_fn(ir) *factor
             end do
          End Do
       End Do
! ---
       Do il1=1, lpsmax(it)
          Do tau1=1, itau(il1,it)
             Do tau2=1, itau(il1,it)
                csum = 0.0d0
                Do ir=1, nmesh(it)
                   if ( radr(ir) > rcut ) exit    
                   csum = csum +wos(ir) *psir_val(ir,il1,tau1,it) &
                        &               *psir_val(ir,il1,tau2,it)
                End Do
                product_psir_val( il1, tau1, tau2, it ) = csum
             End do
          End do
       End Do
    End Do
!
    if ( mype == 0 .and. iprimagmom>2 ) then
       write(nfout,*) '!** product_psir_val'
       write(nfout,*) "   it     l    tau1  tau2     product"
       DO it=1, ntyp
          Do il1=1, lpsmax(it)
             Do tau1=1, itau(il1,it)
                Do tau2=1, itau(il1,it)
                   write(nfout,'(4I6,F15.8)') it, il1, tau1, tau2, &
                        &         product_psir_val( il1, tau1, tau2, it )
                End do
             End do
          End do
       End do
    end if

    call mpi_barrier( mpi_comm_group, ierr )
    deallocate(tmp_fn); deallocate(radr);  deallocate(wos)

  end subroutine m_CD_calc_product_psir_val

  subroutine m_CD_alloc_product_psir_val
    allocate( product_psir_val(nloc,ntau,ntau,ntyp)) 
    product_psir_val = 0.0d0
  end subroutine m_CD_alloc_product_psir_val

  subroutine m_CD_dealloc_product_psir_val
    if ( allocated( product_psir_val ) )  deallocate( product_psir_val )
  end subroutine m_CD_dealloc_product_psir_val
! ============ 2014/08/29

! ====== KT_add === 2014/09/01
  subroutine m_CD_orb_decomposed_chg_magmom
    complex(kind=CMPLDP) :: PauliMatrix( ndim_magmom, ndim_spinor, ndim_spinor )

    real(kind=DP), allocatable :: chg_magmom_orb_decomposed(:,:)
    real(kind=DP), allocatable :: chg_magmom_orb_decomposed_add(:,:)

    call m_ES_set_Pauli_Matrix( PauliMatrix )

    allocate( chg_magmom_orb_decomposed( nlmta, ndim_magmom ) )
    chg_magmom_orb_decomposed = 0.0d0
    if ( sw_use_add_proj == ON ) then
       allocate( chg_magmom_orb_decomposed_add( nlmta_add, ndim_magmom ) )
       chg_magmom_orb_decomposed_add = 0.0d0
    endif

    call contrib_hardpart
    if ( sw_use_add_proj == ON ) call contrib_hardpart_add_proj

    write(nfout,*) 
    write(nfout,*) &
         &  "! --------- Orbital decomposed charge/spin magnetic oment (method2) ------"
    write(nfout,*) "< Detail >"
    call print_orb_decomposed_chg_mag_1

    write(nfout,*) "< Summed over m >"
    call print_orb_decomposed_chg_mag_2

    write(nfout,*) "< Summed over l,m >"
    call print_orb_decomposed_chg_mag_3

!    if ( max_num_orb_index > 0 ) then
!       write(nfout,*) "< Classified by n,l >"
!       call print_orb_decomposed_chg_mag_4
!    endif

    write(nfout,*) 

    deallocate( chg_magmom_orb_decomposed )
    if ( sw_use_add_proj == ON ) then
       deallocate( chg_magmom_orb_decomposed_add )
    endif

  contains

    subroutine contrib_hardpart
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP) :: sum, fac, ctmp(ndim_magmom)
!
      real(kind=DP) :: c1
      complex(kind=CMPLDP) :: z1
!
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
      if ( noncol ) then
         allocate( hsr_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsr_ssrep = 0.0d0
         allocate( hsi_ssrep( natm, nlmt, nlmt, ndim_chgpot ) ); hsi_ssrep = 0.0d0

         call m_ES_MagMom_To_DensMat_hsr( natm, nlmt, hsr, hsi, hsr_ssrep, hsi_ssrep )

         Do ia=1, natm
            it = ityp(ia)
            
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  istmp = ( is1 -1 )*ndim_spinor +is2
                  
                  do lmt1=1,ilmt(it)
                     il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                     ilmta = lmta(lmt1,ia)

                     do lmt2=1,ilmt(it)
                        il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                        
                        if ( il1 /= il2 ) cycle
                        if ( im1 /= im2 ) cycle
                        
                        z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                             &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                        if ( sw_use_contracted_psir == ON ) then
                           z1 = z1 *product_psir_val( il1, it1, it2, it )
                        endif
                        
                        ctmp(:) = z1 *PauliMatrix(:,is2,is1)
                        
                        chg_magmom_orb_decomposed( ilmta,: ) &
                             & = chg_magmom_orb_decomposed( ilmta,: ) +ctmp(:)
                     End do
                  End Do
               End do
            End do
         End Do
         deallocate( hsr_ssrep ); deallocate( hsi_ssrep )

      else

         Do ia=1, natm
            it = ityp(ia)
            Do is1=1, nspin
               do lmt1=1,ilmt(it)
                  il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
                  ilmta = lmta(lmt1,ia)

                  do lmt2=1,ilmt(it)
                     il2=ltp(lmt2,it);  im2=mtp(lmt2,it); it2=taup(lmt2,it)
                        
                     if ( il1 /= il2 ) cycle
                     if ( im1 /= im2 ) cycle
                        
                     c1 = hsr(ia,lmt1,lmt2,is1)
                     if ( sw_use_contracted_psir == ON ) then
                        c1 = c1 *product_psir_val( il1, it1, it2, it )
                     endif
                        
                     chg_magmom_orb_decomposed( ilmta,is1 ) &
                          & = chg_magmom_orb_decomposed( ilmta,is1 ) +c1

                  End Do
               End do
            End do
         End Do
      endif
    end subroutine contrib_hardpart

    subroutine contrib_hardpart_add_proj
      integer :: ia, it, lmt1, lmt2, is1, is2, istmp
      integer :: il1, il2, im1, im2, it1, it2, ilmta
      real(kind=DP) :: sum, fac, ctmp(ndim_magmom)
!
      real(kind=DP) :: c1
      complex(kind=CMPLDP) :: z1
!
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsr_ssrep
      real(kind=DP), allocatable, dimension(:,:,:,:) :: hsi_ssrep
!
      if ( noncol ) then
         allocate( hsr_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); 
         allocate( hsi_ssrep( natm, nlmt_add, nlmt_add, ndim_chgpot ) ); 
         hsr_ssrep = 0.0d0; hsi_ssrep = 0.0d0

         call m_ES_MagMom_To_DensMat_hsr( natm, nlmt_add, hsr_add, hsi_add, &
              &                           hsr_ssrep, hsi_ssrep )
!--
         Do ia=1, natm
            it = ityp(ia)
            
            Do is1=1, ndim_spinor
               Do is2=1, ndim_spinor
                  istmp = ( is1 -1 )*ndim_spinor +is2
                  
                  do lmt1=1,ilmt_add(it)
                     il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                     ilmta = lmta_add(lmt1,ia)
                     do lmt2=1,ilmt_add(it)
                        il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1
                        
                        if ( il1 /= il2 ) cycle
                        if ( im1 /= im2 ) cycle
                        
                        z1 = dcmplx( hsr_ssrep(ia,lmt1,lmt2,istmp), &
                             &       hsi_ssrep(ia,lmt1,lmt2,istmp) )
                        
                        ctmp(:) = z1 *PauliMatrix(:,is2,is1)
                        
                        chg_magmom_orb_decomposed_add( ilmta,: ) &
                             & = chg_magmom_orb_decomposed_add( ilmta,: ) +ctmp(:)
                     End do
                  End Do
               End do
            End do
         End Do
         deallocate( hsr_ssrep ); deallocate( hsi_ssrep )

      else

         Do ia=1, natm
            it = ityp(ia)
            Do is1=1, nspin
               do lmt1=1,ilmt_add(it)
                  il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
                  ilmta = lmta_add(lmt1,ia)
                  do lmt2=1,ilmt_add(it)
                     il2=ltp_add(lmt2,it);  im2=mtp_add(lmt2,it); it2=1
                     
                     if ( il1 /= il2 ) cycle
                     if ( im1 /= im2 ) cycle
                     
                     c1 = hsr_add(ia,lmt1,lmt2,is1)
                     chg_magmom_orb_decomposed_add( ilmta,is1 ) &
                          & = chg_magmom_orb_decomposed_add( ilmta,is1 ) +c1
                  End Do
               End do
            End do
         End Do
      endif
    end subroutine contrib_hardpart_add_proj

    subroutine print_orb_decomposed_chg_mag_1
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP), allocatable :: chg_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( chg_magmom_ylm(25,ndim_magmom) )

      if ( noncol ) then
         write(nfout,'(A,5X,A)') &
              &         '    id      name     l    m', &
              &         '    tot            mx             my             mz'
      else
         if ( nspin == 1 ) then
            write(nfout,'(A,5X,A)') &
                 &         '    id      name     l    m', '    tot'
         else
            write(nfout,'(A,5X,A)') &
                 &         '    id      name     l    m', '    up            down'
         endif
      endif

      Do ia=1, natm
         it = ityp(ia)
         chg_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                 &                     + chg_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)
               
               nspher = ( il1 -1 )**2 +im1
               chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                    &                     + chg_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               if ( noncol ) then
                  write(nfout,'(I6,6X,A5,2I5,4F15.8)') &
                       &              ia, speciesname(it), il1 -1, im1, &
                       &              chg_magmom_ylm(nspher,1:ndim_magmom)
               else
                  if ( nspin == 1 ) then
                     write(nfout,'(I6,6X,A5,2I5,F15.8)') &
                          &              ia, speciesname(it), il1 -1, im1, &
                          &              chg_magmom_ylm(nspher,1:ndim_magmom)
                  else
                     write(nfout,'(I6,6X,A5,2I5,2F15.8)') &
                          &              ia, speciesname(it), il1 -1, im1, &
                          &              chg_magmom_ylm(nspher,1:ndim_magmom)
                  endif
               endif
            End do
         End do
      End do

      deallocate( chg_magmom_ylm )

    end subroutine print_orb_decomposed_chg_mag_1

    subroutine print_orb_decomposed_chg_mag_2
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum( ndim_magmom )
      real(kind=DP), allocatable :: chg_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( chg_magmom_ylm(25,ndim_magmom) )

      if ( noncol ) then
         write(nfout,'(A,5X,A)') &
              & '    id      name     l    ', &
              & '     tot            mx             my             mz'
      else
         if ( nspin == 1 ) then
            write(nfout,'(A,5X,A)') &
                 & '    id      name     l    ', '     tot'
         else
            write(nfout,'(A,5X,A)') &
                 & '    id      name     l    ', '     up            down'
         endif
      endif

      Do ia=1, natm
         it = ityp(ia)
         chg_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                 &                     + chg_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)
               
               nspher = ( il1 -1 )**2 +im1
               chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                    &                     + chg_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif
         Do il1=1, lpsmax(it)
            csum = 0.0d0
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +chg_magmom_ylm(nspher,:)
            End do
!
            if ( noncol ) then
               write(nfout,'(I6,6X,A5,I5,5X,4F15.8)') &
                    &              ia, speciesname(it), il1 -1, &
                    &              csum(1:ndim_magmom)
            else
               if ( nspin == 1 ) then
                  write(nfout,'(I6,6X,A5,I5,5X,F15.8)') &
                       &              ia, speciesname(it), il1 -1, &
                       &              csum(1:ndim_magmom)
               else
                  write(nfout,'(I6,6X,A5,I5,5X,2F15.8)') &
                       &              ia, speciesname(it), il1 -1, &
                       &              csum(1:ndim_magmom)
               endif
            endif
         End do
      End do

      deallocate( chg_magmom_ylm )

    end subroutine print_orb_decomposed_chg_mag_2

    subroutine print_orb_decomposed_chg_mag_3
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: nspher
      real(kind=DP) :: csum( ndim_magmom )
      real(kind=DP), allocatable :: chg_magmom_ylm(:,:)

      if ( mype /= 0 ) return

      allocate( chg_magmom_ylm(25,ndim_magmom) )

      if ( noncol ) then
         write(nfout,'(A,5X,A)') &
              & '    id      name          ', &
              & '     tot            mx             my             mz'
      else
         if ( nspin == 1 ) then
            write(nfout,'(A,5X,A)') &
                 & '    id      name          ', '     tot'
         else
            write(nfout,'(A,5X,A)') &
                 & '    id      name          ', '     up            down'
         endif
      endif

      Do ia=1, natm
         it = ityp(ia)
         chg_magmom_ylm = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            nspher = ( il1 -1 )**2 +im1
            chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                 &                     + chg_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)
               
               nspher = ( il1 -1 )**2 +im1
               chg_magmom_ylm( nspher,: ) = chg_magmom_ylm( nspher,: ) &
                    &                     + chg_magmom_orb_decomposed_add( ilmta,: )
            End do
         endif

         csum = 0.0d0
         Do il1=1, lpsmax(it)
            Do im1=1, 2*il1 -1
               nspher = ( il1 -1 )**2 +im1
               csum(:) = csum(:) +chg_magmom_ylm(nspher,:)
            End do
         End do
!
         if ( noncol ) then
            write(nfout,'(I6,6X,A5,10X,4F15.8)') &
                 &              ia, speciesname(it),  &
                 &              csum(1:ndim_magmom)
         else
            if ( nspin == 1 ) then
               write(nfout,'(I6,6X,A5,10X,F15.8)') &
                    &              ia, speciesname(it), &
                    &              csum(1:ndim_magmom)
            else
               write(nfout,'(I6,6X,A5,10X,2F15.8)') &
                    &              ia, speciesname(it), &
                    &              csum(1:ndim_magmom)
            endif
         endif
      End do

      deallocate( chg_magmom_ylm )

    end subroutine print_orb_decomposed_chg_mag_3

    subroutine print_orb_decomposed_chg_mag_4
      integer :: ia, it, il1, im1, it1, lmt1, ilmta
      integer :: j1, n1
      real(kind=DP) :: csum( ndim_magmom )
      real(kind=DP), allocatable :: chg_magmom_nl(:,:,:)

      if ( mype /= 0 ) return

      allocate( chg_magmom_nl(7,4,ndim_magmom) )

      if ( noncol ) then
         write(nfout,'(A,5X,A)') &
              & '    id      name     n    l', &
              & '     tot            mx             my             mz'
      else
         if ( nspin == 1 ) then
            write(nfout,'(A,5X,A)') &
                 & '    id      name     n    l', '     tot'
         else
            write(nfout,'(A,5X,A)') &
                 & '    id      name     n    l', '     up            down'
         endif
      endif

      Do ia=1, natm
         it = ityp(ia)
         if ( num_orb_index_data(it) == 0 ) cycle

         chg_magmom_nl = 0.0d0

         Do lmt1=1, ilmt(it)
            il1=ltp(lmt1,it); im1=mtp(lmt1,it); it1=taup(lmt1,it)
            ilmta = lmta(lmt1,ia)

            Do j1=1, num_orb_index_data(it)
               if ( il1 == qnum_l_orb_index(it,j1) +1 &
                    &  .and. it1 == qnum_tau_orb_index(it,j1) ) then
                  n1 = qnum_n_orb_index(it,j1)
                  exit
               endif
            End do
            chg_magmom_nl( n1,il1,: ) = chg_magmom_nl( n1,il1,: ) &
                 &                     + chg_magmom_orb_decomposed( ilmta,: )
         End do
         if ( sw_use_add_proj == ON ) then
            Do lmt1=1, ilmt_add(it)
               il1=ltp_add(lmt1,it); im1=mtp_add(lmt1,it); it1=1
               ilmta = lmta_add(lmt1,ia)
               
               Do j1=1, num_orb_index_data(it)
                  if ( il1 == qnum_l_orb_index(it,j1) +1 &
                       &  .and. it1 == qnum_tau_orb_index(it,j1) ) then
                     n1 = qnum_n_orb_index(it,j1)
                     exit
                  endif
               End do
               chg_magmom_nl( n1,il1,: ) = chg_magmom_nl( n1,il1,: ) &
                 &                     + chg_magmom_orb_decomposed( ilmta,: )
            End do
         endif

         Do j1=1, num_orb_index_data(it)
            n1  = qnum_n_orb_index(it,j1)
            il1 = qnum_l_orb_index(it,j1) +1

            if ( noncol ) then
               write(nfout,'(I6,6X,A5,2I5,4F15.8)') &
                    &              ia, speciesname(it), n1,il1 -1, &
                    &              chg_magmom_nl(n1,il1,1:ndim_magmom)
            else
               if ( nspin == 1 ) then
                  write(nfout,'(I6,6X,A5,2I5,F15.8)') &
                       &              ia, speciesname(it), n1, il1 -1, &
                       &              chg_magmom_nl(n1,il1,1:ndim_magmom)
               else
                  write(nfout,'(I6,6X,A5,2I5,2F15.8)') &
                       &              ia, speciesname(it), n1, il1 -1, &
                       &              chg_magmom_nl(n1,il1,1:ndim_magmom)
               endif
            endif
         End do
      End do

      deallocate( chg_magmom_nl )

    end subroutine print_orb_decomposed_chg_mag_4

  end subroutine m_CD_orb_decomposed_chg_magmom
! ======== 2014/09/01

  subroutine m_CD_wd_Magmom_xsf
    character*64 file1
    integer :: lun = 4000

    integer :: i

    file1 = "magmom.xsf"
    open( unit=lun, file=file1, status="unknown", form="formatted" )

    write(lun,'(A)') 'CRYSTAL'
    write(lun,'(A)') 'PRIMVEC'
    write(lun,'(3F20.10)') altv(1:3,1) *Bohr
    write(lun,'(3F20.10)') altv(1:3,2) *Bohr
    write(lun,'(3F20.10)') altv(1:3,3) *Bohr
    write(lun,'(A)') 'CONVVEC'
    write(lun,'(3F20.10)') altv(1:3,1) *Bohr
    write(lun,'(3F20.10)') altv(1:3,2) *Bohr
    write(lun,'(3F20.10)') altv(1:3,3) *Bohr
    write(lun,'(A)') 'PRIMCOORD'
    write(lun,*) natm, 1
    Do i=1, natm
       write(lun,'(I5,6F20.10)') nint(iatomn(ityp(i))), cps(i,1:3)*Bohr, &
            &                    RhoMag_on_atom(i,2:4)
    End Do
    close(lun)

  end subroutine m_CD_wd_Magmom_xsf

end module m_CD_Mag_Moment

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 603 $)
!
!  MODULE: m_Phonon
!
!  AUTHOR(S): T. Yamamoto   May/01/2004
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
module m_Phonon
  ! $Id: m_Phonon.F90 603 2020-04-07 03:25:30Z jkoga $
  use m_Const_parameters,   only : DP, ON, OFF, NOCONV, FMAXVALLEN, PAI, PAI2, PAI4 &
       &     , PHONON_GAMMA, PHONON_BAND, PHONON_DOS &
       &     , LOWER, CARTS, UNIT_PIEZO_CONST &
       &     , CRDTYP, FILE, FERMI_DIRAC, Hartree, AMU
  use m_Control_Parameters, only : sw_phonon, sw_calc_force, sw_calc_force_all &
       &     , sw_vibrational_modes, sw_lo_to_splitting &
       &     , sw_lattice_dielectric_tensor &
       &     , sw_dielectric_function &
       &     , sw_correct_force_constants &
       &     , sw_polynomial_fit, norder &
       &     , sw_int_strain_piezo_tensor, sw_phonon_oneshot &
       &     , phonon_method, num_phonon_calc_mode &
       &     , ipriphonon, printable, way_of_smearing, width, width_tetra
  use m_Crystal_Structure,  only : altv,rltv,altv_super,rltv_super,nlpnt,lpnt,nbztyp_spg
  use m_Ionic_System,       only : num_force_data, phonon_atom &
       &, phonon_displacement &
       &,displaced_atom, displacement &
       &,input_coordinate_system,u &
       &,natm,ionic_mass,speciesname,ityp,ntyp &
       &,istart_phonon,iend_phonon &
       &,natm_prim,natm_super &
       &,pos,cps,phonon_iteration, natm_mobile, force_was_read
  use m_BP_Properties,      only : zeff
  use m_Files,              only : nfout,nfkpoint,nfmatbp,m_Files_open_kpoint_files
  use m_Parallelization,    only : mype,npes,ierr, mpi_comm_group

  ! === KT_add === 13.1R
  use m_Control_Parameters,  only : sw_phonon_with_epsilon
  use m_Raman,               only : m_Raman_read_nfinp, m_Raman_initialize, &
       &                            m_Raman_print_param, m_Raman_calc_susceptibility, &
       &                            dielectric_read_from_file => dielectric
  ! ============== 13.1R

  use m_Kpoints,             only : itrs

  implicit none
  include 'mpif.h'

  real(kind=DP),allocatable,dimension(:,:,:) :: force_data ! dim(natm_super,3,num_force_data)
  real(kind=DP),allocatable,dimension(:,:,:) :: forces ! dim(natm_super*3,natm_prim*3,norder*2)
  real(kind=DP),allocatable,dimension(:) :: force0 ! dim(natm_super*3)
  real(kind=DP) :: dielectric(3,3) = 0.d0
  real(kind=DP) :: kvec_dir(3) = 0.d0
  character(len=3), allocatable, dimension(:) :: point_group ! dim(nqvec)
  character(len=3) :: pg_gamma = ''
  integer :: nlat(3) ! lattice size
  real(kind=DP),allocatable,dimension(:,:) :: qvec ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:,:) :: qvin ! dim(nqvec,3)
  real(kind=DP),allocatable,dimension(:)   :: wght ! dim(nqvec)
  real(kind=DP),allocatable,dimension(:,:) :: qdir ! dim(nqvec,3)
  integer :: nsp = 1
  real(kind=DP),allocatable,dimension(:,:) :: spcpnt ! dim(nsp,3)
  character(len=3), allocatable, dimension(:)  :: pg_spcpnt ! dim(nsp)
  integer :: nsl = 1
  integer,allocatable,dimension(:,:) :: symln  ! dim(nsl,2)
  integer,allocatable,dimension(:) :: ndiv     ! dim(nsl)
  character(len=3), allocatable, dimension(:)  :: pg_symln ! dim(nsl)
  logical, allocatable, dimension(:,:) :: fksym ! dim(48,nqvec)
  real(kind=DP) :: rho_loto = 1.4d0
  ! strain force coupling const.
  real(kind=DP),allocatable         :: strfrc(:,:,:)   !d(3,natm,6)
  real(kind=DP) :: piezoelectric(3,6) = 0.d0

  ! energy range for dielectric function
  real(kind=DP), private :: max_energy = 0.01d0
  real(kind=DP), private :: min_energy = 0.d0
  integer, private :: num_division = 100
  real(kind=DP), private :: damping_factor = 1.d-2

  ! Phonon DOS
  integer, private :: phonon_dos_mesh(3)
  integer                           :: np0,np1,np2
  integer,allocatable, dimension(:) :: ip20,ip10,ip02,ip12
  integer,allocatable, dimension(:) :: ip01,ip21,iu21,iv21,iwt,ip2cub
  integer, dimension(3)             :: nxyz_tetra
  real(kind=DP)                     :: DeltaE_dos = 1.d-5


  ! calculated
  integer :: nmodes ! = 3*natm
  integer :: nqvec = 1
  integer :: qvec_from_file = ON
  real(kind=DP), allocatable,dimension(:,:,:) :: dynmat  ! dim(3*natm,3*natm,nlpnt)
  complex(kind=DP), allocatable,dimension(:,:,:) :: dynmatq ! dim(3*natm,3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:,:)   :: omega   ! dim(3*natm,nqvec)
  complex(kind=DP), allocatable,dimension(:,:,:) :: modes   ! dim(3*natm,3*natm,nqvec)
  character(len=3), allocatable,dimension(:,:) :: mode_irr_rep ! dim(3*natm,nqvec)
  character(len=4), allocatable,dimension(:,:) :: mode_active  ! dim(3*natm,nqvec)
  real(kind=DP), allocatable,dimension(:)   :: msqinv     ! dim(3*natm)
  real(kind=DP), allocatable,dimension(:,:) :: zeff_mode  ! dim(3,nmodes)
  real(kind=DP) :: static_dielectric(3,3) ! static dielectric tensor 
  real(kind=DP) :: lattice_dielectric(3,3) ! lattice dielectric tensor 
  real(kind=DP), allocatable,dimension(:,:) :: strphcpl  ! dim(6,nmodes)

  ! Ewald sum
  real(kind=DP) :: deteps ! Det(epsilon)
  real(kind=DP), dimension(3,3) :: epsinv ! (epsilon)^-1

  integer :: sw_read_forces_pre = ON 

  integer, allocatable, dimension(:) :: mode2atom
  integer, allocatable, dimension(:) :: atm2mobileatm
  ! Tags
  character(len("phonon")),private,parameter :: tag_phonon = "phonon"
  character(len("sw_phonon")),private,parameter :: tag_sw_phonon = "sw_phonon"
  character(len("sw_calc_force")),private,parameter :: tag_sw_calc_force = "sw_calc_force"
  character(len("sw_calc_force_all")),private,parameter :: tag_sw_calc_force_all = "sw_calc_force_all"
  character(len("sw_polynomial_fit")),private,parameter :: tag_sw_polynomial_fit = "sw_polynomial_fit"
  character(len("sw_phonon_oneshot")),private,parameter :: tag_sw_phonon_oneshot = "sw_phonon_oneshot"
  character(len("num_phonon_calc_mode")),private,parameter :: tag_num_phonon_calc_mode = "num_phonon_calc_mode"
  character(len("norder")),private,parameter :: tag_norder = "norder"
  character(len("displacement")),private,parameter :: tag_displacement = "displacement"
  character(len("force_calc")),private,parameter :: tag_force_calc = "force_calc"
  character(len("start")),private,parameter :: tag_start = "start"
  character(len("end")),private,parameter :: tag_end = "end"

  character(len("sw_vibrational_modes")),private,parameter :: tag_sw_vibrational_modes = "sw_vibrational_modes"
  character(len("sw_correct_force_constants")),private,parameter :: tag_sw_correct_force_constants = "sw_correct_force_constants"
  character(len("point_group")),private,parameter :: tag_point_group = "point_group"
  character(len("sw_lo_to_splitting")),private,parameter :: tag_sw_lo_to_splitting = "sw_lo_to_splitting"
  character(len("electronic_dielectric_constant")),private,parameter :: &
       & tag_electronic_dielectric_cnst = "electronic_dielectric_constant"
  character(len("exx")),private,parameter :: tag_exx = "exx"
  character(len("eyy")),private,parameter :: tag_eyy = "eyy"
  character(len("ezz")),private,parameter :: tag_ezz = "ezz"
  character(len("exy")),private,parameter :: tag_exy = "exy"
  character(len("eyz")),private,parameter :: tag_eyz = "eyz"
  character(len("ezx")),private,parameter :: tag_ezx = "ezx"
  character(len("k_vector")),private,parameter :: tag_k_vector = "k_vector"
  character(len("kx")),private,parameter :: tag_kx = "kx"
  character(len("ky")),private,parameter :: tag_ky = "ky"
  character(len("kz")),private,parameter :: tag_kz = "kz"

  character(len("sw_lattice_dielectric_tensor")),private,parameter :: & 
       & tag_sw_lattice_dielec_tensor = "sw_lattice_dielectric_tensor"
  character(len("sw_internal_strain_piezoelectric_tensor")),private,parameter :: & 
       & tag_sw_int_strain_piezo_tensor = "sw_internal_strain_piezoelectric_tensor"

  character(len("sw_dielectric_function")),private,parameter :: tag_sw_dielectric_function = "sw_dielectric_function"
  character(len("energy_range")),private,parameter :: tag_energy_range = "energy_range"
  character(len("min_energy")),private,parameter :: tag_min_energy = "min_energy"
  character(len("max_energy")),private,parameter :: tag_max_energy = "max_energy"
  character(len("division_number")),private,parameter :: tag_division_number = "division_number"
  character(len("damping_factor")),private,parameter :: tag_damping_factor = "damping_factor"


  character(len("lattice")),private,parameter :: tag_lattice = "lattice"
  character(len("l1")),private,parameter :: tag_l1 = "l1"
  character(len("l2")),private,parameter :: tag_l2 = "l2"
  character(len("l3")),private,parameter :: tag_l3 = "l3"

  character(len("no")),private,parameter :: tag_no = "no"
  character(len("id")),private,parameter :: tag_id = "id"
  character(len("special_points")),private,parameter :: tag_special_points = "special_points"
  character(len("symmetry_lines")),private,parameter :: tag_symmetry_lines = "symmetry_lines"
  character(len("k1")),private,parameter :: tag_k1 = "k1"
  character(len("k2")),private,parameter :: tag_k2 = "k2"
  character(len("k3")),private,parameter :: tag_k3 = "k3"
  character(len("num_division")),private,parameter :: tag_num_division = "num_division"

  character(len("method")),private,parameter :: tag_method = "method"
  character(len("calc_type")),private,parameter :: tag_calc_type = "calc_type"
  character(len("gamma")),private,parameter  :: tag_gamma  = "gamma"
  character(len("zone_center")),private,parameter :: tag_zone_center = "zone_center"
  character(len("band")),private,parameter   :: tag_band   = "band"
  character(len("dispersion")),private,parameter :: tag_dispersion = "dispersion"
  character(len("dos")),private,parameter    :: tag_dos    = "dos"

  character(len("mesh")),private,parameter   :: tag_mesh   = "mesh"
  character(len("nx")),private,parameter     :: tag_nx     = "nx"
  character(len("ny")),private,parameter     :: tag_ny     = "ny"
  character(len("nz")),private,parameter     :: tag_nz     = "nz"
  character(len("deltae")),private,parameter :: tag_deltae = "deltae"

  character(len("rho")),private,parameter :: tag_rho = "rho"

  character(len("qvec_from_file")),private, parameter :: tag_qvec_from_file = "qvec_from_file"
  character(len("sw_read_forces_pre")),private, parameter :: tag_sw_read_forces_pre = "sw_read_forces_pre"

contains

  subroutine m_Phonon_rd_param(nfout)

    integer, intent(in) :: nfout

    integer :: iret, f_selectBlock, f_getIntValue, f_getRealValue, f_getStringValue
    integer :: f_selectParentBlock, f_selectTop
    real(kind=DP) :: dret
    character(len=FMAXVALLEN) :: cret
    real(kind=DP) :: dnorm

    iret = f_selectTop()
    if( f_selectBlock( tag_phonon) == 0) then
       if( f_getIntValue( tag_sw_phonon, iret) == 0) sw_phonon = iret
       if(sw_phonon == ON) then
          sw_calc_force = ON
          if( f_getStringValue( tag_method, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          else if( f_getStringValue( tag_calc_type, cret,LOWER) == 0) then
             call set_phonon_method(cret) ! -> phonon_method
          end if
          if( f_getIntValue( tag_sw_calc_force, iret) == 0) sw_calc_force = iret
          if( f_getIntValue( tag_sw_calc_force_all, iret) == 0) sw_calc_force_all = iret
          if( f_getIntValue( tag_sw_polynomial_fit, iret) == 0) sw_polynomial_fit = iret
          if( f_getIntValue( tag_norder, iret) == 0) norder = iret
          if( f_getRealValue( tag_displacement, dret, 'bohr') == 0) then
             u = dret   
          else
             u = 0.1d0 ! default value
          end if
          if( f_getRealValue( tag_damping_factor, dret, '') == 0) damping_factor = dret
          damping_factor = abs(damping_factor)
          if( f_getIntValue( tag_sw_vibrational_modes, iret) == 0) sw_vibrational_modes = iret
          if( f_getIntValue( tag_sw_correct_force_constants, iret) == 0) sw_correct_force_constants = iret
          if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
             pg_gamma = cret(1:3)
          else
             pg_gamma = '' ! default value
          end if

          if(f_getIntValue(tag_sw_read_forces_pre,iret)==0) then
             sw_read_forces_pre = iret
          endif

          if( f_getIntValue( tag_sw_phonon_oneshot, iret)==0) sw_phonon_oneshot = iret
          if( f_getIntValue( tag_num_phonon_calc_mode,iret)==0) num_phonon_calc_mode = iret

          ! ==== KT_add ==== 13.1R
          call m_Raman_read_nfinp
          ! =============== 13.1R

          if( f_getIntValue( tag_sw_lattice_dielec_tensor, iret) == 0) & 
               &  sw_lattice_dielectric_tensor = iret
          if( f_getIntValue( tag_sw_int_strain_piezo_tensor, iret) == 0) & 
               &  sw_int_strain_piezo_tensor = iret

          if( f_getIntValue( tag_sw_dielectric_function, iret) == 0) sw_dielectric_function = iret

          if( f_getIntValue( tag_sw_lo_to_splitting, iret) == 0) sw_lo_to_splitting = iret
          if(sw_lo_to_splitting == ON) then
             if( f_getRealValue( tag_rho, dret, '') == 0) rho_loto = dret
          end if
          if( f_selectBlock( tag_force_calc) == 0) then
             if( f_getIntValue( tag_start, iret) == 0) istart_phonon = iret
             if( f_getIntValue( tag_end, iret) == 0) iend_phonon = iret
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_electronic_dielectric_cnst) == 0) then
             if( f_getRealValue( tag_exx, dret, '') == 0) dielectric(1,1) = dret
             if( f_getRealValue( tag_eyy, dret, '') == 0) dielectric(2,2) = dret
             if( f_getRealValue( tag_ezz, dret, '') == 0) dielectric(3,3) = dret
             if( f_getRealValue( tag_exy, dret, '') == 0) dielectric(1,2) = dret
             dielectric(2,1) = dielectric(1,2)
             if( f_getRealValue( tag_eyz, dret, '') == 0) dielectric(2,3) = dret
             dielectric(3,2) = dielectric(2,3)
             if( f_getRealValue( tag_ezx, dret, '') == 0) dielectric(3,1) = dret
             dielectric(1,3) = dielectric(3,1)
             iret = f_selectParentBlock()
          end if
          if( f_selectBlock( tag_energy_range ) == 0) then
             if( f_getRealValue( tag_min_energy, dret, 'hartree') == 0) min_energy = dret
             if( f_getRealValue( tag_max_energy, dret, 'hartree') == 0) max_energy = dret
             if( f_getIntValue( tag_division_number, iret) == 0) num_division = iret
             iret = f_selectParentBlock()
          end if

          if( f_getIntValue(tag_qvec_from_file,iret)==0) qvec_from_file = iret

          ! ==== KT_add ====== 13.1R
          if( phonon_method == PHONON_GAMMA ) qvec_from_file = OFF
          ! ================== 13.1R

          if(qvec_from_file==OFF)then
             if( f_selectBlock( tag_k_vector) == 0) then
                if( f_getRealValue( tag_kx, dret, '') == 0) kvec_dir(1) = dret
                if( f_getRealValue( tag_ky, dret, '') == 0) kvec_dir(2) = dret
                if( f_getRealValue( tag_kz, dret, '') == 0) kvec_dir(3) = dret
                iret = f_selectParentBlock()
                dnorm = sqrt(sum(kvec_dir(1:3)**2))
                if(abs(dnorm) < 1.d-10) then
                   kvec_dir(1:2)=0.d0
                   kvec_dir(3)=1.d0
                   dnorm = 1.d0
                end if
                kvec_dir(1:3) = kvec_dir(1:3)/dnorm
                iret = f_selectParentBlock()
             else
                kvec_dir(3) = 1.d0  ! default value
             end if
          endif

          ! === KT_add === 13.1R
          if ( sw_phonon_with_epsilon == ON ) then
             call m_Raman_initialize( kvec_dir )
             dielectric = dielectric_read_from_file
          endif
          ! ================ 13.1R

          if( phonon_method /= PHONON_GAMMA) then
             if( f_selectBlock( tag_lattice) == 0) then
                if( f_getIntValue( tag_l1, iret) == 0) nlat(1) = iret
                if( f_getIntValue( tag_l2, iret) == 0) nlat(2) = iret
                if( f_getIntValue( tag_l3, iret) == 0) nlat(3) = iret
                iret = f_selectParentBlock()
             else
                nlat(1:3) = 2
             end if
          else
             nlat(1:3) = 0
          end if

          if( phonon_method == PHONON_BAND) then
             call rd_spcpnt_and_symln()
          else if( phonon_method == PHONON_DOS) then
             phonon_dos_mesh(1:3) = 4 ! default values
             if( f_selectBlock( tag_dos) == 0) then
                if( f_selectBlock( tag_mesh) == 0) then
                   if( f_getIntValue( tag_nx, iret) == 0) phonon_dos_mesh(1) = iret
                   if( f_getIntValue( tag_ny, iret) == 0) phonon_dos_mesh(2) = iret
                   if( f_getIntValue( tag_nz, iret) == 0) phonon_dos_mesh(3) = iret
                   iret = f_selectParentBlock()
                end if
                if( f_getRealValue( tag_deltae, dret, '') == 0) DeltaE_dos = dret
                iret = f_selectParentBlock()
             end if
          end if
          if(f_getIntValue(tag_sw_read_forces_pre,iret)==0) sw_read_forces_pre = iret

          iret = f_selectParentBlock()
       end if

       iret = f_selectParentBlock()
    end if

    if(sw_lattice_dielectric_tensor == ON) then
       phonon_method = PHONON_GAMMA
       sw_lo_to_splitting = OFF
    end if

    if(ipriphonon >= 1) then
       write(nfout,*) '!** sw_phonon = ',sw_phonon
       if(sw_phonon == ON) then
          write(nfout,*) '!** sw_calc_force = ',sw_calc_force
          write(nfout,*) '!** sw_calc_force_all = ',sw_calc_force_all
          write(nfout,*) '!** istart_phonon = ',istart_phonon
          write(nfout,*) '!** iend_phonon   = ',iend_phonon
          write(nfout,*) '!** sw_read_forces_pre   = ',sw_read_forces_pre
          write(nfout,*) '!** displacement (Phonon) = ',u
          write(nfout,*) '!** sw_vibrational_modes = ',sw_vibrational_modes
          write(nfout,*) '!** sw_polynomial_fit = ',sw_polynomial_fit
          write(nfout,*) '!** norder = ',norder
          write(nfout,*) '!** nlat = ',nlat
          write(nfout,*) '!** sw_correct_force_constants = ',sw_correct_force_constants
          write(nfout,*) '!** point_group = ',pg_gamma
          write(nfout,*) '!** sw_lo_to_splitting = ',sw_lo_to_splitting
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,1)
          write(nfout,'(" !** epsilon = [",3(1x,f10.5),1x,"]")') dielectric(1:3,2)
          write(nfout,'(" !**           [",3(1x,f10.5),1x,"]")') dielectric(1:3,3)
          write(nfout,'(" !** k_vector =",3(1x,f10.5))') kvec_dir(1:3)
          write(nfout,*) '!** sw_lattice_dielectric_tensor = ',sw_lattice_dielectric_tensor
          write(nfout,*) '!** sw_dielectric_function = ',sw_dielectric_function
          write(nfout,*) '!** energy_range = ',min_energy,max_energy,num_division
          write(nfout,*) '!** damping_factor = ',damping_factor
          write(nfout,*) '!** sw_internal_strain_piezoelectric_tensor = ',sw_int_strain_piezo_tensor
          if( phonon_method == PHONON_DOS) then
             write(nfout,*) '!** phonon_dos_mesh = ',phonon_dos_mesh(1:3)
          end if
          write(nfout,*) '!** sw_phonon_oneshot = ', sw_phonon_oneshot 
          if(sw_phonon_oneshot == ON) then
             write(nfout,*) '!** num_phonon_calc_mode = ',num_phonon_calc_mode
          end if
          ! ====== KT_add ==== 13.1R
          if ( sw_phonon_with_epsilon == ON ) call m_Raman_print_param
          ! ================== 13.1R
       end if
    end if

  contains
    subroutine rd_spcpnt_and_symln()
      integer :: num

      call read_spcpnt(.true.,nsp,num)  ! paramset = .true.  -> nsp
      nsp = num
      allocate(spcpnt(nsp,3))
      allocate(pg_spcpnt(nsp))
      call read_spcpnt(.false.,nsp,num) ! paramset = .false. -> spcpnt,pg_spcpnt

      call read_symln(.true.,nsl,num)  ! paramset = .true.  -> nsl
      nsl = num
      allocate(symln(nsl,3))
      allocate(ndiv(nsl))
      allocate(pg_symln(nsl))
      call read_symln(.false.,nsl,num) ! paramset = .false. -> symln,ndiv,pg_symln
    end subroutine rd_spcpnt_and_symln

    subroutine read_spcpnt(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      real(kind=dP) :: dret
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_special_points) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getRealValue(tag_k1,dret,'') == 0) spcpnt(no,1) = dret
                  if(f_getRealValue(tag_k2,dret,'') == 0) spcpnt(no,2) = dret
                  if(f_getRealValue(tag_k3,dret,'') == 0) spcpnt(no,3) = dret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_spcpnt(no) = cret(1:3)
                  else
                     pg_spcpnt(no) = '' ! default value
                  end if
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_spcpnt

    subroutine read_symln(paramset,num,icounted)
      logical, intent(in) :: paramset
      integer, intent(in) ::  num
      integer, intent(out) :: icounted

      integer :: i, no, iret
      integer :: f_selectFirstTableLine,f_selectNextTableLine,f_getRealValue,f_getIntValue
      character(len=FMAXVALLEN) :: cret

      i = 1
      if( f_selectBlock( tag_symmetry_lines) == 0) then
         do
            if(i == 1) then
               if( f_selectFirstTableLine() /= 0 ) then
                  exit
               end if
            else
               if( f_selectNextTableLine() /= 0 ) then
                  exit
               end if
            end if
            if(.not.paramset) then
               if(i > num) exit
               no = i
               if(f_getIntValue(tag_no, iret) == 0) then
                  no = iret
               else if(f_getIntValue(tag_id, iret) == 0) then
                  no = iret
               end if
               if(no <= num) then
                  if(f_getIntValue(tag_k1,iret) == 0) symln(no,1) = iret
                  if(f_getIntValue(tag_k2,iret) == 0) symln(no,2) = iret
                  if( f_getStringValue( tag_point_group, cret, NOCONV) == 0) then
                     pg_symln(no) = cret(1:3)
                  else
                     pg_symln(no) = '' ! default value
                  end if
                  if(f_getIntValue(tag_num_division,iret) == 0) ndiv(no) = iret
                  if(iret <= 0) ndiv(no) = 1 
               end if
            end if
            i = i+1
         end do
         iret = f_selectParentBlock()
      end if
      icounted = i - 1

    end subroutine read_symln

    subroutine set_phonon_method(rstr)
      character(len=FMAXVALLEN),intent(in) :: rstr
      logical :: tf
      call strncmp2(rstr, FMAXVALLEN, tag_gamma, len(tag_gamma), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_zone_center, len(tag_zone_center), tf)
      if(tf) then
         phonon_method = PHONON_GAMMA
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_band, len(tag_band), tf)
      if(.not.tf) &
           & call strncmp2(rstr, FMAXVALLEN, tag_dispersion, len(tag_dispersion), tf)
      if(tf) then
         phonon_method = PHONON_BAND
         goto 1001
      end if
      call strncmp2(rstr, FMAXVALLEN, tag_dos, len(tag_dos), tf)
      if(tf) then
         phonon_method = PHONON_DOS
         goto 1001
      end if
1001  continue
    end subroutine set_phonon_method

  end subroutine m_Phonon_rd_param

  subroutine m_Phonon_alloc_qvec()
    integer :: isl,ishf
    real(kind=DP),allocatable,dimension(:,:,:) :: vkxyz_t
    real(kind=DP),allocatable,dimension(:) :: qwgt_t
    integer :: qnv3
    if(phonon_method == PHONON_GAMMA) then
       nqvec = 1
    else if(phonon_method == PHONON_BAND) then
       if(qvec_from_file==OFF)then
          nqvec = 0
          do isl=1,nsl
             ishf = 0
             if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
             nqvec = nqvec + ndiv(isl) + 1 - ishf
          end do
       else
          allocate(vkxyz_t(1,1,1))
          allocate(qwgt_t(1))
          qnv3=0
          call m_Files_open_kpoint_files(FILE,nbztyp_spg)
          call readk0(.true.,nfout,ipriphonon,qnv3,rltv,nfkpoint,nfmatbp &
               & ,nqvec,vkxyz_t,qwgt_t)
          write(nfout,'(a,i5)') ' !** number of k-points for the phonon-band calculation : ',nqvec
          deallocate(vkxyz_t)
          deallocate(qwgt_t)
       endif
    else if(phonon_method == PHONON_DOS) then
       call make_qpoint_set(0,nqvec,.true.) ! ipri=0, paramset = .true.
       allocate(wght(nqvec))
    end if

    allocate(qvec(nqvec,3))
    allocate(qvin(nqvec,3))
    allocate(qdir(nqvec,3))
    allocate(point_group(nqvec)); point_group = ''
    allocate(fksym(48,nqvec)); fksym = .false.
  end subroutine m_Phonon_alloc_qvec

  subroutine m_Phonon_set_qvec(nfout)
    integer, intent(in) :: nfout

    call set_qvec(nfout)
    call set_qvec_point_group(nfout)
    call wd_qvec(nfout)
  contains
    subroutine set_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: k1,k2
      integer :: i,isl,ishf,iqvec
      real(kind=DP) :: q1(3),q2(3),dq(3)
      real(kind=DP), allocatable, dimension(:,:,:) :: qvec_t
      real(kind=DP), allocatable, dimension(:) :: qw_t
      if(phonon_method == PHONON_GAMMA) then
         nqvec = 1
         qvec(nqvec,1:3) = 0.d0
         qvin(nqvec,1:3) = 0.d0
         qdir(nqvec,1:3) = kvec_dir(1:3)
         point_group(nqvec) = pg_gamma
      else if(phonon_method == PHONON_BAND) then
         if(qvec_from_file==OFF)then
            nqvec = 0
            do isl=1,nsl
               k1 = symln(isl,1)
               k2 = symln(isl,2)
               q1(1:3) = rltv(1:3,1)*spcpnt(k1,1) &
                    & + rltv(1:3,2)*spcpnt(k1,2) &
                    & + rltv(1:3,3)*spcpnt(k1,3)
               q2(1:3) = rltv(1:3,1)*spcpnt(k2,1) &
                    & + rltv(1:3,2)*spcpnt(k2,2) &
                    & + rltv(1:3,3)*spcpnt(k2,3)
               dq(1:3) = (q2(1:3)-q1(1:3))/ndiv(isl)  
               ishf = 0
               if(isl/=nsl.and.symln(isl,2)==symln(isl+1,1)) ishf = 1
               iqvec = nqvec + 1
               do i=0,ndiv(isl)-ishf
                  nqvec = nqvec + 1
                  qvec(nqvec,1:3) = i*dq(1:3)+q1(1:3)
                  qdir(nqvec,1:3) = dq(1:3)
                  point_group(nqvec) = pg_symln(isl)
               end do
               point_group(iqvec) = pg_spcpnt(k1)
               if(ishf==0) point_group(nqvec) = pg_spcpnt(k2)
            end do
         else
            allocate(qvec_t(nqvec,3,CRDTYP));qvec_t=0.d0
            allocate(qw_t(nqvec));qw_t=1.d0
            call readk0(.false.,nfout,ipriphonon,nqvec,rltv,nfkpoint,nfmatbp &
                 & , nqvec, qvec_t, qw_t)
            qdir=0.d0
            do i=1,nqvec
               qvec(i,1:3) = qvec_t(i,1:3,CARTS)
            enddo
            do i=1,nqvec-1
               qdir(i,1) = qvec(i+1,1)-qvec(i,1)
               qdir(i,2) = qvec(i+1,2)-qvec(i,2)
               qdir(i,3) = qvec(i+1,3)-qvec(i,3)
            enddo
            if(nqvec>1) qdir(nqvec,:) = qdir(nqvec-1,:)
         endif
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
         end do
      else if(phonon_method == PHONON_DOS) then
         call make_qpoint_set(1,nqvec,.false.) ! ipri=1, paramset = .false.
         do iqvec=1,nqvec
            do i=1,3
               qvin(iqvec,i) = sum(altv(1:3,i)*qvec(iqvec,1:3))/PAI2
            end do
            qdir(iqvec,1:3) = rltv(1:3,1)+rltv(1:3,2)+rltv(1:3,3)
         end do
      end if
    end subroutine set_qvec

    subroutine set_qvec_point_group(nfout)
      use m_Const_Parameters,  only: AUTOMATIC
      use m_Crystal_Structure, only: nopr,op,ig01,il,symmetry_method
      use m_CS_SpaceGroup,     only: lattice_system, &
           & get_kpoint_symmetry,get_point_group_name
      integer,intent(in) :: nfout

      integer :: i,j
      integer :: nopro,ig01o(48)
      integer :: nopro2,ig01o2(48)
      real(kind=DP) :: kvec(3)
      character(len=3) :: pg_name
      character(len=5) :: pg_name_i
      character(len=9) :: system

      if(symmetry_method==AUTOMATIC) then
         system = lattice_system
      else
         if(il>0) then
            system = 'cubic'
         else
            system = 'hexagonal'
         end if
      end if

      do i=1,nqvec
         if(point_group(i) == '') then
            kvec = qvec(i,1:3)
            call get_kpoint_symmetry(nopr,ig01,op,kvec,nopro,ig01o,nopro2,ig01o2)
            do j=1,nopro2
               fksym(ig01o2(j),i) = .true.
            end do
            call get_point_group_name(nfout,system,nopro,ig01o,pg_name,pg_name_i)
            point_group(i) = pg_name
         else
            fksym(1:nopr,i) = .true.
         end if
      end do
    end subroutine set_qvec_point_group

    subroutine wd_qvec(nfout)
      integer,intent(in) :: nfout

      integer :: i
      if(ipriphonon > 0) then
         write(nfout,'("=== q-vectors ===")')
         write(nfout,'("number of q-vectors = ",i5)') nqvec
         write(nfout,'(4x,"i",5x,"qvec(3)",26x,"qvin(3)",22x,"point_group")')
         do i=1,nqvec
            write(nfout,'(i5,3(1x,f10.5),3(1x,f10.5),1x,a3)') i,qvec(i,1:3),qvin(i,1:3),point_group(i)
         end do
      end if
    end subroutine wd_qvec

  end subroutine m_Phonon_set_qvec

  subroutine make_qpoint_set(ipri,nqvec,paramset)
    use m_Crystal_Structure, only: il,inv,ngen,igen,jgen,a,b,c,ca,cb,cc
    integer, intent(in) :: ipri
    integer, intent(inout) :: nqvec
    logical, intent(in) :: paramset

    integer :: nx1,ny1,nz1
    integer :: nx,ny,nz
    integer :: nxx,nyy,nzz
    integer :: nd, lmnp0, lmnp1, lmnp2
    real(kind=DP), pointer, dimension(:,:) :: pa0,pb0,pb 
    integer,       pointer, dimension(:,:) :: ka0,ka2
    integer,       pointer, dimension(:,:) :: ip2cub_wk
    integer,       pointer, dimension(:)   :: nstar2
    integer                                :: i
    real(kind=DP) :: nv(3),trmat(3,3)

    nx = phonon_dos_mesh(1)
    ny = phonon_dos_mesh(2)
    nz = phonon_dos_mesh(3)
    call nskma0(il,nx,ny,nz,nxx,nyy,nzz,nx1,ny1,nz1,nd)

    lmnp0=(nxx+1)*(nyy+1)*(nzz+1)
    lmnp1=lmnp0
    lmnp2=lmnp0

    nxyz_tetra = 0
    allocate(ip10(lmnp0))  ; ip10 = 0        
    if(paramset) allocate(ip20(lmnp0))
    ip20 = 0        
    allocate(ip01(lmnp1))    ; ip01 = 0
    allocate(ip02(lmnp2))    ; ip02 = 0
    allocate(ip21(lmnp1))    ; ip21 = 0
    allocate(ip12(lmnp2))    ; ip12 = 0
    allocate(iu21(lmnp1))    ; iu21 = 0
    allocate(iv21(lmnp1))    ; iv21 = 0
    allocate(nstar2(lmnp2))  ; nstar2 = 0
    allocate(pa0(3,lmnp0))  ; pa0 = 0
    allocate(pb0(3,lmnp0))  ; pb0 = 0
    allocate(pb(3,lmnp2))  ; pb = 0
    allocate(ka0(4,lmnp0))  ; ka0 = 0
!!$  allocate(ka2(4,lmnp2))  ; ka2 = 0

    call setkp0_default_n(il,ngen,inv,igen,jgen,a,b,c,ca,cb,cc &
         &               ,nx,ny,nz &
         &               ,np2,np1,np0,lmnp0,lmnp1,lmnp2 &
         &               ,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3)&
         &               ,ip10,ip20,ip01,ip02,ip21,ip12,iu21,iv21 &
         &               ,nstar2,pa0,pb0,pb,ka0 &
         &               ,ipri,itrs)

    if(.not.paramset) then
       call get_trmat1  !-(contained here) ->(trmat)
       do i=1,nqvec
          nv(1:3) = dble(ka0(1:3,ip02(i)))/dble(ka0(4,ip02(i)))
          qvec(i,1:3) = matmul(trmat,nv)
          wght(i)     = dble(nstar2(i))/dble(np1)
       end do
    else
       nqvec = np2
    end if

    deallocate(ip10)
    deallocate(ip01)
    deallocate(ip02)
    deallocate(ip21)
    deallocate(ip12)
    deallocate(iu21)
    deallocate(iv21)
    deallocate(nstar2)
    deallocate(pa0)
    deallocate(pb0)
    deallocate(pb)
    deallocate(ka0)
!!$  deallocate(ka2)

    if(paramset) return

    allocate(iwt(np2)) ; iwt = 0
    allocate(ip2cub(np1)) ; ip2cub = 0

    allocate(ip2cub_wk(9,nxyz_tetra(1)*nxyz_tetra(2)*nxyz_tetra(3))) 
    ip2cub_wk = 0.d0
    call wtetra &
         &  (nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3),np0,np2,ip20 &
         &  ,iwt,ip2cub &
         &  ,ip2cub_wk)
    deallocate(ip2cub_wk)
  contains
    subroutine get_trmat1
      real(kind=DP), dimension(3,3) :: trbp,trpb,mat1,mat2
      !    make translation matrix  trpb (P -> B)

      call getspgtab(trbp)  ! spg+tetra

      call inver3n(3,trbp,trpb)

      mat1 = transpose(trpb)
      call inver3n(3,mat1,mat2)
      call matpr3(rltv,mat2,trmat)

    end subroutine get_trmat1
  end subroutine make_qpoint_set

  subroutine m_Phonon_write_forces()
    use m_IterationNumbers, only : iteration_ionic, iteration_electronic
    use m_Files, only : nfforce, m_Files_open_nfforce
    use m_Ionic_system, only : natm,num_force_calc,iconf
    use m_Control_Parameters, only : num_phonon_calc_mode
    use m_Force, only : forc_l
#ifdef WINDOWS
    use ifport
#endif

    ! local variables
    integer :: i,ic
    logical :: ini

    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    ic = iconf(iteration_ionic)
    force_data(1:natm_super,1:3,ic) = forc_l(1:natm_super,1:3)

    if(mype /= 0) return

    ini = .false.
    do i=1,3*natm_prim*norder*2
       if(force_was_read(i)) then
         ini = .true.
         exit
       endif
    enddo
!    if(iteration_ionic == 1) then
    if(phonon_iteration == 1 .and. .not. ini) then
       call m_Files_open_nfforce(.false.)  ! new file (asms)
       if(istart_phonon == 1) then
          if(sw_phonon_oneshot == ON) then
             write(nfforce,'(4(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit, num_phonon_calc_mode")') &
                  & num_force_calc,  norder, sw_polynomial_fit, num_phonon_calc_mode
          else
             write(nfforce,'(3(1x,i7),"  : num_force_calc, norder, sw_polynomial_fit")') &
                  & num_force_calc, norder, sw_polynomial_fit
          end if
       end if
    else
       call m_Files_open_nfforce(.true.)  ! append (asms)
    end if
    write(nfforce,'(i4,3(1x,e25.12),2i6,"  : displaced_atom, displacement(1:3), iteration_ionic,iteration_electronic")') &
         & displaced_atom,displacement(1:3),iteration_ionic,iteration_electronic
    do i=1,natm_super
       write(nfforce,'(i4,3(1x,e25.12))') i,forc_l(i,1:3)
    end do
    call flush(nfforce)

  end subroutine m_Phonon_write_forces

  ! ==== KT_add == 13.1R
  subroutine m_Phonon_print_Raman_susc
    call m_Raman_calc_susceptibility( nmodes, omega, modes, &
         &                            mode_active, mode_irr_rep )
  end subroutine m_Phonon_print_Raman_susc
  ! =============== 13.1R

  function m_Phonon_Check_iteration(iteration_ionic)
    use m_Control_Parameters, only : skip_alloc_phonon
    use m_Crystal_Structure, only : m_CS_phonon_symmetry
    use m_Ionic_System, only : m_IS_phonon_equilibrium, m_IS_cps_to_pos &
         & , istart_phonon, iend_phonon, num_force_calc &
         & , iconf
    logical :: m_Phonon_Check_iteration
    integer, intent(in) :: iteration_ionic
    integer :: id

    if(ipriphonon>=1) then
       id = iteration_ionic+istart_phonon-1
       write(nfout,*) 'PHONON: num_force_calc  = ',num_force_calc
       write(nfout,*) 'PHONON: istart, iend = ',istart_phonon, iend_phonon
       write(nfout,*) 'PHONON: id = ',id
       write(nfout,*) 'PHONON: iconf = ',iconf(id)
       write(nfout,*) 'PHONON: iteration_ionic = ',iteration_ionic
    end if
    if(iteration_ionic >= iend_phonon-istart_phonon+1 ) then
       m_Phonon_Check_iteration = .true.
       call m_IS_phonon_equilibrium()
       call m_IS_cps_to_pos()
       call m_CS_phonon_symmetry(ON)
    else 
       m_Phonon_Check_iteration = .false.
    end if
    skip_alloc_phonon = .true.

  end function m_Phonon_Check_iteration

  subroutine m_Phonon_read_forces()
    use m_Files,        only : m_Files_open_nfforce, nfforce
    use m_Ionic_System, only : num_force_calc, napt_phonon, iequconf &
         &                    , iopr_equconf, iconf, phonon_atom,imdtyp
    use m_Crystal_Structure, only : op
#ifdef WINDOWS
    use ifport
#endif
    implicit none

    ! local variables
    integer :: n,i,ia,ja,ind,j,ic,iopr
    integer :: istart,idummy,iter
    character(len=5) :: num
    integer :: icount,jcount
    logical :: exi

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Reading forces'
    call flush(nfout)
!    nmodes = natm_prim*3
    nmodes = natm_mobile*3

    !if(sw_calc_force == OFF) then
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = OFF")')

    !num_force_data = nmodes*norder*2
    num_force_data = natm_prim*3*norder*2
    if(sw_polynomial_fit == ON) num_force_data = num_force_data + 1
  
    if(sw_polynomial_fit == ON) then
      if(.not.allocated(forces)) allocate(forces(3*natm_mobile*nlpnt,nmodes,norder*2+1))
    else
      if(.not.allocated(forces)) allocate(forces(3*natm_mobile*nlpnt,nmodes,norder*2))
    endif
    if(.not.allocated(force0)) allocate(force0(3*natm_mobile*nlpnt))
    !if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    if(.not.allocated(force_data)) allocate(force_data(natm_super,3,num_force_data))
    if(.not.allocated(force_was_read)) then
      allocate(force_was_read(num_force_data));force_was_read = .false.
    endif

    if(mype == 0) then
       call m_Files_open_nfforce(.false.)
       inquire(unit=nfforce,exist=exi)
       if(exi)then
         rewind nfforce
         read(nfforce,*,end=100,err=100) num_force_calc, norder, sw_polynomial_fit
         do while(.true.)
            read(nfforce,*,end=100,err=100) displaced_atom,displacement(1:3),iter,idummy
            ic = iconf(iter)
            do ia=1,natm_super
               read(nfforce,*,end=100,err=100) idummy,force_data(ia,1:3,ic)
            end do
            force_was_read(ic) = .true.
         end do
100      continue
       endif
    end if
    !else
    !   if(ipriphonon>=2) write(nfout,'(" sw_calc_force = ON")')
    !end if

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic = ",2i8)') i, ic
       if(imdtyp(phonon_atom(i))==OFF) cycle
       if(ic >= 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ia,j,ic) = (force_data(ia,j,ic) + dot_product(op(1:3,j,iopr),force_data(ja,1:3,i)))*0.5d0
          end do
       end do
    end do

    if(ipriphonon>=2) write(nfout,'(" num_force_data = ",i8)') num_force_data
    do i=1,num_force_data
       ic = iequconf(i)
       if(ic == 0) cycle
       ic = abs(ic)
       iopr = iopr_equconf(i)
       if(ipriphonon>=2) write(nfout,'(" i, ic, iopr = ",3i8)') i, ic,iopr
       do ia=1,natm_super
          ja = napt_phonon(ia,i)
          do j=1,3
             force_data(ja,j,i) =  dot_product(op(j,1:3,iopr),force_data(ia,1:3,ic))
          end do
       end do
    end do

    if(sw_polynomial_fit == ON) then
       ind=1
       icount = 0
       do ia=1,natm_super
          if(imdtyp(ia)==OFF) cycle
          icount = icount+1
          !istart = 3*(ia-1)+1
          istart = 3*(icount-1)+1
          force0(istart:istart+2) = force_data(ia,1:3,ind)
       end do
    else
       ind=0
    end if
!    do i=1,nmodes
    jcount = 0
    do i=1,3*natm_prim
       if (imdtyp((i-1)/3+1) /= OFF) jcount = jcount+1
       do n=1,norder*2
          ind = ind+1
          if (imdtyp((i-1)/3+1) == OFF) cycle
          icount = 0
          do ia=1,natm_super
             if(imdtyp(ia)==OFF) cycle
             icount = icount+1
             !istart = 3*(ia-1)+1
             istart = 3*(icount-1)+1
             !forces(istart:istart+2,i,n) = force_data(ia,1:3,ind)
             forces(istart:istart+2,jcount,n) = force_data(ia,1:3,ind)
          end do
       end do
    end do

    if(npes>1) then
       call mpi_bcast(forces,3*natm_mobile*nlpnt*nmodes*norder*2,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(force0,3*natm_mobile*nlpnt,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(force_was_read,num_force_data,mpi_logical,0,mpi_comm_group,ierr)
    end if
    if(ipriphonon>1)then
       do ia=1,3*natm_prim*norder*2
          write(nfout,'(a,i8,l2)') ' !** force was read ',ia,force_was_read(ia)
       enddo
    endif

    if(ipriphonon>=1) write(nfout,*) '<< m_Phonon_read_forces >>: Forces are read.'
    call flush(nfout)

    ! check sum of force
    !!if(ipriphonon>=0) then
    if(ipriphonon>=2) then
       write(nfout,*) "check sum of force"
       do i=1,num_force_data
          ic = iconf(i)
          if(ic>num_force_data) cycle
          if(imdtyp(phonon_atom(ic))==OFF) cycle
          do j=1,3
             write(nfout,*) i,j,sum(force_data(1:natm_super,j,i))
          end do
          !do ia=1,natm_super
          !   write(nfout,'(a,2i5,3f20.10)') 'ia, i, f ',ia,i,force_data(ia,1:3,i)
          !enddo
       end do
    end if
    return
  end subroutine m_Phonon_read_forces


  subroutine m_Phonon_calc_dynamical_matrix()
    use m_Crystal_Structure, only : univol, altv
    use m_Ionic_System, only : imdtyp
    implicit none

    ! local variables
    integer :: i,j,k
    integer :: istart
    real(kind=DP) :: mi,ui

    real(kind=DP) :: coefna
    complex(kind=DP), allocatable :: nadynmat(:,:,:) ! dim(nmodes,nmodes,nqvec)
    complex(kind=DP), allocatable :: nafd(:,:,:) ! dim(3,3,natm)
    real(kind=DP) :: sum_rule(nmodes,3)
    integer :: na,ia,ja,ir,jr,ira,jra,n
    real(kind=DP) :: ae,ai,amelem
    integer :: icell,nre,jas
    real(kind=DP) :: r(3),re(3,8)
    real(kind=DP) :: ph,w
    complex(kind=DP) :: expqr
    integer :: ii,jj,iu,ju
    integer :: iq
    real(kind=DP) :: s(3)
    integer :: ng,nr
    real(kind=DP), allocatable :: gv(:,:),rv(:,:),cpstmp(:,:)
    real(kind=DP) :: g2bz

    real(kind=DP), parameter :: eps = 1.d-6
    integer :: icount,jcount

    allocate(mode2atom(nmodes))
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) /= OFF)then
         icount = icount+1
         mode2atom(3*(icount-1)+1) = i
         mode2atom(3*(icount-1)+2) = i
         mode2atom(3*(icount-1)+3) = i
       endif
    enddo
    allocate(dynmat(nmodes,nmodes,nlpnt))
    allocate(dynmatq(nmodes,nmodes,nqvec))
    allocate(msqinv(nmodes))

    call m_Phonon_force_constant_matrix(dynmat)

    deallocate(forces)
    deallocate(force0)
    deallocate(force_was_read)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'calculated force constants:'
       call write_dynmat(dynmat)
    end if

    allocate(cpstmp(natm_mobile,3))
    icount=0
    do ia=1,natm
      if(imdtyp(ia) ==  OFF) cycle
      icount = icount+1
      cpstmp(icount,1:3) = cps(ia,1:3)
    enddo
    ! symmetrized force constants in Real space
    call symmetrize_force_const_Real(dynmat,natm_mobile,cpstmp)
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'symmetrized force constants:'
       call write_dynmat(dynmat)
    end if

    ! check sum rule of force constants
    if(ipriphonon >=2) &
         & write(nfout,*) 'j ir sum_of_force_constants'

    icount = 0
    do ia=1,natm_prim
       if(imdtyp(ia)==OFF) cycle
       icount = icount+1
       do ir=1,3
          !i = (ia-1)*3+ir
          i = (icount-1)*3+ir
          do jr=1,3
             sum_rule(i,jr)=0
             do n=1,nlpnt
                jcount = 0
                do ja=1,natm_prim
                   if(imdtyp(ja)==OFF) cycle
                   jcount = jcount+1
                   !j=(ja-1)*3+jr
                   j=(jcount-1)*3+jr
                   !if(n==1.and.ia==ja) cycle
                   if(n==1.and.icount==jcount) cycle
                   sum_rule(i,jr) = sum_rule(i,jr) + dynmat(i,j,n) 
                end do
             end do
             if(ipriphonon >=2) then
                !j=(ia-1)*3+jr
                j=(icount-1)*3+jr
                write(nfout,*) i,jr,sum_rule(i,jr)+dynmat(i,j,1)
             end if
          end do
       end do
    end do
    ! correct force constants
    if(sw_correct_force_constants == ON) then
       do i=1,nmodes
          ia = (i+2)/3
          do jr=1,3
             j=(ia-1)*3+jr
             dynmat(i,j,1) = - sum_rule(i,jr)
          end do
       end do
    end if

    ! output
    if(sw_correct_force_constants == ON) then
       if(printable) write(nfout,*) '*** Force constants were corrected. ***'
       if(ipriphonon >=2) then
          write(nfout,*) 'Corrected force constants:'
          call write_dynmat(dynmat)
       end if
    else
       if(printable) write(nfout,*) '*** Force constants were NOT corrected. ***'
    end if

    ! Fourier transform of force constants
    dynmatq(:,:,:) = dcmplx(0.d0,0.d0)
    do n=1,nqvec
!!$write(nfout,*) 'qvin=',qvin(n,1:3)
!!$write(nfout,*) 'qvec=',qvec(n,1:3)
       do icell=1,nlpnt
          do j=1,nmodes
             !ja = (j-1)/3 + 1
             ja = mode2atom(j)
!!$ju = mod(j-1,3)
             jas = ja + (icell-1)*natm
             do i=1,nmodes
                !ia = (i-1)/3 + 1
                ia = mode2atom(i)
!!$iu = mod(i-1,3)
!!$r(1:3) = cps(jas,1:3)-cps(ia,1:3)
                r(1:3) = cps(ia,1:3)-cps(jas,1:3)
                call get_pos_in_extcell(r,nre,re)
                expqr = dcmplx(0.d0,0.d0)
                do k=1,nre
                   ph = sum(qvec(n,1:3)*re(1:3,k))
                   expqr = expqr + dcmplx(cos(ph),sin(ph))
                end do
                expqr = expqr/dble(nre)
!!$write(nfout,*) 'ia,ja,i,j=',ia,ja,i,j
!!$write(nfout,'("r =",3f10.5)') r(1:3)
!!$do k=1,nre
!!$   write(nfout,'("k,re =",i3,3f10.5)') k,re(1:3,k)
!!$end do
!!$write(nfout,*) 'ph,expqr=',ph,expqr

                dynmatq(i,j,n) = dynmatq(i,j,n)+dynmat(i,j,icell)*expqr
!!$ii = (ja-1)*3 + iu + 1
!!$jj = (ia-1)*3 + ju + 1
!!$dynmatq(ii,jj,n) = dynmatq(ii,jj,n)+dynmat(i,j,icell)*expqr
             end do
          end do
       end do
    end do
    deallocate(dynmat)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Force constant matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! symmetrized force constants in Fourier space
    call symmetrize_force_const_Fourier(dynmatq,natm_mobile,cpstmp)

    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Symmetrized force constants Fourier space:'
       call write_dynmatq(dynmatq)
    end if


    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix in Fourier space:'
       call write_dynmatq(dynmatq)
    end if

    ! non-analytic part
    if(sw_lo_to_splitting == ON) then
       allocate(nadynmat(nmodes,nmodes,nqvec))
       call get_g2bz(g2bz)
       do iq=1,nqvec
          s = qvin(iq,1:3)
          call mod1(s)
          if(abs(sum(s(1:3)**2)) < eps) then
             ! Gamma point
             call calc_napart_gamma(iq,nadynmat(1,1,iq))
          else
             call calc_napart_parlinski(iq,nadynmat(1,1,iq),g2bz)
          end if
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Non-analytic part of force constant matrix in Fourier space:'
          call write_dynmatq(nadynmat)
       end if

       do iq=1,nqvec
          do j=1,nmodes
             do i=1,nmodes
                dynmatq(i,j,iq) = dynmatq(i,j,iq) + nadynmat(i,j,iq)
             end do
          end do
       end do

       if(ipriphonon >=2) then
          ! output
          write(nfout,*) 'Total force constant matrix in Fourier space:'
          call write_dynmatq(dynmatq)
       end if

       deallocate(nadynmat)

    end if

    ! calculate 1/sqrt(mass)
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) == OFF) cycle
       !istart=3*(i-1)+1
       icount = icount+1
       istart=3*(icount-1)+1
       mi = 1.d0/sqrt(ionic_mass(i))
       msqinv(istart) = mi
       msqinv(istart+1) = mi
       msqinv(istart+2) = mi
    end do
    if(ipriphonon > 1) then
       do i=1,nmodes
          write(nfout,*) 'debug: i= ',i,' msqinv = ',msqinv(i)
       end do
    end if

    ! calculate dynamical matrix in Fourier space
    do n=1,nqvec
       do j=1,nmodes
          do i=1,nmodes
             dynmatq(i,j,n) = dynmatq(i,j,n)*msqinv(i)*msqinv(j)
          end do
       end do
    end do


    do iq=1,nqvec
       !search the absolute maximum element
       amelem = abs(dynmatq(1,1,iq))
       do i=1,nmodes
          do j=i,nmodes
             ae = abs(dynmatq(i,j,iq))
             if(ae > amelem) amelem = ae
          end do
       end do
       if(ipriphonon >=2) then
          write(nfout,*) 'amelem = ',amelem
       end if
       do i=1,nmodes
          do j=1,nmodes
             ae = dble(dynmatq(i,j,iq))
             ai = dimag(dynmatq(i,j,iq))
             if(abs(ae) < amelem*1.d-14) ae = 0.d0
             if(abs(ai) < amelem*1.d-14) ai = 0.d0
             dynmatq(i,j,iq) = dcmplx(ae,ai)
          end do
       end do
    end do
    if(ipriphonon >=2) then
       ! output
       write(nfout,*) 'Dynamical matrix after removing small elements:'
       call write_dynmatq(dynmatq)
    end if

    deallocate(cpstmp)
    deallocate(mode2atom)
    return

  contains
    subroutine get_pos_in_extcell(r,nre,re)
      real(kind=DP), intent(in) :: r(3)
      integer, intent(out) :: nre
      real(kind=DP), intent(out) :: re(3,8)

      integer :: i,j,k,n(3),l
      real(kind=DP) :: s(3),p(3)
      real(kind=DP) :: eps = 1.d-6

      do i=1,3
         s(i) = sum(rltv_super(1:3,i)*r(1:3))/PAI2
      end do
      call mod1(s)
      do i=1,3
         n(i) = 1
         if(abs(s(i)-0.5d0)<eps) n(i) = 2
      end do
      do i=1,3
         if(s(i)>0.5d0-eps) s(i) = s(i) - 1.d0
      end do
      nre = 0
      do k=1,n(3)
         do j=1,n(2)
            do i=1,n(1)
               nre = nre + 1
               p(1) = s(1)+i-1
               p(2) = s(2)+j-1
               p(3) = s(3)+k-1
               do l=1,3
                  re(l,nre) = sum(altv_super(l,1:3)*p(1:3))
               end do
            end do
         end do
      end do
    end subroutine get_pos_in_extcell

    subroutine mod1(t)
      real(kind=DP), intent(inout) :: t(3)
      real(kind=DP), parameter :: eps = 1.d-6
      integer :: k
      t(1:3) = mod(t(1:3),1.d0)
      do k=1,3
         if(t(k) < -eps) t(k) = t(k) + 1.d0
         if(t(k) > 1.d0 - eps) t(k) = t(k) - 1.d0
      end do
    end subroutine mod1

    subroutine symmetrize_force_const_Real(fc,natm,cps)
      use m_Crystal_Structure, only : nopr,op,tau
      real(kind=DP), intent(inout) :: fc(nmodes,nmodes,nlpnt)
      integer, intent(in) :: natm
      real(kind=DP), intent(in) :: cps(natm,3)
      ! local variables
      integer :: i,j,icell,jcell,kcell,irc,jrc
      integer :: nr(natm,nlpnt),l(3,nlpnt),lx(3),ll(3)
      integer :: lr(natm,nlpnt),llr(nlpnt,nlpnt)
!!$  real(kind=DP) :: nonsym_fc(nmodes,nmodes,nlpnt)
      real(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fc
      real(kind=DP) :: tensor(3,3)
      real(kind=DP) :: x(3),y(3)
      real(kind=DP) :: aa(3,3)
      real(kind=DP) :: eps = 1.d-6
      allocate(nonsym_fc(nmodes,nmodes,nlpnt));nonsym_fc=0.d0
      nonsym_fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)
      fc(1:nmodes,1:nmodes,1:nlpnt) = 0.d0

      do icell=1,nlpnt
         l(1:3,icell) = nint(matmul(transpose(rltv),lpnt(icell,1:3))/PAI2)
      end do

      aa = matmul(transpose(rltv_super),altv)/PAI2
      do icell=1,nlpnt
         do jcell=1,nlpnt
            ll = l(1:3,jcell)-l(1:3,icell)
            do kcell=1,nlpnt
               x = matmul(aa,ll-l(1:3,kcell))
               if(sum(abs(x-nint(x)))<eps) then
                  llr(icell,jcell) = kcell
                  exit
               end if
            end do
         end do
      end do

      do n=1,nopr
         do icell=1,nlpnt
            ATOM: do i=1,natm
               x(1:3) = cps(i,1:3) + lpnt(icell,1:3)
               y = matmul(op(1:3,1:3,n),x) + tau(1:3,n,CARTS)
               do j=1,natm
                  x = y-cps(j,1:3)
                  x = matmul(transpose(rltv),x)/PAI2
                  lx = nint(x(1:3))
                  if(sum(abs(x-lx))<eps) then
                     nr(i,icell) = j
                     do jcell=1,nlpnt
                        ll = lx-l(1:3,jcell)
                        x = matmul(aa,ll)
                        if(sum(abs(x-nint(x)))<eps) then
                           lr(i,icell) = jcell
                           exit
                        end if
                     end do
                     cycle ATOM
                  end if
               end do
               write(nfout,'("No equivalent atom for the atom ",i5," in the cell ",i5)') i,icell
               stop 'No equivalent atom'
            end do ATOM
         end do
         icell = 1
         do jcell=1,nlpnt
            do j=1,natm 
               ja=3*(j-1)+1
               jr=nr(j,jcell)
               jra=3*(jr-1)+1
               jrc = lr(j,jcell)
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=nr(i,icell)
                  ira=3*(ir-1)+1
                  irc = lr(i,icell)
                  kcell = llr(irc,jrc)
                  tensor(1:3,1:3)=nonsym_fc(ia:ia+2,ja:ja+2,jcell)
                  call rotate_tensor(tensor,n)
                  fc(ira:ira+2,jra:jra+2,kcell)= &
                       & fc(ira:ira+2,jra:jra+2,kcell) + tensor(1:3,1:3)
               end do
            end do
         end do
      end do
      fc(1:nmodes,1:nmodes,1:nlpnt) = fc(1:nmodes,1:nmodes,1:nlpnt)/nopr
      deallocate(nonsym_fc)
    end subroutine symmetrize_force_const_Real

    subroutine rotate_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      real(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      real(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
!!$tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
                  tnew(i,l)=tnew(i,l)+op(i,j,n)*tensor(j,k)*op(l,k,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_tensor

    subroutine symmetrize_force_const_Fourier(fcq,natm,cps)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : nopr,op
      complex(kind=DP), intent(inout) :: fcq(nmodes,nmodes,nqvec)
      integer, intent(in) :: natm
      real(kind=DP), dimension(natm,3) :: cps
      ! local variables
      integer :: i,j,nop,iq
!!$  complex(kind=DP) :: nonsym_fcq(nmodes,nmodes,nqvec)
      complex(kind=DP),allocatable,dimension(:,:,:) :: nonsym_fcq
      complex(kind=DP) :: tensor(3,3)
      complex(kind=DP) :: expgr
      real(kind=DP) :: ph,g(3)

      allocate(nonsym_fcq(nmodes,nmodes,nqvec));nonsym_fcq=0.d0
      nonsym_fcq(1:nmodes,1:nmodes,1:nqvec) = fcq(1:nmodes,1:nmodes,1:nqvec)
      fcq(1:nmodes,1:nmodes,1:nqvec) = 0.d0

      do iq=1,nqvec
         nop = 0
         do n=1,nopr
            if(.not.fksym(n,iq)) cycle
            nop = nop + 1
            g = matmul(op(1:3,1:3,n),qvec(iq,1:3)) - qvec(iq,1:3)
            do j=1,natm
               ja=3*(j-1)+1
               jr=napt(j,n)
               jra=3*(jr-1)+1
               do i=1,natm
                  ia=3*(i-1)+1
                  ir=napt(i,n)
                  ira=3*(ir-1)+1
                  ph = dot_product(g,cps(j,1:3)-cps(i,1:3))
                  expgr = dcmplx(cos(ph),sin(ph))
                  tensor(1:3,1:3)=nonsym_fcq(ira:ira+2,jra:jra+2,iq)
                  call rotate_complex_tensor(tensor,n)
                  fcq(ia:ia+2,ja:ja+2,iq)= &
                       & fcq(ia:ia+2,ja:ja+2,iq) + tensor(1:3,1:3)*expgr
               end do
            end do
         end do
         fcq(1:nmodes,1:nmodes,iq) = fcq(1:nmodes,1:nmodes,iq)/nop
      end do
      deallocate(nonsym_fcq)
      do iq=1,nqvec
         do j=1,nmodes
            do i=1,j
               fcq(i,j,iq)=(fcq(i,j,iq)+dconjg(fcq(j,i,iq)))*0.5d0
               fcq(j,i,iq)=dconjg(fcq(i,j,iq))
            end do
         end do
      end do

    end subroutine symmetrize_force_const_Fourier


    subroutine rotate_complex_tensor(tensor,n)
      use m_Crystal_Structure, only : op
      complex(kind=DP), intent(inout) :: tensor(3,3)
      integer, intent(in) :: n ! index of rotation

      ! local variables
      integer :: i,j,k,l
      complex(kind=DP) :: tnew(3,3)

      tnew(1:3,1:3)=0.d0

      do l=1,3
         do i=1,3
            do k=1,3
               do j=1,3
                  tnew(i,l)=tnew(i,l)+op(j,i,n)*tensor(j,k)*op(k,l,n)
               end do
            end do
         end do
      end do

      tensor(1:3,1:3)=tnew(1:3,1:3)
    end subroutine rotate_complex_tensor

    subroutine write_dynmat(dynmat)
      real(kind=DP), intent(in) :: dynmat(nmodes,nmodes,nlpnt)
      integer :: icell,l1,l2,l3,n
      do icell=1,nlpnt
         l1 = nint(sum(rltv(1:3,1)*lpnt(icell,1:3))/PAI2)
         l2 = nint(sum(rltv(1:3,2)*lpnt(icell,1:3))/PAI2)
         l3 = nint(sum(rltv(1:3,3)*lpnt(icell,1:3))/PAI2)
         write(nfout,'("icell=",i4," l1=",i3," l2=",i3," l3=",i3," lp=",3f10.5)') icell,l1,l2,l3,lpnt(icell,1:3)
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dynmat(n,1:nmodes,icell)
         end do
      end do
    end subroutine write_dynmat

    subroutine write_dynmatq(dynmatq)
      complex(kind=DP), intent(in) :: dynmatq(nmodes,nmodes,nqvec)
      integer :: iq
      do iq=1,nqvec
         write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
         write(nfout,'("=== Real part ===")') 
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dble(dynmatq(n,1:nmodes,iq))
         end do
         write(nfout,'("=== Imag part ===")') 
         do n=1,nmodes
            write(nfout,'(50(1x,e12.5))') dimag(dynmatq(n,1:nmodes,iq))
         end do
      end do
    end subroutine write_dynmatq

    subroutine calc_napart_gamma(iq,nafc)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)

      real(kind=DP) :: coefna,kzeff(nmodes)
      integer :: i,j,na,ia

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qdir(iq,i)*dielectric(i,j)*qdir(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         if (imdtyp(na) == OFF) cycle
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,ia,na))
            !kzeff(i) = sum(qdir(iq,1:3)*zeff(1:3,mode2atom(i),na))
         end do
      end do
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)
         end do
      end do

    end subroutine calc_napart_gamma

    subroutine calc_napart_parlinski(iq,nafc,g2bz)
      integer, intent(in) :: iq
      complex(kind=DP), intent(out) :: nafc(nmodes,nmodes)
      real(kind=DP), intent(in) :: g2bz

      real(kind=DP) :: coefna,kzeff(nmodes)
      real(kind=DP) :: expk,rho2
      integer :: i,j,na,ia

      rho2 = rho_loto**2*g2bz*0.25d0

      coefna = 0.d0
      do j=1,3
         do i=1,3
            coefna = coefna + qvec(iq,i)*dielectric(i,j)*qvec(iq,j)
         end do
      end do
      coefna = PAI4/(univol*coefna)
      i=0
      do na=1,natm
         if(imdtyp(na)==OFF)cycle
         do ia=1,3
            i=i+1
            kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,ia,na))
            !kzeff(i) = sum(qvec(iq,1:3)*zeff(1:3,mode2atom(i),na))
         end do
      end do
      expk = exp(-PAI**2*sum(qvec(iq,1:3)**2)/rho2)
      do j=1,nmodes
         do i=1,nmodes
            nafc(i,j) = coefna*kzeff(i)*kzeff(j)*expk
         end do
      end do

    end subroutine calc_napart_parlinski

    subroutine get_g2bz(g2)
      real(kind=DP), intent(out) :: g2

      integer :: i,j,k
      real(kind=DP) :: g(3),gg

      g2 = dot_product(rltv(1:3,1),rltv(1:3,1))
      do i=-2,2
         do j=-2,2
            do k=-2,2
               g(1:3) = i*rltv(1:3,1)+j*rltv(1:3,2)+k*rltv(1:3,3)
               gg = dot_product(g,g)
               if(abs(gg) > eps .and. gg < g2) then
                  g2 = gg
               end if
            end do
         end do
      end do
    end subroutine get_g2bz

  end subroutine m_Phonon_calc_dynamical_matrix

  subroutine m_Phonon_force_constant_matrix(force_const_mat)
    implicit none

    real(kind=DP), intent(out) :: force_const_mat(nmodes,nmodes,nlpnt)

    ! local variables
    integer :: is,nc,ind,i,j,jj,ic,icell
    real(kind=DP) :: ui,x
    real(kind=DP), allocatable :: cmat(:,:) !dim(nc,nc)
    real(kind=DP), allocatable :: fvec(:) !dim(nc)

    if(sw_polynomial_fit == ON) then
       nc = norder*2+1
       allocate(cmat(nc,nc)); cmat = 0.d0
       allocate(fvec(nc))
       cmat(1:nc,1) = 1.d0
       ind = 1
       do is = -norder,norder
          if(is==0) cycle
          ind=ind+1
          x = u/dble(is)
          do i=2,nc
             cmat(ind,i) = x**(i-1)
          end do
       end do
       do ic=1,nlpnt
          do j=1,nmodes
             jj = nmodes*(ic-1)+j
             do i=1,nmodes
                fvec(1) = force0(jj)
                fvec(2:nc) = forces(jj,i,1:nc-1)
                force_const_mat(i,j,ic) = -polyfit_diff(nc,cmat,fvec)
             end do
          end do
       end do
    else
       ui=dble(norder)/u
       if(printable .and. ipriphonon>=2) then
          write(nfout,*) 'u=',u
          write(nfout,*) 'ui= norder/u =',ui
       endif
       if(norder == 1) then
          ui = -0.5d0*ui
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (forces(jj,i,2)-forces(jj,i,1))*ui
                end do
             end do
          end do
       else if(norder == 2) then
          ui = -ui/12.d0
          do ic=1,nlpnt
             do j=1,nmodes
                jj = nmodes*(ic-1)+j
                do i=1,nmodes
                   force_const_mat(i,j,ic) = (-8.d0*forces(jj,i,1)+forces(jj,i,2) &
                        &  -forces(jj,i,3)+8.d0*forces(jj,i,4))*ui
                end do
             end do
          end do
       else
          stop 'Your inputed norder is not supported for the differencial approximation.'
       end if
    end if

  contains

    function polyfit_diff(nd,mat,vec)
      implicit none

      real(kind=DP) :: polyfit_diff

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: mat(nd,nd)
      real(kind=DP), intent(in) :: vec(nd)

      ! local variables
      integer :: ipiv(nd),info,i
      real(kind=DP) :: a(nd,nd),b(nd)
      real(kind=DP) :: x0,df
      real(kind=DP) :: xold
      real(kind=DP) :: eps = 1.d-10

      real(kind=DP) :: ux

      ! debug
      !  write(nfout,*) '<<polyfit_diff>>'
      !  call flush(nfout)
      ! end debug

      a = mat
      b = vec

      !debug
      !do i=1,nd
      !  write(nfout,*) 'a=',a(i,1:nd)
      !end do
      !do i=1,nd
      !  write(nfout,*) 'b=',b(i)
      !end do
      !  call flush(nfout)
      !end debug

      call dgesv(nd,1,a,nd,ipiv,b,nd,info)
      if(info .ne. 0 ) then
         if(printable) write(nfout,*) 'LAPACK routine DGETRS failure: info=',info
         stop 'LAPACK routine DGETRS failure'
      end if
      ! debug
      !  do i=1,nd
      !    print *,'i=',i,' b=',b(i)
      !  end do
      !  write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(1),polyfunc(nd,b,0.d0)
      !  i=0
      !  do is=-norder,norder
      !    if(is==0) cycle
      !    i=i+1
      !    ux = u/dble(is) 
      !    write(nfout,'("ux="f10.5," f=",2(1x,f15.10))') ux,vec(i+1),polyfunc(nd,b,ux)
      !  end do
      !  call flush(nfout)
      ! end debug

      x0 = 0.d0
      df = diff_polyfunc(nd,b,x0)
      ! debug
      !print *,'df=',df
      ! end debug
      polyfit_diff = df

    end function polyfit_diff

    function polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: f

      f = b(1)
      do i=2,nd
         f = f + b(i)*x**(i-1)
      end do
      polyfunc = f

    end function polyfunc

    function diff_polyfunc(nd,b,x)
      implicit none

      real(kind=DP) :: diff_polyfunc

      integer, intent(in) :: nd
      real(kind=DP), intent(in) :: b(nd),x

      integer :: i
      real(kind=DP) :: df

      df = b(2)
      do i=3,nd
         df = df + b(i)*dble(i-1)*x**(i-2)
      end do
      diff_polyfunc = df

    end function diff_polyfunc

  end subroutine m_Phonon_force_constant_matrix


  subroutine m_Phonon_calc_vib_modes()
    implicit none

    ! local variables
    integer :: i,j
!!$real(DP) :: eps=1.d-8
    real(DP) :: eps=1.d-16
    real(DP) :: norm

    allocate(omega(nmodes,nqvec),modes(nmodes,nmodes,nqvec))

    write(nfout,*) 'calc_vib_modes is started.'

    do j=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') j,qvin(j,1:3)
       call solve_eigenproblem(dynmatq(1,1,j) ,omega(1,j),modes(1,1,j))
       do i=1,nmodes
          if(ipriphonon>=2) &
               & write(nfout,*) 'omega**2 = ',omega(i,j)  
          if(abs(omega(i,j)) < eps) omega(i,j)=0.d0
          if(omega(i,j) > 0.d0) then
             omega(i,j)=sqrt(omega(i,j))
          else
             omega(i,j)=-sqrt(abs(omega(i,j))) ! for the soft mode
          end if
          if(ipriphonon >=2) &
               & write(nfout,*) '==> omega = ',omega(i,j)  
       end do
    end do

    deallocate(dynmatq)

  contains
    subroutine solve_eigenproblem(dynmat,omega,modes)
      complex(kind=DP), intent(inout) :: dynmat(nmodes,nmodes)
      real(kind=DP), intent(out)      :: omega(nmodes)
      complex(kind=DP), intent(out)   :: modes(nmodes,nmodes)

      real(kind=DP) :: abstol
      integer :: lcwork,lrwork,liwork
      complex(kind=DP), allocatable :: cwork(:) ! dim(lcwork)
      real(kind=DP), allocatable :: rwork(:) ! dim(lrwork)
      integer, allocatable :: iwork(:) ! dim(liwork)
      integer, allocatable :: ifail(:) ! dim(nmodes)
      integer :: info
      integer :: m
      integer :: il,iu
      real(DP) :: vl,vu

      real(DP), external :: dlamch

      abstol=2*dlamch('S')
      !abstol=4.45014771701440D-308
      !print *,'abstol=',abstol
!!$lwork=8*nmodes
      lcwork=4*nmodes
      lrwork=7*nmodes
      liwork=5*nmodes
!!$allocate(work(lwork))
      allocate(cwork(lcwork))
      allocate(rwork(lrwork))
      allocate(iwork(liwork),ifail(nmodes))
      lcwork=-1
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      lcwork = cwork(1)
      !print *,'lwork=',lwork
      !print *,'info=',info
      deallocate(cwork)
      allocate(cwork(lcwork))
      call zheevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu,abstol, &
           &      m,omega,modes,nmodes,cwork,lcwork,rwork,iwork,ifail,info)
!!$call dsyevx('V','A','U',nmodes,dynmat,nmodes,vl,vu,il,iu, &
!!$ &      abstol,m,omega,modes,nmodes,work,lwork,iwork, &
!!$ &      ifail,info)
      !print *,'info=',info
      !print *,'ifail=',ifail(1:nmodes)
      deallocate(cwork,rwork,iwork,ifail)
    end subroutine solve_eigenproblem
  end subroutine m_Phonon_calc_vib_modes

  subroutine m_Phonon_det_irr_rep()
    use m_Representation, only : get_irr_rep
    use m_Crystal_Structure, only : nopr
    use m_Ionic_System, only : imdtyp
    implicit none

    ! local variabes
    integer :: i,j,ia,ja,ist,n
    real(DP) :: norm
    real(DP) :: eir(3),ejr(3),xir(1:nmodes)
    real(DP) :: eii(3),eji(3),xii(1:nmodes)
    integer :: nrep,nsym
    integer :: rep(48,12)
    character(len=3) :: symbol_irrep(12)
    character(len=4) :: active_rep(12)
    real(DP) :: eps = 1.d-1
    integer :: iq
    integer :: icount,jcount

    allocate(atm2mobileatm(natm_prim));atm2mobileatm=0
    icount=0
    do i=1,natm_prim
       if(imdtyp(i) /= OFF)then
         icount = icount+1
         atm2mobileatm(i) = icount
       endif
    enddo

    write(nfout,*) '** Representation **'

    allocate(mode_irr_rep(nmodes,nqvec))
    allocate(mode_active(nmodes,nqvec))
    do iq=1,nqvec
       write(nfout,'(i4," q=(",f8.3,",",f8.3,",",f8.3,")")') iq,qvin(iq,1:3)
       call get_irr_rep(point_group(iq),nsym,nrep,rep,symbol_irrep,active_rep)

       if(printable)  then
          write(nfout,'("Character table:",a3)') point_group(iq)
          do j=1,nrep
             write(nfout,'(a3,1x,48i3)') symbol_irrep(j), rep(1:nsym,j)
          end do
       end if
       ! debug
       !write(nfout,'("Product table:",a3)') point_group
       !do j=1,nrep
       !  write(nfout,'(a3,1x,48i3)') symbol_irrep(j),(sum(rep(1:nopr,j)*rep(1:nopr,i)),i=1,nrep)
       !end do
       ! end debug

       if ( printable ) then
          write(nfout,*) '** mode  repr. active **'
       endif

       do i=1,nmodes
          ! debug
          !        write(nfout,*) 'index of the mode =',i
          !        write(nfout,*) 'norm =',sum(dble(modes(1:nmodes,i,iq))**2+dimag(modes(1:nmodes,i,iq))**2)
          ! end debug
          mode_irr_rep(i,iq)='NON'
          Representation: do j=1,nrep
             xir(1:nmodes)=0.d0
             xii(1:nmodes)=0.d0
             do n=1,nopr
                icount = 0
                do ia=1,natm
                   if(imdtyp(ia)==OFF)cycle
                   !ist = 3*(ia-1)+1
                   icount = icount+1
                   ist = 3*(icount-1)+1
                   eir(1:3) = dble(modes(ist:ist+2,i,iq))
                   eii(1:3) = dimag(modes(ist:ist+2,i,iq))
                   call rotate_eigenvector(n,ia,ja,eir,ejr)
                   call rotate_eigenvector(n,ia,ja,eii,eji)
                   if ( atm2mobileatm(ja) ==0 ) cycle
                   ist = 3*(atm2mobileatm(ja)-1)+1
                   xir(ist:ist+2)=xir(ist:ist+2)+rep(n,j)*ejr(1:3)
                   xii(ist:ist+2)=xii(ist:ist+2)+rep(n,j)*eji(1:3)
                   ! debug
                   !        write(nfout,*) 'j =',j
                   !        write(nfout,*) 'n =',n
                   !        write(nfout,*) 'ia=',ia
                   !        write(nfout,*) 'eir=',eir(1:3)
                   !        write(nfout,*) 'eii=',eii(1:3)
                   !        write(nfout,*) 'ja=',ja
                   !        write(nfout,*) 'ejr=',ejr(1:3)
                   !        write(nfout,*) 'eji=',eji(1:3)
                   ! end debug
                end do
             end do
             !xi(1:nmodes) = xi(1:nmodes)/nopr 
             norm = sum(xir(1:nmodes)**2+xii(1:nmodes)**2)
             ! debug
             !write(nfout,*) 'j=',j,' norm=',norm
             ! end debug
             if(norm > eps) then
                mode_irr_rep(i,iq)= symbol_irrep(j)
                mode_active(i,iq) = active_rep(j)
                ! exit Representation
             end if
          end do Representation

          if(printable) then
             write(nfout,'(1x,i5,5x,a3,4x,a4)') i,mode_irr_rep(i,iq),mode_active(i,iq)
          endif
       end do
    end do ! q loop

    deallocate(atm2mobileatm)
  contains

    subroutine rotate_eigenvector(n,ia,ja,ei,ej)
      use m_Ionic_System, only : napt
      use m_Crystal_Structure, only : op
      integer, intent(in) :: n, ia
      integer, intent(out) :: ja
      real(kind=DP), intent(in) :: ei(3)
      real(kind=DP), intent(out) :: ej(3)

      ! local variables
      integer :: i

      ja = napt(ia,n)

      do i=1,3
         ej(i) = sum(op(i,1:3,n)*ei(1:3))
      end do

    end subroutine rotate_eigenvector

  end subroutine m_Phonon_det_irr_rep


  subroutine m_Phonon_calc_static_dielectric()
    use m_Crystal_Structure, only : univol
    implicit none

    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV
    real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
    end do

    coef = 16.d0*atan(1.d0)/univol
    lattice_dielectric(1:3,1:3) = 0.d0

    if (printable) then
       write(nfout,*) "*** Contribution to diagonal sum of dielectric tensor ***"
       write(nfout,'(A,15X,A)') '  mode   Repr. Active            Freq [cm-1]', &
            &                  ' Contrib.'
    endif

    do im=1,nmodes
       if(omega(im,nqvec)>1.d-10) then
          do j=1,3
             do i=1,3
                lattice_dielectric(i,j) = lattice_dielectric(i,j) +  &
                     & zeff_mode(i,im)*zeff_mode(j,im)/omega(im,nqvec)**2
             end do
          end do
          if(printable) write(nfout,'("im=",i6,1x,a3,1x,a4,2(1x,f25.10))')  &
               &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
               & ,omega(im,nqvec)*ha2ev *ev2cminv &
               & ,coef*sum(zeff_mode(1:3,im)**2)/omega(im,nqvec)**2
       end if
    end do
    lattice_dielectric(1:3,1:3) = coef*lattice_dielectric(1:3,1:3)

    static_dielectric(1:3,1:3) =  &
         & lattice_dielectric(1:3,1:3) + dielectric(1:3,1:3)

  end subroutine m_Phonon_calc_static_dielectric


  subroutine m_Phonon_write_vib_modes()
    use m_Files, only : m_Files_open_nfmode, nfmode
    use m_Ionic_System, only : cps,imdtyp
    use m_Crystal_Structure, only : altv
    implicit none

    ! local variabes
!    real(DP), parameter :: amu = AMU ! 1 amu = 1822.88847974 Me
    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV
    real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
    integer :: i,j,istart,iq
    real(DP) :: omega_ev,omega_cm 
    real(DP) :: zamu(3),znorm
    real(DP) :: x,hbarW,free_e
    integer :: icount,jcount

    call  m_Files_open_nfmode()

    if(mype /= 0) return

    write(nfmode,'(1x,"--- primitive lattice vectors ---")') 
    do i=1,3
       write(nfmode,'(1x,3(f14.10,1x))') altv(1:3,i)
    end do
    write(nfmode,'(1x,"--- Equilibrium position and mass of each atom---")') 
    write(nfmode,'(1x,"Natom=",i5)') natm
    do i=1,natm
       write(nfmode,'(1x,i5,3(1x,f14.10),1x,f14.5,1x,a4)') &
            &                      i,cps(i,1:3),ionic_mass(i),speciesname(ityp(i))
    end do
    write(nfmode,'(1x,"--- Vibrational modes ---")') 
    if(phonon_method == PHONON_GAMMA) then
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5)') nmodes,natm
    else
       write(nfmode,'(1x,"Nmode=",i5," Natom=",i5," Nqvec",i5)') nmodes,natm,nqvec
    end if
    if(phonon_method==PHONON_DOS .and. way_of_smearing==FERMI_DIRAC) free_e=0.d0
    do iq=1,nqvec
       if(phonon_method == PHONON_DOS) then
          write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")",1x,f15.10)') &
               & iq,qvin(iq,1:3),qvec(iq,1:3),wght(iq)
       else if(phonon_method /= PHONON_GAMMA) then
          write(nfmode,'(1x,"iq=",i5," q=(",f15.10,",",f15.10,",",f15.10,") (",f15.10,",",f15.10,",",f15.10,")")') &
               & iq,qvin(iq,1:3),qvec(iq,1:3)
       end if
       do i=1,nmodes
          omega_ev = omega(i,iq)*ha2ev
          omega_cm = omega_ev*ev2cminv 
          write(nfmode,'(1x,"n= ",i5,1x,a3,1x,a4, &
               &                  /5x,"hbarW= ",e15.8," Ha = ",e15.8," eV; nu= ",e15.8," cm^-1")') &
               &                  i,mode_irr_rep(i,iq),mode_active(i,iq),omega(i,iq),omega_ev,omega_cm
          jcount=0
          do j=1,natm
             if(imdtyp(j)==OFF)cycle
             jcount = jcount+1
             istart = 3*(jcount-1)+1
             write(nfmode,'(1x,i5,1x,3f14.10)') j,dble(modes(istart:istart+2,i,iq))
          end do
          if(nqvec>1) then
             jcount=0
             do j=1,natm
                if(imdtyp(j)==OFF)cycle
                jcount = jcount+1
                istart = 3*(jcount-1)+1
                write(nfmode,'(1x,i5,1x,3f14.10)') j,dimag(modes(istart:istart+2,i,iq))
             end do
          end if
          if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
             write(nfmode,'(3x,"Mode effective charge and its norm:")')
             zamu(1:3)=zeff_mode(1:3,i)*sqrt(amu)
             znorm = sqrt(sum(zamu(1:3)**2)) 
             write(nfmode,'(3x,"Z=",3(f14.10,1x),"Norm=",f14.10)') zamu(1:3),znorm
          end if
          if(phonon_method == PHONON_DOS.and.way_of_smearing==FERMI_DIRAC)then
             hbarW = omega(i,iq)
             x = hbarW/width
             if(x.gt.1.d-10) free_e = free_e + wght(iq)*(0.5d0*hbarW+width*log(1.d0-exp(-x)))
          endif
       end do
    end do
    if(phonon_method == PHONON_GAMMA.and.sw_lattice_dielectric_tensor == ON) then
       write(nfmode,'(1x,"--- Lattice and static dielectric tensors ---")') 
       do i=1,3
          write(nfmode,'(1x,"[",3(1x,f10.4)," ]",2x,"[",3(1x,f10.4)," ]")') &
               & lattice_dielectric(i,1:3), static_dielectric(i,1:3)
       end do
    end if
    if(way_of_smearing==FERMI_DIRAC.and.phonon_method==PHONON_DOS.and.printable)then
       write(nfout,'(a,f15.10,a)') '!** Free energy due to lattice vibration : ',free_e,' hartree/cell'
    endif

    return
  end subroutine m_Phonon_write_vib_modes

  subroutine m_Phonon_write_epsilon()
    use m_Crystal_Structure, only : univol
    use m_Files, only : m_Files_open_nfepsilon, nfepsilon
    implicit none

    ! local variables
    real(DP), parameter :: ha2ev = Hartree ! 1 Ha = 27.211383411 eV
    integer :: n,im,i,j
    real(kind=DP) :: e,de,e2,e3,e4
    real(kind=DP) :: coef
    real(kind=DP) :: epsilon(3,3,2,0:num_division)

    if(nqvec /= 1) return

    coef = 16.d0*atan(1.d0)/univol
    de = (max_energy-min_energy)/num_division

    do n=0,num_division
       e = min_energy + de * n
       epsilon(1:3,1:3,1:2,n) = 0.d0
       do im=1,nmodes
          if(omega(im,nqvec)>1.d-5) then
             e2 = omega(im,nqvec)**2-e**2
             e3 = e*omega(im,nqvec)*damping_factor
             e4 = e2**2+e3**2
             if(abs(damping_factor) < 1.d-10) then
                if(abs(omega(im,nqvec)-e) < 1.d-10) then
                   if(e2 > 0.d0) then
                      e2 = 1.d-10   
                   else
                      e2 = -1.d-10
                   end if
                end if
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)/e2
                      epsilon(i,j,2,n) = 0.d0
                   end do
                end do
             else
                do j=1,3
                   do i=1,j
                      epsilon(i,j,1,n) = epsilon(i,j,1,n) + zeff_mode(i,im)*zeff_mode(j,im)*e2/e4
                      epsilon(i,j,2,n) = epsilon(i,j,2,n) + zeff_mode(i,im)*zeff_mode(j,im)*e3/e4
                   end do
                end do
             end if
          end if
       end do
       epsilon(1:3,1:3,1,n)=dielectric(1:3,1:3)+coef*epsilon(1:3,1:3,1,n)
       epsilon(1:3,1:3,2,n)=coef*epsilon(1:3,1:3,2,n)
    end do

    call m_Files_open_nfepsilon()
    if(mype /= 0) return
    write(nfepsilon,'("Energy(eV) E1xx E1yy E1zz E1yz E1zx E1xy E2xx E2yy E2zz E2yz E2zx E2xy")')
    do n=0,num_division
       e = (min_energy + de * n) * ha2ev
       write(nfepsilon,'(13(1x,e25.10))') &
            & e, ((epsilon(i,i,j,n),i=1,3),epsilon(2,3,j,n),epsilon(1,3,j,n),epsilon(1,2,j,n),j=1,2)
    end do

  end subroutine m_Phonon_write_epsilon

  subroutine m_Phonon_set_supercell
    use m_Crystal_Structure, only: m_CS_supercell_on
    integer :: n1,n2,n3
    n1 = nlat(1)
    n2 = nlat(2)
    n3 = nlat(3)
    if(n1==0.and.n2==0.and.n3==0) then
       n1 = 1; n2 = 1; n3 = 1
       call m_CS_supercell_on(nfout,1,n1,n2,n3) ! 1: PRIMITIVE
    else
       call m_CS_supercell_on(nfout,0,n1,n2,n3) ! 0: BRAVAIS
    end if
  end subroutine m_Phonon_set_supercell

  subroutine m_Phonon_calc_dos()
    integer :: idim = 3
    integer :: iq,im,ie
    integer :: newin
    real(kind=DP) :: emin,emax
    !  real(kind=DP), dimension(np2,nmodes) :: omega2
    !  real(kind=DP), dimension(np0) :: eawk, cdwk, cswk
    real(kind=DP), allocatable, dimension(:,:) :: omega2 ! dim(np2,nmodes)      <ASMS>
    real(kind=DP), allocatable, dimension(:)   :: eawk, cdwk, cswk ! dim(np0)   <ASMS>
    real(kind=DP), allocatable, dimension(:,:,:) :: cdos,cind ! dim(np2,nmodes,0:newin)
    real(kind=DP), allocatable, dimension(:) :: e,dos,sumdos ! dim(0:newin)

    allocate(omega2(np2,nmodes))                     ! <ASMS>
    allocate(eawk(np0),cdwk(np0),cswk(np0))          ! <ASMS>
    eawk=0.d0
    cdwk=0.d0
    cswk=0.d0

    do iq=1,np2
       do im=1,nmodes 
          omega2(iq,im) = omega(im,iq) * 1.0d3
       end do
    end do

    emin = minval(omega2) - 0.0005 ! (mhartree)
    emax = maxval(omega2) + 0.0005 ! (mhartree)
    newin = (emax - emin)/(DeltaE_dos*1.0d3) + 1

    allocate(cdos(np2,nmodes,0:newin)); cdos = 0.d0
    allocate(cind(np2,nmodes,0:newin)); cind = 0.d0

    allocate(e(0:newin))
    allocate(dos(0:newin)); dos=0.d0
    allocate(sumdos(0:newin)); sumdos=0.d0
    e(0:newin) = (/(emin + (DeltaE_dos*1.0d3)*ie,ie=0,newin)/)

    call nstt3i(idim,newin,e,nxyz_tetra(1),nxyz_tetra(2),nxyz_tetra(3) &
         &  ,np2,np2,nmodes,omega2 &
         &  ,ip20,np0,eawk,cdwk,cswk,np2,nmodes,cdos,cind,width_tetra )

    do iq=1,np2
       do im=1,nmodes
          do ie=0,newin
             dos(ie)    = dos(ie)    + cdos(iq,im,ie)
             sumdos(ie) = sumdos(ie) + cind(iq,im,ie)
          end do
       end do
    end do
    deallocate(cdos)
    deallocate(cind)

    call write_dos(newin,e,dos,sumdos)

    deallocate(e)
    deallocate(dos)
    deallocate(sumdos)
  contains

    subroutine write_dos(newin,e,dos,sumdos)
      use m_Files, only : m_Files_open_nfphdos, nfphdos
      integer, intent(in) :: newin
      real(kind=DP), intent(in) :: e(0:newin), dos(0:newin), sumdos(0:newin)
      integer :: ie
      real(DP), parameter :: ha2ev = Hartree
      real(DP), parameter :: ev2cminv = 1.d0/1.23984185d-4 ! 1 cm^-1 = 1.233984185e-4 eV
      real(DP) :: eev, ecminv, dosev, doscminv

      if(mype /= 0) return
      call m_Files_open_nfphdos()

      write(nfphdos,'("# Index Omega(mHa) Omega(eV) Omega(cm-1) DOS(States/mHa) DOS(States/eV) DOS(States/cm-1) IntDOS(States)")') 
      do ie = 0, newin
         eev = e(ie)*ha2ev/1.0d3  ! Hartree
         ecminv = eev*ev2cminv
         dosev = dos(ie)/ha2ev*1.0d3 ! Hartree
         doscminv = dosev/ev2cminv
         write(nfphdos,'(i7,7(1x,f15.8))') ie,e(ie), eev, ecminv, dos(ie), dosev, doscminv, sumdos(ie)
      end do
    end subroutine write_dos
  end subroutine m_Phonon_calc_dos

  subroutine m_Phonon_read_strain_forces
    use m_Files, only : nfout, nfstrfrc, m_Files_open_nfstrfrc
    integer :: i, ia, num_force, istr, ipm
    real(kind=DP) :: str, force(3,natm,6,2), strain(6,2), eps(3,3)
    logical :: present(6)

    strain = 0.d0
    present = .false.

    allocate(strfrc(3,natm,6))
    strfrc = 0.d0

    call m_Files_open_nfstrfrc()
    read(nfstrfrc,*) num_force
    do i=1,num_force
       read(nfstrfrc,*) istr, str
       if(str>0.d0) then
          ipm = 1
       else
          ipm = 2
       end if
       strain(istr,ipm) = str
       do ia=1,natm
          read(nfstrfrc,*) force(1:3,ia,istr,ipm)
       end do
    end do

    do istr=1,6
       if(strain(istr,1) > 1.d-8 .and. strain(istr,2) < -1.d-8 &
            & .and. abs(abs(strain(istr,1))-abs(strain(istr,2))) < 1.d-10) then
          present(istr) = .true.
       end if
    end do

    write(nfout,*) 'present strain : ',present

    do istr=1,6
       if(.not.present(istr)) cycle
       str = strain(istr,1)-strain(istr,2)
       eps = 0.d0
       if(istr==1) then
          eps(1,1) = 0.5d0
       else if(istr==2) then
          eps(2,2) = 0.5d0
       else if(istr==3) then
          eps(3,3) = 0.5d0
       else if(istr==4) then
          eps(2,3) = 0.25d0
          eps(3,2) = 0.25d0
       else if(istr==5) then
          eps(3,1) = 0.25d0
          eps(1,3) = 0.25d0
       else if(istr==6) then
          eps(1,2) = 0.25d0
          eps(2,1) = 0.25d0
       end if
       do ia=1,natm
          strfrc(1:3,ia,istr) = (force(1:3,ia,istr,1)-force(1:3,ia,istr,2))/str &
               & + matmul(eps,force(1:3,ia,istr,1)+force(1:3,ia,istr,2))
       end do
    end do

    write(nfout,*) '=== Strain-force coupling constants ==='
    do istr=1,6
       if(.not.present(istr)) cycle
       write(nfout,'("Strain : ",i1)') istr
       do ia=1,natm
          Write(nfout,'(i5,3(1x,f15.5))') ia,strfrc(1:3,ia,istr)
       end do
    end do

  end subroutine m_Phonon_read_strain_forces


  subroutine m_Phonon_calc_int_strain_piezo
    use m_Crystal_Structure, only : univol
    implicit none

    ! local variables
    integer :: im,i,na,ia,j
    real(DP) :: zsum,csum
    real(DP) :: coef

    if(sw_lo_to_splitting == ON) return
    if(nqvec/=1) return

    allocate(zeff_mode(3,nmodes))
    allocate(strphcpl(6,nmodes))
    do im=1,nmodes
       do i=1,3
          zsum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                zsum = zsum + zeff(i,ia,na)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          zeff_mode(i,im) = zsum
       end do
       do i=1,6
          csum = 0.d0
          j=0
          do na=1,natm
             do ia=1,3
                j=j+1
                csum = csum + strfrc(ia,na,i)*dble(modes(j,im,nqvec))*msqinv(j)
             end do
          end do
          strphcpl(i,im) = csum
       end do
    end do

    coef = 1.d0/univol
    piezoelectric(1:3,1:6) = 0.d0
    do j=1,6
       do i=1,3
          write(nfout,'("Direction:",i1," Strain:",i1)') i,j
          do im=1,nmodes
             if(omega(im,nqvec)>1.d-10) then
                piezoelectric(i,j) = piezoelectric(i,j) +  &
                     & zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
                if(printable) write(nfout,'("im=",i4,1x,a3,1x,a4,3(1x,f25.10))')  &
                     &  im,mode_irr_rep(im,nqvec),mode_active(im,nqvec) &
                     & ,omega(im,nqvec)*Hartree/1.23984185d-4 &
                     & ,coef*zeff_mode(i,im)*strphcpl(j,im)/omega(im,nqvec)**2
             end if
          end do
       end do
    end do
    piezoelectric(1:3,1:6) = coef*piezoelectric(1:3,1:6)

    if(printable) then
       write(nfout,*) '=== Internal-strain piezoelectric tensor (a.u.) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)
       end do
       write(nfout,*) '=== Internal-strain piezoelectric tensor (C/m^2) ==='
       do j=1,6
          write(nfout,'(i5,3(1x,f18.10))') j, piezoelectric(1:3,j)*UNIT_PIEZO_CONST
       end do
    end if

  end subroutine m_Phonon_calc_int_strain_piezo

end module m_Phonon

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: mklfft
!
!  AUTHOR(S): T. Yamamoto   March/8/2006
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
#ifdef MKLFFT
module mklfft
!  $Id: mklfft.F90 570 2017-04-21 20:34:50Z yamasaki $
  use MKL_DFTI
  implicit none

  type mklfft_rdh
    TYPE(DFTI_DESCRIPTOR), POINTER :: dh_r1
    TYPE(DFTI_DESCRIPTOR), POINTER :: dh_c2
    integer :: worksize
    integer :: ldx,ldy,ldz
  end type

contains

  subroutine init_mkl_rfft(nx,ny,nz,ldx,ldy,ldz,rdh)
    integer, intent(in) :: nx,ny,nz,ldx,ldy,ldz
    type(mklfft_rdh), intent(inout) :: rdh

    integer :: strides(3),Status
    integer :: nc2(2)

    rdh%worksize = ldx*ldy*ldz/2
    rdh%ldx = ldx
    rdh%ldy = ldy
    rdh%ldz = ldz
    nc2(1)=nz; nc2(2)=ny

    ! REAL X FFT
    Status = DftiCreateDescriptor(rdh%dh_r1, &
     &       DFTI_DOUBLE,DFTI_REAL,1,nx)
    Status = DftiSetValue(rdh%dh_r1, &
     &       DFTI_NUMBER_OF_TRANSFORMS,ldy*nz)
    Status = DftiSetValue(rdh%dh_r1, &
     &       DFTI_INPUT_DISTANCE,ldx)
    Status = DftiCommitDescriptor(rdh%dh_r1)
    ! COMPLEX YZ FFT
    Status = DftiCreateDescriptor(rdh%dh_c2, &
     &       DFTI_DOUBLE,DFTI_COMPLEX,2,nc2)
    Status = DftiSetValue(rdh%dh_c2, &
    !! &       DFTI_NUMBER_OF_TRANSFORMS,nx)
     &       DFTI_NUMBER_OF_TRANSFORMS,nx/2+1)
    strides(1) = 0
    strides(2) = 1
    strides(3) = ldz
    Status = DftiSetValue(rdh%dh_c2,DFTI_INPUT_STRIDES,strides)
    Status = DftiSetValue(rdh%dh_c2,DFTI_INPUT_DISTANCE,ldz*ldy)
    Status = DftiCommitDescriptor(rdh%dh_c2)
  end subroutine init_mkl_rfft

  subroutine mkl_rfft(isw,rdh,a)
    integer, intent(in) :: isw
    type(mklfft_rdh), intent(in) :: rdh
    real(8), intent(inout) :: a(*)

    complex(8) :: work(rdh%worksize)
    integer :: ldx2,ldy,ldz

    ldx2 = rdh%ldx/2
    ldy = rdh%ldy
    ldz = rdh%ldz

    if(isw == -1) then
       call compute_forward(a,work)
    else if(isw == 1) then
       call compute_backward(a,work)
    else
       stop 'mklfft: isw is not 1 nor -1.'
    end if
  contains
    subroutine compute_forward(ar,ac)
      real(8), intent(inout) :: ar(*)
      complex(8), intent(inout) :: ac(*)
      integer :: Status
      Status = DftiComputeForward(rdh%dh_r1,ar)
      call trans_rc(ar,ac)
      Status = DftiComputeForward(rdh%dh_c2,ac)
      call trans_cr(ac,ar)
    end subroutine compute_forward
    subroutine compute_backward(ar,ac)
      real(8), intent(inout) :: ar(*)
      complex(8), intent(inout) :: ac(*)
      integer :: Status
      call trans_rc(ar,ac)
      Status = DftiComputeBackward(rdh%dh_c2,ac)
      call trans_cr(ac,ar)
      Status = DftiComputeBackward(rdh%dh_r1,ar)
    end subroutine compute_backward
    subroutine trans_rc(r,c)
      real(8), intent(in)  :: r(*)
      complex(8), intent(out) :: c(*)

      integer :: i,j,k
      integer :: ir,ic

      do i=1,ldx2
      do j=1,ldy
      do k=1,ldz
         ir = i + ldx2*((j-1) + ldy*(k-1))
         ic = k + ldz*((j-1) + ldy*(i-1))
         c(ic) = dcmplx(r(2*ir-1),r(2*ir))
      end do
      end do
      end do
    end subroutine trans_rc
    subroutine trans_cr(c,r)
      complex(8), intent(in) :: c(*)
      real(8), intent(out)  :: r(*)

      integer :: i,j,k
      integer :: ir,ic

      do i=1,ldx2
      do j=1,ldy
      do k=1,ldz
         ir = i + ldx2*((j-1) + ldy*(k-1))
         ic = k + ldz*((j-1) + ldy*(i-1))
         r(2*ir-1) = dble(c(ic))
         r(2*ir) = dimag(c(ic))
      end do
      end do
      end do
    end subroutine trans_cr
  end subroutine mkl_rfft

end module mklfft
#else
subroutine mklfft_dummy
end 
#endif

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: ChargeDensity_Mixing
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine WriteDownData_onto_Files(final_call)
! $Id: WriteDownData_onto_Files.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Files,               only : m_Files_open_nfcntn,    m_Files_close_all &
       &                          , m_Files_open_nfstatus,  m_Files_skiptoend &
       &                          , m_Files_close_nfinp &
       &                          , m_Files_reopen_nfcntn,  m_Files_reopen_nfcntn_bin &
       &                          , m_Files_close_nfcntn &
       &                          , m_Files_open_nfvlc  &
       &                          , m_Files_open_nfcntn_bin_paw, m_Files_close_nfcntn_bin_paw &
       &                          , m_Files_reopen_nfzaj,   m_Files_reopen_nfchgt &
       &                          , m_Files_open_nfefermi,  m_Files_close_nfefermi &
       &                          , m_Files_open_nfPsicoef, m_Files_close_nfPsicoef &
       &                          , m_Files_open_nfBandSymInput, m_Files_close_nfBandSymInput &
       &                          , m_Files_open_nfeng,     m_Files_close_nfeng &
       &                          , m_Files_checkpoint_dir, m_Files_close_logfile &
       &                          , nfstatus, F_ZAJ_partitioned, F_CHGT_partitioned &
       &                          , F_ZAJ_in_partitioned, F_CHGT_in_partitioned & 
       &                          , F_CNTN_BIN_partitioned, F_CNTN_BIN_in_partitioned &
#ifdef _EMPIRICAL_
       &                     ,nfcntn,nfout
#else 
       &                     ,nfcntn,nfchgt,nfzaj,nfpsicoef,nfbandsyminput,nfeng &
       &                     ,nfcntn_bin,nfout,nfvlc,nfefermi  &
       &                     ,nfcntn_bin_paw, F_ZAJ
#endif
  use m_Const_Parameters,    only: T_CONTROL, BLUEMOON, QUENCHED_CONSTRAINT &
       &                         , ON,OFF,YES,NO,FORCE_CONVERGED, Valence_plus_PC_Charge &
       &                         , VXC_AND_EXC, FINISH, INITIAL, EK_CONVERGED &
       &                         , CONTINUATION &
       &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION, ONE_BY_ONE, EK &
       &                         , DRIVER_CONSTRAINT, BFGS, GDIIS, ALL_AT_ONCE, GRID, P_CONTROL, PT_CONTROL &
       &                         , DRIVER_NEB
  use m_IterationNumbers,    only: m_Iter_wd_iteration_numbers &
       &                         , iteration, iteration_ionic, iteration_electronic
  use m_Timing,              only: tstatc_wd0, m_Timing_wd_status
  use m_Ionic_System,        only: m_IS_wd_pos_and_v, m_IS_wd_forcp_etc &
       &                         , m_IS_wd_nrsv,      m_IS_wd_cps, m_IS_wd_diis_history &
       &                         , m_IS_natm_can_change, m_IS_wd_curr_atom_reservoir &
       &                         , m_IS_wd_pos_brav
  use m_Total_Energy,        only: m_TE_wd_total_energy
  use m_Control_Parameters, only : imdalg,iconvergence_previous_job &
       &                         , continuation_using_ppdata &
       &                         , driver &
       &                         , m_CtrlP_wd_iconvergence &
       &                         , m_CtrlP_wd_edelta_ontheway &
       &                         , m_CtrlP_set_corecharge_cntnbin &
       &                         , m_CtrlP_wd_corecharge_cntnbin &
#ifndef _EMPIRICAL_
       &                         , sw_ekzaj, sw_hubbard, sw_positron &
       &                         , m_CtrlP_wd_neg &
       &                         , sw_rttddft,iconvergence &
#endif
       &                         , iprijobstatus, jobstatus_series, jobstatus_format &
       &                         , icond, sw_write_zaj &
       &                         , sw_optimize_lattice, ipricoefwf &
       &                         , sw_band_symmetry_analysis, iprimagmom &
       &                         , ipritiming &
       &                         , sw_output_hybrid_info
#ifndef _EMPIRICAL_
  use m_IterationNumbers,    only: m_Iter_wd_iters_and_nk
  use m_Control_Parameters,  only: sw_fine_STM_simulation, fixed_charge_k_parallel &
       &                         , m_CtrlP_wd_isolver &
       &                         , m_CtrlP_wd_iconv_ek
  use m_Kpoints,             only: kv3, kv3_ek, m_Kp_wd_kv3, m_Kp_wd_BandSymInput
  use m_PseudoPotential,     only: flg_paw,m_PP_wd_PAW_parameters
  use m_NonLocal_Potential,  only: m_NLP_wd_snl_3D
  use m_PseudoPotential,     only: m_PP_wd_PP_parameters_3D
  use m_ES_IO,               only: m_ESIO_wd_EigenValues, m_ESIO_wd_EigenValues_etc &
       &                         , m_ESIO_wd_Efermi
  use m_ES_IO,               only: m_ESIO_wd_WFs_3D
!!$       &                         , m_ESIO_wd_WFs_dp_3D &  ! write file DP test
  use m_Electronic_Structure,only: iconv_ek, vbm, efermi, metalic_system, check_if_metalic_flag
  use m_Charge_Density,      only: m_CD_wd_hsr
  use m_Charge_Density,      only: m_CD_wd_chgq
  use m_Orbital_Population,  only: m_OP_wd_occ_mat
  use m_PlaneWaveBasisSet,   only: kgp, m_pwBS_wd_curr_pws
  use m_PAW_ChargeDensity,   only: m_PAWCD_wd_cd
  use m_Crystal_Structure,   only: m_CS_wd_fix_spin_status, m_CS_wd_BandSymInput
#endif
  use m_Parallelization,     only: mype, npes, conf_para,  mpi_comm_group
  use m_Parallelization,     only: m_Parallel_wd_npes_etc_3D
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
  use m_Control_Parameters,  only: m_CtrlP_wd_dtim_previous
! ==============================================================================

  use m_Control_Parameters,   only : noncol, ndim_spinor, num_extra_bands, neg, nspin, ekmode &
       &                           , neg_is_enlarged, sw_write_pwbs_info
  use m_UnitCell,            only: m_UC_wd_cntn_data, m_UC_wd_md_cntn_data

  use m_ES_occup,             only: m_ESoc_check_num_bands, m_ESoc_check_if_metalic
! === Restart with phase ek-mode is supported. by tkato 2014/01/23 =============
  use m_Control_Parameters,  only : m_CtrlP_wd_numk_zajsaved
  use m_IterationNumbers,    only : nk_in_the_process
! ==============================================================================
! ======================================= added by K. Tagami ============ 11.0
  use m_Control_Parameters,   only :  noncol
!  use m_Charge_Density,       only : m_CD_wd_chgq_noncl
  use m_Orbital_Population,   only: m_OP_wd_occ_mat_noncl
! ======================================================================== 11.0

  use m_ES_ExactExchange,     only : m_ES_EXX_wd_hybridinfo
  use m_Control_Parameters,  only : use_metagga, sw_opencore
  use m_Files,  only :  m_Files_open_nf_ekindens, m_Files_close_nf_ekindens
  use m_KineticEnergy_Density, only : m_KE_wd_ekindens
  use m_PS_opencore,    only : m_PS_wd_mag_opencore_pol

  use m_Control_Parameters, only : sw_stress_correction
  use m_Stress, only : m_Stress_wd_cdata_4_correction
  use m_CS_SpaceGroup, only : m_CS_SG_wd_cntn

  implicit none
  logical,intent(in),optional :: final_call
  logical :: final_c = .true.
  integer :: status_wdmode
  logical :: flg_wd_zaj = .true.

  integer :: mpi_err
  integer :: sw_wd_Psi_coef = OFF
! === Restart with phase ek-mode is supported. by tkato 2014/01/23 =============
  integer :: numk_zajsaved
! ==============================================================================

  logical :: isSCDFT

#ifndef _EMPIRICAL_
  logical :: ChargeDensity_is_Converged
#endif

  include 'mpif.h'                                      ! MPI

! === An IF BLOCK STRUCTURE ===
!=  if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
!=       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
!=     if(iconvergence_previous_job < EK_CONVERGED) then
!=        ....
!=     else
!=         write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
!=     end if
!=  else
!=     if(iconvergence_previous_job < FORCE_CONVERGED .or. sw_rttddft == ON) then
!=        ....
!=     else
!=        if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL) then
!=           ....
!=        end if
!=        if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL) then
!=           ....
!=        end if
!=        ....
!=     end if
!=  end if

  flg_wd_zaj = .true.
  if ( F_ZAJ == "/dev/null" .or. sw_write_zaj == OFF ) flg_wd_zaj = .false.

  if (present(final_call)) final_c = final_call
  call m_Files_checkpoint_dir(driver /= DRIVER_NEB)
#ifndef _EMPIRICAL_
  if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
       & .and. fixed_charge_k_parallel == ONE_BY_ONE) then
     if(iconvergence_previous_job < EK_CONVERGED) then
        call m_Files_open_nfcntn
        if(mype == 0) rewind nfcntn
        call m_Iter_wd_iters_and_nk(nfcntn)
        call m_Parallel_wd_npes_etc_3D(nfcntn)
        call m_Kp_wd_kv3(nfcntn)
        call m_CtrlP_wd_iconvergence(nfcntn)
        call m_CtrlP_wd_iconv_ek(kv3_ek,iconv_ek,nfcntn)
     else
        write(nfout,'(" --- iconvergence_previous >= EK_CONVERGED ---")')
     end if
  else
#endif
!  if(iconvergence_previous_job < FORCE_CONVERGED) then
  if(iconvergence_previous_job < FORCE_CONVERGED .or. sw_rttddft == ON) then
     if(sw_rttddft == ON .and. iconvergence_previous_job>=FORCE_CONVERGED) iconvergence=FORCE_CONVERGED
     if (.not.conf_para) then
       call m_Files_open_nfcntn                        ! -(m_Files)
     else
       call m_Files_reopen_nfcntn
     endif
     if(mype==0) rewind nfcntn
     call m_Iter_wd_iteration_numbers(nfcntn)
     call m_IS_wd_pos_and_v(nfcntn)
     call m_IS_wd_cps(nfout)
     call m_TE_wd_total_energy(nfcntn)
#ifndef _EMPIRICAL_
     call m_CtrlP_wd_isolver(nfcntn)
#endif
     call m_IS_wd_pos_brav(nfout)

     if(imdalg == T_CONTROL .or. imdalg == BLUEMOON .or. &
          & imdalg == QUENCHED_CONSTRAINT) then
        if(imdalg /= QUENCHED_CONSTRAINT) &
             & call m_IS_wd_nrsv(nfcntn)
        call m_IS_wd_forcp_etc(imdalg,nfcntn)
     end if
     if(imdalg == BFGS .or. imdalg == GDIIS)then
        call m_IS_wd_diis_history(nfcntn)
     endif
     call m_CtrlP_wd_iconvergence(nfcntn)
     call m_CtrlP_wd_edelta_ontheway(nfcntn)
! === For restart lm+MSD! by tkato 2012/02/15 ==================================
     call m_CtrlP_wd_dtim_previous(nfcntn)
! ==============================================================================
     if(isSCDFT()) call wd_eps0(nfcntn)
#ifndef _EMPIRICAL_
     call m_ESIO_wd_EigenValues(nfout,2,nooccupation=NO)
     call m_Files_open_nfeng(icond)
     if((icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) &
          & .and. fixed_charge_k_parallel == ALL_AT_ONCE) then
!!$        if ( noncol ) then
        if(mype == 0) write(nfeng,'(" num_kpoints = ",i6)') kv3 /ndim_spinor
        if(neg_is_enlarged) then
           if(mype == 0) write(nfeng,'(" num_bands   = ",i6)') neg-num_extra_bands
        else
           if(mype == 0) write(nfeng,'(" num_bands   = ",i6)') neg
        end if
        if(mype == 0) write(nfeng,'(" nspin       = ",i6)') nspin / ndim_spinor
        if(m_ESoc_check_num_bands()) then
           call m_ESoc_check_if_metalic(nfout)
!!$           if(metalic_system .or. .not.check_if_metalic_flag) then
           if(metalic_system) then
              if(mype == 0) write(nfeng,'(" Fermi energy level = ",f10.6)') efermi
           else
!!$           write(nfeng,'(" The Highest occupied band energy = ",f10.6/)') vbm
              if(mype == 0) write(nfeng,'(" Valence band max   = ",f10.6)') vbm
           end if
        else
           if(mype == 0) write(nfeng,'(" Fermi energy level = unknown")')
        end if
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=NO)
     else
        call m_ESIO_wd_EigenValues(nfeng,2,nooccupation=NO)
     end if
     call m_Files_close_nfeng()

     if(sw_positron == ON) then
        call m_CtrlP_set_corecharge_cntnbin(ON)
     else
        call m_CtrlP_set_corecharge_cntnbin(OFF)
     end if
     call m_CtrlP_wd_corecharge_cntnbin(nfcntn)
     call m_CtrlP_wd_neg(nfcntn)
     call m_CS_wd_fix_spin_status(nfcntn)
     call m_IS_wd_curr_atom_reservoir(nfcntn)
     if(sw_stress_correction==ON)then
       call m_Stress_wd_cdata_4_correction(nfcntn)
     endif

     call m_CS_SG_wd_cntn(nfcntn)

     call m_Files_reopen_nfcntn_bin()
!!$     call m_Files_open_nfcntn_bin
!!$     if(mype==0) rewind nfcntn_bin
     if(continuation_using_ppdata == YES) then
        call m_PP_wd_PP_parameters_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kgp)
        call m_NLP_wd_snl_3D(nfout,nfcntn_bin,F_CNTN_BIN_partitioned,kv3)
     end if
     call m_ESIO_wd_EigenValues_etc(nfcntn_bin,F_CNTN_BIN_partitioned,totch_flag=ON)

     if(sw_optimize_lattice==ON) call m_UC_wd_cntn_data(nfcntn)
     if(imdalg == P_CONTROL .or. imdalg == PT_CONTROL) call m_UC_wd_md_cntn_data(nfcntn)

     if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL .or. conf_para) &
          & call m_Files_reopen_nfzaj()
     if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL .or. conf_para) &
          & call m_Files_reopen_nfchgt()

! ===================== added by K. Tagami ======================= 12.0Exp
     if ( (icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) .and. &
          &        fixed_charge_k_parallel /= ONE_BY_ONE ) then
        call m_Files_reopen_nfzaj()
     endif
! ================================================================ 12.0Exp

     if ( flg_wd_zaj ) then
        if(sw_ekzaj == OFF) then
           call m_ESIO_wd_WFs_3D(nfout,nfzaj,F_ZAJ_partitioned)
        else
        end if
     endif

     if(sw_write_pwbs_info==ON) call m_pwBS_wd_curr_pws()

! ==== DEBUG TEST ==== 2020/01/28
     if ( icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION ) then
        if(flg_paw) then
           call m_Files_open_nfcntn_bin_paw
           if(mype==0) rewind nfcntn_bin_paw
           call m_PP_wd_PAW_parameters(nfout,nfcntn_bin_paw)
           call m_CD_wd_hsr(nfcntn_bin_paw)
!!$call m_PAWCD_wd_cd(nfout)
           call m_Files_close_nfcntn_bin_paw
        end if

        call m_CD_wd_chgq(nfchgt,F_CHGT_partitioned) ! write chgq_l


! ================================= modified by K. Tagami ============= 11.0
!     if(sw_hubbard == ON) call m_OP_wd_occ_mat(nfout) ! write occupation matrix
!
        if(sw_hubbard == ON) then
           if ( noncol ) then
              call m_OP_wd_occ_mat_noncl(nfout)
           else
              call m_OP_wd_occ_mat(nfout) ! write occupation matrix
           endif
        endif
! ===================================================================== 11.0

        if ( sw_opencore == ON ) call m_PS_wd_mag_opencore_pol
        if ( use_metagga ) then
           call m_Files_open_nf_ekindens()
           call m_KE_wd_ekindens()
           call m_Files_close_nf_ekindens()
        endif
     endif
! ==== DEBUG TEST ==== 2020/01/28

     call m_Files_open_nfefermi()
     call m_ESIO_wd_Efermi(nfout,nfefermi)
     call m_Files_close_nfefermi()

     if(sw_output_hybrid_info == ON .and.  (icond==INITIAL.or.icond==CONTINUATION)) &
     & call m_ES_EXX_wd_hybridinfo()

  else
     if((F_ZAJ_partitioned .neqv. F_ZAJ_in_partitioned) .or. icond == INITIAL) then
        if ( flg_wd_zaj ) then
           if(sw_ekzaj == OFF) then
              call m_Files_reopen_nfzaj()
              call m_ESIO_wd_WFs_3D(nfout,nfzaj,F_ZAJ_partitioned)
           end if
        end if
     endif


     if((F_CHGT_partitioned .neqv. F_CHGT_in_partitioned) .or. icond == INITIAL) then
        call m_Files_reopen_nfchgt()

        call m_CD_wd_chgq(nfchgt,F_CHGT_partitioned) ! write chgq_l

     end if


! ==== DEBUG TEST ==== 2020/01/28
     if(flg_paw) then
        if ( icond /= FIXED_CHARGE .and. icond /= FIXED_CHARGE_CONTINUATION ) then
           call m_Files_open_nfcntn_bin_paw
           if(mype==0) rewind nfcntn_bin_paw
           call m_PP_wd_PAW_parameters(nfout,nfcntn_bin_paw)
           call m_CD_wd_hsr(nfcntn_bin_paw)
           call m_Files_close_nfcntn_bin_paw
!!$call m_PAWCD_wd_cd(nfout)
        end if
     endif
! ==== DEBUG TEST ==== 2020/01/28
#endif
  end if
#ifndef _EMPIRICAL_
  end if
#endif

! ============================= KT_Test ================ 12.5Exp
#ifdef USE_ZAJ_HISTORY
  call m_ES_wf_wd_zaj_history
#endif
! ====================================================== 12.5Exp

  if(iprijobstatus >= 1) then
!!$     write(nfout,'(" WDD onto Files")')
     call m_Files_open_nfstatus()
     if(jobstatus_series == ON) then
!!$        switch_header = OFF
        call m_Files_skiptoend(nfstatus)
     else
!!$        switch_header = ON
     end if
     status_wdmode = FINISH
     call m_Timing_wd_status(nfstatus,jobstatus_format,jobstatus_series,status_wdmode &
          &                , iteration,iteration_ionic,iteration_electronic)
  end if
  if(ipritiming>=2) call tstatc_wd0

  if (conf_para.and.driver==DRIVER_CONSTRAINT) call mpi_barrier(mpi_comm_world,mpi_err)

  if(final_c) then
     call m_Files_close_all()                    ! -(m_Files)
     call PrintStatus()
     call m_Files_close_logfile()
  else
     call m_Files_close_nfinp()
     call m_Files_close_nfcntn()
!!$     if(mype==0)then
!!$        close(nfcntn)
!!$        close(nfinp)
!!$     endif
  endif
contains
  integer function bcast_ipri(ipri_in)
    integer, intent(in)  :: ipri_in
    integer :: ipri_out, ierr
    if(npes > 1) then
       if(mype == 0) ipri_out = ipri_in
       call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
    else
       ipri_out = ipri_in
    end if
!!$    if(ipri_out /= OFF) ipri_out = ON
    if(ipri_out /= ON) ipri_out = OFF
    bcast_ipri = ipri_out
  end function bcast_ipri
end subroutine WriteDownData_onto_Files

!!$subroutine WriteCheckPointData
!!$  use m_IterationNumbers,   only : m_Iter_wd_iteration_numbers_b, iteration_electronic
!!$  use m_Files,              only : m_Files_open_nfcheckpoint, m_Files_close_nfcheckpoint &
!!$       &                         , nfout, nfcheckpoint
!!$  use m_ES_IO,              only : m_ESIO_wd_EigenValues_etc, m_ESIO_wd_WFs
!!$  use m_Charge_Density,     only : m_CD_wd_chgq
!!$  implicit none
!!$
!!$  if((icond == CONTINUATION or. icond == INITIAL).and. iteration_electronic == 10) then
!!$     call m_Files_open_nfcheckpoint
!!$     call m_Iter_wd_iteration_numbers_b(nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_ESIO_wd_EigenValues_etc(nfcheckpoint,F_CHKPNT_partitioned,totch_flag=ON)
!!$     call m_ESIO_wd_WFs(nfout,nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_CD_wd_chgq(nfcheckpoint, F_CHKPNT_partitioned)
!!$     call m_Files_close_nfcheckpoint
!!$  end if
!!$end subroutine WriteCheckPointData
!!$
!!$subroutine ReadCheckPointData_if_needed
!!$  use m_IterationNumbers, only : iteration_ionic, iteration_electronic
!!$  implicit none
!!$  if((icond == CONTINUATION or. icond == INITIAL).and. iteration_electronic == 15) then
!!$     call m_Files_open_nfcheckpoint
!!$     call m_Iter_rd_iteration_numbers_b(nfcheckpoint,F_CHKPNT_partitioned)
!!$     call m_ESIO_rd_EigenValues_etc(
!!$
!!$
!!$end subroutine ReadCheckPointData_if_needed

subroutine PrintStatus()
  use m_Files, only : nfout
  use m_Const_Parameters, only : MAX_SCF_ITERATION_REACHED, MAX_TIME_REACHED, FSTOP &
     &                         , FORCE_CONVERGENCE_REACHED, STRESS_CONVERGENCE_REACHED, MAX_MDSTEPS_REACHED &
     &                         , CHG_CONVERGENCE_REACHED &
     &                         , FORCE_CONVERGED, WF_CONVERGENCE_REACHED, MAX_PHSTEPS_REACHED &
     &                         , FIXED_CHARGE, FIXED_CHARGE_CONTINUATION
  use m_Control_Parameters,  only : terminated_because, iconvergence, iconvergence_previous_job, icond
  use m_IterationNumbers, only : iteration_ionic, iteration_unit_cell, iteration_stress_correction

  implicit none
  integer, dimension(8) :: ipresent_time
  character(len('reason: ')), parameter :: tag_reason = 'reason: '
  call date_and_time(values=ipresent_time)
  write(nfout,*)
write(nfout,'(a)') '------------------------------------------------------------------------'
  write(nfout,'("PHASE/0 terminated at ",i2,":",i2,":",i2,"  ",i2,"/",i2,"/",i4," reason: ")') &
        & ipresent_time(5:7),ipresent_time(3),ipresent_time(2),ipresent_time(1)
!write(nfout,'(a)') "RRRRRR   EEEEEEE     A      SSSSS   OOOOOOO  N     N  ::: "
!write(nfout,'(a)') "R     R  E          A A    S     S  O     O  NN    N  ::: "
!write(nfout,'(a)') "R     R  E         A   A   S        O     O  N N   N  ::: "
!write(nfout,'(a)') "RRRRRR   EEEEE    A     A   SSSSS   O     O  N  N  N       "
!write(nfout,'(a)') "R   R    E        A######        S  O     O  N   N N  ::: "
!write(nfout,'(a)') "R    R   E        A     A  S     S  O     O  N    NN  ::: "
!write(nfout,'(a)') "R     R  EEEEEEE  A     A   SSSSS   OOOOOOO  N     N  ::: "
  select case (terminated_because)
  case (MAX_SCF_ITERATION_REACHED)
!    write(nfout,'(a)') tag_reason//'scf iteration reached max_iteration'
write(nfout,'(a)') "M     M     A     X     X  III  TTTTTTT  EEEEEEE  RRRRRR  "
write(nfout,'(a)') "MM   MM    A A     X   X    I      T     E        R     R "
write(nfout,'(a)') "M M M M   A   A     X X     I      T     E        R     R "
write(nfout,'(a)') "M  M  M  A     A     X      I      T     EEEEE    RRRRRR  "
write(nfout,'(a)') "M     M  AAAAAAA    X X     I      T     E        R   R   "
write(nfout,'(a)') "M     M  A     A   X   X    I      T     E        R    R  "
write(nfout,'(a)') "M     M  A     A  X     X  III     T     EEEEEEE  R     R "
  case (MAX_TIME_REACHED)
!    write(nfout,'(a)') tag_reason//'max. time reached cpumax'
write(nfout,'(a)') " CCCCC   PPPPPP   U     U  M     M     A     X     X  "
write(nfout,'(a)') "C     C  P     P  U     U  MM   MM    A A     X   X   "
write(nfout,'(a)') "C        P     P  U     U  M M M M   A   A     X X    "
write(nfout,'(a)') "C        PPPPPP   U     U  M  M  M  A     A     X     "
write(nfout,'(a)') "C        P        U     U  M     M  AAAAAAA    X X    "
write(nfout,'(a)') "C     C  P        U     U  M     M  A     A   X   X   "
write(nfout,'(a)') " CCCCC   P         UUUUU   M     M  A     A  X     X  "
  case (MAX_MDSTEPS_REACHED)
!    write(nfout,'(a)') tag_reason//'mdsteps reached max_mdstep'
write(nfout,'(a)') "M     M     A     X     X  M     M  DDDDDD    SSSSS   TTTTTTT  PPPPPP   "
write(nfout,'(a)') "MM   MM    A A     X   X   MM   MM  D     D  S     S     T     P     P  "
write(nfout,'(a)') "M M M M   A   A     X X    M M M M  D     D  S           T     P     P  "
write(nfout,'(a)') "M  M  M  A     A     X     M  M  M  D     D   SSSSS      T     PPPPPP   "
write(nfout,'(a)') "M     M  AAAAAAA    X X    M     M  D     D        S     T     P        "
write(nfout,'(a)') "M     M  A     A   X   X   M     M  D     D  S     S     T     P        "
write(nfout,'(a)') "M     M  A     A  X     X  M     M  DDDDDD    SSSSS      T     P        "
  case (FSTOP)
!    write(nfout,'(a)') tag_reason//'integer smaller than the current iteration was detected from the F_STOP file'
write(nfout,'(a)') "FFFFFFF       SSSSS   TTTTTTT  OOOOOOO  PPPPPP   "
write(nfout,'(a)') "F            S     S     T     O     O  P     P  "
write(nfout,'(a)') "F            S           T     O     O  P     P  "
write(nfout,'(a)') "FFFFF         SSSSS      T     O     O  PPPPPP   "
write(nfout,'(a)') "F                  S     T     O     O  P        "
write(nfout,'(a)') "F            S     S     T     O     O  P        "
write(nfout,'(a)') "F     _____   SSSSS      T     OOOOOOO  P        "
  case (FORCE_CONVERGENCE_REACHED)
!    write(nfout,'(a)') tag_reason//'force converged'
write(nfout,'(a)') "FFFFFFF  OOOOOOO  RRRRRR    CCCCC     CCCCC   OOOOOOO  N     N  V     V "
write(nfout,'(a)') "F        O     O  R     R  C     C   C     C  O     O  NN    N  V     V "
write(nfout,'(a)') "F        O     O  R     R  C         C        O     O  N N   N  V     V "
write(nfout,'(a)') "FFFFF    O     O  RRRRRR   C         C        O     O  N  N  N  V     V "
write(nfout,'(a)') "F        O     O  R   R    C         C        O     O  N   N N   V   V  "
write(nfout,'(a)') "F        O     O  R    R   C     C   C     C  O     O  N    NN    V V   "
write(nfout,'(a)') "F        OOOOOOO  R     R   CCCCC     CCCCC   OOOOOOO  N     N     V    "
  case (STRESS_CONVERGENCE_REACHED)
!   write(nfout,'(a)') tag_reason//'stress converged'
write(nfout,'(a)') " SSSSS   TTTTTTT  RRRRRR    SSSSS     CCCCC   OOOOOOO  N     N  V     V "
write(nfout,'(a)') "S     S     T     R     R  S     S   C     C  O     O  NN    N  V     V "
write(nfout,'(a)') "S           T     R     R  S         C        O     O  N N   N  V     V "
write(nfout,'(a)') " SSSSS      T     RRRRRR    SSSSS    C        O     O  N  N  N  V     V "
write(nfout,'(a)') "      S     T     R   R          S   C        O     O  N   N N   V   V  "
write(nfout,'(a)') "S     S     T     R    R   S     S   C     C  O     O  N    NN    V V   "
write(nfout,'(a)') " SSSSS      T     R     R   SSSSS     CCCCC   OOOOOOO  N     N     V    "
  case(CHG_CONVERGENCE_REACHED)
write(nfout,'(a)') " CCCCC   H     H    GGGGG      CCCCC   OOOOOOO  N     N  V     V"
write(nfout,'(a)') "C     C  H     H   G     G    C     C  O     O  NN    N  V     V"
write(nfout,'(a)') "C        H     H   G          C        O     O  N N   N  V     V"
write(nfout,'(a)') "C        HHHHHHH   G  GGGG    C        O     O  N  N  N  V     V"
write(nfout,'(a)') "C        H     H   G     G    C        O     O  N   N N   V   V "
write(nfout,'(a)') "C     C  H     H   G     G    C     C  O     O  N    NN    V V  "
write(nfout,'(a)') " CCCCC   H     H    GGGGG      CCCCC   OOOOOOO  N     N     V   "
  case(WF_CONVERGENCE_REACHED)
write(nfout,'(a)') "W     W  FFFFFFF    CCCCC   OOOOOOO  N     N  V     V "
write(nfout,'(a)') "W  W  W  F         C     C  O     O  NN    N  V     V "
write(nfout,'(a)') "W  W  W  F         C        O     O  N N   N  V     V "
write(nfout,'(a)') "W  W  W  FFFFF     C        O     O  N  N  N  V     V "
write(nfout,'(a)') "W  W  W  F         C        O     O  N   N N   V   V  "
write(nfout,'(a)') "W  W  W  F         C     C  O     O  N    NN    V V   "
write(nfout,'(a)') " WW WW   F          CCCCC   OOOOOOO  N     N     V    "
  case(MAX_PHSTEPS_REACHED)
write(nfout,'(a)') "M     M     A     X     X  PPPPPP   H     H   SSSSS   TTTTTTT  PPPPPP   "
write(nfout,'(a)') "MM   MM    A A     X   X   P     P  H     H  S     S     T     P     P  "
write(nfout,'(a)') "M M M M   A   A     X X    P     P  H     H  S           T     P     P  "
write(nfout,'(a)') "M  M  M  A     A     X     PPPPPP   HHHHHHH   SSSSS      T     PPPPPP   "
write(nfout,'(a)') "M     M  AAAAAAA    X X    P        H     H        S     T     P        "
write(nfout,'(a)') "M     M  A     A   X   X   P        H     H  S     S     T     P        "
write(nfout,'(a)') "M     M  A     A  X     X  P        H     H   SSSSS      T     P        "
  case default
    write(nfout,'(a)') 'unknown'
  end select
  if(terminated_because==FORCE_CONVERGENCE_REACHED  .or. &
     terminated_because==STRESS_CONVERGENCE_REACHED .or. &
     terminated_because==MAX_MDSTEPS_REACHED        .or.&
     terminated_because==CHG_CONVERGENCE_REACHED    .or. &
     terminated_because==WF_CONVERGENCE_REACHED     .or. &
     terminated_because==MAX_PHSTEPS_REACHED) then
write(nfout,'(a)') '------------------------------------------------------------------------'
     return
  endif
  if(.not. (iconvergence_previous_job>=FORCE_CONVERGED) .and. &
   & .not. (icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) &
   & .and.  iconvergence == 0 .and. iteration_ionic==1 .and.  iteration_unit_cell==1 &
   & .and. iteration_stress_correction==1 ) then
!     write(nfout,'(a)') 'WARNING: charge unconverged!!'
     write(nfout,'(a)')
write(nfout,'(a)') "W     W     A     RRRRRR   N     N  III  N     N   GGGGG  "
write(nfout,'(a)') "W  W  W    A A    R     R  NN    N   I   NN    N  G     G "
write(nfout,'(a)') "W  W  W   A   A   R     R  N N   N   I   N N   N  G       "
write(nfout,'(a)') "W  W  W  A     A  RRRRRR   N  N  N   I   N  N  N  G  GGGG "
write(nfout,'(a)') "W  W  W  AAAAAAA  R   R    N   N N   I   N   N N  G     G "
write(nfout,'(a)') "W  W  W  A     A  R    R   N    NN   I   N    NN  G     G "
write(nfout,'(a)') " WW WW   A     A  R     R  N     N  III  N     N   GGGGG  "
write(nfout,'(a)') " CCCCC   H     H    GGGGG    U     U   CCCCC   OOOOOOO  N     N  V     V"
write(nfout,'(a)') "C     C  H     H   G     G   U     U  C     C  O     O  NN    N  V     V"
write(nfout,'(a)') "C        H     H   G         U     U  C        O     O  N N   N  V     V"
write(nfout,'(a)') "C        HHHHHHH   G  GGGG   U     U  C        O     O  N  N  N  V     V"
write(nfout,'(a)') "C        H     H   G     G   U     U  C        O     O  N   N N   V   V "
write(nfout,'(a)') "C     C  H     H   G     G   U     U  C     C  O     O  N    NN    V V  "
write(nfout,'(a)') " CCCCC   H     H    GGGGG     UUUUU    CCCCC   OOOOOOO  N     N     V   "
  endif
write(nfout,'(a)') '------------------------------------------------------------------------'
end subroutine PrintStatus

       subroutine ev_test_2D(n, a, nma, w, z, nmz, ret)

       integer                :: n, nma, nmz
       real(8)                :: a(*), w(*), z(*), ret

       include 'mpif.h'
       include 'trd.h'

       call datacast_init(2)
       call MPI_Barrier(MPI_COMM_EIGEN,ierr)
       call ev_check_2D_body(n, a(1), nma, w(1), z(1), nmz, ret)
       call MPI_Barrier(MPI_COMM_EIGEN,ierr)
       call datacast_free(0)

       return
       end
*
*
*
       subroutine ev_check_2D_body(n, a, nma, w, z, nmz, ret)

       implicit double precision(a-h,o-z),integer(i-n)

       integer                :: n, nma, nmz
       real(8)                :: a(1:nma,*)
       real(8)                :: w(1:n)
       real(8)                :: z(1:nmz,*)
       real(8)                :: ret

       real(8), pointer       :: b(:)
       real(8), pointer       :: c1(:), c2(:)
       real(8), pointer       :: d(:)
       real(8), pointer       :: e(:)

       real(8)                :: m_epsilon
       real(8), external      :: machine_epsilon

       include 'mpif.h'
       include 'trd.h'
*
       m_epsilon = machine_epsilon()
*
       ra=0d0
       rz=0d0
       rr=0d0
       r =0d0

       j_2 = loop_c_start(1, x_nnod,x_inod)
       j_3 = loop_c_end  (n, x_nnod,x_inod)
       j_4 = loop_c_g2l_depth(n, x_nnod,x_inod)
       i_2 = loop_c_start(1, y_nnod,y_inod)
       i_3 = loop_c_end  (n, y_nnod,y_inod)
       i_4 = loop_c_g2l_depth(n, y_nnod,y_inod)

       larray = n
       allocate(b(1:larray))

       larray = j_4
       allocate(c1(1:larray), c2(1:larray))

       larray = MAX(n+1,3*i_4)
       allocate(d(1:larray), e(1:larray))

       b(1:n)=0d0

       i_m = MOD(i_3-i_2+1,4)+i_2
       do i=1,n,1

          jj_0 = loop_c_node(i, x_nnod,x_inode)
          ii_0 = loop_c_node(i, y_nnod,y_inode)
          jj_1 = loop_c_g2l_depth(i, x_nnod,x_inod)
          ii_1 = loop_c_g2l_depth(i, y_nnod,y_inod)

          if ( ii_0 == y_inod ) then
             do j_1 = j_2, j_3
                c1(j_1) = z(j_1,ii_1)
             end do
          end if
          call MPI_Bcast(c1(1),j_4,MPI_DOUBLE_PRECISION,
     &                   ii_0-1,y_COMM_WORLD,ierr)

          do i_1 = i_2, i_m-1
             t0 = 0.0D+00
             s0 = 0.0D+00
             u0 = 0.0D+00
             do j_1 = j_2, j_3
                a0 = a(j_1,i_1)
                b0 = c1(j_1)
                t0 = t0 + b0 * a0          ! t = Az(i)
                s0 = s0 + b0 * z(j_1,i_1)  ! s = Zz(i)
                u0 = u0 + ABS(a0)          ! u = |A|_1
             end do! k
             d(1+(i_1-1)*3) = t0
             d(2+(i_1-1)*3) = s0
             d(3+(i_1-1)*3) = u0
          end do
          do i_1 = i_m, i_3, 4
             t0 = 0.0D+00
             t1 = 0.0D+00
             t2 = 0.0D+00
             t3 = 0.0D+00
             s0 = 0.0D+00
             s1 = 0.0D+00
             s2 = 0.0D+00
             s3 = 0.0D+00
             u0 = 0.0D+00
             u1 = 0.0D+00
             u2 = 0.0D+00
             u3 = 0.0D+00
             do j_1 = j_2, j_3
                a0 = a(j_1,i_1+0)
                a1 = a(j_1,i_1+1)
                a2 = a(j_1,i_1+2)
                a3 = a(j_1,i_1+3)
                b0 = c1(j_1+0)
                t0 = t0 + b0 * a0          ! t = Az(i)
                t1 = t1 + b0 * a1          ! t = Az(i)
                t2 = t2 + b0 * a2          ! t = Az(i)
                t3 = t3 + b0 * a3          ! t = Az(i)
                s0 = s0 + b0 * z(j_1,i_1+0)! s = Zz(i)
                s1 = s1 + b0 * z(j_1,i_1+1)! s = Zz(i)
                s2 = s2 + b0 * z(j_1,i_1+2)! s = Zz(i)
                s3 = s3 + b0 * z(j_1,i_1+3)! s = Zz(i)
                u0 = u0 + ABS(a0)          ! u = |A|_1
                u1 = u1 + ABS(a1)          ! u = |A|_1
                u2 = u2 + ABS(a2)          ! u = |A|_1
                u3 = u3 + ABS(a3)          ! u = |A|_1
             end do! k
             d(1+(i_1-1)*3) = t0
             d(2+(i_1-1)*3) = s0
             d(3+(i_1-1)*3) = u0
             d(1+(i_1  )*3) = t1
             d(2+(i_1  )*3) = s1
             d(3+(i_1  )*3) = u1
             d(1+(i_1+1)*3) = t2
             d(2+(i_1+1)*3) = s2
             d(3+(i_1+1)*3) = u2
             d(1+(i_1+2)*3) = t3
             d(2+(i_1+2)*3) = s3
             d(3+(i_1+2)*3) = u3
          end do

          call MPI_Allreduce(d(1),e(1),3*(i_3-i_2+1),
     &                    MPI_DOUBLE_PRECISION,
     &                    MPI_SUM,x_COMM_WORLD,ierr)

          call datacast_dbl(d(1), c1(1), d(1+i_4), d(1+2*i_4), j_4)

          if ( jj_0 == x_inod ) then
             do i_1 = i_2, i_m-1
                t0 = e(1+(i_1-1)*3)
                s0 = e(2+(i_1-1)*3)
                u0 = e(3+(i_1-1)*3)
                t0 = t0 - w(i) * d(i_1)     ! t = Az(i) - wz(i)
             if ( ii_0 == y_inod .AND. i_1 ==ii_1 ) then
                s0 = s0 - 1.0D+00           ! s = Zz(i) - 1(i)
             end if
                b(i) = b(i) + ABS(t0)       ! b(i)=|Az(i)-wz(i)|_1
                rz   = rz + s0**2           ! rz  =|ZZ-I|_F
                ra   = MAX(ra,u0)           ! ra  =|A|_1
             end do
             do i_1 = i_m, i_3, 4
                t0 = e(1+(i_1-1)*3)
                s0 = e(2+(i_1-1)*3)
                u0 = e(3+(i_1-1)*3)
                t1 = e(1+(i_1  )*3)
                s1 = e(2+(i_1  )*3)
                u1 = e(3+(i_1  )*3)
                t2 = e(1+(i_1+1)*3)
                s2 = e(2+(i_1+1)*3)
                u2 = e(3+(i_1+1)*3)
                t3 = e(1+(i_1+2)*3)
                s3 = e(2+(i_1+2)*3)
                u3 = e(3+(i_1+2)*3)
                t0 = t0 - w(i) * d(i_1+0)   ! t = Az(i) - wz(i)
                t1 = t1 - w(i) * d(i_1+1)   ! t = Az(i) - wz(i)
                t2 = t2 - w(i) * d(i_1+2)   ! t = Az(i) - wz(i)
                t3 = t3 - w(i) * d(i_1+3)   ! t = Az(i) - wz(i)
             if ( ii_0 == y_inod ) then
             if ( i_1+0 ==ii_1 ) then
                s0 = s0 - 1.0D+00           ! s = Zz(i) - 1(i)
             else if ( i_1+1 ==ii_1 ) then
                s1 = s1 - 1.0D+00           ! s = Zz(i) - 1(i)
             else if ( i_1+2 ==ii_1 ) then
                s2 = s2 - 1.0D+00           ! s = Zz(i) - 1(i)
             else if ( i_1+3 ==ii_1 ) then
                s3 = s3 - 1.0D+00           ! s = Zz(i) - 1(i)
             end if
             end if
                b(i) = b(i) + ABS(t0)       ! b(i)=|Az(i)-wz(i)|_1
                b(i) = b(i) + ABS(t1)       ! b(i)=|Az(i)-wz(i)|_1
                b(i) = b(i) + ABS(t2)       ! b(i)=|Az(i)-wz(i)|_1
                b(i) = b(i) + ABS(t3)       ! b(i)=|Az(i)-wz(i)|_1
                rz   = rz + s0**2           ! rz  =|ZZ-I|_F
                rz   = rz + s1**2           ! rz  =|ZZ-I|_F
                rz   = rz + s2**2           ! rz  =|ZZ-I|_F
                rz   = rz + s3**2           ! rz  =|ZZ-I|_F
                ra   = MAX(ra,u0)           ! ra  =|A|_1
                ra   = MAX(ra,u1)           ! ra  =|A|_1
                ra   = MAX(ra,u2)           ! ra  =|A|_1
                ra   = MAX(ra,u3)           ! ra  =|A|_1
             end do
          end if

       end do

*>
       d(1:n)=b(1:n)
       d(n+1)=rz
       call MPI_Allreduce(d(1),e(1),n+1,MPI_DOUBLE_PRECISION,
     &                    MPI_SUM,MPI_COMM_EIGEN,ierr)
       b(1:n)=e(1:n)
       rz    =e(n+1)

       r=ra
       call MPI_Allreduce(ra,r,1,MPI_DOUBLE_PRECISION,
     &                    MPI_MAX,MPI_COMM_EIGEN,ierr)
       ra=r

       rr=0d0
       do i=1,n
          if(b(i)>rr)then
             rr=b(i); k=i
          endif
       enddo! i

       if(TRD_inod==1)then
          print*,"max|Ax-wx|=",rr,k
          print*,"|A|=",ra
          print*,"epsilon=",m_epsilon
          print*,"max|Ax-wx|/Ne|A|=",rr/(n*m_epsilon*ra)
          print*,"|ZZ-I|=",SQRT(rz),rz
       endif
*
       deallocate(e)
       deallocate(b)
       deallocate(c1,c2)
       deallocate(d)
*
       return
       end

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Dealloc_Radr_and_Wos_Epsilon                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
! $Id: Dealloc_Radr_and_Wos_Epsilon.f90 376 2014-06-17 07:48:31Z jkoga $
   subroutine Dealloc_Radr_and_Wos_Epsilon
    use m_PseudoPotential,             only : m_PP_dealloc_NLP
     call m_PP_dealloc_NLP
   end subroutine Dealloc_Radr_and_Wos_Epsilon 

      SUBROUTINE PDLAED2( ICTXT, K, N, N1, NB, D, DROW, DCOL, Q, LDQ,
     $                    RHO, Z, W, DLAMDA, Q2, LDQ2, QBUF, CTOT, PSM,
     $                    NPCOL, INDX, INDXC, INDXP, INDCOL, COLTYP, NN,
     $                    NN1, NN2, IB1, IB2 )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            DCOL, DROW, IB1, IB2, ICTXT, K, LDQ, LDQ2, N,
     $                   N1, NB, NN, NN1, NN2, NPCOL
      DOUBLE PRECISION   RHO
*     ..
*     .. Array Arguments ..
      INTEGER            COLTYP( * ), CTOT( 0: NPCOL-1, 4 ),
     $                   INDCOL( N ), INDX( * ), INDXC( * ), INDXP( * ),
     $                   PSM( 0: NPCOL-1, 4 )
      DOUBLE PRECISION   D( * ), DLAMDA( * ), Q( LDQ, * ),
     $                   Q2( LDQ2, * ), QBUF( * ), W( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED2_X sorts the two sets of eigenvalues together into a single
*  sorted set.  Then it tries to deflate the size of the problem.
*  There are two ways in which deflation can occur:  when two or more
*  eigenvalues are close together or if there is a tiny entry in the
*  Z vector.  For each such occurrence the order of the related secular
*  equation problem is reduced by one.
*
*  Arguments
*  =========
*
*  ICTXT  (global input) INTEGER
*         The BLACS context handle, indicating the global context of
*         the operation on the matrix. The context itself is global.
*
*  K      (output) INTEGER
*         The number of non-deflated eigenvalues, and the order of the
*         related secular equation. 0 <= K <=N.
*
*  N      (input) INTEGER
*         The dimension of the symmetric tridiagonal matrix.  N >= 0.
*
*  N1     (input) INTEGER
*         The location of the last eigenvalue in the leading sub-matrix.
*         min(1,N) < N1 < N.
*
*  NB      (global input) INTEGER
*          The blocking factor used to distribute the columns of the
*          matrix. NB >= 1.
*
*  D      (input/output) DOUBLE PRECISION array, dimension (N)
*         On entry, D contains the eigenvalues of the two submatrices to
*         be combined.
*         On exit, D contains the trailing (N-K) updated eigenvalues
*         (those which were deflated) sorted into increasing order.
*
*  DROW   (global input) INTEGER
*          The process row over which the first row of the matrix D is
*          distributed. 0 <= DROW < NPROW.
*
*  DCOL   (global input) INTEGER
*          The process column over which the first column of the
*          matrix D is distributed. 0 <= DCOL < NPCOL.
*
*  Q      (input/output) DOUBLE PRECISION array, dimension (LDQ, N)
*         On entry, Q contains the eigenvectors of two submatrices in
*         the two square blocks with corners at (1,1), (N1,N1)
*         and (N1+1, N1+1), (N,N).
*         On exit, Q contains the trailing (N-K) updated eigenvectors
*         (those which were deflated) in its last N-K columns.
*
*  LDQ    (input) INTEGER
*         The leading dimension of the array Q.  LDQ >= max(1,NQ).
*
*  RHO    (global input/output) DOUBLE PRECISION
*         On entry, the off-diagonal element associated with the rank-1
*         cut which originally split the two submatrices which are now
*         being recombined.
*         On exit, RHO has been modified to the value required by
*         PDLAED3.
*
*  Z      (global input) DOUBLE PRECISION array, dimension (N)
*         On entry, Z contains the updating vector (the last
*         row of the first sub-eigenvector matrix and the first row of
*         the second sub-eigenvector matrix).
*         On exit, the contents of Z have been destroyed by the updating
*         process.
*
*  DLAMDA (global output) DOUBLE PRECISION array, dimension (N)
*         A copy of the first K eigenvalues which will be used by
*         SLAED3 to form the secular equation.
*
*  W      (global output) DOUBLE PRECISION array, dimension (N)
*         The first k values of the final deflation-altered z-vector
*         which will be passed to SLAED3.
*
*  Q2     (output) DOUBLE PRECISION array, dimension (LDQ2, NQ)
*         A copy of the first K eigenvectors which will be used by
*
*  LDQ2    (input) INTEGER
*         The leading dimension of the array Q2.
*
*  QBUF   (workspace) DOUBLE PRECISION array, dimension 3*N
*
*  CTOT   (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  PSM    (workspace) INTEGER array, dimension( NPCOL, 4)
*
*  NPCOL   (global input) INTEGER
*          The total number of columns over which the distributed
*           submatrix is distributed.
*
*  INDX   (workspace) INTEGER array, dimension (N)
*         The permutation used to sort the contents of DLAMDA into
*         ascending order.
*
*  INDXC  (output) INTEGER array, dimension (N)
*         The permutation used to arrange the columns of the deflated
*         Q matrix into three groups:  the first group contains non-zero
*         elements only at and above N1, the second contains
*         non-zero elements only below N1, and the third is dense.
*
*  INDXP  (workspace) INTEGER array, dimension (N)
*         The permutation used to place deflated values of D at the end
*         of the array.  INDXP(1:K) points to the nondeflated D-values
*         and INDXP(K+1:N) points to the deflated eigenvalues.
*
*  INDCOL (workspace) INTEGER array, dimension (N)
*
*  COLTYP (workspace/output) INTEGER array, dimension (N)
*         During execution, a label which will indicate which of the
*         following types a column in the Q2 matrix is:
*         1 : non-zero in the upper half only;
*         2 : dense;
*         3 : non-zero in the lower half only;
*         4 : deflated.
*
*  NN     (global output) INTEGER, the order of matrix U, (PDLAED1).
*  NN1    (global output) INTEGER, the order of matrix Q1, (PDLAED1).
*  NN2    (global output) INTEGER, the order of matrix Q2, (PDLAED1).
*  IB1    (global output) INTEGER, pointeur on Q1, (PDLAED1).
*  IB2    (global output) INTEGER, pointeur on Q2, (PDLAED1).
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   MONE, ZERO, ONE, TWO, EIGHT
      PARAMETER          ( MONE = -1.0D0, ZERO = 0.0D0, ONE = 1.0D0,
     $                   TWO = 2.0D0, EIGHT = 8.0D0 )
*     ..
*     .. Local Scalars ..
      INTEGER            COL, CT, I, IAM, IE1, IE2, IMAX, INFO, J, JJQ2,
     $                   JJS, JMAX, JS, K2, MYCOL, MYROW, N1P1, N2, NJ,
     $                   NJCOL, NJJ, NP, NPROCS, NPROW, PJ, PJCOL, PJJ
      DOUBLE PRECISION   C, EPS, S, T, TAU, TOL
*     ..
*     .. External Functions ..
      INTEGER            IDAMAX, INDXG2L, INDXL2G, NUMROC
      DOUBLE PRECISION   DLAPY2, PDLAMCH
      EXTERNAL           IDAMAX, INDXG2L, INDXL2G, NUMROC, PDLAMCH,
     $                   DLAPY2
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, BLACS_PINFO, DCOPY, DGERV2D,
     $                   DGESD2D, DLAPST, DROT, DSCAL, INFOG1L
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MAX, MIN, MOD, SQRT
*     ..
*     .. External Functions ..
*     ..
*     .. Local Arrays ..
      INTEGER            PTT( 4 )
*     ..
*     .. Executable Statements ..

      include 'trd.h'
      include 'mpif.h'

      INTEGER REQ(2)
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
      CALL BLACS_PINFO( IAM, NPROCS )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      NP = NUMROC( N, NB, MYROW, DROW, NPROW )
*
      N2 = N - N1
      N1P1 = N1 + 1
*
      IF( RHO.LT.ZERO ) THEN
         CALL DSCAL( N2, MONE, Z( N1P1 ), 1 )
      END IF
*
*     Normalize z so that norm(z) = 1.  Since z is the concatenation of
*     two normalized vectors, norm2(z) = sqrt(2).
*
      T = ONE / SQRT( TWO )
      CALL DSCAL( N, T, Z, 1 )
*
*     RHO = ABS( norm(z)**2 * RHO )
*
      RHO = ABS( TWO*RHO )
*
*     Calculate the allowable deflation tolerance
*
      IMAX = IDAMAX( N, Z, 1 )
      JMAX = IDAMAX( N, D, 1 )
      EPS = PDLAMCH( ICTXT, 'Epsilon' )
      TOL = EIGHT*EPS*MAX( ABS( D( JMAX ) ), ABS( Z( IMAX ) ) )
*
*     If the rank-1 modifier is small enough, no more needs to be done
*     except to reorganize Q so that its columns correspond with the
*     elements in D.
*
      IF( RHO*ABS( Z( IMAX ) ).LE.TOL ) THEN
         K = 0
         GO TO 220
      END IF
*
*     If there are multiple eigenvalues then the problem deflates.  Here
*     the number of equal eigenvalues are found.  As each equal
*     eigenvalue is found, an elementary reflector is computed to rotate
*     the corresponding eigensubspace so that the corresponding
*     components of Z are zero in this new basis.
*
*
      CALL DLAPST( 'I', N, D, INDX, INFO )
*
!$OMP PARALLEL SECTIONS
!$OMP SECTION
      DO 10 I = 1, N1
         COLTYP( I ) = 1
   10 CONTINUE
!$OMP SECTION
      DO 20 I = N1P1, N
         COLTYP( I ) = 3
   20 CONTINUE
!$OMP END PARALLEL SECTIONS
      COL = DCOL
!$OMP PARALLEL DO PRIVATE(I,J,COL)
      DO 40 I = 1, N, NB
         COL = MOD( DCOL+(I-1)/NB, NPCOL )
         DO 30 J = 0, NB - 1
            IF( I+J.LE.N )
     $         INDCOL( I+J ) = COL
   30    CONTINUE
!         COL = MOD( COL+1, NPCOL )
   40 CONTINUE
!$OMP END PARALLEL DO
         COL = MOD( DCOL+(N-1)/NB+1, NPCOL )
*
      K = 0
      K2 = N + 1
      DO 50 J = 1, N
         NJ = INDX( J )
         IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*           Deflate due to small z component.
*
            K2 = K2 - 1
            COLTYP( NJ ) = 4
            INDXP( K2 ) = NJ
            IF( J.EQ.N )
     $         GO TO 80
         ELSE
            PJ = NJ
            GO TO 60
         END IF
   50 CONTINUE
   60 CONTINUE
      J = J + 1
      NJ = INDX( J )
      IF( J.GT.N )
     $   GO TO 80
      IF( RHO*ABS( Z( NJ ) ).LE.TOL ) THEN
*
*        Deflate due to small z component.
*
         K2 = K2 - 1
         COLTYP( NJ ) = 4
         INDXP( K2 ) = NJ
      ELSE
*
*        Check if eigenvalues are close enough to allow deflation.
*
         S = Z( PJ )
         C = Z( NJ )
*
*        Find sqrt(a**2+b**2) without overflow or
*        destructive underflow.
*
         TAU = DLAPY2( C, S )
         T = D( NJ ) - D( PJ )
         C = C / TAU
         S = -S / TAU
         IF( ABS( T*C*S ).LE.TOL ) THEN
*
*           Deflation is possible.
*
            Z( NJ ) = TAU
            Z( PJ ) = ZERO
            IF( COLTYP( NJ ).NE.COLTYP( PJ ) )
     $         COLTYP( NJ ) = 2
            COLTYP( PJ ) = 4
            CALL INFOG1L( NJ, NB, NPCOL, MYCOL, DCOL, NJJ, NJCOL )
            CALL INFOG1L( PJ, NB, NPCOL, MYCOL, DCOL, PJJ, PJCOL )
            IF( INDCOL( PJ ).EQ.INDCOL( NJ ) .AND. MYCOL.EQ.NJCOL ) THEN
               CALL DROT( NP, Q( 1, PJJ ), 1, Q( 1, NJJ ), 1, C, S )
            ELSE IF( MYCOL.EQ.PJCOL ) THEN
               call irecv_dbl( QBUF,      NP,
     $                         NJCOL+1, REQ(2), y_COMM_WORLD )
               call isend_dbl( Q(1, PJJ), NP,
     $                         NJCOL+1, REQ(1), y_COMM_WORLD )
               call waitall_dbl( 2, REQ )
               CALL DROT( NP, Q( 1, PJJ ), 1, QBUF, 1, C, S )
            ELSE IF( MYCOL.EQ.NJCOL ) THEN
               call irecv_dbl( QBUF,      NP,
     $                         PJCOL+1, REQ(2), y_COMM_WORLD )
               call isend_dbl( Q(1, NJJ), NP,
     $                         PJCOL+1, REQ(1), y_COMM_WORLD )
               call waitall_dbl( 2, REQ )
               CALL DROT( NP, QBUF, 1, Q( 1, NJJ ), 1, C, S )
            END IF
            T = D( PJ )*C**2 + D( NJ )*S**2
            D( NJ ) = D( PJ )*S**2 + D( NJ )*C**2
            D( PJ ) = T

            K2 = K2 - 1
            I = 1
   70       CONTINUE
            IF( K2+I.LE.N ) THEN
               IF( D( PJ ).LT.D( INDXP( K2+I ) ) ) THEN
                  INDXP( K2+I-1 ) = INDXP( K2+I )
                  INDXP( K2+I ) = PJ
                  I = I + 1
                  GO TO 70
               ELSE
                  INDXP( K2+I-1 ) = PJ
               END IF
            ELSE
               INDXP( K2+I-1 ) = PJ
            END IF

!            IF( INDCOL( PJ ).EQ.INDCOL( NJ ) .AND. MYCOL.EQ.NJCOL ) THEN
!               CALL DROT( NP, Q( 1, PJJ ), 1, Q( 1, NJJ ), 1, C, S )
!            ELSE IF( MYCOL.EQ.PJCOL ) THEN
!               call waitall_dbl( 2, REQ )
!               CALL DROT( NP, Q( 1, PJJ ), 1, QBUF, 1, C, S )
!            ELSE IF( MYCOL.EQ.NJCOL ) THEN
!               call waitall_dbl( 2, REQ )
!               CALL DROT( NP, QBUF, 1, Q( 1, NJJ ), 1, C, S )
!            END IF

            PJ = NJ
         ELSE
            K = K + 1
            DLAMDA( K ) = D( PJ )
            W( K ) = Z( PJ )
            INDXP( K ) = PJ
            PJ = NJ
         END IF
      END IF
      GO TO 60
   80 CONTINUE
*
*     Record the last eigenvalue.
*
      K = K + 1
      DLAMDA( K ) = D( PJ )
      W( K ) = Z( PJ )
      INDXP( K ) = PJ
*
*     Count up the total number of the various types of columns, then
*     form a permutation which positions the four column types into
*     four uniform groups (although one or more of these groups may be
*     empty).
*
      DO 100 J = 1, 4
         DO 90 I = 0, NPCOL - 1
            CTOT( I, J ) = 0
   90    CONTINUE
         PTT( J ) = 0
  100 CONTINUE
      DO 110 J = 1, N
         CT = COLTYP( J )
         COL = INDCOL( J )
         CTOT( COL, CT ) = CTOT( COL, CT ) + 1
  110 CONTINUE
*
*     PSM(*) = Position in SubMatrix (of types 1 through 4)
*
      DO 120 COL = 0, NPCOL - 1
         PSM( COL, 1 ) = 1
         PSM( COL, 2 ) = 1 + CTOT( COL, 1 )
         PSM( COL, 3 ) = PSM( COL, 2 ) + CTOT( COL, 2 )
         PSM( COL, 4 ) = PSM( COL, 3 ) + CTOT( COL, 3 )
  120 CONTINUE
      PTT( 1 ) = 1
      DO 140 I = 2, 4
         CT = 0
         DO 130 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  130    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  140 CONTINUE
*
*     Fill out the INDXC array so that the permutation which it induces
*     will place all type-1 columns first, all type-2 columns next,
*     then all type-3's, and finally all type-4's.
*
      DO 150 J = 1, N
         JS = INDXP( J )
         COL = INDCOL( JS )
         CT = COLTYP( JS )
         I = INDXL2G( PSM( COL, CT ), NB, COL, DCOL, NPCOL )
         INDX( J ) = I
         INDXC( PTT( CT ) ) = I
         PSM( COL, CT ) = PSM( COL, CT ) + 1
         PTT( CT ) = PTT( CT ) + 1
  150 CONTINUE
*
*
!$OMP PARALLEL DO PRIVATE(I,J,JS,JJS,JJQ2,COL)
      DO 160 J = 1, N
         JS = INDXP( J )
         JJS = INDXG2L( JS, NB, J, J, NPCOL )
         COL = INDCOL( JS )
         IF( COL.EQ.MYCOL ) THEN
            I = INDX( J )
            JJQ2 = INDXG2L( I, NB, J, J, NPCOL )
            CALL DCOPY( NP, Q( 1, JJS ), 1, Q2( 1, JJQ2 ), 1 )
         END IF
  160 CONTINUE
!$OMP END PARALLEL DO
*
*
*     The deflated eigenvalues and their corresponding vectors go back
*     into the last N - K slots of D and Q respectively.
*
      CALL DCOPY( N, D, 1, Z, 1 )
!$OMP PARALLEL DO PRIVATE(I,J,JS)
      DO 170 J = K + 1, N
         JS = INDXP( J )
         I = INDX( J )
         D( I ) = Z( JS )
  170 CONTINUE
!$OMP END PARALLEL DO
*
      PTT( 1 ) = 1
      DO 190 I = 2, 4
         CT = 0
         DO 180 J = 0, NPCOL - 1
            CT = CT + CTOT( J, I-1 )
  180    CONTINUE
         PTT( I ) = PTT( I-1 ) + CT
  190 CONTINUE
*
*
      IB1 = INDXC( 1 )
      IE1 = IB1
      IB2 = INDXC( PTT( 2 ) )
      IE2 = IB2
      DO 200 I = 2, PTT( 3 ) - 1
         IB1 = MIN( IB1, INDXC( I ) )
         IE1 = MAX( IE1, INDXC( I ) )
  200 CONTINUE
      DO 210 I = PTT( 2 ), PTT( 4 ) - 1
         IB2 = MIN( IB2, INDXC( I ) )
         IE2 = MAX( IE2, INDXC( I ) )
  210 CONTINUE
      NN1 = IE1 - IB1 + 1
      NN2 = IE2 - IB2 + 1
      NN = MAX( IE1, IE2 ) - MIN( IB1, IB2 ) + 1
  220 CONTINUE
      RETURN
*
*     End of PDLAED2_X
*
      END

module m_Potential_mixing
! $Id: m_Potential_Mixing.F90 376 2014-06-17 07:48:31Z jkoga $
!
  use m_Const_Parameters,    only : BUCS, DP, OFF &
       &                          , EXECUT,SIMPLE_CUBIC,BOHR,NO,ANTIFERRO &
       &                          , ANEW,RENEW,ON, SIMPLE,BROYD1,BROYD2,DFP,PULAY &
       &                          , OLD, NEXT, PAI, VTK &
       &                          , DELTA10 &
       &                          , unit_conv_byname, UMICRO, GAMMA, DELTA &
       &                          , ELECTRON, INVERSE, YES, CMPLDP
  use m_IterationNumbers,    only : iteration,iteration_for_cmix
  use m_Parallelization,     only : mpi_comm_group &
       &                          , ista_kngp,iend_kngp,is_kngp,ie_kngp,np_kngp,mp_kngp &
       &                          , npes,mype,ierr &
       &                          , is_kgpm,ie_kgpm,ista_kgpm,iend_kgpm,mp_kgpm &
       &                          , nis_fftp, nie_fftp, myrank_g, nrank_g
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,ipri,ipriwf, c_precon &
       &                          , amix,bmix,hownew,nbxmix,istrbr &
       &                          , kimg,af,neg,ipripulay &
       &                          , iprichargemixing &
       &                          , sw_recomposing, spin_density_mixfactor &
       &                          , amin, sw_precon_diff, sw_metric_diff,metric_ratio &
       &                          , sw_force_simple_mixing,printable

  use m_Crystal_Structure,   only : univol, sw_magnetic_constraint
  use m_PlaneWaveBasisSet,   only : kg,kgp,ngpt_l,ngabc,gr_l,kgpm

  use m_Electronic_Structure, only : vlhxc_l, vlhxco_l => vlhxc_l_old

  use m_Control_Parameters,  only : sw_mix_bothspins_sametime &
                                  , sw_recomposing_hsr, sw_force_simple_mixing_hsr
  use m_Ionic_System,        only : ityp, natm
  use m_PseudoPotential,     only : ilmt, nlmt

! =================================== added by K. Tagami ============== 11.0&13.0U2
  use m_Control_Parameters,  only : ndim_magmom, noncol, sw_mix_imaginary_hardpart, &
       &                            sw_hubbard, sw_mix_charge_hardpart
  use m_PseudoPotential,     only : ipaw, flg_paw,  dion_scr_noncl, dion_scr_noncl_old, &
       &                            dion_paw, dion_paw_old
  use m_Electronic_Structure, only : vlhxcQ, vlhxcQ_old, dhub, dhub_aimag
  use m_ES_Mag_Constraint,   only : MagField_constrain_hardpart
! ===================================================================== 11.0&13.0U2

  use m_Control_Parameters,  only : sw_gradient_simplex, alpha_pulay

  implicit none

  real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
  real(kind=DP), allocatable, dimension(:,:,:) :: vlhxcstore_l, vlhxcostore_l

  real(kind=DP),private,pointer, dimension(:,:,:) ::       rho,rhoo  ! MPI
  !         rho => vlhxc_l, rhoo => vlhxco_l ( when kgpm == kgp)
  !         rho and rhoo is projected from vlhxc_l and vlhxco_l, respectively ( otherwise)

  real(kind=DP),private,allocatable,dimension(:,:,:,:) :: rhoj,Frhoj
  real(kind=DP),private,allocatable,dimension(:,:,:)   :: rhojo,Frhojo
  real(kind=DP),private,allocatable,dimension(:,:,:)   :: rhoj_vhsr,Frhoj_vhsr
  real(kind=DP),private,allocatable,dimension(:,:)   :: rhoj_vhsro,Frhoj_vhsro

! === DEBUG by tkato 2011/09/09 ================================================
! real(kind=DP),private, pointer, dimension(:,:)        :: work
! ==============================================================================

!!$  integer, private,parameter   :: n_ratio_q1 = 20
  integer, private             :: n_ratio_q1 = 20
  real(DP),private,parameter   :: q0_default = 1.5*BOHR
  real(DP),private             :: amix_cprec, bmix_cprec
  logical, private             :: param_cprecon_decided = .false.
  real(DP),private             :: q0 = -1.d0, q1 = -1.d0
  real(DP),private,save        :: fg2, frg2

! --> T. Yamasaki, 03rd Aug. 2009
!!  real(DP),private,pointer,dimension(:,:)     :: c_p !d(ista_kngp:iend_kngp,nspin/(af+1))
  real(DP),public,pointer,dimension(:,:)     :: c_p !d(ista_kngp:iend_kngp,nspin/(af+1))

  real(DP),private,pointer,dimension(:,:)     :: c_pm !d(ista_kgpm:iend_kgpm,nspin/(af+1))
! <--

  ! -- For Broyden and DFP mixing method --
  integer, private,parameter                :: iU = 1, iVD = 1, iW = 2, iY = 2, iV = 2
  integer, private                          :: nspin_m
  real(DP),private,allocatable,dimension(:) :: f_p !d(ista_kgpm:iend_kgpm)
  real(DP),private,allocatable,dimension(:,:,:) :: d0_l,u_l,v_l,w_l,dout,dd_l
  real(DP),private,pointer,dimension(:,:,:)         :: F_l
  real(DP),private,allocatable,target,dimension(:,:,:) :: din
  !                                             d(kgpm,kimg,nspin_m)
  real(DP),private,allocatable,dimension(:,:,:)     :: dF_l
  !     dF_l(deltaF):= \Delta \cal F^{m} = \cal F^{m} - \cal F^{m-1}
  !              = F[\rho^{m}] - F[\rho^{m-1}] - (\rho^{m} - \rho^{m-1})
  real(DP),private,allocatable,target,dimension(:,:,:,:,:) :: urec_l
  real(DP),private,allocatable,dimension(:,:,:)     :: f      !d(nbxmix,nbxmix,nspin)
  real(DP),private,allocatable,dimension(:)         :: g      !d(nbxmix)
  !    f and g are used only when hownew == RENEW
  integer, private,allocatable,dimension(:)         :: ncrspd !d(nbxmix)
  real(DP),private,allocatable,dimension(:,:,:)     :: uuf    !d(nbxmix,nspin,2),
                                                   !only for DFP method
  real(DP),private,allocatable,dimension(:,:)       :: uuf_p
  real(DP),private,allocatable,dimension(:,:)       :: g_p
  real(DP),private,allocatable,dimension(:)         :: prj_wk
#ifdef _CDMIX_USE_POINTER_
! Tsuyoshi Miyazaki tmp
  real(DP),private,pointer,dimension(:,:,:)         :: urec_l_3
  real(DP),private,pointer,dimension(:,:,:)         :: urec_l_3_2
#endif

  logical          :: force_dealloc = .false.
  integer, private :: previous_waymix = 0

  include 'mpif.h'
  integer istatus(mpi_status_size)

! ========================== adde by K. Tagami ========================== 5.0
  integer :: nsize_rho_vhsr
  integer, private, allocatable :: imap_vhsr(:)    ! d(nsize_rho_vhsr)
  real(kind=DP),private,allocatable, dimension(:,:) ::   rho_vhsr, rhoo_vhsr
                                                  ! d(nsize_rho_vhsr,nspin)

  real(DP),private,allocatable,dimension(:,:) :: d0_vhsr, u_vhsr, v_vhsr, w_vhsr, &
        &                                        dout_vhsr, dd_vhsr
  real(DP),private,pointer,dimension(:,:)         :: FF_vhsr
  real(DP),private,allocatable,target,dimension(:,:) :: din_vhsr
  !                                             d( nsize_rho_vhsr,nspin_m)
  real(DP),private,allocatable,dimension(:,:)     :: dF_vhsr
  real(DP),private,allocatable,target,dimension(:,:,:,:) :: urec_vhsr

  logical, save :: first = .true.

  real(kind=DP), allocatable :: vnonlocal_store(:,:,:,:)
  real(kind=DP), allocatable :: vnonlocal_old_store(:,:,:,:)
  real(kind=DP), allocatable :: dion_paw_store(:,:,:,:)
  real(kind=DP), allocatable :: dion_paw_old_store(:,:,:,:)
!
  real(kind=DP), allocatable :: rho_store(:,:), vhsr(:,:,:,:)
  real(kind=DP), allocatable :: rhoo_store(:,:), vhsro(:,:,:,:)

! ==============================================================

! ========================== adde by K. Tagami ========================== 11.0
  integer :: nsize_rho_vhsr_unit
!  integer :: sw_mix_imaginary_hardpart = OFF
!  integer :: sw_mix_imaginary_hardpart = ON
! ======================================================================= 11.0

! =======
  real(kind=DP), allocatable :: vnonlocal_r(:,:,:,:), vnonlocal_r_old(:,:,:,:)
  real(kind=DP), allocatable :: vnonlocal_i(:,:,:,:), vnonlocal_i_old(:,:,:,:)
! ======

! --- contained subroutines ---
!   7. m_Pot_prepare_precon       <-(Potential_Mixing)
!  10. m_Pot_simple_mixing        <-(Potential_Mixing)
!  22. precon_4_pot_mix       <-(@10), (@53),(@54),(@55),(@60)
!  23. precon_4_mult             <-(@37),(@45),(48)
!  24. iter_from_reset           <-(@53),(@54),(@55),(@60)
!  25. icrspd_is                 <-(@53),(@54),(@55)
!  26. mult1s                    <-(@49),(@50),(@51),(@53),(@54),(@55),(@60)
!  27. mult1s5                   <-(@53),(@55),(@60)
!  28. mult1s10                  <-(@60)
!  29. subtr_j_th_term           <-(@49),(@50),(@53),(@55)
!  30. store_to_urec2            <-(@53),(@55)
!  31. set_ncrspd_mxiter_etc     <-(@53),(@54),(@55)
!    - rotate_cmix_arrays
!  32. simple_mix1               <-(@53),(@54),(@55),(@60)
!  33. scatter_chg_onto_d        <-(@32),(@40),(@51)
!  34. scatter_cp_onto_cpm       <-(@23),(@40)
!  35. concentrate_d_to_chg      <-(@51),(@55),(@60)
!  36. mix_dealloc_previous      <-(@53),(@54),(@55),(@60)
!  37. mix_broyden_allocate      <-(@51),(@54)
!  38. mix_broyden_deallocate    <-(@36)
!  39. mix_broyden_alloc2        <-(@54)
!  40. alloc_rho_rhoo_and_cpm    <-(@39),(@43),(@46),(@58)
!  41. mix_broyden_dealloc2      <-(@54)
!  42. dealloc_rho_rhoo_and_cpm  <-(@41),(@44),(@47),(@59)
!  43. mix_broyden_alloc3        <-(@53)
!  44. mix_broyden_dealloc3      <-(@53)
!  45. mix_DFP_allocate          <-(@55)
!  46. mix_DFP_alloc2            <-(@55)
!  47. mix_DFP_dealloc2          <-(@55)
!  -x. devide_v_with_vdF
!  49. renew_u_br                <-(@53),(@54)
!  50. renew_d_br                <-(@53),(@54)
!  51. renew_d_last_br           <-(@53),(@54)
!  52. simple_mix_large_Gc       <-(@51),(@55),(@60)
!  53. m_Pot_mix_broyden1         <-(Potential_Mixing)
!    - dF_F_d0_u_v_and_dd - renew_v
!  54. m_Pot_mix_broyden2         <-(Potential_Mixing)
!    - dF_F_d0_u_and_v
!  55. m_Pot_mix_DFP              <-(Potential_Mixing)
!    - dF_F_d0_u_and_w - renew_w - renew_d - renew_d_last
!  56. mix_pulay_allocate        <-(@60)
!  57. mix_pulay_deallocate      <-(@36)
!  58. mix_pulay_alloc2          <-(@60)
!  59. mix_pulay_dealloc2        <-(@60)
!  60. m_Pot_mix_pulay            <-(Potential_Mixing)
!    - mix_pulay_alloc3 - mix_pulay_dealloc3
!    - Resid_and_dd_into_urec - Ri_dot_Rj - Rj_dot_d
!    - get_finv -get_matrix -renew_d_using_g

contains

! ------------------------------------
  subroutine m_Pot_alloc_array_vnonlocal
    allocate( vnonlocal_r( nlmt,nlmt,natm,ndim_magmom ) )
    vnonlocal_r = 0.0d0
    if ( noncol ) then
       allocate( vnonlocal_i( nlmt,nlmt,natm,ndim_magmom ) )
       vnonlocal_i = 0.0d0
    endif

    if ( sw_mix_charge_hardpart == ON ) then
       allocate( vnonlocal_r_old( nlmt,nlmt,natm,ndim_magmom ) )
       vnonlocal_r_old = 0.0d0
    endif
    if ( noncol .and. sw_mix_imaginary_hardpart == ON ) then
       allocate( vnonlocal_i_old( nlmt,nlmt,natm,ndim_magmom ) )
       vnonlocal_i_old = 0.0d0
    endif
  end subroutine m_Pot_alloc_array_vnonlocal

  subroutine m_Pot_dealloc_array_vnonlocal
    deallocate( vnonlocal_r )
    if ( allocated( vnonlocal_r_old ) ) deallocate( vnonlocal_r_old )

    if ( noncol ) then
       deallocate( vnonlocal_i )
       if ( allocated( vnonlocal_i_old ) ) deallocate( vnonlocal_i_old )
    endif
  end subroutine m_Pot_dealloc_array_vnonlocal

  subroutine m_Pot_add_vnonlocal_to_vlhxcQ
    vlhxcQ = vlhxcQ + vnonlocal_r
  end subroutine m_Pot_add_vnonlocal_to_vlhxcQ

  subroutine m_Pot_cp_vnonlocal_to_old
    vnonlocal_r_old = vnonlocal_r
    if ( noncol .and. sw_mix_imaginary_hardpart == ON ) then
       vnonlocal_i_old = vnonlocal_i
    endif
  end subroutine m_Pot_cp_vnonlocal_to_old

  subroutine m_Pot_set_array_vnonlocal
    integer :: is

    if ( noncol ) then
       vnonlocal_r = 0.0d0;  vnonlocal_i = 0.0d0
       if ( sw_hubbard == ON ) then
          vnonlocal_r = dhub;   vnonlocal_i = dhub_aimag
       endif
       if ( sw_magnetic_constraint == ON ) then
          Do is=2, ndim_magmom
             vnonlocal_r(:,:,:,is) = vnonlocal_r(:,:,:,is) &
                  &               +MagField_constrain_hardpart(:,:,:,is-1)
          End Do
       endif
    else
       vnonlocal_r = 0.0d0
       if ( sw_hubbard == ON ) then
          vnonlocal_r = dhub
       endif
       if ( sw_magnetic_constraint == ON ) then
          vnonlocal_r(:,:,:,1) = vnonlocal_r(:,:,:,1) &
               &                +MagField_constrain_hardpart(:,:,:,1)
          vnonlocal_r(:,:,:,2) = vnonlocal_r(:,:,:,2) &
               &                -MagField_constrain_hardpart(:,:,:,1)
       endif
    endif

  end subroutine m_Pot_set_array_vnonlocal
! ------------------------------------

  subroutine alloc_vlhxcstore_recompos_vlhxc(rmxt,rmxtrc)
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc
#ifdef __TIMER_SUB__
    call timer_sta(1104)
#endif
    allocate(vlhxcstore_l(ista_kngp:iend_kngp,kimg,nspin))
    allocate(vlhxcostore_l(ista_kngp:iend_kngp,kimg,nspin))
#ifdef __TIMER_DO__
  call timer_sta(1149)
#endif
    vlhxcstore_l = vlhxc_l
    vlhxcostore_l = vlhxco_l
    vlhxc_l(:,:,1)  = vlhxcstore_l(:,:,1)  + vlhxcstore_l(:,:,2)
    vlhxc_l(:,:,2)  = vlhxcstore_l(:,:,1)  - vlhxcstore_l(:,:,2)
    vlhxco_l(:,:,1) = vlhxcostore_l(:,:,1) + vlhxcostore_l(:,:,2)
    vlhxco_l(:,:,2) = vlhxcostore_l(:,:,1) - vlhxcostore_l(:,:,2)
#ifdef __TIMER_DO__
  call timer_end(1149)
#endif
    rmxtrc(1) = rmxt
    rmxtrc(2) = rmxt*spin_density_mixfactor
#ifdef __TIMER_SUB__
    call timer_end(1104)
#endif
  end subroutine alloc_vlhxcstore_recompos_vlhxc

  subroutine compos_vlhxc_dealloc_vlhxcstore
#ifdef __TIMER_SUB__
    call timer_sta(1106)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1153)
#endif
    vlhxcstore_l = vlhxc_l
    vlhxc_l(:,:,1) = 0.5d0*(vlhxcstore_l(:,:,1) + vlhxcstore_l(:,:,2))
    vlhxc_l(:,:,2) = 0.5d0*(vlhxcstore_l(:,:,1) - vlhxcstore_l(:,:,2))
    vlhxco_l = vlhxcostore_l
#ifdef __TIMER_DO__
  call timer_end(1153)
#endif
    deallocate(vlhxcostore_l, vlhxcstore_l)
#ifdef __TIMER_SUB__
    call timer_end(1106)
#endif
  end subroutine compos_vlhxc_dealloc_vlhxcstore

  subroutine m_Pot_prepare_precon(nfout,rmxt)
    integer, intent(in)      :: nfout
    real(kind=DP), intent(in):: rmxt
    real(kind=DP) :: G_longest, G_shortest, x, gg,gg_mpi
    integer       :: i, n
    real(kind=DP) :: G_longest_mpi, G_shortest_mpi
    integer       :: ist !mpi

    if(param_cprecon_decided) return
#ifdef __TIMER_SUB__
    call timer_sta(1102)
#endif

    if(iprichargemixing >= 2) write(nfout,*) ' << d_para_cprec >>'

!mpi    G_longest = maxval(gr_l)
!mpi    G_shortest = minval(gr_l(2:kgp))
    G_longest_mpi = maxval(gr_l(ista_kngp:iend_kngp))

    ist = ista_kngp
    if(ist == 1) ist = 2

    G_shortest_mpi = minval(gr_l(ist:iend_kngp))
    call mpi_allreduce(G_longest_mpi,G_longest,1 &
                   &  ,mpi_double_precision,mpi_max,mpi_comm_group,ierr)
    call mpi_allreduce(G_shortest_mpi,G_shortest,1 &
                   &  ,mpi_double_precision,mpi_min,mpi_comm_group,ierr)
    if(iprichargemixing >= 2) then
       write(nfout,*) ' G_longest = ', G_longest
       write(nfout,*) ' G_shortest = ', G_shortest
    end if
    amix_cprec = amix; bmix_cprec = bmix
    if(amix_cprec < 0.d0) then
       amix_cprec = rmxt
       if(iprichargemixing >= 2) write(nfout,*) ' amix_cprec = ', amix_cprec
    end if
    if(bmix_cprec < 0.d0) then
       q0 = q0_default
    else
       q0 = bmix_cprec*G_shortest
    end if
    q0 = q0*q0
    if(iprichargemixing >= 2) then
       write(nfout,*) ' bmix_cprec = ', bmix_cprec
       write(nfout,*) ' q0   = ', q0
    end if

    if (metric_ratio>0) n_ratio_q1 = metric_ratio

    x = G_longest**2  - n_ratio_q1*G_shortest**2
    if(x < 0.d0) then
       n = (G_longest/G_shortest)**2 - 1.d0
       if(n <= 0) n = 1
       x = G_longest**2 - n * G_shortest**2
    else
       n = n_ratio_q1
    end if
    if(iprichargemixing >= 2) write(nfout,*) ' n = ', n
    q1 = (n-1) * G_shortest**2 * G_longest**2/x
    q1 = dsqrt(q1)
    if(iprichargemixing >= 2) write(nfout,*) ' q1 = ', q1

    if(nspin == 2 .or. noncol ) then  
       i = 2
!!$       gg = gr_l(i)**2
       gg = 0.d0
       if(ista_kngp <= i .and. i <= iend_kngp) gg = gr_l(i)**2
       if(npes > 1) then
          call mpi_allreduce(gg,gg_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          gg = gg_mpi
       end if

       if(iprichargemixing >= 2) write(nfout,'(" !! gg = ",d20.8)') gg

       if (amin<=0) then
          amin = 0.d0
       endif
       fg2 = max(gg/(gg+q0),amin)
       frg2 = 1.0d0 + q1**2/gg
       if(iprichargemixing >= 2) then
          write(nfout,*) ' ! amix_cprec = ', amix_cprec, ' fg2 = ', fg2
          write(nfout,*) ' ! amix_cprec*g_S**2/(g_S**2+q0) = ', amix_cprec*fg2
       end if
    else
       fg2 = 0.d0
       frg2 = 0.d0
    endif

    param_cprecon_decided = .true.
#ifdef __TIMER_SUB__
    call timer_end(1102)
#endif
  end subroutine m_Pot_prepare_precon

  subroutine m_Pot_force_dealloc()
    force_dealloc = .true.
  end subroutine m_Pot_force_dealloc

  subroutine m_Pot_simple_mixing(nfout,rmxt)
    integer ,intent(in)      :: nfout
    real(kind=DP),intent(in) :: rmxt

    integer       :: is, k
    integer       :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1103)
#endif

! ================================ modified by K. Tagami =============== 11.0
!!! --> T. Yamasaki  03 Aug. 2009
!!    nspin_m  = nspin/(af+1)
!!! <--
!
    if ( noncol ) then
       nspin_m = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

    call tstatc0_begin('m_Pot_simple_mixing ',id_sname,1)

    if(previous_waymix /= SIMPLE.or.force_dealloc) then
       call mix_dealloc_previous()
! ------------------------------  ktDEBUG -------------------- 20121030
       call mix_dealloc_previous_vhsr()
! ------------------------------  ktDEBUG -------------------- 20121030
       force_dealloc = .false.
    end if

! ================================ modified by K. Tagami =============== 11.0
!! --> T. Yamasaki  03 Aug. 2009
!    allocate(rmxtrc(nspin_m))
!
!    if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
!       call alloc_vlhxcstore_recompos_vlhxc(rmxt,rmxtrc) ! --> vlhxc_l, vlhxco_l, rmxtrc
!    else
!       rmxtrc = rmxt
!    end if
!    if(ipri >= 2) write(nfout,'(" rmxt = ",d20.8)') rmxt
!! --> T. Yamasaki  03 Aug. 2009
!
!
    allocate(rmxtrc(nspin_m))

    if ( noncol ) then
       rmxtrc = rmxt
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vlhxcstore_recompos_vlhxc(rmxt,rmxtrc) ! --> vlhxc_l, vlhxco_l, rmxtrc
       else
          rmxtrc = rmxt
       endif
    end if
    if(ipri >= 2) write(nfout,'(" rmxt = ",d20.8)') rmxt
! ====================================================================== 11.0

!!$    allocate(c_p(ista_kngp:iend_kngp))
    allocate(c_p(ista_kngp:iend_kngp,nspin_m))
    c_p = 0.0d0                 ! ===== Adde by K. Tagami =========


! ================================ modified by K. Tagami =============== 11.0
!!    call precon_4_pot_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_pot_mix_noncl(rmxtrc,c_p)
!       write(*,*) 'rmxtrc = ', rmxtrc
!       write(*,*) 'cp = ', c_p
!       stop
    else
       call precon_4_pot_mix(rmxtrc,c_p)
!       write(*,*) 'rmxtrc = ', rmxtrc
!       write(*,*) 'cp = ', c_p
!       stop
    endif
! ======================================================================= 11.0


#ifdef __TIMER_DO__
  call timer_sta(1148)
#endif
! ================================ modified by K. Tagami ================ 11.0
!!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       do k = 1, kimg
          vlhxc_l(:,k,is) = c_p(:,is)*vlhxc_l(:,k,is) + (1.0d0-c_p(:,is))*vlhxco_l(:,k,is)
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1148)
#endif
    deallocate(c_p)

!
    if ( .not. noncol ) then
       if (sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_vlhxc_dealloc_vlhxcstore()
       end if
    endif
    deallocate(rmxtrc)

    previous_waymix = SIMPLE
    call tstatc0_end(id_sname)

#ifdef __TIMER_SUB__
    call timer_end(1103)
#endif
  end subroutine m_Pot_simple_mixing

  subroutine precon_4_pot_mix(pmix,c_p)
    real(DP),intent(in),dimension(nspin_m)                       :: pmix
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,nspin_m) :: c_p
    integer              :: i
    real(DP)             :: gg, agg, tmp
    integer              :: ist  !for mpi
    integer              :: is
#ifdef __TIMER_SUB__
    call timer_sta(1105)
#endif

    if(iprichargemixing >= 2) write(6,'("! pmix(precon_4_pot_mix) = ",f8.4)') pmix
    if(c_precon) then
       ist = ista_kngp
       if(ist == 1) ist = 2
       if(nspin_m == 2) then
#ifdef __TIMER_DO__
  call timer_sta(1150)
#endif
          do i = ist, iend_kngp  !for mpi
             gg = gr_l(i)*gr_l(i)
             tmp = max(gg/(gg+q0),amin)
!!$             agg = amix_cprec*gg/(gg+q0)
             agg = amix_cprec*tmp
             c_p(i,1) = agg * pmix(1)
             if (sw_recomposing==ON .and. sw_precon_diff==NO)then
                c_p(i,2) = amix_cprec * pmix(2)
             else
                c_p(i,2) = agg * pmix(2)
             endif
          enddo
#ifdef __TIMER_DO__
  call timer_end(1150)
#endif
          if(mype == 0) then
             c_p(1,1) = amix_cprec*fg2 * pmix(1)
             if (sw_recomposing==ON .and. sw_precon_diff==NO)then
                c_p(1,2) = amix_cprec * pmix(2)
             else
                c_p(1,2) = amix_cprec*fg2 * pmix(2)
             endif
          end if
       else
#ifdef __TIMER_DO__
  call timer_sta(1151)
#endif
          do i = ist, iend_kngp  !for mpi
             gg = gr_l(i)*gr_l(i)
             tmp = max(gg/(gg+q0),amin)
!!$             c_p(i,1) = amix_cprec*gg/(gg+q0) * pmix(1)
             c_p(i,1) = amix_cprec* tmp * pmix(1)
          end do
#ifdef __TIMER_DO__
  call timer_end(1151)
#endif
          if(mype == 0) c_p(1,1) = amix_cprec*fg2 * pmix(1)
       end if
    else
#ifdef __TIMER_DO__
  call timer_sta(1152)
#endif
       do is = 1, nspin, af+1
          c_p(:,is) = pmix(is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1152)
#endif
    endif
#ifdef __TIMER_SUB__
    call timer_end(1105)
#endif
  end subroutine precon_4_pot_mix

! ===================================== added by K. Tagami ================ 11.0
  subroutine precon_4_pot_mix_noncl(pmix,c_p)
    real(DP),intent(in),dimension(nspin_m)                       :: pmix
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,nspin_m) :: c_p
    integer              :: i
    real(DP)             :: gg, agg, tmp
    integer              :: ist  !for mpi
    integer              :: is

    if(iprichargemixing >= 2) then
       write(6,'("! pmix(precon_4_pot_mix_noncl) = ",f8.4)') pmix
    end if

    if(c_precon) then
       ist = ista_kngp
       if(ist == 1) ist = 2

       do i = ist, iend_kngp  !for mpi
          gg = gr_l(i)*gr_l(i)
          tmp = max(gg/(gg+q0),amin)
!!$             agg = amix_cprec*gg/(gg+q0)
          agg = amix_cprec*tmp
          c_p(i,:) = agg * pmix(:)
       end do
       if (mype == 0) then
          c_p(1,:) = amix_cprec*fg2 * pmix(:)
       end if
    else
       do is = 1, ndim_magmom
          c_p(:,is) = pmix(is)
       end do
    endif

  end subroutine precon_4_pot_mix_noncl
! ============================================================== 11.0

  subroutine precon_4_mult(f_q)
    real(DP),intent(out), dimension(ista_kgpm:iend_kgpm)   :: f_q
    integer  :: i, ist      !mpi
    real(kind=DP), pointer, dimension(:) :: gr_l_m

    f_q = 0.d0
    if(c_precon ) then
       ist  = ista_kgpm
       if(ist == 1) ist = 2
       if(kgp == kgpm .or. npes == 1) then
          do i = ist, iend_kgpm  !for mpi
             f_q(i) = 1.0d0 + (q1/gr_l(i))**2
          end do
       else
          allocate(gr_l_m(ista_kngp:iend_kngp))
! ============================== by K. Tagami =============
        gr_l_m = 0.0d0
! ========================================================
          call scatter_cp_onto_cpm(gr_l,gr_l_m)
          do i = ist, iend_kgpm  !for mpi
             f_q(i) = 1.0d0 + (q1/gr_l_m(i))**2
          end do
          deallocate(gr_l_m)
       end if
       if(mype==0) f_q(1) = frg2
!mpi       f_q(2:kgpm) = 1 + (q1/gr_l(2:kgpm))**2
!mpi       f_q(1)       = frg2
    else
       f_q          = 1.d0
    end if

  end subroutine precon_4_mult

  function iter_from_reset()
    integer             :: n, nbox
    integer             :: iter_from_reset
    if(hownew ==  ANEW) then
       n = (iteration_for_cmix - istrbr - 1)/(nbxmix-1)
       if(n < 0) n = 0
       nbox = iteration_for_cmix - (n*(nbxmix-1) + istrbr +1) + 2
       iter_from_reset = nbox + istrbr - 1
    else
       iter_from_reset = iteration_for_cmix
    endif
  end function iter_from_reset

  function icrspd_is(iter)
    integer, intent(in) :: iter
    integer             :: icrspd_is
    if(iter-istrbr+1 < nbxmix) then
       icrspd_is = ncrspd(iter-istrbr+1)
    else
       icrspd_is = ncrspd(nbxmix)
    endif
  end function icrspd_is

  subroutine mult1s(u,v,f_q,fmult)
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i
#ifdef __TIMER_SUB__
    call timer_sta(1114)
#endif

    fmult = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

       p = 0.d0
       fac=1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1160)
#endif
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             endif
! ======================================================================== 11.0

!             p = p + f_q(i)*u(i,ik,is)*v(i,ik,is)
             p = p + fac*u(i,ik,is)*v(i,ik,is)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1160)
#endif
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_end(1114)
#endif
  end subroutine mult1s

  subroutine mult1s_reduce_spin(u,v,f_q,fmult)
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
!!$    real(DP),intent(out),dimension(nspin_m)            :: fmult
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

    fmult = 0.d0
    p = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

!!$       p = 0.d0
       fac=1.0d0
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             endif
! ======================================================================== 11.0

!             p = p + f_q(i)*u(i,ik,is)*v(i,ik,is)
             p = p + fac*u(i,ik,is)*v(i,ik,is)
          end do
       end do
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
    enddo
    fmult = p
  end subroutine mult1s_reduce_spin

  subroutine mult1s5(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

#ifdef __TIMER_SUB__
    call timer_sta(1115)
#endif
    fmult = 0.d0
! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

       p = 0.d0
       fac=1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1162)
#endif
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             end if
! ========================================================================= 11.0

             p = p + fac*u(i,ik,is,j,iuv)*v(i,ik,is)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1162)
#endif
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_sta(1115)
#endif
  end subroutine mult1s5

  subroutine mult1s5_reduce_spin(u,mb,muv,j,iuv,v,f_q,fmult)
    integer,intent(in) :: mb,muv,j,iuv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m) :: v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
!!$    real(DP),intent(out),dimension(nspin_m)            :: fmult
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,i

    fmult = 0.d0
    p = 0.d0

! ================================ modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ===================================================================== 11.0

!!$       p = 0.d0
       fac = 1.0d0
       do ik = 1,kimg
          do i = ista_kgpm, iend_kgpm   ! mpi
! ========================================== modified by K. Tagami ======== 11.0
!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(i)
!
             if ( noncol ) then
                fac=f_q(i)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(i)
                endif
             end if
! ========================================================================= 11.0

             p = p + fac*u(i,ik,is,j,iuv)*v(i,ik,is)
          end do
       end do
    enddo
    if( npes >= 2) then
       call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       p = p_mpi
    end if
    fmult = p*univol
  end subroutine mult1s5_reduce_spin

  subroutine mult1s10(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out),dimension(nspin_m)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,ig
#ifdef __TIMER_SUB__
    call timer_sta(1137)
#endif

    fmult = 0.d0

! ====================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0

       p = 0.d0
       fac = 1.0d0
#ifdef __TIMER_DO__
  call timer_sta(1186)
#endif
       do ik = 1,kimg
          do ig = ista_kgpm, iend_kgpm   ! mpi
! ====================================== modified by K. Tagami ============= 11.0
!!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(ig)
!
             if ( noncol ) then
                fac=f_q(ig)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(ig)
                endif
             end if
! ========================================================================== 11.0

             p = p + fac*u(ig,ik,is,i,iu)*v(ig,ik,is,j,iv)
          end do
       end do
#ifdef __TIMER_DO__
  call timer_end(1186)
#endif
       if( npes >= 2) then
          call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
          p = p_mpi
       end if
       fmult(is) = p*univol
    enddo
#ifdef __TIMER_SUB__
    call timer_end(1137)
#endif
  end subroutine mult1s10

  subroutine mult1s10_reduce_spin(u,mb,muv,i,iu,v,j,iv,f_q,fmult)
    integer,intent(in) :: mb,muv,i,iu,j,iv
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm,kimg,nspin_m,mb,muv) :: u,v
    real(DP),intent(in), dimension(ista_kgpm:iend_kgpm):: f_q
    real(DP),intent(out)            :: fmult

    real(DP) :: p, p_mpi, fac
    integer  :: is,ik,ig

    fmult = 0.d0
    p = 0.d0

! ====================================== modified by K. Tagami =========== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0

!!$       p = 0.d0
       fac = 1.0d0
       do ik = 1,kimg
          do ig = ista_kgpm, iend_kgpm   ! mpi

! ====================================== modified by K. Tagami ============= 11.0
!!             if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) fac=f_q(ig)
!
             if ( noncol ) then
                fac=f_q(ig)
             else
                if (is==1 .or. sw_recomposing==OFF .or. sw_metric_diff==ON) then
                   fac=f_q(ig)
                endif
             end if
! ========================================================================== 11.0

             p = p + fac*u(ig,ik,is,i,iu)*v(ig,ik,is,j,iv)
          end do
       end do
    enddo
    if( npes >= 2) then
       call mpi_allreduce(p,p_mpi,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       p = p_mpi
    end if
    fmult = p*univol
  end subroutine mult1s10_reduce_spin

  subroutine subtr_j_th_term(f,iuv,j,um)
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP), intent(in),   dimension(nspin) :: f
    real(DP), intent(in),   dimension(nspin_m) :: f
! ==============================================================================
    integer,  intent(in)                     :: iuv,j
    real(DP), intent(inout)                  :: um(ista_kgpm:iend_kgpm,kimg,nspin_m)
    integer :: is, ik, i, istart
#ifdef __TIMER_SUB__
    call timer_sta(1116)
#endif

    istart = ista_kgpm
    if(istart == 1) istart = 2
#ifdef __TIMER_DO__
  call timer_sta(1164)
#endif

! =============================== modified by K. Tagami =================== 11.0
!!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0

       do ik = 1, kimg
          do i = istart, iend_kgpm   ! mpi
             um(i,ik,is) = um(i,ik,is) - f(is)*urec_l(i,ik,is,j,iuv)
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1164)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1116)
#endif
  end subroutine subtr_j_th_term

  subroutine store_to_urec2(v,f,j,iuv)
    real(DP), intent(in)                     :: v(ista_kgpm:iend_kgpm,kimg,nspin_m)
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP), intent(in),  dimension(nspin)  :: f
    real(DP), intent(in),  dimension(nspin_m)  :: f
! ==============================================================================
    integer , intent(in)                     :: j,iuv

    real(DP)          :: dv
    integer           :: is
#ifdef __TIMER_SUB__
    call timer_sta(1119)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1165)
#endif
! ====================================== modified by K. Tagami ============= 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0

       dv = 1.d0/f(is)
       urec_l(:,:,is,j,iuv) = v(:,:,is)*dv
    end do
#ifdef __TIMER_DO__
  call timer_end(1165)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1119)
#endif
  end subroutine store_to_urec2

  subroutine set_ncrspd_mxiter_etc(iter,iuv,mxiter)
    integer, intent(in)  :: iuv,iter
    integer, intent(out) :: mxiter
#ifdef __TIMER_SUB__
    call timer_sta(1111)
#endif
    if(hownew == RENEW) then
       if((iter-istrbr+1) >= 3) then
          if((iter-istrbr+1) > nbxmix) then   ! When the box overflows
             call rotate_cmix_arrays          !-(contained here) ->mxiter,ncrspd,urec_l,f,g
          else
             mxiter = (iter-istrbr+1) - 1
             ncrspd(iter-istrbr+1) = iter-istrbr+1
          endif
       else
          mxiter = (iter-istrbr+1) - 1
          ncrspd(1) = 1
          ncrspd(2) = 2
       endif
    else ! if(hownew == ANEW)
       mxiter = (iter-istrbr+1) - 1
       ncrspd(iter-istrbr+1) = iter-istrbr+1
    endif

#ifdef __TIMER_SUB__
    call timer_end(1111)
#endif
  contains
    subroutine rotate_cmix_arrays
      integer :: is,j,i,icr,jcr,iwork
#ifdef __TIMER_SUB__
    call timer_sta(1112)
#endif

#ifdef __TIMER_DO__
  call timer_sta(1158)
#endif
! ======================================= modified by K. Tagami ========= 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0

         do j = 3, nbxmix
            icr = ncrspd(2)
            jcr = ncrspd(j)
            g(j) = f(icr,jcr,is)
            do i = 3, j-1
               icr = ncrspd(i)
               g(j) = g(j) - f(icr,jcr,is)*g(i)
            enddo
            icr = ncrspd(2)
            urec_l(:,:,is,jcr,iuv) &
                 & = urec_l(:,:,is,jcr,iuv) + g(j)*urec_l(:,:,is,icr,iuv)
         enddo
      enddo
#ifdef __TIMER_DO__
  call timer_end(1158)
#endif
      mxiter = nbxmix-1
      iwork = ncrspd(2)
#ifdef __TIMER_DO__
  call timer_sta(1159)
#endif
      do i = 2, mxiter
         ncrspd(i)= ncrspd(i+1)
      end do
#ifdef __TIMER_DO__
  call timer_end(1159)
#endif
      ncrspd(mxiter+1) = iwork
#ifdef __TIMER_SUB__
    call timer_end(1112)
#endif
    end subroutine rotate_cmix_arrays
  end subroutine set_ncrspd_mxiter_etc

  subroutine simple_mix2(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: p
    integer  :: is,k

! ==================================== added by K. Tagami ============ 11.0
    if ( noncol ) return
! ===================================================================11.0

    if(nspin<2 .or. af==1) return

    if(kgpm == kgp .or. npes == 1) then
!!$       write(6,'(" ! kgpm == kgp")')
       do is = 2, 2
          din (ista_kgpm:iend_kgpm,:,is) = vlhxco_l(ista_kgpm:iend_kgpm,:,is)
          dout(ista_kgpm:iend_kgpm,:,is) = vlhxc_l (ista_kgpm:iend_kgpm,:,is)
       end do
    else
       call scatter_chg_onto_d(vlhxco_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(vlhxc_l, dout)  ! -(m_C.D.)
    end if

    do is = 2,2
       do k = 1, kimg
          vlhxc_l(:,k,is) = p(:,is)*vlhxc_l(:,k,is) + (1.0d0-p(:,is))*vlhxco_l(:,k,is)
       end do
    end do
  end subroutine simple_mix2

  subroutine simple_mix1(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: p
    integer  :: is,k
#ifdef __TIMER_SUB__
    call timer_sta(1108)
#endif

    if(kgpm == kgp .or. npes == 1) then
!!$       write(6,'(" ! kgpm == kgp")')
#ifdef __TIMER_DO__
  call timer_sta(1154)
#endif
! ========================= modified by K. Tagami ==================== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

          din (ista_kgpm:iend_kgpm,:,is) = vlhxco_l(ista_kgpm:iend_kgpm,:,is)
          dout(ista_kgpm:iend_kgpm,:,is) = vlhxc_l (ista_kgpm:iend_kgpm,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1154)
#endif
    else
       call scatter_chg_onto_d(vlhxco_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(vlhxc_l, dout)  ! -(m_C.D.)
    end if

#ifdef __TIMER_DO__
  call timer_sta(1155)
#endif
! ========================= modified by K. Tagami ==================== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0
       do k = 1, kimg
          vlhxc_l(:,k,is) = p(:,is)*vlhxc_l(:,k,is) + (1.0d0-p(:,is))*vlhxco_l(:,k,is)
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1155)
#endif

#ifdef __TIMER_SUB__
    call timer_end(1108)
#endif
  end subroutine simple_mix1

  subroutine scatter_chg_onto_d(c,d)
! ================================== modified by K. Tagami ============= 11.0
!    real(DP),intent(in), dimension(ista_kngp:iend_kngp,kimg,nspin) :: c
!    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,kimg,nspin) :: d
!
    real(DP),intent(in), dimension(ista_kngp:iend_kngp,kimg,ndim_magmom) :: c
    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,kimg,ndim_magmom) :: d
! ======================================================================= 11.0

    integer :: ip,is,istart,iend,nelmnt,i,ik,ipbase
#ifdef __TIMER_SUB__
    call timer_sta(1121)
#endif

    nelmnt = mp_kngp*kimg*nspin_m
    prj_wk = 0.d0
    do ip = 0, npes - 1
       ! (1)  coping input data onto a work array, and broadcasting
       if(is_kngp(ip) > kgpm) exit
#ifdef __TIMER_DO__
  call timer_sta(1168)
#endif
       if(ip == mype) then

! =============================== modified by K. Tagami ============== 11.0
!          do is = 1, nspin, af+1
          do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

             do ik = 1, kimg
                ipbase = mp_kngp*(ik-1) + mp_kngp*kimg*(is-1)
                do i = 1, iend_kngp-ista_kngp+1
                   prj_wk(i + ipbase) = c(ista_kngp-1+i,ik,is)
!!$                   prj_wk(i,ik,is) = c(ista_kngp-1+i,ik,is)
                end do
             end do
          end do
       end if
#ifdef __TIMER_DO__
  call timer_end(1168)
#endif
       call mpi_bcast(prj_wk,nelmnt,mpi_double_precision,ip,mpi_comm_group,ierr)

       ! (2) projection
       istart = ista_kgpm; if(istart < is_kngp(ip)) istart = is_kngp(ip)
       iend   = iend_kgpm; if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
       if(iend < istart) cycle
#ifdef __TIMER_DO__
  call timer_sta(1170)
#endif
! ====================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0

          do ik = 1, kimg
             ipbase = mp_kngp*(ik-1) + mp_kngp*kimg*(is-1)
             do i = istart, iend
                d(i,ik,is) = prj_wk(i + ipbase)
!!$                d(i,ik,is) = prj_wk(i - is_kngp(ip)+1,ik,is)
             end do
          end do
!!$          d(istart:iend,:,is) = prj_wk(istart-is_kngp(ip)+1:iend-is_kngp(ip)+1,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1170)
#endif
    end do
#ifdef __TIMER_SUB__
    call timer_end(1121)
#endif
  end subroutine scatter_chg_onto_d

  subroutine scatter_cp_onto_cpm(cp,cpm)
    real(DP),intent(in), dimension(ista_kngp:iend_kngp,nspin_m) :: cp
    real(DP),intent(out),dimension(ista_kgpm:iend_kgpm,nspin_m) :: cpm

    integer :: ip,istart,iend,i, is, ibase, nelmnt

! --> T. Yamasaki, 03rd Aug. 2009
    nelmnt = mp_kngp*nspin_m
! <--
!!$    print '(" -- scatter_cp_onto_cpm -- ")'
    do ip = 0, npes - 1
       ! (1)  coping input data onto a work array, and broadcasting
       if(is_kngp(ip) > kgpm) exit
       if(ip == mype) then
! --> T. Yamasaki, 03rd Aug. 2009

! ============================= modified by K. Tagami ================= 11.0
!          do is = 1, nspin, af+1
          do is = 1, ndim_magmom, af+1
! ==================================================================== 11.0

             ibase = mp_kngp*(is-1)
             do i = 1, iend_kngp-ista_kngp+1
                prj_wk(i+ibase) = cp(ista_kngp-1+i,is)
             end do
          end do
!!$          do i = 1, iend_kngp-ista_kngp+1
!!$             prj_wk(i)     = cp(ista_kngp-1+i)
!!$!!$             prj_wk(i,1,1) = cp(ista_kngp-1+i)
!!$          end do
       end if
!!$       call mpi_bcast(prj_wk,mp_kngp,mpi_double_precision,ip,mpi_comm_group,ierr)
       call mpi_bcast(prj_wk,mp_kngp*nspin_m,mpi_double_precision,ip,mpi_comm_group,ierr)
! <--
       ! (2) projection
       istart = ista_kgpm; if(istart < is_kngp(ip)) istart = is_kngp(ip)
       iend   = iend_kgpm; if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
       if(iend < istart) cycle
! --> T. Yamasaki, 03rd Aug. 2009

! ==================================== modified by K. Tagami ============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0
          ibase = mp_kngp*(is-1)
          do i = istart, iend
             cpm(i,is) = prj_wk(i + ibase)
          end do
       end do
!!$       do i = istart, iend
!!$          cpm(i) = prj_wk(i - is_kngp(ip)+1)
!!$!!$          cpm(i) = prj_wk(i -is_kngp(ip)+1,1,1)
!!$       end do
!!$!!$       cpm(istart:iend) = prj_wk(istart-is_kngp(ip)+1:iend-is_kngp(ip)+1,1,1)
! <--
    end do
  end subroutine scatter_cp_onto_cpm

  subroutine concentrate_d_to_chg(d,c)
! ============================= modified by K. Tagami ====================== 11.0
!    real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,kimg,nspin) :: d
!    real(DP),intent(out), dimension(ista_kngp:iend_kngp,kimg,nspin) :: c
    real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,kimg,ndim_magmom) :: d
    real(DP),intent(out), dimension(ista_kngp:iend_kngp,kimg,ndim_magmom) :: c
! =========================================================================== 11.0

    integer :: ip,is,istart,iend,nelmnt,ik,i,ip2,ipbase
!!$    integer :: istart_p, iend_p

#ifdef __TIMER_SUB__
    call timer_sta(1122)
#endif
    if(kgpm < kgp .and. npes /= 1) then
       nelmnt = mp_kgpm*kimg*nspin_m
       do ip = 0, npes - 1
          if(is_kngp(ip) > kgpm) exit
          do ip2 = 0, npes - 1
             istart = is_kgpm(ip2); if(istart < is_kngp(ip)) istart = is_kngp(ip)
             iend   = ie_kgpm(ip2); if(iend   > ie_kngp(ip)) iend   = ie_kngp(ip)
             if(iend < istart) cycle
             if(mype == ip2) then
#ifdef __TIMER_DO__
  call timer_sta(1171)
#endif
! ================================ modified by K. Tagami ================= 11.0
!                do is = 1, nspin, af+1
                do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
                   do ik = 1, kimg
                      ipbase = mp_kgpm*(ik-1) + mp_kgpm*kimg*(is-1) - istart + 1
                      do i = istart, iend
                         prj_wk(i+ipbase) = d(i,ik,is)
                      end do
                   end do
                end do
#ifdef __TIMER_DO__
  call timer_end(1171)
#endif
                call mpi_send(prj_wk,nelmnt,mpi_double_precision,ip,1,mpi_comm_group,ierr)
             end if
             if(mype == ip) then
                call mpi_recv(prj_wk,nelmnt,mpi_double_precision,ip2,1,mpi_comm_group,istatus,ierr)
#ifdef __TIMER_DO__
  call timer_sta(1173)
#endif
! ================================ modified by K. Tagami ================= 11.0
!                do is = 1, nspin, af+1
                do is = 1, ndim_magmom, af+1
! ======================================================================== 11.0
                   do ik = 1, kimg
                      ipbase = mp_kgpm*(ik-1) + mp_kgpm*kimg*(is-1) - istart + 1
                      do i = istart, iend
                         c(i,ik,is) = prj_wk(i+ipbase)
                      end do
                   end do
                end do
#ifdef __TIMER_DO__
  call timer_end(1173)
#endif
             end if
             call mpi_barrier(mpi_comm_group,ierr)
          end do
       end do
    end if
#ifdef __TIMER_SUB__
    call timer_end(1122)
#endif
  end subroutine concentrate_d_to_chg

  subroutine mix_dealloc_previous()
    if(previous_waymix == BROYD2) then
       call mix_broyden_deallocate()
    else if(previous_waymix == PULAY) then
       call mix_PULAY_deallocate()
    end if
  end subroutine mix_dealloc_previous

  subroutine mix_broyden_allocate
!!$    if(allocated(f_p)) return

! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

! ================================ Modofied by K. Tagami ===========
!    allocate(f_p(ista_kgpm:iend_kgpm)); call precon_4_mult(f_p) !-(m_Pot)
    allocate(f_p(ista_kgpm:iend_kgpm)); f_p = 0.0d0
    call precon_4_mult(f_p) !-(m_Pot)
! ================================================================
    allocate(din(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dout(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dF_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(urec_l(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix,2))
    allocate(prj_wk(mp_kngp*kimg*nspin_m))
! ======================================Added by K. Tagami ========
    din = 0.0d0; dout = 0.0d0; dF_l = 0.0d0; urec_l = 0.0d0; prj_wk = 0.0d0
! ==================================================================
    if(hownew == RENEW) then
! ============================= modified by K. Tagami =========== 11.0
!       allocate(f(nbxmix,nbxmix,nspin))
!
       if ( noncol ) then
          allocate(f(nbxmix,nbxmix,ndim_magmom))
       else
          allocate(f(nbxmix,nbxmix,nspin))
       endif
! =============================================================== 11.0
       allocate(g(nbxmix))
! ================================= Added by K. Tagami ==========
        f = 0.0d0; g = 0.0d0
! ==============================================================
    end if
    allocate(ncrspd(nbxmix))
! ================================= Added by K. Tagami ==========
        ncrspd = 0
! ==============================================================
  end subroutine mix_broyden_allocate

  subroutine mix_broyden_deallocate
    if(allocated(f_p)) deallocate(f_p)
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(dF_l)) deallocate(dF_l)
    if(allocated(urec_l)) deallocate(urec_l)
    if(allocated(prj_wk)) deallocate(prj_wk)
    if(allocated(f)) deallocate(f)
    if(allocated(g)) deallocate(g)
    if(allocated(ncrspd)) deallocate(ncrspd)
  end subroutine mix_broyden_deallocate

  subroutine mix_broyden_alloc2
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(u_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(v_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami =======
    d0_l = 0; u_l = 0; v_l = 0
! =======================================================================
    call alloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_alloc2

  subroutine alloc_rho_rhoo_and_cpm
    if(kgpm < kgp .and. npes /= 1 ) then
       allocate(rho(ista_kgpm:iend_kgpm,kimg,nspin_m))
       allocate(rhoo(ista_kgpm:iend_kgpm,kimg,nspin_m))
       allocate(c_pm(ista_kgpm:iend_kgpm,nspin_m))
! ============================================= Added by K. Tagami ======
       rho = 0.0d0; rhoo = 0.0d0 ; c_pm = 0.0d0
! =======================================================================
       call scatter_chg_onto_d(vlhxc_l,rho)
       call scatter_chg_onto_d(vlhxco_l,rhoo)
       call scatter_cp_onto_cpm(c_p,c_pm)
    else
       rho => vlhxc_l; rhoo => vlhxco_l; c_pm => c_p
    end if
  end subroutine alloc_rho_rhoo_and_cpm

  subroutine mix_broyden_dealloc2
    deallocate(d0_l); deallocate(u_l); deallocate(v_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_dealloc2

  subroutine dealloc_rho_rhoo_and_cpm
    if(kgpm < kgp .and. npes /= 1) deallocate(rho)
    if(kgpm < kgp .and. npes /= 1) deallocate(rhoo)
    if(kgpm < kgp .and. npes /= 1) deallocate(c_pm)
  end subroutine dealloc_rho_rhoo_and_cpm

  subroutine mix_broyden_alloc3
#ifdef __TIMER_SUB__
    call timer_sta(1109)
#endif
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(u_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(v_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dd_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami ===
    d0_l = 0.0d0; u_l = 0.0d0; v_l = 0.0d0; dd_l = 0.0d0
! =================================================================
    call alloc_rho_rhoo_and_cpm
#ifdef __TIMER_SUB__
    call timer_end(1109)
#endif
  end subroutine mix_broyden_alloc3

  subroutine mix_broyden_dealloc3
    deallocate(d0_l); deallocate(u_l); deallocate(v_l); deallocate(dd_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_broyden_dealloc3

!!! ========================== added by K. Tagami ================ 5.0
  subroutine alloc_rhostore_recomp( rmxt, rmxtrc )
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc

    allocate( rhoo_store( nsize_rho_vhsr,nspin) )
    allocate( rho_store( nsize_rho_vhsr,nspin) )

    rho_store = rho_vhsr;      rhoo_store = rhoo_vhsr

     rho_vhsr(:,1) =  rho_store(:,1) +  rho_store(:,2)
     rho_vhsr(:,2) =  rho_store(:,1) -  rho_store(:,2)
    rhoo_vhsr(:,1) = rhoo_store(:,1) + rhoo_store(:,2)
    rhoo_vhsr(:,2) = rhoo_store(:,1) - rhoo_store(:,2)
    rmxtrc(1) = rmxt;     rmxtrc(2) = rmxt*spin_density_mixfactor

  end subroutine alloc_rhostore_recomp

  subroutine compose_rho_dealloc_store
    rho_store = rho_vhsr

    rho_vhsr(:,1) = 0.5d0*( rho_store(:,1) + rho_store(:,2) )
    rho_vhsr(:,2) = 0.5d0*( rho_store(:,1) - rho_store(:,2) )

    rhoo_vhsr(:,1) = 0.5d0*( rhoo_store(:,1) + rhoo_store(:,2) )
    rhoo_vhsr(:,2) = 0.5d0*( rhoo_store(:,1) - rhoo_store(:,2) )

!    rhoo_vhsr = rhoo_store
    deallocate( rho_store, rhoo_store )

  end subroutine compose_rho_dealloc_store

! ====== Have to change --
  subroutine alloc_vhsrstore_recomp( rmxt, rmxtrc )
    real(kind=DP),intent(in) :: rmxt
    real(kind=DP),intent(out),dimension(nspin_m) :: rmxtrc

    allocate( vnonlocal_store ( nlmt, nlmt, natm, nspin ) )
    allocate( vnonlocal_old_store( nlmt, nlmt, natm, nspin ) )
    vnonlocal_store = 0.0d0;  vnonlocal_old_store = 0.0d0
!
    vnonlocal_store = vnonlocal_r;  
    vnonlocal_old_store = vnonlocal_r_old

    vnonlocal_r(:,:,:,1) = vnonlocal_store(:,:,:,1) +vnonlocal_store(:,:,:,2)
    vnonlocal_r(:,:,:,2) = vnonlocal_store(:,:,:,2) -vnonlocal_store(:,:,:,2)
    vnonlocal_r_old(:,:,:,1) = vnonlocal_old_store(:,:,:,1) +vnonlocal_old_store(:,:,:,2)
    vnonlocal_r_old(:,:,:,2) = vnonlocal_old_store(:,:,:,1) -vnonlocal_old_store(:,:,:,2)

    if ( flg_paw ) then
       allocate( dion_paw_store ( nlmt, nlmt, nspin, natm ) )
       allocate( dion_paw_old_store( nlmt, nlmt, nspin, natm ) )
       dion_paw_store = 0.0d0;  dion_paw_old_store = 0.0d0

       dion_paw_store = dion_paw
       dion_paw_old_store = dion_paw_old
!
       dion_paw(:,:,1,:) = dion_paw_store(:,:,1,:) +dion_paw_store(:,:,2,:)
       dion_paw(:,:,2,:) = dion_paw_store(:,:,2,:) -dion_paw_store(:,:,2,:)
       dion_paw_old(:,:,1,:) = dion_paw_old_store(:,:,1,:) +dion_paw_old_store(:,:,2,:)
       dion_paw_old(:,:,2,:) = dion_paw_old_store(:,:,2,:) -dion_paw_old_store(:,:,2,:)
    endif
! --
    
    rmxtrc(1) = rmxt;     rmxtrc(2) = rmxt*spin_density_mixfactor
  end subroutine alloc_vhsrstore_recomp

  subroutine compose_vhsr_dealloc_store
    vnonlocal_store = vnonlocal_r
    vnonlocal_old_store = vnonlocal_r_old

    vnonlocal_r(:,:,:,1) = vnonlocal_store(:,:,:,1) +vnonlocal_store(:,:,:,2)
    vnonlocal_r(:,:,:,2) = vnonlocal_store(:,:,:,2) -vnonlocal_store(:,:,:,2)
    vnonlocal_r_old(:,:,:,1) = vnonlocal_old_store(:,:,:,1) +vnonlocal_old_store(:,:,:,2)
    vnonlocal_r_old(:,:,:,2) = vnonlocal_old_store(:,:,:,1) -vnonlocal_old_store(:,:,:,2)

    vnonlocal_r     = vnonlocal_r     /2.0d0
    vnonlocal_r_old = vnonlocal_r_old /2.0d0

    deallocate( vnonlocal_store, vnonlocal_old_store )

    if ( flg_paw ) then
       dion_paw_store = dion_paw
       dion_paw_old_store = dion_paw_old

       dion_paw(:,:,1,:) = dion_paw_store(:,:,1,:) +dion_paw_store(:,:,2,:)
       dion_paw(:,:,2,:) = dion_paw_store(:,:,2,:) -dion_paw_store(:,:,2,:)
       dion_paw_old(:,:,1,:) = dion_paw_old_store(:,:,1,:) +dion_paw_old_store(:,:,2,:)
       dion_paw_old(:,:,2,:) = dion_paw_old_store(:,:,2,:) -dion_paw_old_store(:,:,2,:)

       dion_paw     = dion_paw     /2.0d0
       dion_paw_old = dion_paw_old /2.0d0

       deallocate( dion_paw_store, dion_paw_old_store )
    endif
! --

  end subroutine compose_vhsr_dealloc_store

 subroutine simple_mix_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)

    din_vhsr   = rhoo_vhsr ! vlhxco
    dout_vhsr  = rho_vhsr  ! vlhxc
    rho_vhsr(:,1) = rmx_this(1) *dout_vhsr(:,1) + ( 1.0D0 - rmx_this(1) )* din_vhsr(:,1)
    if(nspin_m==2) rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 - rmx_this(2) )* din_vhsr(:,2)

! ===================== added by K. Tagami ================================ 11.0
    if ( noncol ) then
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 -rmx_this(2) )* din_vhsr(:,2)
       rho_vhsr(:,3) = rmx_this(3) *dout_vhsr(:,3) + ( 1.0D0 -rmx_this(3) )* din_vhsr(:,3)
       rho_vhsr(:,4) = rmx_this(4) *dout_vhsr(:,4) + ( 1.0D0 -rmx_this(4) )* din_vhsr(:,4)
    endif
! ========================================================================= 11.0

  end subroutine simple_mix_kt

  subroutine simple_mix2_kt(rmx_this)
    real(kind=DP), intent(in) :: rmx_this(nspin_m)

    if(nspin_m==2)then
        din_vhsr(:,2)  = rhoo_vhsr(:,2)         ! vlhxco
       dout_vhsr(:,2)  =  rho_vhsr(:,2)          ! vlhxc
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 - rmx_this(2) )* din_vhsr(:,2)
    endif
! ===================== added by K. Tagami ================================ 11.0
    if ( noncol ) then
       din_vhsr(:,2)  = rhoo_vhsr(:,2);     dout_vhsr(:,2)  =  rho_vhsr(:,2) 
       rho_vhsr(:,2) = rmx_this(2) *dout_vhsr(:,2) + ( 1.0D0 -rmx_this(2) )* din_vhsr(:,2)
       din_vhsr(:,3)  = rhoo_vhsr(:,3);     dout_vhsr(:,3)  =  rho_vhsr(:,3) 
       rho_vhsr(:,3) = rmx_this(3) *dout_vhsr(:,3) + ( 1.0D0 -rmx_this(3) )* din_vhsr(:,3)
       din_vhsr(:,4)  = rhoo_vhsr(:,4);     dout_vhsr(:,4)  =  rho_vhsr(:,4) 
       rho_vhsr(:,4) = rmx_this(4) *dout_vhsr(:,4) + ( 1.0D0 -rmx_this(4) )* din_vhsr(:,4)
    endif
! ========================================================================== 11.0

  end subroutine simple_mix2_kt

  subroutine mix_dealloc_previous_vhsr()
    if(previous_waymix == BROYD2) then
       call mix_broyden_deallocate_vhsr()
    else if(previous_waymix == PULAY) then
       call mix_PULAY_deallocate_vhsr()
    end if
  end subroutine mix_dealloc_previous_vhsr

  subroutine mix_broyden_allocate_vhsr
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0
    allocate( din_vhsr(nsize_rho_vhsr,nspin_m) )
    allocate( dout_vhsr(nsize_rho_vhsr,nspin_m))
    allocate( dF_vhsr(nsize_rho_vhsr,nspin_m))
    allocate( urec_vhsr(nsize_rho_vhsr,nspin_m,nbxmix,2) )   	
!
    din_vhsr = 0.0d0; dout_vhsr = 0.0d0; dF_vhsr = 0.0d0; urec_vhsr = 0.0d0
!
  end subroutine mix_broyden_allocate_vhsr

  subroutine mix_broyden_deallocate_vhsr
    if(allocated(din_vhsr)) deallocate(din_vhsr)
    if(allocated(dout_vhsr)) deallocate(dout_vhsr)
    if(allocated(dF_vhsr)) deallocate(dF_vhsr)
    if(allocated(urec_vhsr)) deallocate(urec_vhsr)
  end subroutine mix_broyden_deallocate_vhsr

  subroutine mix_broyden_alloc2_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m ) ); d0_vhsr = 0.0d0
    allocate(  u_vhsr( nsize_rho_vhsr,nspin_m ) );  u_vhsr = 0.0d0
    allocate(  v_vhsr( nsize_rho_vhsr,nspin_m ) );  v_vhsr = 0.0d0
  end subroutine mix_broyden_alloc2_vhsr

 subroutine mix_broyden_dealloc2_vhsr
    deallocate(d0_vhsr); deallocate(u_vhsr); deallocate(v_vhsr)
  end subroutine mix_broyden_dealloc2_vhsr

  subroutine mix_broyden_alloc3_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m ) ); d0_vhsr = 0.0d0
    allocate(  u_vhsr( nsize_rho_vhsr,nspin_m ) );  u_vhsr = 0.0d0
    allocate(  v_vhsr( nsize_rho_vhsr,nspin_m ) );  v_vhsr = 0.0d0
    allocate( dd_vhsr( nsize_rho_vhsr,nspin_m ) ); dd_vhsr = 0.0d0
  end subroutine mix_broyden_alloc3_vhsr

  subroutine mix_broyden_dealloc3_vhsr
    deallocate(d0_vhsr); deallocate(u_vhsr); deallocate(v_vhsr); deallocate(dd_vhsr)
  end subroutine mix_broyden_dealloc3_vhsr

 subroutine mix_pulay_allocate_vhsr
! ========================= modified by K. Tagami =================== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0
    allocate(  din_vhsr( nsize_rho_vhsr,nspin_m ) );  din_vhsr = 0.0d0
    allocate( dout_vhsr( nsize_rho_vhsr,nspin_m ) ); dout_vhsr = 0.0d0
    allocate(   dF_vhsr( nsize_rho_vhsr,nspin_m ) );   dF_vhsr = 0.0d0
    allocate( urec_vhsr( nsize_rho_vhsr,nspin_m,nbxmix,2) ); urec_vhsr = 0.0d0
    if(sw_gradient_simplex==ON)then
       allocate(rhoj_vhsr(nsize_rho_vhsr,nspin_m,nbxmix));rhoj_vhsr=0.d0
       allocate(Frhoj_vhsr(nsize_rho_vhsr,nspin_m,nbxmix));Frhoj_vhsr=0.d0
       allocate(rhoj_vhsro(nsize_rho_vhsr,nspin_m));rhoj_vhsro=0.d0
       allocate(Frhoj_vhsro(nsize_rho_vhsr,nspin_m));Frhoj_vhsro=0.d0
    endif
  end subroutine mix_pulay_allocate_vhsr

  subroutine mix_pulay_deallocate_vhsr
    if ( allocated( din_vhsr)) deallocate( din_vhsr)
    if ( allocated(dout_vhsr)) deallocate(dout_vhsr)
    if ( allocated(  dF_vhsr)) deallocate(  dF_vhsr)
    if ( allocated(urec_vhsr)) deallocate(urec_vhsr)
    if ( allocated(rhoj_vhsr)) deallocate(rhoj_vhsr)
    if ( allocated(Frhoj_vhsr)) deallocate(Frhoj_vhsr)
    if ( allocated(rhoj_vhsro)) deallocate(rhoj_vhsro)
    if ( allocated(Frhoj_vhsro)) deallocate(Frhoj_vhsro)
  end subroutine mix_pulay_deallocate_vhsr

  subroutine mix_pulay_alloc2_vhsr
    allocate( d0_vhsr( nsize_rho_vhsr,nspin_m) ); d0_vhsr = 0.0d0
  end subroutine mix_pulay_alloc2_vhsr

  subroutine mix_pulay_dealloc2_vhsr
    deallocate(d0_vhsr)
  end subroutine mix_pulay_dealloc2_vhsr

! ===================================================================== 5.0

  integer function nspin_for_qnewton()
! ================================= modified by K. Tagami ============= 11.0
!     nspin_for_qnewton=nspin
!     if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) nspin_for_qnewton=1
!
    if ( noncol ) then
       nspin_for_qnewton=ndim_magmom
    else
       nspin_for_qnewton=nspin
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) nspin_for_qnewton=1
    endif
! ========================================================================== 11.0
  end function nspin_for_qnewton

  subroutine renew_u_br(j,i)
    integer, intent(in) :: j,i

! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)      :: v_dF(nspin)
    real(DP)      :: v_dF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1113)
#endif
#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,dF_l,f_p,v_dF)!-(m_Pot);<v|dF> ->v_dF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,dF_l,f_p,v_dF)
#endif
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
      v_dF(1) = v_dF(1) + v_dF(2)
      v_df(2) = v_dF(1)
    endif

! ============================== added by K.Tagami ================= 11.0
    if ( noncol ) then
       v_dF(1) = sum( v_dF(:) )
       v_dF(:) = v_dF(1)
    endif
! ================================================================== 11.0

    call subtr_j_th_term(v_dF,iU,j,u_l)  !-(m_Pot)

    !                        |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
! === DEBUG by tkato 2011/11/24 ================================================
!   if(hownew == RENEW) f(j,i,1:nspin) = v_dF(1:nspin)
    if(hownew == RENEW) f(j,i,1:nspin_m) = v_dF(1:nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_end(1113)
#endif
  end subroutine renew_u_br

  subroutine renew_d_br(j)
    integer, intent(in) :: j
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1118)
#endif
#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,F_l,f_p,vF) !-(m_Pot);<v|F>  ->vF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,F_l,f_p,vF) !-(m_Pot);<v|F>  ->vF
#endif
! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ================================= added by K. Tagami =============== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ===================================================================== 11.0

    call subtr_j_th_term(vF,iU,j,d0_l) !-(m_Pot)
    !                        |d(m)> = |d(m)> - <v(j)|F(m)>|u(j)>
#ifdef __TIMER_SUB__
    call timer_end(1118)
#endif
  end subroutine renew_d_br

  subroutine renew_d_last_br(p)
    real(DP), intent(in), dimension(ista_kngp:iend_kngp) :: p
    integer   :: is, ik, i, ns
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1120)
#endif

    call mult1s(v_l,F_l,f_p,vF)              !-(m_Pot) <v|F> ->vF

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ============================ added by K.Tagami ====================== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ====================================================================== 11.0

    if(kgpm == kgp .or. npes == 1) then
#ifdef __TIMER_DO__
  call timer_sta(1166)
#endif
! ===================================== modified by K. Tagami ============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0
          din (:,:,is) = vlhxco_l(ista_kgpm:iend_kgpm,:,is)
          dout(:,:,is) = vlhxc_l (ista_kgpm:iend_kgpm,:,is)
       end do
#ifdef __TIMER_DO__
  call timer_end(1166)
#endif
    else
       call scatter_chg_onto_d(vlhxco_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(vlhxc_l, dout)  ! -(m_C.D.)
    end if

!!$    do is = 1, nspin, af+1
    ns = nspin_for_qnewton()
#ifdef __TIMER_DO__
  call timer_sta(1167)
#endif
    do is = 1, ns,af+1
       do ik = 1, kimg
          do i = ista_kgpm,iend_kgpm
             rho(i,ik,is) = d0_l(i,ik,is) - vF(is)*u_l(i,ik,is)
          end do
       end do
    end do
#ifdef __TIMER_DO__
  call timer_end(1167)
#endif

! ====================================== modified by K. Tagami ============ 11.0
!    if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
    if ( .not. noncol ) then
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
          call simple_mix2(c_p)
       endif
    endif

! =========================================================================== 11.0

    if(kgpm < kgp) then
       call concentrate_d_to_chg(rho,vlhxc_l) !-(m_C.D.)
       call simple_mix_large_Gc(p)           !-(m_C.D.) vlhxc,vlhxco,p ->vlhxc
    end if
#ifdef __TIMER_SUB__
    call timer_end(1120)
#endif
  end subroutine renew_d_last_br

! =========================== added by K. Tagami ================================== 5.0
  subroutine renew_u_br_with_vhsr(j,i)
    integer, intent(in) :: j,i

    integer       :: is
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)      :: v_dF(nspin)
    real(DP)      :: v_dF(nspin_m)
! ==============================================================================

    v_dF = 0.d0

#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,dF_l,f_p,v_dF)!-(m_Pot);<v|dF> ->v_dF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,dF_l,f_p,v_dF)
#endif

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       v_dF(is) = v_dF(is) + sum( urec_vhsr(:,is,j,iV)*dF_vhsr(:,is) )
    End do
!
! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      v_dF(1) = v_dF(1) + v_dF(2)
      v_df(2) = v_dF(1)
    endif
!
! ======================== added by K. Tagami ==================== 11.0
    if ( noncol ) then
       v_dF(1) = sum( v_dF(:) )
       v_dF(:) = v_dF(1)
    endif
! ================================================================ 11.0

    call subtr_j_th_term(v_dF,iU,j,u_l)  !-(m_Pot)
    !                        |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       u_vhsr(:,is) = u_vhsr(:,is) - v_dF(is) *urec_vhsr(:,is,j,iU)
    End do
! === DEBUG by tkato 2011/11/24 ================================================
!   if(hownew == RENEW) f(j,i,1:nspin) = v_dF(1:nspin)
    if(hownew == RENEW) f(j,i,1:nspin_m) = v_dF(1:nspin_m)
! ==============================================================================

  end subroutine renew_u_br_with_vhsr

  subroutine renew_d_br_with_vhsr(j)
    integer, intent(in) :: j
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================
    integer :: is

    vF = 0.d0

#ifdef _CDMIX_USE_POINTER_
    urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,j,iV)
    call mult1s(urec_l_3,F_l,f_p,vF) !-(m_Pot);<v|F>  ->vF
#else
    call mult1s5(urec_l,nbxmix,2,j,iV,F_l,f_p,vF) !-(m_Pot);<v|F>  ->vF
#endif

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
      vF(is) = vF(is) + sum( urec_vhsr(:,is,j,iV)*FF_vhsr(:,is) )
    End do

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ======================== added by K. Tagami ==================== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ================================================================ 11.0

    call subtr_j_th_term(vF,iU,j,d0_l) !-(m_Pot)
    !                        |d(m)> = |d(m)> - <v(j)|F(m)>|u(j)>

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       d0_vhsr(:,is) = d0_vhsr(:,is) - vF(is) *urec_vhsr(:,is,j,iU)
    end do
  end subroutine renew_d_br_with_vhsr

  subroutine renew_d_last_br_with_vhsr( p, rmxtrc_vhsr )
    real(DP), intent(in), dimension(ista_kngp:iend_kngp) :: p
    real(DP), intent(in) :: rmxtrc_vhsr(nspin_m)

    integer   :: is, ik, i, ns
! === DEBUG by tkato 2011/11/24 ================================================
!   real(DP)  :: vF(nspin)
    real(DP)  :: vF(nspin_m)
! ==============================================================================

    vF = 0.0d0
    call mult1s(v_l,F_l,f_p,vF)              !-(m_Pot) <v|F> ->vF

! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       vF(is) = vF(is) + sum( v_vhsr(:,is)*FF_vhsr(:,is) )
    End do

! === DEBUG by tkato 2011/11/24 ================================================
!   if ( nspin==2 .and. sw_mix_bothspins_sametime == YES ) then
    if ( nspin_m==2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
      vF(1) = vF(1) + vF(2)
      vF(2) = vF(1)
    endif

! ========================== added by K. Tagami =============== 11.0
    if ( noncol ) then
       vF(1) = sum( vF(:) )
       vF(:) = vF(1)
    endif
! ============================================================= 11.0

    if(kgpm == kgp .or. npes == 1) then
! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
          din (:,:,is) = vlhxco_l(ista_kgpm:iend_kgpm,:,is)
          dout(:,:,is) = vlhxc_l (ista_kgpm:iend_kgpm,:,is)
       end do
    else
       call scatter_chg_onto_d(vlhxco_l,din )  ! -(m_C.D.)
       call scatter_chg_onto_d(vlhxc_l, dout)  ! -(m_C.D.)
    end if

! =================================== modified by K. Tagami ============ 11.0
!     do is = 1, nspin, af+1
     do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
       din_vhsr (:,is) = rhoo_vhsr(:,is) ! vlhxco
       dout_vhsr(:,is) = rho_vhsr (:,is) ! vlhxc
    end do

!!$    do is = 1, nspin, af+1
    ns = nspin_for_qnewton()
    do is = 1, ns,af+1
       do ik = 1, kimg
          do i = ista_kgpm,iend_kgpm
             rho(i,ik,is) = d0_l(i,ik,is) - vF(is)*u_l(i,ik,is)
          end do
       end do
    end do

    do is = 1, ns, af+1
       rho_vhsr(:,is) = d0_vhsr(:,is) - vF(is) *u_vhsr(:,is)
    end do

! ====================================== modified by K. Tagami ============ 11.0
!    if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
!    if ( sw_force_simple_mixing_hsr==ON .and. sw_recomposing_vhsr==ON ) then
!       call simple_mix2_kt( rmxtrc_vhsr )
!    endif

    if ( .not. noncol ) then
       if (sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
          call simple_mix2(c_p)
       endif
       if ( sw_force_simple_mixing_hsr==ON .and. sw_recomposing_hsr==ON ) then
          call simple_mix2_kt( rmxtrc_vhsr )
       endif
    endif
! =========================================================================== 11.0

    if(kgpm < kgp) then
       call concentrate_d_to_chg(rho,vlhxc_l) !-(m_C.D.)
       call simple_mix_large_Gc(p)           !-(m_C.D.) vlhxc,vlhxco,p ->vlhxc
    end if
  end subroutine renew_d_last_br_with_vhsr

! ============================================================================ 5.0

  subroutine simple_mix_large_Gc(p)
    real(kind=DP), intent(in), dimension(ista_kngp:iend_kngp) :: p

    integer :: istart, iend, is, ik, i
#ifdef __TIMER_SUB__
    call timer_sta(1123)
#endif
    istart = kgpm + 1; if(istart < ista_kngp) istart = ista_kngp
    iend   = kgp;      if(iend   > iend_kngp) iend   = iend_kngp
#ifdef __TIMER_DO__
  call timer_sta(1174)
#endif
    if(iend >= istart) then
! =================================== modified by K. Tagami ============ 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ======================================================================= 11.0
          do ik = 1, kimg
             do i = istart, iend
                vlhxc_l(i,ik,is) = p(i)*vlhxc_l(i,ik,is) + (1.0d0-p(i))*vlhxco_l(i,ik,is)
             end do
          end do
       end do
    end if
#ifdef __TIMER_DO__
  call timer_end(1174)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1123)
#endif
  end subroutine simple_mix_large_Gc

! <<< Quasi-Newton Methods >>>
!  1. Broyden's 1st method
!  2. Broyden's 2nd method
!  3. DFP method
!
! In Quasi-Newton method, following set of equations are used.
!
!\begin{equation}
!\rho^{(m+1)}  = \rho^{(m)} - \lambda^{(m)} \left[ {\bf J} ^{(m)}\right]^{-1} {\cal F}^{(m)}
!\end{equation}
!
!\begin{equation}
!  \left[ {\bf J}^{(m+1)}\right]^{-1} \Delta {\cal F}^{(m+1)} = \Delta
!  \rho ^{(m+1)}
!\end{equation}
!
! $\lambda^{(m)}$ in the first euqation is a parameter of one
! dimensional search. And ${\bf J}^{(m+1)}$ is an approximate value of
! true Jacobian{\cal J}. In this program we fix this value of
! $\lambda^{(m)}$ to be 1.
! $\Delta {\cal F}^{(m+1)}$ and $\Delta \rho^{(m+1)}$ are definded as
! follows.
!
!\begin{equation}
!  \Delta {\cal F}^{(m+1)} = {\cal F}^{(m+1)} - {\cal F}^{(m)},
!\end{equation}
! where ${\cal F}^{(m)} = \rho^{out,(m)} - \rho^{in,(m)}$.
!
!\begin{equation}
!  \Delta \rho^{(m+1)} = \rho^{(m+1)} - \rho^{(m)}
!\end{equation}
!
! Three kinds of mixing ways implemented in this program,
! i.e. Broyden's 1st, Broyden's 2nd and DFP methods, differ in the
! way of approximation of the $\left[ {\bf J} ^{(m)}\right]^{-1}$. For
! combinience, we simply this description of the inverse of Jacobian
! as to be ${\bf J}^{-1(m)}$, hereafter.
!
! <<1>> Broyden's 1st method
!\begin{equation}
!{\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \frac{\left[ | \Delta
!    \rho^{(m)}\rangle - {\bf J}^{-1(m-1)} | \Delta {\cal
!      F}^{(m)}\rangle \right] \otimes \langle \Delta \rho^{(m)} | {\bf
!    J}^{-1(m-1)}}{\langle\rho^{(m)}|{\bf J}^{-1(m-1)}| \Delta {\cal
!    F}^{(m)}\rangle}
!\end{equation}
!
! <<2>> Broyden's 2nd method
!\begin{equation}
!  {\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \left[ |\Delta \rho^{(m)}
!    \rangle - {\bf J}^{-1(m-1)} | \Delta {\cal F}^{(m)} \right]
!  \otimes \frac{\langle \Delta {\cal F}^{(m)}|}{\| \Delta {\cal
!      F}^{(m)}\|^2}
!\end{equation}
!
! <<3>> DFP method
!DFP(Davidon-Fletcher-Powell) algorithm
!\begin{equation}
!  {\bf J}^{-1(m)} = {\bf J}^{-1(m-1)} + \frac{| \Delta
!    \rho^{(m)}\rangle \otimes \langle \Delta \rho^{(m)} |}
!   {\langle\rho^{(m)}|\Delta {\cal F}^{(m)}\rangle}
!   - \frac{|{\bf J}^{-1(m-1)}\Delta {\cal F}^{(m)}\rangle \otimes
!   \langle \Delta {\cal F}^{(m)}{\bf J}^{-1(m-1)}|}{\langle \Delta
!   {\cal F}^{(m)}|{\bf J}^{-1(m-1)}|\Delta {\cal F}^{(m)}\rangle}
!\end{equation}
!
! For reduction of memory space, we rewrite the Jacobian as linear
! combination of dyadic products.
!\begin{equation}
!  {\bf J}^{-1(m)} = -\alpha{\bf 1} + \sum_{i=2}^{m}|u^{(i)}\rangle
!  \otimes \langle v^{(i)}|
!\label{eq:JQN}
!\end{equation}
!Here, we used diagonal form for ${\bf J}^{-1(1)}$.
!\begin{equation}
!  {\bf J}^{-1(1)} = -\alpha {\bf 1}
!\end{equation}
!We can easily obtain $u^{(m)}$ and $v^{(m)}$ for the Broyden's 2nd
!method formula (eq.(\ref{eq:broyden2})).
!\begin{equation}
!  u^{(m)} = \Delta \rho^{(m)} + \alpha \Delta {\cal F}^{(m)} -
!  \sum_{i=2}^{m-1}\langle v^{(i)}|\Delta {\cal F}^{(m)}\rangle u^{(i)}
!\end{equation}
!\begin{equation}
!  v^{(m)} = \frac{1}{\parallel \Delta {\cal F}^{(m)}\parallel^2}
!  \Delta {\cal F}^{(m)}
!\end{equation}
!
!    a     : $\alpha$
!    d     : $\rho$
!    dd    : $\Delta \rho$
!    F     : $\cal F$
!    dF    : $\Delta F$
!

! dF_l   = dF  : $\Delta {\cal F}^{(m)}$
! d0_l    = d(m) + aF(m) - sum(i=2,m-1)<u(i)|F(m)>u(i)
! u_l      = u(m)
!          : $ u^{(m)} = \Delta \rho^{(m)} + \alpha \Delta {\cal F}^{(m)} -
!  \sum_{i=2}^{m-1}\langle v^{(i)}|\Delta {\cal F}^{(m)}\rangle u^{(i)}$
! v        = v(m)
!          : $ v^{(m)} = \frac{1}{\parallel \Delta {\cal F}^{(m)}\parallel^2}$
! din    = d(input,(m-1))   : $ \rho^{in, (m-1)}$ (:first and last),
!         or F(m)             : ${\cal F}^{(m)}$ (: as a transient array)
! dout    = d(output,(m-1))  : $ \rho^{out,(m-1)}$
!
!  J(m) = a + sum_{i=2}^m |u(i)><v(i)|
!  u(m) = dd(m) + a dF(m) - sum_{i=2}^{m-1} <v(i)|dF(m)>|u(i)>
!  v(m) = dF(m)/||dF(m)||
!
  subroutine m_Pot_mix_broyden2(rmx)
    real(DP),intent(in) :: rmx
    integer   :: iter,j,mxiter,icr,jcr
!!$    real(DP)  :: v_dF(nspin),vF(nspin)
    integer   :: id_sname = -1
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
!   real(kind=DP), allocatable, dimension(:,:,:) :: vlhxcstore_l, vlhxcostore_l
! <--
#ifdef __TIMER_SUB__
    call timer_sta(1124)
#endif
    call tstatc0_begin('m_Pot_mix_broyden2 ',id_sname,1)

    if(previous_waymix /= BROYD2.or.force_dealloc) then
       call mix_dealloc_previous()
       call mix_broyden_allocate();    F_l => din
       force_dealloc = .false.
    end if

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vlhxcstore_recompos_vlhxc(rmx,rmxtrc) ! --> vlhxc_l, vlhxco_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif
! ======================================================================== 11.0

! ====================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_pot_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_pot_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! =======================================================


! ============================== modified by K. Tagami ================== 11.0
!    call precon_4_pot_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_pot_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_pot_mix(rmxtrc,c_p)
    endif
! ======================================================================== 11.0

    iter = iter_from_reset()                 !-(m_Pot)

    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_Pot)
       !   din=vlhxco_l; dout=vlhxc_l; (din,dout,c_p)->vlhxc_l
    else
!!$       stop ' -- iter-istrbr+1 > 1 (m_Pot_mix_broyden2) --'
       call mix_broyden_alloc2   !-(m_Pot) d0_l,u_l, and v_l are allocated
       call dF_F_d0_u_and_v      !-(c.h.)   dF_l, F_l, initial u_l,v_l,d0_l

       call set_ncrspd_mxiter_etc(iter,iU,mxiter) !-(m_Pot) ->mxiter,ncrspd
       !                  when hownew == RENEW: f,g,ncrspd, and urec_l are reset.
       icr = icrspd_is(iter)                 !-(m_Pot) function
       do j = 2, mxiter
          jcr = ncrspd(j)
          call renew_u_br(jcr,icr) !-(m_Pot) |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
          call renew_d_br(jcr)     !-(m_Pot) |d(m)> = |d(m)> - <v(j)|F(m)> |u(j)>
       enddo!j-loop

       urec_l(:,:,:,icr,iU) = u_l(:,:,:)  ! storing
       urec_l(:,:,:,icr,iV) = v_l(:,:,:)  ! storing

       call renew_d_last_br(c_p)       !-(m_Pot) vlhxc_l(|d(m)>) = |d(m)>-<v(m)|F(m)>|u(m)>
       call mix_broyden_dealloc2                      !-(m_Pot)
    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_vlhxc_dealloc_vlhxcstore()
       end if
    endif
    deallocate(rmxtrc)

    deallocate(c_p)
    previous_waymix = BROYD2
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1124)
#endif
  contains
    subroutine dF_F_d0_u_and_v
      !   dF_l(=deltaF) = (rho - dout) - (rhoo - din)
      !   F_l = rho - rhoo (=\cal F^{m}); u_l  = (rhoo - din) + c_p*dF_l;
      !   d0_l = rhoo+c_p* F_l;              v_l = dF_l/( |dF_l| )

      integer                      :: is,k,i
      real(DP), dimension(nspin_m) :: fff
#ifdef __TIMER_SUB__
    call timer_sta(1125)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1175)
#endif
! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

         do k = 1, kimg
            do i = ista_kgpm,iend_kgpm
!  Revised by T. Yamasaki, 2009/05/28 (Pointed out by Fukata-san (NEC))
!!$               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-din(i,k,is))
!!$               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i)*(rho(i,k,is) - rhoo(i,k,is))
!!$               u_l(i,k,is)  = c_pm(i)*dF_l(i,k,is) + (rhoo(i,k,is) - din(i,k,is))
               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-F_l(i,k,is))
               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i,is)*(rho(i,k,is) - rhoo(i,k,is))
               u_l(i,k,is)  = c_pm(i,is)*dF_l(i,k,is) + (rhoo(i,k,is) - F_l(i,k,is))
! ----
               F_l(i,k,is)  = rho(i,k,is) - rhoo(i,k,is)
            end do
            if(mype == 0) u_l(1,k,is) = 0.d0
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1175)
#endif

      call mult1s(dF_l,dF_l,f_p,fff)
      if(sum(fff) < 1.d-40)  stop ' fmult is too small'

! === DEBUG by tkato 2011/11/24 ================================================
!     if ( nspin == 2 .and. sw_mix_bothspins_sametime == YES ) then
      if ( nspin_m == 2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
        fff(1) = fff(1) + fff(2)
        fff(2) = fff(1)
      endif

! ========================= added by K. Tagami =========================== 11.0
      if ( noncol ) then
         fff(1) = sum( fff(:) )
         fff(:) = fff(1)
      endif
! ======================================================================== 11.0

#ifdef __TIMER_DO__
  call timer_sta(1176)
#endif
! ========================================= modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0
         v_l(:,:,is) = dF_l(:,:,is)/fff(is)
      end do
#ifdef __TIMER_DO__
  call timer_end(1176)
#endif

#ifdef __TIMER_SUB__
    call timer_end(1125)
#endif
    end subroutine dF_F_d0_u_and_v

  end subroutine m_Pot_mix_broyden2

! ===================== added by K. Tagami ============================== 5.0
  subroutine m_Pot_mix_broyden2_with_vhsr(rmx)
    real(DP),intent(in) :: rmx
    integer   :: iter,j,mxiter,icr,jcr
!!$    real(DP)  :: v_dF(nspin),vF(nspin)
    integer   :: id_sname = -1
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
    real(kind=DP), allocatable, dimension(:,:,:) :: vlhxcstore_l, vlhxcostore_l
! <--

    call tstatc0_begin('m_Pot_mix_broyden2_vhsr ',id_sname,1)

    if (previous_waymix /= BROYD2.or.force_dealloc) then
       force_dealloc = .false.
       if ( first ) then
          call create_map_func(.true.)
          call alloc_rho_vhsr
          call create_map_func(.false.)
          first = .false.
       endif
       call mix_dealloc_previous()
       call mix_dealloc_previous_vhsr()
       call mix_broyden_allocate();        F_l => din
       call mix_broyden_allocate_vhsr();    FF_vhsr => din_vhsr
    end if

    if ( noncol ) then
       if ( flg_paw ) then
          call map_vhsr_to_rho_noncl( rho_vhsr,  vnonlocal_r,     vnonlocal_i, &
               &                      dion_paw )
          call map_vhsr_to_rho_noncl( rhoo_vhsr, vnonlocal_r_old, vnonlocal_i_old, &
               &                      dion_paw_old )
       else
          call map_vhsr_to_rho_noncl( rho_vhsr,  vnonlocal_r,     vnonlocal_i )
          call map_vhsr_to_rho_noncl( rhoo_vhsr, vnonlocal_r_old, vnonlocal_i_old )
       endif
    else
       if ( flg_paw ) then
          call map_vhsr_to_rho( rho_vhsr,  vnonlocal_r,     dion_paw )
          call map_vhsr_to_rho( rhoo_vhsr, vnonlocal_r_old, dion_paw_old )
       else
          call map_vhsr_to_rho( rho_vhsr,  vnonlocal_r )
          call map_vhsr_to_rho( rhoo_vhsr, vnonlocal_r_old )
       endif
    endif

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vlhxcstore_recompos_vlhxc(rmx,rmxtrc) ! --> vlhxc_l,vlhxco_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif

    if ( noncol ) then
       rmxtrc = rmx
    else
       if ( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2 ) then
          call alloc_rhostore_recomp( rmx, rmxtrc )
       else
          rmxtrc = rmx
       endif
    endif

! ====================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_pot_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_pot_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! =======================================================


! ============================= modiifed by K. Tagami =================== 11.0
!    call precon_4_pot_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_pot_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_pot_mix(rmxtrc,c_p)
    endif
! ====================================================================== 11.0

    iter = iter_from_reset()                 !-(m_Pot)

    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_Pot)
       !   din=vlhxco_l; dout=vlhxc_l; (din,dout,c_p)->vlhxc_l
       call simple_mix_kt( rmxtrc )
    else
!!$       stop ' -- iter-istrbr+1 > 1 (m_Pot_mix_broyden2) --'

       call mix_broyden_alloc2   !-(m_Pot) d0_l,u_l, and v_l are allocated
       call mix_broyden_alloc2_vhsr

       call dF_F_d0_u_and_v_with_vhsr

       call set_ncrspd_mxiter_etc(iter,iU,mxiter) !-(m_Pot) ->mxiter,ncrspd
       !                  when hownew == RENEW: f,g,ncrspd, and urec_l are reset.
       icr = icrspd_is(iter)                 !-(m_Pot) function
       do j = 2, mxiter
          jcr = ncrspd(j)
          call renew_u_br_with_vhsr(jcr,icr) !-(m_Pot) |u(m)> = |u(m)> - <v(j)|dF(m)>|u(j)>
          call renew_d_br_with_vhsr(jcr)     !-(m_Pot) |d(m)> = |d(m)> - <v(j)|F(m)> |u(j)>
       enddo!j-loop

       urec_l(:,:,:,icr,iU) = u_l(:,:,:)  ! storing
       urec_l(:,:,:,icr,iV) = v_l(:,:,:)  ! storing

       urec_vhsr(:,:,icr,iU) = u_vhsr(:,:)  ! storing
       urec_vhsr(:,:,icr,iV) = v_vhsr(:,:)  ! storing

       call renew_d_last_br_with_vhsr( c_p, rmxtrc )  
                                !-(m_Pot) vlhxc_l(|d(m)>) = |d(m)>-<v(m)|F(m)>|u(m)>

       call mix_broyden_dealloc2                      !-(m_Pot)
       call mix_broyden_dealloc2_vhsr

    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_vlhxc_dealloc_vlhxcstore()
       end if
       if ( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2 ) then
          call compose_rho_dealloc_store
       end if
    endif

    if ( noncol ) then
       if ( flg_paw ) then
          call map_rho_to_vhsr_noncl( rho_vhsr, vnonlocal_r, vnonlocal_i, dion_paw )
       else
          call map_rho_to_vhsr_noncl( rho_vhsr, vnonlocal_r, vnonlocal_i )
       endif
    else
       if ( flg_paw ) then
          call map_rho_to_vhsr( rho_vhsr, vnonlocal_r, dion_paw )
       else
          call map_rho_to_vhsr( rho_vhsr, vnonlocal_r )
       endif
    endif

    deallocate(rmxtrc)

    deallocate(c_p)

    previous_waymix = BROYD2
    call tstatc0_end(id_sname)
  contains

    subroutine dF_F_d0_u_and_v_with_vhsr
      !   dF_l(=deltaF) = (rho - dout) - (rhoo - din)
      !   F_l = rho - rhoo (=\cal F^{m}); u_l  = (rhoo - din) + c_p*dF_l; 
      !   d0_l = rhoo+c_p* F_l;              v_l = dF_l/( |dF_l| )

      integer                      :: is,k,i
      real(DP), dimension(nspin_m) :: fff

! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0
         do k = 1, kimg
            do i = ista_kgpm,iend_kgpm
!  Revised by T. Yamasaki, 2009/05/28 (Pointed out by Fukata-san (NEC))
!!$               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-din(i,k,is))
!!$               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i)*(rho(i,k,is) - rhoo(i,k,is))
!!$               u_l(i,k,is)  = c_pm(i)*dF_l(i,k,is) + (rhoo(i,k,is) - din(i,k,is))
               dF_l(i,k,is) = (rho (i,k,is)-rhoo(i,k,is)) - (dout(i,k,is)-F_l(i,k,is))
               d0_l(i,k,is) = rhoo(i,k,is) + c_pm(i,is)*(rho(i,k,is) - rhoo(i,k,is))
               u_l(i,k,is)  = c_pm(i,is)*dF_l(i,k,is) + (rhoo(i,k,is) - F_l(i,k,is))
! ----
               F_l(i,k,is)  = rho(i,k,is) - rhoo(i,k,is)
            end do
            if(mype == 0) u_l(1,k,is) = 0.d0
         end do
      end do
!
! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0
         dF_vhsr(:,is) = ( rho_vhsr(:,is)-rhoo_vhsr(:,is)) - ( dout_vhsr(:,is)-FF_vhsr(:,is))
         d0_vhsr(:,is) = rhoo_vhsr(:,is) + rmxtrc(is) *( rho_vhsr(:,is) - rhoo_vhsr(:,is))
          u_vhsr(:,is) = rmxtrc(is) *dF_vhsr(:,is) + ( rhoo_vhsr(:,is) - FF_vhsr(:,is) )
         FF_vhsr(:,is) = rho_vhsr(:,is) - rhoo_vhsr(:,is)
      end do

      call mult1s(dF_l,dF_l,f_p,fff)

! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0
         fff(is) = fff(is) + sum( dF_vhsr(:,is)*dF_vhsr(:,is) )
      end do

      if(sum(fff) < 1.d-40)  stop ' fmult is too small'

!!!!!!!!
! === DEBUG by tkato 2011/11/24 ================================================
!     if ( nspin == 2 .and. sw_mix_bothspins_sametime == YES ) then
      if ( nspin_m == 2 .and. sw_mix_bothspins_sametime == YES ) then
! ==============================================================================
	fff(1) = fff(1) + fff(2)
        fff(2) = fff(1)
      endif

! ========================= added by K. Tagami =========================== 11.0
      if ( noncol ) then
         fff(1) = sum( fff(:) )
         fff(:) = fff(1)
      endif
! ======================================================================== 11.0

! ========================================= modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0
         v_l(:,:,is) = dF_l(:,:,is)/fff(is)
      end do

! ========================================= modified by K. Tagami ========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0
         do i=1,nsize_rho_vhsr
            v_vhsr(i,is) = dF_vhsr(i,is)/fff(is)
         end do
      end do

    end subroutine dF_F_d0_u_and_v_with_vhsr

  end subroutine m_Pot_mix_broyden2_with_vhsr
! ==================================================================== 5.0

  subroutine mix_pulay_allocate
!!$    if(allocated(f_p)) return

! =============================== modified by K. Tagami ========== 11.0
!    nspin_m  = nspin/(af+1)
!
    if ( noncol ) then
       nspin_m  = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ================================================================= 11.0

! =========================================== Modified by K. Tagami =========
!    allocate(f_p(ista_kgpm:iend_kgpm)); call precon_4_mult(f_p) !-(m_Pot)
    allocate(f_p(ista_kgpm:iend_kgpm)); f_p = 0; call precon_4_mult(f_p) !-(m_Pot)
! ============================================================================

    allocate(din(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(dout(ista_kgpm:iend_kgpm,kimg,nspin_m))
    allocate(urec_l(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix,2))
    allocate(uuf_p(nbxmix,nspin_m))
    allocate(f(nbxmix,nbxmix,nspin_m))
    allocate(g_p(nbxmix,nspin_m))
    allocate(prj_wk(mp_kngp*kimg*nspin_m))
    allocate(ncrspd(nbxmix))

    if(sw_gradient_simplex==ON)then
       allocate(rhoj(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix));rhoj=0.d0
       allocate(Frhoj(ista_kgpm:iend_kgpm,kimg,nspin_m,nbxmix));Frhoj=0.d0
       allocate(rhojo(ista_kgpm:iend_kgpm,kimg,nspin_m));rhojo=0.d0
       allocate(Frhojo(ista_kgpm:iend_kgpm,kimg,nspin_m));Frhojo=0.d0
    endif

! ======================================= Added by K. Tagami ===========
    din = 0.0d0; dout = 0.0d0; urec_l = 0.0d0; uuf_p = 0.0d0; f = 0.0d0
    g_p = 0.0d0; prj_wk = 0.0d0; ncrspd = 0
! ======================================================================
  end subroutine mix_pulay_allocate

  subroutine mix_pulay_deallocate
    if(allocated(f_p)) deallocate(f_p)
    if(allocated(din)) deallocate(din)
    if(allocated(dout)) deallocate(dout)
    if(allocated(urec_l)) deallocate(urec_l)
    if(allocated(uuf_p)) deallocate(uuf_p)
    if(allocated(f)) deallocate(f)
    if(allocated(g_p)) deallocate(g_p)
    if(allocated(prj_wk)) deallocate(prj_wk)
    if(allocated(ncrspd)) deallocate(ncrspd)
    if(allocated(rhoj)) deallocate(rhoj)
    if(allocated(Frhoj)) deallocate(Frhoj)
    if(allocated(rhojo)) deallocate(rhojo)
    if(allocated(Frhojo)) deallocate(Frhojo)
  end subroutine mix_pulay_deallocate

  subroutine mix_pulay_alloc2
    allocate(d0_l(ista_kgpm:iend_kgpm,kimg,nspin_m))
! =========================================== Added by K. Tagami ========
    d0_l = 0.0d0
! =======================================================================
    call alloc_rho_rhoo_and_cpm
  end subroutine mix_pulay_alloc2

  subroutine mix_pulay_dealloc2
    deallocate(d0_l)
    call dealloc_rho_rhoo_and_cpm
  end subroutine mix_pulay_dealloc2

  subroutine m_Pot_mix_pulay(nfout,rmx)
    integer, parameter  :: iRho = 1, iResid = 2
    integer, intent(in) :: nfout
    real(DP),intent(in) :: rmx
    integer   :: iter, mxiter
    real(DP),pointer,dimension(:)  :: e_wk, f_wk, ww1, finv
    integer, pointer,dimension(:)  :: ip
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
!   real(kind=DP), allocatable, dimension(:,:,:) :: vlhxcstore_l, vlhxcostore_l
! <--
    integer   :: id_sname = -1
#ifdef __TIMER_SUB__
    call timer_sta(1131)
#endif
    call tstatc0_begin('m_Pot_mix_pulay ',id_sname,1)

    if(previous_waymix /= PULAY.or.force_dealloc) then
       force_dealloc = .false.
       call mix_dealloc_previous()
       call mix_pulay_allocate()
    end if

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vlhxcstore_recompos_vlhxc(rmx,rmxtrc) ! --> vlhxc_l,vlhxco_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif
! ========================================================================= 11.0

! ====================================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_pot_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_pot_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! ========================================================================


! =================================== modified by K. Tagami =============== 11.0
!    call precon_4_pot_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_pot_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_pot_mix(rmxtrc,c_p)
    endif
! ========================================================================= 11.0

    iter = iter_from_reset()                 !-(m_Pot)
    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_Pot)
       !   din=vlhxco_l; dout=vlhxc_l; (din,dout,c_p)->vlhxc_l
    else
       call mix_pulay_alloc2   !-(m_Pot) d0_l,u_l, and w_l are allocated
       call set_ncrspd_mxiter(nbxmix,iter-istrbr,mxiter) ! -> ncrspd, mxiter
!!$       call mix_pulay_alloc3(nbxmix,iter-istrbr)   !-(c.h.) e_wk,f_wk,ww1,finv,ip
       call mix_pulay_alloc3(mxiter)   !-(c.h.) e_wk,f_wk,ww1,finv,ip

!!$       call Resid_and_dd_into_urec(iter-istrbr) !-(c.h.)
!!$       !                               dF ->urec_l; dd ->urec_l; d0_l,din,dout
!!$       call Ri_dot_Rj(iter-istrbr)          !-(c.h.) <R(i)|R(j)>->f
!!$       call get_finv(nbxmix,iter-istrbr,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}
!!$
!!$       call Rj_dot_d(iter-istrbr)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p
!!$
!!$       call get_gmatrix(iter-istrbr)        !-(c.h.) (f,uuf_p)->g
!!$       call renew_d_using_g(iter-istrbr,c_pm)     !-(c.h.)
       call Resid_and_dd_into_urec(mxiter) !-(c.h.)
       !                               dF ->urec_l; dd ->urec_l; d0_l,din,dout
       call Ri_dot_Rj(mxiter)          !-(c.h.) <R(i)|R(j)>->f
!!$       call get_finv(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}
       call get_finv_lapack(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}

       call Rj_dot_d(mxiter)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p

       call get_gmatrix(mxiter)        !-(c.h.) (f,uuf_p)->g
       call renew_d_using_g(mxiter,c_pm)     !-(c.h.)

       call mix_pulay_dealloc3                    !-(c.h.)
       call mix_pulay_dealloc2                    !-(m_Pot)
    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) &
            & call compos_vlhxc_dealloc_vlhxcstore()
    endif
    deallocate(rmxtrc)

    deallocate(c_p)
    previous_waymix = PULAY
    call tstatc0_end(id_sname)
#ifdef __TIMER_SUB__
    call timer_end(1131)
#endif
  contains
    subroutine mix_pulay_alloc3(m)
      integer, intent(in) :: m
      allocate(e_wk(m*m)); allocate(f_wk(m*m)); allocate(ww1(m)); allocate(finv(m*m))
      allocate(ip(m))
! ===================================== Added by K. Tagami ============
      e_wk = 0; f_wk = 0; ww1 = 0; finv = 0; ip = 0
! =====================================================================
    end subroutine mix_pulay_alloc3

    subroutine set_ncrspd_mxiter(n,iter,m)
      integer, intent(in)  :: n, iter
      integer, intent(out) :: m
      integer :: i, nx
      if(hownew == ANEW) then
         m = iter
!!$         ncrspd(:) = (/(i,i=1,m)/)
         do i=1,iter
            ncrspd(i) = i
         end do
      else ! hownew == RENEW
         if(iter <= n) then
            m = iter
!!$            ncrspd(:) = (/(i,i=1,m)/)
            do i=1,iter
               ncrspd(i) = i
            end do
         else
            m = n
            nx = ncrspd(1)
            do i = 1, m-1
               ncrspd(i) = ncrspd(i+1)
            end do
            ncrspd(m) = nx
         end if
      end if
    end subroutine set_ncrspd_mxiter

    subroutine mix_pulay_dealloc3
      deallocate(e_wk); deallocate(f_wk); deallocate(ww1); deallocate(finv)
      deallocate(ip)
    end subroutine mix_pulay_dealloc3

    subroutine Resid_and_dd_into_urec(iter)
      integer, intent(in) :: iter
      integer             :: itc,itc0,itc1
      integer :: i,j,k,imix
#ifdef __TIMER_SUB__
    call timer_sta(1132)
#endif
      itc = ncrspd(iter)
      if(sw_gradient_simplex==ON)then
         do imix=2,iter-1
            itc0 = ncrspd(imix)
            itc1 = ncrspd(imix-1)
            do i=1,nspin_m
               do j=1,kimg
                  do k=ista_kgpm,iend_kgpm
                     urec_l(k,j,i,itc0,iResid) = rho(k,j,i)-rhoo(k,j,i)-(Frhoj(k,j,i,itc1)-rhoj(k,j,i,itc1))
                     urec_l(k,j,i,itc0,iRho  ) = rhoo(k,j,i)-rhoj(k,j,i,itc1)
                  enddo
               enddo
            enddo
         enddo
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i)-rhoo(k,j,i)-(dout(k,j,i)-din(k,j,i))
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i)-din(k,j,i)
                  rhoj(k,j,i,itc) = rhoo(k,j,i)
                  Frhoj(k,j,i,itc) = rho(k,j,i)
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
      else
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i) - rhoo(k,j,i) - (dout(k,j,i) - din(k,j,i)) ! =dF(=delta F^i)
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i) - din(k,j,i)                ! =dd
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
      endif
#ifdef __TIMER_SUB__
    call timer_end(1132)
#endif
    end subroutine Resid_and_dd_into_urec

    subroutine Ri_dot_Rj(n)
      integer, intent(in) :: n
      integer  :: it,jt,itc,jtc
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff1tmp
      real(DP) :: ff1(nspin_m),ff1tmp
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1133)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1179)
#endif
      do it = 1, n
         itc = ncrspd(it)
         do jt = it, n
            jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
            urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,itc,iResid)
            urec_l_3_2 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
            call mult1s(urec_l_3,urec_l_3_2,f_p,ff1)   ! <delta F^i|delta F^j>
#else
            if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
               call mult1s10_reduce_spin(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1tmp)   ! <delta F^i|delta F^j>
               ff1(1)=ff1tmp;ff1(2)=ff1tmp
            else
               call mult1s10(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1)   ! <delta F^i|delta F^j>
            endif

! ============================= added by K. Tagami ======================= 11.0
            if ( noncol ) then
               call mult1s10_reduce_spin( urec_l, nbxmix, 2, itc, iResid, &
                    &                     urec_l, jtc, iResid, f_p, ff1tmp )
                                                        ! <delta F^i|delta F^j>
               ff1(:) = ff1tmp
            endif
! ======================================================================== 11.0

#endif
            f(it,jt,1:nspin_m) = ff1(1:nspin_m)
            if(jt /= it) f(jt,it,1:nspin_m) = f(it,jt,1:nspin_m)
         end do
      end do
#ifdef __TIMER_DO__
  call timer_end(1179)
#endif
#ifdef __TIMER_SUB__
    call timer_end(1133)
#endif
    end subroutine Ri_dot_Rj

    subroutine Rj_dot_d(n)
      integer, intent(in) :: n
      integer  :: jt, jtc
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff1tmp
      real(DP) :: ff1(nspin_m),ff1tmp
! ==============================================================================
#ifdef __TIMER_SUB__
    call timer_sta(1138)
#endif
      do jt = 1, n
         jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
         urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
         call mult1s(urec_l_3,d0_l,f_p,ff1)
#else
         if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(1) = ff1tmp;ff1(2)=ff1tmp
         else
            call mult1s5(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1)
         endif

! ============================= added by K. Tagami ======================= 11.0
         if ( noncol ) then
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            ff1(:) = ff1tmp
         endif
! ======================================================================== 11.0

#endif
         uuf_p(jt,1:nspin_m) = ff1(1:nspin_m)
      end do
#ifdef __TIMER_SUB__
    call timer_end(1138)
#endif
    end subroutine Rj_dot_d

    subroutine get_finv_lapack(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f
      real(DP), allocatable,dimension(:,:) :: fwork
      integer :: is,inf,it,jt,kt,nnspin
      real(DP) :: div,tmp
      allocate(fwork(n,n))
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ======================= added by K. Tagami ============= 11.0 
      if ( noncol ) then
         nnspin = 1
      end if
! ======================================================== 11.0

      do is=1,nnspin
         if(ipripulay >= 2) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is),jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         fwork=0
         do it=1,n
            do jt=1,n
               fwork(jt,it) = f(jt,it,is)
               if(it==jt) fwork(jt,it)=fwork(jt,it)+alpha_pulay
            enddo
         enddo
         call dpotrf('U',n,fwork,n,inf)
         call dpotri('U',n,fwork,n,inf)
         if(inf/=0)then
           if(printable) write(nfout,*) ' !** failed calculation of the inverse matrix for the pulay mixer'
           fwork=0
           do it=1,n
              do jt=1,n
                 fwork(jt,it) = f(jt,it,is)
                 if(it==jt) fwork(jt,it)=fwork(jt,it)+1.d-7
              enddo
           enddo
           call dpotrf('U',n,fwork,n,inf)
           call dpotri('U',n,fwork,n,inf)
         endif
         do it=1,n-1
            do jt=it+1,n
               fwork(jt,it) = fwork(it,jt)
            enddo
         enddo
         do it=1,n
            do jt=1,n
               f(jt,it,is) = fwork(jt,it)
            enddo
         enddo
         if(ipripulay >= 2) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      enddo
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it=1,n
            do jt=1,n
               f(jt,it,2) = f(jt,it,1)
            enddo
         enddo
      endif
! ============================== added by K. Tagami ========== 11.0
      if ( noncol ) then
         do it=1,n
            do jt=1,n
               f(jt,it,:) = f(jt,it,1)
            enddo
         end do
      endif
! ============================================================ 11.0
      deallocate(fwork)

    end subroutine get_finv_lapack

    subroutine get_finv(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f

      integer                        :: icount,is,jt,it,icon
      real(DP)                       :: div
#ifdef __TIMER_SUB__
    call timer_sta(1134)
#endif

      e_wk = 0.d0
      do it = 1, n
         e_wk(it*it) = 1.d0
      end do

! ======================================= modified by K. Tagami =========== 11.0
!      do is = 1, nspin, af+1
      do is = 1, ndim_magmom, af+1
! ========================================================================== 11.0
         div = 1.d0/f(1,1,is)
         icount = 1
#ifdef __TIMER_DO__
  call timer_sta(1180)
#endif
         do jt = 1, n
            do it = 1, n
               f_wk(icount) = f(it,jt,is)*div
               icount = icount + 1
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1180)
#endif
         if(ipripulay >= 1) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is)*div,jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         call rdecomp(n,f_wk,ww1,ip,icon)
         if(icon /= 0) then
            stop 'LU decomposition is impossible.'
         else
            call rsolve(n,n,f_wk,e_wk,finv,ip)
         endif

         icount = 1
#ifdef __TIMER_DO__
  call timer_sta(1181)
#endif
         do jt = 1, n
            do it = 1, n
               f(it,jt,is) = finv(icount)
               icount = icount + 1
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1181)
#endif

         if(ipripulay >= 1) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      end do
#ifdef __TIMER_SUB__
    call timer_end(1134)
#endif
    end subroutine get_finv

    subroutine get_gmatrix(n)
      integer,intent(in) :: n
      integer :: is, it, jt, nnspin
#ifdef __TIMER_SUB__
    call timer_sta(1139)
#endif
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ============================ added by K. Tagami ============= 11.0
      if ( noncol ) nnspin = 1
! ============================================================== 11.0      

      g_p = 0.d0
      do is = 1, nnspin
#ifdef __TIMER_DO__
  call timer_sta(1188)
#endif
         do it = 1, n
            do jt = 1, n
               g_p(it,is) = g_p(it,is) - f(jt,it,is)*uuf_p(jt,is)
            end do
         end do
#ifdef __TIMER_DO__
  call timer_end(1188)
#endif
         if(ipripulay >= 2) then
            write(nfout,'(" -- g_p(1:",i3,") --")') n
            write(nfout,'(8f20.12)') (g_p(it,is),it=1,n)
         end if
      end do
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it = 1,n
            g_p(it,2) = g_p(it,1)
         enddo
      endif
! ============================== added by K. Tagami ============ 11.0
      if ( noncol ) then
         do it = 1,n
            g_p(it,:) = g_p(it,1)
         enddo
      endif
! ============================================================== 11.0

#ifdef __TIMER_SUB__
    call timer_end(1139)
#endif
    end subroutine get_gmatrix

    subroutine renew_d_using_g(n,p)
      integer, intent(in)                                :: n
      real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,nspin_m) :: p
      integer    :: is, k, i, it, itc, ns
#ifdef __TIMER_SUB__
    call timer_sta(1140)
#endif

!!$      do is = 1, nspin, af+1
      ns = nspin_for_qnewton()
      do is = 1, ns,af+1
         do k = 1, kimg
#ifdef __TIMER_DO__
  call timer_sta(1189)
#endif
            do i = ista_kngp, iend_kngp
               rho(i,k,is)  = rhoo(i,k,is) + p(i,is)*d0_l(i,k,is)
            end do
#ifdef __TIMER_DO__
  call timer_end(1189)
#endif
#ifdef __TIMER_DO__
  call timer_sta(1190)
#endif
            do it = 1, n
               itc = ncrspd(it)
               do i = ista_kngp, iend_kngp
                  rho(i,k,is) = rho(i,k,is) + g_p(it,is)* &
                       &        (urec_l(i,k,is,itc,iRho) + p(i,is)*urec_l(i,k,is,itc,iResid))
               end do
            end do
#ifdef __TIMER_DO__
  call timer_end(1190)
#endif
         end do
      end do

! ============================== modified by K. Tagami ================ 11.0
!      if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!
      if ( .not. noncol ) then
         if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
            call simple_mix2(c_p)
         endif
      endif
! ===================================================================== 11.0

      if(kgpm < kgp) then
         call concentrate_d_to_chg(rho,vlhxc_l) !-(m_C.D.)
         call simple_mix_large_Gc(c_p)         !-(m_C.D.) vlhxc,vlhxco,c_p ->vlhxc
      end if
#ifdef __TIMER_SUB__
    call timer_end(1140)
#endif
    end subroutine renew_d_using_g
  end subroutine m_Pot_mix_pulay

!!$ 11.07 AS Pulay version of 'sw_mix_potentiae_hardpart'
  subroutine m_Pot_mix_pulay_with_vhsr(nfout,rmx)
    integer, parameter  :: iRho = 1, iResid = 2
    integer, intent(in) :: nfout
    real(DP),intent(in) :: rmx
    integer   :: iter, mxiter
    real(DP),pointer,dimension(:)  :: e_wk, f_wk, ww1, finv
    integer, pointer,dimension(:)  :: ip
! --> T. Yamasaki  03 Aug. 2009
    real(kind=DP), allocatable, dimension(:):: rmxtrc ! d(nspin_m)
    real(kind=DP), allocatable, dimension(:,:,:) :: vlhxcstore_l, vlhxcostore_l
! <--
    integer   :: id_sname = -1

    call tstatc0_begin('m_Pot_mix_pulay_with_vhsr ',id_sname,1)

    if(previous_waymix /= PULAY.or.force_dealloc) then
       force_dealloc = .false.
       if ( first ) then
          call create_map_func(.true.)
          call alloc_rho_vhsr
          call create_map_func(.false.)
          first = .false.
       endif
       call mix_dealloc_previous()
       call mix_dealloc_previous_vhsr()
       call mix_pulay_allocate()
       call mix_pulay_allocate_vhsr()
    end if

    if ( noncol ) then
       if ( flg_paw ) then
          call map_vhsr_to_rho_noncl( rho_vhsr,  vnonlocal_r,     vnonlocal_i, &
               &                      dion_paw )
          call map_vhsr_to_rho_noncl( rhoo_vhsr, vnonlocal_r_old, vnonlocal_i_old, &
               &                      dion_paw_old )
       else
          call map_vhsr_to_rho_noncl( rho_vhsr,  vnonlocal_r,     vnonlocal_i )
          call map_vhsr_to_rho_noncl( rhoo_vhsr, vnonlocal_r_old, vnonlocal_i_old )
       endif
    else
       if ( flg_paw ) then
          call map_vhsr_to_rho( rho_vhsr,  vnonlocal_r,     dion_paw )
          call map_vhsr_to_rho( rhoo_vhsr, vnonlocal_r_old, dion_paw_old )
       else
          call map_vhsr_to_rho( rho_vhsr,  vnonlocal_r )
          call map_vhsr_to_rho( rhoo_vhsr, vnonlocal_r_old )
       endif
    endif

    allocate(rmxtrc(nspin_m))
    if ( noncol ) then
       rmxtrc(1:nspin_m) = rmx
    else
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vlhxcstore_recompos_vlhxc(rmx,rmxtrc) ! --> vlhxc_l,vlhxco_l, rmxtrc
       else
          rmxtrc(1:nspin_m) = rmx
       end if
    endif
! ========================================================================= 11.0

    if ( noncol ) then
       rmxtrc = rmx
    else
       if ( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2 ) then
          call alloc_rhostore_recomp( rmx, rmxtrc )
       else
          rmxtrc = rmx
       endif
    endif

! ====================================== Modified by K. Tagami =========
!    allocate(c_p(ista_kngp:iend_kngp)); call precon_4_pot_mix(rmx,c_p)
! --> T. Yamasaki, 03rd Aug. 2009
!!$    allocate(c_p(ista_kngp:iend_kngp)); c_p = 0; call precon_4_pot_mix(rmx,c_p)
    allocate(c_p(ista_kngp:iend_kngp,nspin_m)); c_p = 0
! ========================================================================


! ============================= modiifed by K. Tagami =================== 11.0
!    call precon_4_pot_mix(rmxtrc,c_p)
!
    if ( noncol ) then
       call precon_4_pot_mix_noncl(rmxtrc,c_p)
    else
       call precon_4_pot_mix(rmxtrc,c_p)
    endif
! ====================================================================== 11.0

    iter = iter_from_reset()                 !-(m_Pot)

    if((iter-istrbr+1) <= 1) then
       call simple_mix1(c_p)                 !-(m_Pot)
       call simple_mix_kt( rmxtrc )
       !   din=vlhxco_l; dout=vlhxc_l; (din,dout,c_p)->vlhxc_l
    else
       call mix_pulay_alloc2   !-(m_Pot) d0_l,u_l, and w_l are allocated
       call mix_pulay_alloc2_vhsr()
       call set_ncrspd_mxiter(nbxmix,iter-istrbr,mxiter) ! -> ncrspd, mxiter
!!$       call mix_pulay_alloc3(mxiter)   !-(c.h.) e_wk,f_wk,ww1,finv,ip

       call Resid_and_dd_into_urec_with_vhsr(mxiter) !-(c.h.)
       call Ri_dot_Rj_with_vhsr(mxiter)          !-(c.h.) <R(i)|R(j)>->f
       call get_finv_lapack_with_vhsr(nbxmix,mxiter,f)  !-(c.h.) f -> f^{-1}= <R(i)|R(j)>^{-1}
       call Rj_dot_d_with_vhsr(mxiter)           !-(c.h.) <R(j)|d>,(j=1,iter-istrb) -> uuf_p
       call get_gmatrix_with_vhsr(mxiter)        !-(c.h.) (f,uuf_p)->g
       call renew_d_using_g_with_vhsr(mxiter,c_pm)     !-(c.h.)

!!$       call mix_pulay_dealloc3                    !-(c.h.)
       call mix_pulay_dealloc2                    !-(m_Pot)
       call mix_pulay_dealloc2_vhsr                    !-(m_Pot)
    endif

    if ( .not. noncol ) then
       if(sw_recomposing == YES .and. af == 0 .and. nspin == 2) then
          call compos_vlhxc_dealloc_vlhxcstore()
       end if
       if ( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2 ) then
          call compose_rho_dealloc_store
       end if
    endif

    if ( noncol ) then
       if ( flg_paw ) then
          call map_rho_to_vhsr_noncl( rho_vhsr, vnonlocal_r, vnonlocal_i, dion_paw )
       else
          call map_rho_to_vhsr_noncl( rho_vhsr, vnonlocal_r, vnonlocal_i )
       endif
    else
       if ( flg_paw ) then
          call map_rho_to_vhsr( rho_vhsr, vnonlocal_r, dion_paw )
       else
          call map_rho_to_vhsr( rho_vhsr, vnonlocal_r )
       endif
    endif

    deallocate(rmxtrc)
    deallocate(c_p)

    previous_waymix = PULAY
    call tstatc0_end(id_sname)
  contains
    subroutine mix_pulay_alloc3(m)
      integer, intent(in) :: m
      allocate(e_wk(m*m)); allocate(f_wk(m*m)); allocate(ww1(m)); allocate(finv(m*m))
      allocate(ip(m))
! ===================================== Added by K. Tagami ============
      e_wk = 0; f_wk = 0; ww1 = 0; finv = 0; ip = 0
! =====================================================================
    end subroutine mix_pulay_alloc3

    subroutine set_ncrspd_mxiter(n,iter,m)
      integer, intent(in)  :: n, iter
      integer, intent(out) :: m
      integer :: i, nx
      if(hownew == ANEW) then
         m = iter
         ncrspd(:) = (/(i,i=1,m)/)
      else ! hownew == RENEW
         if(iter <= n) then
            m = iter
            ncrspd(:) = (/(i,i=1,m)/)
         else
            m = n
            nx = ncrspd(1)
            do i = 1, m-1
               ncrspd(i) = ncrspd(i+1)
            end do
            ncrspd(m) = nx
         end if
      end if
    end subroutine set_ncrspd_mxiter

    subroutine mix_pulay_dealloc3
      deallocate(e_wk); deallocate(f_wk); deallocate(ww1); deallocate(finv)
      deallocate(ip)
    end subroutine mix_pulay_dealloc3

    subroutine Resid_and_dd_into_urec_with_vhsr(iter)
      integer, intent(in) :: iter
      integer             :: itc,itc0,itc1
      integer :: i,j,k,nmix,imix
      itc = ncrspd(iter)
      if(sw_gradient_simplex==ON)then
         do imix=2,iter-1
            itc0 = ncrspd(imix)
            itc1 = ncrspd(imix-1)
            do i=1,nspin_m
               do j=1,kimg
                  do k=ista_kgpm,iend_kgpm
                     urec_l(k,j,i,itc0,iResid) = rho(k,j,i)-rhoo(k,j,i)-(Frhoj(k,j,i,itc1)-rhoj(k,j,i,itc1))
                     urec_l(k,j,i,itc0,iRho  ) = rhoo(k,j,i)-rhoj(k,j,i,itc1)
                  enddo
               enddo
            enddo
            do i=1,nspin_m
               do j=1,nsize_rho_vhsr
                  urec_vhsr(j,i,itc0,iResid) = rho_vhsr(j,i) - rhoo_vhsr(j,i) - (Frhoj_vhsr(j,i,itc1) - rhoj_vhsr(j,i,itc1))
                  urec_vhsr(j,i,itc0,iRho  ) = rhoo_vhsr(j,i) - rhoj_vhsr(j,i,itc1)
               enddo
            enddo
         enddo
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i)-rhoo(k,j,i)-(dout(k,j,i)-din(k,j,i))
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i)-din(k,j,i)
                  rhoj(k,j,i,itc) = rhoo(k,j,i)
                  Frhoj(k,j,i,itc) = rho(k,j,i)
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
         do i=1,nspin_m
            do j=1,nsize_rho_vhsr
               urec_vhsr(j,i,itc,iResid) = rho_vhsr(j,i) - rhoo_vhsr(j,i) - (dout_vhsr(j,i) - din_vhsr(j,i)) ! =dF(=delta F^i)
               urec_vhsr(j,i,itc,iRho  ) = rhoo_vhsr(j,i) - din_vhsr(j,i)                ! =dd
               d0_vhsr(j,i) = rho_vhsr(j,i) - rhoo_vhsr(j,i)
               din_vhsr(j,i) = rhoo_vhsr(j,i)
               dout_vhsr(j,i) = rho_vhsr(j,i)
               rhoj_vhsr(j,i,itc) = rhoo_vhsr(j,i)
               Frhoj_vhsr(j,i,itc) = rho_vhsr(j,i)
            enddo
         enddo
      else
         do i=1,nspin_m
            do j=1,kimg
               do k=ista_kgpm,iend_kgpm
                  urec_l(k,j,i,itc,iResid) = rho(k,j,i) - rhoo(k,j,i) - (dout(k,j,i) - din(k,j,i)) ! =dF(=delta F^i)
                  urec_l(k,j,i,itc,iRho  ) = rhoo(k,j,i) - din(k,j,i)                ! =dd
                  d0_l(k,j,i) = rho(k,j,i) - rhoo(k,j,i)
                  din(k,j,i)  = rhoo(k,j,i)
                  dout(k,j,i) = rho(k,j,i)
               enddo
            enddo
         enddo
         do i=1,nspin_m
            do j=1,nsize_rho_vhsr
               urec_vhsr(j,i,itc,iResid) = rho_vhsr(j,i) - rhoo_vhsr(j,i) - (dout_vhsr(j,i) - din_vhsr(j,i)) ! =dF(=delta F^i)
               urec_vhsr(j,i,itc,iRho  ) = rhoo_vhsr(j,i) - din_vhsr(j,i)                ! =dd
               d0_vhsr(j,i) = rho_vhsr(j,i) - rhoo_vhsr(j,i)
               din_vhsr(j,i) = rhoo_vhsr(j,i)
               dout_vhsr(j,i) = rho_vhsr(j,i)
            enddo
         enddo
      endif
    end subroutine Resid_and_dd_into_urec_with_vhsr

    subroutine Ri_dot_Rj_with_vhsr(n)
      integer, intent(in) :: n
      integer  :: it,jt,itc,jtc,is
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff2(nspin),ff1tmp
      real(DP) :: ff1(nspin_m),ff2(nspin_m),ff1tmp
! ==============================================================================
      do it = 1, n
         itc = ncrspd(it)
         do jt = it, n
            jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
            urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,itc,iResid)
            urec_l_3_2 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
            call mult1s(urec_l_3,urec_l_3_2,f_p,ff1)   ! <delta F^i|delta F^j>
#else
            if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
               ff1tmp=0.d0
               call mult1s10_reduce_spin(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1tmp)   ! <delta F^i|delta F^j>
               do is=1,nspin_m,af+1
                  ff1tmp = ff1tmp+sum(urec_vhsr(:,is,itc,iResid) * urec_vhsr(:,is,jtc,iResid))
               enddo
               ff1(1) = ff1tmp
               ff1(2) = ff1tmp
            else
               call mult1s10(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1)   ! <delta F^i|delta F^j>
               do is=1,nspin_m,(af+1)
                  ff1(is) = ff1(is)+sum(urec_vhsr(:,is,itc,iResid) * urec_vhsr(:,is,jtc,iResid))
               enddo
            endif

! ============================= added by K. Tagami ======================= 11.0
            if ( noncol ) then
               ff1tmp=0.d0
               call mult1s10_reduce_spin(urec_l,nbxmix,2,itc,iResid,urec_l,jtc,iResid,f_p,ff1tmp)   ! <delta F^i|delta F^j>
               do is=1,ndim_magmom
                  ff1tmp = ff1tmp+sum(urec_vhsr(:,is,itc,iResid) * urec_vhsr(:,is,jtc,iResid))
               enddo
               ff1(:) = ff1tmp
            endif
! ======================================================================== 11.0
#endif
            f(it,jt,1:nspin_m) = ff1(1:nspin_m)
            if(jt /= it) f(jt,it,1:nspin_m) = f(it,jt,1:nspin_m)
         end do
      end do
    end subroutine Ri_dot_Rj_with_vhsr

    subroutine Rj_dot_d_with_vhsr(n)
      integer, intent(in) :: n
      integer  :: jt, jtc, is
! === DEBUG by tkato 2011/11/24 ================================================
!     real(DP) :: ff1(nspin),ff2(nspin)
      real(DP) :: ff1(nspin_m),ff2(nspin_m)
! ==============================================================================
      real(DP) :: ff1tmp
      do jt = 1, n
         jtc = ncrspd(jt)
#ifdef _CDMIX_USE_POINTER_
         urec_l_3 => urec_l(ista_kgpm:iend_kgpm,1:kimg,1:nspin_m,jtc,iResid)
         call mult1s(urec_l_3,d0_l,f_p,ff1)
#else
         if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
            ff1tmp=0.d0
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            do is=1,nspin_m,af+1
               ff1tmp = ff1tmp+sum(urec_vhsr(:,is,jtc,iResid) * d0_vhsr(:,is))
            enddo
            ff1(1) = ff1tmp;ff1(2) = ff1tmp
         else
            call mult1s5(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1)
            ff2=0.d0
            do is=1,nspin_m,af+1
               ff2(is) = ff2(is)+sum(urec_vhsr(:,is,jtc,iResid) * d0_vhsr(:,is))
            enddo
            ff1(:) = ff1(:)+ff2(:)
         endif

! =========================== added by K. Tagami ================== 11.0
         if ( noncol ) then
            ff1tmp=0.d0
            call mult1s5_reduce_spin(urec_l,nbxmix,2,jtc,iResid,d0_l,f_p,ff1tmp)
            do is=1,ndim_magmom
               ff1tmp = ff1tmp+sum(urec_vhsr(:,is,jtc,iResid) * d0_vhsr(:,is))
            enddo
            ff1(:) = ff1tmp
         endif
! ================================================================ 11.0         

#endif
         uuf_p(jt,1:nspin_m) = ff1(1:nspin_m)
      end do
    end subroutine Rj_dot_d_with_vhsr

    subroutine get_finv_lapack_with_vhsr(m,n,f)
      integer,intent(in)                             :: m,n
      real(DP),intent(inout),dimension(m,m,nspin_m) :: f
      real(DP), allocatable,dimension(:,:) :: fwork
      integer :: is,inf,it,jt,kt,nnspin
      real(DP) :: div,tmp
      allocate(fwork(n,n))
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ============================== added by K. Tagami ============== 11.0
      if ( noncol )  nnspin = 1 
! ================================================================ 11.0

      do is=1,nnspin
         if(ipripulay >= 2) then
            write(nfout,600) n,(('(',it,jt,')',f(it,jt,is),jt=1,n),it=1,n)
600         format(//11x,"**input matrix**"/12x &
                 & ,"horder=",I5/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
         fwork=0
         do it=1,n
            do jt=1,n
               fwork(jt,it) = f(jt,it,is)
               if(it==jt) fwork(jt,it)=fwork(jt,it)+alpha_pulay
            enddo
         enddo
         call dpotrf('U',n,fwork,n,inf)
         call dpotri('U',n,fwork,n,inf)
         do it=1,n-1
            do jt=it+1,n
               fwork(jt,it) = fwork(it,jt)
            enddo
         enddo
         do it=1,n
            do jt=1,n
               f(jt,it,is) = fwork(jt,it)
            enddo
         enddo
         if(ipripulay >= 2) then
            write(nfout,630) (('(',it,jt,')',f(it,jt,is),it=1,n),jt=1,n)
630         format(/11x, "**inverse matrix**" &
                 & ,/(2x,4(1x,1a,i2,",",i2,1a,e14.6)))
         end if
      enddo
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it=1,n
            do jt=1,n
               f(jt,it,2) = f(jt,it,1)
            enddo
         enddo
      endif

! ================================= added by K. Tagami ================= 11.0
      if ( noncol ) then
         do it=1,n
            do jt=1,n
               f(jt,it,:) = f(jt,it,1)
            enddo
         end do
      endif
! ====================================================================== 11.0
      deallocate(fwork)
    end subroutine get_finv_lapack_with_vhsr

    subroutine get_gmatrix_with_vhsr(n)
      integer,intent(in) :: n
      integer :: is, it, jt, nnspin
      nnspin = nspin
      if(sw_mix_bothspins_sametime==ON .or. af==1) nnspin=1

! ============================== added by K. Tagami ============== 11.0
      if ( noncol )  nnspin = 1 
! ================================================================ 11.0

      g_p = 0.d0
      do is = 1, nnspin
         do it = 1, n
            do jt = 1, n
               g_p(it,is) = g_p(it,is) - f(jt,it,is)*uuf_p(jt,is)
            end do
         end do
         if(ipripulay >= 2) then
            write(nfout,'(" -- g_p(1:",i3,") --")') n
            write(nfout,'(8f20.12)') (g_p(it,is),it=1,n)
         end if
      end do
      if(sw_mix_bothspins_sametime==ON .and. nspin_m>1)then
         do it = 1,n
            g_p(it,2) = g_p(it,1)
         enddo
      endif
! ================================= added by K. Tagami ================= 11.0
      if ( noncol ) then
         do it = 1,n
            g_p(it,:) = g_p(it,1)
         end do
      end if
! ====================================================================== 11.0
    end subroutine get_gmatrix_with_vhsr

    subroutine renew_d_using_g_with_vhsr(n,p)
      integer, intent(in)                                :: n
      real(DP),intent(in),dimension(ista_kgpm:iend_kgpm,nspin_m) :: p
      integer    :: is, k, i, it, itc, ns

!!$      do is = 1, nspin, af+1
      ns = nspin_for_qnewton()
      do is = 1, ns,af+1
         do k = 1, kimg
            do i = ista_kngp, iend_kngp
               rho(i,k,is)  = rhoo(i,k,is) + p(i,is)*d0_l(i,k,is)
            end do
            do it = 1, n
               itc = ncrspd(it)
               do i = ista_kngp, iend_kngp
                  rho(i,k,is) = rho(i,k,is) + g_p(it,is)* &
                       &        (urec_l(i,k,is,itc,iRho) + p(i,is)*urec_l(i,k,is,itc,iResid))
               end do
            end do
         end do
      end do
      do is=1,ns,af+1
         rho_vhsr(:,is) = rhoo_vhsr(:,is) + rmxtrc(is) * d0_vhsr(:,is)
         do it = 1, n
            itc = ncrspd(it)
            rho_vhsr(:,is) = rho_vhsr(:,is) + g_p(it,is) * &
          & (urec_vhsr(:,is,itc,iRho) + rmxtrc(is)*urec_vhsr(:,is,itc,iResid))
         enddo
      enddo

! ============================== modified by K. Tagami ================ 11.0
!      if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) call simple_mix2(c_p)
!      if(sw_force_simple_mixing_hsr==ON .and. sw_recomposing_vhsr==ON ) call simple_mix2_kt( rmxtrc )
!
      if ( .not. noncol ) then
         if(sw_force_simple_mixing==ON .and. sw_recomposing==ON) then
            call simple_mix2(c_p)
         endif
         if(sw_force_simple_mixing_hsr==ON .and. sw_recomposing_hsr==ON ) then
            call simple_mix2_kt( rmxtrc )
         endif
      endif
! ===================================================================== 11.0

      if(kgpm < kgp) then
         call concentrate_d_to_chg(rho,vlhxc_l) !-(m_C.D.)
         call simple_mix_large_Gc(c_p)         !-(m_C.D.) vlhxc,vlhxco,c_p ->vlhxc
      end if
    end subroutine renew_d_using_g_with_vhsr
  end subroutine m_Pot_mix_pulay_with_vhsr
!!$ 11.07 AS Pulay version of 'sw_mix_potential_hardpart'

! ========================= added by K. Tagami ===================== 5.0
  subroutine create_map_func(paramset)
    logical :: paramset
    integer :: n, ia, it
    integer :: lmt1, lmt2

    if ( noncol ) then
       n=0
       do ia=1,natm
          it = ityp(ia)
          do lmt1=1, ilmt(it)
             do lmt2 = lmt1, ilmt(it)
                n=n+1
                if(.not.paramset) &
                     & imap_vhsr(n) = ia + natm *(lmt1-1) + natm*nlmt*( lmt2 -1 )
             end do
          end do
       end do
       nsize_rho_vhsr = n;   nsize_rho_vhsr_unit = n

       if ( sw_mix_imaginary_hardpart == ON ) then
          do ia=1,natm
             it = ityp(ia)
             do lmt1=1, ilmt(it)
                do lmt2 = lmt1 +1, ilmt(it)
                   n=n+1
                   if(.not.paramset) &
                        & imap_vhsr(n) = ia + natm *(lmt1-1) + natm*nlmt*( lmt2 -1 )
                end do
             end do
          end do
          nsize_rho_vhsr = n
       endif

       if ( flg_paw ) then
          do ia=1,natm
             it = ityp(ia)
             do lmt1=1, ilmt(it)
                do lmt2 = lmt1 +1, ilmt(it)
                   n=n+1
                   if(.not.paramset) &
                        & imap_vhsr(n) = ia + natm *(lmt1-1) + natm*nlmt*( lmt2 -1 )
                end do
             end do
          end do
          nsize_rho_vhsr = n
       endif

    else
       n=0
       do ia=1,natm
          it = ityp(ia)
          do lmt1=1, ilmt(it)
             do lmt2 = lmt1, ilmt(it)
                n=n+1
                if(.not.paramset) &
                     & imap_vhsr(n) = ia + natm *(lmt1-1) + natm*nlmt*( lmt2 -1 )
             end do
          end do
       end do
       nsize_rho_vhsr = n;   nsize_rho_vhsr_unit = n

       if ( flg_paw ) then
          do ia=1,natm
             it = ityp(ia)
             do lmt1=1, ilmt(it)
                do lmt2 = lmt1 +1, ilmt(it)
                   n=n+1
                   if(.not.paramset) &
                        & imap_vhsr(n) = ia + natm *(lmt1-1) + natm*nlmt*( lmt2 -1 )
                end do
             end do
          end do
          nsize_rho_vhsr = n
       endif

    endif
! ================================================================= 11.0
  end subroutine create_map_func

  subroutine alloc_rho_vhsr
! ================================ modified by K. Tagami ============== 11.0
!    allocate( rho_vhsr( nsize_rho_vhsr,nspin)); rho_vhsr = 0.0d0
!    allocate( rhoo_vhsr(nsize_rho_vhsr,nspin));rhoo_vhsr = 0.0d0
    allocate( rho_vhsr( nsize_rho_vhsr,ndim_magmom)); rho_vhsr = 0.0d0
    allocate( rhoo_vhsr(nsize_rho_vhsr,ndim_magmom));rhoo_vhsr = 0.0d0
! ====================================================================== 11.0
    allocate( imap_vhsr(nsize_rho_vhsr) ); imap_vhsr = 0
  end subroutine alloc_rho_vhsr

  subroutine dealloc_rho_vhsr
    deallocate(rho_vhsr)
    deallocate(rhoo_vhsr)
    deallocate(imap_vhsr)
  end subroutine dealloc_rho_vhsr

  subroutine map_vhsr_to_rho( rho, vnonlocal, dion_paw )
    real(kind=DP), intent(out) :: rho( nsize_rho_vhsr,nspin)
    real(kind=DP), intent(in) :: vnonlocal( nlmt, nlmt, natm, nspin )
    real(kind=DP), optional, intent(in) :: dion_paw( nlmt, nlmt, nspin, natm )

    integer :: i, it, is, ia, ilmt1, ilmt2, n, icount

    real(kind=DP), allocatable :: vhsr(:,:)

    allocate( vhsr( natm*nlmt*nlmt, nspin ) )

    vhsr = 0.0d0;   n=0;   icount = 0
    do ia=1,natm
       it = ityp(ia)
       do ilmt1=1, ilmt(it)
          do ilmt2 = 1, ilmt(it)
             n = n +1
             Do is=1, nspin
                vhsr(n,is) = vnonlocal( ilmt1,ilmt2,ia,is )
             End do
          End do
       End do
    End Do
    do is=1,nspin,(af+1)
       do i=1, nsize_rho_vhsr_unit
          rho(i,is) = vhsr(imap_vhsr(i),is)
       end do
    end do

    if ( flg_paw ) then
       vhsr = 0.0d0;   n=0;   icount = icount+1
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, nspin
                   vhsr( n,is ) = dion_paw( ilmt1,ilmt2,is,ia )
                End do
             End do
          End do
       End Do
       do is=1,nspin,(af+1)
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             rho(i,is) = vhsr(imap_vhsr(i),is)
          end do
       end do
    endif

    deallocate( vhsr )

  end subroutine map_vhsr_to_rho

! ============================================ added by K. Tagami ======== 11.0
  subroutine map_vhsr_to_rho_noncl( rho, vnonlocal_r, vnonlocal_i, dion_paw )
    real(kind=DP), intent(out) :: rho( nsize_rho_vhsr,ndim_magmom )
    real(kind=DP), intent(in) :: vnonlocal_r( nlmt, nlmt, natm, nspin )
    real(kind=DP), intent(in) :: vnonlocal_i( nlmt, nlmt, natm, nspin )
    real(kind=DP), optional, intent(in) :: dion_paw( nlmt, nlmt, nspin, natm )

    integer :: i, n, is, ia, ilmt1, ilmt2, it, icount
    real(kind=DP), allocatable :: vhsr(:,:), vhsi(:,:)

    allocate( vhsr( natm*nlmt*nlmt, ndim_magmom ) )
    allocate( vhsi( natm*nlmt*nlmt, ndim_magmom ) )

    vhsr = 0.0d0;  n = 0;  icount = 0
    Do ia=1, natm
       it = ityp(ia)
       Do ilmt1=1, ilmt(it)
          Do ilmt2=1, ilmt(it)
             n = n +1
             Do is=1, ndim_magmom
                vhsr( n,is ) = vnonlocal_r(ilmt1,ilmt2,ia,is)
             End do
          End do
       End do
    End Do
    do is=1,ndim_magmom
       do i=1,nsize_rho_vhsr_unit
          rho(i,is) = vhsr( imap_vhsr(i),is )
       end do
    end do

    if ( sw_mix_imaginary_hardpart == ON ) then
       vhsi = 0.0d0;  n = 0;  icount = icount +1
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, ndim_magmom
                   vhsi( n,is ) = vnonlocal_i(ilmt1,ilmt2,ia,is)
                End do
             End do
          End do
       End Do
       do is=1,ndim_magmom
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             rho(i,is) = vhsi( imap_vhsr(i),is )
          end do
       end do
    end if

    if ( flg_paw ) then
       vhsr = 0.0d0;   n=0;   icount = icount+1
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, ndim_magmom
                   vhsr( n,is ) = dion_paw( ilmt1,ilmt2,is,ia )
                End do
             End do
          End do
       End Do
       do is=1,ndim_magmom
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             rho(i,is) = vhsr( imap_vhsr(i),is )
          end do
       end do
    endif

    deallocate( vhsr )
    if ( allocated( vhsi ) ) deallocate( vhsi )

  end subroutine map_vhsr_to_rho_noncl
! ===================================================================== 11.0

  subroutine map_rho_to_vhsr( rho, vnonlocal, dion_paw )
    real(kind=DP), intent(in) :: rho( nsize_rho_vhsr,nspin )
    real(kind=DP), intent(out) :: vnonlocal( nlmt, nlmt, natm, nspin )
    real(kind=DP), optional, intent(out) :: dion_paw( nlmt, nlmt, nspin, natm )

    integer :: i, is, ia, ilmt1, ilmt2, n, it, icount
    real(kind=DP), allocatable :: vhsr(:,:)

    allocate( vhsr( natm*nlmt*nlmt, nspin ) )

    vhsr = 0.0d0; icount = 0
    do is=1,nspin,(af+1)
       do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
          vhsr(imap_vhsr(i),is) = rho(i,is)
       end do
    end do
    call symmetrize(vhsr)

    n = 0
    Do ia=1, natm
       it = ityp(ia)
       Do ilmt1=1, ilmt(it)
          Do ilmt2=1, ilmt(it)
             n = n +1
             Do is=1, nspin
                vnonlocal( ilmt1,ilmt2,ia,is ) = vhsr( n,is )
             End do
          End do
       End do
    End Do

    if (flg_paw) then
       vhsr = 0.0d0; icount = icount +1
       do is=1,nspin,(af+1)
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             vhsr(imap_vhsr(i),is) = rho(i,is)
          end do
       end do
       call symmetrize(vhsr)
!
       n = 0
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, nspin
                   dion_paw( ilmt1,ilmt2,is,ia ) = vhsr( n,is )
                End do
             End do
          End do
       End Do
    endif

    deallocate( vhsr )

  contains

    subroutine symmetrize(vhsr)
      real(kind=DP), intent(inout) :: vhsr( natm, nlmt, nlmt, nspin )

      integer :: is, lmt1, lmt2, ia

      do is=1,nspin,(af+1)
         do ia=1,natm
            do lmt1=1, nlmt
               do lmt2=lmt1, nlmt
                  if ( lmt1/=lmt2 ) vhsr(ia,lmt2,lmt1,is) = vhsr(ia,lmt1,lmt2,is)
               end do
            end do
         end do
      end do
    end subroutine symmetrize
  end subroutine map_rho_to_vhsr
! ========================================================================= 5.0

  subroutine map_rho_to_vhsr_noncl( rho, vnonlocal_r, vnonlocal_i, dion_paw )
    real(kind=DP), intent(in) :: rho( nsize_rho_vhsr, ndim_magmom )
    real(kind=DP), intent(out) :: vnonlocal_r( nlmt, nlmt, natm, nspin )
    real(kind=DP), intent(out) :: vnonlocal_i( nlmt, nlmt, natm, nspin )
    real(kind=DP), optional, intent(out) :: dion_paw( nlmt, nlmt, nspin, natm )

    integer :: i, is, ia, ilmt1, ilmt2, n, it, icount
    real(kind=DP), allocatable :: vhsr(:,:), vhsi(:,:)

    allocate( vhsr( natm*nlmt*nlmt, ndim_magmom ) )
    allocate( vhsi( natm*nlmt*nlmt, ndim_magmom ) )

    vhsr = 0.0d0;  icount = 0
    do is=1,ndim_magmom
       do i=1,nsize_rho_vhsr_unit
          vhsr(imap_vhsr(i),is) = rho(i,is)
       end do
    end do
    call symmetrize_r(vhsr)
!
    n = 0
    Do ia=1, natm
       it = ityp(ia)
       Do ilmt1=1, ilmt(it)
          Do ilmt2=1, ilmt(it)
             n = n +1
             Do is=1, nspin
                vnonlocal_r( ilmt1,ilmt2,ia,is ) = vhsr( n,is )
             End do
          End do
       End do
    End Do
    
    if ( sw_mix_imaginary_hardpart == ON ) then
       vhsi = 0.0d0;  icount = icount +1
       do is=1,ndim_magmom
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             vhsi(imap_vhsr(i),is) = rho(i,is)
          end do
       end do
       call symmetrize_i(vhsi)
!
       n = 0
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, nspin
                   vnonlocal_i( ilmt1,ilmt2,ia,is ) = vhsi( n,is )
                End do
             End do
          End do
       End Do
    endif

    if ( flg_paw ) then
       vhsr = 0.0d0;  icount = icount +1
       do is=1,ndim_magmom
          do i=nsize_rho_vhsr_unit*icount +1, nsize_rho_vhsr_unit*( icount+1 )
             vhsr(imap_vhsr(i),is) = rho(i,is)
          end do
       end do
       call symmetrize_r(vhsi)
!
       n = 0
       Do ia=1, natm
          it = ityp(ia)
          Do ilmt1=1, ilmt(it)
             Do ilmt2=1, ilmt(it)
                n = n +1
                Do is=1, ndim_magmom
                   dion_paw( ilmt1,ilmt2,is,ia ) = vhsr( n,is )
                End do
             End do
          End do
       End Do
    endif

    deallocate( vhsr )
    if ( allocated( vhsi ) ) deallocate( vhsi )

  contains
    subroutine symmetrize_r(vhsr)
      real(kind=DP), intent(inout) :: vhsr( natm, nlmt, nlmt, ndim_magmom )

      integer :: is, ia, lmt1, lmt2

      do is=1,ndim_magmom
         do ia=1,natm
            do lmt1=1, nlmt
               do lmt2=lmt1, nlmt
                  if ( lmt1/=lmt2 ) then
                     vhsr(ia,lmt2,lmt1,is) = vhsr(ia,lmt1,lmt2,is)
                  endif
               end do
            end do
         end do
      end do
    end subroutine symmetrize_r

    subroutine symmetrize_i(vhsi)
      real(kind=DP), intent(inout) :: vhsi( natm, nlmt, nlmt, ndim_magmom )

      integer :: is, ia, lmt1, lmt2

      do is=1,ndim_magmom
         do ia=1,natm
            do lmt1=1, nlmt
               do lmt2=lmt1, nlmt
                  if ( lmt1/=lmt2 ) then
                     vhsi(ia,lmt2,lmt1,is) = -vhsi(ia,lmt1,lmt2,is)
                  endif
               end do
            end do
         end do
      end do
    end subroutine symmetrize_i
    
  end subroutine map_rho_to_vhsr_noncl
! ========================================================================= 11.0

! ========================= added by K. Tagami========================== 5.0
  subroutine m_Pot_simple_mixing_hard( nfout,rmxt )
    integer, intent(in) :: nfout
    real(kind=DP), intent(in) :: rmxt

    integer :: is

! =============================== modified by K.Tagami ================ 11.0
!    nspin_m  = nspin/(af+1)
    if ( noncol ) then
       nspin_m = ndim_magmom
    else
       nspin_m  = nspin/(af+1)
    endif
! ====================================================================== 11.0

    allocate( rmxtrc(nspin_m) )

! ============================= modified by K. Tagami =============== 11.0
!    if ( sw_recomposing_vhsr == YES .and. af == 0 .and. nspin == 2 ) then
!       call alloc_vhsrstore_recomp( rmxt, rmxtrc )
!    else
!       rmxtrc = rmxt
!    endif

    if ( noncol ) then
       rmxtrc = rmxt
    else
       if( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2) then
          call alloc_vhsrstore_recomp(rmxt,rmxtrc)
       else
          rmxtrc = rmxt
       endif
    end if
! ==================================================================== 11.0

    if ( noncol ) then
       Do is=1, ndim_magmom
          vnonlocal_r(:,:,:,is) = rmxtrc(is) *vnonlocal_r(:,:,:,is) &
            &              + ( 1.d0-rmxtrc(is) ) *vnonlocal_r_old(:,:,:,is)
       End do

       if ( sw_mix_imaginary_hardpart == ON ) then
          Do is=1, ndim_magmom
             vnonlocal_i(:,:,:,is) = rmxtrc(is) *vnonlocal_i(:,:,:,is) &
                  &              + ( 1.d0-rmxtrc(is) ) *vnonlocal_i_old(:,:,:,is)
          End do
       endif

       if ( flg_paw ) then
          Do is=1, ndim_magmom
             dion_paw(:,:,is,:) = rmxtrc(is) *dion_paw(:,:,is,:) &
                  &              + ( 1.d0-rmxtrc(is) ) *dion_paw_old(:,:,is,:)
          End do
       endif

       stop "kt: under construction, 100"

    else
       Do is=1, nspin, af+1
          vnonlocal_r(:,:,:,is) = rmxtrc(is) *vnonlocal_r(:,:,:,is) &
            &              + ( 1.d0-rmxtrc(is) ) *vnonlocal_r_old(:,:,:,is)
       End do
       if ( flg_paw ) then
          Do is=1, nspin, af+1
             dion_paw(:,:,is,:) = rmxtrc(is) *dion_paw(:,:,is,:) &
                  &              + ( 1.d0-rmxtrc(is) ) *dion_paw_old(:,:,is,:)
          End do
       endif
    endif

    if ( .not. noncol ) then
       if ( sw_recomposing_hsr == YES .and. af == 0 .and. nspin == 2) then
          call compose_vhsr_dealloc_store
       end if
    endif

    deallocate(rmxtrc)

  end subroutine m_Pot_simple_mixing_hard
! ============================================================== 5.0

  subroutine m_Pot_simple_mixing_vhsr(nfout,rmxt)
    integer ,intent(in)      :: nfout
    real(kind=DP),intent(in) :: rmxt

    integer:: ia,it,is,lmt1,lmt2
#ifdef __TIMER_SUB__
    call timer_sta(1144)
#endif

#ifdef __TIMER_DO__
    call timer_sta(1192)
#endif
    if ( noncol ) then
       do ia = 1, natm
          it = ityp(ia)
          do is = 1, ndim_magmom
             do lmt1 = 1, ilmt(it)
                do lmt2 = 1, ilmt(it)
                   vnonlocal_r(lmt1,lmt2,ia,is) &
                        &   = rmxt *vnonlocal_r(lmt1,lmt2,ia,is) &
                        &    +(1-rmxt) *vnonlocal_r_old(lmt1,lmt2,ia,is)
                end do
             end do
          end do
       end do

       if ( sw_mix_imaginary_hardpart == ON ) then
          do ia = 1, natm
             it = ityp(ia)
             do is = 1, ndim_magmom
                do lmt1 = 1, ilmt(it)
                   do lmt2 = 1, ilmt(it)
                      vnonlocal_i(lmt1,lmt2,ia,is) &
                           &   = rmxt *vnonlocal_i(lmt1,lmt2,ia,is) &
                           &    +(1-rmxt) *vnonlocal_i_old(lmt1,lmt2,ia,is)
                   end do
                end do
             end do
          end do
       endif

    else
       do ia = 1, natm
          it = ityp(ia)
          
          do is = 1, nspin, af+1
             do lmt1 = 1, ilmt(it)
                do lmt2 = lmt1, ilmt(it)
                   vnonlocal_r(lmt1,lmt2,ia,is) &
                        &   = rmxt *vnonlocal_r(lmt1,lmt2,ia,is) &
                        &    +(1-rmxt) *vnonlocal_r_old(lmt1,lmt2,ia,is)
                end do
             end do
          end do

          if ( ipaw(it) == 0 ) cycle

          do is = 1, nspin, af+1
             do lmt1 = 1, ilmt(it)
                do lmt2 = lmt1, ilmt(it)
                   dion_paw(lmt1,lmt2,is,ia) = rmxt *dion_paw(lmt1,lmt2,is,ia) &
                        &                  + (1-rmxt) *dion_paw_old(lmt1,lmt2,is,ia)
                end do
             end do
          end do

       end do
    end if
#ifdef __TIMER_DO__
    call timer_end(1192)
#endif

#ifdef __TIMER_SUB__
    call timer_end(1144)
#endif
  end subroutine m_Pot_simple_mixing_vhsr

end module m_Potential_mixing

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: forcrsv, forc_cnst, copy_to_cpd_forc_and_forcp, 
!             cnstrnt, rplcps, rbinuc, change_of_coordinate_system
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_Ionic_System.f90 633 2020-12-01 05:11:03Z jkoga $
subroutine forcrsv(natm,ityp,imdtyp,iwei,amion,cpd_l,tkb,nrsv,imdalg &
     & ,frsv,iw_cnst)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: forcrsv
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP,BLUEMOON,QUENCHED_CONSTRAINT
  implicit none
  integer, intent(in)       :: natm,nrsv,imdalg &
       &                      ,ityp(natm),imdtyp(natm),iwei(natm)
  real(kind=DP),intent(in)  :: amion(*),tkb(nrsv),cpd_l(natm,3)
  real(kind=DP),intent(out) :: frsv(nrsv)
  integer, intent(in),optional :: iw_cnst
  real(kind=DP) :: vex,vey,vez
  integer :: ia, ir, icnstrnt_typ

  frsv = 0.d0
  do ia = 1, natm
     ir = icnstrnt_typ(imdtyp(ia),imdalg)
     if(ir >= 1) then
          vex = cpd_l(ia,1)
          vey = cpd_l(ia,2)
          vez = cpd_l(ia,3)
          frsv(ir)= frsv(ir) &
     &             +(( vex*vex +vey*vey +vez*vez )*amion(ityp(ia))&
     &                -3.d0*tkb(ir))*iwei(ia)
     end if
  end do

  if(imdalg == BLUEMOON .or. imdalg == QUENCHED_CONSTRAINT) then
     ir = 1
     frsv(ir) = frsv(ir) + iw_cnst*tkb(ir)
  end if
end subroutine forcrsv

integer function irtyp(imd)
  implicit none
  integer, intent(in) :: imd
  if(imd <= 0) irtyp = -1
  if(imd >= 1) irtyp =  0
  if(imd > 1000) irtyp = imd - 1000
end function irtyp

integer function ibath(imd)
  integer, intent(in) :: imd
  if(imd <= 0) ibath = -1
  if(imd >= 1) ibath =  0
  if(imd > 1000) ibath = imd/1000
end function ibath

integer function icnstrnt_typ(imd,imdalg)
  use m_Const_Parameters, only : HEAT_BATH, BLUEMOON, QUENCHED_CONSTRAINT, VERLET
  implicit none
  integer, intent(in) :: imd, imdalg

  if(imdalg == VERLET) then
     if(imd > HEAT_BATH) then
        icnstrnt_typ = imd - HEAT_BATH
     else
        icnstrnt_typ = imd
     end if
  else
     if(imd <= 0) icnstrnt_typ = -1
     if(imd >= 1) icnstrnt_typ =  0
     if(imd > HEAT_BATH) then
        if(imdalg == BLUEMOON .or. imdalg == QUENCHED_CONSTRAINT) then
           icnstrnt_typ = imd/HEAT_BATH
        else  ! imdalg == TEMPERATURE_CONTROL etc.
           icnstrnt_typ = imd - HEAT_BATH
        end if
     end if
  end if
end function icnstrnt_typ

subroutine forc_cnst(natm,ityp,amion,cps,cnst_typ,nfcatm,ia_cnst,imdtyp &
     &, sgmc,gca)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: forc_cnst
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP,BONDLENGTH_FIX_1, BONDLENGTH_FIX_2 &
       &, FIX, COG_FIX_L
  implicit none
  integer, intent(in) :: natm,ityp(natm),cnst_typ,nfcatm,ia_cnst(nfcatm)&
       &,  imdtyp(natm)
  real(kind=DP),intent(in) :: amion(*),cps(natm,3),sgmc(4)
  real(kind=DP),intent(out):: gca(natm,3)

  integer       :: ia, ia1, ia2, m
  real(kind=DP) :: r12, tmass,rmass

  gca = 0.d0

  ! +++ bond length (1st order) +++
  if(cnst_typ ==  BONDLENGTH_FIX_1) then
     ia1= ia_cnst(1)
     ia2= ia_cnst(2)

     r12= dsqrt(( cps(ia1,1) -cps(ia2,1) )**2  &
          &    +( cps(ia1,2) -cps(ia2,2) )**2  &
          &    +( cps(ia1,3) -cps(ia2,3) )**2 )
     gca(ia1,1:3) = ( cps(ia1,1:3) - cps(ia2,1:3))/r12
     gca(ia2,1:3) = - gca(ia1,1:3)
     return
  end if

  ! +++ bond length (2nd order) +++
  if(cnst_typ ==  BONDLENGTH_FIX_2) then
     ia1= ia_cnst(1)
     ia2= ia_cnst(2)

     gca(ia1,1:3) = 2.d0 * (cps(ia1,1:3) - cps(ia2,1:3))
     gca(ia2,1:3)= -gca(ia1,1:3)
     return
  end if

  ! +++ center-of-mass +++
  if(cnst_typ == COG_FIX_L) then

     tmass= 0.d0; rmass = 0.d0
     do m = 1, nfcatm
        tmass = tmass + amion(ityp(ia_cnst(m)))
     end do
     do ia = 1, natm
        if(imdtyp(ia) /= FIX) rmass = rmass + amion(ityp(ia))
     end do
     rmass = rmass - tmass

     do ia = 1, natm
        if(imdtyp(ia) /= FIX) then
           gca(ia,1:3) = - amion(ityp(ia))/rmass * sgmc(1:3)
        end if
     end do
     do m = 1, nfcatm
        ia = ia_cnst(m)
        gca(ia,1:3) = amion(ityp(ia))/tmass * sgmc(1:3)
     end do
     return
  end if

  print *,'!(forc_cnst) Undefined cnst_typ =', cnst_typ
  stop
end subroutine forc_cnst

subroutine copy_to_cpd_forc_and_forcp(katm,natm,cpd_l,forc_l,cpd,forc,forcp)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: copy_to_cpd_forc_and_forcp
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none

  integer, intent(in) :: katm,natm
  real(kind=DP),intent(in),dimension(katm,3) :: cpd_l,forc_l
  real(kind=DP),intent(out),dimension(katm,3):: cpd,forc,forcp

  integer :: ia
  cpd = 0.d0; forc = 0.d0
  do ia = 1, natm
     cpd(ia,1:3)   = cpd_l(ia,1:3)
     forc(ia,1:3)  = forc_l(ia,1:3)
     forcp(ia,1:3) = forc_l(ia,1:3)
  end do
  do ia = 1, natm
     print *,' cpd = ', cpd_l(ia,1),cpd_l(ia,2),cpd_l(ia,3)
  end do
end subroutine copy_to_cpd_forc_and_forcp

subroutine cnstrnt(natm,ityp,amion,cps,cnst_typ,nfcatm,ia_cnst,imdtyp &
     &, sgmc,sigma)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: cnstrnt
!
!  AUTHOR(S): T. Uchiyama,  T. Yamasaki   August/20/2003
!
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================


  use m_Const_Parameters, only : DP, FIX &
       & ,   BONDLENGTH_FIX_1, BONDLENGTH_FIX_2, COG_FIX_L
  implicit none
  integer, intent(in)      :: natm,ityp(natm),cnst_typ,nfcatm,ia_cnst(nfcatm)
  real(kind=DP),intent(in) :: amion(*),cps(natm,3),sgmc(4),imdtyp(natm)
  real(kind=DP),intent(out):: sigma

  integer       :: ia1,ia2,ia,j,m
  real(kind=DP) :: tmass, rmass, gmass

  ! +++ bond length (1st order) +++
  if(cnst_typ == BONDLENGTH_FIX_1) then

     ia1= ia_cnst(1)
     ia2= ia_cnst(2)
     sigma = dsqrt(( cps(ia1,1) -cps(ia2,1) )**2  &
          &       +( cps(ia1,2) -cps(ia2,2) )**2  &
          &       +( cps(ia1,3) -cps(ia2,3) )**2 ) -sgmc(1)
     return
  end if

  ! +++ bond length (2nd order) +++
  if(cnst_typ == BONDLENGTH_FIX_2) then
     ia1= ia_cnst(1)
     ia2= ia_cnst(2)
     sigma = ( cps(ia1,1) -cps(ia2,1) )**2  &
          & +( cps(ia1,2) -cps(ia2,2) )**2  &
          & +( cps(ia1,3) -cps(ia2,3) )**2 -sgmc(1)
     return
  end if

  ! +++ center-of-mass +++
  if(cnst_typ == COG_FIX_L) then
     tmass = 0.d0
     rmass = 0.d0
     do m= 1, nfcatm
        tmass = tmass + amion (ityp(ia_cnst(m)))
     end do
     do ia = 1, natm
        if(imdtyp(ia) /= FIX) rmass = rmass + amion(ityp(ia))
     end do
     rmass = rmass - tmass
     gmass = tmass*rmass /(tmass + rmass)
     sigma= 0.d0
     do ia = 1, natm
        if(imdtyp(ia) /= FIX) then
           do j = 1, 3
              sigma = sigma - amion(ityp(ia))/rmass * cps(ia,j)*sgmc(j)
           end do
        end if
     end do
     do m= 1, nfcatm
        ia= ia_cnst(m)
        do j = 1, 3
           sigma = sigma +amion(ityp(ia))/gmass *cps(ia,j)*sgmc(j)
        end do
     end do
     sigma = sigma -sgmc(4)
     return
  end if

  print *, '!(cnstrnt) Undefined cnst_typ=', cnst_typ
  stop
end subroutine cnstrnt

subroutine rplcps(cps,ityp,mode,natm2,natm,iwei)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: rplcps
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   August/20/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  implicit none
  integer      , intent(in)                        :: mode
  integer      , intent(in)                        :: natm2
  integer      , intent(in)                        :: natm
  integer      , intent(in)   , dimension(natm)    :: iwei
  real(kind=kind(1.d0)), intent(inout), dimension(natm2,3) :: cps
  integer,       intent(inout), dimension(natm2)   :: ityp
  
  integer nb, ia
  
  nb = 0
  do ia = 1, natm
     if(iwei(ia) ==  2) then
        nb = nb + 1
        cps(natm+nb,1) = -cps(ia,1)
        cps(natm+nb,2) = -cps(ia,2)
        cps(natm+nb,3) = -cps(ia,3)
        if(mode.eq.1) ityp(natm+nb) = ityp(ia)
     endif
  enddo
  
end subroutine rplcps

subroutine rbinuc(pos,natm)
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: rbinuc
!
!  AUTHOR(S): T. Uchiyama, T. Yamasaki   June/16/2003
!  
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)                  
!
!=======================================================================

  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) ::                             natm
  real(kind=DP), intent(inout), dimension(natm,3) :: pos

  integer :: i,j
  do j = 1, 3
     do i = 1, natm
        if(pos(i,j) < 0.d0) pos(i,j) = (ceiling(-pos(i,j))) + pos(i,j)
        if(pos(i,j) > 1.d0) pos(i,j) = pos(i,j) - floor(pos(i,j))
     end do
  end do
end subroutine rbinuc

subroutine change_of_coordinate_system(t,v,k,n,w)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: k, n
  real(kind=DP), intent(in),  dimension(3,3) :: t
  real(kind=DP), intent(in),  dimension(k,3) :: v
  real(kind=DP), intent(out), dimension(k,3) :: w
  integer i, j
  do j = 1, 3
     do i = 1, n
        w(i,j) = t(j,1)*v(i,1) + t(j,2)*v(i,2) + t(j,3)*v(i,3)
     enddo
  enddo
end subroutine change_of_coordinate_system

subroutine fd_symmetrize(natm2,katm,natm,napt,kopr,nopr,op,iwei &
     &, f_l, f_wk, npfatm)
! This subroutine is for symmetrization of atomic forces.
! Original subroutine 'forces' was parallelized using VPPfortran
! according with atoms. This will be parallelized using MPI.
! 
  use m_Const_Parameters, only : DP
  ! Revised according to an indication by Momita-san,
  !     T. Yamasaki (FUJITSU Laboratories ltd.), 2003/07/28 
  !      [ip = npfatm(ia)] -> [ ip = npfatm(iaa)]
  implicit none
  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
  integer, intent(in), dimension(katm,kopr)      :: napt
  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
  integer, intent(in), dimension(katm)           :: iwei
  real(kind=DP), intent(inout), dimension(natm,3):: f_l
  real(kind=DP), dimension(natm,3)               :: f_wk
  integer,       dimension(natm2)                :: npfatm

  integer        :: ia, iop, iaa, ip
  real(kind=DP)  :: f(3)

  f_wk = f_l
  f_l  = 0.d0
  call substitute_npfatm      ! --> npfatm
!xocl spread do/ind_katm
  do ia = 1, natm
     do iop = 1, nopr
!!$        iaa = napt(ia,iop); ip = npfatm(ia)
        iaa = napt(ia,iop); ip = npfatm(iaa)
        f = f_wk(ip,1:3)
        if(iaa > natm) f = -f
        f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op(1:3,1:3,iop)),f)
     end do
  end do
!xocl end spread
  f_l = f_l / nopr

contains
  subroutine substitute_npfatm
    integer :: nb, ia
    nb = 0
    do ia = 1, natm
       if(iwei(ia) == 2) then
          nb = nb + 1
          npfatm(natm+nb) = ia
       end if
       npfatm(ia) = ia
    end do
  end subroutine substitute_npfatm
end subroutine fd_symmetrize

!!$subroutine fd_symmetrize(natm2,katm,natm,napt,kopr,op,kopr2,nopr &
!!$     & ,iwei, f_l, f_wk, npfatm, iop_supercell)
!!$! This subroutine is for symmetrization of atomic forces.
!!$! Original subroutine 'forces' was parallelized using VPPfortran
!!$! according with atoms. This will be parallelized using MPI.
!!$! 
!!$  use m_Const_Parameters, only : DP
!!$  ! Revised according to an indication by Momita-san,
!!$  !     T. Yamasaki (FUJITSU Laboratories ltd.), 2003/07/28 
!!$  !      [ip = npfatm(ia)] -> [ ip = npfatm(iaa)]
!!$  implicit none
!!$  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr,kopr2
!!$  integer, intent(in), dimension(katm,kopr)      :: napt
!!$  real(kind=DP),intent(in),dimension(3,3,kopr2)  :: op
!!$  integer, intent(in), dimension(katm)           :: iwei
!!$  real(kind=DP), intent(inout), dimension(natm,3):: f_l
!!$  real(kind=DP), dimension(natm,3)               :: f_wk
!!$  integer,       dimension(natm2)                :: npfatm
!!$  integer, intent(in), optional, dimension(nopr) :: iop_supercell
!!$
!!$  integer        :: ia, iop, iaa, ip, iop_temp
!!$  real(kind=DP)  :: f(3)
!!$
!!$  f_wk = f_l
!!$  f_l  = 0.d0
!!$  call substitute_npfatm      ! --> npfatm
!!$!!$  write(6,*) ' -- ia, iop, iaa, ip --'
!!$  if(present(iop_supercell)) then
!!$!xocl spread do/ind_katm
!!$     do ia = 1, natm
!!$        do iop = 1, nopr
!!$           iaa = napt(ia,iop); ip = npfatm(iaa)
!!$           f = f_wk(ip,1:3)
!!$           if(iaa > natm) f = -f
!!$           iop_temp = iop_supercell(iop)
!!$           f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op(1:3,1:3,iop_temp)),f)
!!$        end do
!!$     end do
!!$!xocl end spread
!!$  else
!!$!xocl spread do/ind_katm
!!$     do ia = 1, natm
!!$        do iop = 1, nopr
!!$!!$        iaa = napt(ia,iop); ip = npfatm(ia)
!!$           iaa = napt(ia,iop); ip = npfatm(iaa)
!!$           f = f_wk(ip,1:3)
!!$           if(iaa > natm) f = -f
!!$           f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op(1:3,1:3,iop)),f)
!!$        end do
!!$     end do
!!$!xocl end spread
!!$  end if
!!$  f_l = f_l / nopr
!!$
!!$contains
!!$  subroutine substitute_npfatm
!!$    integer :: nb, ia
!!$    nb = 0
!!$    do ia = 1, natm
!!$       if(iwei(ia) == 2) then
!!$          nb = nb + 1
!!$          npfatm(natm+nb) = ia
!!$       end if
!!$       npfatm(ia) = ia
!!$    end do
!!$  end subroutine substitute_npfatm
!!$end subroutine fd_symmetrize

subroutine gnrt_supercell_symm_operations(natm2,katm,natm,napt,kopr,nopr,op &
     &  , koprpaf,tau,ngen_tl,tau_tl,napt_tl,lattice_system,mode &
     &  , dim2,  napt_supercell, iop_supercell, tau_supercell, nopr_supercell &
     &  , dim2e, nope_supercell, pope_supercell,iwei)
! ==== coded by T. Yamasaki after a provided code by Usami-san on Nov. 2013. April 2014 ===
! 
  use m_Const_Parameters,  only : DP, PAI2, DELTA10,DELTA07
  implicit none
  integer,parameter :: modeTAU = 1, modeAPT = 2
  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
  integer, intent(in), dimension(katm,kopr)      :: napt
  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
  integer, intent(in)                            :: koprpaf
  real(kind=DP),intent(in),dimension(3,koprpaf,2):: tau
  integer, intent(in)                            :: ngen_tl
  real(kind=DP),intent(in),dimension(3,ngen_tl,2):: tau_tl
  integer, intent(in), dimension(katm,ngen_tl)   :: napt_tl
  character(len=9), intent(in)                   :: lattice_system
  integer, intent(in)                            :: mode
  integer, intent(in)                            :: dim2
  integer, intent(out),dimension(katm,dim2)      :: napt_supercell
  integer, intent(out),dimension(dim2)           :: iop_supercell
  real(kind=DP),intent(out),dimension(3,dim2)    :: tau_supercell
  integer, intent(out)                           :: nopr_supercell
  integer, intent(in)                            :: dim2e
  integer, intent(out),dimension(kopr)           :: nope_supercell
  integer, intent(out),dimension(dim2e,kopr)     :: pope_supercell
  integer, intent(in), dimension(katm)           :: iwei
  
  integer        :: ia, iop, jop, ip

  integer,             allocatable, dimension(:,:)   :: iop_opxop   ! d(nopr:nopr)
  real(kind=DP), dimension(3,3) :: op_temp
  integer                       :: iop_temp, napt1_temp
  real(kind=DP), dimension(3)   :: tau_temp
  real(kind=DP) ::  delta
  integer :: i, j, nopr_local_temp
  logical :: isComplete

  integer,       dimension(natm2)                :: npfatm
  integer :: icount

  allocate(iop_opxop(nopr,nopr));
  do iop = 1, nopr
     do jop = 1, nopr
        op_temp = matmul(op(:,:,jop), op(:,:,iop))
        iop_opxop(iop,jop) = operatorExists_in_nop()
     end do
  end do

  nope_supercell = 0
  napt_supercell = 0

  ! COPY
  do iop = 1, nopr
     iop_supercell(iop) = iop
!-------------------
     napt_supercell(:,iop) = napt(:,iop)
     nope_supercell(iop) = 1
     pope_supercell(1,iop) = iop
     if(mode==modeTAU) tau_supercell(:, iop) = tau(:, iop, 2)
  end do

  if(ngen_tl >= 1) then
     OP_LOOP: do iop = 1, nopr
        delta = dabs(op(1,1,iop)-1.0d0) + dabs(op(2,1,iop)) +       dabs(op(3,1,iop)) &
             &+ dabs(op(1,2,iop)) +       dabs(op(2,2,iop)-1.0d0) + dabs(op(3,2,iop)) &
             &+ dabs(op(1,3,iop))       + dabs(op(2,3,iop)) +       dabs(op(3,3,iop)-1.0d0)
        if(delta < DELTA10) exit OP_LOOP
     end do OP_LOOP
     if(iop <= nopr) then
!!$        write(6,'(" # of A Unit operator = ",i8)') iop
     else
        stop ' no Unit operator <gnrt_supercell_symm_operations>'
     end if
     do i = 1, ngen_tl
        iop_supercell(nopr+i) = iop
        napt_supercell(:,nopr+i) = napt_tl(:,i)
        nope_supercell(iop) = nope_supercell(iop)+1
        pope_supercell(1+i,iop) = nopr+i
        if(mode==modeTAU) tau_supercell(:,nopr+i) = tau_tl(:,i,2)
     end do
  end if
     
  nopr_supercell = nopr + ngen_tl
  call substitute_npfatm()
  icount = 0
  EXTEND: do 
     if (nopr_supercell > natm*nopr) then
        write(6,*) 'WARNING: Force symmetrization might be a failure.'
        nopr_supercell = nopr
        exit EXTEND
     end if
     icount = icount+1
!     if(mype==0) write(0,*) 'nopr_sup, icount ',nopr_supercell,icount
     ! MAKE TABLES (REDUNDANT SPACE-GROUP)
     isComplete = .true.
     nopr_local_temp = nopr_supercell

     do iop = 1, nopr_local_temp
!        if(mype==0) write(0,*) 'iop, nopr_local_temp',iop,nopr_local_temp
        do jop = 1, nopr_local_temp
           iop_temp = iop_opxop(iop_supercell(iop),iop_supercell(jop))

           if(mode==modeTAU) then
              tau_temp = matmul(op(1:3,1:3,iop_supercell(jop)),tau_supercell(1:3,iop))+tau_supercell(1:3,jop)
              if (lattice_system .eq. 'hexagonal') then
                 ! y-axis, hexagonal only
                 tau_temp(2) = mod(tau_temp(2)+sqrt(3.0d0), sqrt(0.75d0))
              else
                 tau_temp = tau_temp - floor(tau_temp)
              end if
              if(tau_temp(1) > 1.0d0 - DELTA07) tau_temp(1) = 0.d0
              if(tau_temp(2) > 1.0d0 - DELTA07) tau_temp(2) = 0.d0
              if(tau_temp(3) > 1.0d0 - DELTA07) tau_temp(3) = 0.d0
           else if(mode== modeAPT)then
              if(napt_supercell(1,iop)>0) &
              &  napt1_temp = npfatm(napt_supercell(npfatm(napt_supercell(1,iop)),jop))
           end if
           
           if (.not. operatorExists()) then
              nopr_supercell = nopr_supercell + 1
              nope_supercell(iop_temp) = nope_supercell(iop_temp) + 1
              pope_supercell(nope_supercell(iop_temp),iop_temp) = nopr_supercell
              if (nopr_supercell > dim2) cycle EXTEND
              iop_supercell(nopr_supercell) = iop_temp
              if(mode==modeTAU) then
                 tau_supercell(1:3,     nopr_supercell) = tau_temp(1:3)
              else if(mode==modeAPT) then
                 do i = 1, natm
                    if(napt_supercell(i,iop)>0)            &
                    &  napt_supercell(i, nopr_supercell) = &
                    &  npfatm(napt_supercell(npfatm(napt_supercell(i, iop)), jop))
                 end do
              end if
              isComplete = .false.
           end if
        end do
     end do
     if (isComplete) exit EXTEND
  end do EXTEND

  deallocate(iop_opxop)
!!$  mnope_supercell = maxval(nope_supercell(1:nopr))

contains
  subroutine substitute_npfatm()
    integer :: nb, ia
    nb = 0
    do ia = 1, natm
       if(iwei(ia) == 2) then
          nb = nb + 1
          npfatm(natm+nb) = ia
       end if
       npfatm(ia) = ia
    end do
  end subroutine substitute_npfatm

  integer function operatorExists_in_nop()
    real(kind=DP) :: delta
    integer :: nope
    real(kind=DP), dimension(3,3) :: opd

    do nope = 1, nopr
       opd = op_temp - op(:,:,nope)
       delta = opd(1,1)*opd(1,1) + opd(1,2)*opd(1,2) + opd(1,3)*opd(1,3) &
            &+ opd(2,1)*opd(2,1) + opd(2,2)*opd(2,2) + opd(2,3)*opd(2,3) &
            &+ opd(3,1)*opd(3,1) + opd(3,2)*opd(3,2) + opd(3,3)*opd(3,3)
       if(delta < 1.0d-3) then
          operatorExists_in_nop = nope
          return
       end if
    end do
    operatorExists_in_nop = -1
    if(operatorExists_in_nop == -1) then
       write(6,'(" iop, jop = ",2i8)') iop,jop
       write(6,'(" !Illegal value of iop_opxop(iop,jop) = ",i8)') iop_opxop(iop,jop)
       call flush(6)
       stop '!Illegal value of iop_opxop(iop,jop)'
    end if
  end function operatorExists_in_nop
!-----------------------------------------------------------------------------------

  logical function operatorExists()
    ! return .true. if the operator (op_temp, tau_temp) is found in the operator list op_local.
    real(kind=DP) :: delta
    real(kind=DP), dimension(3) :: temp_a, temp
    integer :: nope, nopei

    do nopei = 1, nope_supercell(iop_temp)
       nope = pope_supercell(nopei,iop_temp)
       if(mode == modeTAU) then
          temp_a(:) = tau_supercell(:,nope) - tau_temp(:)
          temp(1:3) = temp_a(1:3) - floor(temp_a(1:3))
          if(temp(1) > 1.0d0 - DELTA07) temp(1) = 0.d0
          if(temp(2) > 1.0d0 - DELTA07) temp(2) = 0.d0
          if(temp(3) > 1.0d0 - DELTA07) temp(3) = 0.d0
          delta = temp(1)*temp(1) + temp(2)*temp(2) + temp(3)*temp(3)

          if (delta < 1.0d-3) then
             operatorExists = .true.  ! found
             return
          end if
       else if(mode == modeAPT) then
          if(npfatm(napt_supercell(1,nope)) == napt1_temp) then
             operatorExists = .true. ! found
             return
          end if
       end if
    end do
    operatorExists = .false.  ! not found
    return
  end function operatorExists
!-----------------------------------------------------------------------------------
end subroutine gnrt_supercell_symm_operations

subroutine gnrt_supercell_symm_operations_apt(natm2,katm,natm,napt,kopr,nopr,op &
     &  , koprpaf,tau,ngen_tl,tau_tl,napt_tl,lattice_system,mode &
     &  , dim2,  napt_supercell, iop_supercell,  nopr_supercell &
     &  , dim2e, iwei)
! ==== coded by T. Yamasaki after a provided code by Usami-san on Nov. 2013. April 2014 ===
! 
  use m_Const_Parameters,  only : DP, PAI2, DELTA10,DELTA07
  use m_Parallelization,   only : mype
  implicit none
  integer,parameter :: modeTAU = 1, modeAPT = 2
  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
  integer, intent(in), dimension(katm,kopr)      :: napt
  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
  integer, intent(in)                            :: koprpaf
  real(kind=DP),intent(in),dimension(3,koprpaf,2):: tau
  integer, intent(in)                            :: ngen_tl
  real(kind=DP),intent(in),dimension(3,ngen_tl,2):: tau_tl
  integer, intent(in), dimension(katm,ngen_tl)   :: napt_tl
  character(len=9), intent(in)                   :: lattice_system
  integer, intent(in)                            :: mode
  integer, intent(in)                            :: dim2
  integer, intent(out),dimension(katm,dim2)      :: napt_supercell
  integer, intent(out),dimension(dim2)           :: iop_supercell
  integer, intent(out)                           :: nopr_supercell
  integer, intent(in)                            :: dim2e
!  integer, intent(out),dimension(kopr)           :: nope_supercell
!  integer, intent(out),dimension(dim2e,kopr)     :: pope_supercell
  integer, intent(in), dimension(katm)           :: iwei

  integer, allocatable, dimension(:)             :: nope_supercell
  integer, allocatable, dimension(:,:)           :: pope_supercell
  
  integer        :: ia, iop, jop, ip

  integer,             allocatable, dimension(:,:)   :: iop_opxop   ! d(nopr:nopr)
  real(kind=DP), dimension(3,3) :: op_temp
  integer                       :: iop_temp, napt1_temp
  real(kind=DP), dimension(3)   :: tau_temp
  real(kind=DP) ::  delta
  integer :: i, j, nopr_local_temp
  logical :: isComplete

  integer,       dimension(natm2)                :: npfatm
  integer :: icount
  allocate(nope_supercell(kopr))
  allocate(pope_supercell(dim2e,kopr))
  allocate(iop_opxop(nopr,nopr));
  do iop = 1, nopr
     do jop = 1, nopr
        op_temp = matmul(op(:,:,jop), op(:,:,iop))
        iop_opxop(iop,jop) = operatorExists_in_nop()
     end do
  end do

  nope_supercell = 0
  napt_supercell = 0

  ! COPY
  do iop = 1, nopr
     iop_supercell(iop) = iop
!-------------------
     napt_supercell(:,iop) = napt(:,iop)
     nope_supercell(iop) = 1
     pope_supercell(1,iop) = iop
  end do

  if(ngen_tl >= 1) then
     OP_LOOP: do iop = 1, nopr
        delta = dabs(op(1,1,iop)-1.0d0) + dabs(op(2,1,iop)) +       dabs(op(3,1,iop)) &
             &+ dabs(op(1,2,iop)) +       dabs(op(2,2,iop)-1.0d0) + dabs(op(3,2,iop)) &
             &+ dabs(op(1,3,iop))       + dabs(op(2,3,iop)) +       dabs(op(3,3,iop)-1.0d0)
        if(delta < DELTA10) exit OP_LOOP
     end do OP_LOOP
     if(iop <= nopr) then
!!$        write(6,'(" # of A Unit operator = ",i8)') iop
     else
        stop ' no Unit operator <gnrt_supercell_symm_operations>'
     end if
     do i = 1, ngen_tl
        iop_supercell(nopr+i) = iop
        napt_supercell(:,nopr+i) = napt_tl(:,i)
        nope_supercell(iop) = nope_supercell(iop)+1
        pope_supercell(1+i,iop) = nopr+i
     end do
  end if
     
  nopr_supercell = nopr + ngen_tl
  call substitute_npfatm()
  icount = 0
  EXTEND: do 
     if (nopr_supercell > natm*nopr) then
        write(6,*) 'WARNING: Force symmetrization might be a failure.'
        nopr_supercell = nopr
        exit EXTEND
     end if
     icount = icount+1
     isComplete = .true.
     nopr_local_temp = nopr_supercell

     do iop = 1, nopr_local_temp
        !if(mype==0) write(0,*) 'iop, nopr_local_temp',iop,nopr_local_temp
        do jop = 1, nopr_local_temp
           iop_temp = iop_opxop(iop_supercell(iop),iop_supercell(jop))
           if(napt_supercell(1,iop)>0) &
           &  napt1_temp = npfatm(napt_supercell(npfatm(napt_supercell(1,iop)),jop))
           
           if (.not. operatorExists(kopr,iop_temp,napt1_temp,dim2e, &
                     natm2,npfatm,nope_supercell,pope_supercell)) then
              nopr_supercell = nopr_supercell + 1
              nope_supercell(iop_temp) = nope_supercell(iop_temp) + 1
              pope_supercell(nope_supercell(iop_temp),iop_temp) = nopr_supercell
              if (nopr_supercell > dim2) cycle EXTEND
              iop_supercell(nopr_supercell) = iop_temp
              do i = 1, natm
                 if(napt_supercell(i,iop)>0)            &
                 &  napt_supercell(i, nopr_supercell) = &
                 &  npfatm(napt_supercell(npfatm(napt_supercell(i, iop)), jop))
              end do
              isComplete = .false.
           end if
        end do
     end do
     if (isComplete) exit EXTEND
  end do EXTEND

  deallocate(iop_opxop)
  deallocate(nope_supercell)
  deallocate(pope_supercell)
!!$  mnope_supercell = maxval(nope_supercell(1:nopr))

contains
  subroutine substitute_npfatm()
    integer :: nb, ia
    nb = 0
    do ia = 1, natm
       if(iwei(ia) == 2) then
          nb = nb + 1
          npfatm(natm+nb) = ia
       end if
       npfatm(ia) = ia
    end do
  end subroutine substitute_npfatm

  integer function operatorExists_in_nop()
    real(kind=DP) :: delta
    integer :: nope
    real(kind=DP), dimension(3,3) :: opd

    do nope = 1, nopr
       opd = op_temp - op(:,:,nope)
       delta = opd(1,1)*opd(1,1) + opd(1,2)*opd(1,2) + opd(1,3)*opd(1,3) &
            &+ opd(2,1)*opd(2,1) + opd(2,2)*opd(2,2) + opd(2,3)*opd(2,3) &
            &+ opd(3,1)*opd(3,1) + opd(3,2)*opd(3,2) + opd(3,3)*opd(3,3)
       if(delta < 1.0d-3) then
          operatorExists_in_nop = nope
          return
       end if
    end do
    operatorExists_in_nop = -1
    if(operatorExists_in_nop == -1) then
       write(6,'(" iop, jop = ",2i8)') iop,jop
       write(6,'(" !Illegal value of iop_opxop(iop,jop) = ",i8)') iop_opxop(iop,jop)
       call flush(6)
       stop '!Illegal value of iop_opxop(iop,jop)'
    end if
  end function operatorExists_in_nop
!-----------------------------------------------------------------------------------

  logical function operatorExists(kopr,iop_temp,napt1_temp,dim2e,natm2,npfatm,nope_supercell,pope_supercell)
    ! return .true. if the operator (op_temp, tau_temp) is found in the operator list op_local.
    integer, intent(in):: kopr,iop_temp,napt1_temp,dim2e,natm2
    integer, intent(in), dimension(natm2) :: npfatm
    integer, intent(in), dimension(kopr)  :: nope_supercell
    integer, intent(in), dimension(dim2e,kopr) :: pope_supercell
    real(kind=DP) :: delta
    real(kind=DP), dimension(3) :: temp_a, temp
    integer :: nope, nopei

    do nopei = 1, nope_supercell(iop_temp)
       nope = pope_supercell(nopei,iop_temp)
       if(npfatm(napt_supercell(1,nope)) == napt1_temp) then
          operatorExists = .true. ! found
          return
       end if
    end do
    operatorExists = .false.  ! not found
    return
  end function operatorExists
!-----------------------------------------------------------------------------------
end subroutine gnrt_supercell_symm_operations_apt


subroutine fd_supercell_symmetrize(natm2,katm,natm,napt,nopr,op,kopr,iwei &
     & , f_l, f_wk, npfatm, iop_supercell)
!
! ===  Changed from the subroutine fd_symmetrize by T. Yamasaki after a provided code ===
! === by Usami-san on Nov. 2013.                                        April 2014    ===
!
! This subroutine is for symmetrization of atomic forces.
! Original subroutine 'forces' was parallelized using VPPfortran
! according with atoms. This will be parallelized using MPI.
! 
  use m_Const_Parameters,  only : DP, PAI2, DELTA10,DELTA07

  implicit none
  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
  integer, intent(in), dimension(katm,nopr) :: napt
  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
  integer, intent(in), dimension(katm)           :: iwei
  real(kind=DP), intent(inout), dimension(natm,3):: f_l
  real(kind=DP), dimension(natm,3)               :: f_wk
  integer,       dimension(natm2)                :: npfatm
  integer, intent(in), dimension(nopr) :: iop_supercell

  integer        :: ia, iop, iaa, ip, iop_temp
  real(kind=DP)  :: f(3)

  f_wk = f_l
  f_l  = 0.d0
  call substitute_npfatm      ! --> npfatm
!xocl spread do/ind_katm
  do ia = 1, natm
     do iop = 1, nopr
        iaa = napt(ia,iop); ip = npfatm(iaa)
        f = f_wk(ip,1:3)
        if(iaa > natm) f = -f
        iop_temp = iop_supercell(iop)
        f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op(1:3,1:3,iop_temp)),f)
     end do
  end do
!xocl end spread
  f_l = f_l / nopr
contains
  subroutine substitute_npfatm
    integer :: nb, ia
    nb = 0
    do ia = 1, natm
       if(iwei(ia) == 2) then
          nb = nb + 1
          npfatm(natm+nb) = ia
       end if
       npfatm(ia) = ia
    end do
  end subroutine substitute_npfatm
end subroutine fd_supercell_symmetrize

!!$subroutine fd_symmetrize_sc(natm2,katm,natm,napt,kopr,nopr,op,iwei &
!!$     &, f_l, f_wk, npfatm)
!!$! This subroutine is for symmetrization of atomic forces.
!!$! Original subroutine 'forces' was parallelized using VPPfortran
!!$! according with atoms. This will be parallelized using MPI.
!!$! 
!!$  use m_Const_Parameters,  only : DP, PAI2, DELTA10,DELTA07
!!$  ! Revised according to an indication by Momita-san,
!!$  !     T. Yamasaki (FUJITSU Laboratories ltd.), 2003/07/28 
!!$  !      [ip = npfatm(ia)] -> [ ip = npfatm(iaa)]
!!$  implicit none
!!$  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
!!$  integer, intent(in), dimension(katm,kopr)      :: napt
!!$  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
!!$  integer, intent(in), dimension(katm)           :: iwei
!!$  real(kind=DP), intent(inout), dimension(natm,3):: f_l
!!$  real(kind=DP), dimension(natm,3)               :: f_wk
!!$  integer,       dimension(natm2)                :: npfatm
!!$
!!$  integer        :: ia, iop, jop, iaa, ip
!!$  real(kind=DP)  :: f(3)
!!$
!!$  integer,       save, allocatable, dimension(:,:)   :: napt_local  ! d(natm,nopr_local)
!!$  integer,       save, allocatable, dimension(:)     :: iop_local   ! d(nopr_local)
!!$  integer,       save                                :: nopr_local
!!$  integer,             allocatable, dimension(:,:)   :: pope_local  ! d(:,nopr)
!!$  integer,             allocatable, dimension(:)     :: nope_local  ! d(nopr)
!!$  integer,             allocatable, dimension(:,:)   :: iop_opxop   ! d(nopr:nopr)
!!$  !
!!$  real(kind=DP), dimension(3,3) :: op_temp
!!$  integer                       :: iop_temp, napt1_temp
!!$  integer :: i, j, nopr_local_temp, dim_redundancy
!!$  logical :: isComplete, isInitialized = .false.
!!$  logical :: DEBUG_WRITE = .true.
!!$
!!$  if(.not.isInitialized) then
!!$     allocate(iop_opxop(nopr,nopr));
!!$     do iop = 1, nopr
!!$        do jop = 1, nopr
!!$           op_temp = matmul(op(:,:,jop), op(:,:,iop))
!!$           iop_opxop(iop,jop) = operatorExists_in_nop()
!!$        end do
!!$     end do
!!$  end if
!!$
!!$  if(.not.isInitialized) then
!!$     dim_redundancy = natm*nopr
!!$     allocate( napt_local(natm, dim_redundancy))
!!$     allocate( iop_local(dim_redundancy), pope_local(dim_redundancy/nopr,nopr))
!!$     allocate( nope_local(nopr)); nope_local = 0
!!$
!!$     ! COPY
!!$     do iop = 1, nopr
!!$        iop_local(iop) = iop
!!$!-------------------
!!$        napt_local(:,iop) = napt(:,iop)
!!$        nope_local(iop) = 1
!!$        pope_local(1,iop) = iop
!!$     end do
!!$     nopr_local = nopr
!!$
!!$     EXTEND: do 
!!$        if (dim_redundancy > natm*nopr) then
!!$           write(6,*) 'WARNING: Force symmetrization might be a failure.'
!!$           nopr_local = nopr
!!$           exit EXTEND
!!$        end if
!!$
!!$     ! MAKE TABLES (REDUNDANT SPACE-GROUP)
!!$        isComplete = .true.
!!$        nopr_local_temp = nopr_local
!!$        do iop = 1, nopr_local_temp
!!$           do jop = 1, nopr_local_temp
!!$              iop_temp = iop_opxop(iop_local(iop),iop_local(jop))
!!$              napt1_temp = napt_local(napt_local(1,iop),jop)
!!$              if (.not. operatorExists_nap()) then
!!$                 nopr_local = nopr_local + 1
!!$                 nope_local(iop_temp) = nope_local(iop_temp) + 1
!!$                 pope_local(nope_local(iop_temp),iop_temp) = nopr_local
!!$                 if (nopr_local > dim_redundancy) cycle EXTEND
!!$                 iop_local(nopr_local) = iop_temp
!!$                 do i = 1, natm
!!$                    napt_local(i, nopr_local) = napt_local( napt_local(i, iop), jop)
!!$                 end do
!!$                 isComplete = .false.
!!$              end if
!!$           end do
!!$        end do
!!$        if (isComplete) exit EXTEND
!!$     end do EXTEND
!!$
!!$     If(dim_redundancy > nopr_local) call reduce_napt_iop_arraysize()
!!$
!!$     if(DEBUG_WRITE) call wd_nopr_local_etc()
!!$
!!$     deallocate(iop_opxop)
!!$     deallocate(nope_local)
!!$     deallocate(pope_local)
!!$  end if
!!$
!!$  isInitialized = .true.
!!$
!!$  f_wk = f_l
!!$  f_l  = 0.d0
!!$  call substitute_npfatm      ! --> npfatm
!!$!xocl spread do/ind_katm
!!$  do ia = 1, natm
!!$     do iop = 1, nopr_local
!!$!!!!$        iaa = napt(ia,iop); ip = npfatm(ia)
!!$        iaa = napt_local(ia,iop); ip = npfatm(iaa)
!!$        f = f_wk(ip,1:3)
!!$        if(iaa > natm) f = -f
!!$        iop_temp = iop_local(iop)
!!$        f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op(1:3,1:3,iop_temp)),f)
!!$     end do
!!$  end do
!!$!xocl end spread
!!$  f_l = f_l / nopr_local
!!$contains
!!$  subroutine wd_nopr_local_etc()
!!$    integer :: iop, i, ic, j, k
!!$!!!!$     if(nopr_local > nopr) then
!!$    write(6,*) ' --- Symmetry Operations (CARTS, PUCV) ---'
!!$    write(6,'(" !! nopr+af = ",i8)') nopr_local
!!$    do iop = 1, nopr
!!$       write(6,'(" #symmetry op. = ",i8)')  iop
!!$       do i = 1, 3
!!$          write(6,'(3f8.4)') (op(i,k,iop),k=1,3)
!!$       end do
!!$       ic = 0
!!$       do j = 1, nopr_local
!!$          if(iop_local(j) == iop) then
!!$             ic = ic+1
!!$             write(6,'(i3,2x,i6,2x,9f5.1)') ic,j,((op(k,i,iop),i=1,3),k=1,3)
!!$          end if
!!$       end do
!!$       write(6,'(" # operation",i3," = ",i8)') iop,ic
!!$    end do
!!$  end subroutine wd_nopr_local_etc
!!$
!!$  subroutine reduce_napt_iop_arraysize()
!!$    integer, allocatable, dimension(:,:) :: napt_temp
!!$    integer, allocatable, dimension(:)   :: iop_temp
!!$    integer :: iatm, iop
!!$    allocate(napt_temp(natm,nopr_local))
!!$    allocate(iop_temp(nopr_local))
!!$
!!$    do iop = 1, nopr_local
!!$       iop_temp(iop) = iop_local(iop)
!!$       do ia = 1, natm
!!$          napt_temp(ia,iop) = napt_local(ia,iop)
!!$       end do
!!$    end do
!!$
!!$    deallocate(napt_local, iop_local)
!!$
!!$    allocate(napt_local(natm,nopr_local))
!!$    allocate(iop_local(nopr_local))
!!$
!!$    iop_local = iop_temp
!!$    napt_local = napt_temp
!!$
!!$    deallocate(napt_temp, iop_temp)
!!$
!!$    write(6,'(" ! napt_local and iop_local have been reduced")')
!!$    write(6,'(" ! dim_redundancy = ", i8)') dim_redundancy
!!$    write(6,'(" ! nopr_local     = ", i8)') nopr_local
!!$  end subroutine reduce_napt_iop_arraysize
!!$
!!$  subroutine substitute_npfatm
!!$    integer :: nb, ia
!!$    nb = 0
!!$    do ia = 1, natm
!!$       if(iwei(ia) == 2) then
!!$          nb = nb + 1
!!$          npfatm(natm+nb) = ia
!!$       end if
!!$       npfatm(ia) = ia
!!$    end do
!!$  end subroutine substitute_npfatm
!!$!-----------------------------------------------------------------------------------
!!$  integer function operatorExists_in_nop()
!!$    real(kind=DP) :: delta
!!$    integer :: nope
!!$    real(kind=DP), dimension(3,3) :: opd
!!$
!!$    do nope = 1, nopr
!!$       opd = op_temp - op(:,:,nope)
!!$       delta = opd(1,1)*opd(1,1) + opd(1,2)*opd(1,2) + opd(1,3)*opd(1,3) &
!!$            &+ opd(2,1)*opd(2,1) + opd(2,2)*opd(2,2) + opd(2,3)*opd(2,3) &
!!$            &+ opd(3,1)*opd(3,1) + opd(3,2)*opd(3,2) + opd(3,3)*opd(3,3)
!!$       if(delta < 1.0d-3) then
!!$          operatorExists_in_nop = nope
!!$          return
!!$       end if
!!$    end do
!!$    operatorExists_in_nop = -1
!!$    if(operatorExists_in_nop == -1) then
!!$       write(6,'(" iop, jop = ",2i8)') iop,jop
!!$       write(6,'(" !Illegal value of iop_opxop(iop,jop) = ",i8)') iop_opxop(iop,jop)
!!$       call flush(6)
!!$       stop '!Illegal value of iop_opxop(iop,jop)'
!!$    end if
!!$  end function operatorExists_in_nop
!!$!-----------------------------------------------------------------------------------
!!$  logical function operatorExists_nap()
!!$    ! return .true. if the operator (op_temp, napt1_temp) is found in the operator list op_local.
!!$    real(kind=DP) :: delta ,temp
!!$    integer       :: nope, nopei
!!$
!!$    do nopei = 1, nope_local(iop_temp)
!!$       nope = pope_local(nopei,iop_temp)
!!$       if(napt_local(1,nope) == napt1_temp) then
!!$          operatorExists_nap = .true. ! found
!!$          return
!!$       end if
!!$    end do
!!$    operatorExists_nap = .false.  ! not found
!!$    return
!!$
!!$  end function operatorExists_nap
!!$!-----------------------------------------------------------------------------------
!!$end subroutine fd_symmetrize_sc
!!$
!!$subroutine fd_symmetrize_sc2(natm2,katm,natm,napt,kopr,nopr,op,iwei &
!!$     &, f_l, f_wk, npfatm)

!!$! Original subroutine 'forces' was parallelized using VPPfortran
!!$! according with atoms. This will be parallelized using MPI.
!!$! 
!!$  use m_Const_Parameters,  only : DP, PAI2
!!$  use m_Crystal_Structure, only : tau, b2pmat, rltv
!!$  use m_CS_SpaceGroup,     only : lattice_system
!!$  ! Revised according to an indication by Momita-san,
!!$  !     T. Yamasaki (FUJITSU Laboratories ltd.), 2003/07/28 
!!$  !      [ip = npfatm(ia)] -> [ ip = npfatm(iaa)]
!!$  implicit none
!!$  integer, intent(in)                            :: natm2,katm,natm,kopr,nopr
!!$  integer, intent(in), dimension(katm,kopr)      :: napt
!!$  real(kind=DP),intent(in),dimension(3,3,kopr)   :: op
!!$  integer, intent(in), dimension(katm)           :: iwei
!!$  real(kind=DP), intent(inout), dimension(natm,3):: f_l
!!$  real(kind=DP), dimension(natm,3)               :: f_wk
!!$  integer,       dimension(natm2)                :: npfatm
!!$
!!$  integer        :: ia, iop, jop, iaa, ip
!!$  real(kind=DP)  :: f(3)
!!$
!!$  real(kind=DP), save, allocatable, dimension(:,:,:) :: op_local
!!$  real(kind=DP), save, allocatable, dimension(:,:)   :: tau_local  ! (=ta1) d(3,nopr), nonprimitive translation vector (A system)
!!$  integer,       save, allocatable, dimension(:,:)   :: napt_local
!!$  integer,       save, allocatable, dimension(:)     :: iop_local
!!$  integer,       save                                :: nopr_local
!!$  !
!!$  real(kind=DP), dimension(3,3) :: op_temp, matrix_temp
!!$  integer                       :: iop_temp
!!$  real(kind=DP), dimension(3)   :: tau_temp
!!$  integer :: i, nopr_local_temp, dim_redundancy, j,k, ic
!!$  logical :: isComplete, isInitialized = .false.
!!$
!!$!  call fd_symmetrize(natm2,katm,natm,napt,kopr,nopr,op,iwei &
!!$!     &, f_l, f_wk, npfatm)
!!$!  return
!!$
!!$  dim_redundancy = -52  ! -52 + 100 = 48
!!$
!!$  EXTEND: do 
!!$     if (isInitialized) exit EXTEND
!!$
!!$     if (dim_redundancy > 32000) then
!!$        write(6,*) 'WARNING: Force symmetrization might be a failure.'
!!$        nopr_local = nopr
!!$        exit EXTEND
!!$     else if (dim_redundancy > 0) then
!!$        deallocate(op_local, tau_local, napt_local,iop_local)  ! not the first-time
!!$     end if
!!$     if (dim_redundancy < 600) then
!!$        dim_redundancy = dim_redundancy + 100
!!$     else
!!$        dim_redundancy = dim_redundancy * 2
!!$     end if
!!$     write(6,'(" dim_redundancy = ",i10)') dim_redundancy
!!$     call flush(6)
!!$     allocate( op_local(3, 3, dim_redundancy), tau_local(3, dim_redundancy), napt_local(natm, dim_redundancy),iop_local(dim_redundancy) )
!!$
!!$     matrix_temp(:,:) = matmul(transpose(b2pmat(:,:)), rltv(:,:)) / PAI2
!!$     ! COPY
!!$     do iop = 1, nopr
!!$!  --- by T. Y. 2014/04/04
!!$        op_local(1:3, 1:3, iop) = transpose(op(1:3, 1:3, iop))
!!$!!        op_local(1:3, 1:3, iop) = op(1:3, 1:3, iop)
!!$!  ---
!!$        iop_local(iop) = iop
!!$!-------------------
!!$        tau_local(:, iop) = matmul(transpose(matrix_temp(:,:)), tau(:, iop,1))
!!$        if (lattice_system .eq. 'hexagonal') then
!!$           tau_local(1,iop) = tau_local(1,iop) - 0.5d0 * tau_local(2,iop)
!!$           tau_local(1,iop) = mod(tau_local(1,iop)+1.0d0, 1.0d0)
!!$           tau_local(2,iop) = sqrt(0.75d0) * tau_local(2,iop)
!!$           tau_local(2,iop) = mod(tau_local(2,iop)+sqrt(3.0d0), sqrt(0.75d0))
!!$        end if
!!$!-------------------
!!$        do i = 1, natm
!!$           napt_local(i, iop) = napt(i, iop)
!!$        end do
!!$     end do
!!$     nopr_local = nopr
!!$
!!$     ! MAKE TABLES (REDUNDANT SPACE-GROUP)
!!$     j = 0
!!$     do
!!$        j = j+1
!!$        isComplete = .true.
!!$        nopr_local_temp = nopr_local
!!$        write(6,'(" j = ",i8)') j
!!$        call flush(6)
!!$        if(j >=10) then
!!$           if(j >= 3200000) then
!!$              stop
!!$           end if
!!$        end if
!!$        write(6,'(" nopr_local_temp = ",i8)') nopr_local_temp
!!$        call flush(6)
!!$        do iop = 1, nopr_local_temp
!!$           do jop = 1, nopr_local_temp
!!$              op_temp = matmul(transpose(op_local(:,:,jop)), transpose(op_local(:,:,iop)))
!!$              op_temp = transpose(op_temp)
!!$              iop_temp = operatorExists_in_nop()
!!$              tau_temp = matmul(transpose(op_local(1:3, 1:3, jop)), tau_local(1:3, iop)) + tau_local(1:3, jop)
!!$              do i = 1, 3
!!$                 ! normalize
!!$                 if (lattice_system .eq. 'hexagonal' .and. i .eq. 2) then
!!$                    ! y-axis, hexagonal only
!!$                    tau_temp(i) = mod(tau_temp(i)+sqrt(3.0d0), sqrt(0.75d0))
!!$                 else
!!$                    tau_temp(i) = mod(tau_temp(i)+2.0d0, 1.0d0)
!!$                 end if
!!$                 if (tau_temp(i) > 0.9999999d0) tau_temp(i) = 0.0d0
!!$              end do
!!$              if (.not. operatorExists()) then
!!$                 nopr_local = nopr_local + 1
!!$                 if (nopr_local > dim_redundancy) then
!!$                    write(6,'(" nopr_local > dim_redundancy : nopr_local = ",i8, " dim_redundancy = ",i8)') nopr_local, dim_redundancy
!!$                    call flush(6)
!!$                    cycle EXTEND
!!$                 end if
!!$                 op_local(1:3, 1:3, nopr_local) = op_temp(1:3, 1:3)
!!$                 iop_local(nopr_local) = iop_temp
!!$                 tau_local(1:3,     nopr_local) = tau_temp(1:3)
!!$                 do i = 1, natm
!!$                    napt_local(i, nopr_local) = napt_local( napt_local(i, iop), jop)
!!$                 end do
!!$                 isComplete = .false.
!!$              end if
!!$           end do
!!$        end do
!!$        if (isComplete) exit EXTEND
!!$     end do
!!$  end do EXTEND
!!$  isInitialized = .true.
!!$
!!$  if(nopr_local > nopr) then
!!$     write(6,*) ' --- Symmetry Operations (CARTS, PUCV) ---'
!!$     write(6,'(" !! nopr+af = ",i8)') nopr_local
!!$     do iop = 1, nopr
!!$        write(6,'(" #symmetry op. = ",i8)')  iop
!!$        do i = 1, 3
!!$           write(6,'(3f8.4)') (op(i,k,iop),k=1,3)
!!$        end do
!!$        ic = 0
!!$        do j = 1, nopr_local
!!$           if(iop_local(j) == iop) then
!!$              ic = ic+1
!!$              write(6,'(i3,2x,i5,2x,3f16.12,2x,9f6.2)') ic,j,tau_local(1:3,j),((op_local(k,i,j),i=1,3),k=1,3)
!!$           end if
!!$        end do
!!$        write(6,'(" # operation",i3," = ",i8)') iop,ic
!!$     end do
!!$  end if
!!$
!!$  write(6,'(" nopr_local = ",i8," (fd_symmetrize_sc)")') nopr_local
!!$  call flush(6)
!!$  f_wk = f_l
!!$  f_l  = 0.d0
!!$  call substitute_npfatm      ! --> npfatm
!!$!xocl spread do/ind_katm
!!$  do ia = 1, natm
!!$     do iop = 1, nopr_local
!!$!!!$        iaa = napt(ia,iop); ip = npfatm(ia)
!!$        iaa = napt_local(ia,iop); ip = npfatm(iaa)
!!$        f = f_wk(ip,1:3)
!!$        if(iaa > natm) f = -f
!!$!!!$        f_l(ia,1:3) = f_l(ia,1:3) + matmul(transpose(op_local(1:3,1:3,iop)),f)
!!$        f_l(ia,1:3) = f_l(ia,1:3) + matmul(op_local(1:3,1:3,iop) ,f)
!!$     end do
!!$  end do
!!$!xocl end spread
!!$  f_l = f_l / nopr_local
!!$contains
!!$  subroutine substitute_npfatm
!!$    integer :: nb, ia
!!$    nb = 0
!!$    do ia = 1, natm
!!$       if(iwei(ia) == 2) then
!!$          nb = nb + 1
!!$          npfatm(natm+nb) = ia
!!$       end if
!!$       npfatm(ia) = ia
!!$    end do
!!$  end subroutine substitute_npfatm
!!$!-----------------------------------------------------------------------------------
!!$  integer function operatorExists_in_nop()
!!$    real(kind=DP) :: delta,temp
!!$    integer :: i,j,nope
!!$    do nope = 1, nopr
!!$       delta = 0.0d0
!!$       do i = 1, 3
!!$          do j = 1, 3
!!$!!             temp = op_temp(i,j) - op(i,j,nope)
!!$             temp = op_temp(i,j) - op(j,i,nope)
!!$             delta = delta + temp*temp
!!$          end do
!!$       end do
!!$       if(delta < 1.0d-3) then
!!$          operatorExists_in_nop = nope
!!$          return
!!$       end if
!!$    end do
!!$    operatorExists_in_nop = -1
!!$  end function operatorExists_in_nop
!!$
!!$  logical function operatorExists()
!!$    ! return .true. if the operator (op_temp, tau_temp) is found in the operator list op_local.
!!$    real(kind=DP) delta ,temp, temp_a, temp_b
!!$    integer i, j, nope
!!$
!!$    do nope = 1, nopr_local
!!$       ! ROTATION
!!$       if(1<=iop_temp.and. iop_temp <= nopr .and. iop_temp /= iop_local(nope)) cycle
!!$       if(iop_temp <= 0)then
!!$          delta = 0.0d0
!!$          do i = 1, 3
!!$             do j = 1, 3
!!$                temp = op_temp(i, j) - op_local(i, j, nope)
!!$                delta = delta + temp * temp
!!$             end do
!!$          end do
!!$          if (delta > 1.0d-3) cycle  ! next operator
!!$       end if
!!$
!!$       ! TRANSLATION
!!$       delta = 0.0d0
!!$       do i = 1, 3
!!$          temp_a = tau_local(i, nope)
!!$          temp_b = tau_temp(i)
!!$          if (dabs(temp_a) <=1.d-8 .and. dabs(temp_b) <=1.d-8) cycle
!!$          temp = mod(temp_a - temp_b + 2.0d0, 1.0d0)
!!$          if (temp > 0.9999999d0) cycle
!!$          temp = temp / max(abs(temp_a), abs(temp_b))
!!$          delta = delta + temp * temp
!!$       end do
!!$
!!$
!!$       if (delta < 1.0d-3) then
!!$          operatorExists = .true.  ! found
!!$          if(nopr_local+1 == 4891 .or. nopr_local+1 == 4892 .or. nopr_local+1==4893  &
!!$               & .or. nopr_local+1==4900 .or.nopr_local+1==4901 .or. nopr_local+1==4902) then
!!$             write(6,'(" ** operatorExists, nope = ",i8, " (iop, jop) = (",i8,i8," )")') nope, iop, jop
!!$          end if
!!$          if(nopr_local_temp >= 5190) then
!!$             if(jop == nopr_local_temp) then
!!$                write(6,'(" operatorExists, nope = ",i8, " (iop, jop) = (",i8,i8," )")') nope, iop, jop
!!$                call flush(6)
!!$             end if
!!$          end if
!!$          return
!!$       end if
!!$    enddo
!!$    operatorExists = .false.  ! not found
!!$  end function operatorExists
!!$!-----------------------------------------------------------------------------------
!!$end subroutine fd_symmetrize_sc2

subroutine set_iatomn_default(elen,ntyp, speciesname, iatomn)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: elen,ntyp
  character(len=elen), dimension(ntyp), intent(in) :: speciesname
  real(kind=DP), dimension(ntyp), intent(out) :: iatomn
  character(len=elen), allocatable :: ename_table(:)
  integer :: it,ie,pos,ii
  integer :: nmax_elem = 120

  allocate( ename_table( nmax_elem ) );ename_table=''
!  call set_table( 4,  1, 'H', 'He', 'Li', 'Be', 'B' )
  ename_table(1)  = 'H'
  ename_table(2)  = 'He'
  ename_table(3)  = 'Li'
  ename_table(4)  = 'Be'
  ename_table(5)  = 'B'
  ename_table(6)  = 'C'
  ename_table(7)  = 'N'
  ename_table(8)  = 'O'
  ename_table(9)  = 'F'
  ename_table(10) = 'Ne'
  ename_table(11) = 'Na'
  ename_table(12) = 'Mg'
  ename_table(13) = 'Al'
  ename_table(14) = 'Si'
  ename_table(15) = 'P'
  ename_table(16) = 'S'
  ename_table(17) = 'Cl'
  ename_table(18) = 'Ar'
  ename_table(19) = 'K'
  ename_table(20) = 'Ca'
  ename_table(21) = 'Sc'
  ename_table(22) = 'Ti'
  ename_table(23) = 'V'
  ename_table(24) = 'Cr'
  ename_table(25) = 'Mn'
  ename_table(26) = 'Fe'
  ename_table(27) = 'Co'
  ename_table(28) = 'Ni'
  ename_table(29) = 'Cu'
  ename_table(30) = 'Zn'
  ename_table(31) = 'Ga'
  ename_table(32) = 'Ge'
  ename_table(33) = 'As'
  ename_table(34) = 'Se'
  ename_table(35) = 'Br'
  ename_table(36) = 'Kr'
  ename_table(37) = 'Rb'
  ename_table(38) = 'Sr'
  ename_table(39) = 'Y'
  ename_table(40) = 'Zr'
  ename_table(41) = 'Nb'
  ename_table(42) = 'Mo'
  ename_table(43) = 'Tc'
  ename_table(44) = 'Ru'
  ename_table(45) = 'Rh'
  ename_table(46) = 'Pd'
  ename_table(47) = 'Ag'
  ename_table(48) = 'Cd'
  ename_table(49) = 'In'
  ename_table(50) = 'Sn'
  ename_table(51) = 'Sb'
  ename_table(52) = 'Te'
  ename_table(53) = 'I'
  ename_table(54) = 'Xe'
  ename_table(55) = 'Cs'
  ename_table(56) = 'Ba'
  ename_table(57) = 'La'
  ename_table(58) = 'Ce'
  ename_table(59) = 'Pr'
  ename_table(60) = 'Nd'
  ename_table(61) = 'Pm'
  ename_table(62) = 'Sm'
  ename_table(63) = 'Eu'
  ename_table(64) = 'Gd'
  ename_table(65) = 'Tb'
  ename_table(66) = 'Dy'
  ename_table(67) = 'Ho'
  ename_table(68) = 'Er'
  ename_table(69) = 'Tm'
  ename_table(70) = 'Yb'
  ename_table(71) = 'Lu'
  ename_table(72) = 'Hf'
  ename_table(73) = 'Ta'
  ename_table(74) = 'W'
  ename_table(75) = 'Re'
  ename_table(76) = 'Os'
  ename_table(77) = 'Ir'
  ename_table(78) = 'Pt'
  ename_table(79) = 'Au'
  ename_table(80) = 'Hg'
  ename_table(81) = 'Tl'
  ename_table(82) = 'Pb'
  ename_table(83) = 'Bi'
  ename_table(84) = 'Po'
  ename_table(85) = 'At'
  ename_table(86) = 'Rn'
  ename_table(87) = 'Fr'
  ename_table(88) = 'Ra'
  ename_table(89) = 'Ac'
  ename_table(90) = 'Th'
  ename_table(91) = 'Pa'
  ename_table(92) = 'U'
  ename_table(93) = 'Np'
  ename_table(94) = 'Pu'
  ename_table(95) = 'Am'
  ename_table(96) = 'Cm'
  ename_table(97) = 'Bk'
  ename_table(98) = 'Cf'
  ename_table(99) = 'Es'
  ename_table(100) = 'Fm'
  ename_table(101) = 'Md'
  ename_table(102) = 'No'
  ename_table(103) = 'Lr'
  ename_table(104) = 'Rf'
  ename_table(105) = 'Db'
  ename_table(106) = 'Sg'
  ename_table(107) = 'Bh'
  ename_table(108) = 'Hs'
  ename_table(109) = 'Mt'
  ename_table(110) = 'Ds'
  ename_table(111) = 'Rg'
  ename_table(112) = 'Cn'
  ename_table(113) = 'Nh'
  ename_table(114) = 'Fl'
  ename_table(115) = 'Mc'
  ename_table(116) = 'Lv'
  ename_table(117) = 'Ts'
  ename_table(118) = 'Og'

  iatomn = 0 
  do it=1,ntyp
     do ie=1,nmax_elem 
        if(trim(speciesname(it)) == trim(ename_table(ie))) then
           iatomn(it) = real(ie)
        else
           pos = index(trim(speciesname(it)),trim(ename_table(ie)))
           if (pos.eq.1) then
              read(speciesname(it)(len(trim(ename_table(ie)))+1:len(speciesname(it))),*,err=90,end=90) ii
              iatomn(it) = real(ie)
90            continue
           endif
        endif
     enddo
  enddo
  deallocate(ename_table) 

end subroutine set_iatomn_default

subroutine set_covrad_default(ntyp, iatomn, covrads)
  use m_Const_Parameters, only : DP,BOHR
  implicit none
!
  integer, intent(in) :: ntyp
  real(kind=DP), intent(in) :: iatomn(ntyp)
  real(kind=DP), intent(inout) :: covrads(ntyp)
  real(kind=DP) :: ang2bohr
  real(kind=DP), allocatable, dimension(:) :: cov_table
!
  integer :: it,i
  integer :: nmax_elem = 120
  ang2bohr = 1.d0/BOHR
  allocate(cov_table(nmax_elem))

  cov_table(:) = 1.d0

  cov_table(1) = 0.32d0
  cov_table(2) = 0.93d0
  cov_table(3) = 1.23d0
  cov_table(4) = 0.9d0
  cov_table(5) = 0.82d0
  cov_table(6) = 0.77d0
  cov_table(7) = 0.75d0
  cov_table(8) = 0.73d0
  cov_table(9) = 0.72d0
  cov_table(10) = 0.71d0
  cov_table(11) = 1.54d0
  cov_table(12) = 1.36d0
  cov_table(13) = 1.18d0
  cov_table(14) = 1.11d0
  cov_table(15) = 1.06d0
  cov_table(16) = 1.02d0
  cov_table(17) = 0.99d0
  cov_table(18) = 0.98d0
  cov_table(19) = 2.03d0
  cov_table(20) = 1.74d0
  cov_table(21) = 1.44d0
  cov_table(22) = 1.32d0
  cov_table(23) = 1.22d0
  cov_table(24) = 1.18d0
  cov_table(25) = 1.17d0
  cov_table(26) = 1.17d0
  cov_table(27) = 1.16d0
  cov_table(28) = 1.15d0
  cov_table(29) = 1.17d0
  cov_table(30) = 1.25d0
  cov_table(31) = 1.26d0
  cov_table(32) = 1.22d0
  cov_table(33) = 1.2d0
  cov_table(34) = 1.16d0
  cov_table(35) = 1.14d0
  cov_table(36) = 1.89d0
  cov_table(37) = 2.16d0
  cov_table(38) = 1.91d0
  cov_table(39) = 1.62d0
  cov_table(40) = 1.45d0
  cov_table(41) = 1.34d0
  cov_table(42) = 1.3d0
  cov_table(43) = 1.27d0
  cov_table(44) = 1.25d0
  cov_table(45) = 1.25d0
  cov_table(46) = 1.28d0
  cov_table(47) = 1.34d0
  cov_table(48) = 1.41d0
  cov_table(49) = 1.44d0
  cov_table(50) = 1.41d0
  cov_table(51) = 1.4d0
  cov_table(52) = 1.36d0
  cov_table(53) = 1.33d0
  cov_table(54) = 1.31d0
  cov_table(55) = 2.35d0
  cov_table(56) = 1.98d0
  cov_table(57) = 1.25d0
  cov_table(58) = 1.65d0
  cov_table(59) = 1.65d0
  cov_table(60) = 1.64d0
  cov_table(61) = 1.63d0
  cov_table(62) = 1.62d0
  cov_table(63) = 1.85d0
  cov_table(64) = 1.61d0
  cov_table(65) = 1.59d0
  cov_table(66) = 1.59d0
  cov_table(67) = 1.58d0
  cov_table(68) = 1.57d0
  cov_table(69) = 1.56d0
  cov_table(70) = 1.7d0
  cov_table(71) = 1.56d0
  cov_table(72) = 1.44d0
  cov_table(73) = 1.34d0
  cov_table(74) = 1.37d0
  cov_table(75) = 1.28d0
  cov_table(76) = 1.26d0
  cov_table(77) = 1.27d0
  cov_table(78) = 1.3d0
  cov_table(79) = 1.34d0
  cov_table(80) = 1.49d0
  cov_table(81) = 1.48d0
  cov_table(82) = 1.47d0
  cov_table(83) = 1.46d0
  cov_table(84) = 1.53d0
  cov_table(85) = 1.47d0
  cov_table(86) = 1.42d0
  cov_table(87) = 2.23d0
  cov_table(88) = 2.01d0
  cov_table(89) = 1.86d0
  cov_table(90) = 1.75d0
  cov_table(91) = 1.69d0
  cov_table(92) = 1.7d0
  cov_table(93) = 1.71d0
  cov_table(94) = 1.72d0
  cov_table(95) = 1.66d0
  cov_table(96) = 1.66d0
  cov_table(97) = 1.66d0
  cov_table(98) = 1.68d0
  cov_table(99) = 1.65d0
  cov_table(100) = 1.67d0
  cov_table(101) = 1.73d0
  cov_table(102) = 1.76d0
  cov_table(103) = 1.61d0
  cov_table(104) = 1.57d0
  cov_table(105) = 1.49d0
  cov_table(106) = 1.43d0
  cov_table(107) = 1.41d0
  cov_table(108) = 1.34d0
  cov_table(109) = 1.29d0

  do it=1,ntyp
     i = nint( iatomn(it) )
     covrads(it) = cov_table(i) * ang2bohr
  enddo

  deallocate(cov_table)

end subroutine set_covrad_default

! === KT_add ======= 13.3B
!*** ref. http://www.caslab.com/List-of-Elements/ *****
!
subroutine set_amion_default( ntyp, iatomn, amion )
  use m_Const_Parameters, only : DP
  implicit none
!
  integer, intent(in) :: ntyp
  real(kind=DP), intent(in) :: iatomn(ntyp)
  real(kind=DP), intent(inout) :: amion(ntyp)
!
  integer :: nmax_elem = 120
!
  integer :: it, i
  real(kind=DP) :: coeff
  real(kind=DP), allocatable :: mass_table(:)
!
  allocate( mass_table( nmax_elem ) )

  call set_table(   1, 1.00794d0, 4.002602d0, 6.941d0, 9.012182d0, 10.811d0 )
  call set_table(   6, 12.0107d0, 14.0067d0, 15.9994d0, 18.9984032d0, 20.1797d0 )
  call set_table(  11, 22.98976928d0, 24.3050d0, 26.9815386d0, 28.0855d0, 30.973762d0 )
  call set_table(  16, 32.065d0, 35.453d0, 39.948d0, 39.0983d0, 40.078d0 )

  call set_table(  21, 44.955912d0, 47.867d0, 50.9415d0, 51.9961d0, 54.938045d0 )
  call set_table(  26, 55.845d0, 58.933195d0, 58.6934d0, 63.546d0, 65.409d0 )
  call set_table(  31, 69.723d0, 72.64d0, 74.92160d0, 78.96d0, 79.904d0 )
  call set_table(  36, 83.798d0, 85.4678d0, 87.62d0, 88.90585d0, 91.224d0 )

  call set_table(  41, 92.90638d0, 95.94d0, 97.9072d0, 101.07d0, 102.90550d0 )
  call set_table(  46, 106.42d0, 107.8682d0, 112.411d0, 114.818d0, 118.710d0 )
  call set_table(  51, 121.760d0, 127.60d0, 126.90447d0, 131.293d0, 132.9054519d0 )
  call set_table(  56, 137.327d0, 138.90547d0, 140.116d0, 140.90765d0, 144.242d0 )

  call set_table(  61, 144.9127d0, 150.36d0, 151.964d0, 157.25d0, 158.92535d0 )
  call set_table(  66, 162.500d0, 164.93032d0, 167.259d0, 168.93421d0, 173.04d0 )
  call set_table(  71, 174.967d0, 178.49d0, 180.94788d0, 183.84d0, 186.207d0 )
  call set_table(  76, 190.23d0, 192.217d0, 195.084d0, 196.966569d0, 200.59d0 )

  call set_table(  81, 204.3833d0, 207.2d0, 208.98040d0, 208.9824d0, 209.9871d0 )
  call set_table(  86, 222.0176d0, 223.0197d0, 226.0254d0, 227.0277d0, 232.03806d0 )
  call set_table(  91, 231.03588d0, 238.02891d0, 237.0482d0, 244.0642d0, 243.0614d0 )
  call set_table(  96, 247.0704d0, 247.0703d0, 251.0796d0, 252.0830d0, 257.0951d0 )

  call set_table( 101, 258.0984d0, 259.1010d0, 262.1097d0, 261.1088d0, 262d0 )
  call set_table( 106, 266d0, 264d0, 277d0, 268d0, 271d0 )
  call set_table( 111, 272d0, 285d0, 284d0, 289d0, 288d0 )
  call set_table( 116, 292d0, 293d0, 294d0, 500d0, 500d0 )

!
  coeff = 1.66053d-27 /9.1093897d-31
  Do it=1, ntyp
     if ( amion(it) < -99.0 ) then
        i = nint( iatomn(it) )
        amion(it) = mass_table(i) *coeff
     endif
  End do

  deallocate( mass_table )

contains

  subroutine set_table( istart, c1, c2, c3, c4, c5 )
    integer, intent(in) :: istart
    real(kind=DP), intent(in) :: c1, c2, c3, c4, c5

    mass_table( istart ) = c1
    mass_table( istart +1 ) = c2
    mass_table( istart +2 ) = c3
    mass_table( istart +3 ) = c4
    mass_table( istart +4 ) = c5
  end subroutine set_table

end subroutine set_amion_default
! ========== 13.3B

subroutine get_ac_from_dynm(nfdynm,targetframe,natm,nchar,ntyp,avec,bvec,cvec,speciesname,ityp,cps,cpd)
  implicit none
  integer, intent(in) :: nfdynm,targetframe,natm,nchar,ntyp
  real(kind=8), dimension(3), intent(out) :: avec,bvec,cvec
  character(len=nchar), dimension(ntyp), intent(out) :: speciesname
  integer, dimension(natm), intent(out) :: ityp
  real(kind=8), dimension(natm,3), intent(out) :: cps,cpd
  integer, parameter :: ncharline=256
  integer, parameter :: ncharword=20
  integer :: nwords = 20
  character(len=ncharline) :: line
  character(len=ncharword), allocatable, dimension(:) :: output
  integer :: i
  integer :: tmpint
  logical :: in_header, in_data
  integer :: ntypc,currat,iframe
  integer :: nword_out

  allocate(output(nwords))
  in_header = .false.
  in_data = .false.
  ntypc = 0
  iframe = 0
  avec=0.d0;bvec=0.d0;cvec=0.d0
  speciesname='';ityp=0.d0;cps=0.d0
  do 
    read(unit=nfdynm,end=100,fmt='(a)') line
    call split(ncharline,ncharword,nwords,line,output,nword_out)
    if(.not. in_header .and. trim(output(1)) == '#')  then
      in_header = .true.
      cycle
    endif
    if(in_header) then
      if(trim(output(2)) == 'a_vector')then
        ntypc = 0
        currat = 0
        read(output(4),*) avec(1)
        read(output(5),*) avec(2)
        read(output(6),*) avec(3)
      else if(trim(output(2)) == 'b_vector')then
        read(output(4),*) bvec(1)
        read(output(5),*) bvec(2)
        read(output(6),*) bvec(3)
      else if(trim(output(2)) == 'c_vector')then
        read(output(4),*) cvec(1)
        read(output(5),*) cvec(2)
        read(output(6),*) cvec(3)
      else if(trim(output(2)) == '(natm->type)')then
        do i=3,nwords
          if(len(trim(output(i)))==0) exit
          ntypc = ntypc + 1
          read(output(i),*) ityp(ntypc)
        enddo
      else if(trim(output(2)) == '(speciesname)')then
        read(output(3),*) tmpint 
        speciesname(tmpint)(1:nchar) = output(5)(1:nchar)
      endif
    endif
    if(output(1) == 'cps')then
      in_header = .false.
      in_data = .true.
      ntypc = 0
      currat = 0
      cycle
    endif
    if(in_data)then
      currat = currat+1
      read(output(2),*) cps(currat,1)
      read(output(3),*) cps(currat,2)
      read(output(4),*) cps(currat,3)
      if(nword_out == 10)then
        read(output(5),*) cpd(currat,1)
        read(output(6),*) cpd(currat,2)
        read(output(7),*) cpd(currat,3)
      endif
      if(currat == natm)then
        iframe = iframe+1
        in_data = .false.
        if(targetframe .eq.iframe) then
           exit
        endif
      endif
    endif
  enddo

100 continue
  deallocate(output)
end subroutine get_ac_from_dynm

subroutine get_numat_and_ntyp(nfdynm,natm,ntyp)
  implicit none
  integer, intent(in) :: nfdynm
  integer, intent(out) :: natm,ntyp
  integer, parameter :: ncharline=256
  integer, parameter :: ncharword=20
  integer :: nwords = 20
  integer :: nword_out
  character(len=ncharline) :: line
  character(len=ncharword), allocatable, dimension(:) :: output
  logical :: in_header
  integer :: i

  natm = 0;ntyp = 0
  allocate(output(nwords))
  in_header = .false.
  do 
    read(unit=nfdynm,end=100,fmt='(a)') line
    call split(ncharline,ncharword,nwords,line,output,nword_out)
    if(.not. in_header .and. trim(output(1)) == '#')  then
      in_header = .true.
      cycle
    endif
    if(in_header) then
      if(trim(output(2)) == 'ntyp')then
        read(output(4),*) ntyp
        read(output(7),*) natm
        return
      endif
    endif
  enddo
100 continue
  write(0,*) '!** failed to resolve natm and ntyp'
  return
end subroutine get_numat_and_ntyp

subroutine split(ncharline,ncharword,nwords,input,output,nword_out) 
  implicit none
  integer, intent(in) :: ncharline,ncharword,nwords
  character(len=ncharline), intent(in) :: input
  character(len=ncharword), dimension(nwords), intent(out) :: output
  integer, intent(out) :: nword_out
  integer :: i, currword,currind
  logical :: was_ws
  was_ws = .true.
  currword = 0
  currind = 0
  do i=1,nwords
    output(i) = ''
  enddo
  do i=1,ncharline
    if (input(i:i) .eq. ' ') then
      was_ws = .true.
      cycle
    endif
    if (was_ws) then
      currword = currword + 1
      was_ws = .false.
      currind = 0
    endif
    currind = currind+1
    output(currword)(currind:currind) = input(i:i)
  enddo
  nword_out = currword
end subroutine split

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  MODULE: m_FFT
!
!  AUTHOR(S): T. Yamasaki, K. Betsuyaku,   August/20/2003
!  
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004
!                                   , March/14/2005, April/10/2007
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1,cw2,cw3
  complex(kind=CMPLDP),private,allocatable,dimension(:)    :: wlp,wmp,wnp
  ! ------- Positron
  complex(kind=CMPLDP),private,target,allocatable,dimension(:)    :: cw1_pstrn,cw2_pstrn,cw3_pstrn

  real(kind=DP),private,allocatable,dimension(:)           :: ftw

  integer :: idp, nlp, nmp, nnp

  integer :: sw_avoiding_odd_fftbox = OFF
  integer :: sw_zero_padding = OFF

  integer :: istat

  include 'mpif.h'

  include 'ffte.h'
contains
  subroutine fft_WFCD_work_alloc
    integer :: nnl,nnm,nnn
! ----> work arrays of fft for wave functions
    if(ipri >= 1) write(nfout,'(" !!allocation of cw1,cw2,cw3 (fft_WFCD_work_alloc)")')
    if(kimg == 1) then
       nnl  = fft_box_size_WF(1,1)
       nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
       allocate(cw1(nnl), stat=istat)
       allocate(cw2(nnm), stat=istat)
       allocate(cw3(nnn), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! WF_JRCATFFTg <<m_FFT.fft_WFCD_work_alloc>>")')
    else if(kimg == 2) then
       allocate(cw1(nda3*2+np), stat=istat)
       allocate(cw2(nda3*2+np), stat=istat)
       allocate(cw3(nda3*2+np), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! FFTE <<m_FFT.fft_WFCD_work_alloc>>")')
    end if
! ------- Positron start 
! ----> and work arrays of fft for positron wave functions
    if(sw_positron /= OFF) then
       if(ipri >= 1) write(nfout,'(" !!allocation of cw1_pstrn,cw2_pstrn,cw3_pstrn (fft_WFCD_work_alloc)")')
       if(kimg == 1) then
          nnl  = fft_box_size_pWF(1,1)
          nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)
          allocate(cw1_pstrn(nnl), stat=istat)
          allocate(cw2_pstrn(nnm), stat=istat)
          allocate(cw3_pstrn(nnn), stat=istat)
       else if(kimg == 2) then
          allocate(cw1_pstrn(nda3/2+np), stat=istat)
          allocate(cw2_pstrn(nda3/2+np), stat=istat)
          allocate(cw3_pstrn(nda3/2+np), stat=istat)
       end if
    end if
! ------- Positron end

! ----> work arrays of ifft for the charge density
    if(kimg == 1) then
       nnl = fft_box_size_CD(1,1)
       nnm = fft_box_size_CD(2,1);  nnn = fft_box_size_CD(3,1)
       allocate(wlp(nnl), stat=istat)
       allocate(wmp(nnm), stat=istat)
       allocate(wnp(nnn), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! wlp,wmp,wnp are allocated, CD_JRCATFFT_WS  <<m_FFT.fft_WFCD_work_alloc>>")')
    else
       allocate(wlp(nda3/2+np), stat=istat)
       allocate(wmp(nda3/2+np), stat=istat)
       allocate(wnp(nda3/2+np), stat=istat)
       if(ipri >= 1) write(nfout,'(" !! wlp,wmp,wnp are allocated, FFTE <<m_FFT.fft_WFCD_work_alloc>>")')
    end if
  end subroutine fft_WFCD_work_alloc

  subroutine m_FFT_alloc_WF_work
    integer :: nid,nnm,nnn,nmax

    if(kimg == 1) then
       nid  = fft_box_size_WF(1,0)
       nnm  = fft_box_size_WF(2,1);  nnn  = fft_box_size_WF(3,1)
       nmax = max(nid,nnm,nnn)
       allocate(ftw(nmax*2*2), stat=istat)     ! T. Yamasaki, 28 Jun. 2004
    else if(kimg == 2) then
    end if
  end subroutine m_FFT_alloc_WF_work

  subroutine m_FFT_alloc_pWF_work()
    integer :: nid,nnm,nnn, nmax

    if(kimg == 1) then
       nid  = fft_box_size_pWF(1,0)
       nnm  = fft_box_size_pWF(2,1);  nnn  = fft_box_size_pWF(3,1)
       nmax = max(nid,nnm,nnn)
       allocate(ftw(nmax*2*2), stat=istat)
    else if(kimg == 2) then
    end if
  end subroutine m_FFT_alloc_pWF_work

  subroutine m_FFT_dealloc_WF_work
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
       if(istat /= 0 ) then
          if(ipri>=1) then
             write(nfout,*) 'Deallocation error for ftw in sub. m_FFT_dealloc_WF_work'
             write(nfout,*) 'stat=', istat
          end if
          stop
       end if
    end if
  end subroutine m_FFT_dealloc_WF_work

  subroutine m_FFT_alloc_CD_box
    integer :: nmax
    if(kimg == 1) then
       nmax = max(idp,nmp,nnp)
       allocate(ftw(nmax*2*2), stat=istat)
    else if(kimg == 2) then
    end if
    allocate(afft_CD(nfftp), stat=istat)
  end subroutine m_FFT_alloc_CD_box

  subroutine m_FFT_dealloc_CD_box
    if(allocated(ftw)) then
       deallocate(ftw, stat=istat)
    end if
    deallocate(afft_CD, stat=istat)
  end subroutine m_FFT_dealloc_CD_box

  subroutine m_FFT_setup(inversion_symmetry,paramset)
    integer, intent(in) :: inversion_symmetry
    logical, intent(in) :: paramset

    integer :: nfft_t, ipad
    integer :: id_sname = -1
    real(kind=DP), allocatable,dimension(:)               :: cfft

    call tstatc0_begin('m_FFT_setup ',id_sname)

    if(inversion_symmetry == ON) then  ! kimg == 1
       ipad = 2
    else if(inversion_symmetry == OFF) then ! kimg == 2
       ipad = 0
       if(ipri >= 1) write(nfout,*) '!FFT_WF = FFTE <<m_FFT_setup>>'
    end if
! --- fft_box_size_WF, fft_box_size_pWF ---
    fft_box_size_WF(1,0) = fft_box_size_WF(1,1) + ipad
    fft_box_size_WF(2:3,0) = fft_box_size_WF(2:3,1)
    if(sw_positron /= OFF) then
       fft_box_size_pWF(1,0)   = fft_box_size_pWF(1,1) + ipad
       fft_box_size_pWF(2:3,0) = fft_box_size_pWF(2:3,1)
    end if

    nfft =   product(fft_box_size_WF(1:3,0)) * (2-inversion_symmetry)
! --- fft_box_size_CD ---
    fft_box_size_CD_nonpara(1,0)   = fft_box_size_CD(1,1) + ipad
    fft_box_size_CD_nonpara(2:3,0) = fft_box_size_CD(2:3,1)
    nfftp_nonpara  = product(fft_box_size_CD_nonpara(1:3,0)) * (2-inversion_symmetry)

    fft_box_size_CD(1:3,0)   = fft_box_size_CD_nonpara(1:3,0)
    fft_box_size_CD_c(1:3,0) = fft_box_size_CD(1:3,0)
    nfftp  = product(fft_box_size_CD(1:3,0)) * (2-inversion_symmetry)
    nfftps = nfftp

    if(ipri >= 1) call wd_FFTboxsizes(nfout)

    idp = fft_box_size_CD(1,0)
    nlp = fft_box_size_CD(1,1)
    nmp = fft_box_size_CD(2,1)
    nnp = fft_box_size_CD(3,1)

    if(sw_positron /= OFF) &
         & nfft_pstrn = product(fft_box_size_pWF(1:3,0))*(2-inversion_symmetry)

    if(.not. paramset) then
       call fft_WFCD_work_alloc     ! <cw[123],cw[123]_pstrn,wlp,wmp,wnp> are allocated

! Initialization of the Wave-Function FFT
       if(kimg == 1) then
          if(sw_positron /= OFF .and. nfft_pstrn > nfft) then
             call m_FFT_alloc_pWF_work()  ! <ftw> is allocated
             nfft_t = nfft_pstrn
          else
             call m_FFT_alloc_WF_work()   ! <ftw> is allocated
             nfft_t = nfft
          end if
          allocate(cfft(nfft_t), stat=istat) ! cfft is used only for initiallization
          if(istat /= 0) then
             if(ipri >= 1) then
                write(nfout,*) 'Allocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat, 'nfft =', nfft
             end if
             stop
          end if
       end if

       call init_fft_coefficients_arrays_WF()

       if(kimg == 1) then
          call m_FFT_dealloc_WF_work()
          deallocate(cfft,stat=istat)
          if(istat /= 0 ) then
             if(ipri >= 1) then
                write(nfout,*) 'Deallocation error for cfft in sub. m_FFT_setup'
                write(nfout,*) 'stat =', istat
             end if
             stop
          end if
       end if

! Initialization of the Charge-Density FFT
       call CDFFT_setup()

    endif

    call tstatc0_end(id_sname)
  contains
    subroutine init_fft_coefficients_arrays_WF()
      integer :: id, nl, nm, nn, ierr
      integer :: id_p, nl_p, nm_p, nn_p
      id = fft_box_size_WF(1,0)
      nl = fft_box_size_WF(1,1)
      nm = fft_box_size_WF(2,1)
      nn = fft_box_size_WF(3,1)
      if(sw_positron /= OFF) then
         id_p = fft_box_size_pWF(1,0)
         nl_p = fft_box_size_pWF(1,1)
         nm_p = fft_box_size_pWF(2,1)
         nn_p = fft_box_size_pWF(3,1)
      end if

      if(kimg == 1) then
         call jrcat_r3ft(cfft,ftw,id,nl,nm,nn,cw1,cw2,cw3,0,0,0,0)
         if(sw_positron /= OFF) &
              & call jrcat_r3ft(cfft,ftw,id_p,nl_p,nm_p,nn_p &
              &                   ,cw1_pstrn,cw2_pstrn,cw3_pstrn,0,0,0,0)
      else  ! kimg == 2
        call settbl(cw1,nl)
        call settbl(cw2,nm)
        call settbl(cw3,nn)
        if(sw_positron /= OFF) then
           call settbl(cw1_pstrn,nl_p)
           call settbl(cw2_pstrn,nm_p)
           call settbl(cw3_pstrn,nn_p)
        end if
      endif

    end subroutine init_fft_coefficients_arrays_WF

  end subroutine m_FFT_setup

  subroutine CDFFT_setup()
    if(kimg == 1) then
       call m_FFT_alloc_CD_box()       ! <ftw> is allocated
    else if(kimg == 2) then
    end if

    call init_fft_coefficients_arrays_CD()

    CD_setup_is_done = YES

    if(kimg == 1) then
       call m_FFT_dealloc_CD_box()
    else if(kimg == 2) then
    end if
  contains
    subroutine init_fft_coefficients_arrays_CD
      integer :: id, nl, nm, nn, ierr

   !  ---> FFT for Charge density
      id = fft_box_size_CD(1,0)
      nl = fft_box_size_CD(1,1)
      nm = fft_box_size_CD(2,1)
      nn = fft_box_size_CD(3,1)
      if(kimg == 1) then
         call jrcat_r3ft(afft_CD,ftw,id,nl,nm,nn,wlp,wmp,wnp,0,0,0,0)
      else if(kimg == 2) then
        call settbl(wlp,nl)
        call settbl(wmp,nm)
        call settbl(wnp,nn)
      endif

    end subroutine init_fft_coefficients_arrays_CD
  end subroutine CDFFT_setup

  subroutine m_FFT_WF(electron_or_positron,nfout,afft,inverse_or_direct,switch)  ! G space --> R space
    integer, intent(in)          :: electron_or_positron
    integer, intent(in)          :: nfout
    real(kind=DP), intent(inout) :: afft(nfft)
    integer, intent(in)          :: inverse_or_direct
    integer, intent(in)          :: switch

    complex(kind=CMPLDP),pointer,dimension(:) :: cw1_t, cw2_t, cw3_t

    integer :: id, nl, nm, nn
    integer :: isign

    integer, dimension(2) :: flag_jrcat_r3ft = (/-2,  2/)
    integer kc1, kc2, kc3

    integer :: id_sname = -1

    if(electron_or_positron == ELECTRON) then
       call tstatc0_begin('m_FFT_WF ',id_sname)

       if(kimg==1) id = fft_box_size_WF(1,0)
       nl = fft_box_size_WF(1,1)
       nm = fft_box_size_WF(2,1)
       nn = fft_box_size_WF(3,1)
       cw1_t=>cw1; cw2_t=>cw2; cw3_t=>cw3 
    else if(electron_or_positron == POSITRON) then
       call tstatc0_begin('m_FFT_pWF ',id_sname)

       if(kimg==1) id = fft_box_size_pWF(1,0)
       nl = fft_box_size_pWF(1,1)
       nm = fft_box_size_pWF(2,1)
       nn = fft_box_size_pWF(3,1)
       cw1_t=>cw1_pstrn; cw2_t=>cw2_pstrn; cw3_t=>cw3_pstrn
    end if

    if(kimg == 1) then
       if(switch == ON) then
          kc1 = 0;       kc2 = nm/4 + 1;       kc3 = nn/4 + 1
       else
          kc1 = 0;       kc2 = 0       ;       kc3 = 0
       endif
       call jrcat_r3ft(afft,ftw,id,nl,nm,nn,cw1_t,cw2_t,cw3_t,kc1,kc2,kc3&
            & ,flag_jrcat_r3ft(inverse_or_direct))
    else if(kimg == 2) then
       if(inverse_or_direct == INVERSE) then
         isign = 2
       else if(inverse_or_direct == DIRECT) then
         isign = 1
       else
          if(ipri>=1) write(*,*) "inverse_or_direct must be 1 or 2 in subroutine m_FFT_pWF"
         stop
       endif
       call zfft3dw(afft,nl,nm,nn,cw1_t,cw2_t,cw3_t,isign)
    endif

    call tstatc0_end(id_sname)
  end subroutine m_FFT_WF


  subroutine fft_CD_inverse_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    integer :: kc1 = 0, kc2 = 0, kc3 = 0
    if(kimg == 1) then
       call jrcat_r3ft(afft_CD,ftw,idp,nlp,nmp,nnp,wlp,wmp,wnp,kc1,kc2,kc3&
            & ,-2)
    else if(kimg == 2) then
       call zfft3dw(afft_CD,nlp,nmp,nnp,wlp,wmp,wnp,2)
    endif
  end subroutine fft_CD_inverse_core

  subroutine fft_CD_direct_core(afft_CD)
    real(kind=DP),intent(inout),dimension(nfftp_nonpara) :: afft_CD
    integer :: kc1 = 0, kc2 = 0, kc3 = 0
    if(kimg == 1) then
       call jrcat_r3ft(afft_CD,ftw,idp,nlp,nmp,nnp,wlp,wmp,wnp,kc1,kc2,kc3&
            & , 2)
    else if(kimg == 2) then
       call zfft3dw(afft_CD,nlp,nmp,nnp,wlp,wmp,wnp,1)
    endif
  end subroutine fft_CD_direct_core

! --------------

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 590 $)
!
!  MODULE: m_IterationNumbers
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
! *************************************************************
! 
module m_IterationNumbers
!     (m_Iter)
! $Id: m_IterationNumbers.F90 590 2018-11-06 04:20:58Z jkoga $
  use m_Const_Parameters, only : len_tag_iteration, tag_iteration &
       &                       , len_tag_iters_and_nk, tag_iters_and_nk &
       &                       , EK_CONVERGED, COORDINATE_CONTINUATION
  use m_Parallelization, only  : mpi_comm_group,mype,npes,ierr,nrank_k
  implicit none

  integer :: iteration = 0            ! #total iteration
  integer :: first_iteration_of_this_job = 0
  integer :: iteration_ionic = 1      ! #timestep for MD of ions
  integer :: iteration_scdft = 1
  integer :: iteration_scdft_initial = 1
  logical :: iteration_scdft_initial_is_set = .false.
  integer :: iteration_electronic = 0 ! #iteration for electronic states convergence
  integer :: iteration_rmm_start  = 0 ! #iteration where rmm starts in iteration_electonic
  integer :: iteration_for_cmix   = 0 ! #iteration for charge mixing.
  !      This is almost same with iteration_electronic.

  integer :: iteration_unit_cell  = 1 ! #iteration for the unit cell, when unit cell optimization is enabled

  integer :: iteration_uramp = 1 ! #iteration for the U-ramping method, when the U-ramping method is enabled

  integer :: iteration_dimer = 1 ! #iteration for the dimer method

  !      Unique difference is that this value is reset when the job starts to run.
  integer :: nk_in_the_process    = 0 ! #kpoint calculating. This is effective only
  !                                     when ekmode (in m_Control_Parameters) is ON.
  integer :: nk_converged         = 0
  integer :: nkgroup              = 0
  integer :: first_kpoint_in_this_job = 0
  integer :: first_iteration_electronic = 0

  integer :: iteration_positron_wf = 0

  integer :: iteration_stress_correction = 1

  integer, parameter :: len_str = 132
  character(len=len_str) :: str

  include 'mpif.h'
contains

  subroutine m_Iter_reset_iter_ionic()
     iteration_ionic = 1
  end subroutine m_Iter_reset_iter_ionic

  subroutine m_Iter_reset_iter_scdft()
    iteration_scdft = 1
  end subroutine m_Iter_reset_iter_scdft

  subroutine m_Iter_reset_iter_electronic(nfout)
    integer, intent(in) :: nfout
    iteration_electronic = 0
    first_iteration_electronic = iteration_electronic
    if(mype == 0) then
       write(nfout,'(" iteration_electronic is rest 0")')
    end if
  end subroutine m_Iter_reset_iter_electronic

  subroutine m_Iter_wd_iteration_numbers(nfcntn)
    integer, intent(in) :: nfcntn
    logical :: unitcell_can_change,Uramping,isSCDFT
    if(mype==0) then
       write(nfcntn,*) tag_iteration
       if(.not.unitcell_can_change())then
          if (Uramping()) then
            write(nfcntn,'(4i10)') iteration, iteration_uramp,iteration_ionic, iteration_electronic
          else if (isSCDFT()) then
            write(nfcntn,'(4i10)') iteration, iteration_scdft,iteration_ionic, iteration_electronic
          else
            write(nfcntn,'(3i10)') iteration, iteration_ionic, iteration_electronic
          endif
       else
          write(nfcntn,'(4i10)') iteration, iteration_unit_cell, iteration_ionic, iteration_electronic
       endif
    endif
  end subroutine m_Iter_wd_iteration_numbers

  subroutine m_Iter_wd_iteration_numbers_b(nf,F_partitioned)
    integer, intent(in) :: nf
    logical, intent(in) :: F_partitioned
    call mpi_barrier(mpi_comm_group,ierr)
    if(F_partitioned) then
       if(mype == 0) then
          write(nf,*) iteration, iteration_ionic, iteration_electronic
       end if
    else
       write(nf,*) iteration, iteration_ionic, iteration_electronic
    end if
  end subroutine m_Iter_wd_iteration_numbers_b

  subroutine m_Iter_rd_iteration_numbers(nfcntn,icond)
    integer, intent(in) :: nfcntn
    integer, intent(in) :: icond
    logical             :: EOF_reach, tag_is_found
    logical :: unitcell_can_change,Uramping,isSCDFT

    if(mype==0) then
       call rewind_to_tag0(nfcntn,len_tag_iteration,tag_iteration &
            &, EOF_reach, tag_is_found, str,len_str)
       if(.not.tag_is_found) then
          stop ' tag_iteration is not found'
       else
          if(.not.unitcell_can_change())then
             if(Uramping()) then
               read(nfcntn,*) iteration, iteration_uramp,iteration_ionic, iteration_electronic
             else if (isSCDFT())then
               read(nfcntn,*) iteration, iteration_scdft,iteration_ionic, iteration_electronic
             else
               read(nfcntn,*) iteration, iteration_ionic, iteration_electronic
             endif
          else
             read(nfcntn,*) iteration, iteration_unit_cell, iteration_ionic, iteration_electronic
          endif
!          if(icond==COORDINATE_CONTINUATION.and.iteration_electronic>0) then
!             iteration=iteration-iteration_electronic
!             iteration_electronic=0
!          endif
       endif
    endif
    if(npes > 1) then
       call mpi_bcast(iteration,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       call mpi_bcast(iteration_ionic,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       call mpi_bcast(iteration_electronic,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(unitcell_can_change()) call mpi_bcast(iteration_unit_cell,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(Uramping()) call mpi_bcast(iteration_uramp,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
       if(isSCDFT()) call mpi_bcast(iteration_scdft,1 &
            & ,mpi_integer,0,mpi_comm_group,ierr)
    end if
    first_iteration_of_this_job = iteration
!!$    iteration_ionic =  iteration_ionic + 1
  end subroutine m_Iter_rd_iteration_numbers

!!$  subroutine m_Iter_rd_iters_and_nk(icon,nfcntn,nspin)
  subroutine m_Iter_rd_iters_and_nk(nfcntn,nspin)
    integer, intent(in) :: nfcntn, nspin
    logical             :: EOF_reach, tag_is_found

!!$    write(6,'(" !! iconvergence = ",i6)') icon
!!$    if(icon < EK_CONVERGED) then
       if(mype==0) then
          call rewind_to_tag0(nfcntn,len_tag_iters_and_nk,tag_iters_and_nk &
               &, EOF_reach, tag_is_found, str,len_str)
          if(.not.tag_is_found) then
             stop ' tag_iters_and_nk is not found'
          else
             read(nfcntn,*) iteration, iteration_electronic, nk_in_the_process
          endif
       endif
       if(npes > 1) then
          call mpi_bcast(iteration,           1,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(iteration_electronic,1,mpi_integer,0,mpi_comm_group,ierr)
          call mpi_bcast(nk_in_the_process,   1,mpi_integer,0,mpi_comm_group,ierr)
       end if
!!$    else
!!$       iteration = 1; iteration_electronic = 1; nk_in_the_process = 1
!!$    end if
    if(mype==0) then
         write(6,'(" !! iteration, iteration_electronic, nk_in_the_process = ",3i6)')&
         & iteration, iteration_electronic, nk_in_the_process
    end if
    first_iteration_of_this_job = iteration
    first_iteration_electronic  = iteration_electronic
    first_kpoint_in_this_job    = nk_in_the_process
    nk_converged                = first_kpoint_in_this_job - 1
    iteration_electronic = iteration_electronic - 1
    nk_in_the_process    = nk_in_the_process - nspin*nrank_k
!!$    iteration_ionic =  iteration_ionic + 1
  end subroutine m_Iter_rd_iters_and_nk

  subroutine m_Iter_wd_iters_and_nk(nfcntn)
    integer, intent(in) :: nfcntn
    if(mype==0) then
       write(nfcntn,*) tag_iters_and_nk
       write(nfcntn,'(3i10)') iteration, iteration_electronic, nk_in_the_process
    end if
  end subroutine m_Iter_wd_iters_and_nk

  subroutine m_Iter_set_converged_nk(nspin)
    integer, intent(in) :: nspin
    nk_converged = nk_in_the_process + nspin-1
  end subroutine m_Iter_set_converged_nk

  subroutine m_Iter_nk_incre(incre)
    integer, intent(in) :: incre
    integer :: aincre
    if(incre == 2 .and. nk_in_the_process == 0) then
       aincre = 1
    else
       aincre = incre
    end if
    nk_in_the_process = nk_in_the_process + aincre
  end subroutine m_Iter_nk_incre

  subroutine m_Iter_nk_incre2(incre,kv3_ek)
    integer, intent(in) :: incre,kv3_ek
    integer :: aincre
    if(nk_in_the_process == 0) then
       aincre = 1
    else
       aincre = nrank_k*incre
    end if
    nk_in_the_process = nk_in_the_process + aincre
    if(nk_in_the_process > kv3_ek+1) nk_in_the_process = kv3_ek + 1
    nkgroup = nkgroup+1
  end subroutine m_Iter_nk_incre2

  subroutine m_Iter_nkgroup_incre()
    nkgroup=nkgroup+1
  end subroutine m_Iter_nkgroup_incre

  subroutine m_Iter_wd_nk(nfout)
    integer, intent(in) :: nfout
    if(mype==0) then
       write(nfout,*)
       write(nfout,'(" ------------------------")')
       write(nfout,'(" nk_in_the_process = ",i6)') nk_in_the_process
    end if
  end subroutine m_Iter_wd_nk

  subroutine m_Iter_wd_nk2(nfout,kv3)
    integer, intent(in) :: nfout,kv3
    if(mype==0) then
       write(nfout,*)
       write(nfout,'(" ------------------------")')
       write(nfout,'(" nk_in_the_process = ",i6, " nk in the k_point_group = ",i6)') &
            & nk_in_the_process, nk_in_the_process+kv3-1
       write(nfout,'(" nkgroup = ",i6)') nkgroup
    end if
  end subroutine m_Iter_wd_nk2

  subroutine m_Iter_mdIterN_increment()
    iteration_ionic   = iteration_ionic + 1
    if(mype==0) then
       write(6,*) ' ! iteration_ionic = ', iteration_ionic
    end if
  end subroutine m_Iter_mdIterN_increment

  subroutine m_Iter_dimer_incre()
    iteration_dimer  = iteration_dimer + 1
    if(mype==0) then
       write(6,*) ' ! iteration_dimer = ', iteration_dimer
    end if
  end subroutine m_Iter_dimer_incre

  subroutine m_Iter_scdftIterN_increment()
    iteration_scdft  = iteration_scdft + 1
    if(mype==0) then
       write(6,*) ' ! iteration_scdft = ', iteration_scdft
    end if
  end subroutine m_Iter_scdftIterN_increment

  subroutine m_Iter_unitcell_increment()
    iteration_unit_cell = iteration_unit_cell + 1
  end subroutine m_Iter_unitcell_increment

  subroutine m_Iter_stress_correction_incre()
    iteration_stress_correction = iteration_stress_correction + 1
  end subroutine m_Iter_stress_correction_incre

  subroutine m_Iter_uramp_increment()
    iteration_uramp = iteration_uramp + 1
  end subroutine m_Iter_uramp_increment

  subroutine m_Iter_electronic_reset()
    iteration_electronic = 0
    iteration_for_cmix   = 0
  end subroutine m_Iter_electronic_reset
  
  subroutine m_Iter_cmix_reset()
    iteration_for_cmix  = 0
  end subroutine m_Iter_cmix_reset

  subroutine m_Iter_electronic_set()
    iteration_electronic = first_iteration_electronic
  end subroutine m_Iter_electronic_set

!!$  subroutine m_Iter_nkgroup_set(kv3)
!!$    integer, intent(in) :: kv3
!!$    nkgroup = (nk_in_the_process-1)/kv3
!!$  end subroutine m_Iter_nkgroup_set

  subroutine m_Iter_wd_electronic(nfout)
    integer, intent(in) :: nfout
    if(mype==0) then
       write(nfout,'(" iteration_electronic = ",i6)') iteration_electronic
    end if
  end subroutine m_Iter_wd_electronic

  subroutine m_Iter_initialize
    iteration = 0
  end subroutine m_Iter_initialize

  subroutine m_Iter_electronic_incre
    iteration_electronic = iteration_electronic + 1
    iteration_for_cmix   = iteration_for_cmix   + 1
  end subroutine m_Iter_electronic_incre

  subroutine m_Iter_total_increment
    iteration = iteration + 1
  end subroutine m_Iter_total_increment

  subroutine m_Iter_set_rmm_start
    iteration_rmm_start = iteration_electronic
  end subroutine m_Iter_set_rmm_start

  subroutine m_Iter_positron_incre()
    iteration_positron_wf = iteration_positron_wf + 1
  end subroutine m_Iter_positron_incre

  subroutine m_Iter_positron_set()
    iteration_positron_wf = 0
  end subroutine m_Iter_positron_set

  subroutine m_Iter_reset_nk_in_the_process()
    nk_in_the_process = 0
    nkgroup = 0
  end subroutine m_Iter_reset_nk_in_the_process

end module m_IterationNumbers

#ifdef JRCATFFT_WS
#define _INCLUDE_EXX_
#elif FFTW3
#define _INCLUDE_EXX_
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE: Initial_Electronic_Structure, Initial_WaveFunctions_ek
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Initial_Electronic_Structure
! $Id: Initial_Electronic_Structure.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_Const_Parameters,   only : Gauss_distrib_func, from_wave_functions&
       &                         , INITIAL, CONTINUATION, FIXED_CHARGE &
       &                         , FIXED_CHARGE_CONTINUATION, ON, OFF, EXECUT &
       &                         , COORDINATE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, FILE &
       &                         , by_pseudo_atomic_orbitals &
       &                         , Valence_plus_PC_Charge, VXC_AND_EXC, EXC_ONLY &
       &                         , ONE_BY_ONE, ALL_AT_ONCE, DP, YES &
       &                         , Partial_Core_Charge, PT_CONTROL
  use m_IterationNumbers,   only : iteration, nk_in_the_process
  use m_Files,              only : nfout,nfchgt,nfzaj,nfcntn_bin,nfeng,nfefermi &
       &                         , F_ZAJ_in_partitioned, F_CHGT_in_partitioned &
       &                         , F_CNTN_BIN_in_partitioned &
       &                         , nfchr &
       &                         , m_Files_open_nfchr &
       &                         , m_Files_open_nfcntn_bin &
       &                         , m_Files_skiptoend, m_Files_open_nfzaj, m_Files_open_nfchgt &
       &                         , m_Files_open_nfefermi, m_Files_close_nfefermi &
       &                         , nfcntn_bin_paw &
       &                         , file_existence_contfiles &
       &                         , m_Files_check_nfzaj_existence, m_Files_check_nfchgt_existence &
       &                         , m_Files_check_file_existence &
       &                         , m_Files_open_nfcntn_bin_paw,m_Files_close_nfcntn_bin_paw &
       &                         , m_Files_nfcntn_bin_paw_exists
  use m_Control_Parameters, only : ipri, iprichargedensity, initial_chg, icond, nspin, intzaj &
       &                         , evaluation_eko_diff &
       &                         , skip_alloc_phonon, sw_phonon, sw_calc_force, neg, neg_previous &
       &                         , delta_eigenvalue_cond_is_given, sw_dipole_correction, sw_hubbard &
       &                         , ekmode, fixed_charge_k_parallel, ipriparallel, printable &
       &                         , sw_initial_charge_rspace &
       &                         , m_CtrlP_set_neg_properly, m_CntrlP_set_neg, m_CntrlP_set_meg &
       &                         , m_Cntrlp_set_davidson_size &
       &                         , sw_hybrid_functional, sw_screening_correction &
       &                         , sw_external_potential, sw_fef, initial_occmat,kimg &
       &                         , sw_berry_phase, sw_rsb, sw_eval_epc_on_fftmesh &
       &                         , sw_initial_es, imdalg, sw_interpolate_charge, sw_interpolate_wfs &
       &                         , sw_pdos
  use m_Kpoints,            only : kv3
  use m_PlaneWaveBasisSet,  only : kg1, m_pwBS_alloc_ylm_l,kgp,ngabc, kg1_prev, kgp_prev, m_pwBS_rd_prev_pws
  use m_Total_Energy,      only  : m_TE_set_etotal_old
  use m_Electronic_Structure,only: totch, m_ES_gtotch &
       &                         , m_ES_energy_eigen_values_ext_3D &
       &                         , m_ES_alloc_vlhxc, m_ES_alloc_vlhxcQ &
       &                         , m_ES_alloc_zaj_etc &
       &                         , m_ES_alloc_eko_ek, m_ES_alloc_eko1 &
       &                         , m_ES_cpeko &
       &                         , m_ES_alloc_Dhub,vlhxc_l &
#ifdef FFTW3
       &                         , m_ES_cp_zaj_prev_to_zaj &
       &                         , m_ES_gen_zaj_from_prev_zaj
#else
       &                         , m_ES_cp_zaj_prev_to_zaj
#endif
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_wf_extrpl,       only : m_ES_wf_extrpl_alloc
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs_3D
  use m_ES_IO,              only : m_ESIO_rd_Efermi, m_ESIO_rd_EigenValues_etc, m_ESIO_rd_WFs
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers_3D  &
       &                         , m_ESIW_by_randomnumbers0_3D 
  use m_ES_initialWF,       only : m_ESIW_by_atomic_orbitals
  use m_ES_WF_by_SDorCG,    only : m_ESsd_alloc_dzajn2, m_ESsd_alloc_zaj_old
  use m_Charge_Density,     only : chgq_l &
       &                         , m_CD_alloc_hsr &
       &                         , m_CD_rd_hsr &
       &                         , m_CD_rd_chgq  &
       &                         , m_CD_initial_CD_by_file_rspace &
       &                         , m_CD_adjust_spindensity  &
#ifdef FFTW3
       &                         , m_CD_cp_chgq_prev_to_chgq &
       &                         , m_CD_gen_chgq_from_prev_chgq
#else
       &                         , m_CD_cp_chgq_prev_to_chgq
#endif
  use m_Crystal_Structure, only  : sw_fix_total_spin, sw_magnetic_constraint,  univol
! <--
  use m_XC_Potential,      only  : vxc_l, exc

  use m_Orbital_Population,only  : m_OP_rd_occ_mat, m_OP_mix_om, m_OP_occ_mat_init, m_OP_cp_ommix_to_omold
  use m_FiniteElectricField,only : m_FEF_Constract_of_ftq
  use m_Parallelization,      only : m_Parallel_dealloc_mpi_elec, m_Parallel_init_mpi_elec_3D &
                       &           , np_g1k_prev, ista_kngp,iend_kngp,nrank_e,mype
  use m_Charge_Density,       only : m_CD_wd_chgq_l_small_portion   &
 &                                 , m_CD_cp_chgq_to_chgqo
  use m_Charge_Density,       only : m_CD_initial_CD_by_Gauss_func, m_CD_initial_CD_by_Gauss_kt
  use m_Charge_Density,       only : m_CD_softpart_3D, m_CD_hardpart
  use m_Dipole,               only : m_Dipole_vdip_alloc_3D
  use m_Electronic_Structure, only : vlhxc_l             &
 &                                 , zaj_l,   zaj_ball    &
 &                                 , fsr_l                 &
 &                                 , fsi_l                 &
 &                                 , eko_l              &
 &                                 , occup_l            &
 &                                 , neordr,  nrvf_ordr ,vlhxcQ           
  use m_ES_LHXC,              only : m_ESlhxc_potential_3D
  use m_ES_Intgr_VlhxcQlm,    only : m_ESiVQ_integrate_VlhxcQlm_3D
  use m_Ionic_System,         only : zfm3_l 
  use m_Parallelization,      only : myrank_k, map_k, init_zaj_para
  use m_PlaneWaveBasisSet,    only : ylm_l        &
  &                                , gr_l          &
  &                                , m_pwBS_sphrp_l_3D
  use m_PseudoPotential,      only : qitg_l ,  nqitg     &
 &                                 , psc_l               &
 &                                 , rhvg_l              &
 &                                 , modnrm, m_PP_gfqwei_3D, flg_paw, epc, m_PP_rd_PAW_parameters
  use m_XC_Potential,         only : m_XC_cal_potential_3D
  use m_Control_Parameters,   only : nspin, af, kimg, from_PSEUDOPOTENTIAL_FILE  &
 &                                 , istress,sw_fine_STM_simulation
  use m_Const_Parameters,     only : GAMMA
  use m_Kpoints,              only : kv3,vkxyz,k_symmetry
!F---
  use m_PlaneWaveBasisSet   ,only : iba
  use m_Control_Parameters  ,only : nblocksize_mgs,  nblocksize_mgs_is_given
  use m_Electronic_Structure,only : nblocksize_mgs_default,m_ES_alloc_zaj_l_prev
  use m_Parallelization     ,only : make_index_band_3D, make_index_band_for_Gdiv_3D, make_ball_buff
!F---
!!$#ifdef FJ_TIMER
!!$  use m_Parallelization,      only : mpi_comm_group
!!$#endif
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup,  m_ES_EXX_ngpt &
       &                         , m_ES_EXX_init &
       &                         , m_ES_EXX_update, m_ES_EXX_crotylm, m_ES_EXX_ylm
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================
  use m_Ionic_System,      only  : zeta1,m_IS_natm_can_change


   use m_Control_Parameters,     only : m_CtrlP_set_init_status, read_charge_hardpart, &
        &                               use_metagga, sw_read_pwbs_info, &
        &                               sw_calc_wf_orb_projection, sw_orb_popu
   use m_OP_rotation,            only : m_OP_init_Wfn_orb_proj        
#ifdef MEMORY_SAVE_ZAJ_OLD
   use m_Control_Parameters,     only : RMM2P_is_specified
#endif
   use m_ErrorMessages
! ===================== KT_Test ========================= 12.5Exp
   use m_Control_Parameters,    only : m_CtrlP_set_hybrid_parameters, xctype, &
        &                              sw_opencore
   use m_ES_ExactExChange,      only : m_ES_EXX_set_nmax_G_hyb
   use m_PS_opencore,         only : m_PS_set_rmag_opencore, m_PS_set_pcc_opencore, &
        &                            m_PS_init_mag_opencore_pol, &
        &                            m_PS_rd_mag_opencore_pol
! ======================================================= 12.5Exp


! ================================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,   only : noncol, ndim_spinor, ndim_magmom, &
       &                             import_collinear_spindensity, &
       &                             import_collinear_wavefunctions

!  use m_Charge_Density,  only : m_CD_initCD_by_file_rsp_noncl, &
!       &                        m_CD_adjust_spindensity_noncl, &
!       &                        m_CD_initial_CD_by_Gauss_kt, &
!       &                        m_CD_wd_chgq_l_portion_noncl
!  use m_ES_LHXC,         only : m_ESlhxc_potential_noncl

!  use m_Electronic_Structure,   only : m_ES_energy_eigen_vals_noncl, &
!       &                               m_ES_energy_eigenvals_ext_noncl, &
!       &                               m_ES_alloc_zaj_etc_noncl
!  use m_ES_Ortho,               only : m_ES_modified_gramschmidt_noncl

  use m_Files,                  only : m_Files_open_nfchr_noncl
!!  use m_PseudoPotential,        only : m_PP_set_fqwei_noncl
!!  use m_ES_NonCollinear,        only :  m_ES_init_Mat_dion0_noncl, &
!!       &                                m_ES_set_Mat_q_noncl
!
!!  use m_ES_IO,                   only : m_ESIO_rd_WFs_import_frm_collin
!!  use m_Charge_Density,          only : m_CD_rd_chgq_import_frm_collin, &
!!       &                                m_CD_rd_chgq_noncl
  use m_CD_Mag_Moment,           only : m_CD_alloc_RhoMag_on_atom, &
       &                                m_CD_calc_ChgMagMom_in_sphere, &
       &                                sw_monitor_atomcharge
  use m_ES_Mag_Constraint,       only : m_ES_add_MagConstraintPot_chgql, &
       &                                m_ES_add_MagConstraintPot_hsr
  use m_Orbital_Population,      only  : m_OP_rd_occ_mat_noncl
! ===================================================================== 11.0

! ================================== added by K. Tagami =============== 11.0
  use m_Control_Parameters,      only : SpinOrbit_mode
  use m_Const_Parameters,        only : Neglected, BuiltIn, ByProjector
  use m_SpinOrbit_Potential,     only : m_SO_alloc_dsoc, &
       &                                m_SO_set_Dsoc_potential1, &
       &                                m_SO_calc_MatLS_orb_s_to_f, &
       &                                m_SO_diagonalize_MatLS, &
       &                                m_SO_set_MatU_ylm_RC
  use m_ES_NonCollinear,         only : m_ES_alloc_factor_fss, &
       &                                 m_ES_set_factor_fss

! ==================================================================== 11.0

! ================================== added by K. Tagami =============== 11.0
  use m_Const_Parameters,        only : ByPawPot, ZeffApprox
  use m_SpinOrbit_Potential,    only : m_SO_alloc_Mat_SOC_strenth, &
       &                                m_SO_set_Dsoc_potential2
  use m_SpinOrbit_RadInt,       only : m_SO_calc_SOC_strength_pawpot, &
       &                               m_SO_calc_SOC_strength_zeff, &
       &                               m_SO_check_mode_Builtin, &
       &                               m_SO_check_mode_Pawpot, &
       &                               m_SO_check_mode_Zeff
! ======================================================================= 11.0
  use m_BerryPhase,             only : m_BP_rd_cntn_data

! ============= KT_add ==================== 13.0D
  use m_Files,  only : m_Files_reopen_nfcntn_bin_paw
! ========================================= 13.0D


  use m_Const_Parameters,    only : CRYSTAL_FIELD_APPROX
  use m_Orbital_Population,  only : m_OP_occ_mat_gen_kt

! ==== EXP_CELLOPT === 2015/09/24
  use m_IterationNumbers,     only : iteration_unit_cell,iteration_stress_correction
  use m_Control_Parameters,   only :  sw_read_nfchgt_prev_cell, sw_read_nfzaj_prev_cell
! ==================== 2015/09/24

  use m_ES_dos,               only : m_ES_dos_alloc_compr_compi_ek

  implicit none
  integer :: iloop
  logical, save :: is_charge_density_read = .false.
! <--
  integer :: neg_incre

  integer :: ierror
  logical :: read_pwbs

  integer :: ispin, ik, iksnl,ib
!!$#ifdef FJ_TIMER
!!$  integer :: ierr
!!$#endif

! -----> T. Yamasaki, 11 July 2008 ---- 
  real(kind=DP) :: zeta_sum
  logical :: initialization_required
  if(.not.initialization_required()) then
!     call m_CD_softpart_3D(nfout,kv3)
!     call m_CD_hardpart(nfout,kv3)
!     call m_CD_cp_chgq_to_chgqo()
     call m_PP_gfqwei_3D(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
     call m_CtrlP_set_init_status(.false.)
     call UpdateUeff()
     if(sw_hybrid_functional == ON) then
       call m_ES_EXX_init()
       call EXX()
     endif
     return
  endif

  call UpdateUeff()

  read_pwbs = .false.
  if(sw_read_pwbs_info==ON)then
    call m_pwBS_rd_prev_pws(read_pwbs)
  endif

! ====================== KT_Test ========================= 12.5Exp
!  if(sw_hybrid_functional == ON) then
!     call m_CtrlP_set_hybrid_parameters
!     call m_ES_EXX_set_nmax_G_hyb
!  endif
! ======================================================== 12.5Exp

  if(sw_hybrid_functional == ON) call m_ES_EXX_update(ON)

  if(icond == INITIAL .or. icond==COORDINATE_CONTINUATION) then
     call m_ES_gtotch(nfout)
     if(icond == INITIAL) then
        if(totch >= neg*2.0) then
           if(ipri >= 1) then
              write(nfout,'(" ### Warning(1309): Number of bands(neg) is insufficient:")')
              write(nfout,'("                totch = ",f10.3," >= neg*2.0 = ",f10.3)') totch, neg*2.0
           end if
           if(dabs(sum(zeta1)) > 0.d0) then
              call m_CtrlP_set_neg_properly(1.3*totch) ! -> neg
           else
              call m_CtrlP_set_neg_properly(totch) ! -> neg
           end if
           call m_CntrlP_set_meg(neg)
           call m_CntrlP_set_neg(neg)
!           if(ipri >= 1) write(nfout,'(" neg (=num_bands) is enlarged ",i12)') neg
           if(ipri >= 1) write(nfout,'(" ### Warning(1309): Number of bands is enlarged",i12)') neg
           call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
           call m_Parallel_dealloc_mpi_elec()


           call m_Parallel_init_mpi_elec_3D(nfout,ipriparallel,printable,neg,kv3,nspin,kg1,iba)
           call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg &
                & , nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
           call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
           call make_ball_buff
        end if
     end if
  else if(icond == CONTINUATION) then
     if(neg_previous > neg) then
        call m_CntrlP_set_neg(neg_previous)
        call m_CntrlP_set_meg(neg)
        call m_CntrlP_set_davidson_size(neg) ! -> max_subspace_size
        call m_Parallel_dealloc_mpi_elec()


        call m_Parallel_init_mpi_elec_3D(nfout,ipriparallel,printable,neg,kv3,nspin,kg1,iba)
        call make_index_band_3D(nfout,ipriparallel,printable,kv3,neg &
             &   , nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
        call make_index_band_for_Gdiv_3D(neg, nblocksize_mgs,nblocksize_mgs_is_given,nblocksize_mgs_default)
        call make_ball_buff
        if(ipri >= 1) write(nfout,'(" neg is enlarged ",f12.5)') neg
     end if
  end if
! <------

#ifdef _INCLUDE_EXX_
  if(sw_hybrid_functional == ON) call m_ES_EXX_init()
#endif

  if(nrank_e > neg) call phase_execution_error(PARALLELIZATION_INVALID_NE)

  if(.not.skip_alloc_phonon) then
     call m_CD_alloc_hsr()
     call m_ES_alloc_vlhxc()
     call m_ES_alloc_vlhxcQ()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(30)
#endif

     call m_SO_set_MatU_ylm_RC

     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_alloc_RhoMag_on_atom
     endif

     call m_ES_alloc_zaj_etc()
! === Use extrapolation! =======================================================
     call m_ES_wf_extrpl_alloc()
! ==============================================================================

#ifdef FJ_TIMER
                    call timer_end(30)
#endif
#ifdef MEMORY_SAVE_ZAJ_OLD
     if(RMM2P_is_specified) then
#endif
     call m_ESsd_alloc_zaj_old()
#ifdef MEMORY_SAVE_ZAJ_OLD
     end if
#endif
     call m_ESsd_alloc_dzajn2()
     if(sw_hubbard == ON) call m_ES_alloc_Dhub()
     if(sw_hybrid_functional == ON) call m_ES_EXX_ngpt()
     if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
        if(ekmode == ON) then
           call m_ES_alloc_eko_ek()
        else if(ekmode == OFF .and. fixed_charge_k_parallel == ONE_BY_ONE) then
           call m_ES_alloc_eko_ek()
        end if

        if(evaluation_eko_diff == ON) then
           call m_ES_alloc_eko1()
        else if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     else
        if(delta_eigenvalue_cond_is_given) then
           call m_ES_alloc_eko1()
           call m_ES_cpeko()
        end if
     end if
     if(sw_dipole_correction == ON) then
        call m_Dipole_vdip_alloc_3D()
     end if
  end if


  if(sw_phonon == ON .and. sw_calc_force == OFF) return

!!$  call m_PP_gfqwei(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2
!!$  if(modnrm == EXECUT .and. (icond == INITIAL .or. icond == CONTINUATION)) then
  if(.not.skip_alloc_phonon) then

     if ( sw_opencore == ON .and. nspin == 2 ) then
        call m_PS_set_rmag_opencore
        call m_PS_set_pcc_opencore
     endif


     call m_PP_gfqwei_3D(nfout)  ! -> modnrm, fqwei, nlmta1, nlmta2

     if(modnrm == EXECUT ) then
        call m_pwBS_alloc_ylm_l()
        call m_pwBS_sphrp_l_3D()                           ! -> ylm_l
     end if
  end if

  if(sw_fef==ON) call m_FEF_Constract_of_ftq()

! ==== ASMS ====
  if ( sw_hybrid_functional == ON ) sw_eval_epc_on_fftmesh = ON
  if ( xctype == 'vdwdf' ) sw_eval_epc_on_fftmesh = ON
  if ( sw_opencore == ON .and. nspin == 2 ) sw_eval_epc_on_fftmesh = ON
  if ( flg_paw ) sw_eval_epc_on_fftmesh = off
  if ( sw_eval_epc_on_fftmesh == ON .and. sw_opencore == OFF ) then
     call m_XC_cal_potential_3D( nfout, Partial_Core_Charge, chgq_l, VXC_AND_EXC )
     epc = exc
  endif
! ==== ASMS ====

  if(iteration == 0) call m_TE_set_etotal_old()

  if(sw_screening_correction == ON) then
     call screening_potential
  end if
! === "phase" repository merge: To make 3D_Parallel by tkato 2011/11/10 ========
! ==============================================================================

  if(icond == INITIAL .or. icond == COORDINATE_CONTINUATION .or. &
       & (icond==FIXED_CHARGE .and. ekmode==OFF .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     if(icond /= INITIAL) call m_ES_gtotch(nfout)
     if(icond == INITIAL) call check_neg()

     !---- set a charge density ----
     if(.not.is_charge_density_read.and.(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF))) then
        call read_charge_density(condition=1)
        call read_efermi()
        if(icond==FIXED_CHARGE .and. ekmode == OFF) call copy_chgq_to_chgqo()
     else
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(30)
#endif
        if (iteration_unit_cell > 1 .and. sw_read_nfchgt_prev_cell == ON ) then
           call read_charge_density(condition=-4)
!        call m_CD_initial_CD_by_Gauss_func(nfout)   ! (intchg) -> chgq_l
#ifdef FFTW3
        else if ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
        &  kgp_prev .eq. kgp .and. sw_interpolate_charge == ON) then
           call m_CD_cp_chgq_prev_to_chgq(nfout)
        else if ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
        &  kgp_prev .ne. kgp .and. sw_interpolate_charge == ON) then
           call m_CD_gen_chgq_from_prev_chgq(nfout)
#endif
        else
          call m_CD_initial_CD_by_Gauss_kt(nfout)   ! (intchg) -> chgq_l
        endif
#ifdef FJ_TIMER
                    call timer_end(30)
#endif

     end if

     if ( sw_opencore == ON ) then
        call m_PS_init_mag_opencore_pol
        if ( sw_eval_epc_on_fftmesh == ON ) then
           call m_XC_cal_potential_3D( nfout, Partial_Core_Charge, chgq_l, EXC_ONLY )
           epc = exc
        endif
     endif

     !---- set wave functions ----
     if ( ((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and.  imdalg .ne. PT_CONTROL) .and. &
!     &  (sw_read_nfzaj_prev_cell == ON .or. is_charge_density_read)) then
     &  sw_read_nfzaj_prev_cell == ON ) then
        call read_zaj( condition =-4 )
     else if((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
     &  kg1_prev .eq. kg1 .and. sw_interpolate_wfs == ON) then
        call m_ES_cp_zaj_prev_to_zaj()
     else if((iteration_unit_cell > 1 .or. iteration_stress_correction>1) .and. &
     &  kg1_prev .ne. kg1 .and. sw_interpolate_wfs == ON) then
#ifdef FFTW3
        call m_ES_gen_zaj_from_prev_zaj(nfout)
#else
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(40)
#endif
        if ( init_zaj_para ) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        else
           call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        endif
#ifdef FJ_TIMER
                    call timer_end(40)
#endif
#endif
     else if(intzaj == by_random_numbers) then
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(40)
#endif
        if ( init_zaj_para ) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        else
           call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        endif
#ifdef FJ_TIMER
                    call timer_end(40)
#endif
     else if(intzaj == by_pseudo_atomic_orbitals) then
        call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)    ! (paozaj) -> zaj_l
     else if(intzaj == by_matrix_diagon) then

     else if(intzaj == FILE) then
        call read_zaj( condition = 1 )
! === ik is not defined here!!! by tkato 2013/02/12 ============================
!!$       call m_ES_betar_dot_WFs_3D(nfout,ik)         ! (fsrfsi)
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_betar_dot_WFs_3D(nfout,ik)         ! (fsrfsi)
       end do

        if(initial_chg == FILE .or. (icond==FIXED_CHARGE.and.ekmode==OFF)) then
        else
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(34)
#endif
           call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC)  ! -> vxc_l
#ifdef FJ_TIMER
                    call timer_end(34)
#endif
           call Local_Hartree_XC_potential()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(36)
#endif
           call m_ESiVQ_integrate_VlhxcQlm_3D(nfout) ! (lclchh) -> vlhxcQ
#ifdef FJ_TIMER
                    call timer_end(36)
#endif
           call energy_eigen_values()
           call ChargeDensity_Construction(1)
        end if
     endif

     !---- set a potential ----
     call m_XC_cal_potential_3D(nfout,Valence_plus_PC_Charge,chgq_l, VXC_AND_EXC) ! -> vxc_l
     call Local_Hartree_XC_potential()
     if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals .or. intzaj == FILE) then
        if ( sw_monitor_atomcharge == ON ) then
           call m_CD_calc_ChgMagMom_in_sphere
        endif
        if ( sw_magnetic_constraint == ON ) then
           call m_ES_add_MagConstraintPot_chgql
           call m_ES_add_MagConstraintPot_hsr
        endif
     end if
 
! === DEBUG by tkato 2014/08/14 ================================================
!    call modified_gramschmidt()
     if(intzaj /= by_matrix_diagon) call modified_gramschmidt()
! ==============================================================================
!     if(intzaj /= by_matrix_diagon) then
      if(sw_hybrid_functional == ON) call EXX()
!     end if
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(36)
#endif
     call m_ESiVQ_integrate_VlhxcQlm_3D(nfout)   ! (lclchh) -> vlhxcQ
#ifdef FJ_TIMER
                    call timer_end(36)
#endif
     if(intzaj /= by_matrix_diagon) call energy_eigen_values()

     if(iprichargedensity >= 2) call m_CD_wd_chgq_l_small_portion(nfout)
     if(icond==COORDINATE_CONTINUATION) icond = INITIAL

     if(sw_hubbard == ON) then
        if(intzaj==FILE)then
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           endif
        else 
           if(initial_occmat == FILE .or. icond==FIXED_CHARGE .or.  iteration_unit_cell > 1) then
              call read_occ_mat() ! -> om
           else if (sw_initial_es==ON)then
              call ChargeDensity_Construction(1)
              call Renewal_of_OccMat(.false.,ON, .false.)
           else
              if ( initial_occmat == CRYSTAL_FIELD_APPROX ) then
                 call m_OP_occ_mat_gen_kt(nfout) ! -> om
              else
                 call m_OP_occ_mat_init(nfout) ! -> om
              endif
           end if
        endif
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if

  else if(icond == CONTINUATION .or. &
       & (icond==FIXED_CHARGE_CONTINUATION .and. ekmode==OFF &
       & .and. fixed_charge_k_parallel == ALL_AT_ONCE)) then
     call m_Files_open_nfcntn_bin
     call m_ESIO_rd_EigenValues_etc(nfout,nfcntn_bin,F_CNTN_BIN_in_partitioned)
!!$     call m_ESIO_wd_EigenValues(nfout,2,nooccupation=NO)
     call m_Files_open_nfzaj()
     if(read_pwbs)then
       call m_ES_alloc_zaj_l_prev(np_g1k_prev)
     endif
     call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned,read_pwbs)
#ifdef FFTW3
     if(read_pwbs)then
       call m_ES_gen_zaj_from_prev_zaj(nfout)
       call modified_gramschmidt()
     endif
#endif
     if(neg_previous < neg) then
        if ( init_zaj_para ) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        else
           call m_ESIW_by_randomnumbers0_3D(nfout,kv3,1,neg)      ! (rndzaj) -> zaj_l
        endif
     end if
     call read_charge_density(condition = 2)
     if(flg_paw) call m_CD_rd_hsr(nfcntn_bin_paw)
     if ( use_metagga ) call read_ekindens()
     if ( sw_opencore == ON ) then
        call m_PS_rd_mag_opencore_pol
        if ( sw_eval_epc_on_fftmesh == ON ) then
           call m_XC_cal_potential_3D( nfout, Partial_Core_Charge, chgq_l, EXC_ONLY )
           epc = exc
        endif
     endif

     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_calc_ChgMagMom_in_sphere
     endif

     if(icond /= CONTINUATION) call read_efermi()

     do ik = 1, kv3, af+1
        if(map_k(ik) /= myrank_k) cycle         ! MPI
        call m_ES_betar_dot_WFs_3D(nfout,ik)            ! (fsrfsi) ->fsr_l
     end do
     if(sw_hybrid_functional == ON) call EXX()

     if(neg_previous < neg) then
        call modified_gramschmidt()
        call m_ES_energy_eigen_values_ext_3D(nfout)
     end if
     call Renewal_of_Potential()
     if(sw_hubbard == ON) then
        call read_occ_mat()    ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond==FIXED_CHARGE_CONTINUATION .and. ekmode == OFF) then
        call copy_chgq_to_chgqo()
        if(sw_hubbard == ON) call m_OP_cp_ommix_to_omold()
     end if

  else if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     call m_ES_gtotch(nfout)

     call read_charge_density(condition = 2)
     if(flg_paw.and.ekmode/=OFF) call m_CD_rd_hsr(nfcntn_bin_paw)
     if ( use_metagga ) call read_ekindens()
     if ( sw_opencore == ON ) then
        call m_PS_rd_mag_opencore_pol
        if ( sw_eval_epc_on_fftmesh == ON ) then
           call m_XC_cal_potential_3D( nfout, Partial_Core_Charge, chgq_l, EXC_ONLY )
           epc = exc
        endif
     endif

     if ( sw_monitor_atomcharge == ON ) then
        call m_CD_calc_ChgMagMom_in_sphere
     endif

     call read_efermi()

     if(sw_hybrid_functional == ON) call EXX()
     call Renewal_of_Potential()
     if(sw_hubbard==ON) then
        call read_occ_mat() ! -> om
        call m_OP_mix_om(1.d0) ! om -> ommix
        call Renewal_of_Hubbard_Potential() ! ommix -> dhub
     end if
     if(icond == FIXED_CHARGE_CONTINUATION .and. nk_in_the_process >= 2) call m_Files_skiptoend(nfeng)
     if(icond == FIXED_CHARGE_CONTINUATION .and. sw_berry_phase == ON ) call m_BP_rd_cntn_data()
     if(sw_pdos == ON) then
        call m_ES_dos_alloc_compr_compi_ek()
     endif
  endif

  if (icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) then
     if ( sw_orb_popu == ON .and. sw_calc_wf_orb_projection == ON ) then
        call m_OP_init_Wfn_orb_proj(nfout)
     endif
  endif
     
  call m_CtrlP_set_init_status(.false.)

contains
  subroutine read_charge_density(condition)
    use m_Files,              only : m_Files_open_nfchr
    use m_Charge_Density,     only : m_CD_rd_chgq &
         &                         , m_CD_initial_CD_by_file_rspace &
         &                         , m_CD_adjust_spindensity
    integer, intent(in) :: condition
    integer :: ispin
    integer :: iloop

    call m_Files_open_nfchgt()
!!$    write(6,'( " icond = ",i8, " condition = ", i8,"  (read_charge_density)")') icond,condition
    is_charge_density_read = .true.
    if(condition == 1) then
       if(sw_initial_charge_rspace == ON) then
             do iloop = 1, nspin
                call m_Files_open_nfchr(nspin,iloop)
                call m_CD_initial_CD_by_file_rspace(nspin,iloop,nfout,nfchr)
             end do
       else
             call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned,read_pwbs)
          if ( flg_paw .and. read_charge_hardpart == YES .and. m_Files_nfcntn_bin_paw_exists()) then
             call m_Files_open_nfcntn_bin_paw()
             call m_PP_rd_PAW_parameters(nfout,nfcntn_bin_paw)
             call m_CD_rd_hsr(nfcntn_bin_paw)
             call m_Files_close_nfcntn_bin_paw()
          endif
       end if

          call m_CD_adjust_spindensity(nfout)

    else if(condition == 2) then
          call m_CD_rd_chgq(nfout,nfchgt,F_CHGT_in_partitioned,read_pwbs)
!!$       if ( flg_paw .and. ) then
!!$          call m_CD_rd_hsr(nfcntn_bin_paw)
!!$       endif

    else if(condition == -4) then      ! coordinate-continuation
!
    end if

  end subroutine read_charge_density
 
  subroutine read_ekindens
    use m_Files,  only :  m_Files_open_nf_ekindens, m_Files_close_nf_ekindens
    use m_KineticEnergy_Density, only : m_KE_rd_ekindens

    call m_Files_open_nf_ekindens
    call m_KE_rd_ekindens()
    call m_Files_close_nf_ekindens

  end subroutine read_ekindens

  subroutine read_efermi()
    use m_Files,              only : nfout,m_Files_open_nfefermi, m_Files_close_nfefermi
    use m_ES_IO,              only : m_ESIO_rd_Efermi

    call m_Files_open_nfefermi()
    call m_ESIO_rd_Efermi(nfout,nfefermi)
    call m_Files_close_nfefermi()
  end subroutine read_efermi

  subroutine copy_chgq_to_chgqo()
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
        call timer_sta(30)
#endif
    call m_CD_cp_chgq_to_chgqo()
#ifdef FJ_TIMER
        call timer_end(30)
#endif
  end subroutine copy_chgq_to_chgqo

  subroutine Local_Hartree_XC_potential()
    use m_ES_LHXC,            only : m_ESlhxc_potential_3D
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(35)
#endif
    call m_ESlhxc_potential_3D(nfout,chgq_l,vxc_l) ! (stlhxc) ->vlhxc_l
#ifdef FJ_TIMER
                    call timer_end(35)
#endif
  end subroutine Local_Hartree_XC_potential

  subroutine energy_eigen_values()
    use m_Electronic_Structure,   only : m_ES_energy_eigen_values_3D
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(33)
#endif
    call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
#ifdef FJ_TIMER
                    call timer_end(33)
#endif
  end subroutine energy_eigen_values

  subroutine modified_gramschmidt()
    use m_ES_ortho,           only : m_ES_modified_gram_schmidt
#ifdef FJ_TIMER
!                    call mpi_barrier(mpi_comm_group, ierr)
                    call timer_sta(32)
#endif
       call m_ES_modified_gram_schmidt(nfout) ! ->zaj_l, fsr_l,fsi_l
#ifdef FJ_TIMER
                    call timer_end(32)
#endif
  end subroutine modified_gramschmidt

  subroutine EXX()
    use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
         &                         , m_ES_EXX_occup  &
         &                         , sw_rspace_hyb, m_ES_EXX_init0 &
         &                         , m_ES_EXX_ylm, m_ES_EXX_crotylm
    call m_ES_EXX_init0()
    if(modnrm == EXECUT ) then
       if(sw_rspace_hyb==OFF) call m_ES_EXX_ylm()
       call m_ES_EXX_crotylm()
    end if
    call m_ES_EXX_occup(nfout)
    call m_ES_EXX_gather_valence_states(nfout)
    call m_ES_EXX_kernel(nfout)
  end subroutine EXX

  subroutine read_occ_mat()
    use m_Orbital_Population,      only  : m_OP_rd_occ_mat
       call m_OP_rd_occ_mat(nfout) ! -> om
  end subroutine read_occ_mat

  subroutine read_zaj( condition )
    use m_ES_IO,                   only : m_ESIO_import_WFs_prev_cell
    use m_Parallelization,         only : np_g1k_prev
    use m_Electronic_Structure,    only : m_ES_alloc_zaj_l_prev
    use m_PlaneWaveBasisSet,       only : kg1_prev
    integer, intent(in) :: condition

    call m_Files_open_nfzaj()

    if ( condition == 1 ) then
          if(read_pwbs)then
            call m_ES_alloc_zaj_l_prev(np_g1k_prev)
          endif
          call m_ESIO_rd_WFs(nfout,nfzaj,F_ZAJ_in_partitioned,read_pwbs)
#ifdef FFTW3
          if(read_pwbs)then
            call m_ES_gen_zaj_from_prev_zaj(nfout)
            call modified_gramschmidt()
          endif
#endif

    else if ( condition == -4 ) then       ! coordinate-continuation
       call m_ESIO_import_WFs_prev_cell(nfout,nfzaj,F_ZAJ_in_partitioned)
    endif

  end subroutine read_zaj

  subroutine check_neg()
    if(totch >= neg*2.0) then
       if(ipri >= 1) write(nfout,'(" This job stops because totch = ",f12.5, " > neg*2.0 = ",f12.5)') &
            & totch, neg*2.0
       stop ' totch > neg*2.0'
    end if
  end subroutine check_neg
end subroutine Initial_Electronic_Structure

subroutine Initial_WaveFunctions_ek
!                           @(#)Initial_Electronic_Structure.f90 1.4 03/02/19 00:43:18
  use m_Const_Parameters,   only : FIXED_CHARGE, FIXED_CHARGE_CONTINUATION &
       &                         , by_random_numbers, by_matrix_diagon, YES, ON, OFF &
       &                         , by_pseudo_atomic_orbitals
  use m_IterationNumbers,   only : nk_in_the_process &
       &                         , first_kpoint_in_this_job &
       &                         , iteration_electronic &
       &                         , m_Iter_reset_iter_electronic
  use m_Control_Parameters, only : ekmode,icond,intzaj,evaluation_eko_diff &
       &                         , ipri,ipriekzaj, sw_ekzaj,neg, printable, numk_zajsaved &
       &                         , sw_hybrid_functional, kimg
  use m_Files,              only : nfout,nfzaj, m_Files_open_nfzaj, m_Files_open_nfzaj_append
  use m_Kpoints,            only : kv3, kv3_ek, vkxyz, vkxyz_ek
  use m_Electronic_Structure,only: m_ES_energy_eigen_values_3D &
       &                         , m_ES_cpeko &
       &                         , m_ES_wd_zaj_small_portion0
  use m_ES_nonlocal,        only : m_ES_betar_dot_WFs_3D
  use m_ES_ortho,           only : m_ES_modified_gram_schmidt
  use m_ES_initialWF,       only : m_ESIW_by_randomnumbers_3D &
       &                         , m_ESIW_by_atomic_orbitals
  use m_ES_IO,              only : m_ESIO_rd_WFs_and_EVs_ek
  use m_ES_ExactExchange,  only  : m_ES_EXX_gather_valence_states, m_ES_EXX_kernel &
       &                         , m_ES_EXX_occup

! =========================================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,   only : noncol, ndim_magmom
  use m_Control_Parameters,   only : af
  use m_Parallelization,      only : myrank_k, map_k
! ========================================================================= 11.0

  implicit none
  integer :: ik

  if(printable) write(nfout,'("!! icond, nk_in_the_process, first_kpoint_in_this_job = ",3i8)') &
       & icond, nk_in_the_process, first_kpoint_in_this_job
  if(ekmode == ON) then
     if(icond == FIXED_CHARGE &
          & .or. (icond == FIXED_CHARGE_CONTINUATION &
          &         .and. nk_in_the_process /= first_kpoint_in_this_job)) then
        if(sw_ekzaj == OFF) then
           if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
              if(nk_in_the_process==1)then
                 if(intzaj == by_random_numbers) then
                    call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
                 else
                    call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
                 end if
              endif
              do ik = 1, kv3, af+1
                 if(map_k(ik) /= myrank_k) cycle
                 call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
              end do

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
!
              call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ======================================================================== 11.0

              if(sw_hybrid_functional == ON) then
                 call m_ES_EXX_occup(nfout)
                 call m_ES_EXX_gather_valence_states(nfout)
                 call m_ES_EXX_kernel(nfout)
              end if

! ======================================= modified by K. Tagami ========== 11.0
!              call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
!
              call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ======================================================================= 11.0

              if(intzaj == by_matrix_diagon) then

              end if
           end if
           if(icond == FIXED_CHARGE_CONTINUATION.and.iteration_electronic == 0) &
                & call m_Files_open_nfzaj_append()
        else
           call m_Files_open_nfzaj()
           call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj) ! -> zaj_l,eko_l,neordr
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do
        end if
     else if (icond == FIXED_CHARGE_CONTINUATION &
          & .and. nk_in_the_process == first_kpoint_in_this_job) then
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        do ik = 1, kv3, af+1
           if(map_k(ik) /= myrank_k) cycle
           call m_ES_betar_dot_WFs_3D(nfout,ik)
        end do
     else
        stop ' icond is illegal (Initial_Electronic_Structure_ek)'
     end if
  else if(ekmode == OFF) then
     if(ipri>=1) write(nfout,'(" kv3 = ",i8)') kv3
     if(icond == FIXED_CHARGE_CONTINUATION .and. first_kpoint_in_this_job == nk_in_the_process) then
        if(ipri>=1) write(nfout,'("!! icond = ",i8)') icond
        call m_Files_open_nfzaj()
        call m_ESIO_rd_WFs_and_EVs_ek(nfout,nfzaj)
        if(nk_in_the_process+kv3-1 > numk_zajsaved) then
           call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do

! ================================ modified by K. Tagami ==================== 11.0
!          call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ========================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================= modified by K. Tagami =============== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
          call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ====================================================================== 11.0

        else
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)
           end do
        end if
        call m_ES_wd_zaj_small_portion0(" -- Initial_WF_ek --",20)
     else
        if(icond==FIXED_CHARGE) then
           call m_Files_open_nfzaj()
        else
           call m_Files_open_nfzaj_append()
        end if
        if(intzaj == by_random_numbers .or. intzaj == by_pseudo_atomic_orbitals) then
           if(intzaj == by_random_numbers) then
              call m_ESIW_by_randomnumbers_3D(nfout,kv3,1,neg)! (rndzaj) -> zaj_l
           else
              call m_ESIW_by_atomic_orbitals(nfout,kv3,1,neg)! (paozaj) -> zaj_l
           end if
           do ik = 1, kv3, af+1
              if(map_k(ik) /= myrank_k) cycle
              call m_ES_betar_dot_WFs_3D(nfout,ik)     ! (fsrfsi,sumset)
           end do

! =========================================== modified by K. Tagami =========== 11.0
!           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
           call m_ES_modified_gram_schmidt(nfout) ! (grmsmd)
! ============================================================================== 11.0

           if(sw_hybrid_functional == ON) then
              call m_ES_EXX_occup(nfout)
              call m_ES_EXX_gather_valence_states(nfout)
              call m_ES_EXX_kernel(nfout)
           end if

! ================================ modifie by K. Tagami ==================== 11.0
!           call m_ES_energy_eigen_values(nfout)   ! (eigen0) -> eko_l,neordr
           call m_ES_energy_eigen_values_3D(nfout)   ! (eigen0) -> eko_l,neordr
! ======================================================================== 11.0

        end if
        if(intzaj == by_matrix_diagon .or. ipriekzaj == 0) &
             & call m_Iter_reset_iter_electronic(nfout)
     end if
  end if
  if(evaluation_eko_diff == YES) call m_ES_cpeko()
end subroutine Initial_WaveFunctions_ek

!=======================================================================
!
!  PROGRAM  PHASE/0 2014.01 (rev.375)
!
!  "First-principles Electronic Structure Calculation Program"
!
!  PROGRAM: dipole_strength_tensor
!
!  AUTHOR(S):  H. Momida
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!   The original version of this set of the computer programs "PHASE" was developed by 
!  the members of the Theory Group of Joint Research Center for Atom Technology 
!  (JRCAT), based in Tsukuba, in the period 1993-2001.  
!   Since 2002, this program set had been intensively developed as a part of the following 
!  national projects supported by the Ministry of Education, Culture, Sports, Science and 
!  Technology (MEXT) of Japan; "Frontier Simulation Software for Industrial Science 
!  (FSIS)" from 2002 to 2005, "Revolutionary Simulation Software (RSS21)" from 2006 to 
!  2008. "Research and Development of Innovative Simulation Software (RISS)" from 2008 
!  to 2013. These projects is lead by the Center for Research on Innovative Simulation 
!  Software (CISS), the Institute of Industrial Science (IIS), the University of Tokyo.
!   Since 2013, this program set has been further developed centering on PHASE System 
!  Consortium. 
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
program dipole_strength_tensor
implicit none
integer :: nt,ndata,i,j,omega_max,id
real*8 :: epsilon,gamma,dt,time,dipl,tmp,omega_delta,time_delta,fac,pi
real*8,allocatable,dimension(:) :: t,omega
real*8,allocatable,dimension(:,:) :: c,d
complex*16,allocatable,dimension(:,:) :: d_w,alpha,S
complex*16,parameter :: zi=(0.0d0,1.0d0)
character(len=2) :: ctmp2

!==== parameters
pi=acos(-1.0d0)

!==== input parameters
!!time_delta=(0.002d-15)/(2.418884327d-17)    !! input parameter (time step)
!time_delta=0.1                             !! input parameter (time step)
!epsilon=0.01      !! input parameter (magnitude of impulse electric filed)

!==== input and output files
open(10,file='j.data',status='old')
open(11,file='j.out',status='unknown')
open(12,file='p.out',status='unknown')
open(13,file='pw.out',status='unknown')
open(14,file='abs.out',status='unknown')

!-- read input (current density)
!read(10,*)
!read(10,*) nt,ndata
ndata=3
read(10,*) time_delta,epsilon
read(10,*) nt
allocate(t(nt),c(nt,3),d(nt,3)); t=0.0d0; c=0.0d0; d=0.0d0
do i=1,nt
  time=(i-1)*time_delta
  t(i)=time
  read(10,*) ctmp2,(c(i,id),id=1,3)
enddo

!-- write input (current density)
write(11,'(''time(au) total current(x,y,z) (au)'')')
write(11,'(2i8)') nt,ndata+1
do i=1,nt
  write(11,'(4f15.8)') t(i),(c(i,id),id=1,3)
enddo

!-- calculate dipole difference d(t)-d(0)
!! trapezoidal
do id=1,3
  d(1,id)=c(1,id)*(t(2)-t(1))*0.5d0
  do i=2,nt-1
    d(i,id)=d(i-1,id)+c(i,id)*(t(i+1)-t(i))
  enddo
  d(nt,id)=d(nt-1,id)+c(nt,id)*(t(nt)-t(nt-1))*0.5d0
enddo
!! simpson
!do id=1,3
!  d(1,id)=c(1,id)*time_delta/3.0d0
!  do i=2,nt-1
!    if(mod(i,2)==1) fac=2.0d0
!    if(mod(i,2)==0) fac=4.0d0
!    d(i,id)=d(i-1,id)+fac*c(i,id)*time_delta/3.0d0
!  enddo
!  d(nt,id)=d(nt-1,id)+c(nt,id)*time_delta/3.0d0
!enddo

!-- shift dipole difference
write(*,'(''# induced average dipole'')')
do id=1,3
tmp=sum(d(1:nt,id))/dble(nt)
write(*,'(''id='',i2,'' P-shift='',f15.8)') id,tmp
do i=1,nt
  d(i,id)=d(i,id)-tmp
enddo
enddo

!-- write dipole difference
write(12,'(''time(au) dipole difference(x,y,z) (au)'')')
write(12,'(2i8)') nt,ndata+1
do i=1,nt
  write(12,'(4f15.8)') t(i),(d(i,id),id=1,3)
enddo

!-- set frequency window, dumping factor = gamma
gamma=0.00001d0
omega_delta=0.0005d0
omega_max=4000
allocate(omega(0:omega_max)); omega=0.0d0
do j=0,omega_max
  omega(j)=j*omega_delta
enddo

!-- Fourier transform from TIME(t) to FREQUENCY(omega)
allocate(d_w(0:omega_max,3)); d_w=(0.0d0,0.0d0)
do id=1,3
  do j=0,omega_max
  do i=1,nt
!! P(t) -> P(w) : P(w)=a(w)*E(w)
    d_w(j,id)=d_w(j,id) &
  & +cdexp(zi*omega(j)*t(i))*dexp(-gamma*t(i)*t(i))*d(i,id)*time_delta
!----
!! J(t) -> J(w) * J(w)=a(w)*E(w)
!   d_w(j,id)=d_w(j,id) &
! & +cdexp(zi*omega(j)*t(i))*dexp(-gamma*t(i)*t(i))*(-c(i,id))*time_delta
  enddo
  enddo
enddo

!-- write Fourier transform of dipole difference
write(13,'(''omega(au) FT of dipole difference(x,y,z) (au)'')')
write(13,'(2i8)') omega_max+1,2*ndata+1
do i=0,omega_max
  write(13,'(7f15.8)') omega(i),(d_w(i,id),id=1,3)
enddo

!-- calculate dynamic polarizability(omega)
allocate(alpha(0:omega_max,3)); alpha=0.0d0
do id=1,3
  do j=0,omega_max
    alpha(j,id)=-d_w(j,id)/epsilon
  enddo
enddo

!-- calculate dipole strength(omega)
allocate(S(0:omega_max,3)); S=0.0d0
do id=1,3
  do j=0,omega_max
    S(j,id)=2.0d0/pi*omega(j)*alpha(j,id)
  enddo
enddo

!-- write alpha(omega) or S(omega)
write(14,'(''omega(au) dynamic polarizability(x,y,z)(au)'')')
write(14,'(i8,''  7'')') omega_max+1
do j=0,omega_max
! write(14,'(7f15.8)') omega(j),(alpha(j,id),id=1,3)
! write(14,'(7f15.8)') omega(j),(S(j,id),id=1,3)
  write(14,'(4f15.8)') omega(j),(imag(S(j,id)),id=1,3)
enddo

deallocate(t,c,d,alpha,S,omega,d_w)
close(10); close(11); close(12); close(13)
end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: rdecomp, rsolve, cdecomp, csolve, csolve2,  rg_eispack, 
!           balanc, balbak, cdiv, elmhes, eltran, hqr, hqr2, cg_eispack,
!           cbabk2, cbal, comqr, comqr2, corth, csroot, mltpha4, 
!          decide_alpha, rmm3_uda, rmm2_uda,  crmm2_uda, crmm3_uda,
!
!  AUTHOR(S): T. Uda, T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!  $Id: rmmsubs.F 570 2017-04-21 20:34:50Z yamasaki $
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rdecomp(n,a,w,ip,ier)
c     $Id: rmmsubs.F 570 2017-04-21 20:34:50Z yamasaki $
c                       rmmsubs.f 1.2 99/06/04 21:17:36
c                       rmmsubs.f 1.3 03/02/20 18:35:31
c     rmm routine is available for systems
c                        with inversion symmetry or
c                        GAMMA point sampling  
c
c***********************************************
c*    LU decomposition of real matrix a(n,n)
c***********************************************
      real*8 a(n,n),w(n)
      real*8 al
      real*8 eps
      integer ip(n)
      integer ier
c     parameter(eps=1.0d-75)
      parameter(eps=1.0d-30)
#ifdef __TIMER_SUB__
      call timer_sta(1135)
#endif

      do k=1,n
         ip(k)=k
      end do

      do k=1,n
         l=k
         al=abs(a(ip(l),k))
#ifdef __TIMER_DO__
      call timer_sta(1182)
#endif
	      do i=k+1,n
		 if(abs(a(ip(i),k)).gt.al) then
		    l=i
		    al=abs(a(ip(l),k))
		 end if
	      end do
#ifdef __TIMER_DO__
      call timer_end(1182)
#endif

      if(l.ne.k) then
         lv=ip(k)
         ip(k)=ip(l)
         ip(l)=lv
      end if

      if(dabs(a(ip(k),k)).lt.eps) then ! This matrix is singular.
c        write(6,*) 'dabs(a(ip(k),k))',dabs(a(ip(k),k))
         ier = 1 
         return
      end if

c** Gaussian elimination **
      a(ip(k),k)=1.0d0/a(ip(k),k)

#ifdef __TIMER_DO__
      call timer_sta(1183)
#endif
	      do i=k+1,n

		 a(ip(i),k)=a(ip(i),k)*a(ip(k),k)

		      do j=k+1,n
			 w(j)=a(ip(i),j)-a(ip(i),k)*a(ip(k),j)
		      end do

		      do j=k+1,n
			 a(ip(i),j)=w(j)
		      end do
	      end do
#ifdef __TIMER_DO__
      call timer_end(1183)
#endif
      end do
#ifdef __TIMER_SUB__
      call timer_end(1135)
#endif
         ier = 0 ! normal return
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rsolve(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c***************************************
c*    Solve the linear equation.
c*    matrix a(n,n) must be LU-decomposed
c*    before the calling of this routine.
c***************************************

      real*8 a(n,n),b(n,m),x(n,m)
      integer ip(n)

      real*8 t
#ifdef __TIMER_SUB__
      call timer_sta(1136)
#endif

#ifdef __TIMER_DO__
      call timer_sta(1184)
#endif
      do k=1,m
         do i=1,n
            t=b(ip(i),k)
            do j=1,i-1
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t
         end do
      end do
#ifdef __TIMER_DO__
      call timer_end(1184)
#endif

#ifdef __TIMER_DO__
      call timer_sta(1185)
#endif
      do k=1,m
         do i=n,1,-1
            t=x(i,k)
            do j=i+1,n
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t*a(ip(i),i)
         end do
      end do
#ifdef __TIMER_DO__
      call timer_end(1185)
#endif

#ifdef __TIMER_SUB__
      call timer_end(1136)
#endif
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine cdecomp(n,a,w,ip,ier)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c***********************************************
c*    LU decomposition of complex matrix a(n,n)
c***********************************************
      complex*16 a(n,n),w(n)
      real*8 al
      real*8 eps
      integer ip(n)
      integer ier 
      parameter(eps=1.0d-10)

      do k=1,n
         ip(k)=k
      end do

      do k=1,n
         l=k
         al=cdabs(a(ip(l),k))
	      do i=k+1,n
		 if(cdabs(a(ip(i),k)).gt.al) then
		    l=i
		    al=cdabs(a(ip(l),k))
		 end if
	      end do

      if(l.ne.k) then
         lv=ip(k)
         ip(k)=ip(l)
         ip(l)=lv
      end if

      if(cdabs(a(ip(k),k)).lt.eps) then ! This matrix is singular.
         ier = 1 
         return
      end if

c** Gaussian elimination **
      a(ip(k),k)=1.0d0/a(ip(k),k)

	      do i=k+1,n

		 a(ip(i),k)=a(ip(i),k)*a(ip(k),k)

		      do j=k+1,n
			 w(j)=a(ip(i),j)-a(ip(i),k)*a(ip(k),j)
		      end do

		      do j=k+1,n
			 a(ip(i),j)=w(j)
		      end do
	      end do
      end do
         ier = 0 ! normal return
      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine csolve(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c******************************************************
c*    Solve the linear equation.
c*    The complex matrix a(n,n) must be LU-decomposed
c*    before calling this routine.
c******************************************************
      complex*16 a(n,n),b(n,m),x(n,m)
      integer ip(n)

      complex*16 t

      do k=1,m
         do i=1,n
            t=b(ip(i),k)
            do j=1,i-1
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t
         end do
      end do

      do k=1,m
         do i=n,1,-1
            t=x(i,k)
            do j=i+1,n
               t=t-a(ip(i),j)*x(j,k)
            end do
            x(i,k)=t*a(ip(i),i)
         end do
      end do

      return
      end

c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine csolve2(n,m,a,b,x,ip)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
c******************************************************
c*    Solve the linear equation.
c*    The complex matrix a(n,n) must be LU-decomposed
c*    before calling this routine.
c******************************************************
      real*8 a(n,n,2),b(n,m,2),x(n,m,2)
      integer ip(n)

      complex*16 t, q

      do k=1,m
         do i=1,n
            t=dcmplx(b(ip(i),k,1),b(ip(i),k,2))
            do j=1,i-1
               t=t-dcmplx(a(ip(i),j,1),a(ip(i),j,2)) 
     &             *  dcmplx(x(j,k,1),x(j,k,2))
            end do
            x(i,k,1) = dreal(t)
            x(i,k,2) = dimag(t)
         end do
      end do

      do k=1,m
         do i=n,1,-1
            t=dcmplx(x(i,k,1),x(i,k,2))
            do j=i+1,n
               t=t - dcmplx(a(ip(i),j,1),a(ip(i),j,2))
     &              *dcmplx(x(j,k,1),    x(j,k,2))
            end do
            q = t*dcmplx(a(ip(i),i,1),a(ip(i),i,2))
            x(i,k,1) = dreal(q)
            x(i,k,2) = dimag(q)
         end do
      end do

      return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine rg_eispack(nm,n,a,wr,wi,matz,z,iv1,fv1,ierr)
      integer n,nm,is1,is2,ierr,matz
      double precision a(nm,n),wr(n),wi(n),z(nm,n),fv1(n)
      integer iv1(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a real general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a.
c
c        a  contains the real general matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.  complex conjugate
c        pairs of eigenvalues appear consecutively with the
c        eigenvalue having the positive imaginary part first.
c
c        z  contains the real and imaginary parts of the eigenvectors
c        if matz is not zero.  if the j-th eigenvalue is real, the
c        j-th column of  z  contains its eigenvector.  if the j-th
c        eigenvalue is complex with positive imaginary part, the
c        j-th and (j+1)-th columns of  z  contain the real and
c        imaginary parts of its eigenvector.  the conjugate of this
c        vector is the eigenvector for the conjugate eigenvalue.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for hqr
c           and hqr2.  the normal completion code is zero.
c
c        iv1  and  fv1  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  balanc(nm,n,a,is1,is2,fv1)
      call  elmhes(nm,n,is1,is2,a,iv1)
      if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  hqr(nm,n,is1,is2,a,wr,wi,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  eltran(nm,n,is1,is2,a,iv1,z)
      call  hqr2(nm,n,is1,is2,a,wr,wi,z,ierr)
      if (ierr .ne. 0) go to 50
      call  balbak(nm,n,is1,is2,fv1,n,z)
   50 return
      end
      subroutine balanc(nm,n,a,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision a(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a real matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        a contains the input matrix to be balanced.
c
c     on output
c
c        a contains the balanced matrix.
c
c        low and igh are two integers such that a(i,j)
c          is equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j),      j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in balance appears in
c     balanc  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = a(i,j)
         a(i,j) = a(i,m)
         a(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = a(j,i)
         a(j,i) = a(m,i)
         a(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
         j = l + 1 - jj
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (a(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (a(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + dabs(a(j,i))
            r = r + dabs(a(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
  250    a(i,j) = a(i,j) * g
c
         do 260 j = 1, l
  260    a(j,i) = a(j,i) * f
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end
      subroutine balbak(nm,n,low,igh,scale,m,z)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),z(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a real general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  balanc.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  balanc.
c
c        scale contains information determining the permutations
c          and scaling factors used by  balanc.
c
c        m is the number of columns of z to be back transformed.
c
c        z contains the real and imaginary parts of the eigen-
c          vectors to be back transformed in its first m columns.
c
c     on output
c
c        z contains the real and imaginary parts of the
c          transformed eigenvectors in its first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
  100    z(i,j) = z(i,j) * s
c
  110 continue
c     ......... for i=low-1 step -1 until 1,
c               igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = scale(i)
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = z(i,j)
            z(i,j) = z(k,j)
            z(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end
      subroutine cdiv(ar,ai,br,bi,cr,ci)
      double precision ar,ai,br,bi,cr,ci
c
c     complex division, (cr,ci) = (ar,ai)/(br,bi)
c
      double precision s,ars,ais,brs,bis
      s = dabs(br) + dabs(bi)
      ars = ar/s
      ais = ai/s
      brs = br/s
      bis = bi/s
      s = brs**2 + bis**2
      cr = (ars*brs + ais*bis)/s
      ci = (ais*brs - ars*bis)/s
      return
      end
      subroutine elmhes(nm,n,low,igh,a,int)
c
      integer i,j,m,n,la,nm,igh,kp1,low,mm1,mp1
      double precision a(nm,n)
      double precision x,y
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmhes,
c     num. math. 12, 349-368(1968) by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a real general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     stabilized elementary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the input matrix.
c
c     on output
c
c        a contains the hessenberg matrix.  the multipliers
c          which were used in the reduction are stored in the
c          remaining triangle under the hessenberg matrix.
c
c        int contains information on the rows and columns
c          interchanged in the reduction.
c          only elements low through igh are used.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         mm1 = m - 1
         x = 0.0d0
         i = m
c
         do 100 j = m, igh
            if (dabs(a(j,mm1)) .le. dabs(x)) go to 100
            x = a(j,mm1)
            i = j
  100    continue
c
         int(m) = i
         if (i .eq. m) go to 130
c     .......... interchange rows and columns of a ..........
         do 110 j = mm1, n
            y = a(i,j)
            a(i,j) = a(m,j)
            a(m,j) = y
  110    continue
c
         do 120 j = 1, igh
            y = a(j,i)
            a(j,i) = a(j,m)
            a(j,m) = y
  120    continue
c     .......... end interchange ..........
  130    if (x .eq. 0.0d0) go to 180
         mp1 = m + 1
c
         do 160 i = mp1, igh
            y = a(i,mm1)
            if (y .eq. 0.0d0) go to 160
            y = y / x
            a(i,mm1) = y
c
            do 140 j = m, n
  140       a(i,j) = a(i,j) - y * a(m,j)
c
            do 150 j = 1, igh
  150       a(j,m) = a(j,m) + y * a(j,i)
c
  160    continue
c
  180 continue
c
  200 return
      end
      subroutine eltran(nm,n,low,igh,a,int,z)
c
      integer i,j,n,kl,mm,mp,nm,igh,low,mp1
      double precision a(nm,igh),z(nm,n)
      integer int(igh)
c
c     this subroutine is a translation of the algol procedure elmtrans,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine accumulates the stabilized elementary
c     similarity transformations used in the reduction of a
c     real general matrix to upper hessenberg form by  elmhes.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        a contains the multipliers which were used in the
c          reduction by  elmhes  in its lower triangle
c          below the subdiagonal.
c
c        int contains information on the rows and columns
c          interchanged in the reduction by  elmhes.
c          only elements low through igh are used.
c
c     on output
c
c        z contains the transformation matrix produced in the
c          reduction by  elmhes.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
c     .......... initialize z to identity matrix ..........
      do 80 j = 1, n
c
         do 60 i = 1, n
   60    z(i,j) = 0.0d0
c
         z(j,j) = 1.0d0
   80 continue
c
      kl = igh - low - 1
      if (kl .lt. 1) go to 200
c     .......... for mp=igh-1 step -1 until low+1 do -- ..........
      do 140 mm = 1, kl
         mp = igh - mm
         mp1 = mp + 1
c
         do 100 i = mp1, igh
  100    z(i,mp) = a(i,mp-1)
c
         i = int(mp)
         if (i .eq. mp) go to 140
c
         do 130 j = mp, igh
            z(mp,j) = z(i,j)
            z(i,j) = 0.0d0
  130    continue
c
         z(i,mp) = 1.0d0
  140 continue
c
  200 return
      end
      double precision function epslon (x)
      double precision x
c
c     estimate unit roundoff in quantities of size x.
c
      double precision a,b,c,eps
c
c     this program should function properly on all systems
c     satisfying the following two assumptions,
c        1.  the base used in representing floating point
c            numbers is not a power of three.
c        2.  the quantity  a  in statement 10 is represented to 
c            the accuracy used in floating point variables
c            that are stored in memory.
c     the statement number 10 and the go to 10 are intended to
c     force optimizing compilers to generate code satisfying 
c     assumption 2.
c     under these assumptions, it should be true that,
c            a  is not exactly equal to four-thirds,
c            b  has a zero for its last bit or digit,
c            c  is not exactly equal to one,
c            eps  measures the separation of 1.0 from
c                 the next larger floating point number.
c     the developers of eispack would appreciate being informed
c     about any systems where these assumptions do not hold.
c
c     this version dated 4/6/83.
c
      a = 4.0d0/3.0d0
   10 b = a - 1.0d0
      c = b + b + b
      eps = dabs(c-1.0d0)
      if (eps .eq. 0.0d0) go to 10
      epslon = eps*dabs(x)
      return
      end
      subroutine hqr(nm,n,low,igh,h,wr,wi,ierr)
C  RESTORED CORRECT INDICES OF LOOPS (200,210,230,240). (9/29/89 BSG)
c
      integer i,j,k,l,m,n,en,ll,mm,na,nm,igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n)
      double precision p,q,r,s,t,w,x,y,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr,
c     num. math. 14, 219-231(1970) by martin, peters, and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 359-371(1971).
c
c     this subroutine finds the eigenvalues of a real
c     upper hessenberg matrix by the qr method.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.  information about
c          the transformations used in the reduction to hessenberg
c          form by  elmhes  or  orthes, if performed, is stored
c          in the remaining triangle under the hessenberg matrix.
c
c     on output
c
c        h has been destroyed.  therefore, it must be saved
c          before calling  hqr  if subsequent calculation and
c          back transformation of eigenvectors is to be performed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated september 1989.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 1001
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + dabs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
         tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, EN
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 210 i = L, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, EN
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 240 i = L, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 wr(en) = x + t
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      x = x + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine hqr2(nm,n,low,igh,h,wr,wi,z,ierr)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,mm,na,nm,nn,
     x        igh,itn,its,low,mp2,enm2,ierr
      double precision h(nm,n),wr(n),wi(n),z(nm,n)
      double precision p,q,r,s,t,w,x,y,ra,sa,vi,vr,zz,norm,tst1,tst2
      logical notlas
c
c     this subroutine is a translation of the algol procedure hqr2,
c     num. math. 16, 181-204(1970) by peters and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a real upper hessenberg matrix by the qr method.  the
c     eigenvectors of a real general matrix can also be found
c     if  elmhes  and  eltran  or  orthes  and  ortran  have
c     been used to reduce this general matrix to hessenberg form
c     and to accumulate the similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  balanc.  if  balanc  has not been used,
c          set low=1, igh=n.
c
c        h contains the upper hessenberg matrix.
c
c        z contains the transformation matrix produced by  eltran
c          after the reduction by  elmhes, or by  ortran  after the
c          reduction by  orthes, if performed.  if the eigenvectors
c          of the hessenberg matrix are desired, z must contain the
c          identity matrix.
c
c     on output
c
c        h has been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  the eigenvalues
c          are unordered except that complex conjugate pairs
c          of values appear consecutively with the eigenvalue
c          having the positive imaginary part first.  if an
c          error exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        z contains the real and imaginary parts of the eigenvectors.
c          if the i-th eigenvalue is real, the i-th column of z
c          contains its eigenvector.  if the i-th eigenvalue is complex
c          with positive imaginary part, the i-th and (i+1)-th
c          columns of z contain the real and imaginary parts of its
c          eigenvector.  the eigenvectors are unnormalized.  if an
c          error exit is made, none of the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      norm = 0.0d0
      k = 1
c     .......... store roots isolated by balanc
c                and compute matrix norm ..........
      do 50 i = 1, n
c
         do 40 j = k, n
   40    norm = norm + dabs(h(i,j))
c
         k = i
         if (i .ge. low .and. i .le. igh) go to 50
         wr(i) = h(i,i)
         wi(i) = 0.0d0
   50 continue
c
      en = igh
      t = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalues ..........
   60 if (en .lt. low) go to 340
      its = 0
      na = en - 1
      enm2 = na - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
   70 do 80 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 100
         s = dabs(h(l-1,l-1)) + dabs(h(l,l))
         if (s .eq. 0.0d0) s = norm
         tst1 = s
         tst2 = tst1 + dabs(h(l,l-1))
         if (tst2 .eq. tst1) go to 100
   80 continue
c     .......... form shift ..........
  100 x = h(en,en)
      if (l .eq. en) go to 270
      y = h(na,na)
      w = h(en,na) * h(na,en)
      if (l .eq. na) go to 280
      if (itn .eq. 0) go to 1000
      if (its .ne. 10 .and. its .ne. 20) go to 130
c     .......... form exceptional shift ..........
      t = t + x
c
      do 120 i = low, en
  120 h(i,i) = h(i,i) - x
c
      s = dabs(h(en,na)) + dabs(h(na,enm2))
      x = 0.75d0 * s
      y = x
      w = -0.4375d0 * s * s
  130 its = its + 1
      itn = itn - 1
c     .......... look for two consecutive small
c                sub-diagonal elements.
c                for m=en-2 step -1 until l do -- ..........
      do 140 mm = l, enm2
         m = enm2 + l - mm
         zz = h(m,m)
         r = x - zz
         s = y - zz
         p = (r * s - w) / h(m+1,m) + h(m,m+1)
         q = h(m+1,m+1) - zz - r - s
         r = h(m+2,m+1)
         s = dabs(p) + dabs(q) + dabs(r)
         p = p / s
         q = q / s
         r = r / s
         if (m .eq. l) go to 150
         tst1 = dabs(p)*(dabs(h(m-1,m-1)) + dabs(zz) + dabs(h(m+1,m+1)))
         tst2 = tst1 + dabs(h(m,m-1))*(dabs(q) + dabs(r))
         if (tst2 .eq. tst1) go to 150
  140 continue
c
  150 mp2 = m + 2
c
      do 160 i = mp2, en
         h(i,i-2) = 0.0d0
         if (i .eq. mp2) go to 160
         h(i,i-3) = 0.0d0
  160 continue
c     .......... double qr step involving rows l to en and
c                columns m to en ..........
      do 260 k = m, na
         notlas = k .ne. na
         if (k .eq. m) go to 170
         p = h(k,k-1)
         q = h(k+1,k-1)
         r = 0.0d0
         if (notlas) r = h(k+2,k-1)
         x = dabs(p) + dabs(q) + dabs(r)
         if (x .eq. 0.0d0) go to 260
         p = p / x
         q = q / x
         r = r / x
  170    s = dsign(dsqrt(p*p+q*q+r*r),p)
         if (k .eq. m) go to 180
         h(k,k-1) = -s * x
         go to 190
  180    if (l .ne. m) h(k,k-1) = -h(k,k-1)
  190    p = p + s
         x = p / s
         y = q / s
         zz = r / s
         q = q / p
         r = r / p
         if (notlas) go to 225
c     .......... row modification ..........
         do 200 j = k, n
            p = h(k,j) + q * h(k+1,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
  200    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 210 i = 1, j
            p = x * h(i,k) + y * h(i,k+1)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
  210    continue
c     .......... accumulate transformations ..........
         do 220 i = low, igh
            p = x * z(i,k) + y * z(i,k+1)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
  220    continue
         go to 255
  225    continue
c     .......... row modification ..........
         do 230 j = k, n
            p = h(k,j) + q * h(k+1,j) + r * h(k+2,j)
            h(k,j) = h(k,j) - p * x
            h(k+1,j) = h(k+1,j) - p * y
            h(k+2,j) = h(k+2,j) - p * zz
  230    continue
c
         j = min0(en,k+3)
c     .......... column modification ..........
         do 240 i = 1, j
            p = x * h(i,k) + y * h(i,k+1) + zz * h(i,k+2)
            h(i,k) = h(i,k) - p
            h(i,k+1) = h(i,k+1) - p * q
            h(i,k+2) = h(i,k+2) - p * r
  240    continue
c     .......... accumulate transformations ..........
         do 250 i = low, igh
            p = x * z(i,k) + y * z(i,k+1) + zz * z(i,k+2)
            z(i,k) = z(i,k) - p
            z(i,k+1) = z(i,k+1) - p * q
            z(i,k+2) = z(i,k+2) - p * r
  250    continue
  255    continue
c
  260 continue
c
      go to 70
c     .......... one root found ..........
  270 h(en,en) = x + t
      wr(en) = h(en,en)
      wi(en) = 0.0d0
      en = na
      go to 60
c     .......... two roots found ..........
  280 p = (y - x) / 2.0d0
      q = p * p + w
      zz = dsqrt(dabs(q))
      h(en,en) = x + t
      x = h(en,en)
      h(na,na) = y + t
      if (q .lt. 0.0d0) go to 320
c     .......... real pair ..........
      zz = p + dsign(zz,p)
      wr(na) = x + zz
      wr(en) = wr(na)
      if (zz .ne. 0.0d0) wr(en) = x - w / zz
      wi(na) = 0.0d0
      wi(en) = 0.0d0
      x = h(en,na)
      s = dabs(x) + dabs(zz)
      p = x / s
      q = zz / s
      r = dsqrt(p*p+q*q)
      p = p / r
      q = q / r
c     .......... row modification ..........
      do 290 j = na, n
         zz = h(na,j)
         h(na,j) = q * zz + p * h(en,j)
         h(en,j) = q * h(en,j) - p * zz
  290 continue
c     .......... column modification ..........
      do 300 i = 1, en
         zz = h(i,na)
         h(i,na) = q * zz + p * h(i,en)
         h(i,en) = q * h(i,en) - p * zz
  300 continue
c     .......... accumulate transformations ..........
      do 310 i = low, igh
         zz = z(i,na)
         z(i,na) = q * zz + p * z(i,en)
         z(i,en) = q * z(i,en) - p * zz
  310 continue
c
      go to 330
c     .......... complex pair ..........
  320 wr(na) = x + p
      wr(en) = x + p
      wi(na) = zz
      wi(en) = -zz
  330 en = enm2
      go to 60
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  340 if (norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 1 do -- ..........
      do 800 nn = 1, n
         en = n + 1 - nn
         p = wr(en)
         q = wi(en)
         na = en - 1
         if (q) 710, 600, 800
c     .......... real vector ..........
  600    m = en
         h(en,en) = 1.0d0
         if (na .eq. 0) go to 800
c     .......... for i=en-1 step -1 until 1 do -- ..........
         do 700 ii = 1, na
            i = en - ii
            w = h(i,i) - p
            r = 0.0d0
c
            do 610 j = m, en
  610       r = r + h(i,j) * h(j,en)
c
            if (wi(i) .ge. 0.0d0) go to 630
            zz = w
            s = r
            go to 700
  630       m = i
            if (wi(i) .ne. 0.0d0) go to 640
            t = w
            if (t .ne. 0.0d0) go to 635
               tst1 = norm
               t = tst1
  632          t = 0.01d0 * t
               tst2 = norm + t
               if (tst2 .gt. tst1) go to 632
  635       h(i,en) = -r / t
            go to 680
c     .......... solve real equations ..........
  640       x = h(i,i+1)
            y = h(i+1,i)
            q = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i)
            t = (x * s - zz * r) / q
            h(i,en) = t
            if (dabs(x) .le. dabs(zz)) go to 650
            h(i+1,en) = (-r - w * t) / x
            go to 680
  650       h(i+1,en) = (-s - y * t) / zz
c
c     .......... overflow control ..........
  680       t = dabs(h(i,en))
            if (t .eq. 0.0d0) go to 700
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 700
            do 690 j = i, en
               h(j,en) = h(j,en)/t
  690       continue
c
  700    continue
c     .......... end real vector ..........
         go to 800
c     .......... complex vector ..........
  710    m = na
c     .......... last vector component chosen imaginary so that
c                eigenvector matrix is triangular ..........
         if (dabs(h(en,na)) .le. dabs(h(na,en))) go to 720
         h(na,na) = q / h(en,na)
         h(na,en) = -(h(en,en) - p) / h(en,na)
         go to 730
  720    call cdiv(0.0d0,-h(na,en),h(na,na)-p,q,h(na,na),h(na,en))
  730    h(en,na) = 0.0d0
         h(en,en) = 1.0d0
         enm2 = na - 1
         if (enm2 .eq. 0) go to 800
c     .......... for i=en-2 step -1 until 1 do -- ..........
         do 795 ii = 1, enm2
            i = na - ii
            w = h(i,i) - p
            ra = 0.0d0
            sa = 0.0d0
c
            do 760 j = m, en
               ra = ra + h(i,j) * h(j,na)
               sa = sa + h(i,j) * h(j,en)
  760       continue
c
            if (wi(i) .ge. 0.0d0) go to 770
            zz = w
            r = ra
            s = sa
            go to 795
  770       m = i
            if (wi(i) .ne. 0.0d0) go to 780
            call cdiv(-ra,-sa,w,q,h(i,na),h(i,en))
            go to 790
c     .......... solve complex equations ..........
  780       x = h(i,i+1)
            y = h(i+1,i)
            vr = (wr(i) - p) * (wr(i) - p) + wi(i) * wi(i) - q * q
            vi = (wr(i) - p) * 2.0d0 * q
            if (vr .ne. 0.0d0 .or. vi .ne. 0.0d0) go to 784
               tst1 = norm * (dabs(w) + dabs(q) + dabs(x)
     x                      + dabs(y) + dabs(zz))
               vr = tst1
  783          vr = 0.01d0 * vr
               tst2 = tst1 + vr
               if (tst2 .gt. tst1) go to 783
  784       call cdiv(x*r-zz*ra+q*sa,x*s-zz*sa-q*ra,vr,vi,
     x                h(i,na),h(i,en))
            if (dabs(x) .le. dabs(zz) + dabs(q)) go to 785
            h(i+1,na) = (-ra - w * h(i,na) + q * h(i,en)) / x
            h(i+1,en) = (-sa - w * h(i,en) - q * h(i,na)) / x
            go to 790
  785       call cdiv(-r-y*h(i,na),-s-y*h(i,en),zz,q,
     x                h(i+1,na),h(i+1,en))
c
c     .......... overflow control ..........
  790       t = dmax1(dabs(h(i,na)), dabs(h(i,en)))
            if (t .eq. 0.0d0) go to 795
            tst1 = t
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 795
            do 792 j = i, en
               h(j,na) = h(j,na)/t
               h(j,en) = h(j,en)/t
  792       continue
c
  795    continue
c     .......... end complex vector ..........
  800 continue
c     .......... end back substitution.
c                vectors of isolated roots ..........
      do 840 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 840
c
         do 820 j = i, n
  820    z(i,j) = h(i,j)
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, n
         j = n + low - jj
         m = min0(j,igh)
c
         do 880 i = low, igh
            zz = 0.0d0
c
            do 860 k = low, m
  860       zz = zz + z(i,k) * h(k,j)
c
            z(i,j) = zz
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
c---*----1----*----2----*----3----*----4----*----5----*----6----*----7
      subroutine cg_eispack(nm,n,ar,ai,wr,wi,matz,zr,zi,fv1,fv2,fv3
     &     ,ierr)
      integer n,nm,is1,is2,ierr,matz
      double precision ar(nm,n),ai(nm,n),wr(n),wi(n),zr(nm,n),zi(nm,n),
     x       fv1(n),fv2(n),fv3(n)
c
c     this subroutine calls the recommended sequence of
c     subroutines from the eigensystem subroutine package (eispack)
c     to find the eigenvalues and eigenvectors (if desired)
c     of a complex general matrix.
c
c     on input
c
c        nm  must be set to the row dimension of the two-dimensional
c        array parameters as declared in the calling program
c        dimension statement.
c
c        n  is the order of the matrix  a=(ar,ai).
c
c        ar  and  ai  contain the real and imaginary parts,
c        respectively, of the complex general matrix.
c
c        matz  is an integer variable set equal to zero if
c        only eigenvalues are desired.  otherwise it is set to
c        any non-zero integer for both eigenvalues and eigenvectors.
c
c     on output
c
c        wr  and  wi  contain the real and imaginary parts,
c        respectively, of the eigenvalues.
c
c        zr  and  zi  contain the real and imaginary parts,
c        respectively, of the eigenvectors if matz is not zero.
c
c        ierr  is an integer output variable set equal to an error
c           completion code described in the documentation for comqr
c           and comqr2.  the normal completion code is zero.
c
c        fv1, fv2, and  fv3  are temporary storage arrays.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (n .le. nm) go to 10
      ierr = 10 * n
      go to 50
c
   10 call  cbal(nm,n,ar,ai,is1,is2,fv1)
      call  corth(nm,n,is1,is2,ar,ai,fv2,fv3)
      if (matz .ne. 0) go to 20
c     .......... find eigenvalues only ..........
      call  comqr(nm,n,is1,is2,ar,ai,wr,wi,ierr)
      go to 50
c     .......... find both eigenvalues and eigenvectors ..........
   20 call  comqr2(nm,n,is1,is2,fv2,fv3,ar,ai,wr,wi,zr,zi,ierr)
      if (ierr .ne. 0) go to 50
      call  cbabk2(nm,n,is1,is2,fv1,n,zr,zi)
   50 return
      end
      subroutine cbabk2(nm,n,low,igh,scale,m,zr,zi)
c
      integer i,j,k,m,n,ii,nm,igh,low
      double precision scale(n),zr(nm,m),zi(nm,m)
      double precision s
c
c     this subroutine is a translation of the algol procedure
c     cbabk2, which is a complex version of balbak,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine forms the eigenvectors of a complex general
c     matrix by back transforming those of the corresponding
c     balanced matrix determined by  cbal.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by  cbal.
c
c        scale contains information determining the permutations
c          and scaling factors used by  cbal.
c
c        m is the number of eigenvectors to be back transformed.
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the eigenvectors to be
c          back transformed in their first m columns.
c
c     on output
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the transformed eigenvectors
c          in their first m columns.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      if (m .eq. 0) go to 200
      if (igh .eq. low) go to 120
c
      do 110 i = low, igh
         s = scale(i)
c     .......... left hand eigenvectors are back transformed
c                if the foregoing statement is replaced by
c                s=1.0d0/scale(i). ..........
         do 100 j = 1, m
            zr(i,j) = zr(i,j) * s
            zi(i,j) = zi(i,j) * s
  100    continue
c
  110 continue
c     .......... for i=low-1 step -1 until 1,
c                igh+1 step 1 until n do -- ..........
  120 do 140 ii = 1, n
         i = ii
         if (i .ge. low .and. i .le. igh) go to 140
         if (i .lt. low) i = low - ii
         k = scale(i)
         if (k .eq. i) go to 140
c
         do 130 j = 1, m
            s = zr(i,j)
            zr(i,j) = zr(k,j)
            zr(k,j) = s
            s = zi(i,j)
            zi(i,j) = zi(k,j)
            zi(k,j) = s
  130    continue
c
  140 continue
c
  200 return
      end
      subroutine cbal(nm,n,ar,ai,low,igh,scale)
c
      integer i,j,k,l,m,n,jj,nm,igh,low,iexc
      double precision ar(nm,n),ai(nm,n),scale(n)
      double precision c,f,g,r,s,b2,radix
      logical noconv
c
c     this subroutine is a translation of the algol procedure
c     cbalance, which is a complex version of balance,
c     num. math. 13, 293-304(1969) by parlett and reinsch.
c     handbook for auto. comp., vol.ii-linear algebra, 315-326(1971).
c
c     this subroutine balances a complex matrix and isolates
c     eigenvalues whenever possible.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the complex matrix to be balanced.
c
c     on output
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the balanced matrix.
c
c        low and igh are two integers such that ar(i,j) and ai(i,j)
c          are equal to zero if
c           (1) i is greater than j and
c           (2) j=1,...,low-1 or i=igh+1,...,n.
c
c        scale contains information determining the
c           permutations and scaling factors used.
c
c     suppose that the principal submatrix in rows low through igh
c     has been balanced, that p(j) denotes the index interchanged
c     with j during the permutation step, and that the elements
c     of the diagonal matrix used are denoted by d(i,j).  then
c        scale(j) = p(j),    for j = 1,...,low-1
c                 = d(j,j)       j = low,...,igh
c                 = p(j)         j = igh+1,...,n.
c     the order in which the interchanges are made is n to igh+1,
c     then 1 to low-1.
c
c     note that 1 is returned for igh if igh is zero formally.
c
c     the algol procedure exc contained in cbalance appears in
c     cbal  in line.  (note that the algol roles of identifiers
c     k,l have been reversed.)
c
c     arithmetic is real throughout.
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      radix = 16.0d0
c
      b2 = radix * radix
      k = 1
      l = n
      go to 100
c     .......... in-line procedure for row and
c                column exchange ..........
   20 scale(m) = j
      if (j .eq. m) go to 50
c
      do 30 i = 1, l
         f = ar(i,j)
         ar(i,j) = ar(i,m)
         ar(i,m) = f
         f = ai(i,j)
         ai(i,j) = ai(i,m)
         ai(i,m) = f
   30 continue
c
      do 40 i = k, n
         f = ar(j,i)
         ar(j,i) = ar(m,i)
         ar(m,i) = f
         f = ai(j,i)
         ai(j,i) = ai(m,i)
         ai(m,i) = f
   40 continue
c
   50 go to (80,130), iexc
c     .......... search for rows isolating an eigenvalue
c                and push them down ..........
   80 if (l .eq. 1) go to 280
      l = l - 1
c     .......... for j=l step -1 until 1 do -- ..........
  100 do 120 jj = 1, l
         j = l + 1 - jj
c
         do 110 i = 1, l
            if (i .eq. j) go to 110
            if (ar(j,i) .ne. 0.0d0 .or. ai(j,i) .ne. 0.0d0) go to 120
  110    continue
c
         m = l
         iexc = 1
         go to 20
  120 continue
c
      go to 140
c     .......... search for columns isolating an eigenvalue
c                and push them left ..........
  130 k = k + 1
c
  140 do 170 j = k, l
c
         do 150 i = k, l
            if (i .eq. j) go to 150
            if (ar(i,j) .ne. 0.0d0 .or. ai(i,j) .ne. 0.0d0) go to 170
  150    continue
c
         m = k
         iexc = 2
         go to 20
  170 continue
c     .......... now balance the submatrix in rows k to l ..........
      do 180 i = k, l
  180 scale(i) = 1.0d0
c     .......... iterative loop for norm reduction ..........
  190 noconv = .false.
c
      do 270 i = k, l
         c = 0.0d0
         r = 0.0d0
c
         do 200 j = k, l
            if (j .eq. i) go to 200
            c = c + dabs(ar(j,i)) + dabs(ai(j,i))
            r = r + dabs(ar(i,j)) + dabs(ai(i,j))
  200    continue
c     .......... guard against zero c or r due to underflow ..........
         if (c .eq. 0.0d0 .or. r .eq. 0.0d0) go to 270
         g = r / radix
         f = 1.0d0
         s = c + r
  210    if (c .ge. g) go to 220
         f = f * radix
         c = c * b2
         go to 210
  220    g = r * radix
  230    if (c .lt. g) go to 240
         f = f / radix
         c = c / b2
         go to 230
c     .......... now balance ..........
  240    if ((c + r) / f .ge. 0.95d0 * s) go to 270
         g = 1.0d0 / f
         scale(i) = scale(i) * f
         noconv = .true.
c
         do 250 j = k, n
            ar(i,j) = ar(i,j) * g
            ai(i,j) = ai(i,j) * g
  250    continue
c
         do 260 j = 1, l
            ar(j,i) = ar(j,i) * f
            ai(j,i) = ai(j,i) * f
  260    continue
c
  270 continue
c
      if (noconv) go to 190
c
  280 low = k
      igh = l
      return
      end
      subroutine comqr(nm,n,low,igh,hr,hi,wr,wi,ierr)
c
      integer i,j,l,n,en,ll,nm,igh,itn,its,low,lp1,enm1,ierr
      double precision hr(nm,n),hi(nm,n),wr(n),wi(n)
      double precision si,sr,ti,tr,xi,xr,yi,yr,zzi,zzr,norm,tst1,tst2,
     x       pythag
c
c     this subroutine is a translation of a unitary analogue of the
c     algol procedure  comlr, num. math. 12, 369-376(1968) by martin
c     and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 396-403(1971).
c     the unitary analogue substitutes the qr algorithm of francis
c     (comp. jour. 4, 332-345(1962)) for the lr algorithm.
c
c     this subroutine finds the eigenvalues of a complex
c     upper hessenberg matrix by the qr method.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        hr and hi contain the real and imaginary parts,
c          respectively, of the complex upper hessenberg matrix.
c          their lower triangles below the subdiagonal contain
c          information about the unitary transformations used in
c          the reduction by  corth, if performed.
c
c     on output
c
c        the upper hessenberg portions of hr and hi have been
c          destroyed.  therefore, they must be saved before
c          calling  comqr  if subsequent calculation of
c          eigenvectors is to be performed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  if an error
c          exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c     calls csroot for complex square root.
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      ierr = 0
      if (low .eq. igh) go to 180
c     .......... create real subdiagonal elements ..........
      l = low + 1
c
      do 170 i = l, igh
         ll = min0(i+1,igh)
         if (hi(i,i-1) .eq. 0.0d0) go to 170
         norm = pythag(hr(i,i-1),hi(i,i-1))
         yr = hr(i,i-1) / norm
         yi = hi(i,i-1) / norm
         hr(i,i-1) = norm
         hi(i,i-1) = 0.0d0
c
         do 155 j = i, igh
            si = yr * hi(i,j) - yi * hr(i,j)
            hr(i,j) = yr * hr(i,j) + yi * hi(i,j)
            hi(i,j) = si
  155    continue
c
         do 160 j = low, ll
            si = yr * hi(j,i) + yi * hr(j,i)
            hr(j,i) = yr * hr(j,i) - yi * hi(j,i)
            hi(j,i) = si
  160    continue
c
  170 continue
c     .......... store roots isolated by cbal ..........
  180 do 200 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 200
         wr(i) = hr(i,i)
         wi(i) = hi(i,i)
  200 continue
c
      en = igh
      tr = 0.0d0
      ti = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalue ..........
  220 if (en .lt. low) go to 1001
      its = 0
      enm1 = en - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low d0 -- ..........
  240 do 260 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 300
         tst1 = dabs(hr(l-1,l-1)) + dabs(hi(l-1,l-1))
     x            + dabs(hr(l,l)) + dabs(hi(l,l))
         tst2 = tst1 + dabs(hr(l,l-1))
         if (tst2 .eq. tst1) go to 300
  260 continue
c     .......... form shift ..........
  300 if (l .eq. en) go to 660
      if (itn .eq. 0) go to 1000
      if (its .eq. 10 .or. its .eq. 20) go to 320
      sr = hr(en,en)
      si = hi(en,en)
      xr = hr(enm1,en) * hr(en,enm1)
      xi = hi(enm1,en) * hr(en,enm1)
      if (xr .eq. 0.0d0 .and. xi .eq. 0.0d0) go to 340
      yr = (hr(enm1,enm1) - sr) / 2.0d0
      yi = (hi(enm1,enm1) - si) / 2.0d0
      call csroot(yr**2-yi**2+xr,2.0d0*yr*yi+xi,zzr,zzi)
      if (yr * zzr + yi * zzi .ge. 0.0d0) go to 310
      zzr = -zzr
      zzi = -zzi
  310 call cdiv(xr,xi,yr+zzr,yi+zzi,xr,xi)
      sr = sr - xr
      si = si - xi
      go to 340
c     .......... form exceptional shift ..........
  320 sr = dabs(hr(en,enm1)) + dabs(hr(enm1,en-2))
      si = 0.0d0
c
  340 do 360 i = low, en
         hr(i,i) = hr(i,i) - sr
         hi(i,i) = hi(i,i) - si
  360 continue
c
      tr = tr + sr
      ti = ti + si
      its = its + 1
      itn = itn - 1
c     .......... reduce to triangle (rows) ..........
      lp1 = l + 1
c
      do 500 i = lp1, en
         sr = hr(i,i-1)
         hr(i,i-1) = 0.0d0
         norm = pythag(pythag(hr(i-1,i-1),hi(i-1,i-1)),sr)
         xr = hr(i-1,i-1) / norm
         wr(i-1) = xr
         xi = hi(i-1,i-1) / norm
         wi(i-1) = xi
         hr(i-1,i-1) = norm
         hi(i-1,i-1) = 0.0d0
         hi(i,i-1) = sr / norm
c
         do 490 j = i, en
            yr = hr(i-1,j)
            yi = hi(i-1,j)
            zzr = hr(i,j)
            zzi = hi(i,j)
            hr(i-1,j) = xr * yr + xi * yi + hi(i,i-1) * zzr
            hi(i-1,j) = xr * yi - xi * yr + hi(i,i-1) * zzi
            hr(i,j) = xr * zzr - xi * zzi - hi(i,i-1) * yr
            hi(i,j) = xr * zzi + xi * zzr - hi(i,i-1) * yi
  490    continue
c
  500 continue
c
      si = hi(en,en)
      if (si .eq. 0.0d0) go to 540
      norm = pythag(hr(en,en),si)
      sr = hr(en,en) / norm
      si = si / norm
      hr(en,en) = norm
      hi(en,en) = 0.0d0
c     .......... inverse operation (columns) ..........
  540 do 600 j = lp1, en
         xr = wr(j-1)
         xi = wi(j-1)
c
         do 580 i = l, j
            yr = hr(i,j-1)
            yi = 0.0d0
            zzr = hr(i,j)
            zzi = hi(i,j)
            if (i .eq. j) go to 560
            yi = hi(i,j-1)
            hi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
  560       hr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            hr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            hi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  580    continue
c
  600 continue
c
      if (si .eq. 0.0d0) go to 240
c
      do 630 i = l, en
         yr = hr(i,en)
         yi = hi(i,en)
         hr(i,en) = sr * yr - si * yi
         hi(i,en) = sr * yi + si * yr
  630 continue
c
      go to 240
c     .......... a root found ..........
  660 wr(en) = hr(en,en) + tr
      wi(en) = hi(en,en) + ti
      en = enm1
      go to 220
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine comqr2(nm,n,low,igh,ortr,orti,hr,hi,wr,wi,zr,zi,ierr)
C  MESHED overflow control WITH vectors of isolated roots (10/19/89 BSG)
C  MESHED overflow control WITH triangular multiply (10/30/89 BSG)
c
      integer i,j,k,l,m,n,en,ii,jj,ll,nm,nn,igh,ip1,
     x        itn,its,low,lp1,enm1,iend,ierr
      double precision hr(nm,n),hi(nm,n),wr(n),wi(n),zr(nm,n),zi(nm,n),
     x       ortr(igh),orti(igh)
      double precision si,sr,ti,tr,xi,xr,yi,yr,zzi,zzr,norm,tst1,tst2,
     x       pythag
c
c     this subroutine is a translation of a unitary analogue of the
c     algol procedure  comlr2, num. math. 16, 181-204(1970) by peters
c     and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 372-395(1971).
c     the unitary analogue substitutes the qr algorithm of francis
c     (comp. jour. 4, 332-345(1962)) for the lr algorithm.
c
c     this subroutine finds the eigenvalues and eigenvectors
c     of a complex upper hessenberg matrix by the qr
c     method.  the eigenvectors of a complex general matrix
c     can also be found if  corth  has been used to reduce
c     this general matrix to hessenberg form.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        ortr and orti contain information about the unitary trans-
c          formations used in the reduction by  corth, if performed.
c          only elements low through igh are used.  if the eigenvectors
c          of the hessenberg matrix are desired, set ortr(j) and
c          orti(j) to 0.0d0 for these elements.
c
c        hr and hi contain the real and imaginary parts,
c          respectively, of the complex upper hessenberg matrix.
c          their lower triangles below the subdiagonal contain further
c          information about the transformations which were used in the
c          reduction by  corth, if performed.  if the eigenvectors of
c          the hessenberg matrix are desired, these elements may be
c          arbitrary.
c
c     on output
c
c        ortr, orti, and the upper hessenberg portions of hr and hi
c          have been destroyed.
c
c        wr and wi contain the real and imaginary parts,
c          respectively, of the eigenvalues.  if an error
c          exit is made, the eigenvalues should be correct
c          for indices ierr+1,...,n.
c
c        zr and zi contain the real and imaginary parts,
c          respectively, of the eigenvectors.  the eigenvectors
c          are unnormalized.  if an error exit is made, none of
c          the eigenvectors has been found.
c
c        ierr is set to
c          zero       for normal return,
c          j          if the limit of 30*n iterations is exhausted
c                     while the j-th eigenvalue is being sought.
c
c     calls cdiv for complex division.
c     calls csroot for complex square root.
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated october 1989.
c
c     ------------------------------------------------------------------
c
      ierr = 0
c     .......... initialize eigenvector matrix ..........
      do 101 j = 1, n
c
         do 100 i = 1, n
            zr(i,j) = 0.0d0
            zi(i,j) = 0.0d0
  100    continue
         zr(j,j) = 1.0d0
  101 continue
c     .......... form the matrix of accumulated transformations
c                from the information left by corth ..........
      iend = igh - low - 1
      if (iend) 180, 150, 105
c     .......... for i=igh-1 step -1 until low+1 do -- ..........
  105 do 140 ii = 1, iend
         i = igh - ii
         if (ortr(i) .eq. 0.0d0 .and. orti(i) .eq. 0.0d0) go to 140
         if (hr(i,i-1) .eq. 0.0d0 .and. hi(i,i-1) .eq. 0.0d0) go to 140
c     .......... norm below is negative of h formed in corth ..........
         norm = hr(i,i-1) * ortr(i) + hi(i,i-1) * orti(i)
         ip1 = i + 1
c
         do 110 k = ip1, igh
            ortr(k) = hr(k,i-1)
            orti(k) = hi(k,i-1)
  110    continue
c
         do 130 j = i, igh
            sr = 0.0d0
            si = 0.0d0
c
            do 115 k = i, igh
               sr = sr + ortr(k) * zr(k,j) + orti(k) * zi(k,j)
               si = si + ortr(k) * zi(k,j) - orti(k) * zr(k,j)
  115       continue
c
            sr = sr / norm
            si = si / norm
c
            do 120 k = i, igh
               zr(k,j) = zr(k,j) + sr * ortr(k) - si * orti(k)
               zi(k,j) = zi(k,j) + sr * orti(k) + si * ortr(k)
  120       continue
c
  130    continue
c
  140 continue
c     .......... create real subdiagonal elements ..........
  150 l = low + 1
c
      do 170 i = l, igh
         ll = min0(i+1,igh)
         if (hi(i,i-1) .eq. 0.0d0) go to 170
         norm = pythag(hr(i,i-1),hi(i,i-1))
         yr = hr(i,i-1) / norm
         yi = hi(i,i-1) / norm
         hr(i,i-1) = norm
         hi(i,i-1) = 0.0d0
c
         do 155 j = i, n
            si = yr * hi(i,j) - yi * hr(i,j)
            hr(i,j) = yr * hr(i,j) + yi * hi(i,j)
            hi(i,j) = si
  155    continue
c
         do 160 j = 1, ll
            si = yr * hi(j,i) + yi * hr(j,i)
            hr(j,i) = yr * hr(j,i) - yi * hi(j,i)
            hi(j,i) = si
  160    continue
c
         do 165 j = low, igh
            si = yr * zi(j,i) + yi * zr(j,i)
            zr(j,i) = yr * zr(j,i) - yi * zi(j,i)
            zi(j,i) = si
  165    continue
c
  170 continue
c     .......... store roots isolated by cbal ..........
  180 do 200 i = 1, n
         if (i .ge. low .and. i .le. igh) go to 200
         wr(i) = hr(i,i)
         wi(i) = hi(i,i)
  200 continue
c
      en = igh
      tr = 0.0d0
      ti = 0.0d0
      itn = 30*n
c     .......... search for next eigenvalue ..........
  220 if (en .lt. low) go to 680
      its = 0
      enm1 = en - 1
c     .......... look for single small sub-diagonal element
c                for l=en step -1 until low do -- ..........
  240 do 260 ll = low, en
         l = en + low - ll
         if (l .eq. low) go to 300
         tst1 = dabs(hr(l-1,l-1)) + dabs(hi(l-1,l-1))
     x            + dabs(hr(l,l)) + dabs(hi(l,l))
         tst2 = tst1 + dabs(hr(l,l-1))
         if (tst2 .eq. tst1) go to 300
  260 continue
c     .......... form shift ..........
  300 if (l .eq. en) go to 660
      if (itn .eq. 0) go to 1000
      if (its .eq. 10 .or. its .eq. 20) go to 320
      sr = hr(en,en)
      si = hi(en,en)
      xr = hr(enm1,en) * hr(en,enm1)
      xi = hi(enm1,en) * hr(en,enm1)
      if (xr .eq. 0.0d0 .and. xi .eq. 0.0d0) go to 340
      yr = (hr(enm1,enm1) - sr) / 2.0d0
      yi = (hi(enm1,enm1) - si) / 2.0d0
      call csroot(yr**2-yi**2+xr,2.0d0*yr*yi+xi,zzr,zzi)
      if (yr * zzr + yi * zzi .ge. 0.0d0) go to 310
      zzr = -zzr
      zzi = -zzi
  310 call cdiv(xr,xi,yr+zzr,yi+zzi,xr,xi)
      sr = sr - xr
      si = si - xi
      go to 340
c     .......... form exceptional shift ..........
  320 sr = dabs(hr(en,enm1)) + dabs(hr(enm1,en-2))
      si = 0.0d0
c
  340 do 360 i = low, en
         hr(i,i) = hr(i,i) - sr
         hi(i,i) = hi(i,i) - si
  360 continue
c
      tr = tr + sr
      ti = ti + si
      its = its + 1
      itn = itn - 1
c     .......... reduce to triangle (rows) ..........
      lp1 = l + 1
c
      do 500 i = lp1, en
         sr = hr(i,i-1)
         hr(i,i-1) = 0.0d0
         norm = pythag(pythag(hr(i-1,i-1),hi(i-1,i-1)),sr)
         xr = hr(i-1,i-1) / norm
         wr(i-1) = xr
         xi = hi(i-1,i-1) / norm
         wi(i-1) = xi
         hr(i-1,i-1) = norm
         hi(i-1,i-1) = 0.0d0
         hi(i,i-1) = sr / norm
c
         do 490 j = i, n
            yr = hr(i-1,j)
            yi = hi(i-1,j)
            zzr = hr(i,j)
            zzi = hi(i,j)
            hr(i-1,j) = xr * yr + xi * yi + hi(i,i-1) * zzr
            hi(i-1,j) = xr * yi - xi * yr + hi(i,i-1) * zzi
            hr(i,j) = xr * zzr - xi * zzi - hi(i,i-1) * yr
            hi(i,j) = xr * zzi + xi * zzr - hi(i,i-1) * yi
  490    continue
c
  500 continue
c
      si = hi(en,en)
      if (si .eq. 0.0d0) go to 540
      norm = pythag(hr(en,en),si)
      sr = hr(en,en) / norm
      si = si / norm
      hr(en,en) = norm
      hi(en,en) = 0.0d0
      if (en .eq. n) go to 540
      ip1 = en + 1
c
      do 520 j = ip1, n
         yr = hr(en,j)
         yi = hi(en,j)
         hr(en,j) = sr * yr + si * yi
         hi(en,j) = sr * yi - si * yr
  520 continue
c     .......... inverse operation (columns) ..........
  540 do 600 j = lp1, en
         xr = wr(j-1)
         xi = wi(j-1)
c
         do 580 i = 1, j
            yr = hr(i,j-1)
            yi = 0.0d0
            zzr = hr(i,j)
            zzi = hi(i,j)
            if (i .eq. j) go to 560
            yi = hi(i,j-1)
            hi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
  560       hr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            hr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            hi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  580    continue
c
         do 590 i = low, igh
            yr = zr(i,j-1)
            yi = zi(i,j-1)
            zzr = zr(i,j)
            zzi = zi(i,j)
            zr(i,j-1) = xr * yr - xi * yi + hi(j,j-1) * zzr
            zi(i,j-1) = xr * yi + xi * yr + hi(j,j-1) * zzi
            zr(i,j) = xr * zzr + xi * zzi - hi(j,j-1) * yr
            zi(i,j) = xr * zzi - xi * zzr - hi(j,j-1) * yi
  590    continue
c
  600 continue
c
      if (si .eq. 0.0d0) go to 240
c
      do 630 i = 1, en
         yr = hr(i,en)
         yi = hi(i,en)
         hr(i,en) = sr * yr - si * yi
         hi(i,en) = sr * yi + si * yr
  630 continue
c
      do 640 i = low, igh
         yr = zr(i,en)
         yi = zi(i,en)
         zr(i,en) = sr * yr - si * yi
         zi(i,en) = sr * yi + si * yr
  640 continue
c
      go to 240
c     .......... a root found ..........
  660 hr(en,en) = hr(en,en) + tr
      wr(en) = hr(en,en)
      hi(en,en) = hi(en,en) + ti
      wi(en) = hi(en,en)
      en = enm1
      go to 220
c     .......... all roots found.  backsubstitute to find
c                vectors of upper triangular form ..........
  680 norm = 0.0d0
c
      do 720 i = 1, n
c
         do 720 j = i, n
            tr = dabs(hr(i,j)) + dabs(hi(i,j))
            if (tr .gt. norm) norm = tr
  720 continue
c
      if (n .eq. 1 .or. norm .eq. 0.0d0) go to 1001
c     .......... for en=n step -1 until 2 do -- ..........
      do 800 nn = 2, n
         en = n + 2 - nn
         xr = wr(en)
         xi = wi(en)
         hr(en,en) = 1.0d0
         hi(en,en) = 0.0d0
         enm1 = en - 1
c     .......... for i=en-1 step -1 until 1 do -- ..........
         do 780 ii = 1, enm1
            i = en - ii
            zzr = 0.0d0
            zzi = 0.0d0
            ip1 = i + 1
c
            do 740 j = ip1, en
               zzr = zzr + hr(i,j) * hr(j,en) - hi(i,j) * hi(j,en)
               zzi = zzi + hr(i,j) * hi(j,en) + hi(i,j) * hr(j,en)
  740       continue
c
            yr = xr - wr(i)
            yi = xi - wi(i)
            if (yr .ne. 0.0d0 .or. yi .ne. 0.0d0) go to 765
               tst1 = norm
               yr = tst1
  760          yr = 0.01d0 * yr
               tst2 = norm + yr
               if (tst2 .gt. tst1) go to 760
  765       continue
            call cdiv(zzr,zzi,yr,yi,hr(i,en),hi(i,en))
c     .......... overflow control ..........
            tr = dabs(hr(i,en)) + dabs(hi(i,en))
            if (tr .eq. 0.0d0) go to 780
            tst1 = tr
            tst2 = tst1 + 1.0d0/tst1
            if (tst2 .gt. tst1) go to 780
            do 770 j = i, en
               hr(j,en) = hr(j,en)/tr
               hi(j,en) = hi(j,en)/tr
  770       continue
c
  780    continue
c
  800 continue
c     .......... end backsubstitution ..........
c     .......... vectors of isolated roots ..........
      do  840 i = 1, N
         if (i .ge. low .and. i .le. igh) go to 840
c
         do 820 j = I, n
            zr(i,j) = hr(i,j)
            zi(i,j) = hi(i,j)
  820    continue
c
  840 continue
c     .......... multiply by transformation matrix to give
c                vectors of original full matrix.
c                for j=n step -1 until low do -- ..........
      do 880 jj = low, N
         j = n + low - jj
         m = min0(j,igh)
c
         do 880 i = low, igh
            zzr = 0.0d0
            zzi = 0.0d0
c
            do 860 k = low, m
               zzr = zzr + zr(i,k) * hr(k,j) - zi(i,k) * hi(k,j)
               zzi = zzi + zr(i,k) * hi(k,j) + zi(i,k) * hr(k,j)
  860       continue
c
            zr(i,j) = zzr
            zi(i,j) = zzi
  880 continue
c
      go to 1001
c     .......... set error -- all eigenvalues have not
c                converged after 30*n iterations ..........
 1000 ierr = en
 1001 return
      end
      subroutine corth(nm,n,low,igh,ar,ai,ortr,orti)
c
      integer i,j,m,n,ii,jj,la,mp,nm,igh,kp1,low
      double precision ar(nm,n),ai(nm,n),ortr(igh),orti(igh)
      double precision f,g,h,fi,fr,scale,pythag
c
c     this subroutine is a translation of a complex analogue of
c     the algol procedure orthes, num. math. 12, 349-368(1968)
c     by martin and wilkinson.
c     handbook for auto. comp., vol.ii-linear algebra, 339-358(1971).
c
c     given a complex general matrix, this subroutine
c     reduces a submatrix situated in rows and columns
c     low through igh to upper hessenberg form by
c     unitary similarity transformations.
c
c     on input
c
c        nm must be set to the row dimension of two-dimensional
c          array parameters as declared in the calling program
c          dimension statement.
c
c        n is the order of the matrix.
c
c        low and igh are integers determined by the balancing
c          subroutine  cbal.  if  cbal  has not been used,
c          set low=1, igh=n.
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the complex input matrix.
c
c     on output
c
c        ar and ai contain the real and imaginary parts,
c          respectively, of the hessenberg matrix.  information
c          about the unitary transformations used in the reduction
c          is stored in the remaining triangles under the
c          hessenberg matrix.
c
c        ortr and orti contain further information about the
c          transformations.  only elements low through igh are used.
c
c     calls pythag for  dsqrt(a*a + b*b) .
c
c     questions and comments should be directed to burton s. garbow,
c     mathematics and computer science div, argonne national laboratory
c
c     this version dated august 1983.
c
c     ------------------------------------------------------------------
c
      la = igh - 1
      kp1 = low + 1
      if (la .lt. kp1) go to 200
c
      do 180 m = kp1, la
         h = 0.0d0
         ortr(m) = 0.0d0
         orti(m) = 0.0d0
         scale = 0.0d0
c     .......... scale column (algol tol then not needed) ..........
         do 90 i = m, igh
   90    scale = scale + dabs(ar(i,m-1)) + dabs(ai(i,m-1))
c
         if (scale .eq. 0.0d0) go to 180
         mp = m + igh
c     .......... for i=igh step -1 until m do -- ..........
         do 100 ii = m, igh
            i = mp - ii
            ortr(i) = ar(i,m-1) / scale
            orti(i) = ai(i,m-1) / scale
            h = h + ortr(i) * ortr(i) + orti(i) * orti(i)
  100    continue
c
         g = dsqrt(h)
         f = pythag(ortr(m),orti(m))
         if (f .eq. 0.0d0) go to 103
         h = h + f * g
         g = g / f
         ortr(m) = (1.0d0 + g) * ortr(m)
         orti(m) = (1.0d0 + g) * orti(m)
         go to 105
c
  103    ortr(m) = g
         ar(m,m-1) = scale
c     .......... form (i-(u*ut)/h) * a ..........
  105    do 130 j = m, n
            fr = 0.0d0
            fi = 0.0d0
c     .......... for i=igh step -1 until m do -- ..........
            do 110 ii = m, igh
               i = mp - ii
               fr = fr + ortr(i) * ar(i,j) + orti(i) * ai(i,j)
               fi = fi + ortr(i) * ai(i,j) - orti(i) * ar(i,j)
  110       continue
c
            fr = fr / h
            fi = fi / h
c
            do 120 i = m, igh
               ar(i,j) = ar(i,j) - fr * ortr(i) + fi * orti(i)
               ai(i,j) = ai(i,j) - fr * orti(i) - fi * ortr(i)
  120       continue
c
  130    continue
c     .......... form (i-(u*ut)/h)*a*(i-(u*ut)/h) ..........
         do 160 i = 1, igh
            fr = 0.0d0
            fi = 0.0d0
c     .......... for j=igh step -1 until m do -- ..........
            do 140 jj = m, igh
               j = mp - jj
               fr = fr + ortr(j) * ar(i,j) - orti(j) * ai(i,j)
               fi = fi + ortr(j) * ai(i,j) + orti(j) * ar(i,j)
  140       continue
c
            fr = fr / h
            fi = fi / h
c
            do 150 j = m, igh
               ar(i,j) = ar(i,j) - fr * ortr(j) - fi * orti(j)
               ai(i,j) = ai(i,j) + fr * orti(j) - fi * ortr(j)
  150       continue
c
  160    continue
c
         ortr(m) = scale * ortr(m)
         orti(m) = scale * orti(m)
         ar(m,m-1) = -g * ar(m,m-1)
         ai(m,m-1) = -g * ai(m,m-1)
  180 continue
c
  200 return
      end
      subroutine csroot(xr,xi,yr,yi)
      double precision xr,xi,yr,yi
c
c     (yr,yi) = complex dsqrt(xr,xi) 
c     branch chosen so that yr .ge. 0.0 and sign(yi) .eq. sign(xi)
c
      double precision s,tr,ti,pythag
      tr = xr
      ti = xi
      s = dsqrt(0.5d0*(pythag(tr,ti) + dabs(tr)))
      if (tr .ge. 0.0d0) yr = s
      if (ti .lt. 0.0d0) s = -s
      if (tr .le. 0.0d0) yi = s
      if (tr .lt. 0.0d0) yr = 0.5d0*(ti/yi)
      if (tr .gt. 0.0d0) yi = 0.5d0*(ti/yr)
      return
      end
      double precision function pythag(a,b)
      double precision a,b
c
c     finds dsqrt(a**2+b**2) without overflow or destructive underflow
c
      double precision p,r,s,t,u
      p = dmax1(dabs(a),dabs(b))
      if (p .eq. 0.0d0) go to 20
      r = (dmin1(dabs(a),dabs(b))/p)**2
   10 continue
         t = 4.0d0 + r
         if (t .eq. 4.0d0) go to 20
         s = r/t
         u = 1.0d0 + 2.0d0*s
         p = u*p
         r = (s/u)**2 * r
      go to 10
   20 pythag = p
      return
      end
c ---------------------------
      subroutine mltpha4(katm,matm,pos,pai2,kngp,ngabc,kng1,nbase,iiba
     &     ,zmltc,zmlts)
c                           @(#)rmmsubs.f 1.2 99/06/04 21:17:36
      implicit real*8 (a-h,o-z)
      integer nbase(*),ngabc(kngp,3)
      real*8 pos(katm,3)
      real*8 zmltc(kng1,matm),zmlts(kng1,matm)
      do ia = 1, matm
         fx = pos(ia,1)*pai2
         fy = pos(ia,2)*pai2
         fz = pos(ia,3)*pai2
         do i = 1, iiba
            nb = nbase(i)
            ph = ngabc(nb,1)*fx + ngabc(nb,2)*fy + ngabc(nb,3)*fz
            zmltc(i,ia) = dcos(ph)
            zmlts(i,ia) = dsin(ph)
         enddo
      enddo
      return
      end

      subroutine decide_alpha(kimg,dtim,nrmm,eigenr,eigeni,vector,alpha)
      implicit none
      integer  kimg
      real*8   dtim
      integer  nrmm
      real*8   eigenr(0:nrmm-1), eigeni(0:nrmm-1)
      real*8   vector(0:nrmm-1,0:nrmm-1,kimg)
      real*8   alpha(nrmm-1,kimg)

      real*8 eee
      integer i, k

      do k = 1, kimg
         do i = 1, nrmm-1
            alpha(i,k) = 0.d0
         end do
      end do

      if(nrmm .eq. 2) then
         if(eigeni(0) .ne. 0.d0) then
c            write(6,*) 'Warning: Eigen value is not real.'
            alpha(1,1) = dtim   
         else if( min(eigenr(0),eigenr(1)) .lt. 0.0d0 ) then
c            write(6,*) 'Warning: Eigen value is less than zero.'
            alpha(1,1) = dtim   
         else if( eigenr(0) .lt. eigenr(1) ) then
            if(kimg .eq. 1) then
               alpha(1,1) = vector(1,0,1)/vector(0,0,1)
               if(alpha(1,1) .le. 0.0d0) alpha(1,1) = dtim
            else if(kimg .eq. 2) then
               alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &              /dcmplx(vector(0,0,1),vector(0,0,kimg))
            end if
         else
            if(kimg .eq. 1) then
               alpha(1,1) = vector(1,1,1)/vector(0,1,1)
               if(alpha(1,1) .le. 0.0d0) alpha(1,1) = dtim
            else if(kimg .eq. 2) then
               alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &               /dcmplx(vector(0,1,1),vector(0,1,kimg))
            end if
         end if
      else if(nrmm .eq. 3) then
         eee = abs(eigeni(0))+abs(eigeni(1))+abs(eigeni(nrmm-1))
c*
         if(eee.eq.0.0d0) then  ! All eigenvalues are real.
c*
            if     ( eigenr(0).le.min(eigenr(1),eigenr(2)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,0,1)/vector(0,0,1)
                  alpha(2,1) = vector(2,0,1)/vector(0,0,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
                  alpha(2,1) = dcmplx(vector(2,0,1),vector(2,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
               endif
            else if( eigenr(1).le.min(eigenr(2),eigenr(0)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,1,1)/vector(0,1,1)
                  alpha(2,1) = vector(2,1,1)/vector(0,1,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
                  alpha(2,1) = dcmplx(vector(2,1,1),vector(2,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
               endif
            else if( eigenr(2).le.min(eigenr(0),eigenr(1)) ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,2,1)/vector(0,2,1)
                  alpha(2,1) = vector(2,2,1)/vector(0,2,1)
               else
                  alpha(1,1) = dcmplx(vector(1,2,1),vector(1,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
                  alpha(2,1) = dcmplx(vector(2,2,1),vector(2,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
               endif
            else 
               alpha(1,1) = dtim
               alpha(2,1) = 0.0d0
            end if
c*
         else                   ! Just one eigenvalue is real.
c*
            if     ( eigeni(0).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,0,1)/vector(0,0,1)
                  alpha(2,1) = vector(2,0,1)/vector(0,0,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,0,1),vector(1,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
                  alpha(2,1) = dcmplx(vector(2,0,1),vector(2,0,kimg))
     &                      /dcmplx(vector(0,0,1),vector(0,0,kimg))
               endif
            else if( eigeni(1).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,1,1)/vector(0,1,1)
                  alpha(2,1) = vector(2,1,1)/vector(0,1,1)
               else
                  alpha(1,1) = dcmplx(vector(1,1,1),vector(1,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
                  alpha(2,1) = dcmplx(vector(2,1,1),vector(2,1,kimg))
     &                      /dcmplx(vector(0,1,1),vector(0,1,kimg))
               endif
            else if( eigeni(2).eq.0.0d0 ) then
               if(kimg .eq. 1) then
                  alpha(1,1) = vector(1,2,1)/vector(0,2,1)
                  alpha(2,1) = vector(2,2,1)/vector(0,2,1)
               else if(kimg .eq. 2) then
                  alpha(1,1) = dcmplx(vector(1,2,1),vector(1,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
                  alpha(2,1) = dcmplx(vector(2,2,1),vector(2,2,kimg))
     &                      /dcmplx(vector(0,2,1),vector(0,2,kimg))
               endif
            else
               alpha(1,1) = dtim
               alpha(2,1) = 0.0d0
            end if
         end if
      end if
      return
      end

      subroutine rmm3_uda(ipri,nrmm,am,sm,alpha)
      implicit real*8(a-h,o-z)
      integer ipri, nrmm
      dimension am(0:nrmm-1,0:nrmm-1),sm(0:nrmm-1,0:nrmm-1)
     &     ,alpha(nrmm-1)
      dimension c(3)
c         print *,'am=',am(0,0),am(1,0),am(2,0)
c         print *,'   ',am(1,1),am(2,1)
**********12/13******************
c      if(am(0,0)/sm(0,0).gt.1.0d-2) then
*      if(am(0,0).gt.1.0d0) then
c         print *,'calculation is made by SD'
c         print *,'am=',am(0,0),am(1,0),am(2,0)
c         print *,'   ',am(1,1),am(2,1)
c         print *,'   ',am(2,2)

c         print *,'sm=',sm(0,0),sm(1,0),sm(2,0)
c         print *,'   ',sm(1,1),sm(2,1)
c         print *,'   ',sm(2,2)

c         alpha(1)=-0.10d0
c         alpha(2)=0.0d0
c         return
c      end if
************12/13****************
      a11 = am(0,0)
      a12 = am(1,0)
      a13 = am(2,0)
      a22 = am(1,1)
      a23 = am(2,1)
      a33 = am(2,2)
c$$$      a11=am(1)
c$$$      a12=am(2)
c$$$      a13=am(3)
c$$$      a22=am(4)
c$$$      a23=am(5)
c$$$      a33=am(6)

      s11 = sm(0,0)
      s12 = sm(1,0)
      s13 = sm(2,0)
      s22 = sm(1,1)
      s23 = sm(2,1)
      s33 = sm(2,2)
c$$$      s11=sm(1)
c$$$      s12=sm(2)
c$$$      s13=sm(3)
c$$$      s22=sm(4)
c$$$      s23=sm(5)
c$$$      s33=sm(6)

c      print *,'-------------------------------------------------------'
c      print *,'a11=',a11
c      print *,'a12=',a12
c      print *,'a13=',a13
c      print *,'a22=',a22
c      print *,'a23=',a23
c      print *,'a33=',a33
c      print *,'s11=',s11
c      print *,'s12=',s12
c      print *,'s13=',s13
c      print *,'s22=',s22
c      print *,'s23=',s23
c      print *,'s33=',s33
c      print *,'a11/s11=',a11/s11
c      print *,'a22/s22=',a22/s22
c      print *,'a33/s33=',a33/s33
c

      a21=a12
      a32=a23   
      a31=a13   
      s21=s12
      s32=s23
      s31=s13

c$$$      write(6,'(" -- s(<i|S|j>) (rmm3_uda) --")')
c$$$      write(6,'(3d12.4, " : s11 s12 s13 ")') s11,s12,s13
c$$$      write(6,'(3d12.4, " : s21 s22 s23 ")') s21,s22,s23
c$$$      write(6,'(3d12.4, " : s31 s32 s33 ")') s31,s32,s33
c$$$      write(6,'(" -- a(rr=<Ri|Rj>) (rmm3_uda) --")')
c$$$      write(6,'(3d12.4, " : r11 r12 r13 ")') a11,a12,a13
c$$$      write(6,'(3d12.4, " : r21 r22 r23 ")') a21,a22,a23
c$$$      write(6,'(3d12.4, " : r31 r32 r33 ")') a31,a32,a33
      
      r10=a22*a33-a32*a23
      r20=a21*a33-a31*a23
      r30=a21*a32-a31*a22

      r11=a32*s23+a23*s32 - a22*s33-s22*a33
      r21=a31*s23+s31*a23 - a21*s33-s21*a33
      r31=a31*s22+s31*a22 - a21*s32-s21*a32

      r12=s22*s33 - s32*s23
      r22=s21*s33 - s31*s23
      r32=s21*s32 - s31*s22

      f0= a11*r10 - a12*r20 + a13*r30
      f1= a11*r11 - a12*r21 + a13*r31
     -    -s11*r10 + s12*r20 - s13*r30

      f2= a11*r12 - a12*r22 + a13*r32
     -    -s11*r11 + s12*r21 - s13*r31

      f3= -s11*r12 + s12*r22 - s13*r32
c   -------------- 20021223 -------------------- 
        f3= f3/f0
        f2= f2/f0
        f1= f1/f0
        f0= 1.0d0
c ===============================================
   
      e1=0.d0
      e2=a11/s11
c      print *,'e2=',e2
      e0=0.d0
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           e3=e2
c           e2=0.5d0*e2
c           else 
c            go to 50
c            end if
      do 40 k=1,100
         s=e2*(e2*(f3*e2+f2)+f1)+f0 
        if(s.le.0.d0) then
           go to 50
        else
         s=e2*(3.0d0*f3*e2+2.0d0*f2)+f1 
c           et=e2+1.d-30
c           s1=et*(et*(f3*et+f2)+f1)+f0 
c           if((s1-s).ge.0.d0 ) then
           if(s.ge.0.d0 ) then
              e2=e0 + (e2-e0)*0.5d0 
           else
              e3=e2
              e2 = e2 + (e2-e0)*0.5d0
              e0 = e2
           end if
        end if
 40   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3    k=100 is insufficient    *'
      write(6,*)'******************************************************'
      end if
 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'
	e1=e0

      do 10 j=1,250

        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c$$$        if((e2-e1).lt.5.d-22) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20
c        if((dabs(s).lt.1.d-90).or.((e2-e1)/e2.lt.1.d-17)) go to 20
c        if((qabs(s).lt.1.d-70).or.((e2-e1)/e2.lt.1.d-10)) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3    j=250 is insufficient    *'
      write(6,*) 'e2,e1=',e2,e1
      write(6,*)'******************************************************'
      end if
 20   continue
      if((e2/a11)*s11.ge.1.d0) then
      if(ipri .ge. 1 ) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3        vector not improved  *'
      write(6,*) 'a11/s11=',a11/s11
      write(6,*) 'e2,s=',e2,s
      write(6,*) 'e1=',e1
      write(6,*) 'j=',j
      write(6,*)'******************************************************'
      end if
      end if
c      write(6,*) 'a11=',a11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      d=(a12-e2*s12)*(a23-e2*s23)- (a13-e2*s13)*(a22-e2*s22)
      c(2)=(-(a11-e2*s11)*(a23-e2*s23)+(a13-e2*s13)*(a21-e2*s21))/d
      c(3)=(-(a12-e2*s12)*(a21-e2*s21)+(a22-e2*s22)*(a11-e2*s11))/d

      ee=(c(1)*c(1)*a11+2.d0*c(1)*c(2)*a12+c(2)*c(2)*a22+
     -     2.d0*c(1)*c(3)*a13+2.d0*c(2)*c(3)*a23+c(3)*c(3)*a33)/
     -     (c(1)*c(1)*s11+2.d0*c(1)*c(2)*s12+c(2)*c(2)*s22+
     -     2.d0*c(1)*c(3)*s13+ 2.d0*c(2)*c(3)*s23+c(3)*c(3)*s33)

      if((dabs(ee-e2)/e2.ge.1.d-5).and.(e2.gt.1.d0-20)) then
c      if((dabs(ee-e2)/e2.ge.1.d-3).and.(e2.gt.1.d0-13)) then
c      if(qabs(ee-e2)/e2.ge.1.d-5) then
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm3        vector not reliable  *'
      write(6,*) 'ee=',ee
      write(6,*) 'e1=',e1
      write(6,*) 'e2=',e2
      write(6,*)'******************************************************'

cccccc12/12/2002cccccccccccccccc
      write(6,*) ' f3,f2=',f3,f2
      write(6,*) ' f1,f0=',f1,f0
      write(6,*) 'a(0,0),(0,1),(0,2)=',am(0,0),am(0,1),am(0,2)
      write(6,*) '      a(1,1),(1,2)=',am(1,1),am(1,2)
      write(6,*) '            a(2,2)=',am(2,2)
      write(6,*) 's(0,0),(0,1),(0,2)=',sm(0,0),sm(0,1),sm(0,2)
      write(6,*) '      s(1,1),(1,2)=',sm(1,1),sm(1,2)
      write(6,*) '            s(2,2)=',sm(2,2)
      end if
      end if
c      write(6,*) 'ee=',ee
c      write(6,*) 'e2=',e2

c      write(6,*)'   e1=',e1
c      write(6,*)'   e2=',e2
c      write(6,*)'   e3=',e3
c      write(6,*)' jj=',j,'   f(e1) = ',s
c       write(6,*)'eigen vector =',c(1),c(2),c(3)
c      write(6,*) 'recalculated eigen value by using c1,c2,c3'
c      write(6,*) ee
 
 30   continue
      alpha(1) = c(2)
      alpha(2) = c(3)
c      alpha(1) = c(2)*0.75d0
c      alpha(2) = c(3)*0.75d0
      return
      end

      subroutine rmm2_uda(ipri,nrmm,am,sm,alpha)
      implicit real*8(a-h,o-z)
      integer  ipri, nrmm
      dimension am(0:nrmm-1,0:nrmm-1),sm(0:nrmm-1,0:nrmm-1)
     &     ,alpha(nrmm-1)
      dimension c(2)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 2 basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2)
c 
c                      1>=|0> : trial vector
c                      2>=R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this routine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c    
c-----------------------------------------------------------------
      a11 = am(0,0)
      a12 = am(1,0)
      a22 = am(1,1)
      s11 = sm(0,0)
      s12 = sm(1,0)
      s22 = sm(1,1)

c      print *,'-------------------------------------------------------'
c      print *,'a11=',a11
c      print *,'a12=',a12
c      print *,'a22=',a22
c      print *,'s11=',s11
c      print *,'s12=',s12
c      print *,'s22=',s22

      a21=a12
      s21=s12

      f1= s11*s22 - s12*s21

      f2= a12*s21 + a21*s12 
     -     -s11*a22 - a11*s22

      f3= a11*a22  - a21*a12
    
      e1=0.d0
      e2=a11/s11
c$$$      e2 = -f2/(2*f1)
      if (e2.lt.1.d-20)then
         alpha(1)=0.0d0
         return
         end if

c      do 40 k=1,100
c           go to 50
c        else
c           et=e2+1.d-30
c           s1=et*(et*f1+f2)+f3 
c           if((s1-s).ge.0.d0 ) then
c              e2=e0 + (e2-e0)*0.5d0 
c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
        s=e2*(e2*f1+f2)+f3 
        if(s.gt.0.d0) then
           if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2  vector is not improved    *'
      write(6,*)'******************************************************'
           end if
        alpha(1)=0.0d0
        return
        end if
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      e1start = e1
      e2start = e2
      do 10 j=1,250

         s=e2*(e2*f1+f2)+f3
c$$$         if((e2-e1).lt.5.d-22) go to 20
c$$$        if((qabs(s).lt.1.d-70).or.((e2-e1)/e2.lt.1.d-10)) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if

 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2    j=250 is insufficient    *'
      write(6,*)'******************************************************'
      write(6,'(" s = ",d15.5, " e2,e1,e2-e1 = ",3d15.5)') s,e2,e1,e2-e1
      write(6,'(" e2start, e1start, e2start-e1start = ",3d15.5)')
     &     e2start,e1start,e2start-e1start
      end if
 20   continue

      if((e2/a11)*s11.ge.1.d0) then
         if( ipri. ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2        vector not improved  *'
      write(6,*)'******************************************************'
      write(6,*) 'a11/s11=',a11/s11
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'a11=',a11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      c(2)=-(a11-e2*s11)/(a12-e2*s12)

      ee=(c(1)*c(1)*a11+2.d0*c(1)*c(2)*a12+c(2)*c(2)*a22)/
     -   (c(1)*c(1)*s11+2.d0*c(1)*c(2)*s12+c(2)*c(2)*s22)

      if(dabs(ee-e2)/e2.ge.1.d-5) then
c      if(qabs(ee-e2)/e2.ge.1.d-5) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub rmm2        vector not reliable  *'
      write(6,*)'******************************************************'
      write(6,*) 'ee=',ee
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'ee=',ee
c      write(6,*) 'e2=',e2

c      write(6,*)'   e1=',e1
c      write(6,*)'   e2=',e2
c      write(6,*)'   e3=',e3
c      write(6,*)' jj=',j,'   f(e1) = ',s
c       write(6,*)'eigen vector =',c(1),c(2)
c      write(6,*) 'recalculated eigen value by using c1,c2'
c      write(6,*) ee
 
 30   continue

      alpha(1) = c(2)
      return
      end
c-----------------------------------------------------------------
      subroutine crmm2_uda(ipri,nrmm,rcam,rcsm,alpha)
      implicit real*8(a,b,d-h,o-z)
      implicit complex*16 (c)
      integer ipri, nrmm
      dimension rcam(0:nrmm-1,0:nrmm-1,2),rcsm(0:nrmm-1,0:nrmm-1,2)
     &     ,alpha(nrmm-1,2)
      complex*16 cam(0:1,0:1),csm(0:1,0:1)
      dimension c(2)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 2 basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2)
c 
c                      1>=|0> : trial vector
c                      2>=R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this rootine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c    
c    * Revised by T. Yamasaki,  14th Mar. 2003 
c        + calpha
c               --> alpha
c        + calpha(1) = c(2)
c               -->
c             alpha(1) = dreal(c(2))
c    * Revised by T. Uda and T. Yamasaki, 19th Mar. 2003
c        + alpha(nrmm-1)
c               --> alpha(nrmm-1,2)
c        + alpha(1) = dreal(c(2))
c               -->
c             alpha(1,1) = dreal(c(2))
c             alpha(1,2) = dimag(c(2))
c-----------------------------------------------------------------


      do i = 0, nrmm-1
         do j = 0, nrmm-1
            cam(i,j) = dcmplx(rcam(i,j,1),rcam(i,j,2))
            csm(i,j) = dcmplx(rcsm(i,j,1),rcam(i,j,2))
         end do
      end do
      ca11 = cam(0,0)
      ca21 = cam(1,0)
      ca12 = cam(0,1)
      ca22 = cam(1,1)

      cs11 = csm(0,0)
      cs21 = csm(1,0)
      cs12 = csm(0,1)
      cs22 = csm(1,1)

c      print *,'-------------------------------------------------------'
c      print *,'ca11=',ca11
c      print *,'ca12=',ca12
c      print *,'ca22=',ca22
c      print *,'cs11=',cs11
c      print *,'cs12=',cs12
c      print *,'cs22=',cs22


      f1= cs11*cs22 - cs12*cs21

      f2= ca12*cs21 + ca21*cs12 
     -     -cs11*ca22 - ca11*cs22

      f3= ca11*ca22  - ca21*ca12



      e1=0.d0
      e2=ca11/cs11
c$$$      e20=e2

      if (e2.lt.1.d-20) then
         alpha(1,1)=0.0d0
         alpha(1,2)=0.0d0
         return
      end if

c      do 40 k=1,100
c        if(s.le.0.d0) then
c           go to 50
c        else
c           s=2.0d0*e2*f1+f2
c           et=e2+1.d-30
c           s1=et*(et*f1+f2)+f3

        s=e2*(e2*f1+f2)+f3

           if(s.ge.0.d0 ) then
              if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2   vector is not improved   *'
      write(6,*)'******************************************************'
              end if
           
           alpha(1,1)=0.0d0
           alpha(1,2)=0.0d0
           return
           end if

c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
c 40   continue
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      do 10 j=1,250

        s=e2*(e2*f1+f2)+f3
c$$$        if((e2-e1).lt.5.d-22) go to 20
c        if((dabs(s).lt.1.d-90).or.((e2-e1)/e2.lt.1.d-10)) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s. lt. 0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2    j=250 is insufficient   *'
      write(6,*)'******************************************************'
      write(6,'(" s = ",d20.5)') s
      end if
 20   continue
      
      test = (e2/ca11)*cs11
      if(test.ge.1.d0) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2        vector not improved *'
      write(6,*)'******************************************************'
      write(6,*) 'a11/s11=',ca11/cs11
      write(6,*) 'e2=',e2
         end if
      end if
c      write(6,*) 'a11=',ca11
c      write(6,*) 'e2=',e2

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      c(2)=-(ca11-e2*cs11)/(ca12-e2*cs12)

      ee=real(c(1)*c(1)*ca11+2.d0*c(1)*c(2)*ca12+
     -                                     dconjg(c(2))*c(2)*ca22)/
     -   real(c(1)*c(1)*cs11+2.d0*c(1)*c(2)*cs12+
     -                                     dconjg(c(2))*c(2)*cs22)

      if(dabs(ee-e2)/e2.ge.1.d-5) then

         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm2       vector not reliable  *'
      write(6,*)'******************************************************'
      write(6,*) 'ee=',ee
      write(6,*) 'e1,e2=',e1,e2
         end if
      end if
 
 30   continue

      alpha(1,1) = dreal(c(2))
      alpha(1,2) = dimag(c(2))
      return
      end
c------------------------------------------------------------------
      subroutine crmm3_uda(ipri,nrmm,rcam,rcsm,alpha)
      implicit real*8(a,b,d-h,o-z)
      implicit complex*16 (c)
      integer ipri,nrmm
      dimension rcam(0:nrmm-1,0:nrmm-1,2),rcsm(0:nrmm-1,0:nrmm-1,2)
     &     ,alpha(nrmm-1,2)
      complex*16 cam(0:2,0:2),csm(0:2,0:2),c(3)
c-----------------------------------------------------------------
c   
c     Residual Minimization Method with 3basis
c  
c           R=H-<H>   
c   
c           Minimization of Residual  <i|R*R|j>/ <i|S|j> (i,j=1,2,3)
c 
c                      |1>=|0> : trial vector
c                      |2>=R|0>
c                      |3>=R|2>=R*R|0>
c           
c           Initial Residual: Ri= <1|R*R|1>/ <1|S|1> 
c     
c                When Ri<1.d-20 this rootine is skipped.      
c   
c                                          2003/02/21
c                                          written by T.Uda   
c
c    * Revised by T. Yamasaki,  14th Mar. 2003 
c        + calpha
c               --> alpha
c        + calpha(1) = c(2)
c          calpha(2) = c(3)
c               -->
c             alpha(1) = dreal(c(2))
c             alpha(2) = dreal(c(3))
c    * Revised by T. Uda and T. Yamasaki, 19th Mar. 2003
c        + alpha(nrmm-1)
c               --> alpha(nrmm-1,2)
c        + alpha(1) = dreal(c(2))
c          alpha(2) = dreal(c(3))
c               -->
c             alpha(1,1) = dreal(c(2))
c             alpha(2,1) = dreal(c(3))
c             alpha(1,2) = dimag(c(2))
c             alpha(2,2) = dimag(c(3))
c-----------------------------------------------------------------

c$$$      write(6,'(" <<crmm3_uda>>")')

      do i = 0, nrmm-1
         do j = 0, nrmm-1
            cam(i,j) = dcmplx(rcam(i,j,1),rcam(i,j,2))
            csm(i,j) = dcmplx(rcsm(i,j,1),rcam(i,j,2))
         end do
      end do
c
      ca11 = cam(0,0)
      ca12 = cam(0,1)
      ca13 = cam(0,2)
      ca22 = cam(1,1)
      ca23 = cam(1,2)
      ca33 = cam(2,2)
      ca21 = cam(1,0)
      ca31 = cam(2,0)
      ca32 = cam(2,1)

      cs11 = csm(0,0)
      cs12 = csm(0,1)
      cs13 = csm(0,2)
      cs22 = csm(1,1)
      cs23 = csm(1,2)
      cs33 = csm(2,2)
      cs21 = csm(1,0)
      cs31 = csm(2,0)
      cs32 = csm(2,1)
      

c$$$      ex1=ca11/cs11
c$$$      ex2=ca22/cs22
c$$$      ex3=ca33/cs33

c      print *,'ex1=',ex1
c      print *,'ex2=',ex2
c      print *,'ex3=',ex3
      
c      isign=0
c      if (ex3.lt.ex2) then
c       ctest=ca12
c       ca12 =ca13
c       ca13 =ctest



c$$$      print *,'-------------------------------------------------------'
c$$$      print *,'ca11=',ca11
c$$$      print *,'ca12=',ca12
c$$$      print *,'ca21=',ca21
c$$$      print *,'ca13=',ca13
c$$$      print *,'ca31=',ca31
c$$$      print *,'ca22=',ca22
c$$$      print *,'ca23=',ca23
c$$$      print *,'ca32=',ca32
c$$$      print *,'ca33=',ca33

c      print *,'cs11=',cs11
c      print *,'cs12=',cs12
c      print *,'cs21=',cs21
c      print *,'cs13=',cs13
c      print *,'cs31=',cs31
c      print *,'cs22=',cs22
c      print *,'cs23=',cs23
c      print *,'cs32=',cs32
c      print *,'cs33=',cs33

      f1= cs11*cs22 - cs12*cs21

      f2= ca12*cs21 + ca21*cs12 
     -     -cs11*ca22 - ca11*cs22

      f3= ca11*ca22  - ca21*ca12



      e1=0.d0
      e2=ca11/cs11
      e20=e2

      if (e2.lt.1.d-20) then
         goto 1001
c$$$         alpha(1,1)=0.0d0
c$$$         alpha(2,1)=0.0d0
c$$$         alpha(1,2)=0.0d0
c$$$         alpha(2,2)=0.0d0
c$$$         return
      end if

        s=e2*(e2*f1+f2)+f3

           if(s.ge.0.d0 ) then
              if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3   vector is not improved   *'
      write(6,*)'******************************************************'
              end if
           
              goto 1001

           return
           end if


      do 10 j1=1,250
c$$$         write(6,'(" j1 = ",i5)') j1

        s=e2*(e2*f1+f2)+f3
c$$$        if((e2-e1).lt.5.d-22) go to 20
        if((e2-e1)/e2.lt.1.d-10) go to 20

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 20
        end if
 10   continue
      if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3   j1=250 is insufficient   *'
      write(6,*)' e20,e21=',e20,e2
      write(6,*)' e1 ,e2 =',e1,e2
      write(6,*)'******************************************************'
      end if
 20   continue

c$$$      write(6,'(" !! out of 20 continue")')

      cr10=ca22*ca33-ca32*ca23
      cr20=ca21*ca33-ca31*ca23
      cr30=ca21*ca32-ca31*ca22

      cr11=ca32*cs23+ca23*cs32 - ca22*cs33-cs22*ca33
      cr21=ca31*cs23+cs31*ca23 - ca21*cs33-cs21*ca33
      cr31=ca31*cs22+cs31*ca22 - ca21*cs32-cs21*ca32

      cr12=cs22*cs33 - cs32*cs23
      cr22=cs21*cs33 - cs31*cs23
      cr32=cs21*cs32 - cs31*cs22

      f0= ca11*cr10 - ca12*cr20 + ca13*cr30
      f1= ca11*cr11 - ca12*cr21 + ca13*cr31
     -    -cs11*cr10 + cs12*cr20 - cs13*cr30

      f2= ca11*cr12 - ca12*cr22 + ca13*cr32
     -    -cs11*cr11 + cs12*cr21 - cs13*cr31

      f3= -cs11*cr12 + cs12*cr22 - cs13*cr32
c --------------------------------20030219---------------------
             f3= f3/f0
             f2= f2/f0
             f1= f1/f0
             f0= 1.0d0
c =============================================================
c$$$      do j1 = 1, 50
c$$$         write(6,'(" !! out of devided by f0: f0 = ",d20.10)') f0
c$$$      end do
    
c      e1=0.d0
c      e2=ca11/cs11
c      e20=ca11/cs11
c      print *,'e2=',e2
c      e0=0.d0
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           e3=e2
c           e2=0.5d0*e2
c           else 
c            go to 50
c            end if
c      do 40 k=1,100
c        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c        if(s.le.0.d0) then
c           go to 50
c        else
c           s=e2*(3.0d0*f3*e2+f2)+f1
c           et=e2+1.d-30
c           s1=et*(et*(f3*et+f2)+f1)+f0 
c           if(s.ge.0.d0 ) then
c              e2=e0 + (e2-e0)*0.5d0 
c           else
c              e3=e2
c              e2 = e2 + (e2-e0)*0.5d0
c              e0 = e2
c           end if
c        end if
c 40   continue
c      write(6,*)'******************************************************'
c      write(6,*)'*  warning from sub crmm3    k=100 is insufficient   *'
c      write(6,*)'******************************************************'
c 50   continue
c       write(6,*)'k=',k
c       write(6,*)'          ---------------------------------'

      e1=0.0d0
      e21=e2

 
      do 110 j2=1,250
      
        s=e2*(e2*(f3*e2+f2)+f1)+f0 
c$$$        write(6,'(" j2 = ",i5, " e2 = ",d20.10," s= ",d20.10)') j2, e2,s
c$$$        if((e2-e1).lt.1.0d-25) go to 120
        if((e2-e1)/e2.lt.1.0d-10) go to 120

        if(s.lt.0.d0) then
           e2=e1+(e2-e1)*0.5d0
        else if (s. gt. 0.d0)then
           e3=e2
           e2=e2+(e2-e1)*0.5d0
           e1=e3
        else 
           go to 120
        end if
 110   continue
       if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3  j2=250 is insufficient    *'
      write(6,*)' e20,e21,e2=',e20,e21,e2
      write(6,*)' e1 ,e2 =',e1,e2
      write(6,*) 'j =',j
      write(6,*)'******************************************************'
       end if
 120   continue

      d=f2*f2 - 3.d0*f1*f3
      if (d.lt.0.0d0 .or. dabs(f3).lt.1.d-50) then
         if(ipri .ge. 1)
     &   write(6,'(" !rmmsubs d = ",d20.10," f1,f2,f3 = ",3d20.10)')
     &        d, f1,f2,f3
         if(d.lt.0.0d0 .and. ipri.ge.1) 
     &        write(6,*) ' !crmm3 warning d < 0.0'
         if(dabs(f3).lt.1.d-50 .and. ipri.ge.1) 
     &        write(6,*) ' !crmm3 warning |f3| <delta'
         goto 1001
      end if

c$$$       zeropoint1 = (-f2-sqrt(d))/(3.0d0*f3)
       zeropoint2 = (-f2+sqrt(d))/(3.0d0*f3)

c$$$      write(6,'(" !rmmsubs zeropoint2 = ",d20.10)') zeropoint2

c$$$       s0=zeropoint2*(zeropoint2*(zeropoint2*f3+f2)+f1)+f0
       s1=e1*(e1*(e1*f3+f2)+f1)+f0
       s2=e2*(e2*(e2*f3+f2)+f1)+f0
c$$$       do j1 = 1, 200
c$$$          write(6,'(" !!s1,s2,zeropoint2 = ",3d20.10)') s1,s2,zeropoint2
c$$$       end do
c       write(6,*) 'zeropoint2, f(zeropoint2)=',zeropoint2,s2
c       write(6,*)' e20,e21,e2=',e20,e21,e2

      if(e2.gt.zeropoint2) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3      e2 > zero point       *'
      write(6,*)'   e2,e21,e20=',e2,e21,e20
      write(6,*)'******************************************************'
         end if
      end if
      if(s1.lt.-1.0d-10.or.s2.gt.1.0d-10) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3                            *'
      write(6,*)'   e1,e2,zeropoint2=',e1,e2,zeropoint2
      write(6,*)'   e2,e21,e20=',e1,e21,e20
      write(6,*)' f(e1)=',s1,'f(e2)=',s2
      write(6,*)'******************************************************'
         end if
      end if
 

c      e3=(e1+e2)*0.5d0
      c(1)=1.d0
      cd=(ca12-e2*cs12)*(ca23-e2*cs23)- (ca13-e2*cs13)*(ca22-e2*cs22)
      c(2)=(-(ca11-e2*cs11)*(ca23-e2*cs23)+(ca13-e2*cs13)*
     -    (ca21-e2*cs21))/cd
      c(3)=(-(ca12-e2*cs12)*(ca21-e2*cs21)+(ca22-e2*cs22)*
     -    (ca11-e2*cs11))/cd

      ee=real(c(1)*c(1)*ca11+2.d0*c(1)*c(2)*ca12
     -                      +conjg(c(2))*c(2)*ca22+
     -     2.d0*c(1)*c(3)*ca13+2.d0*conjg(c(2))*c(3)*ca23
     -                      +conjg(c(3))*c(3)*ca33)/
     -     real(c(1)*c(1)*cs11+2.d0*c(1)*c(2)*cs12
     -                      +conjg(c(2))*c(2)*cs22+
     -     2.d0*c(1)*c(3)*cs13+ 2.d0*conjg(c(2))*c(3)*cs23
     -                      +conjg(c(3))*c(3)*cs33)

      if((dabs(ee-e2)/e2).ge.1.d-5) then
         if(ipri .ge. 1) then
      write(6,*)'******************************************************'
      write(6,*)'*  warning from sub crmm3        vector not reliable *'
      write(6,*) 'e20,ee=',e20,ee
      write(6,*) 'e1 ,e2=',e1,e2
      write(6,*)'******************************************************'
         end if
      end if

 30   continue
      alpha(1,1) = dreal(c(2))
      alpha(2,1) = dreal(c(3))
      alpha(1,2) = dimag(c(2))
      alpha(2,2) = dimag(c(3))
      return
 1001 continue
      alpha(1,1) = 0.d0
      alpha(2,1) = 0.d0
      alpha(1,2) = 0.d0
      alpha(2,2) = 0.d0
      return
      end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  PROGRAM: TDLRMAIN
!
!  AUTHOR(S): K. Tagami et al   Aug. 1 2011
!
!  The license of the code and contact address:
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=======================================================================

! ======================================================================
!  This is a collection of subroutines for spectra called in the main program.
! ======================================================================

! ======================= history ======================================
!  ver 1.0 :  2010/3/31
!               applicable to the crystal such as Si.  
!  ver 2.0 :  2011/3/31
!               applicable to the isolated molecule such as C6H6.
!
! ======================================================================

!---------------------------------------------------
!!
!!!           Calc Density etc. 
!!
!---------------------------------------------------
subroutine Calc_RhoTilde_General
  use m_LinearResponse_Density,   only : Add_SoftPart_General, Add_HardPart_General
  use m_PseudoPotential,          only : modnrm
  use m_Const_Parameters,         only : EXECUT

  implicit none

  call Add_SoftPart_General
  if ( modnrm == EXECUT ) call Add_HardPart_General
end subroutine Calc_RhoTilde_General

subroutine Calc_RhoTilde_LWLimit
  use m_LinearResponse_Density,   only : Add_SoftPart_LWLimit, Add_HardPart_LWLimit, &
       &                                 Add_Correction_To_G0, Add_KageShira_To_G0
  use m_PseudoPotential,          only : modnrm
  use m_Const_Parameters,         only : EXECUT

  implicit none

  Call Add_SoftPart_LWLimit
  if ( modnrm == EXECUT )  Call Add_HardPart_LWLimit
  Call Add_Correction_To_G0
  Call Add_KageShira_To_G0
end subroutine Calc_RhoTilde_LWLimit

!------------------------------------------------------
!!
!!!      calc  Matrix G ( DYSON, xc_kernel_type == ALDA_R )
!!
!------------------------------------------------------
subroutine Calc_MatrixG_General
  use m_LinearResponse_ALDA,     only : Add_SoftPart_MatG_General

  implicit none

  Call Add_SoftPart_MatG_General
end subroutine Calc_MatrixG_General

subroutine Calc_MatrixG_LWLimit
  use m_LinearResponse_ALDA,     only : Add_SoftPart_MatG_LWLimit

  implicit none

  call Add_SoftPart_MatG_LWLimit

end subroutine Calc_MatrixG_LWLimit

!---------------------------------------------------
!!
!!!           Open/close file for Spectrum  
!!
!---------------------------------------------------
subroutine Open_File_Spectrum
  use m_Files,              only  : m_Files_open_nf_LR
  use m_Parallelization,    only :  mype
  implicit none

  if ( mype == 0 ) call m_Files_open_nf_LR()
end subroutine Open_File_Spectrum

subroutine Close_File_Spectrum
  use m_Files,              only  : m_Files_close_nf_LR
  use m_Parallelization,    only :  mype
  implicit none

  if ( mype == 0 ) call m_Files_close_nf_LR
end subroutine Close_File_Spectrum

!---------------------------------------------------
!!
!!!         Initialize / Finalize Spectrum  
!!
!---------------------------------------------------
subroutine Initialization_Spectrum
  use m_Const_Parameters,           only : Valence_plus_PC_Charge
  use m_LinearResponse_ALDA,        only : m_LR_alloc_Matrix_G, m_LR_alloc_Matrix_T,&
       &                                   m_LR_alloc_RKernels_ALDA, &
       &                                   m_LR_alloc_igfp, m_LR_set_igfp
  use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R, ALDA_G, &
       &                                   tddft_eqn_type, DYSON, BS
  use m_LinearResponse_Kernel,      only : m_LR_alloc_Coulomb_Kernels, &
       &                                   m_LR_alloc_XC_Kernels
!  use m_LinearResponse_Spectrum,    only : m_LR_alloc_Chi_Head
  use m_LinearResponse_NonInt,      only : m_LR_alloc_Mat_Chi0
  !!use m_LinearResponse_ALDA,        only : m_LR_alloc_igfp, m_LR_set_igfp
  !!use m_LinearResponse_Control,     only : tddft_eqn_type, DYSON, BS
  implicit none

! -------------------------------- start ----------------
  call m_LR_alloc_Coulomb_Kernels
  if ( tddft_eqn_type == DYSON ) call m_LR_alloc_XC_Kernels
  call m_LR_alloc_Mat_Chi0
  !call m_LR_alloc_Chi_Head
  call alloc_chi_head()

  if ( xc_kernel_type == ALDA_R .or. xc_kernel_type == ALDA_G ) then
     call m_LR_alloc_RKernels_ALDA
     call m_LR_alloc_igfp
     call m_LR_set_igfp
  endif
!
  if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
     Call m_LR_alloc_Matrix_G
     Call m_LR_alloc_Matrix_T
  endif
  call set_Coulomb_and_XC_Kernels
  call Open_File_Spectrum
! ------------------------------- end ----------------
end subroutine Initialization_Spectrum

subroutine Finalization_Spectrum
  use m_LinearResponse_ALDA,        only : m_LR_dealloc_Matrix_G, &
       &                                   m_LR_dealloc_Matrix_T, &
       &                                   m_LR_dealloc_RKernels_ALDA, &
       &                                   m_LR_dealloc_igfp
  use m_LinearResponse_Kernel,      only : m_LR_dealloc_Coulomb_Kernels, &
       &                                   m_LR_dealloc_XC_Kernels
  use m_LinearResponse_NonInt,      only : m_LR_dealloc_Mat_Chi0
!  use m_LinearResponse_Spectrum,    only : &
!       &                                   m_LR_dealloc_Chi_Head, &
!       &                                   m_LR_dealloc_MatL
  use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R, ALDA_G, &
       &                                   tddft_eqn_type, DYSON, BS
  !!use m_LinearResponse_ALDA,        only : m_LR_dealloc_igfp
  use m_LinearResponse_BS,        only : m_LR_dealloc_MatV, &
       &                                   m_LR_dealloc_MatK_ALDA, &
       &                                   m_LR_dealloc_MatXi, &
       &                                   m_LR_dealloc_MatL0 
  !!use m_LinearResponse_Control,     only : tddft_eqn_type, DYSON, BS

  implicit none

! ---------------------------------- start ---------
  Call m_LR_dealloc_Coulomb_Kernels
  if ( tddft_eqn_type == DYSON ) Call m_LR_dealloc_XC_Kernels
  Call m_LR_dealloc_Mat_Chi0
!  Call m_LR_dealloc_Chi_Head
  call dealloc_chi_head()

  if ( xc_kernel_type == ALDA_R .or. xc_kernel_type == ALDA_G ) then
     call m_LR_dealloc_RKernels_ALDA
     call m_LR_dealloc_igfp
  end if
  if ( tddft_eqn_type == DYSON .and. xc_kernel_type == ALDA_R ) then
     call m_LR_dealloc_Matrix_G
     call m_LR_dealloc_Matrix_T
  endif

  if ( tddft_eqn_type == BS ) then
     if ( xc_kernel_type == ALDA_R ) then
        call m_LR_dealloc_MatK_ALDA
     endif
     call m_LR_dealloc_MatV
     call m_LR_dealloc_MatXi
     call m_LR_dealloc_MatL0
!     call m_LR_dealloc_MatL
     call dealloc_matl()
  endif

  call Close_File_Spectrum
! --------------------------------- end -----------
end subroutine Finalization_Spectrum

!---------------------------------------------------
!!
!!!          Calc Spectrum  in the case of DYSON
!!
!---------------------------------------------------
subroutine Calc_Spectrum
!  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header, &
!       &                                    Write_Spectrum_Data, &
!       &                                    Calc_Chi_Head, Mat_Chi0, &
!       &                                    set_nband_LR
  use m_LinearResponse_Density,     only : Calc_FermiLevel_ek
  use m_LinearResponse_Control,     only : nrd_efermi, e, nstep, sw_LongWaveLimit, &
       &                                   xc_kernel_type, ALDA_R
  use m_LinearResponse_NonInt,      only : Calc_Chi0_LWLimit, Calc_Chi0_General, &
       &                                   Check_Total_Charge
  use m_Const_Parameters,           only : Hartree, DP, Valence_plus_PC_Charge
  !!$use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R
  use m_LinearResponse_ALDA,        only : Calc_MatrixT_LWLimit, Calc_MatrixT_General
!
  !!use m_LinearResponse_Spectrum,  only : set_nband_LR
  use m_Files,                      only : nfout

  implicit none

  integer            :: istep
  real(kind=DP)      :: ene
! ------------------------------------ start -------------
  Call Calc_FermiLevel_ek( nrd_efermi )
! --debug
!  Call Check_Total_Charge
!  stop
! --
!  call Write_Spectrum_Header
!  call set_nband_LR
  call write_header()
  call set_nb()
! ------------------------------------- main ---------------
  Do istep=1, nstep
     ene = e(istep)
     if ( sw_LongWaveLimit==1 ) then
        Call Calc_Chi0_LWLimit( ene )
        if ( xc_kernel_type == ALDA_R ) call Calc_MatrixT_LWLimit( ene )
     else
        Call Calc_Chi0_General( ene )
        if ( xc_kernel_type == ALDA_R ) call Calc_MatrixT_General( ene )
     endif
!     Call Calc_Chi_Head( ene )
!     Call Write_Spectrum_Data( ene )
     Call chi_head( ene )
     call write_data(ene)
     write(nfout,*) '! spectrum at ', istep, '-th ( e=', ene ,' ) is finished.'
  End do
end subroutine Calc_Spectrum

!---------------------------------------------------
!!
!!!         Calc Spectrum in the case of BS && ALDA_R
!!
!---------------------------------------------------
subroutine Calc_Spectrum_Mol
!  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header, &
!       &                                    Write_Spectrum_Data, &
!       &                                    Calc_Chi_Head, Mat_Chi0, &
!       &                                    set_nband_LR, m_LR_Alloc_MatL, &
!       &                                    Calc_MatL, Calc_Chi_Head_Mol
  use m_LinearResponse_Density,     only : Calc_FermiLevel_ek
  use m_LinearResponse_Control,     only : nrd_efermi, e, nstep, sw_LongWaveLimit, &
       &                                   xc_kernel_type, ALDA_R
  use m_LinearResponse_NonInt,      only : Calc_Chi0_LWLimit, Calc_Chi0_General, &
       &                                   Check_Total_Charge
  use m_Const_Parameters,           only : Hartree, DP, Valence_plus_PC_Charge
  !!$use m_LinearResponse_Control,     only : xc_kernel_type, ALDA_R
!
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatK_ALDA, m_LR_Alloc_MatV
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatXi
!  use m_LinearResponse_BS,  only : m_LR_Alloc_MatL0
!  use m_LinearResponse_BS,  only : Calc_MatV, Calc_MatK_ALDA, Calc_MatXi
!  use m_LinearResponse_BS,  only : Calc_MatL0
  use m_LinearResponse_BS,  only : m_LR_Alloc_MatK_ALDA, m_LR_Alloc_MatV &
   ,m_LR_Alloc_MatXi &
   ,m_LR_Alloc_MatL0 &
   ,Calc_MatV, Calc_MatK_ALDA, Calc_MatXi &
   ,Calc_MatL0 &
   ,Check_Charge_on_mesh, Check_exc_energy &
   ,Print_MatV, Print_MatK


  !!use m_LinearResponse_Spectrum,  only : set_nband_LR, m_LR_Alloc_MatL, &
  !!     &                                 Calc_MatL, Calc_Chi_Head_Mol
  use m_Files,                     only : nfout

  !use m_LinearResponse_BS,  only : Check_Charge_on_mesh, Check_exc_energy
  !use m_LinearResponse_BS,  only : Print_MatV, Print_MatK


! --
  implicit none
  integer :: istep
  Real(kind=DP) :: ene
! --------------------------
  Call Calc_FermiLevel_ek( nrd_efermi )
!  Call Check_Total_Charge
!  stop
! --
!  call Write_Spectrum_Header
!  call set_nband_LR
  call write_header()
  call set_nb()
! --
!  Call Check_Charge_on_mesh
!  Call Check_Exc_energy
!  stop

! ------------
  call m_LR_Alloc_MatV
  call Calc_MatV
  if ( xc_kernel_type == ALDA_R ) then
     call m_LR_Alloc_MatK_ALDA
     call Calc_MatK_ALDA
  endif
! --
!!!!!!!!!!!  Call print_MatV
!!!!!!!!!!!!  if ( xc_kernel_type == ALDA_R ) Call print_MatK
!  stop

  call m_LR_Alloc_MatXi
  call Calc_MatXi
!
  call m_LR_Alloc_MatL0
!  call m_LR_Alloc_MatL
  call alloc_matl()
! ------------------------------------- main ---------------
  Do istep=1, nstep
     ene = e(istep)
!     write(*,*) 'istep = ', istep, ene
     call Calc_MatL0( ene )
!     Call Calc_MatL
     call mat_l()
!     call Calc_Chi_Head_Mol( ene )
!     Call Write_Spectrum_Data( ene )
     call chi_head_mol( ene )
     call write_data(ene)
     write(nfout,*) '! spectrum at ', istep, '-th ( e=', ene ,' ) is finished.'
  End do
!
end subroutine Calc_Spectrum_Mol

! -----------------------------------------------------
!!
!!!               set Coulomb + XC Kernels
!!
!-------------------------------------------------------
subroutine set_Coulomb_and_XC_Kernels
  use m_LinearResponse_Control,   only : xc_kernel_type, RPA, ALDA_G, ALDA_R, &
       &                                LRC, LRC_alpha, &
       &                                sw_Coulomb_Screening
  use m_LinearResponse_Kernel,   only : set_Coulomb_Kernel, &
       &                                set_Screened_Coulomb_Kernel, &
       &                                set_XC_Kernel_RPA, &
       &                                set_XC_Kernel_ALDA_G, &
       &                                set_XC_Kernel_ALDA_R, &
       &                                set_XC_Kernel_LRC
  use m_Const_Parameters,         only : Valence_Plus_PC_Charge
  use m_Control_Parameters,       only : xctype

  implicit none

! -------------------------------- start ----------
!  write(*,*) 'xc_type = ',xctype, xc_kernel_type
  if ( sw_Coulomb_Screening==1 ) then
     Call set_Screened_Coulomb_Kernel
  else
     Call set_Coulomb_Kernel
  endif

  select case (xc_kernel_type)
  case (RPA)
     Call set_XC_Kernel_RPA
  case (LRC)
     Call set_XC_Kernel_LRC( LRC_alpha )
  case (ALDA_G)
     Call set_XC_kernel_ALDA_G( Valence_plus_PC_Charge )
  case (ALDA_R)
     Call set_XC_kernel_ALDA_R( Valence_plus_PC_Charge )
  end select

end subroutine set_Coulomb_and_XC_Kernels

subroutine alloc_chi_head()
  use m_LinearResponse_Spectrum,    only : m_LR_alloc_Chi_Head
  call m_LR_alloc_Chi_Head()
end subroutine alloc_chi_head

subroutine dealloc_chi_head()
  use m_LinearResponse_Spectrum, only : m_LR_dealloc_Chi_Head
  Call m_LR_dealloc_Chi_Head
end subroutine dealloc_chi_head

subroutine dealloc_matl()
  use m_LinearResponse_Spectrum, only : m_LR_dealloc_MatL
  call m_LR_dealloc_MatL
end subroutine dealloc_matl

subroutine write_header()
  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Header
  implicit none
  call Write_Spectrum_Header()
end subroutine write_header

subroutine chi_head(ene)
  use m_Const_Parameters, only : DP
  use m_LinearResponse_Spectrum, only : Calc_Chi_Head
  implicit none
  real(kind=DP), intent(in) :: ene   
  call Calc_Chi_Head(ene)
end subroutine chi_head

subroutine chi_head_mol(ene)
  use m_Const_Parameters, only : DP
  use m_LinearResponse_Spectrum, only : Calc_Chi_Head_Mol
  implicit none
  real(kind=DP), intent(in) :: ene   
  call Calc_Chi_Head_Mol(ene)
end subroutine chi_head_mol

subroutine write_data(ene)
  use m_LinearResponse_Spectrum,    only :  Write_Spectrum_Data
  use m_Const_Parameters, only : DP
  implicit none
  real(kind=DP), intent(in) :: ene
  call Write_Spectrum_Data(ene)
end subroutine write_data

subroutine set_nb()
  use m_LinearResponse_Spectrum, only : set_nband_LR
  implicit none
  call set_nband_LR
end subroutine set_nb

subroutine alloc_matl()
  use m_LinearResponse_Spectrum, only : m_LR_Alloc_MatL
  implicit none
  call m_LR_Alloc_MatL
end subroutine

subroutine mat_l()
  use m_LinearResponse_Spectrum, only : Calc_MatL
  implicit none
  call Calc_MatL
end subroutine mat_l

!*********************************************************
!* 逆空間でのクーロン力を遮蔽するポテンシャルを作成するモジュール
!*
!* 2006年6月19日改良版
!*********************************************************

! 3次元座標型とその演算子の定義
module class_position
  use m_Const_Parameters, only : DP
  implicit none

  type position
     real(kind=DP) :: x, y, z
  end type
  
  interface operator(+)
     module procedure add
  end interface
  
  interface operator(-)
     module procedure sub
  end interface

  interface operator(*)
     module procedure smul
  end interface

  interface operator(/)
     module procedure sdiv
  end interface
  
  interface operator(*)
     module procedure iprod
  end interface

  interface operator(.IPROD.)
     module procedure iprod
  end interface

  interface operator(.OPROD.)
     module procedure oprod
  end interface

contains
  function add( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%x + r2%x
    r%y = r1%y + r2%y
    r%z = r1%z + r2%z
  end function

  function sub( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%x - r2%x
    r%y = r1%y - r2%y
    r%z = r1%z - r2%z
  end function

  function smul( r1, d ) result(r)
    type(position), intent(in) :: r1
    real(kind=DP), intent(in) :: d
    type(position) :: r

    r%x = r1%x * d
    r%y = r1%y * d
    r%z = r1%z * d
  end function

  function sdiv( r1, d ) result(r)
    type(position), intent(in) :: r1
    real(kind=DP), intent(in) :: d
    type(position) :: r

    r%x = r1%x / d
    r%y = r1%y / d
    r%z = r1%z / d
  end function

  function iprod( r1, r2 ) result(d)
    type(position), intent(in) :: r1, r2
    real(kind=DP) :: d

    d = r1%x*r2%x + r1%y*r2%y + r1%z*r2%z
  end function

  function oprod( r1, r2 ) result(r)
    type(position), intent(in) :: r1, r2
    type(position) :: r

    r%x = r1%y*r2%z - r1%z*r2%y
    r%y = r1%z*r2%x - r1%x*r2%z
    r%z = r1%x*r2%y - r1%y*r2%x
  end function

  function length( r ) result(d)
    type(position), intent(in) :: r
    real(kind=DP) :: d

    d = sqrt(r%x*r%x + r%y*r%y + r%z*r%z) 
  end function

  function length2( r ) result(d)
    type(position), intent(in) :: r
    real(kind=DP) :: d

    d = (r%x*r%x + r%y*r%y + r%z*r%z) 
  end function

end module

! 遮蔽ポテンシャルモジュール
module m_Screening
  use m_Const_Parameters, only : DP, PAI
!  use m_PlaneWaveBasisSet, only : ngabc, kgp
  use m_Screening_FFT  ! 簡略化したPHASEのFFTモジュールを利用する
  use class_position
  implicit none

  ! 数学定数の設定
  real(kind=DP), parameter :: M_PI       = PAI ! 円周率
  real(kind=DP), parameter :: M_2_SQRTPI = 1.12837916709551257390d0 ! 2/sqrt(pi)

  ! 本モジュールで使用する変数群
  type Screening_param
     type(position) La, Lb, Lc ! 単位胞の格子ベクトル

     !---- PHASE変数のコピーを自前で持つ
     real(kind=DP), pointer, dimension(:,:) ::  ngabc ! PHASE変数

     real(kind=DP) Gmax ! カットオフ波数
     real(kind=DP) alpha ! 遮蔽ポテンシャルの遮蔽パラメタ
     real(kind=DP), dimension(:), pointer :: phik ! 遮蔽ポテンシャル
     integer Nk    ! 波数ベクトルの総数
  end type
  
  type(Screening_param) :: Screening

contains

  ! 遮蔽ポテンシャルを設定するサブルーチン
  subroutine setup_screening
    real(kind=DP)  V             ! 単位胞の体積
    type(position) dKa, dKb, dKc ! 逆格子の刻み
    integer        Na0, Nb0, Nc0 ! 格子点数
    integer        Na, Nb, Nc ! 格子点数
    type(position) dLa, dLb, dLc ! 実格子の刻み
    real(kind=DP)  dV            ! 実格子の刻み
    real(kind=DP)  r             ! 実空間の距離
    real(kind=DP)  kk            ! 逆格子ベクトルのノルム
    
    integer ia, ib, ic     ! 3次元格子点のインデックス
    integer ja, jb, jc     ! 3次元格子点のインデックス
    integer i, j           ! 1次元インデックス

    integer, dimension(3) :: n_rGpv ! FFTモジュールの初期化用の変数

    real(kind=DP),  allocatable, dimension(:) :: phir ! 実格子での値
    type(position), allocatable, dimension(:) :: K    ! 逆格子ベクトル

    ! 体積の計算
    V  = Screening%La .IPROD. ( Screening%Lb .OPROD. Screening%Lc )

    ! 逆格子の刻み幅の設定
    dKa = (Screening%Lb .OPROD. Screening%Lc) * (2.0d0*M_PI/V)
    dKb = (Screening%Lc .OPROD. Screening%La) * (2.0d0*M_PI/V)
    dKc = (Screening%La .OPROD. Screening%Lb) * (2.0d0*M_PI/V)

    ! PHASE変数の n_rGpv (逆格子点の数の概算値) と同じ値を自分で計算する。
    n_rGpv(1) = abs(Screening%Gmax/length(dKa)) + 1
    n_rGpv(2) = abs(Screening%Gmax/length(dKb)) + 1
    n_rGpv(3) = abs(Screening%Gmax/length(dKc)) + 1

    ! PHASE変数の fft_box_size_CD (逆格子点の数) と同じ値を自分で計算する。
    call m_Screening_FFT_set_box_sizes( n_rGpv, 1 )
    call m_Screening_FFT_setup( 1, .false. )

    ! 格子点の数の入手
    Na0 = fft_box_size_CD(1,0)
    Nb0 = fft_box_size_CD(2,0)
    Nc0 = fft_box_size_CD(3,0)
    Na = fft_box_size_CD(1,1)
    Nb = fft_box_size_CD(2,1)
    Nc = fft_box_size_CD(3,1)
    ! 実格子の刻み幅の設定
    dLa = Screening%La*(1.0d0/Na)
    dLb = Screening%Lb*(1.0d0/Nb)
    dLc = Screening%Lc*(1.0d0/Nc)
    dV  = dLa .IPROD. ( dLb .OPROD. dLc) ! ひとつの刻みの体積

    ! 実空間での遮蔽ポテンシャルの長距離成分を保存する配列変数を確保する
    allocate( phir(Na0*Nb0*Nc0) )

    ! 実空間での遮蔽ポテンシャルの長距離成分を設定するループ
    do ic = 0, Nc-1  !実空間の格子点でのループ
       do ib = 0, Nb-1 
          do ia = 0, Na-1
             ! 単位胞の8隅がポテンシャルの原点となるように座標を調整する
             if( 2*ia>Na ) then
                ja = ia-Na
             else
                ja = ia
             end if
             if( 2*ib>Nb ) then
                jb = ib-Nb
             else
                jb = ib
             end if
             if( 2*ic>Nc ) then
                jc = ic-Nc
             else
                jc = ic
             end if

             ! 最寄の隅からの距離
             r = length(dLa*dble(ja) + dLb*dble(jb) + dLc*dble(jc))

             ! 3次元の格子インデックスから1次元配列のインデックスへの変換
             i = (ic*Nb0+ib)*Na0 + (ia + 1)

             ! 実空間での遮蔽ポテンシャルの長距離成分の設定
             phir(i) = phirlong(r)

!             write(15,'(i5,2e15.5,6i5)') i,phir(i),r,ia,ib,ic,ja,jb,jc
!             write(17,'(5f10.6)') dLa%x*dble(ja), dLb%y*dble(jb), dLc%z*dble(jc), r, phir(i)

          end do
       end do
    end do

    ! 実空間での遮蔽ポテンシャルの長距離成分をフーリエ変換で逆空間に変換する
    call m_Screening_FFT_set_box_sizes( n_rGpv, 1 )
    call m_Screening_FFT_setup( 1, .false. )
    call m_Screening_FFT_alloc_CD_box
    call m_Screening_FFT_CD_inverse( 6, phir )
    call m_Screening_FFT_dealloc_CD_box


    ! 逆空間での遮蔽ポテンシャルを保存する配列変数を確保する
    allocate( K(Screening%Nk) )
    allocate( Screening%phik(Screening%Nk) )

    do j=1, Screening%Nk
       ja=Screening%ngabc(j,1)
       jb=Screening%ngabc(j,2)
       jc=Screening%ngabc(j,3)
       ! 逆格子点の波数ベクトルのノルムを計算する
       K(j) = dKa*dble(ja) + dKb*dble(jb) + dKc*dble(jc)
       kk = length2(K(j))

       ! 逆格子点のインデックスを少し変換する。
       if( jc < 0 ) then
          ic = jc + Nc
       else
          ic = jc
       end if
       if( jb < 0 ) then
          ib = jb + Nb
       else
          ib = jb
       end if
       if( ja < 0 ) then
          ia = -2*ja
       else
          ia = +2*ja
       end if
       ! 3次元の格子インデックスから1次元配列のインデックスへの変換
       i = (ic*Nb0+ib)*Na0 + (ia + 1)

       Screening%phik(j) = phir(i)*dV - phiklong(kk)

!       write(16,'(2i5,6e15.5,6i5)') j,i,Screening%phik(j), &
!            phir(i),dV,phir(i)*dV,phiklong(kk), sqrt(kk),&
!            ia,ib,ic,ja,jb,jc
!       write(18,'(6f10.6)') K(j)%x, K(j)%y, K(j)%z, kk, phir(i)*dV, phiklong(kk)
!       write(*,*) Screening%phik(j)
    end do
!    write (*,*) "Debug informations for the screening module"
!    write (*,*) "  Screening%Gmax = ", Screening%Gmax
!    write (*,*) "  n_rGpv() = ", n_rGpv(1), n_rGpv(2), n_rGpv(3)
!    write (*,*) "  N = ", Na, Nb, Nc
!    write (*,*) "  Screening%Nk = ", Screening%Nk
    ! 遮蔽ポテンシャルの値のテスト表示
!    write(*,*) "# i kx ky kz kk PhiK(i)"
!    do j=1, Screening%Nk
!       if( j>32 ) then
!          write(*,*) "omitted"
!          exit
!       end if
!       write(13,100) j, K(j)%x, K(j)%y, K(j)%z, length2(K(j)), Screening%phik(j)
!    end do

    deallocate( K )
    deallocate( phir )
    
100 format(i4,5f11.6)

    return
  end subroutine

  ! 実空間での遮蔽ポテンシャルの長距離成分を返す関数
  real(kind=DP) function phirlong( r ) 
    real(kind=DP) r
    real(kind=DP) derf ! 誤差関数

    if( r == 0.d0 ) then ! 原点は特別に対応する
       phirlong = Screening%alpha*M_2_SQRTPI
    else
       phirlong = derf(Screening%alpha*r)/r
    end if
  end function

  ! 逆空間での遮蔽ポテンシャルの長距離成分を返す関数
  real(kind=DP) function phiklong( kk ) 
    real(kind=DP) kk

    if( kk == 0.d0 ) then ! 原点は特別に対応する
       phiklong = -M_PI/(Screening%alpha*Screening%alpha)
    else
       phiklong = 4.0d0*M_PI/kk*exp(-kk/(4.0d0*Screening%alpha*Screening%alpha))
    end if
  end function

end module

      SUBROUTINE PDLAED0( N, D, E, Q, IQ, JQ, DESCQ, WORK, IWORK, INFO )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            INFO, IQ, JQ, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * ), IWORK( * )
      DOUBLE PRECISION   D( * ), E( * ), Q( * ), WORK( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAED0 computes all eigenvalues and corresponding eigenvectors of a
*  symmetric tridiagonal matrix using the divide and conquer method.
*
*
*  Arguments
*  =========
*
*  N       (global input) INTEGER
*          The order of the tridiagonal matrix T.  N >= 0.
*
*  D       (global input/output) DOUBLE PRECISION array, dimension (N)
*          On entry, the diagonal elements of the tridiagonal matrix.
*          On exit, if INFO = 0, the eigenvalues in descending order.
*
*  E       (global input/output) DOUBLE PRECISION array, dimension (N-1)
*          On entry, the subdiagonal elements of the tridiagonal matrix.
*          On exit, E has been destroyed.
*
*  Q       (local output) DOUBLE PRECISION array,
*          global dimension (N, N),
*          local dimension ( LLD_Q, LOCc(JQ+N-1))
*          Q  contains the orthonormal eigenvectors of the symmetric
*          tridiagonal matrix.
*          On output, Q is distributed across the P processes in block
*          cyclic format.
*
*  IQ      (global input) INTEGER
*          Q's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JQ      (global input) INTEGER
*          Q's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCQ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*
*
*  WORK    (local workspace ) DOUBLE PRECISION array, dimension (LWORK)
*          LWORK = 6*N + 2*NP*NQ, with
*          NP = NUMROC( N, MB_Q, MYROW, IQROW, NPROW )
*          NQ = NUMROC( N, NB_Q, MYCOL, IQCOL, NPCOL )
*          IQROW = INDXG2P( IQ, NB_Q, MYROW, RSRC_Q, NPROW )
*          IQCOL = INDXG2P( JQ, MB_Q, MYCOL, CSRC_Q, NPCOL )
*
*  IWORK   (local workspace/output) INTEGER array, dimension (LIWORK)
*          LIWORK = 2 + 7*N + 8*NPCOL
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  The algorithm failed to compute the INFO/(N+1) th
*                eigenvalue while working on the submatrix lying in
*                global rows and columns mod(INFO,N+1).
*
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
      INTEGER            I, ID, IDCOL, IDROW, IID, IINFO, IIQ, IM1, IM2,
     $                   IPQ, IQCOL, IQROW, J, JJD, JJQ, LDQ, MATSIZ,
     $                   MYCOL, MYROW, N1, NB, NBL, NBL1, NPCOL, NPROW,
     $                   SUBPBS, TSUBPBS
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DGEBR2D, DGEBS2D, DGERV2D,
     $                   DGESD2D, DSTEQR, INFOG2L, PDLAED1, PXERBLA
*     ..
*     .. External Functions ..
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, MIN
*     ..
      include 'mpif.h'
      include 'DC_ADD.h'
      REAL(8) :: d1,d2
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Test the input parameters.
*
      CALL BLACS_GRIDINFO( DESCQ( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
      IF( DESCQ( NB_ ).GT.N .OR. N.LT.2 )
     $   INFO = -1
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCQ( CTXT_ ), 'PDLAED0', -INFO )
         RETURN
      END IF
*
      NB = DESCQ( NB_ )
      LDQ = DESCQ( LLD_ )
      CALL INFOG2L( IQ, JQ, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
*
*     Determine the size and placement of the submatrices, and save in
*     the leading elements of IWORK.
*
      TSUBPBS = ( N-1 ) / NB + 1
      IWORK( 1 ) = TSUBPBS
      SUBPBS = 1
   10 CONTINUE
      IF( IWORK( SUBPBS ).GT.1 ) THEN
         DO 20 J = SUBPBS, 1, -1
            IWORK( 2*J ) = ( IWORK( J )+1 ) / 2
            IWORK( 2*J-1 ) = IWORK( J ) / 2
   20    CONTINUE
         SUBPBS = 2*SUBPBS
         GO TO 10
      END IF
      DO 30 J = 2, SUBPBS
         IWORK( J ) = IWORK( J ) + IWORK( J-1 )
   30 CONTINUE
*
*     Divide the matrix into TSUBPBS submatrices of size at most NB
*     using rank-1 modifications (cuts).
*
!=!$OMP PARALLEL DO PRIVATE(I,IM1) IF(NB>1)
      DO 40 I = NB + 1, N, NB
         IM1 = I - 1
         D( IM1 ) = D( IM1 ) - ABS( E( IM1 ) )
         D( I ) = D( I ) - ABS( E( IM1 ) )
   40 CONTINUE
!=!$OMP END PARALLEL DO
*
*     Solve each submatrix eigenproblem at the bottom of the divide and
*     conquer tree. D is the same on each process.
*
      d1 = MPI_WTIME()
      DO 50 ID = 1, N, NB
         CALL INFOG2L( IQ-1+ID, JQ-1+ID, DESCQ, NPROW, NPCOL, MYROW,
     $                 MYCOL, IID, JJD, IDROW, IDCOL )
         MATSIZ = MIN( NB, N-ID+1 )
         IF( MYROW.EQ.IDROW .AND. MYCOL.EQ.IDCOL ) THEN
            IPQ = IID + ( JJD-1 )*LDQ
            CALL DSTEQR( 'I', MATSIZ, D( ID ), E( ID ), Q( IPQ ), LDQ,
     $                   WORK, INFO )
            IF( INFO.NE.0 ) THEN
               CALL PXERBLA( DESCQ( CTXT_ ), 'DSTEQR', -INFO )
               RETURN
            END IF
            IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL ) THEN
               CALL DGESD2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                       IQROW, IQCOL )
            END IF
         ELSE IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
            CALL DGERV2D( DESCQ( CTXT_ ), MATSIZ, 1, D( ID ), MATSIZ,
     $                    IDROW, IDCOL )
         END IF
   50 CONTINUE
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         CALL DGEBS2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N )
      ELSE
         CALL DGEBR2D( DESCQ( CTXT_ ), 'A', ' ', N, 1, D, N, IQROW,
     $                 IQCOL )
      END IF
      d2 = MPI_WTIME()
      p_time0 = p_time0 + (d2-d1)
*
*     Successively merge eigensystems of adjacent submatrices
*     into eigensystem for the corresponding larger matrix.
*
*     while ( SUBPBS > 1 )
*
   60 CONTINUE
      IF( SUBPBS.GT.1 ) THEN
         IM2 = SUBPBS - 2
         DO 80 I = 0, IM2, 2
            IF( I.EQ.0 ) THEN
               NBL = IWORK( 2 )
               NBL1 = IWORK( 1 )
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = 1
               MATSIZ = MIN( N, NBL*NB )
               N1 = NBL1*NB
            ELSE
               NBL = IWORK( I+2 ) - IWORK( I )
               NBL1 = NBL / 2
               IF( NBL1.EQ.0 )
     $            GO TO 70
               ID = IWORK( I )*NB + 1
               MATSIZ = MIN( NB*NBL, N-ID+1 )
               N1 = NBL1*NB
            END IF
*
*     Merge lower order eigensystems (of size N1 and MATSIZ - N1)
*     into an eigensystem of size MATSIZ.
*
            CALL PDLAED1( MATSIZ, N1, D( ID ), ID, Q, IQ, JQ, DESCQ,
     $                    E( ID+N1-1 ), WORK, IWORK( SUBPBS+1 ), IINFO )
            IF( IINFO.NE.0 ) THEN
               INFO = IINFO*( N+1 ) + ID
            END IF
*
   70       CONTINUE
            IWORK( I / 2+1 ) = IWORK( I+2 )
   80    CONTINUE
         SUBPBS = SUBPBS / 2
*
         GO TO 60
      END IF
*
*     end while
*
   90 CONTINUE
      RETURN
*
*     End of PDLAED0
*
      END

      subroutine eigen_prd_load(a, w, nm,
     &              d_t,
     &              u_x, u_y, v_x, v_y, nv,
     &              m0, i_base, i_block)
      use eigen_devel
      use eigen_libs
      implicit NONE

      integer, intent(in)    :: nm, nv, m0, i_base, i_block
      real(8), intent(inout) :: a(1:nm,*)
      real(8), intent(out)   :: w(1:nm,*)
      real(8), intent(out)   :: u_x(1:nv,*), u_y(1:nv,*)
      real(8), intent(out)   :: v_x(1:nv,*), v_y(1:nv,*)
      real(8), intent(out)   :: d_t(*)

      integer                ::  x_pos, x_owner_nod
      integer                ::  y_pos, y_owner_nod
      integer                ::  i_1, i_2, i_3, i_4
      integer                ::  j_1, j_2, j_3, j_4
      integer                ::  k_1, k_2, k_3, k_4
      integer                ::  i, j, L

      include 'param.h'


      i_2 = eigen_loop_start(i_base+1,  y_nnod,y_inod)
      i_3 = eigen_loop_end  (i_base+m0, y_nnod,y_inod)
      j_2 = eigen_loop_start(1,         x_nnod,x_inod)
      j_3 = eigen_loop_end  (i_base+m0, x_nnod,x_inod)

      do i_1=i_2,i_3
         j = eigen_translate_l2g(i_1, y_nnod,y_inod)
         do j_1=j_2,j_3
            w(j_1,j-i_base) = a(j_1,i_1)
         end do! j_1
      end do! i_1

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = eigen_loop_end  (i_base+m0-1, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         if ( y_nnod == x_nnod ) then
!DIR$ IVDEP
!DIR$ VECTOR ALWAYS
            do i_1=i_2,i_3,i_4
               d_t(i_1)   = a(i_1,i_1)
               a(i_1,i_1) = ZERO
            end do! i_1
         else
            do i_1=i_2,i_3,i_4
               j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
               j_1 = eigen_translate_g2l(j, x_nnod,x_inod)
               d_t(i_1)   = a(j_1,i_1)
               a(j_1,i_1) = ZERO
            end do! i_1
         end if
      end if

      i = i_base+m0
      L = i - 2
      y_pos  = eigen_translate_g2l(i, y_nnod,y_inod)
      x_pos  = eigen_translate_g2l(i, x_nnod,x_inod)

      k_2 = m0
      k_3 = MAX(1,3*(2-i_block))
      do k_1=k_3,k_2
         do j_1=1,x_pos
            u_x(j_1,k_1) = ZERO
            v_x(j_1,k_1) = ZERO
         end do! j_1
         do j_1=1,y_pos
            u_y(j_1,k_1) = ZERO
            v_y(j_1,k_1) = ZERO
         end do! j_1
      end do! k_1

      return
      end subroutine  eigen_prd_load


      subroutine eigen_prd_store(a, w, nm,
     &              d_t,
     &              m0, i_base)
      use eigen_devel
      use eigen_libs
      implicit NONE

      integer, intent(in)    :: nm, m0, i_base
      real(8), intent(out)   :: a(1:nm,*)
      real(8), intent(in)    :: w(1:nm,*), d_t(*)

      integer                ::  i, i_1, i_2, i_3, i_4
      integer                ::  j, j_1, j_2, j_3, j_4


      i_2 = eigen_loop_start(i_base+1,  y_nnod,y_inod)
      i_3 = eigen_loop_end  (i_base+m0, y_nnod,y_inod)
      do i_1=i_2,i_3
         j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
         j_3 = eigen_loop_end  (j, x_nnod,x_inod)
         do j_1=1,j_3
            a(j_1,i_1) = w(j_1,j-i_base)
         end do! j_1
      end do! i_1

      if ( diag_0 > 0 ) then
         i_2 = diag_0
         i_3 = eigen_loop_end  (i_base, y_nnod,y_inod)
         i_4 = x_nnod/n_common
         if ( y_nnod == x_nnod ) then
            do i_1=i_2,i_3,i_4
               j_1 = i_1
               a(j_1,i_1) = d_t(i_1)
            end do! i_1
         else
            do i_1=i_2,i_3,i_4
!              j   = eigen_translate_l2g(i_1, y_nnod,y_inod)
!              j_1 = eigen_translate_g2l(j, x_nnod,x_inod)
               j   = (i_1-1)*y_nnod+y_inod
               j_1 = (j-1)/x_nnod+1
               a(j_1,i_1) = d_t(i_1)
            end do! i_1
         end if
      end if

      return
      end subroutine  eigen_prd_store

      SUBROUTINE DLAPST( ID, N, D, INDX, INFO )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      CHARACTER          ID
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            INDX( * )
      DOUBLE PRECISION   D( * )
*     ..
*
*  Purpose
*  =======
*  DLAPST is a modified version of the LAPACK routine DLASRT.
*
*  Define a permutation INDX that sorts the numbers in D
*  in increasing order (if ID = 'I') or
*  in decreasing order (if ID = 'D' ).
*
*  Use Quick Sort, reverting to Insertion sort on arrays of
*  size <= 20. Dimension of STACK limits N to about 2**32.
*
*  Arguments
*  =========
*
*  ID      (input) CHARACTER*1
*          = 'I': sort D in increasing order;
*          = 'D': sort D in decreasing order.
*
*  N       (input) INTEGER
*          The length of the array D.
*
*  D       (input)  DOUBLE PRECISION array, dimension (N)
*          The array to be sorted.
*
*  INDX    (ouput) INTEGER array, dimension (N).
*          The permutation which sorts the array D.
*
*  INFO    (output) INTEGER
*          = 0:  successful exit
*          < 0:  if INFO = -i, the i-th argument had an illegal value
*
*  =====================================================================
*
*     .. Parameters ..
      INTEGER            SELECT
      PARAMETER          ( SELECT = 20 )
*     ..
*     .. Local Scalars ..
      INTEGER            DIR, ENDD, I, ITMP, J, START, STKPNT
      DOUBLE PRECISION   D1, D2, D3, DMNMX
*     ..
*     .. Local Arrays ..
      INTEGER            STACK( 2, 32 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
*     Test the input paramters.
*
      INFO = 0
      DIR = -1
      IF( LSAME( ID, 'D' ) ) THEN
         DIR = 0
      ELSE IF( LSAME( ID, 'I' ) ) THEN
         DIR = 1
      END IF
      IF( DIR.EQ.-1 ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DLAPST', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.LE.1 )
     $   RETURN
*
      DO 10 I = 1, N
         INDX( I ) = I
   10 CONTINUE
*
      STKPNT = 1
      STACK( 1, 1 ) = 1
      STACK( 2, 1 ) = N
   20 CONTINUE
      START = STACK( 1, STKPNT )
      ENDD = STACK( 2, STKPNT )
      STKPNT = STKPNT - 1
      IF( ENDD-START.LE.SELECT .AND. ENDD-START.GT.0 ) THEN
*
*        Do Insertion sort on D( START:ENDD )
*
         IF( DIR.EQ.0 ) THEN
*
*           Sort into decreasing order
*
            DO 40 I = START + 1, ENDD
               DO 30 J = I, START + 1, -1
                  IF( D( INDX( J ) ).GT.D( INDX( J-1 ) ) ) THEN
                     ITMP = INDX( J )
                     INDX( J ) = INDX( J-1 )
                     INDX( J-1 ) = ITMP
                  ELSE
                     GO TO 40
                  END IF
   30          CONTINUE
   40       CONTINUE
*
         ELSE
*
*           Sort into increasing order
*
            DO 60 I = START + 1, ENDD
               DO 50 J = I, START + 1, -1
                  IF( D( INDX( J ) ).LT.D( INDX( J-1 ) ) ) THEN
                     ITMP = INDX( J )
                     INDX( J ) = INDX( J-1 )
                     INDX( J-1 ) = ITMP
                  ELSE
                     GO TO 60
                  END IF
   50          CONTINUE
   60       CONTINUE
*
         END IF
*
      ELSE IF( ENDD-START.GT.SELECT ) THEN
*
*        Partition D( START:ENDD ) and stack parts, largest one first
*
*        Choose partition entry as median of 3
*
         D1 = D( INDX( START ) )
         D2 = D( INDX( ENDD ) )
         I = ( START+ENDD ) / 2
         D3 = D( INDX( I ) )
         IF( D1.LT.D2 ) THEN
            IF( D3.LT.D1 ) THEN
               DMNMX = D1
            ELSE IF( D3.LT.D2 ) THEN
               DMNMX = D3
            ELSE
               DMNMX = D2
            END IF
         ELSE
            IF( D3.LT.D2 ) THEN
               DMNMX = D2
            ELSE IF( D3.LT.D1 ) THEN
               DMNMX = D3
            ELSE
               DMNMX = D1
            END IF
         END IF
*
         IF( DIR.EQ.0 ) THEN
*
*           Sort into decreasing order
*
            I = START - 1
            J = ENDD + 1
   70       CONTINUE
   80       CONTINUE
            J = J - 1
            IF( D( INDX( J ) ).LT.DMNMX )
     $         GO TO 80
   90       CONTINUE
            I = I + 1
            IF( D( INDX( I ) ).GT.DMNMX )
     $         GO TO 90
            IF( I.LT.J ) THEN
               ITMP = INDX( I )
               INDX( I ) = INDX( J )
               INDX( J ) = ITMP
               GO TO 70
            END IF
            IF( J-START.GT.ENDD-J-1 ) THEN
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
            ELSE
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
            END IF
         ELSE
*
*           Sort into increasing order
*
            I = START - 1
            J = ENDD + 1
  100       CONTINUE
  110       CONTINUE
            J = J - 1
            IF( D( INDX( J ) ).GT.DMNMX )
     $         GO TO 110
  120       CONTINUE
            I = I + 1
            IF( D( INDX( I ) ).LT.DMNMX )
     $         GO TO 120
            IF( I.LT.J ) THEN
               ITMP = INDX( I )
               INDX( I ) = INDX( J )
               INDX( J ) = ITMP
               GO TO 100
            END IF
            IF( J-START.GT.ENDD-J-1 ) THEN
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
            ELSE
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = J + 1
               STACK( 2, STKPNT ) = ENDD
               STKPNT = STKPNT + 1
               STACK( 1, STKPNT ) = START
               STACK( 2, STKPNT ) = J
            END IF
         END IF
      END IF
      IF( STKPNT.GT.0 )
     $   GO TO 20
      RETURN
*
*     End of DLAPST
*
      END

module m_SpinOrbit_ForceTheorem
  use m_Const_Parameters,  only : DP, CMPLDP, PARABOLIC, TETRAHEDRON, COLD, &
       &                          FERMI_DIRAC, GAMMA, &
       &                          Neglected, ByPawPot, ByProjector, ZeffApprox, &
       &                          ReadFromPP, OFF, ON
  use m_Control_Parameters,  only : neg, nspin, m_CtrlP_way_of_smearing, &
       &                            ndim_spinor, ndim_chgpot, kimg, ekmode, &
       &                            SpinOrbit_mode
  use m_Files,              only : nfout
  use m_Kpoints,          only : kv3, k_symmetry
  use m_Electronic_Structure,  only : eko_l, fsr_l, fsi_l, occup_l
  use m_Ionic_System,       only : ityp, natm
  use m_PseudoPotential,   only : nlmt, ltp, taup, nlmta, ilmt, lmta

  use m_Parallelization,  only : map_k, map_e, map_z, myrank_k, myrank_e, mpi_k_world, &
       &                         ista_e, iend_e, istep_e, np_e, npes, ierr, &
       &                         mpi_comm_group, mype, ista_k, iend_k

  use m_ES_Occup,            only : m_ESoc_fermi_parabolic, m_ESoc_fermi_tetrahedron, &
       &                            m_ESoc_fermi_ColdSmearing, m_ESoc_fermi_Dirac

  use m_SpinOrbit_Potential,     only : m_SO_alloc_dsoc, dsoc, &
       &                                m_SO_set_Dsoc_potential1, &
       &                                m_SO_calc_MatLS_orb_s_to_f, &
       &                                m_SO_diagonalize_MatLS, &
       &                                m_SO_set_MatU_ylm_RC, &
       &                                m_SO_alloc_Mat_SOC_strenth, &
       &                                m_SO_set_Dsoc_potential2, &
       &                                m_SO_dealloc_Mat_SOC_strenth, &
       &                                m_SO_dealloc_dsoc
  use m_SpinOrbit_RadInt,       only : m_SO_calc_SOC_strength_pawpot, &
       &                               m_SO_calc_SOC_strength_zeff, &
       &                               m_SO_check_mode_Builtin, &
       &                               m_SO_check_mode_Pawpot, &
       &                               m_SO_check_mode_Zeff
  use m_SpinOrbit_FromFile,     only : m_SO_set_SOC_strength_from_PP

  implicit none
  include 'mpif.h'
!
  integer :: neg_doubled
  integer :: ndim_spinor_prev, ndim_chgpot_prev
!
contains
  
  subroutine m_SO_init_Force_Theorem
    ndim_spinor_prev = ndim_spinor;   ndim_chgpot_prev = ndim_chgpot
    ndim_spinor = 2;                  ndim_chgpot = ndim_spinor **2

    call m_SO_check_mode_Pawpot
    call m_SO_check_mode_Zeff
    
    if ( SpinOrbit_Mode /= Neglected ) then
       call m_SO_set_MatU_ylm_RC
       call m_SO_calc_MatLS_orb_s_to_f
       call m_SO_diagonalize_MatLS
    endif
    if ( SpinOrbit_Mode == ByPawPot ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_calc_SOC_strength_pawpot
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ZeffApprox ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_calc_SOC_strength_zeff
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ReadFromPP ) then
       call m_SO_alloc_Mat_SOC_strenth
       call m_SO_set_SOC_strength_from_PP
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential2
    endif
    if ( SpinOrbit_Mode == ByProjector ) then
       call m_SO_alloc_Dsoc
       call m_SO_set_Dsoc_potential1
    endif
    
#ifdef USE_ASMS_SPINORBIT
    call ASMS_SpinOrbit_setup( nfout, nspin, neg, kv3, &
         &                     mype, npes, mpi_comm_group, &
         &                     np_e, ista_e, iend_e, istep_e, &
         &                     ista_k, iend_k, myrank_k )
#endif

  end subroutine m_SO_init_Force_Theorem

  subroutine m_SO_finalize_Force_Theorem
    ndim_spinor = ndim_spinor_prev;       ndim_chgpot = ndim_chgpot_prev
    
    if ( SpinOrbit_Mode == ByPawPot .or. SpinOrbit_Mode == ZeffApprox &
         &                          .or. SpinOrbit_Mode == ReadFromPP ) then
       call m_SO_dealloc_Mat_SOC_strenth
       call m_SO_dealloc_Dsoc
    endif
    if ( SpinOrbit_Mode == ByProjector ) then
       call m_SO_dealloc_Dsoc
    endif
  end subroutine m_SO_finalize_Force_Theorem
   
  subroutine m_SO_calc_band_energy_fth
    integer :: neg_doubled
    integer :: ik
    complex(kind=CMPLDP), allocatable :: MatH(:,:)

    if ( SpinOrbit_mode == Neglected ) return

    neg_doubled = neg *ndim_spinor
    allocate( MatH( neg_doubled, neg_doubled ) ); MatH = 0.0d0
    
    Do ik=1, kv3, nspin
       if ( map_k(ik) /= myrank_k ) cycle
       
       MatH = 0.0d0
       call set_contrib_from_dsoc
       call add_diagonal_elements
#ifdef USE_ASMS_SPINORBIT
       call ASMS_SpinOrbit_renew_level_FTH( ik, ndim_spinor, neg_doubled, MatH, &
            &                               map_z, eko_l )
#endif
    End Do
    deallocate( MatH )
!
    if ( ekmode == OFF ) then
       call FermiEnergyLevel
#ifdef USE_ASMS_SPINORBIT
       call ASMS_SpinOrbit_bandenergy_FTH( map_k, occup_l, eko_l )
#endif
    endif

  contains

    subroutine add_diagonal_elements
      integer :: is, ib1, itmp
      real(kind=DP), allocatable :: eko_wk(:,:), eko_mpi(:,:)

      allocate( eko_wk( neg, ndim_spinor ) ); eko_wk = 0.0d0
      Do is=1, ndim_spinor
         itmp = 1
         if ( nspin == 2 ) itmp = is
         
         Do ib1=ista_e, iend_e, istep_e
            eko_wk( ib1, is ) = eko_l( map_z(ib1),ik +itmp-1 )
         End do
      End Do
      
      if ( npes > 1 ) then
         allocate( eko_mpi( neg, ndim_spinor ) ); eko_mpi = 0.0d0
         call mpi_allreduce( eko_wk, eko_mpi, neg*ndim_spinor, &
              &              mpi_double_precision, mpi_sum, &
              &              mpi_k_world(myrank_k), ierr )
         eko_wk = eko_mpi
         deallocate( eko_mpi )
      endif
!
      Do is=1, ndim_spinor
         Do ib1=1, neg
            itmp = ( is -1 )*neg +ib1
            MatH( itmp,itmp ) = MatH( itmp,itmp ) +eko_wk( ib1,is )
         End do
      End Do
      deallocate( eko_wk )

    end subroutine add_diagonal_elements

    subroutine set_contrib_from_dsoc
      integer :: ib1, ib2, is1, is2, itmp1, itmp2
      integer :: ia, it, istmp, jb1, jb2
      integer :: lmt1, lmt2, il1, il2, it1, it2, lmta1, lmta2
      complex(kind=CMPLDP) :: z1, wf1, wf2
      complex(kind=CMPLDP), allocatable :: wk_fsri(:,:), MatH_mpi(:,:)

      allocate( wk_fsri( nlmta, ndim_spinor ) ); wk_fsri = 0.0d0

      Do ib2=1, neg
         wk_fsri = 0.0d0
         
         if ( map_e(ib2) == myrank_e ) then
            Do is1=1, ndim_spinor
               itmp1 = 1
               if ( nspin == 2 ) itmp1 = is1
                
               if ( kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2 ) then
                  wk_fsri(:,is1) = fsr_l( map_z(ib2),:,ik+itmp1-1 )
               else
                  wk_fsri(:,is1) = dcmplx( fsr_l( map_z(ib2),:,ik+itmp1-1 ), &
                       &                   fsi_l( map_z(ib2),:,ik+itmp1-1 ) )
               endif
            End do
         endif
         call mpi_bcast( wk_fsri, 2*nlmta*ndim_spinor, mpi_double_precision, &
              &          map_e(ib2), mpi_k_world(myrank_k), ierr )
         !
         DO ib1=ista_e, iend_e, istep_e
            
            Do ia=1, natm
               it = ityp(ia)
               
               Do lmt1=1, ilmt(it)
                  il1 = ltp(lmt1,it); it1 = taup(lmt1,it)
                  lmta1 = lmta( lmt1,ia )
                  
                  Do lmt2=1, ilmt(it)
                     il2 = ltp(lmt2,it); it2 = taup(lmt2,it)
                     lmta2 = lmta( lmt2,ia )
                     
                     Do is1=1, ndim_spinor
                        itmp1 = 1
                        if ( nspin == 2 ) itmp1 = is1
                        
                        Do is2=1, ndim_spinor
                           itmp2 = 1
                           if ( nspin == 2 ) itmp2 = is2
                           
                           if ( kv3/nspin == 1 .and. k_symmetry(1) == GAMMA &
                                &              .and. kimg == 2 ) then
                              wf1 = fsr_l( map_z(ib1), lmta1, ik +itmp1 -1 )
                           else
                              wf1 = dcmplx( fsr_l( map_z(ib1), lmta1, ik +itmp1 -1 ), &
                                   &        fsi_l( map_z(ib1), lmta1, ik +itmp1 -1 ) )
                           endif
                           wf2 = wk_fsri( lmta2, is2 )
                           
                           istmp = ( is1 -1 )*ndim_spinor +is2
                           z1 = dconjg(wf1) *dsoc( lmt1, lmt2, ia, istmp ) *wf2
                           
                           jb1 = neg *( is1 -1 )+ib1
                           jb2 = neg *( is2 -1 )+ib2
                           MatH(jb1,jb2) = MatH (jb1,jb2) +z1
                        End Do
                     End do
                  End Do
                  
               End Do
            End do
         End DO
      End Do
!
      if ( npes > 1 ) then
         allocate( MatH_mpi( neg_doubled, neg_doubled ) ); MatH_mpi = 0.0d0
         call mpi_allreduce( MatH, MatH_mpi, 2*neg_doubled**2, &
               &             mpi_double_precision, mpi_sum, &
               &             mpi_k_world(myrank_k), ierr )
         MatH = MatH_mpi
         deallocate( MatH_mpi )
      endif
      deallocate( wk_fsri )

    end subroutine set_contrib_from_dsoc

  end subroutine m_SO_calc_band_energy_fth

  subroutine FermiEnergyLevel()
    integer :: way_of_smearing

    way_of_smearing = m_CtrlP_way_of_smearing()
    if(way_of_smearing == PARABOLIC) then
       call m_ESoc_fermi_parabolic(nfout)
    else if(way_of_smearing == TETRAHEDRON) then
       stop "Not supported"
       call m_ESoc_fermi_tetrahedron(nfout)
    else if(way_of_smearing == COLD) then
       call m_ESoc_fermi_ColdSmearing(nfout)
! ================ KT_add ========================= 13.0E
    else if(way_of_smearing == FERMI_DIRAC) then
       call m_ESoc_fermi_Dirac(nfout)
! ================================================= 13.0E
    end if
  end subroutine FermiEnergyLevel

end module m_SpinOrbit_ForceTheorem

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  SUBROUINE:  crngabc4, setglist4, zf_list_s, calc_phase2, calc_phase
!              substitute_il3
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_Electronic_Structure.F90 633 2020-12-01 05:11:03Z jkoga $
subroutine substitute_il3(n,il3)
  implicit none
  integer, intent(in)               :: n
  integer, intent(out), dimension(n) :: il3

  integer i, l
  l = 0
  do i = 1, n
     if(i > (l+1)**2) l = l + 1
     il3(i) = l
  end do
end subroutine substitute_il3

subroutine calc_phase(ia,natm,pos,kgp,ibaik,ngabc,kg1,nbase,kd,zfcos,zfsin)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: ia   ! #atom
  integer, intent(in)                          :: natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in)                          :: kgp  ! 1st dim. of ngabc
  integer, intent(in)                          :: ibaik! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: kg1  ! 1st dim. of nbase
  integer, intent(in), dimension(kg1)          :: nbase! pointer to a G-vector set
  integer, intent(in)                          :: kd   ! dim. of zfcos, zfsin
  real(kind=DP), intent(out), dimension(kd)    :: zfcos, zfsin ! phase

  integer       :: i, nb
  real(kind=DP) ::  fx, fy, fz, ph
  fx = pos(ia,1)*PAI2
  fy = pos(ia,2)*PAI2
  fz = pos(ia,3)*PAI2
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
  do i = 1,ibaik
     nb = nbase(i)
     ph = ngabc(nb,1)*fx+ngabc(nb,2)*fy+ngabc(nb,3)*fz
     zfcos(i) = dcos(ph)
     zfsin(i) = dsin(ph)
  end do
end subroutine calc_phase

!$$#ifdef PARA3D
subroutine calc_phasek_b_3D(natm,pos,n_ialist0,ia_list,kgp,ist,ien,ngabc,kg1,nbase,kd_adj,zfcos_x,zfsin_x)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: natm       ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos        ! positions of atoms
  integer, intent(in)                          :: n_ialist0  ! #atom
  integer, intent(in), dimension(n_ialist0)    :: ia_list
  integer, intent(in)                          :: kgp        ! 1st dim. of ngabc
  integer, intent(in)                          :: ist, ien   ! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc      ! g-vectors
  integer, intent(in)                          :: kg1        ! 1st dim. of nbase
  integer, intent(in), dimension(kg1)          :: nbase      ! pointer to a G-vector set
  integer, intent(in)                          :: kd_adj     ! dim. of zfcos, zfsin
  real(kind=DP), intent(out), dimension(kd_adj,n_ialist0)   :: zfcos_x, zfsin_x ! phase

  integer       :: i, nb, ia,iap, iadd
  real(kind=DP) ::  fx, fy, fz, ph

#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption parallel
#endif
#ifdef NEC_TUNE2
!CDIR OUTERUNROLL=4
#endif
#ifdef NEC_TUNE_SMP
!CDIR SELECT(CONCUR)
#endif
  do iap = 1, n_ialist0
     ia = ia_list(iap)
     fx = pos(ia,1)*PAI2
     fy = pos(ia,2)*PAI2
     fz = pos(ia,3)*PAI2
     do i = ist, ien
        iadd = i - ist + 1
        nb = nbase(i)
        ph = ngabc(nb,1)*fx+ngabc(nb,2)*fy+ngabc(nb,3)*fz
        zfcos_x(iadd,iap) = dcos(ph)
        zfsin_x(iadd,iap) = dsin(ph)
     end do
   end do
end subroutine calc_phasek_b_3D
!$$#endif

subroutine calc_phase2_blk(natm,pos,ia,kgp,ngabc,ibl1,ibl2,ista_kngp,iend_kngp,zfcos,zfsin)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in)                          :: ia   ! #atom
  integer, intent(in)                          :: kgp  ! range of operation
!  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in), dimension(ista_kngp:iend_kngp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: ibl1,ibl2,ista_kngp, iend_kngp
  real(kind=DP),intent(out),dimension(ibl1:ibl2) :: zfcos, zfsin ! phase

  integer       ::  i
  real(kind=DP) :: fx, fy, fz, ph
  integer       ::  iend  !mpi
  fx = pos(ia,1)*PAI2
  fy = pos(ia,2)*PAI2
  fz = pos(ia,3)*PAI2
  iend = ibl2
  if( ibl2 > kgp ) iend = kgp
  if( ibl1 <= iend ) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
     do i = ibl1, iend  !for mp
        ph = ngabc(i,1)*fx+ngabc(i,2)*fy+ngabc(i,3)*fz
        zfcos(i) = dcos(ph)
        zfsin(i) = dsin(ph)
     end do
  endif
!xocl end spread
end subroutine calc_phase2_blk

subroutine calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in)                          :: natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in)                          :: ia   ! #atom
  integer, intent(in)                          :: kgp  ! range of operation
!  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in), dimension(ista_kngp:iend_kngp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: ista_kngp, iend_kngp
  real(kind=DP),intent(out),dimension(ista_kngp:iend_kngp) :: zfcos, zfsin ! phase

  integer       ::  i
  real(kind=DP) :: fx, fy, fz, ph
  integer       ::  iend  !mpi
  fx = pos(ia,1)*PAI2
  fy = pos(ia,2)*PAI2
  fz = pos(ia,3)*PAI2
  iend = iend_kngp
  if( iend_kngp > kgp ) iend = kgp
  if( ista_kngp <= iend ) then
#ifdef NEC_TUNE_SMP
!CDIR INNER
#endif
     do i = ista_kngp, iend  !for mp
        ph = ngabc(i,1)*fx+ngabc(i,2)*fy+ngabc(i,3)*fz
        zfcos(i) = dcos(ph)
        zfsin(i) = dsin(ph)
     end do
  endif
!xocl end spread
end subroutine calc_phase2

subroutine calc_phase_b(natm,pos,ia_list,n_ialist,kgp,ngabc,ista_kngp,iend_kngp,ista_kngp_adj,iend_kngp_adj,zfcos_x,zfsin_x)
  use m_Const_Parameters, only : PAI2, DP
  implicit none
  integer, intent(in) ::                          natm ! 1st dim. of pos
  real(kind=DP), intent(in), dimension(natm,3) :: pos  ! positions of atoms
  integer, intent(in) ::                          n_ialist ! #atom
  integer, intent(in), dimension(n_ialist) ::     ia_list(n_ialist) ! list of #atom
  integer, intent(in) ::                          kgp  ! range of operation
  integer, intent(in), dimension(kgp,3)        :: ngabc! g-vectors
  integer, intent(in)                          :: ista_kngp, iend_kngp, ista_kngp_adj, iend_kngp_adj
  real(kind=DP),intent(out),dimension(ista_kngp_adj:iend_kngp_adj,n_ialist) :: zfcos_x, zfsin_x ! phase

  integer       ::  i, ia, ip, is
  real(kind=DP) :: fx_1, fy_1, fz_1, ph_1, fx_2, fy_2, fz_2, ph_2, fx_3, fy_3, fz_3, ph_3, fx_4, fy_4, fz_4, ph_4
  integer       ::  iend  !mpi
  if(n_ialist >= 1) then
     fx_1 = pos(ia_list(1),1)*PAI2
     fy_1 = pos(ia_list(1),2)*PAI2
     fz_1 = pos(ia_list(1),3)*PAI2
  end if
  if(n_ialist >= 2) then
     fx_2 = pos(ia_list(2),1)*PAI2
     fy_2 = pos(ia_list(2),2)*PAI2
     fz_2 = pos(ia_list(2),3)*PAI2
  end if
  if(n_ialist >= 3) then
     fx_3 = pos(ia_list(3),1)*PAI2
     fy_3 = pos(ia_list(3),2)*PAI2
     fz_3 = pos(ia_list(3),3)*PAI2
  end if
  if(n_ialist >= 4) then
     fx_4 = pos(ia_list(4),1)*PAI2
     fy_4 = pos(ia_list(4),2)*PAI2
     fz_4 = pos(ia_list(4),3)*PAI2
  end if

  iend = iend_kngp
  if( iend_kngp > kgp ) iend = kgp
  if( ista_kngp <= iend ) then
     is = ista_kngp_adj - ista_kngp
     if(n_ialist == 1) then
!cdir parallel do private(i,ph_1,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
        end do
     else if(n_ialist == 2) then
!cdir parallel do private(i,ph_1,ph_2,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
        end do
     else if(n_ialist == 3) then
!cdir parallel do private(i,ph_1,ph_2,ph_3,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ph_3 = ngabc(i,1)*fx_3+ngabc(i,2)*fy_3+ngabc(i,3)*fz_3
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
           zfcos_x(ip,3) = dcos(ph_3)
           zfsin_x(ip,3) = dsin(ph_3)
        end do
     else if(n_ialist >= 4) then
!cdir parallel do private(i,ph_1,ph_2,ph_3,ph_4,ip)
        do i = ista_kngp, iend  !for mp
           ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
           ph_2 = ngabc(i,1)*fx_2+ngabc(i,2)*fy_2+ngabc(i,3)*fz_2
           ph_3 = ngabc(i,1)*fx_3+ngabc(i,2)*fy_3+ngabc(i,3)*fz_3
           ph_4 = ngabc(i,1)*fx_4+ngabc(i,2)*fy_4+ngabc(i,3)*fz_4
           ip = i + is
           zfcos_x(ip,1) = dcos(ph_1)
           zfsin_x(ip,1) = dsin(ph_1)
           zfcos_x(ip,2) = dcos(ph_2)
           zfsin_x(ip,2) = dsin(ph_2)
           zfcos_x(ip,3) = dcos(ph_3)
           zfsin_x(ip,3) = dsin(ph_3)
           zfcos_x(ip,4) = dcos(ph_4)
           zfsin_x(ip,4) = dsin(ph_4)
        end do
     end if
     if(n_ialist > 4 ) then
        do ia = 5, n_ialist
           fx_1 = pos(ia_list(ia),1)*PAI2
           fy_1 = pos(ia_list(ia),2)*PAI2
           fz_1 = pos(ia_list(ia),3)*PAI2
!cdir parallel do private(i,ph_1,ip)
           do i = ista_kngp, iend   !MPI
              ph_1 = ngabc(i,1)*fx_1+ngabc(i,2)*fy_1+ngabc(i,3)*fz_1
              ip = i + is
              zfcos_x(ip,ia) = dcos(ph_1)
              zfsin_x(ip,ia) = dsin(ph_1)
           end do
        end do
     end if
  endif
!xocl end spread
end subroutine calc_phase_b

subroutine zf_list_s(n_min,n_max,matm,natm,f,ia,zfcos,zfsin)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: n_min,n_max,matm,natm
  real(kind=DP),intent(in) :: f
  integer, intent(in)      :: ia
  real(DP),intent(out),dimension(n_min:n_max,matm+1:natm)::zfcos,zfsin

  integer :: i
  do i = n_min, n_max
     zfcos(i,ia) = dcos(i*f)
     zfsin(i,ia) = dsin(i*f)
  end do
end subroutine zf_list_s

subroutine setglist4(n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
     &     ,nbase,ngabc,kgp,iiba, nglist)
  implicit none
  integer,intent(in) :: n_min1,n_max1,n_min2,n_max2,n_min3,n_max3
  integer,intent(in) :: kgp,iiba,nbase(*),ngabc(kgp,3)
  integer,intent(out):: nglist(n_min1:n_max1,n_min2:n_max2,n_min3:n_max3)

  integer :: i, nb, nb1,nb2,nb3

  nglist = -1

  do i = 1, iiba
     nb = nbase(i)
     nb1 = ngabc(nb,1)
     nb2 = ngabc(nb,2)
     nb3 = ngabc(nb,3)
     nglist(nb1,nb2,nb3) = i
  enddo
end subroutine setglist4


subroutine crngabc4(n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
     &     ,nglist,kg1,nngabc,newp)
  implicit none
  integer, intent(in) :: n_min1,n_max1,n_min2,n_max2,n_min3,n_max3 &
       &, nglist(n_min1:n_max1,n_min2:n_max2,n_min3:n_max3), kg1
  integer, intent(out) :: nngabc(kg1,3),newp(kg1)
  
  integer :: ngcount, jcount,kcount,jp,kp,ip

  ngcount = 0
  do jcount = n_min2, n_max2
     jp = jcount
     do kcount = n_min3, n_max3
        kp = kcount
        do ip = n_min1, n_max1
           if(nglist(ip,jp,kp) /= -1) then
              ngcount = ngcount + 1
              nngabc(ngcount,1) = ip
              nngabc(ngcount,2) = jp
              nngabc(ngcount,3) = kp
              newp(ngcount) = nglist(ip,jp,kp)
           endif
           jp = jp + 1
           if(jp.eq.n_max2+1) jp = n_min2
           kp = kp + 1
           if(kp.eq.n_max3+1) kp = n_min3
        enddo
     enddo
  enddo
end subroutine crngabc4

! ==== experimental ===
subroutine sphset_upto_L6( cr2, isph2, mmt2 )
  use m_Const_Parameters,  only : DP, CMPLDP
  implicit none
!
  integer, intent(out) :: mmt2( 16, 16 )
  integer, intent(out) :: isph2( 16, 16, 7 )
  real(kind=DP), intent(out) :: cr2( 16, 16, 7 )
  
  real(kind=DP), allocatable :: gaunt_coeff(:,:,:)
  integer :: nsph1, nsph2, nsph3, num
!
  cr2 = 0.0d0;  isph2 = 0;  mmt2 = 0

  allocate( gaunt_coeff(16,49,16) );  gaunt_coeff = 0.0d0
  call set_gaunt_coeff( gaunt_coeff )

  Do nsph1=1, 16
     Do nsph3=1, 16
        num = 0
        Do nsph2=1, 49
!           if ( abs(gaunt_coeff(nsph1,nsph2,nsph3)) < 1.0D-8 ) cycle
           if ( abs(gaunt_coeff(nsph1,nsph2,nsph3)) < 1.0D-6 ) cycle
           num = num +1
           isph2(nsph1,nsph3,num) = nsph2
           cr2(nsph1,nsph3,num) = gaunt_coeff(nsph1,nsph2,nsph3)
        End Do
        mmt2(nsph1,nsph3) = num
!        write(*,*) "Num = ", nsph1, nsph3, num
     End Do
  End Do
  deallocate( gaunt_coeff )
end subroutine sphset_upto_L6

subroutine set_gaunt_coeff( gaunt_coeff )
  use m_Const_Parameters,  only : DP, CMPLDP, PAI4, zi
  implicit none

  real(kind=DP), intent(out) :: gaunt_coeff(16,49,16)

  integer :: l1, l2, l3, m1, m2, m3, im1, im2, im3
  integer :: nsph1, nsph2, nsph3
  real(kind=DP) :: c0, c1, c2, c3
  complex(kind=CMPLDP) :: zsum
  complex(kind=CMPLDP), allocatable :: matwk(:,:,:)
  complex(kind=CMPLDP), pointer :: matU1(:,:), matU2(:,:), matU3(:,:)
  real(kind=DP) :: wigner_3j

  real(kind=DP), allocatable :: matwk2(:,:,:)
  
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L0( 2*0+1, -0:0 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L1( 2*1+1, -1:1 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L2( 2*2+1, -2:2 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L3( 2*3+1, -3:3 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L4( 2*4+1, -4:4 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L5( 2*5+1, -5:5 )
  complex(kind=CMPLDP), target :: MatU_ylm_RC_L6( 2*6+1, -6:6 )

  gaunt_coeff = 0.0d0

  call set_matU_ylm
  
  allocate( matwk(-3:3,-6:6,-3:3) ); matwk = 0.0d0
  
  Do l1=0, 3
     select case(l1)
     case (0)
        matU1 =>  MatU_ylm_RC_L0
     case (1)
        matU1 =>  MatU_ylm_RC_L1
     case (2)
        matU1 =>  MatU_ylm_RC_L2
     case (3)
        matU1 =>  MatU_ylm_RC_L3
     end select
     
     Do l2=0, 6
        select case(l2)
        case (0)
           matU2 =>  MatU_ylm_RC_L0
        case (1)
           matU2 =>  MatU_ylm_RC_L1
        case (2)
           matU2 =>  MatU_ylm_RC_L2
        case (3)
           matU2 =>  MatU_ylm_RC_L3
        case (4)
           matU2 =>  MatU_ylm_RC_L4
        case (5)
           matU2 =>  MatU_ylm_RC_L5
        case (6)
           matU2 =>  MatU_ylm_RC_L6
        end select
        
        Do l3=0, 3
           select case(l3)
           case (0)
              matU3 =>  MatU_ylm_RC_L0
           case (1)
              matU3 =>  MatU_ylm_RC_L1
           case (2)
              matU3 =>  MatU_ylm_RC_L2
           case (3)
              matU3 =>  MatU_ylm_RC_L3
           end select
           
           c0 = ( 2*l1+1 )*( 2*l2 +1 )*( 2*l3 +1 ) /PAI4
           c0 = sqrt( c0 )
           
           matwk = 0.0d0
           Do m1=-l1, l1
              Do m2=-l2, l2
                 Do m3=-l3, l3
                    c1 = wigner_3j( dble(l1), 0.0d0, dble(l2), 0.0d0, dble(l3), 0.0d0 )
                    c2 = wigner_3j( dble(l1), -dble(m1), dble(l2), dble(m2), &
                         &          dble(l3), dble(m3) )
                    c3 = (-1)**m1
                    matwk(m1,m2,m3) = c0 *c1 *c2 *c3
                 End Do
              End Do
           End Do
           !
           Do im1=1, 2*l1 +1
              Do im2=1, 2*l2 +1
                 Do im3=1, 2*l3 +1
                    nsph1 = l1**2 +im1
                    nsph2 = l2**2 +im2
                    nsph3 = l3**2 +im3
                    zsum = 0.0d0
                    Do m1=-l1, l1
                       Do m2=-l2, l2
                          Do m3=-l3, l3
                             zsum = zsum +conjg(matU1(im1,m1)) *matU2(im2,m2) &
                                  &      *matU3(im3,m3) *matwk(m1,m2,m3)
                          End Do
                       End Do
                    ENd Do
                    gaunt_coeff(nsph1,nsph2,nsph3) = zsum
                 End Do
              ENd Do
           ENd Do
        End Do
     ENd Do
  End Do
  deallocate( matwk )

contains
  subroutine set_matU_ylm
    real(kind=DP) :: ctmp
    complex(kind=CMPLDP) :: ztmp
    !
    MatU_ylm_RC_L0 = 0.0d0
    MatU_ylm_RC_L1 = 0.0d0
    MatU_ylm_RC_L2 = 0.0d0
    MatU_ylm_RC_L3 = 0.0d0
    MatU_ylm_RC_L4 = 0.0d0
    MatU_ylm_RC_L5 = 0.0d0
    MatU_ylm_RC_L6 = 0.0d0
    ! -------
    ctmp = 1.0d0 / sqrt(2.0d0)

! ------------------------- ktDEBUG ------------ 2012/11/12
    ztmp = -ctmp * zi
!!    ztmp = ctmp * zi
! ------------------------- ktDEBUG ------------ 2012/11/12
    !
! s-orbital
    MatU_ylm_RC_L0(  1,0 ) = 1.0d0
! p-orbital
    MatU_ylm_RC_L1(  1,-1 ) =  ctmp;    MatU_ylm_RC_L1( 1,1 ) = -ctmp
    MatU_ylm_RC_L1(  2,-1 ) =  ztmp;    MatU_ylm_RC_L1( 2,1 ) =  ztmp
    MatU_ylm_RC_L1(  3, 0 ) = 1.0d0
! d-orbital
    MatU_ylm_RC_L2(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L2(  2,-2 ) =  ctmp;    MatU_ylm_RC_L2( 2,2 ) =  ctmp
    MatU_ylm_RC_L2(  3,-2 ) =  ztmp;    MatU_ylm_RC_L2( 3,2 ) = -ztmp
    MatU_ylm_RC_L2(  4,-1 ) =  ztmp;    MatU_ylm_RC_L2( 4,1 ) =  ztmp
    MatU_ylm_RC_L2(  5,-1 ) =  ctmp;    MatU_ylm_RC_L2( 5,1 ) = -ctmp
! f-orbital
    MatU_ylm_RC_L3(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L3(  2,-1 ) =  ctmp;   MatU_ylm_RC_L3( 2,1 ) = -ctmp
    MatU_ylm_RC_L3(  3,-1 ) =  ztmp;   MatU_ylm_RC_L3( 3,1 ) =  ztmp
    MatU_ylm_RC_L3(  4,-2 ) =  ctmp;   MatU_ylm_RC_L3( 4,2 ) =  ctmp
    MatU_ylm_RC_L3(  5,-2 ) =  ztmp;   MatU_ylm_RC_L3( 5,2 ) = -ztmp
    MatU_ylm_RC_L3(  6,-3 ) =  ctmp;   MatU_ylm_RC_L3( 6,3 ) = -ctmp
    MatU_ylm_RC_L3(  7,-3 ) =  ztmp;   MatU_ylm_RC_L3( 7,3 ) =  ztmp
! g-orbital
    MatU_ylm_RC_L4(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L4(  2,-1 ) =  ctmp;   MatU_ylm_RC_L4( 2,1 ) = -ctmp
    MatU_ylm_RC_L4(  3,-1 ) =  ztmp;   MatU_ylm_RC_L4( 3,1 ) =  ztmp
    MatU_ylm_RC_L4(  4,-2 ) =  ctmp;   MatU_ylm_RC_L4( 4,2 ) =  ctmp
    MatU_ylm_RC_L4(  5,-2 ) =  ztmp;   MatU_ylm_RC_L4( 5,2 ) = -ztmp
    MatU_ylm_RC_L4(  6,-3 ) =  ctmp;   MatU_ylm_RC_L4( 6,3 ) = -ctmp
    MatU_ylm_RC_L4(  7,-3 ) =  ztmp;   MatU_ylm_RC_L4( 7,3 ) =  ztmp
    MatU_ylm_RC_L4(  8,-4 ) =  ctmp;   MatU_ylm_RC_L4( 8,4 ) =  ctmp
    MatU_ylm_RC_L4(  9,-4 ) =  ztmp;   MatU_ylm_RC_L4( 9,4 ) = -ztmp
! L=5
    MatU_ylm_RC_L5(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L5(  2,-1 ) =  ctmp;   MatU_ylm_RC_L5(  2,1 ) = -ctmp
    MatU_ylm_RC_L5(  3,-1 ) =  ztmp;   MatU_ylm_RC_L5(  3,1 ) =  ztmp
    MatU_ylm_RC_L5(  4,-2 ) =  ctmp;   MatU_ylm_RC_L5(  4,2 ) =  ctmp
    MatU_ylm_RC_L5(  5,-2 ) =  ztmp;   MatU_ylm_RC_L5(  5,2 ) = -ztmp
    MatU_ylm_RC_L5(  6,-3 ) =  ctmp;   MatU_ylm_RC_L5(  6,3 ) = -ctmp
    MatU_ylm_RC_L5(  7,-3 ) =  ztmp;   MatU_ylm_RC_L5(  7,3 ) =  ztmp
    MatU_ylm_RC_L5(  8,-4 ) =  ctmp;   MatU_ylm_RC_L5(  8,4 ) =  ctmp
    MatU_ylm_RC_L5(  9,-4 ) =  ztmp;   MatU_ylm_RC_L5(  9,4 ) = -ztmp
    MatU_ylm_RC_L5( 10,-5 ) =  ctmp;   MatU_ylm_RC_L5( 10,5 ) = -ctmp
    MatU_ylm_RC_L5( 11,-5 ) =  ztmp;   MatU_ylm_RC_L5( 11,5 ) =  ztmp
! L=6
    MatU_ylm_RC_L6(  1, 0 ) = 1.0d0
    MatU_ylm_RC_L6(  2,-1 ) =  ctmp;   MatU_ylm_RC_L6(  2,1 ) = -ctmp
    MatU_ylm_RC_L6(  3,-1 ) =  ztmp;   MatU_ylm_RC_L6(  3,1 ) =  ztmp
    MatU_ylm_RC_L6(  4,-2 ) =  ctmp;   MatU_ylm_RC_L6(  4,2 ) =  ctmp
    MatU_ylm_RC_L6(  5,-2 ) =  ztmp;   MatU_ylm_RC_L6(  5,2 ) = -ztmp
    MatU_ylm_RC_L6(  6,-3 ) =  ctmp;   MatU_ylm_RC_L6(  6,3 ) = -ctmp
    MatU_ylm_RC_L6(  7,-3 ) =  ztmp;   MatU_ylm_RC_L6(  7,3 ) =  ztmp
    MatU_ylm_RC_L6(  8,-4 ) =  ctmp;   MatU_ylm_RC_L6(  8,4 ) =  ctmp
    MatU_ylm_RC_L6(  9,-4 ) =  ztmp;   MatU_ylm_RC_L6(  9,4 ) = -ztmp
    MatU_ylm_RC_L6( 10,-5 ) =  ctmp;   MatU_ylm_RC_L6( 10,5 ) = -ctmp
    MatU_ylm_RC_L6( 11,-5 ) =  ztmp;   MatU_ylm_RC_L6( 11,5 ) =  ztmp
    MatU_ylm_RC_L6( 12,-6 ) =  ctmp;   MatU_ylm_RC_L6( 12,6 ) =  ctmp
    MatU_ylm_RC_L6( 13,-6 ) =  ztmp;   MatU_ylm_RC_L6( 13,6 ) = -ztmp
  end subroutine set_matU_ylm

end subroutine set_gaunt_coeff

real(kind=DP) function wigner_3j( val_j1, val_m1, val_j2, val_m2, val_j3, val_m3 )
  use m_Const_Parameters,  only : DP, CMPLDP
  implicit none
  real(kind=DP), intent(in) :: val_j1, val_j2, val_j3, val_m1, val_m2, val_m3

  integer :: i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, k, kmin, kmax
  real(kind=DP) :: c1, c2, c3, c4, c5, c6, c7, c8, c9, c10
  real(kind=DP) :: d1, d2, term_n, term_s, coeff
  real(kind=DP) :: factorial

  if ( nint(val_m1 +val_m2 +val_m3) .ne. 0 ) then
     wigner_3j = 0.0d0;  return
  endif
  
  coeff = (-1)**( val_j1 -val_j2 -val_m3 )
  
  i1 = nint( val_j3 +val_j1 -val_j2 );    i2 = nint( val_j3 -val_j1 +val_j2 )
  i3 = nint( val_j1 +val_j2 -val_j3 );    i4 = nint( val_j3 -val_m3 )
  i5 = nint( val_j3 +val_m3 )
  i6 = nint( val_j1 +val_j2 +val_j3 +1 )
  i7 = nint( val_j1 -val_m1 );            i8 = nint( val_j1 +val_m1 )
  i9 = nint( val_j2 -val_m2 );            i10 = nint( val_j2 +val_m2 )
  
  c1 = factorial(i1);      c2 = factorial(i2);       c3 = factorial(i3)
  c4 = factorial(i4);      c5 = factorial(i5);       c6 = factorial(i6)
  c7 = factorial(i7);      c8 = factorial(i8);       c9 = factorial(i9)
  c10= factorial(i10)
  
  d1 = c1 *c2 *c3 *c4 *c5
  d2 = c6 *c7 *c8 *c9 *c10
!  write(*,*) "d1 = ", d1, d2
  
  term_n = sqrt( d1 /d2 )
  
  kmin = max( 0, nint(val_m1 -val_j1) )
  kmin = max( kmin, nint(val_j2 -val_j1 -val_m3) )
  kmax = min( nint(val_j2 +val_j3 +val_m1), nint(val_j3 -val_j1 +val_j2) )
  kmax = min( kmax, nint(val_j3 -val_m3) )
  
  term_s = 0.0d0
  Do k=kmin, kmax
     !    Do k=0, 100
     i2 = nint( val_j2 +val_j3 +val_m1 -k )
     i3 = nint( val_j1 -val_m1 +k )
     i5 = nint( val_j3 -val_j1 +val_j2 -k )
     i6 = nint( val_j3 -val_m3 -k )
     i7 = nint( val_j1 -val_j2 +val_m3 +k )
!       if ( i2 < 0 ) cycle
!       if ( i3 < 0 ) cycle
!       if ( i5 < 0 ) cycle
!       if ( i6 < 0 ) cycle
!       if ( i7 < 0 ) cycle

     c1 = (-1)**( val_j2 +val_m2 +k )
     c2 = factorial(i2);       c3 = factorial(i3);
     c4 = factorial(k)
     c5 = factorial(i5);       c6 = factorial(i6);       c7 = factorial(i7)
     d1 = c1 *c2 *c3
     d2 = c4 *c5 *c6 *c7
     term_s = term_s +d1 /d2
  End Do
  wigner_3j = coeff *term_n *term_s
  return
end function wigner_3j

real(kind=8) recursive function factorial(n)
  integer, intent(in) :: n
  
  integer :: i
  
  factorial = 1
  Do i=1, n
     factorial = factorial *i
  End do
  return
end function factorial

      subroutine eigen_dcx(n, d, e, lde, z, ldz, INFO, RET)
!$    use OMP_LIB
      use MPI
      use eigen_devel
      use eigen_blacs, only : eigen_get_blacs_context
      use eigen_dc
      implicit NONE

      integer, intent(in)           :: n, lde, ldz
      real(8), intent(inout)        :: d(1:n), e(1:2*lde)
      real(8), intent(out)          :: z(1:ldz,*)
      integer, intent(out)          :: info
      real(8), intent(out)          :: ret

! Parameters BLACS array descritor(the position of entry tags), etc
      INTEGER, PARAMETER            :: BLOCK_CYCLIC_2D = 1
      INTEGER, PARAMETER            :: DLEN_  = 9
      INTEGER, PARAMETER            :: DTYPE_ = 1
      INTEGER, PARAMETER            :: CTXT_  = 2
      INTEGER, PARAMETER            :: M_     = 3
      INTEGER, PARAMETER            :: N_     = 4
      INTEGER, PARAMETER            :: MB_    = 5
      INTEGER, PARAMETER            :: NB_    = 6
      INTEGER, PARAMETER            :: RSRC_  = 7
      INTEGER, PARAMETER            :: CSRC_  = 8
      INTEGER, PARAMETER            :: LLD_   = 9

      integer                       :: DESCZ( DLEN_ )
      integer                       :: DESCW( DLEN_ )
 
      integer                       :: i,j,nx,istat,NB,lddz,lddw
      integer                       :: NP, NQ, NPCOL, NPROW
      integer                       :: NPROCS, IAM, MYCOL, MYROW
      integer                       :: ICTXT

      integer                       :: world_size, my_rank, ierr
      integer                       :: TRILWMIN, LWORK, LIWORK
 
      real(8), pointer              :: work(:)
      integer, pointer              :: iwork(:)

      logical, parameter            :: USE_MY_REDIST = .TRUE.

#if defined(__INTEL_COMPILER)
      integer                       :: MKL_MODE
      integer, external             :: MKL_GET_DYNAMIC
#endif
      integer, external             :: NUMROC

#if TIMER_PRINT
      real(8)  :: d1,d2
#endif

 
      flops = 0D0
      dgemm_time = 0D0
 
      call eigen_timer_reset( )

#if TIMER_PRINT
      d1 = eigen_get_wtime()
#endif

      NPROCS = TRD_nnod
      IAM    = TRD_inod-1

      NPROW = x_nnod
      NPCOL = y_nnod

      ICTXT = eigen_get_blacs_context( )
!      ICTXT = BLACS_ICONTXT_FOR_EIGEN

!      CALL BLACS_GRIDINIT( ICTXT, 'Column-major', NPROW, NPCOL )

      MYROW = x_inod-1
      MYCOL = y_inod-1

!      call BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )


! BLACS array registration
      NB = 64
      NB = MIN(NB, N)

      NP = NUMROC( n, NB, MYROW, 0, NPROW )
      NQ = NUMROC( n, NB, MYCOL, 0, NPCOL )
      lddz = (n-1)/NPROW+1
      lddz = ((lddz-1)/NB+1)*NB
      lddw = (n-1)/NPCOL+1
      lddw = ((lddw-1)/NB+1)*NB
!
      call DESCINIT( DESCZ, n, n, NB, NB, 0, 0, ICTXT, lddz, INFO )

! preparing working arrays
      nx     = (N-1)/NPCOL+1
      LWORK  = MAX(1+6*N+2*NP*(NQ+MAX(NQ,NB)), lddz*lddw, ldz*nx)
      LIWORK = 2+7*n+8*NPCOL
      allocate(work(lwork), iwork(liwork), stat=istat)
      if(istat.ne.0) then
           print*,"Memory exhausted"
           call flush(6)
           call MPI_Abort( MPI_COMM_WORLD, 1, ierr )
      end if

! Somehow, Z must be nullified (Originally next loop is not required.)
!$OMP PARALLEL DO
!OCL XFILL
      do i=1, lddz*lddw
         z(i,1) = 0.0D+00
      enddo
!$OMP END PARALLEL DO
#if TIMER_PRINT
      d2 = eigen_get_wtime()
      IF(IAM==0)print*,"before PDSTEDC",d2-d1
#endif

      call DLAED6_INIT()

#if defined(__INTEL_COMPILER)
      MKL_MODE = MKL_GET_DYNAMIC()
      call MKL_SET_DYNAMIC(0)
#endif

#if TIMER_PRINT
      d1 = eigen_get_wtime ()
#endif
      CALL MY_PDSXEDC('I',2, n, d(1), e(1), lde, z(1,1), 1, 1, DESCZ,
     $               WORK(1), LWORK, IWORK(1), LIWORK, INFO)
#if TIMER_PRINT
      d2 = eigen_get_wtime()
#endif

#if defined(__INTEL_COMPILER)
      call MKL_SET_DYNAMIC(MKL_MODE)
#endif

#if TIMER_PRINT
      IF(IAM==0)print*,"PDSTEDC",d2-d1
#endif

      IF ( NB == 1 ) THEN
         do i=nx,1,-1
            work(1:lddz)=z(1+(i-1)*lddz:lddz+(i-1)*lddz,1)
            z(1:lddz,i)=work(1:lddz)
         enddo
         do i=1,nx
            z(lddz+1:ldz,i)=0.0D0
         enddo
         call bcast_dbl( d(1), n, 1, TRD_COMM_WORLD )
      ELSE

      IF( USE_MY_REDIST )THEN
#if TIMER_PRINT
         d1 = eigen_get_wtime()
#endif
         call dc_redist1( n, NB, z, work, lddz, iwork, liwork/2 )
#if TIMER_PRINT
         d2 = eigen_get_wtime()
         IF(IAM==0)print*,"MY-REDIST1",d2-d1
         d1 = eigen_get_wtime()
#endif
         call dc_redist2( n, NB, work, lddz, z, ldz, iwork, liwork/2 )
#if TIMER_PRINT
         d2 = eigen_get_wtime()
         IF(IAM==0)print*,"MY-REDIST2",d2-d1
#endif
      ELSE
#if TIMER_PRINT
         d1 = eigen_get_wtime()
#endif
         call DESCINIT( DESCW, n, n, 1, 1, 0, 0, ICTXT, ldz, INFO )
         call PDGEMR2D( n, n, z, 1, 1, DESCZ, work, 1, 1, DESCW, ICTXT )
#if TIMER_PRINT
         d2 = eigen_get_wtime()
         IF(IAM==0)print*,"PDGEMR2D",d2-d1
#endif
      END IF ! if ( USE_MY_REDIST ) .. else ..

#if TIMER_PRINT
         d1 = eigen_get_wtime()
#endif
!$OMP PARALLEL PRIVATE(i)
!$    IF ( omp_get_thread_num()==0 ) THEN
         call bcast_dbl( d(1), n, 1, TRD_COMM_WORLD )
!$    ENDIF
!$    IF ( omp_get_num_threads()==1 .OR.
!$   $     omp_get_thread_num()==1 ) THEN
      IF( .NOT.USE_MY_REDIST )THEN
         do i=1,ldz*nx
            z(i,1)=work(i)
         enddo
      ENDIF
!$    ENDIF
!$OMP END PARALLEL
#if TIMER_PRINT
         d2 = eigen_get_wtime()
         IF(IAM==0)print*,"RERE1",d2-d1
#endif
      END IF ! if ( NB == 1 ) .. else ..

      call eigen_timer_print( )

! freeing working arrays
      deallocate(work)
      deallocate(iwork)

 
! BLACS/PBLAS/SCALAPACK finalize
!      call BLACS_GRIDEXIT( ICTXT )

      call reduce_dbl( flops, ret, 1, 1, TRD_COMM_WORLD )

#if TIMER_PRINT
      IF(IAM==0)THEN
         print*,"PDGEMM", dgemm_time, 
     &          1D-9*flops/dgemm_time,"GFLOPS"
      ENDIF
#endif

      ret = flops

      return
      end subroutine  eigen_dcx

!=======================================================================
!
!  SOFTWARE NAME : PHASE ($Revision: 618 $)
!
!  SUBROUINE:  ex_ggapw91, cr_ggapw91, ex_ggapbe, cr_ggapbe, xclda, ggabek, 
!            ggaprd, xcpotf_wigner, xcpotf_pzold, xcpotf_xalfa, xcpotf_pz,
!            xcpotf_vwn, xcpotf_mjw_bh_gl, cpden, gdiffs, gtgrad, wdcoef,
!            gcoef1, gcoef2, ggrade, cnggrd1, cpval, cpval_abs, getroh, 
!            getroh2, cnggrd, mkprdc, 
!
!  AUTHOR(S): T. Yamasaki, K. Kato   August/20/2003
!  
!  FURTHER MODIFICATION: M. Saito, T. Yamasaki, December/01/2003
!  FURTHER MODIFICATION: T. Yamasaki, June/03/2010
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
! $Id: b_XC_Potential.F90 618 2020-05-12 08:44:53Z ktagami $
!!====================================================================
!!        modified  by T.Yamasaki  94/11/14
!!
!!        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!
! === xclda etc. are necessary to make 3D_Parallel, too!!! by tkato ============
!!BRANCH_P ORG_Parallel
! ==============================================================================
!$$#ifndef PARA3D
subroutine ex_ggapw91(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc &
     &                    ,dFx_drho,dFx_dgradrho, ien)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)


  integer :: is, i, iend_true
  real(kind=DP) :: exc1,facw,d,dd,fk,s,fac,s2,s3,s4&
       & ,p0,p1,p2,p3,p4,p5,p6,f,ex,fs,exd,exdd,exc0,excd,excdd

  real(kind=DP), parameter :: a1 = 0.19645d0
  real(kind=DP), parameter :: a2 = 0.27430d0
  real(kind=DP), parameter :: a3 = 0.15084d0
  real(kind=DP), parameter :: a4 = 100.0d0

! === KT_mod === 2014/11/25
!!!  real(kind=DP), parameter :: ax = -0.7385588d0
       real(kind=DP), parameter ::  ax = -0.7385587663820224d0
!=============== 2014/11/25

  real(kind=DP), parameter :: a  =  7.7956d0
  real(kind=DP), parameter :: b1 =  0.004d0

! === KT_mod === 2014/11/25
!  real(kind=DP), parameter :: thrd   = 0.33333333333d0
!  real(kind=DP), parameter :: thrd4  = 1.333333333333333d0
  real(kind=DP), parameter :: thrd   = 0.33333333333333333333333d0
  real(kind=DP), parameter :: thrd4  = 1.33333333333333333333333d0
!=============== 2014/11/25

  real(kind=DP), parameter :: thpith = 3.0936677262801d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

  facw = ispin
  exc = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true       ! MPI
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif

        fac = ax*d**thrd
        s2  = s*s
        s3  = s2*s
        s4  = s2*s2
        p0  = 1.d0/(dsqrt(1.d0+a*a*s2))
        p1  = dlog(a*s+1.d0/p0)
        p2  = dexp(-a4*s2)
        p3  = 1.d0/(1.d0+a1*s*p1+b1*s4)
        p4  = 1.d0 + a1*s*p1 + (a2-a3*p2)*s2
        f   = p3*p4
        ex  = fac*f*d
        p5  = 2.d0 *(s*(a2-a3*p2)+a3*a4*s3*p2 - 2.d0*b1*s3)
        p6  = (a1*(p1+a*s*p0)+4.d0*b1*s3)*((a2-a3*p2)*s2-b1*s4)
        fs  = (p5*p3-p6*p3*p3)
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith

        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
!!$c gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapw91


!!===================================================================
!!        modified  by T.Yamasaki  94/11/15
!!
!!        The original is modified and Spin polrarized GGA programs
!!        are added in this subroutine
!!                                                      by K. Kato 1995/1/18 
!!
subroutine cr_ggapw91(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ien)
!!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter :: a  = 0.0310907d0,     a1   = 0.21370d0
  real(kind=DP), parameter :: b1 = 7.5957d0,        b2n  = 3.5876d0
  real(kind=DP), parameter :: b3 = 1.6382d0,        b4   = 0.49294d0
  real(kind=DP), parameter :: p  = 1.00d0,          p1   = p+1.d0
  real(kind=DP), parameter :: ap  = 0.015545d0,     a1p  = 0.20548d0
  real(kind=DP), parameter :: b1p = 14.1189d0,      b2np = 6.1977d0
  real(kind=DP), parameter :: b3p = 3.3662d0,       b4p = 0.62517d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter :: aq  = 0.016887d0,     a1q = 0.11125d0
  real(kind=DP), parameter :: b1q = 10.3570d0,      b2nq = 3.6231d0
  real(kind=DP), parameter :: b3q = 0.88026d0,      b4q = 0.49671d0
! vwn 95/12/2 Y.M

  real(kind=DP), parameter :: xnu = 15.75592d0,     cc0 =  0.004235d0
  real(kind=DP), parameter :: cx  = -0.001667212d0, alf =  0.09d0
  real(kind=DP), parameter :: c1  =  0.002568d0,    c2  =  0.023266d0
  real(kind=DP), parameter :: c3  =  7.389d-6,      c4  =  8.723d0
  real(kind=DP), parameter :: c5  =  0.472d0,       c6  =  7.389d-2
  real(kind=DP), parameter :: a4  = 100.d0

! ==== KT_mod ==== 2014/11/25
!  real(kind=DP), parameter :: thrd   = 0.333333333333d0
!  real(kind=DP), parameter :: sixth7 = 1.1666666666666666d0
  real(kind=DP), parameter :: thrd   = 0.3333333333333333333333d0
  real(kind=DP), parameter :: sixth7 = 1.1666666666666666666666d0
! ================= 2014/11/25

  integer       :: is,i,iend_true
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,g4,facpon,d,dd,rs,fk,sk,t,s&
       & , q0,rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon,b,b2,t2,s2,t4,t6 &
       & , rs2,rs3,q4,q5,q6,q7,cc,r0,r1,coeff,r2,r3,a4ms,h0,h1,h,q8 &
       & , h0t,h0b,h0rs,h1t,ccrs,r1rs,h1rs,ht,hrs &
       & , ec1,ec1d,ec1dd,exc0,excd,excdd &
       & , thrd2,thrd4,zeta,q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,fzdd,fz&
       & , euzt,zetadxd,bzt,h0zt,h1zt,gzt &
       & , onpzeta, onmzeta, onzt4 

! ==== kT_add ===== 2014/11/25
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666666666d0
! ================= 2014/11/25

  facw = ispin

! === KT_mod === 2014/11/25
!  bet = xnu*cc0
  bet=0.06672455060314922d0
! ============== 2014/11/25

  delt = 2.d0*alf/bet

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is=1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g = 1.d0
        g3  = g**3
        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r, iend_true  ! MPI
           d = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd =facw* grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2 ) then
              t = dd/(d*sk*2.d0)
              s = dd/(d*fk*2.d0)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3.d0*cx/7.d0
           r2  = xnu*coeff*g3
           a4ms = -a4*g4*s2
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1
!======================================================
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0*bet*t*( 1.d0 +2.d0*b*t2 )/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2 )/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           h1t  = 2.d0*r3*r2*t*(1.d0-r1*t2)
           ccrs = ( c2 +2.d0*c3*rs )/q7 -q6*( c4 +2*c5*rs +3.d0*c6*rs2 )/q7**2
           r1rs = 100.d0 *r0/rs
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t +h1t
           hrs  = h0rs +h1rs
           ec1  = d*h/facw
           ec1d = h -thrd*rs*hrs -sixth7*t*ht
           ec1dd = 0.5d0*ht/sk

!---------------------------------------------------
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin  == 2 ) then
        thrd2 = thrd * 2.0d0
        thrd4 = thrd * 4.0d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4-2.d0))

        do i = ista_r, iend_r      ! MPI
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d.lt.density_minimum) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, ispin) ) / d
           onpzeta = 2.d0*chgrhr_l(i,1)     / d
           onmzeta = 2.d0*chgrhr_l(i,ispin) / d
           g  = ( onpzeta**thrd2 + onmzeta**thrd2) * 0.5d0
!!$           g  = ( (1+zeta)**thrd2 + (1-zeta)**thrd2 ) * 0.5

           if(dabs(zeta) < zeta_minimum) then
              fz = 4.d0/9.d0 * zeta*zeta*(1.d0 + 5.d0/54.d0 * zeta*zeta&
                   &                 *(1.d0 +44.d0/133.d0* zeta*zeta ))&
                   &    /(2.d0**thrd4-2.d0)
           else
              fz = ( (1.d0+zeta)**thrd4+(1.d0-zeta)**thrd4-2.d0)/(2.d0**thrd4-2.d0)
           end if

           g3  = g**3
           g4  = g3*g
           facpon = -delt/(g3*bet)

           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = grad_trho(i)
!!$c        dd = grad_rho(i, 1) + grad_rho(i, 2)
! gradient of charge density 95/12/3 H.S.
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
! --> check if this is correct or not
!!$              t = dd/(d*sk*2.d0)
              t = dd/(d*sk*2.d0)/g  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
              s = dd/(d*fk*2.d0)
           else
              t = 0.d0
              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1.d0+1.d0/q1)
           q3 = a*( b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp )

           q0p = -2.d0*ap*(1.d0+a1p*rs)
           q1p =  2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0+1.d0/q1p)
           q3p = ap*(b1p/rs12+2.d0*b2np+3.d0*b3p*rs12+2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0 *aq*(1.d0+a1q*rs)
           q1q =  2.d0 *aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12+2.d0*b2nq+3.d0*b3q*rs12+2.d0*b4q*p1*rsp)

           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/(9.d0*(2.d0**thrd4 - 2.d0 )) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = (4.d0/3.d0)/(2.d0**thrd4-2.d0)*(onpzeta**thrd-onmzeta**thrd )
           end if

           onzt4 = onmzeta*onpzeta * (1.d0 + zeta*zeta)
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &        -   q0q * q2q * fz / fzdd * onzt4
           eurs = (-2.d0*a*a1*q2 - q0*q3/(q1**2+q1)) * (1.d0-fz*zeta**4) &
                &+(-2.d0*ap*a1p*q2p-q0p*q3p/(q1p**2+q1p))*fz*zeta**4 &
                &-(-2.d0*aq*a1q*q2q-q0q*q3q/(q1q**2+q1q))*fz/fzdd*onzt4
           euzt = -q0q*q2q/fzdd*(fzd*(1.d0-zeta**4)-4.d0*fz*zeta**3) &
                &+(q0p*q2p-q0*q2)*(fzd*zeta +4.d0*fz )*zeta**3
! vwn 95/12/2 Y.M
           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu - thrd*rs*eurs + euzt * zetadxd
!
! ==== KT_mod ==== 2014/11/25
!           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
!              ec1 = 0.d0; ec1d = 0.d0; ec1dd= 0.d0
!              goto 10
!           end if
! ================= 2014/11/25

           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           rs2 = rs*rs
           rs3 = rs2*rs
           q4  = 1.d0+b*t2
           q5  = 1.d0+b*t2+b2*t4
           q6  = c1+c2*rs+c3*rs2
           q7  = 1.d0+c4*rs+c5*rs2+c6*rs3
           cc  = -cx + q6/q7
           r0  = (sk/fk)**2
           r1  = a4*r0*g4
           coeff = cc-cc0-3.d0*cx/7.d0
           r2  = xnu*coeff*g3
! --> Check if this is correct or not
!!$           a4ms = -a4*g4*s2
           a4ms = -r1*t2   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           r3  = dexp(a4ms)
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h1  = r3*r2*t2
           h   = h0+h1

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1.d0+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
! --> Check if this is correct or not
!!$           h0rs = h0b * b2 * eurs / bet / g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h1t  = 2*r3*r2*t*(1.d0-r1*t2)
           ccrs = (c2+2*c3*rs)/q7-q6*(c4+2*c5*rs+3*c6*rs2)/q7**2
! --> Check if this is correct or not
!!$           r1rs = 100*r0/rs
           r1rs = r1/rs  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h1rs = xnu*t2*r3*(ccrs - coeff*t2*r1rs) * g3
           ht   = h0t+h1t
           hrs  = h0rs + h1rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &                *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
! ==== KT_mod ==== 2014/11/25
!!!              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
	      gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
! ================ 2014/11/25
           end if

! --> Check if this is correct or not
!!$           bzt = pon*b**2 * (euzt-3*eu*gzt/g) / ( bet * g3 ) 
           bzt = b * (b+delt) * (euzt-3*eu*gzt/g) / ( bet * g3 )  ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           h0zt = 3*gzt*h0/g + h0b*bzt
! --> Check if this is correct or not
!!$           h1zt =(3*gzt + 4*gzt*a4ms ) * h1 / g
           h1zt =(3.d0 + 4.d0*a4ms ) * h1 * gzt/ g   ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--
           
           ec1  = d*h * 0.5d0

! --> Check if this is correct or not
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht + (h0zt+h1zt) * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht + (h0zt+h1zt-gzt*ht/g) * zetadxd    ! 2011/04/26 revised according to a Katsumata-san's comment.
!!$           ec1dd = 0.5*ht/sk
           ec1dd = 0.5d0*ht/sk/g     ! 2011/04/26 revised according to a Katsumata-san's comment.
! <--

10         continue
           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is == 2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5d0
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapw91

#ifndef PREV_EX_GGAPBE
!!$====================================================================
!!$        modified  by T.Yamasaki  94/11/14
!!$
!!$        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine ex_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dFx_drho,dFx_dgradrho,revPBE,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)
  logical, intent(in),optional :: revPBE

!!  real(kind=DP), parameter :: ax = -0.7385588d0
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
!!  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
!!  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
  real(kind=DP), parameter ::  yum = 0.2195149727645171d0
  real(kind=DP) :: cupa

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i,iend_true
  logical       :: repbe

  repbe = .false.
  if(present(revPBE)) repbe = revPBE
  cupa = 0.8040d0
  if(repbe) cupa = 1.245d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true  ! MPI
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1.d0 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2.d0 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#else
!!$====================================================================
!!$        modified  by T.Yamasaki  94/11/14
!!$
!!$        Modified for Spin polrarized GGA by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
! ==== DEBUG! ==================================================================
#if 1
subroutine ex_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dFx_drho,dFx_dgradrho,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)

#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
#else
  real(kind=DP), parameter :: ax = -0.7385588d0
#endif
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
#else
  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
#endif

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i,iend_true

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_true
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#else
subroutine ex_ggapbe(nspin,ispin,chgrhr_l,grad_rho,f2or1,exc,dFx_drho,dFx_dgradrho)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,PAI
  use m_Parallelization,   only : ista_fftph, iend_fftph
  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_fftph:iend_fftph,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_fftph:iend_fftph,nspin)

#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
#else
  real(kind=DP), parameter :: ax = -0.7385588d0
#endif
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0
#ifndef PREV_EX_GGAPBE
  real(kind=DP), parameter :: cupa = 0.8040d0, yum = 0.2195149727645171d0
#else
  real(kind=DP), parameter :: cupa = 0.804, yum = 0.21951
#endif

  real(kind=DP) :: facw,d,dd,fk,s,fac,s2,yums2,f,ex,fs,exd,exdd,exc0,excd,excdd,exc1
  integer       :: is,i

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_fftph, iend_fftph
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
        yums2 = yum * s2
        f = 1 + cupa * yums2 / ( cupa + yums2 )
        ex  = fac*f*d
        fs = 2 * cupa ** 2 * yum * s / ( cupa + yums2 ) ** 2
        exd = thrd4*fac*(f-s*fs)
        exdd = ax*fs*0.5d0/thpith
!------------------------------------------     
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd 
        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*f2or1(i)
     end do
     exc = exc + exc1
  end do
end subroutine ex_ggapbe
#endif
! ==== DEBUG! ==================================================================
#endif

#ifndef PREV_CR_GGAPBE
!!$===================================================================
!!$        modified  by T.Yamasaki  94/11/15
!!$
!!$        The original is modified and Spin polrarized GGA programs
!!$        are added in this subroutine
!!$                                                      by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
subroutine cr_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ecor,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out),optional :: ecor
  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
!Fix!  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
!Fix!  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
  !Fix!real(kind=DP), parameter  :: gamma = 0.031091
  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
!--------------------------
!Fix!  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
  real(kind=DP), parameter  :: bet=0.06672455060314922d0
  real(kind=DP), parameter  :: delt=bet/gamma
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

!Fix! T.Yamatomto 2011/06/29
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0
!Fix! T.Yamatomto 2011/06/29


  integer       :: is,i,iend_true
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
!Fix!  bet = xnu*cc0
!Fix!  delt = bet / gamma
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  if(present(ecor)) ecor = 0.d0
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_true ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
           !Fix!rs = (0.75/(PAI*d))**thrd
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 + b*t2
           q5  = 1.d0 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1d0+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*( 1.d0 +2d0 *b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0 *b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
           !Fix!ec1dd = 0.5*ht/sk
           ec1dd = 0.5d0*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2.d0
        thrd4 = thrd * 4.d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4 - 2.d0 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2.d0 *chgrhr_l(i, 1) / d
           onmzeta = 2.d0 *chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2.d0
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9.d0 *zeta*zeta*(1.d0 + 5.d0/54.d0 *zeta*zeta &
                   &               *(1.d0 +44.d0/135.d0*zeta*zeta )) &
                   &       /(2.d0**thrd4 -2.d0)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2.d0) / (2.d0**thrd4 - 2.d0)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
!Fix!              t = dd/(d*sk*2)
              t = dd/(d*sk*2.d0*g)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 +1.d0/q1 )
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)

           q0p = -2.d0 *ap*(1.d0+a1p*rs)
           q1p = 2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0 +1.d0/q1p)
           q3p = ap*(b1p/rs12 +2.d0*b2np +3.d0*b3p*rs12 +2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0*aq*(1.d0+a1q*rs)
           q1q =  2.d0*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12 +2.d0*b2nq +3.d0*b3q*rs12 +2.d0*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2.d0 ) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2.d0) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1.d0 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2.d0*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1.d0 -fz*zeta**4 )&
                &+( -2.d0*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2.d0*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4.d0*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4.d0*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

!Fix!           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
!Fix!              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
!Fix!              go to 10
!Fix!           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 +b*t2
           q5  = 1.d0 +b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*(1.d0 +2.d0*b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &             *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
!Fix!              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3.d0*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3.d0 * gzt * h0 / g + h0b * bzt

           !Fix!ec1  = d*h * 0.5
           ec1  = d*h * 0.5d0
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           !Fix!ec1dd = 0.5*ht/sk / g
           ec1dd = 0.5d0*ht/sk / g

10         continue
           !Fix!exc0 = eu*d * 0.5 + ec1
           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
     if(present(ecor)) ecor = ecor + exc1
  end do
end subroutine cr_ggapbe
#else
!!$===================================================================
!!$        modified  by T.Yamasaki  94/11/15
!!$
!!$        The original is modified and Spin polrarized GGA programs
!!$        are added in this subroutine
!!$                                                      by K. Kato 1995/1/18 
!!$
!!$        Modified to Perdew-Burke-Ernzerhof(PBE) GGA by K. Kato 1999/4/1 
!!$
! ==== DEBUG! ==================================================================
#if 1
subroutine cr_ggapbe(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_trho,wos,exc,dF_drho,ien)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
#else
  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
#endif
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
#else
  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
#endif
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
#else
  real(kind=DP), parameter  :: gamma = 0.031091
#endif
!--------------------------
#ifndef PREV_CR_GGAPBE
  real(kind=DP), parameter  :: bet=0.06672455060314922d0
  real(kind=DP), parameter  :: delt=bet/gamma
#else
  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
#endif
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

#ifndef PREV_CR_GGAPBE
!Fix! T.Yamatomto 2011/06/29
  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0
!Fix! T.Yamatomto 2011/06/29
#endif

  integer       :: is,i,iend_true
#ifndef PREV_CR_GGAPBE
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#else
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
#endif
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

#ifdef PREV_CR_GGAPBE
  bet = xnu*cc0
  delt = bet / gamma
#endif
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_true ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
#ifndef PREV_CR_GGAPBE
           rs = (0.75d0/(PAI*d))**thrd
#else
           rs = (0.75/(PAI*d))**thrd
#endif
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1 + b*t2
           q5  = 1 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
#ifndef PREV_CR_GGAPBE
           ec1dd = 0.5d0*ht/sk
#else
           ec1dd = 0.5*ht/sk
#endif
           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do
     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2
        thrd4 = thrd * 4
        fzdd = 8/(9*(2**thrd4 - 2 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2*chgrhr_l(i, 1) / d
           onmzeta = 2*chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9 *zeta*zeta*(1 + 5.d0/54 *zeta*zeta &
                   &               *(1 +44.d0/135*zeta*zeta )) &
                   &       /(2**thrd4 -2)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2) / (2**thrd4 - 2)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
#ifndef PREV_CR_GGAPBE
              t = dd/(d*sk*2*g)
#else
              t = dd/(d*sk*2)
#endif
           else
              t = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p = 2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2 ) &
                   &     *zeta *( 1 + 5.d0/27 *zeta*zeta &
                   &           *( 1 +22.d0/45 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1 -fz*zeta**4 )&
                &+( -2*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

#ifdef NEC_TUNE_MXCP
           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
              go to 10
           end if
#endif
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1+b*t2
           q5  = 1+b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1 +14.d0/27 *zeta*zeta &
                   &             *( 1 +13.d0/18 *zeta*zeta ))
           else
#ifndef PREV_CR_GGAPBE
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
#else              
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
#endif
           end if
           bzt = b * ( b+delt) * ( euzt - 3*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3 * gzt * h0 / g + h0b * bzt

#ifndef PREV_CR_GGAPBE
           ec1  = d*h * 0.5d0
#else
           ec1  = d*h * 0.5
#endif
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5*ht/sk / g

10         continue
#ifndef PREV_CR_GGAPBE
           exc0 = eu*d * 0.5d0 + ec1
#else
           exc0 = eu*d * 0.5 + ec1
#endif
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapbe
#else
subroutine cr_ggapbe(nspin,ispin,chgrhr_l,grad_trho,f2or1,exc,dF_drho)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : PAI,DP
  use m_Parallelization,   only : ista_fftph, iend_fftph
  implicit none

  integer,intent(in)        :: nspin,ispin
  real(kind=DP),intent(in)  :: chgrhr_l(ista_fftph:iend_fftph,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_fftph:iend_fftph)
  real(kind=DP),intent(in)  :: f2or1(ista_fftph:iend_fftph)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_fftph:iend_fftph,nspin)

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0
  real(kind=DP), parameter  :: ap  = 0.015545d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter  :: aq  = 0.016887d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0
! vwn 95/12/2 Y.M
  real(kind=DP), parameter  :: gamma = 0.031091
!--------------------------
  real(kind=DP), parameter  :: xnu = 15.75592d0, cc0 = 0.004235d0
  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

  integer       :: is,i
  real(kind=DP) :: facw,bet,delt,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt

  facw = ispin
  bet = xnu*cc0
  delt = bet / gamma
!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_fftph,iend_fftph ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)
           rs = (0.75/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2)
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)
           eurs = -2*a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1 + b*t2
           q5  = 1 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht
           ec1dd = 0.5*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*f2or1(i)
        end do
     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2
        thrd4 = thrd * 4
        fzdd = 8/(9*(2**thrd4 - 2 ))

        do i = ista_fftph,iend_fftph
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2*chgrhr_l(i, 1) / d
           onmzeta = 2*chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9 *zeta*zeta*(1 + 5.d0/54 *zeta*zeta &
                   &               *(1 +44.d0/135*zeta*zeta )) &
                   &       /(2**thrd4 -2)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2) / (2**thrd4 - 2)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3*PAI*PAI*d)**thrd
           sk = dsqrt(4*fk/PAI)

           if(d > density_minimum2) then
! --> Check if this is correct or not
              ! 2011/04/26 revised according to a Katsumata-san's comment.
!!$              t = dd/(d*sk*2)
              t = dd/(d*sk*2)
              t = t/g
! <--
!!$              s = dd/(d*fk*2)
           else
              t = 0.d0
!!$              s = 0.d0
           endif

           q0 = -2*a*(1+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2*a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log(1+1/q1)
           q3 = a*(b1/rs12+2*b2n+3*b3*rs12+2*b4*p1*rsp)

           q0p = -2*ap*(1+a1p*rs)
           q1p = 2*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1+1/q1p)
           q3p = ap*(b1p/rs12+2*b2np+3*b3p*rs12+2*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2*aq*(1+a1q*rs)
           q1q =  2*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1+1/q1q)
           q3q = aq*(b1q/rs12+2*b2nq+3*b3q*rs12+2*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2 ) &
                   &     *zeta *( 1 + 5.d0/27 *zeta*zeta &
                   &           *( 1 +22.d0/45 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1 -fz*zeta**4 )&
                &+( -2*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

           if(onpzeta < zeta_minimum2 .or. onmzeta < zeta_minimum2) then
              ec1  = 0.d0;    ec1d = 0.d0;     ec1dd= 0.d0
              go to 10
           end if
           pon = facpon*eu
           b   = delt/(dexp(pon)-1)
           b2  = b*b
           t2  = t*t
!!$           s2  = s*s
           t4  = t2*t2
           t6  = t4*t2
           q4  = 1+b*t2
           q5  = 1+b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2*bet*t*(1+2*b*t2)/q8 * g3
           h0b = -bet*t6*(2*b+b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9*zeta *( 1 +14.d0/27 *zeta*zeta &
                   &             *( 1 +13.d0/18 *zeta*zeta ))
           else
              gzt = ( 1.d0/onpzeta**thrd -1.d0/onmzeta**thrd )/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3 * gzt * h0 / g + h0b * bzt

           ec1  = d*h * 0.5
! --> revised by Kato-san,  1999Jul16
!!$           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + h0zt * zetadxd
           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5*ht/sk / g

10         continue
           exc0 = eu*d * 0.5 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*f2or1(i)
        end do
     end if
     exc = exc + exc1
  end do
end subroutine cr_ggapbe
#endif
! ==== DEBUG! ==================================================================
#endif

!!$c===================================================================
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
!!$     1994/11/24 coded by T.Yamasaki
!!$
subroutine xclda(nspin,ispin,ista_r,iend_r,chgrhr_l,wos,exc,dF_drho,ien)
  use m_Const_Parameters,  only : DP, PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
!!$  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dF_drho(ista_r:iend_r,nspin)

  integer :: is, i, iend_true
  real(kind=DP) :: co2,d,rs,exclds
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0

  co2 = (0.75d0/PAI)**thrd
  exc = 0.d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  is = 1
  if(ispin == 2)  stop '!Sorry, ispin == 2 is not supported now'

  do i = ista_r, iend_true
     d = chgrhr_l(i,is)
     if(d < 1.d-40) then
        dF_drho(i,is) = 0.d0
        cycle
     endif
     rs = co2*(1.d0/d)**thrd
     if(rs >= 1.d0) then
        dF_drho(i,is) = &
             &   (-0.61093d0/rs - (0.1423d0+0.1759d0*dsqrt(rs) &
             &    + 0.06366d0*rs)&
             &   /(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)**2 )
        exclds = -0.61093d0*0.75d0/rs &
             &   -0.1423d0/(1 + 1.0529d0*dsqrt(rs) + 0.3334d0*rs)
     else
        dF_drho(i,is) =  &
             &  ( -0.61093d0/rs - 0.05837d0 - 0.0084d0*rs &
             &   + 0.0311d0*log(rs) + 0.00133d0*rs*dlog(rs) )
        exclds = -0.61093d0*0.75d0/rs &
             &  - 0.048d0 -0.0116*rs &
             &  + 0.0311d0*dlog(rs) + 0.0020d0*rs*dlog(rs)
     end if
     exc = exc + exclds*wos(i)*d
  end do
end subroutine xclda

!!$c ---------------------------------------
!!$c       1994/11/24 coded by T. Yamasaki
!!$c       1994/12/22 modified by T. Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggabek(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dF_drho,dF_dgradrho,ien)
  use m_Const_Parameters,  only : DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dF_dgradrho(ista_r:iend_r,nspin)

  integer        :: i, iend_true
  real(kind=DP)  :: fac,tthrd,fac_t,d,dd,dthrd,dthrd4,x,x2,p0,x2ovp0&
       &, y,f,vxc1,exgga

  real(kind=DP), parameter ::    b = 0.0042d0
  real(kind=DP), parameter :: thrd = 0.333333333333333333d0
        
  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  fac = 4*thrd * b
  tthrd = 2.d0**thrd
  fac_t  = 1.d0/tthrd
  do i = ista_r, iend_true
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-10 .or. dd > 1.d10) then
        dF_dgradrho(i,1) = 0.d0
        cycle
     endif
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = tthrd*dd/dthrd4
     x2 = x*x
     p0 = dsqrt(1+x2)
     x2ovp0 = 6*b*x2/p0
     if(x < 1.d-40) then
        y = 0.d0
     else
        y = dlog(x + p0)
     endif
     f  = 1.d0/(1.d0+6.d0*b*x*y)
     vxc1    = x2*f*f*(1.d0-x2ovp0)
     dF_drho(i,1) = dF_drho(i,1) + fac*dthrd*vxc1*fac_t
     dF_dgradrho(i,1) = fac*dthrd*(vxc1 + x2*f)*fac_t

     exgga  = -b * dthrd4 * x2 * f * fac_t
     exc      = exc      + exgga*wos(i)
  end do
end subroutine ggabek

!!$c ---------------------------------------
!!$c     1994/11/24 coded by T.Yamasaki
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
subroutine ggaprd(nspin,ispin,ista_r,iend_r,chgrhr_l,grad_rho,wos,exc,dF_drho,dF_dgradrho,ien)
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)         :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP),intent(in)   :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(out)  :: exc
  real(kind=DP),intent(inout):: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(inout)  :: dF_dgradrho(ista_r:iend_r,nspin)

  real(kind=DP) :: cinfin,d,ovd,thrd4,sixth7,co2,dd,rs,dthrd,dthrd4&
       &, x, cdenom,c,phi,expphi,ecgga,dcdrs,dcdrho
  integer       :: i, iend_true

  real(kind=DP), parameter :: alpha = 0.023266d0
  real(kind=DP), parameter ::  beta = 7.389d-6
  real(kind=DP), parameter :: gamma = 8.723d0
  real(kind=DP), parameter :: delta = 0.472d0
  real(kind=DP), parameter ::fchird = 0.11
  real(kind=DP), parameter :: thrd  = 0.333333333333333333d0
  real(kind=DP), parameter :: c0    = 0.001667d0
  real(kind=DP), parameter :: c1    = 0.002568d0

  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)

  cinfin = c0 + c1
  d = 1.d0
  ovd = 1.d0/d
  thrd4 = 4*thrd
  sixth7 = 7.d0/6.d0

  co2 = (0.75d0/PAI)**thrd
  do i = ista_r, iend_true
     d = chgrhr_l(i,1)
     dd = grad_rho(i,1)
     if(d < 1.d-40) cycle
     rs = co2*(1.d0/d)**thrd
     dthrd  = d**thrd
     dthrd4 = dthrd*d
     x = dd/dthrd4
     cdenom = 1.d0/(1 + rs*(gamma + rs*(delta + 1.d+4*beta*rs)))
     c = c0 + (c1 + rs*(alpha + beta*rs))*cdenom
     phi = 1.745d0 * fchird * cinfin/c * x *dsqrt(dthrd)
     expphi = dexp(-phi)
     ecgga = ovd*expphi*c*dd*x

     dcdrs = cdenom * ((alpha + 2*beta*rs) &
          &         - cdenom * (c1+rs*(alpha+beta*rs)) &
          &       * (gamma+rs*(2*delta + 3.d+4*beta*rs)))
     dcdrho = -thrd*(rs/d)*dcdrs
     dF_drho(i,1) = dF_drho(i,1) + ovd*(dcdrho*(phi+1) &
          &       +(sixth7*phi - thrd4)*c)*expphi*x*dd
     dF_dgradrho(i,1) = dF_dgradrho(i,1) + ovd*expphi*c*x*(2 - phi)

     exc = exc + ecgga*wos(i)
  end do
end subroutine ggaprd

subroutine cr_lda(nspin,ispin,ista_r,iend_r,chgrhr_l,exc,dF_drho,ien)
  use m_Const_Parameters,  only : PAI,DP
  integer, intent(in)        :: nspin,ispin,ista_r,iend_r
  integer,intent(in),optional :: ien
  real(kind=DP), intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP), intent(inout) :: exc
  real(kind=DP), intent(inout) :: dF_drho(ista_r:iend_r,ispin)
  real(kind=DP) :: rhomin = 1.d-9
  integer :: i, iend_true
  real(kind=DP) :: n,rs,x,ec,dedx,dxdr
  iend_true = iend_r
  if(present(ien)) iend_true = min(iend_r,ien)
  ec = 0.d0
  do i=ista_r,iend_true
     n = chgrhr_l(i,ispin)
!     if(n<rhomin) n = rhomin
     if(n<rhomin) cycle
     
     rs = ((3.d0/(4.d0*PAI*n))**(1.d0/3.d0))
     x = rs/11.4d0
     ec = -0.0666d0*0.5d0*((1.d0+x**3)*DLOG(1.d0+1.d0/x)-x**2+x/2.d0-1.d0/3.d0)
     exc = exc+ec*n

     dxdr = -(3.d0/(4.d0*PAI))**(1.d0/3.d0)/11.4d0/3.d0*n**(-4.d0/3.d0)
     dedx = -0.0333d0*(3*x*x*dlog(1.d0+1.d0/x)-(1+x**3)/(x*(x+1))-2*x+0.5d0)
     dF_drho(i,ispin) = dF_drho(i,ispin) + dedx*dxdr*n+ec
  enddo
end subroutine cr_lda

subroutine xcpotf_wigner(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!*****<<< WIGNER INTERPOLATION >>>
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: rho,rs,zeta,vxc,tmp,WX0,CO2
  integer       :: i, icount
  real(kind=DP), parameter :: C13 = 1.d0/3.d0
  real(kind=DP), parameter :: CO3 = 4.d0/3.d0

  CO2 = (0.75d0/PAI)**C13
  WX0 =  3*(((9*PAI)/4)**C13)/(2*PAI)

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     icount = 0
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
        rs     = CO2*( 1.0d0/rho  )**C13
        if(rho < DELTA) cycle
        zeta = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))/rho
        if(dabs(zeta) > DELTA) icount = icount + 1
        tmp    = - WX0/2.d0*CO3/RS -(0.440d0*CO3*RS + 3.432d0)/(RS+7.8D0)**2
        chgrhr_l(i,UP  ) = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc    = -(WX0/2.d0/RS+0.44d0/(RS+7.8d0))
        exc    = exc + vxc*rho*wos(i)
     end do
     if(icount >= 1) then
        write(6,*)' WIGNER XC-ENERGY and POTENTIAL are not' &
             &         , ' appropriate for Spin-Polarized calculation'
        stop 'WIGNER'
     endif
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - WX0/2.d0*CO3/rs &
             &           -(0.440d0*CO3*rs + 3.432d0)/(rs+7.8d0)**2
        vxc    = -(WX0/2.d0/rs+0.44d0/(rs+7.8d0))
        exc    = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_wigner

subroutine xcpotf_pzold(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP) :: B1P01,B1P02,CP00,CP01,CP02,OVC213,OVC243 &
       &         , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP) :: rho,ovn,rs,denmp,denmf,wcp,wcf,vcp,vcf,zeta,f00,f2up,f2down &
       &         , t1,wxp,wxf,vxp,x,t2,vxc
  integer       :: i

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213  = 2.d0**C13

  B1P01 = 7.d0*BETA1P/6.d0
  B1P02 = 4.d0*BETA2P/3.d0

  CP00 = BP - AP/3.d0
  CP01 = (2*DPx - CP)/3.d0
  CP02 = 2*CP/3.d0

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     OVC213 = 1.D0/(C213 - 1)
     OVC243 = 1.D0/(2.D0**C43 - 2)

     B1F01 = 7.D0*BETA1F/6.D0
     B1F02 = 4.D0*BETA2F/3.D0
     CF00 = BF - AF/3.D0
     CF01 = (2*DF - CF)/3.D0
     CF02 = 2*CF/3.D0

     do i = ista_r, iend_r   ! MPI
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        endif
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1+B1F01*sqrt(rs)+B1F02*RS)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*RS)*dLOG(RS) + CP00 + CP01*RS
           vcf = (AF+CF02*RS)*dLOG(RS) + CF00 + CF01*RS
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        f00    = ((1+zeta)**C43 + (1-zeta)**C43 - 2)*OVC243
        f2up   = ((1+zeta)**C13 - 1)*OVC213
        f2down = ((1-zeta)**C13 - 1)*OVC213
        t1 = vcf - vcp - C43*(wcf - wcp)
        wxp = -WX0*0.5d0/rs
        wxf = wxp * C213
        vxp = wxp * C43
        x = vxp + vcp + t1*f00
        t2 = C43 * ((WXF - WXP) + ( WCF - WCP ))
        chgrhr_l(i,UP  ) = x + t2*f2up
        chgrhr_l(i,DOWN) = x + t2*f2down

        vxc = wxp + wcp + ((wxf - wxp) + (wcf - wcp))*f00
        exc = exc + vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
        if(rho < DELTA) then
           chgrhr_l(i,1) = 0.d0
           cycle
        endif
        ovn    = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1.D0+B1P01*SQRT(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*log(rs) + DPx*rs
           vcp = (AP+CP02*rs)*log(rs) + CP00 + CP01*rs
        end if

        wxp = -WX0*0.5D0/rs
        wxf = WXP * C213
        vxp = WXP * C43
        x = vxp + vcp
        chgrhr_l(i,1  ) = x
        vxc = wxp + wcp
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_pzold

subroutine xcpotf_xalfa(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter   :: C13   =  1.d0/3.d0
  real(kind=DP), parameter   :: ALPHA = 0.7d0
  real(kind=DP)              :: CO1, CO2
  real(kind=DP)              :: rho,tmp,vxc
  integer                    :: i

  CO1   = 1.5d0*ALPHA*(3.D0/PAI)**C13
  CO2   = (0.75d0/PAI)**C13

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,UP) + chgrhr_l(i,DOWN)
!!$        rs     = CO2*( 1.0D0/rho  )**C13
        tmp    = - CO1*(rho**C13)
        chgrhr_l(i,UP)   = tmp
        chgrhr_l(i,DOWN) = tmp
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i,1)
!!$        rs     = CO2*( 1.0d0/rho  )**C13
        chgrhr_l(i,1)   = - CO1*(rho**C13)
        vxc = 0.25d0*CO1*(rho**C13)
        exc = exc+vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_xalfa

subroutine xcpotf_pz(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C23   =  2.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP), parameter :: GAMP   = -0.1423d0, GAMF   = -0.0843d0 &
       &                    , BETA1P =  1.0529d0, BETA2P =  0.3334d0 &
       &                    , BETA1F =  1.3981d0, BETA2F =  0.2611d0 &
       &                    , AP     =  0.0311d0, BP     = -0.0480d0 &
       &                    , CP     =  0.0020d0, DPx    = -0.0116d0 &
       &                    , AF     =  0.01555d0,BF     = -0.0269d0 &
       &                    , CF     =  0.00070d0,DF     = -0.0048d0

  real(kind=DP)  :: B1P01,B1P02,CP00,CP01,CP02,C243 &
       &          , B1F01,B1F02,CF00,CF01,CF02
  real(kind=DP)  :: CO2, WX0, C213
  real(kind=DP)  :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,denmp,denmf,wcp,wcf &
       &          , vcp,vcf,wc,t1,f11,t2,vc1,vc2,vxc,vxp
  integer        :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  B1P01 = 7*BETA1P/6.d0
  B1P02 = 4*BETA2P/3.d0
  CP00 = BP - AP/3.D0
  CP01 = (2*DPx - CP)/3.D0
  CP02 = 2*CP/3.D0

  if(ispin == 2 .and. input_charge == Valence_plus_PC_Charge) then
     C213 = 2.d0**C13 - 1
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**C43 - 2)

     B1F01 = 7*BETA1F/6.d0
     B1F02 = 4*BETA2F/3.d0
     CF00 = BF - AF/3.d0
     CF01 = (2*DF - CF)/3.d0
     CF02 = 2*CF/3.d0

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / c243
        wx  = wxp*(1+C213*f00)
        vx1 = c43*wxp*(1+zeta)**c13
        vx2 = c43*wxp*(1-zeta)**c13
        if(rs >= 1.d0) then
           denmp = 1.d0 + BETA1P*sqrt(rs) + BETA2P*rs
           denmf = 1.D0 + BETA1F*sqrt(rs) + BETA2F*rs
           wcp = GAMP/denmp
           wcf = GAMF/denmf
           vcp = wcp*(1.d0+B1P01*sqrt(rs)+B1P02*rs)/denmp
           vcf = wcf*(1.D0+B1F01*sqrt(rs)+B1F02*rs)/denmf
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           wcf = AF*dlog(rs) + BF + CF*rs*dlog(rs) + DF*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
           vcf = (AF+CF02*rs)*dLOG(rs) + CF00 + CF01*rs
        end if
        wc     = wcp + f00*(wcf - wcp)
        t1     = vcp + f00*(vcf - vcp)
        f11    = C23/C213*((1+zeta)**c13-(1-zeta)**c13)
        t2     = f11*(wcf-wcp)
        vc1    = t1+t2*(1-zeta)
        vc2    = t1-t2*(1+zeta)

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        vxp = C43*wxp
        if(rs >= 1.d0) then
           denmp = 1 + BETA1P*sqrt(rs) + BETA2P*rs
           wcp = GAMP/denmp
           vcp = wcp*(1+B1P01*sqrt(rs)+B1P02*rs)/denmp
        else
           wcp = AP*dlog(rs) + BP + CP*rs*dlog(rs) + DPx*rs
           vcp = (AP+CP02*rs)*dLOG(rs) + CP00 + CP01*rs
        end if
        wc     = wcp
        chgrhr_l(i,1   ) = vxp + vcp

        vxc    = wxp + wcp
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_pz

subroutine xcpotf_vwn(ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: ispin,ista_r,iend_r,input_charge
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter :: B1 = 1.13107d0,    C1 = 13.0045d0 &
       &                    , D1 = -0.0047584d0 &
       &                    , A2 =  0.0621814d0, B2 =  3.72744d0 &
       &                    , C2 = 12.9352d0   , D2 = -0.10498d0 &
       &                    , A3 =  0.0310907d0, B3 =  7.06042d0 &
       &                    , C3 = 18.0578d0,    D3 = -0.32500d0
  real(kind=DP), parameter :: C13   =  1.d0/3.d0,  C43   =  4.d0/3.d0
  real(kind=DP) :: CO2, WX0, C213

  real(kind=DP) :: F20,A1,Q1,P01,Q2,P02,Q3,P03,C243
  real(kind=DP) :: rho,ovn,zeta,f00,wx,vx1,vx2,x,p,r,h00,h10,h0p,h1p,h0f,h1f &
       &         , z4,h000,wc,vc,g00,vc0,vc1,vc2,rs,wxp,vxc
  integer       :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1

  F20   = 4/(9*C213)
  A1   = -1/(3*PAI*PAI)
  Q1   = dsqrt(4*C1-B1**2)
  P01  = D1**2 + B1*D1 + C1

  Q2   = dsqrt(4*C2-B2**2)
  P02  = D2**2 + B2*D2 + C2

  Q3   = dsqrt(4*C3-B3**2)
  P03  = D3**2 + B3*D3 + C3

  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213
!           ovc243 = 1.d0/(2.d0**c43 - 2)

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP)   = 0.d0  
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        x   = dsqrt(rs)
        p   = x**2 + B1*x + C1
        r   = datan(Q1/(2*x+B1))
        h00= (A1/F20) * ( dlog((x**2)/p)+2*B1*r/Q1 &
             &       -B1*D1*(dlog(((x-D1)**2)/p)+2*(B1+2*D1)*r/Q1)/P01 )
        h10= (A1/F20) * ( 2/x - (1-B1*D1/P01)*(2*x+B1)/p - 2*B1*D1/((x-D1)*P01) &
             &                 - 4*B1*(1-(B1+2*D1)*D1/P01)/(Q1**2+(2*x+B1)**2) )

        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= A2 * ( dlog((x**2)/p)+2*B2*r/Q2 &
             &        -B2*D2*(dlog(((x-D2)**2)/p)+2*(B2+2*D2)*r/Q2)/P02 )
        h1p= A2 * ( 2/x - (1-B2*D2/P02)*(2*x+B2)/p - 2*B2*D2/((x-D2)*P02) &
             &        -4*B2*(1-(B2+2*D2)*D2/P02)/(Q2**2+(2*x+B2)**2) )

        p   = x**2 + B3*x + C3
        r   = datan(Q3/(2*x+B3))
        h0f = A3 * ( dlog((x**2)/p)+2*B3*r/Q3 &
             &       -B3*D3*(dlog(((x-D3)**2)/p)+2*(B3+2*D3)*r/Q3)/P03 )
        h1f = A3 * ( 2/x - (1-B3*D3/P03)*(2*x+B3)/p - 2*B3*D3/((x-D3)*P03) &
             &         - 4*B3*(1-(B3+2*D3)*D3/P03)/(Q3**2+(2*x+B3)**2) )

        z4   = zeta**4
        h000 = h0f - h0p - h00
        wc=h0p+h00*f00+h000*z4*f00
        vc=wc-x*((1-z4*f00)*h1p+z4*f00*h1f+(1-z4)*f00*h10)/6
        g00 = 4*((1+zeta)**c13-(1-zeta)**c13) / (6*c213)
        vc0 = 4* h000*(zeta**3)*f00 + (h000*z4+h00)*g00
        vc1=vc+(1-zeta)*vc0
        vc2=vc-(1+zeta)*vc0

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
!!$     OVC213 = 1.d0/C213
     C243   = 2*C213

     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1  ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        wxp    = -WX0*0.5d0/rs
        f00 = 0.d0
        wx  = wxp
        vx1 = c43*wxp

        x   = dsqrt(rs)
        p   = x**2 + B2*x + C2
        r   = datan(Q2/(2*x+B2))
        h0p= a2 * ( dlog((x**2)/p)+2*b2*r/q2 &
             &       -b2*d2*(dlog(((x-d2)**2)/p)+2*(b2+2*d2)*r/q2)/p02 )
        h1p= a2 * ( 2/x - (1-b2*d2/p02)*(2*x+b2)/p - 2*b2*d2/((x-d2)*p02) &
             &           - 4*b2*(1-(b2+2*d2)*d2/p02)/(q2**2+(2*x+b2)**2) )

        wc  = h0p
        vc1 = wc-x*h1p/6

        wc  = wc*0.5d0
        vc1 = vc1*0.5d0

        chgrhr_l(i,1  ) = vx1 + vc1
        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_vwn

subroutine xcpotf_mjw_bh_gl(len_xctype,xctype,ispin,ista_r,iend_r,input_charge,DELTA,chgrhr_l,wos,exc)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters,  only : DP,UP,DOWN,PAI,Valence_plus_PC_Charge
  implicit none

  integer,intent(in)         :: len_xctype,ispin,ista_r,iend_r,input_charge
  character(len=len_xctype)  :: xctype
  real(kind=DP),intent(in)   :: DELTA
  real(kind=DP),intent(inout):: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)   :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout):: exc

  real(kind=DP), parameter ::  CP    =  0.0020d0,  CF     =  0.00070d0
  real(kind=DP), parameter ::  C13   =  1.d0/3.d0, C43   =  4.d0/3.d0

  real(kind=DP) :: CO2, WX0, C213
  real(kind=DP) :: C243, CPX, RP, CFX, RF
  real(kind=DP) :: rho,ovn,rs,zeta,wxp,f00,wx,vx1,vx2,rsp,rsf,aap,aaf &
       &         , wcp,wcf,vcp,vcf,t1,t2,f11,f12,wc,vc1,vc2,vxc
  integer       :: i

  CO2   = (0.75d0/PAI)**C13
  WX0   =  3*(((9*PAI)/4)**C13)/(2*PAI)
  C213 = 2**C13 - 1
  if(xctype ==  'mjw    ') then
! --*   moruzzi-janak-williams; Phys.Rev.12(1975)1257.  
     CPX=0.0450d0
     RP=21.0d0
  else if(xctype == 'bh     ') then                                    
! --*   von barth-hedin; J.Phys.C:Solid State Phys.5(1972)1629.  
     CPX=0.0504d0
     RP=30.0d0
  else if(xctype == 'gl     ') then                                    
! --*   gunnarsson-lundqvist; Phys.Rev.B13(1976)4274. 
     CPX=0.0666d0
     RP=11.4d0
  end if
  if(ispin ==  2 .and. input_charge == Valence_plus_PC_Charge) then
     if(xctype ==  'mjw    ') then
        CFX=cp/2
        RF=RP*(2.d0**C43)
     else if(xctype ==  'bh     ') then                                    
        CFX=0.0254d0
        RF=75.0d0
     else if(xctype ==  'gl     ') then                                    
        CFX=0.0406d0
        RF=15.9d0
     end if

     C243   = 2*C213
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, UP) + chgrhr_l(i,DOWN)
        if(rho <= DELTA) then
           chgrhr_l(i,UP  ) = 0.D0
           chgrhr_l(i,DOWN) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, UP  ) = 0.d0
           chgrhr_l(i, DOWN) = 0.d0
           cycle
        end if
        zeta   = (chgrhr_l(i,UP) - chgrhr_l(i,DOWN))*ovn
        wxp    = -WX0*0.5d0/rs
        f00 = ( (1+zeta)**C43 + (1-zeta)**C43 - 2 ) / C243
        wx  = wxp*(1+C213*f00)
        vx1 = C43*wxp*(1+zeta)**C13
        vx2 = C43*wxp*(1-zeta)**C13
        rsp = rs/RP
        rsf = rs/RF
        aap = dlog(1+1/rsp)                                      
        aaf = dlog(1+1/rsf)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        wcf = - CFX * ((1+rsf**3)*aaf - rsf**2 + rsf/2 - C13)
        vcp = - CP * aap
        vcf = - CF * aaf

        t1  = vcf - vcp - C43*(wcf-wcp) 
        t2  = C43 * (wcf-wcp)

        f11= ( (1+zeta)**C13 -1 ) / C213
        f12= ( (1-zeta)**C13 -1 ) / C213
        wc=wcp + (wcf - wcp)*f00
        vc1=vcp + t1*f00 + t2*f11
        vc2=vcp + t1*f00 + t2*f12

        wc = wc*0.5d0
        vc1 = vc1*0.5d0
        vc2 = vc2*0.5d0

        chgrhr_l(i,UP  ) = vx1 + vc1
        chgrhr_l(i,DOWN) = vx2 + vc2

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  else
     c243   = 2*C213
     do i = ista_r, iend_r
        rho    = chgrhr_l(i, 1)
        if(rho <= DELTA) then
           chgrhr_l(i,1   ) = 0.D0
           cycle
        end if
        ovn = 1.d0/rho
        rs     = CO2*ovn**C13
        if(rs <= DELTA) then
           chgrhr_l(i, 1   ) = 0.d0
           cycle
        end if
        zeta   = 0.d0
        wxp    = -WX0*0.5d0/rs
        wx  = wxp
        vx1 = c43*wxp
        vx2 = c43*wxp

        rsp = rs/RP
        aap = dlog(1+1/rsp)                                      
        wcp = - CPX * ((1+rsp**3)*aap - rsp**2 + rsp/2 - C13)
        vcp = - CP * aap

        wc=wcp * 0.5d0
        vc1=vcp * 0.5d0

        chgrhr_l(i,1   ) = vx1 + vc1

        vxc    = wx + wc
        exc = exc + vxc*rho*wos(i)
     end do
  endif
end subroutine xcpotf_mjw_bh_gl
!$$#endif
! === xclda etc. are necessary to make 3D_Parallel, too!!! by tkato ============
!!BRANCH_P_END ORG_Parallel
! ==============================================================================

!! --- ggasubs ---
!! -------------------------------------------
subroutine cpden(rh,kmesh,mesh,lfp,rad,rho,fdiff)
!      30th Oct. 1994
!             by T.Yamasaki
!
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in)                          :: kmesh,mesh,lfp
  real(kind=DP),intent(in), dimension(kmesh,2) :: rh
  real(kind=DP),intent(in), dimension(kmesh)   :: rad
  real(kind=DP),intent(out),dimension(kmesh,2) :: rho
  real(kind=DP),intent(out),dimension(kmesh)   :: fdiff

  real(kind=DP)  :: ovpi4

  ovpi4 = 1.d0/PAI4
  if(lfp == 1) then
     rho(:,1) = rh(:,1)*ovpi4/(rad(:)*rad(:))
     rho(:,2) = rh(:,2)*ovpi4/(rad(:)*rad(:))
     fdiff(:) = rho(:,1) + rho(:,2)
  else
     rho(:,1) = rh(:,1)*ovpi4/(rad(:)*rad(:))
     fdiff(:) = rho(:,1)
  end if
end subroutine cpden

! ------------------------------------------------------
subroutine gdiffs(h,rad,fdiff,kmesh,mmesh,mddiff,nddiff)
!             8th Aug. 1992
!                 by T.Yamasaki
!           revised by T.Yamasaki on 30th Oct. 1994
!
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)          :: kmesh,mmesh,mddiff,nddiff
  real(kind=DP), intent(in)    :: h, rad(kmesh)
  real(kind=DP), intent(inout) :: fdiff(kmesh,0:mddiff)

  integer       :: id,j
  real(kind=DP) :: alpha

  if(nddiff > mddiff) write(6,*) ' *** nddiff > mddiff *** '
  do id = 1, nddiff
     alpha = 1.d0/(dexp(h*id)-1.d0)
     do j = 1, mmesh - id
        fdiff(j,id) = (fdiff(j+1,id-1) - fdiff(j,id-1)) * alpha/rad(j)
     end do
  end do
end subroutine gdiffs

! ------------------------------------------------------
!             8th Aug. 1992
!                 by T.Yamasaki
subroutine gtgrad(h,rad,fdiff,kmesh,mmesh,nddiff,nddriv &
     &     ,npcntr,coeff,mddiff,grad,modeex)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer,      intent(in) :: kmesh,mmesh,nddiff,nddriv,npcntr,mddiff,modeex
  real(kind=DP),intent(in) :: h,rad(kmesh),fdiff(kmesh,nddiff)
  real(kind=DP)            :: coeff(0:mddiff,nddriv:mddiff)
  real(kind=DP),intent(out):: grad(kmesh)

  integer, parameter :: EXECUT = 2

  if(npcntr > nddiff) then
     write(6,*) ' *** npcntr should be smaller than nddiff ***'
     write(6,*) ' *** (npcntr, nddiff) = (',npcntr,',',nddiff,') ***'
     stop
  endif
  if(nddriv == 1) then
     call gcoef1(h,coeff,mddiff,nddiff)
  else if(nddriv == 2) then
     call gcoef2(h,coeff,mddiff,nddiff)
  else
     write(6,*) ' *** nddriv = ', nddriv, ' ***'
     stop ' *** nddriv should be smaller than 3 ***'
  endif
#ifdef DEBUG_WRITE
  call wdcoef(coeff,mddiff,nddiff,nddriv)
#endif
  if(modeex == EXECUT) then
     call ggrade(coeff,mddiff,nddiff,nddriv,rad,fdiff,kmesh,mmesh,npcntr,grad)
  endif
end subroutine gtgrad

#ifdef DEBUG_WRITE
! --------------------------------------------------------------
subroutine wdcoef(coeff,mddiff,nddiff,nddriv)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: mddiff,nddiff,nddriv
  real(kind=DP), intent(in) :: coeff(0:mddiff,nddriv:mddiff)

  integer :: i

  write(6,*) ' ++++ nddriv = ', nddriv, ' ++++'
  do i = nddriv, nddiff
     write(6,*) ' ++++ i(alpha) = ', i ,' ++++'
     write(6,'(10f8.4)') (coeff(j,i),j = 0, nddiff)
  end do
end subroutine wdcoef
#endif

! --------------------------------------------------------------
subroutine gcoef1(h,coeff,mddiff,nddiff)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: mddiff,nddiff
  real(kind=DP),intent(in) :: h
  real(kind=DP),intent(out):: coeff(0:mddiff,mddiff)

  integer       :: i,npd,ip,j,isum,imul,ipp
  real(kind=DP) :: x, y
  coeff(:,1) = 1.d0

#ifdef SX
!cdir skip
#endif
  do npd = 2, nddiff
#ifdef SX
!cdir skip
#endif
     do i = 0, npd-1
        ip = -i
        x = 1.d0
#ifdef SX
!cdir skip
#endif
        do j = 1, npd - 1
           if(ip == 0) ip = 1
           x = x*(1.d0 - dexp(h*ip))
           ip = ip + 1
        end do
        coeff(i,npd) = x
     end do
#ifdef SX
!cdir skip
#endif
     do i = npd, nddiff
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd
           ipp = ip
           x = 1.d0
#ifdef SX
!cdir skip
#endif
           do imul = 1, npd
              if(imul /= isum)  x = x*(1.d0 - dexp(h*ipp))
!                    x = x*(0 - ipp*h)
              ipp = ipp + 1
           end do
           y = y + x
        end do
        coeff(i, npd) = y
     end do
  end do
end subroutine gcoef1

! --------------------------------------------------------------------
subroutine gcoef2(h,coeff,mddiff,nddiff)
  use m_Const_Parameters, only : DP
  implicit none

  integer, intent(in) :: mddiff, nddiff
  real(kind=DP), intent(in)  :: h
  real(kind=DP), intent(out) :: coeff(0:mddiff,2:mddiff)

  integer       :: i, npd,isum,imul,ip,ipp,jsum
  real(kind=DP) :: x, y

  coeff(:,2) = 2.d0

#ifdef SX
!cdir skip
#endif
  do npd = 3, nddiff
#ifdef SX
!cdir skip
#endif
     do i = 0, npd-1
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd-1
           ipp = ip
           x = 1.d0
#ifdef SX
!cdir skip
#endif
           do imul = 1, npd-1
              if(ipp == 0) ipp = 1
              if(imul /= isum)   x = x*(1 - dexp(h*ipp))
!                    x = x*(0.d0 - ipp*h)
              ipp = ipp + 1
           end do
           y = y + x
        end do
        coeff(i,npd) = 2.d0*y
     end do
#ifdef SX
!cdir skip
#endif
     do i = npd, nddiff
        ip = -i
        y = 0.d0
#ifdef SX
!cdir skip
#endif
        do isum = 1, npd-1
           do jsum = isum+1, npd
              ipp = ip
              x = 1.d0
#ifdef SX
!cdir skip
#endif
              do imul = 1, npd
                 if(isum /= imul .and. jsum /= imul)  x = x*(1 - dexp(h*ipp))
!                       x = x*(0.d0 - ipp*h)
                 ipp = ipp + 1
              end do
              y = y + x
           end do
        end do
        coeff(i, npd) = 2.d0*y
     end do
  end do
end subroutine gcoef2

! --------------------------------------------------------------------
subroutine ggrade(coeff,mddiff,nddiff,nddriv,rad,fdiff,kmesh,mmesh,npcntr,grad)
  use m_Const_Parameters, only : DP
  implicit none

  integer, intent(in) :: mddiff,nddiff,nddriv,kmesh,mmesh,npcntr
  real(DP),intent(in) :: coeff(0:mddiff,nddriv:mddiff),rad(0:kmesh-1),fdiff(0:kmesh-1,mddiff)
  real(DP),intent(out):: grad(0:kmesh-1)

  integer :: j,ipcntr,idf,iddiff,id

  grad = 0.d0

  ipcntr = -1
  idf  = nddiff - (npcntr+1)*2
  do j = 0, npcntr - 1
     ipcntr = ipcntr + 1
     idf = idf + 2
     if(idf < nddriv+1) then
        iddiff = nddriv + 1
     else
        iddiff = idf
     endif
     do id = iddiff, nddriv+1, -1
        grad(j) = (grad(j) + coeff(ipcntr,id)*fdiff(j-ipcntr,id))*rad(j)
     end do
  end do

  do id = nddiff, nddriv+1, -1
     do j = npcntr, mmesh-1-nddiff+npcntr
        grad(j) = (grad(j) + coeff(npcntr,id)*fdiff(j-npcntr,id))*rad(j)
     end do
  end do

  ipcntr = npcntr
  iddiff = nddiff
  do j = mmesh-nddiff+npcntr,mmesh-1
     iddiff = iddiff - 2
     if(iddiff < nddriv+1) then
        iddiff = nddriv + 1
        ipcntr = ipcntr + 1
     else
        ipcntr = ipcntr - 1
     endif
     do id = iddiff, nddriv + 1, -1
        grad(j) = (grad(j) + coeff(ipcntr,id)*fdiff(j-ipcntr,id))*rad(j)
     end do
  end do

  ipcntr = -1
  idf = nddiff - (npcntr + 1)*2
  do j = 0, npcntr-1
     ipcntr = ipcntr + 1
     idf = idf + 2
     if(idf < nddriv+1) then
        iddiff = nddriv+1
     else
        iddiff = idf
     endif
     grad(j) = grad(j) + coeff(j,nddriv)*fdiff(j-ipcntr,nddriv)
  end do

  do j = npcntr, mmesh-nddiff+npcntr-1
     grad(j) = grad(j) + coeff(npcntr,nddriv)*fdiff(j-npcntr,nddriv)
  end do

  ipcntr = npcntr
  iddiff = nddiff
  do j = mmesh-nddiff+npcntr, mmesh-1
     iddiff = iddiff - 2
     if(iddiff < nddriv+1) then
        iddiff = nddriv + 1
        ipcntr = ipcntr + 1
     else
        ipcntr = ipcntr - 1
     endif
     grad(j) = grad(j) + coeff(ipcntr,nddriv)*fdiff(j-ipcntr,nddriv)
  end do

end subroutine ggrade

! ----------------------------------------
!       14th Aug. 1992 by T.Yamasaki
!    Revised by T.Yamasaki on 30th Oct. 1994
subroutine cnggrd1(grdnts,kmesh,mmesh)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)         :: kmesh,mmesh
  real(kind=DP),intent(inout) :: grdnts(kmesh,1)

  integer       :: i
  real(kind=DP) :: fac

  do i = 1, mmesh
     fac = 1.d0
     if(grdnts(i,1) < 0.d0) fac = -1.d0
     grdnts(i,1) = grdnts(i,1)*grdnts(i,1)
     grdnts(i,1) = dsqrt(grdnts(i,1))*fac
  end do
end subroutine cnggrd1

! -------------------------------------------
!      15TH AUG. 1992
!             BY T.YAMASAKI
!
subroutine cpval(a,mel,nel,cpmod,nmode,b)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)      :: mel,nel,cpmod,nmode
  real(kind=DP),intent(in) :: a(mel,nmode)
  real(kind=DP),intent(out):: b(mel)

  integer, parameter :: ABSLUT = 1, NORMAL = 2

  if(cpmod == NORMAL) then
     if(nmode == 1) then
        b(1:nel) = a(1:nel,1)
     else if(nmode ==  2) then
        b(1:nel) = a(1:nel,1) + a(1:nel,2)
     endif
  else if(cpmod == ABSLUT) then
     if(nmode == 1) then
        b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1))
     else if(nmode == 2) then
        b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1) + a(1:nel,2)*a(1:nel,2))
     endif
  else
     write(6,*) ' !D invalid value of (cpmod = ',cpmod,')'
  endif

end subroutine cpval

! -------------------------------------------
!      30TH Nov. 1994
!             BY T.YAMASAKI
!
subroutine cpval_abs(a,mel,nel,nmode,b)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)       :: mel, nel, nmode
  real(kind=DP), intent(in) :: a(mel,nmode)
  real(kind=DP), intent(out):: b(mel)

  if(nmode == 1) then
     b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1))
  else if(nmode == 2) then
     b(1:nel) = dsqrt(a(1:nel,1)*a(1:nel,1) + a(1:nel,2)*a(1:nel,2))
  end if
end subroutine cpval_abs

! -------------------------------------------
!      15TH AUG. 1992
!             BY T.YAMASAKI
!      1st DEC. 1994
!           Revised by T.Yamasaki 
!
subroutine getroh(rh,kmesh,mesh,rad,rho)
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in) :: kmesh,mesh
  real(DP),intent(in) :: rh(kmesh),rad(kmesh)
  real(DP),intent(out):: rho(kmesh)

  real(DP) :: ovpi4

  ovpi4 = 1.d0/PAI4
  rho(1:mesh) = rh(1:mesh)*ovpi4/(rad(1:mesh)*rad(1:mesh))
end subroutine getroh

! -------------------------------------------
!      1ST DEC. 1994
!             BY T.YAMASAKI
!
subroutine getroh2(rh,rhpc,kmesh,mesh,rad,rho)
  use m_Const_Parameters, only : DP,PAI4
  implicit none
  integer, intent(in) :: kmesh,mesh
  real(DP),intent(in) :: rh(kmesh),rhpc(kmesh),rad(kmesh)
  real(DP),intent(out):: rho(kmesh)

  real(DP) :: ovpi4

  ovpi4 = 1.d0/PAI4
  rho(1:mesh) = (rh(1:mesh)+rhpc(1:mesh))*ovpi4/(rad(1:mesh)*rad(1:mesh))
end subroutine getroh2

! ----------------------------------------
!       14TH AUG. 1992 BY T.YAMASAKI
!       1ST DEC.  1994  Revised by T.Yamasaki
!       3rd DEC.  1994  Revised by Y.Morikawa
!
subroutine cnggrd(grdnts,rad,kmesh,mesh)
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in)   :: kmesh,mesh
  real(DP),intent(in)   :: rad(kmesh)
  real(DP),intent(inout):: grdnts(kmesh,3)

  integer :: i
!!$cccc  changed by Y.M
  do  i = 1, mesh
     grdnts(i,3) = grdnts(i,2)
     grdnts(i,2) = grdnts(i,2) + 2*grdnts(i,1)/rad(i)
  end do
!!$cccc  changed by Y.M

  grdnts(1:mesh,1) = dabs(grdnts(1:mesh,1))

end subroutine cnggrd

! ----------------------------------------
!       15TH AUG. 1992 BY T.YAMASAKI
!
subroutine mkprdc(a,b,c,m,n,ndeg)
!                           @(#)b_XC_Potential.F90 1.4 02/09/27 20:39:38
  use m_Const_Parameters, only : DP
  implicit none
  integer, intent(in) :: m,n,ndeg
  real(DP),intent(in) :: a(m,ndeg),b(m,ndeg)
  real(DP),intent(out):: c(m)

  integer :: ideg,ip
  c = 0.d0

  do ideg = 1, ndeg
     do ip = 1, n
        c(ip) = c(ip) + a(ip,ideg)*b(ip,ideg)
     end do
  end do
end subroutine mkprdc

subroutine  epcor_0(nspin,DELTA,tchgr_l,f2or1,epc)
  ! Electron-positron correlation, 0-density limit
  ! Coded by Dr. Mineo Saito, 15th Nov. 2003
  use m_Const_Parameters,  only : PAI,DP
  use m_Parallelization,   only : ista_sfftph, iend_sfftph
  implicit none

 integer,intent(in)        :: nspin
 real(kind=DP),intent(in)  :: DELTA
 real(kind=DP),intent(inout)  :: tchgr_l(ista_sfftph:iend_sfftph,nspin)
 real(kind=DP),intent(in)  :: f2or1(ista_sfftph:iend_sfftph) 
 real(kind=DP),intent(out)  :: epc 
 
 real*8 rs,facw,d,alog,e_density,epc_derivative,epc_energy, HARTREE
 integer i_derive,is,i

  HARTREE = 1.d0/2.d0
  epc=0.d0
  facw = nspin
  do is = 1, nspin
   do i = ista_sfftph, iend_sfftph 
     d  = facw * tchgr_l(i, is)
     rs=1.d0/((4.d0/3.d0*PAI*d)**(1.d0/3.d0))  
     if(rs.le.0.d0) stop 'error epxc'
     i_derive=0
	 if(rs.lt.0.302d0)then
	  alog=log(rs)
	  epc_energy=-1.56d0/dsqrt(rs)+(0.051d0*alog-0.081d0)*alog+1.14d0
	  epc_derivative=1.56d0/2/rs**1.5d0+(0.051d0*alog-0.081d0)/rs+0.051d0*alog/rs
         elseif(rs.lt.0.56d0)then
	  epc_energy=-0.92305d0-0.05459d0/rs/rs
	  epc_derivative=0.05459*2/rs**3
         elseif(rs.lt.8.0)then
	  epc_energy=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
	  epc_derivative=13.15111*2/(rs+2.5d0)**3-2.8655d0/(rs+2.5d0)**2
	 else
          e_density=1.d0/(PAI*4.d0/3.d0*rs*rs*rs) 
	  epc_energy=-179856.2768*e_density*e_density+186.4207*e_density-0.524d0
	  epc_derivative=-179856.2768*3*e_density**2+186.4207d0*2*e_density-0.524d0
	  i_derive=1
	endif 
!       tchgr_l(i,is)=(epc_energy-rs/3.d0*epc_derivative)*HARTREE
       tchgr_l(i,is)=epc_energy*HARTREE
!	    if(i_derive.eq.1) tchgr_l(i,is)=epc_derivative*HARTREE
!		epc=epc+tchgr_l(i,is)*f2or1(i)*HARTREE
		epc=epc+tchgr_l(i,is)*f2or1(i)
    enddo
  enddo
end subroutine epcor_0  
subroutine  epcor_00(DELTA,tchgr_l,nnmesh)
  ! Electron-positron correlation, 0-density limit
  ! Coded by Dr. Mineo Saito, 15th Nov. 2003
  use m_Const_Parameters,  only : PAI,DP
  implicit none

real(kind=DP),intent(in)  :: DELTA
 real(kind=DP),intent(inout)  :: tchgr_l(nnmesh)
 
real(kind=DP)  :: epc 
real*8 rs,d,alog,e_density,epc_derivative,epc_energy,HARTREE
 integer i_derive,i,nnmesh
 
HARTREE=1.d0/2.d0
  epc=0.d0
  do i = 1, nnmesh 
     d  = tchgr_l(i)
     rs=1.d0/((4.d0/3.d0*PAI*d)**(1.d0/3.d0))  
     if(rs.le.0.d0) stop 'error epxc'
     i_derive=0
	 if(rs.lt.0.302d0)then
	  alog=log(rs)
	  epc_energy=-1.56d0/dsqrt(rs)+(0.051d0*alog-0.081d0)*alog+1.14d0
	  epc_derivative=1.56d0/2/rs**1.5d0+(0.051d0*alog-0.081d0)/rs+0.051d0*alog/rs
         elseif(rs.lt.0.56d0)then
	  epc_energy=-0.92305d0-0.05459d0/rs/rs
	  epc_derivative=0.05459*2/rs**3
         elseif(rs.lt.8.0)then
	  epc_energy=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
	  epc_derivative=13.15111*2/(rs+2.5d0)**3-2.8655d0/(rs+2.5d0)**2
	 else
          e_density=1.d0/(PAI*4.d0/3.d0*rs*rs*rs) 
	  epc_energy=-179856.2768*e_density*e_density+186.4207*e_density-0.524d0
	  epc_derivative=-179856.2768*3*e_density**2+186.4207d0*2*e_density-0.524d0
	  i_derive=1
	endif 
!       tchgr_l(i)=(epc_energy-rs/3.d0*epc_derivative)*HARTREE
       tchgr_l(i)=epc_energy*HARTREE
!	    if(i_derive.eq.1) tchgr_l(i)=epc_derivative*HARTREE
!		epc=epc+tchgr_l(i)*HARTREE
		epc=epc+tchgr_l(i)
    enddo
 end subroutine epcor_00 
subroutine enhance_0(e_density,enhance)
  use m_Const_Parameters,  only : PAI,DP
  real*8 rs,e_density,DEL,enhance
  DEL=1.d-8
  if(e_density.gt.DEL)then
     rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))  
     enhance=1.d0+1.23d0*rs+0.9889d0*rs**1.5d0 &
          -1.4820d0*rs**2+0.3956d0*rs**2.5d0+rs**3/6.d0
  else
     enhance=0.d0
  endif
end subroutine enhance_0

subroutine enhance_01(e_density,enhance,epsilon_ele)
 use m_Const_Parameters,  only : PAI,DP
 real*8 rs,e_density,DEL,enhance,epsilon_ele
 DEL=1.d-8
!  epsilon=6.34466667d0
 if(e_density.gt.DEL)then
    rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))
!!$    enhance=1.d0+1.23d0*rs+0.8295d0*rs**1.5d0 &
!!$         -1.26d0*rs**2+0.3286d0*rs**2.5d0+(rs**3)/6.d0*(1.d0-1.d0/epsilon_ele)
    enhance=1.d0+1.23d0*rs+0.9889d0*rs**1.5d0 &
         -1.4820d0*rs**2+0.3956d0*rs**2.5d0+(rs**3)/6.d0*(1.d0-1.d0/epsilon_ele)
 else
    enhance=0.d0
 endif
end subroutine enhance_01

subroutine enhance_gga_0(e_density,gradient,enhance)
  use m_Const_Parameters,  only : PAI,DP
  real*8 rs,e_density,DEL,enhance,gradient,fermi_momentum,Thomas_length,enhance_lda,e_param
  DEL=1.d-8
  if(e_density.gt.DEL)then
     rs=1.d0/((4.d0/3.d0*PAI*e_density)**(1.d0/3.d0))  
     enhance_lda=1.d0+1.23d0*rs-0.0742d0*rs**2.d0+rs**3.d0/6.d0
	 fermi_momentum=1.92d0/rs
	 Thomas_length=(4.d0/PAI*fermi_momentum)**(0.5d0)
	 e_param=(gradient/(e_density*Thomas_length))**2.d0
	 enhance=1.d0+(enhance_lda-1.d0)*exp(-0.22d0*e_param)
  else
     enhance=0.d0
  endif
end subroutine enhance_gga_0

subroutine epcor_finite(nspin,DELTA,etchgr_l,ptchgr_l,f2or1,epc)
    use m_Const_Parameters,  only : PAI,DP
    use m_Parallelization,   only : ista_sfftph, iend_sfftph
	implicit none

    integer,intent(in)        :: nspin
    real(kind=DP),intent(in)  :: DELTA
    real(kind=DP),intent(inout)  :: etchgr_l(ista_sfftph:iend_sfftph,nspin)
    real(kind=DP),intent(inout)  :: ptchgr_l(ista_sfftph:iend_sfftph,nspin)
    real(kind=DP),intent(in)  :: f2or1(ista_sfftph:iend_sfftph) 
    real(kind=DP),intent(out)  :: epc
    real*8 facw
    integer is,i
	
	real*8 rs_e,rs_p,epcor_inverse,epcor,ed,pd
	real*8 a_rs,b_rs,c_rs,e_energy_ap,p_energy_ap,p_ap_derivative
	real*8 e_ap_derivative,epc_ne_derivative,epc_np_derivative
	real*8 a_derivative,b_derivative,c_derivative
	epc=0.d0
	facw=nspin
	do is=1,nspin
        do i = ista_sfftph, iend_sfftph 
			ed=facw*etchgr_l(i,is)
			pd=facw*ptchgr_l(i,is)
			rs_e=1.d0/((4.d0/3.d0*PAI*ed)**(1.d0/3.d0))
			rs_p=1.d0/((4.d0/3.d0*PAI*pd)**(1.d0/3.d0))
			if(rs_e.le.0.d0) stop 'error epxc'
			call epcor_abc(rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative)
			call cal_energy_ap(rs_e,e_energy_ap,e_ap_derivative)
			call cal_energy_ap(rs_p,p_energy_ap,p_ap_derivative)
			epcor_inverse=a_rs+b_rs*rs_p+c_rs*rs_p**2.d0+(4.d0*PAI/3.d0)*(rs_p**3.d0) &
								/e_energy_ap+(4.d0*PAI/3.d0)*(rs_e**3.d0)/p_energy_ap
			epcor=1.d0/epcor_inverse
			epc_ne_derivative=-(a_derivative+b_derivative*rs_p+c_derivative*rs_p**2.d0 &
								-4.d0*PAI/3.d0*e_ap_derivative*rs_p*rs_p*rs_p/(e_energy_ap &
								*e_energy_ap)+(4.d0*PAI*rs_e*rs_e/p_energy_ap)* &
								(-4.d0*PAI/9.d0*rs_e**4.d0))*(epcor*epcor)
			epc_np_derivative=-((b_rs+2.d0*c_rs*rs_p+4.d0*PAI*rs_p*rs_p/e_energy_ap)* &
								(-4.d0*PAI/9.d0*rs_p**4.d0)-4.d0*PAI/3.d0*p_ap_derivative* &
								rs_e*rs_e*rs_e/(p_energy_ap*p_energy_ap))*(epcor*epcor)
			etchgr_l(i,is)=epc_ne_derivative
			ptchgr_l(i,is)=epc_np_derivative
			epc=epc+epcor*f2or1(i)
		end do
	end do
      end subroutine epcor_finite

subroutine cal_energy_ap(rs,energy_ap,ap_derivative)
    use m_Const_Parameters,  only : PAI
	implicit none
	real*8 rs,log,density,energy_ap,ap_derivative
	integer i_derive
	i_derive=0
	if(rs.lt.0.302d0)then
		log=dlog(rs)
		energy_ap=-1.56d0/dsqrt(rs)+(0.051d0*log-0.081d0)*log+1.14d0
		ap_derivative=1.56d0/2.d0/rs**1.5d0+(0.051d0*log-0.081d0)/rs &
						+0.051d0*log/rs
	elseif(rs.lt.0.56d0)then
		energy_ap=-0.92305d0-0.05459d0/rs/rs
		ap_derivative=0.05459*2.d0/rs**3.d0
	elseif(rs.lt.8.0)then
		energy_ap=-13.15111d0/(rs+2.5d0)**2+2.8655d0/(rs+2.5)-0.6298d0
		ap_derivative=13.15111*2.d0/(rs+2.5d0)**3.d0-2.8655d0/(rs+2.5d0)**2.d0
	else
		density=3.d0/(4.d0*PAI*rs**3.d0)
		energy_ap=-179856.2768*density*density+186.4207*density-0.524d0
		ap_derivative=-179856.2768*2.d0*density+186.4207d0
		i_derive=1
	end if
	if(i_derive.eq.0)   ap_derivative=ap_derivative*(-4.d0*PAI/9.d0*rs**4.d0)
end subroutine cal_energy_ap

subroutine epcor_abc(rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative)
    use m_Const_Parameters,  only : PAI
	implicit none
	real*8 rs_e,a_rs,b_rs,c_rs,a_derivative,b_derivative,c_derivative
	a_rs=69.7029d0-107.4927d0*rs_e+23.7182d0*rs_e**2.d0
	a_derivative=(-107.4927d0+23.7182d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
	b_rs=-107.4927d0+141.8458d0*rs_e-33.6472d0*rs_e**2.d0
	b_derivative=(141.8458d0-33.6472d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
	c_rs=23.7182d0-33.6472d0*rs_e+5.21152d0*rs_e**2.d0
	c_derivative=(-33.6472d0+5.21152d0*2.d0*rs_e)*(-4.d0*PAI/9.d0*rs_e**4.d0)
end subroutine epcor_abc


! ========= KT_add === 13.0A
! ==================================== KT_add ========================== 13.0A
subroutine ex_gga_library( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_rho, &
     &                     wos, exc, dFx_drho, dFx_dgradrho, pot_type )
  use m_Const_Parameters,  only : DP,PAI
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(in)  :: grad_rho(ista_r:iend_r,nspin)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)
  real(kind=DP),intent(out) :: exc
  real(kind=DP),intent(out) :: dFx_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out) :: dFx_dgradrho(ista_r:iend_r,nspin)
  integer, intent(in) :: pot_type

!!  real(kind=DP), parameter :: ax = -0.7385588d0
  real(kind=DP), parameter :: ax = -0.7385587663820224d0 !! ax = -(3/4)*(3/PI)^(1/3)
  real(kind=DP), parameter :: thrd = 0.33333333333d0, thrd4 = 1.333333333333333d0
  real(kind=DP), parameter :: thpith = 3.0936677262801d0

! ----- parameters of enhanced factor --
  real(kind=DP), parameter :: mu_gel    = 0.1234567901234568d0   !  = 10.0 /81.0

  real(kind=DP), parameter :: mu_pbe    = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_revpbe = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_rpbe   = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_wc     = 0.2195149727645171d0
  real(kind=DP), parameter :: mu_pbesol = 0.1234567901234568d0   !  = 10.0 /81.

  real(kind=DP), parameter :: mu_b86r   = 0.1234567901234568d0   !  = 10.0 /81.
  real(kind=DP), parameter :: mu_optpbe = 0.175519d0
  real(kind=DP), parameter :: mu_optb86b = 0.1234567901234568d0   !  = 10.0 /81.0
  real(kind=DP), parameter :: mu_c09    = 0.0617d0
  real(kind=DP), parameter :: mu_lvpw86r = 0.094344444444444444d0  ! = 0.8491 /9.0

  real(kind=DP), parameter :: kappa_pbe    = 0.804d0
  real(kind=DP), parameter :: kappa_revpbe = 1.245d0          ! by Koga-san
  real(kind=DP), parameter :: kappa_rpbe   = 0.804d0
  real(kind=DP), parameter :: kappa_wc     = 0.804d0
  real(kind=DP), parameter :: kappa_pbesol = 0.804d0
  real(kind=DP), parameter :: kappa_pbeint = 0.804d0

  real(kind=DP), parameter :: kappa_b86r   = 0.7114d0
  real(kind=DP), parameter :: kappa_optpbe = 1.04804d0
  real(kind=DP), parameter :: kappa_optb86b = 1.0d0
  real(kind=DP), parameter :: kappa_c09    = 1.245d0

! ---- others
  real(kind=DP), parameter :: coeff_WC = 0.0079325D0      ! ---- Wu and Cohen (2006)
  real(kind=DP), parameter :: alpha_c09 = 0.0483d0

  real(kind=DP), parameter :: s_low_htbs = 0.6d0, s_high_htbs = 2.6d0
!
  real(kind=DP), parameter :: a_pw86r = 0.1234567901234568d0   !  = 10.0 /81.0
  real(kind=DP), parameter :: b_pw86r = 17.33d0
  real(kind=DP), parameter :: c_pw86r = 0.163d0

  real(kind=DP), parameter :: alpha_lvpw86r = 0.02178d0
  real(kind=DP), parameter :: beta_lvpw86r = 1.15d0

  real(kind=DP), parameter :: a1_ev93 = 1.647127D0
  real(kind=DP), parameter :: a2_ev93 = 0.980118D0
  real(kind=DP), parameter :: a3_ev93 = 0.017399D0
  real(kind=DP), parameter :: b1_ev93 = 1.523671D0
  real(kind=DP), parameter :: b2_ev93 = 0.367229D0
  real(kind=DP), parameter :: b3_ev93 = 0.011282D0

  real(kind=DP), parameter :: beta_lb94 = 0.05d0
! ----------------
  integer       :: is, i, pot_mode

  real(kind=DP) :: facw, d, dd, fk, s, fac, s2, mu_s2, f, ex, df_ds, &
       &           exd, exdd, exc0, excd, excdd, exc1, pot_add
  real(kind=DP) :: ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, x, dx_ds, s4, s6, df_dx
  real(kind=DP) :: y, dy_ds
  real(kind=DP) :: alpha_pbeint, mu_this, dmu_ds
!
  logical :: First = .true.
  real(kind=DP), save :: coeff_spline_htbs(0:5)

  if ( pot_type == 5 ) then
     if ( First ) then
        call init_spline_htbs( mu_wc, kappa_rpbe, kappa_wc, coeff_wc, &
             &                 s_low_htbs, s_high_htbs, coeff_spline_htbs )
        First = .false.
     endif
  endif

!---- Spin dependency

  facw = ispin
  exc  = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  do is = 1, ispin
     exc1 = 0.d0
#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
     do i = ista_r, iend_r
        d  = facw * chgrhr_l(i, is)
        dd = facw * grad_rho(i, is)
        fk = (3.d0*PAI*PAI*d)**thrd
!!$        sk = dsqrt(4*fk/PAI)
        if(d > 1.d-05) then
           s = dd/(d*fk*2.d0)
        else
           s = 0.d0
        endif
!-------------------------------------
        fac = ax*d**thrd
        s2  = s*s
!
        pot_mode = pot_type
        if ( pot_type == 5 ) then
           if ( s <= s_low_htbs ) then
              pot_mode = 4
           else if ( s >= s_high_htbs ) then
              pot_mode = 3
           endif
        endif
!
        select case ( pot_mode )
        case (1)                        ! pbe
           x = mu_pbe *s2;   dx_ds = 2.0d0 *mu_pbe *s
           ctmp1 = kappa_pbe + x

           f = 1.0d0 +kappa_pbe *x /ctmp1
           df_dx = kappa_pbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (2)                        ! revpbe
           x = mu_revpbe *s2;   dx_ds = 2.0d0 *mu_revpbe *s
           ctmp1 = kappa_revpbe + x

           f = 1.0d0 +kappa_revpbe *x /ctmp1
           df_dx = kappa_revpbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (3)                        ! rpbe
           x = mu_rpbe *s2;   dx_ds = 2.0d0 *mu_rpbe *s
           ctmp1 = exp( -x/ kappa_rpbe )

           f = 1.0d0 +kappa_rpbe -kappa_rpbe *ctmp1
           df_dx = ctmp1
           df_ds = dx_ds *df_dx

        case (4)                        ! W. Cohen
           s4 = s2 *s2
           ctmp1 = exp( -s2 )
           ctmp2 = coeff_WC *s4

           x = mu_gel *s2 + ( mu_wc -mu_gel )*s2 *ctmp1 + log( 1.0d0 +ctmp2 )
           dx_ds = 2.0d0 *mu_gel *s + ( mu_wc -mu_gel ) *2.0d0 *s *ctmp1 *( 1.0d0 -s2 ) &
                &  +4.0d0 *coeff_WC *s2 *s /( 1.0d0 +ctmp2 )

           ctmp3 = kappa_wc +x

           f = 1.0d0 +kappa_wc *x / ctmp3
           df_dx = kappa_wc**2 /ctmp3**2           
           df_ds = dx_ds *df_dx

        case (5)
           ctmp1 = ( s -s_low_htbs )/( s_high_htbs -s_low_htbs )
           ctmp2 = ctmp1 *ctmp1
           ctmp3 = ctmp1 *ctmp2
           ctmp4 = ctmp1 *ctmp3
           ctmp5 = ctmp1 *ctmp4
           f = coeff_spline_htbs(0) +coeff_spline_htbs(1) *ctmp1 &
                &                   +coeff_spline_htbs(2) *ctmp2 &
                &                   +coeff_spline_htbs(3) *ctmp3 &
                &                   +coeff_spline_htbs(4) *ctmp4 &
                &                   +coeff_spline_htbs(5) *ctmp5
!
           df_ds = coeff_spline_htbs(1) + 2.0d0 *coeff_spline_htbs(2) *ctmp1 &
                &                       + 3.0d0 *coeff_spline_htbs(3) *ctmp2 &
                &                       + 4.0d0 *coeff_spline_htbs(4) *ctmp3 &
                &                       + 5.0d0 *coeff_spline_htbs(5) *ctmp4
           df_ds = df_ds / (s_high_htbs -s_low_htbs )

        case (6)                       ! pbesol
           x = mu_pbesol *s2;   dx_ds = 2.0d0 *mu_pbesol *s
           ctmp1 = kappa_pbesol + x

           f = 1.0d0 +kappa_pbesol *x /ctmp1
           df_dx = kappa_pbesol**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (7)                       ! pbeint
           ctmp1 = mu_pbe - mu_gel

           alpha_pbeint = mu_gel**2 /kappa_pbeint /ctmp1
           ctmp2 = alpha_pbeint *s2
           ctmp3 = 1.0d0 +ctmp2

           mu_this = mu_gel +ctmp1 *ctmp2 /ctmp3
           dmu_ds = ctmp1 *alpha_pbeint *s  /ctmp3**2

           x = mu_this *s2;   dx_ds = 2.0d0 *mu_this *s + dmu_ds *s2

           ctmp4 = kappa_pbeint + x

           f = 1.0d0 +kappa_pbeint *x /ctmp4
           df_dx = kappa_pbeint**2 /ctmp4**2
           df_ds = dx_ds *df_dx

        case (11)                      ! B86r  I. Hamada
           x = mu_b86r *s2;   dx_ds = 2.0d0 *mu_b86r *s

           ctmp1 = 1.0d0 + x /kappa_b86r
           ctmp2 = ctmp1**(-4.0d0/5.0d0)
           ctmp3 = -0.8d0 *ctmp2 /ctmp1

           f = 1.0d0 + x *ctmp2
           df_dx = ctmp2 +ctmp3 *x /kappa_b86r
           df_ds = dx_ds *df_dx

        case (12)                      ! optpbe
           x = mu_optpbe *s2;   dx_ds = 2.0d0 *mu_optpbe *s
           ctmp1 = kappa_optpbe + x

           f = 1.0d0 +kappa_optpbe *x /ctmp1
           df_dx = kappa_optpbe**2 /ctmp1**2
           df_ds = dx_ds *df_dx

        case (13)                      ! optb86b
           x = mu_optb86b *s2;   dx_ds = 2.0d0 *mu_optb86b *s
           ctmp1 = 1.0d0 + x /kappa_optb86b
           ctmp2 = ctmp1**(-4.0d0/5.0d0)
           ctmp3 = -0.8d0 *ctmp2 /ctmp1

           f = 1.0d0 + x *ctmp2
           df_dx = ctmp2 +ctmp3 *x /kappa_optb86b
           df_ds = dx_ds *df_dx

        case (14)                      ! pw86r
           s4 = s2 *s2
           ctmp1 = a_pw86r
           ctmp2 = b_pw86r *s2
           ctmp3 = c_pw86r *s4

           ctmp4 = 1.0d0 +( 15.0d0 *ctmp1 +ctmp2 +ctmp3 ) *s2
           ctmp5 = 30.0d0 *ctmp1 +4.0d0 *ctmp2  +6.0d0 *ctmp3

           f = ctmp4 ** (1.0d0/15.0d0)
           df_ds = 1.0d0 /15.0d0 *f /ctmp4 * ctmp5 *s

        case (15)                      ! c09x
           x = mu_c09 *s2;  dx_ds = 2.0d0 *mu_c09 *s
           ctmp1 = alpha_c09 /mu_c09

           ctmp2 = exp( -ctmp1 *x )
           ctmp3 = exp( -ctmp1 *x /2.0d0 )

           ctmp4 = -ctmp1 *ctmp2
           ctmp5 = -ctmp1 *ctmp3 /2.0d0

           f = 1.0d0 + x *ctmp2 + kappa_c09 *( 1.0d0 -ctmp3 )
           df_dx = ctmp2 +x*ctmp4 -kappa_c09* ctmp5
           df_ds = dx_ds *df_dx

        case (16)                      ! lv-pw86r
           s4 = s2 *s2;  s6 = s4 *s2
           ctmp1 = 1.0d0 +15.d0 *a_pw86r *s2 +b_pw86r *s4 + c_pw86r *s6
           ctmp2 = ctmp1**(1.0d0/15.0d0)

           ctmp3 = 1.0d0/15.d0 /ctmp1 *ctmp2 *s &
                &  *( 30.0d0 *a_pw86r +4.0d0 *b_pw86r *s2 + 6.0d0 *c_pw86r *s4 )

           ctmp4 = 1.0d0 +alpha_lvpw86r *s6
           ctmp5 = beta_lvpw86r + alpha_lvpw86r *s6
           ctmp6 = 1.0d0 +mu_lvpw86r *s2

           f = ctmp6 /ctmp4 +alpha_lvpw86r *s6 /ctmp5 *ctmp2
           df_ds = s /ctmp4**2 *( -6.0d0 *alpha_lvpw86r *s4 *ctmp6 &
                &                 +2.0d0 *mu_lvpw86r *ctmp4 ) &
                &  +6.0d0 *alpha_lvpw86r *beta_lvpw86r *s4 *s /ctmp5**2 *ctmp2 &
                &  +alpha_lvpw86r *s6 /ctmp5 *ctmp3

        case (20)                    ! Engel Vosko (EV93)
           s4 = s2 *s2;  s6 = s4 *s2

           x = 1.0D0 +a1_ev93 *s2 +a2_ev93 *s4 +a3_ev93 *s6
           y = 1.0D0 +b1_ev93 *s2 +b2_ev93 *s4 +b3_ev93 *s6
           dx_ds = s *( 2.0D0 *a1_ev93 +4.0D0 *a2_ev93 *s2 +6.0D0 *a3_ev93 *s4 )
           dy_ds = s *( 2.0D0 *b1_ev93 +4.0D0 *b2_ev93 *s2 +6.0D0 *b3_ev93 *s4 )

           ctmp1 = y*dx_ds -x*dy_ds

           f = x /y
           df_ds = ctmp1 /y**2

        case (25)                     ! Leeuwen Baerends (LB94)
           f = 1.0d0;       df_ds = 0.0d0
           ctmp1 = d **(1./3.)
           if (d > 1.d-05) then
              x = dd /d /ctmp1
           else
              x = 0.d0
           endif
           ctmp2 = beta_lb94 *x**2 *ctmp1
           ctmp3 = 1.0d0 +3.d0 *beta_lb94 *x *asinh(x)
           pot_add = -ctmp2 /ctmp3

        case default
           stop "xc functinal not supported "
        end select

        ex  = fac *f *d
        exd = thrd4 *fac* ( f -s *df_ds )
        exdd = ax *df_ds *0.5d0 /thpith
!------------------------------------------
        exc0 = ex / facw
        excd = exd
        dFx_drho(i, is) = excd
        if ( pot_type == 25 ) dFx_drho(i,is) = dFx_drho(i,is) +pot_add

        excdd = exdd
! gradient of charge density 95/12/3 H.S.
        if(dabs(grad_rho(i, is)) > 1.d-9) then
           dFx_dgradrho(i, is) = excdd / grad_rho(i, is)
        else
           dFx_dgradrho(i, is) = 0.d0
        endif
! gradient of charge density 95/12/3 H.S.
        exc1 = exc1 + exc0*wos(i)
     end do
     exc = exc + exc1
  end do

end subroutine ex_gga_library

subroutine cr_gga_library( nspin, ispin, ista_r, iend_r, chgrhr_l, grad_trho, wos, &
     &                     exc, dF_drho, ecor, pot_type )
  use m_Const_Parameters,  only : PAI,DP
  implicit none

  integer,intent(in)        :: nspin,ispin,ista_r,iend_r, pot_type
  real(kind=DP),intent(in)  :: chgrhr_l(ista_r:iend_r,ispin)
  real(kind=DP),intent(inout) :: grad_trho(ista_r:iend_r)
  real(kind=DP),intent(in)  :: wos(ista_r:iend_r)  
  real(kind=DP),intent(inout) :: exc
  real(kind=DP),intent(inout) :: dF_drho(ista_r:iend_r,nspin)
  real(kind=DP),intent(out),optional :: ecor

  real(kind=DP), parameter :: zeta_minimum    = 1.d-4
  real(kind=DP), parameter :: zeta_minimum2   = 1.d-6
  real(kind=DP), parameter :: density_minimum = 1.d-20
  real(kind=DP), parameter :: density_minimum2= 1.d-5

  real(kind=DP), parameter  :: a  = 0.0310907d0,    a1   = 0.21370d0
  real(kind=DP), parameter  :: b1 = 7.5957d0,       b2n  = 3.5876d0
  real(kind=DP), parameter  :: b3 = 1.6382d0,       b4   = 0.49294d0
  real(kind=DP), parameter  :: p  = 1.00d0,         p1   = p+1.d0

  real(kind=DP), parameter  :: ap  = 0.01554535d0,    a1p  = 0.20548d0
  real(kind=DP), parameter  :: b1p = 14.1189d0,     b2np = 6.1977d0
  real(kind=DP), parameter  :: b3p = 3.3662d0,      b4p  = 0.62517d0

  real(kind=DP), parameter  :: aq  = 0.0168869d0,    a1q  = 0.11125d0
  real(kind=DP), parameter  :: b1q = 10.3570d0,     b2nq = 3.6231d0
  real(kind=DP), parameter  :: b3q = 0.88026d0,     b4q  = 0.49671d0

  real(kind=DP), parameter  :: gamma = 0.03109069086965489503494086371273d0
!--------------------------

  real(kind=DP), parameter  :: thrd = 0.333333333333d0, sixth7 = 1.1666666666666666d0

  real(kind=DP), parameter  :: eta = 1.d-12
  real(kind=DP), parameter  :: sixthm = -0.16666666666666d0

! ----- parameters 
  real(kind=DP), parameter :: beta_pbe   = 0.06672455060314922d0
  real(kind=DP), parameter :: beta_pbesol = 0.046d0
  real(kind=DP), parameter :: beta_pbeint = 0.052d0

  integer       :: is,i
  real(kind=DP) :: facw,exc1,g,g3,facpon,d,dd,rs,fk,sk,t,q0 &
       &         , rs12,rs32,rsp,q1,q2,eu,q3,eurs,ecd,pon &
       &         , b,b2,t2,t4,t6,q4,q5,h0,h,q8,h0t,h0b,h0rs,ht,hrs &
       &         , ec1,ec1d,ec1dd,exc0,excd,excdd &
       &         , thrd2,thrd4,fzdd,zeta,onpzeta,onmzeta,fz,zetadxd &
       &         , q0p,q1p,q2p,q3p,q0q,q1q,q2q,q3q,fzd,onzt4,gzt,bzt,h0zt,euzt
  real(kind=DP) :: bet, delt

! ------
  select case ( pot_type )
  case (6)                           ! pbesol
     bet = beta_pbesol
  case (7)                           ! pbeint
     bet = beta_pbeint
  case default
     bet = beta_pbe
  end select

  delt = bet /gamma
! ------


  facw = ispin

!---- Spin dependency
#ifdef NEC_TUNE_MXCP
!CDIR NOCONCUR
#endif
  if(present(ecor)) ecor = 0.d0
  do is = 1, ispin
     exc1 = 0.d0
     if ( ispin == 1 ) then
        g   = 1.d0
        g3  = g**3
!!$        g4  = g3*g
        facpon = -delt/(g3*bet)

#ifdef NEC_TUNE_MXCP
!CDIR INNER
#endif
        do i = ista_r,iend_r ! MPI
           d  = facw*chgrhr_l(i, 1)
           if(d < density_minimum) cycle
! gradient of charge density 95/12/3 H.S.
           dd = facw* grad_trho(i)

           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)
           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0)
           else
              t = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0 + a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 + 1.d0/q1)
           eu = q0*q2
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)
           eurs = -2.d0 *a*a1*q2 - q0*q3/(q1**2 + q1)
           ecd = eu-thrd*rs*eurs
           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t

           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 + b*t2
           q5  = 1.d0 + b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1d0+delt*q4*t2/q5)
           h   = h0
           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*( 1.d0 +2d0 *b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0 *b+b2*t2)/q8 * g3
           h0rs = h0b*b*eurs*(b+delt)/ bet / g3
           ht   = h0t
           hrs  = h0rs
           ec1  = d*h/facw
           ec1d = h-thrd*rs*hrs-sixth7*t*ht

           ec1dd = 0.5d0*ht/sk

           exc0 = eu*d/facw + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(dabs(grad_trho(i)) > 1.0d-9) then
              grad_trho(i) = excdd / grad_trho(i)
           else
              grad_trho(i) = 0.d0
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d/facw
           exc1 = exc1 + exc0*wos(i)
        end do

     else if ( ispin ==  2 ) then
        thrd2 = thrd * 2.d0
        thrd4 = thrd * 4.d0
        fzdd = 8.d0 /(9.d0*(2.d0**thrd4 - 2.d0 ))

        do i = ista_r,iend_r
           d = chgrhr_l(i, 1) + chgrhr_l(i, ispin)
           if(d < density_minimum ) cycle
           zeta = ( chgrhr_l(i, 1) - chgrhr_l(i, 2) ) / d
           onpzeta = 2.d0 *chgrhr_l(i, 1) / d
           onmzeta = 2.d0 *chgrhr_l(i, 2) / d
           g = ( onpzeta**thrd2 + onmzeta**thrd2 )/2.d0
           if(dabs(zeta) < zeta_minimum ) then
              fz= 4.d0/9.d0 *zeta*zeta*(1.d0 + 5.d0/54.d0 *zeta*zeta &
                   &               *(1.d0 +44.d0/135.d0*zeta*zeta )) &
                   &       /(2.d0**thrd4 -2.d0)
           else
              fz = (onpzeta**thrd4 + onmzeta**thrd4 -2.d0) / (2.d0**thrd4 - 2.d0)
           end if
           g3  = g**3
!!$           g4  = g3*g
           facpon = -delt/(g3*bet)
           if(d < density_minimum) cycle
           dd = grad_trho(i)
           rs = (0.75d0/(PAI*d))**thrd
           fk = (3.d0*PAI*PAI*d)**thrd
           sk = dsqrt(4.d0*fk/PAI)

           if(d > density_minimum2) then
              t = dd/(d*sk*2.d0*g)
           else
              t = 0.d0
           endif

           q0 = -2.d0 *a*(1.d0+a1*rs)
           rs12 = dsqrt(rs)
           rs32 = rs12**3
           rsp = rs**p
           q1 = 2.d0 *a*(b1*rs12+b2n*rs+b3*rs32+b4*rs*rsp)
           q2 = log( 1.d0 +1.d0/q1 )
           q3 = a*(b1/rs12 +2.d0*b2n +3.d0*b3*rs12 +2.d0*b4*p1*rsp)

           q0p = -2.d0 *ap*(1.d0+a1p*rs)
           q1p = 2.d0*ap*(b1p*rs12+b2np*rs+b3p*rs32+b4p*rs*rsp)
           q2p = log(1.d0 +1.d0/q1p)
           q3p = ap*(b1p/rs12 +2.d0*b2np +3.d0*b3p*rs12 +2.d0*b4p*p1*rsp)
! vwn 95/12/2 Y.M
           q0q = -2.d0*aq*(1.d0+a1q*rs)
           q1q =  2.d0*aq*(b1q*rs12+b2nq*rs+b3q*rs32+b4q*rs*rsp)
           q2q = log(1.d0 +1.d0/q1q)
           q3q = aq*(b1q/rs12 +2.d0*b2nq +3.d0*b3q*rs12 +2.d0*b4q*p1*rsp)
           if(dabs(zeta) < zeta_minimum) then
              fzd = 8.d0/9.d0 /( 2.d0**thrd4 -2.d0 ) &
                   &     *zeta *( 1.d0 + 5.d0/27.d0 *zeta*zeta &
                   &           *( 1.d0 +22.d0/45.d0 *zeta*zeta ))
           else
              fzd = 4.d0/3.d0 /( 2.d0**thrd4 -2.d0) &
                   &     *( onpzeta**thrd -onmzeta**thrd )
           end if
           onzt4= onmzeta*onpzeta *( 1.d0 + zeta*zeta )
           eu = q0*q2 + ( q0p * q2p - q0 * q2 ) * fz * zeta**4 &
                &             -   q0q * q2q * fz / fzdd * onzt4
           eurs = ( -2.d0*a*a1*q2 -q0*q3/(q1**2 +q1 )) * ( 1.d0 -fz*zeta**4 )&
                &+( -2.d0*ap*a1p*q2p -q0p*q3p/( q1p**2 +q1p )) *fz*zeta**4 &
                &-( -2.d0*aq*a1q*q2q -q0q*q3q/( q1q**2 +q1q )) *fz/fzdd*onzt4
           euzt =  -q0q*q2q /fzdd *( fzd*onzt4 -4.d0*fz*zeta**3 )&
                &        +( q0p*q2p -q0*q2 )*(fzd*zeta +4.d0*fz )*zeta**3 
! vwn 95/12/2 Y.M

           zetadxd = - 2.d0 * chgrhr_l(i, 3-is) * (-1.d0)**is / d
           ecd = eu-thrd*rs*eurs + euzt * zetadxd 

           pon = facpon*eu
           b   = delt/(dexp(pon)-1.d0)
           b2  = b*b
           t2  = t*t

           t4  = t2*t2
           t6  = t4*t2
           q4  = 1.d0 +b*t2
           q5  = 1.d0 +b*t2+b2*t4
           h0  = g3*(bet/delt)*dlog(1.d0+delt*q4*t2/q5)
           h   = h0

           q8  = q5*q5+delt*q4*q5*t2
           h0t = 2.d0 *bet*t*(1.d0 +2.d0*b*t2)/q8 * g3
           h0b = -bet*t6*( 2.d0*b +b2*t2)/q8 * g3
           h0rs = h0b * b * eurs * (b+delt) / bet / g3
           ht   = h0t
           hrs  = h0rs

           if(dabs(zeta) < zeta_minimum) then
              gzt = -2.d0/9.d0*zeta *( 1.d0 +14.d0/27.d0 *zeta*zeta &
                   &             *( 1.d0 +13.d0/18.d0 *zeta*zeta ))
           else
              gzt = ( (onpzeta**2+eta)**sixthm - (onmzeta**2+eta)**sixthm)/3.d0
           end if
           bzt = b * ( b+delt) * ( euzt - 3.d0*eu*gzt/g ) / ( bet * g3 ) 
           h0zt = 3.d0 * gzt * h0 / g + h0b * bzt


           ec1  = d*h * 0.5d0

           ec1d = h-thrd*rs*hrs-sixth7*t*ht  + (h0zt-gzt*t*h0t/g) * zetadxd
           ec1dd = 0.5d0*ht/sk / g

10         continue

           exc0 = eu*d * 0.5d0 + ec1
           excd = ecd + ec1d
           dF_drho(i, is) = dF_drho(i, is) + excd
           excdd = ec1dd
! gradient of charge density 95/12/3 H.S.
           if(is ==  2) then
              if(dabs(grad_trho(i)) > 1.0d-9) then
                 grad_trho(i) = excdd / grad_trho(i)
              else
                 grad_trho(i) = 0.d0
              endif
           endif
! gradient of charge density 95/12/3 H.S.
!!$           exec1 = eu*d * 0.5
           exc1 = exc1 + exc0*wos(i)
        end do
     end if
     exc = exc + exc1
     if(present(ecor)) ecor = ecor + exc1
  end do
end subroutine cr_gga_library

subroutine init_spline_htbs( mu, kappa_rpbe, kappa_wc, coeff_wc, &
     &                       s_low_htbs, s_high_htbs, coeff_spline )
  use m_Const_Parameters,  only : DP
  implicit none

  real(kind=DP), intent(in) :: mu, kappa_rpbe, kappa_wc, coeff_wc
  real(kind=DP), intent(in) :: s_low_htbs, s_high_htbs
  real(kind=DP), intent(out) :: coeff_spline(0:5)
!
  real(kind=DP) :: f_0, df_0, d2f_0, f_1, df_1, d2f_1
  real(kind=DP) :: delta_s, ctmp1, ctmp2, ctmp3

  call set_values_endpoint0( s_low_htbs,  f_0, df_0, d2f_0 )   ! WC06 at lower limit
  call set_values_endpoint1( s_high_htbs, f_1, df_1, d2f_1 )   ! RPBE at high limit

! scaling from s=(s1,s2) to y=(0, 1)   ! y = (s-s1)/(s2-s1)
!
  delta_s = s_high_htbs -s_low_htbs
  df_0 = df_0 *delta_s;     d2f_0 = d2f_0 *delta_s**2
  df_1 = df_1 *delta_s;     d2f_1 = d2f_1 *delta_s**2
!
  coeff_spline(0) = f_0
  coeff_spline(1) = df_0
  coeff_spline(2) = d2f_0 /2.0d0
!
  ctmp1 =   f_1 -coeff_spline(0) -coeff_spline(1) -coeff_spline(2)
  ctmp2 =  df_1 -coeff_spline(1) -2.0d0 *coeff_spline(2)
  ctmp3 = d2f_1 -2.0d0 *coeff_spline(2)
!
  coeff_spline(3) = ( 20.0d0 *ctmp1 -8.0d0 *ctmp2 + ctmp3 ) /2.0d0
  coeff_spline(4) = ( 4.0d0 *ctmp2 -ctmp3 -6.0d0 *coeff_spline(3) ) /4.0d0
  coeff_spline(5) = ctmp1 -coeff_spline(3) -coeff_spline(4)

contains

  subroutine set_values_endpoint0( s, f, df_ds, d2f_ds2 )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: f, df_ds, d2f_ds2

    real(kind=DP), parameter :: mu_gel    = 0.1234567901234568d0   !  = 10.0 /81.0

    real(kind=DP) :: s2, s4, x, dx_ds, d2x_ds2, df_dx, d2f_dx2
    real(kind=DP) :: ctmp1, ctmp2, ctmp3

    s2 = s**2;  s4 = s2**2

    ctmp1 = exp( -s2 )
    ctmp2 = coeff_WC *s4

    x = mu_gel *s2 + ( mu -mu_gel )*s2 *ctmp1 + log( 1.0d0 +ctmp2 )
    dx_ds = 2.0d0 *mu_gel *s + ( mu -mu_gel ) *2.0d0 *s *ctmp1 *( 1.0d0 -s2 ) &
         &  +4.0d0 *coeff_WC *s2 *s /( 1.0d0 +ctmp2 )
    d2x_ds2 = 2.0d0 *mu_gel &
         &   + 2.0d0 *( mu -mu_gel ) *ctmp1 *( 1.0d0 -5.0d0 *s2 +2.0d0 *s4 ) &
         &   + 4.0d0 *coeff_WC *s2 *( 3.0d0 -ctmp2 ) /( 1.0d0 +ctmp2 )**2

    ctmp3 = kappa_wc +x

    f = 1.0d0 +kappa_wc *x /ctmp3
    df_dx = kappa_wc**2 /ctmp3**2
    d2f_dx2 = -2.0d0 *df_dx /ctmp3

    df_ds = dx_ds * df_dx
    d2f_ds2 = d2x_ds2 *df_dx +dx_ds**2 *d2f_dx2

  end subroutine set_values_endpoint0

  subroutine set_values_endpoint1( s, f, df_ds, d2f_ds2 )
    real(kind=DP), intent(in) :: s
    real(kind=DP), intent(out) :: f, df_ds, d2f_ds2

    real(kind=DP) :: s2, x, dx_ds, d2x_ds2
    real(kind=DP) :: ctmp1

    s2 = s**2

    x = mu *s2;   dx_ds = 2.0d0 *mu *s;   d2x_ds2 = 2.0d0 *mu
    ctmp1 = exp( -x/ kappa_rpbe )

    f = 1.0d0 +kappa_rpbe -kappa_rpbe *ctmp1
    df_ds = dx_ds *ctmp1
    d2f_ds2 = ctmp1 * ( d2x_ds2 -dx_ds**2 /kappa_rpbe )

  end subroutine set_values_endpoint1

end subroutine init_spline_htbs
! ===================== 13.0A

       subroutine matrix_set(a,n)
       implicit double precision(a-h,o-z),integer(i-n)

       real(8)   :: a(n,n)

       do i=1,n
          do j=1,n
             a(j,i) = (n+1-Max(n+1-i,n+1-j))*1.0D+00
          end do
       end do

       return
       end

       subroutine matrix_seti(a,n)
       implicit double precision(a-h,o-z),integer(i-n)

       real(8)   :: a(n,n)

       do i=1,n
          do j=1,n
             if(j<i)then
               a(j,i) = (n+1-Max(n+1-i,n+1-j))*1.0D+00
             else if(j==i)then
               a(j,i) = 0.0D+00
             else
               a(j,i) =-(n+1-Max(n+1-i,n+1-j))*1.0D+00
             endif
          end do
       end do

       return
       end

       subroutine mat_set(n, a, nm, mtype, ndim)

       implicit double precision(a-h,o-z),integer(i-n)
       real(8)                :: a(1:nm,*)

       include 'mpif.h'
       include 'trd.h'


          call datacast_init(ndim)

          j_2=loop_c_start(1, x_nnod, x_inod)
          j_3=loop_c_end  (n, x_nnod, x_inod)
          i_2=loop_c_start(1, y_nnod, y_inod)
          i_3=loop_c_end  (n, y_nnod, y_inod)

          do i_1=i_2,i_3
             i = loop_c_l2g_depth(i_1, y_nnod, y_inod)
             if(mtype==0)then
                do j_1=j_2,j_3
                   j = loop_c_l2g_depth(j_1, x_nnod, x_inod)
                   a(j_1,i_1)=(n+1-Max(n+1-i,n+1-j))*1.0D+00
!                   a(j_1,i_1)=(Max(n+1-i,n+1-j))*1.0D+00
                enddo
             endif
!             if(mtype==1)then
!                a(1:n,i_1)=0D0
!                a(i,i_1)=2D0
!                if(i-1>=1)a(i-1,i_1)=-1D0
!                if(i+1<=n)a(i+1,i_1)=-1D0
!             endif
             if(mtype==1)then
                do j_1=j_2,j_3
                   j = loop_c_l2g_depth(j_1, x_nnod, x_inod)
                   if(i==j)then
                      a(j_1,i_1)=-7.2D0
                   else
                      a(j_1,i_1)=-3.0D0/(i-j)**2
                   endif
                enddo
             endif
             if(mtype==2)then
                do j_1=j_2,j_3
                   CALL RANDOM_NUMBER(t)
                   a(j_1,i_1)=1.D0-2*t
                enddo
             endif
          enddo

          call datacast_free(0)


       return
       end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 581 $)
!
!  MODULE: m_ES_WF_by_MatDiagon
!
!  AUTHOR(S): T. Yamasaki, M. Okamoto,   August/22/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

#ifndef SX
#define DGEMM__       DGEMM
#endif

#ifndef NO_MATDIAGON_DGEMM
#define MATDIAGON_DGEMM
#endif

module m_ES_WF_by_MatDiagon
! $Id: m_ES_WF_by_MatDiagon.F90 581 2018-08-01 08:38:42Z jkoga $
  use m_Electronic_Structure,only : zaj_l, eko_l, vlhxcQ,vlhxc_l &
#ifdef SAVE_FFT_TIMES
       &                          , status_saved_phifftr &
#endif
       &                          , nrvf_ordr, nblocksize_mgs_default, fsr_l,fsi_l,neordr &
       &                          , m_ES_wd_zaj_small_portion_3D
  use m_ES_nonlocal,         only : m_ES_betar_dot_WFs_4_each_k_3D
  use m_NonLocal_Potential,  only : snl
  use m_PlaneWaveBasisSet,   only : kg1_ext,kg1,iba2,iba,nmatsz,nmatsz2,nbmat,nbmat2,nbase,ngabc,ttr,igpo &
       &                          , n_rGsv, nbase_gamma, kg2_gamma &
       &                          , m_pwBS_alloc_igpo &
       &                          , m_pwBS_dealloc_igpo &
       &                          , m_pwBS_GminusGmapfunction &
       &                          , m_pwBS_set_gmaxs &
       &                          , m_pwBS_alloc_nbmat_and_iba2 &
       &                          , m_pwBS_dealloc_nbmat_and_iba2 &
       &                          , m_pwBS_mat_for_each_WF
  use m_PseudoPotential,     only : modnrm,n_non0_lmtxlmt,index_lmt1_lmt2,lmtt &
       &                          , ltp,mtp,ilmt,dion,q,ivanl, nlmtt &
       &                          , ipaw,dion_paw
  use m_Kpoints,             only : kv3, vkxyz, k_symmetry
  use m_Ionic_System,        only : ntyp, natm, ityp, iwei, pos, ivan
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,kimg,af,neg,iprimatdiagon,intzaj &
       &                          , n_matrix_size,gmax,eps_solve_Hx_eq_ex,gmaxs_given,ekmode &
#ifdef SAVE_FFT_TIMES
       &                          , skip_alloc_phonon, sw_save_fft
#else
       &                          , skip_alloc_phonon
#endif
  use m_Const_Parameters,    only : DP,PAI2,EXECUT,CMPLDP,BUCS,SmallestPositiveNumber,by_matrix_diagon,ON, GAMMA &
       &                          , GAMMA_base_symmetrization, OLD
  use m_Parallelization,     only : mpi_comm_group,myrank_k,map_k,ierr,npes, np_e &
       &                          , ista_kngp,iend_kngp,ista_e,iend_e &
       &                          , istep_e,map_z
  use m_Parallelization,   only : nis_G_g1k,nie_G_g1k,nel_G_g1k,ista_G_g1k,iend_G_g1k,np_G_g1k,mp_G_g1k,map_G_g1k &
       &                        , nis_B_g1k,nie_B_g1k,nel_B_g1k,ista_B_g1k,iend_B_g1k,np_B_g1k,mp_B_g1k,map_B_g1k &
       &                          , mpi_kg_world, mpi_ke_world          &
       &                          , myrank_g, myrank_e, nrank_g &
       &                          , mpi_chg_world, myrank_chg, nrank_chg &
       &                          , nis_g1k,nie_g1k,nel_g1k,ista_g1k,iend_g1k,np_g1k,mp_g1k  &
       &                          , neg_g,nrank_e,mype,mpi_k_world,ista_k,iend_k,neg_g_all,map_e &
       &                          , m_Parallel_init_mpi_G_iba2_3D, m_Parallel_init_mpi_B_iba2_3D
  use m_Control_Parameters,  only : ipriparallel,printable &
       &                          , sw_scalapack, method_scalapack, block_size, nprow, npcol, meg &
       &                          , nblocksize_mgs_is_given                    &
       &                          , nblocksize_mgs, divide_square
  use m_PlaneWaveBasisSet,   only : kgp, ngabc_kngp_l, ngabc_kngp_B_l, kg
  use m_Files,               only : nfout
  use m_Const_Parameters,    only : HOUSEHOLDER
  use m_Parallelization,     only : make_index_band_for_scalapack_md                &
       &                          , dealloate_index_band_for_scalapack_md           &
       &                          , nmatsz_col, nel_col_md, nis_col_md, nie_col_md, scl_col_md  &
       &                          , nmatsz_row, nel_row_md, nis_row_md, nie_row_md, scl_row_md  &
       &                          , scl_md_comm_max, scl_md_comm_max_r                 &
       &                          , scl_md_comm_rank, scl_md_comm_rank_r               &
       &                          , scl_md_comm_rno,  scl_md_comm_rno_r                &
       &                          , scl_md2_comm_max, scl_md2_comm_max_r                 &
       &                          , scl_md2_comm_rank, scl_md2_comm_rank_r               &
       &                          , scl_md2_comm_rno,  scl_md2_comm_rno_r                &
       &                          , nis_e, nie_e

! =========================== added by K. Tagami =================== 11.0
  use m_Const_Parameters,     only : Neglected, BuiltIn, OFF, SKIP
  use m_Control_Parameters,  only : noncol, ndim_chgpot, ndim_spinor, SpinOrbit_mode, sw_hubbard 
  use m_PseudoPotential,     only : dion_scr_noncl, q_noncl, nlmt
  use m_ES_NonCollinear,      only : m_ES_MagMom_to_DensMat_Gspace, &
       &                             m_ES_MagMom_to_DensMat_vlhxcl
! ================================================================== 11.0

  implicit none

  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:,:):: hsmat_s !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat1
  real(kind=DP),private,allocatable,target,dimension(:,:):: hsmat2
  real(kind=DP),private,allocatable,dimension(:,:,:):: Linv  !d(nmatsz,nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: ldag  !d(nmatsz,kimg)
  real(kind=DP),private,allocatable,dimension(:,:)  :: vlhxc   !d(nmatsz2,kimg)
  real(kind=DP),private,allocatable,dimension(:)    :: zfcos,zfsin !d(nmatsz2)
  real(kind=DP),private,allocatable,dimension(:,:,:)  :: zaj_mat !d(nmatsz,np_e,kimg)

  integer :: npcol_md, nprow_md
  integer :: nsclcol_md, nsclrow_md
!ScaLAPACK
    logical, save :: nsame


  logical, private :: reduced_basis_mode = .false.

  include 'mpif.h'

contains

  subroutine m_ESmat_set_reduced_basis_mode(reduced)
      logical, intent(in) :: reduced
      reduced_basis_mode = reduced
  end subroutine m_ESmat_set_reduced_basis_mode

  subroutine alloc_matrices()
!f    allocate(hsmat(nmatsz,nmatsz,kimg)); hsmat = 0.d0
    allocate(vlhxc(nmatsz2,kimg))
    allocate(zfcos(0:nmatsz2))
    allocate(zfsin(0:nmatsz2))
!f    if(modnrm == EXECUT) then
!f       allocate(linv(nmatsz,nmatsz,kimg))
!f       allocate(ldag(nmatsz,kimg))
!f    end if
!f    allocate(zaj_mat(nmatsz,np_e,kimg))
    allocate(hsmat(maxval(np_B_g1k),maxval(np_G_g1k),kimg)); hsmat = 0.d0
    if(modnrm == EXECUT) then
       allocate(hsmat_s(maxval(np_B_g1k),maxval(np_G_g1k),kimg)); hsmat_s = 0.d0
       allocate(linv(maxval(np_G_g1k),maxval(np_B_g1k),kimg)); linv = 0.d0
       allocate(ldag(maxval(np_G_g1k),kimg))
    end if
    allocate(zaj_mat(nmatsz,np_e,kimg))
  end subroutine alloc_matrices

  subroutine dealloc_matrices()
    if(allocated(zaj_mat)) deallocate(zaj_mat)
    if(allocated(ldag))  deallocate(ldag)
    if(allocated(linv))  deallocate(linv)
    if(allocated(zfsin)) deallocate(zfsin)
    if(allocated(zfcos)) deallocate(zfcos)
    if(allocated(vlhxc)) deallocate(vlhxc)
    if(allocated(hsmat)) deallocate(hsmat)
    if(allocated(hsmat_s)) deallocate(hsmat_s)
  end subroutine dealloc_matrices


!===============================================================================
  subroutine m_ESmat_solve_Hx_eq_eSx_3D(nfout,iteration,iteration_electronic)
    integer, intent(in) :: nfout, iteration, iteration_electronic

    integer   :: ispin, ik, iksnl, n=0
    integer   :: id_sname = -1
!---- ScaLAPACK
    integer :: is,ie, nb_mgs
    integer :: lda,lwork1, lwork2
    integer, save :: lrwork1,lrwork2,liwork1,liwork2,occ
    integer, save :: ictxt, myrow, mycol
    integer, dimension(9), save :: desca,descz
    integer, allocatable, save :: usermap(:,:)
    integer :: nmatsz_opt
!---- ScaLAPACK
    logical :: unitcell_can_change
                                                  __TIMER_SUB_START(1201)
    call tstatc0_begin('m_ESmat_solve_Hx_eq_eSx ',id_sname,1)
                                                  __TIMER_DO_START(1476)
    if(iprimatdiagon >= 2) write(nfout,'(" !! iteration = ",i6, " m_ESmat_solve_Hx_eq_eSx")') iteration

    if(ekmode == ON ) then
       if(iteration_electronic == 1) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)  ! -> gmaxs,nmatsz,n_rGv
       else
          call m_pwBS_set_gmaxs(n,gmax)                     ! -> gmaxs,nmatsz,n_rGv
       end if
    else
       if(iteration == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if(skip_alloc_phonon .and. iteration_electronic == 1 .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else if(unitcell_can_change() .and. iteration_electronic == 1 &
         &    .and. intzaj == by_matrix_diagon) then
          call m_pwBS_set_gmaxs(n_matrix_size,gmaxs_given)
       else
          call m_pwBS_set_gmaxs(n,gmax)
       end if
    end if

    call m_pwBS_alloc_nbmat_and_iba2()
    call m_pwBS_mat_for_each_WF() ! -> nbmat,nbmat2,iba2

    call m_pwBS_alloc_igpo()
    call m_pwBS_GminusGmapfunction()  ! -> igpo, nmatsz2
    if(iprimatdiagon >= 3) write(nfout,'(" nmatsz2 = ",i9)') nmatsz2

!
    call m_Parallel_init_mpi_G_iba2_3D(nfout,ipriparallel,printable,kv3,iba2)
    call m_Parallel_init_mpi_B_iba2_3D(nfout,ipriparallel,printable,kv3,iba2)

    call alloc_matrices()

!fj --------------------
          if(nblocksize_mgs_is_given) then
             nb_mgs = nblocksize_mgs
          else
             nb_mgs = nblocksize_mgs_default
          end if
!fj    -----------------
                                                  __TIMER_DO_STOP(1476)
                                                  __TIMER_DO_START(1477)
    do ispin = 1, nspin, af+1
       call prjvlhxc_l2vlhxc_t()   ! vlhxc_l -> vlhxc
       do ik = ispin, kv3-nspin+ispin,nspin
          if(map_k(ik) /= myrank_k) cycle
          iksnl = (ik-1)/nspin + 1
          hsmat = 0.d0
          if(modnrm == EXECUT) then
             hsmat_s = 0.d0
             if(iprimatdiagon >=3 ) write(nfout,'(" !! modnrm == EXECUT (m_ESmat_solve_Hx_eq_eSx)")')
             call ovmtrx() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- ovmtrx --")
!x          if(sw_scalapack /= ON) then
!x                call cholde() ; if(iprimatdiagon >= 3) call wd_hsmat(" -- cholde --")   ! -> linv
!x          endif
          end if
          call nlmtrx()           ! (nlmtrx) -> hsmat <- snl
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- nlmtrx --")
          call amtrxkinetic()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxkinetic --")
          call amtrxlocalpt()     !  -> hsmat
                          if(iprimatdiagon >= 3) call wd_hsmat(" -- amtrxlocalpt --")
!x          if(sw_scalapack /= ON) then
!x             if(modnrm == EXECUT) call lhl() ! -> hsmat
!x                             if(modnrm == EXECUT .and. iprimatdiagon >= 3) call wd_hsmat(" -- lhl --")
!x          endif

!---- ScaLAPACK
         if(sw_scalapack == ON) then
            nprow_md = nprow
            npcol_md = npcol
            if (divide_square > 0) then
               if(nprow==0 .or. npcol==0) then
                  nprow_md = int(sqrt(real(nrank_e*nrank_g)))
                  npcol_md = nprow_md
               else
                  if(nprow*npcol > nrank_g*nrank_e) then
                     nprow_md = nrank_e
                     npcol_md = nrank_g
                  end if
               end if
            else
               if(nprow==0 .or. npcol==0) then
                  nprow_md = nrank_e
                  npcol_md = nrank_g
               end if
               if(nprow*npcol > nrank_g*nrank_e) then
                  nprow_md = nrank_e
                  npcol_md = nrank_g
               end if
            end if
            if(block_size == 0) then
               block_size = nb_mgs
            end if
            if(nprow==nrank_g .and. npcol==nrank_e .and. block_size==nb_mgs) then
               nsame = .true.
            else
               nsame = .false.
            endif
            nsclrow_md = nprow_md
            nsclcol_md = npcol_md

            call set_nprow_npcol(nsclrow_md,nsclcol_md)
            allocate(usermap(nsclrow_md,nsclcol_md))

            nmatsz_opt = min(iba2(ik),nmatsz)
            call scalapack_setup_3D(nmatsz_opt,lwork1,lrwork1,liwork1,lwork2,&
               & lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
            call make_index_band_for_scalapack_md(neg, nmatsz_opt, ik, nb_mgs, block_size &
                 &                              , nsclrow_md, nsclcol_md)
               ! -> scl_md_comm_max, scl_md_comm_max_r, scl_md_comm_rank, scl_md_comm_rank_r
               ! -> scl_md_comm_rno, scl_md_comm_rno_r, scl_md2_comm_max, scl_md2_comm_max_r
               ! -> scl_md2_comm_rank, scl_md2_comm_rank_r, scl_md2_comm_rno,  scl_md2_comm_rno_r
            deallocate(usermap)
         end if

!---- ScaLAPACK
         if(sw_scalapack == ON) then
              call solve_Hx_eq_ex_ScaLAPACK()
         else
#ifdef _USE_LAPACK_
      ! [LAPACK] with LAPACK library
      !***** LAPACK [begin] ***** M.Okamoto
          call solve_Hx_eq_ex_LAPACK()
      !***** LAPACK [end] ***** M.Okamoto
#else
      ! [LAPACK] without LAPACK library
          call solve_Hx_eq_ex()
#endif
         endif
          if(iprimatdiagon >= 3) call wd_hsmat(" -- after diagonalization --")
!x          if(sw_scalapack /= ON) then
!x             if(modnrm == EXECUT) call lx() ! -> zaj_mat
!x          endif
          ! Debug
          if(k_symmetry(ik) == GAMMA .or. k_symmetry(ik) == GAMMA_base_symmetrization) call phase_mult()
          call cp_zaj_mat_to_zaj_l() ! zaj_mat -> zaj_l
          if(sw_scalapack == ON) then
            call dealloate_index_band_for_scalapack_md
          endif
       end do
    end do
                                                  __TIMER_DO_STOP(1477)
                                                  __TIMER_DO_START(1478)
    if(iprimatdiagon >= 3) then
       do ik = 1, kv3
          if(map_k(ik) /= myrank_k) cycle
          call m_ES_wd_zaj_small_portion_3D(nfout,ik," (m_ESmat_solve_Hx_eq_eSx)",26)
       end do
    end if

    call dealloc_matrices()
    call m_pwBS_dealloc_igpo()
    call m_pwBS_dealloc_nbmat_and_iba2()

!f    call m_ES_betar_dot_WFs(nfout) ! (fsrfsi) -> fsr_l, fsi_l
       do ik = 1, kv3, af+1
          if(map_k(ik) /= myrank_k) cycle         ! MPI
!          call m_ES_betar_dot_WFs_3D(nfout,ik) ! (fsrfsi) -> fsr_l, fsi_l
          call m_ES_betar_dot_WFs_4_each_k_3D(nfout,ik)
       end do
                                                  __TIMER_DO_STOP(1478)
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1201)
  contains
    ! Contained subroutines
    !  1)    subroutine wd_hsmat
    !  2)    subroutine solve_Hx_eq_ex_LAPACK
    !  3)*   subroutine solve_Hx_eq_ex         * is same with the corresponding subroutine contained in 
    !  4)*   subroutine calphase                        a subroutine m_ESmat_solve_Hx_eq_eSx
    !  5)    subroutine nlmtrx
    !  6)    subroutine ovmtrx
    !  7)    subroutine cholde
    !  8)    subroutine amtrxkinetic
    !  9)$   subroutine prjvlhxc_l2vlhxc_t     $ is almost same
    ! 10)    subroutine amtrxlocalpt
    ! 11)    subroutine lhl
    ! 12)    subroutine lx
    ! 13)    subroutine phase_mult
    ! 14)    subroutine cp_zaj_mat_to_zaj_l
    ! 15)    subroutine solve_Hx_eq_ex_ScaLAPACK
    ! 16)    subroutine set_nprow_npcol
    ! 17)    subroutine scalapack_setup_3D
    ! 18)    subroutine trans_scalapack
    ! 19)    subroutine trans_scalapack_r
    ! 20)    subroutine eigsend

    subroutine wd_hsmat(str)
      character(len=*),intent(in) :: str
      integer :: i, imax, j, jmax
      integer, parameter :: NMATSIZE = 10
                                                  __TIMER_SUB_START(1202)
      write(nfout,'(a30," ik= ",i5)') str,ik
      imax = min(NMATSIZE, nmatsz)
      jmax = min(NMATSIZE, nmatsz)
      do j = 1, jmax
         write(nfout,'(" hsmat(1:*,",i3,",1): ",10f8.4,99(/19x,10f8.4))') j &
              & , (hsmat(i,j,1),i=1,imax)
      end do
      if(kimg == 2) then
         do j = 1, jmax
            write(nfout,'(" hsmat(1:*,",i3,",2): ",10f8.4,99(/19x,10f8.4))') j &
                 & , (hsmat(i,j,2),i=1,imax)
         end do
      end if
                                                  __TIMER_SUB_STOP(1202)
    end subroutine wd_hsmat

#ifdef _USE_LAPACK_
   ! [LAPACK] with LAPACK library
   !***** LAPACK [begin] ***** M.Okamoto
    subroutine solve_Hx_eq_ex_LAPACK()
      integer :: n, lda, ne, ne_found, il, iu, info, i, j, ib, lwork, ib_wk, index_G, index_B, isize, ierr
      real(kind=DP) :: abstol, vl, vu, sum, dlamch
      integer,allocatable ::              ifail(:), iwork(:)
      real(kind=DP),allocatable ::        amat(:,:), evec(:), rvmat(:,:), rwork(:)
      complex(kind=CMPLDP),allocatable :: cmat(:,:), cmat2(:,:), cvmat(:,:), cwork(:)
      complex(kind=CMPLDP),parameter :: IMG = (0.d0,1.d0)
      integer ::  mpi_comm
#ifdef _FJ_DBG0_
      integer ::                          iiii,jjjj
#endif
!! === DEBUG by tkato 2011/09/06 ================================================
!      complex(kind=CMPLDP) :: ctemp
!! ==============================================================================
                                                  __TIMER_SUB_START(1203)
      mpi_comm = mpi_k_world(myrank_k)
      zaj_mat(:,:,:) = 0.d0
      lda = nmatsz
      !!$ vl = -1.d10 ; vu = 1.d10 ; il = ista_e ; iu = iend_e
      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg
      ne = iu - il + 1
      abstol = 2*dlamch('S')
      n = iba2(ik)
      isize = lda*n
      if (kimg == 1) then
         lwork = max(1,12*n)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
! === DEBUG by tkato 2012/11/06 ================================================
!        allocate(amat(lda,n),rvmat(lda,ne),rwork(lwork))
         allocate(amat(lda,n),rvmat(lda,n),rwork(lwork))
! ==============================================================================
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         amat(:,:) = 0.d0
                                                  __TIMER_DO_START(1286)
         do i = ista_B_g1k(ik), iend_B_g1k(ik)
         do j = ista_G_g1k(ik), iend_G_g1k(ik)
            index_B = i-ista_B_g1k(ik)+1
            index_G = j-ista_G_g1k(ik)+1
            amat(i,j) = hsmat(index_B,index_G,1)
         end do
         end do
                                                  __TIMER_DO_STOP(1286)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1263)
         call mpi_allreduce(MPI_IN_PLACE,amat,isize,mpi_double_precision,mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1263)

         if(iprimatdiagon>= 2)  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,RMat=amat)
         if(modnrm == EXECUT) then
            rvmat(:,:) = 0.d0
            do i = ista_B_g1k(ik), iend_B_g1k(ik)
               do j = ista_G_g1k(ik), iend_G_g1k(ik)
                  index_B = i-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  rvmat(i,j) = hsmat_s(index_B,index_G,1)
               end do
            end do
            call mpi_allreduce(MPI_IN_PLACE,rvmat,isize,mpi_double_precision,mpi_sum,mpi_comm,ierr)
                                                  __TIMER_DO_START(1287)
            Call dsygv(1,'V','U',n,amat,lda,rvmat,lda,evec,rwork,lwork,info)
            ne_found = ne   !!<<== DEBUG by tkato 2012/11/06 =====
                                                  __TIMER_DO_STOP(1287)
         else
                                                  __TIMER_DO_START(1287)
            call dsyevx('V','I','U',n,amat,lda,vl,vu,il,iu,abstol, &
                 & ne_found,evec,rvmat,lda,rwork,lwork,iwork,ifail,info)
                                                  __TIMER_DO_STOP(1287)
         endif
         if(iprimatdiagon>=2) call check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK_noncl2 " &
              &                                   ,nfout,ik,n,ne,lda,evec,Rmat=rvmat)
         call check_LAPACKerror(ne_found,ne,info)
                                                  __TIMER_DO_START(1288)
         do ib = ista_e, iend_e, istep_e
            j = ib - ista_e +1                 !  j = map_z(ib)
            ib_wk = neg_g(j)
            do i = 1,n
               zaj_mat(i,j,1) = rvmat(i,ib_wk) ! zaj_l(i,j,ik,1)=rvmat(i,ib-ista_e+1)! M.Okamoto (August 22,2003)
            end do
            eko_l(j,ik) = evec(ib_wk)          !  eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
                                                  __TIMER_DO_STOP(1288)
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++
         deallocate(amat,rvmat,rwork)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
         lwork = max(1,6*n)
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),iwork(5*n),ifail(n))
! === DEBUG by tkato 2011/09/06 ================================================
!        allocate(cmat(lda,n),cvmat(lda,ne),cwork(lwork),rwork(7*n))
         allocate(cmat(lda,n),cmat2(lda,n),cvmat(lda,ne),cwork(lwork),rwork(7*n))
         evec = 0.d0; iwork = 0; ifail = 0; cmat = dcmplx(0.d0,0.d0)
         cvmat = dcmplx(0.d0,0.d0); rwork = 0.d0;
! ==============================================================================
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                  __TIMER_DO_START(1289)
         do i = ista_B_g1k(ik), iend_B_g1k(ik)          !f       do i = 1,n
         do j = ista_G_g1k(ik), iend_G_g1k(ik)          !f       do j = 1,n
            index_B = i-ista_B_g1k(ik)+1
            index_G = j-ista_G_g1k(ik)+1
            cmat(i,j) = dcmplx(hsmat(index_B,index_G,1),hsmat(index_B,index_G,2))
!f            cmat(i,j) = cmplx(hsmat(i,j,1),hsmat(i,j,2))
         end do
         end do
                                                  __TIMER_DO_STOP(1289)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1264)
         call mpi_allreduce(MPI_IN_PLACE,cmat,isize,mpi_double_complex,mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1264)

! === DEBUG by tkato 2011/09/06 ================================================
!        call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
!           ne_found,evec,cvmat,lda,ctemp,-1,rwork,iwork,ifail,info)
!        lwork = int(real(ctemp))
!        allocate(cwork(lwork)); cwork = dcmplx(0.d0,0.d0)
! ==============================================================================
        if(iprimatdiagon>= 2)  call check_LAPACKinputs("solve_Hx_eq_ex_LAPACK "  &
              &                                   ,nfout,n,lda,vl,vu,il,iu,lwork,abstol,CMat=cmat)
        if(modnrm == EXECUT) then
         cmat2 = dcmplx(0.d0,0.d0)
         do i = ista_B_g1k(ik), iend_B_g1k(ik)
         do j = ista_G_g1k(ik), iend_G_g1k(ik)
            index_B = i-ista_B_g1k(ik)+1
            index_G = j-ista_G_g1k(ik)+1
            cmat2(i,j) = dcmplx(hsmat_s(index_B,index_G,1),hsmat_s(index_B,index_G,2))
         end do
         end do
         call mpi_allreduce(MPI_IN_PLACE,cmat2,isize,mpi_double_complex,mpi_sum,mpi_comm,ierr)
                                                  __TIMER_DO_START(1287)
         call zhegv(1,'V','U',n,cmat,lda,cmat2,lda,evec,cwork,lwork,rwork,info)
         cvmat(:,1:ne) = cmat(:,1:ne)
                                                  __TIMER_DO_STOP(1287)
        else
                                                  __TIMER_DO_START(1287)
           call zheevx('V','I','U',n,cmat,lda,vl,vu,il,iu,abstol, &
                & ne_found,evec,cvmat,lda,cwork,lwork,rwork,iwork,ifail,info)
                                                  __TIMER_DO_STOP(1287)
        endif
         if(iprimatdiagon>=2) call check_LAPACKoutputs("solve_Hx_eq_ex_LAPACK_noncl2 " &
              &                                   ,nfout,ik,n,ne,lda,evec,Cmat=cvmat)
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
                                                  __TIMER_DO_START(1290)
         do ib = ista_e, iend_e, istep_e
            j = ib - ista_e +1                        !f         j = map_z(ib)
            ib_wk = neg_g(j)
            do i = 1,n
               zaj_mat(i,j,1) = real(cvmat(i,ib_wk))
               zaj_mat(i,j,2) = aimag(cvmat(i,ib_wk))
               !!$ zaj_l(i,j,ik,1)    = real(cvmat(i,ib-ista_e+1))  ! M.Okamoto (August 22,2003)
               !!$ zaj_l(i,j,ik,kimg) = aimag(cvmat(i,ib-ista_e+1)) ! M.Okamoto (August 22,2003) 
            end do
            eko_l(j,ik) = evec(ib_wk)  !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
                                                  __TIMER_DO_STOP(1290)
           if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++++++++
         deallocate(cmat,cvmat,cwork,rwork)
        !+++++++++++++++++++++++++++++++++++
      end if
#ifdef _FJ_DBG0_
       if(mype .eq. 0) then
            write(1002,'("evec")')
            write(1002,'(5f10.7)') (evec(iiii),iiii=1,neg)

            write(1002,'("zaj_mat:kimg=1")')
            do iiii = 1, nb_mgs
               write(1002,'("iiii=",i4)') iiii
               write(1002,'(8(f10.7))') (zaj_mat(jjjj,iiii,1),jjjj=1,200)
            enddo

            write(1002,'("zaj_mat:kimg=2")')
            do iiii = 1, nb_mgs
               write(1002,'("iiii=",i4)') iiii
               write(1002,'(8(f10.7))') (zaj_mat(jjjj,iiii,2),jjjj=1,200)
            enddo
        endif
#endif

      if (iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,n,ne,evec,"solve_Hx_eq_ex")

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) stop ' ! illegal evec (solve_Hx_eq_ex)'
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum
     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++
                                                  __TIMER_SUB_STOP(1203)
    end subroutine solve_Hx_eq_ex_LAPACK
   !***** LAPACK [end] ***** M.Okamoto
#else 
   ! [LAPACK] without LAPACK library
    subroutine solve_Hx_eq_ex()
      real(kind=DP),allocatable,dimension(:,:) :: a
      real(kind=DP),allocatable,dimension(:)   :: ekt
      real(kind=DP),allocatable,dimension(:,:) :: v
      real(kind=DP),allocatable,dimension(:,:) :: w
      complex(kind=CMPLDP),allocatable,dimension(:,:) :: zw

      real(kind=DP) :: eps
      integer :: i,j,ierr,ib
      allocate(ekt(nmatsz))
      allocate(v(nmatsz*kimg,neg))

      zaj_mat(:,:,:) = 0.d0
      eps = eps_solve_Hx_eq_ex    !      default value of (eps_solve_Hx_eq_ex) = 1.d-15
      if(kimg == 1) then
         allocate(w(iba2(ik),6))
         call hobsvw(hsmat,nmatsz,iba2(ik),ekt,-neg,v,neg,eps,w,ierr)
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1, iba2(ik)
               zaj_mat(i,j,1) = v(i,ib)
            end do
            eko_l(j,ik) = ekt(ib)
         end do
         deallocate(w)
! --------------
         do i = 1, nmatsz
            do j = 1, nmatsz
               hsmat(i,j,1) = v(i,j)
            end do
         end do
! -------------
      else if(kimg == 2) then
         allocate(w(3,iba2(ik)))
         allocate(zw(5,iba2(ik)))
         allocate(a(nmatsz*kimg,nmatsz)); a = 0.d0
         do j=1,nmatsz
            do i=1,nmatsz
               a(i*2-1,j) = hsmat(i,j,1)
               a(i*2,  j) = hsmat(i,j,2)
            end do
         end do
         call chobsd(a,nmatsz,iba2(ik),ekt,-neg,v,neg,eps,w,zw,ierr)
         do ib = ista_e, iend_e, istep_e
            j = map_z(ib)
            do i = 1, iba2(ik)
               zaj_mat(i,j,1) = v(i*2-1,ib)
               zaj_mat(i,j,2) = v(i*2, ib)
            end do
            eko_l(j,ik) = ekt(ib)
         end do
         deallocate(a,zw,w)
! --------------
         do i = 1, nmatsz
            do j = 1, nmatsz
               hsmat(i,j,1) = v(i*2-1,j)
               hsmat(i,j,2) = v(i*2,j)
            end do
         end do
! -------------
      end if

      if(iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,nmatsz,neg,ekt,"solve_Hx_eq_ex")
!!$!!$         call m_ES_wd_zaj_small_portion(nfout,ik," (solve_Hx_eq_ex)",17)

      eps = 0.d0
      do ib = 1, neg
         eps = eps + abs(ekt(ib))
      end do
      if(eps < SmallestPositiveNumber*1.d5) stop ' ! illegal ekt (solve_Hx_eq_ex)'
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') eps

      deallocate(v); deallocate(ekt)
    end subroutine solve_Hx_eq_ex
#endif
   ! [LAPACK]

    subroutine calphase(ia)
      integer, intent(in) :: ia
      integer       :: i
      real(kind=DP) :: ph
                                                  __TIMER_SUB_START(1204)
                                                  __TIMER_DO_START(1291)
      do i = 1, nmatsz2
         ph = (pos(ia,1)*ngabc(i,1)+pos(ia,2)*ngabc(i,2)+pos(ia,3)*ngabc(i,3))*PAI2
         zfcos(i) = cos(ph)
         zfsin(i) = sin(ph)
      end do
                                                  __TIMER_DO_STOP(1291)
      zfcos(0) = 0.d0; zfsin(0) = 0.d0
                                                  __TIMER_SUB_STOP(1204)
    end subroutine calphase
         
    subroutine nlmtrx

      real(kind=DP),pointer,dimension(:,:,:) :: a
      real(kind=DP),allocatable,dimension(:,:)  :: s
      integer, pointer, dimension(:,:)       :: ng
      
      complex(kind=CMPLDP),parameter :: zi = (0.d0,1.d0)
      integer :: i,j,it,ia,u,v,n,lmt1,il1,lmt2,il2,j1,l1,l2,l3,ip,y,i1, i2,j2,m
      real(kind=DP) :: fr,f21,f12,t
      integer :: ista,  index_B, index_G
                                                  __TIMER_SUB_START(1205)
      a => hsmat
      ng => ngabc
!!$      s => snl(:,:,iksnl)
      allocate(s(kg1_ext,nlmtt)); s = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) == GAMMA <<nlmtrx>>")')
         if(iprimatdiagon >= 2) write(nfout,'(" kg2_gamma, iba(ik), iba2(ik) = ",3i8)') kg2_gamma,iba(ik),iba2(ik)
                                                  __TIMER_DO_START(1292)
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            il1 = ltp(lmt1,it)
            if(iprimatdiagon >= 2) write(nfout,'(" nlmtt, j, lmt1, it, il1 = ",5i8)') nlmtt,j,lmt1,it,il1
!f            s(1,j) = snl(1,j,iksnl)
            if( myrank_g == 0) s(1,j) = snl(1,j,iksnl)
            if(mod(il1,2) == 0) then
               do i = ista_g1k(ik), iend_g1k(ik)              !f    do i = 2, kg2_gamma
                  if ( i == 1) cycle
                  if ( i > kg2_gamma) cycle
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) =  snl(i-ista_g1k(ik)+1,j,iksnl)    !f      s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = -snl(i-ista_g1k(ik)+1,j,iksnl)    !f      s(i2,j) = -snl(i,j,iksnl)
               end do
            else
               do i = ista_g1k(ik), iend_g1k(ik)              !f    do i = 2, kg2_gamma
                  if ( i == 1) cycle
                  if ( i > kg2_gamma) cycle
                  i1 = nbase(i,ik)
                  i2 = nbase_gamma(i,2)
                  s(i1,j) = snl(i-ista_g1k(ik)+1,j,iksnl)     !f      s(i1,j) = snl(i,j,iksnl)
                  s(i2,j) = snl(i-ista_g1k(ik)+1,j,iksnl)     !f      s(i2,j) = snl(i,j,iksnl)
               end do
            end if
         end do
                                                  __TIMER_DO_STOP(1292)
      else
         if(iprimatdiagon >= 2) write(nfout,'(" k_symmetry(ik) /= GAMMA <<nlmtrx>>")')
                                                  __TIMER_DO_START(1293)
         do j = 1, nlmtt
            do i = ista_g1k(ik), iend_g1k(ik)                 !f      do i = 1, iba(ik)
               s(i,j) = snl(i-ista_g1k(ik)+1,j,iksnl)         !f        s(i,j) = snl(i,j,iksnl)
            end do
         end do
                                                  __TIMER_DO_STOP(1293)
      end if
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,1265)
      call mpi_allreduce(MPI_IN_PLACE,s,kg1_ext*nlmtt, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1265)
      a = 0.d0
      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1  = index_lmt1_lmt2(ip,it,1)
            lmt2  = index_lmt1_lmt2(ip,it,2)
            u     = lmtt(lmt1,it)
            v     = lmtt(lmt2,it)
            il1   = ltp(lmt1,it)
            il2   = ltp(lmt2,it)
            if(lmt2 <= lmt1) cycle
!!$            if(ivanl(il1,it) /= 1 .and. &
            if(ivan(it) /= 1 .and. &
                 & (il1 /= il2 .or. mtp(lmt1,it) /= mtp(lmt2,it))) cycle
            if(mod(il1+il2,2) == 0) then
               if(ipaw(it)==0) then
                   fr  = dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr  = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               endif
               if(il1==il2) then
                  f21 = fr*iwei(ia)
                                                  __TIMER_DO_START(1294)
                  do j = ista_G_g1k(ik), iend_G_g1k(ik)           !f        do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

                     ista = max(j,ista_B_g1k(ik))

                     if(kimg == 1) then
                        do i = ista, iend_B_g1k(ik)               !f          do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           index_B = i-ista_B_g1k(ik)+1
                           index_G = j-ista_G_g1k(ik)+1
                           a(index_B,index_G,1) = a(index_B,index_G,1)+f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))*zfcos(y)
!f                           a(i,j,1) = a(i,j,1)+f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = ista, iend_B_g1k(ik)               !f          do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*(s(m,u)*s(j2,v)+s(m,v)*s(j2,u))
                           index_B = i-ista_B_g1k(ik)+1
                           index_G = j-ista_G_g1k(ik)+1
                           a(index_B,index_G,1) = a(index_B,index_G,1) + t*zfcos(y) !f a(i,j,1)=a(i,j,1)+t*zfcos(y)
                           a(index_B,index_G,2) = a(index_B,index_G,2) - t*zfsin(y) !f a(i,j,2)=a(i,j,2)-t*zfsin(y)
                        end do
                     end if
                  end do
                                                  __TIMER_DO_STOP(1294)
               else
                  f21 = real(zi**(il2-il1))*fr*iwei(ia)
                  f12 = real(zi**(il1-il2))*fr*iwei(ia)
!!$                  write(nfout,'(" zi**(il1-il2) = ",2f16.8)') zi**(il1-il2)
                                                  __TIMER_DO_START(1295)
                  do j = ista_G_g1k(ik), iend_G_g1k(ik)    !f        do j = 1, iba2(ik)
                     j1 = nbmat(j,ik)
                     j2 = nbmat2(j,ik)
                     l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

                     ista = max(j,ista_B_g1k(ik))
                     if(kimg == 1) then
                        do i = ista, iend_B_g1k(ik)        !f          do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           index_B = i-ista_B_g1k(ik)+1
                           index_G = j-ista_G_g1k(ik)+1
                         a(index_B,index_G,1)=a(index_B,index_G,1)+(f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfcos(y)
!f                           a(i,j,1) = a(i,j,1)+(f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfcos(y)
                        end do
                     else
                        do i = ista, iend_B_g1k(ik)        !f          do i = j, iba2(ik)
                           n = nbmat(i,ik)
                           m = nbmat2(i,ik)
                           y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                           t  = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                           index_B = i-ista_B_g1k(ik)+1
                           index_G = j-ista_G_g1k(ik)+1
                           a(index_B,index_G,1) = a(index_B,index_G,1) + t*zfcos(y) !f a(i,j,1)=a(i,j,1)+t*zfcos(y)
                           a(index_B,index_G,2) = a(index_B,index_G,2) - t*zfsin(y) !f a(i,j,2)=a(i,j,2)-t*zfsin(y)
                        end do
                     end if
                  end do
                                                  __TIMER_DO_STOP(1295)
               end if
            else if(mod(il1+il2,2) == 1) then
               if(ipaw(it)==0) then
                   fr = vlhxcQ(lmt1,lmt2,ia,ispin)
               else
                   fr = dion_paw(lmt1,lmt2,ispin,ia) + vlhxcQ(lmt1,lmt2,ia,ispin)
               end if
               f21 = -aimag(zi**(il2-il1))*fr*iwei(ia)
               f12 = -aimag(zi**(il1-il2))*fr*iwei(ia)
                                                  __TIMER_DO_START(1296)
               do j = ista_G_g1k(ik), iend_G_g1k(ik)       !f          do j = 1, iba2(ik)
                  j1 = nbmat(j,ik)
                  j2 = nbmat2(j,ik)
                  l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

                  ista = max(j,ista_B_g1k(ik))
                  if(kimg == 1) then
                     do i = ista, iend_B_g1k(ik)           !f            do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        index_B = i-ista_B_g1k(ik)+1
                        index_G = j-ista_G_g1k(ik)+1
!f                        a(i,j,1) = a(i,j,1)+ &
!f                            & (f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfsin(y)
                        a(index_B,index_G,1) = a(index_B,index_G,1)+ &
                            & (f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u))*zfsin(y)
                     end do
                  else
                     do i = ista, iend_B_g1k(ik)           !f            do i = j, iba2(ik)
                        n = nbmat(i,ik)
                        m = nbmat2(i,ik)
                        y = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
                        t = f21*s(m,u)*s(j2,v)+f12*s(m,v)*s(j2,u)
                        index_B = i-ista_B_g1k(ik)+1
                        index_G = j-ista_G_g1k(ik)+1
                        a(index_B,index_G,1) = a(index_B,index_G,1) + t*zfsin(y) !f  a(i,j,1)=a(i,j,1)+t*zfsin(y)
                        a(index_B,index_G,2) = a(index_B,index_G,2) + t*zfcos(y) !f  a(i,j,2)=a(i,j,2)+t*zfcos(y)
                     end do
                  end if
               end do
                                                  __TIMER_DO_STOP(1296)
            end if
         end do
         do lmt1 = 1, ilmt(it)
            if(ipaw(it)==0) then
                fr = (dion(lmt1,lmt1,it) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            else
                fr = (dion_paw(lmt1,lmt1,ispin,ia) + vlhxcQ(lmt1,lmt1,ia,ispin))*iwei(ia)
            endif
            u  = lmtt(lmt1,it)
                                                  __TIMER_DO_START(1297)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)       !f            do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)

               ista = max(j,ista_B_g1k(ik))
               if(kimg == 1) then
                  do i = ista, iend_B_g1k(ik)          !f          do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     a(index_B,index_G,1) = a(index_B,index_G,1) + fr*s(i2,u)*s(j2,u)*zfcos(y)
!f                     a(i,j,1) = a(i,j,1) + fr*s(i2,u)*s(j2,u)*zfcos(y)
                  end do
               else if(kimg == 2) then
                  do i = ista, iend_B_g1k(ik)          !f          do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     y = igpo(ng(i1,1)-l1,ng(i1,2)-l2,ng(i1,3)-l3)
                     t = fr*s(i2,u)*s(j2,u)
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     a(index_B,index_G,1) = a(index_B,index_G,1) + t*zfcos(y)  !f a(i,j,1) = a(i,j,1)+t*zfcos(y)
                     a(index_B,index_G,2) = a(index_B,index_G,2) - t*zfsin(y)  !f a(i,j,2) = a(i,j,2)-t*zfsin(y)
                  end do
               end if
            end do
                                                  __TIMER_DO_STOP(1297)
         end do
      end do
      deallocate(s)
                                                  __TIMER_SUB_STOP(1205)
    end subroutine nlmtrx

    subroutine ovmtrx

      integer :: i,j,it,ia,u,v,n,ip,y,jn,j1,l1,l2,l3,i1,lmt1,lmt2
      integer :: i2,j2,m,jm
      real(kind=DP) :: fr,t
      real(kind=DP),allocatable,dimension(:,:)   :: s

      real(kind=DP),allocatable,dimension(:,:,:)   :: a_wk
      integer :: ista, index_B, index_G, k, mpi_comm
                                                  __TIMER_SUB_START(1206)
      mpi_comm = mpi_k_world(myrank_k)
      allocate(s(kg1_ext,nlmtt)); s = 0.0d0
      allocate(a_wk(nmatsz,nmatsz,kimg)); a_wk = 0.d0

      if(k_symmetry(ik) == GAMMA) then
         do j = 1, nlmtt
            ! --- finding it and lmt 
            Finding: do u = 1, ntyp
               do ip = 1, ilmt(u)
                  if(lmtt(ip,u) == j) then
                     lmt1 = ip
                     it = u
                     exit Finding
                  end if
               end do
            end do Finding
            l1 = ltp(lmt1,it)

            if( myrank_g == 0) s(1,j) = snl(1,j,iksnl)
            ip = 1
            if(mod(l1,2) == 0)  ip = -1
                                                  __TIMER_DO_START(1298)
            do i = ista_g1k(ik), iend_g1k(ik)            !f        do i = 2, iba(ik)
               if ( i == 1) cycle
               i1 = nbase(i,ik)
               i2 = nbase_gamma(i,2)
               s(i1,j) =    snl(i-ista_g1k(ik)+1,j,iksnl)  !f           s(i1,j) =             snl(i,j,iksnl)
               s(i2,j) = ip*snl(i-ista_g1k(ik)+1,j,iksnl)  !f           s(i2,j) = (-1)^{l1+1}*snl(i,j,iksnl)
            end do
                                                  __TIMER_DO_STOP(1298)
         end do
         if(iprimatdiagon >= 3) then
            write(nfout,'(" --- ovmtrx ---")')
            write(nfout,'(" ik = ",i8)') ik
            do j = 1, nlmtt
               write(nfout,'(" s(1:*,",i3,")      : ",10f8.4)')j, (s(i,j),i=1,10)
            end do
         end if
      else
         do j = 1, nlmtt
                                                  __TIMER_DO_START(1300)
            do i = ista_g1k(ik), iend_g1k(ik)               !f         do i = 1, kg1
               s(i,j) = snl(i-ista_g1k(ik)+1,j,iksnl)
            end do
                                                  __TIMER_DO_STOP(1300)
         end do
      end if
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,1266)
      call mpi_allreduce(MPI_IN_PLACE, s, kg1_ext*nlmtt, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1266)
      hsmat = 0.d0
!!$      do j = ista_G_g1k(ik), iend_G_g1k(ik)
!!$      do i = ista_B_g1k(ik), iend_B_g1k(ik)
!!$         index_B = i-ista_B_g1k(ik)+1
!!$         index_G = j-ista_G_g1k(ik)+1
!!$         if( i == j ) hsmat(index_B,index_G,1) = 1.d0       !f     a(i,i,1) = 1.d0
!!$      end do; end do
      do i = ista_G_g1k(ik), iend_G_g1k(ik)       !f      do i = 1, iba2(ik)
         if(ista_B_g1k(ik) <= i .and. i <= iend_B_g1k(ik)) then
            index_B = i-ista_B_g1k(ik)+1
            index_G = i-ista_G_g1k(ik)+1
            hsmat(index_B,index_G,1) = 1.d0       !f     a(i,i,1) = 1.d0
         end if
      end do

      do ia = 1, natm
         it = ityp(ia)
         call calphase(ia)  ! -> zfcos, zfsin
         do ip = 1, n_non0_lmtxlmt(it)
            lmt1 = index_lmt1_lmt2(ip,it,1)
            u = lmtt(lmt1,it)
            lmt2 = index_lmt1_lmt2(ip,it,2)
            if(lmt2 <= lmt1) cycle
            v = lmtt(lmt2,it)
            if(ltp(lmt1,it) /= ltp(lmt2,it) .or. mtp(lmt1,it) /= mtp(lmt2,it) ) cycle
            fr = q(lmt1,lmt2,it)*iwei(ia)
                                                  __TIMER_DO_START(1301)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)      !f            do j = 1, iba2(ik)
               jn = nbmat(j,ik)
               jm = nbmat2(j,ik)
               l1 = ngabc(jn,1); l2 = ngabc(jn,2); l3 = ngabc(jn,3)
               ista = max(j,ista_B_g1k(ik))
               if(kimg == 1) then
                  do i = ista, iend_B_g1k(ik)          !f              do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ngabc(n,1)-l1,ngabc(n,2)-l2,ngabc(n,3)-l3)
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     hsmat(index_B,index_G,1) = hsmat(index_B,index_G,1)+fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))*zfcos(y)
!f                     a(i,j,1) = a(i,j,1)+fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))*zfcos(y)
                  end do
               else
                  do i = ista, iend_B_g1k(ik)            !f                  do i = j, iba2(ik)
                     n = nbmat(i,ik)
                     m = nbmat2(i,ik)
                     y = igpo(ngabc(n,1)-l1,ngabc(n,2)-l2,ngabc(n,3)-l3)
                     t  = fr*(s(m,u)*s(jm,v)+s(m,v)*s(jm,u))
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     hsmat(index_B,index_G,1) = hsmat(index_B,index_G,1)+t*zfcos(y) !f a(i,j,1)=a(i,j,1)+t*zfcos(y)
                     hsmat(index_B,index_G,2) = hsmat(index_B,index_G,2)-t*zfsin(y) !f a(i,j,2)=a(i,j,2)-t*zfsin(y)
                  end do
               end if
            end do
                                                  __TIMER_DO_STOP(1301)
         end do
         do lmt1 = 1, ilmt(it)
            u  = lmtt(lmt1,it)
            fr = q(lmt1,lmt1,it)*iwei(ia)
                                                  __TIMER_DO_START(1302)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)       !f        do j = 1, iba2(ik)
               j1 = nbmat(j,ik)
               j2 = nbmat2(j,ik)
               l1 = ngabc(j1,1); l2 = ngabc(j1,2); l3 = ngabc(j1,3)
               ista = max(j,ista_B_g1k(ik))
               if(kimg == 1) then
                  do i = ista, iend_B_g1k(ik)           !f          do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ngabc(i1,1)-l1,ngabc(i1,2)-l2,ngabc(i1,3)-l3)
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     hsmat(index_B,index_G,1) = hsmat(index_B,index_G,1)+fr*s(i2,u)*s(j2,u)*zfcos(ip)
!f                     a(i,j,1) = a(i,j,1)+fr*s(i2,u)*s(j2,u)*zfcos(ip)
                  end do
               else if(kimg == 2) then
                  do i = ista, iend_B_g1k(ik)           !f          do i = j, iba2(ik)
                     i1 = nbmat(i,ik)
                     i2 = nbmat2(i,ik)
                     ip = igpo(ngabc(i1,1)-l1,ngabc(i1,2)-l2,ngabc(i1,3)-l3)
                     t  = fr*s(i2,u)*s(j2,u)
                     index_B = i-ista_B_g1k(ik)+1
                     index_G = j-ista_G_g1k(ik)+1
                     hsmat(index_B,index_G,1)=hsmat(index_B,index_G,1)+t*zfcos(ip) !f a(i,j,1)=a(i,j,1)+t*zfcos(ip)
                     hsmat(index_B,index_G,2)=hsmat(index_B,index_G,2)-t*zfsin(ip) !f a(i,j,2)=a(i,j,2)-t*zfsin(ip)
                  end do
               end if
            end do
                                                  __TIMER_DO_STOP(1302)
         end do
      end do

      do k = 1, kimg
      do j = ista_G_g1k(ik), iend_G_g1k(ik)
      do i = ista_B_g1k(ik), iend_B_g1k(ik)
         index_G = j-ista_G_g1k(ik)+1
         index_B = i-ista_B_g1k(ik)+1
         a_wk(i,j,k) = hsmat(index_B,index_G,k)
      end do; end do; end do
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1267)
      call mpi_allreduce(MPI_IN_PLACE,a_wk,nmatsz*nmatsz*kimg,mpi_double_precision,mpi_sum,mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1267)

                                                  __TIMER_DO_START(1303)
      do k = 1, kimg
      do j = 2, iba2(ik)
      do i = 1, j-1
         a_wk(i,j,k) = a_wk(j,i,k)
      end do;  end do;  end do
                                                  __TIMER_DO_STOP(1303)
                                                  __TIMER_DO_START(1304)
      do k = 1, kimg
      do j = ista_G_g1k(ik), iend_G_g1k(ik)
      do i = ista_B_g1k(ik), iend_B_g1k(ik)
         index_G = j-ista_G_g1k(ik)+1
         index_B = i-ista_B_g1k(ik)+1
         hsmat(index_B,index_G,k) = a_wk(i,j,k)
         if(modnrm == EXECUT) hsmat_s(index_B,index_G,k) = a_wk(i,j,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1304)
      deallocate(s)
      deallocate(a_wk)
                                                  __TIMER_SUB_STOP(1206)
    end subroutine ovmtrx

    subroutine cholde

! Choleski decomposition.
! ref: S.G.Louie,K.M.Ho,and M.L.Cohen, PRB19,(1979),p1774.
      integer       :: n,i,j
      real(kind=DP) :: t
      integer  :: imax, jmax
      integer, parameter :: NMATSIZE = 10

      integer  :: iend, jend, index_G, index_B, isize, nend, index_n, mpi_comm
      real(kind=DP),allocatable,dimension(:,:) :: ldag_wk
      real(kind=DP),allocatable,dimension(:) :: linv_wk1
      real(kind=DP),allocatable,dimension(:,:) :: linv_wk2, hsmat_wk
                                                  __TIMER_SUB_START(1207)
      mpi_comm = mpi_k_world(myrank_k)
      allocate(ldag_wk(np_G_g1k(ik),kimg))
      allocate(linv_wk1(kimg))
      allocate(linv_wk2(nmatsz,kimg))
      allocate(hsmat_wk(nmatsz,kimg))

      linv = 0.d0
!f      linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if((myrank_g == 0) .and. (myrank_e ==0)) linv(1,1,1) = 1.d0/sqrt(hsmat(1,1,1))
      if(kimg == 1) then
         do n = 1, iba2(ik)-1
!---
          index_n = n-ista_G_g1k(ik)+1
          isize = np_B_g1k(ik)*kimg
          hsmat_wk = 0.0d0
                                                  __TIMER_DO_START(1305)
          if((nis_G_g1k(myrank_g,ik) <= n) .and.      &
   &             (nie_G_g1k(myrank_g,ik) > n)) then
             do i = ista_B_g1k(ik), iend_B_g1k(ik)
                index_B = i-ista_B_g1k(ik)+1
                hsmat_wk(i,1)=hsmat(index_B,index_n+1,1)
             end do
          endif
                                                  __TIMER_DO_STOP(1305)
                                                  __TIMER_DO_START(1306)
          if(nis_G_g1k(myrank_g,ik) == n+1) then
             do i = ista_B_g1k(ik), iend_B_g1k(ik)
                index_B = i-ista_B_g1k(ik)+1
                hsmat_wk(i,1)=hsmat(index_B,1,1)
             end do
          endif
                                                  __TIMER_DO_STOP(1306)
          isize = nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1268)
          call mpi_allreduce(MPI_IN_PLACE,hsmat_wk,isize,mpi_double_precision,mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1268)
!---
            ldag = 0.d0
            ldag_wk = 0.d0
                                                  __TIMER_DO_START(1307)
            do i = ista_G_g1k(ik), min(n,iend_G_g1k(ik))      !f            do  i = 1, n
               jend = min(i, iend_B_g1k(ik))
               do j = ista_B_g1k(ik), jend                    !f               do j = 1, i
                  index_G = i-ista_G_g1k(ik)+1
                  index_B = j-ista_B_g1k(ik)+1
                  ldag_wk(index_G,1) = ldag_wk(index_G,1) + linv(index_G,index_B,1)*hsmat_wk(j,1)
               end do
            end do
                                                  __TIMER_DO_STOP(1307)
        isize = np_G_g1k(ik)*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1269)
         call mpi_allreduce(ldag_wk, ldag, isize, mpi_double_precision, mpi_sum, mpi_kg_world, ierr)
                                                  __TIMER_COMM_STOP(1269)

                                                  __TIMER_DO_START(1308)
            t = 0.d0
            do i = ista_G_g1k(ik),  min(n,iend_G_g1k(ik))     !f            do i = 1, n
               index_G = i-ista_G_g1k(ik)+1
               t = t + ldag(index_G,1)**2                     !f               t = t + ldag(i,1)**2
            end do
                                                  __TIMER_DO_STOP(1308)

                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,1270)
            call mpi_allreduce(MPI_IN_PLACE, t, 1, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1270)

          if(nie_G_g1k(myrank_g,ik) == n+1) then
             ldag(index_n+1,1) = sqrt(hsmat_wk(n+1,1)-t)
          endif

                                                  __TIMER_DO_START(1309)
            linv_wk2 = 0.0d0
            linv_wk1(1) = 1.d0/sqrt(hsmat_wk(n+1,1)-t)
            do i = ista_B_g1k(ik), min(n,iend_B_g1k(ik))        !f            do i = 1, n
               do j = ista_G_g1k(ik), min(n,iend_G_g1k(ik))     !f               do j = 1, n
                  index_G = j-ista_G_g1k(ik)+1
                  index_B = i-ista_B_g1k(ik)+1
                  linv_wk2(i,1)=linv_wk2(i,1)-linv_wk1(1)*ldag(index_G,1)*linv(index_G,index_B,1)
               end do
            end do
                                                  __TIMER_DO_STOP(1309)

          isize = nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1271)
         call mpi_allreduce(MPI_IN_PLACE, linv_wk2, isize, mpi_double_precision, mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1271)
     
          linv_wk2(n+1,1) = linv_wk1(1)
    nend = min(n+1,iend_B_g1k(ik))
    if(nrank_g > 1) then
                                                  __TIMER_DO_START(1310)
          if((nis_G_g1k(myrank_g,ik) < n+1) .and.      &
   &             (nie_G_g1k(myrank_g,ik) >= n+1)) then
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
              linv(index_G+1,index_B,1)=linv_wk2(i,1)
            end do
          else if (nis_G_g1k(myrank_g,ik) == n+1) then
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
              linv(1,index_B,1)=linv_wk2(i,1)
            end do
          endif
                                                  __TIMER_DO_STOP(1310)
    else
                                                  __TIMER_DO_START(1311)
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
                linv(index_G+1,index_B,1)=linv_wk2(i,1)
            end do
                                                  __TIMER_DO_STOP(1311)
    endif

         end do
      else if(kimg == 2) then
         do n = 1, iba2(ik)-1
!---
          index_n = n-ista_G_g1k(ik)+1
          isize = np_B_g1k(ik)*kimg
          hsmat_wk = 0.0d0
                                                  __TIMER_DO_START(1312)
          if((nis_G_g1k(myrank_g,ik) <= n) .and.      &
   &             (nie_G_g1k(myrank_g,ik) > n)) then
             do i = ista_B_g1k(ik), iend_B_g1k(ik)
                index_B = i-ista_B_g1k(ik)+1
                hsmat_wk(i,1)=hsmat(index_B,index_n+1,1)
                hsmat_wk(i,2)=hsmat(index_B,index_n+1,2)
             end do
          endif
                                                  __TIMER_DO_STOP(1312)
                                                  __TIMER_DO_START(1313)
          if(nis_G_g1k(myrank_g,ik) == n+1) then
             do i = ista_B_g1k(ik), iend_B_g1k(ik)
                index_B = i-ista_B_g1k(ik)+1
                hsmat_wk(i,1)=hsmat(index_B,1,1)
                hsmat_wk(i,2)=hsmat(index_B,1,2)
             end do
          endif
                                                  __TIMER_DO_STOP(1313)

          isize = nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1272)
          call mpi_allreduce(MPI_IN_PLACE,hsmat_wk,isize,mpi_double_precision,mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1272)
!---
            ldag = 0.d0
            ldag_wk = 0.d0
            iend = min(n,iend_G_g1k(ik))
                                                  __TIMER_DO_START(1314)
            do i = ista_G_g1k(ik), iend                      !f            do i = 1, n
               jend = min(i,iend_B_g1k(ik))
               do j = ista_B_g1k(ik), jend                   !f               do j = 1, i
                  index_G = i-ista_G_g1k(ik)+1
                  index_B = j-ista_B_g1k(ik)+1
                  ldag_wk(index_G,1) = ldag_wk(index_G,1) &
                       & + linv(index_G,index_B,1)*hsmat_wk(j,1)-linv(index_G,index_B,2)*hsmat_wk(j,2)
                  ldag_wk(index_G,2) = ldag_wk(index_G,2) &
                       & + linv(index_G,index_B,1)*hsmat_wk(j,2)+linv(index_G,index_B,2)*hsmat_wk(j,1)
               end do
            end do
                                                  __TIMER_DO_STOP(1314)
         isize = np_G_g1k(ik)*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1273)
         call mpi_allreduce(ldag_wk, ldag, isize, mpi_double_precision, mpi_sum, mpi_kg_world, ierr)
                                                  __TIMER_COMM_STOP(1273)

            t = 0.d0
                                                  __TIMER_DO_START(1315)
            do i = ista_G_g1k(ik), min(n,iend_G_g1k(ik))      !f            do i = 1, n
               index_G = i-ista_G_g1k(ik)+1
               t = t + ldag(index_G,1)**2 + ldag(index_G,2)**2
!f               t = t + ldag(i,1)**2 + ldag(i,2)**2
            end do
                                                  __TIMER_DO_STOP(1315)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,1274)
            call mpi_allreduce(MPI_IN_PLACE, t, 1, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1274)

!f            ldag(n+1,1) = sqrt(hsmat(n+1,n+1,1)-t)
!f            linv(n+1,n+1,1) = 1.d0/sqrt(hsmat(n+1,n+1,1)-t)
          if(nie_G_g1k(myrank_g,ik) == n+1) then
             ldag(index_n+1,1) = sqrt(hsmat_wk(n+1,1)-t)
          endif
!--          if((nis_G_g1k(myrank_g,ik) < n+1) .and.      &
!--   &             (nie_G_g1k(myrank_g,ik) >= n+1)) then
!--             ldag(index_n+1,1) = sqrt(hsmat_wk(n+1,1)-t)
!--          else if (nis_G_g1k(myrank_g,ik) == n+1) then
!--             ldag(1,1) = sqrt(hsmat_wk(n+1,1)-t)
!--          endif

                                                  __TIMER_DO_START(1316)
            linv_wk2 = 0.0d0
            linv_wk1(1) = 1.d0/sqrt(hsmat_wk(n+1,1)-t)
            linv_wk1(2) = 0.0d0
            iend = min(n,iend_B_g1k(ik))
            do i = ista_B_g1k(ik), iend                   !f            do i = 1, n
               jend = iend_G_g1k(ik) ; if( n < iend_G_g1k(ik)) jend = n
               do j = ista_G_g1k(ik), jend                !f               do j = 1, n
                  index_G = j-ista_G_g1k(ik)+1
                  index_B = i-ista_B_g1k(ik)+1

                  linv_wk2(i,1) = linv_wk2(i,1) &
                       &       - linv_wk1(1)*(ldag(index_G,1)*linv(index_G,index_B,1) &
                       &                     +ldag(index_G,2)*linv(index_G,index_B,2))&
                       &       + linv_wk1(2)*(ldag(index_G,1)*linv(index_G,index_B,2)&
                       &                     -ldag(index_G,2)*linv(index_G,index_B,1) )
                  linv_wk2(i,2) = linv_wk2(i,2) &
                       &       - linv_wk1(1)*(ldag(index_G,1)*linv(index_G,index_B,2) &
                       &                     -ldag(index_G,2)*linv(index_G,index_B,1))&
                       &       - linv_wk1(2)*(ldag(index_G,1)*linv(index_G,index_B,1)&
                       &                     -ldag(index_G,2)*linv(index_G,index_B,2) )
               end do
            end do
                                                  __TIMER_DO_STOP(1316)
          isize = nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1275)
         call mpi_allreduce(MPI_IN_PLACE, linv_wk2, isize, mpi_double_precision, mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1275)

          linv_wk2(n+1,1) = linv_wk1(1)
    nend = min(n+1,iend_B_g1k(ik))
    if(nrank_g > 1) then

                                                  __TIMER_DO_START(1317)
          if((nis_G_g1k(myrank_g,ik) < n+1) .and.      &
   &             (nie_G_g1k(myrank_g,ik) >= n+1)) then
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
              linv(index_G+1,index_B,1)=linv_wk2(i,1)
              linv(index_G+1,index_B,2)=linv_wk2(i,2)
            end do
          else if (nis_G_g1k(myrank_g,ik) == n+1) then
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
              linv(1,index_B,1)=linv_wk2(i,1)
              linv(1,index_B,2)=linv_wk2(i,2)
            end do
          endif
                                                  __TIMER_DO_STOP(1317)
    else
                                                  __TIMER_DO_START(1318)
            do i = ista_B_g1k(ik), nend
              index_B = i-ista_B_g1k(ik)+1
              index_G = n-ista_G_g1k(ik)+1
                linv(index_G+1,index_B,1)=linv_wk2(i,1)
                linv(index_G+1,index_B,2)=linv_wk2(i,2)
            end do
                                                  __TIMER_DO_STOP(1318)
    endif

         end do
      end if
      if(iprimatdiagon >= 2) then
         imax = NMATSIZE; if(imax > nmatsz) imax = nmatsz
         jmax = NMATSIZE; if(jmax > nmatsz) jmax = nmatsz
         do j = 1, jmax
            write(nfout,'(" linv(1:*,",i3,",1): ",10f8.4,99(/18x,10f8.4))') j, (linv(i,j,1),i=1,imax)
         end do
         if(kimg == 2) then
            do j = 1, jmax
               write(nfout,'(" linv(1:*,",i3,",2): ",10f8.4,99(/18x,10f8.4))') j, (linv(i,j,2),i=1,imax)
            end do
         end if
      end if
      deallocate(ldag_wk)
      deallocate(linv_wk1,linv_wk2)
      deallocate(hsmat_wk)
                                                  __TIMER_SUB_STOP(1207)
    end subroutine cholde

    subroutine amtrxkinetic
      integer :: i,j
      real(kind=DP) :: ga,gb,gc
      integer :: index_B,index_G
                                                  __TIMER_SUB_START(1208)
                                                  __TIMER_DO_START(1319)
      do i = ista_G_g1k(ik), iend_G_g1k(ik)     !f      do i = 1, iba2(ik)
         if(ista_B_g1k(ik) <= i .and. i <= iend_B_g1k(ik)) then
            index_B = i-ista_B_g1k(ik)+1
            index_G = i-ista_G_g1k(ik)+1
            j = nbmat(i,ik)
            ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
            gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
            gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
            hsmat(index_B,index_G,1) = hsmat(index_B,index_G,1) + 0.5 & !f  hsmat(i,i,1) = hsmat(i,i,1) + 0.5 &
                 & * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
                 & +  ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
         end if
      end do
!!$      do jj = ista_G_g1k(ik), iend_G_g1k(ik)
!!$      do i  = ista_B_g1k(ik), iend_B_g1k(ik)
!!$       if( i == jj) then
!!$         index_B =  i-ista_B_g1k(ik)+1
!!$         index_G = jj-ista_G_g1k(ik)+1
!!$         j = nbmat(i,ik)
!!$         ga = vkxyz(ik,1,BUCS) + ngabc(j,1)
!!$         gb = vkxyz(ik,2,BUCS) + ngabc(j,2)
!!$         gc = vkxyz(ik,3,BUCS) + ngabc(j,3)
!!$         hsmat(index_B,index_G,1) = hsmat(index_B,index_G,1) + 0.5 &
!!$              & * (ttr(1)*ga*ga + ttr(2)*gb*gb + ttr(3)*gc*gc &
!!$              & +  ttr(4)*ga*gb + ttr(5)*gb*gc + ttr(6)*gc*ga)
!!$       endif
!!$      end do; end do
                                                  __TIMER_DO_STOP(1319)
                                                  __TIMER_SUB_STOP(1208)
    end subroutine amtrxkinetic

    subroutine prjvlhxc_l2vlhxc_t()
      integer :: i,irc
                                                  __TIMER_SUB_START(1209)
      vlhxc = 0.d0
                                                  __TIMER_DO_START(1320)
      do irc = 1, kimg
         do i = ista_kngp, min(iend_kngp,nmatsz2)
            vlhxc(i,irc) = vlhxc_l(i,irc,ispin)
         end do
      end do
                                                  __TIMER_DO_STOP(1320)
      if(npes >= 2) then
                                                  __TIMER_COMM_START_w_BARRIER(mpi_chg_world,1276)
         call mpi_allreduce(MPI_IN_PLACE,vlhxc,nmatsz2*kimg,mpi_double_precision &
!f              &            ,mpi_sum,mpi_comm_group,ierr)
              &            ,mpi_sum,mpi_chg_world,ierr)
                                                  __TIMER_COMM_STOP(1276)
      end if
                                                  __TIMER_SUB_STOP(1209)
    end subroutine prjvlhxc_l2vlhxc_t

    subroutine amtrxlocalpt()
      integer :: j,j1,l1,l2,l3,i,n,ip
      real(kind=DP),pointer,dimension(:,:,:) :: a
      integer,      pointer,dimension(:,:)   :: ng

      real(kind=DP),allocatable,dimension(:,:,:)   :: a_wk
      integer :: ista, index_B, index_G, k, mpi_comm

      a  => hsmat
      ng => ngabc
                                                  __TIMER_SUB_START(1210)

      mpi_comm = mpi_k_world(myrank_k)
      allocate(a_wk(nmatsz,nmatsz,kimg)); a_wk = 0.d0
                                                  __TIMER_DO_START(1321)
      do j = ista_G_g1k(ik), iend_G_g1k(ik)                              !f do j = 1, iba2(ik)
         j1 = nbmat(j,ik)
         l1 = ng(j1,1); l2 = ng(j1,2); l3 = ng(j1,3)
         ista = max(j,ista_B_g1k(ik))
         if(kimg == 1) then
            do i = ista, iend_B_g1k(ik)                                  !f  do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               index_B = i-ista_B_g1k(ik)+1
               index_G = j-ista_G_g1k(ik)+1
               a(index_B,index_G,1) = a(index_B,index_G,1) + vlhxc(ip,1) !f    a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
            end do
         else
            do i = ista, iend_B_g1k(ik)                                  !f  do i = j, iba2(ik)
               n = nbmat(i,ik)
               ip = igpo(ng(n,1)-l1,ng(n,2)-l2,ng(n,3)-l3)
               index_B = i-ista_B_g1k(ik)+1
               index_G = j-ista_G_g1k(ik)+1
               a(index_B,index_G,1) = a(index_B,index_G,1) + vlhxc(ip,1) !f    a(i,j,1) = a(i,j,1) + vlhxc(ip,1)
               a(index_B,index_G,2) = a(index_B,index_G,2) + vlhxc(ip,2) !f    a(i,j,2) = a(i,j,2) + vlhxc(ip,2)
            end do
         end if
      end do
                                                  __TIMER_DO_STOP(1321)

                                                  __TIMER_DO_START(1322)
      do k = 1, kimg
      do j = ista_G_g1k(ik), iend_G_g1k(ik)
      do i = ista_B_g1k(ik), iend_B_g1k(ik)
         index_G = j-ista_G_g1k(ik)+1
         index_B = i-ista_B_g1k(ik)+1
         a_wk(i,j,k) = a(index_B,index_G,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1322)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1277)
      call mpi_allreduce(MPI_IN_PLACE,a_wk,nmatsz*nmatsz*kimg, mpi_double_precision, mpi_sum, mpi_comm,ierr)
                                                  __TIMER_COMM_STOP(1277)

                                                  __TIMER_DO_START(1323)
      do k = 1, kimg
         l1 = 3 -2*k
         do j = 2, iba2(ik)
         do i = 1, j-1
            a_wk(i,j,k) = l1*a_wk(j,i,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1323)

                                                  __TIMER_DO_START(1324)
      do k = 1, kimg
      do j = ista_G_g1k(ik), iend_G_g1k(ik)
      do i = ista_B_g1k(ik), iend_B_g1k(ik)
         index_G = j-ista_G_g1k(ik)+1
         index_B = i-ista_B_g1k(ik)+1
         a(index_B,index_G,k) = a_wk(i,j,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1324)
      deallocate(a_wk)
                                                  __TIMER_SUB_STOP(1210)
    end subroutine amtrxlocalpt

    subroutine lhl

      integer :: i,j,k, index_B, index_G, n, mpi_comm
      real(kind=DP),allocatable,dimension(:,:,:) :: ww, h_wk1, linv_wk

                                                  __TIMER_SUB_START(1211)
      mpi_comm = mpi_k_world(myrank_k)
      allocate(ww(nmatsz,nmatsz,kimg)); ww = 0.d0
      allocate(h_wk1(nmatsz,np_G_g1k(ik),kimg)); h_wk1 = 0.0d0
      allocate(linv_wk(nmatsz,np_B_g1k(ik),kimg)); linv_wk = 0.0d0

                                                  __TIMER_DO_START(1325)
      do k = 1, kimg
      do j = ista_B_g1k(ik), iend_B_g1k(ik)
      do i = ista_G_g1k(ik), iend_G_g1k(ik)
         index_B = j-ista_B_g1k(ik)+1
         index_G = i-ista_G_g1k(ik)+1
         linv_wk(i,index_B,k) = linv(index_G,index_B,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1325)
      n = nmatsz*np_B_g1k(ik)*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_world,1278)
      call mpi_allreduce(MPI_IN_PLACE, linv_wk, n, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1278)

      if(kimg == 1) then
                                                  __TIMER_DO_START(1326)
         do i = 1, iba2(ik)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)                !f            do j = 1, iba2(ik)
               do k = ista_B_g1k(ik), min(i,iend_B_g1k(ik))      !f               do k = 1, i
                  index_B = k-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  ww(i,j,1) = ww(i,j,1) + linv_wk(i,index_B,1)*hsmat(index_B,index_G,1)
!f                                                           ww(i,j,1) = ww(i,j,1) + linv(i,k,1)*h(k,j,1)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1326)

         n = nmatsz*nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1279)
         call mpi_allreduce(MPI_IN_PLACE, ww, n, mpi_double_precision, mpi_sum, mpi_comm, ierr)
                                                  __TIMER_COMM_STOP(1279)

         h_wk1 = 0.0d0                                            !f        h = 0.d0
                                                  __TIMER_DO_START(1327)
         do i = 1, iba2(ik)
           do j = ista_G_g1k(ik), iend_G_g1k(ik)                  !f        do j = 1, iba2(ik)
               do k = ista_B_g1k(ik), min(j,iend_B_g1k(ik) )      !f          do k = 1, j
                  index_B = k-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  h_wk1(i,index_G,1) = h_wk1(i,index_G,1) + ww(i,k,1)*linv(index_G,index_B,1)
!f                  h(i,j,1) = h(i,j,1) + ww(i,k,1)*linv(j,k,1)
               end do
            end do
         end do 
                                                  __TIMER_DO_STOP(1327)
         n = nmatsz*np_G_g1k(ik)*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1280)
         call mpi_allreduce(MPI_IN_PLACE, h_wk1, n, mpi_double_precision, mpi_sum, mpi_kg_world, ierr)
                                                  __TIMER_COMM_STOP(1280)

      else if(kimg == 2) then
                                                  __TIMER_DO_START(1328)
      do j = ista_B_g1k(ik), iend_B_g1k(ik)
      do i = ista_G_g1k(ik), iend_G_g1k(ik)
         index_B = j-ista_B_g1k(ik)+1
         index_G = i-ista_G_g1k(ik)+1
         h_wk1(j,index_G,1) = hsmat(index_B,index_G,1)
      end do; end do
                                                  __TIMER_DO_STOP(1328)
      n = nmatsz*np_G_g1k(ik)
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1281)
      call mpi_allreduce(MPI_IN_PLACE, h_wk1, n, mpi_double_precision, mpi_sum, mpi_kg_world, ierr)
                                                  __TIMER_COMM_STOP(1281)

                                                  __TIMER_DO_START(1329)
         do i = 1, iba2(ik)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)                 !f        do j = 1, iba2(ik)
               do k = ista_B_g1k(ik), min(i,iend_B_g1k(ik))       !f           do k = 1, i
                  index_B = k-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  ww(i,j,1) = ww(i,j,1) + linv_wk(i,index_B,1)*hsmat(index_B,index_G,1)  &
     &                                  - linv_wk(i,index_B,2)*hsmat(index_B,index_G,2)
                  ww(i,j,2) = ww(i,j,2) + linv_wk(i,index_B,1)*hsmat(index_B,index_G,2)  &
!     &                                 + linv_wk(i,index_B,2)*hsmat(index_B,index_G,1)
     &                                  + linv_wk(i,index_B,2)*h_wk1(i,index_G,1)
!f                  ww(i,j,1) = ww(i,j,1)+linv(i,k,1)*h(k,j,1)-linv(i,k,2)*h(k,j,2)
!f                  ww(i,j,2) = ww(i,j,2)+linv(i,k,1)*h(k,j,2)+linv(i,k,2)*h(i,j,1)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1329)
         n = nmatsz*nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1282)
         call mpi_allreduce(MPI_IN_PLACE, ww, n, mpi_double_precision, mpi_sum, mpi_comm, ierr)
                                                  __TIMER_COMM_STOP(1282)
         h_wk1 = 0.0d0
                                                  __TIMER_DO_START(1330)
         do i = 1, iba2(ik)
            do j = ista_G_g1k(ik), iend_G_g1k(ik)                 !f        do j = 1, iba2(ik)
               do k = ista_B_g1k(ik), min(j,iend_B_g1k(ik))       !f           do k = 1, j
                  index_B = k-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  h_wk1(i,index_G,1) = h_wk1(i,index_G,1) + ww(i,k,1)*linv(index_G,index_B,1) &
       &                                                  + ww(i,k,2)*linv(index_G,index_B,2)
                  h_wk1(i,index_G,2) = h_wk1(i,index_G,2) + ww(i,k,2)*linv(index_G,index_B,1) &
       &                                                  - ww(i,k,1)*linv(index_G,index_B,2)
!f                  h(i,j,1) = h(i,j,1)+ww(i,k,1)*linv(j,k,1)+ww(i,k,2)*linv(j,k,2)
!f                  h(i,j,2) = h(i,j,2)+ww(i,k,2)*linv(j,k,1)-ww(i,k,1)*linv(j,k,2)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1330)

         n = nmatsz*np_G_g1k(ik)*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1283)
         call mpi_allreduce(MPI_IN_PLACE, h_wk1, n, mpi_double_precision, mpi_sum, mpi_kg_world, ierr)
                                                  __TIMER_COMM_STOP(1283)
      end if

      hsmat = 0.0d0
                                                  __TIMER_DO_START(1331)
      do k = 1, kimg
      do j = ista_G_g1k(ik), iend_G_g1k(ik)
      do i = ista_B_g1k(ik), iend_B_g1k(ik)
         index_G = j-ista_G_g1k(ik)+1
         index_B = i-ista_B_g1k(ik)+1
         hsmat(index_B,index_G,k) = h_wk1(i,index_G,k)
      end do; end do; end do
                                                  __TIMER_DO_STOP(1331)

      deallocate(ww)
      deallocate(h_wk1)
      deallocate(linv_wk)
                                                  __TIMER_SUB_STOP(1211)
    end subroutine lhl

    subroutine lx()

#ifdef HIUX
! *** 'poption''s have been inserted by Dr. Kino (National Institute  ***
! *** for Materials Science, Japan).  12 July 2005                    ***
#endif
      integer :: ib, ib2, i, j, k, isize
      real(kind=DP),allocatable,dimension(:,:,:)  :: linv_wk
      integer :: index_G, index_B
                                                  __TIMER_SUB_START(1212)
      allocate(linv_wk(np_G_g1k(ik),nmatsz,kimg));linv_wk = 0.0d0
!
                                                  __TIMER_DO_START(1332)
         do k = 1, kimg
            do i = ista_G_g1k(ik), iend_G_g1k(ik)
               do j = ista_B_g1k(ik), iend_B_g1k(ik)
                  index_G = i-ista_G_g1k(ik)+1
                  index_B = j-ista_B_g1k(ik)+1
                  linv_wk(index_G,j,k) = linv(index_G,index_B,k)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1332)
         isize = np_G_g1k(ik)*nmatsz*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_kg_world,1264)
         call mpi_allreduce(MPI_IN_PLACE,linv_wk,isize,mpi_double_precision,mpi_sum, mpi_kg_world,ierr)
                                                  __TIMER_COMM_STOP(1264)

      if(kimg == 1) then
         do ib = ista_e, iend_e, istep_e
            ib2 = ib - ista_e +1                       !f        ib2 = map_z(ib)
                                                  __TIMER_DO_START(1333)
            do i = ista_G_g1k(ik), iend_G_g1k(ik)      !f        do i = 1, iba2(ik)
               index_G = i-ista_G_g1k(ik)+1
               ldag(index_G,1) = zaj_mat(i,ib2,1)      !f           ldag(i,1) = zaj_mat(i,ib2,1)
            end do
                                                  __TIMER_DO_STOP(1333)
            zaj_mat(:,ib2,1) = 0.d0
                                                  __TIMER_DO_START(1334)
            do i = 1, iba2(ik)
!            do i = ista_B_g1k(ik), iend_B_g1k(ik)
               do j = ista_G_g1k(ik), iend_G_g1k(ik)   !f        do j = 1, iba2(ik)
                  index_B = i-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv_wk(index_G,i,1)*ldag(index_G,1)
               end do
            end do
                                                  __TIMER_DO_STOP(1334)
         end do

      else if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
            ib2 = ib - ista_e +1                       !f           ib2 = map_z(ib)
            if(iba2(ik) > nmatsz)  stop ' iba2(ik) > nmatsz'
                                                  __TIMER_DO_START(1335)

            do i = ista_G_g1k(ik), iend_G_g1k(ik)      !f        do i = 1, iba2(ik)
               index_G = i-ista_G_g1k(ik)+1
               ldag(index_G,1) = zaj_mat(i,ib2,1)      !f           ldag(i,1) = zaj_mat(i,ib2,1)
               ldag(index_G,2) = zaj_mat(i,ib2,2)      !f           ldag(i,2) = zaj_mat(i,ib2,2)
            end do
                                                  __TIMER_DO_STOP(1335)
            zaj_mat(:,ib2,1:2) = 0.d0
                                                  __TIMER_DO_START(1336)
            do i = 1, iba2(ik)
               do j = ista_G_g1k(ik), iend_G_g1k(ik)   !f        do j = i, iba2(ik)
                  index_B = i-ista_B_g1k(ik)+1
                  index_G = j-ista_G_g1k(ik)+1
                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) &
                       &        + linv_wk(index_G,i,1)*ldag(index_G,1) + linv_wk(index_G,i,2)*ldag(index_G,2)
                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) &
                       &        + linv_wk(index_G,i,1)*ldag(index_G,2) - linv_wk(index_G,i,2)*ldag(index_G,1)
!f                  zaj_mat(i,ib2,1) = zaj_mat(i,ib2,1) + linv(j,i,1)*ldag(j,1) + linv(j,i,2)*ldag(j,2)
!f                  zaj_mat(i,ib2,2) = zaj_mat(i,ib2,2) + linv(j,i,1)*ldag(j,2) - linv(j,i,2)*ldag(j,1)
               end do
            end do
                                                  __TIMER_DO_STOP(1336)
         end do
      end if

         isize = nmatsz*np_e*kimg
                                                  __TIMER_COMM_START_w_BARRIER(mpi_ke_group,1285)
         call mpi_allreduce(MPI_IN_PLACE, zaj_mat, isize, mpi_double_precision, mpi_sum, mpi_ke_world, ierr)
                                                  __TIMER_COMM_STOP(1285)

      deallocate(linv_wk)
                                                  __TIMER_SUB_STOP(1212)
    end subroutine lx

    subroutine phase_mult()

      integer :: ib, ib2, ig
      real(kind=DP) :: wfr,wfi,sqrwf, pcos,psin
#ifndef _PHASE_MULT_0_
      integer :: ig1, ig2, ig_max 
      complex(kind=CMPLDP) :: exp2theta, exptheta
      real(kind=DP) :: sqrwf0, wfr2, wfi2, sqrwfi, sqrwf1, sqrwf2,f &
           &          ,phase2r, phase2i, cos2theta, pcos0,psin0, norm
      real(kind=DP), parameter :: abswf_min = 1.d-16
#endif
                                                  __TIMER_SUB_START(1213)
      
!!$      do ig = 1, nmatsz
      if(kimg == 2) then
         do ib = ista_e, iend_e, istep_e
!f            ib2 = map_z(ib)
            ib2 = ib - ista_e +1
#ifdef _PHASE_MULT_0_
            wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
            if(abs(wfi*wfi) > 1.d-30) then
               sqrwf = wfr**2 + wfi**2
               f = dsqrt(sqrwf)
               pcos = -wfr/f; psin = wfi/f
               if(iprimatdiagon >= 2) write(nfout,'(4x," pcos, psin = ",2e14.6)') pcos, psin
                                                  __TIMER_DO_START(1337)
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
                                                  __TIMER_DO_STOP(1337)
            end if
#else
            wfi = zaj_mat(1,ib2,2)
            sqrwfi = wfi*wfi
            if(sqrwfi > 1.d-35) then
               wfr = zaj_mat(1,ib2,1)
               sqrwf0 = wfr**2 + sqrwfi
!!$               if(sqrwf0 > abswf_min) then
               if(sqrwfi > abswf_min) then
                  ig_max = 1
               else
                  ig_max = 1
                  g_search: do ig = 2, kg2_gamma
                     ig1 = nbase_gamma(ig,1)
                     wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                     sqrwfi = wfi*wfi
                     sqrwf = wfr**2 + sqrwfi
                     if(sqrwfi > abswf_min) then
                        ig_max = ig
                        exit g_search
                     else
                        if(sqrwf > sqrwf0) then
                           ig_max = ig
                           sqrwf0 = sqrwf
                        end if
                     end if
                  end do g_search
               end if
               if(ig_max == 1) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos = -wfr/f; psin = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf = ",e14.6)') sqrwf0
                  end if
               else if(ig_max >= 2) then
                  wfr = zaj_mat(1,ib2,1); wfi = zaj_mat(1,ib2,2)
                  sqrwf0 = wfr**2 + wfi**2
                  f = dsqrt(sqrwf0)
                  pcos0 = -wfr/f; psin0 = wfi/f
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig =  0")') pcos0, psin0
                  end if
                  ig1 = nbase_gamma(ig_max,1)
                  ig2 = nbase_gamma(ig_max,2)
                  wfr  = zaj_mat(ig1,ib2,1);  wfi  = zaj_mat(ig1,ib2,2)
                  wfr2 = zaj_mat(ig2,ib2,1);  wfi2 = zaj_mat(ig2,ib2,2)
                  sqrwf1 = wfr**2 + wfi**2
                  sqrwf2 = wfr2**2 + wfi2**2
                  sqrwf = sqrt(sqrwf1*sqrwf2)
                  phase2r =  (wfr*wfr2 - wfi*wfi2)/sqrwf
                  phase2i = -(wfr*wfi2 + wfr2*wfi)/sqrwf
                  norm = sqrt(phase2r*phase2r + phase2i*phase2i)
                  phase2r = phase2r/norm
                  phase2i = phase2i/norm
                  exp2theta = dcmplx(phase2r,phase2i)
                  exptheta = sqrt(exp2theta)
                  pcos = real(exptheta)
                  psin = imag(exptheta)
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                     write(nfout,'(4x," sqrwf1, sqrwf2, sqrwf = ",3e14.6)') sqrwf1, sqrwf2, sqrwf
                  end if
                  cos2theta = (wfr*wfr2 - wfi*wfi2)/sqrwf
                  cos2theta = cos2theta/norm
                  if(cos2theta > 1.0) cos2theta = 1.d0
                  if(cos2theta < -1.0) then
                     pcos = 0.d0
                     psin = 1.d0
                  else
                     pcos =  sqrt((1+cos2theta)/2.0)
                     psin =  sqrt((1-cos2theta)/2.0)
                  end if
                  if(pcos0 < 0.0) pcos = - pcos
                  if(psin0 < 0.0) psin = - psin 
                  if(iprimatdiagon >= 2) then
                     write(nfout,'(4x," pcos, psin = ",2e14.6, " ig_max = ",i5 )') pcos, psin,ig_max
                  end if
               end if
                                                  __TIMER_DO_START(1338)
               do ig = 1, iba2(ik)
                  wfr = zaj_mat(ig,ib2,1); wfi = zaj_mat(ig,ib2,2)
                  zaj_mat(ig,ib2,1) = pcos*wfr - psin*wfi
                  zaj_mat(ig,ib2,2) = pcos*wfi + psin*wfr
               end do
                                                  __TIMER_DO_STOP(1338)
               zaj_mat(1,ib2,2) = 0.d0
!!            !$else
!!            !$   do ig = 2, kg2_gamma
!!            !$      ig1 = nbase_gamma(ig,1)
!!            !$      wfr = zaj_mat(ig1,ib2,1)
!!            !$      sqrwf = sqrwf + wfr**2
!!            !$   end do
!!            !$   sqrwf = 2.d0*sqrwf + zaj_mat(1,ib2,1)**2
!!            !$   sqrwf = 1.d0/sqrt(sqrwf)
!!            !$   do ig = 1, iba2(ik)
!!            !$      wfr = zaj_mat(ig,ib2,1)
!!            !$      zaj_mat(ig,ib2,1) = wfr*sqrwf
!!            !$      zaj_mat(ig,ib2,2) = 0.d0
!!            !$   end do
            end if
#endif
            if(iprimatdiagon >=2 ) then
               write(nfout,'(i4," Re ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),1),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),1),ig=6,40)
               write(nfout,'(i4," Im ",5e14.6)') ib, (zaj_mat(ig,map_z(ib),2),ig=1,5)
               write(nfout,'(8x,5e14.6)') (zaj_mat(ig,map_z(ib),2),ig=6,40)
            end if
         end do

         if(k_symmetry(ik) == GAMMA_base_symmetrization) then
                                                  __TIMER_DO_START(1339)
            do ib = ista_e, iend_e, istep_e
!f               ib2 = map_z(ib)
               ib2 = ib - ista_e + 1
               do ig = 2, kg2_gamma
                  ig1 = nbase_gamma(ig,1)
                  ig2 = nbase_gamma(ig,2)
                  wfr = zaj_mat(ig1,ib2,1); wfi = zaj_mat(ig1,ib2,2)
                  zaj_mat(ig2,ib2,1) = wfr
                  zaj_mat(ig2,ib2,2) = -wfi
               end do
            end do
                                                  __TIMER_DO_STOP(1339)
         end if
      end if
      if(iprimatdiagon >= 2) write(nfout,'(" out of <<phase_mult>>")')
                                                  __TIMER_SUB_STOP(1213)
    end subroutine phase_mult

    subroutine cp_zaj_mat_to_zaj_l()
      integer :: ib,ig, i, l, j, is
      real(kind=DP),allocatable, dimension(:,:,:):: zaj_l_wk
                                                  __TIMER_SUB_START(1214)
      allocate(zaj_l_wk(kg1,np_e,kimg)) ; zaj_l_wk = 0.d0
      if(k_symmetry(ik) == GAMMA) then
                                                  __TIMER_DO_START(1340)
         do l = 1, kimg
            do ib = 1, np_e
               do i = 1, kg2_gamma
                  ig = nbase(i,ik)
                  zaj_l_wk(i,ib,l) = zaj_mat(ig,ib,l)     !f       zaj_l(i,ib,ik,l) = zaj_mat(ig,ib,l)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1340)
      else
                                                  __TIMER_DO_START(1342)
         do l = 1, kimg
            do ib = 1, np_e
               do i = 1, iba2(ik)
                  ig = nbmat2(i,ik)
                  zaj_l_wk(ig,ib,l) = zaj_mat(i,ib,l)     !f       zaj_l(ig,ib,ik,l) = zaj_mat(i,ib,l)
               end do
            end do
         end do
                                                  __TIMER_DO_STOP(1342)
      end if
                                                  __TIMER_DO_START(1344)
   do l = 1, kimg
      zaj_l(:,:,ik,l) = 0.d0
   do j = 1, np_e
   do i = 1, np_g1k(ik)
        is = nis_g1k(myrank_g,ik) + i-1
        zaj_l(i,j,ik,l) = zaj_l_wk(is,j,l)
   enddo; enddo; enddo
                                                  __TIMER_DO_STOP(1344)

#ifdef SAVE_FFT_TIMES
  if(sw_save_fft == ON) then
     do j = 1, np_e
        status_saved_phifftr(j,ik) = OLD
     end do
  end if
#endif
    deallocate(zaj_l_wk)
                                                  __TIMER_SUB_STOP(1214)
    end subroutine cp_zaj_mat_to_zaj_l
            
    subroutine solve_Hx_eq_ex_ScaLAPACK()

      integer ::                          n, ne, ne_found, il, iu, info, i, j, ib, k, ib_wk, NZ
      real(kind=DP) ::                    abstol, vl, vu, sum, dlamch, ORFAC
      integer,allocatable ::              ifail(:), iwork(:),    ICLUSTR(:)
      real(kind=DP),allocatable ::        evec(:),  rwork(:),    rvmat_l(:,:)
      complex(kind=CMPLDP),allocatable :: cmat(:,:),  cwork(:)
      complex(kind=CMPLDP),parameter ::   IMG = (0.d0,1.d0)

      real(kind=DP),allocatable ::        WORK(:),GAP(:)
#ifdef _FJ_DBG0_
      integer ::                          iiii,jjjj
#endif
                                                  __TIMER_SUB_START(1471)
      zaj_mat(:,:,:) = 0.d0
!      lda = nmatsz
      !!$ vl = -1.d10 ; vu = 1.d10 ; il = ista_e ; iu = iend_e
      vl = -1.d10 ; vu = 1.d10 ; il = 1 ; iu = neg
      ne = iu - il + 1

      abstol = 2*dlamch('S')

      if (kimg == 1) then
         n = iba2(ik)
        !+++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),ifail(n))
        !+++++++++++++++++++++++++++++++++++++++++++++++++
        is = 1; ie = nmatsz

        allocate(RWORK(lwork1))
        allocate(IWORK(liwork1))
        allocate(hsmat1(lda,occ));hsmat1 = 0.0d0
        allocate(hsmat2(lda,occ));hsmat1 = 0.0d0
        allocate(rvmat_l(lda,occ)); rvmat_l = 0.0d0
        allocate(GAP(nsclrow_md*nsclcol_md))
        allocate(ICLUSTR(2*nsclrow_md*nsclcol_md))

        if(modnrm == EXECUT) then
           call trans_scalapack( block_size, hsmat, hsmat1, &
       &                        maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
           call trans_scalapack( block_size, hsmat_s, hsmat2, &
       &                        maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
           ORFAC = 0.001
           ABSTOL = 2*DLAMCH('S')
                                                  __TIMER_DO_START(1479)
        if (myrow /= -1) then
           CALL PDSYGVX( 1,'V', 'I', 'U', nmatsz_opt, hsmat1, 1, 1, DESCA, hsmat2, 1, 1,                   &
     &                 DESCA, VL, VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvmat_l, 1, 1, &
     &                 DESCZ, RWORK, lwork1, IWORK, liwork1, IFAIL,                   &
     &                 ICLUSTR, GAP, INFO)
        endif
                                                  __TIMER_DO_STOP(1479)
        else
           call trans_scalapack( block_size, hsmat, hsmat1, &
       &                        maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
           ORFAC = 0.001
           ABSTOL = 2*DLAMCH('S')
                                                  __TIMER_DO_START(1480)
        if (myrow /= -1) then
           CALl PDSYEVX( 'V', 'I', 'U', nmatsz_opt, hsmat1, 1, 1, DESCA, VL,                &
     &                    VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvmat_l, 1,        &
     &                    1, DESCZ, RWORK, lwork1, IWORK, liwork1, IFAIL,               &
     &                    ICLUSTR, GAP, INFO )
        endif
                                                  __TIMER_DO_STOP(1480)
        endif

        call trans_scalapack_r( block_size, rvmat_l, zaj_mat, &
     &                     maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)

            if (nrank_e*nrank_g /= nsclcol_md*nsclrow_md) then
               call eigsend(evec,n)
            end if

         if(iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_ScaLAPACK): ik = ",i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
!!$            a = "     "
!!$            do ib = ista_e, iend_e, istep_e
!f               write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
!f                    & ib,ik,evec(ib),a,(rvmat(i,ib),i=1,5)
!x               write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
!x                    & ib,ik,evec(ib),a,(amat(i,ib),i=1,5)
!!$            end do
         end if
!x         if (ne_found /= ne) then
!x            write(*,*) '### ERROR ### ne_found != ne'
!x            write(*,*) '   ne_found ...',ne_found
!x            write(*,*) '   ne       ...',ne
!x            stop
!x         end if
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
                                                  __TIMER_DO_START(1481)
         do ib = ista_e, iend_e, istep_e
!f            j = map_z(ib)
            j = ib - ista_e +1
            ib_wk = neg_g(j)
            do i = 1,n
!f               zaj_mat(i,j,1) = rvmat(i,ib)
!f               zaj_mat(i,j,1) = rvmat(i,ib_wk)
!aa               zaj_mat(i,j,1) = amat(i,ib_wk)
               !!$ zaj_l(i,j,ik,1) = rvmat(i,ib-ista_e+1) ! M.Okamoto (August 22,2003)
            end do
!f            eko_l(j,ik) = evec(ib)
            eko_l(j,ik) = evec(ib_wk)
            !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
                                                  __TIMER_DO_STOP(1481)
         if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++
         deallocate(RWORK)
         deallocate(hsmat1,hsmat2)
         deallocate(rvmat_l)
         deallocate(GAP,ICLUSTR)
        !+++++++++++++++++++++++++++++
      else if (kimg == 2) then
         n = iba2(ik)
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         allocate(evec(n),ifail(n))
         evec = 0.d0;  ifail = 0
        !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

         is = 1; ie = nmatsz

        allocate(CWORK(lwork2))
        allocate(RWORK(lrwork2))
        allocate(IWORK(liwork2))
        allocate(hsmat1(lda*kimg,occ)); hsmat1 = 0.0d0
        allocate(hsmat2(lda*kimg,occ)); hsmat2 = 0.0d0
        allocate(rvmat_l(lda*kimg,occ)); rvmat_l = 0.0d0
        allocate(GAP(nsclrow_md*nsclcol_md))
        allocate(ICLUSTR(2*nsclrow_md*nsclcol_md))

        if(modnrm == EXECUT) then
           call trans_scalapack( block_size, hsmat, hsmat1, &
       &                        maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
           call trans_scalapack( block_size, hsmat_s, hsmat2, &
       &                     maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
           ORFAC = 0.001
           ABSTOL = 2*DLAMCH('S')
                                                  __TIMER_DO_START(1482)
        if (myrow /= -1) then
           CALL PZHEGVX( 1,'V', 'I', 'U', nmatsz_opt, hsmat1, 1, 1, DESCA, hsmat2, 1, 1,                   &
     &              DESCA, VL, VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvmat_l, 1, 1, &
     &              DESCZ, CWORK, lwork2, RWORK, lrwork2, IWORK, liwork2, IFAIL,                   &
     &              ICLUSTR, GAP, INFO)
        endif
                                                  __TIMER_DO_STOP(1482)
        else
           call trans_scalapack( block_size, hsmat, hsmat1, &
       &                        maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)
                                                  __TIMER_DO_START(1483)
           ORFAC = 0.001
           ABSTOL = 2*DLAMCH('S')
        if (myrow /= -1) then
           CALL PZHEEVX( 'V', 'I', 'U', nmatsz_opt, hsmat1, 1, 1, DESCA, VL,                         &
     &                    VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvmat_l, 1,            &
     &                    1, DESCZ, CWORK, lwork2, RWORK, lrwork2, IWORK,            &
     &                    liwork2, IFAIL, ICLUSTR, GAP, INFO )
        endif
                                                  __TIMER_DO_STOP(1483)
        endif

        call trans_scalapack_r( block_size, rvmat_l, zaj_mat, &
     &                     maxval(np_B_g1k), maxval(np_G_g1k), lda, occ)

            if (nrank_e*nrank_g /= nsclcol_md*nsclrow_md) then
               call eigsend(evec,n)
            end if

#ifdef _FJ_DBG0_
       if(mype .eq. 0) then
            write(1002,'("evec")')
            write(1002,'(5f10.7)') (evec(iiii),iiii=1,neg)

            write(1002,'("zaj_mat:kimg=1")')
            do iiii = 1, nb_mgs
               write(1002,'("iiii=",i4)') iiii
               write(1002,'(8(f10.7))') (zaj_mat(jjjj,iiii,1),jjjj=1,200)
            enddo

            write(1002,'("zaj_mat:kimg=2")')
            do iiii = 1, nb_mgs
               write(1002,'("iiii=",i4)') iiii
               write(1002,'(8(f10.7))') (zaj_mat(jjjj,iiii,2),jjjj=1,200)
            enddo
!            write(1002,'("rvmat_l:kimg=1")')
!            do iiii = 1, occ
!               write(1002,'("iiii=",i4)') iiii
!               write(1002,'(8(f10.8))') (rvmat_l(jjjj,iiii),jjjj=1,lda*kimg,1)
!            enddo
!            write(1002,'("rvmat_l:kimg=2")')
!            do iiii = 1, occ
!               write(1002,'("iiii=",i4)') iiii
!               write(1002,'(8(f10.8))') (rvmat_l(jjjj,iiii),jjjj=1,lda*kimg,2)
!            enddo
        endif
#endif

         if(iprimatdiagon >= 2) then
            write(nfout,'(" --- eigen values (solve_Hx_eq_ex_ScaLAPACK): ik = ",i8)') ik
            write(nfout,'(8f10.6)') (evec(i),i=1,ne)
         end if
!x         if (ne_found /= ne) then
!x            write(*,*) '### ERROR ### ne_found != ne'
!x            write(*,*) '   ne_found ...',ne_found
!x            write(*,*) '   ne       ...',ne
!x            stop
!x         end if
      if (myrow /= -1) then
         if (info /= 0) then
            write(*,*) '### ERROR ### info /= 0'
            write(*,*) '   info ...',info
            stop
         end if
      endif
                                                  __TIMER_DO_START(1484)
         do ib = ista_e, iend_e, istep_e
            j = ib - ista_e +1              !f      j = map_z(ib)
            ib_wk = neg_g(j)
            eko_l(j,ik) = evec(ib_wk)       !f      eko_l(j,ik) = evec(ib)
            !!$ eko_l(j,ik) = evec(ib-ista_e+1) ! M.Okamoto (August 22,2003)
         end do
                                                  __TIMER_DO_STOP(1484)
           if(af/=0) eko_l(:,ik+1) = eko_l(:,ik)
        !+++++++++++++++++++++++++++++++++++
          deallocate(RWORK,CWORK)
          deallocate(hsmat1,hsmat2)
          deallocate(rvmat_l)
          deallocate(GAP,ICLUSTR)
        !+++++++++++++++++++++++++++++++++++
      end if
      if(iprimatdiagon >= 2) call wd_CalculatedEigenvalues(nfout,ik,n,ne,evec,"solve_Hx_eq_ex")

      sum = 0.d0
      do i = 1,ne
         sum = sum + abs(evec(i))
      end do
      if (sum < SmallestPositiveNumber*1.d5) stop ' ! illegal evec (solve_Hx_eq_ex)'
      if (iprimatdiagon >= 2) write(nfout,'(" -- sum = ",f20.8)') sum
     !+++++++++++++++++++++++++++++
      deallocate(evec,iwork,ifail)
     !+++++++++++++++++++++++++++++
                                                  __TIMER_SUB_STOP(1471)
    end subroutine solve_Hx_eq_ex_ScaLAPACK

  subroutine set_nprow_npcol(nsclrow_md,nsclcol_md)
    integer, intent(inout) :: nsclrow_md,nsclcol_md

!      if(printable) write(nfout,'("set nprow,npcol,block_size=",3i5)') nsclrow_md,nsclcol_md,block_size
      write(nfout,'("set nprow,npcol,block_size=",3i5)') nsclrow_md,nsclcol_md,block_size;call flush(nfout)
!      nprow = nrank_g
!      npcol = nrank_e
!      nprow = 1
!      npcol = nrank_e*nrank_g

!   if(nprow /= nrank_e) then
!      nprow = 1
!      npcol = nrank_e
!      if(printable) write(nfout,'("set nprow,npcol=",2i5)') nprow,npcol
!   else
!       if(iprisubmat >= 2) write(nfout,'("nprow,npcol=",2i5)') nprow,npcol
!   end if
  end subroutine set_nprow_npcol

  subroutine scalapack_setup_3D(ndim,lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol,desca,descz,usermap)
    integer, intent(in) :: ndim
    integer, intent(out) :: lwork1,lrwork1,liwork1,lwork2,lrwork2,liwork2,lda,occ,ictxt,myrow,mycol
    integer, dimension(9), intent(out) :: desca,descz
    integer, intent(inout) :: usermap(nprow_md,npcol_md)

    integer :: i,j, nb, np0,nq0, iam,nprocs,info
    integer, external :: indxg2l, indxg2p, numroc, iceil, pjlaenv
    integer, parameter :: BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1, &
     &                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6, &
     &                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9
    integer :: id_sname = -1
!fj+
    integer     :: lwork0,lrwork0,liwork0
    integer     :: itmp(1)
    real(DP)    :: rtmp(1)
    complex(DP) :: ctmp(1)
    complex(DP) :: htmp1(1),htmp2(1),rvtmp1(1)
    real(DP)    :: htmp1r(1),htmp2r(1),rvtmp1r(1)
    real(DP)    :: GAP(1),evec(1)
    integer     :: ICLUSTR(1),IFAIL(1),NZ,ne_found
    real(DP)    :: ORFAC,ABSTOL,VL,VU
!fj-
   integer      :: nn
                                                  __TIMER_SUB_START(1472)
    call tstatc0_begin('scalapack_setup ', id_sname)

    lwork1  = 0
    lrwork1 = 0
    liwork1 = 0
    lwork2  = 0
    lrwork2 = 0
    liwork2 = 0
    desca = 0
    descz = 0

    nb = block_size

    if(mod(ndim,nb)>0) then
       lda = ndim/nb +1
    else
       lda = ndim/nb
    end if
    occ = lda
    if(mod(lda,nprow_md)>0) then
       lda = lda/nprow_md+1
    else
       lda = lda/nprow_md
    end if
    if(mod(occ,npcol_md)>0) then
       occ = occ/npcol_md+1
    else
       occ = occ/npcol_md
    end if
    lda = lda*nb
    occ = occ*nb
!    if(iprisubmat>=2) write(nfout,'("lda,occ=",2i5)') lda,occ

    do j=1,npcol_md
       do i=1,nprow_md
!fj --------------------
!fj       usermap(i,j) = myrank_k*nrank_e + (j-1)*nprow + i - 1
!          usermap(i,j) = myrank_k*nrank_e*nrank_g + (i-1)*npcol + j - 1
          usermap(i,j) = myrank_k*nrank_e*nrank_g + (j-1)*nprow_md + i - 1
!fj --------------------
       end do
    end do
!    if(iprimatdiagon>=1) then
!       write(nfout,'("USERMPAP")')
!       do i=1,nprow
!          write(nfout,'(1x,i3)') (usermap(i,j),j=1,npcol)
!       end do
!    end if
    call blacs_setup(iam,nprocs)
    call blacs_get(-1,0,ictxt)
    call blacs_gridmap(ictxt,usermap,nprow_md,nprow_md,npcol_md)
    call blacs_gridinfo(ictxt,nprow_md,npcol_md,myrow,mycol)
    if(myrow == -1) then
!       if(printable) write(nfout,*) 'BLACS init failed.'
!       stop 'BLACS init failed.'
      return
    else
    end if
    call descinit(desca,ndim,ndim,nb,nb,0,0,ictxt,lda,info)
    call descinit(descz,ndim,ndim,nb,nb,0,0,ictxt,lda,info)

 if(kimg==1) then
       if(method_scalapack==HOUSEHOLDER) then
          if(printable) write(nfout,*) 'HOUSEHOLDER:yes'
          nn  = max(ndim, nb, 2)
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow_md )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol_md )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork1 = 5*ndim + max(5*nn, np0*nq0+2*nb*nb) + iceil(ndim,nprow_md*npcol_md)*nn
          liwork1= 6*max(ndim,nprow_md*npcol_md+1,4)
          if(printable) write(nfout,*) 'lwork1 =',lwork1
          if(printable) write(nfout,*) 'liwork1=',liwork1
       else
          if(printable) write(nfout,*) 'HOUSEHOLDER:no'
          nn  = max(ndim, nb, 2)
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow_md )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol_md )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork0 = 5*ndim + max(5*nn, np0*nq0+2*nb*nb) + iceil(ndim,nprow_md*npcol_md)*nn
          liwork0= 6*max(ndim,nprow_md*npcol_md+1,4)
          if(printable) write(nfout,*) 'lwork0 =',lwork0
          if(printable) write(nfout,*) 'liwork0=',liwork0
          if(modnrm == EXECUT) then
              CALL PDSYGVX( 1,'V', 'I', 'U', ndim, htmp1r, 1, 1, DESCA, htmp2r, 1, 1,                   &
     &                 DESCA, VL, VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvtmp1r, 1, 1, &
     &                 DESCZ, rtmp, -1, itmp, -1, IFAIL,                   &
     &                 ICLUSTR, GAP, INFO)
          else
              CALl PDSYEVX( 'V', 'I', 'U', ndim, htmp1r, 1, 1, DESCA, VL,                &
     &                    VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvtmp1r, 1,        &
     &                    1, DESCZ, rtmp, -1, itmp, -1, IFAIL,               &
     &                    ICLUSTR, GAP, INFO )
          endif
          lwork1  = max( lwork0, nint(rtmp(1)) )
          liwork1 = max( liwork0, itmp(1) )

          if(printable) write(nfout,*) 'lrwork1=',lrwork1
          if(printable) write(nfout,*) 'liwork1=',liwork1

       end if
 else
       if(method_scalapack==HOUSEHOLDER) then
          if(printable) write(nfout,*) 'HOUSEHOLDER:yes'
          nn  = max(ndim, nb, 2)
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow_md )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol_md )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork2 = ndim + ( np0 + nq0 + nb ) * nb
          lrwork2 = 4*ndim + max(5*nn, np0*nq0) + iceil(ndim,nprow_md*npcol_md)*nn
          liwork2 = 6*MAX( ndim, NPROW_md*NPCOL_md + 1, 4 )
          if(printable) write(nfout,*) 'lwork2 =',lwork2
          if(printable) write(nfout,*) 'lrwork2=',lrwork2
          if(printable) write(nfout,*) 'liwork2=',liwork2
       else
          if(printable) write(nfout,*) 'HOUSEHOLDER:no'
          nn  = max(ndim, nb, 2)
          np0 = NUMROC( max(ndim,nb,2), nb, 0, 0, nprow_md )
          nq0 = NUMROC( max(ndim,nb,2), nb, 0, 0, npcol_md )
          if(printable) write(nfout,*) 'np0,nq0=',np0,nq0
          lwork0 = ndim + ( np0 + nq0 + nb ) * nb
          lrwork0 = 4*ndim + max(5*nn, np0*nq0) + iceil(ndim,nprow_md*npcol_md)*nn
          liwork0 = 6*MAX( ndim, NPROW_md*NPCOL_md + 1, 4 )
          if(printable) write(nfout,*) 'lwork0 =',lwork0
          if(printable) write(nfout,*) 'lrwork0=',lrwork0
          if(printable) write(nfout,*) 'liwork0=',liwork0

          if(modnrm == EXECUT) then
              CALL PZHEGVX( 1,'V', 'I', 'U', ndim, htmp1, 1, 1, DESCA, htmp2, 1, 1,                   &
     &              DESCA, VL, VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvtmp1, 1, 1, &
     &              DESCZ, ctmp, -1, rtmp, -1, itmp, -1, IFAIL,                   &
     &              ICLUSTR, GAP, INFO)
          else
              CALL PZHEEVX( 'V', 'I', 'U', ndim, htmp1, 1, 1, DESCA, VL,                         &
     &                    VU, 1, neg, ABSTOL, ne_found, NZ, evec, ORFAC, rvtmp1, 1,            &
     &                    1, DESCZ, ctmp, -1, rtmp, -1, itmp,            &
     &                    -1, IFAIL, ICLUSTR, GAP, INFO )
          endif

          lwork2  = max( lwork0 , nint(real(ctmp(1))) )
          lrwork2 = max( lrwork0, nint(rtmp(1)) )
          liwork2 = max( liwork0, itmp(1) )
       end if
!-- _1x10
!          lrwork2 = lrwork2*100
!-- _1x10_1
!          lwork2  = lwork2*10
!          lrwork2 = lrwork2*10
!-- _1x10_2
!          lwork2  = lwork2*10
!          lrwork2 = lrwork2*100
!-- _1x10_3
!          lwork2  = lwork2*10
!          lrwork2 = lrwork2*1000
!-- _1x10_4
!          lwork2  = lwork2*100
!          lrwork2 = lrwork2*10
!-- _1x10_5
!          lwork2  = lwork2*100
!          lrwork2 = lrwork2*100
!-- _1x10_6
!          lwork2  = lwork2*100
!          lrwork2 = lrwork2*1000
!-- _1x10_7
!          lwork2  = lwork2*1000
!          lrwork2 = lrwork2*10
!-- _1x10_8
!          lwork2  = lwork2*1000
!          lrwork2 = lrwork2*100
!-- _1x10_9
!          lwork2  = lwork2*1000
!          lrwork2 = lrwork2*1000
!--
!           lwork2  = lwork2*10
!           lrwork2 = lrwork2*10
!!$           lrwork2 = lrwork2*1000
!          lrwork2 = lrwork2*10
!          lrwork2 = lrwork2*100
!          liwork2 = liwork2*10
!--
          if(printable) write(nfout,*) 'lwork2 =',lwork2
          if(printable) write(nfout,*) 'lrwork2=',lrwork2
          if(printable) write(nfout,*) 'liwork2=',liwork2

 end if
 call flush(nfout)
    call tstatc0_end(id_sname)
                                                  __TIMER_SUB_STOP(1472)
  end subroutine scalapack_setup_3D

    subroutine trans_scalapack(scl_nb,zmat_l,amat_l,maxeg,maxe,lda,occ)
     integer, intent(in) :: scl_nb, maxeg, maxe, lda, occ
     real(kind=DP), intent(in) :: zmat_l(maxeg,maxe,kimg)
     real(kind=DP), intent(inout) :: amat_l(lda*kimg,occ)

     integer , allocatable, dimension(:) :: wk_rk
     integer :: i, k, j,  nn, lrk
     integer :: lno_r, ng_r, lrk_r, rank_r
     integer :: lno_c, ng_c, lrk_c, rank_c

     real(kind=DP), allocatable, dimension(:,:) :: send_buf, recv_buf

     integer, allocatable, dimension(:)   :: req_r, req_s
     integer, allocatable, dimension(:,:) :: sta_r, sta_s
     integer :: lrank, itag, icnt_send, icnt_recv, mpi_comm, ierr
                                                  __TIMER_SUB_START(1474)

      mpi_comm = mpi_k_world(myrank_k)
      itag = 10001
      allocate(req_r(scl_md_comm_rank_r), stat=ierr)
      allocate(req_s(scl_md_comm_rank  ), stat=ierr)
      allocate(sta_r(MPI_STATUS_SIZE,scl_md_comm_rank_r), stat=ierr)
      allocate(sta_s(MPI_STATUS_SIZE,scl_md_comm_rank  ), stat=ierr)
      allocate(recv_buf(scl_md_comm_max*kimg,scl_md_comm_rank_r), stat=ierr)
      allocate(send_buf(scl_md_comm_max*kimg,scl_md_comm_rank  ), stat=ierr)
      icnt_recv = 0
      icnt_send = 0

                                                  __TIMER_DO_START(1485)
      do i = 1, scl_md_comm_rank_r
         lrank = scl_md_comm_rno_r(i)
         if (lrank /= mype) then
            icnt_recv = icnt_recv + 1
            call mpi_irecv(recv_buf(1,i), scl_md_comm_max*kimg, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_r(icnt_recv), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack :  mpi_irecv error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10001, ierr)
             endif
         endif
      enddo
                                                  __TIMER_DO_STOP(1485)

      allocate(wk_rk(max(scl_md_comm_rank,scl_md_comm_rank_r)))
      wk_rk = 0
      rank_c = myrank_g
      rank_r = myrank_e
                                                  __TIMER_DO_START(1486)
      do k = nis_G_g1k(rank_c,ik), nie_G_g1k(rank_c,ik)
         if (mod(k,scl_nb) > 0) then
            nn = k / scl_nb + 1
         else
            nn = k / scl_nb
         end if
         lrk_c = mod((nn-1),scl_col_md)
         do j = nis_B_g1k(rank_r,ik), nie_B_g1k(rank_r,ik)
            if (mod(j,scl_nb) > 0) then
               nn = j / scl_nb + 1
            else
               nn = j / scl_nb
            end if
            lrk_r = mod((nn-1),scl_row_md)
            lrk = scl_row_md*lrk_c+lrk_r
!!          if (lrk /= mype) then
               do lrank = 1, scl_md_comm_rank
                  if (scl_md_comm_rno(lrank) == lrk) then
                     wk_rk(lrank) = wk_rk(lrank) + 1
                     if (kimg == 1) then
                        send_buf(wk_rk(lrank),lrank) = &
 &                                                 zmat_l(j-nis_B_g1k(rank_r,ik)+1,k-nis_G_g1k(rank_c,ik)+1,1)
                     else
                        send_buf(wk_rk(lrank)*2-1,lrank) = &
 &                                                 zmat_l(j-nis_B_g1k(rank_r,ik)+1,k-nis_G_g1k(rank_c,ik)+1,1)
                        send_buf(wk_rk(lrank)*2  ,lrank) = &
 &                                                 zmat_l(j-nis_B_g1k(rank_r,ik)+1,k-nis_G_g1k(rank_c,ik)+1,2)
                     end if
                     exit
                  end if
               end do
!!          end if
         end do
      end do
                                                  __TIMER_DO_STOP(1486)

                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1489)
                                                  __TIMER_DO_START(1485)
      do i = 1, scl_md_comm_rank
         lrank = scl_md_comm_rno(i)
         if (lrank /= mype) then
            icnt_send = icnt_send + 1
            call mpi_isend(send_buf(1,i), scl_md_comm_max*kimg, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_s(icnt_send), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack :  mpi_isend error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10002, ierr)
             endif
         endif
      enddo
                                                  __TIMER_DO_STOP(1485)

   if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col_md*scl_row_md)) then
      rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row_md)
      rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row_md
                                                  __TIMER_DO_START(1487)
      do k = nis_col_md(rank_c), nie_col_md(rank_c)
         ng_c = nmatsz_col(k)
         lrk_c = map_G_g1k(ng_c,ik)
         lno_c = ng_c - nis_G_g1k(lrk_c,ik) + 1
         do j = nis_row_md(rank_r), nie_row_md(rank_r)
            ng_r = nmatsz_row(j)
            lrk_r = map_B_g1k(ng_r,ik)
            lno_r = ng_r - nis_B_g1k(lrk_r,ik) + 1
            lrk = nrank_e*lrk_c+lrk_r
            if (lrk == mype) then

               if(ng_r> ng_c) cycle

               if (kimg == 1) then
                  amat_l(j-nis_row_md(rank_r)+1,k-nis_col_md(rank_c)+1) = zmat_l(lno_r,lno_c,1)
               else
                  amat_l((j-nis_row_md(rank_r)+1)*2-1,k-nis_col_md(rank_c)+1) = zmat_l(lno_r,lno_c,1)
                  amat_l((j-nis_row_md(rank_r)+1)*2  ,k-nis_col_md(rank_c)+1) = zmat_l(lno_r,lno_c,2)
               end if

            end if
         end do
      end do
                                                  __TIMER_DO_STOP(1487)
   end if

      call mpi_waitall(icnt_recv, req_r, sta_r, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10003, ierr)
       endif

      call mpi_waitall(icnt_send, req_s, sta_s, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10004, ierr)
       endif
                                                  __TIMER_COMM_STOP(1489)

      if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col_md*scl_row_md)) then

         wk_rk = 0
         rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row_md)
         rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row_md
                                                  __TIMER_DO_START(1488)
         do k = nis_col_md(rank_c), nie_col_md(rank_c)
            ng_c = nmatsz_col(k)
            lrk_c = map_G_g1k(ng_c,ik)
            do j = nis_row_md(rank_r), nie_row_md(rank_r)
               ng_r = nmatsz_row(j)
               lrk_r = map_B_g1k(ng_r,ik)
               lrk = nrank_e*lrk_c+lrk_r
!!             if (lrk /= mype) then
                  do lrank = 1, scl_md_comm_rank_r
                     if (scl_md_comm_rno_r(lrank) == lrk) then
                        wk_rk(lrank) = wk_rk(lrank) + 1

                        if(ng_r> ng_c) cycle

                        if (kimg == 1) then
                   amat_l(j-nis_row_md(rank_r)+1,k-nis_col_md(rank_c)+1) = recv_buf(wk_rk(lrank),lrank)
                        else
                   amat_l((j-nis_row_md(rank_r)+1)*2-1,k-nis_col_md(rank_c)+1) = recv_buf(wk_rk(lrank)*2-1,lrank)
                   amat_l((j-nis_row_md(rank_r)+1)*2  ,k-nis_col_md(rank_c)+1) = recv_buf(wk_rk(lrank)*2  ,lrank)
                        end if

                        exit
                     end if
                  end do
!!             end if
            end do
         end do
                                                  __TIMER_DO_STOP(1488)
      end if

      deallocate(req_r, stat=ierr)
      deallocate(req_s, stat=ierr)
      deallocate(sta_r, stat=ierr)
      deallocate(sta_s, stat=ierr)
      deallocate(send_buf, stat=ierr)
      deallocate(recv_buf, stat=ierr)
      deallocate(wk_rk, stat=ierr)
                                                  __TIMER_SUB_STOP(1474)

    end subroutine trans_scalapack

    subroutine trans_scalapack_r(scl_nb,zmat_l,z_mat,maxeg,maxe,lda,occ)
     integer, intent(in) :: scl_nb, maxeg, maxe, lda, occ
     real(kind=DP), intent(in) :: zmat_l(lda*kimg,occ)
     real(kind=DP), intent(inout) :: z_mat(nmatsz,np_e,kimg)

     integer , allocatable, dimension(:) :: wk_rk
     integer :: i, k, j, nn, mm, j_ng
     integer :: lrk, lad
     integer :: lno_r, lrk_r, rank_r
     integer :: lno_c, lrk_c, rank_c
     integer :: lrk2, lrk_r2, lrk_c2
     integer :: lrk1, lrk_r1, lrk_c1

     real(kind=DP), allocatable, dimension(:,:) :: send_buf, recv_buf
     real(kind=DP), allocatable, dimension(:,:,:) :: amat_l

     integer, allocatable, dimension(:)   :: req_r, req_s
     integer, allocatable, dimension(:,:) :: sta_r, sta_s
     integer :: ib, lrank, itag, icnt_send, icnt_recv, mpi_comm, ierr

      mpi_comm = mpi_k_world(myrank_k)
      itag = 10002
                                                  __TIMER_SUB_START(1475)
      allocate(amat_l(nmatsz,np_e,kimg), stat=ierr); amat_l = 0.0d0
      allocate(req_r(scl_md2_comm_rank_r), stat=ierr)
      allocate(req_s(scl_md2_comm_rank  ), stat=ierr)
      allocate(sta_r(MPI_STATUS_SIZE,scl_md2_comm_rank_r), stat=ierr)
      allocate(sta_s(MPI_STATUS_SIZE,scl_md2_comm_rank  ), stat=ierr)
      allocate(recv_buf(scl_md2_comm_max_r*kimg,scl_md2_comm_rank_r), stat=ierr)
      allocate(send_buf(scl_md2_comm_max_r*kimg,scl_md2_comm_rank  ), stat=ierr)
      icnt_recv = 0
      icnt_send = 0
!     send_buf=0.0d0
!     recv_buf=0.0d0

                                                  __TIMER_DO_START(1490)
      do i = 1, scl_md2_comm_rank_r
         lrank = scl_md2_comm_rno_r(i)
         if (lrank /= mype) then
            icnt_recv = icnt_recv + 1
            call mpi_irecv(recv_buf(1,i), scl_md2_comm_max_r*kimg, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_r(icnt_recv), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack_r :  mpi_irecv error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10001, ierr)
             endif
         endif
      enddo
                                                  __TIMER_DO_STOP(1490)

      allocate(wk_rk(max(scl_md2_comm_rank,scl_md2_comm_rank_r)))

      if ((mype-nrank_e*nrank_g*myrank_k) < (scl_col_md*scl_row_md)) then

         wk_rk = 0

         rank_r = mod((mype-nrank_e*nrank_g*myrank_k),scl_row_md)
         rank_c = (mype-nrank_e*nrank_g*myrank_k)/scl_row_md
                                                  __TIMER_DO_START(1491)
         do k = 1, neg
            ib = neg_g_all(k)
            if (mod(ib,nb_mgs) > 0) then
               nn = ib / nb_mgs + 1
            else
               nn = ib / nb_mgs
            end if
            lrk_c1 = mod((nn-1),nrank_e)
            lrk_c2 = mod((ib-1)/scl_nb,scl_col_md)
            mm = (ib-1)/(scl_col_md*scl_nb)
            lad = mod(ib-1,scl_nb)+1
            lno_c = mm*scl_nb+lad
            do j = nis_row_md(rank_r), nie_row_md(rank_r)
               j_ng = nmatsz_row(j)
               lrk_r1 = map_G_g1k(j_ng,ik)
               lrk_r2 = mod((j_ng-1)/scl_nb,scl_row_md)
               nn = (j_ng-1)/(scl_row_md*scl_nb)
               lad = mod(j_ng-1,scl_nb)+1
               lno_r = nn*scl_nb+lad
               lrk1 = nrank_e*lrk_r1+lrk_c1
               lrk2 = scl_row_md*lrk_c2+lrk_r2
               if (lrk2 == mype) then
                  do lrank = 1, scl_md2_comm_rank
                     if(scl_md2_comm_rno(lrank) == lrk1) then
                        wk_rk(lrank) = wk_rk(lrank) + 1
                        if (kimg == 1) then
                           send_buf(wk_rk(lrank)    ,lrank) =   zmat_l(lno_r,lno_c)
                        else
                           send_buf(wk_rk(lrank)*2-1,lrank) =   zmat_l(lno_r*2-1,lno_c)
                           send_buf(wk_rk(lrank)*2  ,lrank) =   zmat_l(lno_r*2  ,lno_c)
                        endif
                        exit
                     end if
                  end do
               end if
            end do
         end do
                                                  __TIMER_DO_STOP(1491)
      end if

                                                  __TIMER_COMM_START_w_BARRIER(mpi_comm,1494)
                                                  __TIMER_DO_START(1490)
      do i = 1, scl_md2_comm_rank
         lrank = scl_md2_comm_rno(i)
         if (lrank /= mype) then
            icnt_send = icnt_send + 1
            call mpi_isend(send_buf(1,i), scl_md2_comm_max_r*kimg, &
           &               mpi_double_precision, lrank, itag, mpi_comm, req_s(icnt_send), ierr)
             if (ierr /= 0) then
                write(nfout,*)' trans_scalapack :  mpi_isend error'
                call flush(nfout)
                call mpi_abort(mpi_comm_world, 10002, ierr)
             endif
         endif
      enddo
                                                  __TIMER_DO_STOP(1490)

      rank_c = myrank_e
      rank_r = myrank_g
                                                  __TIMER_DO_START(1492)
      do k = nis_e(rank_c), nie_e(rank_c)
         ib = neg_g_all(k)
         lrk_c = mod((ib-1)/scl_nb,scl_col_md)
         mm = (ib-1)/(scl_col_md*scl_nb)
         lad = mod(ib-1,scl_nb)+1
         lno_c = mm*scl_nb+lad
         do j = nis_G_g1k(rank_r,ik), nie_G_g1k(rank_r,ik)
            lrk_r = mod((j-1)/scl_nb,scl_row_md)
            nn = (j-1)/(scl_row_md*scl_nb)
            lad = mod(j-1,scl_nb)+1
            lno_r = nn*scl_nb+lad
            lrk = scl_row_md*lrk_c+lrk_r
            if (lrk == mype) then
               if (kimg == 1) then
                  amat_l(j,k-nis_e(rank_c)+1,1) = zmat_l(lno_r,lno_c)
               else
                  amat_l(j,k-nis_e(rank_c)+1,1) = zmat_l(lno_r*2-1,lno_c)
                  amat_l(j,k-nis_e(rank_c)+1,2) = zmat_l(lno_r*2  ,lno_c)
               endif
            end if
         end do
      end do
                                                  __TIMER_DO_STOP(1492)

      call mpi_waitall(icnt_recv, req_r, sta_r, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack_r :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10003, ierr)
       endif

      call mpi_waitall(icnt_send, req_s, sta_s, ierr)
       if (ierr /= 0) then
          write(nfout,*)' trans_scalapack_r :  mpi_waitall error'
          call flush(nfout)
          call mpi_abort(mpi_comm_world, 10004, ierr)
       endif
                                                  __TIMER_COMM_STOP(1494)

      wk_rk = 0
      rank_c = myrank_e
      rank_r = myrank_g
                                                  __TIMER_DO_START(1493)
      do k = nis_e(rank_c), nie_e(rank_c)
         ib = neg_g_all(k)
         lrk_c = mod((ib-1)/scl_nb,scl_col_md)
         do j = nis_G_g1k(rank_r,ik), nie_G_g1k(rank_r,ik)
            lrk_r = mod((j-1)/scl_nb,scl_row_md)
            lrk = scl_row_md*lrk_c+lrk_r
               do lrank = 1, scl_md2_comm_rank_r
                  if (scl_md2_comm_rno_r(lrank) == lrk) then
                     wk_rk(lrank) = wk_rk(lrank) + 1
                     if (kimg == 1) then
                        amat_l(j,k-nis_e(rank_c)+1,1) = recv_buf(wk_rk(lrank),lrank)
                     else
                        amat_l(j,k-nis_e(rank_c)+1,1) = recv_buf(wk_rk(lrank)*2-1,lrank)
                        amat_l(j,k-nis_e(rank_c)+1,2) = recv_buf(wk_rk(lrank)*2  ,lrank)
                     endif
                     exit
                  end if
               end do
         end do
      end do

      call mpi_allreduce(amat_l,z_mat,nmatsz*np_e*kimg,mpi_double_precision,mpi_sum,mpi_ke_world,ierr)
                                                  __TIMER_DO_STOP(1493)

      deallocate(amat_l, stat=ierr)
      deallocate(req_r, stat=ierr)
      deallocate(req_s, stat=ierr)
      deallocate(sta_r, stat=ierr)
      deallocate(sta_s, stat=ierr)
      deallocate(send_buf, stat=ierr)
      deallocate(recv_buf, stat=ierr)
      deallocate(wk_rk, stat=ierr)
                                                  __TIMER_SUB_STOP(1475)
    end subroutine trans_scalapack_r

    subroutine eigsend(evec_w,n)
    integer :: i, n, ierr, itag=100
    integer, dimension(MPI_STATUS_SIZE) :: stat
    real(kind=DP) :: evec_w(n)

    if ((myrank_e==0) .and. (myrank_g==0)) then
       do i = nrank_e*nrank_g-1, nsclcol_md*nsclrow_md, -1
          call mpi_send(evec_w, n, mpi_double_precision, i, &
         &              itag, mpi_k_world(myrank_k), ierr)
           if (ierr /= 0) then
              write(nfout,*)' eigsend :  mpi_send error'
              call flush(nfout)
              call mpi_abort(mpi_comm_world, 10010, ierr)
           end if
       end do
    end if

    if ((nsclcol_md*nsclrow_md-1) < (nrank_e*myrank_g+myrank_e)) then
       call mpi_recv(evec_w, n, mpi_double_precision, 0, &
      &              itag, mpi_k_world(myrank_k), stat, ierr)
        if (ierr /= 0) then
           write(nfout,*)' eigsend :  mpi_irecv error'
           call flush(nfout)
           call mpi_abort(mpi_comm_world, 10012, ierr)
        end if
    end if
    end subroutine eigsend

  end subroutine m_ESmat_solve_Hx_eq_eSx_3D
  subroutine check_LAPACKinputs(str,nfout,n,lda,vl,vu,il,iu,lwork,abstol,RMat,CMat)
    character(len=*),intent(in) :: str
    integer, intent(in) ::         nfout,n,lda,il,iu,lwork
    real(DP), intent(in) ::        vl,vu,abstol
    real(DP),        optional, intent(in), dimension(lda,n) :: RMat
    complex(CMPLDP), optional, intent(in), dimension(lda,n) :: CMat
    integer :: i
    character(len=32) :: strp
    strp = "<<"//trim(str)//">>"
    write(nfout,'(" --- n   = ", i8,1x,a32)') n,strp
    write(nfout,'(" --- lda = ",i8)') lda
    write(nfout,'(" --- vl  = ",d20.8, " vu = ",d20.8)') vl, vu
    write(nfout,'(" --- il  = ",i8, " iu = ", i8)') il, iu
    write(nfout,'(" --- lwork = ",i8)') lwork
    write(nfout,'(" --- abstol = ", d20.8)') abstol
    if(present(RMat))  write(nfout,'(" --- amat(diagonal) = ",8f8.4)') (RMat(i,i),i=1,n)
    if(present(CMat)) then
       write(nfout,'(" --- Real(cmat(diagonal)) = ",8f8.4)') (real(CMat(i,i)),i=1,n)
       write(nfout,'(" --- Imag(cmat(diagonal)) = ",8f8.4)') (aimag(CMat(i,i)),i=1,n)
    end if
  end subroutine check_LAPACKinputs

  subroutine check_LAPACKoutputs(str,nfout,ik,n,ne,lda,evec,Rmat,Cmat)
    character(len=*),intent(in) ::       str
    integer, intent(in) ::               nfout,ik,n,ne,lda
    real(DP),intent(in), dimension(n) :: evec
    real(DP),        optional, intent(in), dimension(lda,n) :: RMat
    complex(CMPLDP), optional, intent(in), dimension(lda,n) :: CMat
    character(len=32) :: strp

    integer :: ib, ri, i
    character(len=4) :: a
    
    strp = "<<"//trim(str)//">>"
    write(nfout,'(" --- eigen values ik = ",i8,1x,a32," ---")')ik,strp
    write(nfout,'(8f10.6)') (evec(i),i=1,ne)

    if(Present(Rmat)) then
       do ib = ista_e, iend_e, istep_e               ! MPI
          write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",4x,5e14.6)') &
               & ib,ik,evec(ib),(Rmat(i,ib),i=1,5)
       end do
    end if
    if(Present(Cmat)) then
       a = "     "
       do ib = ista_e, iend_e, istep_e               ! MPI
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "
             if(ri == 1) write(nfout,'(" evec(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,evec(ib),a,(real(Cmat(i,ib)),i=1,5)
             if(ri == 2) write(nfout,'(32x,a4,5e14.6)') a,(aimag(Cmat(i,ib)),i=1,5)
          end do
       end do
    end if
    
  end subroutine check_LAPACKoutputs

  subroutine check_LAPACKerror(ne_found,ne,info)
    integer, intent(in) :: ne_found,ne,info
    if (ne_found /= ne) then
       write(*,*) '### ERROR ### ne_found != ne'
       write(*,*) '   ne_found ...',ne_found
       write(*,*) '   ne       ...',ne
       stop ' ne_found is not ne, stopped at <<check_LAPACKerror>>'
    end if
    if (info /= 0) then
       write(*,*) '### ERROR ### info /= 0'
       write(*,*) '   info ...',info
       stop ' info is not zero, stopped at <<check_LAPACKerror>>'
    end if
  end subroutine check_LAPACKerror

  subroutine wd_CalculatedEigenvalues(nfout,ik,nmatsz,neg,ekt,str)
    integer, intent(in) :: nfout,ik,nmatsz,neg
    real(kind=DP),intent(in),dimension(nmatsz) :: ekt
    character(len=*),intent(in) :: str

    integer :: i, ib, ri
    character(len=5) :: ac

    write(nfout,'(" -- eigen values : ik = ",i8, 1x,a32," --")') ik,trim(str)
    write(nfout,'(8f10.6)') (ekt(i),i=1,neg)
    ac = "     "
    do ib = ista_e, iend_e, istep_e
       do ri = 1, kimg
          if(ri == 1 .and. kimg == 2) ac = "(Re) "
          if(ri == 2) ac = "(Im) "
          if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
               & ib,ik,eko_l(map_z(ib),ik),ac,(zaj_mat(i,map_z(ib),ri),i=1,5)
          if(ri == 2) write(nfout,'(31x,a4,5e14.6)') ac,(zaj_mat(i,map_z(ib),ri),i=1,5)
          write(nfout,'(35x,5e14.6)') (zaj_mat(i,map_z(ib),ri),i=6,20)
       end do
    end do
  end subroutine wd_CalculatedEigenvalues

end module m_ES_WF_by_MatDiagon

       subroutine  tred1_au(
     &                a, nm,
     &                u_x, u_y, v_x, nv,
     &                u_t, v_t, d_t,
     &                i, i_base, m,
     &                w, e, beta)
!$     use omp_lib
       implicit NONE

       integer, intent(in)    ::  nm, nv, i, i_base, m
       real(8), intent(inout) ::  a(1:nm,*)
       real(8), intent(inout) ::  u_x(1:nv), u_y(1:nv)
       real(8), intent(inout) ::  v_x(1:nv)
       real(8), intent(inout) ::  u_t(*), v_t(*)
       real(8), intent(in)    ::  d_t(*)
       real(8), intent(inout) ::  w(*), e(*), beta

       integer                ::  n, blk_0
       integer                ::  x_pos, y_pos, x_root, y_root
       integer                ::  n1, n2
       integer                ::  i_1, i_2, i_3
       integer                ::  j_1, j_2, j_3
       integer                ::  k_1, k_2, k_3
       integer                ::  L

       real(8) :: anorm2, a_n, g_n

       real(8) :: d1, d2

       integer                ::  local_size, local_rank

       include 'trd_au.h'

       real(8)      t2_reduce1, t2_reduce2
       common /t2/  t2_reduce1, t2_reduce2


       include 'mpif.h'
       include 'trd.h'
       include 'CSTAB.h'
       include 'param.h'


          local_rank = 0
          local_size = 1
!$        local_rank = omp_get_thread_num()
!$        local_size = omp_get_num_threads()

             L = i-1

             i_2 = loop_c_start(1, y_nnod,y_inod)
             i_3 = loop_c_end  (L, y_nnod,y_inod)
             j_2 = loop_c_start(1, x_nnod,x_inod)
             j_3 = loop_c_end  (L, x_nnod,x_inod)

             y_root = loop_c_node (L, y_nnod,y_inod)
             y_pos  = loop_c_g2l_depth(i, y_nnod,y_inod)

             x_root = loop_c_node (L, x_nnod,x_inod)
             x_pos  = loop_c_g2l_depth(L, x_nnod,x_inod)

             k_1   = i-i_base
             k_2   = m
             n     = i_3
             blk_0 = k_1-k_2


       if ( local_size > 1 ) then

          n1 = offset1+nv*local_rank
          n2 = offset2+nv*local_rank

          do j_1=1,x_pos
             u0_z(j_1+n1) = ZERO
          enddo
          do j_1=1,y_pos
             v0_z(j_1+n2) = ZERO
          enddo

          call  tred1_au_body1(
     &             a, nm,
     &             u_x, u_y, u0_z(1+n1), v0_z(1+n2),
     &             1, n, x_pos, y_pos, nv, blk_0
     &             ,local_rank, local_size
     &             )

!$OMP BARRIER

          call  tred1_au_body2(
     &             v_x, u0_z(1+offset1),
     &             v_t, v0_z(1+offset2),
     &             nv, x_pos, y_pos
     &             ,local_rank, local_size
     &             )

!$OMP BARRIER

       else

          do j_1=1,x_pos
             v_x(j_1) = ZERO
          enddo
          do j_1=1,y_pos
             v_t(j_1) = ZERO
          enddo

          call  tred1_au_body1(
     &             a, nm,
     &             u_x, u_y, v_x, v_t,
     &             1, n, x_pos, y_pos, nv, blk_0
     &             ,local_rank, local_size
     &             )

       endif

!          if ( local_rank == 0 ) then
!$OMP MASTER
             anorm2 = ZERO
             do  j_1=1,x_pos
                anorm2   =  anorm2 + u_x(j_1)**2
             end do ! j_1

             if ( x_root == x_inod ) then
                a_n = u_x(x_pos)
             else
                a_n = ZERO
             endif

             v_t(y_pos+1) = anorm2
             v_t(y_pos+2) = a_n

             if ( TRD_nnod > 1 ) then
            d1=MPI_Wtime()
                call reduce_dbl(v_t, u_t, y_pos+2, 1, x_COMM_WORLD)
            d2=MPI_Wtime()
            t2_reduce1=t2_reduce1+(d2-d1)
             end if

             anorm2 =  v_t(y_pos+1)
             a_n    =  v_t(y_pos+2)
             g_n    = -SIGN(SQRT(anorm2), a_n)
             beta   =  anorm2 - a_n * g_n
             e (i)  =  g_n

             if ( x_root == x_inod ) then
                u_x(x_pos) =  a_n - g_n
                i_1 = loop_c_node (i, y_nnod,y_inod)
                if ( i_1 == y_inod ) then
                   w(x_pos) =  u_x(x_pos)
                end if
             end if

             if ( y_root == y_inod ) then
                i_1  = loop_c_g2l_depth(L, y_nnod,y_inod)
                u_y(i_1) =  a_n - g_n
                do  j_1=1,x_pos
                   v_x(j_1) = v_x(j_1) - g_n * a(j_1,i_1)
                end do
             end if

             call  tred1_au_body3(
     &                u_x, u_y, v_x,
     &                u_t, v_t, d_t,
     &                1, n, x_pos, y_pos, nv
     &                )

             if ( TRD_nnod > 1 ) then
            d1=MPI_Wtime()
                call reduce_dbl(v_x, v_t, x_pos, x_nnod, y_COMM_WORLD)
            d2=MPI_Wtime()
            t2_reduce2=t2_reduce2+(d2-d1)
             end if

!$OMP END MASTER
!          end if


       return
       end subroutine ! tred1_au

       subroutine  tred1_au_body1(
     &                a, nm,
     &                u_x, u_y, u_t, v_t,
     &                n1, n2, x_pos, y_pos, nv, blk_0
     &                ,local_rank, local_size
     &                )
!$     use omp_lib
       implicit NONE

       integer, intent(in)    :: nm, nv, n1, n2
       real(8), intent(inout) :: a(1:nm,*)
       real(8), intent(inout) :: u_x(1:nv), u_y(1:nv)
       real(8), intent(inout) :: u_t(1:nv), v_t(1:nv)
       integer, intent(in)    :: blk_0
       integer                :: x_pos, y_pos, x_root, y_root
       integer                :: local_size, local_rank

       integer                :: i_0
       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: k_1, k_2, k_3, k_4
       integer                :: l_1, l_2, l_3, l_4
       integer                :: i, j, k

       real(8)                :: v0, u0
       real(8)                :: a0_0
       real(8)                :: a0_1
       real(8)                :: a0_2
       real(8)                :: a0_3
       real(8)                :: a0_4
       real(8)                :: a0_5
       real(8)                :: a0_6
       real(8)                :: a0_7
       real(8)                :: v_t0, u_y0
       real(8)                :: v_t1, u_y1
       real(8)                :: v_t2, u_y2
       real(8)                :: v_t3, u_y3
       real(8)                :: v_t4, u_y4
       real(8)                :: v_t5, u_y5
       real(8)                :: v_t6, u_y6
       real(8)                :: v_t7, u_y7

       integer                ::   LX, LY
       integer                ::   ii_1, ii_2, ii_3, ii_4, ii_5
       integer                ::   jj_1, jj_2, jj_3, jj_4, jj_5
       integer                ::   kk_1, kk_2, kk_3, kk_4, kk_5

       include 'trd.h'
       include 'param.h'


          i_2 = n1
          i_3 = n2
!
! v:= Au
!
          if ( blk_0 == 0 ) then
             do i_1=i_2+local_rank,i_3,local_size
                j   = loop_c_l2g_depth(i_1, y_nnod,y_inod)
                j_3 = loop_c_end  (j, x_nnod,x_inod)
                j   = j+y_nnod*(6*2-1)
                j_4 = loop_c_end  (j, x_nnod,x_inod)
                do j_1=j_3+1,MIN(j_4,nm)
                   a(j_1,i_1) = ZERO
                end do! j_1
             end do! i_1
!$OMP BARRIER
          end if
!
!
          LX = 32*1000; LY = 32*1
!
          l_2 = i_2; l_3 = i_3
          l_1 = l_2; l_4 = l_3

             k_2 = 1
             k   = loop_c_l2g_depth(l_4, y_nnod,y_inod)
             k_3 = loop_c_end  (k-1, x_nnod,x_inod)
             do k_1=k_2,k_3,LX; k_4 = MIN(k_3,k_1+LX-1)

                j    = loop_c_l2g_depth(k_1, x_nnod,x_inod)
                ii_2 = loop_c_start(j,y_nnod,y_inod)
                ii_2 = MAX(l_1,ii_2)
                ii_3 = l_4
                if ( ii_2 > ii_3 ) cycle
                ii_4 = MOD(ii_3-ii_2+1,6*2)+ii_2


                do i_1=ii_2+local_rank,ii_4-1,local_size

                   j    = loop_c_l2g_depth(i_1, y_nnod,y_inod)
                   j    = j+(1-1)*y_nnod
                   jj_2 = k_1
                   jj_3 = loop_c_end  (j-1, x_nnod,x_inod)
                   jj_3 = MIN(k_4,jj_3)
                   if ( jj_2 > jj_3 ) cycle

             do kk_1=jj_2,jj_3,64*64; kk_4=MIN(kk_1+64*64-1,jj_3)

                   u_y0 = u_y(i_1+0)

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
                   do j_1=kk_1,kk_4
!                   do j_1=jj_2,jj_3

                      u0 = u_x(j_1+0)
                      a0_0 = a(j_1+0,i_1+0)
                      v0 = u_t(j_1+0)


                      v0 = v0
     &                            + (a0_0*u_y0)
                      v_t(i_1+0) = v_t(i_1+0)
     &                            + (a0_0*u0)

                      u_t(j_1+0) = v0

                   end do! j_1

            end do! kk_1

                end do! i_1

                do i_0=ii_4+local_rank*6*2,ii_3, local_size*6*2

                   j    = loop_c_l2g_depth(i_0, y_nnod,y_inod)
                   j    = j+(6*2-1)*y_nnod
                   jj_2 = k_1
                   jj_3 = loop_c_end  (j-1, x_nnod,x_inod)
                   jj_3 = MIN(k_4,jj_3)
                   if ( jj_2 > jj_3 ) cycle

             do kk_1=jj_2,jj_3,16*31; kk_4=MIN(kk_1+16*31-1,jj_3)
             do i_1 = i_0,i_0+6*2-1,6

                   u_y0 = u_y(i_1+0)
                   u_y1 = u_y(i_1+1)
                   u_y2 = u_y(i_1+2)
                   u_y3 = u_y(i_1+3)
                   u_y4 = u_y(i_1+4)
                   u_y5 = u_y(i_1+5)

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
!DIR$ UNROLL(8)
                   do j_1=kk_1,kk_4

                      u0 = u_x(j_1+0)

                      a0_0 = a(j_1+0,i_1+0)
                      a0_1 = a(j_1+0,i_1+1)

                      v_t(i_1+0) = v_t(i_1+0)
     &                            + (a0_0*u0)
                      v_t(i_1+1) = v_t(i_1+1)
     &                            + (a0_1*u0)

                   enddo

!              call MM_PREFETCH(a(kk_1,i_1),1)

!DIR$ IVDEP
!DIR$ VECTOR ALIGNED
!DIR$ UNROLL(4)
                   do j_1=kk_1,kk_4

                      u0 = u_x(j_1+0)
                      v0 = ZERO

                      a0_0 = a(j_1+0,i_1+0)
                      a0_1 = a(j_1+0,i_1+1)

                      v0 = v0
     &                            + (a0_0*u_y0)
     &                            + (a0_1*u_y1)

                      a0_2 = a(j_1+0,i_1+2)
                      a0_3 = a(j_1+0,i_1+3)

                      v_t(i_1+2) = v_t(i_1+2)
     &                            + (a0_2*u0)
                      v_t(i_1+3) = v_t(i_1+3)
     &                            + (a0_3*u0)

                      v0 = v0
     &                            + (a0_2*u_y2)
     &                            + (a0_3*u_y3)

                      a0_4 = a(j_1+0,i_1+4)
                      a0_5 = a(j_1+0,i_1+5)

                      v_t(i_1+4) = v_t(i_1+4)
     &                            + (a0_4*u0)
                      v_t(i_1+5) = v_t(i_1+5)
     &                            + (a0_5*u0)

                      v0 = v0
     &                            + (a0_4*u_y4)
     &                            + (a0_5*u_y5)

                      u_t(j_1+0) = v0 + u_t(j_1+0)

                   end do! j_1

            enddo! i_1
            enddo! kk_1

                end do! i_1
             end do! k_1


       return
       end subroutine ! tred1_au_body1

       subroutine  tred1_au_body2(
     &                u_t, u_z, v_t, v_z, nv,
     &                x_pos, y_pos
     &                ,local_rank, local_size
     &                )
       implicit NONE

       integer, intent(in)    :: nv, x_pos, y_pos
       real(8), intent(out)   :: u_t(1:nv),   v_t(1:nv)
       real(8), intent(in)    :: u_z(1:nv,*), v_z(1:nv,*)

       integer                :: local_rank, local_size

       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: jj_1, jj_2, jj_3, jj_4
       integer                :: i, j, k

       integer, parameter     :: LX = 1024

       include 'param.h'


          jj_1 = x_pos
          jj_2 = MAX(512,(jj_1-1)/local_size+1)
          jj_3 =    (jj_2*(local_rank+0)     )+1
          jj_4 = MIN(jj_2*(local_rank+1),jj_1)

          do jj_1=jj_3,jj_4,LX
             j_3=jj_1; j_4=MIN(jj_1+LX-1,jj_4)
           if ( local_size == 4 ) then
                do j_1=j_3,j_4
                  u_t(j_1) = u_z(j_1,1)+u_z(j_1,2)+u_z(j_1,3)+u_z(j_1,4)
                end do
           else
             if ( MOD(local_size,2) == 1 ) then
                do j_1=j_3,j_4
                   u_t(j_1) = u_z(j_1,1)
                end do
             else
                do j_1=j_3,j_4
                   u_t(j_1) = ZERO
                end do
             end if
             do j=MOD(local_size,2)+1,local_size,2
                do j_1=j_3,j_4
                   u_t(j_1) = u_t(j_1)+u_z(j_1,j+0)+u_z(j_1,j+1)
                end do
             end do
            end if
          end do

          jj_1 = y_pos
          jj_2 = MAX((jj_1-1)/local_size+1,512)
          jj_3 =    (jj_2*(local_rank+0)     )+1
          jj_4 = MIN(jj_2*(local_rank+1),jj_1)

          do jj_1=jj_3,jj_4,LX
             j_3=jj_1; j_4=MIN(jj_1+LX-1,jj_4)
           if ( local_size == 4 ) then
                do j_1=j_3,j_4
                  v_t(j_1) = v_z(j_1,1)+v_z(j_1,2)+v_z(j_1,3)+v_z(j_1,4)
                end do
           else
             if ( MOD(local_size,2) == 1 ) then
                do j_1=j_3,j_4
                   v_t(j_1) = v_z(j_1,1)
                end do
             else
                do j_1=j_3,j_4
                   v_t(j_1) = ZERO
                end do
             end if
             do j=MOD(local_size,2)+1,local_size,2
                do j_1=j_3,j_4
                   v_t(j_1) = v_t(j_1)+v_z(j_1,j+0)+v_z(j_1,j+1)
                end do
             end do
           end if
          end do


       return
       end subroutine ! tred1_au_body2

       subroutine  tred1_au_body3(
     &                u_x, u_y, v_x,
     &                u_t,v_t,d_t,
     &                n1, n2, x_pos, y_pos, nv
     &                )
       implicit NONE

       integer, intent(in)    :: nv, n1, n2
       real(8), intent(in)    :: u_x(1:nv),u_y(1:nv)
       real(8), intent(inout) :: v_x(1:nv)
       real(8), intent(in)    :: u_t(*),v_t(*)
       real(8), intent(in)    :: d_t(1:nv)
       integer                :: x_pos, y_pos, x_root, y_root

       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       integer                :: i, j, k
       integer                :: nm1, nm2

       include 'trd.h'


          i_2 = n1
          i_3 = n2

          if ( diag_0 > 0 ) then

             j = loop_c_l2g_depth(diag_0, y_nnod,y_inod)
             j = loop_c_g2l_depth(j, x_nnod,x_inod)
             if ( j > nv ) return

             nm1 = y_nnod/n_common
             nm2 = x_nnod/n_common

             if ( nm2 == 1 ) then
             if ( nm1 == 1 ) then
                call tred1_au_body3_sub11(
     &               v_x(j), v_t(diag_0), d_t(diag_0), u_y(diag_0),
     &               (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)
             else
                call tred1_au_body3_subX1(
     &               v_x(j), v_t(diag_0), d_t(diag_0), u_y(diag_0),
     &               (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)
             end if
             else
                call tred1_au_body3_subXX(
     &               v_x(j), v_t(diag_0), d_t(diag_0), u_y(diag_0),
     &               (i_3-diag_0)/(x_nnod/n_common)+1, nm1, nm2)

             end if

          end if


       return
       end subroutine ! tred1_au_body3

       subroutine tred1_au_body3_subXX(v_x,v_t,d_t,u_y, n,nm1,nm2)
       implicit NONE

       integer, intent(in)    :: n, nm1, nm2
       real(8), intent(inout) :: v_x(nm1,*)
       real(8), intent(in)    :: v_t(nm2,*)
       real(8), intent(in)    :: d_t(nm2,*)
       real(8), intent(in)    :: u_y(nm2,*)

       integer                :: i


!DIR$ VECTOR ALWAYS
          do i=1,n
             v_x(1,i) = v_x(1,i)+v_t(1,i)+d_t(1,i)*u_y(1,i)
          end do! i


       return
       end subroutine ! tred1_au_body3_subXX

       subroutine tred1_au_body3_subX1(v_x,v_t,d_t,u_y, n,nm1,nm2)
       implicit NONE

       integer, intent(in)    :: n, nm1, nm2
       real(8), intent(inout) :: v_x(nm1,*)
       real(8), intent(in)    :: v_t(*)
       real(8), intent(in)    :: d_t(*)
       real(8), intent(in)    :: u_y(*)

       integer                :: i


!DIR$ VECTOR ALWAYS
          do i=1,n
             v_x(1,i) = v_x(1,i)+v_t(i)+d_t(i)*u_y(i)
          end do! i


       return
       end subroutine ! tred1_au_body3_subX1

       subroutine tred1_au_body3_sub11(v_x,v_t,d_t,u_y, n,nm1,nm2)
       implicit NONE

       integer, intent(in)    :: n, nm1, nm2
       real(8), intent(inout) :: v_x(1:n)
       real(8), intent(in)    :: v_t(1:n)
       real(8), intent(in)    :: d_t(1:n)
       real(8), intent(in)    :: u_y(1:n)

       integer                :: i


!DIR$ VECTOR ALWAYS
          do i=1,n
             v_x(i) = v_x(i)+v_t(i)+d_t(i)*u_y(i)
          end do! i


       return
       end subroutine ! tred1_au_body3_sub11

module m_db
  use m_Files,                     only : F_INP,m_Files_reopen_nfinp
  use stringModule,                only : strSplit,splitStr
  use m_Const_Parameters,          only : LOWER,NOCONV

  implicit none
  private

  public:: getIntDB_TB,getLogDB_TB,getRealDB_TB
  public:: getStringDB_TB
  public:: getIntDB,getRealVecDB,getRealDB
  public:: getStringDB,initDB

contains

  subroutine initDB
    call m_Files_reopen_nfinp(1)
  end subroutine initDB

  subroutine getIntDB(tag,retInt,defint)
    character(len=*),intent(in):: tag
    integer,intent(out):: retInt
    integer,intent(in),optional:: defInt

    integer:: f_getIntValue,f_selectTop,f_selectBlock
    integer:: iret,nsize
    logical:: br

    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    br=.false.
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret)))/=0) then
          br=.true.
          exit
       endif
    end do

    if(f_getIntValue(trim(splitStr(nsize)),iret)==0.and..not.br) then
       retInt=iret
    else
       if(present(defint)) then
          retInt=defInt
       else
          write(6,'(3a)') 'Error in getIntDB :',tag,' is not found.'
          stop
       end if
    end if

  end subroutine getIntDB

  subroutine getIntDB_TB(tag,int_vec,def_vec)
    character(len=*),intent(in):: tag
    integer,dimension(:),intent(out):: int_vec
    integer,dimension(:),intent(in),optional :: def_vec
    integer:: iret,i,matSize,nsize
    integer:: f_selectTop,f_selectBlock
    integer:: f_selectFirstTableLine
    integer:: f_selectNextTableLine
    integer:: f_getIntValue

    matSize=size(int_vec)
    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret))) /= 0) go to 10
    end do

    i = 1
    do while(.true.)
       if (i == 1) then
          if(f_selectFirstTableLine() /= 0) then
             exit
          end if
       else
          if(f_selectNextTableLine() /= 0) then
             exit
          end if
       end if
       if(i > matSize) exit
       if( f_getIntValue(trim(splitStr(nsize)),iret) == 0) &
            int_vec(i) = iret
       i=i+1
    end do
!    if(i-1.ne.matSize) then
!       write(6,*) 'Error in getIntDB_TB:',i-1,matSize
!       stop
!    end if
    return

10  continue
    if(present(def_vec)) then
       int_vec(:)=def_vec(:)
    else
       write(6,'(3a)') 'Error in getIntDB_TB: ',tag,' is not found!'
       stop
    end if
 
  end subroutine getIntDB_TB

  subroutine getLogDB_TB(tag,log_vec,def_vec)
    character(len=*),intent(in):: tag
    logical,dimension(:),intent(out):: log_vec
    logical,dimension(:),intent(in),optional :: def_vec
    integer:: iret,i,matSize,nsize
    integer:: f_selectTop,f_selectBlock
    integer:: f_selectFirstTableLine
    integer:: f_selectNextTableLine
    integer:: f_getIntValue

    matSize=size(log_vec)
    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret))) /= 0) go to 10
    end do

    i = 1
    do while(.true.)
       if (i == 1) then
          if(f_selectFirstTableLine() /= 0) then
             exit
          end if
       else
          if(f_selectNextTableLine() /= 0) then
             exit
          end if
       end if
       if(i > matSize) exit
       if( f_getIntValue(trim(splitStr(nsize)),iret) == 0) then
          if(iret.eq.1) then
             log_vec(i)=.true.
          else if(iret.eq.0) then
             log_vec(i)=.false.
          else
             write(6,*) 'Error in getLogDB_TB: ',iret
             stop
          end if
       end if
       i=i+1
    end do
!    if(i-1.ne.matSize) then
!       write(6,*) 'Error in getIntDB_TB:',i-1,matSize
!       stop
!    end if
    return

10  continue
    if(present(def_vec)) then
       log_vec(:)=def_vec(:)
    else
       write(6,'(3a)') 'Error in getIntDB_TB: ',tag,' is not found!'
       stop
    end if
 
  end subroutine getLogDB_TB

  subroutine getRealDB_TB(tag,re_vec,def_vec)
    character(len=*),intent(in):: tag
    real(8),dimension(:),intent(out):: re_vec
    real(8),dimension(:),intent(in),optional :: def_vec
    integer:: iret,i,matSize,nsize
    integer:: f_selectTop,f_selectBlock
    integer:: f_selectFirstTableLine
    integer:: f_selectNextTableLine
    integer:: f_getRealValue
    real(8):: dret

    matSize=size(re_vec)
    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret))) /= 0) go to 10
    end do

    i = 1
    do while(.true.)
       if (i == 1) then
          if(f_selectFirstTableLine() /= 0) then
             exit
          end if
       else
          if(f_selectNextTableLine() /= 0) then
             exit
          end if
       end if
       if(i > matSize) exit
       if( f_getRealValue(trim(splitStr(nsize)),dret,'') == 0) &
            re_vec(i) = dret
       i=i+1
    end do
!    if(i-1.ne.matSize) then
!       write(6,*) 'Error in getIntDB_TB:',i-1,matSize
!       stop
!    end if
    return

10  continue
    if(present(def_vec)) then
       re_vec(:)=def_vec(:)
    else
       write(6,'(3a)') 'Error in getRealDB_TB: ',tag,' is not found!'
       stop
    end if
 
  end subroutine getRealDB_TB

  subroutine getStringDB_TB(tag,str_vec,def_vec)
    character(len=*),intent(in):: tag
    character(len=64),dimension(:),intent(out):: str_vec
    character(len=64),dimension(:),intent(in),optional :: def_vec
    integer:: iret,i,matSize,nsize
    integer:: f_selectTop,f_selectBlock
    integer:: f_selectFirstTableLine
    integer:: f_selectNextTableLine
    integer:: f_getStringValue
    character(len=64):: str_ret

    matSize=size(str_vec)
    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret))) /= 0) go to 10
    end do

    i = 1
    do while(.true.)
       if (i == 1) then
          if(f_selectFirstTableLine() /= 0) then
             exit
          end if
       else
          if(f_selectNextTableLine() /= 0) then
             exit
          end if
       end if
       if(i > matSize) exit
       if( f_getStringValue(trim(splitStr(nsize)),str_ret,NOCONV) == 0) &
            str_vec(i) = str_ret
       i=i+1
    end do
!    if(i-1.ne.matSize) then
!       write(6,*) 'Error in getIntDB_TB:',i-1,matSize
!       stop
!    end if
    return

10  continue
    if(present(def_vec)) then
       str_vec(:)=def_vec(:)
    else
       write(6,'(3a)') 'Error in getStringDB_TB: ',tag,' is not found!'
       stop
    end if
 
  end subroutine getStringDB_TB

  subroutine getRealVecDB(tag,retVec,defVec)
    character(len=*),intent(in):: tag
    real(8),intent(out):: retVec(3)
    real(8),intent(in),optional:: defVec(3)

    integer:: f_selectTop,f_selectBlock,getRealVectorValue 
	
    integer:: iret,nsize
    real(8):: tmp_vec(3)
    character(16) :: readunit
    logical :: br
!!$interface 
!!$	integer function getRealVectorValue(ttag,rret,unit)
!!$	!DEC$ ATTRIBUTES C, ALIAS: '_getrealvectorvalue' :: getRealVectorValue
!!$	!DEC$ ATTRIBUTES REFERENCE :: ttag
!!$	!DEC$ ATTRIBUTES REFERENCE :: unit
!!$	!DEC$ ATTRIBUTES REFERENCE :: rret
!!$	character*(*):: ttag
!!$	real(8):: rret(3)
!!$	character*(*):: unit	
!!$	end function getRealVectorValue
!!$end interface

    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    br=.false.
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret)))/=0) then
          br=.true.
          exit
       endif
    end do
    if(getRealVectorValue(trim(splitStr(nsize))//char(0), &
                                  tmp_vec,readunit)==0.and..not.br) then
       retVec(1:3)=tmp_vec(1:3)
    else
       if(present(defVec)) then
          retVec(1:3)=defVec(1:3)
       else
          write(6,'(3a)') 'Error in getRealVecDB :',tag,' is not found.'
          stop
       end if
    end if

  end subroutine getRealVecDB

  subroutine getRealDB(tag,retRe,defRe)
    character(len=*),intent(in):: tag
    real(8),intent(out):: retRe
    real(8),intent(in),optional:: defRe

    integer:: f_getRealValue,f_selectTop,f_selectBlock
    integer:: iret,nsize
    real(8):: dret
    logical:: br

    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    br=.false.
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret)))/=0) then
         br=.true.
         exit
       endif
    end do

    if(f_getRealValue(trim(splitStr(nsize)),dret,'')==0.and..not.br) then
       retRe=dret
    else
       if(present(defRe)) then
          retRe=defRe
       else
          write(6,'(3a)') 'Error in getRealDB :',tag,' is not found.'
          stop
       end if
    end if

  end subroutine getRealDB

  subroutine getStringDB(tag,retStr,defStr)
    character(len=*),intent(in):: tag
    character(len=*),intent(out):: retStr
    character(len=*),intent(in),optional:: defStr

    integer:: f_getStringValue,f_selectTop,f_selectBlock
    integer:: iret,nsize
    character(len=64):: str_ret
    logical:: br

    call strSplit(trim(tag))
    nsize=size(splitStr)
    iret = f_selectTop()
    br=.false.
    do iret=1,nsize-1
       if(f_selectBlock(trim(splitStr(iret)))/=0) then
          br=.true.
          exit
       endif
    end do

    if(f_getStringValue(trim(splitStr(nsize)),str_ret,LOWER)==0.and..not.br) then
       retStr=str_ret
    else
       if(present(defStr)) then
          retStr=defStr
       else
          write(6,'(3a)') 'Error in getStringDB :',tag,' is not found.'
          stop
       end if
    end if

  end subroutine getStringDB

end module m_db

#define DERIVATIVE_IN_CARTS
#define USE_DERIVATIVE_QRSPS_RSPACE
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 616 $)
!
!  MODULE: m_ES_ExactExchange
!
!  AUTHOR(S): T. Yamamoto   November/22/2009
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan.
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

module m_ES_ExactExchange
  use m_Electronic_Structure,only: totch,zaj_l,occup_l,neordr,eko_l,vnlph_l,fsr_l,fsi_l
  use m_NonLocal_Potential, only : snl
  use m_PlaneWaveBasisSet,  only : ngabc,igf,kg1,kg,kgp,nbase,nbmx,iba,m_pwBS_kinetic_energies &
       &                         , nbase_gamma,igfp_l,ngpt_l,m_pwBS_sphrp_exx,kgp_exx, igfp_exx, n_rGpv &
       &                         , igf_exx,kg_exx, kg_gamma, get_kg1_ext
  use m_Kpoints,            only : kv3,vkxyz,k_symmetry,qwgt,mp_index &
       &                         , m_Kp_sample_mesh, kshift &
       &                         , kv3_ek, vkxyz_ek, qwgt_ek
  use m_FFT,                only : nfft,fft_box_size_WF, fft_box_size_EXX &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , m_FFT_WF, fft_box_size_CD, m_FFT_CD0 &
       &                         , m_FFT_CD0_exx &
#ifdef FFTW3
       &                         , nfftp_exx_nonpara, fft_box_size_CD_exx, m_FFT_exx, nfft_exx
#else
       &                         , nfftp_exx_nonpara, fft_box_size_CD_exx, nfft_exx
#endif
  use m_Ionic_System,       only : zeta1, qex, iatom, ntyp, natm, ityp, pos, iwei, napt
  use m_PseudoPotential,    only : qitg_l, iqitg, nqitg, m_PP_include_vanderbilt_pot &
       &                         , ilmt,iqitg,nloc,ntau,ival,isph,il2p,dl2p,modnrm &
       &                         , nlmta,lmta,lmtt,ltp,mtp,taup,nloc,m_PP_find_maximum_l &
       &                         , m_PP_tell_lmtt_l_m_tau &
       &                         , m_PP_set_index_arrays1,m_PP_set_index_arrays2 &
       &                         , radr,xh,rmax,nmesh,mmesh, qrspspw, nlmtt &
       &                         , m_PP_qitgft_qmk
 
  use m_Files,              only : nfout, m_Files_open_nfhybridinfo, m_Files_close_nfhybridinfo, nfhybridinfo &
       &                         , m_Files_open_nfscfzaj, m_Files_close_nfscfzaj, nfscfzaj
  use m_Timing,             only : tstatc0_begin,tstatc0_end
  use m_Control_Parameters, only : nspin,ipri,kimg,neg,printable,af,ekmode &
       &                         , alpha_exx,omega_exx,sw_screened_exchange  &
       &                         , sw_singular_correction,reduction_factor_exx &
       &                         , way_ksample,m_CtrlP_cachesize,sw_rspace_hyb &
       &                         , sw_precalculate,sw_rsb,potential_update &
       &                         , sw_rspace_hyb_dgm &
       &                         , icond, sw_hybrid_functional, ipriexx &
       &                         , precision_WFfile, fixed_charge_k_parallel
  use m_Crystal_Structure,  only : univol,altv,rltv,nopr,tau,op
  ! nopr : # of operations
  ! tau  : nonprimitive translation vector
  ! op   : rotation matrix in real space 
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, DIRECT, INVERSE, DELTA, DELTA10 &
       &                         , DELTA07, PAI2, PAI4, PAI, ELECTRON, GAMMA, BUCS &
       &                         , MONKHORST_PACK, MESH &
       &                         , INITIAL, CONTINUATION, FIXED_CHARGE_CONTINUATION, FIXED_CHARGE &
       &                         , CRDTYP, SP, ONE_BY_ONE, ALL_AT_ONCE
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , nrank_e,nrank_k,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,mpi_e_world,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_kg1_k, np_kg1_k, mp_kg1_k &
!       &                         , m_Parallel_mpi_nval,np_nval, mp_nval,ista_kngp_exx,iend_kngp_exx &
       &                         , ista_kngp_exx,iend_kngp_exx &
#ifdef TRANSPOSE
       &                         , ierr,mp_e,nis_e,nie_e,nel_e
#else
       &                         , ierr,mp_e,nel_e
#endif

! ============================ KT_Test ================================ 12.5Exp
  use m_Control_Parameters,    only : nmax_G_hyb, hybrid_functional_type
  use m_PlaneWaveBasisSet,     only : kgp, kg1, kg
! ===================================================================== 12.5Exp

  use m_Realspace, only : nmesh_rs_aug_max,nmesh_rs_aug,meshx_rs_aug,meshy_rs_aug,meshz_rs_aug,meshxyz_rs_aug &
  & , qr_clm_ylm,dqr_clm_ylm,plmt1,plmt2,nlmtpair
  use m_ES_RSB, only : overlap,m_ES_RSB_unitary_transform_wf,m_ES_RSB_unitary_transform_vec,m_ES_RSB_alloc,m_ES_RSB_doit
! ==== ASMS ====
  use m_Kpoints,  only : kv3_fbz,  vkxyz_fbz
! ==== ASMS ====

  use m_IterationNumbers, only : nk_in_the_process

  implicit none

  integer :: sw_update_wfv = ON
  integer :: nval
  integer :: nval_old
  integer :: nfftwf
  integer :: ntrs ! ntrs = 1, if TRS is used. Otherwise, ntrs=0
  integer, allocatable :: ngpt_exx(:,:,:) ! d(kg,nopr,0:ntrs)
#ifndef MEMORY_SAVE_EXX
  real(kind=DP), allocatable :: qitg_exx(:,:,:) ! d(kgp,nqitg,nqmk)
  real(kind=DP), allocatable :: ylm_exx(:,:,:) ! d(kgp,maxylm,nqmk)
#else
#ifndef MEMORY_SAVE_MORE_EXX
  real(kind=DP), allocatable :: qitg_exx(:,:,:) ! d(kgp,nqitg,nqmk)
#else
  real(kind=DP), allocatable :: qitg_exx(:,:) ! d(kgp,nqitg)
#endif
  real(kind=DP), allocatable :: ylm_exx(:,:) ! d(kgp,maxylm)
#endif
  real(kind=DP), allocatable :: vc(:,:) ! d(kgp,nqmk)
  real(kind=DP), allocatable :: wfv(:,:,:,:) ! d(kg1,nval,kv3,kimg)
  real(kind=DP), allocatable :: wfv_old(:,:,:,:) ! d(kg1,nval_old,kv3,kimg)
  real(kind=DP), allocatable :: fsr_exx(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsi_exx(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsr_exx_old(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: fsi_exx_old(:,:,:) ! d(nval,nlmta,kv3)
  real(kind=DP), allocatable :: occup_val(:,:) ! d(nval,kv3)
  real(kind=DP), allocatable :: occup_val_old(:,:) ! d(nval_old,kv3)
  real(kind=DP), allocatable :: dfsr_exx(:,:,:,:) ! d(nval,nlmta,kv3,3)
  real(kind=DP), allocatable :: dfsi_exx(:,:,:,:) ! d(nval,nlmta,kv3,3)
  real(kind=DP), allocatable :: dfsr_l(:,:,:,:) ! d(np_e,nlmta,ista_k:iend_k,3)
  real(kind=DP), allocatable :: dfsi_l(:,:,:,:) ! d(np_e,nlmta,ista_k:iend_k,3)

  integer :: ikcenter
  real(kind=DP) :: kshift_norm2
  logical, allocatable :: qmk_zero(:,:) ! d(kv3bz,kv3)
  logical, allocatable :: qmk_zero2(:) ! d(kv3bz*kv3)
  real(kind=DP), allocatable :: qmk(:,:) !d(kv3bz*kv3,3)
  integer, allocatable :: iqmk(:,:) !d(kv3bz,kv3))
  integer :: nqmk
  integer :: kv3bz

  real(kind=DP), allocatable :: eexx_kb(:,:)
  !
  ! q(BZ) = S*k(IBZ)
  ! 
  ! Symmetry operations in space group:
  !    Os={S|u}
  !    Or={R|t}
  !
  ! Wavefunction coefficient:
  !    c(q,SG) = c(k,G) exp(i(k+G)*t)
  !            = c(k,G) exp(-i(q+SG)*u)
  !
  !    If time reversal symmetry is present,
  !         c(-q,-G) = c*(q,G)
  !
  integer, allocatable :: ikp(:) ! d(kv3bz)
  integer, allocatable :: iops(:) ! d(kv3bz) No. of S_inv = R :  Or={R|t}
  integer, allocatable :: iopt(:) ! d(kv3bz) No. of S         :  Os={S|u}
  integer, allocatable :: itrs(:) ! d(kv3bz) Time reversal symmetry, 0 or 1
  real(kind=DP), allocatable :: vkbz(:,:) ! d(kv3bz,3) k-points in Full BZ
  real(kind=DP), allocatable :: wbz(:) ! d(kv3bz) weight for k-points in Full BZ

  real(kind=DP), allocatable :: oprec(:,:,:) ! d(3,3,nopr) Reciprocal space rotation matrix
  real(kind=DP), allocatable :: opdir(:,:,:) ! d(3,3,nopr) Direct space rotation matrix

  integer :: nface
  integer, allocatable :: iface_bz(:,:) ! d(3,nface)
  integer :: n_bz_mesh(3)

  real(kind=DP), allocatable :: crotylm(:,:,:) ! d(mmax,nsph,nopr)
  integer, allocatable :: iylm(:,:,:) ! d(mmax,nsph,nopr)
  integer, allocatable :: nylm(:,:) ! d(nsph,nopr)
  integer, allocatable :: isph_lmta(:) ! d(nlmta))
  integer, allocatable :: lmta_rot(:,:,:) ! d(mmax,nlmta,nopr))
  integer, allocatable :: ia_lmta(:) !(nlmta)

  logical, save :: preproc_done=.false.
  integer :: n,ibsize,iwidth,maxm
  integer, parameter :: mcritical = 4*2+1
  integer, allocatable :: il3(:)
  integer, allocatable, dimension(:) :: nqitg_sp,nqitg_sp0    
  integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
  integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
  integer :: mc ! maxval(nc)
  integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)


  real(kind=DP), allocatable, dimension(:,:) :: eko_hyb
  real(kind=DP), allocatable, dimension(:,:,:,:,:) :: fsrqm,fsiqm

  real(kind=DP), allocatable, dimension(:,:,:,:) :: exx_potential
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
  integer :: it, lcmax
  integer, allocatable, dimension(:) :: nmm_il3
  integer, allocatable, dimension(:,:) :: mm_il3
  real(kind=DP), allocatable, dimension(:,:) :: qrsps_mm
  real(kind=DP), allocatable, dimension(:) :: h, radr_kept, wos_kept
#endif
  integer, save :: id_sname_cdfft = -1

  integer, pointer :: kv3_for_innerloop, kv3_for_outerloop
  integer, pointer :: kg1_for_innerloop
  real(kind=DP), dimension(:), pointer :: qwgt_for_innerloop,qwgt_for_outerloop
  real(kind=DP), dimension(:,:,:), pointer :: vkxyz_for_innerloop, vkxyz_for_outerloop
  integer, dimension(:), pointer :: iba_for_innerloop
  integer, dimension(:,:), pointer :: nbase_for_innerloop,nbase_gamma_for_innerloop

  include 'mpif.h'                                      ! MPI

contains

  function k_index(ik) result(res)
    integer, intent(in) :: ik
    integer :: res
    res = ik
    if((icond==FIXED_CHARGE .or. icond==FIXED_CHARGE_CONTINUATION) .and. &
    & fixed_charge_k_parallel == ONE_BY_ONE) then
      res = nk_in_the_process + ik-1
      if (res>kv3_ek) res = kv3_ek
    endif
    return
  end function k_index

  subroutine m_ES_EXX_wd_hybridinfo()
    if(mype == 0)then
      write(nfout,'(a)') '!** output hybrid info to F_HYBRIDINFO'
    endif
    if(sw_hybrid_functional == OFF)then
      call m_ES_EXX_init()
    endif
    call m_Files_open_nfhybridinfo()
    if(mype==0)then
      write(nfhybridinfo) kv3,kv3bz
      write(nfhybridinfo) get_kg1_ext()
      write(nfhybridinfo) kshift
      write(nfhybridinfo) vkxyz
      write(nfhybridinfo) iba
      write(nfhybridinfo) nbase
      write(nfhybridinfo) allocated(nbase_gamma)
      if (allocated(nbase_gamma)) then
      write(nfhybridinfo) nbase_gamma
      endif
      write(nfhybridinfo) qwgt
      write(nfhybridinfo) vkbz
      write(nfhybridinfo) wbz
      write(nfhybridinfo) n_bz_mesh
      write(nfhybridinfo) ikp
      write(nfhybridinfo) iops
      write(nfhybridinfo) iopt
      write(nfhybridinfo) itrs
    endif
    call m_ES_EXX_gather_valence_states(nfout)
    if(mype==0)then
      write(nfhybridinfo) nval
      write(nfhybridinfo) neg
      write(nfhybridinfo) modnrm
      write(nfhybridinfo) nlmta
      write(nfhybridinfo) kg1
      write(nfhybridinfo) occup_val
      !!$write(nfhybridinfo) wfv
      if(modnrm == EXECUT) then
        write(nfhybridinfo) fsr_exx
        write(nfhybridinfo) fsi_exx
      endif
    endif
    call m_Files_close_nfhybridinfo()
  end subroutine m_ES_EXX_wd_hybridinfo

  subroutine m_ES_EXX_rd_hybridinfo()
    logical :: logi
    integer :: ierr,isize,mdn
    integer :: i,j,negp
    real(kind=DP), allocatable, dimension(:,:) :: wfd
    real(kind=SP), allocatable, dimension(:,:) :: wfs
    call m_Files_open_nfhybridinfo()
    allocate(kv3_for_innerloop)
    allocate(kg1_for_innerloop)
    if(mype==0)then
      read(nfhybridinfo) kv3_for_innerloop,kv3bz
      read(nfhybridinfo) isize
    endif
    call mpi_bcast(kv3_for_innerloop,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(kv3bz,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(isize,1,mpi_integer,0,mpi_comm_group,ierr)
    kg1_for_innerloop = isize
    allocate(vkxyz_for_innerloop(kv3_for_innerloop,3,CRDTYP))
    allocate(iba_for_innerloop(kv3_for_innerloop))
    allocate(nbase_for_innerloop(isize,kv3_for_innerloop))
    logi = .false.
    if(mype == 0)then
      read(nfhybridinfo) kshift
      read(nfhybridinfo) vkxyz_for_innerloop
      read(nfhybridinfo) iba_for_innerloop
      read(nfhybridinfo) nbase_for_innerloop
      read(nfhybridinfo) logi
    endif
    call mpi_bcast(kshift,3,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(vkxyz_for_innerloop,kv3_for_innerloop*3*CRDTYP,mpi_double_precision,0,mpi_comm_group,ierr)    
    call mpi_bcast(iba_for_innerloop,kv3_for_innerloop,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(nbase_for_innerloop,isize*kv3_for_innerloop,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(logi,1,mpi_logical,0,mpi_comm_group,ierr)
    if(logi)then
      allocate(nbase_gamma_for_innerloop(kg_gamma,2))
      if(mype == 0)then
        read(nfhybridinfo) nbase_gamma_for_innerloop
      endif
      call mpi_bcast(nbase_gamma_for_innerloop,kg_gamma*2,mpi_integer,0,mpi_comm_group,ierr)
    endif
    allocate(qwgt_for_innerloop(kv3_for_innerloop))
    allocate(vkbz(kv3bz,3))
    allocate(wbz(kv3bz))
    allocate(ikp(kv3bz))
    allocate(iops(kv3bz))
    allocate(iopt(kv3bz))
    allocate(itrs(kv3bz))
    if(mype==0) then
      read(nfhybridinfo) qwgt_for_innerloop
      read(nfhybridinfo) vkbz
      read(nfhybridinfo) wbz
      read(nfhybridinfo) n_bz_mesh
      read(nfhybridinfo) ikp
      read(nfhybridinfo) iops
      read(nfhybridinfo) iopt
      read(nfhybridinfo) itrs
      read(nfhybridinfo) nval
      read(nfhybridinfo) negp
      read(nfhybridinfo) mdn
      read(nfhybridinfo) nlmta
      read(nfhybridinfo) isize
    endif
    call mpi_bcast(qwgt_for_innerloop,kv3_for_innerloop,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(vkbz,kv3bz*3,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(wbz,kv3bz,mpi_double_precision,0,mpi_comm_group,ierr)
    call mpi_bcast(n_bz_mesh,3,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(ikp,kv3bz,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(iops,kv3bz,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(iopt,kv3bz,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(itrs,kv3bz,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(nval,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(negp,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(mdn,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(nlmta,1,mpi_integer,0,mpi_comm_group,ierr)
    call mpi_bcast(isize,1,mpi_integer,0,mpi_comm_group,ierr)
    ntrs = maxval(itrs)
    allocate(occup_val(nval,kv3_for_innerloop))
    if(mdn == EXECUT) then
      allocate(fsr_exx(nval,nlmta,kv3_for_innerloop))
      allocate(fsi_exx(nval,nlmta,kv3_for_innerloop))
    endif
    if(mype==0)then
      read(nfhybridinfo) occup_val
!!      read(nfhybridinfo) wfv
      if(mdn == EXECUT) then
        read(nfhybridinfo) fsr_exx
        read(nfhybridinfo) fsi_exx
      endif
    endif
    call mpi_bcast(occup_val,nval*kv3_for_innerloop,mpi_double_precision,0,mpi_comm_group,ierr)
    if(mdn==EXECUT)then
      call mpi_bcast(fsr_exx,nval*nlmta*kv3_for_innerloop,mpi_double_precision,0,mpi_comm_group,ierr)
      call mpi_bcast(fsi_exx,nval*nlmta*kv3_for_innerloop,mpi_double_precision,0,mpi_comm_group,ierr)
    endif
    call m_Files_close_nfhybridinfo()


    call m_Files_open_nfscfzaj()
    allocate(wfv(isize,nval,kv3_for_innerloop,kimg));wfv=0.d0
    if(mype==0)then
      if(precision_WFfile == SP) then
        allocate(wfs(isize,kimg));wfs=0.d0
        do i=1,kv3_for_innerloop
           do j=1,negp
              read(nfscfzaj) wfs
              if(j.le.nval) wfv(:,j,i,:) = wfs(:,:)
           enddo
        enddo
        deallocate(wfs)
      else
        allocate(wfd(isize,kimg));wfd=0.d0
        do i=1,kv3_for_innerloop
           do j=1,negp
              read(nfscfzaj) wfd
              if(j.le.nval) wfv(:,j,i,:) = wfd(:,:)
           enddo
        enddo
        deallocate(wfd)
      endif
    endif
    call mpi_bcast(wfv,isize*nval*kv3_for_innerloop*kimg,mpi_double_precision,0,mpi_comm_group,ierr)
    call m_Files_close_nfscfzaj()
  end subroutine m_ES_EXX_rd_hybridinfo

! ====================== KT_Test ==================================== 12.5
  subroutine m_ES_EXX_set_nmax_G_hyb
    if ( nmax_G_hyb == 0 ) then
       nmax_G_hyb = kgp
    else if ( nmax_G_hyb == -1 ) then
       nmax_G_hyb = kg
    else if ( nmax_G_hyb == -2 ) then
       nmax_G_hyb = kg /2
    else if ( nmax_G_hyb == -3 ) then
       nmax_G_hyb = kg1
    endif
    if(sw_rspace_hyb==ON) nmax_G_hyb = kgp_exx
    write(nfout,*) 'nmax_G_hyb is set to ', nmax_G_hyb

  end subroutine m_ES_EXX_set_nmax_G_hyb
! ================================================================== 12.5

  subroutine m_ES_EXX_update(on_or_off)
    implicit none
    integer, intent(in) :: on_or_off

    sw_update_wfv = on_or_off
    if(printable) then
       if(sw_update_wfv==ON) then
          write(nfout,'(" EXX: wfv will be updated.")')
       else
          write(nfout,'(" EXX: wfv will be conserved.")')
       end if
    end if
  end subroutine m_ES_EXX_update

  subroutine m_ES_EXX_kbz
    implicit none
    integer :: ik, jk, iopr, i, j, ikbz, jkbz, jtrs
    integer :: i1, i2, i3
    real(kind=DP) :: rkxyz(3), kxyz(3), df(3), ko(3)
    logical :: ltrue
    integer :: g0(3)
    real(kind=DP) :: x(3), y(3)
    real(kind=DP) :: wtot
    real(kind=DP) :: ss(3,3)
    real(kind=DP) :: dk(3)

    allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) return

    write(nfout,'("k-points in IBZ")')
    write(nfout,'("ik, k1, k2, k3")')
    do ik=1,kv3_for_innerloop,nspin
       write(nfout,'(i5,3(1x,f10.5))') (ik-1)/nspin+1, vkxyz_for_innerloop(ik,1:3,BUCS)
    end do

    call m_ES_EXX_fbz_faces ! -> iface_bz

    if(kv3_for_innerloop/nspin==1) then
       kv3bz = 1
       n_bz_mesh(1:3) = 1
    else
       if(way_ksample == MONKHORST_PACK) then
          n_bz_mesh(1:3) = mp_index(1:3)
       else
          call m_Kp_sample_mesh(n_bz_mesh)
       end if
       kv3bz = n_bz_mesh(1)*n_bz_mesh(2)*n_bz_mesh(3)
    end if

    allocate(vkbz(kv3bz,3))
    allocate(wbz(kv3bz))
    wbz(1:kv3bz) = product(reduction_factor_exx(1:3))/dble(kv3bz)

    ikbz = 0
    do i1=0,n_bz_mesh(1)-1
       do i2=0,n_bz_mesh(2)-1
          do i3=0,n_bz_mesh(3)-1
             rkxyz(1) = (dble(i1) + kshift(1)) / dble(n_bz_mesh(1))  ! USAMI
             rkxyz(2) = (dble(i2) + kshift(2)) / dble(n_bz_mesh(2))
             rkxyz(3) = (dble(i3) + kshift(3)) / dble(n_bz_mesh(3))
             call m_ES_EXX_move_k_into_fbz(rkxyz,ko)
             do ik=1,kv3_for_innerloop
                dk(1:3) = vkxyz_for_innerloop(ik,1:3,BUCS)-ko(1:3)
                if( abs(dk(1)-nint(dk(1)))<DELTA07 .and. &
                  & abs(dk(2)-nint(dk(2)))<DELTA07 .and. &
                  & abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                  ko(1:3) = vkxyz_for_innerloop(ik,1:3,BUCS)
                  exit
                end if
             end do
             ikbz = ikbz + 1
             vkbz(ikbz,1:3) = ko(1:3)
          end do
       end do
    end do

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    allocate(ikp(kv3bz))
    allocate(iops(kv3bz))
    allocate(iopt(kv3bz)); iopt = 0
    allocate(itrs(kv3bz)); itrs = 0

    ! q(bz) = S*k'(ibz)
    do ikbz=1,kv3bz
       ikp(ikbz) = 0
       LOOP_S: do jtrs=0,1
          do iopr=1,nopr
             rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkbz(ikbz,1:3))
             do jk=1,kv3_for_innerloop,nspin
                dk(1:3) = vkxyz_for_innerloop(jk,1:3,BUCS)-rkxyz(1:3)
                if( abs(dk(1)-nint(dk(1)))<DELTA07 .and. &
                  & abs(dk(2)-nint(dk(2)))<DELTA07 .and. &
                  & abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                   g0(1:3) = nint(dk(1:3))
                   ikp(ikbz) = jk
                   iops(ikbz) = iopr
                   itrs(ikbz) = jtrs
                  exit LOOP_S
                end if
             end do
          end do
       end do LOOP_S
       if(ikp(ikbz) == 0) then
          write(nfout,'("ikbz=",i5)') ikbz
          write(nfout,'(" ikp=",i5)') ikp(ikbz)
          write(nfout,'("rkxyz=",3(1x,f20.5))') rkxyz(1:3)
          stop "Did not find the index of k' in IBZ."
       end if

       do iopr=1,nopr
          ss = matmul(op(:,:,iopr),op(:,:,iops(ikbz)))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
           & abs(ss(2,2)-1.d0)<DELTA07 .and. &
           & abs(ss(3,3)-1.d0)<DELTA07 .and. &
           & abs(ss(1,2))<DELTA07 .and. &
           & abs(ss(1,3))<DELTA07 .and. &
           & abs(ss(2,3))<DELTA07) then
             iopt(ikbz) = iopr
             exit
          end if
       end do

       !   k'(bz) is transferable to k in IBZ by a symmetry operation.
       !   g0 = k(ibz) - R k(bz)
       !    0 = k(ibz) - R k'(bz)
       !    k'(bz) = k(bz) + R^inv g0

       rkxyz = (1-2*itrs(ikbz)) * matmul(oprec(:,:,iopt(ikbz)),g0(1:3))
       vkbz(ikbz,1:3) = vkbz(ikbz,1:3) + rkxyz(1:3)

    end do

    ntrs = maxval(itrs)

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    write(nfout,'(2x,"ikbz",3x,"ikp",2x,"iops",2x,"iopt",2x,"itrs")')
    do ikbz=1,kv3bz
       write(nfout,'(i5,4(1x,i5))') ikbz, ikp(ikbz), iops(ikbz), iopt(ikbz), itrs(ikbz)
    end do
  end subroutine m_ES_EXX_kbz

  subroutine m_ES_EXX_kbz2
    implicit none
    integer :: ik, jk, iopr, i, j, ikbz, jkbz, jtrs
    integer :: i1, i2, i3
    real(kind=DP) :: rkxyz(3), kxyz(3), df(3), ko(3)
    logical :: ltrue
    integer :: g0(3), jtrs_max
    real(kind=DP) :: x(3), y(3)
    real(kind=DP) :: wtot
    real(kind=DP) :: ss(3,3)
    real(kind=DP) :: dk(3)

    if(.not.allocated(oprec)) allocate(oprec(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),rltv(:,j))
          do i=1,3
             y = altv(:,i)
             oprec(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION ) return

    if(kv3_for_innerloop/nspin==1) then
       n_bz_mesh(1:3) = 1
    else
       if(way_ksample == MONKHORST_PACK) then
          n_bz_mesh(1:3) = mp_index(1:3)
       else
          call m_Kp_sample_mesh(n_bz_mesh)
       end if
    end if

    kv3bz = kv3_fbz /nspin
    if(.not.allocated(vkbz)) allocate(vkbz(kv3bz,3));  if(.not.allocated(wbz)) allocate(wbz(kv3bz))

    wbz(1:kv3bz) = product(reduction_factor_exx(1:3))/dble(kv3bz)
    Do ik=1, kv3bz
       vkbz(ik,1:3) = vkxyz_fbz(nspin*(ik-1)+1,1:3,BUCS)
    End do

    write(nfout,'("k-points in IBZ")')
    write(nfout,'("ik, k1, k2, k3")')
    do ik=1,kv3_for_innerloop,nspin
       write(nfout,'(i5,3(1x,f10.5))') (ik-1)/nspin+1, vkxyz_for_innerloop(ik,1:3,BUCS)
    end do

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    if(.not.allocated(ikp)) allocate(ikp(kv3bz))
    if(.not.allocated(iops)) allocate(iops(kv3bz))
    if(.not.allocated(iopt)) allocate(iopt(kv3bz)); iopt = 0
    if(.not.allocated(itrs)) allocate(itrs(kv3bz)); itrs = 0

    ! q(bz) = S*k'(ibz)
    do ikbz=1,kv3bz
       ikp(ikbz) = 0

       LOOP_S: do jtrs=0, 1
          do iopr=1,nopr
             rkxyz = (1-2*jtrs) * matmul(oprec(:,:,iopr),vkbz(ikbz,1:3))
             do jk=1,kv3_for_innerloop,nspin
                dk(1:3) = vkxyz_for_innerloop(jk,1:3,BUCS)-rkxyz(1:3)
                if( abs(dk(1)-nint(dk(1)))<DELTA07 .and. &
                  & abs(dk(2)-nint(dk(2)))<DELTA07 .and. &
                  & abs(dk(3)-nint(dk(3)))<DELTA07 ) then
                   g0(1:3) = nint(dk(1:3))
                   ikp(ikbz) = jk
                   iops(ikbz) = iopr
                   itrs(ikbz) = jtrs
                  exit LOOP_S
                end if
             end do
          end do
       end do LOOP_S
       if(ikp(ikbz) == 0) then
          write(nfout,'("ikbz=",i5)') ikbz
          write(nfout,'(" ikp=",i5)') ikp(ikbz)
          write(nfout,'("rkxyz=",3(1x,f20.5))') rkxyz(1:3)
          stop "Did not find the index of k' in IBZ."
       end if

       do iopr=1,nopr
          ss = matmul(op(:,:,iopr),op(:,:,iops(ikbz)))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
           & abs(ss(2,2)-1.d0)<DELTA07 .and. &
           & abs(ss(3,3)-1.d0)<DELTA07 .and. &
           & abs(ss(1,2))<DELTA07 .and. &
           & abs(ss(1,3))<DELTA07 .and. &
           & abs(ss(2,3))<DELTA07) then
             iopt(ikbz) = iopr
             exit
          end if
       end do

       !   k'(bz) is transferable to k in IBZ by a symmetry operation.
       !   g0 = k(ibz) - R k(bz)
       !    0 = k(ibz) - R k'(bz)
       !    k'(bz) = k(bz) + R^inv g0

       rkxyz = (1-2*itrs(ikbz)) * matmul(oprec(:,:,iopt(ikbz)),g0(1:3))
       vkbz(ikbz,1:3) = vkbz(ikbz,1:3) + rkxyz(1:3)
    end do

    ntrs = maxval(itrs)

    write(nfout,'("k-points in BZ")')
    write(nfout,'("ikbz k1 k2 k3 wbz")')
    do ikbz=1,kv3bz
       write(nfout,'(i7,4(1x,f20.5))') ikbz, vkbz(ikbz,1:3), wbz(ikbz)
    end do

    write(nfout,'(2x,"ikbz",3x,"ikp",2x,"iops",2x,"iopt",2x,"itrs")')
    do ikbz=1,kv3bz
       write(nfout,'(i5,4(1x,i5))') ikbz, ikp(ikbz), iops(ikbz), iopt(ikbz), itrs(ikbz)
    end do
  end subroutine m_ES_EXX_kbz2

  subroutine m_ES_EXX_fbz_faces
    implicit none
    integer :: n
    integer :: i,j,k
    real(kind=DP) :: mtr(3,3)
    integer, parameter :: nface_max = 125
    logical :: exists_in_fbz(nface_max)
    integer :: iface(3,nface_max)
    real(kind=DP), parameter :: lambda = 1.d0+1.d-8
    real(kind=DP) :: gg, gg_ref

    do i=1,3
       do j=1,3
          mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
       end do
    end do

    n=0
    do i=-2,2
       do j=-2,2
          do k=-2,2
             if(i == 0 .and. j == 0 .and. k == 0) cycle
             n=n+1
             iface(1,n)=i
             iface(2,n)=j
             iface(3,n)=k
          end do
       end do
    end do

    exists_in_fbz(1:nface_max) = .true.
    do i=1,n
       if(exists_in_fbz(i)) then
          gg_ref = dot_product(iface(:,i),matmul(mtr,iface(:,i)))
          do j=1,n
             if(i /= j) then
                gg = dot_product(iface(:,i),matmul(mtr,iface(:,j)))
                if(gg*lambda > gg_ref) exists_in_fbz(j) = .false.
             end if
          end do
       end if
    end do

    nface = 0
    do i=1,n
       if(exists_in_fbz(i)) nface = nface + 1
    end do
    allocate(iface_bz(3,nface))
    nface = 0
    do i=1,n
       if(exists_in_fbz(i)) then
          nface = nface + 1
          iface_bz(1:3,nface) = iface(1:3,i)
       end if
    end do

    ! Write FBZ faces
    write(nfout,'("FBZ faces: iface_bz(3,nface)")')
    write(nfout,'("nface=",i5)') nface
    write(nfout,'("i, n1, n2, n3")')
    do i=1,nface
       write(nfout,'(i5,3(1x,i5))') i, iface_bz(1:3,i)
    end do
  end subroutine m_ES_EXX_fbz_faces

  subroutine m_ES_EXX_move_k_into_fbz(ki,ko)
    implicit none
    real(kind=DP), intent(in) :: ki(3)
    real(kind=DP), intent(out) :: ko(3)

    integer :: i, j
    real(kind=DP) :: mtr(3,3)
    real(kind=DP), parameter :: lambda = 1.d0+1.d-8
    real(kind=DP) :: gg, gg_ref

    do i=1,3
       do j=1,3
          mtr(i,j) = dot_product(rltv(:,i),rltv(:,j))
       end do
    end do

    ko(1:3) = ki(1:3)
    do i=1,nface
       gg_ref = dot_product(iface_bz(:,i),matmul(mtr,iface_bz(:,i))) * 0.5d0
       do 
          gg = dot_product(iface_bz(:,i),matmul(mtr,ko))
          if(gg > gg_ref*lambda) then
             ko(1:3) = ko(1:3) - dble(iface_bz(1:3,i))
          else
             exit
          end if
       end do
    end do
  end subroutine m_ES_EXX_move_k_into_fbz

  subroutine m_ES_EXX_init0
    integer :: ii,ie
    if(potential_update>0) then
       if(.not.allocated(exx_potential)) allocate(exx_potential(kg1,np_e,ista_k:iend_k,kimg));exx_potential = 0.d0
    endif
  end subroutine m_ES_EXX_init0

  subroutine m_ES_EXX_init
    implicit none
    integer :: ik, ikbz, ii,ierr,ie
    real(kind=DP) :: dk(3), v0(3)
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_init ',id_sname,level=1)

    if(icond == INITIAL .or. icond == CONTINUATION)then
        kg1_for_innerloop   => kg1
        kv3_for_innerloop   => kv3
        qwgt_for_innerloop  => qwgt
        vkxyz_for_innerloop => vkxyz
        iba_for_innerloop   => iba
        nbase_for_innerloop => nbase
        if (allocated(nbase_gamma)) nbase_gamma_for_innerloop => nbase_gamma
        kv3_for_outerloop   => kv3
        qwgt_for_outerloop  => qwgt
        vkxyz_for_outerloop => vkxyz
    else if (icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION)then
        call m_ES_EXX_rd_hybridinfo()
        if(fixed_charge_k_parallel == ONE_BY_ONE)then 
          kv3_for_outerloop   => kv3_ek
          qwgt_for_outerloop  => qwgt_ek
          vkxyz_for_outerloop => vkxyz_ek
        else if (fixed_charge_k_parallel == ALL_AT_ONCE)then
          kv3_for_outerloop   => kv3
          qwgt_for_outerloop  => qwgt
          vkxyz_for_outerloop => vkxyz
        else
          stop 'invalid fixed_charge_k_parallel'
        endif
    else
        stop 'invalid icond'
    endif

! === ASMS ===
!    call m_ES_EXX_kbz ! -> ntrs, etc.
    call m_ES_EXX_kbz2    ! -> ntrs, etc.
! === ASMS ===

! === ASMS ===
!    ikgamma = 1
!    do ik=1,kv3,nspin
!       if( abs(vkxyz(ik,1,BUCS))<DELTA07 .and. &
!         & abs(vkxyz(ik,2,BUCS))<DELTA07 .and. &
!         & abs(vkxyz(ik,3,BUCS))<DELTA07 ) then
!          ikgamma = ik
!          exit
!       end if
!    end do

    kshift_norm2 = kshift(1)**2 +kshift(2)**2 +kshift(3)**2
    ikcenter = 1
    v0(1) = dble(kshift(1)) / dble(n_bz_mesh(1))
    v0(2) = dble(kshift(2)) / dble(n_bz_mesh(2))
    v0(3) = dble(kshift(3)) / dble(n_bz_mesh(3))

    do ik=1,kv3_for_outerloop,nspin
       if( abs(vkxyz_for_outerloop(ik,1,BUCS)-v0(1))<DELTA07 .and. &
            & abs(vkxyz_for_outerloop(ik,2,BUCS)-v0(2))<DELTA07 .and. &
            & abs(vkxyz_for_outerloop(ik,3,BUCS)-v0(3))<DELTA07 ) then
          ikcenter = ik
          exit
       end if
    end do
! === ASMS ===

    if(allocated(qmk_zero)) deallocate(qmk_zero)
    allocate(qmk_zero(kv3bz,kv3_for_outerloop)); qmk_zero = .false.
    if(allocated(qmk)) deallocate(qmk)
    allocate(qmk(kv3bz*kv3_for_outerloop,3))
    if(allocated(qmk_zero2)) deallocate(qmk_zero2)
    allocate(qmk_zero2(kv3bz*kv3_for_outerloop))
    if(allocated(iqmk)) deallocate(iqmk)
    allocate(iqmk(kv3bz,kv3_for_outerloop))
    nqmk = 0
    do ik=1,kv3_for_outerloop
       do ikbz=1,kv3bz
          if(.not.q_on_k_centered_mesh(ikbz,ik)) cycle
          if( abs(vkbz(ikbz,1)-vkxyz_for_outerloop(ik,1,BUCS))<DELTA07 .and. &
            & abs(vkbz(ikbz,2)-vkxyz_for_outerloop(ik,2,BUCS))<DELTA07 .and. &
            & abs(vkbz(ikbz,3)-vkxyz_for_outerloop(ik,3,BUCS))<DELTA07 ) then
             qmk_zero(ikbz,ik) = .true.
          end if
          if(nqmk==0) then
             nqmk = nqmk + 1
             qmk(nqmk,1:3) = vkbz(ikbz,1:3)-vkxyz_for_outerloop(ik,1:3,BUCS)    
             iqmk(ikbz,ik) = nqmk
             qmk_zero2(nqmk) = qmk_zero(ikbz,ik)
          else
             dk(1:3) = vkbz(ikbz,1:3)-vkxyz_for_outerloop(ik,1:3,BUCS)    
             do ii=1,nqmk
                if( abs(qmk(ii,1)-dk(1))<DELTA07 .and. &
                  & abs(qmk(ii,2)-dk(2))<DELTA07 .and. &
                  & abs(qmk(ii,3)-dk(3))<DELTA07 ) then
                  iqmk(ikbz,ik) = ii
                  go to 100
                end if
             end do
             nqmk = nqmk + 1
             qmk(nqmk,1:3) = dk(1:3)
             iqmk(ikbz,ik) = nqmk
             qmk_zero2(nqmk) = qmk_zero(ikbz,ik)
         100 continue
          end if
       end do
    end do

    if(sw_hybrid_functional==ON) call m_PP_qitgft_qmk()

#ifdef FFTW3
    nfftwf = product(fft_box_size_EXX(1:3,1))
#else
    nfftwf = product(fft_box_size_WF(1:3,1))
    nfft_exx = product(fft_box_size_WF(1:3,0)) * kimg
#endif

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_init
 
  subroutine m_ES_EXX_crotylm
    implicit none
    integer :: l1max, mmax, nsph
    integer :: ia1,it1,il1,im1,tau1,lmt1,lmtt1,isph1
    integer :: ia2,it2,il2,im2,tau2,lmt2,lmtt2,isph2
    integer :: iy,ilmta1,iopr
    integer :: iopr1,iopr2
    integer :: invop(nopr)
    integer :: i,j
    real(kind=DP) :: ss(3,3)
    real(kind=DP) :: x(3), y(3)
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_crotylm ',id_sname,level=1)

    do iopr1=1,nopr
       do iopr2=1,nopr
          ss = matmul(op(:,:,iopr1),op(:,:,iopr2))
          if(abs(ss(1,1)-1.d0)<DELTA07 .and. &
          & abs(ss(2,2)-1.d0)<DELTA07 .and. &
          & abs(ss(3,3)-1.d0)<DELTA07 .and. &
          & abs(ss(1,2))<DELTA07 .and. &
          & abs(ss(1,3))<DELTA07 .and. &
          & abs(ss(2,3))<DELTA07) then
             invop(iopr1) = iopr2
             exit
          end if
       end do
    end do

    l1max = nloc
    mmax  = 2*l1max-1
    nsph = l1max**2
    if(.not.allocated(crotylm)) allocate(crotylm(mmax,nsph,nopr))
    crotylm = 0.0d0
    if(.not.allocated(iylm))    allocate(iylm(mmax,nsph,nopr))
    if(.not.allocated(nylm))    allocate(nylm(nsph,nopr))
    call get_crotylm(l1max,mmax,nsph,nopr,crotylm,iylm,nylm,op)

    if(.not.allocated(isph_lmta)) allocate(isph_lmta(nlmta))
    if(.not.allocated(lmta_rot))  allocate(lmta_rot(mmax,nlmta,nopr))
    lmta_rot = 0
    if(.not.allocated(ia_lmta))   allocate(ia_lmta(nlmta))
    do ia1=1,natm
       it1=ityp(ia1)
       do lmt1=1,ilmt(it1)

          il1  = ltp( lmt1, it1)
          im1  = mtp( lmt1, it1)
          tau1 = taup(lmt1, it1)
          lmtt1 = lmtt(lmt1,it1)
          isph1 = (il1-1)**2 + im1

          ilmta1 = lmta(lmt1,ia1)
          ia_lmta(ilmta1) = ia1
          isph_lmta(ilmta1) = isph1
          do iopr=1,nopr
             ia2=napt(ia1,invop(iopr))
             it2=ityp(ia2)
             if(it1/=it2) stop 'm_ES_EXX_crotylm: it1 and it2 differ.'
             do lmt2=1,ilmt(it2)
                il2  = ltp( lmt2, it2)
                tau2 = taup(lmt2, it2)
                if(il1==il2.and.tau1==tau2) then
                   im2  = mtp( lmt2, it2)
                   lmtt2 = lmtt(lmt2,it2)
                   isph2 = (il2-1)**2 + im2
                   do iy=1,nylm(isph1,iopr)
                      if(isph2 == iylm(iy,isph1,iopr)) then
                         lmta_rot(iy,ilmta1,iopr) = lmta(lmt2,ia2)
                      end if
                   end do
                end if
             end do
          end do
       end do
    end do

    if(.not.allocated(opdir)) allocate(opdir(3,3,nopr))
    do iopr=1,nopr
       do j=1,3
          x = matmul(op(:,:,iopr),altv(:,j))
          do i=1,3
             y = rltv(:,i)
             opdir(i,j,iopr) = dot_product(y,x)/PAI2
          end do
       end do
    end do

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_crotylm

  subroutine m_ES_EXX_dealloc
    implicit none
    deallocate(vc)
    deallocate(wfv)
    deallocate(occup_val)
    deallocate(ngpt_exx)
    if(modnrm == EXECUT) then
#ifndef MEMORY_SAVE_EXX
       if(sw_rspace_hyb==OFF) then
         deallocate(ylm_exx)
         deallocate(qitg_exx)
       endif
#else
#ifndef MEMORY_SAVE_MORE_EXX
       if(sw_rspace_hyb==OFF) deallocate(qitg_exx)
#endif
#endif
       deallocate(fsr_exx)
       deallocate(fsi_exx)
    end if
  end subroutine m_ES_EXX_dealloc
  
  subroutine m_ES_EXX_gather_valence_states(nfout,transform)
    implicit none
    integer, intent(in) :: nfout
    logical, optional, intent(in) :: transform

    integer :: ik,ib,ib1,ibm,irev
    real(kind=DP), allocatable :: wfv_mpi(:,:,:,:) ! d(kg1,nval,kv3,kimg)
    real(kind=DP), allocatable :: occup_val_mpi(:,:) ! d(nval,kv3)
    real(kind=DP), allocatable :: fsr_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: fsi_mpi(:,:,:) ! d(nval,nlmta,kv3)
    real(kind=DP), allocatable :: efsr_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: efsi_l(:,:) ! d(np_e,nlmta)


    logical :: trans
    integer, allocatable, dimension(:) :: ista
    integer,save  :: id_sname = -1

    if(sw_update_wfv==OFF) return
    if(icond == FIXED_CHARGE .or. icond == FIXED_CHARGE_CONTINUATION) return

    allocate(ista(MPI_STATUS_SIZE))

    trans = .true.
    if(present(transform)) trans = transform
    call tstatc0_begin('m_ES_EXX_gather_valence_states ',id_sname,level=1)


    if(sw_rsb==ON.and.trans) then
       do ik=1,kv3,af+1
          if(map_k(ik) /= myrank_k) cycle
          call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       enddo
    endif

    ibm = 0
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib=1,neg
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             if(occup_l(map_z(ib1),ik) > DELTA) then
                ibm = max(ib,ibm)
             end if
          end if
       end do
    end do
    if(npes>1) then
       call mpi_allreduce(ibm,irev,1,MPI_INTEGER,MPI_MAX,mpi_comm_group,ierr)
       nval = irev
    else
       nval = ibm
    end if


    if(allocated(wfv)) deallocate(wfv)
    if(allocated(occup_val)) deallocate(occup_val)
    allocate(wfv(kg1,nval,kv3,kimg))
    allocate(occup_val(nval,kv3))
    wfv = 0.d0
    occup_val = 0.d0
    if(modnrm == EXECUT) then
       if(allocated(fsr_exx)) deallocate(fsr_exx)
       if(allocated(fsi_exx)) deallocate(fsi_exx)
       allocate(fsr_exx(nval,nlmta,kv3))
       allocate(fsi_exx(nval,nlmta,kv3))
       allocate(efsr_l(np_e,nlmta));efsr_l=0.d0
       allocate(efsi_l(np_e,nlmta));efsi_l=0.d0
       fsr_exx = 0.d0
       fsi_exx = 0.d0
    end if
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       if(modnrm == EXECUT) call get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
       do ib=1,nval
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             wfv(1:kg1,ib,ik,1:kimg) = zaj_l(1:kg1,map_z(ib1),ik,1:kimg)
             occup_val(ib,ik) = occup_l(map_z(ib1),ik)
             if(modnrm == EXECUT) then
                fsr_exx(ib,1:nlmta,ik) = efsr_l(map_z(ib1),1:nlmta)
                fsi_exx(ib,1:nlmta,ik) = efsi_l(map_z(ib1),1:nlmta)
             end if
          end if
       end do
    end do    
    if(modnrm == EXECUT) then
       deallocate(efsr_l)
       deallocate(efsi_l)
    end if

    allocate(wfv_mpi(kg1,nval,kv3,kimg))
    allocate(occup_val_mpi(nval,kv3))
    call mpi_allreduce(wfv,wfv_mpi,kg1*nval*kv3*kimg,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
    call mpi_allreduce(occup_val,occup_val_mpi,nval*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
    wfv = wfv_mpi
    occup_val = occup_val_mpi
    deallocate(wfv_mpi)
    deallocate(occup_val_mpi)
    if(modnrm == EXECUT) then
       allocate(fsr_mpi(nval,nlmta,kv3))
       allocate(fsi_mpi(nval,nlmta,kv3))
       call mpi_allreduce(fsr_exx,fsr_mpi,nval*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(fsi_exx,fsi_mpi,nval*nlmta*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       fsr_exx = fsr_mpi
       fsi_exx = fsi_mpi
       deallocate(fsr_mpi)
       deallocate(fsi_mpi)
    end if

    if(sw_rspace_hyb==ON .and. modnrm==EXECUT.and.sw_precalculate==ON)then
       if(allocated(fsrqm)) deallocate(fsrqm)
       if(allocated(fsiqm)) deallocate(fsiqm)
       allocate(fsrqm(nmesh_rs_aug_max,nlmta,nval,kv3bz,nspin));fsrqm=0.d0
       allocate(fsiqm(nmesh_rs_aug_max,nlmta,nval,kv3bz,nspin));fsiqm=0.d0
       call build_fsqm()
    endif

    if(sw_rsb==ON.and.trans) then
       do ik=1,kv3,af+1
          if(map_k(ik) /= myrank_k) cycle
          call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)
       enddo
    endif

    deallocate(ista)
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_gather_valence_states

  subroutine build_fsqm()
    integer :: jkbz,kk,kop,jop,jtrs,m
    integer :: ia,it,imesh,lmt1,lmt2,nma,ilmta1,ilmta2,ispin,lmtp
    real(kind=DP), allocatable, dimension(:) :: fsr, fsi !d(nlmta)
    real(kind=DP), allocatable, dimension(:) :: cosqmkr,sinqmkr
    real(kind=DP) :: fr,fi,fr0,fi0
    real(kind=DP) :: qm
    allocate(fsr(nlmta));fsr=0.d0
    allocate(fsi(nlmta));fsi=0.d0
    fsrqm = 0.d0
    fsiqm = 0.d0
    do ispin=1,nspin,af+1
       do jkbz=1,kv3bz
          ! q(bz) = S*k(ibz)
          kk = ikp(jkbz) + ispin - 1
          kop = iops(jkbz)
          jop = iopt(jkbz) 
          jtrs = itrs(jkbz)
          do m=1,nval
             call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi)
             do ia=1,natm
                it = ityp(ia)
                if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
                nma = nmesh_rs_aug(ia)
                do lmtp=1,nlmtpair(ia)
                   lmt1 = plmt1(lmtp,ia)
                   lmt2 = plmt2(lmtp,ia)
                   ilmta1 = lmta(lmt1,ia)
                   ilmta2 = lmta(lmt2,ia)
                   fr = fsr(ilmta2)
                   fi = fsi(ilmta2)
                   fr0 = fsr(ilmta1)
                   fi0 = fsi(ilmta1)
                   do imesh=1,nma
                      qm = qr_clm_ylm(imesh,ia,lmtp)
                      fsrqm(imesh,ilmta1,m,jkbz,ispin) = fsrqm(imesh,ilmta1,m,jkbz,ispin)+qm*fr
                      fsiqm(imesh,ilmta1,m,jkbz,ispin) = fsiqm(imesh,ilmta1,m,jkbz,ispin)+qm*fi
                      if(lmt1.ne.lmt2)then
                         fsrqm(imesh,ilmta2,m,jkbz,ispin) = fsrqm(imesh,ilmta2,m,jkbz,ispin)+qm*fr0
                         fsiqm(imesh,ilmta2,m,jkbz,ispin) = fsiqm(imesh,ilmta2,m,jkbz,ispin)+qm*fi0
                      endif
                   enddo
                enddo
             enddo
          enddo
       enddo
    enddo
    deallocate(fsr)
    deallocate(fsi)
  end subroutine build_fsqm

  subroutine m_ES_EXX_kernel(nfout)
    implicit none
    integer, intent(in) :: nfout
    
    integer :: ik,ikbz,ig,kgs
    real(kind=DP) :: fac, wi, kg(3), vzero, g2
    real(kind=DP), dimension(6) :: ttr
    integer :: igs,ige
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_kernel ',id_sname,level=1)

    if(.not.allocated(vc)) allocate(vc(nmax_G_hyb,nqmk))

    vc = 0.d0

    call getttr(rltv,ttr)

    fac = PAI4/univol

    if(sw_singular_correction==ON) then
       call singular_correction(vzero)
    else
       vzero = 0.d0
    end if
    vzero = vzero*dble(kv3bz)/product(reduction_factor_exx(1:3))

    if ( hybrid_functional_type == 'gaupbe' ) then
       call case_gaupbe
    else
       if(sw_screened_exchange==OFF) then
          do ik=1,nqmk
             kgs=1
             if(qmk_zero2(ik)) then
                kgs=2
                vc(1,ik) = vzero
             end if
             igs = kgs;ige=nmax_G_hyb
             do ig=igs,ige
                kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
                g2          = ttr(1)*kg(1)*kg(1) &
                     &           + ttr(2)*kg(2)*kg(2) &
                     &           + ttr(3)*kg(3)*kg(3) &
                     &           + ttr(4)*kg(1)*kg(2) &
                     &           + ttr(5)*kg(2)*kg(3) &
                     &           + ttr(6)*kg(3)*kg(1)
                if(g2<1e-12) then
                   vc(ig,ik) = vzero
                else
                   vc(ig,ik) = fac / g2
                endif
             end do
          end do
       else
          wi = 1.d0/(4.d0*omega_exx*omega_exx)
          do ik=1,nqmk
             kgs=1
             if(qmk_zero2(ik)) then
                kgs=2
                vc(1,ik) = vzero
             end if
             igs = kgs;ige=nmax_G_hyb
             do ig=igs,ige
                kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
                g2          = ttr(1)*kg(1)*kg(1) &
                     &           + ttr(2)*kg(2)*kg(2) &
                     &           + ttr(3)*kg(3)*kg(3) &
                     &           + ttr(4)*kg(1)*kg(2) &
                     &           + ttr(5)*kg(2)*kg(3) &
                     &           + ttr(6)*kg(3)*kg(1)
                if(g2<1e-12) then
                   vc(ig,ik) = vzero
                else
                   vc(ig,ik) = fac / g2 * (1.d0-exp(-g2*wi))
                endif
             end do
          end do
       end if

       vc = -alpha_exx * vc
    endif

    call tstatc0_end(id_sname)

    !!stop 'm_ES_EXX_kernel: Singular correction'

  contains

    subroutine case_gaupbe        ! J. Chem. Phys. 138 (2013) 241101.
      integer :: ik, ig, igs, ige
      real(kind=DP) :: fac, c1

      real(kind=DP), parameter :: alpha_gaupbe = 0.15d0
      real(kind=DP), parameter :: beta_gaupbe  = 0.24d0

      fac = ( PAI /alpha_gaupbe )**(3.d0/2.d0) /univol *beta_gaupbe

      do ik=1,nqmk
         kgs=1
         igs = kgs;ige=nmax_G_hyb
         do ig=igs,ige
            kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
            g2          = ttr(1)*kg(1)*kg(1) &
                 &           + ttr(2)*kg(2)*kg(2) &
                 &           + ttr(3)*kg(3)*kg(3) &
                 &           + ttr(4)*kg(1)*kg(2) &
                 &           + ttr(5)*kg(2)*kg(3) &
                 &           + ttr(6)*kg(3)*kg(1)
            c1 = exp( -g2 /4.0d0 /alpha_gaupbe )
            vc(ig,ik) = -fac *c1
         end do
      end do
    end subroutine case_gaupbe

    subroutine singular_correction(chi)
      implicit none 
      real(kind=DP), intent(out) :: chi

      real(kind=DP), parameter :: gam  = 1.d0 ! Bohr^-2
      real(kind=DP) :: chig1, chig2, chig3, gam3
      real(kind=DP) :: chi0, chi1, chi2

      !chig1 = chig(gam1)
      !chig2 = chig(gam2)
      !chi_app = chig1 + (chig1-chig2)/(gam2-gam1) * gam1

      call chig_deriv(gam,chi0,chi1,chi2)
      chi = chi0 - chi1*gam + 0.5d0*chi2*gam**2

      if(sw_screened_exchange==ON) then
         gam3 = 1.d0/(4.d0*omega_exx**2)
         chig3 = chig(gam3)
         chi = chi - chig3
      !   chi_app = chi_app - chig3
      end if

      if(printable) then
         write(nfout,'("EXX: Singular correction: chi(0)=",f10.5)') chi
         write(nfout,'("EXX: chi0(",f10.5,") =",f10.5)') gam, chi0
         write(nfout,'("EXX: chi1(",f10.5,") =",f10.5)') gam, chi1
         write(nfout,'("EXX: chi2(",f10.5,") =",f10.5)') gam, chi2
         if(sw_screened_exchange==ON) &
          & write(nfout,'("EXX: chi0(",f10.5,") =",f10.5)') gam3, chig3 
      end if
    end subroutine singular_correction

    function chig(gam)
      implicit none 
      real(kind=DP) :: chig
      real(kind=DP), intent(in) :: gam

      integer :: ig, ikbz, kgs, igs, ige
      real(kind=DP) :: sumg, sumgk, v0(3)

      sumg = 0.d0
      do ikbz=1,kv3bz
! ==== ASMS ===
!         if(.not.q_on_k_centered_mesh(ikbz,ikgamma)) cycle
!         kgs=1
!         if(qmk_zero(ikbz,ikgamma)) kgs=2
!
         if(.not.q_on_k_centered_mesh(ikbz,ikcenter)) cycle
         kgs=1
#if 1
         if ( qmk_zero(ikbz,ikcenter) ) kgs=2
         v0(:) = vkxyz_for_outerloop(ikcenter,:,BUCS)
#else
         if ( kshift_norm2 < DELTA07 .and. qmk_zero(ikbz,ikcenter) ) kgs=2
         v0(:) = 0.0d0
#endif
! ==== ASMS ===

         sumgk = 0.d0
         do ig=kgs,nmax_G_hyb
            kg(1:3) = vkbz(ikbz,1:3) -v0(1:3) +ngabc(ig,1:3)
            g2          = ttr(1)*kg(1)*kg(1) &
            &           + ttr(2)*kg(2)*kg(2) &
            &           + ttr(3)*kg(3)*kg(3) &
            &           + ttr(4)*kg(1)*kg(2) &
            &           + ttr(5)*kg(2)*kg(3) &
            &           + ttr(6)*kg(3)*kg(1)
            sumgk = sumgk + exp(-gam*g2) / g2
         end do
         sumg = sumg + wbz(ikbz) * sumgk
      end do
      sumg = fac * sumg

      chig = 1.d0/sqrt(PAI*gam) - sumg
    end function chig

    subroutine chig_deriv(gam,chi0,chi1,chi2)
      implicit none
      real(kind=DP), intent(in) :: gam
      real(kind=DP), intent(out) :: chi0, chi1, chi2

      integer :: ig, ikbz, kgs
      real(kind=DP) :: sumg0, sumgk0
      real(kind=DP) :: sumg1, sumgk1
      real(kind=DP) :: sumg2, sumgk2
      real(kind=DP) :: expg2, v0(3)

      sumg0 = 0.d0
      sumg1 = 0.d0
      sumg2 = 0.d0
      do ikbz=1,kv3bz
! ==== ASMS ===
!         if(.not.q_on_k_centered_mesh(ikbz,ikgamma)) cycle
!         kgs=1
!         if(qmk_zero(ikbz,ikgamma)) kgs=2
!
         if(.not.q_on_k_centered_mesh(ikbz,ikcenter)) cycle
         kgs=1
#if 1
         if ( qmk_zero(ikbz,ikcenter) ) kgs=2
         v0(:) = vkxyz_for_outerloop(ikcenter,:,BUCS)
#else
         if ( kshift_norm2 < DELTA07 .and. qmk_zero(ikbz,ikcenter) ) kgs=2
         v0(:) = 0.0d0
#endif
! ==== ASMS ===
         sumgk0 = 0.d0
         sumgk1 = 0.d0
         sumgk2 = 0.d0
         do ig=kgs,nmax_G_hyb
            kg(1:3) = vkbz(ikbz,1:3) -v0(1:3) +ngabc(ig,1:3)
            g2          = ttr(1)*kg(1)*kg(1) &
            &           + ttr(2)*kg(2)*kg(2) &
            &           + ttr(3)*kg(3)*kg(3) &
            &           + ttr(4)*kg(1)*kg(2) &
            &           + ttr(5)*kg(2)*kg(3) &
            &           + ttr(6)*kg(3)*kg(1)
            expg2 = exp(-gam*g2)
            sumgk0 = sumgk0 + expg2 / g2
            sumgk1 = sumgk1 + expg2
            sumgk2 = sumgk2 + expg2 * g2
         end do
         sumg0 = sumg0 + wbz(ikbz) * sumgk0
         sumg1 = sumg1 + wbz(ikbz) * sumgk1
         sumg2 = sumg2 + wbz(ikbz) * sumgk2
      end do
      chi0 =  1.d0/sqrt(PAI*gam) - fac*sumg0
      chi1 = -0.5d0/sqrt(PAI*gam**3) + fac*sumg1
      chi2 =  0.75d0/sqrt(PAI*gam**5) - fac*sumg2
    end subroutine chig_deriv

  end subroutine m_ES_EXX_kernel

  subroutine m_ES_EXX_potential(nfout,ispin,ib,ik,nff,fsr,fsi,vxw,iupdate,store_potential,exx,exx_only)
    implicit none
    integer, intent(in) :: nfout
    integer, intent(in) :: ispin,ib,ik
    integer, intent(in) :: nff
    integer, intent(in), optional :: iupdate
    logical, intent(in), optional :: store_potential
    integer :: iup
    real(kind=DP), intent(in)  :: fsr(nlmta),fsi(nlmta)
    real(kind=DP), intent(out) :: vxw(nff,kimg) 
    real(kind=DP), intent(out), optional :: exx
    logical, intent(in), optional :: exx_only

    real(kind=DP), allocatable :: efsr_l(:)
    real(kind=DP), allocatable :: efsi_l(:)
    logical :: eo
    real(kind=DP) :: ene
    integer :: ig,iadd
    logical :: store_p
    real(kind=DP), allocatable, dimension(:) :: zajbuf_r,zajbuf_i
    integer :: kgw,kgv
    integer :: id_sname=-1
    call tstatc0_begin('m_ES_EXX_potential ',id_sname,level=1)
    store_p = .true.
    if(present(store_potential)) store_p = store_potential

    eo = .false.
    if(present(exx_only)) eo = exx_only
    vxw = 0.0d0

    iup = 2
    if(present(iupdate)) iup = iupdate
    if(iup.lt.potential_update)then
       vxw(1:iba(ik),1:kimg) = exx_potential(1:iba(ik),ib,ik,1:kimg)
       if(present(exx))then
         exx=0.d0
         if(kimg==1)then
            do ig=1,iba(ik)
               exx = exx + zaj_l(ig,ib,ik,1)*vxw(ig,1)
            enddo
         else
            if(k_symmetry(ik) == GAMMA) then
               do ig=2,iba(ik)
                  exx = exx + zaj_l(ig,ib,ik,1) * vxw(ig,1) &
                      &     + zaj_l(ig,ib,ik,2) * vxw(ig,2)
               end do
               exx = exx * 2.d0 + zaj_l(1,ib,ik,1) * vxw(1,1)
            else
               do ig=1,iba(ik)
                  exx = exx + zaj_l(ig,ib,ik,1)*vxw(ig,1) &
                      &     + zaj_l(ig,ib,ik,2)*vxw(ig,2)
               end do
            endif
         endif
       endif
       return
    endif
    allocate(efsr_l(nlmta));efsr_l=0.d0
    allocate(efsi_l(nlmta));efsi_l=0.d0
    if(modnrm == EXECUT) call get_expkt_fs_b(ik,ib,fsr,fsi,efsr_l,efsi_l)
    allocate(zajbuf_r(kg1));zajbuf_r(:) = zaj_l(:,ib,ik,1)
    allocate(zajbuf_i(kg1));zajbuf_i(:) = zaj_l(:,ib,ik,kimg)
    kgw = kg1;kgv=kg1

    if(present(exx))then
       call apply_Vx_to_WF( ispin, ib, ik, kgw, kgv, zajbuf_r, zajbuf_i, efsr_l, efsi_l, vxw, ene, eo )
    else
       call apply_Vx_to_WF( ispin, ib, ik, kgw, kgv, zajbuf_r, zajbuf_i, efsr_l, efsi_l, vxw )
    endif

    deallocate(efsr_l)
    deallocate(efsi_l)
    deallocate(zajbuf_r)
    deallocate(zajbuf_i)
    if(present(exx)) exx = ene
    if(.not.eo.and.potential_update>0.and.store_p) &
    &  exx_potential(1:iba(ik),ib,ik,1:kimg) = vxw(1:iba(ik),1:kimg)
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_potential

  subroutine m_ES_EXX_eigenvalue_for_each_k(ispin,ik,update_eko,iupdate)
    implicit none
    integer, intent(in) :: ispin, ik
    logical, intent(in), optional :: update_eko
    integer, intent(in), optional :: iupdate

    integer :: ib,ig
    integer :: iup
    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxw !d(kg1,kimg)
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng
    logical :: u_eko
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_eigenvalue_for_each_k ',id_sname,level=1)
    
    iup = 2
    if(present(iupdate)) iup = iupdate

    if(.not.allocated(eexx_kb)) allocate(eexx_kb(np_e,ista_k:iend_k))

    if(.not.allocated(eko_hyb))then
       allocate(eko_hyb(np_e,ista_k:iend_k));eko_hyb=0.d0
    endif
    eko_hyb(:,ik) = 0.0d0
    u_eko = .true.
    if(.not.present(update_eko))then
       eko_l(:,ik) = 0.d0
    else
       if(update_eko) eko_l(:,ik) = 0.d0
       u_eko = update_eko
    endif
    ng=kg1
    allocate(vxw(ng,np_e,ista_k:iend_k,kimg))
       if(sw_rsb==ON.and.iup.ge.potential_update) call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       do ib=1,np_e   ! MPI
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),&
             & vxw(1:ng,ib,ik,1:kimg),iup,exx=exx,exx_only=.true.,store_potential=.false.)
          else
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),&
             & vxw(1:ng,ib,ik,1:kimg),iup,exx=exx,exx_only=.true.,store_potential=.false.)
          endif
          eexx_kb(ib,ik) = occup_l(ib,ik)*exx
          eko_hyb(ib,ik) = exx
          if(u_eko) then
             eko_l(ib,ik) = eko_l(ib,ik) + exx
          endif
       end do
       if(sw_rsb==ON.and.iup.ge.potential_update) call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)

    deallocate(vxw)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_eigenvalue_for_each_k

  subroutine m_ES_EXX_cp_eigenvalue(ik)
     integer, intent(in) :: ik
     if(.not.allocated(eko_hyb)) return
     eko_l(1:np_e,ik) = eko_hyb(1:np_e,ik)
  end subroutine m_ES_EXX_cp_eigenvalue

  subroutine m_ES_EXX_Diagonal_part(ispin,ik,vxdi)
    implicit none
    integer, intent(in) :: ispin, ik
    real(kind=DP), intent(out), dimension(kg1) :: vxdi

    integer :: ib,ig
    integer :: ii,m,jkbz,kk,jk,jop,jtrs
    real(kind=DP) :: fac, occupation
    real(kind=DP), allocatable, dimension(:) :: rho, pot, vx, vxq !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: rhor, rhoi !d(kg1)

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxdi_t

    integer,save  :: id_sname = -1


    call tstatc0_begin('m_ES_EXX_Diagonal_part ',id_sname,level=1)


    allocate(rho(nfft))
    allocate(pot(nfft))
    allocate(vx(nfft)); vx = 0.d0
    allocate(vxq(nfft))
    allocate(rhor(nmax_G_hyb)); rhor = 0.d0
    allocate(rhoi(nmax_G_hyb)); rhoi = 0.d0

    ! rho(G) = sum_q sum_m |phi_m(q+G)|^2
    do jkbz=1,kv3bz
       if(.not.q_on_k_centered_mesh(jkbz,ik)) cycle
       ! q(bz) = S*k(ibz)
       kk = ikp(jkbz) + ispin - 1
       jop = iopt(jkbz)
       jtrs = itrs(jkbz)
! === DEBUB by tkato 2013/02/21 ================================================
       rhor = 0.0d0
       rhoi = 0.0d0
! ==============================================================================
       do m=1,nval
          if(occup_val(m,kk) < DELTA) cycle
          occupation = wbz(jkbz)*occup_val(m,kk)/qwgt_for_innerloop(kk)/dble(kv3_for_innerloop)
          if(kimg==1) then
             do ii=1,iba_for_innerloop(kk)
                rhor(ii) = rhor(ii) + occupation * ( wfv(ii,m,kk,1) * wfv(ii,m,kk,1) )
             end do
          else
             do ii=1, min( iba_for_innerloop(kk), nmax_G_hyb )
                rhor(ii) = rhor(ii) + occupation * ( wfv(ii,m,kk,1) * wfv(ii,m,kk,1) &
                                                 & + wfv(ii,m,kk,2) * wfv(ii,m,kk,2) )
             end do
          end if
       end do
       call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,rhor,rhoi,rho)
#ifdef FFTW3
       call m_FFT_exx(nfout,rho,INVERSE,OFF) ! rho(R)
#else
       call m_FFT_WF(ELECTRON,nfout,rho,INVERSE,OFF) ! rho(R)
#endif

       do ii=1, min( kg, nmax_G_hyb )
          rhor(ii) = vc(ii,iqmk(jkbz,ik))
          rhoi(ii) = 0.d0
       end do
       call map_RHOG_on_FFT_box(rhor,rhoi,pot)
#ifdef FFTW3
       call m_FFT_exx(nfout,pot,INVERSE,OFF) ! pot(R)
#else
       call m_FFT_WF(ELECTRON,nfout,pot,INVERSE,OFF) ! pot(R)
#endif

       call product_on_FFT_box(pot,rho,vxq) ! vx(R)
       vx = vx + vxq
    end do

#ifdef FFTW3
    call m_FFT_exx(nfout,vx,DIRECT,OFF) ! vx(G)
#else
    call m_FFT_WF(ELECTRON,nfout,vx,DIRECT,OFF) ! vx(G)
#endif
    call map_FFT_box_on_RHOG(rhor,rhoi,vx) 
    fac = 1.d0/dble(nfftwf)
    vxdi = 0.0d0
    do ii=1,iba(ik)
       ig = nbase(ii,ik)
       if ( ig <= nmax_G_hyb ) then
          vxdi(ii) = fac * rhor(ig)
       endif
    end do
 
    deallocate(rho)
    deallocate(pot)
    deallocate(vx)
    deallocate(rhor)
    deallocate(rhoi)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_Diagonal_part


  subroutine m_ES_EXX_add_Diagonal_part(ik,ibo,vxdi,vnldi)
    implicit none
    integer, intent(in) :: ik, ibo
    real(kind=DP), intent(in), dimension(kg1) :: vxdi
    real(kind=DP), intent(out), dimension(kg1) :: vnldi

    integer :: ib

    ib = map_z(ibo)
    vnldi = vnldi + vxdi
  end subroutine m_ES_EXX_add_Diagonal_part

  subroutine m_ES_Vexx_W(ik,iupdate,store_exxp)
    implicit none
    integer, intent(in) :: ik
    integer, intent(in), optional :: iupdate
    logical, intent(in), optional :: store_exxp

    logical :: store_e

    integer :: ib,ig,ispin,iup
    real(kind=DP), allocatable, dimension(:,:,:,:) :: vxw !d(kg1,kimg)
    real(kind=DP), allocatable, dimension(:,:,:) :: vexx
    real(kind=DP) :: exx
    integer :: ng
    integer,save  :: id_sname = -1
    iup = 2
    if(present(iupdate)) iup = iupdate
    store_e = .true.
    if(present(store_exxp)) store_e = store_exxp
    call tstatc0_begin('m_ES_Vexx_W ',id_sname,level=1)

    ispin = mod(ik-1,nspin)+1

    ng = kg1
       allocate(vxw(ng,np_e,ista_k:iend_k,kimg))
       if(sw_rsb==ON) call UnitaryTransform_WF(INVERSE,ik,zaj_l,.true.,.true.)
       do ib=1,np_e   ! MPI
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsi_l(ib,:,ik),&
             &    vxw(1:ng,ib,ik,1:kimg),iup,store_potential=store_e)
          else
             call m_ES_EXX_potential(nfout,ispin,ib,ik,ng,fsr_l(ib,:,ik),fsr_l(ib,:,ik),&
             &    vxw(1:ng,ib,ik,1:kimg),iup,store_potential=store_e)
          endif
       end do
       if(sw_rsb==ON)then
          call UnitaryTransform_WF(DIRECT,ik,vxw,.false.,.false.)
          call UnitaryTransform_WF(DIRECT,ik,zaj_l,.true.,.true.)
          if(potential_update>0.and.store_e) &
          &  call UnitaryTransform_WF(DIRECT,ik,exx_potential,.false.,.false.)
       endif
       do ib=1,np_e
          call m_ES_Vexx_add_vexx(ik,ib,vxw(1:ng,ib,ik,1:kimg))
       enddo
       deallocate(vxw)
    call tstatc0_end(id_sname)
  end subroutine m_ES_Vexx_W

  subroutine m_ES_Vexx_add_vexx(ik,ib,vxw_exx)
    integer, intent(in) :: ib,ik
    real(kind=DP),dimension(kg1,kimg),intent(in) :: vxw_exx
    integer :: ig,iadd
    logical ma
    if(kimg==1) then
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + vxw_exx(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + vxw_exx(ig,1)
          vnlph_l(ig,ib,2) = vnlph_l(ig,ib,2) + vxw_exx(ig,2)
       end do
    end if 
  end subroutine m_ES_Vexx_add_vexx

  subroutine apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,wfr,wfi,bdwr,bdwi,vxw,eexx,eonly,force_l,dbdwr,dbdwi)
    implicit none
    integer, intent(in)                       :: ispin, ib,ik,kgw,kgv
    real(kind=DP), intent(in), dimension(kgw) :: wfr, wfi
    real(kind=DP), intent(in), dimension(nlmta) :: bdwr, bdwi
    real(kind=DP), intent(out), optional, dimension(kgv,kimg) :: vxw
    real(kind=DP), intent(out), optional :: eexx
    logical, intent(in), optional :: eonly

    real(kind=DP), intent(in), dimension(nlmta,3), optional :: dbdwr, dbdwi
    real(kind=DP), intent(inout), dimension(natm,3), optional :: force_l
    logical :: force_mode=.false.
    real(kind=DP) :: exx
    integer :: kk,m,ig,ii,jop,kop,jtrs
    integer :: jkbz
    real(kind=DP) :: fac, ph, occupation, dnorm
    real(kind=DP) :: skg(3)
    real(kind=DP), allocatable, dimension(:) :: rho,phi !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: wfn,wfm !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: sumdel !d(nfft)
    real(kind=DP), allocatable, dimension(:) :: rhogr, rhogi !d(kgp)
    real(kind=DP), allocatable, dimension(:) :: wfsr,wfsi !d(kg1)
    real(kind=DP), allocatable, dimension(:) :: cosgt, singt !d(kg1)
    real(kind=DP), allocatable, dimension(:) :: fsr, fsi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: dfsr, dfsi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: qvr, qvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: dqvr, dqvi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:,:) :: gqvr, gqvi !d(nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: sumqvr, sumqvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:,:) :: sumdqvr, sumdqvi !d(nlmta)
    real(kind=DP), allocatable, dimension(:) :: rhor,rhoi
    real(kind=DP), allocatable, dimension(:) :: afft
    real(kind=DP) :: ifac
    logical :: eo
    integer :: ikk
    integer,save  :: id_sname = -1,id_sname1=-2,id_sname2=-3,id_sname3=-4
    call tstatc0_begin('apply_Vx_to_WF ',id_sname)

    ikk = k_index(ik)

    eo=.false.
    if(present(eonly))then
      eo = eonly
    endif
    if(present(eexx))then
      eexx = 0.d0
    endif

    force_mode = present(force_l).and.present(dbdwr).and.present(dbdwi)

    allocate(rho(nfft));rho=0.d0
    allocate(phi(nfft));phi=0.d0
    allocate(wfn(nfft));wfn=0.d0
    allocate(wfm(nfft));wfm=0.d0
    allocate(sumdel(nfft));sumdel=0.d0
    allocate(rhogr(nmax_G_hyb));rhogr=0.d0
    if(sw_rspace_hyb==ON.and.modnrm==EXECUT)then
       allocate(rhor(nfftp_exx_nonpara/2));rhor=0.d0
       allocate(rhoi(nfftp_exx_nonpara/2));rhoi=0.d0
       allocate(afft(nfftp_exx_nonpara));afft=0.d0
    endif
    if(kimg==2) then
       allocate(rhogi(nmax_G_hyb))
       rhogi = 0.d0        
    endif
    allocate(wfsr(kg1_for_innerloop));wfsr=0.d0
    if(kimg==2) then
       allocate(wfsi(kg1_for_innerloop));wfsi=0.d0
    endif
    allocate(cosgt(kg1_for_innerloop))
    if(kimg==2) allocate(singt(kg1_for_innerloop))
    if(modnrm == EXECUT) then
       allocate(fsr(nlmta))
       allocate(fsi(nlmta))
       allocate(qvr(nlmta))
       allocate(qvi(nlmta))
       allocate(sumqvr(nlmta))
       allocate(sumqvi(nlmta))
       fac = 1.d0/dble(nfftwf)
       sumqvr = 0.d0
       sumqvi = 0.d0
       if(force_mode)then
          allocate(dfsr(nlmta,3))
          allocate(dfsi(nlmta,3))
          allocate(dqvr(nlmta,3))
          allocate(dqvi(nlmta,3))
          allocate(gqvr(nlmta,3))
          allocate(gqvi(nlmta,3))
          allocate(sumdqvr(nlmta,3))
          allocate(sumdqvi(nlmta,3))
          sumdqvr=0.d0;sumdqvi=0.d0
       endif
    end if

    call map_WFG_on_FFT_box(ik,wfr,wfi,wfn)
#ifdef FFTW3
    call m_FFT_exx(nfout,wfn,INVERSE,OFF) ! wfn(R)
#else
    call m_FFT_WF(ELECTRON,nfout,wfn,INVERSE,OFF) ! wfn(R)
#endif

    sumdel = 0.d0
    do jkbz=1,kv3bz
       if(.not.q_on_k_centered_mesh(jkbz,ikk)) cycle
#ifdef MEMORY_SAVE_EXX
       call m_ES_EXX_ylm_each_k(iqmk(jkbz,ikk))
#ifdef MEMORY_SAVE_MORE_EXX
       call qitgft_qmk_each_k(iqmk(jkbz,ikk))
#endif
#endif
       ! q(bz) = S*k(ibz)
       kk = ikp(jkbz) + ispin - 1
       kop = iops(jkbz)
       jop = iopt(jkbz) 
       jtrs = itrs(jkbz)
       if(kimg==1) then
          do ig=1,iba_for_innerloop(kk)
             ii = nbase_for_innerloop(ig,kk)
             skg(1:3) = vkxyz_for_innerloop(kk,1:3,BUCS) + ngabc(ii,1:3)
             ph = PAI2 * dot_product(skg,tau(:,kop,BUCS))
             cosgt(ig) = cos(ph)
          end do
       else
          do ig=1,iba_for_innerloop(kk)
             ii = nbase_for_innerloop(ig,kk)
             skg(1:3) = vkxyz_for_innerloop(kk,1:3,BUCS) + ngabc(ii,1:3)
             ph = PAI2 * dot_product(skg,tau(:,kop,BUCS))
             cosgt(ig) = cos(ph)
             singt(ig) = sin(ph)
          end do
       end if
       do m=1,nval
          if(occup_val(m,kk) < DELTA) cycle
          if(sw_rsb==ON)then
             if(.not.overlap(ib,m))cycle
          endif
          occupation = wbz(jkbz) * occup_val(m,kk)/qwgt_for_innerloop(kk)/dble(kv3_for_innerloop)
          if(kimg==1) then
             dnorm = 0.d0
             do ig=1,iba_for_innerloop(kk)
                wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig)  
                dnorm = dnorm + wfsr(ig)*wfsr(ig)
             end do
             dnorm = 1.d0/sqrt(dnorm)
             wfsr = wfsr * dnorm
             call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,wfsr,wfsr,wfm)
          else
             if(jtrs==0) then
                do ig=1,iba_for_innerloop(kk)
                   wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig) - wfv(ig,m,kk,2) * singt(ig)
                   wfsi(ig) = wfv(ig,m,kk,2) * cosgt(ig) + wfv(ig,m,kk,1) * singt(ig)
                end do
             else
                do ig=1,iba_for_innerloop(kk)
                   wfsr(ig) = wfv(ig,m,kk,1) * cosgt(ig) - wfv(ig,m,kk,2) * singt(ig)
                   wfsi(ig) = -wfv(ig,m,kk,2) * cosgt(ig) - wfv(ig,m,kk,1) * singt(ig)
                end do
             end if
             call map_Rot_WFG_on_FFT_box(kk,jop,jtrs,wfsr,wfsi,wfm)
          end if
#ifdef FFTW3
          call m_FFT_exx(nfout,wfm,INVERSE,OFF) ! wfm(R)
#else
          call m_FFT_WF(ELECTRON,nfout,wfm,INVERSE,OFF) ! wfm(R)
#endif
          call product_on_FFT_box(wfn,wfm,rho) ! rho_soft(R)
#ifdef FFTW3
          call m_FFT_exx(nfout,rho,DIRECT,OFF) ! rho_soft(G)
#else
          call m_FFT_WF(ELECTRON,nfout,rho,DIRECT,OFF) ! rho_soft(G)
#endif

          if(kimg==1) then
             call map_FFT_box_on_RHOG(rhogr,rhogr,rho)
             do ii=1,nmax_G_hyb
                rhogr(ii) = vc(ii,iqmk(jkbz,ikk)) * rhogr(ii) ! phi(G) = Vc(G,q) * rho(G)
             end do
             call map_RHOG_on_FFT_box(rhogr,rhogr,phi)
          else
             call map_FFT_box_on_RHOG(rhogr,rhogi,rho)
             !! rho(G) = rho_soft(G) + rho_hard(G)
             if(modnrm == EXECUT) then
                do ii=1, min( kg, nmax_G_hyb )
                   rhogr(ii) = fac * rhogr(ii)
                   rhogi(ii) = fac * rhogi(ii)
                end do
                do ii=kg+1, nmax_G_hyb
                   rhogr(ii) = 0.d0
                   rhogi(ii) = 0.d0
                end do
                if(force_mode)then
                   call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi,dfsr,dfsi)
                else
                   if(sw_rspace_hyb==OFF .or. (sw_rspace_hyb==ON .and. sw_precalculate==OFF)) &
                  &   call get_Rot_betar_dot_WFs(kk,m,jop,kop,jtrs,fsr,fsi)
                endif
                if(sw_rspace_hyb==ON)then
                   if(sw_precalculate==OFF)then
                      call add_RHOG_hard_part_rs(iqmk(jkbz,ikk),rhor,rhoi,bdwr,bdwi,fsr,fsi)
                   else
                      call add_RHOG_hard_part_rs2(iqmk(jkbz,ikk),rhor,rhoi,&
                     & fsrqm(:,:,m,jkbz,ispin),fsiqm(:,:,m,jkbz,ispin),bdwr,bdwi)
                   endif
                   call map_RHOG_on_FFT_box_hard(rhor,rhoi,afft)
                   call m_FFT_CD0_exx(nfout,afft,DIRECT)
                   call map_FFT_box_on_RHOG_hard(rhor,rhoi,afft)
                   do ii=1,nmax_G_hyb
                      rhogr(ii) = rhogr(ii) + rhor(ii)
                      rhogi(ii) = rhogi(ii) + rhoi(ii)
                   end do
                else
                   call add_RHOG_hard_part(iqmk(jkbz,ikk),rhogr,rhogi,bdwr,bdwi,fsr,fsi)
                endif
             end if
             if(present(eexx))then
                exx = 0.d0
                call sum_rho_vc_rho(rhogr,rhogi,vc(1,iqmk(jkbz,ikk)),exx)
                eexx = eexx + occupation * exx
                if(eo) cycle
             endif
             do ii=1,nmax_G_hyb
                rhogr(ii) = vc(ii,iqmk(jkbz,ikk)) * rhogr(ii) ! phi(G) = Vc(G,q) * rho(G)
                rhogi(ii) = vc(ii,iqmk(jkbz,ikk)) * rhogi(ii) ! phi(G) = Vc(G,q) * rho(G)
             end do
             !! Dij[Vnm] = Sum_G Qij(G) * Vnm(G)
             !! Hi[Vnm] = Sum_j Dij[Vnm] <beta_j|psi_m>
!
             if (modnrm == EXECUT) then
                if(sw_rspace_hyb==ON)then
                   call map_RHOG_on_FFT_box_hard_inv(rhogr,rhogi,afft)
                   call m_FFT_CD0_exx(nfout,afft,INVERSE)
                   call map_FFT_box_on_RHOG_hard_inv(rhor,rhoi,afft)
                   if(force_mode)then
                      call integrate_QijVnm_rs(iqmk(jkbz,ikk),rhor,rhoi,fsr,fsi,qvr,qvi,dfsr,dfsi,dqvr,dqvi,gqvr,gqvi)
                   else
                   if(sw_precalculate==OFF)then
                      call integrate_QijVnm_rs(iqmk(jkbz,ikk),rhor,rhoi,fsr,fsi,qvr,qvi)
                   else
                      call integrate_QijVnm_rs2(iqmk(jkbz,ikk),rhor,rhoi, &
                    & fsrqm(:,:,m,jkbz,ispin),fsiqm(:,:,m,jkbz,ispin),qvr,qvi)
                   endif
                   endif
                else
                   if(force_mode)then
                      call integrate_QijVnm(iqmk(jkbz,ikk),rhogr,rhogi,fsr,fsi,qvr,qvi,dfsr,dfsi,dqvr,dqvi,gqvr,gqvi)
                   else
                      call integrate_QijVnm(iqmk(jkbz,ikk),rhogr,rhogi,fsr,fsi,qvr,qvi)
                   endif
                endif
             endif
! =============================================================== 12.5Exp
             if(.not.force_mode)then
                call map_RHOG_on_FFT_box(rhogr,rhogi,phi)
             endif
          end if

          if(force_mode)then
             sumqvr = sumqvr + occupation * qvr ! sum_m qvr_m
             sumqvi = sumqvi + occupation * qvi ! sum_m qvi_m
             sumdqvr = sumdqvr + occupation * (dqvr+gqvr) ! sum_m (dqvr_m + gqvr_m)
             sumdqvi = sumdqvi + occupation * (dqvi+gqvi) ! sum_m (dqvi_m + gqvi_m)
          else
#ifdef FFTW3
             call m_FFT_exx(nfout,phi,INVERSE,OFF) ! phi(R)
#else
             call m_FFT_WF(ELECTRON,nfout,phi,INVERSE,OFF) ! phi(R)
#endif
             call product_on_FFT_box(phi,wfm,rho) ! delta(R)
             sumdel = sumdel + occupation * rho ! sum delta(R)
             !! Bin = Sum_m fm * Hi[Vnm]
             if(modnrm == EXECUT) then
                sumqvr = sumqvr + occupation * qvr ! sum_m qvr_m
                sumqvi = sumqvi + occupation * qvi ! sum_m qvi_m
             end if
          endif
       end do 
    end do 
    if(force_mode)then
       !! dEXX/dR(n) = Sum_i Re[ <psi_n|dbeta_i/dR> * Bin +  <psi_n|beta_i> * Cin ]
       call sum_EXX_force_terms(force_l,bdwr,bdwi,dbdwr,dbdwi,sumqvr,sumqvi,sumdqvr,sumdqvi)
    else
#ifdef FFTW3
       call m_FFT_exx(nfout,sumdel,DIRECT,OFF) ! sum delta(G)
#else
       call m_FFT_WF(ELECTRON,nfout,sumdel,DIRECT,OFF) ! sum delta(G)
#endif
       if(kimg==1) then
          call map_FFT_box_on_WFG(ik,vxw(1,1),vxw(1,1),sumdel)
       else
          call map_FFT_box_on_WFG(ik,vxw(1,1),vxw(1,2),sumdel)
       end if

       if(modnrm == EXECUT)  then
          fac = 1.d0/dble(nfftwf)
       else
          fac = 1.d0/dble(nfftwf)**2
          if(present(eexx)) eexx = eexx*fac
       end if
       vxw = fac*vxw
       if(modnrm == EXECUT) then
          call add_Vx_hard_part(ik,vxw,sumqvr,sumqvi)
       endif
    endif
    deallocate(rho)
    deallocate(phi)
    deallocate(wfn)
    deallocate(wfm)
    deallocate(sumdel)
    deallocate(rhogr)
    if(kimg==2) deallocate(rhogi)
    deallocate(wfsr)
    if(kimg==2) deallocate(wfsi)
    deallocate(cosgt)
    if(kimg==2) deallocate(singt)
    if(modnrm == EXECUT) then
       deallocate(fsr)
       deallocate(fsi)
       deallocate(qvr)
       deallocate(qvi)
       deallocate(sumqvr)
       deallocate(sumqvi)
       if(force_mode)then
          deallocate(dfsr)
          deallocate(dfsi)
          deallocate(dqvr)
          deallocate(dqvi)
          deallocate(gqvr)
          deallocate(gqvi)
          deallocate(sumdqvr)
          deallocate(sumdqvi)
       endif
    end if

    if(sw_rspace_hyb==ON.and.modnrm==EXECUT)then
       deallocate(rhor)
       deallocate(rhoi)
       deallocate(afft)
    endif

    call tstatc0_end(id_sname)
  end subroutine apply_Vx_to_WF


  subroutine m_ES_EXX_energy2(eexx)
    implicit none
    real(kind=DP), intent(out) :: eexx
    real(kind=DP) :: eexx_mpi
    integer :: ispin,ik,ib,ib1,ierr
    eexx = 0.0d0
    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          do ib=1,np_e   ! MPI
             if(occup_l(ib,ik) < DELTA) cycle
             eexx = eexx + eexx_kb(ib,ik)
          enddo
       enddo
    enddo
    eexx = 0.5d0*eexx/dble(kv3/nspin)
    if(nspin==1) eexx = 2.d0 * eexx

    if(npes>1) then
       call mpi_allreduce(eexx,eexx_mpi,1,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       eexx = eexx_mpi
    end if

  end subroutine m_ES_EXX_energy2

  subroutine m_ES_EXX_energy(eexx)
    implicit none
    real(kind=DP), intent(out) :: eexx
    integer :: ispin,ik
    integer :: id_sname=-1
    call tstatc0_begin('m_ES_EXX_energy ',id_sname,level=1)

    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          call m_ES_EXX_eigenvalue_for_each_k(ispin,ik,.false.,iupdate=2)
       enddo
    enddo
    call m_ES_EXX_energy2(eexx)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_energy

  subroutine product_on_FFT_box(wfn,wfm,rho)
    implicit none
    real(kind=DP), intent(in), dimension(nfft) :: wfn,wfm
    real(kind=DP), intent(out), dimension(nfft) :: rho

    integer :: i, ire, iim, ik
    rho=0.d0
    if(kv3_for_innerloop/nspin==1 .and. k_symmetry(1) == GAMMA) then
       do i=1,nfft_exx,2
          ire = i
          iim = i+1
          rho(ire) = wfn(ire)*wfm(ire)
          rho(iim) = 0.d0
       end do
    else
       do i=1,nfft_exx,2
          ire = i
          iim = i+1
          rho(ire) = wfn(ire)*wfm(ire) + wfn(iim)*wfm(iim)
          rho(iim) = wfn(ire)*wfm(iim) - wfn(iim)*wfm(ire)
       end do
    end if
  end subroutine product_on_FFT_box


  subroutine sum_rho_vc_rho(rhor,rhoi,vc,exx)
    implicit none
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: rhor,rhoi
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: vc
    real(kind=DP), intent(out) :: exx

    integer :: ig

    exx = 0.d0

    if(kimg==1) then
       do ig=1,nmax_G_hyb
          exx = exx + vc(ig) * rhor(ig)*rhor(ig)
       end do
    else
       do ig=1,nmax_G_hyb
          exx = exx + vc(ig) * (rhor(ig)*rhor(ig)+rhoi(ig)*rhoi(ig))
       end do
    end if
  end subroutine sum_rho_vc_rho

  subroutine map_WFG_on_FFT_box(ik,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                         :: ik
    real(kind=DP), intent(in), dimension(kg1)   :: wfr, wfi
    real(kind=DP), intent(out), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf_exx(1)
          bfft(i1) = wfr(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             if(i<=kg_exx)then
               i1 = igf_exx(i)
               bfft(i1) = wfr(ii)
             endif
             j = nbase_gamma(ii,2)
             if(j<=kg_exx)then
               i2 = igf_exx(j)
               bfft(i2) = wfr(ii)
             endif
          end do
       else ! kimg == 2
          i1 = 2*igf_exx(1) - 1
          bfft(i1)   = wfr(1)
          bfft(i1+1) = wfi(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             if(i<=kg_exx)then
               i1 = 2*igf_exx(i)-1
               bfft(i1  ) = wfr(ii)
               bfft(i1+1) = wfi(ii)
             endif
             j = nbase_gamma(ii,2)
             if(j<=kg_exx)then
               i2 = 2*igf_exx(j)-1
               bfft(i2  ) = wfr(ii)
               bfft(i2+1) = -wfi(ii)
             endif
          end do
       end if
    else
      if(kimg == 1) then 
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           if(nbase(i,ik)<=kg_exx)then
             i1 = igf_exx(nbase(i,ik))
             bfft(i1) = wfr(i)
           endif
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba(ik)
           if(nbase(i,ik)<=kg_exx)then
             i1 = 2*igf_exx(nbase(i,ik)) - 1
             bfft(i1) = wfr(i)
             i2 = 2*igf_exx(nbase(i,ik))
             bfft(i2) = wfi(i)
           endif
        end do
      end if
    end if
  end subroutine map_WFG_on_FFT_box

  subroutine map_Rot_WFG_on_FFT_box(ik,nop,jtrs,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                         :: ik,nop,jtrs
    real(kind=DP), intent(in), dimension(kg1_for_innerloop)   :: wfr, wfi
    real(kind=DP), intent(out), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii, ip

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf_exx(1)
          bfft(i1) = wfr(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_for_innerloop(ik)
             i = nbase_for_innerloop(ii,ik)
             if(ngpt_exx(i,nop,jtrs)<=kg_exx)then
                i1 = igf_exx(ngpt_exx(i,nop,jtrs))
                bfft(i1) = wfr(ii)
             endif
             j = nbase_gamma_for_innerloop(ii,2)
             if(ngpt_exx(j,nop,jtrs)<=kg_exx)then
                i2 = igf_exx(ngpt_exx(j,nop,jtrs))
                bfft(i2) = wfr(ii)
             endif
          end do
       else ! kimg == 2
          i1 = 2*igf_exx(1) - 1
          bfft(i1)   = wfr(1)
          bfft(i1+1) = wfi(1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_for_innerloop(ik)
             i = nbase_for_innerloop(ii,ik)
             if(ngpt_exx(i,nop,jtrs)<=kg_exx)then
               i1 = 2*igf_exx(ngpt_exx(i,nop,jtrs))-1
               bfft(i1  ) = wfr(ii)
               bfft(i1+1) = wfi(ii)
             endif
             j = nbase_gamma_for_innerloop(ii,2)
             if(ngpt_exx(j,nop,jtrs)<=kg_exx)then
               i2 = 2*igf_exx(ngpt_exx(j,nop,jtrs))-1
               bfft(i2  ) = wfr(ii)
               bfft(i2+1) = -wfi(ii)
             endif
          end do
       end if
    else
      if(kimg == 1) then 
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba_for_innerloop(ik)
           if(ngpt_exx(nbase_for_innerloop(i,ik),nop,jtrs)<=kg_exx)then
             i1 = igf_exx(ngpt_exx(nbase_for_innerloop(i,ik),nop,jtrs))
             bfft(i1) = wfr(i)
           endif
        end do
      else ! kimg == 2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
        do i = 1, iba_for_innerloop(ik)
           if(ngpt_exx(nbase_for_innerloop(i,ik),nop,jtrs)<=kg_exx)then
             ip = igf_exx(ngpt_exx(nbase_for_innerloop(i,ik),nop,jtrs))
             i1 = 2*ip - 1
             bfft(i1) = wfr(i)
             i2 = 2*ip
             bfft(i2) = wfi(i)
           endif
        end do
      end if
    end if
  end subroutine map_Rot_WFG_on_FFT_box

  subroutine map_FFT_box_on_WFG(ik,wfr,wfi,bfft)
    implicit none
    integer, intent(in)                        :: ik
    real(kind=DP), intent(out), dimension(kg1) :: wfr, wfi
    real(kind=DP), intent(in), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          wfr = 0.d0

          i1 = igf_exx(1)
          wfr(1) = bfft(i1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             if(i<=kg_exx)then
               i1 = igf_exx(i)
               wfr(ii) = bfft(i1)
             endif
          end do
       else ! kimg == 2
          wfr = 0.d0
          wfi = 0.d0

          i1 = 2*igf_exx(1) - 1
          wfr(1) = bfft(i1)
          wfi(1) = bfft(i1+1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
             i = nbase(ii,ik)
             if(i<=kg_exx)then
               i1 = 2*igf_exx(i)-1
               wfr(ii) = bfft(i1  )
               wfi(ii) = bfft(i1+1)
             endif
          end do
       end if
    else
       if(kimg == 1) then
          wfr = 0.d0
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             if(nbase(i,ik)<=kg_exx)then
               i1 = igf_exx(nbase(i,ik))
               wfr(i) = bfft(i1)
             endif
          end do
       else ! kimg == 2
          wfr = 0.d0
          wfi = 0.d0
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             if(nbase(i,ik)<=kg_exx)then
               i1 = 2*igf_exx(nbase(i,ik)) - 1
               wfr(i) = bfft(i1)
               i2 = 2*igf_exx(nbase(i,ik))
               wfi(i) = bfft(i2)
             endif
          end do
       end if
    end if
  end subroutine map_FFT_box_on_WFG

  subroutine map_FFT_box_on_RHOG(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(out), dimension(nmax_G_hyb) :: rhor, rhoi
    real(kind=DP), intent(in), dimension(nfft) :: afft

    integer :: i,i1,i2

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg_exx, nmax_G_hyb )
          i1 = igf_exx(i)
          rhor(i) = afft(i1)
       end do
    else ! kimg==2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg_exx, nmax_G_hyb )
          i1 = 2*igf_exx(i) - 1
          rhor(i) = afft(i1)
          i2 = 2*igf_exx(i)
          rhoi(i) = afft(i2)
       end do
    end if
  end subroutine map_FFT_box_on_RHOG

  subroutine map_RHOG_on_FFT_box(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nmax_G_hyb) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfft) :: afft

    integer :: i,i1,i2

    afft = 0.d0

    if(kimg == 1) then
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg_exx, nmax_G_hyb )
          i1 = igf_exx(i)
          afft(i1) = rhor(i)
       end do
    else ! kimg==2
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
       do i = 1, min( kg_exx, nmax_G_hyb )
          i1 = 2*igf_exx(i) - 1
          afft(i1) = rhor(i)
          i2 = 2*igf_exx(i)
          afft(i2) = rhoi(i)
       end do
    end if
  end subroutine map_RHOG_on_FFT_box

  subroutine map_RHOG_on_FFT_box_hard(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara) :: afft

    integer :: i,i1,i2

!    afft(:) = 0.d0
    do i = 1, nfftp_exx_nonpara/2
!       i1 = (igfp_l(i)-1)*kimg+1
       i1 = (i-1)*kimg+1
       afft(i1)   = rhor(i)
       afft(i1+1) = rhoi(i)
    end do
  end subroutine map_RHOG_on_FFT_box_hard

  subroutine map_RHOG_on_FFT_box_hard_inv(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara) :: afft
    integer :: i,i1,i2

    afft(:) = 0.d0

    do i = 1, kgp_exx
       i1 = (igfp_exx(i)-1)*kimg+1
       afft(i1) = rhor(i)
       afft(i1+1) = rhoi(i)
    end do
  end subroutine map_RHOG_on_FFT_box_hard_inv

  subroutine map_FFT_box_on_RHOG_hard(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara) :: afft
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP) :: rinplw
    integer :: i,i1,i2
    integer :: id_sname = -1

    rinplw = 1.d0/product(fft_box_size_CD_exx(1:3,1))
    rhor(:)=0.d0
    rhoi(:)=0.d0
    do i = 1, kgp_exx
       i1 = (igfp_exx(i)-1)*kimg+1
       rhor(i) = afft(i1)*rinplw
       rhoi(i) = afft(i1+1)*rinplw
    end do
  end subroutine map_FFT_box_on_RHOG_hard

  subroutine map_FFT_box_on_RHOG_hard_inv(rhor,rhoi,afft)
    implicit none
    real(kind=DP), intent(in), dimension(nfftp_exx_nonpara) :: afft
    real(kind=DP), intent(out), dimension(nfftp_exx_nonpara/2) :: rhor, rhoi
    real(kind=DP) :: rinplw
    integer :: i,i1,i2

    rinplw = 1.d0/product(fft_box_size_CD_exx(1:3,1))
!    rhor(:)=0.d0
!    rhoi(:)=0.d0
    do i = 1, nfftp_exx_nonpara/2
       i1 = (i-1)*kimg+1
       rhor(i) = afft(i1)*rinplw 
       rhoi(i) = afft(i1+1)*rinplw
    end do
  end subroutine map_FFT_box_on_RHOG_hard_inv

  subroutine m_ES_EXX_ngpt()
    implicit none

    integer :: i,j,iopr,ii
    integer :: ia,ib,ic
    integer :: namin,namax,nbmin,nbmax,ncmin,ncmax
    integer, allocatable, dimension(:,:,:) :: g_list
    integer, allocatable, dimension(:) :: ngpt_exx_tmp, ngpt_exx0_tmp
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_ngpt ',id_sname,level=1)

!!$    allocate(ngpt_exx(kgp,nopr,0:ntrs)); ngpt_exx = 0
    allocate(ngpt_exx(kg,nopr,0:ntrs)); ngpt_exx = 0

    !! Time reversal symmetry

    if(ntrs>0) then

       namax = n_rGpv(1); nbmax = n_rGpv(2); ncmax = n_rGpv(3)
       namin = -namax   ; nbmin = -nbmax   ; ncmin = -ncmax
       allocate(g_list(namin:namax,nbmin:nbmax,ncmin:ncmax)); g_list = 0

       do i = 1, kgp
          ia = ngabc(i,1)
          ib = ngabc(i,2)
          ic = ngabc(i,3)
          g_list(ia,ib,ic) = i
       end do
    end if

    if(npes > 1) then
       allocate(ngpt_exx0_tmp(kgp))
       do iopr=1,nopr
          ngpt_exx0_tmp = 0
          do i = ista_kngp, iend_kngp
             ngpt_exx0_tmp(i) = ngpt_l(i,iopr)
          end do
          call mpi_allreduce(MPI_IN_PLACE,ngpt_exx0_tmp,kgp,mpi_integer,mpi_sum,mpi_comm_group,ierr)
          ngpt_exx(1:kg,iopr,0) = ngpt_exx0_tmp(1:kg)

          if(ntrs>0) then
             allocate(ngpt_exx_tmp(kg))
             ngpt_exx_tmp = 0
             do i=1,kg
                ii = ngpt_exx0_tmp(i)
                ia = -ngabc(ii,1)
                ib = -ngabc(ii,2)
                ic = -ngabc(ii,3)
                ngpt_exx_tmp(i) = g_list(ia,ib,ic)
             end do
             ngpt_exx(1:kg,iopr,1) = ngpt_exx_tmp(1:kg)
! === ASMS ===
             deallocate(ngpt_exx_tmp)
! === ASMS ===
          end if
       end do
       deallocate(ngpt_exx0_tmp)
    else
       do iopr=1,nopr
          if(ntrs==0) then
             do i = 1, kg
                ngpt_exx(i,iopr,0) = ngpt_l(i,iopr)
             end do
          else
             do i = 1, kg
                ngpt_exx(i,iopr,0) = ngpt_l(i,iopr)
                ii = ngpt_l(i,iopr)
                ia = -ngabc(ii,1)
                ib = -ngabc(ii,2)
                ic = -ngabc(ii,3)
                ngpt_exx(i,iopr,1) = g_list(ia,ib,ic)
             end do
          end if
       end do
    end if

!!$    allocate(ngpt_exx_tmp(kgp))
!!$    do iopr=1,nopr
!!$       ngpt_exx_tmp = 0
!!$       do i=1,kgp
!!$          ii = ngpt_exx(i,iopr,0)
!!$          if(ista_kngp<=ii .and. ii<=iend_kngp) then
!!$             ia = -ngabc_kngp_l(ii,1)
!!$             ib = -ngabc_kngp_l(ii,2)
!!$             ic = -ngabc_kngp_l(ii,3)
!!$             ngpt_exx_tmp(i) = g_list(ia,ib,ic)
!!$          end if
!!$       end do
!!$       call mpi_allreduce(MPI_IN_PLACE, ngpt_exx_tmp, kgp, mpi_integer, mpi_sum,mpi_ke_world,ierr)
!!$       ngpt_exx(:,iopr,1) = ngpt_exx_tmp(:)
!!$    end do
!!$    deallocate(ngpt_exx_tmp)
!!$    
!!$          ia = -ngabc(ii,1)
!!$          ib = -ngabc(ii,2)
!!$          ic = -ngabc(ii,3)
!!$          ngpt_exx(i,iopr,1) = g_list(ia,ib,ic)
!!$       end do
!!$    end do
    if(ntrs>0) deallocate(g_list)

    j = 0
    do ii = 0, ntrs
       do iopr = 1, nopr
          do i = 1, kg
             if(ngpt_exx(i,iopr,ii) <= 0) j = j + 1
          end do
       end do
    end do
    if(j >= 1) then
       write(nfout,'(" !! check of ngpt_exx")')
       do ii = 0, ntrs
          do iopr = 1, nopr
             do i = 1, kg
                if(ngpt_exx(i,iopr,ii) <= 0) write(nfout,'(" ngpt_exx(",i8,",",i8,",",i8,") = ",i20)') &
                & i,iopr,ii, ngpt_exx(i,iopr,ii)
             end do
          end do
       end do
       write(nfout,'(" !! total number of negative values for ngpt_exx = ",i8)') j
       write(nfout,'(" !! out of check of ngpt_exx")')
    end if

    call tstatc0_end(id_sname)
    !!!stop 'Check: G_list'
  end subroutine m_ES_EXX_ngpt

  subroutine m_ES_EXX_occup(nfout)
    implicit none
    integer, intent(in) :: nfout

    real(kind=DP) :: chgt, chg(nspin), zet
    integer :: ik,ib,is,it
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_occup ',id_sname,level=1)

    chg(1:nspin) = 0.d0
    do it=1,ntyp
       chgt = ival(it) * iatom(it) + qex(it)
       if(nspin==1) then
          chg(1) = chg(1) + chgt
       else
          zet = zeta1(it)
          chg(1) = chg(1) + chgt * (1.d0+zet)/2.d0
          chg(2) = chg(2) + chgt * (1.d0-zet)/2.d0
       end if
    end do
    if(nspin==1) chg(1) = chg(1)/2.d0

    nval = nint(maxval(chg)+0.1d0)

    occup_l(1:np_e,ista_k:iend_k) = 0.d0
    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       do ib = 1, neg
          if(neordr(ib,ik)>nval) cycle
          if(map_e(ib) == myrank_e) then
!!$       do ib=ista_e,iend_e,istep_e
!!$          !!if(ib>nval) cycle
!!$          if(neordr(ib,ik)>nval) cycle
             occup_l(map_z(ib),ik) = kv3*qwgt(ik)
          end if
       end do
    end do
    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_occup

  subroutine m_ES_EXX_store_wfv()
    implicit none
    if(.not.allocated(wfv_old)) allocate(wfv_old(kg1,nval,kv3,kimg))
    if(.not.allocated(occup_val_old)) allocate(occup_val_old(nval,kv3))
    if(modnrm == EXECUT) then
       if(.not.allocated(fsr_exx_old)) allocate(fsr_exx_old(nval,nlmta,kv3))
       if(.not.allocated(fsi_exx_old)) allocate(fsi_exx_old(nval,nlmta,kv3))
    end if

    wfv_old  = wfv
    occup_val_old = occup_val
    nval_old = nval
    if(modnrm == EXECUT) then
       fsr_exx_old = fsr_exx
       fsi_exx_old = fsi_exx
    end if
  end subroutine m_ES_EXX_store_wfv

  subroutine m_ES_EXX_restore_wfv()
    implicit none
    if(allocated(wfv)) deallocate(wfv)
    if(allocated(occup_val)) deallocate(occup_val)
    if(modnrm == EXECUT) then
       if(allocated(fsr_exx)) deallocate(fsr_exx)
       if(allocated(fsi_exx)) deallocate(fsi_exx)
    end if
    nval = nval_old
    allocate(wfv(kg1,nval,kv3,kimg))
    allocate(occup_val(nval,kv3))
    if(modnrm == EXECUT) then
       allocate(fsr_exx(nval,nlmta,kv3))
       allocate(fsi_exx(nval,nlmta,kv3))
    end if
    wfv = wfv_old
    occup_val = occup_val_old
    if(modnrm == EXECUT) then
       fsr_exx = fsr_exx_old
       fsi_exx = fsi_exx_old
    end if
    deallocate(wfv_old)
    deallocate(occup_val_old)
    if(modnrm == EXECUT) then
       deallocate(fsr_exx_old)
       deallocate(fsi_exx_old)
    end if
  end subroutine m_ES_EXX_restore_wfv

  function q_on_k_centered_mesh(iq,ik) result(ltf)
    implicit none
    integer, intent(in) :: iq, ik

    logical :: ltf
    real(kind=DP) :: qv(3), kv(3) 
    integer :: dv(3)

    qv(1:3) = vkbz(iq,1:3)
    kv(1:3) = vkxyz_for_outerloop(ik,1:3,BUCS)
 
    dv(1:3) = nint( (qv(1:3) - kv(1:3)) * n_bz_mesh(1:3) )

    ltf = .false.
    if(mod(dv(1),reduction_factor_exx(1)) == 0 .and. &
     & mod(dv(2),reduction_factor_exx(2)) == 0 .and. &
     & mod(dv(3),reduction_factor_exx(3)) == 0 ) then
       ltf = .true.
    end if
  end function q_on_k_centered_mesh

!! For debug
  function check_ibz_k(ik) result(ltf)
    implicit none
    integer, intent(in) :: ik

    logical :: ltf
    real(kind=DP) :: vkx, vky, vkz

    open(1000,file="ibz.data")
    read(1000,*) vkx, vky, vkz
    close(1000)

    ltf = .true.
    if(abs(vkxyz(ik,1,BUCS) - vkx) < DELTA07 .and. & 
     & abs(vkxyz(ik,2,BUCS) - vky) < DELTA07 .and. & 
     & abs(vkxyz(ik,3,BUCS) - vkz) < DELTA07 ) then
       ltf = .false.
       write(nfout,'("IBZ k: ",3f20.5)') vkxyz(ik,1:3,BUCS)
    end if
  end function check_ibz_k

  function check_bz_k(ik) result(ltf)
    implicit none
    integer, intent(in) :: ik

    logical :: ltf
    real(kind=DP) :: vkx, vky, vkz

    open(1100,file="bz.data")
    read(1100,*) vkx, vky, vkz
    close(1100)

    ltf = .true.
    if(abs(vkbz(ik,1) - vkx) < DELTA07 .and. &
     & abs(vkbz(ik,2) - vky) < DELTA07 .and. &
     & abs(vkbz(ik,3) - vkz) < DELTA07 ) then
       write(nfout,'(" BZ k: ",3f20.5)') vkbz(ik,1:3)
       ltf = .false.
    end if
  end function check_bz_k

!! For ultrasoft pseudopotentials 
#ifndef MEMORY_SAVE_EXX
  subroutine m_ES_EXX_ylm()
    implicit none

    integer :: i,n,ik,ig
    integer :: iend_kngp0
    real(kind=DP), allocatable, dimension(:) :: ylm_t ! d(kngp,n)
    real(kind=DP), allocatable, dimension(:,:) :: gqmk ! d(ista_kngp:iend_kngp,3)
    real(kind=DP), allocatable, dimension(:) :: gqmkr ! d(ista_kngp:iend_kngp)

    real(kind=DP) :: kg(3), ttr(6), g2
    integer,save  :: id_sname = -1
    call tstatc0_begin('m_ES_EXX_ylm ',id_sname,level=1)

    call getttr(rltv,ttr)

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    n = n*n
    if(.not.allocated(ylm_exx)) allocate(ylm_exx(nmax_G_hyb,n,nqmk))

! === ASMS ==== 
    iend_kngp0 = iend_kngp
    if(iend_kngp0.gt.nmax_G_hyb) iend_kngp0 = nmax_G_hyb
! === ASMS ==== 

    if( ista_kngp <= nmax_G_hyb ) then
       allocate(gqmk(ista_kngp:iend_kngp0,3))
       allocate(gqmkr(ista_kngp:iend_kngp0))
    endif
    do ik=1,nqmk
       do ig=ista_kngp,iend_kngp0
          kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
          g2          = ttr(1)*kg(1)*kg(1) &
          &           + ttr(2)*kg(2)*kg(2) &
          &           + ttr(3)*kg(3)*kg(3) &
          &           + ttr(4)*kg(1)*kg(2) &
          &           + ttr(5)*kg(2)*kg(3) &
          &           + ttr(6)*kg(3)*kg(1)
          gqmk(ig,1:3) = kg(1:3)
          gqmkr(ig) = sqrt(g2)
       end do
       if(npes > 1) then
          allocate(ylm_t(nmax_G_hyb))
          do i=1,n
             ylm_t = 0.d0
             if ( ista_kngp <= nmax_G_hyb ) then
                call m_pwBS_sphrp_exx( i, rltv, ista_kngp, iend_kngp0, &
                     &                 gqmk, gqmkr, ylm_t(ista_kngp:iend_kngp0) )
             endif
             call mpi_allreduce( ylm_t, ylm_exx(1,i,ik), nmax_G_hyb, &
                  &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
          end do
          deallocate(ylm_t)
       else
          do i=1,n
             call m_pwBS_sphrp_exx(i,rltv,1,nmax_G_hyb,gqmk,gqmkr,ylm_exx(1,i,ik))
          end do
       end if

    end do
    !!stop 'm_ES_EXX_ylm'
    if ( allocated(gqmk) )  deallocate(gqmk)
    if ( allocated(gqmkr) ) deallocate(gqmkr)

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_ylm
#else
  subroutine m_ES_EXX_ylm_each_k(ik)
     implicit none
     integer, intent(in) :: ik
     real(kind=DP), allocatable, dimension(:,:) :: gqmk ! d(kgp,3)
     real(kind=DP), allocatable, dimension(:) :: gqmkr ! d(kgp)
     integer :: i, n, ig

     real(kind=DP) :: kg(3), ttr(6), g2
     integer,save  :: id_sname = -1
     call tstatc0_begin('m_ES_EXX_ylm ', id_sname, level=1)

     call getttr(rltv,ttr)

     call m_PP_find_maximum_l(n) ! n-1: maximum l
     n = (n-1) + (n-1) + 1
     n = n*n
     if(.not. allocated(ylm_exx)) allocate(ylm_exx(nmax_G_hyb,n))

     allocate(gqmk(kgp,3))
     allocate(gqmkr(kgp))
     do ig = 1, kgp
          kg(1:3) = qmk(ik,1:3) + ngabc(ig,1:3)
          g2          = ttr(1)*kg(1)*kg(1) &
          &           + ttr(2)*kg(2)*kg(2) &
          &           + ttr(3)*kg(3)*kg(3) &
          &           + ttr(4)*kg(1)*kg(2) &
          &           + ttr(5)*kg(2)*kg(3) &
          &           + ttr(6)*kg(3)*kg(1)
          gqmk(ig,1:3) = kg(1:3)
          gqmkr(ig) = sqrt(g2)
     end do
     do i = 1, n
        call m_pwBS_sphrp_exx(i,rltv,1,nmax_G_hyb,gqmk,gqmkr,ylm_exx(1,i))
     end do
     deallocate(gqmk)
     deallocate(gqmkr)

     call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_ylm_each_k
#endif

#ifndef MEMORY_SAVE_MORE_EXX
  subroutine check_qitg()
    implicit none
    integer :: iq, ips , ipe

    ips = 1
    ipe = nmax_G_hyb

    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"qitg_l=",f20.5,1x,"qitg_exx=",f20.5,1x)') iq, qitg_l(ips,iq), qitg_exx(ips,iq,1)/univol
    end do

    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"diff=",f20.5)') iq, sum(qitg_l(ips:ipe,iq)-qitg_exx(ips:ipe,iq,1)/univol)
    end do

    stop 'check_qitg'
  end subroutine check_qitg

  subroutine check_qitg_qmk()
    implicit none
    integer :: iq, ik, ips, ipe

    ips = 1
    ipe = nmax_G_hyb

    do ik=1,nqmk
    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"qitg_exx=",f20.5,1x)') iq, qitg_exx(ips,iq,ik)/univol
    end do
    end do

    do ik=1,nqmk
    do iq=1,nqitg
       write(nfout,'("iq=",i5,1x,"sum=",f20.5)') iq, sum(qitg_exx(ips:ipe,iq,ik)/univol)
    end do
    end do

    stop 'check_qitg_qmk'
  end subroutine check_qitg_qmk
#endif

#ifndef MEMORY_SAVE_EXX
  subroutine check_ylm_exx()
    implicit none
    integer :: i, n, ik, ips, ipe

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    n = n*n

    ips = 1
    ipe = nmax_G_hyb

    do ik=1,nqmk
    do i=1,n
       write(nfout,'("i=",i5,1x,"ylm_exx=",f20.5,1x)') i, ylm_exx(ips,i,ik)
    end do
    end do

    do ik=1,nqmk
    do i=1,n
       write(nfout,'("i=",i5,1x,"sum=",f20.5)')  i, sum(qitg_exx(ips:ipe,i,ik))
    end do
    end do

    stop 'check_ylm_exx'
  end subroutine check_ylm_exx
#endif

  subroutine hard_part_preproc()
    integer :: it,ncache
    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2))
    call substitute_il3(n**2,il3) ! -(b_Elec..)

    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
! =================================== Added by K. Tagami =======
    nqitg_sp = 0; nqitg_sp0 = 0; iq2l3 = 0
! ==============================================================
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
    & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc,.true.)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
! ==================================== Added by K. Tagami ======
    nc2lmt1 = 0;  nc2lmt2 = 0; nc2n = 0
! =============================================================
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
    & ,nc2lmt1,nc2lmt2,nc2n,nc,.true.) ! -> nc2lmt1, nc2lmt2, nc2n, nc

    ncache = (m_CtrlP_cachesize()*1024)*3/4
    if(ncache == 0) then
       ibsize =  nmax_G_hyb
    else
       iwidth = 0
       do it = 1, ntyp
          iwidth = max(iwidth,nqitg_sp(it)-nqitg_sp0(it)+1)
       end do
       ibsize=ncache/(8*(iwidth + 2))
    end if
    if(ibsize.gt.nmax_G_hyb) ibsize = nmax_G_hyb
#ifdef HYB_DISABLE_BLOCKING
    ibsize = nmax_G_hyb
#endif
    preproc_done = .true.
  end subroutine hard_part_preproc


  subroutine add_RHOG_hard_part(iqmk,rhogr,rhogi,fnr,fni,fmr,fmi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(inout) :: rhogr(nmax_G_hyb)
    real(kind=DP), intent(inout) :: rhogi(nmax_G_hyb)
    real(kind=DP), intent(in) :: fnr(nlmta)
    real(kind=DP), intent(in) :: fni(nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)

    integer :: it,ia,i,lmt1,lmt2,np,il1,il2,tau1,tau2,ilmta1,ilmta2
    integer :: l3,ilm3,iil
    real(kind=DP) :: ph, hr, hi, fac, f0
    real(kind=DP), allocatable :: cosgt(:), singt(:)

    real(kind=DP), allocatable, dimension(:) :: ylm_sum,ylm_sum2

    real(kind=DP), allocatable :: qitg_red(:,:),ylm_red(:,:)
    real(kind=DP), allocatable :: rhogr_red(:),rhogi_red(:)
    real(kind=DP) :: yr,yi
    integer :: ibl1,ibl2,iq,inn,ip,m, ips, ipe

    integer,save  :: id_sname = -1

    call tstatc0_begin('add_RHOG_hard_part ',id_sname)

    if(.not.preproc_done) call hard_part_preproc()

    allocate(cosgt(ibsize))
    allocate(singt(ibsize))
    allocate(ylm_sum(ibsize));ylm_sum=0.d0
    allocate(ylm_sum2(ibsize));ylm_sum2=0.d0

    allocate(qitg_red(ibsize,nqitg))
    allocate(ylm_red(ibsize,n*n))
    allocate(rhogr_red(ibsize))
    allocate(rhogi_red(ibsize))
! --
    ips = 1
    ipe = nmax_G_hyb

    do ibl1=ips, ipe, ibsize
       rhogr_red=0.d0;  rhogi_red=0.d0

       ibl2=min(ipe,ibl1+ibsize-1)
       do iq=1,nqitg
          do i=1,ibl2-ibl1+1
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq)
#else
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq,iqmk)
#endif
          enddo
       enddo
       do inn=1,n*n
          do i=1,ibl2-ibl1+1
#ifndef MEMORY_SAVE_EXX
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn,iqmk)
#else
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn)
#endif
          enddo
       enddo

       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,ibl2-ibl1+1
             ph = PAI2 * dot_product(pos(ia,1:3),ngabc(i+ibl1-1,1:3)+qmk(iqmk,1:3))
             cosgt(i) = cos(ph);  singt(i) = sin(ph)
          end do
          do iq = nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             iil = mod(l3,4)
             ylm_sum  = 0.d0;  ylm_sum2 = 0.d0

             do m = 1, 2*l3+1
                ilm3 = l3*l3+m
                yr=0.d0;  yi=0.d0

                do ip=1,nc(m,iq)
                   lmt1 = nc2lmt1(ip,m,iq);  lmt2 = nc2lmt2(ip,m,iq)
                   ilmta1 = lmta(lmt1,ia);   ilmta2 = lmta(lmt2,ia)
                   np = nc2n(ip,m,iq)
                   hr = fnr(ilmta1)*fmr(ilmta2) + fni(ilmta1)*fmi(ilmta2)
                   hi = fnr(ilmta1)*fmi(ilmta2) - fni(ilmta1)*fmr(ilmta2)
                   f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                   yr = yr + f0*hr;  yi = yi + f0*hi
                   !do i=1,ibl2-ibl1+1
                   !   ylm_sum(i)  = ylm_sum(i)  + f0*ylm_red(i,ilm3)*hr
                   !   ylm_sum2(i) = ylm_sum2(i) + f0*ylm_red(i,ilm3)*hi
                   !enddo
                enddo
                do i=1,ibl2-ibl1+1
                   ylm_sum(i)  = ylm_sum(i)  + yr*ylm_red(i,ilm3)
                   ylm_sum2(i) = ylm_sum2(i) + yi*ylm_red(i,ilm3)
                enddo
             enddo

             if(iil==0) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) + fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                   rhogi_red(i) = rhogi_red(i) + fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                end do
             else if(iil==1) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) + fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                   rhogi_red(i) = rhogi_red(i) - fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                end do
             else if(iil==2) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) - fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                   rhogi_red(i) = rhogi_red(i) - fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                end do
             else if(iil==3) then
                do i=1,ibl2-ibl1+1
                   fac =  qitg_red(i,iq)
                   rhogr_red(i) = rhogr_red(i) - fac * (cosgt(i)*ylm_sum2(i)-singt(i)*ylm_sum(i))
                   rhogi_red(i) = rhogi_red(i) + fac * (cosgt(i)*ylm_sum(i) +singt(i)*ylm_sum2(i))
                end do
             end if
          enddo
       enddo

       do i=ibl1,ibl2
          rhogr(i) = rhogr(i) + rhogr_red(i-ibl1+1)
          rhogi(i) = rhogi(i) + rhogi_red(i-ibl1+1)
       enddo
       
    enddo
    
    deallocate(cosgt); deallocate(singt)
    deallocate(ylm_sum); deallocate(ylm_sum2)
    deallocate(qitg_red); deallocate(ylm_red)
    deallocate(rhogr_red); deallocate(rhogi_red)

    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part

  subroutine add_RHOG_hard_part_rs(iqmk,rhor,rhoi,fnr,fni,fmr,fmi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(out) :: rhor(nfftp_exx_nonpara/2)
    real(kind=DP), intent(out) :: rhoi(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fnr(nlmta)
    real(kind=DP), intent(in) :: fni(nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    integer :: n,it,ia,imesh,lmt1,lmt2,il1,il2,tau1,tau2,ilmta1,ilmta2,lmtp
    integer :: nma
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP) :: rr,ii,si,co,qm,rr0,ii0
    integer :: ind
    real(kind=DP), allocatable, dimension(:) :: rtmp,itmp
    real(kind=DP) :: fac
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_RHOG_hard_part_rs ',id_sname)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rtmp(nmesh_rs_aug_max));rtmp=0.d0
    allocate(itmp(nmesh_rs_aug_max));itmp=0.d0
    rhor(:) = 0.d0;rhoi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       rtmp=0.d0;itmp=0.d0
       do lmtp = 1,nlmtpair(ia)
          lmt1 = plmt1(lmtp,ia)
          lmt2 = plmt2(lmtp,ia)
          ilmta1 = lmta(lmt1,ia)
          ilmta2 = lmta(lmt2,ia)
          rr = fnr(ilmta1)*fmr(ilmta2) + fni(ilmta1)*fmi(ilmta2)
          ii = fnr(ilmta1)*fmi(ilmta2) - fni(ilmta1)*fmr(ilmta2)
          if(lmt1.ne.lmt2)then
            rr = rr+fnr(ilmta2)*fmr(ilmta1) + fni(ilmta2)*fmi(ilmta1)
            ii = ii+fnr(ilmta2)*fmi(ilmta1) - fni(ilmta2)*fmr(ilmta1)
          endif
          do imesh=1,nma
             co = cosqmkr(imesh)
             si = sinqmkr(imesh)
             qm = qr_clm_ylm(imesh,ia,lmtp)
             rtmp(imesh) = rtmp(imesh) + qm*(rr*co+ii*si)
             itmp(imesh) = itmp(imesh) + qm*(ii*co-rr*si)
          enddo
       enddo
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          rhor(ind) = rhor(ind) + rtmp(imesh)
          rhoi(ind) = rhoi(ind) + itmp(imesh)
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rtmp)
    deallocate(itmp)
    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part_rs

  subroutine add_RHOG_hard_part_rs2(iqmk,rhor,rhoi,qmfnr,qmfni,fmr,fmi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(out) :: rhor(nfftp_exx_nonpara/2)
    real(kind=DP), intent(out) :: rhoi(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: qmfnr(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: qmfni(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP), allocatable, dimension(:) :: rtmp,itmp
    real(kind=DP) :: fr,fi,co,si,qmr,qmi,rr,ii
    integer :: ia,it,lmt1,ilmta1,ind,imesh,nma
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_RHOG_hard_part_rs2 ',id_sname)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rtmp(nmesh_rs_aug_max));rtmp=0.d0
    allocate(itmp(nmesh_rs_aug_max));itmp=0.d0
    rhor(:) = 0.d0;rhoi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       rtmp=0.d0;itmp=0.d0
       do lmt1=1,ilmt(it)
          ilmta1 = lmta(lmt1,ia)
          fr =  fmr(ilmta1)
          fi = -fmi(ilmta1) ! c.c. of fsr
          do imesh=1,nma
             co =  cosqmkr(imesh)
             si = -sinqmkr(imesh) ! c.c. of exp(i(G+q-k))
             qmr = qmfnr(imesh,ilmta1)
             qmi = qmfni(imesh,ilmta1)
             rr = co*qmr-si*qmi
             ii = co*qmi+si*qmr
             rtmp(imesh) = rtmp(imesh) + rr*fr-ii*fi
             itmp(imesh) = itmp(imesh) + ii*fr+rr*fi
          enddo
       enddo
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          rhor(ind) = rhor(ind) + rtmp(imesh)
          rhoi(ind) = rhoi(ind) + itmp(imesh)
       enddo
    enddo
    deallocate(cosqmkr) 
    deallocate(sinqmkr) 
    deallocate(rtmp)
    deallocate(itmp)
    call tstatc0_end(id_sname)
  end subroutine add_RHOG_hard_part_rs2



  subroutine qmk_dot_r(iqmk,ia,zc_ar,zs_ar)
    integer, intent(in) :: iqmk,ia 
    real(kind=DP),dimension(nmesh_rs_aug_max),intent(out) :: zc_ar,zs_ar
    integer :: i
    real(kind=DP) :: inl,inm,inn
    real(kind=DP) :: rx,ry,rz,kdr
    integer :: id_sname = -1
    inl = 1.d0/dble(fft_box_size_CD_exx(1,1))
    inm = 1.d0/dble(fft_box_size_CD_exx(2,1))
    inn = 1.d0/dble(fft_box_size_CD_exx(3,1))
    do i=1,nmesh_rs_aug(ia)
       rx = dble(meshx_rs_aug(i,ia))*inl
       ry = dble(meshy_rs_aug(i,ia))*inm
       rz = dble(meshz_rs_aug(i,ia))*inn
       kdr = (rx*qmk(iqmk,1)+ry*qmk(iqmk,2)+rz*qmk(iqmk,3))*PAI2
       zc_ar(i) = dcos(kdr)
       zs_ar(i) = dsin(kdr)
    enddo
  end subroutine qmk_dot_r


! ================================== KT_Test ========================= 12.5Exp
  subroutine integrate_QijVnm(iqmk,potr,poti,fmr,fmi,qvr,qvi,dfmr,dfmi,dqvr,dqvi,gqvr,gqvi)
    implicit none
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nmax_G_hyb)
    real(kind=DP), intent(in) :: poti(nmax_G_hyb)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), optional, intent(in) :: dfmr(nlmta,3)
    real(kind=DP), optional, intent(in) :: dfmi(nlmta,3)
    real(kind=DP), optional, intent(out) :: dqvr(nlmta,3)
    real(kind=DP), optional, intent(out) :: dqvi(nlmta,3)
    real(kind=DP), optional, intent(out) :: gqvr(nlmta,3)
    real(kind=DP), optional, intent(out) :: gqvi(nlmta,3)

    integer :: it,ia,i,lmt1,lmt2,np,il1,il2,tau1,tau2,ilmta1,ilmta2
    integer :: l3,ilm3,iiqitg,iil
    real(kind=DP) :: ph, hr, hi, fac, f0
    real(kind=DP) :: cosgt, singt
    real(kind=DP) :: dr, di
    real(kind=DP), allocatable :: zsr(:), zsi(:)

    real(kind=DP), allocatable :: qitg_red(:,:),ylm_red(:,:)
    integer :: ibl1,ibl2,iq,inn,ip,m, ips, ipe
    logical :: force_mode = .false. 
    real(kind=DP), allocatable :: gvec(:,:)
    real(kind=DP) :: er(3), ei(3), vec1(3)
    integer,save  :: id_sname = -1

    call tstatc0_begin('integrate_QijVnm ',id_sname)
    force_mode = present(dfmr).and.present(dfmi).and.present(dqvr).and.present(dqvi).and. &
               & present(gqvr).and.present(gqvi)
    if(.not.preproc_done) call hard_part_preproc()

    qvr(1:nlmta) = 0.d0;  qvi(1:nlmta) = 0.d0
    if(force_mode)then
       dqvr(1:nlmta,1:3) = 0.d0
       dqvi(1:nlmta,1:3) = 0.d0
       gqvr(1:nlmta,1:3) = 0.d0
       gqvi(1:nlmta,1:3) = 0.d0
    endif
    allocate(zsr(ibsize)); allocate(zsi(ibsize))
    allocate(qitg_red(ibsize,nqitg))
    allocate(ylm_red(ibsize,n*n))
    if(force_mode) allocate(gvec(ibsize,3))

    ips = 1
    ipe = nmax_G_hyb

    do ibl1=ips, ipe, ibsize
       ibl2=min(ipe,ibl1+ibsize-1)
       do iq=1,nqitg
          do i=1,ibl2-ibl1+1
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq)
#else
             qitg_red(i,iq) = qitg_exx(i+ibl1-1,iq,iqmk)
#endif
          enddo
       enddo
       do inn=1,n*n
          do i=1,ibl2-ibl1+1
#ifndef MEMORY_SAVE_EXX
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn,iqmk)
#else
             ylm_red(i,inn) = ylm_exx(i+ibl1-1,inn)
#endif
          enddo
       enddo
       
       if(force_mode)then
          do i=1,ibl2-ibl1+1
             gvec(i,1:3) = ngabc(i+ibl1-1,1:3) + qmk(iqmk,1:3)
          end do
#ifdef DERIVATIVE_IN_CARTS
          do i=1,ibl2-ibl1+1
             vec1(1) = rltv(1,1)*gvec(i,1) +rltv(1,2)*gvec(i,2) +rltv(1,3)*gvec(i,3)
             vec1(2) = rltv(2,1)*gvec(i,1) +rltv(2,2)*gvec(i,2) +rltv(2,3)*gvec(i,3)
             vec1(3) = rltv(3,1)*gvec(i,1) +rltv(3,2)*gvec(i,2) +rltv(3,3)*gvec(i,3)
             gvec(i,1:3) = vec1(1:3)
          end do
#endif
       endif
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,ibl2-ibl1+1
             ph = PAI2 * dot_product(pos(ia,1:3),ngabc(i+ibl1-1,1:3)+qmk(iqmk,1:3)) 
             cosgt = cos(ph); singt = sin(ph)
! ==== ASMS ==== 
             zsr(i) = cosgt * potr(i+ibl1-1) - singt * poti(i+ibl1-1)
             zsi(i) =-cosgt * poti(i+ibl1-1) - singt * potr(i+ibl1-1)
! ==== ASMS ==== 
          end do

          do iq=nqitg_sp0(it), nqitg_sp(it)
             l3 = iq2l3(iq)
             iil = mod(l3,4)         ! (-i)^L
             
             do m = 1, 2*l3+1
                ilm3 = l3*l3+m
                
                dr = 0.d0; di = 0.d0
                if(force_mode)then
                   er(1:3) = 0.d0;ei(1:3)=0.d0
                endif
                if(iil==0) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr + fac * zsr(i)
                      di = di + fac * zsi(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er + (fac * zsr(i))*gvec(i,1:3)
                         ei = ei + (fac * zsi(i))*gvec(i,1:3)
                      end do
                   endif
                else if(iil==1) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
! ==== ASMS ==== 
                      dr = dr + fac * zsi(i)
                      di = di - fac * zsr(i)
! ==== ASMS ==== 
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
! ==== ASMS ====
                         er = er + (fac * zsi(i))*gvec(i,1:3)
                         ei = ei - (fac * zsr(i))*gvec(i,1:3)
! ==== ASMS ====
                      end do
                   endif
                else if(iil==2) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                      dr = dr - fac * zsr(i)
                      di = di - fac * zsi(i)
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
                         er = er - (fac * zsr(i))*gvec(i,1:3)
                         ei = ei - (fac * zsi(i))*gvec(i,1:3)
                      end do
                   endif
                else if(iil==3) then
                   do i=1,ibl2-ibl1+1
                      fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
! ==== ASMS ====
                      dr = dr - fac * zsi(i)
                      di = di + fac * zsr(i)
! ==== ASMS ====
                   end do
                   if(force_mode)then
                      do i=1,ibl2-ibl1+1
                         fac =  qitg_red(i,iq) * ylm_red(i,ilm3)
! ==== ASMS ====
                         er = er - (fac * zsi(i))*gvec(i,1:3)
                         ei = ei + (fac * zsr(i))*gvec(i,1:3)
! ==== ASMS ====
                      end do
                   endif
                end if

! ==== ASMS ==== 2017/09/22
!                di = -di
!                if(force_mode) ei=-ei
! ==== ASMS ==== 2017/09/22

                do ip=1,nc(m,iq)
                   lmt1 = nc2lmt1(ip,m,iq); lmt2 = nc2lmt2(ip,m,iq)
                   ilmta1 = lmta(lmt1,ia);  ilmta2 = lmta(lmt2,ia)
                   np = nc2n(ip,m,iq)
                   f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                   qvr(ilmta1) = qvr(ilmta1) + f0 * (dr * fmr(ilmta2) - di * fmi(ilmta2))
                   qvi(ilmta1) = qvi(ilmta1) + f0 * (di * fmr(ilmta2) + dr * fmi(ilmta2))
                end do
                if(force_mode)then
                   do ip=1,nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq); lmt2 = nc2lmt2(ip,m,iq)
                      ilmta1 = lmta(lmt1,ia);  ilmta2 = lmta(lmt2,ia)
                      np = nc2n(ip,m,iq)
                      f0 = iwei(ia) * dl2p(lmt1,lmt2,np,it)
                      dqvr(ilmta1,1:3) = dqvr(ilmta1,1:3) + f0 * (dr * dfmr(ilmta2,1:3) - di * dfmi(ilmta2,1:3))
                      dqvi(ilmta1,1:3) = dqvi(ilmta1,1:3) + f0 * (di * dfmr(ilmta2,1:3) + dr * dfmi(ilmta2,1:3))
                      gqvr(ilmta1,1:3) = gqvr(ilmta1,1:3) + f0 * (ei(1:3) * fmr(ilmta2) + er(1:3) * fmi(ilmta2))
                      gqvi(ilmta1,1:3) = gqvi(ilmta1,1:3) + f0 * (-er(1:3) * fmr(ilmta2) + ei(1:3) * fmi(ilmta2))
                   enddo
                endif
             end do
          end do
       end do
       
    enddo
    
    deallocate(zsr);  deallocate(zsi)
    deallocate(qitg_red); deallocate(ylm_red)
    if(force_mode) deallocate(gvec)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm
! ========================================================================= 125.Exp

  subroutine integrate_QijVnm_rs2(iqmk,potr,poti,fmrq,fmiq,qvr,qvi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: poti(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fmrq(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(in) :: fmiq(nmesh_rs_aug_max,nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP), allocatable, dimension(:) :: rra,iia
    integer :: ia,it,lmt1,ilmta1
    integer :: imesh,nma,ind
    real(kind=DP) :: co,si
    real(kind=DP) :: qr,qi,qmr,qmi,rr,ii
    integer :: id_sname=-1
    call tstatc0_begin('integrate_QijVnm_rs2 ',id_sname)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rra(nmesh_rs_aug_max));rra=0.d0
    allocate(iia(nmesh_rs_aug_max));iia=0.d0
    qvr(:) = 0.d0
    qvi(:) = 0.d0
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          co  =  cosqmkr(imesh)
          si  = -sinqmkr(imesh)
          rra(imesh) =  potr(ind)*co+poti(ind)*si
          iia(imesh) = -poti(ind)*co+potr(ind)*si
       enddo
       do lmt1=1,ilmt(it)
          ilmta1 = lmta(lmt1,ia)
          qr=0.d0;qi=0.d0
          do imesh=1,nma
             qmr = fmrq(imesh,ilmta1)
             qmi = fmiq(imesh,ilmta1)
             rr = rra(imesh)
             ii = iia(imesh)
             qr = qr+qmr*rr-qmi*ii
             qi = qi+qmr*ii+qmi*rr
          enddo
          qvr(ilmta1) = qr
          qvi(ilmta1) = qi
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rra,iia)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm_rs2

  subroutine integrate_QijVnm_rs(iqmk,potr,poti,fmr,fmi,qvr,qvi,dfmr,dfmi,dqvr,dqvi,gqvr,gqvi)
    integer, intent(in) :: iqmk
    real(kind=DP), intent(in) :: potr(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: poti(nfftp_exx_nonpara/2)
    real(kind=DP), intent(in) :: fmr(nlmta)
    real(kind=DP), intent(in) :: fmi(nlmta)
    real(kind=DP), intent(out) :: qvr(nlmta)
    real(kind=DP), intent(out) :: qvi(nlmta)
    real(kind=DP), intent(in),optional  :: dfmr(nlmta,3)
    real(kind=DP), intent(in),optional  :: dfmi(nlmta,3)
    real(kind=DP), intent(out),optional :: dqvr(nlmta,3)
    real(kind=DP), intent(out),optional :: dqvi(nlmta,3)
    real(kind=DP), intent(out),optional :: gqvr(nlmta,3)
    real(kind=DP), intent(out),optional :: gqvi(nlmta,3)
    integer :: n,it,ia,imesh,lmt1,lmt2,il1,il2,tau1,tau2,ilmta1,ilmta2,lmtp
    real(kind=DP), dimension(:), allocatable :: cosqmkr,sinqmkr
    real(kind=DP) :: co,si,rr,ii,rrr,iii,qr,qi,qqr,qqi,qm,rr0,ii0
    real(kind=DP), allocatable, dimension(:) :: rra,iia
    integer :: nma,ind
    real(kind=DP) :: er(3), ei(3),dqm(3),dqqr(3),dqqi(3),der(3),dei(3),drr(3),dii(3),drr0(3),dii0(3)
    real(kind=DP) :: dqqr0(3),dqqi0(3),der0(3),dei0(3)
    logical :: force_mode = .false.
    integer :: id_sname=-1
    call tstatc0_begin('integrate_QijVnm_rs ',id_sname)
    force_mode = present(dfmr).and.present(dfmi).and. &
               & present(dqvr).and.present(dqvi).and. &
               & present(gqvr).and.present(gqvi)
    allocate(cosqmkr(nmesh_rs_aug_max));cosqmkr=0.d0
    allocate(sinqmkr(nmesh_rs_aug_max));sinqmkr=0.d0
    allocate(rra(nmesh_rs_aug_max));rra=0.d0
    allocate(iia(nmesh_rs_aug_max));iia=0.d0
    qvr(:) = 0.d0
    qvi(:) = 0.d0
    if(force_mode)then
       dqvr(1:nlmta,1:3) = 0.d0
       dqvi(1:nlmta,1:3) = 0.d0
       gqvr(1:nlmta,1:3) = 0.d0
       gqvi(1:nlmta,1:3) = 0.d0
    endif
    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       call qmk_dot_r(iqmk,ia,cosqmkr,sinqmkr)
       nma = nmesh_rs_aug(ia)
       do imesh=1,nma
          ind = meshxyz_rs_aug(imesh,ia)
          co  =  cosqmkr(imesh)
          si  = -sinqmkr(imesh)
          rra(imesh) =  potr(ind)*co+poti(ind)*si
          iia(imesh) = -poti(ind)*co+potr(ind)*si
       enddo
       do lmtp=1,nlmtpair(ia)
          lmt1 = plmt1(lmtp,ia)
          lmt2 = plmt2(lmtp,ia)
          ilmta1 = lmta(lmt1,ia)
          ilmta2 = lmta(lmt2,ia)
          rr0 =  fmr(ilmta1)
          ii0 =  fmi(ilmta1)
          qqr=0.d0;qqi=0.d0
          qr=0.d0;qi=0.d0
          rr =  fmr(ilmta2)
          ii =  fmi(ilmta2)
          if(force_mode)then
            dqqr=0.d0;dqqi=0.d0
            dqqr0=0.d0;dqqi0=0.d0
            der=0.d0;dei=0.d0
            der0=0.d0;dei0=0.d0
            drr(1:3) =  dfmr(ilmta2,1:3)
            dii(1:3) =  dfmi(ilmta2,1:3)
            er=0.d0;ei=0.d0
          endif
          do imesh=1,nma
             qm = qr_clm_ylm(imesh,ia,lmtp)
             qr = qr+qm*rra(imesh)
             qi = qi+qm*iia(imesh)
          enddo
          if(force_mode)then
             do imesh=1,nma
                dqm(1:3) = dqr_clm_ylm(imesh,ia,lmtp,1:3)
                er(1:3) = er(1:3)+dqm(1:3)*rra(imesh)
                ei(1:3) = ei(1:3)+dqm(1:3)*iia(imesh)
             enddo
          endif
          qqr = qr*rr-qi*ii
          qqi = qr*ii+qi*rr
          qvr(ilmta1) = qvr(ilmta1)+qqr
          qvi(ilmta1) = qvi(ilmta1)+qqi
          if(force_mode)then
             dqqr(1:3)  = qr*drr(1:3)-qi*dii(1:3)
             dqqi(1:3)  = qr*dii(1:3)+qi*drr(1:3)
             der(1:3)   = er(1:3)*rr-ei(1:3)*ii
             dei(1:3)   = er(1:3)*ii+ei(1:3)*rr
             dqvr(ilmta1,1:3) = dqvr(ilmta1,1:3)+dqqr(1:3)
             dqvi(ilmta1,1:3) = dqvi(ilmta1,1:3)+dqqi(1:3)
#ifdef USE_DERIVATIVE_QRSPS_RSPACE
             gqvr(ilmta1,1:3) = gqvr(ilmta1,1:3)+der(1:3)
             gqvi(ilmta1,1:3) = gqvi(ilmta1,1:3)+dei(1:3)
#endif
          endif
          if(lmt1.ne.lmt2)then
             qvr(ilmta2) = qvr(ilmta2)+(qr*rr0-qi*ii0)
             qvi(ilmta2) = qvi(ilmta2)+(qr*ii0+qi*rr0)
          endif
          if(force_mode.and.lmt1.ne.lmt2)then
             drr0(1:3) =  dfmr(ilmta1,1:3)
             dii0(1:3) =  dfmi(ilmta1,1:3)
             dqqr0(1:3) = qr*drr0(1:3)-qi*dii0(1:3)
             dqqi0(1:3) = qr*dii0(1:3)+qi*drr0(1:3)
             der0(1:3)   = er(1:3)*rr0-ei(1:3)*ii0
             dei0(1:3)   = er(1:3)*ii0+ei(1:3)*rr0
             dqvr(ilmta2,1:3) = dqvr(ilmta2,1:3)+dqqr0(1:3)
             dqvi(ilmta2,1:3) = dqvi(ilmta2,1:3)+dqqi0(1:3)
#ifdef USE_DERIVATIVE_QRSPS_RSPACE
             gqvr(ilmta2,1:3) = gqvr(ilmta2,1:3)+der0(1:3)
             gqvi(ilmta2,1:3) = gqvi(ilmta2,1:3)+dei0(1:3)
#endif
          endif
       enddo
    enddo
    deallocate(cosqmkr)
    deallocate(sinqmkr)
    deallocate(rra,iia)
    call tstatc0_end(id_sname)
  end subroutine integrate_QijVnm_rs


  subroutine add_Vx_hard_part(ik,vxw,sumqvr,sumqvi)
  !!subroutine add_Vx_hard_part(ik,vxw1,sumqvr,sumqvi)
    implicit none
    integer, intent(in) :: ik
    real(kind=DP), intent(inout) :: vxw(kg1,kimg)
    !!real(kind=DP), intent(inout) :: vxw1(kg1,kimg)
    real(kind=DP), intent(in) :: sumqvr(nlmta)
    real(kind=DP), intent(in) :: sumqvi(nlmta)

    integer :: it,ia,i,il1,ilmtt1,ilmta1,iil,iksnl,ikk
    integer :: lmt1,lmtt1
    real(kind=DP) :: fac, ph
    real(kind=DP), allocatable :: cosgt(:) ! d(kg1)
    real(kind=DP), allocatable :: singt(:) ! d(kg1)
    integer,save  :: id_sname = -1
    call tstatc0_begin('add_Vx_hard_part ',id_sname)

    allocate(cosgt(kg1))
    allocate(singt(kg1))
    ikk = k_index(ik)
    iksnl = (ik-1)/nspin + 1

    do ia=1,natm
       it = ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       do i=1,iba(ik)
          ph = PAI2 * dot_product(pos(ia,1:3),vkxyz_for_outerloop(ikk,1:3,BUCS)+ngabc(nbase(i,ik),1:3))
          cosgt(i) = cos(ph)
          singt(i) = sin(ph)
       end do
       do lmt1 = 1, ilmt(it)
          il1  = ltp(lmt1,it)
          lmtt1 = lmtt(lmt1,it)
          ilmta1 = lmta(lmt1,ia)
          iil=mod(il1-1,4)
          if(iil==0) then
             do i=1,iba(ik)
                fac = iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
             end do
          else if(iil==1) then
             do i=1,iba(ik)
                fac = iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) - fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
             end do
          else if(iil==2) then
             do i=1,iba(ik)
                fac = -iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
             end do
          else if(iil==3) then
             do i=1,iba(ik)
                fac = -iwei(ia)*snl(i,lmtt1,iksnl)
                vxw(i,1) = vxw(i,1) + fac * (cosgt(i)*sumqvi(ilmta1)-singt(i)*sumqvr(ilmta1))
                if(kimg==2) vxw(i,2) = vxw(i,2) - fac * (cosgt(i)*sumqvr(ilmta1)+singt(i)*sumqvi(ilmta1))
             end do
          end if
       end do
    end do

    deallocate(cosgt)
    deallocate(singt)

    call tstatc0_end(id_sname)
  end subroutine add_Vx_hard_part

  subroutine get_Rot_betar_dot_WFs(ik,ib,jop,kop,jtrs,fsr,fsi,dfsr,dfsi)
    implicit none
    integer, intent(in)                          :: ik,ib,jop,kop,jtrs
    real(kind=DP), intent(out), dimension(nlmta) :: fsr,fsi
    real(kind=DP), intent(out), optional, dimension(nlmta,3) :: dfsr,dfsi

    integer :: ilmta1,ilmta2,isph1,isph2,iy
    integer :: ia,i
    real(kind=DP) :: prim(3)
    real(kind=DP) :: coskt(natm), sinkt(natm)
    real(kind=DP) :: ph, tmpr, tmpi
    logical :: force_mode=.false.
    integer,save  :: id_sname = -1

! === ASMS === 2019/10/28
    integer :: ixyz1, ixyz2
    real(kind=DP) :: c1, cvec1(3), cvec2(3)
! === ASMS === 2019/10/28

    call tstatc0_begin('get_Rot_betar_dot_WFs ',id_sname)
    force_mode = present(dfsr).and.present(dfsi)
    if(jop==1) then
       fsr(1:nlmta) = fsr_exx(ib,1:nlmta,ik)
       fsi(1:nlmta) = fsi_exx(ib,1:nlmta,ik)
       if(force_mode)then
          dfsr(1:nlmta,1:3) = dfsr_exx(ib,1:nlmta,ik,1:3)
          dfsi(1:nlmta,1:3) = dfsi_exx(ib,1:nlmta,ik,1:3)
       endif
    else
       fsr = 0.d0
       fsi = 0.d0
       if(force_mode)then
          dfsr = 0.d0
          dfsi = 0.d0
       endif
       do ilmta1=1,nlmta       
          isph1=isph_lmta(ilmta1)
          do iy=1,nylm(isph1,jop)
             isph2 = iylm(iy,isph1,jop)
             ilmta2=lmta_rot(iy,ilmta1,jop)
             fsr(ilmta1) = fsr(ilmta1) +crotylm(iy,isph1,jop) *fsr_exx(ib,ilmta2,ik)
             fsi(ilmta1) = fsi(ilmta1) +crotylm(iy,isph1,jop) *fsi_exx(ib,ilmta2,ik)
             if(force_mode)then
                dfsr(ilmta1,1:3) = dfsr(ilmta1,1:3) &
                     &            +crotylm(iy,isph1,jop) *dfsr_exx(ib,ilmta2,ik,1:3)
                dfsi(ilmta1,1:3) = dfsi(ilmta1,1:3) &
                     &            +crotylm(iy,isph1,jop) *dfsi_exx(ib,ilmta2,ik,1:3)
             endif
          end do
       end do 
    end if

    if(jop>1) then
       do ia=1,natm
          prim(1:3) = matmul(opdir(:,:,kop),pos(ia,1:3)) + tau(1:3,kop,BUCS) - pos(napt(ia,kop),1:3)
          ph = PAI2 * dot_product(vkxyz_for_innerloop(ik,1:3,BUCS),prim) 
          coskt(ia) = cos(ph)
          sinkt(ia) = sin(ph)
       end do
       do ilmta1=1,nlmta
          ia = ia_lmta(ilmta1)
          tmpr = fsr(ilmta1)
          tmpi = fsi(ilmta1)
          fsr(ilmta1) = coskt(ia) * tmpr - sinkt(ia) * tmpi
          fsi(ilmta1) = coskt(ia) * tmpi + sinkt(ia) * tmpr 
          if(force_mode)then
             do i=1,3
                tmpr = dfsr(ilmta1,i)
                tmpi = dfsi(ilmta1,i)
                dfsr(ilmta1,i) = coskt(ia) * tmpr - sinkt(ia) * tmpi
                dfsi(ilmta1,i) = coskt(ia) * tmpi + sinkt(ia) * tmpr 
             end do
          endif
       end do
    end if

    if(jop>1 .and. force_mode )then
       do ilmta1=1,nlmta
          cvec1(:) = dfsr(ilmta1,:)
          cvec2(:) = dfsi(ilmta1,:)
          Do ixyz1=1, 3
             tmpr = 0.d0
             tmpi = 0.d0
             Do ixyz2=1, 3
#ifdef DERIVATIVE_IN_CARTS
                c1 = op(ixyz2,ixyz1,kop)
#else
                c1 = opdir(ixyz2,ixyz1,kop)
#endif
                tmpr = tmpr +c1 *cvec1(ixyz2)
                tmpi = tmpi +c1 *cvec2(ixyz2)
             End Do
             dfsr(ilmta1,ixyz1) = tmpr
             dfsi(ilmta1,ixyz1) = tmpi
          End Do
       End Do
    endif

    if(jtrs==1) fsi = -fsi
    if(force_mode.and.jtrs==1) dfsi = -dfsi
    call tstatc0_end(id_sname)
  end subroutine get_Rot_betar_dot_WFs

  subroutine get_expkt_fs_b(ik,ib,fsr_l,fsi_l,efsr_l,efsi_l)
    implicit none
    integer, intent(in) :: ik,ib
    real(kind=DP), intent(in), dimension(nlmta) :: fsr_l,fsi_l
    real(kind=DP), intent(out), dimension(nlmta) :: efsr_l,efsi_l

    integer :: it, ia, lmt, ilmta
    real(kind=DP) :: ph, coskt, sinkt
    efsr_l(1:nlmta) = 0.d0
    efsi_l(1:nlmta) = 0.d0
    if(k_symmetry(ik)==GAMMA)then
       efsr_l(:) = fsr_l(:)
    else
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          ph = PAI2 * dot_product(pos(ia,1:3),vkxyz(ik,1:3,BUCS))
          coskt = cos(ph)
          sinkt = sin(ph)
          do lmt = 1, ilmt(it)
             ilmta = lmta(lmt,ia)
             efsr_l(ilmta) = coskt * fsr_l(ilmta) - sinkt * fsi_l(ilmta)
             efsi_l(ilmta) = sinkt * fsr_l(ilmta) + coskt * fsi_l(ilmta)
          end do
       end do
    endif

  end subroutine get_expkt_fs_b

  subroutine get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
    implicit none
    integer, intent(in) :: ik
    real(kind=DP), intent(in), dimension(np_e,nlmta,ista_k:iend_k) :: fsr_l,fsi_l
    real(kind=DP), intent(out), dimension(np_e,nlmta) :: efsr_l,efsi_l

    integer :: it, ia, lmt, ilmta
    real(kind=DP) :: ph, coskt, sinkt
    integer :: ib
    efsr_l = 0.d0
    efsi_l = 0.d0
    do ib=1,np_e
       call get_expkt_fs_b(ik,ib,fsr_l(ib,1:nlmta,ik),fsi_l(ib,1:nlmta,ik),efsr_l(ib,1:nlmta),efsi_l(ib,1:nlmta))
    enddo

  end subroutine get_expkt_fs

  subroutine m_ES_EXX_Force(force)
    implicit none
    real(kind=DP), intent(out) :: force(natm,3)

    integer :: ik,ib,ig,ispin,ia,iadd
    real(kind=DP), allocatable :: force_l(:,:) ! d(natm,3)
    real(kind=DP), allocatable :: force_mpi(:,:) ! d(natm,3)
    real(kind=DP), allocatable :: efsr_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: efsi_l(:,:) ! d(np_e,nlmta)
    real(kind=DP), allocatable :: defsr_l(:,:,:) ! d(np_e,nlmta,3)
    real(kind=DP), allocatable :: defsi_l(:,:,:) ! d(np_e,nlmta,3)
    real(kind=DP), allocatable, dimension(:) :: zajbuf_r,zajbuf_i
    integer :: kgw,kgv
    integer,save  :: id_sname = -1

    real(kind=DP), allocatable :: force_kdep(:,:,:), force_kdep_mpi(:,:,:)

    if(modnrm /= EXECUT) then
       force = 0.d0
       return
    end if

    call tstatc0_begin('m_ES_EXX_Force ',id_sname,level=1)

    call m_FFT_alloc_WF_work()

    allocate(force_l(natm,3))
    allocate(efsr_l(np_e,nlmta));efsr_l=0.d0
    allocate(efsi_l(np_e,nlmta));efsi_l=0.d0

    !!write(nfout,'("m_ES_EXX_force")')

    allocate(dfsr_l(np_e,nlmta,ista_k:iend_k,3));dfsr_l=0.d0
    allocate(dfsi_l(np_e,nlmta,ista_k:iend_k,3));dfsi_l=0.d0
    call drv_betar_dot_WFs_exx() !-> dfsr_l, dfsi_l

    allocate(dfsr_exx(nval,nlmta,kv3,3));dfsr_exx=0.d0
    allocate(dfsi_exx(nval,nlmta,kv3,3));dfsi_exx=0.d0
    call gather_drv_bdw_exx() !-> dfsr_exx, dfsi_exx

    if ( ipriexx >= 2 ) then
       allocate( force_kdep(natm,3,kv3) ); force_kdep = 0.0d0
    endif

    force = 0.d0
    do ispin=1,nspin,af+1
       do ik=ispin, kv3+ispin-nspin, nspin
          if(map_k(ik) /= myrank_k) cycle ! MPI
          call get_expkt_fs(ik,fsr_l,fsi_l,efsr_l,efsi_l)
          do ib=1,np_e   ! MPI
             if(occup_l(ib,ik) < DELTA) cycle
             force_l = 0.d0
             allocate(zajbuf_r(kg1));zajbuf_r(:) = zaj_l(:,ib,ik,1)
             allocate(zajbuf_i(kg1));zajbuf_i(:) = zaj_l(:,ib,ik,kimg)
             kgw = kg1;kgv=kg1

               if(kimg==1) then
                  call apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,zajbuf_r,zajbuf_r &
                      & ,efsr_l(ib,1:nlmta),efsr_l(ib,1:nlmta) &
                      & ,dbdwr=dfsr_l(ib,1:nlmta,ik,1:3),dbdwi=dfsr_l(ib,1:nlmta,ik,1:3),force_l=force_l)
               else
                  call apply_Vx_to_WF(ispin,ib,ik,kgw,kgv,zajbuf_r,zajbuf_i &
                      & ,efsr_l(ib,1:nlmta),efsi_l(ib,1:nlmta) &
                      & ,dbdwr=dfsr_l(ib,1:nlmta,ik,1:3),dbdwi=dfsi_l(ib,1:nlmta,ik,1:3),force_l=force_l)
               end if
             force = force + occup_l(ib,ik) * force_l
             if ( ipriexx >= 2 ) then
                force_kdep(:,:,ik) = force_kdep(:,:,ik) +occup_l(ib,ik) * force_l
             endif

             deallocate(zajbuf_r)
             deallocate(zajbuf_i)
          end do
       end do
    end do

    force = -force / dble(kv3/nspin)
    if(nspin==1) force = 2.d0 * force
    
    deallocate(force_l)
    deallocate(efsr_l)
    deallocate(efsi_l)
    deallocate(dfsr_l)
    deallocate(dfsi_l)
    deallocate(dfsr_exx)
    deallocate(dfsi_exx)

    call m_FFT_dealloc_WF_work()

    if(npes>1) then
       allocate(force_mpi(natm,3))
       call mpi_allreduce(force,force_mpi,natm*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       force = force_mpi
       deallocate(force_mpi)
    end if

    !! Reduced coordinate -> Cartesian coordinate

! ==== ASMS ====
!    do ia=1,natm
!       force(ia,1:3) = matmul(transpose(rltv),force(ia,1:3))
!    end do
!
#ifndef DERIVATIVE_IN_CARTS
    do ia=1,natm
       call pucv2cart( rltv, force(ia,1), force(ia,2), force(ia,3) )
    End do
#endif
! ==== ASMS ====

    if ( ipriexx >= 2 ) then
       force_kdep = -force_kdep / dble(kv3/nspin)
       if(nspin==1) force_kdep = 2.d0 * force_kdep
       if(npes>1) then
          allocate(force_kdep_mpi(natm,3,kv3))
          call mpi_allreduce( force_kdep,force_kdep_mpi,natm*3*kv3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
          force_kdep = force_kdep_mpi
          deallocate(force_kdep_mpi)
       end if
#ifndef DERIVATIVE_IN_CARTS
       Do ik=1, kv3
          do ia=1,natm
             call pucv2cart( rltv, force_kdep(ia,1,ik), &
                  &          force_kdep(ia,2,ik), force_kdep(ia,3,ik) )
          End do
       End Do
#endif
       if ( mype == 0 ) then
          write(nfout,*)
#ifdef DERIVATIVE_IN_CARTS
          write(nfout,'(A)') "#DERIVATIVE_IN_CARTS is defined"
#endif
#ifdef USE_DERIVATIVE_QRSPS_RSPACE
          write(nfout,'(A)') "#USE_DERIVATIVE_QRSPS_RSPACE is defined"
#endif
          Do ik=1, kv3
             write(nfout,'(A,I5,3F20.10)') "# ik = ", ik, vkxyz(ik,1:3,BUCS)
             write(nfout,'(A)')            "# ia,   fx,      fy,      fz"
             Do ia=1, natm
                write(nfout,'(I5,3F20.10)') ia, force_kdep(ia,1:3,ik)
             End Do
          End Do
       endif
       deallocate( force_kdep )
    endif

    call tstatc0_end(id_sname)
  end subroutine m_ES_EXX_Force

  subroutine sum_EXX_force_terms(force_l,bdwr,bdwi,dbdwr,dbdwi,sumqvr,sumqvi,sumdqvr,sumdqvi)
    implicit none
    real(kind=DP), intent(inout) :: force_l(natm,3)
    real(kind=DP), intent(in) :: bdwr(nlmta), bdwi(nlmta)
    real(kind=DP), intent(in) :: dbdwr(nlmta,3), dbdwi(nlmta,3)
    real(kind=DP), intent(in) :: sumqvr(nlmta), sumqvi(nlmta)
    real(kind=DP), intent(in) :: sumdqvr(nlmta,3), sumdqvi(nlmta,3)

    integer :: ia,it,lmt1,ip

    do ia=1,natm
       it=ityp(ia)
       if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
       do lmt1 = 1, ilmt(it)
          ip = lmta(lmt1,ia)
          force_l(ia,1:3) = force_l(ia,1:3) &
                        & + dbdwr(ip,1:3)*sumqvr(ip) + dbdwi(ip,1:3)*sumqvi(ip) &
                        & + bdwr(ip)*sumdqvr(ip,1:3) + bdwi(ip)*sumdqvi(ip,1:3)
       end do
    end do
  end subroutine sum_EXX_force_terms

  subroutine gather_drv_bdw_exx()
    implicit none

    integer :: ik,ib,ib1,ibm,irev
    real(kind=DP), allocatable :: dfsr_mpi(:,:,:,:) ! d(nval,nlmta,kv3,3)
    real(kind=DP), allocatable :: dfsi_mpi(:,:,:,:) ! d(nval,nlmta,kv3,3)

    integer,save  :: id_sname = -1

    call tstatc0_begin('gather_drv_bdw_exx ',id_sname)

    dfsr_exx = 0.d0
    dfsi_exx = 0.d0

    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle
       do ib=1,nval
          ib1 = neordr(ib,ik)
          if(map_e(ib1) == myrank_e) then
             dfsr_exx(ib,1:nlmta,ik,1:3) = dfsr_l(map_z(ib1),1:nlmta,ik,1:3)
             dfsi_exx(ib,1:nlmta,ik,1:3) = dfsi_l(map_z(ib1),1:nlmta,ik,1:3)
          end if
       end do
    end do    

    if(npes>1) then
       allocate(dfsr_mpi(nval,nlmta,kv3,3))
       allocate(dfsi_mpi(nval,nlmta,kv3,3))
       call mpi_allreduce(dfsr_exx,dfsr_mpi,nval*nlmta*kv3*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       call mpi_allreduce(dfsi_exx,dfsi_mpi,nval*nlmta*kv3*3,MPI_DOUBLE_PRECISION,MPI_SUM,mpi_comm_group,ierr)
       dfsr_exx = dfsr_mpi
       dfsi_exx = dfsi_mpi
       deallocate(dfsr_mpi)
       deallocate(dfsi_mpi)
    end if

    call tstatc0_end(id_sname)
  end subroutine gather_drv_bdw_exx

  subroutine drv_betar_dot_WFs_exx()
    implicit none

    integer :: ik,ib,it,ia,i,il1,ilmtt1,ilmta1,iil,iksnl
    integer :: lmt1,lmtt1
    real(kind=DP) :: fac, ph, fr, fi, fac2, vec1(3)
    real(kind=DP), allocatable :: cosgt(:) ! d(kg1)
    real(kind=DP), allocatable :: singt(:) ! d(kg1)
    real(kind=DP), allocatable :: gvec(:,:) ! d(kg1,3)

    integer,save  :: id_sname = -1
    call tstatc0_begin('drv_betar_dot_WFs_exx ',id_sname)

    allocate(cosgt(kg1))
    allocate(singt(kg1))
    allocate(gvec(kg1,3))

    dfsr_l = 0.d0
    dfsi_l = 0.d0

    do ik=1,kv3,af+1
       if(map_k(ik) /= myrank_k) cycle ! MPI
       iksnl = (ik-1)/nspin + 1
       fac2 = 1.d0
       if(k_symmetry(ik)==GAMMA) fac2 = 2.d0
       do ia=1,natm
          it = ityp(ia)
          if( m_PP_include_vanderbilt_pot(it) == SKIP) cycle
          do i=1,iba(ik)
             gvec(i,1:3) = vkxyz_for_outerloop(ik,1:3,BUCS)+ngabc(nbase(i,ik),1:3)
             ph = PAI2 * dot_product(pos(ia,1:3),gvec(i,1:3))
             cosgt(i) = cos(ph)
             singt(i) = sin(ph)
          end do
#ifdef DERIVATIVE_IN_CARTS
          do i=1,iba(ik)
             vec1(1) = rltv(1,1)*gvec(i,1) +rltv(1,2)*gvec(i,2) +rltv(1,3)*gvec(i,3)
             vec1(2) = rltv(2,1)*gvec(i,1) +rltv(2,2)*gvec(i,2) +rltv(2,3)*gvec(i,3)
             vec1(3) = rltv(3,1)*gvec(i,1) +rltv(3,2)*gvec(i,2) +rltv(3,3)*gvec(i,3)
             gvec(i,1:3) = vec1(1:3)
          end do
#endif
          do lmt1 = 1, ilmt(it)
             il1  = ltp(lmt1,it)
             lmtt1 = lmtt(lmt1,it)
             ilmta1 = lmta(lmt1,ia)
             iil=mod(il1,4) !! i^(L+1)
             if(iil==0) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      fi = fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==1) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = -fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      fi =  fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==2) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr = -fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      fi = -fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             else if(iil==3) then
                do ib=1,np_e
                   if(occup_l(ib,ik) < DELTA) cycle
                   do i=1,iba(ik)
                      fac = snl(i,lmtt1,iksnl)*fac2
                      fr =  fac * ( cosgt(i)*zaj_l(i,ib,ik,2)+singt(i)*zaj_l(i,ib,ik,1) )
                      fi = -fac * ( cosgt(i)*zaj_l(i,ib,ik,1)-singt(i)*zaj_l(i,ib,ik,2) )
                      dfsr_l(ib,ilmta1,ik,1:3) = dfsr_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fr
                      dfsi_l(ib,ilmta1,ik,1:3) = dfsi_l(ib,ilmta1,ik,1:3) + gvec(i,1:3) * fi
                   end do
                end do
             end if
          end do
       end do
    end do

    deallocate(cosgt)
    deallocate(singt)
    deallocate(gvec)

    call tstatc0_end(id_sname)
  end subroutine drv_betar_dot_WFs_exx
#if defined(MEMORY_SAVE_EXX) && defined(MEMORY_SAVE_MORE_EXX)
  subroutine qitgft_qmk_each_k_setup(it_in,nmm_il3_in,mm_il3_in,qrsps_mm_in,lcmax_in,h_in)
     use m_PseudoPotential, only : wos, nqitg_sp
     implicit none
     integer, intent(in) :: it_in
     integer, intent(in) :: nmm_il3_in(lcmax_in+1)
     integer, intent(in) :: mm_il3_in(nqitg_sp(it_in),lcmax_in+1)
     real(kind=DP), intent(in) :: qrsps_mm_in(mmesh,nqitg_sp(it_in))
     integer, intent(in) :: lcmax_in
     real(kind=DP), intent(in) :: h_in(it_in)

     it = it_in
     lcmax = lcmax_in
     allocate(nmm_il3(lcmax+1)); nmm_il3 = nmm_il3_in
     allocate(mm_il3(nqitg_sp(it),lcmax+1)); mm_il3 = mm_il3_in
     allocate(qrsps_mm(mmesh,nqitg_sp(it))); qrsps_mm = qrsps_mm_in
     allocate(h(it)); h = h_in
     allocate(radr_kept(mmesh)); radr_kept = radr
     allocate(wos_kept(mmesh)); wos_kept = wos

     return
  end subroutine qitgft_qmk_each_k_setup

  subroutine qitgft_qmk_each_k(ik)
     use m_PseudoPotential,    only : nqitg_sp
     implicit none
     integer, intent(in) :: ik

     integer :: mm0, i, il3, mm, mmp, n, idp, iq
     real(kind=DP) :: ttr(6), kg(3)
     real(kind=DP) :: qitg_sh, g2, gabs
     real(kind=DP) :: wkx(mmesh), wky(mmesh)
     real(kind=DP), allocatable :: gqmk_l(:) ! d(kgp)
     real(kind=DP), allocatable :: qitg_exx_l(:,:) ! d(kgp,nqitg_sp(it))
     integer,save  :: id_sname = -1

     if(m_PP_include_vanderbilt_pot(it) == SKIP .or. sw_rspace_hyb == ON) return

     call tstatc0_begin('qitgft_qmk ', id_sname)

     call getttr(rltv,ttr)

     allocate(qitg_exx_l(kgp,nqitg_sp(it))); qitg_exx_l = 0.0d0
     allocate(gqmk_l(kgp))
     mm0 = 0
     do i = 1, it-1
        mm0 = mm0 + nqitg_sp(i)
     end do
     do i = 1, kgp
        kg(1:3) = qmk(ik,1:3) + ngabc(i,1:3)
        g2          = ttr(1)*kg(1)*kg(1) &
        &           + ttr(2)*kg(2)*kg(2) &
        &           + ttr(3)*kg(3)*kg(3) &
        &           + ttr(4)*kg(1)*kg(2) &
        &           + ttr(5)*kg(2)*kg(3) &
        &           + ttr(6)*kg(3)*kg(1)
        gqmk_l(i) = sqrt(g2)
     end do
     do il3 = 1, lcmax+1
        if(nmm_il3(il3) <= 0) cycle
        do i = 1, kgp
           gabs = gqmk_l(i)
           if(gabs < DELTA) then
              idp = nmesh(it)+1
           else
              idp = ceiling(nmesh(it) - dlog(rmax(it)*gabs)/h(it))
           end if
! ==== ASMS ====
           if ( idp > nmesh(it) +1 ) idp = nmesh(it) +1
! ==== ASMS ====

           wkx(1:nmesh(it)) = gabs*radr_kept(1:nmesh(it))
           call dsjnvn(il3-1,nmesh(it),idp,wkx,wky)
           do mm = 1, nmm_il3(il3)
              mmp = mm_il3(mm,il3)
              if ( mmp <= 0 ) cycle

              qitg_sh = 0.d0
              do n = 1, nmesh(it)
                 qitg_sh = qitg_sh + wos_kept(n)*qrsps_mm(n,mmp)*wky(n)
              end do
              qitg_exx_l(i,mmp) = qitg_sh*PAI4
           end do
        end do
     end do
     do iq = 1, nqitg_sp(it)
        do i = 1, kgp
           qitg_exx(i,mm0+iq) = qitg_exx_l(i,iq)
        end do
     end do
     deallocate(qitg_exx_l)
     deallocate(gqmk_l)

     call tstatc0_end(id_sname)
  end subroutine qitgft_qmk_each_k
#endif

end module m_ES_ExactExchange

      subroutine  eigen_hrd_Au(
     &              ar, ai, nm,
     &              ur_x, ui_x,
     &              ur_y, ui_y,
     &              vr_x, vi_x,
     &              ur_t, ui_t, vr_t, vi_t,
     &              d_t,
     &              n, x_pos,y_pos, nv,blk_0,
     &              ar_,ai_,n_,nm_
     &            )
!----
      use communication_h, only : send_dbl
     &               , recv_dbl
     &               , reduce_dbl
!----
      implicit none

      integer, intent(in)    :: nm, nv, n
      real(8), intent(inout) :: ar(1:nm,*), ai(1:nm,*)
      real(8), intent(inout) :: ur_x(1:nv), ui_x(1:nv)
      real(8), intent(inout) :: ur_y(1:nv), ui_y(1:nv)
      real(8), intent(inout) :: vr_x(1:nv), vi_x(1:nv)
      real(8), intent(inout) :: vr_t(1:nv), vi_t(1:nv)
      real(8), intent(inout) :: ur_t(1:nv), ui_t(1:nv)
      real(8), intent(in)    :: d_t(1:nv)
      integer, intent(in)    :: blk_0
      integer, intent(in)    :: n_,nm_
      real(8), intent(inout) :: ar_(1:nm_,*), ai_(1:nm_,*)
      integer                :: x_pos, y_pos
      integer                :: local_size, local_rank
      real(8), pointer       :: ur_z(:),ui_z(:),vr_z(:),vi_z(:)
      save                   :: ur_z,   ui_z,   vr_z   ,vi_z

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'

      local_rank = 0
      local_size = 1
!$    local_rank = omp_get_thread_num()
!$    local_size = omp_get_num_threads()

      if ( n == -1 ) then
         if ( local_rank == 0 ) then
            allocate(ur_z(nv*local_size), ui_z(nv*local_size),
     &               vr_z(nv*local_size), vi_z(nv*local_size))
         end if
         return
      end if
      if ( n <  -1 ) then
         if ( local_rank == 0 ) then
            deallocate(ur_z, ui_z, vr_z, vi_z)
         end if
         return
      end if

      call eigen_hrd_Au_step1(
     &       ar,ai, nm,
     &       ur_x,ui_x, ur_y,ui_y,
     &       ur_z(1+nv*local_rank),
     &       ui_z(1+nv*local_rank),
     &       vr_z(1+nv*local_rank),
     &       vi_z(1+nv*local_rank),
     &       1,n,x_pos,y_pos,nv,blk_0,
     &       local_rank, local_size
     &     )

!$omp barrier

      call eigen_hrd_Au_step2(
     &       vr_x,vi_x, ur_z,ui_z,
     &       vr_t,vi_t, vr_z,vi_z,
     &       nv, x_pos, y_pos,
     &       local_rank, local_size
     &     )

!$omp barrier

      if ( local_rank == 0 ) then

         if(n+1<=y_pos)then
            vr_t(n+1:y_pos) = 0.0d0
            vi_t(n+1:y_pos) = 0.0d0
         endif
         if ( nprocs > 1 ) then
            call reduce_dbl(vr_t, ur_t, y_pos, mpi_comm_col)
            call reduce_dbl(vi_t, ui_t, y_pos, mpi_comm_col)
         end if

         call eigen_hrd_Au_step3(
     &          ur_x,ui_x,ur_y,ui_y,vr_x,vi_x,
     &          ur_t,ui_t,vr_t,vi_t,d_t,
     &          1,n,x_pos,y_pos,nv
     &        )

         if ( nprocs > 1 ) then
            if ( nprocs >= es_cluster**2 .and.
     &                       size_of_col > 1 .and. es_icnod > 1 ) then
               call recv_dbl(vr_x(1), 0, es_icnod-1, es_ccomm_world)
            endif
            call reduce_dbl(vr_x, vr_t, x_pos, mpi_comm_row)
            call reduce_dbl(vi_x, vi_t, x_pos, mpi_comm_row)
            if ( nprocs >= es_cluster**2 .and.
     &           size_of_col > 1 .and. 
     &           es_icnod < es_ncnod ) then
               call send_dbl(vr_x(1), 0, es_icnod+1, es_ccomm_world)
            endif
         end if

      endif

      return
      end subroutine ! eigen_hrd_Au

      subroutine  eigen_hrd_Au_step1(
     &              ar,ai,nm,
     &              ur_x,ui_x,ur_y,ui_y,
     &              ur_t,ui_t,vr_t,vi_t,
     &              n1,n2,x_pos,y_pos,nv,blk_0,
     &              local_rank, local_size
     &            )
!----
      use communication_h, only : get_loop_end
     &               , translate_l2g
!----
      implicit none

      integer, intent(in)    :: nm, nv, n1, n2
      real(8), intent(inout) :: ar(1:nm,*), ai(1:nm,*)
      real(8), intent(inout) :: ur_x(1:nv), ui_x(1:nv)
      real(8), intent(inout) :: ur_y(1:nv), ui_y(1:nv)
      real(8), intent(inout) :: ur_t(1:nv), ui_t(1:nv)
      real(8), intent(inout) :: vr_t(1:nv), vi_t(1:nv)
      integer, intent(in)    :: blk_0
      integer                :: x_pos, y_pos
      integer                :: local_size, local_rank
      integer                :: i_1, i_2, i_3, i_4
      integer                :: j_1, j_2, j_3, j_4
      integer                :: k_1, k_2, k_3, k_4
      integer                :: i, j, k

      real(8)                :: vr0, vi0, ur0, ui0
      real(8)                :: ar0_0, ai0_0
      real(8)                :: ar0_1, ai0_1
      real(8)                :: ar0_2, ai0_2
      real(8)                :: ar0_3, ai0_3
      real(8)                :: ar0_4, ai0_4
      real(8)                :: ar0_5, ai0_5
      real(8)                :: ar0_6, ai0_6
      real(8)                :: ar0_7, ai0_7
      real(8)                :: ar0_8, ai0_8
      real(8)                :: ar0_9, ai0_9
      real(8)                :: vr_t0,vi_t0, ur_y0,ui_y0
      real(8)                :: vr_t1,vi_t1, ur_y1,ui_y1
      real(8)                :: vr_t2,vi_t2, ur_y2,ui_y2
      real(8)                :: vr_t3,vi_t3, ur_y3,ui_y3
      real(8)                :: vr_t4,vi_t4, ur_y4,ui_y4
      real(8)                :: vr_t5,vi_t5, ur_y5,ui_y5
      real(8)                :: vr_t6,vi_t6, ur_y6,ui_y6
      real(8)                :: vr_t7,vi_t7, ur_y7,ui_y7
      real(8)                :: vr_t8,vi_t8, ur_y8,ui_y8
      real(8)                :: vr_t9,vi_t9, ur_y9,ui_y9

      integer                ::   ii_1, ii_2, ii_3, ii_4
      integer                ::   jj_1, jj_2, jj_3, jj_4

      include 'mpif.h'
!$    include 'omp_lib.h'
      include 'trd.h'

      i_2 = n1
      i_3 = n2
!----
! v:= au
!----
      if ( n1 == 1 ) then
         ur_t(1:x_pos) = 0.0d+00
         ui_t(1:x_pos) = 0.0d+00
         vr_t(1:y_pos) = 0.0d+00
         vi_t(1:y_pos) = 0.0d+00
      end if

      if ( blk_0 == 0 ) then
         do i_1=i_2+local_rank,i_3,local_size
            j   = translate_l2g(i_1, size_of_row,my_row)
            j_3 = get_loop_end  (j, size_of_col,my_col)
            j   = j+size_of_row*(10-1)
            j_4 = get_loop_end  (j, size_of_col,my_col)
            do j_1=j_3+1,min(j_4,nm)
               ar(j_1,i_1) = 0.0d+00
               ai(j_1,i_1) = 0.0d+00
            end do! j_1
         end do! i_1
!$omp barrier
      end if
!----
      k_1 = 1
      ii_2 = i_2; ii_3 = i_3
      ii_4 = mod(ii_3-ii_2+1,10)+ii_2

      do i_1=ii_2+local_rank,ii_4-1,local_size

         j    = translate_l2g(i_1, size_of_row,my_row)
         j    = j+(1-1)*size_of_row
         jj_2 = k_1
         jj_3 = get_loop_end  (j-1, size_of_col,my_col)
         if ( jj_2 > jj_3 ) cycle

         do j_1=jj_2,jj_3

            ur0 = ur_x(j_1+0)
            ui0 = ui_x(j_1+0)
            vr0 = 0
            vi0 = 0
!----       vr0 = ur_t(j_1+0)
!----       vi0 = ui_t(j_1+0)

            ar0_0 = ar(j_1+0,i_1+0)
            ai0_0 = ai(j_1+0,i_1+0)
            vr_t(i_1+0) = vr_t(i_1+0)
     &                  + (ar0_0*ur0)
     &                  + (ai0_0*ui0)

            vi_t(i_1+0) = vi_t(i_1+0)
     &                  + (ar0_0*ui0)
     &                  - (ai0_0*ur0)
            vr0 = vr0
     &          + (ar0_0*ur_y(i_1+0))
     &          - (ai0_0*ui_y(i_1+0))
            vi0 = vi0
     &          + (ar0_0*ui_y(i_1+0))
     &          + (ai0_0*ur_y(i_1+0))

            ur_t(j_1+0) = vr0 + ur_t(j_1+0)
            ui_t(j_1+0) = vi0 + ui_t(j_1+0)

         end do! j_1

      end do! i_1

      do i_1=ii_4+local_rank*10,ii_3, local_size*10

         j    = translate_l2g(i_1, size_of_row,my_row)
         j    = j+(10-1)*size_of_row
         jj_2 = k_1
         jj_3 = get_loop_end  (j-1, size_of_col,my_col)
         if ( jj_2 > jj_3 ) cycle

         do j_1=jj_2,jj_3

            ur0 = ur_x(j_1+0)
            ui0 = ui_x(j_1+0)
            vr0 = 0
            vi0 = 0
!----       vr0 = ur_t(j_1+0)
!----       vi0 = ui_t(j_1+0)

            ar0_0 = ar(j_1+0,i_1+0)
            ai0_0 = ai(j_1+0,i_1+0)
            ar0_1 = ar(j_1+0,i_1+1)
            ai0_1 = ai(j_1+0,i_1+1)
            ar0_2 = ar(j_1+0,i_1+2)
            ai0_2 = ai(j_1+0,i_1+2)
            ar0_3 = ar(j_1+0,i_1+3)
            ai0_3 = ai(j_1+0,i_1+3)
            vr_t(i_1+0) = vr_t(i_1+0)
     &                  + (ar0_0*ur0)
     &                  + (ai0_0*ui0)

            vi_t(i_1+0) = vi_t(i_1+0)
     &                  + (ar0_0*ui0)
     &                  - (ai0_0*ur0)
            vr_t(i_1+1) = vr_t(i_1+1)
     &                  + (ar0_1*ur0)
     &                  + (ai0_1*ui0)

            vi_t(i_1+1) = vi_t(i_1+1)
     &                  + (ar0_1*ui0)
     &                  - (ai0_1*ur0)
            vr_t(i_1+2) = vr_t(i_1+2)
     &                  + (ar0_2*ur0)
     &                  + (ai0_2*ui0)

            vi_t(i_1+2) = vi_t(i_1+2)
     &                  + (ar0_2*ui0)
     &                  - (ai0_2*ur0)
            vr_t(i_1+3) = vr_t(i_1+3)
     &                  + (ar0_3*ur0)
     &                  + (ai0_3*ui0)

            vi_t(i_1+3) = vi_t(i_1+3)
     &                  + (ar0_3*ui0)
     &                  - (ai0_3*ur0)
            vr0 = vr0
     &                  + (ar0_0*ur_y(i_1+0))
     &                  - (ai0_0*ui_y(i_1+0))
     &                  + (ar0_1*ur_y(i_1+1))
     &                  - (ai0_1*ui_y(i_1+1))
     &                  + (ar0_2*ur_y(i_1+2))
     &                  - (ai0_2*ui_y(i_1+2))
     &                  + (ar0_3*ur_y(i_1+3))
     &                  - (ai0_3*ui_y(i_1+3))
            vi0 = vi0
     &                  + (ar0_0*ui_y(i_1+0))
     &                  + (ai0_0*ur_y(i_1+0))
     &                  + (ar0_1*ui_y(i_1+1))
     &                  + (ai0_1*ur_y(i_1+1))
     &                  + (ar0_2*ui_y(i_1+2))
     &                  + (ai0_2*ur_y(i_1+2))
     &                  + (ar0_3*ui_y(i_1+3))
     &                  + (ai0_3*ur_y(i_1+3))
            ar0_4 = ar(j_1+0,i_1+4)
            ai0_4 = ai(j_1+0,i_1+4)
            ar0_5 = ar(j_1+0,i_1+5)
            ai0_5 = ai(j_1+0,i_1+5)
            ar0_6 = ar(j_1+0,i_1+6)
            ai0_6 = ai(j_1+0,i_1+6)
            ar0_7 = ar(j_1+0,i_1+7)
            ai0_7 = ai(j_1+0,i_1+7)
            vr_t(i_1+4) = vr_t(i_1+4)
     &                  + (ar0_4*ur0)
     &                  + (ai0_4*ui0)

            vi_t(i_1+4) = vi_t(i_1+4)
     &                  + (ar0_4*ui0)
     &                  - (ai0_4*ur0)
            vr_t(i_1+5) = vr_t(i_1+5)
     &                  + (ar0_5*ur0)
     &                  + (ai0_5*ui0)

            vi_t(i_1+5) = vi_t(i_1+5)
     &                  + (ar0_5*ui0)
     &                  - (ai0_5*ur0)
            vr_t(i_1+6) = vr_t(i_1+6)
     &                  + (ar0_6*ur0)
     &                  + (ai0_6*ui0)

            vi_t(i_1+6) = vi_t(i_1+6)
     &                  + (ar0_6*ui0)
     &                  - (ai0_6*ur0)
            vr_t(i_1+7) = vr_t(i_1+7)
     &                  + (ar0_7*ur0)
     &                  + (ai0_7*ui0)

            vi_t(i_1+7) = vi_t(i_1+7)
     &                  + (ar0_7*ui0)
     &                  - (ai0_7*ur0)
            vr0 = vr0
     &                  + (ar0_4*ur_y(i_1+4))
     &                  - (ai0_4*ui_y(i_1+4))
     &                  + (ar0_5*ur_y(i_1+5))
     &                  - (ai0_5*ui_y(i_1+5))
     &                  + (ar0_6*ur_y(i_1+6))
     &                  - (ai0_6*ui_y(i_1+6))
     &                  + (ar0_7*ur_y(i_1+7))
     &                  - (ai0_7*ui_y(i_1+7))
            vi0 = vi0
     &                  + (ar0_4*ui_y(i_1+4))
     &                  + (ai0_4*ur_y(i_1+4))
     &                  + (ar0_5*ui_y(i_1+5))
     &                  + (ai0_5*ur_y(i_1+5))
     &                  + (ar0_6*ui_y(i_1+6))
     &                  + (ai0_6*ur_y(i_1+6))
     &                  + (ar0_7*ui_y(i_1+7))
     &                  + (ai0_7*ur_y(i_1+7))
            ar0_8 = ar(j_1+0,i_1+8)
            ai0_8 = ai(j_1+0,i_1+8)
            ar0_9 = ar(j_1+0,i_1+9)
            ai0_9 = ai(j_1+0,i_1+9)
            vr_t(i_1+8) = vr_t(i_1+8)
     &                  + (ar0_8*ur0)
     &                  + (ai0_8*ui0)

            vi_t(i_1+8) = vi_t(i_1+8)
     &                  + (ar0_8*ui0)
     &                  - (ai0_8*ur0)
            vr_t(i_1+9) = vr_t(i_1+9)
     &                  + (ar0_9*ur0)
     &                  + (ai0_9*ui0)

            vi_t(i_1+9) = vi_t(i_1+9)
     &                  + (ar0_9*ui0)
     &                  - (ai0_9*ur0)
            vr0 = vr0
     &                  + (ar0_8*ur_y(i_1+8))
     &                  - (ai0_8*ui_y(i_1+8))
     &                  + (ar0_9*ur_y(i_1+9))
     &                  - (ai0_9*ui_y(i_1+9))
            vi0 = vi0
     &                  + (ar0_8*ui_y(i_1+8))
     &                  + (ai0_8*ur_y(i_1+8))
     &                  + (ar0_9*ui_y(i_1+9))
     &                  + (ai0_9*ur_y(i_1+9))

            ur_t(j_1+0) = vr0 + ur_t(j_1+0)
            ui_t(j_1+0) = vi0 + ui_t(j_1+0)

         end do! j_1

      end do! i_1

      return
      end subroutine ! eigen_hrd_Au_step1

      subroutine  eigen_hrd_Au_step2(
     &            ur_t,ui_t, ur_z,ui_z,
     &            vr_t,vi_t, vr_z,vi_z, nv, x_pos, y_pos
     &           ,local_rank, local_size
     &            )
      implicit none

      integer, intent(in)    :: nv, x_pos, y_pos
      real(8), intent(out)   :: ur_t(1:nv),   ui_t(1:nv)
      real(8), intent(out)   :: vr_t(1:nv),   vi_t(1:nv)
      real(8), intent(in)    :: ur_z(1:nv,*), ui_z(1:nv,*)
      real(8), intent(in)    :: vr_z(1:nv,*), vi_z(1:nv,*)

      integer                :: local_rank, local_size
      integer                :: j_1, j_2, j_3, j_4
      integer                :: jj_1, jj_2, jj_3, jj_4
      integer                :: i, j, k
      integer, parameter     :: lx = 1024

      jj_1 = x_pos
      jj_2 = (jj_1-1)/local_size+1
      jj_3 =    (jj_2*(local_rank+0)     )+1
      jj_4 = min(jj_2*(local_rank+1),jj_1)

      if ( jj_2 < 1024 ) then
         if(local_rank==0)then
            jj_3=1; jj_4=x_pos
         else
            jj_3=1; jj_4=0
         endif
      endif

      j_3=jj_3; j_4=jj_4
      if ( mod(local_size,2) == 1 ) then
         do j_1=j_3,j_4
            ur_t(j_1) = ur_z(j_1,1)
            ui_t(j_1) = ui_z(j_1,1)
         end do
      else
         do j_1=j_3,j_4
            ur_t(j_1) = ur_z(j_1,1)+ur_z(j_1,2)
            ui_t(j_1) = ui_z(j_1,1)+ui_z(j_1,2)
         end do
      end if
      do j=mod(local_size-1,2)+2,local_size,2
         do j_1=j_3,j_4
            ur_t(j_1) = ur_t(j_1)+ur_z(j_1,j+0)+ur_z(j_1,j+1)
            ui_t(j_1) = ui_t(j_1)+ui_z(j_1,j+0)+ui_z(j_1,j+1)
         end do
      end do

      jj_1 = y_pos
      jj_2 = (jj_1-1)/local_size+1
      jj_3 =    (jj_2*(local_rank+0)     )+1
      jj_4 = min(jj_2*(local_rank+1),jj_1)

      if ( jj_2 < 1024 ) then
         if(local_rank==0)then
            jj_3=1; jj_4=y_pos
         else
            jj_3=1; jj_4=0
         endif
      endif

      j_3=jj_3; j_4=jj_4
      if ( mod(local_size,2) == 1 ) then
         do j_1=j_3,j_4
            vr_t(j_1) = vr_z(j_1,1)
            vi_t(j_1) = vi_z(j_1,1)
         end do
      else
         do j_1=j_3,j_4
            vr_t(j_1) = vr_z(j_1,1)+vr_z(j_1,2)
            vi_t(j_1) = vi_z(j_1,1)+vi_z(j_1,2)
         end do
      end if
      do j=mod(local_size-1,2)+2,local_size,2
         do j_1=j_3,j_4
            vr_t(j_1) = vr_t(j_1)+vr_z(j_1,j+0)+vr_z(j_1,j+1)
            vi_t(j_1) = vi_t(j_1)+vi_z(j_1,j+0)+vi_z(j_1,j+1)
         end do
      end do

      return
      end subroutine ! eigen_hrd_Au_step2

      subroutine  eigen_hrd_Au_step3(
     &              ur_x,ui_x,ur_y,ui_y,
     &              vr_x,vi_x,
     &              ur_t,ui_t,vr_t,vi_t,d_t,
     &              n1,n2,x_pos,y_pos,nv
     &            )
!----
      use communication_h, only : translate_l2g
     &               , translate_g2l
!----
      implicit none

      integer, intent(in)    :: nv, n1, n2
      real(8), intent(in)    :: ur_x(1:nv),ui_x(1:nv)
      real(8), intent(in)    :: ur_y(1:nv),ui_y(1:nv)
      real(8), intent(inout) :: vr_x(1:nv),vi_x(1:nv)
      real(8), intent(in)    :: ur_t(*),ui_t(*),vr_t(*),vi_t(*)
      real(8), intent(in)    :: d_t(1:nv)
      integer                :: x_pos, y_pos

      integer                :: i_2, i_3
      integer                :: i, j, k
      integer                :: nm1, nm2

      include 'mpif.h'
      include 'trd.h'

      i_2 = n1
      i_3 = n2

      if ( diag_0 > 0 ) then

         j = translate_l2g(diag_0, size_of_row,my_row)
         j = translate_g2l(j, size_of_col,my_col)
         if ( j > nv ) return

         nm1 = size_of_row/n_common
         nm2 = size_of_col/n_common

         if ( nm2 == 1 ) then
            if ( nm1 == 1 ) then
               call eigen_hrd_Au_step3_sub3(
     &                vr_x(j), vi_x(j),
     &                vr_t(diag_0), vi_t(diag_0),
     &                d_t(diag_0),
     &                ur_y(diag_0), ui_y(diag_0),
     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
     &              )
            else
               call eigen_hrd_Au_step3_sub2(
     &                vr_x(j), vi_x(j),
     &                vr_t(diag_0), vi_t(diag_0),
     &                d_t(diag_0),
     &                ur_y(diag_0), ui_y(diag_0),
     &                (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
     &              )
            end if
         else
            call eigen_hrd_Au_step3_sub1(
     &             vr_x(j), vi_x(j),
     &             vr_t(diag_0), vi_t(diag_0),
     &             d_t(diag_0),
     &             ur_y(diag_0), ui_y(diag_0),
     &             (i_3-diag_0)/(size_of_col/n_common)+1, nm1, nm2
     &           )

         end if

      end if

      return
      end subroutine ! eigen_hrd_Au_step3

      subroutine eigen_hrd_Au_step3_sub1(
     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y,
     &             n,nm1,nm2
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: vr_x(nm1,*), vi_x(nm1,*)
      real(8), intent(in)    :: vr_t(nm2,*), vi_t(nm2,*)
      real(8), intent(in)    :: d_t(nm2,*)
      real(8), intent(in)    :: ur_y(nm2,*), ui_y(nm2,*)

      integer                :: i

      do i=1,n
         vr_x(1,i) = vr_x(1,i)+vr_t(1,i)+d_t(1,i)*ur_y(1,i)
         vi_x(1,i) = vi_x(1,i)+vi_t(1,i)+d_t(1,i)*ui_y(1,i)
      end do! i

      return
      end subroutine ! eigen_hrd_Au_step3_sub1

      subroutine eigen_hrd_Au_step3_sub2(
     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y,
     &             n,nm1,nm2
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: vr_x(nm1,*), vi_x(nm1,*)
      real(8), intent(in)    :: vr_t(*), vi_t(*)
      real(8), intent(in)    :: d_t(*)
      real(8), intent(in)    :: ur_y(*), ui_y(*)

      integer                :: i

      do i=1,n
         vr_x(1,i) = vr_x(1,i)+vr_t(i)+d_t(i)*ur_y(i)
         vi_x(1,i) = vi_x(1,i)+vi_t(i)+d_t(i)*ui_y(i)
      end do! i

      return
      end subroutine ! eigen_hrd_Au_step3_sub2

      subroutine eigen_hrd_Au_step3_sub3(
     &             vr_x,vi_x,vr_t,vi_t,d_t,ur_y,ui_y,
     &             n,nm1,nm2
     &           )
      implicit none

      integer, intent(in)    :: n, nm1, nm2
      real(8), intent(inout) :: vr_x(1:n), vi_x(1:n)
      real(8), intent(in)    :: vr_t(1:n), vi_t(1:n)
      real(8), intent(in)    :: d_t(1:n)
      real(8), intent(in)    :: ur_y(1:n), ui_y(1:n)

      integer                :: i

      do i=1,n
         vr_x(i) = vr_x(i)+vr_t(i)+d_t(i)*ur_y(i)
         vi_x(i) = vi_x(i)+vi_t(i)+d_t(i)*ui_y(i)
      end do! i

      return
      end subroutine ! eigen_hrd_Au_step3_sub3

       subroutine eigen_trbakwyx(n, nvec, a, nma0, z, nmz0, e, m0, iblk)
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_trbak
       implicit NONE

       integer, intent(in)    :: n, nvec, nma0, nmz0, m0, iblk
       real(8), intent(in)    :: a(*)
       real(8), intent(out)   :: z(*)
       real(8), intent(in)    :: e(*)

       real(8) , pointer      :: w(:), d(:)
       real(8) , pointer      :: v1(:), ss1(:)
       real(8) , pointer      :: v2(:), ss2(:)
       real(8) , pointer      :: v3(:), ss3(:)
       real(8) , pointer      :: tt(:)

       integer                :: nma, nmz, m
       integer                :: na, nm, kx
       integer                :: i_v1, i_v2, i_v3
       integer                :: i_s1, i_s2, i_s3
       integer                :: i_t
       integer                :: i_stat, ierr

       real(8) :: d1, d2

       include 'CSTAB.h'
*
       nma  = nma0
       nmz  = nmz0
       m    = MIN(nsm, m0)
       if ( m < 1 ) m = 1
*
       call eigen_timer_reset( )
*
       na   = (n-1)/y_nnod+1
       na   = na  +MOD(na  -1,2)
       call CSTAB_get_optdim(nma,9,16*4,16*6,nm)
*
       allocate(
     &          d(1:n),
     &          v1(1:MAX(nm*m,n)+n_columns),
     &          ss1(1:na*m+ns0+n_columns),
     &          v2(1:MAX(nm*m,n)+n_columns),
     &          ss2(1:na*m+ns0+n_columns),
     &          v3(1:MAX(nm*m,n)+n_columns),
     &          ss3(1:na*m+ns0+n_columns),
     &          tt(1:na*m+ns0+n_columns),
     &          stat=i_stat)
       if ( i_stat /= 0 ) then
         if ( TRD_inod == 1 ) print*, "Memory allocation error."
         call mpi_abort(TRD_COMM_WORLD,1,ierr)
       end if
*
       call CSTAB_adjust_base(v1(1), z(1), i_v1)
       call CSTAB_adjust_base(ss1(1), z(1), i_s1)
       call CSTAB_adjust_base(v2(1), z(1), i_v2)
       call CSTAB_adjust_base(ss2(1), z(1), i_s2)
       call CSTAB_adjust_base(v3(1), z(1), i_v3)
       call CSTAB_adjust_base(ss3(1), z(1), i_s3)
       call CSTAB_adjust_base(tt(1), z(1), i_t)
          kx = (L1_WINDOW/8)
!     &           +(L1_WINDOW)
!     &           +(L1_LSIZE/8)
     &           +(L1_LSIZE)
     &           +(L2_LSIZE/8)
       i_v1 = i_v1 + kx*3
       i_s1 = i_s1 + kx*1
       i_v2 = i_v2 + kx*5
       i_s2 = i_s2 + kx*1
       i_v3 = i_v3 + kx*7
       i_s3 = i_s3 + kx*1
       i_t = i_t + kx*1
       call CSTAB_round_offset(i_v1)
       call CSTAB_round_offset(i_s1)
       call CSTAB_round_offset(i_v2)
       call CSTAB_round_offset(i_s2)
       call CSTAB_round_offset(i_v3)
       call CSTAB_round_offset(i_s3)
       call CSTAB_round_offset(i_t)
*
       allocate( TRBK_buf(1:m*nm) )
*
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d1 = eigen_get_wtime()
!$OMP PARALLEL
       call trbakwy_body( n, nvec,
     $      a(1), nma,
     $      z(1), nmz,
     $      e(1), d(1),
     $      v1(1+i_v1), v2(1+i_v2), v3(1+i_v3), nm, m,
     $      ss1(1+i_s1), ss2(1+i_s2), ss3(1+i_s3),
     $      tt(1+i_t), iblk, na )
!$OMP END PARALLEL
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
       d2 = eigen_get_wtime()
*
       deallocate( TRBK_buf )
*
       deallocate( d )
       deallocate( v1 )
       deallocate( ss1 )
       deallocate( v2 )
       deallocate( ss2 )
       deallocate( v3 )
       deallocate( ss3 )
       deallocate( tt )
*
       call eigen_timer_print( )

#if TIMER_PRINT
       IF(TRD_inod==1)print*,"TRBAKWY",d2-d1
#endif
*
       return
       end
*
*
*
       subroutine trbakwy_body(n, nvec, a, nma, z, nmz, e, d,
     &             v1, v2, v3, nm, m, ss1, ss2, ss3, tt, iblk, nss)
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_TRBAK
       implicit NONE

       integer, intent(in)    :: n, nvec, nma, nmz
       integer, intent(in)    :: nm, m, iblk, nss
       real(8), intent(in)    :: a(1:nma,*)
       real(8), intent(inout) :: z(1:nmz,*)
       real(8), intent(in)    :: e(1:n)
       real(8), intent(inout) :: d(1:n)

       real(8), intent(out)   :: v1(1:nm,*), ss1(*)
       real(8), intent(out)   :: v2(1:nm,*), ss2(*)
       real(8), intent(out)   :: v3(1:nm,*), ss3(*)
       real(8), intent(out)   :: tt(*)
*
       integer                :: nodes(0:nsm-1)

       real(8), pointer       :: wk(:)
       integer                :: nx, lwk, ierr

       integer                :: i, L, mode
       integer                :: x_pos, x_root
       integer                :: i_1, i_2, i_3, i_4
       integer                :: j_1, j_2, j_3, j_4
       real(8)                :: s0, s1, s2, s3
       real(8)                :: d0, d1, d2, ds, de, dcom, dx, dy, dz

*
       dx = 0D0; dy = 0D0; dz = 0D0

!$OMP MASTER
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
!$OMP END MASTER
!$OMP BARRIER
!$OMP MASTER
#if TIMER_PRINT
       d1 = eigen_get_wtime()
#endif
       dcom=0.0D0+00
*-
#if AT_BCAST_OVERLAP
!$     DO_OVERLAP_BCAST_LEVEL  = 2
!$     TRBK_TIME_COUNTER  = 0
!$     TRBK_TIME_INTERVAL = 1
!$     TRBK_TIME_NEXT     = 2
!$     TRBK_SWITCHED      = 0
!$     TRBK_TIME_TRBK1    = 0D0
!$     TRBK_TIME_TRBK1x   = 0D0
!$     TRBK_TIME_BCAST    = 0D0
!$     TRBK_TIME_REDUC    = 1D0
!$     TRBK_TIME_FR       = 0D0
!===
!$     call omp_init_lock( TRBK_LOCK(1) )
!$     call omp_set_lock( TRBK_LOCK(1) )
!$     TRBK_LOCK(2) = 0
!$     call omp_unset_lock( TRBK_LOCK(1) )
!===
#else
!$     DO_OVERLAP_BCAST_LEVEL  = 0
#endif
*-
       lwk=MAX(((m-1)/y_nnod+1)*((n-1)/x_nnod+1),n)
       allocate(wk(lwk))
!$OMP END MASTER
*
       i_2 = eigen_loop_start(1+iblk, y_nnod,y_inod)
       i_3 = eigen_loop_end  (n,      y_nnod,y_inod)
*
!$OMP MASTER
       d(1:n)=0.0
       do i_1=i_2,i_3
!          i = eigen_translate_l2g(i_1, y_nnod,y_inod)
          i = (i_1-1)*y_nnod+y_inod
          l = i-iblk
!          x_root = eigen_owner_node(l, x_nnod,x_inod)
          x_root = MOD(l-1,x_nnod)+1
          if ( x_root == x_inod ) then
!             j_1 = eigen_translate_g2l(l, x_nnod,x_inod)
             j_1  = (l-1)/x_nnod+1
             d(i) = a(j_1,i_1)
          end if
       end do! i_1
       call reduce_dbl( d, wk, n, 1, TRD_COMM_WORLD )
       do i=1+iblk,n
          if ( e(i)*d(i) == 0.0D+00 ) then
             s0 = 0.0
          else
             s0 = (1.0D0/d(i))/e(i)
          end if
          d(i) = s0
       end do! i
!$OMP END MASTER
*
       i_2 = eigen_loop_start(1,    y_nnod,y_inod)
       i_3 = eigen_loop_end  (nvec, y_nnod,y_inod)
*
*----------------------------------------------------------------
*
       nx = MIN(MOD(n-(1+iblk)+1,m)+(1+iblk)-1,n)
*
       do i=(1+iblk),nx

!$OMP BARRIER
*
          if ( e(i) == 0.0 ) cycle
*
          j_2 = eigen_loop_start(1,   x_nnod,x_inod)
          j_3 = eigen_loop_end  (i-iblk, x_nnod,x_inod)
          i_4=MOD(i_3-i_2+1,4)+i_2
*
!$OMP MASTER
          ds = eigen_get_wtime()
          nodes(0) = eigen_owner_node(i, y_nnod, y_inod)
          if ( nodes(0) == y_inod ) then
             i_1 = eigen_translate_g2l(i, y_nnod, y_inod)
             do j_1=j_2,j_3
                v1(j_1,1) = a(j_1,i_1)
             end do! j_1
          end if
          call bcast_dbl(v1(j_2,1), j_3-j_2+1, nodes(0), y_COMM_WORLD)

          de = eigen_get_wtime()
          dcom = dcom + (de - ds)
!$OMP END MASTER
*
!$OMP BARRIER
*
!$OMP MASTER
          call barrier( y_COMM_WORLD )
          call barrier( x_COMM_WORLD )
!$OMP END MASTER
!$    if ( omp_get_num_threads() == 1 .OR.
!$   +     omp_get_thread_num() == 1 ) then
          if ( i_4 == i_2 + 1 ) then
             i_1 = i_2
             s0=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v1(j_1,1)*z(j_1,i_1+0)
             end do! j_1
             ss1(i_1+0)=s0
          end if
          if ( i_4 == i_2 + 2 ) then
             i_1 = i_2
             s0=0.0D+00
             s1=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v1(j_1,1)*z(j_1,i_1+0)
                s1=s1+v1(j_1,1)*z(j_1,i_1+1)
             end do! j_1
             ss1(i_1+0)=s0
             ss1(i_1+1)=s1
          end if
          if ( i_4 == i_2 + 3 ) then
             i_1 = i_2
             s0=0.0D+00
             s1=0.0D+00
             s2=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v1(j_1,1)*z(j_1,i_1+0)
                s1=s1+v1(j_1,1)*z(j_1,i_1+1)
                s2=s2+v1(j_1,1)*z(j_1,i_1+2)
             end do! j_1
             ss1(i_1+0)=s0
             ss1(i_1+1)=s1
             ss1(i_1+2)=s2
          end if
!$        end if
!$OMP DO SCHEDULE(DYNAMIC)
          do i_1=i_4,i_3,4
             s0=0.0D+00
             s1=0.0D+00
             s2=0.0D+00
             s3=0.0D+00
             do j_1=j_2,j_3
                s0=s0+v1(j_1,1)*z(j_1,i_1+0)
                s1=s1+v1(j_1,1)*z(j_1,i_1+1)
                s2=s2+v1(j_1,1)*z(j_1,i_1+2)
                s3=s3+v1(j_1,1)*z(j_1,i_1+3)
             end do! j_1
             ss1(i_1+0)=s0
             ss1(i_1+1)=s1
             ss1(i_1+2)=s2
             ss1(i_1+3)=s3
          end do! i_1
!$OMP END DO
*
!$OMP BARRIER
*
!$OMP MASTER
          ds = eigen_get_wtime()
          call reduce_dbl(ss1(i_2),tt, i_3-i_2+1, 1, x_COMM_WORLD)
          de = eigen_get_wtime()
          dcom = dcom + (de - ds)

          s0 = d(i)
          do i_1=i_2,i_3
             ss1(i_1) = ss1(i_1) * s0
          end do! i_1
!$OMP END MASTER

!$OMP BARRIER

          j_2 = eigen_loop_start(1,      x_nnod,x_inod)
          j_3 = eigen_loop_end  (i-iblk, x_nnod,x_inod)
          i_4=MOD(i_3-i_2+1,4)+i_2

!$OMP MASTER
          if ( i_4 == i_2 + 1 ) then
             i_1 = i_2
             s0 = ss1(i_1+0)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v1(j_1,1)
             end do! j_1
          end if
          if ( i_4 == i_2 + 2 ) then
             i_1 = i_2
             s0 = ss1(i_1+0)
             s1 = ss1(i_1+1)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v1(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v1(j_1,1)
             end do! j_1
          end if
          if ( i_4 == i_2 + 3 ) then
             i_1 = i_2
             s0 = ss1(i_1+0)
             s1 = ss1(i_1+1)
             s2 = ss1(i_1+2)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v1(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v1(j_1,1)
                z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v1(j_1,1)
             end do! j_1
          end if
!$OMP END MASTER
!$OMP DO
          do i_1=i_4,i_3,4
             s0 = ss1(i_1+0)
             s1 = ss1(i_1+1)
             s2 = ss1(i_1+2)
             s3 = ss1(i_1+3)
             do j_1=j_2,j_3
                z(j_1,i_1+0) = z(j_1,i_1+0) + s0 * v1(j_1,1)
                z(j_1,i_1+1) = z(j_1,i_1+1) + s1 * v1(j_1,1)
                z(j_1,i_1+2) = z(j_1,i_1+2) + s2 * v1(j_1,1)
                z(j_1,i_1+3) = z(j_1,i_1+3) + s3 * v1(j_1,1)
             end do! j_1
          end do! i_1
!$OMP ENDDO
*
!$OMP BARRIER
*
       end do
*
*----------------------------------------------------------------
*
       d2 = eigen_get_wtime()
       d0 = d2 -d1

#define	USE_BCASTW	1

       mode = 0; i = nx+1
*
!$OMP MASTER
          if ( nx+1 <= n ) then
             ds = eigen_get_wtime()
             call trbakwy_datacast(i_3, m, i, a(1,1), nma,
     $                          v1(1,1), nm, ss1(1),
#if !USE_BCASTW
     $                          wk(1),
#endif
     $                          iblk)
             de = eigen_get_wtime()
             dcom = dcom + (de - ds)
          end if
!$OMP END MASTER
!$OMP BARRIER
!$OMP MASTER
          if ( nx+1+m <= n ) then
             ds = eigen_get_wtime()
             call trbakwy_datacast(i_3, m, i+m, a(1,1), nma,
     $                          v2(1,1), nm, ss2(1),
#if !USE_BCASTW
     $                          wk(1),
#endif
     $                          iblk)
             de = eigen_get_wtime()
             dcom = dcom + (de - ds)
          end if
!$OMP END MASTER
*
       do i=nx+1, n, m
*
          if ( mode == 0 ) then
             call trbakwy_body2(i_3, z(1,1), nmz,
     $            d(1), e(1), v1(1,1), nm, m,
     $            i, ss1(1), tt, nss, iblk,
     $            dcom, dx, dy, dz)
          endif
          if ( mode == 1 ) then
             call trbakwy_body2(i_3, z(1,1), nmz,
     $            d(1), e(1), v2(1,1), nm, m,
     $            i, ss2(1), tt, nss, iblk,
     $            dcom, dx, dy, dz)
          endif
          if ( mode == 2 ) then
             call trbakwy_body2(i_3, z(1,1), nmz,
     $            d(1), e(1), v3(1,1), nm, m,
     $            i, ss3(1), tt, nss, iblk,
     $            dcom, dx, dy, dz)
          endif
*
!$OMP MASTER
          if ( i+2*m <= n ) then
          ds = eigen_get_wtime()
          if ( mode == 0 ) then
             call trbakwy_datacast(i_3, m, i+2*m, a(1,1), nma,
     $                             v3(1,1), nm, ss3(1),
#if !USE_BCASTW
     $                             wk(1),
#endif
     $                             iblk)
          end if
          if ( mode == 1 ) then
             call trbakwy_datacast(i_3, m, i+2*m, a(1,1), nma,
     $                             v1(1,1), nm, ss1(1),
#if !USE_BCASTW
     $                             wk(1),
#endif
     $                             iblk)
          end if
          if ( mode == 2 ) then
             call trbakwy_datacast(i_3, m, i+2*m, a(1,1), nma,
     $                             v2(1,1), nm, ss2(1),
#if !USE_BCASTW
     $                             wk(1),
#endif
     $                             iblk)
          end if
          de = eigen_get_wtime()
          dcom = dcom + (de - ds)
          end if
!$OMP END MASTER
*
          mode = MOD( mode + 1, 3 )
*
       end do
*
*----------------------------------------------------------------
*
!$     if ( omp_get_num_threads() > 1 ) then
!$OMP BARRIER
!$        if ( omp_get_thread_num() == 1 ) then
!$           ss1(1) = dx; ss1(2) = dy
!$        endif
!$OMP BARRIER
!$        if ( omp_get_thread_num() == 0 ) then
!$           dx = ss1(1); dy = ss1(2)
!$        endif
!$     endif
!$OMP BARRIER
*
#if AT_BCAST_OVERLAP
!===
!$OMP MASTER
!$     call omp_destroy_lock( TRBK_LOCK(1) )
!$OMP END MASTER
!===
#endif
!$OMP MASTER
       call MPI_Barrier(TRD_COMM_WORLD,ierr)
!$OMP END MASTER
!$OMP BARRIER
!$OMP MASTER
       deallocate(wk)

#if TIMER_PRINT
       d2 = eigen_get_wtime()

       if ( 1 == TRD_inod ) then
          print*,"TRBAK=",(d2-d1)
          print*,"COMM=",dcom
          print*,"   ",d2-d1,(2d0*nvec*n*n)/(d2-d1)*1d-9,"GFLOPS"
          print*,"   ",dx,(1d0*nvec*n*n)/(dx)*1d-9,"GFLOPS"
          print*,"   ",dy,(1d0*nvec*n*n)/(dy)*1d-9,"GFLOPS"
          print*,"   ",d0,dz
       end if
#endif
!$OMP END MASTER
*
        d0=USE_BCASTW
*
       return

       end subroutine

       subroutine trbakwy_datacast(i_3, m, i, a, nma, v, nm,
     $                             ss,
#if !USE_BCASTW
     $                             wk,
#endif
     $                             iblk)
!$     use OMP_LIB
       use MPI
       use eigen_devel
       use eigen_libs
       use eigen_TRBAK
       implicit NONE

       integer, intent(in)   :: i_3, m, i, nma, nm, iblk
       real(8), intent(in)   :: a(nma,*)
       real(8), intent(out)  :: ss(*)
#if !USE_BCASTW
       real(8), intent(out)  :: wk(*)
#endif
       real(8), intent(out)  :: v(nm,*)

       integer :: j, iy, k0
       integer :: i_1
       integer :: j_1, j_2, j_3, j_4, j_5
       integer :: nodes(0:nsm-1)

!$     real(8) :: ds, de
       real(8) :: du1,du2
       integer :: req(2), IERR

*
!$      ds = omp_get_wtime()

        ss(1:i_3*m+ns0) = 0.0D+0

        du1=USE_BCASTW
#if USE_BCASTW
        j_3 = MIN(eigen_loop_end (i+m-1-iblk, x_nnod, x_inod), nm)
!-
      if ( MOD( m, y_nnod ) == 0 ) then
!-
        do j=0,m-1
           if ( y_inod == eigen_owner_node(i+j, y_nnod, y_inod) ) then
              iy  = eigen_owner_node(i+j, y_nnod, y_inod)
              i_1 = eigen_translate_g2l(i+j, y_nnod, iy)
              k0  = (j/y_nnod)*j_3
              v(1+k0:j_3+k0, 1) = a(1:j_3, i_1)
           end if
        end do

        k0  = (m/y_nnod)*j_3
        call allgather_dbl(v, TRBK_buf, k0, y_COMM_WORLD)

        do j=0,m-1
           iy = eigen_owner_node(i+j, y_nnod, y_inod)
           k0 = ((iy-1)*(m/y_nnod)+(j/y_nnod))*j_3
           v(1:j_3, j+1) = TRBK_buf(1+k0:j_3+k0)
           j_2 = eigen_loop_start(i+j,  x_nnod,x_inod)
           if ( j_2 <= j_3 ) v(j_2:j_3, j+1) = 0D0
        end do
!-
      else
!-
        do j=0,m-1
           if ( y_inod == eigen_owner_node(i+j, y_nnod, y_inod) ) then
              iy  = eigen_owner_node(i+j, y_nnod, y_inod)
              i_1 = eigen_translate_g2l(i+j, y_nnod, iy)
              v(1:j_3, j+1) = a(1:j_3, i_1)
              j_2 = eigen_loop_start(i+j,  x_nnod,x_inod)
              if ( j_2 <= j_3 ) v(j_2:j_3, j+1) = 0D0
           end if
        end do
        do j=0,m-1,y_nnod
           iy  = eigen_owner_node(i+j, y_nnod, y_inod)
           k0  = MIN(m-j, y_nnod)
           call bcastw_dbl(v(1,j+1), j_3, iy,
     &                     nm, k0, TRBK_buf, y_COMM_WORLD)
        end do
!-
      end if
#else
!-
        IF ( m > y_nnod .AND. y_nnod > 1 ) THEN

          do j=0,m-1
             nodes(j) = eigen_owner_node(i+j, y_nnod, y_inod)
          enddo

          do iy=1,y_nnod

                j_2 = eigen_loop_start(1,    x_nnod,x_inod)
                j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
                i_1 = eigen_translate_g2l(i+j, y_nnod, iy)
!                j_2 = eigen_loop_start(1,    x_nnod,x_inod)
!                j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
                if ( y_inod == iy ) then
                   do j_1=j_2,j_3
                      wk(k0+j_1) = a(j_1, i_1)
                   end do! k
                endif
                k0=k0+(j_3-j_2+1)
             endif
             enddo

             call bcast_dbl(wk, k0, iy, y_COMM_WORLD)

             k0=0
             do j=0,m-1
             if ( nodes(j) == iy ) then
!                i_1 = eigen_translate_g2l(i+j, y_nnod, iy)
!                j_2 = eigen_loop_start(1,    x_nnod,x_inod)
!                j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1, j+1) = wk(k0+j_1)
                end do! k
                k0=k0+(j_3-j_2+1)
             endif
             enddo

             do j=0,m-1
             if ( nodes(j) == iy ) then
                j_4 = eigen_loop_start(i+j,  x_nnod,x_inod)
                j_5 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
!OCL XFILL
                do j_1=j_4,j_5
                   v(j_1, j+1) = 0.0D+00
                end do
             endif
             enddo

          enddo

        ELSE

          do j=0,m-1
             nodes(j) = eigen_owner_node(i+j, y_nnod, y_inod)
             if ( nodes(j) == y_inod ) then
                i_1 = eigen_translate_g2l(i+j, y_nnod, y_inod)
                j_2 = eigen_loop_start(1,    x_nnod,x_inod)
                j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
                do j_1=j_2,j_3
                   v(j_1, j+1) = a(j_1, i_1)
                end do! k
                j_2 = eigen_loop_start(i+j,  x_nnod,x_inod)
                j_3 = eigen_loop_end  (i+m-1-iblk,x_nnod,x_inod)
!CDIR NOVECTOR
                do j_1=j_2,j_3
                   v(j_1, j+1) = 0.0D+00
                end do
             end if
          end do
          j_2 = eigen_loop_start(1,     x_nnod,x_inod)
          j_3 = eigen_loop_end  (i+m-1-iblk, x_nnod,x_inod)
          do j=0,m-1
             call bcast_dbl(v(1,j+1), j_3-j_2+1,
     &                      nodes(j), y_COMM_WORLD)
          enddo

        ENDIF
!-
#endif

#if 1
        j_3 = eigen_loop_end  (i+m-1-iblk, x_nnod,x_inod)
        call barrier( y_COMM_WORLD )
        call barrier( x_COMM_WORLD )
#endif

!$      de = omp_get_wtime()
!$      TRBK_TIME_BCAST = de - ds
*
       return
       end subroutine

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 633 $)
!
!  MODULE: m_Electronic_Structure
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!
!  FURTHER MODIFICATION: T. Yamasaki, January/13/2004, April/15/2006, September/02/2008
!  FURTHER MODIFICATION: T. Yamasaki, T. Uda and T. Ohno, September 2009 (MGS_DGEMM)
!  FURTHER MODIFICATION: T. Yamasaki and T. Yamamoto,   October 2009  (NONLOCAL_DGEMM)
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!

!   This module has been revised for the GAMMA point (k=(0,0,0)) by T. Yamasaki
!  in April 2006. Number of operations for the Gamma point have been tremendously
!  reduced in subroutines of m_ES_betar_dot_Wfs, m_ES_Vnonlocal_W, and
!  m_ES_modified_gram_schmidt.
!
#ifdef __TIMER_SUB__
#   define __TIMER_SUB_START(a)  call timer_sta(a)
#   define __TIMER_SUB_STOP(a)   call timer_end(a)
#else
#   define __TIMER_SUB_START(a)
#   define __TIMER_SUB_STOP(a)
#endif
#ifdef __TIMER_DO__
#   define __TIMER_DO_START(a)   call timer_sta(a)
#   define __TIMER_DO_STOP(a)    call timer_end(a)
#else
#   define __TIMER_DO_START(a)
#   define __TIMER_DO_STOP(a)
#endif
#ifdef __TIMER_COMM__
#   define __TIMER_COMM_START_w_BARRIER(str,a)   call timer_barrier(str) ;   call timer_sta(a)
#   define __TIMER_COMM_START(a)       call timer_sta(a)
#   define __TIMER_COMM_STOP(a)        call timer_end(a)
#else
#   define __TIMER_COMM_START_w_BARRIER(str,a)
#   define __TIMER_COMM_START(a)
#   define __TIMER_COMM_STOP(a)
#endif

module m_Electronic_Structure
! $Id: m_Electronic_Structure.F90 633 2020-12-01 05:11:03Z jkoga $
  use m_IterationNumbers,   only : iteration_electronic, nk_in_the_process, nkgroup, iteration
!!!!!BRANCH_P ORG_Parallel
! === DEBUG for icond=2,3 & one_by_one by tkato 2014/01/24 =====================
  use m_IterationNumbers,   only : first_kpoint_in_this_job
! ==============================================================================
!!!!!BRANCH_P_END ORG_Parallel
  use m_NonLocal_Potential, only : snl,norm_phig
  use m_PlaneWaveBasisSet,  only : igf,kg1,kg,kgp,nbase,nbmx,iba &
       &                         , nbase_gamma,kg1_prev, iba_prev &
       &                         , nbase_prev, nbase_gamma_prev, igf_prev
  use m_PlaneWaveBasisSet,   only : m_pwBS_kinetic_energies
  use m_PseudoPotential,    only : ival,ilmt,nlmt,nlmtt,nlmta,lmta,lmtt,ltp,mtp,q,dion &
       &                         , ilmt_phi,nlmt_phi,nlmtt_phi,nlmta_phi &
       &                         , lmta_phi,lmtt_phi,ltp_phi,mtp_phi,taup_phi &
       &                         , iproj_phi, nlmta_add, nac_p &
       &                         , modnrm,nac,fqwei,nlmta1,nlmta2 &
       &                         , porb, qorb, m_PP_tell_iorb_lmtt &
       &                         , nrorb, irorb, crorb &
       &                         , ipaw, dion_paw
  use m_Crystal_Structure,  only : op, nopr, nlpnt, additional_charge, altv_refcell
  use m_Kpoints,            only : kv3,vkxyz, kv3_ek,vkxyz_ek,k_symmetry, vkxyz_refcell
  use m_Ionic_System,       only : ntyp,iatom, natm, iwei, ityp, pos, cps, qex &
       &                         , if_pdos, speciesname, iproj_group
  use m_FFT,                only : nfft &
       &                         , m_FFT_alloc_WF_work &
       &                         , m_FFT_dealloc_WF_work &
       &                         , fft_box_size_WF, fft_box_size_WF_prev
  use m_FFT,                only : m_FFT_WF, m_FFT_W_Vlocal_W
  use m_Files,              only : nfout
  use m_Timing,             only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters, only : nspin,ipri, iprievdff, iprieigenvalue, ipribetar &
       &                         , kimg, neg, meg, neg_previous, num_extra_bands, printable &
       &                         , af, ekmode, delta_eigenvalue, evaluation_eko_diff &
       &                         , delta_eigenvalue_conduction, delta_eigenvalue_cond_is_given &
       &                         , m_CtrlP_ntcnvg_incre &
       &                         , m_CtrlP_ntcnvg_clear &
       &                         , m_CtrlP_ntcnvg_reset &
       &                         , m_CtrlP_cachesize &
       &                         , m_CntrlP_set_neg, m_CntrlP_set_meg &
       &                         , sw_orb_popu, sw_use_add_proj, sw_rsb &
       &                         , sw_serial_fft &
       &                         , sw_modified_kpoint_increment &
#ifdef SAVE_FFT_TIMES
       &                         , sw_save_fft &
#endif
       &                         , sw_hybrid_functional &
       &                         , sw_interpolate_wfs &
#ifndef ENABLE_ESM_PACK
       &                         , nblocksize_mgs, nblocksize_mgs_is_given
#else
       &                         , nblocksize_mgs, nblocksize_mgs_is_given, esm_qbac
#endif
  use m_Const_Parameters,   only : DP, CMPLDP, SKIP, EXECUT, ON, OFF, INVERSE, DELTA, PAI2 &
       &                         , DELTAevdff, BUCS, SCF, EK, CARTS, DIRECT &
       &                         , ELECTRON, GAMMA, EK_CONVERGED, STORED_AND_NEW, OLD
  use m_Parallelization,    only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype &
       &                         , np_kngp, mp_kngp, nel_kngp, myrank_g & 
       &                         , nrank_e,myrank_e,map_e,ista_e,iend_e,istep_e,idisp_e &
       &                         , map_z,np_e,mpi_k_world,myrank_k,map_k,ista_k,iend_k &
       &                         , ista_atm, iend_atm &
       &                         , ierr,mp_e,nel_e &
       &                         , ista_g1k,iend_g1k,np_g1k,mp_g1k &
       &                         , np_fs, mp_fs,  nel_fs, nrank_k, nis_kv3_ek
! ============================== added by K. Tagami ========== 11.0
  use m_Control_Parameters,    only : noncol, ndim_spinor, ndim_chgpot, ndim_magmom, &
       &                              SpinOrbit_mode, sw_hubbard, sw_band_unfolding
  use m_Const_Parameters,     only : BuiltIn, Neglected

  use m_PseudoPotential,      only : dion_scr_noncl, fqwei_noncl
  use m_FFT,  only : m_FFT_W_Vlocal_W_noncl
  use m_ES_NonCollinear,      only : m_ES_MagMom_to_DensMat_Gspace, &
       &                            m_ES_MagMom_to_DensMat_vlhxcl, &
       &                             m_ES_DensMat_To_MagMom_dm, &
       &                             m_ES_DensMat_To_MagMom_porb
! ============================================================ 11.0

! ============================== added by K. Tagami ========== 12.0Exp
  use m_Control_Parameters,    only :   fixed_charge_k_parallel, sw_band_unfolding
  use m_Const_Parameters,      only :   ONE_BY_ONE
! ============================== added by K. Tagami ========== 12.0Exp

! ========== KT_add ======= 13.0U2
  use m_Control_Parameters, only : sw_potential_mixing, sw_mix_charge_hardpart, &
       &                           sw_modified_TFW_functional
  use m_PseudoPotential,    only : flg_paw, nloc
! ========================= 13.0U2

! === KT_add ==== 2015/02/21
  use m_Ionic_System,  only : ionic_charge_atomtyp, ionic_charge_atoms, &
       &                      mag_moment0_atoms_is_defined
! =============== 2015/02/21

  implicit none

  real(kind=DP),allocatable, dimension(:,:,:,:):: zaj_l   ! d(kg1,np_e,ista_k:iend_k,kimg) wave functions
  real(kind=DP),allocatable, dimension(:,:,:,:):: zaj_l_buf   ! d(kg1,np_e,ista_k:iend_k,kimg) wave functions
  real(kind=DP),allocatable, dimension(:,:,:,:):: zaj_l_prev
#ifdef SAVE_FFT_TIMES
  real(kind=DP),allocatable, dimension(:,:,:)  :: Phifftr_l 
  !                                      d(nfft,np_e,ista_k:iend_k) or d(lsize,np_e,ista_k:iend_k)
  integer, allocatable, dimension(:,:) :: status_saved_phifftr ! d(np_e,ista_k:iend_k) 0: nothing or old, 1: stored and new
#endif
!!$  integer,      allocatable, dimension(:)     :: symmetric_or_antisymmetric
!!$                               !d(np_e), this is allocated when kimg == 1 and the system is symmetric
!!$  real(kind=DP),allocatable, dimension(:,:)   :: zaj_gamma_neg
!!$                               !d(kg1,np_e), zaj -G part for Gamma points when kimg = 1 and the system is symmetric
  integer,      allocatable, dimension(:,:)   :: neordr, nrvf_ordr !d(neg,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:)   :: eko_l             !d(np_e,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:)   :: eko_ek            !d(neg,kv3_ek)
  integer,  allocatable, dimension(:)         :: iconv_ek          !d(kv3_ek)
  real(kind=DP),allocatable, dimension(:,:)   :: occup_l           !d(np_e,ista_k:iend_k)
  real(kind=DP)                               :: efermi, efermi_spin(2), vbm = -9.99d10
  logical ::                                     metalic_system = .false.
  logical ::                                     check_if_metalic_flag = .false.
  real(kind=DP)                               :: totch
  real(kind=DP)                               :: band_entropy = 0.d0

  real(kind=DP),allocatable, dimension(:,:,:) :: fsr_l,fsi_l!d(np_e,nlmta,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:,:) :: fsr_add_l,fsi_add_l!d(np_e,nlmta_add,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:,:,:) :: compr_l,compi_l!d(np_e,nlmta_phi,nopr,ista_k:iend_k)
  real(kind=DP),allocatable, dimension(:,:,:,:) :: compr_l_ek,compi_l_ek!d(np_e,nlmta_phi,nopr,ista_k:iend_k)

! ====== KT_mod ======== 13.0U2
!  real(kind=DP), allocatable, dimension(:,:,:) :: vlhxc_l !d(ista_kngp:iend_kngp,kimg,nspin)
  real(kind=DP), target, allocatable, dimension(:,:,:) :: vlhxc_l
                                               !d(ista_kngp:iend_kngp,kimg,nspin)
! ====================== 13.0U2
! ===== KT_add ========= 13.0U2
  real(kind=DP), target, allocatable, dimension(:,:,:) :: vlhxc_l_old
! ====================== 13.0U2

! =========================================== added by K. Tagami ============ 11.0
  real(kind=DP), allocatable, dimension(:,:,:) :: vlhxc_ssrep 
                                     !d(ista_kngp:iend_kngp,kimg,ndim_chgpot)
  real(kind=DP), allocatable, dimension(:,:,:,:):: dhub_aimag
! =========================================================================== 11.0

  real(kind=DP), allocatable, dimension(:,:,:,:):: vlhxcQ  !d(nlmt,nlmt,natm,nspin) 
! ===== KT_add ========= 13.0U2
  real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_old
! ====================== 13.0U2

  real(kind=DP), allocatable, dimension(:,:,:,:):: dhub  !d(nlmt,nlmt,natm,nspin) 
  real(kind=DP), allocatable, dimension(:,:,:) :: vnlph_l  !d(kg1,np_e,kimg) work array

  real(kind=DP),private,allocatable,dimension(:,:) :: eko1_l  !d(np_e,ista_k:iend_k)
  real(kind=DP),private,allocatable,dimension(:)   :: evdff   !d(3)
  real(kind=DP),private,allocatable,dimension(:)   :: evdffr  !d(3)
  ! evdff(1) : dsqrt((sum((e_old - e_new)**2))/(sum))
  ! evdff(2) : (1/sum)sum(dabs(e_old - e_new))
  ! evdff(3) : (1/sum)sum(dsqrt(dabs(e_old**2 - e_new**2)))

  integer,private                                     :: NB
#ifdef SX
  integer,        parameter                           :: nblocksize_mgs_default = 200
#else
!f  integer,        parameter                           :: nblocksize_mgs_default = 8
  integer,        parameter                           :: nblocksize_mgs_default = 8
#endif

  real(kind=DP),private,allocatable,dimension(:)      :: ar, ai

  real(kind=DP),        allocatable, dimension(:)     :: afft, bfft
  integer, private, parameter                         :: sw_timing_2ndlevel = ON

#ifndef NO_NONLOCAL_DGEMM
  logical :: DGEMM_DEBUG = .false.
#endif

  complex(kind=CMPLDP), allocatable, dimension(:) :: vloc_esm

  logical                   :: firstcall = .true.
  integer, allocatable,  dimension(:)   :: fftscnt0, fftrcnt0, fftindex0, fftdist0
  integer, allocatable,  dimension(:,:) :: fftsend0, fftrecv0
  integer :: fftmaxrecv0, fftmaxsend0

!  1-1.  m_ES_alloc_zaj_etc
!  1-2.  m_ES_alloc_eko1
!  1-3.  m_ES_alloc_eko_ek
!  1-4.  m_ES_alloc_vlhxc
!  1-5.  m_ES_dealloc_vlhxc
!  1-6.  m_ES_alloc_vlhxcQ
!  1-7.  m_ES_dealloc_vlhxcQ
!  1-8.  m_ES_alloc_Dhub
!  1-9.  m_ES_dealloc_Dhub
!  1-10. m_ES_alloc_scss_etc
!  1-11. m_ES_dealloc_scss_etc
!  1-12. m_ES_alloc_fft_related
!  1-13. m_ES_dealloc_fft_related
!  1-14. m_ES_alloc_afft_scss_etc
!  1-15. m_ES_dealloc_afft_scss_etc
!  1-16. alloc_zfsincos_mpi
!  1-17. dealloc_zfsincos_mpi
!  1-18. m_ES_mgs_alloc
!        - mgs_vdb_alloc, - mgs_nrc_alloc
!  1-19. m_ES_mgs_dealloc
!        - mgs_vdb_dealloc, - mgs_nrc_dealloc
!  1-20. m_ES_alloc_zfsincos
!  1-21. m_ES_dealloc_zfsincos
!  1-22. m_ES_alloc_arai
!  1-23. m_ES_dealloc_arai
!  2-1.  m_ES_gtotch
!  2-2.  m_ES_wd_zaj_small_portion
!  2-3.  m_ES_decide_precon_factor
!  2-4.  kinetic_energy               <- (2-3)
!  2-5.  m_ES_Vnonlocal_W
!        - calc_phase_mpi, - Vnonlocal_W_part_sum_over_lmt1
!        - add_vnlph_l_with_eko_part, - add_vnlph_l_without_eko_part
!  2-6.  m_ES_sort_eigen_values
!        - cp_eigen_values_for_af, - expand_neordr_and_nrvf_ordr
!        - heap_sorting
!  2-7.  m_ES_energy_eigen_values
!        - get_ipri0
!  2-8.  m_ES_energy_eigen_values_ext
!        - get_ipri0
!  2-9.  m_ES_eigen_values_for_each_k
!        - W_T_W, - W_Vnonlocal_W
!  2-10. m_ES_eigen_values_for_each_kex
!        - W_T_W, - W_Vnonlocal_W
!  2-11. m_ES_Vlocal_in_Rspace
!        - map_vlhxc_l_onto_afft
!  2-12. m_ES_WF_in_Rspace
!  2-13. G_dot_R_mpi                  <- (2-14), (2-20), (2-23), (2-26)
!  2-14. m_ES_betar_dot_WFs           -> (2-15), (2-16)
!  2-15. wd_fsr_fsi                   <- (2-14), (2-17)
!  2-16. G_dot_R_map                  <- (2-14), (2-17), (2-18), (2-20), (2-23), (2-26)
!  2-17. m_ES_betar_dot_WFs_4_each_k  -> (2-15), (2-16)
!  2-18. m_ES_betar_dot_Psi_4_each_k  -> (2-16)
!  2-19. m_ES_betar_dot_WFs_4_lmta_k
!       - G_dot_R_mult_snl, - betar_dot_WFs_core, - multiple_i_l
!       - betar_dot_WFs_core2
!  2-20. m_ES_phir_dot_WFs            -> (2-13), (2-16)
!  2-21. wd_compr_compi
!  2-22. m_ES_phir_dot_WFs_4_lmta_k
!       - G_dot_R_mult_phig, - phir_dot_WFs_core, - multiple_i_l, - phir_dot_WFs_core2
!  2-23. m_ES_add_betar_dot_WFs       -> (2-13), (2-16), (2-24)
!  2-24. wd_fsr_fsi_add               <- (2-23)
!  2-25. m_ES_add_betar_dot_WFs_4_lmta_k
!        - G_dot_R_mult_snl, - betar_dot_WFs_core, - multiple_i_l, - betar_dot_WFs_core2
!  2-26. m_ES_PAO_WFs                 -> (2-13), (2-16)
!  2-27. m_ES_PAO_WFs_4_lmta_k
!        - G_dot_R_mult_paog
!  2-28. m_ES_modified_gram_schmidt
!  2-29. m_ES_orthogonalize_SD_to_WFs -> (2-30)
!  2-30. mgs_sd2wf_each_k_G           <- (2-29)  -> (2-34), (2-44)
!        - broadcast_fs, - Psi1SPhi2_t, - modify_bsd_and_phi_t, - alloc_phi_w_and_brd_w
!        - dealloc_phi_w_and_brd_w, - WSW, - normalize_bsd_and_phi, - Psi1SPhi2
!        - modify_bsd_and_phi
!  2-31. orthogonalize_SD             -> (2-33)
!  2-32. m_ES_MGS_4_each_k            -> (2-17), (2-33)
!        - wd_title_of_the_operation
!  2-33. mgs_4_each_k_G               <- (2-31), (2-32)  -> (2-34), (2-44)
!        - WSW_t, - normalize_bp_and_psi_t, - W1SW2_t_r
!        - modify_bp_and_psi_t_r, - substitute_jto_ib2back, - W1SW2_t
!        - modify_bp_and_psi_t, - alloc_and_brd_w, - dealloc_and_brd_w
!        - WSW, - normalize_bp_and_psi, - W1SW2, - modify_bp_and_psi
!  2-34. set_npzri                    <- (2-30), (2-33)
!  2-35. m_ES_W_transpose
!  2-36. m_ES_W_transpose_back
!  2-37. m_ES_W_transpose_back2
!  2-38. m_ES_W_transpose_r
!  2-39. m_ES_W_transpose_back_r
!  2-40. m_ES_F_transpose
!  2-41. m_ES_F_transpose_back
!  2-42. m_ES_F_transpose_r
!  2-43. m_ES_F_transpose_back_r
!  2-44. cp_bp_and_psi_2_brd_w2      <- (2-30), (2-33)
!  2-45. m_ES_wd_eko
!  2-46. m_ES_wd_eko_cond
!  2-47. m_ES_wd_eko2
!  2-48. m_ES_sum_of_LocalPart
!  2-48. m_ES_sum_of_LocalPart2
!  2-49. m_ES_cpeko
!  2-50. logical fnct. m_ES_eekdif
!        - get_ipri0
!  2-51. logical fnct. m_ES_eekdif_cond
!  2-52. m_ES_cp_eko_l_to_eko_ek
!  2-53. real(DP) fnct. m_ES_what_is_evdff_now
!  2-54. real(kind=DP) fnct. m_ES_get_energy
!  2-55. m_ES_orbital_population
!  2-56. m_ES_sym_comp
!  2-57. m_ES_orbital_den_mat
!  2-58. m_ES_set_num_bands_super
!

  include 'mpif.h'                                      ! MPI
  integer istatus(mpi_status_size)                      ! MPI

  interface m_ES_WF_in_Rspace
    module procedure m_ES_WF_in_Rspace0
    module procedure m_ES_WF_in_Rspace1
  end interface m_ES_WF_in_Rspace

contains


  subroutine m_ES_realloc_zaj()
    if(allocated(zaj_l)) deallocate(zaj_l)
    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg));zaj_l = 0.d0
  end subroutine m_ES_realloc_zaj

  subroutine m_ES_alloc_zaj_etc()
    integer :: ik,ib
#ifdef SAVE_FFT_TIMES
    integer :: lsize
#endif
    if(iend_k - ista_k < 0) stop ' iend_k - ista_k < 0 (in m_ES_alloc_zaj_etc)'
    if(nlmta <= 0) stop ' nlmta <= 0 (in m_ES_alloc_zaj_etc)'
     allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
     if(sw_rsb==ON) allocate(zaj_l_buf(kg1,np_e,ista_k:iend_k,kimg))
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       allocate(Phifftr_l(nfft,np_e,ista_k:iend_k)); Phifftr_l = 0.d0
       allocate(status_saved_phifftr(np_e,ista_k:iend_k)); status_saved_phifftr = 0
    end if
#endif
    allocate(neordr(neg,ista_k:iend_k))
    allocate(nrvf_ordr(neg,ista_k:iend_k))
    do ik = ista_k, iend_k
       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)
       nrvf_ordr(1:neg,ik) = (/(ib,ib=1,neg)/)
    end do
    allocate(eko_l(np_e,ista_k:iend_k)); eko_l = 0.d0
    allocate(occup_l(np_e,ista_k:iend_k)); occup_l = 0.d0
    allocate(fsr_l(np_e,nlmta,ista_k:iend_k))
    if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
       allocate(fsi_l(np_e,nlmta,ista_k:iend_k)); fsi_l = 0.d0
!!$ASASASAS
!!$    end if
    else
       allocate(fsi_l(1,1,1))
    end if
    fsi_l = 0.d0
!!$ASASASAS
    allocate(vnlph_l(kg1,np_e,kimg))
    ! -- for PDOS
    if(sw_orb_popu == ON) then
       allocate(compr_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       compr_l=0.d0         !ASMS 2016/09/08

       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(compi_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
!!$ASASASAS
!!%       end if
       else
          allocate(compi_l(1,1,1,1))
       end if
       compi_l = 0.d0
!!$ASASASAS
       if(ekmode == ON) then
          allocate(compr_l_ek(np_e,nlmta_phi,nopr,kv3_ek))
          if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
             allocate(compi_l_ek(np_e,nlmta_phi,nopr,kv3_ek))
          else
             allocate(compi_l_ek(1,1,1,1))
          end if
       endif
    end if
    if(sw_use_add_proj == ON) then
       allocate(fsr_add_l(np_e,nlmta_add,ista_k:iend_k))
       if(.not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate(fsi_add_l(np_e,nlmta_add,ista_k:iend_k))
       end if
    end if

  end subroutine m_ES_alloc_zaj_etc

! ======================================= added by K. Tagami =============== 11.0
  subroutine m_ES_alloc_zaj_etc_noncl()
    integer :: ik,ib
    if(iend_k - ista_k < 0) stop ' iend_k - ista_k < 0 (in m_ES_alloc_zaj_etc_noncl)'
    if(nlmta <= 0) stop ' nlmta <= 0 (in m_ES_alloc_zaj_etc_noncl)'
    allocate(zaj_l(kg1,np_e,ista_k:iend_k,kimg))
    if(sw_rsb==ON) allocate(zaj_l_buf(kg1,np_e,ista_k:iend_k,kimg))
    allocate(neordr(neg,ista_k:iend_k))
    allocate(nrvf_ordr(neg,ista_k:iend_k))
    do ik = ista_k, iend_k
       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)
       nrvf_ordr(1:neg,ik) = (/(ib,ib=1,neg)/)
    end do
    allocate(eko_l(np_e,ista_k:iend_k)); eko_l = 0.d0
    allocate(occup_l(np_e,ista_k:iend_k)); occup_l = 0.d0
    allocate(fsr_l(np_e,nlmta,ista_k:iend_k)); fsr_l = 0.0d0
    allocate(fsi_l(np_e,nlmta,ista_k:iend_k));  fsi_l = 0.d0

    allocate(vnlph_l(kg1,np_e,kimg)); vnlph_l = 0.0d0
    ! -- for PDOS
    if(sw_orb_popu == ON) then
       allocate(compr_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       allocate(compi_l(np_e,nlmta_phi,nopr,ista_k:iend_k))
       compr_l = 0.d0; compi_l = 0.0d0
    end if
!
    if(sw_use_add_proj == ON) then
       allocate(fsr_add_l(np_e,nlmta_add,ista_k:iend_k))
       allocate(fsi_add_l(np_e,nlmta_add,ista_k:iend_k))
       fsr_add_l = 0.0d0; fsi_add_l = 0.0d0
    end if

  end subroutine m_ES_alloc_zaj_etc_noncl
! =======================================================================-11.0

  subroutine m_ES_alloc_eko1()
    allocate(eko1_l(np_e,ista_k:iend_k)); eko1_l = 0.d0
    allocate(evdff(3));evdff=1.d99
    allocate(evdffr(3))
  end subroutine m_ES_alloc_eko1

  subroutine m_ES_alloc_eko_ek()
    if ( allocated( eko_ek ) ) deallocate( eko_ek )
    allocate(eko_ek(neg,kv3_ek)); eko_ek = 0.0d0

    if(.not.allocated(iconv_ek)) then
       allocate(iconv_ek(kv3_ek)); iconv_ek = 0
    end if
  end subroutine m_ES_alloc_eko_ek


  subroutine m_ES_cp_iconv(numk,iconv_ek_tmp)
    integer, intent(in) :: numk
    integer, intent(in), dimension(numk) :: iconv_ek_tmp
    integer :: i
    if(numk>=1) then
       if(.not.allocated(iconv_ek)) then
          allocate(iconv_ek(kv3_ek))
          iconv_ek = 0
       end if
       do i = 1, numk
          iconv_ek(i) = iconv_ek_tmp(i)
       end do
       if(ipri >= 1) then
          write(nfout,'(" ! -- iconv_ek -- <<m_ES_cp_iconv>>")')
          write(nfout,'(" ! ",8i6)') (iconv_ek(i),i=1,numk)
          write(nfout,'(" ! ",8i6)') (iconv_ek(i),i=numk+1,kv3_ek)
       end if
    end if
  end subroutine m_ES_cp_iconv

  subroutine m_ES_alloc_vlhxc()
! =================================== modified by K. Tagami ================ 11.0
!!    allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin)); vlhxc_l = 0.d0
!
    if ( noncol ) then
      allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,ndim_magmom))
    else 
      if(.not.allocated(vlhxc_l)) allocate(vlhxc_l(ista_kngp:iend_kngp,kimg,nspin))
    endif
    vlhxc_l = 0.d0
! ========================================================================== 11.0

! ====== KT_add ====== 13.0U2
    if ( sw_potential_mixing == ON .or. sw_modified_tfw_functional == ON ) then
      allocate(vlhxc_l_old(ista_kngp:iend_kngp,kimg,ndim_magmom))
      vlhxc_l_old = 0.0d0
   endif
! ==================== 13.0U2

  end subroutine m_ES_alloc_vlhxc

  subroutine m_ES_dealloc_vlhxc()
    if(allocated(vlhxc_l)) deallocate(vlhxc_l)

! ========== KT_add ========= 13.0U2
    if(allocated(vlhxc_l_old)) deallocate(vlhxc_l_old)
! =========================== 13.0U2

  end subroutine m_ES_dealloc_vlhxc

  subroutine m_ES_alloc_vlhxcQ()
    if(nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_vlhxcQ)'
! =================================== modified by K. Tagami ================ 11.0
!    allocate(vlhxcQ(nlmt,nlmt,natm,nspin)); vlhxcQ = 0.d0
!
    if ( noncol ) then
       allocate(vlhxcQ(nlmt,nlmt,natm,ndim_magmom))
    else 
       if(.not.allocated(vlhxcQ)) allocate(vlhxcQ(nlmt,nlmt,natm,nspin))
    endif
    vlhxcQ = 0.d0
! ========================================================================== 11.0

#if 0
! ====== KT_add ====== 13.0U2
    if ( sw_potential_mixing == ON ) then
       if ( flg_paw .or. sw_mix_charge_hardpart == ON ) then
          allocate(vlhxcQ_old(nlmt,nlmt,natm,nspin))
          vlhxcQ_old = 0.d0
       endif
   endif
! ==================== 13.0U2
#endif

  end subroutine m_ES_alloc_vlhxcQ

  subroutine m_ES_dealloc_vlhxcQ()
    if(allocated(vlhxcQ))  deallocate(vlhxcQ)
#if 0
! ======== KT_add ==== 13.0U2
    if(allocated(vlhxcQ_old))  deallocate(vlhxcQ_old)
! ==================== 13.0U2
#endif
  end subroutine m_ES_dealloc_vlhxcQ

! ====== KT_add =================== 13.0U2
  subroutine m_ES_cp_vlhxc_to_old
    vlhxc_l_old = vlhxc_l
    if ( flg_paw .or. sw_mix_charge_hardpart == ON) then
       vlhxcQ_old = vlhxcQ
#if 0
       if ( noncol ) vlhxcQ_i_old = vlhxcQ_i
#endif
    endif
  end subroutine m_ES_cp_vlhxc_to_old

  subroutine m_ES_cp_vlhxcQ_to_old
    if ( flg_paw .or. sw_mix_charge_hardpart == ON) then
       vlhxcQ_old = vlhxcQ
#if 0
       if ( noncol ) vlhxcQ_i_old = vlhxcQ_i
#endif
    endif
  end subroutine m_ES_cp_vlhxcQ_to_old
! ==================================== 13.0U2

  subroutine m_ES_wd_vlhxcQ()
    integer :: i, j, na
    write(nfout,'(" --- m_ES_wd_vlhxcQ ---")')
    do na = 1, natm
       write(nfout,'("  na = ", i8)') na
       do j = 1, nlmt
          write(nfout,'(" j = ", i8)') j
          write(nfout,'(8f10.4)') (vlhxcQ(i,j,na,1),i=1,nlmt)
       end do
    end do
  end subroutine m_ES_wd_vlhxcQ

  subroutine m_ES_alloc_Dhub()
    if(nlmt <= 0) stop ' nlmt <=  0 (in m_ES_alloc_Dhub)'
! ======================================== modified by K. Tagami ========= 11.0
!!    allocate(dhub(nlmt,nlmt,natm,nspin)); dhub = 0.d0
!
    if ( noncol ) then
       if(allocated(dhub)) deallocate(dhub)
       if(allocated(dhub_aimag)) deallocate(dhub_aimag)
       allocate(dhub(nlmt,nlmt,natm,ndim_magmom))
       allocate(dhub_aimag(nlmt,nlmt,natm,ndim_magmom))
       dhub = 0.d0; dhub_aimag = 0.0d0
    else
       if(allocated(dhub)) deallocate(dhub)
       allocate(dhub(nlmt,nlmt,natm,nspin))
       dhub = 0.d0
    endif
! =========================================================================11.0

  end subroutine m_ES_alloc_Dhub

  subroutine m_ES_dealloc_Dhub()
    if(allocated(dhub)) deallocate(dhub)
! ======================================== added by K. Tagami ========= 11.0
    if(allocated(dhub_aimag)) deallocate(dhub_aimag)
! ===================================================================== 11.0
  end subroutine m_ES_dealloc_Dhub

  subroutine m_ES_alloc_fft_related()
    allocate(afft(nfft))
    allocate(bfft(nfft))
    call m_FFT_alloc_WF_work() ! allocate(ftw)
  end subroutine m_ES_alloc_fft_related

  subroutine m_ES_dealloc_fft_related()
    call m_FFT_dealloc_WF_work()
    deallocate(bfft)
    deallocate(afft)
  end subroutine m_ES_dealloc_fft_related

  subroutine m_ES_gtotch(nfout)
    integer, intent(in) :: nfout
    integer :: it, ia

    totch = 0.d0
    do it = 1, ntyp
       totch = totch + ival(it)*iatom(it) + qex(it)
    end do
#ifdef ENABLE_ESM_PACK
    totch = totch - esm_qbac
#endif
! ===== KT_add === 2014/06/08
    totch = totch - additional_charge      ! totch is num. of electrons
! ================ 2014/06/08

! === KT_add === 2015/02/21
#ifdef INIT_CHARGE_ATOM_BY_ATOM
    if ( mag_moment0_atoms_is_defined ) then
       Do ia=1, natm
          totch = totch -ionic_charge_atoms(ia) *iwei(ia)
       End do
    else
       Do ia=1, natm
          it = ityp(ia)
          totch = totch -ionic_charge_atomtyp(it) *iwei(ia)
       end do
    endif
#else
    Do ia=1, natm
       it = ityp(ia)
       totch = totch -ionic_charge_atomtyp(it) *iwei(ia)
    end do
#endif
! ============ 2015/02/21

    if(printable) write(nfout,'(" TOTCH (total charge) = ",d25.12)') totch
    if(totch <= 1.d-20) stop ' ! illegal TOTCH value (m_ES_gtotch)'
    if(totch > natm*500.0) then
       if(printable) then
          do it=1,ntyp
             write(nfout,'(" !! it, ival, iatom, qex = ",i4,f8.4,i4,f8.4)') it,ival(it),iatom(it),qex(it)
          end do
          write(nfout,'(" ! illegal TOTCH value (m_ES_gtotch)")')
       end if
       stop ' ! illegal TOTCH value (m_ES_gtotch)'
    end if
  end subroutine m_ES_gtotch

  subroutine m_ES_wd_zaj_small_portion(nfout,ik,comment,nc)
    integer,        intent(in) :: nfout, ik, nc
    character(len=nc), intent(in) :: comment

    character(len=5) :: a
    integer :: i, ib, ri, j
    real(kind=DP), allocatable, dimension(:,:) :: zaj_tmp
    integer, parameter :: NZAJSIZE = 20
    integer :: nelm

    write(nfout,*) comment
    a = "     "
    do ib = ista_e, iend_e, istep_e               ! MPI
       if(k_symmetry(ik) == GAMMA) then
          allocate(zaj_tmp(5,2)); zaj_tmp = 0.d0
          do i = 1, 5
             find_j: do j = 1, 10
                if(nbase_gamma(j,1) == i) then
                   zaj_tmp(i,1) = zaj_l(j,map_z(ib),ik,1)
                   if(kimg == 2) zaj_tmp(i,2) = zaj_l(j,map_z(ib),ik,2)
                   goto 1001
                end if
             end do find_j
             find_j2: do j = 2, 10
                if(nbase_gamma(j,2) == i) then
                   zaj_tmp(i,1) = zaj_l(j,map_z(ib),ik,1)
                   if(kimg == 2) zaj_tmp(i,2) = -zaj_l(j,map_z(ib),ik,2)
                   exit find_j2
                end if
             end do find_j2
1001         continue
          end do
          
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "
             
             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_tmp(i,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_tmp(i,ri),i=1,5)
          end do
          deallocate(zaj_tmp)
       else
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
          end do
       end if
       if(ipri >= 3) then
          nelm = min(iba(ik),NZAJSIZE)
          do ri = 1, kimg
             if(ri == 1 .and. kimg == 2) a = "(Re) "
             if(ri == 2) a = "(Im) "

             if(ri == 1) write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
                  & ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             if(ri == 2) write(nfout,'(31x,a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5)
             write(nfout,'(35x,5e14.6)') (zaj_l(i,map_z(ib),ik,ri),i=6,nelm)
!!$             write(nfout,'(35x,5e14.6)') (zaj_l(i,map_z(ib),ik,ri),i=6,kg1)
          end do
       end if
    end do
!!$       if(kimg==2) a = "(Im) "
!!$       write(nfout,'(" eko(",i4,",",i3,")= ",e14.6," ",a4,5e14.6)') &
!!$            &  ib,ik,eko_l(map_z(ib),ik),a,(zaj_l(i,map_z(ib),ik,1),i=1,5)
!!$       write(nfout,455) ik,ib,eko_l(map_z(ib),ik) ! MPI
!!$       do ri = 1, kimg
!!$          if(ri == 1 .and. kimg == 2) write(nfout,*) ' (zaj real part)'
!!$          if(ri == 2)                 write(nfout,*) ' (zaj imag part)'
!!$          if(ri == 1 .and. kimg == 2) a = "(Re)"
!!$          if(ri == 2)                 a = "(Im)"
!!$          write(nfout,'(a4,5e14.6)') a,(zaj_l(i,map_z(ib),ik,ri),i=1,5) ! MPI
!!$       end do
!!$    end do
!!$455 format(' ',' ik, ib = ',2i5,' e = ',d20.12)
  end subroutine m_ES_wd_zaj_small_portion

  subroutine m_ES_decide_precon_factor(precon,ik,ib,ekin,p)
    integer, intent(in)                         :: precon,ik,ib
    real(kind=DP), intent(in),  dimension(kg1) :: ekin
    real(kind=DP), intent(out), dimension(kg1) :: p

    integer       :: i
    real(kind=DP) :: ektot, x, x1, x2, d_ektot

! ======================== added by K. Tagami ============== 11.0
    real(kind=DP) :: ctmp1
    integer :: is
! =========================================================== 11.0

    if(precon == ON) then
! ======================== modiifed by K. Tagami ============ 11.0
!       call kinetic_energy(ik,ib,ekin,ektot)   ! -(m_E.S.)

       if ( noncol ) then
          ektot = 0.0d0
          Do is=1, ndim_spinor
             call kinetic_energy( ik+is-1, ib, ekin, ctmp1 )  
             ektot = ektot + ctmp1
          End do
       else
          call kinetic_energy(ik,ib,ekin,ektot)   ! -(m_E.S.)
       endif

! =========================================================== 11.0

       d_ektot = 1.d0/ektot
       do i = 1, iba(ik)
          x = ekin(i)*d_ektot
          x1 = 27 + ( 18 + (12 + 8*x) *x) *x
          x2 = 16*(x*x)*(x*x)
          p(i)  = x1/(x1 + x2 )
       end do
    else
       p = 1.d0
    end if
  end subroutine m_ES_decide_precon_factor

  subroutine kinetic_energy(ik,ib,dekin,ektot)
    integer, intent(in) :: ik, ib
    real(kind=DP), intent(in), dimension(kg1) :: dekin
    real(kind=DP), intent(out)                 :: ektot
    integer  :: i
    ektot = 0.d0
    if(kimg == 1) then
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*zaj_l(i,map_z(ib),ik,1)**2
       end do
    else
       do i = 1, iba(ik)
          ektot = ektot + dekin(i)*( zaj_l(i,map_z(ib),ik,1)**2 &
               &                   + zaj_l(i,map_z(ib),ik,2)**2)
       end do
    end if
    if(k_symmetry(ik) == GAMMA)  ektot = ektot*2.d0
  end subroutine kinetic_energy

  subroutine m_ES_sort_eigen_values()
    integer             :: ik, ib, jb
#ifdef _NO_HEAP_SORT_EIGENVALUES_
    integer             :: ibo, jbo
#endif
    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable,dimension(:) :: eko_t, eko_t2
#ifdef _ESORT_ALLGATHER_
    integer :: n_little_elements, n_big_elements, ns, in, ip, ip0
    real(kind=DP), allocatable,dimension(:) :: work_subst
#endif

    integer                  :: i, id_sname = -1, id_sname2 = -1, id_sname3 = -1
    call tstatc0_begin('m_ES_sort_eigen_values ',id_sname,1)


#ifdef _ESORT_ALLGATHER_
    allocate(eko_t(mp_e*nrank_e))
    allocate(eko_t2(mp_e)); eko_t2 = 0.d0
#else
    allocate(eko_t(neg))
    allocate(eko_t2(np_e))   ! MPI
#endif    

    do ik = 1, kv3, af+1
       if(map_k(ik) /= myrank_k) cycle    ! MPI

       do ib = 1, np_e
          eko_t2(ib) = eko_l(ib,ik)
       end do
       if(nrank_e > 1) then
          call tstatc0_begin('mpi_barrier ',id_sname2)
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          call tstatc0_end(id_sname2)
#ifdef _ESORT_ALLGATHER_
          call tstatc0_begin('mpi_allgather ',id_sname3)
          call mpi_allgather(eko_t2,mp_e, mpi_double_precision &
               &           , eko_t, mp_e, mpi_double_precision,mpi_k_world(myrank_k),ierr)

          n_little_elements = mp_e*nrank_e - neg
          if(ipri >= 2) write(nfout,'("!esort n_little_elements = ",i6)') n_little_elements
          if(ipri >= 2) write(nfout,'("!esort eko_t  = ",10(/,10f8.4))') (eko_t(i),i=1,mp_e*nrank_e)
          if(n_little_elements > 1) then
             n_big_elements = nrank_e - n_little_elements
             ns = mp_e*(n_big_elements + 1) - 1
             allocate(work_subst(neg-ns))
             do in = n_big_elements+2, nrank_e
                ip0 = mp_e*(in-1)
                ip  = (mp_e-1)*(in - n_big_elements - 2)
                do i = 1, nel_e(in-1)
                   work_subst(ip+i) = eko_t(ip0+i)
                end do
             end do
             do i = 1, neg-ns
                eko_t(ns+i-1) = work_subst(i)
             end do
             deallocate(work_subst)
          end if
#else
          call tstatc0_begin('mpi_allgatherv ',id_sname3)
          call mpi_allgatherv(eko_t2,nel_e(myrank_e),mpi_double_precision, eko_t, nel_e &
               & , idisp_e,mpi_double_precision,mpi_k_world(myrank_k),ierr)
#endif
          call tstatc0_end(id_sname3)
       else
          eko_t = eko_t2
       end if
!!$#else
!!$       eko_t = 0.d0                       ! MPI
!!$       do ib = 1, neg                     ! MPI
!!$          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik)   ! MPI
!!$       end do                             ! MPI
!!$
!!$       if(nrank_e > 1) then
!!$          call tstatc0_begin('mpi_allreduce ',id_sname3)
!!$          call mpi_allreduce(eko_t,eko_t2,neg,mpi_double_precision &
!!$               & ,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
!!$          eko_t = eko_t2
!!$          call tstatc0_end(id_sname3)
!!$       end if
!!$#endif

       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t before sorting ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

#ifdef _NO_HEAP_SORT_EIGENVALUES_
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr(ib,ik)
             jbo = neordr(jb,ik)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr(jb,ik) = ibo
                neordr(ib,ik) = jbo
             endif
          enddo
       enddo
#else
       call heap_sorting(neg,eko_t,neordr(1,ik))
#endif

       do ib = 1, neg
          do jb = 1, neg
             if(ib == neordr(jb,ik)) then
                nrvf_ordr(ib,ik) = jb
                exit
             endif
          enddo
       enddo

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t in order ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if
    end do ! do-loop of ik

    if(af /= 0) then
       call cp_eigen_values_for_af()
       call expand_neordr_and_nrvf_ordr()
    end if
    deallocate(eko_t)
!!$#ifdef TRANSPOSE
    deallocate(eko_t2)
!!$#else
!!$    if(nrank_e > 1) deallocate(eko_t2)  ! MPI
!!$#endif
!!$    call mpi_barrier(mpi_comm_group,ierr)
    call tstatc0_end(id_sname)
  contains
    subroutine cp_eigen_values_for_af()
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle                              ! MPI
         do ib = 1, np_e                                              ! MPI
            eko_l(ib,ik+af) = eko_l(ib,ik)
         enddo
      enddo
    end subroutine cp_eigen_values_for_af

    subroutine expand_neordr_and_nrvf_ordr()
      integer :: ik
      do ik = 1, kv3, af+1
         if(map_k(ik) /= myrank_k) cycle                             ! MPI
         neordr(1:neg,ik+af) = neordr(1:neg,ik)
         nrvf_ordr(1:neg,ik+af) = nrvf_ordr(1:neg,ik)
      end do
    end subroutine expand_neordr_and_nrvf_ordr

#ifndef _NO_HEAP_SORT_EIGENVALUES_
    subroutine heap_sorting(n,eig,iord)
      integer, intent(in) :: n
      real(kind=DP), intent(inout) :: eig(n)
      integer, intent(inout) :: iord(n)

      integer :: i,j,k,itmp,it
      real(kind=DP) :: rt

      !*** initialization: heapfy eig and iord ***
      do i=2,n
         rt = eig(i)
         it = iord(i)
         j=i
10       itmp=j/2
         if(eig(itmp).ge.rt) go to 20
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         if(j.gt.1) go to 10
20       eig(j) = rt
         iord(j) = it
      end do
      !*** to be fully sort ***
      do k=n-1,1,-1
         rt = eig(1)
         eig(1) = eig(k+1)
         eig(k+1) = rt
         rt = eig(1)
         it = iord(1)
         iord(1) = iord(k+1)
         iord(k+1) = it
         it = iord(1)
         j=1
         itmp=2
30       if(itmp.gt.k) go to 40
         if(itmp.lt.k) then
            if(eig(itmp+1).gt.eig(itmp)) itmp=itmp+1
         end if
         if(rt.ge.eig(itmp)) go to 40
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         itmp=j*2
         go to 30
40       eig(j) = rt
         iord(j) = it
      end do
    end subroutine heap_sorting
#endif
  end subroutine m_ES_sort_eigen_values

! ===================================== added by K. Tagami ============== 11.0
  subroutine m_ES_sort_eigen_vals_noncl()
    integer             :: ik, ib, jb
#ifdef _NO_HEAP_SORT_EIGENVALUES_
    integer             :: ibo, jbo
#endif
    real(kind=DP), parameter :: delta = 1.d-12
    real(kind=DP), allocatable,dimension(:) :: eko_t, eko_t2
#ifdef _ESORT_ALLGATHER_
    integer :: n_little_elements, n_big_elements, ns, in, ip, ip0
    real(kind=DP), allocatable,dimension(:) :: work_subst
#endif

! ===================================== added by K. Tagami ================ 11.0
    integer :: ikskip, is
! ========================================================================= 11.0

    integer                  :: i, id_sname = -1, id_sname2 = -1, id_sname3 = -1
    call tstatc0_begin('m_ES_sort_eigen_vals_noncl ',id_sname,1)


!!$#ifdef TRANSPOSE
#ifdef _ESORT_ALLGATHER_
    allocate(eko_t(mp_e*nrank_e))
    allocate(eko_t2(mp_e)); eko_t2 = 0.d0
#else
    allocate(eko_t(neg))
    allocate(eko_t2(np_e))   ! MPI
#endif    
!!$#else
!!$    allocate(eko_t(neg))
!!$    if(nrank_e > 1) allocate(eko_t2(neg))    ! MPI
!!$#endif

    ikskip = ndim_spinor

    do ik = 1, kv3, ikskip
       if(map_k(ik) /= myrank_k) cycle    ! MPI
!!$#ifdef TRANSPOSE
       do ib = 1, np_e
          eko_t2(ib) = eko_l(ib,ik)
       end do
       if(nrank_e > 1) then
          call tstatc0_begin('mpi_barrier ',id_sname2)
          call mpi_barrier(mpi_k_world(myrank_k),ierr)
          call tstatc0_end(id_sname2)
#ifdef _ESORT_ALLGATHER_
          call tstatc0_begin('mpi_allgather ',id_sname3)
          call mpi_allgather(eko_t2,mp_e, mpi_double_precision &
               &           , eko_t, mp_e, mpi_double_precision,mpi_k_world(myrank_k),ierr)

          n_little_elements = mp_e*nrank_e - neg
          if(ipri >= 2) write(nfout,'("!esort n_little_elements = ",i6)') n_little_elements
          if(ipri >= 2) write(nfout,'("!esort eko_t  = ",10(/,10f8.4))') (eko_t(i),i=1,mp_e*nrank_e)
          if(n_little_elements > 1) then
             n_big_elements = nrank_e - n_little_elements
             ns = mp_e*(n_big_elements + 1) - 1
             allocate(work_subst(neg-ns))
             do in = n_big_elements+2, nrank_e
                ip0 = mp_e*(in-1)
                ip  = (mp_e-1)*(in - n_big_elements - 2)
                do i = 1, nel_e(in-1)
                   work_subst(ip+i) = eko_t(ip0+i)
                end do
             end do
             do i = 1, neg-ns
                eko_t(ns+i-1) = work_subst(i)
             end do
             deallocate(work_subst)
          end if
#else
          call tstatc0_begin('mpi_allgatherv ',id_sname3)
          call mpi_allgatherv(eko_t2,nel_e(myrank_e),mpi_double_precision, eko_t, nel_e &
               & , idisp_e,mpi_double_precision,mpi_k_world(myrank_k),ierr)
#endif
          call tstatc0_end(id_sname3)
       else
          eko_t = eko_t2
       end if
!!$#else
!!$       eko_t = 0.d0                       ! MPI
!!$       do ib = 1, neg                     ! MPI
!!$          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik)   ! MPI
!!$       end do                             ! MPI
!!$
!!$       if(nrank_e > 1) then
!!$          call tstatc0_begin('mpi_allreduce ',id_sname3)
!!$          call mpi_allreduce(eko_t,eko_t2,neg,mpi_double_precision &
!!$               & ,mpi_sum,mpi_k_world(myrank_k),ierr)       ! MPI
!!$          eko_t = eko_t2
!!$          call tstatc0_end(id_sname3)
!!$       end if
!!$#endif

       neordr(1:neg,ik) = (/(ib,ib=1,neg)/)

! ----------------- debug --
!       write(*,'(" !Esort  eko_t before sorting ")')
!       write(*,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
! ------------------------

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t before sorting ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

#ifdef _NO_HEAP_SORT_EIGENVALUES_
       do ib = 1, neg-1
          do jb = ib+1, neg
             ibo = neordr(ib,ik)
             jbo = neordr(jb,ik)
             if(eko_t(jbo)  < eko_t(ibo)-delta) then        ! MPI
                neordr(jb,ik) = ibo
                neordr(ib,ik) = jbo
             endif
          enddo
       enddo
#else
       call heap_sorting(neg,eko_t,neordr(1,ik))
#endif

       do ib = 1, neg
          do jb = 1, neg
             if(ib == neordr(jb,ik)) then
                nrvf_ordr(ib,ik) = jb
                exit
             endif
          enddo
       enddo

       if(ipri >=2 ) then
          write(nfout,'(" !Esort  eko_t in order ")')
          write(nfout,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
       end if

! ------- debug --
!       write(*,'(" !Esort  eko_t in order ")')
!       write(*,'(" !Esort ",10f8.4)') (eko_t(neordr(i,ik)),i=1,neg)
! ---------------

    end do ! do-loop of ik

! ------------------- important- ---------------
!
    Do ik=1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle

       Do is=1, ndim_spinor
          Do ib=1, neg
             neordr( ib,ik+is-1 ) = neordr( ib,ik )
!!!             write(*,*) 'ik, ib ordr : ', ik, ib, neordr( ib,ik )
          End do
       End do
    End do
! --------------------------- unknown
    Do ik=1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle

       Do is=1, ndim_spinor
          Do ib=1, neg
              nrvf_ordr( ib,ik+is-1 ) =  nrvf_ordr( ib,ik )
          End do
       End do
    End do
! ---------------------    

    deallocate(eko_t)
!!$#ifdef TRANSPOSE
    deallocate(eko_t2)
!!$#else
!!$    if(nrank_e > 1) deallocate(eko_t2)  ! MPI
!!$#endif
!!$    call mpi_barrier(mpi_comm_group,ierr)
    call tstatc0_end(id_sname)

  contains

    subroutine dummy
    end subroutine dummy

#ifndef _NO_HEAP_SORT_EIGENVALUES_
    subroutine heap_sorting(n,eig,iord)
      integer, intent(in) :: n
      real(kind=DP), intent(inout) :: eig(n)
      integer, intent(inout) :: iord(n)

      integer :: i,j,k,itmp,it
      real(kind=DP) :: rt

      !*** initialization: heapfy eig and iord ***
      do i=2,n
         rt = eig(i)
         it = iord(i)
         j=i
10       itmp=j/2
         if(eig(itmp).ge.rt) go to 20
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         if(j.gt.1) go to 10
20       eig(j) = rt
         iord(j) = it
      end do
      !*** to be fully sort ***
      do k=n-1,1,-1
         rt = eig(1)
         eig(1) = eig(k+1)
         eig(k+1) = rt
         rt = eig(1)
         it = iord(1)
         iord(1) = iord(k+1)
         iord(k+1) = it
         it = iord(1)
         j=1
         itmp=2
30       if(itmp.gt.k) go to 40
         if(itmp.lt.k) then
            if(eig(itmp+1).gt.eig(itmp)) itmp=itmp+1
         end if
         if(rt.ge.eig(itmp)) go to 40
         eig(j) = eig(itmp)
         iord(j) = iord(itmp)
         j=itmp
         itmp=j*2
         go to 30
40       eig(j) = rt
         iord(j) = it
      end do
    end subroutine heap_sorting
#endif
  end subroutine m_ES_sort_eigen_vals_noncl
! ========================================================================= 11.0

  subroutine m_ES_energy_eigen_values(nfout,sort)
    integer, intent(in) :: nfout
    logical, intent(in), optional :: sort

    integer             :: is, ik, ipri0
!!$    real(kind=DP), pointer, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: ekin
    logical :: sor

    sor = .true.
    if(present(sort)) sor=sort
    allocate(afft(nfft)); allocate(bfft(nfft))
!!$    allocate(sc(kg1))
!!$    ekin => sc(1:kg1)
    allocate(ekin(kg1))
    call m_FFT_alloc_WF_work()

    do is = 1, nspin, af+1
       call m_ES_Vlocal_in_Rspace(is,afft)                  ! (ptfft1)
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle                   ! MPI
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
          call m_ES_eigen_values_for_each_k(is,ik,ekin,afft)
       end do
    end do
    if(sor) call m_ES_sort_eigen_values()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate(afft); deallocate(bfft)
!!$    deallocate(sc)
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_values

! =============================== added by K. Tagami ================ 11.0
  subroutine m_ES_energy_eigen_vals_noncl(nfout)
    integer, intent(in) :: nfout
    integer             :: ipri0
    integer :: ik

    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    allocate(ekin(kg1))
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn
    call m_FFT_alloc_WF_work()

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )   ! vlhxc_ss -> afft_kt

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle                   ! MPI
       call m_pwBS_kinetic_energies(ik,vkxyz,ekin)
       call m_ES_eigen_vals_each_k_noncl( ik,ekin,afft_kt, bfft_kt )
    End do

    call m_ES_sort_eigen_vals_noncl()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko(nfout,mode=SCF)

    deallocate( afft_kt, bfft_kt )
    deallocate( ekin)

    call m_FFT_dealloc_WF_work()

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_vals_noncl
! ========================================================================= 11.0

  subroutine m_ES_energy_eigen_values_ext(nfout)
    integer, intent(in) :: nfout

    integer             :: is, ik, ipri0
!!$    real(kind=DP), pointer, dimension(:) :: ekin
    real(kind=DP), allocatable, dimension(:) :: ekin

    allocate(afft(nfft)); allocate(bfft(nfft))
!!$    allocate(sc(kg1))
!!$    ekin => sc(1:kg1)
    allocate(ekin(kg1))
    call m_FFT_alloc_WF_work()

    do is = 1, nspin, af+1
       call m_ES_Vlocal_in_Rspace(is,afft)                  ! (ptfft1)
       do ik = is, kv3-nspin+is, nspin
          if(map_k(ik) /= myrank_k) cycle                   ! MPI
          call m_pwBS_kinetic_energies(ik,vkxyz,ekin)

          if(ipri >= 3) then
             write(nfout,'(" -- ekin <<m_ES_eigen_values_ext>> -- ik = ",i8)') ik
             write(nfout,'(8f8.4)') (ekin(ipri0),ipri0=1,iba(ik))
          end if

          call m_ES_eigen_values_for_each_kex(nfout,is,ik,ekin,afft)
       end do
    end do
    call m_ES_sort_eigen_values()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko2(nfout,mode=SCF)

    deallocate(afft); deallocate(bfft)
!!$    deallocate(sc)
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()
  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigen_values_ext

! ==================================== added by K. Tagami ============== 11.0
  subroutine m_ES_energy_eigenvals_ext_noncl(nfout)
    integer, intent(in) :: nfout
    integer             :: ipri0
    integer :: ik

    real(kind=DP), allocatable, dimension(:) :: ekin
    real(kind=DP), allocatable :: afft_kt(:,:)
    real(kind=DP), allocatable :: bfft_kt(:,:)

    allocate(ekin(kg1))
    allocate(afft_kt(nfft,ndim_chgpot)); afft_kt = 0.0d0      ! pot
    allocate(bfft_kt(nfft,ndim_spinor)); bfft_kt = 0.0d0      ! wfn
    call m_FFT_alloc_WF_work()

    call m_ES_Vlocal_in_Rspace_noncl( afft_kt )

    Do ik=1, kv3, ndim_spinor
       if (map_k(ik) /= myrank_k) cycle                   ! MPI
       call m_pwBS_kinetic_energies(ik,vkxyz,ekin)

       if(ipri >= 3) then
          write(nfout,'(" -- ekin <<m_ES_eigen_values_ext>> -- ik = ",i8)') ik
          write(nfout,'(8f8.4)') (ekin(ipri0),ipri0=1,iba(ik))
       end if

       call m_ES_eigen_vals_each_kex_noncl( nfout, ik, ekin, afft_kt, bfft_kt )
    End do

    call m_ES_sort_eigen_vals_noncl()

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 2) call m_ES_wd_eko2(nfout,mode=SCF)

    deallocate( afft_kt, bfft_kt )
    deallocate(ekin)
    call m_FFT_dealloc_WF_work()

  contains

    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0
  end subroutine m_ES_energy_eigenvals_ext_noncl
! ========================================================================== 11.0

  subroutine m_ES_eigen_values_for_each_k(is,ik,ekin,afft)
    integer,       intent(in)                  :: is,ik    ! is: spin
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: afft
#ifdef NEC_TUNE_SMP
    real(kind=DP), dimension(nfft) :: bfft
#endif

    integer       :: ib
    real(kind=DP) :: eg
    integer       :: id_sname = -1
!!$    write(nfout,'(" --- energy_eigen_vlues ---")')
    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_T_W()                     ! (eigen1) --> eko_l , kinetic part

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,eg)
#endif
    do ib = ista_e, iend_e, istep_e  ! MPI
       call m_ES_WF_in_Rspace(ik,ib,bfft) ! -(m_E.S.); (swffft)
       call m_FFT_W_Vlocal_W(ELECTRON,nfft,afft,bfft,eg) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before W_Vnonlocal_W <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_Vnonlocal_W(ik)

    call tstatc0_end(id_sname)
  contains
    subroutine W_T_W()
      integer :: ib, i
      real(kind=DP) :: eko

      if(sw_hybrid_functional == OFF) eko_l(1:np_e,ik) = 0.d0                   ! MPI
      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            eko = 0.d0
            do i = 1, iba(ik)
               !eko_l(ib,ik) = eko_l(ib,ik) + ekin(i)*zaj_l(i,ib,ik,1)**2
               eko = eko + ekin(i)*zaj_l(i,ib,ik,1)**2
            end do
            if(k_symmetry(ik) == GAMMA) eko = 2.d0*eko
            eko_l(ib,ik) = eko_l(ib,ik) + eko
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            eko = 0.d0
            do i = 1, iba(ik)
               !eko_l(ib,ik) = eko_l(ib,ik) + ekin(i)*(zaj_l(i,ib,ik,1)**2+zaj_l(i,ib,ik,2)**2)
               eko = eko + ekin(i)*(zaj_l(i,ib,ik,1)**2+zaj_l(i,ib,ik,2)**2)
            end do
            if(k_symmetry(ik) == GAMMA) eko = 2.d0*eko
            eko_l(ib,ik) = eko_l(ib,ik) + eko
         end do
      end if

      if(ipri >= 2) then
         write(6,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W

    subroutine W_Vnonlocal_W(ik)
      integer, intent(in) :: ik

      integer       :: ia, lmt1, lmt2, it, p, q, ib
      real(kind=DP) :: fac

      integer :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W ',id_sname)

      do ia = 1, natm
         it = ityp(ia)
         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)
            if(k_symmetry(ik) == GAMMA) then
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac = iwei(ia)
!!$                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  if(ipaw(it).eq.0) then
                     fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  else
                     fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
                  end if
                  do ib = 1, np_e                                  ! MPI
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik))
                  end do
               end do
            else
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac = iwei(ia)
!!$                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  if(ipaw(it).eq.0) then
                     fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
                  else
                     fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
                  end if
                  do ib = 1, np_e                                  ! MPI
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik)&
                          &      + fsi_l(ib,p,ik)*fsi_l(ib,q,ik))
                  end do
               end do
            end if
         end do
      end do
      if(ipri >= 2) then
         write(6,'(" -- eko_l <<W_Vnonlocal_W>> --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W
  end subroutine m_ES_eigen_values_for_each_k

! ============================= added by K. Tagami ======================= 11.0
  subroutine m_ES_eigen_vals_each_k_noncl( ik, ekin, afft_kt, bfft_kt )
    integer,       intent(in)                  :: ik
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in)  :: afft_kt( nfft,ndim_chgpot )
!
    real(kind=DP), intent(inout)  :: bfft_kt( nfft,ndim_spinor )

    integer       :: ib, is
    real(kind=DP) :: eg
    integer       :: id_sname = -1
!!$    write(nfout,'(" --- energy_eigen_vlues ---")')

    call tstatc0_begin('energy_eigen_values_k_noncl ', id_sname,1)

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before <<m_ES_eigen_vals_each_k_noncl>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif

    call W_T_W_noncl()                     ! (eigen1) --> eko_l , kinetic part

#ifdef NEC_TUNE_SMP
!CDIR PARALLEL DO PRIVATE(bfft,eg)
#endif
    do ib = ista_e, iend_e, istep_e  ! MPI
       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik +is -1  , ib, bfft_kt(1:nfft,is) ) 
       End do

       call m_FFT_W_Vlocal_W_noncl( ELECTRON, nfft, afft_kt, bfft_kt, eg, &
	&                           ndim_spinor, ndim_chgpot ) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI

    end do

    if(ipri >= 3) then
       write(nfout,'(" -- eko_l before W_Vnonlocal_W <<m_ES_eigen_values_for_each_k>> --, ik = ",i3)') ik 
       write(nfout,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
    endif


!    write(938,*) iwei
!    write(940,*) fsr_l
!    write(942,*) dion_Scr_noncl
!    stop

    call W_Vnonlocal_W_noncl_A(ik)

!    stop

    call tstatc0_end(id_sname)

  contains

    subroutine W_T_W_noncl()
      integer :: ib, i, is
      real(kind=DP) :: ctmp, meko

      if(sw_hybrid_functional == OFF) eko_l(1:np_e,ik) = 0.d0           ! MPI
      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            meko = 0.0d0
            do i = 1, iba(ik)
	       ctmp = 0.0d0
               Do is=1, ndim_spinor
                  ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2
               End do
               meko = meko + ekin(i) *ctmp
!!!!!               eko_l(ib,ik) = eko_l(ib,ik) + ekin(i) *ctmp
            end do
!!!!            if(k_symmetry(ik) == GAMMA) eko_l(ib,ik) = 2.d0*eko_l(ib,ik)

            if ( k_symmetry(ik) == GAMMA ) meko = 2.0d0 *meko
            eko_l(ib,ik) = eko_l(ib,ik) + meko

         end do

      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = 1, np_e                        ! MPI
            meko = 0.0d0
            do i = 1, iba(ik)
	       ctmp = 0.0d0
               Do is=1, ndim_spinor
                  ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2 &
	&                     + zaj_l( i, ib, ik +is-1, 2 )**2
	       End do
!!               eko_l(ib,ik) = eko_l(ib,ik) + ekin(i) *ctmp
               meko = meko + ekin(i) *ctmp
            end do
!!            if(k_symmetry(ik) == GAMMA) eko_l(ib,ik) = 2.d0*eko_l(ib,ik)

            if ( k_symmetry(ik) == GAMMA ) meko = 2.0d0 *meko
            eko_l(ib,ik) = eko_l(ib,ik) + meko

         end do
      end if

      if(ipri >= 2) then
         write(6,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W_noncl

    subroutine W_Vnonlocal_W_noncl_A(ik)
      integer, intent(in) :: ik

      integer :: ia, lmt1, lmt2, it, p, q, ib
      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: k1, k2
      integer :: mdvdb

      real(kind=DP) :: c1, c2, fac0
      complex(kind=CMPLDP) :: fac

      real*8 csum_1, csum_2

      integer :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W_noncl ',id_sname)

!      write(960,*) 'FF'
!      write(960,*) dion_scr_noncl

      csum_1 = 0.0d0;       csum_2 = 0.0d0

      do ia = 1, natm
         it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
         mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)

            il1 = ltp(lmt1,it); im1 = mtp(lmt1,it)

            if(k_symmetry(ik) == GAMMA) then
               do lmt2 = lmt1, ilmt(it)
                  q = lmta(lmt2,ia)
                  fac0   = 2.d0 * iwei(ia)
                  if(lmt1 == lmt2) fac0 = iwei(ia)

                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        is_tmp = ndim_spinor*( is1 -1 ) +is2
                        fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

                        k1 = ik + is1 - 1
                        k2 = ik + is2 - 1

                        Do ib = 1, np_e                                  ! MPI
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + fac*(fsr_l(ib,p,k1)*fsr_l(ib,q,k2) )
                        End do
                     End do
                  End do
               End do
            else
! ----------------------------------- Which is better ? --------
!!!!!               Do lmt2 = lmt1, ilmt(it)
               Do lmt2 = 1, ilmt(it)
                  q = lmta(lmt2,ia)

                  il2 = ltp(lmt2,it); im2 = mtp(lmt2,it)


! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                  if ( mdvdb == SKIP ) then
                     if ( il1 /= il2 ) cycle
                     if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                        if ( im1 /= im2 ) cycle
                     endif
                  endif
#endif
! ---------------------------------------------------- 11.0S

!                  fac   = 2.d0 * iwei(ia)
!                  if(lmt1 == lmt2) fac = iwei(ia)

                  fac0 = iwei(ia)

                  Do is1=1, ndim_spinor
                     Do is2=1, ndim_spinor
                        is_tmp = ndim_spinor *( is1 -1 ) +is2
                        fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

!                        write(950,*) lmt1, lmt2, is_tmp, ia, fac, dion( lmt1, lmt2, it )

                        k1 = ik + is1 - 1
                        k2 = ik + is2 - 1

                        Do ib = 1, np_e                                  ! MPI
                           c1 =  real(fac) *( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) &
                                &            +fsi_l(ib,p,k1)*fsi_l(ib,q,k2) )
#if 1
! -- orig -
                           c2 = -aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
	&                                     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
#else
! -- kt : debug --
!                           c2 = aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
!                                &            -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
!--
#endif
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + c1 + c2
                        End do
                     End Do
                  End Do
               end do
            end if

         end do
      end do

      if(ipri >= 2) then
         write(6,'(" -- eko_l <<W_Vnonlocal_W_noncl A *>> --, ik = ",i3)') ik
         write(6,'(8f8.4)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W_noncl_A

  end subroutine m_ES_eigen_vals_each_k_noncl
! ==================================================================== 11.0

  subroutine m_ES_eigen_values_for_each_kex(nfout,is,ik,ekin,afft)
    integer,       intent(in)                  :: nfout,is,ik    ! is: spin
    real(kind=DP), intent(in), dimension(kg1) :: ekin
    real(kind=DP), intent(in), dimension(nfft) :: afft

    integer       :: ib
    real(kind=DP) :: eg
    integer,save  :: id_sname = -1
    call tstatc0_begin('energy_eigen_values ', id_sname,1)

    call W_T_W()                     ! (eigen1) --> eko_l , kinetic part
    do ib = ista_e, iend_e, istep_e  ! MPI
       if(nrvf_ordr(ib,ik) <= neg_previous) cycle
       call m_ES_WF_in_Rspace(ik,ib,bfft) ! -(m_E.S.); (swffft)
       call m_FFT_W_Vlocal_W(ELECTRON,nfft,afft,bfft,eg) ! (eigens) --> eg
       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    call W_Vnonlocal_W(ik)

    call tstatc0_end(id_sname)
  contains
    subroutine W_T_W()
      integer :: ib, i, ip, ibt

!!$      eko_l(1:np_e,ik) = 0.d0                   ! MPI
      do ib = neg_previous+1, neg
         ip = neordr(ib,ik)
         if(map_e(ip) == myrank_e) eko_l(map_z(ip),ik) = 0.d0
      end do

      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = neg_previous+1, neg                   ! MPI
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i)*zaj_l(i,ibt,ik,1)**2
               end do
               if(k_symmetry(ik) == GAMMA) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
!!$         do ib = 1, np_e                        ! MPI
         do ib = neg_previous+1, neg
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i)*(zaj_l(i,ibt,ik,1)**2+zaj_l(i,ibt,ik,2)**2)
               end do
               if(k_symmetry(ik) == GAMMA) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      end if

      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_T_W) --, ik = ",i3)') ik 
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W

    subroutine W_Vnonlocal_W(ik)
      integer, intent(in) :: ik

      integer       :: ia, lmt1, lmt2, it, p, q, ib, ibo
      real(kind=DP) :: fac

      integer,save :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W ',id_sname)

      do ia = 1, natm
         it = ityp(ia)
         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)
            do lmt2 = lmt1, ilmt(it)
               q = lmta(lmt2,ia)
               fac   = 2.d0 * iwei(ia)
               if(lmt1 == lmt2) fac = iwei(ia)
!!$               fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
               if(ipaw(it).eq.0) then
                  fac   = fac*(dion(lmt1,lmt2,it) + vlhxcQ(lmt1,lmt2,ia,is))
               else
                  fac   = fac*(dion_paw(lmt1,lmt2,is,ia) + vlhxcQ(lmt1,lmt2,ia,is))
               end if
               if(k_symmetry(ik) == GAMMA) then
                  do ib = 1, np_e                                  ! MPI
                     ibo = ista_e + ista_e*(ib-1)
                     if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                     eko_l(ib,ik) = eko_l(ib,ik) &
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik))
                  end do
               else
                  do ib = 1, np_e                                  ! MPI
                     ibo = ista_e + ista_e*(ib-1)
                     if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                     eko_l(ib,ik) = eko_l(ib,ik) &                       
                          & + fac*(fsr_l(ib,p,ik)*fsr_l(ib,q,ik)&
                          &      + fsi_l(ib,p,ik)*fsi_l(ib,q,ik))
                  end do
               end if
            end do
         end do
      end do
      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_Vnonlocal_W) --, ik = ",i3)') ik 
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W
  end subroutine m_ES_eigen_values_for_each_kex

!================================ added by K. Tagami ==================== 11.0
  subroutine m_ES_eigen_vals_each_kex_noncl( nfout,ik,ekin,afft_kt, bfft_kt )
    integer,       intent(in)                  :: nfout, ik
    real(kind=DP), intent(in), dimension(kg1) :: ekin

    real(kind=DP), intent(in)  :: afft_kt( nfft,ndim_chgpot )
    real(kind=DP), intent(inout)  :: bfft_kt( nfft,ndim_spinor )

    integer       :: ib, is
    real(kind=DP) :: eg
    integer,save  :: id_sname = -1

    call tstatc0_begin('energy_eigen_vals_kex_noncl ', id_sname,1)

    call W_T_W_noncl()                     ! (eigen1) --> eko_l , kinetic part

    do ib = ista_e, iend_e, istep_e  ! MPI
       if(nrvf_ordr(ib,ik) <= neg_previous) cycle

       Do is=1, ndim_spinor
         call m_ES_WF_in_Rspace( ik +is-1, ib, bfft_kt(:,is) )    
       End do

       call m_FFT_W_Vlocal_W_noncl( ELECTRON,nfft,afft_kt,bfft_kt,eg, &
            &                       ndim_spinor, ndim_chgpot )  ! (eigens) --> eg

       eko_l(map_z(ib),ik) = eko_l(map_z(ib),ik) + eg ! MPI
    end do

    call W_Vnonlocal_W_noncl_A(ik)

    call tstatc0_end(id_sname)
  contains

    subroutine W_T_W_noncl()
      integer :: ib, i, ip, ibt, is
      real(kind=DP) :: ctmp

!!$      eko_l(1:np_e,ik) = 0.d0                   ! MPI
      do ib = neg_previous+1, neg
         ip = neordr(ib,ik)
         if(map_e(ip) == myrank_e) eko_l(map_z(ip),ik) = 0.d0
      end do

      if(kimg==1) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
         do ib = neg_previous+1, neg                   ! MPI
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
	          ctmp = 0.0d0
         	  Do is=1, ndim_spinor
	            ctmp = ctmp + zaj_l( i, ibt, ik +is-1, 1 )**2
	          End do
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i) *ctmp
               end do
               if ( k_symmetry(ik)==GAMMA ) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      else if(kimg==2) then
#ifdef VPP
*vocl loop,unroll(4)
#endif
!!$         do ib = 1, np_e                        ! MPI
         do ib = neg_previous+1, neg
            ip = neordr(ib,ik)
            if(map_e(ip) == myrank_e) then
               ibt = map_z(ip)
               do i = 1, iba(ik)
	          ctmp = 0.0d0
	          Do is=1, ndim_spinor
                    ctmp = ctmp + zaj_l( i, ib, ik +is-1, 1 )**2 &
	&                       + zaj_l( i, ib, ik +is-1, 2 )**2
	          End do
                  eko_l(ibt,ik) = eko_l(ibt,ik) + ekin(i) *ctmp
               end do
               if ( k_symmetry(ik)==GAMMA ) eko_l(ibt,ik) = eko_l(ibt,ik)*2.d0
            end if
         end do
      end if

      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_T_W_noncl) --, ik = ",i3)') ik
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif
    end subroutine W_T_W_noncl

    subroutine W_Vnonlocal_W_noncl_A(ik)
      integer, intent(in) :: ik

      integer :: ia, lmt1, lmt2, it, p, q, ib, ibo
      integer :: is1, is2, is_tmp
      integer :: il1, il2, im1, im2
      integer :: k1, k2
      integer :: mdvdb

      real(kind=DP) :: c1, c2, fac0
      complex(kind=CMPLDP) :: fac

      integer,save :: id_sname = -1
      call tstatc0_begin('W_Vnonlocal_W_noncl ',id_sname)

!      write(960,*) 'FF'
!      write(960,*) dion_scr_noncl

      do ia = 1, natm
         it = ityp(ia)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
         mdvdb = m_PP_include_vanderbilt_pot(it)
#endif
! ---------------------------------------------------- 11.0S

         do lmt1 = 1, ilmt(it)
            p = lmta(lmt1,ia)

            il1 = ltp(lmt1,it);  im1 = mtp(lmt1,it)

!!!!!!            do lmt2 = lmt1, ilmt(it)
            do lmt2 = 1, ilmt(it)
               q = lmta(lmt2,ia)

               il2 = ltp(lmt2,it);  im2 = mtp(lmt2,it)

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
               if ( mdvdb == SKIP ) then
                  if ( il1 /= il2 ) cycle
                  if ( SpinOrbit_mode == Neglected .and. sw_hubbard == OFF ) then
                     if ( im1 /= im2 ) cycle
                  endif
               endif
#endif
! ---------------------------------------------------- 11.0S

!               fac0   = 2.d0 * iwei(ia)
!               if(lmt1 == lmt2) fac0 = iwei(ia)

               fac0   = iwei(ia)

               Do is1=1, ndim_spinor
                  Do is2=1, ndim_spinor
                     is_tmp = ndim_spinor*( is1 -1 ) +is2
                     fac = fac0 *dion_scr_noncl( lmt1, lmt2, is_tmp, ia )

                     k1 = ik + is1 - 1
                     k2 = ik + is2 - 1

                     if ( k_symmetry(ik) == GAMMA ) then
                        do ib = 1, np_e                                  ! MPI
                           ibo = ista_e + ista_e*(ib-1)
                           if(nrvf_ordr(ibo,ik) <= neg_previous) cycle
                           eko_l(ib,ik) = eko_l(ib,ik) &
                                & + fac*( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) )
                        end do
                     else
                        do ib = 1, np_e                                  ! MPI
                           ibo = ista_e + ista_e*(ib-1)
                           if(nrvf_ordr(ibo,ik) <= neg_previous) cycle

                           c1 =  real(fac) *( fsr_l(ib,p,k1)*fsr_l(ib,q,k2) &
                                &            +fsi_l(ib,p,k1)*fsi_l(ib,q,k2) )
#if 1
! ----------- orig --
                           c2 = -aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
                                &	     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
#else
! --- kt :debug --
!                           c2 = aimag(fac) *( fsr_l(ib,p,k1)*fsi_l(ib,q,k2) &
!                                &	     -fsi_l(ib,p,k1)*fsr_l(ib,q,k2) )
! ---
#endif
                           eko_l(ib,ik) = eko_l(ib,ik) + c1 +c2

                        end do
                     end if
                  End Do      ! is2
               End do       !is1

            end do
         end do
      end do
      if(ipri >= 3 .and. printable) then
         write(nfout,'(" -- eko_l (W_Vnonlocal_W_noncl :) --, ik = ",i3)') ik
         write(nfout,'(5d20.8)') (eko_l(ib,ik),ib=1,np_e) ! MPI
      endif

      call tstatc0_end(id_sname)
    end subroutine W_Vnonlocal_W_noncl_A

  end subroutine m_ES_eigen_vals_each_kex_noncl
! ========================================================= 11.0

  subroutine m_ES_Vlocal_in_Rspace(is,afft)
    integer, intent(in) :: is
    real(kind=DP), dimension(nfft) :: afft
    integer,save                   :: id_sname = -1
!!$    call tstatc0_begin('m_ES_Vlocal_in_Rspace ', id_sname,1)
    call tstatc0_begin('m_ES_Vlocal_in_Rspace ', id_sname)

    call map_vlhxc_l_onto_afft(is)      !-(contained here) vlhxc_l  --> afft ;using (igf)
    call m_FFT_WF(ELECTRON,nfout,afft,INVERSE,OFF) ! afft -> afft

    call tstatc0_end(id_sname)
  contains
    subroutine map_vlhxc_l_onto_afft(is)
      integer, intent(in) :: is
      integer :: i,i1,ri
      integer :: iend
      real(kind=DP), pointer, dimension(:) :: afft_mpi
      if(npes > 1) allocate(afft_mpi(nfft))

      afft = 0.d0
      iend = iend_kngp
      if( iend > kg ) iend = kg
      do ri = 1, kimg
         do i = ista_kngp, iend  !for mpi
            i1 = kimg*igf(i) + (ri - kimg)
            afft(i1) = vlhxc_l(i,ri,is)
         end do
      end do

      if(npes > 1) then
         call mpi_allreduce(afft,afft_mpi,nfft &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         afft = afft_mpi
         deallocate(afft_mpi)
      end if

    end subroutine map_vlhxc_l_onto_afft
  end subroutine m_ES_Vlocal_in_Rspace

! ==================================== added by K. Tagami ================== 11.0
  subroutine m_ES_Vlocal_in_Rspace_noncl( afft_kt )
    real(kind=DP), intent(out) :: afft_kt( nfft, ndim_chgpot )

    integer :: is
    integer,save                   :: id_sname = -1
!!$    call tstatc0_begin('m_ES_Vlocal_in_Rspace_noncl ', id_sname,1)
    call tstatc0_begin('m_ES_Vlocal_in_Rspace_noncl ', id_sname)

    allocate( vlhxc_ssrep( ista_kngp:iend_kngp,kimg,ndim_chgpot) )
    vlhxc_ssrep = 0.0d0

    call m_ES_MagMom_to_DensMat_vlhxcl( vlhxc_l, vlhxc_ssrep )

    afft_kt = 0.d0
    Do is=1, ndim_chgpot
      call map_vlhxc_ss_onto_afft(is)  
                    !-(contained here) vlhxc_l  --> afft ;using (igf)
      call m_FFT_WF( ELECTRON, nfout, afft_kt(:,is), INVERSE, OFF ) ! afft -> afft
    End do

    deallocate( vlhxc_ssrep )
    call tstatc0_end(id_sname)

  contains

    subroutine map_vlhxc_ss_onto_afft(is)
      integer, intent(in) :: is
      integer :: i,i1,ri
      integer :: iend
      real(kind=DP), allocatable, dimension(:) :: afft_mpi

      if(npes > 1) allocate(afft_mpi(nfft))

      iend = iend_kngp
      if( iend > kg ) iend = kg
      do ri = 1, kimg
         do i = ista_kngp, iend  !for mpi
            i1 = kimg*igf(i) + (ri - kimg)
            afft_kt(i1,is) = vlhxc_ssrep(i,ri,is)
         end do
      end do

      if(npes > 1) then
         call mpi_allreduce( afft_kt(:,is), afft_mpi,nfft &
              &  ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
         afft_kt(:,is) = afft_mpi(:)
         deallocate(afft_mpi)
      end if

    end subroutine map_vlhxc_ss_onto_afft

  end subroutine m_ES_Vlocal_in_Rspace_noncl
! ========================================================================= 11.0


  subroutine m_ES_WF_in_Rspace_kt(k1,k2,ik,psi_l,bfft)
    integer, intent(in) :: k1,k2,ik
    real(kind=DP), intent(in),dimension(kg1,1,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    call m_ES_map_WF_on_fftmesh(k1,k2,ik,psi_l,bfft)
    call m_FFT_WF(ELECTRON,nfout,bfft,INVERSE,ON)

  end subroutine m_ES_WF_in_Rspace_kt

  subroutine m_ES_map_WF_on_fftmesh(k1,k2,ik,psi_l,bfft)
    integer, intent(in) :: k1,k2,ik
    real(kind=DP), intent(in),dimension(kg1,1,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = psi_l(1,1,ik,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = psi_l(ii,1,ik,1)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) =   psi_l(ii,1,ik,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf(1) - 1
          bfft(i1)   = psi_l(1,1,ik,1)
          bfft(i1+1) = psi_l(1,1,ik,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = psi_l(ii,1,ik,1)
             bfft(i1+1) = psi_l(ii,1,ik,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = psi_l(ii,1,ik,1)
             bfft(i2+1) = -psi_l(ii,1,ik,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,1,ik,ri)   ! MPI
          end do
       end do
    end if
  end subroutine m_ES_map_WF_on_fftmesh

  subroutine m_ES_WF_in_Rspace1(k1,k2,ik,ib,psi_l,bfft)
    integer, intent(in) :: k1,k2,ik,ib
    real(kind=DP), intent(in),dimension(kg1,np_e,k1:k2,kimg) :: psi_l
    real(kind=DP), intent(inout), dimension(nfft) :: bfft

    integer :: i,i1,ri, j, i2, ii
#ifndef NEC_TUNE_SMP
    integer,save  :: id_sname = -1
#ifdef SAVE_FFT_TIMES
    integer,save :: id_sname2 = -1
#endif
#endif

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       if (status_saved_phifftr(map_z(ib),ik) == STORED_AND_NEW) then
#ifndef NEC_TUNE_SMP
          call tstatc0_begin('m_ES_WF_in_Rspace(2) ',id_sname2,1)
#endif
          if(ipri>=2 .and. ik==1 .and. ib==1) write(nfout,'(" !### zaj_fftr(stored) --> bfft")')
          bfft(:) = Phifftr_l(:,map_z(ib),ik)
#ifndef NEC_TUNE_SMP
          call tstatc0_end(id_sname2)
#endif
       endif
    else
#endif

#ifndef NEC_TUNE_SMP
       call tstatc0_begin('m_ES_WF_in_Rspace(1) ',id_sname,1)
#endif

    if(ipri>=2 .and. ik==1 .and. ib==1) write(nfout,'(" !### zaj_l --(FFT)--> bfft")')

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = psi_l(1,map_z(ib),ik,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = psi_l(ii,map_z(ib),ik,1)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) =   psi_l(ii,map_z(ib),ik,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf(1) - 1
          bfft(i1)   = psi_l(1,map_z(ib),ik,1)
          bfft(i1+1) = psi_l(1,map_z(ib),ik,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = psi_l(ii,map_z(ib),ik,1)
             bfft(i1+1) = psi_l(ii,map_z(ib),ik,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = psi_l(ii,map_z(ib),ik,1)
             bfft(i2+1) = -psi_l(ii,map_z(ib),ik,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,map_z(ib),ik,ri)   ! MPI
          end do
       end do
    end if
    if(ipri >= 2) then
       if(ik <= 2 .and. ib <= 3) then
          write(6,'(" ! bfft G-space ik = ",i3," ib = ",i3," <<m_ES_WF_in_Rspace>>")') ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if
    call m_FFT_WF(ELECTRON,nfout,bfft,INVERSE,ON)
    if(ipri >= 2) then
       if(ik <=  2 .and. ib <= 3) then
          write(6,'(" ! bfft R-space ik = ",i3," ib = ",i3," <<m_ES_WF_in_Rspace>>")') ik, ib
          write(6,'(8f8.4)') (bfft(i),i=1,120)
       end if
    end if

#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       Phifftr_l(:,map_z(ib),ik) = bfft(:)
       status_saved_phifftr(map_z(ib),ik) = STORED_AND_NEW
    end if
#endif
#ifndef NEC_TUNE_SMP
    call tstatc0_end(id_sname)
#endif
#ifdef SAVE_FFT_TIMES
    end if
#endif

  end subroutine m_ES_WF_in_Rspace1

  subroutine m_ES_WF_in_Rspace0(ik,ib,bfft)
    integer, intent(in)                           :: ik, ib
    real(kind=DP), intent(inout), dimension(nfft) :: bfft
    call m_ES_WF_in_Rspace1(ista_k,iend_k,ik,ib,zaj_l,bfft)
  end subroutine m_ES_WF_in_Rspace0

!!$  integer function cachesize(level)
!!$    integer, intent(in) :: level
!!$    if(level == 1) then
!!$       cachesize = 64
!!$    else if(level == 2) then
!!$       cachesize = 512
!!$    else if(level == 3) then
!!$       cachesize = 1024
!!$    else
!!$       cachesize = 100000
!!$    end if
!!$  end function cachesize

  subroutine m_ES_wd_zaj_small_portion0(str,nc)
    integer, intent(in) :: nc
    character(len=nc), intent(in) :: str

    integer :: ik
    do ik = ista_k, iend_k, af+1                            ! MPI
       if(ipri>=1) call m_ES_wd_zaj_small_portion(nfout,ik,str,nc)
    end do
  end subroutine m_ES_wd_zaj_small_portion0

  subroutine m_ES_wd_eko(nfout,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp
    integer :: j, k
    real(kind=DP) :: c1, vkxyz_wk(3)

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    if(printable) write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0
! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ===================================================================== 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

      if ( sw_band_unfolding == ON .and. mode == EK ) then
         vkxyz_wk(1:3) = vkxyz_refcell(ikp+ik,1:3,BUCS)
      else
         vkxyz_wk(1:3) = vkxyz(ik,1:3,BUCS)
      endif

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          if(printable) write(nfout,'(" ik = ",i7," ( ",3f10.6," )",/99(4f18.10,/))')&
               &ik+ikp,vkxyz_wk(1:3), (eko(neordr(ib,ik)),ib=1,neg-num_extra_bands)
!!$          write(nfout,'(" ik = ",i4,99(4f18.10,/))')&
!!$               &ik,(eko(neordr(ib,ik)),ib=1,neg)
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          if(printable) write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(10f8.4,/))')&
               & ik,vkxyz_wk(1:3), (eko(neordr(ib,ik)),ib=1,neg)
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko

  subroutine m_ES_wd_eko_cond(nfout,ibcm,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode, ibcm
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(ibcm > neg) return

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0
! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ======================================================================= 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          if(iprieigenvalue >= 1) then
             write(nfout,'(" ik = ",i7," ( ",3f10.6," ) [conduction bands]" &
                  & ,/99(4f18.10,/))') ik+ikp,vkxyz(ik,1:3,BUCS) &
                  & , (eko(neordr(ib,ik)),ib=ibcm,neg-num_extra_bands)
          end if
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4f18.10,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          if(iprieigenvalue >= 2) then
             write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(10f8.4,/))')&
                  &ik,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=ibcm,neg)
          end if
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko_cond

  subroutine m_ES_wd_eko2(nfout,mode)
    integer, intent(in) ::                  nfout
    integer, intent(in) ::                  mode
    real(kind=DP), pointer, dimension(:) :: eko, eko_t ! d(neg) MPI

    integer :: ik, ib, ikp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko(neg)); allocate(eko_t(neg))           ! MPI
    write(nfout,*) '=== energy_eigen_values ==='

    ikp = 0

! =========================== modified by K. Tagami =================== 12.0Exp
!    if(mode == EK) ikp = nk_in_the_process - 1
    if (mode == EK) then
       if ( fixed_charge_k_parallel == ONE_BY_ONE ) then
          ikp = nk_in_the_process - 1
       endif
    endif
! ======================================================================= 12.0Exp

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle                 ! MPI
       eko_t = 0                                       ! MPI
       do ib = 1, neg                                  ! MPI
          if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),ik) ! MPI
       end do                                          ! MPI
       call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI
       if(mode == EK .or. ik == 1) then
          write(nfout,'(" ik = ",i7," ( ",3f10.6," )",/99(4f18.10,/))')&
               &ik+ikp,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg-num_extra_bands)
!!$          write(nfout,'(" ik = ",i4,99(4f18.10,/))')&
!!$               &ik,(eko(neordr(ib,ik)),ib=1,neg)
          if(iprieigenvalue >= 2 .and. num_extra_bands >= 1) &
               & write(nfout,'(" -- extra_bands --",/99(4d20.8,/))') &
               & (eko(neordr(ib,ik)),ib=neg-num_extra_bands+1, neg)
       else
          write(nfout,'(" ik = ",i7," (",3f10.6," )",/99(5f20.8,/))')&
               &ik,vkxyz(ik,1:3,BUCS), (eko(neordr(ib,ik)),ib=1,neg)
       endif
    end do
    deallocate(eko); deallocate(eko_t)                 ! MPI
  end subroutine m_ES_wd_eko2

  subroutine m_ES_sum_of_LocalPart(ik,ibo,bpr_l,bpi_l,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi_l(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart


!!$  subroutine m_ES_sum_of_LocalPart(ik,ibo,bpr_l,bpi_l,dz)
!!$    integer, intent(in)                                 :: ik,ibo
!!$    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
!!$    real(kind=DP),intent(out)                           :: dz
!!$
!!$    integer  :: ib, ia, p, q
!!$
!!$    ib = map_z(ibo)
!!$    dz = 0.d0
!!$    do ia = 1, nac
!!$       p = nlmta1(ia); q = nlmta2(ia)
!!$       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi_l(ib,q,ik))
!!$    end do
!!$  end subroutine m_ES_sum_of_LocalPart

! =============================== added by K. Tagami ================= 11.0
  subroutine m_ES_sum_of_LocalPart_noncl( ik,ibo,kst, ken, bpr_l,bpi_l,dz)
    integer, intent(in)  :: ik,ibo
    integer, intent(in)  :: kst, ken
    real(kind=DP), intent(in) :: bpr_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_l(np_e,nlmta,kst:ken)
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q
    integer :: is1, is2, is_tmp, k1, k2
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr_l(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi_l(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi_l(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr_l(ib,q,k2))

             dz = dz + c1 + c2

          End do
       End Do
    end do
  end subroutine m_ES_sum_of_LocalPart_noncl
! ================================================================ 11.0


  subroutine m_ES_sum_of_LocalPart2(ik,ibo,bpr_l,bpi_l,bpr_np,bpi_np,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l,bpr_np,bpi_np !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr_np(ib,q,ik) + bpi_l(ib,p,ik)*bpi_np(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart2

! ============================== added by K. Tagami ======================== 11.0
  subroutine m_ES_sum_of_LocalPart2_noncl( ik, ibo, kst, ken, &
       &                                   bpr_l, bpi_l, &
       &                                   bpr_np, bpi_np, dz )
    integer, intent(in)       :: ik,ibo
    integer, intent(in)       :: kst, ken
    real(kind=DP), intent(in) :: bpr_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_l(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpr_np(np_e,nlmta,kst:ken)
    real(kind=DP), intent(in) :: bpi_np(np_e,nlmta,kst:ken)

    real(kind=DP),intent(out)      :: dz

    integer  :: ib, ia, p, q
    integer :: k1, k2
    integer :: is1, is2, is_tmp
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr_np(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi_np(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi_np(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr_np(ib,q,k2))

             dz = dz + c1 + c2
          Enddo
       End do
    end do
  end subroutine m_ES_sum_of_LocalPart2_noncl
! ==================================================================== 11.0

  subroutine m_ES_sum_of_LocalPart3(ik,ibo,bpr_l,bpi_l,bpr1_l,bpi1_l,dz)
    integer, intent(in)                                 :: ik,ibo
    real(kind=DP),intent(in),dimension(np_e,nlmta,ik:ik):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(in),dimension(np_e,nlmta,ista_k:iend_k):: bpr1_l,bpi1_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       dz = dz + fqwei(ia)*(bpr_l(ib,p,ik)*bpr1_l(ib,q,ik) + bpi_l(ib,p,ik)*bpi1_l(ib,q,ik))
    end do
  end subroutine m_ES_sum_of_LocalPart3


! ============================== added by K. Tagami ======================== 11.0
  subroutine m_ES_sum_of_LocalPart3_noncl( ik, ibo, kst, ken, &
       &                                   bpr_l, bpi_l, &
       &                                   bpr1_l, bpi1_l, dz )
    integer, intent(in) :: ik,ibo
    integer, intent(in) :: kst, ken
    real(kind=DP),intent(in),dimension(np_e,nlmta,kst:ken):: bpr_l,bpi_l !MPI
    real(kind=DP),intent(in),dimension(np_e,nlmta,ista_k:iend_k):: bpr1_l,bpi1_l !MPI
    real(kind=DP),intent(out)                           :: dz

    integer  :: ib, ia, p, q
    integer :: k1, k2
    integer :: is1, is2, is_tmp
    real(kind=DP) :: c1, c2

    ib = map_z(ibo)
    dz = 0.d0
    do ia = 1, nac
       p = nlmta1(ia); q = nlmta2(ia)
       Do is1=1, ndim_spinor
          Do is2=1, ndim_spinor
             is_tmp = (is1 -1 )*ndim_spinor + is2
             k1 = ik + is1 -1
             k2 = ik + is2 -1

             c1 = real( fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpr1_l(ib,q,k2) &
                  &    + bpi_l(ib,p,k1) *bpi1_l(ib,q,k2))
             c2 =-aimag(fqwei_noncl(ia,is_tmp) ) &
                  &   *( bpr_l(ib,p,k1) *bpi1_l(ib,q,k2) &
                  &     -bpi_l(ib,p,k1) *bpr1_l(ib,q,k2))

             dz = dz + c1 + c2
          Enddo
       End do
    end do    
  end subroutine m_ES_sum_of_LocalPart3_noncl
! =========================================================================== 11.0

  subroutine m_ES_cpeko()
    eko1_l = eko_l
  end subroutine m_ES_cpeko

  logical function m_ES_eekdif()
    integer       :: ik, ib
    real(kind=DP) :: fac, tmp, ekosum

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(ekmode == ON .and. evaluation_eko_diff == OFF) then
       m_ES_eekdif = .false.
       return
    end if

    evdff = 0.d0; evdffr = 0.d0

! =================================== modified by K. Tagami ============ 11.0
!!    fac = 1.d0/dble(kv3*neg)
!
    if ( noncol ) then
      fac = 1.0d0 / dble( kv3/ndim_spinor *neg )
    else
      fac = 1.d0/dble(kv3*neg)
    endif
! ====================================================================== 11.0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

    ekosum = 0.d0
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff(1) = evdff(1) + tmp*tmp
          evdff(2) = evdff(2) + dabs(tmp)
          ekosum = ekosum + eko_l(map_z(ib),ik)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff(3) = evdff(3) + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff,evdffr,3 &
         & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       call mpi_allreduce(MPI_IN_PLACE,ekosum,1,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)
       evdff = evdffr
    end if

!!$    if(iprievdff >= 2) write(6,'(" ! evdff = ",3d16.8)') evdff(1:3)
    evdff(1) = dsqrt(fac*evdff(1))*(af+1)
    evdff(2) = fac*evdff(2)*(af+1)
    evdff(3) = fac*evdff(3)*(af+1)

    eko1_l = eko_l

    if(iprievdff >= 1) &
!!$         & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
!!$         &    iteration_electronic, evdff(1), evdff(2), evdff(3)
         & write(nfout,'(" ENERGY EIGEN VALUE SUM. FOR",i6," -TH ITER (K=",i6,":",i6 &
         & ,") = ",F16.8, " <eko_old-eko_new>:(",3d13.5,")")') &
         &   iteration_electronic,nk_in_the_process, nk_in_the_process+kv3-1 &
         & , ekosum, evdff(1), evdff(2), evdff(3)

    if(max(evdff(1),evdff(2)) < delta_eigenvalue) then
       ib = m_CtrlP_ntcnvg_incre()
       if(printable) then
          write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_electronic, ib
          if(iprievdff < 1) &
               & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
               &    iteration_electronic, evdff(1), evdff(2), evdff(3)
       end if
    else
       call m_CtrlP_ntcnvg_reset()    ! K.Mae 030808 
    end if
    m_ES_eekdif = m_CtrlP_ntcnvg_clear()

  end function m_ES_eekdif

  logical function m_ES_eekdif2()
    integer       :: ik, ib, it, kv3_e
    real(kind=DP), allocatable, dimension(:,:) :: evdff2, evdffr2 ! d(3,kv3)
    integer, allocatable, dimension(:)         :: iconv           ! d(kv3)
    real(kind=DP) :: fac, tmp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    if(evaluation_eko_diff == OFF) then
       m_ES_eekdif2 = .false.
       return
    end if

    allocate(evdff2(3,kv3));  evdff2  = 0.d0
    allocate(evdffr2(3,kv3)); evdffr2 = 0.d0
    allocate(iconv(kv3)); iconv = 0

    fac = 1.d0/dble(neg)

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff2(1,ik) = evdff2(1,ik) + tmp*tmp
          evdff2(2,ik) = evdff2(2,ik) + dabs(tmp)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff2(3,ik) = evdff2(3,ik)  &
                  & + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff2,evdffr2,3*kv3 &
            & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       evdff2 = evdffr2
    end if

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
    do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       evdff2(1,ik) = dsqrt(fac*evdff2(1,ik))*(af+1)
       evdff2(2,ik) = fac*evdff2(2,ik)*(af+1)
       evdff2(3,ik) = fac*evdff2(3,ik)*(af+1)
    end do

    eko1_l = eko_l

    if(iprievdff >= 1) then
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
          write(nfout,'(" >> (",i6,") <eko_old-eko_new>(ik=",i6,") :(",3d13.5 &
               & ,")")') iteration_electronic,ik &
               & ,evdff2(1,ik),evdff2(2,ik),evdff2(3,ik)
       end do
    end if

    it = 0
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(max(evdff2(1,ik),evdff2(2,ik)) < delta_eigenvalue) then
          iconv(ik) = EK_CONVERGED
       else
          it = it + 1
       end if
    end do
!!!!!BRANCH_P 3D_Parallel
!!!!    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
!!!!!BRANCH_P_END 3D_Parallel
!!!!!BRANCH_P ORG_Parallel
! === DEBUG for icond=2,3 & one_by_one by tkato 2014/01/24 =====================
    if(first_kpoint_in_this_job == 0) then
       kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    else
       kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1)-first_kpoint_in_this_job+1)
    end if
! ==============================================================================
!!!!!BRANCH_P_END ORG_Parallel
    if(iprievdff >= 2) then
       write(nfout,'(" ! -- iconv_ek(before) -- <<m_ES_eekdif2>>")')
       write(nfout,'(" ! ",10i8)') iconv_ek(1:kv3_ek)
    end if
    do ik = 1, kv3_e
       if(iconv_ek(nk_in_the_process+ik-1) /= EK_CONVERGED) then
          iconv_ek(nk_in_the_process+ik-1) = iconv(ik)
       end if
    end do
!!$    iconv_ek(nk_in_the_process:nk_in_the_process+kv3_e-1) = iconv(1:kv3_e)
    if(iprievdff >= 2) then
       write(nfout,'(" ! -- iconv_ek(after) -- <<m_ES_eekdif2>>")')
       write(nfout,'(" ! ",10i8)') iconv_ek(1:kv3_ek)
    end if

    if(it == 0) then
       ib = m_CtrlP_ntcnvg_incre()
       if(printable) then
          write(nfout,'(" !iter = ",i7," ntcnvg = ",i7)') iteration_electronic, ib
          if(iprievdff < 1) then
! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
             do ik = 1, kv3, ikskip
! ====================================================================== 11.0

                write(nfout,'(" >> (",i5,") <eko_(old-new)>(ik=",i4,")=("&
                     & ,3d12.4 ,", iconv = ",i2,")")') iteration_electronic,ik&
                     & ,evdff2(1,ik),evdff2(2,ik),evdff2(3,ik),iconv(ik)
             end do
          end if
       end if
    else
       call m_CtrlP_ntcnvg_reset()    ! K.Mae 030808 
    end if
    m_ES_eekdif2 = m_CtrlP_ntcnvg_clear()
    deallocate(evdff2,evdffr2)
    deallocate(iconv)
  end function m_ES_eekdif2

  logical function m_ES_eekdif_cond()
    integer       :: ik, ib, ibcm, ipri0
    real(kind=DP) :: fac, tmp

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

!!$    if(evaluation_eko_diff == OFF) then
    if(.not.delta_eigenvalue_cond_is_given) then
       m_ES_eekdif_cond = .true.
       return
    end if

    ibcm = totch/2 + 1.1
    if(printable) write(nfout,'("!m_ES_eekdif_cond: ibcm = ",i8)') ibcm

    evdff = 0.d0; evdffr = 0.d0
    if(neg-ibcm > 0) then
       fac = 1.d0/dble(kv3*(neg-ibcm))
    else
       fac = 1.d0/dble(kv3*neg)
    end if

! ======================= added by K. Tagami ========================= 11.0
    if ( noncol ) fac = fac * dble(ndim_spinor)
! =================================================================== 11.0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0

       if(map_k(ik) /= myrank_k) cycle
       do ib = ista_e, iend_e, istep_e
          if(nrvf_ordr(ib,ik) < ibcm .or. nrvf_ordr(ib,ik) > neg - num_extra_bands) cycle
          tmp = eko_l(map_z(ib),ik) - eko1_l(map_z(ib),ik)
          evdff(1) = evdff(1) + tmp*tmp
          evdff(2) = evdff(2) + dabs(tmp)
          if(dabs(tmp).gt.DELTAevdff) then
             evdff(3) = evdff(3) + dsqrt(dabs(eko1_l(map_z(ib),ik)**2 - eko_l(map_z(ib),ik)**2))
          end if
       end do
    end do

    if(npes > 1) then
       call mpi_allreduce(evdff,evdffr,3 &
         & ,mpi_double_precision,mpi_sum,mpi_comm_group,ierr)  ! MPI
       evdff = evdffr
    end if

    evdff(1) = dsqrt(fac*evdff(1))*(af+1)
    evdff(2) = fac*evdff(2)*(af+1)
    evdff(3) = fac*evdff(3)*(af+1)

    eko1_l = eko_l


    if(iprievdff >= 1) &
         & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,")")') &
         &    iteration_electronic, evdff(1), evdff(2), evdff(3)

    if(max(evdff(1),evdff(2)) < delta_eigenvalue_conduction) then
       m_ES_eekdif_cond = .true.
       if(printable) then
          if(iprievdff < 1) &
               & write(nfout,'(" >> (",i6,") <eko_old-eko_new>:(",3d13.5,") : m_ES_eekdif_cond")') &
               &    iteration_electronic, evdff(1), evdff(2), evdff(3)
       end if
    else
       m_ES_eekdif_cond = .false.
    end if

    call get_ipri0(iprieigenvalue,ipri0)
    if(ipri0 >= 1 ) call m_ES_wd_eko_cond(nfout,ibcm,mode=SCF)

  contains
    subroutine get_ipri0(ipri_in, ipri_out)
      integer, intent(in)  :: ipri_in
      integer, intent(out) :: ipri_out
      if(npes > 1) then
         if(mype == 0) ipri_out = ipri_in
         call mpi_bcast(ipri_out,1,mpi_integer,0,mpi_comm_group,ierr)
      else
         ipri_out = ipri_in
      end if
    end subroutine get_ipri0

  end function m_ES_eekdif_cond

  subroutine m_ES_cp_eko_l_to_eko_ek()
    real(kind=DP),pointer,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))
    eko_t = 0.d0 ; eko_t2 = 0.d0

! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = af +1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3, af+1
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) == myrank_e) eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
         & ,mpi_sum,mpi_k_world(myrank_k),ierr)
    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    if(nk_in_the_process+kv3_e-1>kv3_ek) kv3_e = kv3_ek+1-nk_in_the_process
    eko_ek(:,nk_in_the_process:nk_in_the_process+kv3_e-1) = eko_t2(:,1:kv3_e)
    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_ES_cp_eko_l_to_eko_ek

  subroutine m_ES_cp_eko_l_to_eko_ek2()
    real(kind=DP),allocatable,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0
    integer :: ikt,is, kv3t

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))

    eko_t = 0.d0
! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = 1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) /= myrank_e) cycle
          eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    if(npes >= 2) then
       call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
            &              ,mpi_sum, mpi_comm_group,ierr)
    else
       eko_t2 = eko_t
    end if

    kv3_e = min(kv3,kv3_ek-kv3*(nkgroup-1))
    if(nk_in_the_process+kv3_e-1 > kv3_ek) kv3_e = kv3_ek - nk_in_the_process + 1
    if(kv3_e <=0) kv3_e = 1

    if(sw_modified_kpoint_increment == ON)then
      do ik=0,nrank_k-1
         do is=1,nspin
            ikt = nspin*(nis_kv3_ek(ik)-1)+(nkgroup-1)*nspin+is
            if(ikt>kv3_ek) ikt = kv3_ek
            !eko_ek(:,ikt) = eko_t2(:,(ik-1)*nspin+is)
            eko_ek(:,ikt) = eko_t2(:,ik*nspin+is)
         enddo
      enddo
    else
      eko_ek(:,nk_in_the_process:nk_in_the_process+kv3_e-1) = eko_t2(:,1:kv3_e)
    endif

    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_ES_cp_eko_l_to_eko_ek2

  subroutine m_ES_cp_eko_l_to_eko_ek0()
    real(kind=DP),allocatable,dimension(:,:) :: eko_t, eko_t2 ! d(neg,kv3)
    integer :: ik, ib, kv3_e

! ====================================== added by K. Tagami =============== 11.0
    integer :: ikskip
! ========================================================================= 11.0

    allocate(eko_t(neg,kv3)); allocate(eko_t2(neg,kv3))

    eko_t = 0.d0
! ==================================== added by K. Tagami =============== 11.0
    if ( noncol ) then
      ikskip = ndim_spinor
    else
      ikskip = 1
    endif
! ====================================================================== 11.0

! ================================== modified by K. Tagami ============= 11.0
!!!    do ik = 1, kv3
      do ik = 1, kv3, ikskip
! ====================================================================== 11.0
       if(map_k(ik) /= myrank_k) cycle
       do ib = 1, neg
          if(map_e(ib) /= myrank_e) cycle
          eko_t(ib,ik) = eko_l(map_z(ib),ik)
       end do
    end do
    if(npes >= 2) then
       call mpi_allreduce(eko_t,eko_t2,neg*kv3,mpi_double_precision &
            &              ,mpi_sum, mpi_comm_group,ierr)
    else
       eko_t2 = eko_t
    end if

    eko_ek(:,:) = eko_t2(:,:)

    deallocate(eko_t); deallocate(eko_t2)
  end subroutine m_ES_cp_eko_l_to_eko_ek0

  real(DP) function m_ES_what_is_evdff_now()
    m_ES_what_is_evdff_now = max(evdff(1),evdff(2))
  end function m_ES_what_is_evdff_now

  real(kind=DP) function m_ES_get_energy(ilevel)
    integer, intent(in) :: ilevel
    real(kind=DP), pointer, dimension(:) :: eko, eko_t

    integer :: ib
    allocate(eko(neg)); allocate(eko_t(neg))

    do ib = 1, neg
       if(map_e(ib) == myrank_e) eko_t(ib) = eko_l(map_z(ib),1)
    end do
    call mpi_allreduce(eko_t,eko,neg,mpi_double_precision,mpi_sum,mpi_k_world(myrank_k),ierr) ! MPI

    m_ES_get_energy = eko(neordr(ilevel,1))
  end function m_ES_get_energy

  subroutine m_ES_orbital_population(nfout)
    integer, intent(in) :: nfout

    integer :: is,ik,ib,iopr,i,it,ia,il,im,tau,lmt,ilmta,iksnl, lmtt
    real(kind=DP) :: temp, pup, pdn, fac
    real(kind=DP), dimension(nlmta_phi,2) :: porb_mpi

    if(.not.allocated(porb)) allocate(porb(nlmta_phi,2))

    porb_mpi = 0.d0
    porb   = 0.d0

    is = 1
    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle
       if(nspin==2) is = mod(ik-1,2)+1
       iksnl = (ik-1)/nspin + 1
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do i=1,nlmta_phi
                call m_PP_tell_iorb_lmtt(i,lmtt)
                temp = 0.d0
                if(k_symmetry(ik) == GAMMA) then
                   do iopr = 1,nopr
! =============================== Modified by K. Tagami =====  0.2b
!                      temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2) &
!                           &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                      temp = temp + compr_l(map_z(ib),i,iopr,ik)**2 /2.0 &
                           &      *(1.d0+qorb(i)/(norm_phig(lmtt,iksnl)*2.))
! ==========================================================
                   end do
                else
                   do iopr = 1,nopr
                      temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2 &
                           &         + compi_l(map_z(ib),i,iopr,ik)**2) &
                           &      *(1.d0+qorb(i)/norm_phig(lmtt,iksnl))
                   end do
                end if
                porb_mpi(i,is) = porb_mpi(i,is) + occup_l(map_z(ib),ik)*temp/dble(nopr)
             end do
          end if
       end do
    end do
    call mpi_allreduce(porb_mpi,porb,nlmta_phi*2,mpi_double_precision &
         &            ,mpi_sum,mpi_comm_group,ierr)

    fac = 2.d0/kv3
    do is=1,nspin
       do i=1,nlmta_phi
          porb(i,is) = fac*porb(i,is)
       end do
    end do
    if(nspin == 1) then
       do i=1,nlmta_phi
          porb(i,1)=0.5d0*porb(i,1)
          porb(i,2)=porb(i,1)
       end do
    end if

    pup=0.d0; pdn=0.d0
    do i=1,nlmta_phi
       pup = pup +porb(i,1);    pdn = pdn +porb(i,2)
    end do

    ! Write down Porb
    if(ipri >= 1) then  ! -->
       
       write(nfout,'(" --------- Orbital population ---------")')
       write(nfout,'("  ia   l   m   t    Porb(UP)   Porb(DN) element")')
       do ia=1,natm
          if(if_pdos(ia) == OFF) cycle
! ======================================== Added by K. Tagami == 0.2a =
          if(iproj_group(ia) == 0) cycle
! ================================================================
          it = ityp(ia)
          do lmt=1,ilmt_phi(it)
             ilmta = lmta_phi(lmt,ia)
             il  = ltp_phi(lmt,it)
             im  = mtp_phi(lmt,it)
             tau = taup_phi(lmt,it)
             write(nfout,'(4(1x,i3),2(1x,f10.5),4x,4a)') &
               &    ia, il-1, im, tau, porb(ilmta,1:2), speciesname(it)
          end do
       end do
       write(nfout,'(8x,"Total : ",3(1x,f10.5))') pup,pdn,pup+pdn
       
    end if      ! <--

  end subroutine m_ES_orbital_population

! ============================== added by K. Tagami =================== 11.0
  subroutine m_ES_orbital_population_noncl(nfout)
    integer, intent(in) :: nfout

    integer :: ik,ib,iopr,i,it,ia,il,im,tau,lmt,ilmta,iksnl
    real(kind=DP) :: fac
    integer :: is1, is2, istmp, lmtt

    real(kind=DP), allocatable :: porb_mpi( :,: )
    real(kind=DP) :: porb_sum( ndim_magmom )
    complex(kind=CMPLDP) :: porb_ssrep( nlmta_phi, ndim_magmom )
    complex(kind=CMPLDP) :: z1, z2, ztemp

    if(.not.allocated(porb)) allocate(porb(nlmta_phi,ndim_magmom))

    porb_ssrep = 0.d0;      porb   = 0.d0

    do ik = 1, kv3, ndim_spinor

       if (map_k(ik) /= myrank_k) cycle
       iksnl = (ik-1)/ndim_spinor + 1

       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do i=1,nlmta_phi
                call m_PP_tell_iorb_lmtt(i,lmtt)

                if(k_symmetry(ik) == GAMMA) then
                   stop 'Not supported : Gamma symmetry in noncollinear system.'
                else
                   Do is1=1, ndim_spinor
                      Do is2=1, ndim_spinor
                         istmp = ( is1 -1 )*ndim_spinor + is2
                         
                         ztemp = 0.0d0
                         do iopr = 1,nopr
                            z1 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is1-1 ), &
                                 &       compi_l(map_z(ib),i,iopr,ik+is1-1 ) )
                            z2 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is2-1 ), &
                                 &       compi_l(map_z(ib),i,iopr,ik+is2-1 ) )
                            ztemp = ztemp + z1 *conjg(z2) &
                                 &      *( 1.d0+qorb(i)/norm_phig(lmtt,iksnl) )
                         End do
                         
                         porb_ssrep(i,istmp) = porb_ssrep(i,istmp) &
                              &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                              
                      End do
                   End do

                end if

             end do
          end if
       end do
    end do
! --

    fac = 1.d0 / ( kv3 /ndim_spinor )
    porb_ssrep = porb_ssrep *fac

!------------
    if ( SpinOrbit_mode == BuiltIn ) then
       stop 'kt : Under construction porb '
    endif
! -----

    call m_ES_DensMat_To_MagMom_porb( nlmta_phi, porb_ssrep, porb )

    if ( npes >=2 ) then
       allocate( porb_mpi(nlmta_phi,ndim_magmom ) )
       porb_mpi = 0.0d0
       call mpi_allreduce( porb, porb_mpi, nlmta_phi*ndim_magmom, &
            &              mpi_double_precision, mpi_sum,mpi_comm_group, ierr )
       porb = porb_mpi
       deallocate( porb_mpi )
    endif

    porb_sum = 0.0d0
    do i=1,nlmta_phi
       porb_sum(:) = porb_sum(:) + porb(i,:)
    end do

! Write down Porb
    if (ipri >= 1) then

       write(nfout,'(" --------- Orbital population ---------")')
       write(nfout,'("  ia   l   m   t    Porb(tot)  Porb(mx)   Porb(my)   Porb(mz) element")')
       do ia=1,natm
          if(if_pdos(ia) == OFF) cycle

          if(iproj_group(ia) == 0) cycle

          it = ityp(ia)
          do lmt=1,ilmt_phi(it)
             ilmta = lmta_phi(lmt,ia)
             il  = ltp_phi(lmt,it)
             im  = mtp_phi(lmt,it)
             tau = taup_phi(lmt,it)
             write(nfout,'(4(1x,i3),4(1x,f10.5),4x,4a)') &
                  & ia,il,im,tau,porb(ilmta,1:ndim_magmom),speciesname(it)
          end do
       end do

       write(nfout,'(" -------- summation ---------")')
       write(nfout,'("             total       mx         my         mz")')
       write(nfout,'(8x,4(1x,f10.5))') porb_sum(1:ndim_magmom)

    end if

  end subroutine m_ES_orbital_population_noncl
! ===================================================================== 11.0

  subroutine m_ES_sym_comp(nfout)
    integer, intent(in) :: nfout

    integer :: ik,iopr,mm,jorb,iorb,ib

    do ik=1,kv3
       if(map_k(ik) /= myrank_k) cycle
       if(k_symmetry(ik) == GAMMA) then
          compr_l(:,:,2:nopr,ik) = 0.d0
          do iopr=2,nopr
             do iorb=1,nlmta_phi
                do mm=1,nrorb(iorb,iopr)
                   jorb=irorb(mm,iorb,iopr)
                   do ib=1,np_e
                      compr_l(ib,iorb,iopr,ik) = compr_l(ib,iorb,iopr,ik) &
                           & + compr_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                   end do
                end do
             end do
          end do
       else
          compr_l(:,:,2:nopr,ik) = 0.d0
          compi_l(:,:,2:nopr,ik) = 0.d0
          do iopr=2,nopr
             do iorb=1,nlmta_phi
                do mm=1,nrorb(iorb,iopr)
                   jorb=irorb(mm,iorb,iopr)
                   do ib=1,np_e
                      compr_l(ib,iorb,iopr,ik) = compr_l(ib,iorb,iopr,ik) &
                           & + compr_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                      compi_l(ib,iorb,iopr,ik) = compi_l(ib,iorb,iopr,ik) &
                           & + compi_l(ib,jorb,1,ik)*crorb(mm,iorb,iopr)
                   end do
                end do
             end do
          end do
       end if
    end do

    if(ipri>=2) write(nfout,*) '** compr and compi were symmetrized. **'

  end subroutine m_ES_sym_comp

  subroutine m_ES_orbital_den_mat(nfout,dm,max2lp,max_projs)
    integer, intent(in) :: nfout,max2lp,max_projs
    real(kind=DP), intent(out) :: dm(max2lp,max2lp,max_projs,natm,nspin)

    integer :: is,ik,ib,iopr,i,it,ia,im,lmt,iksnl
    integer :: im1,im2,i1,i2,lmt1,lmt2,ip
    integer :: lmtt, lmtt1, lmtt2

    real(kind=DP) :: temp, fac
    real(kind=DP), dimension(max2lp,max2lp,max_projs,natm,nspin) :: dm_mpi

    dm_mpi = 0.d0
    dm     = 0.d0

    is = 1
    do ik = 1, kv3
       if(map_k(ik) /= myrank_k) cycle
       if(nspin==2) is = mod(ik-1,2)+1
       iksnl = (ik-1)/nspin + 1
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do ia=1,natm
                it = ityp(ia)
                !!if(if_pdos(ia) == OFF) cycle
                if(iproj_group(ia) == 0) cycle

                ! diagonal part
                do lmt=1,ilmt_phi(it)
                   im  = mtp_phi(lmt,it)
                   ip  = iproj_phi(lmt,it)
                   i = lmta_phi(lmt,ia)
                   lmtt = lmtt_phi(lmt,it)

                   temp = 0.d0
                   if(k_symmetry(ik) == GAMMA) then
                      do iopr = 1,nopr
! ============================ Modified by K. Tagami ==== 0.2b
!                         temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2) &
!                             &      *(1.d0+qorb(i)/norm_phig(lmt,iksnl))
                         temp = temp + compr_l(map_z(ib),i,iopr,ik)**2 /2.0 &
                             &      *(1.d0+qorb(i)/(norm_phig(lmtt,iksnl)*2.0))
! ======================================================
                      end do
                   else
                      do iopr = 1,nopr
                         temp = temp + (  compr_l(map_z(ib),i,iopr,ik)**2 &
                              &         + compi_l(map_z(ib),i,iopr,ik)**2) &
                              &      *(1.d0+qorb(i)/norm_phig(lmtt,iksnl))
                      end do
                   end if
                   dm_mpi(im,im,ip,ia,is) = dm_mpi(im,im,ip,ia,is) &
                        &                  + occup_l(map_z(ib),ik)*temp/dble(nopr)
                end do

                ! non-diagonal part
                do lmt2=1,ilmt_phi(it)
                   do lmt1=1,lmt2-1
                      if(ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle
                      ip  = iproj_phi(lmt1,it)
                      im1  = mtp_phi(lmt1,it)
                      i1 = lmta_phi(lmt1,ia)
                      im2  = mtp_phi(lmt2,it)
                      i2 = lmta_phi(lmt2,ia)

                      lmtt1 = lmtt_phi(lmt1,it);     lmtt2 = lmtt_phi(lmt2,it)

                      temp = 0.d0
                      if(k_symmetry(ik) == GAMMA) then
                         do iopr = 1,nopr
! ===================== Modified by K. Tagami ==== ???? === 0.2b
!                            temp = temp + ( &
!                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik)) &
!                                 & /sqrt(norm_phig(lmt1,iksnl)*norm_phig(lmt2,iksnl))
                            temp = temp + ( &
                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik)) &
                                 & /sqrt(norm_phig(lmtt1,iksnl)*norm_phig(lmtt2,iksnl)) / 4.0
! ========================================================
                         end do
                      else
                         do iopr = 1,nopr
                            temp = temp + ( &
                                 &   compr_l(map_z(ib),i1,iopr,ik)*compr_l(map_z(ib),i2,iopr,ik) &
                                 & + compi_l(map_z(ib),i1,iopr,ik)*compi_l(map_z(ib),i2,iopr,ik)) &
                                 & /sqrt(norm_phig(lmtt1,iksnl)*norm_phig(lmtt2,iksnl))
                         end do
                      end if
                      dm_mpi(im1,im2,ip,ia,is) = dm_mpi(im1,im2,ip,ia,is) + occup_l(map_z(ib),ik)*temp/dble(nopr)
                      dm_mpi(im2,im1,ip,ia,is) = dm_mpi(im1,im2,ip,ia,is)
                   end do
                end do
             end do
          end if
       end do
    end do
    call mpi_allreduce(dm_mpi,dm,max2lp**2*max_projs*natm*nspin,mpi_double_precision &
                    & ,mpi_sum,mpi_comm_group,ierr)

    fac = 2.d0/kv3
    dm = fac*dm
    if(nspin == 1) dm = 0.5d0*dm

  end subroutine m_ES_orbital_den_mat

! ================================= added by K. Tagami ================= 11.0
  subroutine m_ES_orbital_den_mat_noncl( nfout, dm, max2lp, max_projs )
!
    integer, intent(in) :: nfout,max2lp,max_projs
    real(kind=DP), intent(out) :: dm(max2lp,max2lp,max_projs,natm,ndim_magmom)

    integer :: ik,ib,iopr,i,it,ia,im,lmt,iksnl
    integer :: im1,im2,i1,i2,lmt1,lmt2,ip
    integer :: lmtt, lmtt1, lmtt2
    integer :: is1, is2, istmp

    real(kind=DP) :: fac
    complex(kind=CMPLDP) :: z1, z2, ztemp
    complex(kind=CMPLDP), allocatable :: dm_ssrep( :, :, :, :, : )

    real(kind=DP), allocatable :: dm_mpi( :, :, :, :, : )

    allocate( dm_ssrep( max2lp, max2lp, max_projs, natm, ndim_chgpot ) )
    dm_ssrep = 0.d0; dm  = 0.d0

    do ik = 1, kv3, ndim_spinor
       if(map_k(ik) /= myrank_k) cycle
       
       iksnl = (ik-1)/ndim_spinor + 1
       
       do ib = 1, neg
          if(map_e(ib) == myrank_e) then
             do ia=1,natm
                it = ityp(ia)
                !!if(if_pdos(ia) == OFF) cycle
                if(iproj_group(ia) == 0) cycle
                
! ------------------------------- diagonal part ----------
                do lmt=1,ilmt_phi(it)
                   im  = mtp_phi(lmt,it)
                   ip  = iproj_phi(lmt,it)
                   i = lmta_phi(lmt,ia)
                   lmtt = lmtt_phi(lmt,it)
                   
                   if (k_symmetry(ik) == GAMMA) then
                      stop 'Not supported : Gamma symmetry in noncollinear system.'
                   else
                      Do is1=1, ndim_spinor
                         Do is2=1, ndim_spinor
                            istmp = ( is1 -1 )*ndim_spinor + is2

                            ztemp = 0.0d0
                            do iopr = 1,nopr
                               z1 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is1-1 ), &
                                    &       compi_l(map_z(ib),i,iopr,ik+is1-1 ) )
                               z2 = dcmplx( compr_l(map_z(ib),i,iopr,ik+is2-1 ), &
                                    &       compi_l(map_z(ib),i,iopr,ik+is2-1 ) )
                               ztemp = ztemp + z1 *conjg(z2) &
                                    &      *( 1.d0+qorb(i)/norm_phig(lmtt,iksnl) )
                            End do

                            dm_ssrep( im, im, ip, ia, istmp ) &
                                 & = dm_ssrep( im, im, ip, ia, istmp ) &
                                 &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                         End do
                      End do
                   end if

                end do

! --------------------  non-diagonal part --------------
                do lmt2 = 1,ilmt_phi(it)
!!!!                   do lmt1=1,lmt2-1

                   do lmt1 = 1, ilmt_phi(it)

                      if ( lmt1 == lmt2 ) cycle
                      if (ltp_phi(lmt1,it) /= ltp_phi(lmt2,it)) cycle

                      ip  = iproj_phi(lmt1,it)
                      im1  = mtp_phi(lmt1,it)
                      i1 = lmta_phi(lmt1,ia)
                      im2  = mtp_phi(lmt2,it)
                      i2 = lmta_phi(lmt2,ia)

                      lmtt1 = lmtt_phi(lmt1,it);   lmtt2 = lmtt_phi(lmt2,it)

                      if (k_symmetry(ik) == GAMMA) then
                         stop 'Not supported : Gamma symmetry in noncollinear system.'
                      else
                         Do is1=1, ndim_spinor
                            Do is2=1, ndim_spinor
                               istmp = ( is1 -1 )*ndim_spinor + is2

                               ztemp = 0.0d0
                               do iopr = 1,nopr
                                  z1 = dcmplx( compr_l(map_z(ib),i1,iopr,ik+is1-1 ), &
                                       &       compi_l(map_z(ib),i1,iopr,ik+is1-1 ) )
                                  z2 = dcmplx( compr_l(map_z(ib),i2,iopr,ik+is2-1 ), &
                                       &       compi_l(map_z(ib),i2,iopr,ik+is2-1 ) )
                                  ztemp = ztemp + z1 *conjg(z2) &
                                       & / sqrt( norm_phig(lmtt1,iksnl) &
                                       &         *norm_phig(lmtt2,iksnl) )
                               End do

                               dm_ssrep( im1, im2, ip, ia, istmp ) &
                                    & = dm_ssrep( im1, im2, ip, ia, istmp ) &
                                    &  + occup_l(map_z(ib),ik) *ztemp /dble(nopr)
                            End do
                         End do
                      end if
                   end do
                end do
! ------------------------------------------------------
             end do
          end if
       end do
    end do
! ----------
    fac = 1.d0 / ( kv3 /ndim_spinor )
    dm_ssrep = dm_ssrep *fac

!------------
    if ( SpinOrbit_mode == BuiltIn ) then
       stop 'kt : Under construction porb '
    endif
! -----

    call m_ES_DensMat_To_MagMom_dm( dm_ssrep, dm, max2lp, max_projs )

    if ( npes > 1 ) then
       allocate( dm_mpi( max2lp, max2lp, max_projs, natm, ndim_magmom ) )
       dm_mpi = 0.0d0

       call mpi_allreduce( dm, dm_mpi, max2lp**2*max_projs*natm*ndim_magmom, &
         &                 mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       dm = dm_mpi
       deallocate( dm_mpi )
    endif
! --

  end subroutine m_ES_orbital_den_mat_noncl
! ================================================================ 11.0

  subroutine m_ES_set_num_bands_super()
    integer :: i
    i = neg*nlpnt
    call m_CntrlP_set_neg(i)
    call m_CntrlP_set_meg(i)
    if(printable) then
       write(nfout,*) 'num_bands will be changed.'
       write(nfout,'("neg,meg=",2i7)') neg,meg
    end if
  end subroutine m_ES_set_num_bands_super

  subroutine m_ES_add_neg(ne)
     integer, intent(in) :: ne
     integer :: newneg
     if(ne==0) return
     newneg = neg+ne
     if(printable) write(nfout,'(a,i6,a,i6)') ' !** the number of bands will change from ',neg,' to ',newneg
     call m_CntrlP_set_neg(newneg)
     call m_CntrlP_set_meg(newneg)
     neg_previous = newneg
     !call m_Parallel_dealloc_mpi_elec()
     !call m_Parallel_init_mpi_elec(nfout,0,printable,neg,kv3,nspin,kg1)
  end subroutine m_ES_add_neg

  subroutine m_ES_cp_zaj_prev_to_zaj()
    if(mype == 0) then
      write(nfout,'(a)') ' !** copied previous wavefunctions to current wavefunctions'
    endif
    zaj_l = zaj_l_prev
  end subroutine m_ES_cp_zaj_prev_to_zaj

  subroutine m_ES_cp_zaj_to_zaj_prev()
    if(mype == 0) then
      write(nfout,'(a)') ' !** copied current wavefunctions to previous wavefunctions'
    endif
    zaj_l_prev = zaj_l
  end subroutine m_ES_cp_zaj_to_zaj_prev

  subroutine map_zaj_to_fft_box(ik,kg1,nfft,psi_l,bfft)
    integer, intent(in):: ik,kg1,nfft
    real(kind=DP), dimension(kg1,kimg), intent(in) :: psi_l
    real(kind=DP), dimension(nfft), intent(out) :: bfft
    integer :: i,i1,ri, j, i2, ii
    integer :: id_sname2=-1
    call tstatc0_begin('map_zaj_to_fft_box ',id_sname2)

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf(1)
          bfft(i1) = psi_l(1,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = igf(i)
             bfft(i1) = psi_l(ii,1)
             j = nbase_gamma(ii,2)
             i2 = igf(j)
             bfft(i2) =   psi_l(ii,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf(1) - 1
          bfft(i1)   = psi_l(1,1)
          bfft(i1+1) = psi_l(1,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba(ik)
!!$             i = nbase(ii,1)
             i = nbase(ii,ik)
             i1 = 2*igf(i)-1
             bfft(i1  ) = psi_l(ii,1)
             bfft(i1+1) = psi_l(ii,2)
             j = nbase_gamma(ii,2)
             i2 = 2*igf(j)-1
             bfft(i2  ) = psi_l(ii,1)
             bfft(i2+1) = -psi_l(ii,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba(ik)
             i1 = kimg*igf(nbase(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,ri)   ! MPI
          end do
       end do
    end if
  end subroutine map_zaj_to_fft_box

#ifdef FFTW3
  subroutine m_ES_gen_zaj_from_prev_zaj(nfout)
    integer, intent(in) :: nfout
    integer :: ib,ik,ri
    integer :: i,j,k, id, nl, nm, nn, nlhf,inew,jnew,knew,ip,mm,is,nl2,nm2,nn2,ig
    integer :: ii,jj,kk,ierr
    integer :: nfft_prev
    real(kind=DP), allocatable, dimension(:) :: xmat,ymat,zmat
    real(kind=DP), allocatable, dimension(:,:,:) :: cmatr, cmati, cmatr2, cmati2
    real(kind=DP) :: trilinear_interpolation
    integer(kind=DP) :: plan
    real(kind=DP), allocatable, dimension(:,:) :: zajtmp
    integer, parameter :: FFTW_MEASURE=0
    integer,save                   :: id_sname = -1
    call tstatc0_begin('m_ES_gen_zaj_from_prev_zaj ', id_sname, 1)
    allocate(bfft(nfft))
    id = fft_box_size_WF_prev(1,0)
    mm = fft_box_size_WF_prev(2,0)
    nl = fft_box_size_WF_prev(1,1)
    nm = fft_box_size_WF_prev(2,1)
    nn = fft_box_size_WF_prev(3,1)
    nl2=nl+2;nm2=nm+2;nn2=nn+2
    nfft_prev = product(fft_box_size_WF_prev(1:3,0)) * kimg
    allocate(afft(nfft_prev))
    allocate(xmat(nl2));allocate(ymat(nm2));allocate(zmat(nn2))
    allocate(cmatr(nl2,nm2,nn2))
    allocate(cmati(nl2,nm2,nn2))
    if(kimg == 1) then
       nlhf = id/2
    else
       nlhf = id
    end if

    if(kimg == 1)then 
      call dfftw_plan_dft_r2c_3d(plan,nl,nm,nn,afft(1),afft(1),FFTW_MEASURE)
    else
      call dfftw_plan_dft_3d(plan,nl,nm,nn,afft(1),afft(1),+1,FFTW_MEASURE)
    endif

    zaj_l = 0.d0
    allocate(zajtmp(kg1_prev,kimg))
    do ik=1,kv3
       if(map_k(ik) /= myrank_k) cycle
!       do ib=ista_e,iend_e,istep_e
       do ib=1,np_e
          zajtmp = 0.d0
          do ig=1,iba_prev(ik)
!             zajtmp(ig,:) = zaj_l_prev(ig,map_z(ib),ik,:)
             zajtmp(ig,:) = zaj_l_prev(ig,ib,ik,:)
          enddo
          call map_zaj_to_fft_box_prev(ik,kg1_prev,nfft_prev,zajtmp,afft)
          if(kimg==1)then
            call dfftw_execute_dft_r2c(plan,afft(1),afft(1))
          else
            call dfftw_execute_dft(plan,afft(1),afft(1))
          endif
          id = fft_box_size_WF_prev(1,0)
          mm = fft_box_size_WF_prev(2,0)
          nl = fft_box_size_WF_prev(1,1)
          nm = fft_box_size_WF_prev(2,1)
          nn = fft_box_size_WF_prev(3,1)
          if(kimg == 1) then
             nlhf = id/2
          else
             nlhf = id
          end if
          cmatr=0.d0
          cmati=0.d0
          do i = 0, nm+1
            do j = 0, nn+1
              do k = 0, nl+1
                ii=i;jj=j;kk=k
                if(i.eq.0) ii = nm
                if(j.eq.0) jj = nn
                if(k.eq.0) kk = nl
                if(i.eq.nm+1) ii = 1
                if(j.eq.nn+1) jj = 1
                if(k.eq.nl+1) kk = 1
                if(kimg == 1 .and. kk > nlhf) then
                   knew = id - kk
                   jnew = nn+2 - jj
                   inew = nm+2 - ii
                   if(jnew > nn) then
                      jnew = jnew - nn
                   end if
                   if(inew > nm) then
                      inew = inew - nm
                   end if
                else
                   knew = kk; jnew = jj; inew = ii
                end if
                ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
                xmat(k+1) = dble(k)/dble(nl)
                ymat(i+1) = dble(i)/dble(nm)
                zmat(j+1) = dble(j)/dble(nn)
                cmatr(k+1,i+1,j+1) = afft(ip*2-1)
                cmati(k+1,i+1,j+1) = afft(ip*2)
              enddo
            enddo
          enddo

          id = fft_box_size_WF(1,0)
          mm = fft_box_size_WF(2,0)
          nl = fft_box_size_WF(1,1)
          nm = fft_box_size_WF(2,1)
          nn = fft_box_size_WF(3,1)
          if(kimg == 1) then
             nlhf = id/2
          else
             nlhf = id
          end if
          bfft=0.d0
          do i = 1, nm
             do j = 1, nn
                do k = 1, nl
                  if(kimg == 1 .and. k > nlhf) then
                     knew = id - k
                     jnew = nn+2 - j
                     inew = nm+2 - i
                     if(jnew > nn) then
                        jnew = jnew - nn
                     end if
                     if(inew > nm) then
                        inew = inew - nm
                     end if
                  else
                     knew = k; jnew = j; inew = i
                  end if
                  ip = nlhf*mm*(jnew-1) + nlhf*(inew-1) + knew
                  bfft(ip*2-1) = trilinear_interpolation( &
               &  nl2,nm2,nn2,cmatr,xmat,ymat,zmat, &
               &  dble(k)/dble(nl),dble(i)/dble(nm),dble(j)/dble(nn))

                  bfft(ip*2) = trilinear_interpolation( &
               &  nl2,nm2,nn2,cmati,xmat,ymat,zmat, &
               &  dble(k)/dble(nl),dble(i)/dble(nm),dble(j)/dble(nn))
                enddo
             enddo
          enddo
          call m_FFT_WF(ELECTRON,nfout,bfft,DIRECT,ON)
          do ri=1,kimg
            do ig=1,iba(ik)
!              zaj_l(ig,map_z(ib),ik,ri) = bfft(kimg*igf(nbase(ig,ik))+(ri-kimg))
              zaj_l(ig,ib,ik,ri) = bfft(kimg*igf(nbase(ig,ik))+(ri-kimg))
            enddo
          enddo
       enddo
    enddo
    deallocate(zaj_l_prev)
    deallocate(zajtmp)
    deallocate(afft)
    deallocate(bfft)
    deallocate(xmat)
    deallocate(ymat)
    deallocate(zmat)
    deallocate(cmatr)
    deallocate(cmati)
    call dfftw_destroy_plan(plan)
    call tstatc0_end(id_sname)

    contains

    subroutine map_zaj_to_fft_box_prev(ik,kg1,nfft,psi_l,bfft)
    integer, intent(in):: ik,kg1,nfft
    real(kind=DP), dimension(kg1,kimg), intent(in) :: psi_l
    real(kind=DP), dimension(nfft), intent(out) :: bfft
    integer :: i,i1,ri, j, i2, ii
    integer :: id_sname2=-1
    call tstatc0_begin('map_zaj_to_fft_box ',id_sname2)

    bfft = 0.d0
    if(k_symmetry(ik) == GAMMA) then
       if(kimg == 1) then
          i1 = igf_prev(1)
          bfft(i1) = psi_l(1,1)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_prev(ik)
!!$             i = nbase(ii,1)
             i = nbase_prev(ii,ik)
             i1 = igf_prev(i)
             bfft(i1) = psi_l(ii,1)
             j = nbase_gamma_prev(ii,2)
             i2 = igf_prev(j)
             bfft(i2) =   psi_l(ii,1)
          end do
       else if(kimg == 2) then
          i1 = 2*igf_prev(1) - 1
          bfft(i1)   = psi_l(1,1)
          bfft(i1+1) = psi_l(1,2)
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do ii = 2, iba_prev(ik)
!!$             i = nbase(ii,1)
             i = nbase_prev(ii,ik)
             i1 = 2*igf_prev(i)-1
             bfft(i1  ) = psi_l(ii,1)
             bfft(i1+1) = psi_l(ii,2)
             j = nbase_gamma_prev(ii,2)
             i2 = 2*igf_prev(j)-1
             bfft(i2  ) = psi_l(ii,1)
             bfft(i2+1) = -psi_l(ii,2)
          end do
       end if
    else
#ifdef NEC_TUNE_SMP
!CDIR NOLOOPCHG
#endif
       do ri = 1, kimg
#ifdef NEC_TUNE_SMP
!CDIR NODEP
#endif
          do i = 1, iba_prev(ik)
             i1 = kimg*igf_prev(nbase_prev(i,ik)) + (ri - kimg)
             bfft(i1) = psi_l(i,ri)   ! MPI
          end do
       end do
    end if
    end subroutine map_zaj_to_fft_box_prev

  end subroutine m_ES_gen_zaj_from_prev_zaj
#endif

  subroutine m_ES_alloc_zaj_l_prev(kg1)
    integer, intent(in) :: kg1
    if(.not.allocated(zaj_l_prev)) allocate(zaj_l_prev(kg1,np_e,ista_k:iend_k,kimg))
  end subroutine m_ES_alloc_zaj_l_prev


  subroutine m_ES_dealloc_zaj_l_prev()
    if(allocated(zaj_l_prev)) deallocate(zaj_l_prev)
  end subroutine m_ES_dealloc_zaj_l_prev

  subroutine m_ES_dealloc(store_prev)
    logical, intent(in), optional :: store_prev
    logical :: unitcell_can_change
    logical :: store
    store = unitcell_can_change() .and. sw_interpolate_wfs == ON
    if(present(store_prev)) then
      if(store_prev) then
        store = .true.
      endif
    endif
    if(allocated(zaj_l_prev)) deallocate(zaj_l_prev)
    if(store) then
      allocate(zaj_l_prev(kg1,np_e,ista_k:iend_k,kimg))
      zaj_l_prev = zaj_l
    endif

    if(allocated(vlhxcQ)) deallocate(vlhxcQ)
    if(allocated(vlhxc_l)) deallocate(vlhxc_l)
    if(allocated(vnlph_l)) deallocate(vnlph_l)   

    if(allocated(zaj_l)) deallocate(zaj_l)
    if(allocated(zaj_l_buf)) deallocate(zaj_l_buf)
#ifdef SAVE_FFT_TIMES
    if(sw_save_fft == ON) then
       if(allocated(Phifftr_l)) deallocate(Phifftr_l)
       if(allocated(status_saved_phifftr)) deallocate(status_saved_phifftr)
    end if
#endif
    if(allocated(fsr_l)) deallocate(fsr_l)   
    if(allocated(fsi_l)) deallocate(fsi_l)   
    if(allocated(eko_l)) deallocate(eko_l)
    if(allocated(occup_l)) deallocate(occup_l)   
    if(allocated(neordr)) deallocate(neordr)   
    if(allocated(nrvf_ordr)) deallocate(nrvf_ordr)   
    if(allocated(eko_ek)) deallocate(eko_ek)   
    if(allocated(eko1_l)) deallocate(eko1_l) 
    if(allocated(evdff)) deallocate(evdff) 
    if(allocated(evdffr)) deallocate(evdffr)
    if(allocated(compr_l)) deallocate(compr_l)
    if(allocated(compi_l)) deallocate(compi_l)
    if(allocated(fsr_add_l)) deallocate(fsr_add_l)
    if(allocated(fsi_add_l)) deallocate(fsi_add_l)

  end subroutine m_ES_dealloc


  subroutine m_ES_add_it_to_vnlph(ik,ib,v)
    integer, intent(in) :: ik,ib
    real(kind=DP), intent(in) :: v(kg1,kimg)

    integer :: ig

    if(kimg==1) then
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + v(ig,1)
       end do
    else
       do ig=1,iba(ik)
          vnlph_l(ig,ib,1) = vnlph_l(ig,ib,1) + v(ig,1)
          vnlph_l(ig,ib,2) = vnlph_l(ig,ib,2) + v(ig,2)
       end do
    end if
  end subroutine m_ES_add_it_to_vnlph

end module m_Electronic_Structure

*
*
* NOTICE : THIS SOURCE IS LIMITTED FOR THE MICROPROCESSORS
*          WHICH ADOPT THE IEEE754 FLOATING POINT ARITHMETIC FORMAT
*          AND OPERATIONS
*
*
       real(8) function machine_epsilon()

       implicit NONE
       real(8) :: eps
       data eps /z'3CB0000000000000'/

       machine_epsilon = eps

       return
       end function  machine_epsilon

*> \brief \b DPOTRS
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DPOTRS + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dpotrs.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dpotrs.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dpotrs.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER          UPLO
*       INTEGER            INFO, LDA, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DPOTRS solves a system of linear equations A*X = B with a symmetric
*> positive definite matrix A using the Cholesky factorization
*> A = U**T*U or A = L*L**T computed by DPOTRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] UPLO
*> \verbatim
*>          UPLO is CHARACTER*1
*>          = 'U':  Upper triangle of A is stored;
*>          = 'L':  Lower triangle of A is stored.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.  N >= 0.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in] A
*> \verbatim
*>          A is DOUBLE PRECISION array, dimension (LDA,N)
*>          The triangular factor U or L from the Cholesky factorization
*>          A = U**T*U or A = L*L**T, as computed by DPOTRF.
*> \endverbatim
*>
*> \param[in] LDA
*> \verbatim
*>          LDA is INTEGER
*>          The leading dimension of the array A.  LDA >= max(1,N).
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the right hand side matrix B.
*>          On exit, the solution matrix X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup doublePOcomputational
*
*  =====================================================================
      SUBROUTINE DPOTRS( UPLO, N, NRHS, A, LDA, B, LDB, INFO )
*
*  -- LAPACK computational routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      CHARACTER          UPLO
      INTEGER            INFO, LDA, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      DOUBLE PRECISION   A( LDA, * ), B( LDB, * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ONE
      PARAMETER          ( ONE = 1.0D+0 )
*     ..
*     .. Local Scalars ..
      LOGICAL            UPPER
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      EXTERNAL           LSAME
*     ..
*     .. External Subroutines ..
      EXTERNAL           DTRSM, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX
*     ..
*     .. Executable Statements ..
*
*     Test the input parameters.
*
      INFO = 0
      UPPER = LSAME( UPLO, 'U' )
      IF( .NOT.UPPER .AND. .NOT.LSAME( UPLO, 'L' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDA.LT.MAX( 1, N ) ) THEN
         INFO = -5
      ELSE IF( LDB.LT.MAX( 1, N ) ) THEN
         INFO = -7
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DPOTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( UPPER ) THEN
*
*        Solve A*X = B where A = U**T *U.
*
*        Solve U**T *X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'Transpose', 'Non-unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
*
*        Solve U*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Upper', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
      ELSE
*
*        Solve A*X = B where A = L*L**T.
*
*        Solve L*X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'No transpose', 'Non-unit', N,
     $               NRHS, ONE, A, LDA, B, LDB )
*
*        Solve L**T *X = B, overwriting B with X.
*
         CALL DTRSM( 'Left', 'Lower', 'Transpose', 'Non-unit', N, NRHS,
     $               ONE, A, LDA, B, LDB )
      END IF
*
      RETURN
*
*     End of DPOTRS
*
      END

      SUBROUTINE PZHEEV( JOBZ, UPLO, N, A, IA, JA, DESCA, W, Z, IZ, JZ,
     $                   DESCZ, WORK, LWORK, RWORK, LRWORK, INFO )
*
*  -- ScaLAPACK routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     August 14, 2001 
*
*     .. Scalar Arguments ..
      CHARACTER          JOBZ, UPLO
      INTEGER            IA, INFO, IZ, JA, JZ, LRWORK, LWORK, N
*     ..
*     .. Array Arguments ..
      INTEGER            DESCA( * ), DESCZ( * )
      DOUBLE PRECISION   RWORK( * ), W( * )
      COMPLEX*16         A( * ), WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PZHEEV computes selected eigenvalues and, optionally, eigenvectors
*  of a real symmetric matrix A by calling the recommended sequence
*  of ScaLAPACK routines.
*
*  In its present form, PZHEEV assumes a homogeneous system and makes
*  only spot checks of the consistency of the eigenvalues across the
*  different processes.  Because of this, it is possible that a
*  heterogeneous system may return incorrect results without any error
*  messages.
*
*  Notes
*  =====
*  A description vector is associated with each 2D block-cyclicly dis-
*  tributed matrix.  This vector stores the information required to
*  establish the mapping between a matrix entry and its corresponding
*  process and memory location.
*
*  In the following comments, the character _ should be read as
*  "of the distributed matrix".  Let A be a generic term for any 2D
*  block cyclicly distributed matrix.  Its description vector is DESCA:
*
*  NOTATION        STORED IN      EXPLANATION
*  --------------- -------------- --------------------------------------
*  DTYPE_A(global) DESCA( DTYPE_) The descriptor type.
*  CTXT_A (global) DESCA( CTXT_ ) The BLACS context handle, indicating
*                                 the BLACS process grid A is distribu-
*                                 ted over. The context itself is glo-
*                                 bal, but the handle (the integer
*                                 value) may vary.
*  M_A    (global) DESCA( M_ )    The number of rows in the distributed
*                                 matrix A.
*  N_A    (global) DESCA( N_ )    The number of columns in the distri-
*                                 buted matrix A.
*  MB_A   (global) DESCA( MB_ )   The blocking factor used to distribute
*                                 the rows of A.
*  NB_A   (global) DESCA( NB_ )   The blocking factor used to distribute
*                                 the columns of A.
*  RSRC_A (global) DESCA( RSRC_ ) The process row over which the first
*                                 row of the matrix A is distributed.
*  CSRC_A (global) DESCA( CSRC_ ) The process column over which the
*                                 first column of A is distributed.
*  LLD_A  (local)  DESCA( LLD_ )  The leading dimension of the local
*                                 array storing the local blocks of the
*                                 distributed matrix A.
*                                 LLD_A >= MAX(1,LOCr(M_A)).
*
*  Let K be the number of rows or columns of a distributed matrix,
*  and assume that its process grid has dimension p x q.
*  LOCr( K ) denotes the number of elements of K that a process
*  would receive if K were distributed over the p processes of its
*  process column.
*  Similarly, LOCc( K ) denotes the number of elements of K that a
*  process would receive if K were distributed over the q processes of
*  its process row.
*  The values of LOCr() and LOCc() may be determined via a call to the
*  ScaLAPACK tool function, NUMROC:
*          LOCr( M ) = NUMROC( M, MB_A, MYROW, RSRC_A, NPROW ),
*          LOCc( N ) = NUMROC( N, NB_A, MYCOL, CSRC_A, NPCOL ).
*
*  Arguments
*  =========
*
*     NP = the number of rows local to a given process.
*     NQ = the number of columns local to a given process.
*
*  JOBZ    (global input) CHARACTER*1
*          Specifies whether or not to compute the eigenvectors:
*          = 'N':  Compute eigenvalues only.
*          = 'V':  Compute eigenvalues and eigenvectors.
*
*  UPLO    (global input) CHARACTER*1
*          Specifies whether the upper or lower triangular part of the
*          symmetric matrix A is stored:
*          = 'U':  Upper triangular
*          = 'L':  Lower triangular
*
*  N       (global input) INTEGER
*          The number of rows and columns of the matrix A.  N >= 0.
*
*  A       (local input/workspace) block cyclic COMPLEX*16 array,
*          global dimension (N, N), local dimension ( LLD_A,
*          LOCc(JA+N-1) )
*
*          On entry, the symmetric matrix A.  If UPLO = 'U', only the
*          upper triangular part of A is used to define the elements of
*          the symmetric matrix.  If UPLO = 'L', only the lower
*          triangular part of A is used to define the elements of the
*          symmetric matrix.
*
*          On exit, the lower triangle (if UPLO='L') or the upper
*          triangle (if UPLO='U') of A, including the diagonal, is
*          destroyed.
*
*  IA      (global input) INTEGER
*          A's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JA      (global input) INTEGER
*          A's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCA   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix A.
*          If DESCA( CTXT_ ) is incorrect, PZHEEV cannot guarantee
*          correct error reporting.
*
*  W       (global output) DOUBLE PRECISION array, dimension (N)
*          On normal exit, the first M entries contain the selected
*          eigenvalues in ascending order.
*
*  Z       (local output) COMPLEX*16 array,
*          global dimension (N, N),
*          local dimension (LLD_Z, LOCc(JZ+N-1))
*          If JOBZ = 'V', then on normal exit the first M columns of Z
*          contain the orthonormal eigenvectors of the matrix
*          corresponding to the selected eigenvalues.
*          If JOBZ = 'N', then Z is not referenced.
*
*  IZ      (global input) INTEGER
*          Z's global row index, which points to the beginning of the
*          submatrix which is to be operated on.
*
*  JZ      (global input) INTEGER
*          Z's global column index, which points to the beginning of
*          the submatrix which is to be operated on.
*
*  DESCZ   (global and local input) INTEGER array of dimension DLEN_.
*          The array descriptor for the distributed matrix Z.
*          DESCZ( CTXT_ ) must equal DESCA( CTXT_ )
*
*  WORK    (local workspace/output) COMPLEX*16 array,
*          dimension (LWORK)
*          On output, WORK(1) returns the workspace needed to guarantee
*          completion.  If the input parameters are incorrect, WORK(1)
*          may also be incorrect.
*
*          If JOBZ='N' WORK(1) = minimal workspace for eigenvalues only.
*          If JOBZ='V' WORK(1) = minimal workspace required to
*             generate all the eigenvectors.
*
*
*  LWORK   (local input) INTEGER
*          See below for definitions of variables used to define LWORK.
*          If no eigenvectors are requested (JOBZ = 'N') then
*             LWORK >= MAX( NB*( NP0+1 ), 3 ) +3*N
*          If eigenvectors are requested (JOBZ = 'V' ) then
*          the amount of workspace required:
*             LWORK >= (NP0 + NQ0 + NB)*NB + 3*N + N^2
*
*          Variable definitions:
*             NB = DESCA( MB_ ) = DESCA( NB_ ) =
*                  DESCZ( MB_ ) = DESCZ( NB_ )
*             NP0 = NUMROC( NN, NB, 0, 0, NPROW )
*             NQ0 = NUMROC( MAX( N, NB, 2 ), NB, 0, 0, NPCOL )
*
*          If LWORK = -1, the LWORK is global input and a workspace
*          query is assumed; the routine only calculates the minimum
*          size for the WORK array.  The required workspace is returned
*          as the first element of WORK and no error message is issued
*          by PXERBLA.
*
*  RWORK   (local workspace/output) COMPLEX*16 array,
*          dimension (LRWORK)
*          On output RWORK(1) returns the
*          DOUBLE PRECISION workspace needed to
*          guarantee completion.  If the input parameters are incorrect,
*          RWORK(1) may also be incorrect.
*
*  LRWORK  (local input) INTEGER
*          Size of RWORK array.
*          If eigenvectors are desired (JOBZ = 'V') then
*             LRWORK >= 2*N + 2*N-2
*          If eigenvectors are not desired (JOBZ = 'N') then
*             LRWORK >= 2*N
*
*          If LRWORK = -1, the LRWORK is global input and a workspace
*          query is assumed; the routine only calculates the minimum
*          size for the RWORK array.  The required workspace is returned
*          as the first element of RWORK and no error message is issued
*          by PXERBLA.
*
*  INFO    (global output) INTEGER
*          = 0:  successful exit
*          < 0:  If the i-th argument is an array and the j-entry had
*                an illegal value, then INFO = -(i*100+j), if the i-th
*                argument is a scalar and had an illegal value, then
*                INFO = -i.
*          > 0:  If INFO = 1 through N, the i(th) eigenvalue did not
*                converge in ZSTEQR2 after a total of 30*N iterations.
*                If INFO = N+1, then PZHEEV has detected heterogeneity
*                by finding that eigenvalues were not identical across
*                the process grid.  In this case, the accuracy of
*                the results from PZHEEV cannot be guaranteed.
*
*  Alignment requirements
*  ======================
*
*  The distributed submatrices A(IA:*, JA:*) and C(IC:IC+M-1,JC:JC+N-1)
*  must verify some alignment properties, namely the following
*  expressions should be true:
*
*  ( MB_A.EQ.NB_A.EQ.MB_Z .AND. IROFFA.EQ.IROFFZ .AND. IROFFA.EQ.0 .AND.
*    IAROW.EQ.IZROW )
*  where
*  IROFFA = MOD( IA-1, MB_A ) and ICOFFA = MOD( JA-1, NB_A ).
*
*  =====================================================================
*
*  Version 1.4 limitations:
*     DESCA(MB_) = DESCA(NB_)
*     DESCA(M_) = DESCZ(M_)
*     DESCA(N_) = DESCZ(N_)
*     DESCA(MB_) = DESCZ(MB_)
*     DESCA(NB_) = DESCZ(NB_)
*     DESCA(RSRC_) = DESCZ(RSRC_)
*
*     .. Parameters ..
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
      DOUBLE PRECISION   ZERO, ONE
      PARAMETER          ( ZERO = 0.0D+0, ONE = 1.0D+0 )
      COMPLEX*16         CZERO, CONE
      PARAMETER          ( CZERO = ( 0.0D+0, 0.0D+0 ),
     $                   CONE = ( 1.0D+0, 0.0D+0 ) )
      INTEGER            ITHVAL
      PARAMETER          ( ITHVAL = 10 )
*     ..
*     .. Local Scalars ..
      LOGICAL            LOWER, WANTZ
      INTEGER            CONTEXTC, CSRC_A, I, IACOL, IAROW, ICOFFA,
     $                   IINFO, INDD, INDE, INDRD, INDRE, INDRWORK,
     $                   INDTAU, INDWORK, INDWORK2, IROFFA, IROFFZ,
     $                   ISCALE, IZROW, J, K, LDC, LLRWORK, LLWORK,
     $                   LRMIN, LRWMIN, LWMIN, MB_A, MB_Z, MYCOL,
     $                   MYPCOLC, MYPROWC, MYROW, NB, NB_A, NB_Z, NP0,
     $                   NPCOL, NPCOLC, NPROCS, NPROW, NPROWC, NQ0, NRC,
     $                   RSIZEZSTEQR2, RSRC_A, RSRC_Z, SIZEPZHETRD,
     $                   SIZEPZUNMTR, SIZEZSTEQR2
      DOUBLE PRECISION   ANRM, BIGNUM, EPS, RMAX, RMIN, SAFMIN, SIGMA,
     $                   SMLNUM
*     ..
*     .. Local Arrays ..
      INTEGER            DESCQR( 10 ), IDUM1( 3 ), IDUM2( 3 )
*     ..
*     .. External Functions ..
      LOGICAL            LSAME
      INTEGER            INDXG2P, NUMROC, SL_GRIDRESHAPE
      DOUBLE PRECISION   PDLAMCH, PZLANHE
      EXTERNAL           LSAME, INDXG2P, NUMROC, SL_GRIDRESHAPE,
     $                   PDLAMCH, PZLANHE
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDEXIT, BLACS_GRIDINFO, CHK1MAT, DCOPY,
     $                   DESCINIT, DGAMN2D, DGAMX2D, DSCAL, PCHK1MAT,
     $                   PCHK2MAT, PXERBLA, PZELGET, PZGEMR2D, PZHETRD,
     $                   PZLASCL, PZLASET, PZUNMTR, ZSTEQR2
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS, DBLE, DCMPLX, ICHAR, INT, MAX, MIN, MOD,
     $                   SQRT
*     ..
*     .. Executable Statements ..
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
*     Quick return
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Test the input arguments.
*
      CALL BLACS_GRIDINFO( DESCA( CTXT_ ), NPROW, NPCOL, MYROW, MYCOL )
      INFO = 0
*
*     Initialize pointer to some safe value
*
      INDTAU = 1
      INDD = 1
      INDE = 1
      INDWORK = 1
      INDWORK2 = 1
*
      INDRE = 1
      INDRD = 1
      INDRWORK = 1
*
      WANTZ = LSAME( JOBZ, 'V' )
      IF( NPROW.EQ.-1 ) THEN
         INFO = -( 700+CTXT_ )
      ELSE IF( WANTZ ) THEN
         IF( DESCA( CTXT_ ).NE.DESCZ( CTXT_ ) ) THEN
            INFO = -( 1200+CTXT_ )
         END IF
      END IF
      IF( INFO.EQ.0 ) THEN
         CALL CHK1MAT( N, 3, N, 3, IA, JA, DESCA, 7, INFO )
         IF( WANTZ )
     $      CALL CHK1MAT( N, 3, N, 3, IZ, JZ, DESCZ, 12, INFO )
*
         IF( INFO.EQ.0 ) THEN
*
*           Get machine constants.
*
            SAFMIN = PDLAMCH( DESCA( CTXT_ ), 'Safe minimum' )
            EPS = PDLAMCH( DESCA( CTXT_ ), 'Precision' )
            SMLNUM = SAFMIN / EPS
            BIGNUM = ONE / SMLNUM
            RMIN = SQRT( SMLNUM )
            RMAX = MIN( SQRT( BIGNUM ), ONE / SQRT( SQRT( SAFMIN ) ) )
*
            NPROCS = NPROW*NPCOL
            NB_A = DESCA( NB_ )
            MB_A = DESCA( MB_ )
            NB = NB_A
            LOWER = LSAME( UPLO, 'L' )
*
            RSRC_A = DESCA( RSRC_ )
            CSRC_A = DESCA( CSRC_ )
            IROFFA = MOD( IA-1, MB_A )
            ICOFFA = MOD( JA-1, NB_A )
            IAROW = INDXG2P( 1, NB_A, MYROW, RSRC_A, NPROW )
            IACOL = INDXG2P( 1, MB_A, MYCOL, CSRC_A, NPCOL )
            NP0 = NUMROC( N+IROFFA, NB, MYROW, IAROW, NPROW )
            NQ0 = NUMROC( N+ICOFFA, NB, MYCOL, IACOL, NPCOL )
            IF( WANTZ ) THEN
               NB_Z = DESCZ( NB_ )
               MB_Z = DESCZ( MB_ )
               RSRC_Z = DESCZ( RSRC_ )
               IROFFZ = MOD( IZ-1, MB_A )
               IZROW = INDXG2P( 1, NB_A, MYROW, RSRC_Z, NPROW )
            END IF
*
*           COMPLEX*16 work space for PZHETRD
*
            CALL PZHETRD( UPLO, N, A, IA, JA, DESCA, RWORK( INDD ),
     $                    RWORK( INDE ), WORK( INDTAU ),
     $                    WORK( INDWORK ), -1, IINFO )
            SIZEPZHETRD = INT( ABS( WORK( 1 ) ) )
*
*           COMPLEX*16 work space for PZUNMTR
*
            IF( WANTZ ) THEN
               CALL PZUNMTR( 'L', UPLO, 'N', N, N, A, IA, JA, DESCA,
     $                       WORK( INDTAU ), Z, IZ, JZ, DESCZ,
     $                       WORK( INDWORK ), -1, IINFO )
               SIZEPZUNMTR = INT( ABS( WORK( 1 ) ) )
            ELSE
               SIZEPZUNMTR = 0
            END IF
*
*           DOUBLE PRECISION work space for ZSTEQR2
*
            IF( WANTZ ) THEN
               RSIZEZSTEQR2 = MIN( 1, 2*N-2 )
            ELSE
               RSIZEZSTEQR2 = 0
            END IF
*
*           Initialize the context of the single column distributed
*           matrix required by ZSTEQR2. This specific distribution
*           allows each process to do 1/pth of the work updating matrix
*           Q during ZSTEQR2 and achieve some parallelization to an
*           otherwise serial subroutine.
*
            LDC = 0
            IF( WANTZ ) THEN
               CONTEXTC = SL_GRIDRESHAPE( DESCA( CTXT_ ), 0, 1, 1,
     $                    NPROCS, 1 )
               CALL BLACS_GRIDINFO( CONTEXTC, NPROWC, NPCOLC, MYPROWC,
     $                              MYPCOLC )
               NRC = NUMROC( N, NB_A, MYPROWC, 0, NPROCS )
               LDC = MAX( 1, NRC )
               CALL DESCINIT( DESCQR, N, N, NB, NB, 0, 0, CONTEXTC, LDC,
     $                        INFO )
            END IF
*
*           COMPLEX*16 work space for ZSTEQR2
*
            IF( WANTZ ) THEN
               SIZEZSTEQR2 = N*LDC
            ELSE
               SIZEZSTEQR2 = 0
            END IF
*
*           Set up pointers into the WORK array
*
            INDTAU = 1
            INDD = INDTAU + N
            INDE = INDD + N
            INDWORK = INDE + N
            INDWORK2 = INDWORK + N*LDC
            LLWORK = LWORK - INDWORK + 1
*
*           Set up pointers into the RWORK array
*
            INDRE = 1
            INDRD = INDRE + N
            INDRWORK = INDRD + N
            LLRWORK = LRWORK - INDRWORK + 1
*
*           Compute the total amount of space needed
*
            LRWMIN = 2*N + RSIZEZSTEQR2
            LWMIN = 3*N + MAX( SIZEPZHETRD, SIZEPZUNMTR, SIZEZSTEQR2 )
*
         END IF
         IF( INFO.EQ.0 ) THEN
            IF( .NOT.( WANTZ .OR. LSAME( JOBZ, 'N' ) ) ) THEN
               INFO = -1
            ELSE IF( .NOT.( LOWER .OR. LSAME( UPLO, 'U' ) ) ) THEN
               INFO = -2
            ELSE IF( LWORK.LT.LWMIN .AND. LWORK.NE.-1 ) THEN
               INFO = -14
            ELSE IF( LRWORK.LT.LRWMIN .AND. LRWORK.NE.-1 ) THEN
               INFO = -16
            ELSE IF( IROFFA.NE.0 ) THEN
               INFO = -5
            ELSE IF( DESCA( MB_ ).NE.DESCA( NB_ ) ) THEN
               INFO = -( 700+NB_ )
            END IF
            IF( WANTZ ) THEN
               IF( IROFFA.NE.IROFFZ ) THEN
                  INFO = -10
               ELSE IF( IAROW.NE.IZROW ) THEN
                  INFO = -10
               ELSE IF( DESCA( M_ ).NE.DESCZ( M_ ) ) THEN
                  INFO = -( 1200+M_ )
               ELSE IF( DESCA( N_ ).NE.DESCZ( N_ ) ) THEN
                  INFO = -( 1200+N_ )
               ELSE IF( DESCA( MB_ ).NE.DESCZ( MB_ ) ) THEN
                  INFO = -( 1200+MB_ )
               ELSE IF( DESCA( NB_ ).NE.DESCZ( NB_ ) ) THEN
                  INFO = -( 1200+NB_ )
               ELSE IF( DESCA( RSRC_ ).NE.DESCZ( RSRC_ ) ) THEN
                  INFO = -( 1200+RSRC_ )
               ELSE IF( DESCA( CTXT_ ).NE.DESCZ( CTXT_ ) ) THEN
                  INFO = -( 1200+CTXT_ )
               END IF
            END IF
         END IF
         IF( WANTZ ) THEN
            IDUM1( 1 ) = ICHAR( 'V' )
         ELSE
            IDUM1( 1 ) = ICHAR( 'N' )
         END IF
         IDUM2( 1 ) = 1
         IF( LOWER ) THEN
            IDUM1( 2 ) = ICHAR( 'L' )
         ELSE
            IDUM1( 2 ) = ICHAR( 'U' )
         END IF
         IDUM2( 2 ) = 2
         IF( LWORK.EQ.-1 ) THEN
            IDUM1( 3 ) = -1
         ELSE
            IDUM1( 3 ) = 1
         END IF
         IDUM2( 3 ) = 3
         IF( WANTZ ) THEN
            CALL PCHK2MAT( N, 3, N, 3, IA, JA, DESCA, 7, N, 3, N, 3, IZ,
     $                     JZ, DESCZ, 12, 3, IDUM1, IDUM2, INFO )
         ELSE
            CALL PCHK1MAT( N, 3, N, 3, IA, JA, DESCA, 7, 3, IDUM1,
     $                     IDUM2, INFO )
         END IF
         WORK( 1 ) = DCMPLX( LWMIN )
         RWORK( 1 ) = DBLE( LRWMIN )
      END IF
*
      IF( INFO.NE.0 ) THEN
         CALL PXERBLA( DESCA( CTXT_ ), 'PZHEEV', -INFO )
         IF( WANTZ )
     $      CALL BLACS_GRIDEXIT( CONTEXTC )
         RETURN
      ELSE IF( LWORK.EQ.-1 .OR. LRWORK.EQ.-1 ) THEN
         IF( WANTZ )
     $      CALL BLACS_GRIDEXIT( CONTEXTC )
         RETURN
      END IF
*
*     Scale matrix to allowable range, if necessary.
*
      ISCALE = 0
*
      ANRM = PZLANHE( 'M', UPLO, N, A, IA, JA, DESCA,
     $       RWORK( INDRWORK ) )
*
*
      IF( ANRM.GT.ZERO .AND. ANRM.LT.RMIN ) THEN
         ISCALE = 1
         SIGMA = RMIN / ANRM
      ELSE IF( ANRM.GT.RMAX ) THEN
         ISCALE = 1
         SIGMA = RMAX / ANRM
      END IF
*
      IF( ISCALE.EQ.1 ) THEN
         CALL PZLASCL( UPLO, ONE, SIGMA, N, N, A, IA, JA, DESCA, IINFO )
      END IF
*
*     Reduce symmetric matrix to tridiagonal form.
*
      CALL PZHETRD( UPLO, N, A, IA, JA, DESCA, RWORK( INDRD ),
     $              RWORK( INDRE ), WORK( INDTAU ), WORK( INDWORK ),
     $              LLWORK, IINFO )
*
*     Copy the values of D, E to all processes.
*
      DO 10 I = 1, N
         CALL PZELGET( 'A', ' ', WORK( INDD+I-1 ), A, I+IA-1, I+JA-1,
     $                 DESCA )
         RWORK( INDRD+I-1 ) = DBLE( WORK( INDD+I-1 ) )
   10 CONTINUE
      IF( LSAME( UPLO, 'U' ) ) THEN
         DO 20 I = 1, N - 1
            CALL PZELGET( 'A', ' ', WORK( INDE+I-1 ), A, I+IA-1, I+JA,
     $                    DESCA )
            RWORK( INDRE+I-1 ) = DBLE( WORK( INDE+I-1 ) )
   20    CONTINUE
      ELSE
         DO 30 I = 1, N - 1
            CALL PZELGET( 'A', ' ', WORK( INDE+I-1 ), A, I+IA, I+JA-1,
     $                    DESCA )
            RWORK( INDRE+I-1 ) = DBLE( WORK( INDE+I-1 ) )
   30    CONTINUE
      END IF
*
      IF( WANTZ ) THEN
*
         CALL PZLASET( 'Full', N, N, CZERO, CONE, WORK( INDWORK ), 1, 1,
     $                 DESCQR )
*
*        ZSTEQR2 is a modified version of LAPACK's CSTEQR.  The
*        modifications allow each process to perform partial updates
*        to matrix Q.
*
         CALL ZSTEQR2( 'I', N, RWORK( INDRD ), RWORK( INDRE ),
     $                 WORK( INDWORK ), LDC, NRC, RWORK( INDRWORK ),
     $                 INFO )
*
         CALL PZGEMR2D( N, N, WORK( INDWORK ), 1, 1, DESCQR, Z, IA, JA,
     $                  DESCZ, CONTEXTC )
*
         CALL PZUNMTR( 'L', UPLO, 'N', N, N, A, IA, JA, DESCA,
     $                 WORK( INDTAU ), Z, IZ, JZ, DESCZ,
     $                 WORK( INDWORK ), LLWORK, IINFO )
*
      ELSE
*
         CALL ZSTEQR2( 'N', N, RWORK( INDRD ), RWORK( INDRE ),
     $                 WORK( INDWORK ), 1, 1, RWORK( INDRWORK ), INFO )
      END IF
*
*     Copy eigenvalues from workspace to output array
*
      CALL DCOPY( N, RWORK( INDD ), 1, W, 1 )
*
*     If matrix was scaled, then rescale eigenvalues appropriately.
*
      IF( ISCALE.EQ.1 ) THEN
         CALL DSCAL( N, ONE / SIGMA, W, 1 )
      END IF
*
      WORK( 1 ) = DBLE( LWMIN )
*
*     Free up resources
*
      IF( WANTZ ) THEN
         CALL BLACS_GRIDEXIT( CONTEXTC )
      END IF
*
*     Compare every ith eigenvalue, or all if there are only a few,
*     across the process grid to check for heterogeneity.
*
      IF( N.LE.ITHVAL ) THEN
         J = N
         K = 1
      ELSE
         J = N / ITHVAL
         K = ITHVAL
      END IF
*
      LRMIN = INT( RWORK( 1 ) )
      INDTAU = 0
      INDE = INDTAU + J
      DO 40 I = 1, J
         RWORK( I+INDTAU ) = W( ( I-1 )*K+1 )
         RWORK( I+INDE ) = W( ( I-1 )*K+1 )
   40 CONTINUE
*
      CALL DGAMN2D( DESCA( CTXT_ ), 'All', ' ', J, 1, RWORK( 1+INDTAU ),
     $              J, 1, 1, -1, -1, 0 )
      CALL DGAMX2D( DESCA( CTXT_ ), 'All', ' ', J, 1, RWORK( 1+INDE ),
     $              J, 1, 1, -1, -1, 0 )
*
      DO 50 I = 1, J
         IF( INFO.EQ.0 .AND. ( RWORK( I+INDTAU )-RWORK( I+INDE ).NE.
     $       ZERO ) ) THEN
            INFO = N + 1
         END IF
   50 CONTINUE
      RWORK( 1 ) = LRMIN
*
      RETURN
*
*     End of PZHEEV
*
      END

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: Preparation_ep
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
subroutine Preparation_ep
! $Id: Preparation_ep.f90 570 2017-04-21 20:34:50Z yamasaki $
  use m_Control_Parameters,only: m_CtrlP_set_wct_start
  use m_Files,             only: nfout
  use m_Crystal_Structure, only: nbztyp_spg, m_CS_alloc_op_tau &
       &                       , m_CS_gnrt_symmetry_operations
  use m_Ionic_System,      only: m_IS_alloc_napt &
       &                       , m_IS_symm_check_of_pos
  use m_Force,             only: m_Force_alloc

  implicit none

  call m_CtrlP_set_wct_start                   !  (ckcput)
!!$  if(nbztyp_spg >= GENERAL) call m_Files_open_
!!$  call m_CS_gnrt_symmetry_operations(.true.,nfout,nfspg)
  call m_CS_gnrt_symmetry_operations(.true.,nfout)
!!$  if(.not.paramset) then
     call m_CS_alloc_op_tau(nfout)
!!$     call m_CS_gnrt_symmetry_operations(.false.,nfout,nfspg)
     call m_CS_gnrt_symmetry_operations(.false.,nfout)
     call m_IS_alloc_napt()
     call m_IS_symm_check_of_pos()
!!$  end if
  call m_Force_alloc()
end subroutine Preparation_ep

         subroutine eigen_s(n, a, lda, w, z, ldz, m)
         implicit NONE
*-
         integer, intent(in)    :: n, lda, ldz, m
         real(8), intent(inout) :: a(lda,*), w(*), z(ldz,*)
         real(8), pointer       :: d(:), e(:), e2(:)
*-
         real(8)                :: hs0, hs1, s0, s1, FPS
         integer                :: m0, my_rank, world_size, INFO, ierr,i
         include 'mpif.h'
         include 'commtxt.h'
*-
         allocate(d(1:n), e(1:n), e2(1:n))
*-
         hs0 = MPI_Wtime()
         call MPI_Comm_size(MPI_COMM_EIGEN, world_size, ierr)
         call MPI_Comm_rank(MPI_COMM_EIGEN, my_rank,    ierr)
*-
         s0 = MPI_Wtime()

            call tred1(n, a(1,1), lda, d(1), e(1), m)

         s1 = MPI_Wtime()

         if(my_rank==0)then
            print*,"TRD-BLK",n," ",s1-s0," ",
     &               1*dble(n)**3*4/3/(s1-s0)*1D-9,"GFLOPS"
            print*,"TRD-BLK-INFO",n," ",m
         endif
         call flush(6)
*-
         s0 = MPI_Wtime()

            e2(1:n) = e(1:n)
            w(1:n)  = d(1:n)

            call dc(n, w(1), e2(2), z(1,1), ldz, INFO, FPS)

         s1 = MPI_Wtime()

         if(my_rank==0)then
            print*,"D&C",s1-s0,"ERRCODE=",INFO
         endif
         call flush(6)
*-
         s0 = MPI_Wtime()

            m0 = 64
            m0 = m
            m0 = 128
            call trbakwy(n, a(1,1), lda, z(1,1), ldz, e(1), m0)

         s1 = MPI_Wtime()

         if(my_rank==0)then
             print*,"TRDBAK",n,s1-s0,2e-9*dble(n)**3/(s1-s0),"GFLOPS"
         endif
         call flush(6)
*-
         hs1 = MPI_Wtime()
*
         if(my_rank==0)then
            print*,"Total",hs1-hs0,10e-9*dble(n)**3/3/(hs1-hs0),"GFLOPS"
         endif
         call flush(6)
*-
         deallocate(d, e, e2)
*-
         end subroutine

       subroutine matrix_adjust_h(a,n,b,lda)

      use communication_h, only : loop_c
     &               , translate_l2g
     &               , eigen_init
     &               , eigen_free

       implicit double precision(a-h,o-z),integer(i-n)
       real(8)  :: a(n,n)
       real(8)  :: b(1:lda,*)

       include 'mpif.h'
       include 'trd.h'

       call eigen_init(1)

       i_2=1; i_3=n
       call loop_c(i_2,i_3,i_4,n,size_of_row,my_row)
       j_2=1; j_3=n
       call loop_c(j_2,j_3,j_4,n,size_of_col,my_col)

       do i_1=i_2,i_3
          i = translate_l2g(i_1,size_of_row,my_row)
          do j_1=j_2,j_3
             j = translate_l2g(j_1,size_of_col,my_col)
             b(j_1,i_1) = a(j,i)
          end do
       end do

       call eigen_free(0)

       return
       end

       subroutine matrix_adjust_hi(a,n,b,lda)

      use communication_h, only : loop_c
     &               , translate_l2g
     &               , eigen_init
     &               , eigen_free

       implicit double precision(a-h,o-z),integer(i-n)
       real(8)  :: a(n,n)
       real(8)  :: b(1:lda,*)

       include 'mpif.h'
       include 'trd.h'

       call eigen_init(1)

       i_2=1; i_3=n
       call loop_c(i_2,i_3,i_4,n,size_of_row,my_row)
       j_2=1; j_3=n
       call loop_c(j_2,j_3,j_4,n,size_of_col,my_col)

       do i_1=i_2,i_3
          i = translate_l2g(i_1,size_of_row,my_row)
          do j_1=j_2,j_3
             j = translate_l2g(j_1,size_of_col,my_col)
             if(j<i)then
               b(j_1,i_1) = a(j,i)
             else if(j==i)then
               b(j_1,i_1) = a(j,i)
             else
               b(j_1,i_1) = a(j,i)
             endif
          end do
       end do

       call eigen_free(0)

       return
       end

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 635 $)
!
!  MODULE: m_Const_Parameters
!
!  AUTHOR(S): T. Yamasaki and K. Mae   August/20/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!***************************************************************
module m_Const_Parameters
! $Id: m_Const_Parameters.F90 635 2021-02-26 07:16:10Z jkoga $
  implicit none

  integer, parameter :: DRIVER_GENERAL=0, DRIVER_CONSTRAINT=1, DRIVER_NEB=2, DRIVER_PHONON=3 &
       &              , DRIVER_MTD=5, DRIVER_URAMP=6,DRIVER_SC_DFT=7, DRIVER_DIMER=8
  integer, parameter :: DELTA_MOVING_AVERAGE=0,DELTA_ENERGY=1,SLOPE=2,DELTA_V=3
  integer, parameter :: SCF    = 0, EK   = -1
  integer, parameter :: NODATA = 0, PUCV = 0, CARTS = 1, BUCS = 2
  integer, parameter :: CRDTYP = BUCS
  integer, parameter :: NONAME = 0, MESH = 1, SKPS_DIRECT_IN = 4 &
       &     , GAMMA = 3, FILE = 2, MONKHORST_PACK = 5
  integer, parameter :: GAMMA_base_symmetrization = 6
  integer, parameter :: DIRECTIN = 1, FROM_ENDPOINTS = 3, PROPORTIONAL = 4
  integer, parameter :: BEGIN = 1, END = 2
  integer, parameter :: ITER01 = 0, START = 0, FINISH = 3 &
       &     , DFINIS = 4, FLUSH = 5, ITERATIVE = 1
  integer, parameter :: TAG_FORMAT = 0, TAG_LINE = 1, TABLE = 2
  integer, parameter :: DP = kind(1.d0)
  integer, parameter :: SP = kind(1.0)
  integer, parameter :: CMPLDP = kind((1.d0, 0.d0))
  integer, parameter :: CMPLSP = kind((1.0 , 0.0 ))
  integer, parameter :: irsize = 8
  real(kind=DP), parameter :: PAI  = 3.141592653589793238462D0
  real(kind=DP), parameter :: PAIsqrt  = 1.7724538509055158819194276d0
  real(kind=DP), parameter :: PAI2 = PAI*2.d0, PAI4 = PAI*4.d0
  integer, parameter :: SD  = -1, SDPRC = 0, MSD = 1, MSDPRC = 2 &
       &        , CG  = 3, CGPRC = 4, RMM = 5, RMMPRC = 6, RMM2P = 17,RMM2PPRC = 18 &
       &	, RMM2 = 7, RMM2PRC = 8, SDLM = 9, SDLMPRC = 10 &
       &        , MSDLM = 11, MSDLMPRC = 12, bbCG = 13, bbCGPRC = 14 &
       &        , eazyCG = 15, eazyCGPRC = 16 &
       &        , default_sd2cg = 30&
       &        , SUBMAT = 51, MATRIXDIAGON = 53, DAVIDSON = 55, MDDAVIDSON = 56 &
       &        , MDKOSUGI = 57
  integer, parameter :: lmSD = SDLM, lmMSD = MSDLM, lmCG = CG &
       &        , lmRMM2 = RMM2, lmRMM = RMM, lmeazyCG = eazyCG&
       &        , RMM3 = RMM, RMM3PRC = RMMPRC
  integer, parameter :: EXPLICIT=-1, LMM_RMM=1, DAV_RMM=2, FEF=3
  integer, parameter :: SURFACE = 0, WHOLE_BZ = 1, SIMPLE_CUBIC = 2 &
       &        , BCC = 3,  FCC = 4, DIAMOND = 5, HEXAGONAL = 6, ORTHORHOMBIC = 7 &
       &        , HCP = 33,RUTILE = 8, C2v_SURFACE = 20, Csy_SURFACE = 21 &
       &        , GENERAL = 100, GENERAL_LARGER = 101 &
       &        , HEX1fold = 30, HEX2fold = 31, HEX3fold = 32, TRIGONAL = -11
  integer, parameter :: REGULAR_INTERVALS = 1, EAZY = 1, BY_ATOMIC_POSITIONS = 2, BY_ATOMS = 2
  integer, parameter :: TRIGONAL_lattice = -1, HEXAGONAL_lattice = 0, PRIMITIVE_lattice = 1 &
       &              , FCC_lattice = 2, BCC_lattice = 3, BottomCenteredCubic_lattice = 4
  integer, parameter :: BRAVAIS = 0, PRIMITIVE = 1
  integer, parameter :: SMALL = 1, MEDIUM = 2, LARGE = 3
  integer, parameter :: OLD = 0, NEW_ = 1, UNKNOWN = 2, NEXT = 1, STORED_AND_NEW = 1
  integer, parameter :: FORMATTED = 0, UNFORMATTED = 1
  integer, parameter :: ON = 1, OFF = 0
  integer, parameter :: UNIT_MATRIX=3, SPIN_POlARIZED=4, CRYSTAL_FIELD_APPROX=5
  integer, parameter :: GRID = 2
  integer, parameter :: YES = 1, NO = 0
  integer, parameter :: PARA = 0, ANTIFERRO = 1, FERRO = 2, NONMAG = 0
  integer, parameter :: EFERMI_VICINITY = 1, ALL_VALUES = 2
  integer, parameter :: EXACT = 1,FINE = 2,MODERATE = 3,COARSE = 4

! ================================== added by K. Tagami ================= 11.0
  integer, parameter :: NONCOLLINEAR = 5
! ======================================================================= 11.0

! ================================== added by K. Tagami ================= 11.0
  integer, parameter :: Neglected = 0,  BuiltIn = 5,  ByProjector = 10, &
       &                ByPawPot = 15, ZeffApprox = 20, ReadFromPP = 25
! ======================================================================= 11.0

  integer, parameter :: check_file_name_on  = 1
  integer, parameter :: check_file_name_off = 0
  integer, parameter :: by_matrix_diagon    = 1
  integer, parameter :: by_random_numbers   = 0
  integer, parameter :: by_pseudo_atomic_orbitals = 3
  integer, parameter :: Gauss_distrib_func  = 1
  integer, parameter :: PROJECTOR = 1, WAVEFUNCTION = 2, MULLIKEN = 3
  integer, parameter :: SPHERICAL_HARMONICS = 1, ATOMIC_ORBITAL = 2, WANNIER_FUNCTION = 3

! ============================= added by K. Tagami ====================== 5.0
  integer, parameter :: OccMat_Type1 = 1, OccMat_Type2 = 2
  integer, parameter :: Ueff_From_First = 100, Ueff_Gradually = 101
! ======================================================================== 5.0
  integer, parameter :: FLL = 1, AMF = 2

  integer, parameter :: VERY_NARROW         = 3
  integer, parameter :: from_PSEUDOPOTENTIAL_FILE = 4
  integer, parameter :: from_wave_functions = 2
  integer, parameter :: INITIAL = 0, CONTINUATION = 1, FIXED_CHARGE = 2 &
       & , FIXED_CHARGE_CONTINUATION = 3, AUTOMATIC = -1, PREPARATION_ONLY = -2 &
       & , FIXED_CHARGE_AUTOMATIC    = -3, COORDINATE_CONTINUATION = -4
  integer, parameter :: ALL_AT_ONCE = 0, ONE_BY_ONE = 1
  integer, parameter :: MANUAL = -2
  integer, parameter :: Partial_Core_Charge = 0, Valence_plus_PC_Charge = 1

! ================================== added by K. Tagami ================= 11.0
  integer, parameter :: Valence_Charge_Only = 10, Valence_plus_Core_Charge = 11
! ======================================================================= 11.0

  integer, parameter :: Core_Charge = 2
  integer, parameter :: GGA = 1, LDA  = 0
  integer, parameter :: UP  = 1, DOWN = 2
  integer, parameter :: SKIP = 0, EXECUT = 1
  integer, parameter :: SOFTPART = 1, HARDPART = 2
  integer, parameter :: WITHOUTTAG = 0, WITHTAG = 1
  integer, parameter :: INVERSE = 1, DIRECT = 2
  integer, parameter :: ORTHONORMALIZATION = 0, ORTHOGONALIZATION = 1, NORMALIZATION = 2
  integer, parameter :: OVER = 0, UNDER = 1
  integer, parameter :: OUTER = 1, INNER = -1
  integer, parameter :: ALL_BANDS = 0, OTHER_BANDS = 1, SAME_BAND = 2
  complex(kind=CMPLDP), parameter :: zi = (0.d0,1.d0)
  integer, parameter :: MDOLD = -1, MDSMPL = -2
  integer, parameter :: PARABOLIC = 0, MP = 1, TETRAHEDRON = 2, COLD = 3

! ==== KT_add ================================================== 13.0E
  integer, parameter :: FERMI_DIRAC = 4
! ============================================================== 13.0E

  integer, parameter :: CYLINDER = 0, BOX=1
  integer, parameter :: TEMPERATURE_CONTROL = -1, VERLET = 1&
       &, QUENCHED_MD    = 2,       NORMAL_MODE_ANALYSIS = 3 &
       &, HYPERPLANE_ADAPTIVE_COORDINATE = 4 &
       &, GDIIS  = 5 &
       &, BLUEMOON = -5, QUENCHED_CONSTRAINT = -6 &
       &, FIRE = -7 &
       &, HAC = HYPERPLANE_ADAPTIVE_COORDINATE &
       &, T_CONTROL = TEMPERATURE_CONTROL &
       &, PHONON_FORCE = 10, CG_STROPT = 11 &
       &, SD_MD = 12, STEEPEST_DESCENT = SD_MD, MC = 13 &
       &, DAMPED_MD = 14, VELOCITY_SCALING = 15, BFGS = 16 &
       &, CG_STROPT2 = 17 &
       &, PT_CONTROL = 18, P_CONTROL = 19, L_BFGS = 20
  integer, parameter :: ORDINA = 0, CNSTRA = 1
  integer, parameter :: ALDOS = 1, LAYERDOS = 2
  integer, parameter :: FIX    = 0, RELAX  = 1, BONDLENGTH_FIX = 10 &
       &, COG_FIX = 101, COG_CNTR = 101, HEAT_BATH = 1000, FIX_IN_A_PLANE = 5 &
       &, BONDLENGTH_FIX_1 = 11, BONDLENGTH_FIX_2 = 12, COG_FIX_L = 102 &
       &, FIX_HBATH = FIX - 1, RELAX_HBATH = RELAX - 1 &
       &, FIXED_NORMAL_HYPERVECTOR = 13, NUDGED_ELASTIC_BAND_METHOD = 14
  integer, parameter :: NOSE = 2000, NOSE_HOOVER = 1000, LANGEVIN = 3000
  integer, parameter :: IINCRE_CRITICAL = 1000
  real(kind=DP), parameter :: UMICRO = 1.d-6
  real(kind=DP), parameter :: LIMIT_1DSEARCH = 1.d+10
  integer, parameter :: EXC_ONLY = 0, VXC_AND_EXC = 1, STRESS_ = 2
  integer, parameter :: SIMPLE = 1, BROYD1 = 2, BROYD2 = 3, DFP = 4 &
       &, PULAY = 5, ANEW = 1, RENEW = 2
  integer, parameter :: NORMCONSERVATION = 0, VANDERBILT_TYPE = 1, VDB = VANDERBILT_TYPE
  real(kind=DP),parameter :: BOHR = 0.529177210903d0
  real(kind=DP),parameter :: BOHR_RADIUS = BOHR*1.d-10
  real(kind=DP),parameter :: Hartree = 27.211386245988d0
  real(kind=DP),parameter :: Rydberg = Hartree*0.5d0
  real(kind=DP),parameter :: AU_MASS = 9.1093897d-31
  real(kind=DP),parameter :: AU_TIME = 2.41888432658572d-17
  real(kind=DP),parameter :: ATOMIC_MASS = 1.66053d-27
  real(kind=DP),parameter :: AMU = AU_MASS/ATOMIC_MASS
  integer, parameter ::      HR_ENERGY_UNIT =1, EV_ENERGY_UNIT = 2
  real(kind=DP),parameter :: DELTA = 1.d-60, DELTA10 = 1.d-10, DELTA07 = 1.d-07
  real(kind=DP),parameter :: DELTAevdff = 1.d-10
  real(kind=DP),parameter :: DELTA_FermiSearchRange = 1.d0
  integer,parameter ::       ELECTRON = 0, POSITRON = 1
  integer,parameter ::       TOTAL = 0
  integer,parameter ::       MAPPED = 1, NOTMAPPED = 0
  integer,parameter ::       WHOLE = 0,  INITIALLY = 1

  integer,parameter :: NOPOLAR = 0, POLARIZATION = 1, EFFECTIVE_CHARGE = 2, PIEZOELECTRIC_CONST = 3
  integer,parameter :: UNIFIED = 0, PARTITIONED = 1
  integer,parameter :: HOUSEHOLDER = 0, DIVIDEandCONQUER = 1

  integer,parameter :: PHONON_GAMMA = 0, PHONON_BAND = 1, PHONON_DOS = 2
  integer,parameter :: pp_PAW = -2, pp_GNCPP2_with_AE_WF = 2, pp_GNCPP2 = 2, pp_GNCPP1 = 1, pp_CIAOPP = 3

! === Apply modifications for vdW function. by tkato 2012/06/14 ================
  integer,parameter :: VDW_WILLIAMS = 0, VDW_GRIMME = 1, VDW_DFTD3 = 2
! ==============================================================================

! === Magnetic Constraint ============== KT_add ================== 13.0U
  integer, parameter :: ABRUPT = 10, STEPWISE = 11, LINEAR =12
  integer, parameter :: MAG_MOMENT_VALS_GLOBAL = 1, MAG_MOMENT_DIREC_GLOBAL = 2, &
       &                MAG_MOMENT_VALS_LOCAL = 3, MAG_MOMENT_DIREC_LOCAL = 4, &
       &                MAG_MOMENT_VALS_OCCMAT = 10, &
       &                MAG_MOMENT_DIREC_HARDPART = 20
! ================================================================ 13.0U

! == behavior of subroutine Preparation
  integer, parameter :: SKIP_SYMMCHECK=1,RETURN_AFTER_SYMMCHECK=2

! === spectrum
  integer, parameter :: MacroDielectric=0,  PACS=1,  EELS=2

  integer, parameter :: LINEAR_INTERPOLATION = 1,SPLINE_INTERPOLATION = 2
! === charge symmetrization ===
  integer, parameter :: USE_OPR_FULL = 0, USE_OPR_IN_STAR_OF_K = 1
  integer, parameter :: chg_symm_level0 = 0, chg_symm_level1 = 1, chg_symm_level2 = 2

! === orbital pop ====
  integer, parameter :: DIAG_CHARGE_DENSITY_MATRIX = 1, DIAG_SPIN_DENSITY_MATRIX = 2, &
       &                DIAG_LS_with_t2g_octa = 3, DIAG_LS = 4, &
       &                LOCAL_POINT_GROUP = -1, LOCAL_DOUBLE_POINT_GROUP = -2

! === real-space treatment of the nonlocal pp
  integer,parameter :: MASK_FUNCTION = 10, PREFITTING = 11

! === checkpoint file ===
  integer, parameter :: SCF_ITERATION=1,STREVL_ITERATION=2,NEB_ITERATION=3,UNITCELL_ITERATION=4 &
                     &, REAC_ITERATION=5

  integer, parameter :: len_tag_ionic_system = 12
  character(len=len_tag_ionic_system) :: tag_ionic_system
  data tag_ionic_system/'Ionic System'/

  integer, parameter :: len_tag_iteration = 48
  character(len=len_tag_iteration) :: tag_iteration
  data tag_iteration/'iteration, iteration_ionic, iteration_electronic'/

  integer, parameter :: len_tag_iters_and_nk = 50
  character(len=len_tag_iters_and_nk) :: tag_iters_and_nk
  data tag_iters_and_nk/'iteration, iteration_electronic, nk_in_the_process'/

  integer, parameter :: UNDETERMINED=-1,MAX_SCF_ITERATION_REACHED=0, MAX_TIME_REACHED=1, FSTOP=2 &
                   &  , FORCE_CONVERGENCE_REACHED=3, STRESS_CONVERGENCE_REACHED=4 &
                   &  , MAX_MDSTEPS_REACHED=5, CHG_CONVERGENCE_REACHED=6 &
                   &  , WF_CONVERGENCE_REACHED=7, MAX_PHSTEPS_REACHED=8

!$$#ifndef PARA3D
  integer, parameter :: len_tag_npes_etc = 22
  character(len=len_tag_npes_etc) :: tag_npes_etc
  data tag_npes_etc /'npes, nrank_e, nrank_k'/
!$$#endif

  integer, parameter :: VARIATIONAL=1, HARRIS=2
  integer, parameter :: len_tag_total_energy = 12
  character(len=len_tag_total_energy) :: tag_total_energy
  data tag_total_energy/'Total Energy'/

  ! -- isolver
  integer,parameter  :: len_tag_isolver = len("isolver")
  character(len=len_tag_isolver) :: tag_isolver = "isolver"

  real(kind=DP) :: x
  real(kind=DP),parameter :: SmallestPositiveNumber = tiny(x)

  integer, parameter :: TOTAL_ENERGY = 1, MODIFIED_TOTAL_ENERGY = 2, BAND_ENERGY = 3

  integer, parameter :: BEFORE = 0, AFTER = 1
  integer, parameter :: varLINEAR = 0, varTANH = 1

  integer, parameter :: FORCE_CONVERGED = 2, CHARGE_CONVERGED = 1 &
       & , STRESS_CONVERGED = 3, EK_CONVERGED = 2

  integer, parameter :: BINARY = 3, VTK = 2, CUBE = 1, DENSITY_ONLY = 0, INTEGRATED = 0, SEPARATE = 1

  integer, parameter :: NEWTON = 1, LAGRANGE = 0

  integer, parameter :: GaussLegendre = 1, SphericalHarmonicsExpansion = 2
!== ESM
  integer, parameter :: BARE = 0, PE1 = 1, PE2 = 2
!== ESM

  integer, parameter :: PHASE0_INPUT=1, PHASE0_OUTPUT=2, NEB_INPUT=3

  integer, parameter :: ALL=0, XSF=1, N2P2=2

  integer, parameter :: FMAXTAGLEN = 256
  integer, parameter :: FMAXVALLEN = 256
  integer, parameter :: FMAXUNITLEN = 20
  integer, parameter :: FMAXDEPTH = 16

  integer, parameter :: num_d6h = 24
  integer, parameter :: num_oh = 48
  character(5), dimension(num_d6h ), parameter :: d6h_symbol = (/ &
                                                & 'e    ', &	! 1
						& 'c6+  ', &	! 2
						& 'c3+  ', &	! 3
						& 'c2   ', &	! 4
						& 'c3-  ', &	! 5
						& 'c6-  ', &	! 6
						& 'c211 ', &	! 7
						& 'c221 ', &	! 8
						& 'c231 ', &	! 9
						& 'c212 ', &	! 10
						& 'c222 ', &	! 11
						& 'c232 ', &	! 12
						& 'ie   ', &	! 13
						& 'ic6+ ', &	! 14
						& 'ic3+ ', &	! 15
						& 'ic2  ', &	! 16
						& 'ic3- ', &	! 17
						& 'ic6- ', &	! 18
						& 'ic211', &	! 19
						& 'ic221', &	! 20
						& 'ic231', &	! 21
						& 'ic212', &	! 22
						& 'ic222', &	! 23
						& 'ic232'  /)	! 24


  character(5), dimension(num_oh), parameter :: oh_symbol = (/ &
        & 'e    ', 'c2x  ', 'c2y  ', 'c2z  ', &	! 1 2 3 4
	& 'c31+ ', 'c32+ ', 'c33+ ', 'c34+ ', &	! 5 6 7 8
	& 'c31- ', 'c32- ', 'c33- ', 'c34- ', &	! 9 10 11 12
	& 'c2a  ', 'c2b  ', 'c2c  ', 'c2d  ', &	! 13 14 15 16
	& 'c2e  ', 'c2f  ', 'c4x+ ', 'c4y+ ', &	! 17 18 19 20
	& 'c4z+ ', 'c4x- ', 'c4y- ', 'c4z- ', &	! 21 22 23 24
	& 'ie   ', 'ic2x ', 'ic2y ', 'ic2z ', &	! 25 26 27 28
        & 'ic31+', 'ic32+', 'ic33+', 'ic34+', &	! 29 30 21 32
	& 'ic31-', 'ic32-', 'ic33-', 'ic34-', &	! 33 34 35 36
	& 'ic2a ', 'ic2b ', 'ic2c ', 'ic2d ', &	! 37 38 39 40
        & 'ic2e ', 'ic2f ', 'ic4x+', 'ic4y+', &	! 41 42 43 44
        & 'ic4z+', 'ic4x-', 'ic4y-', 'ic4z-' /)	! 45 46 47 48
  ! --> m_input_interface
  integer, parameter :: TL_LINENO = 0
  integer, parameter :: TL_FROMCUR = 1
  integer, parameter :: TL_NEXT = 1
  integer, parameter :: TL_BACK = -1
  
  integer, parameter :: NOCONV = 0
  integer, parameter :: LOWER = 1
  integer, parameter :: UPPER = 2

  integer, parameter :: numdefaultunits = 9
  character(FMAXUNITLEN), dimension(numdefaultunits), parameter :: defaultunits = (/ &
       & 'hartree             ', 'bohr                ', 'au_time             ', 'au_mass             ', 'degree              ', &
       & 'k                   ', 'bohr/au_time        ', 'hartree/bohr        ', 'hartree/bohr3       '                     /)

  type unitsystem
      integer :: energy
      logical :: inpfg_energy
      integer :: length
      logical :: inpfg_length
      integer :: time
      logical :: inpfg_time
      integer :: mass
      logical :: inpfg_mass
      integer :: angle
      logical :: inpfg_angle
      integer :: temperature
      logical :: inpfg_temperature
      integer :: velocity
      logical :: inpfg_velocity
      integer :: force
      logical :: inpfg_force
      integer :: pressure
      logical :: inpfg_pressure
  end type unitsystem
  type(unitsystem), dimension(FMAXDEPTH),save :: usys_file
  integer :: fblkdepth = 1
  ! <-- m_input_interface

  ! --> m_unit_conv 
real(DP), parameter :: CONST_EV = 1.602176634d-19
real(DP), parameter :: CONST_NA = 6.02214076d+23
real(DP), parameter :: CONST_kB = 3.16681156340237d-6 ! = 1/11604.6996795594d0/27.21139615d0 K -> Hartree

real(DP), parameter :: UNIT_PIEZO_CONST = 57.214766228657d0 ! C/m^2 = 1 a.u.

!!$real(DP), parameter :: CONST_PI = 3.14159265358979323846d0
real(DP), parameter :: CONST_PI = PAI

integer, parameter :: TYPE_ENERGY = 1
integer, parameter :: TYPE_LENGTH = 2
integer, parameter :: TYPE_TIME = 3
integer, parameter :: TYPE_MASS = 4
integer, parameter :: TYPE_ANGLE = 5
integer, parameter :: TYPE_TEMPERATURE = 6
integer, parameter :: TYPE_VELOCITY = 7
integer, parameter :: TYPE_FORCE = 8
integer, parameter :: TYPE_PRESSURE = 9

integer, parameter :: UNITNAMELEN = 16
type unitlist
    character(UNITNAMELEN) :: name
    real(kind=DP) :: factor
    integer ::       type
end type unitlist

integer, parameter :: BULK   = 1
integer, parameter :: DEFECT = 2
integer, parameter :: Positron_CONV = 1  ! zero-density limit, non-scf
                                         !    calc p- wfns once
integer, parameter :: Positron_GGGC = 2  ! zero-density limit, scf
                                         !    update e- and p- wfns successively
integer, parameter :: Positron_PSN  = 3  ! fully two-component scf

integer, parameter :: FFT_redundant = 1
integer, parameter :: FFT_parallel = 2
integer, parameter :: WIDE = 0
integer, parameter :: NARROW = 1
integer, parameter :: eVunit = 2
! ========================== KT_mod =================== 13.0B 
!integer, parameter :: unit_list_size = 50
integer, parameter :: unit_list_size = 51
! ===================================================== 13.0B

type(unitlist),parameter :: unit_1  = unitlist( 'ev                  ',    1.d0,                      TYPE_ENERGY )
type(unitlist),parameter :: unit_2  = unitlist( 'rydberg             ',   Rydberg,                    TYPE_ENERGY )
type(unitlist),parameter :: unit_3  = unitlist( 'hartree             ',   Hartree,                    TYPE_ENERGY )
type(unitlist),parameter :: unit_4  = unitlist( 'j/mol               ',    1.d0/CONST_EV/CONST_NA,    TYPE_ENERGY )
type(unitlist),parameter :: unit_5  = unitlist( 'cal/mol             ',    4.184d0/CONST_EV/CONST_NA, TYPE_ENERGY )
type(unitlist),parameter :: unit_6  = unitlist( 'angstrom            ',    1.d0,                      TYPE_LENGTH )
type(unitlist),parameter :: unit_7  = unitlist( 'bohr                ',    BOHR,                      TYPE_LENGTH )
type(unitlist),parameter :: unit_8  = unitlist( 'nm                  ',    1.d+1,                     TYPE_LENGTH )
type(unitlist),parameter :: unit_9  = unitlist( 's                   ',    1.d0,                      TYPE_TIME   )
type(unitlist),parameter :: unit_10 = unitlist( 'sec                 ',    1.d0,                      TYPE_TIME   )
type(unitlist),parameter :: unit_11 = unitlist( 'au_time             ',    AU_TIME,                   TYPE_TIME   )
type(unitlist),parameter :: unit_12 = unitlist( 'fs                  ',    1.d-15,                    TYPE_TIME   )
type(unitlist),parameter :: unit_13 = unitlist( 'ps                  ',    1.d-12,                    TYPE_TIME   )
type(unitlist),parameter :: unit_14 = unitlist( 'ns                  ',    1.d-9,                     TYPE_TIME   )
type(unitlist),parameter :: unit_15 = unitlist( 'min                 ',   60.d0,                      TYPE_TIME   )
type(unitlist),parameter :: unit_16 = unitlist( 'hour                ', 3600.d0,                      TYPE_TIME   )
type(unitlist),parameter :: unit_17 = unitlist( 'day                 ',   24.d0*3600.d0,              TYPE_TIME   )
type(unitlist),parameter :: unit_18 = unitlist( 'kg                  ',    1.d0,                      TYPE_MASS   )
type(unitlist),parameter :: unit_19 = unitlist( 'g                   ',    1.d-3,                     TYPE_MASS   )
type(unitlist),parameter :: unit_20 = unitlist( 'au_mass             ',    AU_MASS,                   TYPE_MASS   )
type(unitlist),parameter :: unit_21 = unitlist( 'atomic_mass         ',    ATOMIC_MASS,               TYPE_MASS   )
type(unitlist),parameter :: unit_22 = unitlist( 'degree              ',    1.d0,                      TYPE_ANGLE  )
type(unitlist),parameter :: unit_23 = unitlist( 'radian              ',  180.d0/CONST_PI,             TYPE_ANGLE  )
type(unitlist),parameter :: unit_24 = unitlist( 'k                   ',    0.d0,                 TYPE_TEMPERATURE )
type(unitlist),parameter :: unit_25 = unitlist( 'centigrade          ',  273.15d0,               TYPE_TEMPERATURE )
type(unitlist),parameter :: unit_26 = unitlist( 'angstrom/s          ',    1.d0,                    TYPE_VELOCITY )
type(unitlist),parameter :: unit_27 = unitlist( 'angstrom/fs         ',    1.d0/1.d-15,             TYPE_VELOCITY )
type(unitlist),parameter :: unit_28 = unitlist( 'angstrom/au_time    ',    1.d0/AU_TIME,            TYPE_VELOCITY )
type(unitlist),parameter :: unit_29 = unitlist( 'bohr/fs             ',    BOHR/1.d-15,             TYPE_VELOCITY )
type(unitlist),parameter :: unit_30 = unitlist( 'bohr/au_time        ',    BOHR/AU_TIME,            TYPE_VELOCITY )
type(unitlist),parameter :: unit_31 = unitlist( 'nm/fs               ',    1.d+1/1.d-15,            TYPE_VELOCITY )
type(unitlist),parameter :: unit_32 = unitlist( 'nm/au_time          ',    1.d+1/AU_TIME,           TYPE_VELOCITY )
type(unitlist),parameter :: unit_33 = unitlist( 'ev/angstrom         ',    1.d0,                    TYPE_FORCE )
type(unitlist),parameter :: unit_34 = unitlist( 'ev/bohr             ',    1.d0/BOHR,               TYPE_FORCE )
type(unitlist),parameter :: unit_35 = unitlist( 'ev/nm               ',    1.d0/1.d+1,              TYPE_FORCE )
type(unitlist),parameter :: unit_36 = unitlist( 'rydberg/angstrom    ',    Rydberg,                 TYPE_FORCE )
type(unitlist),parameter :: unit_37 = unitlist( 'rydberg/bohr        ',    Rydberg/BOHR,            TYPE_FORCE )
type(unitlist),parameter :: unit_38 = unitlist( 'rydberg/nm          ',    Rydberg/1.d+1,           TYPE_FORCE )
type(unitlist),parameter :: unit_39 = unitlist( 'hartree/angstrom    ',    Hartree,                 TYPE_FORCE )
type(unitlist),parameter :: unit_40 = unitlist( 'hartree/bohr        ',    Hartree/BOHR,            TYPE_FORCE )
type(unitlist),parameter :: unit_41 = unitlist( 'hartree/nm          ',    Hartree/1.d+1,           TYPE_FORCE )
type(unitlist),parameter :: unit_42 = unitlist( 'ev/angstrom3        ',    1.d0,                    TYPE_PRESSURE )
type(unitlist),parameter :: unit_43 = unitlist( 'ev/bohr3            ',    1.d0/(BOHR**3),          TYPE_PRESSURE )
type(unitlist),parameter :: unit_44 = unitlist( 'ev/nm3              ',    1.d0/(1.d+1**3),         TYPE_PRESSURE )
type(unitlist),parameter :: unit_45 = unitlist( 'rydberg/angstrom3   ',    Rydberg,                 TYPE_PRESSURE )
type(unitlist),parameter :: unit_46 = unitlist( 'rydberg/bohr3       ',    Rydberg/(BOHR**3),       TYPE_PRESSURE )
type(unitlist),parameter :: unit_47 = unitlist( 'rydberg/nm3         ',    Rydberg/(1.d+1**3),      TYPE_PRESSURE )
type(unitlist),parameter :: unit_48 = unitlist( 'hartree/angstrom3   ',    Hartree,                 TYPE_PRESSURE )
type(unitlist),parameter :: unit_49 = unitlist( 'hartree/bohr3       ',    Hartree/(BOHR**3),       TYPE_PRESSURE )
type(unitlist),parameter :: unit_50 = unitlist( 'hartree/nm3         ',    Hartree/(1.d+1**3),      TYPE_PRESSURE )

! ========================== KT_mod =================== 13.0B 
type(unitlist),parameter :: unit_51 = unitlist( 'gpa                 ',    1.0D-21 /CONST_EV,       TYPE_PRESSURE )
! ===================================================== 13.0B

type(unitlist), dimension(unit_list_size), parameter ::  unit_list = (/ &
     & unit_1,  unit_2,  unit_3,  unit_4,  unit_5,  unit_6,  unit_7,  unit_8,  unit_9,  unit_10, &
     & unit_11, unit_12, unit_13, unit_14, unit_15, unit_16, unit_17, unit_18, unit_19, unit_20, &
     & unit_21, unit_22, unit_23, unit_24, unit_25, unit_26, unit_27, unit_28, unit_29, unit_30, &
     & unit_31, unit_32, unit_33, unit_34, unit_35, unit_36, unit_37, unit_38, unit_39, unit_40, &
     & unit_41, unit_42, unit_43, unit_44, unit_45, unit_46, unit_47, unit_48, unit_49, unit_50, &
     & unit_51 &
     & /)


contains

integer function get_unit_id( unit, idno, unittype )
    implicit none
    character(*), intent(in) :: unit
    integer, intent(out) :: idno
    integer, intent(out) :: unittype
    integer i
!!$    character(UNITNAMELEN) :: wkunit

!!$    wkunit = unit
    do i = 1, unit_list_size
        if( unit == unit_list(i)%name ) then
            idno = i
            unittype = unit_list(i)%type
            get_unit_id = 0
            return
        end if
    end do 

    if( i > unit_list_size ) then
        get_unit_id = -1
        return
    end if

end function get_unit_id

integer function unit_conv_byname( valin, valout, unitin, unitout )
    implicit none
    real(kind=DP), intent(in) :: valin
    real(kind=DP), intent(out) :: valout
    character(*), intent(in) :: unitin
    character(*), intent(in) :: unitout
    integer i, fgin, fgout, typein, typeout
    real(kind=DP) factorin, factorout

    fgin = 0
    fgout = 0
    do i = 1, unit_list_size
        if( unitin == unit_list(i)%name ) then
            factorin = unit_list(i)%factor
            typein = unit_list(i)%type
            fgin = 1
        else if( unitout == unit_list(i)%name ) then
            factorout = unit_list(i)%factor
            typeout = unit_list(i)%type
            fgout = 1
        end if
        if( fgin == 1 .and. fgout == 1 ) then
            exit
        end if
    end do 

    if( i > unit_list_size ) then
        if( fgin == 0 ) then
            unit_conv_byname = -1
        else
            unit_conv_byname = -2
        end if
        return
    end if

    if( typein /= typeout ) then
        unit_conv_byname = -3
        return
    end if

    if( typein == TYPE_TEMPERATURE ) then
        valout = valin + factorin - factorout
    else
        valout = valin*factorin/factorout
    end if

    unit_conv_byname = 0
    return
end function unit_conv_byname

integer function unit_conv_byid( valin, valout, idin, idout )
    implicit none
    real(DP), intent(in) :: valin
    real(DP), intent(out) :: valout
    integer, intent(in) :: idin
    integer, intent(in) :: idout
    integer ::  typein, typeout
    real(DP) :: factorin, factorout

    factorin = unit_list(idin)%factor
    typein = unit_list(idin)%type

    factorout = unit_list(idout)%factor
    typeout = unit_list(idout)%type

    if( typein /= typeout ) then
        unit_conv_byid = -3
        return
    end if

    if( typein == TYPE_TEMPERATURE ) then
        valout = valin + factorin - factorout
    else
        valout = valin*factorin/factorout
    end if

    unit_conv_byid = 0
    return
end function unit_conv_byid


end module m_Const_Parameters

module m_Band_Unfolding
  use m_Const_Parameters,   only : PAI2, CARTS, DP, OFF, MAPPED, NOTMAPPED, SKIP, &
       &                           GAMMA, BUCS, CMPLDP, ON, Neglected
  use m_Control_Parameters,  only : ekmode, neg, noncol, num_extra_bands, &
       &                            ndim_spinor, kimg, flag_mpi_g_dot_r, nspin, af, &
       &                            sw_orb_popu, orb_popu_method, SpinOrbit_Mode, &
       &                            wf_orb_proj_print_format, num_proj_elems, &
       &                            proj_group, proj_attribute, &
       &                            sw_calc_wf_orb_projection, band_unfolding_active, &
       &                            tolerance_Gvec_matching

  use m_PseudoPotential,    only : modnrm, nlmta, ilmt, lmta, q, ilmt_phi, ltp_phi, &
       &                           mtp_phi, taup_phi, lmta_phi, lmtt_phi, &
       &                           ltp, mtp, taup, nlmtt_phi, nlmta_phi, &
       &                           q_phirt_pw, qorb, m_PP_tell_iorb_lmtt, &
       &                           m_PP_tell_iorb_ia_l_m_tau
  use m_Crystal_Structure,  only : altv_refcell, rltv, univol
  use m_Kpoints,  only : kv3, vkxyz, k_symmetry, kv3_ek, vkxyz_refcell
  use m_Files,        only : nfout, nfband_spectr_wght, &
       &                     m_Files_open_nfband_spwt, &
       &                     m_Files_close_nfband_spwt, nfwfk_orb_proj, &
       &                     m_Files_open_nfwfk_orb_proj, &
       &                     m_Files_close_nfwfk_orb_proj

  use m_PlaneWaveBasisSet,    only : kg, ngabc, iba, nbase, nbmx, GVec_on_refcell

  use m_Parallelization,  only : mype, npes, myrank_k, map_k, ista_e, iend_e, map_z, &
       &                         mpi_comm_group, ista_nbmx, mp_nbmx, np_nbmx, ng_nbmx, &
       &                         mpi_nbmx_world, ierr, ista_k, iend_k, np_e, istep_e, &
       &                         nrank_e
  use m_Parallelization,  only : ista_g1k, iend_g1k, np_g1k, mpi_ke_world, &
       &                         nrank_g, np_fs, ista_fs, iend_fs, ista_atm, iend_atm

  use m_IterationNumbers,  only : nk_in_the_process
  use m_Ionic_System,   only : pos, natm, ityp, altv, iproj_group
  use m_Electronic_Structure,  only : zaj_l, neordr
  use m_ES_nonlocal,     only : zfcos, zfsin, zfcos_mpi, zfsin_mpi, &
       &                        m_ES_alloc_zfsincos, m_ES_dealloc_zfsincos, &
       &                        alloc_zfsincos_mpi, dealloc_zfsincos_mpi, &
       &                        m_ES_betar_dot_WFs_4_lmta_k_3D, &
       &                        m_ES_alloc_arai_3D, m_ES_dealloc_arai_3D, &
       &                        m_ES_phir_dot_WFs_4_lmta_k_3D, &
       &                        m_ES_betar_dot_Psi_4_each_k_3D
  use m_NonLocal_Potential,  only : snl, phig, norm_phig

  use m_Kpoints,  only :  sw_force_kpt_inside_bz,  GvecTrans_kpt

  use m_SpinOrbit_Potential,  only :  MatU_ylm_RC_L0,  MatU_ylm_RC_L1,  MatU_ylm_RC_L2, &
       &                              MatU_ylm_RC_L3
  
  implicit none
  include 'mpif.h'

  real(kind=DP), allocatable :: fsr_filtered(:,:,:), fsi_filtered(:,:,:)
  real(kind=DP), allocatable :: compr_filtered(:,:,:,:), compi_filtered(:,:,:,:)
contains

  subroutine m_BU_set_GVec_Flag_refcell
    integer :: i, j, k, ik
    real(kind=DP) :: vec1(3), cx, cy, cz, delta

    if ( allocated( Gvec_on_refcell ) ) deallocate( Gvec_on_refcell )
    if ( sw_force_kpt_inside_bz == ON ) then
       allocate( GVec_on_refcell(kg,ista_k:iend_k) );
    else
       allocate( GVec_on_refcell(kg,1) );
    endif
    GVec_on_refcell = 0

    delta = tolerance_Gvec_matching

    if ( sw_force_kpt_inside_bz == ON ) then
       Do ik=ista_k, iend_k
          Do i=1, kg
             vec1(1) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(1,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(1,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(1,3)
             vec1(2) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(2,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(2,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(2,3)
             vec1(3) = ( ngabc(i,1) +GVecTrans_kpt(ik,1) )*rltv(3,1) &
                  &   +( ngabc(i,2) +GVecTrans_kpt(ik,2) )*rltv(3,2) &
                  &   +( ngabc(i,3) +GVecTrans_kpt(ik,3) )*rltv(3,3)
             cx = 0.0d0; cy = 0.0d0; cz = 0.0d0
             Do k=1, 3
                cx = cx +altv_refcell(k,1) *vec1(k)
                cy = cy +altv_refcell(k,2) *vec1(k)
                cz = cz +altv_refcell(k,3) *vec1(k)
             End Do

             cx = cx /PAI2;     cy = cy /PAI2;      cz = cz /PAI2
             cx = abs( cx -nint(cx) );
             cy = abs( cy -nint(cy) );
             cz = abs( cz -nint(cz) );

             if ( cx < delta .and. cy < delta .and. cz < delta ) then
                GVec_on_refcell(i,ik) = 1
             endif
          ENd Do
       End Do
    else
       Do i=1, kg
          vec1(1) = ngabc(i,1) *rltv(1,1) +ngabc(i,2) *rltv(1,2) +ngabc(i,3) *rltv(1,3)
          vec1(2) = ngabc(i,1) *rltv(2,1) +ngabc(i,2) *rltv(2,2) +ngabc(i,3) *rltv(2,3)
          vec1(3) = ngabc(i,1) *rltv(3,1) +ngabc(i,2) *rltv(3,2) +ngabc(i,3) *rltv(3,3)

          cx = 0.0d0; cy = 0.0d0; cz = 0.0d0
          Do k=1, 3
             cx = cx +altv_refcell(k,1) *vec1(k)
             cy = cy +altv_refcell(k,2) *vec1(k)
             cz = cz +altv_refcell(k,3) *vec1(k)
          End Do

          cx = cx /PAI2;     cy = cy /PAI2;      cz = cz /PAI2
          cx = abs( cx -nint(cx) );
          cy = abs( cy -nint(cy) );
          cz = abs( cz -nint(cz) );

          if ( cx < delta .and. cy < delta .and. cz < delta ) then
             GVec_on_refcell(i,1) = 1
          endif
       ENd Do
    endif

  end subroutine m_BU_set_GVec_Flag_refcell

       
  subroutine m_BU_calc_spectral_weight_3D
    real(kind=DP), allocatable :: SpectralWeight(:,:)
    integer :: ik, ie, neg_t
    integer :: lun, j, k

    real(kind=DP) :: c1
    real(kind=DP), allocatable :: work(:,:), work2(:)
    integer, allocatable :: iwork(:,:), neordr_t(:,:)

    band_unfolding_active = .true.
    
    if ( modnrm /= SKIP ) then
       allocate( fsr_filtered(np_e,np_fs,ista_k:iend_k) )
       if( .not.(kv3/nspin == 1 .and. k_symmetry(1) == GAMMA .and. kimg == 2)) then
          allocate( fsi_filtered(np_e,np_fs,ista_k:iend_k));
       else
          allocate( fsi_filtered(1,1,1) )
       endif
       fsr_filtered = 0.0d0;     fsi_filtered = 0.d0
       call m_BU_betar_dot_WFs_3D(nfout)
    end if
       
    allocate( SpectralWeight(neg,kv3) ); SpectralWeight = 0.0d0

    call softpart
    if ( modnrm /= SKIP ) call hardpart

    if ( npes > 1 ) then
       allocate( work(neg,kv3) ); work = 0.0d0
       call mpi_allreduce( SpectralWeight, work, kv3 *neg, &
            &              mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
       SpectralWeight = work
       deallocate( work )
    endif

    neg_t = neg -num_extra_bands
    
    allocate( work2(neg) )
#if 1
    allocate( neordr_t(neg,kv3) ); neordr_t = 0
    neordr_t(:,ista_k:iend_k) = neordr(:,ista_k:iend_k)
    if ( npes > 1 ) then
       allocate( iwork(neg,kv3) )
       call mpi_allreduce( neordr_t, iwork, neg*kv3, mpi_integer, mpi_sum, &
            &              mpi_comm_group, ierr )
       neordr_t = iwork /nrank_e /nrank_g
       deallocate( iwork )
    endif
#endif    

    if ( mype == 0 ) then
       if ( ekmode == ON ) then
          if ( nk_in_the_process == 1 ) then
             call m_Files_open_nfband_spwt(2)
             write(nfband_spectr_wght,'(A,I8)') 'num_kpoints = ', kv3_ek /ndim_spinor
             write(nfband_spectr_wght,'(A,I8)') 'num_bands   = ', neg_t
             write(nfband_spectr_wght,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
             write(nfband_spectr_wght,*)
          else
             call m_Files_open_nfband_spwt(3)
          endif
          Do ik=1, kv3, ndim_spinor
             if ( ik+nk_in_the_process -1 > kv3_ek ) cycle
             write( nfband_spectr_wght,'(A,I6,A,3F16.8,A)') &
                  &             "ik = ", ik +nk_in_the_process -1, " ( ", &
                  &             vkxyz_refcell(ik+nk_in_the_process-1,1:3,BUCS), " )"
             if ( noncol ) then
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik) &
                        &     +SpectralWeight(neordr_t(ie,ik+1),ik+1)
#else
                   work2(ie) = SpectralWeight(ie,ik) &
                        &     +SpectralWeight(ie,ik+1)
#endif
                End Do
             else
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik)
#else
                   work2(ie) = SpectralWeight(ie,ik)
#endif
                End Do
             endif
             write( nfband_spectr_wght,'(4f18.10)') ( work2(ie),ie=1, neg_t )
             write( nfband_spectr_wght,* )
          End Do
          call m_Files_close_nfband_spwt

       else
          call m_Files_open_nfband_spwt(2)
          write(nfband_spectr_wght,'(A,I8)') 'num_kpoints = ', kv3 /ndim_spinor
          write(nfband_spectr_wght,'(A,I8)') 'num_bands   = ', neg_t
          write(nfband_spectr_wght,'(A,I8)') 'nspin       = ', nspin /ndim_spinor
          write(nfband_spectr_wght,*)
          Do ik=1, kv3, ndim_spinor
             write( nfband_spectr_wght,'(A,I6,A,3F16.8,A)') &
                  &             "ik = ", ik, " ( ", &
                  &                    vkxyz_refcell(ik,1:3,BUCS), " )"
             if ( noncol ) then
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik) &
                        &     +SpectralWeight(neordr_t(ie,ik+1),ik+1)
#else
                   work2(ie) = SpectralWeight(ie,ik ) &
                        &     +SpectralWeight(ie,ik+1)
#endif
                End Do
             else
                Do ie=1, neg
#if 1
                   work2(ie) = SpectralWeight(neordr_t(ie,ik),ik)
#else
                   work2(ie) = SpectralWeight(ie,ik)
#endif
                End Do
             endif
             write( nfband_spectr_wght,'(4f18.10)') ( work2(ie),ie=1, neg_t )
             write( nfband_spectr_wght,* )
          End Do
          call m_Files_close_nfband_spwt
       endif
    endif
    deallocate( work2 )
#if 1
    deallocate( neordr_t )
#endif
    
    deallocate( SpectralWeight )
    if ( allocated( fsr_filtered ) ) deallocate( fsr_filtered )
    if ( allocated( fsi_filtered ) ) deallocate( fsi_filtered )

    band_unfolding_active = .false.
    
  contains

   subroutine hardpart
      integer :: ik, i, ib1, ia, it, lmt1, lmt2, p1, p2, iadd
      real(kind=DP) :: csum
      real(kind=DP), allocatable :: work1(:,:), work2(:,:), fs(:,:)

      allocate( work1(neg,kv3) ) ; work1 = 0.0d0

      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle

         Do ie=ista_e, iend_e
            ib1 = map_z(ie)

            if ( k_symmetry(ik) == GAMMA) then
               allocate(fs(nlmta,1));   fs = 0.d0
               do i = ista_fs, iend_fs
                  iadd = i - ista_fs + 1
                  fs(i,1) = fsr_filtered(ib1,iadd,ik)
               end do
               call mpi_allreduce( MPI_IN_PLACE, fs, nlmta, mpi_double_precision, &
                    &              mpi_sum, mpi_ke_world, ierr )
            else
               allocate(fs(nlmta,2));    fs = 0.d0
               do i = ista_fs, iend_fs
                  iadd = i - ista_fs + 1
                  fs(i,1) = fsr_filtered(ib1,iadd,ik)
                  fs(i,2) = fsi_filtered(ib1,iadd,ik)
               end do
               call mpi_allreduce( MPI_IN_PLACE, fs, nlmta*2, mpi_double_precision, &
                    &              mpi_sum, mpi_ke_world, ierr )
            endif
            csum = 0.0d0

            do ia = ista_atm, iend_atm
               it = ityp(ia)
               do lmt1 = 1, ilmt(it)
                  p1 = lmta(lmt1,ia)
                  do lmt2 = 1, ilmt(it)
                     p2 = lmta(lmt2,ia)

                     if ( k_symmetry(ik) == GAMMA) then
                        csum = csum +fs( p1,1 ) *fs( p2,1 ) &
                             &      *q( lmt1, lmt2, it )
                     else
                        csum = csum +( fs( p1,1 ) *fs( p2,1 ) &
                             &        +fs( p1,2 ) *fs( p2,2 ) ) &
                             &      *q( lmt1, lmt2, it )
                     endif
                  end do
               end do
            end do
            deallocate(fs)
            work1(ie,ik) = work1(ie,ik) +csum
         End Do
      End Do
      SpectralWeight = SpectralWeight +work1
      deallocate(work1)
    end subroutine hardpart

    subroutine softpart
      integer :: ik, ie, ib1, ig, ii, ierr
      real(kind=DP) :: csum, c1, c2
      
      Do ik=1, kv3, ndim_spinor
         if ( map_k(ik) /= myrank_k ) cycle
         
         Do ie=ista_e, iend_e
            ib1 = map_z(ie)
            
            csum = 0.0d0
            
            if ( kimg == 1 ) then
               Do ig=ista_g1k(ik), iend_g1k(ik)
                  ii = nbase(ig, ik )
                  if ( sw_force_kpt_inside_bz == ON ) then
                     if ( GVec_on_refcell(ii,ik) == 0 ) cycle
                  else
                     if ( GVec_on_refcell(ii,1) == 0 ) cycle
                  endif
                  c1 = zaj_l( ig-ista_g1k(ik)+1, ib1, ik, 1 )
                  csum = csum + c1 **2
               End Do
            else
               Do ig=ista_g1k(ik), iend_g1k(ik)
                  ii = nbase(ig, ik )
                  if ( sw_force_kpt_inside_bz == ON ) then
                     if ( GVec_on_refcell(ii,ik) == 0 ) cycle
                  else
                     if ( GVec_on_refcell(ii,1) == 0 ) cycle
                  endif
                  c1 = zaj_l( ig-ista_g1k(ik)+1, ib1, ik, 1 )
                  c2 = zaj_l( ig-ista_g1k(ik)+1, ib1, ik, kimg )
                  csum = csum + c1 **2 +c2**2
               End Do
            endif
            SpectralWeight(ie,ik) = csum 
         End Do
      End Do
      
    end subroutine softpart

  end subroutine m_BU_calc_spectral_weight_3D


  subroutine m_BU_betar_dot_WFs_3D(nfout)
    integer, intent(in)    :: nfout
    integer :: ik
    integer :: mod_ball = ON
    
    Do ik=ista_k, iend_k
       call m_ES_betar_dot_Psi_4_each_k_3D( nfout, zaj_l, ista_k, iend_k, ik, &
            &                               fsr_filtered, fsi_filtered, mod_ball )
    End Do
  end subroutine m_BU_betar_dot_WFs_3D


end module m_Band_Unfolding

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Module Name : m_ES_occup_EPS                                     #
!#                                                                       #
!#                                Written by T. Hamada 2007/5/8          #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
module m_ES_occup_EPS
!     (m_ESoc)
! $Id: m_ES_occup_EPS.F90 410 2014-10-30 05:20:45Z jkoga $
  use m_Electronic_Structure, only : efermi, occup_l, eko_l, totch, neordr, eko_ek &
       &                            , vbm, metalic_system, check_if_metalic_flag
  use m_Kpoints,              only : kv3, kv3_ek, qwgt, qwgt_ek &
       &                            ,np0,np2,ip20,iwt,ip2cub,nxyz_tetra
  use m_Timing,               only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,   only : ipri, iprioccup, width, nspin, neg, af, ekmode, width_tetra
!!$       &                            ,deltaE_dos_Gaussdistrib, variance_dos_Gaussdistrib
  use m_Const_Parameters,     only : DP, DELTA_FermiSearchRange, ON, OFF
  use m_Parallelization,      only : npes,map_ek,mype,map_e,map_k,myrank_e,myrank_k &
       &                            ,ierr,np_e,map_z,ista_e,ista_k,iend_k
!! UVSOR
  use m_ES_occup,             only : check_totch, check_if_metalic
!! UVSOR

! ==== KT_add ==== 2014/09/22
  use m_Control_Parameters,    only : noncol, ndim_spinor
! ================ 2014/09/22

  implicit none
!   1. m_ESoc_fermi_parabolic       <-(ChargeDensity_Construction) ->(3)
!      - get_occup_l_and_tot, - find_eko_minimum_and_maximum
!   2. m_ESoc_fermi_tetrahedron     <-(ChargeDensity_Construction) ->(3)
!   3. check_totch           <-(1),(2)
!
!   The subroutine "m_ESoc_fermi_parabolic" was originally coded by
!   Noriaki Hamada, 1984.05.17
!
!! UVSOR
  real(kind=DP), allocatable, dimension(:,:) :: occup_l_ek
!! UVSOR
  include 'mpif.h'
contains

!! UVSOR
  subroutine m_ESoc_EPS_alloc_occup_l_ek
   allocate(occup_l_ek(neg,kv3_ek)) ; occup_l_ek=0.0d0
  end subroutine m_ESoc_EPS_alloc_occup_l_ek

  subroutine m_ESoc_EPS_dealloc_occup_l_ek
   deallocate(occup_l_ek)
  end subroutine m_ESoc_EPS_dealloc_occup_l_ek
!! UVSOR

  subroutine m_ESoc_EPS_fermi_parabolic_ek(nfout)
!
!   Coded from <m_ESoc_fermi_parabolic> 
!                      by T. Yamasaki (FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    integer :: id_sname = -1
!! UVSOR
    integer             :: ik, ie
    real(kind=DP),allocatable,dimension(:,:) :: occup_mpi, eko_tmp

    allocate(occup_mpi(neg,kv3_ek)); occup_mpi =0.0d0
!! UVSOR

    call tstatc0_begin('m_ESoc_EPS_fermi_parabolic_ek ', id_sname)

    call check_totch(nfout)

! ==== KT_mod ====== 2014/09/22
!    emin = minval(eko_ek)
!    emax = maxval(eko_ek)
!
    if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) )
       Do ik=1, kv3_ek /ndim_spinor
          eko_tmp(:,ik) = eko_ek(:,(ik-1)*ndim_spinor+1)
       End do
       emin = minval( eko_tmp );  emax = maxval( eko_tmp )
       deallocate( eko_tmp )
    else
       emin = minval(eko_ek);     emax = maxval(eko_ek)
    endif
! =================== 2014/09/22

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! === KT_mod ===== 2014/09/22
!       call get_tot_eps()             ! -(contained here) ->tot
!          ~~~~~~~~~~~~~~~~~~~~
       if ( noncol ) then
          call get_tot_eps_noncl()
       else
          call get_tot_eps()
       endif
! =============== 2014/09/22

       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)
       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch
    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    call check_if_metalic(nfout,metalic_system)
    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band enrgy = ", f10.4)') vbm

   call tstatc0_end(id_sname)

! ==== KT_mod ==== 2014/09/22
!    do ik = 1, kv3_ek, af+1                             ! MPI
!       do ie = 1, neg                                   ! MPI
!          if(map_e(ie) == myrank_e) then                ! MPI
!             occup_l_ek(map_z(ie),ik) = occup_mpi(ie,ik)! MPI
!          end if                                        ! MPI
!       end do                                           ! MPI
!    end do                                              ! MPI
!   deallocate(occup_mpi)
!
   if ( noncol ) then
      do ik = 1, kv3_ek, ndim_spinor
         do ie = 1, neg
            if(map_e(ie) == myrank_e) then
               occup_l_ek(map_z(ie),ik)   = occup_mpi(ie,ik)
               occup_l_ek(map_z(ie),ik+1) = occup_mpi(ie,ik)
            end if
         end do
      end do
   else
      do ik = 1, kv3_ek, af+1                             ! MPI
         do ie = 1, neg                                   ! MPI
            if(map_e(ie) == myrank_e) then                ! MPI
               occup_l_ek(map_z(ie),ik) = occup_mpi(ie,ik)! MPI
            end if                                        ! MPI
         end do                                           ! MPI
      end do                                              ! MPI
   endif

   deallocate(occup_mpi)
! ================ 2014/09/22

  contains

    subroutine get_tot_eps
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw
      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight*wspin*kv3_ek*qwgt_ek(k)
!! UVSOR
            occup_mpi(i,k) = totw
!! UVSOR
            tot = tot + 2*totw
         end do
      end do
      tot = tot/kv3_ek * (af+1)
      if(iprioccup >= 2) write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') efermi,tot, jcount
    end subroutine get_tot_eps

! === KT_add === 2014/09/22
    subroutine get_tot_eps_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            occup_mpi(i,k) = totw
            tot = tot + totw
         end do
      end do

      tot = tot /wktmp
      if(iprioccup >= 2) then
         write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') &
              &          efermi,tot, jcount
      endif

    end subroutine get_tot_eps_noncl
! ========= 2014/09/22

  end subroutine m_ESoc_EPS_fermi_parabolic_ek

  subroutine m_ESoc_EPS_fermi_tetra_ek(nfout)
!  Coded from <m_ESoc_fermi_tetrahedron>
!          by Takahiro Yamasaki(FUJITSU LABORATORIES Ltd.), 28th Jun. 2003
!
    integer, intent(in) :: nfout
#ifndef NO_TETRAHEDRON
    real(kind=DP), parameter :: delta = 1.d-12
    integer, parameter       :: idim = 3
    integer        :: neig,nengy,ispin,ip2,ik,instts1,ikee,nxx,nyy,nzz, ib, jb
    real(kind=DP)  :: efermi2,eval,totind, et
    real(kind=DP), pointer, dimension(:,:,:) :: eig2
    real(kind=DP), pointer, dimension(:) :: eawk,cdwk,cswk,cdos,cind,valud
    integer             :: id_sname = -1
!! UVSOR
    integer        :: ip_mpi, ieig
    integer, allocatable, dimension(:,:) :: neordr_ek
    real(kind=DP), pointer, dimension(:,:,:) :: occup2
!! UVSOR

    call tstatc0_begin('m_ESoc_EPS_fermi_tetra_ek ', id_sname)

    if ( noncol ) stop "PPPPPPPPPP"

    allocate(eig2(np2,neg,nspin)); eig2 = 0.d0
    allocate(eawk(np0)); eawk = 0.d0
    allocate(cdwk(np0)); cdwk = 0.d0
    allocate(cswk(np0)); cswk = 0.d0
    allocate(cdos(np2*neg)); cdos = 0.d0
    allocate(cind(np2*neg)); cind = 0.d0
    allocate(valud(nspin)); valud = 0.d0
!! UVSOR
    allocate(neordr_ek(neg,kv3_ek)) ; neordr_ek = 0
    allocate(occup2(neg,np2,nspin)) ; occup2 = 0.0d0
!! UVSOR

    call check_totch(nfout)           ! totch is checked

    nxx = nxyz_tetra(1)
    nyy = nxyz_tetra(2)
    nzz = nxyz_tetra(3)
    neig=neg
    nengy=0
    do ispin=1,nspin
       do ip2=1,np2
          ik=nspin*(ip2-1)+ispin
!! UVSOR
          neordr_ek(1:neg,ik) = (/(ib,ib = 1, neg)/)
!! UVSOR
          do ib=1,neg
             eig2(ip2,ib,ispin)=eko_ek(ib,ik)
          enddo
          do ib = 1,neg-1
             do jb = ib+1, neg
                if(eig2(ip2,jb,ispin) < eig2(ip2,ib,ispin)-delta) then
                   et = eig2(ip2,ib,ispin)
                   eig2(ip2,ib,ispin) = eig2(ip2,jb,ispin)
                   eig2(ip2,jb,ispin) = et
!! UVSOR
                   neordr_ek(ib,ik) =jb
                   neordr_ek(jb,ik) =ib
!! UVSOR
                end if
             end do
          end do
       enddo
    enddo

    if(iprioccup>=2) write(nfout,*) ' === tetrahedron method', &
                &  ' for k-space integration ==='
    if(iprioccup>=2) then
       write(nfout,'(" --- eig2 ---")')
       do ip2 = 1, np2
! === DEBUG by tkato 2013/11/19 ================================================
!         write(nfout,'(" (ip2 = ",i8,")",99(/,8d12.4))') ip2,(eig2(ip2,ib,ispin),ib=1,neg)
          write(nfout,'(" (ip2 = ",i8,")",99(/,8d12.4))') ip2,(eig2(ip2,ib,nspin),ib=1,neg)
! ==============================================================================
       end do
    end if
    efermi2 = efermi
! === Optional argument needs interface!!! by T.Kato 2013/07/02 ================
!   call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
!            &  eig2,ip20,np0,totch, efermi2,eval,valud, &
!            &  iwt,ip2cub,iprioccup)
    call fermi1(nxx,nyy,nzz,np2,np2,neig,neg,nspin, &
             &  eig2,ip20,np0,totch, efermi2,eval,valud, &
             &  iwt,ip2cub,iprioccup,.false.)
! ==============================================================================
    if(iprioccup>=2) write(nfout,*) 'eval=',eval
    do ispin=1,nspin
!!$      write(nfout,*) ' ispin=',ispin
      instts1 = 0
      call nsdos3(nfout,idim,efermi2,nxx,nyy,nzz,np2,1,neig, &
               &  eig2(1,1,ispin),ip20,np0,eawk,instts1,np2,iwt,ip2cub,iprioccup)
      call nstt3i(idim,nengy,efermi2,nxx,nyy,nzz, &
               &  np2,np2,neig,eig2(1,1,ispin), &
               &  ip20,np0,eawk,cdwk,cswk,np2,neig,cdos,cind,width_tetra )
      efermi=efermi2

      totind=0.d0
      do ip2=1,np2
         do ib=1,neig
            ikee=ip2+np2*(ib-1)
!! UVSOR
            ik = nspin * (ip2-1) + ispin
            ip_mpi = neordr_ek(ib,ik)
            occup2(ip_mpi,ip2,ispin) = cind(ikee)*dble(np2)
!! UVSOR
            totind=totind+cind(ikee)
         enddo
      enddo
      if(iprioccup>=2) write(nfout,*) 'for spin=',ispin, &
                  &  ' ** TOTAL CHARGE after fermi1 = ',totind
    enddo

!! UVSOR
    do ieig = 1, neg
       if(map_e(ieig) /= myrank_e) cycle                          ! MPI
       do ispin=1,nspin
          do ip2=1,np2
             ik=nspin*(ip2-1)+ispin
!             if(map_k(ik) == myrank_k) then                      ! MPI
                occup_l_ek(map_z(ieig),ik)=occup2(ieig,ip2,ispin) ! MPI
!             end if
          enddo
       enddo
    enddo
    deallocate(neordr_ek)
    deallocate(occup2)
!! UVSOR

    deallocate(valud); deallocate(cind); deallocate(cdos); deallocate(cswk)
    deallocate(cdwk);  deallocate(eawk)
    deallocate(eig2)
    
    call check_if_metalic(nfout,metalic_system)
    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band enrgy = ", f10.4)') vbm

    call tstatc0_end(id_sname)
#endif
  end subroutine m_ESoc_EPS_fermi_tetra_ek

! =========================== KT_add ======================= 13.0E
  subroutine m_ESoc_EPS_fermi_dirac_ek(nfout)
    integer, intent(in) :: nfout

    integer             :: jcount
    real(kind=DP)       :: emin, emax, e1, e2, tot
    real(kind=DP), parameter :: DELTA_TOTCH = 1.d-10
    integer,       parameter :: MAXITR = 100000
    integer :: id_sname = -1

    integer             :: ik, ie
    real(kind=DP),allocatable,dimension(:,:) :: occup_mpi, eko_tmp

    allocate(occup_mpi(neg,kv3_ek)); occup_mpi =0.0d0

    call tstatc0_begin('m_ESoc_EPS_fermi_dirac_ek ', id_sname)

    call check_totch(nfout)

! ==== KT_mod ====== 2014/09/22
!    emin = minval(eko_ek)
!    emax = maxval(eko_ek)
!
    if ( noncol ) then
       allocate( eko_tmp( neg, kv3_ek/ndim_spinor ) )
       Do ik=1, kv3_ek /ndim_spinor
          eko_tmp(:,ik) = eko_ek(:,(ik-1)*ndim_spinor+1)
       End do
       emin = minval( eko_tmp );  emax = maxval( eko_tmp )
       deallocate( eko_tmp )
    else
       emin = minval(eko_ek);     emax = maxval(eko_ek)
    endif
! =================== 2014/09/22

    efermi = emax
    e1 = emin - dabs(DELTA_FermiSearchRange)
    e2 = emax + dabs(DELTA_FermiSearchRange)

    jcount = 1
    occupied_ch_equals_totch : do

! === KT_mod ===== 2014/09/22
!       call get_tot_eps()             ! -(contained here) ->tot
!          ~~~~~~~~~~~~~~~~~~~~
       if ( noncol ) then
          call get_tot_eps_noncl()
       else
          call get_tot_eps()
       endif
! =============== 2014/09/22

       if(jcount == 1 .and. tot < totch) &
            call wd_fermi_error1(nfout,emin,emax,tot,totch) ! -(b_Fermi)

       if(dabs(tot - totch) < DELTA_TOTCH) exit occupied_ch_equals_totch
       if( tot < totch) then
          e1 = efermi; efermi = efermi + (e2-efermi)/2
       else
          e2 = efermi; efermi = efermi + (e1-efermi)/2
       end if
       jcount = jcount + 1
       if(jcount > MAXITR) then
          call wd_fermi_error2 &   !-(b_Fermi)
               & (nfout,e1,e2,efermi,emin,emax,tot,totch,neg,MAXITR)
       end if
    end do occupied_ch_equals_totch

    if(iprioccup >= 2) &
         &write(nfout,'( " efermi = ", f10.4, " tot = ", f10.4)') efermi, tot

    call check_if_metalic(nfout,metalic_system)
    if(iprioccup >= 2 .and. .not.metalic_system) &
         &write(nfout,'( " The highest occupied band enrgy = ", f10.4)') vbm

   call tstatc0_end(id_sname)

! ==== KT_mod ==== 2014/09/22
!    do ik = 1, kv3_ek, af+1                             ! MPI
!       do ie = 1, neg                                   ! MPI
!          if(map_e(ie) == myrank_e) then                ! MPI
!             occup_l_ek(map_z(ie),ik) = occup_mpi(ie,ik)! MPI
!          end if                                        ! MPI
!       end do                                           ! MPI
!    end do                                              ! MPI
!   deallocate(occup_mpi)
!
   if ( noncol ) then
      do ik = 1, kv3_ek, ndim_spinor
         do ie = 1, neg
            if(map_e(ie) == myrank_e) then
               occup_l_ek(map_z(ie),ik)   = occup_mpi(ie,ik)
               occup_l_ek(map_z(ie),ik+1) = occup_mpi(ie,ik)
            end if
         end do
      end do
   else
      do ik = 1, kv3_ek, af+1                             ! MPI
         do ie = 1, neg                                   ! MPI
            if(map_e(ie) == myrank_e) then                ! MPI
               occup_l_ek(map_z(ie),ik) = occup_mpi(ie,ik)! MPI
            end if                                        ! MPI
         end do                                           ! MPI
      end do                                              ! MPI
   endif

   deallocate(occup_mpi)
! ================ 2014/09/22

  contains

    subroutine get_tot_eps
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw

      tot = 0.d0
      do k = 1, kv3_ek, af+1
         do i = 1, neg
            e = eko_ek(i,k)

            call width_fermi_dirac(e,efermi,width,dos,weight)  ! -(b_Fermi)

            totw = weight*wspin*kv3_ek*qwgt_ek(k)
            occup_mpi(i,k) = totw
            tot = tot + 2*totw
         end do
      end do

      tot = tot/kv3_ek * (af+1)
      if (iprioccup >= 2) then
         write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') &
              &                         efermi,tot, jcount
      endif

    end subroutine get_tot_eps

! === KT_add === 2014/09/22
    subroutine get_tot_eps_noncl
      integer       :: k, i
      real(kind=DP) :: wspin = 1.d0, e, dos, weight, totw, wktmp

      tot = 0.d0
      wktmp = kv3_ek / ndim_spinor

      do k = 1, kv3_ek, ndim_spinor
         do i = 1, neg
            e = eko_ek(i,k)
            call width2(e,efermi,width,dos,weight)  ! -(b_Fermi)
            totw = weight *wspin *wktmp *qwgt_ek(k)
            occup_mpi(i,k) = totw
            tot = tot + totw
         end do
      end do

      tot = tot /wktmp
      if(iprioccup >= 2) then
         write(nfout,'(" efermi, tot = ",d20.12,d20.12," jcount = ",i7)') &
              &          efermi,tot, jcount
      endif

    end subroutine get_tot_eps_noncl
! ========= 2014/09/22

  end subroutine m_ESoc_EPS_fermi_dirac_ek
! ============================================================ 13.0E
end module m_ES_occup_EPS

!#========================================================================
!#                                                                       #
!# Software Name : UVSOR ver. 3.00                                       #
!#                                                                       #
!#      Sub Routine : Shift_Kpoint                                       #
!#                                                                       #
!#                                Written by T. Hamada 2006/4/28         #
!#                                                                       #
!#      Contact address :  IIS,The University of Tokyo RSS21 project     #
!#                                                                       #
!#"Multiscale Simulation System for Functional Analysis of Nanomaterials"#
!#                                                                       #
!#========================================================================
!
   subroutine Shift_Kpoint
      use m_Kpoints,               only : vkxyz_ek, kv3_ek
      use m_Files,                 only : nfout
      use m_Epsilon_ek,            only : sw_mass, mass_dir, ikshift, mass_direction, mass_ik, norm, check_gamma_point, vkxyz_ek_org
      use m_Crystal_Structure,     only : altv
      use m_Control_Parameters,    only : printable
      use m_Const_parameters,      only : DP, CARTS, BUCS, PAI
      implicit none
      integer                         :: ik, ind
      real(DP),dimension(3)           :: ashift, rshift
      real(DP)                        :: len_ashift
      if(sw_mass ==0.or.ikshift==0.0d0) return
! backup vkxyz_ek
      vkxyz_ek_org(1:kv3_ek,1:3,1:2) = vkxyz_ek(1:kv3_ek,1:3,1:2)
! set k-point shift
      ashift(1:3) = mass_dir(1:3)
      call norm(ashift,len_ashift)
      if(printable) write(nfout,'(1x,"!* len_mass_dir =",f10.5)') len_ashift
      ashift(1:3)= ashift(1:3)*ikshift
      if(printable) write(nfout,'(1x,"!* ikshift = ",f10.5)') ikshift
      if(printable) write(nfout,'(1x,"!* ashift = (",3f10.5,")")') ashift(1:3)
      if(mass_direction==0) then
! mass_ik point shift
         ik = mass_ik
         if(printable) write(nfout,'(1x,"!* shift of ik = ",i4," for mass calculation")') ik
         call shift_ikpoint
      else
! gamma point shift
         if(printable) write(nfout,'(1x,"!* shift of gamma point for mass calculation")')
         do ik = 1, kv3_ek
            call check_gamma_point(vkxyz_ek(ik,1:3,CARTS),ind)
            if(ind/=0) exit
         end do
         call shift_ikpoint
      end if
      if(printable) write(nfout,'(1x,"!* rshift = (",3f10.5,")")') rshift(1:3)
      if(printable) write(nfout,'(1x,"!* shifted ik = ",i4," point = (",3f10.5,")")') &
     & ik, vkxyz_ek(ik,1,BUCS),vkxyz_ek(ik,2,BUCS),vkxyz_ek(ik,3,BUCS)
      contains
       subroutine shift_ikpoint
         implicit none
         real(DP), dimension(3,3) :: work
         work(1:3,1:3) = altv(1:3,1:3)/(2.0d0*PAI)
         rshift(1) = work(1,1)*ashift(1)+work(1,2)*ashift(2)+work(1,3)*ashift(3)
         rshift(2) = work(2,1)*ashift(1)+work(2,2)*ashift(2)+work(2,3)*ashift(3)
         rshift(3) = work(3,1)*ashift(1)+work(3,2)*ashift(2)+work(3,3)*ashift(3)
         vkxyz_ek(ik,1:3,BUCS) = vkxyz_ek(ik,1:3,BUCS) + rshift(1:3)
       end subroutine shift_ikpoint
   end subroutine Shift_Kpoint

!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 594 $)
!
!  MODULE: m_ES_Intgr_VlhxcQlm
!
!  AUTHOR(S): T. Yamasaki   August/20/2003
!      Further modification by T. Yamasaki   May/17/2005
!      Further modification by T. Yamasaki   Aug/31/2007
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
!     The original version of this set of the computer programs "PHASE"
!  was developed by the members of the Theory Group of Joint Research
!  Center for Atom Technology (JRCAT), based in Tsukuba, in the period
!  1993-2001.
!
!     Since 2002, this set has been tuned and new functions have been
!  added to it as a part of the national project "Frontier Simulation 
!  Software for Industrial Science (FSIS)",  which is supported by
!  the IT program of the Ministry of Education, Culture, Sports,
!  Science and Technology (MEXT) of Japan. 
!     Since 2006, this program set has been developed as a part of the
!  national project "Revolutionary Simulation Software (RSS21)", which
!  is supported by the next-generation IT program of MEXT of Japan.
!   Since 2013, this program set has been further developed centering on PHASE System
!  Consortium.
!   The activity of development of this program set has been supervised by Takahisa Ohno.
!
!

#ifdef VPP
#define _VECTOR_TUNING_
#endif
#ifdef SX
#define _VECTOR_TUNING_
#endif
#ifdef HIUX
#define _VECTOR_TUNING_
#endif

module m_ES_Intgr_VlhxcQlm
! $Id: m_ES_Intgr_VlhxcQlm.F90 594 2019-07-01 07:15:23Z jkoga $
  use m_Electronic_Structure,only : vlhxcQ, vlhxc_l, dhub
  use m_PlaneWaveBasisSet,   only : kgp,ngabc,m_pwBS_sphrp2,ylm_l
  use m_PseudoPotential,     only : ilmt,ltp,taup,isph,il2p,iqitg,qitg_l,dl2p &
       &                           ,modnrm,m_PP_find_maximum_l, nqitg, nlmt &
       &                           ,m_PP_include_vanderbilt_pot, ivanl &
       &                           ,m_PP_set_index_arrays1 &
       &                           ,m_PP_set_index_arrays2
  use m_Ionic_System,        only : ntyp, natm, ityp, pos, ihubbard
  use m_Crystal_Structure,   only : af, rltv, univol
  use m_Timing,              only : tstatc0_begin, tstatc0_end
  use m_Control_Parameters,  only : nspin,iprivlhxcq,kimg,nel_Ylm, m_CtrlP_cachesize, sw_communicator_for_chg
  use m_Const_Parameters,    only : DP, PAI2, zi, SKIP, OFF
  use m_Parallelization,     only : mpi_comm_group,ista_kngp,iend_kngp,npes,mype,ierr, np_e

! ========================== added by K. Tagami ================== 11.0
  use m_Control_Parameters,  only : ndim_magmom
! ================================================================ 11.0

  implicit none

  include 'mpif.h'
!  52. m_ESiVQ_integrate_VlhxcQlm
#ifdef _VECTOR_TUNING_
!      - symmetrize_vlhxcq, - integrate_qitg_x_ylm, - integration_of_VlhxcQlm_core3,
#else
!      - symmetrize_vlhxcq, - integration_of_VlhxcQlm_core2,
#endif
!      - integration_of_VlhxcQlm_core
contains

!$$#ifndef PARA3D
  subroutine m_ESiVQ_integrate_VlhxcQlm(nfout)
    ! ***
    ! (Rev) T. Yamaskai, 31, Aug, 2007
    !     1. 'call set_index_arrays1' that included a bug is replaced
    !       by 'call m_PP_set_index_arrays1', whose bug is fixed.
    !     2. 'call set_index_arrays2' is also replaced by 'call
    !       m_PP_set_index_arrays2' that can be referred from other modules.
    !     3. contained subroutines, set_index_arrays1 and set_index_arrays2 were
    !       deleted.
    ! ***
    integer, intent(in)   :: nfout

    real(kind=DP), pointer, dimension(:)               :: ylm
    real(kind=DP), allocatable, dimension(:)           :: ylm_t
    real(kind=DP), allocatable, target, dimension(:,:) :: ylm_ext
#ifdef _VECTOR_TUNING_
    real(kind=DP), allocatable, target, dimension(:,:) :: zfcos_x, zfsin_x  ! d(ista_kngp:iend_kngp_adj,n_ialist0)
#ifndef _m_ESIV_no_loop_exchange_
    integer                                            :: ia_s
    real(kind=DP), allocatable, dimension(:,:)         :: veq_x ! d(ista_kngp:iend_kngp_adj,n_ialist0)
    real(kind=DP), allocatable, dimension(:)           :: vq_x ! d(n_ialist0) 
#endif
    integer :: iend_kngp_adj, n_ialist, n_ialist0, ia_start, n_iagroup, n_ia, ia_g, l3_odd, l3_even
    integer, allocatable, dimension(:) :: ia_list
    real(kind=DP), allocatable, dimension(:,:) ::         qitgylm
#else
    real(kind=DP), allocatable, target, dimension(:)   :: zfcos, zfsin
#ifndef _m_ESIV_no_loop_exchange_
    integer :: ncache, ibsize, ibl1, ibl2
    real(kind=DP), allocatable, dimension(:)           :: veq ! d(ista_kngp:iend_kngp)
    real(kind=DP)                                      :: vq_ia
    real(kind=DP), allocatable, dimension(:,:)         :: qitg_red, ylm_red, vlhxc_red
#endif
#endif
    integer,       allocatable, dimension(:)           :: il3

    integer :: is,it,lmt1,lmt2,il1,tau1,il2,tau2,n,ilm3,l3,iiqitg,ia

#ifndef _m_ESIV_no_loop_exchange_
    integer :: m, maxm, ip, np, iq
    integer, parameter :: mcritical = 4*2+1
    integer, allocatable, dimension(:) :: nqitg_sp, nqitg_sp0 !d(ntyp)
    integer, allocatable, dimension(:) :: iq2l3 ! d(nqitg)
    integer, allocatable, dimension(:,:) :: nc  ! d(maxm,nqitg)
    integer :: mc ! maxval(nc)
    integer, allocatable, dimension(:,:,:) :: nc2lmt1, nc2lmt2, nc2n ! d(mc,maxm,nqitg)
#endif

    real(kind=DP), allocatable, dimension(:,:,:,:) :: vlhxcQ_mpi ! d(nlmt,nlmt,natm,nspin)

    integer :: id_sname = -1
    if(modnrm == SKIP) return

    call tstatc0_begin('m_ESiVQ_integrate_VlhxcQlm ',id_sname)

    call m_PP_find_maximum_l(n)    ! n-1: maximum l
    n = (n-1) + (n-1) + 1
    allocate(il3(n**2)); call substitute_il3(n**2,il3) ! -(b_Elec..)

#ifndef _m_ESIV_no_loop_exchange_
    allocate(nqitg_sp(ntyp)); allocate(nqitg_sp0(ntyp))
    allocate(iq2l3(nqitg))
    allocate(nc(mcritical,nqitg));nc=0
    call m_PP_set_index_arrays1(nfout,ntyp,nqitg,mcritical,n**2,il3 &
         & ,maxm,mc,nqitg_sp,nqitg_sp0,iq2l3,nc)
    allocate(nc2lmt1(mc,maxm,nqitg))
    allocate(nc2lmt2(mc,maxm,nqitg))
    allocate(nc2n(mc,maxm,nqitg))
    call m_PP_set_index_arrays2(nfout,mc,maxm,nqitg,mcritical,n**2,il3,iq2l3 &
         & ,nc2lmt1,nc2lmt2,nc2n,nc) ! -> nc2lmt1, nc2lmt2, nc2n, nc
#endif

#ifdef _VECTOR_TUNING_
    n_ialist = 1
#ifdef HIUX
    n_ialist = 16
#endif
#ifdef VPP
    n_ialist = 8
#endif
#ifdef SX
    n_ialist = 8
#endif
    iend_kngp_adj = iend_kngp
#ifdef HIUX
#else
    if(mod(iend_kngp-ista_kngp+1,2) == 0) iend_kngp_adj = iend_kngp_adj+1
#endif
    allocate(ia_list(n_ialist))
#endif

    if(n**2 > nel_Ylm) then
       allocate(ylm_ext(ista_kngp:iend_kngp,nel_Ylm+1:n**2));  ylm_ext = 0.d0
       allocate(ylm_t(ista_kngp:iend_kngp)); ylm_t = 0.d0
       do ilm3 = nel_Ylm+1, n**2
          call m_pwBS_sphrp2(ilm3,rltv,ista_kngp,iend_kngp,ylm_t)  ! (ilm3,rltv,ngabc,gr_l)->(ylm)
          ylm_ext(:,ilm3) = ylm_t(:)
       end do
       deallocate(ylm_t)
    end if

    vlhxcQ = 0.d0

! ====================================== modified by K. Tagami ============== 11.0
!    do is = 1, nspin, af+1
    do is = 1, ndim_magmom, af+1
! =========================================================================== 11.0

#ifdef _VECTOR_TUNING_
       do it = 1, ntyp
          if(sum(ivanl(:,it)) == 0) cycle
          allocate(qitgylm(ista_kngp:iend_kngp,2))

          n_ia = 0
          do ia = 1, natm
             if(ityp(ia) == it) n_ia = n_ia + 1
          end do
          if(n_ialist <=0) stop 'n_ialist is illegal <<m_ESiVQ_integrate_VlhxcQlm>>'
          n_iagroup = n_ia/n_ialist + 1
          ia_start = 1
          if(iprivlhxcq >= 2) write(nfout,'(" !m_ESiVQ_integrate_VlhxcQlm: n_iagroup = ",i8, " ityp = ",i8)') n_iagroup,it
          do ia_g = 1, n_iagroup
             n_ialist0 = 0
             ia_list = 0
             AtomcountLoop: do ia = ia_start, natm
                if(ityp(ia) == it) then
                   n_ialist0 = n_ialist0 + 1
                   ia_list(n_ialist0) = ia
                end if
                if(n_ialist0 >= n_ialist) exit AtomcountLoop
             end do AtomcountLoop
             ia_start = ia+1
             if(n_ialist0 >= 1) then
                if(iprivlhxcq >= 2) write(nfout,'(" !m_ESiVQ_integrate_VlhxcQlm: ia_list = ",8i8)') (ia_list(ia),ia=1,n_ialist0)
                allocate(zfcos_x(ista_kngp:iend_kngp_adj,n_ialist0))
                allocate(zfsin_x(ista_kngp:iend_kngp_adj,n_ialist0))
                call calc_phase_b(natm,pos,ia_list,n_ialist0,kgp,ngabc,ista_kngp,iend_kngp &
                     &                                                ,ista_kngp,iend_kngp_adj,zfcos_x,zfsin_x)
#ifndef _m_ESIV_no_loop_exchange_
                allocate(veq_x(ista_kngp:iend_kngp_adj,n_ialist0))
                allocate(vq_x(n_ialist0))
                if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
                do iq = nqitg_sp0(it), nqitg_sp(it)
                   l3 = iq2l3(iq)
                   if(l3 == 0) then
                      ilm3 = 1
                      call integration_of_VlhxcQlm_core4(iq,vq_x) ! iq, vlhxc,exp,qitg_l,ylm -> vq_x
                   else
                      call dp_Vlhxcq_exp_Q_x(iq) ! vlhxc, exp, qitg_l  -> veq_x
                   end if
                   do m = 1, 2*l3+1
                      ilm3 = l3*l3+m
                      if(l3 /= 0) call veQ_dot_ylm_x(vq_x) ! veq_x, ylm -> vq_x
                      do ia_s = 1, n_ialist0 
                         ia = ia_list(ia_s)
                         do ip = 1, nc(m,iq)
                            lmt1 = nc2lmt1(ip,m,iq)
                            lmt2 = nc2lmt2(ip,m,iq)
                            np = nc2n(ip,m,iq)
                            if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
                            vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) + univol*vq_x(ia_s)*dl2p(lmt1,lmt2,np,it)
                         end do
                      end do
                   end do
                end do
                deallocate(vq_x,veq_x)
#else
                if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,lmt1, il1,tau1,lmt2, il2,tau2,il2p,ilm3,  l3,iiqitg ")')
                
                do lmt1 = 1, ilmt(it)
                   il1  = ltp( lmt1, it);   tau1 = taup(lmt1, it)
                   do lmt2 = lmt1, ilmt(it)
                      il2  = ltp( lmt2, it);   tau2 = taup(lmt2, it)
                      l3_odd = 0; l3_even = 0

! ---------------------------------------------------- 11.0S
#ifdef SKIP_TEST
                      if ( il1 /= il2 ) cycle
                      if ( im1 /= im2 ) cycle
#endif
! ---------------------------------------------------- 11.0S


                      qitgylm = 0.d0
                      do n = 1, il2p(lmt1,lmt2,it)
                         ilm3 = isph(lmt1,lmt2,n,it);   l3 = il3(ilm3)
                         iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                         if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",11i5)') ia,lmt1,il1,tau1,lmt2,il2,tau2,n,ilm3,l3,iiqitg
                         if(iiqitg == 0) cycle
                         call integrate_qitg_x_ylm() ! -> qitgylm
                      end do
                      if(l3_odd + l3_even >=1) call integration_of_VlhxcQlm_core3()
                      !                             ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                   end do
                end do
#endif
                deallocate(zfsin_x,zfcos_x)
             end if
          end do
          deallocate(qitgylm)
       end do
#else

#ifndef _m_ESIV_no_loop_exchange_
       ncache = (m_CtrlP_cachesize()*1024)*3/4
       if(ncache == 0) then
          ibsize = iend_kngp-ista_kngp+1
       else
          ibsize=ncache/(8*(n**2))
       end if
       if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibsize = ", i8)') ibsize
       allocate(zfcos(ibsize)); zfcos = 0.d0
       allocate(zfsin(ibsize)); zfsin = 0.d0
       allocate(veq(ibsize))
       allocate(qitg_red(ibsize,nqitg))
       allocate(vlhxc_red(ibsize,kimg))
       allocate(ylm_red(ibsize,n**2))
       do ibl1 = ista_kngp, iend_kngp, ibsize
          ibl2 = ibl1+ibsize-1
          if(ibl2 .gt. iend_kngp) ibl2 = iend_kngp
          if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ibl1,ibl2,ibsize = ", 3i8)') ibl1, ibl2, ibsize

          call substitute_qitgred()  ! qitg_l -> qitg_red
          call substitute_vlhxcred() ! vlhxc_l -> vlhxc_red
          call substitute_ylmred()   ! ylm_l, ylm_ext -> ylm_red 
          do ia = 1, natm
             it = ityp(ia)
             if(sum(ivanl(:,it)) == 0) cycle
             call calc_phase_div(ia)  !   -> zfcos, zfsin
             if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,  iq,  l3,   m,ilm3,  ip,lmt1,lmt2,  np")')
             do iq = nqitg_sp0(it), nqitg_sp(it)
                l3 = iq2l3(iq)
                call dp_Vlhxcq_exp_Q_div(iq) ! vlhxc, exp, qitg_l  -> veq
                do m = 1, 2*l3+1
                   ilm3 = l3*l3+m
!!$                   if(ilm3 <= nel_Ylm) then
!!$                      ylm => ylm_l(:,ilm3)
!!$                   else
!!$                      ylm => ylm_ext(:,ilm3)
!!$                   end if
                   call veQ_dot_ylm_div(vq_ia) ! veq, ylm -> vq_ia
                   do ip = 1, nc(m,iq)
                      lmt1 = nc2lmt1(ip,m,iq)
                      lmt2 = nc2lmt2(ip,m,iq)
                      np = nc2n(ip,m,iq)
                      if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",9i5)') ia, iq, l3, m, ilm3, ip, lmt1,lmt2,np
                      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is) + univol*vq_ia*dl2p(lmt1,lmt2,np,it)
                   end do
                end do
             end do
          end do
       end do
       deallocate(ylm_red)
       deallocate(vlhxc_red)
       deallocate(qitg_red)
       deallocate(veq)
#else
       allocate(zfcos(ista_kngp:iend_kngp)); zfcos = 0.d0
       allocate(zfsin(ista_kngp:iend_kngp)); zfsin = 0.d0
       do ia = 1, natm
          it = ityp(ia)
          if(sum(ivanl(:,it)) == 0) cycle
          call calc_phase2(natm,pos,ia,kgp,ngabc,ista_kngp,iend_kngp,zfcos,zfsin)
          !                -> zfcos, zfsin
          if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ:    ia,lmt1, il1,tau1,lmt2, il2,tau2,il2p,ilm3,  l3,iiqitg ")')
          do lmt1 = 1, ilmt(it)
             il1  = ltp( lmt1, it);   tau1 = taup(lmt1, it)
             do lmt2 = lmt1, ilmt(it)
                il2  = ltp( lmt2, it);   tau2 = taup(lmt2, it)

#ifdef SKIP_TEST
! ---------------------------------------------------- 11.0S
                if ( il1 /= il2 ) cycle
                if ( im1 /= im2 ) cycle
! ---------------------------------------------------- 11.0S
#endif

                do n = 1, il2p(lmt1,lmt2,it)
                   ilm3 = isph(lmt1,lmt2,n,it);   l3 = il3(ilm3)
                   iiqitg = iqitg(il1,tau1,il2,tau2,l3+1,it)
                   if(iprivlhxcq >= 2) write(nfout,'(" !mESiVQ: ",11i5)') ia,lmt1,il1,tau1,lmt2,il2,tau2,n,ilm3,l3,iiqitg
                   if(iiqitg == 0) cycle
                   if(ilm3 <= nel_Ylm) then
                      ylm => ylm_l(:,ilm3)
                   else
                      ylm => ylm_ext(:,ilm3)
                   end if
                   call integration_of_VlhxcQlm_core2 ! -> vlhxcQ(lmt1,lmt2,ia,is)
                   !    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                end do
             end do
          end do
       end do
#endif
#endif

#ifndef _VECTOR_TUNING_
       deallocate(zfsin);deallocate(zfcos)
#endif
    end do
    if(npes > 1) then
! ================================= modified by K. Tagami ================ 11.0
!       allocate(vlhxcQ_mpi(nlmt,nlmt,natm,nspin)); vlhxcQ_mpi = 0.d0
!       call mpi_allreduce(vlhxcQ, vlhxcQ_mpi,nlmt*nlmt*natm*nspin, mpi_double_precision,mpi_sum,mpi_comm_group,ierr)

       allocate( vlhxcQ_mpi(nlmt,nlmt,natm,ndim_magmom) ); vlhxcQ_mpi = 0.d0
       call mpi_allreduce( vlhxcQ, vlhxcQ_mpi, nlmt*nlmt*natm*ndim_magmom, &
        &                  mpi_double_precision, mpi_sum, mpi_comm_group, ierr )
! ======================================================================= 11.0
       vlhxcQ = vlhxcQ_mpi
       deallocate(vlhxcQ_mpi)
    end if
    call symmetrize_vlhxcq
    if(allocated(ylm_ext)) deallocate(ylm_ext)
#ifdef _VECTOR_TUNING_
    deallocate(ia_list); deallocate(il3)
#else
!!$    deallocate(zfsin); deallocate(zfcos); deallocate(il3)
    deallocate(il3)
#endif

#ifndef _m_ESIV_no_loop_exchange_
    deallocate(nc2n,nc2lmt2,nc2lmt1,nc,iq2l3,nqitg_sp,nqitg_sp0)
#endif

    if(iprivlhxcq >= 2) then
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ start'
! =================================== modified by K. Tagami =============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

          do it = 1, natm
             write(nfout,*) ' (vlhxcQ) -- #atom = ', it
             do lmt1 = 1, ilmt(ityp(it))
                write(nfout,*) ' --- lmt1 = ', lmt1
                write(nfout,'(99(5d16.8,/))')&
                     & (vlhxcq(lmt1,lmt2,it,is),lmt2=1,ilmt(ityp(it)))
             end do
          end do
       end do
       write(nfout,*) ' <<< m_ESiVQ_integrate_VlhxcQlm >>> vlhxcQ end'
    endif
    call tstatc0_end(id_sname)
  contains

    subroutine symmetrize_vlhxcq
      integer :: is, ia, it, lmt1, lmt2
! =================================== modified by K. Tagami =============== 11.0
!       do is = 1, nspin, af+1
       do is = 1, ndim_magmom, af+1
! ========================================================================= 11.0

         do ia = 1, natm
            it = ityp(ia)
            do lmt1 = 1, ilmt(it)
               do lmt2 = lmt1+1, ilmt(it)
                  vlhxcQ(lmt2,lmt1,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)
               end do
            end do
         end do
      end do
    end subroutine symmetrize_vlhxcq

#ifdef _VECTOR_TUNING_
#ifndef _m_ESIV_no_loop_exchange_
    subroutine integration_of_VlhxcQlm_core4(iq,vq)
      integer, intent(in) :: iq
      real(kind=DP),dimension(n_ialist0), intent(out) :: vq
      integer       :: i,ia_s,ia
      real(kind=DP) ::  f


      vq = 0.d0
      if(ilm3 <= nel_Ylm) then
         if(kimg == 1) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
                  end do
               end do
            end if
         else if(kimg == 2) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  !for mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_l(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
                  end do
               end do
            end if
         end if
      else if(ilm3 > nel_Ylm) then
         if(kimg == 1) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
                  end do
               end do
            end if
         else if(kimg == 2) then
            if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  ! mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
                  end do
               end do
            else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
               do ia_s = 1, n_ialist0
                  do i = ista_kngp, iend_kngp  !for mpi
                     vq(ia_s) = vq(ia_s) + qitg_l(i,iq)*ylm_ext(i,ilm3) &
                          & *(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
                  end do
               end do
            end if
         end if
      end if

      if(mod(l3,2) == 0) then
         vq(:) = real(zi**l3)*vq(:)
      else if(mod(l3,2) == 1) then
         vq(:) = -aimag(zi**l3)*vq(:)
      end if
    end subroutine integration_of_VlhxcQlm_core4

    subroutine dp_Vlhxcq_exp_Q_x(iq)
      integer, intent(in) :: iq
      integer       :: i, ia_s

      if(kimg == 1) then
         if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfcos_x(i,ia_s)
               end do
            end do
         else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfsin_x(i,ia_s)
               end do
            end do
         end if
      else if(kimg == 2) then
         if(mod(l3,2) == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
               end do
            end do
         else if(mod(l3,2) == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  !for mpi
                  veq_x(i,ia_s) = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
         end if
      end if
    end subroutine dp_Vlhxcq_exp_Q_x

    subroutine veQ_dot_ylm_x(vq_x)
      real(kind=DP), intent(out) :: vq_x(n_ialist0)

      integer       :: i,iy, ia

      if(ilm3 <= nel_Ylm) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
#ifdef SX
!CDIR PARALLEL DO PRIVATE(ia,i)
#endif
         do ia = 1, n_ialist0
            vq_x(ia) = 0.d0
            do i = ista_kngp, iend_kngp  ! mpi
               vq_x(ia) = vq_x(ia) + veq_x(i,ia)*ylm_l(i,ilm3)
            end do
         end do
      else
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
#ifdef SX
!CDIR PARALLEL DO PRIVATE(ia,i)
#endif
         do ia = 1, n_ialist0
            vq_x(ia) = 0.d0
            do i = ista_kngp, iend_kngp  ! mpi
               vq_x(ia) = vq_x(ia) + veq_x(i,ia)*ylm_ext(i,ilm3)
            end do
         end do
      end if

      if(mod(l3,4) == 0) then
         vq_x = vq_x
      else if(mod(l3,4) == 1) then
         vq_x = -vq_x
      else if(mod(l3,4) == 2) then
         vq_x = -vq_x
      else if(mod(l3,4) == 3) then
         vq_x = vq_x
      end if
    end subroutine veQ_dot_ylm_x
#else
    subroutine integrate_qitg_x_ylm()
      integer :: i
      real(kind=DP) :: f

      if(ilm3 <= nel_Ylm) then
         if(mod(l3,2) == 0) then
            l3_even = l3_even+1
            f = real(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  ! mpi
               qitgylm(i,1) = qitgylm(i,1) + f*qitg_l(i,iiqitg)*ylm_l(i,ilm3)
            end do
         else if(mod(l3,2) == 1) then
            l3_odd = l3_odd+1
            f = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  !mpi
               qitgylm(i,2) = qitgylm(i,2) + f*qitg_l(i,iiqitg)*ylm_l(i,ilm3)
            end do
         end if
      else
         if(mod(l3,2) == 0) then
            l3_even = l3_even+1
            f = real(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  ! mpi
               qitgylm(i,1) = qitgylm(i,1) + f*qitg_l(i,iiqitg)*ylm_ext(i,ilm3)
            end do
         else if(mod(l3,2) == 1) then
            l3_odd = l3_odd+1
            f = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)
            do i = ista_kngp, iend_kngp  !mpi
               qitgylm(i,2) = qitgylm(i,2) + f*qitg_l(i,iiqitg)*ylm_ext(i,ilm3)
            end do
         end if
      end if
    end subroutine integrate_qitg_x_ylm
      
    subroutine integration_of_VlhxcQlm_core3
      integer       :: i,ia_s,ia
      real(kind=DP),allocatable,dimension(:) :: vq

      allocate(vq(n_ialist0)); vq = 0.d0

      if(kimg == 1) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
         do ia_s = 1, n_ialist0
            do i = ista_kngp, iend_kngp  ! mpi
               vq(ia_s) = vq(ia_s) + vlhxc_l(i,1,is)*(qitgylm(i,1)*zfcos_x(i,ia_s) &
                    &                               + qitgylm(i,2)*zfsin_x(i,ia_s))
            end do
         end do
      else if(kimg == 2) then
         if(l3_even > 0 .and. l3_odd >0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,1)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s)) &
                       & + qitgylm(i,2)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
        else if(l3_even > 0 .and. l3_odd == 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,1)*(vlhxc_l(i,1,is)*zfcos_x(i,ia_s)-vlhxc_l(i,2,is)*zfsin_x(i,ia_s))
               end do
            end do
         else if(l3_even == 0 .and. l3_odd > 0) then
#ifdef VPP
*vocl loop, unroll(4)
#endif
#ifdef HIUX
*poption indep
*poption parallel
#endif
            do ia_s = 1, n_ialist0
               do i = ista_kngp, iend_kngp  ! mpi
                  vq(ia_s) = vq(ia_s) &
                       & + qitgylm(i,2)*(vlhxc_l(i,1,is)*zfsin_x(i,ia_s)+vlhxc_l(i,2,is)*zfcos_x(i,ia_s))
               end do
            end do
         end if
      end if

      do ia_s = 1, n_ialist0
         ia = ia_list(ia_s)
         vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq(ia_s)
      end do
      deallocate(vq)
    end subroutine integration_of_VlhxcQlm_core3
#endif


!!!-->  #else if .not. _VECTOR_TUNING_
#else

    subroutine substitute_qitgred()
      integer :: iq, i
      do iq = 1, nqitg
         do i = 1, ibl2-ibl1+1
            qitg_red(i, iq) = qitg_l(i+ibl1-1,iq)
         end do
      end do
    end subroutine substitute_qitgred

    subroutine substitute_vlhxcred
      integer :: i
      if(kimg==1) then
         do i = 1, ibl2-ibl1+1
            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
         end do
      else if(kimg==2) then
         do i = 1, ibl2-ibl1+1
            vlhxc_red(i,1) = vlhxc_l(i+ibl1-1,1,is)
            vlhxc_red(i,2) = vlhxc_l(i+ibl1-1,2,is)
         end do
      end if
    end subroutine substitute_vlhxcred

    subroutine substitute_ylmred
      integer :: ilm, i
      do ilm = 1, nel_Ylm
         do i = 1, ibl2-ibl1+1
            ylm_red(i,ilm) = ylm_l(i+ibl1-1,ilm)
         end do
      end do
      if(n**2 > nel_Ylm) then
         do ilm = nel_ylm+1, n**2
            do i = 1, ibl2-ibl1+1
               ylm_red(i,ilm) = ylm_ext(i+ibl1-1,ilm)
            end do
         end do
      end if
    end subroutine substitute_ylmred

    subroutine calc_phase_div(ia)
      integer, intent(in) :: ia
      integer :: i, ig
      real(kind=DP) :: fx, fy, fz, ph
      fx = pos(ia,1)*PAI2
      fy = pos(ia,2)*PAI2
      fz = pos(ia,3)*PAI2
      do i = 1, ibl2-ibl1+1
         ig = i + ibl1 - 1
         ph = ngabc(ig,1)*fx + ngabc(ig,2)*fy + ngabc(ig,3)*fz
         zfcos(i) = dcos(ph)
         zfsin(i) = dsin(ph)
      end do
    end subroutine calc_phase_div

#ifndef _m_ESIV_no_loop_exchange_
    subroutine dp_Vlhxcq_exp_Q(iq)
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2
      
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  ! mpi
            veq(i) = qitg_l(i,iq)*vlhxc_l(i,1,is)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  ! mpi
            veq(i)  = qitg_l(i,iq)*(vlhxc_l(i,1,is)*zfsc1(i)+f*vlhxc_l(i,2,is)*zfsc2(i))
         end do
      end if
    end subroutine dp_Vlhxcq_exp_Q

    subroutine veQ_dot_ylm(vq)
      real(kind=DP), intent(out) :: vq

      integer       :: i,iy
      vq = 0.d0
      do i = ista_kngp, iend_kngp  ! mpi
         iy = i-ista_kngp+1
         vq = vq + veq(i)*ylm(iy)
      end do

      if(mod(l3,4) == 0) then
         vq = vq
      else if(mod(l3,4) == 1) then
         vq = -vq
      else if(mod(l3,4) == 2) then
         vq = -vq
      else if(mod(l3,4) == 3) then
         vq = vq
      end if
    end subroutine veQ_dot_ylm

    subroutine dp_Vlhxcq_exp_Q_div(iq)
      integer, intent(in) :: iq
      integer       :: i
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2
      
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = 1, ibl2-ibl1+1
            veq(i) = qitg_red(i,iq)*vlhxc_red(i,1)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = 1, ibl2-ibl1+1
            veq(i)  = qitg_red(i,iq)*(vlhxc_red(i,1)*zfsc1(i)+f*vlhxc_red(i,2)*zfsc2(i))
         end do
      end if
    end subroutine dp_Vlhxcq_exp_Q_div

    subroutine veQ_dot_ylm_div(vq)
      real(kind=DP), intent(out) :: vq

      integer       :: i,iy
      vq = 0.d0
      do i = 1, ibl2-ibl1+1
         vq = vq + veq(i)*ylm_red(i,ilm3)
      end do

      if(mod(l3,4) == 0) then
         vq = vq
      else if(mod(l3,4) == 1) then
         vq = -vq
      else if(mod(l3,4) == 2) then
         vq = -vq
      else if(mod(l3,4) == 3) then
         vq = vq
      end if
    end subroutine veQ_dot_ylm_div

#else
    subroutine integration_of_VlhxcQlm_core2
      integer       :: i,iy
      real(kind=DP) :: vq
      real(kind=DP) :: f
      real(kind=DP), pointer, dimension(:) :: zfsc1, zfsc2

      vq = 0.d0
      if(mod(l3,2) == 0) then
         zfsc1 => zfcos
         if(kimg == 2) zfsc2 => zfsin
         f = -1.d0
      else if(mod(l3,2) == 1) then
         zfsc1 => zfsin
         if(kimg == 2) zfsc2 => zfcos
         f = 1.d0
      end if

      if(kimg == 1) then
         do i = ista_kngp, iend_kngp  ! mpi
            iy = i-ista_kngp+1
            vq = vq + qitg_l(i,iiqitg)*ylm(iy)*vlhxc_l(i,1,is)*zfsc1(i)
         end do
      else if(kimg == 2) then
         do i = ista_kngp, iend_kngp  ! mpi
            iy = i-ista_kngp+1
            vq  = vq + qitg_l(i,iiqitg)*ylm(iy)*(vlhxc_l(i,1,is)*zfsc1(i)+f*vlhxc_l(i,2,is)*zfsc2(i))
         end do
      end if
      if(mod(l3,2) == 0) then
         vq = real(zi**l3)*dl2p(lmt1,lmt2,n,it)*vq
      else if(mod(l3,2) == 1) then
         vq = -aimag(zi**l3)*dl2p(lmt1,lmt2,n,it)*vq
      end if

      vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq
    end subroutine integration_of_VlhxcQlm_core2
#endif
#endif

!!$    subroutine integration_of_VlhxcQlm_core
!!$      integer       :: ia, i, iy
!!$      real(kind=DP) :: dga, vq, grt, qy, zfc, zfs
!!$
!!$      dga = dl2p(lmt1,lmt2,n,it)
!!$      do ia = 1, natm
!!$         if(ityp(ia) /= it) cycle
!!$         vq = 0.d0
!!$         if(mod(il1+il2,2) == 0) then
!!$            do i = ista_kngp, iend_kngp  !for mpi
!!$               iy = i-ista_kngp+1
!!$               grt = (pos(ia,1)*ngabc(i,1) + pos(ia,2)*ngabc(i,2)&
!!$                    &+pos(ia,3)*ngabc(i,3))*PAI2
!!$               zfc = dcos(grt); if(kimg == 2) zfs = dsin(grt)
!!$               qy  = qitg_l(i,iiqitg)*ylm(iy)
!!$               vq  = vq+ qy*vlhxc_l(i,1,is)*zfc
!!$               if(kimg==2) vq = vq - qy*vlhxc_l(i,kimg,is)*zfs
!!$            end do
!!$            vq = real(zi**l3)*dga*vq
!!$         else if(mod(il1+il2,2) == 1) then
!!$            do i = ista_kngp, iend_kngp  !for mpi
!!$               iy = i-ista_kngp+1
!!$               grt = (pos(ia,1)*ngabc(i,1) + pos(ia,2)*ngabc(i,2)&
!!$                    &+pos(ia,3)*ngabc(i,3))*PAI2
!!$               zfs = dsin(grt); if(kimg==2) zfc = dcos(grt)
!!$               qy  = qitg_l(i,iiqitg)*ylm(iy)
!!$               vq  = vq + qy*vlhxc_l(i,1,is)*zfs
!!$               if(kimg==2) vq = vq + qy*vlhxc_l(i,kimg,is)*zfc
!!$            end do
!!$            vq = -aimag(zi**l3)*dga*vq
!!$         endif
!!$         vlhxcQ(lmt1,lmt2,ia,is) = vlhxcQ(lmt1,lmt2,ia,is)+univol*vq
!!$      end do
!!$    end subroutine integration_of_VlhxcQlm_core
  end subroutine m_ESiVQ_integrate_VlhxcQlm
!$$#endif

  subroutine m_ESiVQ_add_dhub_to_vlhxcQ(nfout)
    integer, intent(in) :: nfout
    integer :: is,ia
! ========================================== modified by K. Tagami ======== 11.0
!    do is=1,nspin
    do is=1, ndim_magmom
! ========================================================================= 11.0
       do ia=1,natm
          if(ihubbard(ia) > 0) then
             vlhxcQ(:,:,ia,is) = vlhxcQ(:,:,ia,is)+dhub(:,:,ia,is)
          end if
       end do
    end do
  end subroutine m_ESiVQ_add_dhub_to_vlhxcQ


end module m_ES_Intgr_VlhxcQlm

!#include "f2c.h"
!#include <malloc.h>
!
!
!extern void
!dsyevd_(char *jobz, char *uplo, integer *n, doublereal *
!a, integer *lda, doublereal *w, doublereal *work, integer *lwork, 
!integer *iwork, integer *liwork, integer *info);
!
!int lapack_eigen2_(int *N, int *n, int *hbw, int *id, double *D, double *E, int *lde, double *Q, int *LDQ) {

      SUBROUTINE LAPACK_EIGEN2(N_GLOBAL, N, HBW, ID, D, E, LDE, Q, LDQ)
      implicit NONE

      INTEGER :: N_GLOBAL, N, HBW, ID, LDE, LDQ
      REAL(8) :: D(*), E(LDE,*), Q(LDQ,*)

      INTEGER :: i, j, info, lwork, liwork
      REAL(8) :: temp
      REAL(8), POINTER :: work(:)
      INTEGER, POINTER :: iwork(:)
      CHARACTER*1 :: JOBU, JOBVT

      DO J=1,N
      DO I=1,N
         Q(I,J)=0.0D0
      ENDDO
      ENDDO

      DO I=1,N
         Q(I,I)=D(I+ID-1)
      ENDDO

      DO J=1,HBW
      DO I=1,N-J
         Q(I,I+J)=E(I+ID-1,J)
         Q(I+J,I)=E(I+ID-1,J)
      ENDDO
      ENDDO

      JOBU = 'V'; JOBVT= 'U'

      lwork = -1
      liwork = -1

      call dsyevd(JOBU, JOBVT, N, Q, LDQ, D(1+ID-1),
     &            temp, lwork, i, liwork, info)
!      call DSYEV (JOBU, JOBVT, N, Q, LDQ, D(1+ID-1),
!     &            temp, lwork, info)

      lwork  = int(temp)
      liwork = i;

      allocate(work(lwork), iwork(liwork))
!      allocate(work(lwork))

      call dsyevd(JOBU, JOBVT, N, Q, LDQ, D(1+ID-1),
     &             work, lwork, iwork, liwork, info)
!      call DSYEV (JOBU, JOBVT, N, Q, LDQ, D(1+ID-1),
!     &            work, lwork, info)

      deallocate(work,iwork)
!      deallocate(work)

      END SUBROUTINE

      SUBROUTINE PDLAEDZ( N, N1, ID, Q, IQ, JQ, LDQ, DESCQ, Z, WORK )
*
*  -- ScaLAPACK auxiliary routine (version 1.7) --
*     University of Tennessee, Knoxville, Oak Ridge National Laboratory,
*     and University of California, Berkeley.
*     December 31, 1998
*
*     .. Scalar Arguments ..
      INTEGER            ID, IQ, JQ, LDQ, N, N1
*     ..
*     .. Array Arguments ..
      INTEGER            DESCQ( * )
      DOUBLE PRECISION   Q( LDQ, * ), WORK( * ), Z( * )
*     ..
*
*  Purpose
*  =======
*
*  PDLAEDZ Form the z-vector which consists of the last row of Q_1
*  and the first row of Q_2.
*  =====================================================================
*
*     .. Parameters ..
*
      INTEGER            BLOCK_CYCLIC_2D, DLEN_, DTYPE_, CTXT_, M_, N_,
     $                   MB_, NB_, RSRC_, CSRC_, LLD_
      PARAMETER          ( BLOCK_CYCLIC_2D = 1, DLEN_ = 9, DTYPE_ = 1,
     $                   CTXT_ = 2, M_ = 3, N_ = 4, MB_ = 5, NB_ = 6,
     $                   RSRC_ = 7, CSRC_ = 8, LLD_ = 9 )
*     ..
*     .. Local Scalars ..
*
      INTEGER            COL, I, IBUF, ICTXT, IIQ, IIZ1, IIZ2, IQCOL,
     $                   IQROW, IZ, IZ1, IZ1COL, IZ1ROW, IZ2, IZ2COL,
     $                   IZ2ROW, J, JJQ, JJZ1, JJZ2, MYCOL, MYROW, N2,
     $                   NB, NBLOC, NPCOL, NPROW, NQ1, NQ2, ZSIZ
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MIN, MOD
*     ..
*     .. External Subroutines ..
      EXTERNAL           BLACS_GRIDINFO, DCOPY, DGEBR2D, DGEBS2D,
     $                   DGERV2D, DGESD2D, INFOG2L
*     ..
*     .. External Functions ..
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*     ..
*     .. Executable Statements ..
*
*       This is just to keep ftnchek and toolpack/1 happy
      IF( BLOCK_CYCLIC_2D*CSRC_*CTXT_*DLEN_*DTYPE_*LLD_*MB_*M_*NB_*N_*
     $    RSRC_.LT.0 )RETURN
*
      ICTXT = DESCQ( CTXT_ )
      NB = DESCQ( NB_ )
      CALL BLACS_GRIDINFO( ICTXT, NPROW, NPCOL, MYROW, MYCOL )
      CALL INFOG2L( ID, ID, DESCQ, NPROW, NPCOL, MYROW, MYCOL, IIQ, JJQ,
     $              IQROW, IQCOL )
      N2 = N - N1
*
*     Form z1 which consist of the last row of Q1
*
      CALL INFOG2L( IQ-1+( ID+N1-1 ), JQ-1+ID, DESCQ, NPROW, NPCOL,
     $              MYROW, MYCOL, IIZ1, JJZ1, IZ1ROW, IZ1COL )
      NQ1 = NUMROC( N1, NB, MYCOL, IZ1COL, NPCOL )
      IF( ( MYROW.EQ.IZ1ROW ) .AND. ( NQ1.NE.0 ) ) THEN
         CALL DCOPY( NQ1, Q( IIZ1, JJZ1 ), LDQ, WORK, 1 )
         IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL )
     $      CALL DGESD2D( ICTXT, NQ1, 1, WORK, NQ1, IQROW, IQCOL )
      END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z1
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         COL = IZ1COL
         DO 20 I = 0, NPCOL - 1
            NQ1 = NUMROC( N1, NB, COL, IZ1COL, NPCOL )
            IF( NQ1.GT.0 ) THEN
               IF( IZ1ROW.NE.IQROW .OR. COL.NE.IQCOL ) THEN
                  IBUF = N1 + 1
                  CALL DGERV2D( ICTXT, NQ1, 1, WORK( IBUF ), NQ1,
     $                          IZ1ROW, COL )
               ELSE
                  IBUF = 1
               END IF
               IZ1 = 0
               IZ = I*NB + 1
               NBLOC = ( NQ1-1 ) / NB + 1
               DO 10 J = 1, NBLOC
                  ZSIZ = MIN( NB, NQ1-IZ1 )
                  CALL DCOPY( ZSIZ, WORK( IBUF+IZ1 ), 1, Z( IZ ), 1 )
                  IZ1 = IZ1 + NB
                  IZ = IZ + NB*NPCOL
   10          CONTINUE
            END IF
            COL = MOD( COL+1, NPCOL )
   20    CONTINUE
      END IF
*
*     Form z2 which consist of the first row of Q2
*
      CALL INFOG2L( IQ-1+( ID+N1 ), JQ-1+( ID+N1 ), DESCQ, NPROW, NPCOL,
     $              MYROW, MYCOL, IIZ2, JJZ2, IZ2ROW, IZ2COL )
      NQ2 = NUMROC( N2, NB, MYCOL, IZ2COL, NPCOL )
      IF( ( MYROW.EQ.IZ2ROW ) .AND. ( NQ2.NE.0 ) ) THEN
         CALL DCOPY( NQ2, Q( IIZ2, JJZ2 ), LDQ, WORK, 1 )
         IF( MYROW.NE.IQROW .OR. MYCOL.NE.IQCOL )
     $      CALL DGESD2D( ICTXT, NQ2, 1, WORK, NQ2, IQROW, IQCOL )
      END IF
*
*     Proc (IQROW, IQCOL) receive the parts of z2
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         COL = IZ2COL
         DO 40 I = 0, NPCOL - 1
            NQ2 = NUMROC( N2, NB, COL, IZ2COL, NPCOL )
            IF( NQ2.GT.0 ) THEN
               IF( IQROW.NE.IZ2ROW .OR. IQCOL.NE.COL ) THEN
                  IBUF = 1 + N2
                  CALL DGERV2D( ICTXT, NQ2, 1, WORK( IBUF ), NQ2,
     $                          IZ2ROW, COL )
               ELSE
                  IBUF = 1
               END IF
               IZ2 = 0
               IZ = NB*I + N1 + 1
               NBLOC = ( NQ2-1 ) / NB + 1
               DO 30 J = 1, NBLOC
                  ZSIZ = MIN( NB, NQ2-IZ2 )
                  CALL DCOPY( ZSIZ, WORK( IBUF+IZ2 ), 1, Z( IZ ), 1 )
                  IZ2 = IZ2 + NB
                  IZ = IZ + NB*NPCOL
   30          CONTINUE
            END IF
            COL = MOD( COL+1, NPCOL )
   40    CONTINUE
      END IF
*
*     proc(IQROW,IQCOL) broadcast Z=(Z1,Z2)
*
      IF( MYROW.EQ.IQROW .AND. MYCOL.EQ.IQCOL ) THEN
         CALL DGEBS2D( ICTXT, 'All', ' ', N, 1, Z, N )
      ELSE
         CALL DGEBR2D( ICTXT, 'All', ' ', N, 1, Z, N, IQROW, IQCOL )
      END IF
*
      RETURN
*
*     End of PDLAEDZ
*
      END

      module eigen_house
      implicit NONE

         real(8), pointer       ::  u0_z(:), v0_z(:)
         real(8), pointer       ::  u1_z(:), v1_z(:)
         integer                ::  offset1, offset2
         integer                ::  offset3, offset4

      end module eigen_house

module m_ValenceBand_Spectrum

  use m_Control_Parameters,  only : printable, ipriepsilon
  use m_Const_Parameters, only : DP
  use m_Files,  only : nfout, nfpot, m_Files_open_ps_files, m_Files_close_ps_files, &
       &               m_Files_open_ps_file, m_Files_close_ps_file
  use m_Ionic_System,  only : ityp, ivan, iatomn, ntyp
  use m_Parallelization,  only : mype, ierr, mpi_comm_group

  use m_Orbital_QuantumNum, only : num_orb_index_data, &
       &                           qnum_n_orb_index, qnum_l_orb_index, &
       &                           qnum_t_orb_index, qnum_tau_orb_index

  implicit none
  include 'mpif.h'

  integer,  allocatable, dimension(:)     :: nppc_data       ! nppc_data(ntyp)
  integer,  allocatable, dimension(:,:)   :: phase_ylm1,phase_ylm2   
                                           ! phase_ylm1(ntyp,:),phase_ylm2(ntyp,:)
  integer,  allocatable, dimension(:,:)    :: dipole_tau1,dipole_tau2   
                                            ! dipole_tau1(ntyp,:),dipole_tau2(ntyp,:)
  integer                                 :: mnppc
  real(DP), allocatable, dimension(:,:,:)   :: dipole_dxyz_us 
                                            ! dipole_dxyz_us(ntyp,:,3)

contains

  subroutine m_VBS_dealloc_dipole_ppc
    deallocate(nppc_data);   deallocate(dipole_dxyz_us)
    deallocate(phase_ylm1);  deallocate(phase_ylm2)
    deallocate(dipole_tau1); deallocate(dipole_tau2)    
  end subroutine m_VBS_dealloc_dipole_ppc

  subroutine m_VBS_set_data_ppc_from_pp
    call m_Files_open_ps_files(ivan,iatomn,ntyp,ierr)
    if (ierr/=0) call mpi_stop(nfout)

    if(.not.allocated(nppc_data)) allocate(nppc_data(ntyp)) ; nppc_data=0
    call find_ppc_data_number(nfout)

    call alloc_ptrans_data_array_ek
    call read_ptrans_data_ek

    call m_Files_close_ps_files

  end subroutine m_VBS_set_data_ppc_from_pp

  subroutine m_VBS_set_data_ppc_from_pp_it()
    integer :: it
    if(.not.allocated(nppc_data)) allocate(nppc_data(ntyp)) ; nppc_data=0
    do it=1,ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
       if (ierr/=0) call mpi_stop(nfout)
       call find_ppc_data_number_it(nfout,it)
       call m_Files_close_ps_file(it)
    enddo
    call alloc_ptrans_data_array_ek()
    do it=1,ntyp
       call m_Files_open_ps_file(ivan,iatomn,ntyp,it,ierr)
       if (ierr/=0) call mpi_stop(nfout)
       call find_ppc_data_number_it(nfout,it)
       call read_ptrans_data_ek_it(it)
       call m_Files_close_ps_file(it)
    enddo
    if(printable) write(nfout,'(1x,"!* ntyp = ",i3)') ntyp
  end subroutine m_VBS_set_data_ppc_from_pp_it

  subroutine find_ppc_data_number(nfout)
!
!   find data number of core-repair term
!   nppc_data(it) : data number for it-th type pseudopotential
!
    integer,intent(in) :: nfout
    integer            :: it

    do it=1, ntyp
       call find_ppc_data_number_it(nfout,it)
    end do

 end subroutine find_ppc_data_number

 subroutine find_ppc_data_number_it(nfout,it)
    integer, intent(in) :: nfout,it
    integer, save :: nfpp=0
    integer :: nptrans
    if(mype==0)then
       nfpp=nfpp+1
       call find_dipole_section(nfpot(nfpp),nfout,it,nptrans)
       if(printable) &
       & write(nfout,'(1x,"! PP transition moment correction data : it = ",i3, &
       & 2x,"number of data read from PP file = ",i3)') it, nptrans
       nppc_data(it)=nptrans
    endif
    if(it==ntyp) then
       call mpi_bcast(nppc_data,ntyp,mpi_integer,0,mpi_comm_group,ierr) ! MPI
       nfpp=0
    endif
 end subroutine find_ppc_data_number_it

 subroutine find_dipole_section(nfp,nfout,it,nptrans)
!
!   find dipole section in gncpp2 potential file
!
    integer,intent(in)   :: nfp, nfout,it
    integer, intent(out) :: nptrans
    integer              :: idipole
    character(len=10)    :: line

    if(mype /= 0) return

! == KT_add === 2014/07/23
    rewind(nfp)
! ============= 2014/07/23

10  read(nfp,'(a10)',end=20) line
    idipole=index(line,'DIPOLE')
    if(idipole/=0) then
       read(nfp,*) nptrans
       if(nptrans==0) then
          if(printable) &
          & write(nfout,'(1x,"!* number of dipole data is zero for atom type ",i3,"   m_Epsilon_ek STOP")') it
          stop
       end if
       return
    end if
    goto 10
20  if(printable) write(*,'(1x,"!* dipole section is not found in pseudopotential file")')
    stop
 end subroutine find_dipole_section

 subroutine alloc_ptrans_data_array_ek
    implicit none
!
!   allocate data array for core-repair term
!
    integer :: it
! find maximum of nppc_data(it): it=1-ntyp
    if(mype == 0) then
       if(ntyp==1) then
          mnppc=nppc_data(1)
       else
          mnppc=nppc_data(1)
          do it=1,ntyp
             if(mnppc<nppc_data(it)) mnppc=nppc_data(it)
          end do
       end if
    end if
    call mpi_bcast(mnppc,1,mpi_integer,0,mpi_comm_group, ierr) ! MPI
    if(printable) write(nfout,'(1x,"!* mnppc = ",i3)') mnppc
! allocate data array
    if(.not.allocated(dipole_dxyz_us)) allocate(dipole_dxyz_us(ntyp,mnppc,3)); dipole_dxyz_us=0.0d0
    if(.not.allocated(dipole_tau1))    allocate(dipole_tau1(ntyp,mnppc)); dipole_tau1=0
    if(.not.allocated(dipole_tau2))    allocate(dipole_tau2(ntyp,mnppc)); dipole_tau2=0
    if(.not.allocated(phase_ylm1))     allocate(phase_ylm1(ntyp,mnppc)); phase_ylm1=0
    if(.not.allocated(phase_ylm2))     allocate(phase_ylm2(ntyp,mnppc)); phase_ylm2=0
 end subroutine alloc_ptrans_data_array_ek

 subroutine read_ptrans_data_ek_it(it)
    integer, intent(in) :: it
    integer, save :: nfpp=0
    if(mype==0) then
       nfpp=nfpp+1
       if(printable) &
       & write(nfout,'(1x,"! ppc data for it = ",i4," are read: nppc = ",i4)') it,nppc_data(it)
! ====================== KT_mod ================================ 13.0S +2014/07/23
!          call read_ptrans_data_ek_core(nfpot(nfpp),nfout,it)
!
       if ( num_orb_index_data(it) > 0 ) then
          call read_ptrans_data_ek_core( nfpot(nfpp), nfout, it )
       else
          call read_ptrans_data_ek_core_kt( nfpot(nfpp), nfout, it )
       endif
! ============================================================== 13.0S +2014/07/23
    endif

    if(it==ntyp) then
       call mpi_bcast(dipole_dxyz_us,ntyp*mnppc*3,mpi_double_precision,0,mpi_comm_group,ierr) ! MPI
       call mpi_bcast(dipole_tau1,ntyp*mnppc,mpi_integer,0,mpi_comm_group,ierr)      ! MPI
       call mpi_bcast(dipole_tau2,ntyp*mnppc,mpi_integer,0,mpi_comm_group,ierr)      ! MPI
       call mpi_bcast(phase_ylm1,ntyp*mnppc,mpi_integer,0,mpi_comm_group,ierr)       ! MPI
       call mpi_bcast(phase_ylm2,ntyp*mnppc,mpi_integer,0,mpi_comm_group,ierr)       ! MPI
       nfpp=0
    endif
 end subroutine read_ptrans_data_ek_it

 subroutine read_ptrans_data_ek
    implicit none
!
!   read core-repair term
!
    integer :: it
!!!    if(mype == 0)  then      !!! KT_mod: 2014/12/13
       do it =1, ntyp
          call read_ptrans_data_ek_it(it)
       end do
!!!    end if                   !!! KT_mod : 2014/12/13

    if(printable) write(nfout,'(1x,"!* ntyp = ",i3)') ntyp
  end subroutine read_ptrans_data_ek

     subroutine read_ptrans_data_ek_core(nfp,nfout,it)
       implicit none
!
!      read core-repair term pij(I)
!      cf. H. Kageshima and K. Shiraishi,Phys. Rev. B vol.56, 14985 (1997)
!      pij(I)
!      i, j :: atomic orbital index (CIAO)
!      i ->  ltmltm(n1,l1,t1,m1)  j-> ltmltm(n2,l2,t1,m1)  ltm: compound index
!      n :: principal quantum number    l :: azimuthal quantum number
!      m :: magnetic quantum number     t :: energy reference index
!      dipole_dxyz_us(it,ltmltm,ixyz)     :: core repair term for it-th type pseudopotential in ixyz direction
!                                         :: ixyz=1 -> x; ixyz=2 -> y;  ixyz= 3 -> z
!      phase_ylm  :: Ylm index for phase
!      dipole_tau :: reference index 
!      
!
       integer, intent(in) :: nfp,nfout,it
       integer :: n1,l1,t1,m1,n2,l2,t2,m2
       integer :: ltmltm,lmax, j1

       do ltmltm = 1, nppc_data(it)
!         n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
!         l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
!         t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
!         m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
          read(nfp,53) n1,l1,t1,m1,n2,l2,t2,m2, &
               &    dipole_dxyz_us(it,ltmltm,1), &
               &    dipole_dxyz_us(it,ltmltm,2), &
               &    dipole_dxyz_us(it,ltmltm,3), &
               &    phase_ylm1(it,ltmltm), phase_ylm2(it,ltmltm)
          dipole_tau1(it,ltmltm)=t1
          dipole_tau2(it,ltmltm)=t2

! === KT_add === 2014/07/23
          Do j1=1, num_orb_index_data(it)
             if ( n1 == qnum_n_orb_index(it,j1) &
                  &    .and. l1 == qnum_l_orb_index(it,j1) &
                  &    .and. t1 == qnum_t_orb_index(it,j1) ) then
                dipole_tau1( it,ltmltm ) = qnum_tau_orb_index(it,j1)
                exit
             end if
          End Do
          Do j1=1, num_orb_index_data(it)
             if ( n2 == qnum_n_orb_index(it,j1) &
                  &    .and. l2 == qnum_l_orb_index(it,j1) &
                  &    .and. t2 == qnum_t_orb_index(it,j1) ) then
                dipole_tau2( it,ltmltm ) = qnum_tau_orb_index(it,j1)
                exit
             end if
          End Do
! ============ 2014/07/23

          if (ipriepsilon>=2.and.printable ) then
             write(nfout,53) n1,l1,dipole_tau1(it,ltmltm),m1,n2,l2,dipole_tau2(it,ltmltm),m2, &
                  & dipole_dxyz_us(it,ltmltm,1),dipole_dxyz_us(it,ltmltm,2),dipole_dxyz_us(it,ltmltm,3), &
                  & phase_ylm1(it,ltmltm),phase_ylm2(it,ltmltm)
          end if
       end do

53     format(1x,8i3,3e18.10,2i3)

     end subroutine read_ptrans_data_ek_core

! ========================== KT_add =========================== 13.0S
! ****************************************************
!  Note: In the DIPOLE section of pp files, the variable tau ("t1, "t2") is 
!        defined for each principal quantum number. For example, 
!               5s: tau=1, 2,   6s: tau=1, 2
!
!        On the other hand, in the PHASE, the principal quantum numbers are not
!        treated explicitly. In the above exmaple,
!               s-orbital:  tau=1, 2, 3, 4
!
!        The subroutine read_ptrans_data_ek_core is not correct in the cases
!        when an l-quantum number corresponds to multiple pricipal numbers.
!
!        In the following subroutine, we could overcome this limitation by some tricks..
! ****************************************************
!
     subroutine read_ptrans_data_ek_core_kt(nfp,nfout,it)
       implicit none
       integer, intent(in) :: nfp,nfout,it

       integer :: n1, l1, t1, m1, n2, l2, t2, m2
       integer :: ltmltm, lval, lmax, nmax
       integer :: ndata, count, i
       integer :: old_n1, old_t1, old_n2, old_t2
!
       integer, allocatable :: data_n1(:), data_n2(:), data_l1(:), data_l2(:)       
       integer, allocatable :: data_t1(:), data_t2(:), data_m1(:), data_m2(:)       
       integer, allocatable :: data_ylm1(:), data_ylm2(:), igeta(:,:)
       real(kind=DP), allocatable :: data_dipol(:,:)

       ndata = nppc_data(it)

       lmax = 3         ! s:0, p:1,  d:2,  f:3
       nmax = 8         ! 8s, 8p, 8d .. etc.

       allocate( data_n1(ndata) );  allocate( data_n2(ndata) )
       allocate( data_l1(ndata) );  allocate( data_l2(ndata) )
       allocate( data_m1(ndata) );  allocate( data_m2(ndata) )
       allocate( data_t1(ndata) );  allocate( data_t2(ndata) )
       allocate( data_dipol(ndata,3) );  
       allocate( data_ylm1(ndata) ); allocate( data_ylm2(ndata) ); 

       allocate( igeta(nmax,0:lmax) );  igeta = -100

       do i=1, ndata
          read(nfp,53) data_n1(i), data_l1(i), data_t1(i), data_m1(i), &
               &       data_n2(i), data_l2(i), data_t2(i), data_m2(i), &
               &       data_dipol(i,1), data_dipol(i,2), data_dipol(i,3), &
               &       data_ylm1(i), data_ylm2(i) 
       End do

       Do lval=0, lmax
          count = 0
          Do i=1, ndata
             if ( data_l1(i) == lval ) then
                n1 = data_n1(i);  t1 = data_t1(i)

                if ( count==0 ) then
                   count = count +1
                   if ( igeta(n1,lval) == -100 ) igeta(n1,lval) = 0
                else
                   if ( old_n1 /=n1 .and. igeta(n1,lval)== -100 ) igeta(n1,lval)=old_t1
                endif
                old_n1 = n1;  old_t1 = t1
             endif
          End do

          count = 0
          Do i=1, ndata
             if ( data_l2(i) == lval ) then
                n2 = data_n2(i);  t2 = data_t2(i)

                if ( count==0 ) then
                   count = count +1
                   if ( igeta(n2,lval) == -100 ) igeta(n2,lval) = 0
                else
                   if ( old_n2 /=n2 .and. igeta(n2,lval)== -100 ) igeta(n2,lval)=old_t2
                endif
                old_n2 = n2;  old_t2 = t2
             endif
          End do
       End do

       Do i=1, ndata
          n1 = data_n1(i);  n2 = data_n2(i)
          l1 = data_l1(i);  l2 = data_l2(i)
          t1 = data_t1(i);  t2 = data_t2(i)
          m1 = data_m1(i);  m2 = data_m2(i)

          dipole_tau1(it, i) = data_t1(i) +igeta(n1,l1)
          dipole_tau2(it, i) = data_t2(i) +igeta(n2,l2)

          dipole_dxyz_us(it, i, 1) = data_dipol(i,1)
          dipole_dxyz_us(it, i, 2) = data_dipol(i,2)
          dipole_dxyz_us(it, i, 3) = data_dipol(i,3)

          phase_ylm1(it, i) = data_ylm1(i)
          phase_ylm2(it, i) = data_ylm2(i)

          if (ipriepsilon>=2.and.printable) then
             write(nfout,53) n1, l1, dipole_tau1(it,i), m1, &
                  &          n2, l2, dipole_tau2(it,i), m2, &
                  &          dipole_dxyz_us(it,i,1), &
                  &          dipole_dxyz_us(it,i,2), &
                  &          dipole_dxyz_us(it,i,3), &
                  &          phase_ylm1(it,i), phase_ylm2(it,i)
          end if
       end do
53     format(1x,8i3,3e18.10,2i3)

       deallocate( data_n1 );  deallocate( data_n2 )
       deallocate( data_l1 );  deallocate( data_l2 )
       deallocate( data_m1 );  deallocate( data_m2 )
       deallocate( data_t1 );  deallocate( data_t2 )
       deallocate( data_dipol );  
       deallocate( data_ylm1 ); deallocate( data_ylm2 ); 
       deallocate( igeta )

     end subroutine read_ptrans_data_ek_core_kt
! ================================================================== 13.0S

  subroutine m_VBS_find_ptrans_index_ek( it, nspher1, nspher2, tau1, tau2, index, ifact )
    integer, intent(in) :: it, nspher1, nspher2, tau1, tau2
    integer, intent(out) :: index, ifact

    integer :: i
    integer :: nspher10, nspher20, tau10, tau20

    index = 0; ifact = 0
    if ( nspher1 > nspher2 ) then
       nspher20 = nspher1;   tau20 = tau1
       nspher10 = nspher2;   tau10 = tau2;    ifact = -1
    else
       nspher10 = nspher1;   tau10 = tau1;
       nspher20 = nspher2;   tau20 = tau2;    ifact = 1
    endif

    do i=1, nppc_data(it)
       if ( phase_ylm1(it,i) == nspher10 .and. phase_ylm2(it,i) == nspher20 ) then
          if ( dipole_tau1(it,i) == tau10 .and. dipole_tau2(it,i) == tau20 ) then
             index = i
             exit
          end if
       end if
    end do

  end subroutine m_VBS_find_ptrans_index_ek

end module m_ValenceBand_Spectrum

!--
       subroutine send_dbl(buf, n, idest, icom)
       implicit NONE

       integer, intent(in)    :: n, idest, icom
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr


          call MPI_Send(buf, n, MPI_DOUBLE_PRECISION,
     &                  idest-1, 1, icom, ierr)


       return
       end subroutine ! send_dbl
!--
       subroutine send_dblt(buf, n, idest, itag, icom)
       implicit NONE

       integer, intent(in)    :: n, idest, itag, icom
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr


          call MPI_Send(buf, n, MPI_DOUBLE_PRECISION,
     &                  idest-1, itag, icom, ierr)


       return
       end subroutine ! send_dblt
!--
       subroutine isend_dbl(buf, n, idest, ireq, icom)
       implicit NONE

       integer, intent(in)    :: n, idest, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr


          call MPI_Isend(buf,n,MPI_DOUBLE_PRECISION,
     &                   idest-1, 1, icom, ireq, ierr)


       return
       end subroutine ! isend_dbl
!--
       subroutine recv_dbl(buf, n, isrc, icom)
       implicit NONE

       integer, intent(in)    :: n, isrc, icom
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr
       integer                :: status(MPI_STATUS_SIZE)


          call MPI_Recv(buf, n, MPI_DOUBLE_PRECISION,
     &                  isrc-1, 1, icom, status, ierr)


       return
       end subroutine ! recv_dbl
!--
       subroutine recv_dblt(buf, n, isrc, itag, icom)
       implicit NONE

       integer, intent(in)    :: n, isrc, itag, icom
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr
       integer                :: status(MPI_STATUS_SIZE)


          call MPI_Recv(buf, n, MPI_DOUBLE_PRECISION,
     &                  isrc-1, itag, icom, status, ierr)


       return
       end subroutine ! recv_dblt
!--
       subroutine irecv_dbl(buf, n, isrc, ireq, icom)
       implicit NONE

       integer, intent(in)    :: n, isrc, icom
       integer, intent(inout) :: ireq
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr


          call MPI_Irecv(buf, n, MPI_DOUBLE_PRECISION,
     &                   isrc-1, 1, icom, ireq, ierr)


       return
       end subroutine ! irecv_dbl
!--
       subroutine wait_dbl(ireq)
       implicit NONE

       integer, intent(inout) :: ireq

       include 'mpif.h'
       integer                :: status(MPI_STATUS_SIZE)
       integer                :: ierr


          call MPI_Wait(ireq, status, ierr)


       return
       end subroutine ! wait_dbl
!--
       subroutine waitall_dbl(n, ireq)
       implicit NONE

       integer, intent(in   ) :: n
       integer, intent(inout) :: ireq(n)

       include 'mpif.h'
       integer, pointer       :: status(:)
       integer                :: ierr


          allocate(status(MPI_STATUS_SIZE*n))
          call MPI_Waitall(n, ireq, status(1), ierr)
          deallocate(status)


       return
       end subroutine ! waitall_dbl
!--
       subroutine bcast_dbl(buf, n, iroot, icom)
       implicit NONE

       integer, intent(in)    :: n, iroot, icom
       real(8), intent(inout) :: buf(1:n)

       include 'mpif.h'
       integer                :: ierr

       integer :: world_size, my_rank, i, j

       real(8) :: d1,d2
       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather


          d1=MPI_Wtime()

          call MPI_Bcast(buf, n, MPI_DOUBLE_PRECISION,
     &                   iroot-1, icom, ierr)

!          call d_bBcast(buf, n, iroot-1, icom, ierr)

          d2=MPI_Wtime()
          time_bcast=time_bcast+(d2-d1)


       return
       end subroutine ! bcast_dbl
!--
       subroutine reduce_dbl(buf, wrk, n, dist, icom)
       implicit NONE

       integer, intent(in)    :: n, dist, icom
       real(8), intent(inout) :: buf(1:n), wrk(1:n)

       include 'mpif.h'
       integer                :: ierr

       real(8) :: d1,d2
       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather

          d1=MPI_Wtime()


          call MPI_Allreduce(buf, wrk, n, MPI_DOUBLE_PRECISION,
     &                       MPI_SUM, icom, ierr)
          buf(1:n) = wrk(1:n)
!          call MPI_Allreduce(MPI_IN_PLACE, buf, n, MPI_DOUBLE_PRECISION,
!     &                       MPI_SUM, icom, ierr)

          d2=MPI_Wtime()
          time_reduce=time_reduce+(d2-d1)

       return
       end subroutine ! reduce_dbl
!--
       subroutine allgather_dbl(buf, wrk, n, icom)
       implicit NONE

       integer, intent(in)    :: n, icom
       real(8), intent(inout) :: buf(1:n), wrk(1:n)

       include 'mpif.h'
       integer                :: ierr

       real(8) :: d1,d2
       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather

          d1=MPI_Wtime()

          call MPI_Allgather(buf, n, MPI_DOUBLE_PRECISION,
     &                       wrk, n, MPI_DOUBLE_PRECISION,
     &                       icom, ierr)

          d2=MPI_Wtime()
          time_gather=time_gather+(d2-d1)

       return
       end subroutine ! allgather_dbl
!--
       integer function loop_c_start(istart, nnod, inod)
       implicit NONE

       integer, intent(in)    :: istart, nnod, inod


          loop_c_start = (istart+nnod-1-inod)/nnod+1


       return
       end function ! loop_c_start
!--
       integer function loop_c_end(iend, nnod, inod)
       implicit NONE

       integer, intent(in)    :: iend, nnod, inod


          loop_c_end   = (iend  +nnod  -inod)/nnod+0


       return
       end function ! loop_c_end
!--
       integer function loop_c_l2g_depth(ictr, nnod, inod)
       implicit NONE

       integer, intent(in)    :: ictr, nnod, inod


          loop_c_l2g_depth   = (ictr-1)*nnod+inod


       return
       end function ! loop_c_end
!--
       integer function loop_c_node(ictr, nnod, inod)
       implicit NONE

       integer, intent(in)    :: ictr, nnod, inod


          loop_c_node   = MOD(ictr-1,nnod)+1


       return
       end function ! loop_c_end
!--
       integer function loop_c_g2l_depth(ictr, nnod, inod)
       implicit NONE

       integer, intent(in)    :: ictr, nnod, inod


          loop_c_g2l_depth   = (ictr-1)/nnod+1


       return
       end function ! loop_c_end
!--
       subroutine loop_c(istart, iend, idoctr, isize, nnod, inod)
       implicit NONE

       integer, intent(inout) :: istart, iend, idoctr
       integer, intent(in)    :: isize, nnod, inod

       integer                :: istart0, iend0, idoctr0
       integer                :: istart1, iend1

       integer, external      :: loop_c_start, loop_c_end


          if ( istart > iend ) then
             istart=1; iend=0; idoctr=0
             return
          end if
          if ( nnod == 1 ) then
             idoctr=istart
             return
          end if

          istart1 = MAX(istart,1    )
          iend1   = MIN(iend  ,isize)

          istart = loop_c_start(istart1,nnod,inod)
          iend   = loop_c_end  (iend1,  nnod,inod)
          idoctr = (istart-1)*nnod+inod


       return
       end subroutine ! loop_c
!--

       subroutine datacast_init(ndim)
       implicit NONE

       include 'mpif.h'
       include 'trd.h'

       integer                ::  ndim
       integer                ::  n1, n2, n3, i, j, k, ierr
       integer :: old_grp, new_grp, ranks(0:4095)

       real(8) :: d1,d2
       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather


       time_bcast = 0d0
       time_reduce= 0d0
       time_redist= 0d0
       time_gather= 0d0


          TRD_COMM_WORLD = MPI_COMM_EIGEN

          call MPI_Comm_size(TRD_COMM_WORLD, TRD_nnod, ierr)
          call MPI_Comm_rank(TRD_COMM_WORLD, TRD_inod, ierr)
          TRD_inod = TRD_inod+1

#IFDEF PHASE
          x_nnod = NPROWtoDC
          y_nnod = NPCOLtoDC
#ELSE
          if ( ndim == 1 ) then
             x_nnod = 1 !! fixed
          else
             x_nnod = INT(SQRT(DBLE(TRD_nnod)))
             i = 1
             if ( MOD(TRD_nnod,i) == 0 ) then
                k = i
             else
                k = 1
             end if
             do
                if ( x_nnod <= k ) exit
                if ( MOD(x_nnod,k) == 0 .AND.
     &               MOD(TRD_nnod,x_nnod) == 0 ) exit
                x_nnod = x_nnod-1
             end do!!
          endif
          y_nnod = TRD_nnod/x_nnod
#ENDIF
!
!          print*,TRD_inod,"PE partition = ",x_nnod,y_nnod
!
!          x_inod =    (TRD_inod-1)/y_nnod +1
!          y_inod = MOD(TRD_inod-1, y_nnod)+1
          x_inod = MOD(TRD_inod-1, x_nnod)+1
          y_inod =    (TRD_inod-1)/x_nnod +1

          call MPI_Comm_split(TRD_COMM_WORLD,y_inod,x_inod,
     1         x_COMM_WORLD,ierr)
          call MPI_Comm_split(TRD_COMM_WORLD,x_inod,y_inod,
     1         y_COMM_WORLD,ierr)


          n1 = MAX(x_nnod,y_nnod)
          n2 = MIN(x_nnod,y_nnod)
          do
             if ( n1 == n2 ) then
                n_common = n1
                exit
             end if
             n3 = n1-n2
             n1 = MAX(n2,n3)
             n2 = MIN(n2,n3)
          end do!!

          p0_ = -1
          q0_ = -1
          do i=1,x_nnod
             if ( MOD(i-1,n_common) == MOD(y_inod-1,n_common) ) then
                n1 = y_inod-i
                if ( n1 >= 0 ) then
                   do j=1,x_nnod
                      k = +n1+(j-1)*y_nnod
                      if ( MOD(k,x_nnod) == 0 ) then
                         p0_(i) = k/x_nnod
                         q0_(i) = (j-1)
                         exit
                      end if
                   end do! j
                else
                   do j=1,y_nnod
                      k = -n1+(j-1)*x_nnod
                      if ( MOD(k,y_nnod) == 0 ) then
                         q0_(i) = k/y_nnod
                         p0_(i) = (j-1)
                         exit
                      end if
                   end do! j
                end if
             end if
          end do! i
          p0_ = p0_+1
          q0_ = q0_+1


          diag_0 = 0
          diag_1 = 0
          do i=1,y_nnod/n_common
             j = (i-1)*y_nnod+y_inod
             k = MOD(j-1,x_nnod)+1
             if ( k == x_inod ) then
                diag_0 = i
                diag_1 = (j-1)/x_nnod+1
                exit
             end if
          end do! i_1

!          call MPI_Barrier(TRD_COMM_WORLD, ierr)

       return
       end subroutine ! datacast_init
!--
       subroutine datacast_free(flag)
       implicit NONE

       include 'mpif.h'
       include 'trd.h'

       integer                :: flag, ierr

       real(8) :: d1,d2
       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather

          call MPI_Comm_free(x_COMM_WORLD,ierr)
          call MPI_Comm_free(y_COMM_WORLD,ierr)

          TRD_COMM_WORLD=MPI_COMM_EIGEN

       if ( flag == 1 ) then
       if ( TRD_inod == 1 ) then
          print*, "COMM_STAT"
          print*, "   BCAST  :: ", time_bcast
          print*, "   REDUCE :: ", time_reduce
          print*, "   REDIST :: ", time_redist
          print*, "   GATHER :: ", time_gather
       endif
       endif


       return
       end subroutine ! datacast_free
!--
       subroutine datacast_dbl(u_y, u_x, u_t, u_s, n)
       implicit NONE

       integer, intent(in)    :: n
       real(8), intent(inout) :: u_y(1:n), u_x(1:n), u_t(1:n), u_s(1:n)

       include 'trd.h'
       include 'mpif.h'

       integer :: nx, ny, ic, i, j, k
       integer :: req(1024), reqr(2), reqs(2), x_snod, y_snod
       integer :: his_rank, her_rank

       real(8) :: d1,d2

       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather


          d1=MPI_Wtime()

          if ( x_nnod == 1 ) then
             if ( y_nnod == 1 ) then
                u_y(1:n) = u_x(1:n)
             else
                ny = (n-1)/y_nnod+1
                do i=1,ny
                   j = y_inod+y_nnod*(i-1)
                   u_y(i) = u_x(j)
                end do! i
             end if
             return
          end if

          if ( x_nnod == y_nnod ) then
             if ( x_inod == y_inod ) then
                u_y(1:n) = u_x(1:n)
             end if
             call bcast_dbl(u_y, n, y_inod, x_COMM_WORLD)
             return
          end if

          x_snod = x_nnod/n_common
          y_snod = y_nnod/n_common

          if ( p0_(x_inod) > 0 ) then

             nx = (n-p0_(x_inod))/y_snod+1
             do i=1,nx
                j = p0_(x_inod)+y_snod*(i-1)
                k = q0_(x_inod)+x_snod*(i-1)
                u_t(i) = u_x(j)
                u_y(k) = u_x(j)
!             print*,"I am",TRD_inod,"SdRv ",TRD_inod
             end do! i

             do ic=1,x_snod-1

!
! receiving message : length    = ifloor(n/y_snod)
!                   : #sender   = x_nnod-1
!
                his_rank = MOD(x_inod-1 +x_nnod +ic*n_common,x_nnod)+1
                ny = (n-p0_(his_rank))/y_snod+1
!             print*,"I am",TRD_inod,"Recv ",(his_rank-1)*y_nnod+y_inod
                call irecv_dbl(u_s, ny, his_rank, reqr(1), x_COMM_WORLD)

!
! sending message   : length    = ifloor(n/y_snod)
!                   : #receiver = x_nnod-1
!
                her_rank = MOD(x_inod-1 +x_nnod -ic*n_common,x_nnod)+1
                call isend_dbl(u_t, nx, her_rank, req(ic), x_COMM_WORLD)
!             print*,"I am",TRD_inod,"Send ",(her_rank-1)*y_nnod+y_inod

                call wait_dbl(reqr(1))

                do i=1,ny
                   k = q0_(his_rank)+x_snod*(i-1)
                   u_y(k) = u_s(i)
                end do! i

             end do! ic
                call waitall_dbl(x_snod-1, req)

             do ic=1,n_common-1
                her_rank = MOD(x_inod-1 +x_nnod +ic,x_nnod)+1
!             print*,"I am",TRD_inod,"Send ",(her_rank-1)*y_nnod+y_inod
                call isend_dbl(u_y, n, her_rank, req(ic), x_COMM_WORLD)
!                call wait_dbl(req(ic))
             end do! ic
                call waitall_dbl(n_common-1, req)

          else

                i = MOD(y_inod-1,n_common)
                j = MOD(x_inod-1,n_common)
                ic = MOD(j-i+n_common,n_common)
                his_rank = MOD(x_inod-1 +x_nnod -ic,x_nnod)+1
!             print*,"I am",TRD_inod,"Recv ",(his_rank-1)*y_nnod+y_inod
                call recv_dbl(u_y, n, his_rank, x_COMM_WORLD)

          end if

9999      continue

          d2=MPI_Wtime()
          time_redist=time_redist+(d2-d1)


       return
       end subroutine ! datacast_dbl
!--
       subroutine datacast_dbl2(ur_y,ui_y, ur_x,ui_x, u_t,u_s, n)
       implicit NONE

       integer, intent(in)    :: n
       real(8), intent(inout) :: ur_y(1:n), ui_y(1:n)
       real(8), intent(inout) :: ur_x(1:n), ui_x(1:n)
       real(8), intent(inout) :: u_t(1:2*n), u_s(1:2*n)

       include 'trd.h'
       include 'mpif.h'

       integer :: nx, ny, ic, i, j, k
       integer :: req(1024), reqr(2), reqs(2), x_snod, y_snod
       integer :: his_rank, her_rank

       real(8) :: d1,d2

       real(8) ::    time_bcast, time_reduce, time_redist, time_gather
       common /stat/ time_bcast, time_reduce, time_redist, time_gather


          d1=MPI_Wtime()

          if ( x_nnod == 1 ) then
             if ( y_nnod == 1 ) then
                ur_y(1:n)=ur_x(1:n)
                ui_y(1:n)=ui_x(1:n)
             else
                ny=(n-1)/y_nnod+1
                do i=1,ny
                   j=y_inod+y_nnod*(i-1)
                   ur_y(i)=ur_x(j)
                   ui_y(i)=ui_x(j)
                end do! i
             end if
             return
          end if

          if ( x_nnod == y_nnod ) then
             if ( x_inod == y_inod ) then
                u_t(  1:  n) = ur_x(1:n)
                u_t(n+1:n+n) = ui_x(1:n)
             end if
             call bcast_dbl(u_t, 2*n, y_inod, x_COMM_WORLD)
             ur_y(1:n) = u_t(  1:  n)
             ui_y(1:n) = u_t(n+1:n+n)
             return
          end if

          x_snod = x_nnod/n_common
          y_snod = y_nnod/n_common

          if ( p0_(x_inod) > 0 ) then

             nx = (n-p0_(x_inod))/y_snod+1
             do i=1,nx
                j = p0_(x_inod)+y_snod*(i-1)
                k = q0_(x_inod)+x_snod*(i-1)
                u_t(   i) = ur_x(j)
                u_t(nx+i) = ui_x(j)
                ur_y(k) = ur_x(j)
                ui_y(k) = ui_x(j)
!             print*,"I am",TRD_inod,"SdRv ",TRD_inod
             end do! i

             do ic=1,x_snod-1

!
! receiving message : length    = ifloor(n/y_snod)
!                   : #sender   = x_nnod-1
!
                his_rank = MOD(x_inod-1 +x_nnod +ic*n_common,x_nnod)+1
                ny = (n-p0_(his_rank))/y_snod+1
!             print*,"I am",TRD_inod,"Recv ",(his_rank-1)*y_nnod+y_inod
                call irecv_dbl(u_s, 2*ny,
     &                        his_rank, reqr(1), x_COMM_WORLD)

!
! sending message   : length    = ifloor(n/y_snod)
!                   : #receiver = x_nnod-1
!
                her_rank = MOD(x_inod-1 +x_nnod -ic*n_common,x_nnod)+1
                call isend_dbl(u_t, 2*nx,
     &                         her_rank, req(ic), x_COMM_WORLD)
!             print*,"I am",TRD_inod,"Send ",(her_rank-1)*y_nnod+y_inod

                call wait_dbl(reqr(1))

                do i=1,ny
                   k = q0_(his_rank)+x_snod*(i-1)
                   ur_y(k) = u_s(   i)
                   ui_y(k) = u_s(ny+i)
                end do! i

             end do! ic
                call waitall_dbl(x_snod-1, req)

             do ic=1,n_common-1
                her_rank = MOD(x_inod-1 +x_nnod +ic,x_nnod)+1
!             print*,"I am",TRD_inod,"Send ",(her_rank-1)*y_nnod+y_inod
                u_t(  1:  n) = ur_y(1:n)
                u_t(n+1:n+n) = ui_y(1:n)
!                call send_dbl(u_t, 2*n, her_rank, x_COMM_WORLD)
                call isend_dbl(u_t, 2*n,
     &                         her_rank, req(ic), x_COMM_WORLD)
             end do! ic
                call waitall_dbl(n_common-1, req)

          else

                i = MOD(y_inod-1,n_common)
                j = MOD(x_inod-1,n_common)
                ic = MOD(j-i+n_common,n_common)
                his_rank = MOD(x_inod-1 +x_nnod -ic,x_nnod)+1
!             print*,"I am",TRD_inod,"Recv ",(his_rank-1)*y_nnod+y_inod
                call recv_dbl(u_s, 2*n,
     &                        his_rank, x_COMM_WORLD)
                ur_y(1:n) = u_s(  1:  n)
                ui_y(1:n) = u_s(n+1:n+n)

          end if

9999      continue

          d2=MPI_Wtime()
          time_redist=time_redist+(d2-d1)


       return
       end subroutine ! datacast_dbl2

      subroutine CYC1D_CYC2D(n,a,lda,b,ldb, x_nnod, y_nnod, iret)
      implicit NONE
*
      include 'mpif.h'
      include 'commtxt.h'
*
      integer                 :: n,lda,ldb,iret
      real(8)                 :: a(lda,1), b(ldb,1)
      integer                 :: x_nnod, y_nnod
*
      real(8), pointer        :: work(:,:)
      integer                 :: world_size, my_rank, sq_size
      integer                 :: his_rank, her_rank
      integer                 :: his_posx, her_posx
      integer                 :: his_posy, her_posy
      integer                 :: my_posx, my_posy, my_posu, my_posv
      integer                 :: size_s,size_r
      integer                 :: nws, nqs
      integer                 :: i,j,k, ic,jc,kc,lc,id
*
      integer                 :: status(MPI_STATUS_SIZE)
      integer                 :: type
      integer                 :: comm
      integer                 :: tag
      integer                 :: req
      integer                 :: error
*
      iret = 0
*
      if ( n > lda ) then
         iret = 1
         return
      end if
*
*    [*,world_size] --> [y_nnod,x_nnod]
*     A(lda,nws) --> B(ldb,nqs)
*
      comm = MPI_COMM_EIGEN
      type = MPI_DOUBLE_PRECISION
      tag  = 10000
*
      call MPI_Comm_size(comm,world_size,error)
      call MPI_Comm_rank(comm,my_rank,error)
      my_rank = my_rank+1
!      sq_size=int(sqrt(dble(world_size)))
*
!      y_nnod = sq_size
!      x_nnod = world_size / y_nnod
      if ( x_nnod*y_nnod /= world_size ) then
         iret = 3
         return
      end if
*
      nws = (n-1)/world_size+1
      nqs = (n-1)/x_nnod+1
      if ( nqs > ldb ) then
         iret = 2
         return
      end if
*
!      if ( x_nnod > 1 ) then
         allocate(work(ldb,x_nnod), stat=error)
         if ( error /= 0 ) then
            iret = -1
            return
         end if
!      end if
*
!      my_posy = MOD(my_rank-1, y_nnod) + 1
!      my_posx =    (my_rank-1)/y_nnod  + 1
      my_posx = MOD(my_rank-1, x_nnod) + 1
      my_posy =    (my_rank-1)/x_nnod  + 1
      my_posu = MOD(my_rank-1, y_nnod) + 1
      my_posv =    (my_rank-1)/y_nnod  + 1
*
*
      call MPI_Barrier(comm,error)
*
      do ic=1,nws
*
         kc = my_rank+(ic-1)*world_size
         if ( kc <= n ) then
*
            do id=1,x_nnod
               his_posx = MOD(my_posv+id-2,x_nnod)+1
               size_s   =    (n-his_posx)/x_nnod+1
               do i=1,size_s
                  j = his_posx+(i-1)*x_nnod
                  work(i,id) = A(j,ic)
               end do
            end do
*
         end if
*
* BUCKET Algorithm
*
         do id=1,x_nnod
*-
            his_posx = MOD(my_posv+id-2,x_nnod)+1
            his_rank =    (his_posx-1)*1+(my_posu-1)*x_nnod+1

            if ( kc <= n ) then
               size_s = (n-his_posx)/x_nnod+1
            else
               size_s = 0
            end if

            if ( size_s > 0 ) then
               call MPI_Isend(work(1,id),size_s,type,
     &                     his_rank-1,tag,comm,req,error)
!             print*,"I am",my_rank,"Send ",his_rank,work(1:size_s,id)
            end if
*-
            her_posx = MOD(my_posx-1+x_nnod-id+1,x_nnod)+1
            her_rank =    (her_posx-1)*y_nnod+(my_posy-1)*1+1

            lc = her_rank+(ic-1)*world_size

            if ( lc <= n ) then
               size_r = (n-my_posx)/x_nnod+1
            else
               size_r = 0
            end if

            if ( size_r > 0 ) then
               jc = her_posx+(ic-1)*x_nnod
               call MPI_Recv(B(1,jc),size_r,type,
     &                     her_rank-1,tag,comm,status,error)
!             print*,"I am",my_rank,"Recv ",her_rank,B(1:size_r,jc),jc
            end if
*-
            if ( size_s > 0 ) then
               call MPI_Wait(req,status,error)
            end if
*-
         end do

      end do
*
      call MPI_Barrier(comm,error)
*
!      if ( x_nnod > 1 ) then
         deallocate(work)
!      end if
*
      return
      end
      subroutine CYC2D_CYC1D(n,a,lda,b,ldb, x_nnod, y_nnod, iret)
      implicit NONE
*
      include 'mpif.h'
      include 'commtxt.h'
*
      integer                 :: n,lda,ldb,iret
      real(8)                 :: a(lda,1), b(ldb,1)
      integer                 :: x_nnod, y_nnod
*
      real(8), pointer        :: work(:,:)
      integer                 :: world_size, my_rank, sq_size
      integer                 :: his_rank, her_rank
      integer                 :: his_posx, her_posx
      integer                 :: his_posy, her_posy
      integer                 :: my_posx, my_posy, my_posu, my_posv
      integer                 :: size_s,size_r
      integer                 :: nws, nqs
      integer                 :: i,j,k, ic,jc,kc,lc,id
*
      integer                 :: status(MPI_STATUS_SIZE)
      integer                 :: type
      integer                 :: comm
      integer                 :: tag
      integer                 :: req
      integer                 :: error
*
      iret = 0
*
      if ( n > lda ) then
         iret = 1
         return
      end if
*
*    [*,world_size] <-- [y_nnod,x_nnod]
*     A(lda,nws) <-- B(ldb,nqs)
*
      comm = MPI_COMM_EIGEN
      type = MPI_DOUBLE_PRECISION
      tag  = 10000
*
      call MPI_Comm_size(comm,world_size,error)
      call MPI_Comm_rank(comm,my_rank,error)
      my_rank = my_rank+1
!      sq_size = int(sqrt(dble(world_size)))
*
!      y_nnod = sq_size
!      x_nnod = world_size / y_nnod
      if ( x_nnod*y_nnod /= world_size ) then
         iret = 3
         return
      end if
*
      nws = (n-1)/world_size+1
      nqs = (n-1)/x_nnod+1
      if ( nqs > ldb ) then
         iret = 2
         return
      end if
*
!      if ( x_nnod > 1 ) then
         allocate(work(ldb,x_nnod), stat=error)
         if ( error /= 0 ) then
            iret = -1
            return
         end if
!      end if
*
!      my_posy = MOD(my_rank-1, y_nnod) + 1
!      my_posx =    (my_rank-1)/y_nnod  + 1
      my_posx = MOD(my_rank-1, x_nnod) + 1
      my_posy =    (my_rank-1)/x_nnod  + 1
      my_posu = MOD(my_rank-1, y_nnod) + 1
      my_posv =    (my_rank-1)/y_nnod  + 1
*
*
      call MPI_Barrier(comm,error)
*
      do ic=1,nws
*
         kc = my_rank+(ic-1)*world_size
*
* BUCKET Algorithm
*
         do id=1,x_nnod
*-
            her_posx = MOD(my_posx-1+x_nnod-id+1,x_nnod)+1
            her_rank =    (her_posx-1)*y_nnod+(my_posy-1)*1+1

            lc = her_rank+(ic-1)*world_size
            if ( lc <= n ) then
               size_r = (n-my_posx)/x_nnod+1
            else
               size_r = 0
            end if

            if ( size_r > 0 ) then
               jc = her_posx+(ic-1)*x_nnod
               call MPI_Isend(B(1,jc),size_r,type,
     &                     her_rank-1,tag,comm,req,error)
!              print*,"I am",my_rank,"Recv ",her_rank,B(1:size_r,jc)
            end if
*-
            his_posx = MOD(my_posv+id-2,x_nnod)+1
            his_rank =    (his_posx-1)*1+(my_posu-1)*x_nnod+1

            if ( kc <= n ) then
               size_s = (n-his_posx)/x_nnod+1
            else
               size_s = 0
            end if

            if ( size_s > 0 ) then
               call MPI_Recv(work(1,id),size_s,type,
     &                     his_rank-1,tag,comm,status,error)
!              print*,"I am",my_rank,"Send ",his_rank,work(1:size_s,id)
            end if
*-
            if ( size_r>0)then
               call MPI_Wait(req,status,error)
            end if
*-
         end do

         if ( kc <= n ) then
            do id=1,x_nnod
               his_posx = MOD(my_posv+id-2,x_nnod)+1
               size_s   =    (n-his_posx)/x_nnod+1
               do i=1,size_s
                  j = his_posx+(i-1)*x_nnod
                  A(j,ic) = work(i,id)
               end do
            end do
         end if
*
      end do
*
      call MPI_Barrier(comm,error)
*
!      if ( x_nnod > 1 ) then
         deallocate(work)
!      end if
*
      return
      end
      subroutine pcast_cyclic_real(u, a, nma, i_st, i_ed, comm)

      implicit NONE
      integer, intent(in)     :: nma, i_st, i_ed, comm
      real(8), intent(inout)  :: u(*),a(nma,*)

      include'mpif.h'

      real(8), pointer        :: buff(:)

      integer                 :: i_inod, i_nnod
      integer                 :: i_status(MPI_STATUS_SIZE), i_req
      integer, parameter      :: i_dtype = MPI_DOUBLE_PRECISION
      integer                 :: i_stat, i_err

      integer                 :: i_1, j_1
      integer                 :: i1, i2
      integer                 :: j1, j2, j3, j4, j5, j6
      integer                 :: im0, im1, im2, im3
      integer                 :: imid0, imid2
      integer                 :: iwidth, idisp, ilength
      integer                 :: idispr, idisps, icross
      integer                 :: ilhs, irhs


      if ( i_st > i_ed ) return

      call MPI_Comm_size(comm, i_nnod, i_err)
      call MPI_Comm_rank(comm, i_inod, i_err)
      i_inod  = i_inod+1

      if ( i_nnod == 1 ) then
         do i_1=i_st,i_ed
            u(i_1) = a(1,i_1)
         end do! i_1
         return
      end if

      i1 =    ((i_st-1)/i_nnod)+1
      j1 = MOD((i_st-1),i_nnod)+1
      i2 =    ((i_ed-1)/i_nnod)+1
      j2 = MOD((i_ed-1),i_nnod)+1
      iwidth = i2-i1+1

      imid2 = 2**(INT(LOG(DBLE(2*i_nnod-1))/LOG(2.00D+00)))
      imid0 = imid2/2

      allocate(buff(iwidth*imid2), stat=i_stat)
      if ( i_stat /= 0 ) then
         print*,"memory allocation error pcast"
         call mpi_abort(comm,1,i_err)
      end if

      idisp = (i_inod-1)*2*iwidth
      if ( i_inod > imid0 ) idisp = 0
      do i_1=1,iwidth
         buff(i_1+idisp) = a(1,i_1+i1-1)
      end do! i_1

      if ( i_inod <= imid0 ) then
         if ( i_inod+imid0 <= i_nnod ) then
            call mpi_recv(
     1          buff(1+idisp+iwidth),
     2          iwidth, i_dtype, (i_inod+imid0)-1,
     3          90, comm, i_status, i_err)
         end if

         im0 = 1
         do
            if ( im0 >= imid0 ) exit

            im2 = im0
            im0 = im0*2
            im1 = MOD((i_inod-1),im0)+1
            im3 =    ((i_inod-1)/im0)+1
            ilength = (iwidth*im0)

            if ( im1 <= im2 ) then
               idisps = (im3-1)*ilength*2
               idispr = idisps +ilength
               icross = i_inod+im2-1
            else
               idispr = (im3-1)*ilength*2
               idisps = idispr +ilength
               icross = i_inod-im2-1
            end if

            call mpi_isend(
     1          buff(1+idisps),
     2          ilength, i_dtype, icross,
     3          100+im0, comm, i_req, i_err)
            call mpi_recv(
     1          buff(1+idispr),
     2          ilength, i_dtype, icross,
     3          100+im0, comm, i_status, i_err)
            call mpi_wait(i_req, i_status, i_err)

         end do!!

         if ( i_inod+imid0 <= i_nnod ) then
            ilength = iwidth*imid2
            call mpi_send(
     1          buff(1),
     2          ilength, i_dtype, (i_inod+imid0)-1,
     3          95, comm, i_err)
         endif
      else
            call mpi_send(
     1          buff(1),
     2          iwidth, i_dtype, (i_inod-imid0)-1,
     3          90, comm, i_err)
            ilength = iwidth*imid2
            call mpi_recv(
     1          buff(1),
     2          ilength, i_dtype, (i_inod-imid0)-1,
     3          95, comm, i_status, i_err)
      endif

      if ( iwidth /= 1 ) then

         do j_1=1,imid0
         do i_1=2,iwidth-1
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! i_1
         end do! j_1
         i_1=1
         do j_1=j1,imid0
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! j_1
         i_1=iwidth
         do j_1=1,MIN(imid0,j2)
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! j_1

         j4 = i_nnod-imid0
         j5 = MAX(1,j1-imid0)
         j6 = MIN(j4,j2-imid0)

         do j_1=1,j4
         do i_1=2,iwidth-1
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! i_1
         end do! j_1
         i_1=1
         do j_1=j5,j4
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! j_1
         i_1=iwidth
         do j_1=1,j6
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! j_1

      else

         do i_1=j1,MIN(j2,imid0)
            u(i_1      ) = buff(2*i_1-1)
         end do! i_1
         do i_1=1,j2-imid0
            u(i_1+imid0) = buff(2*i_1  )
         end do! i_1

      end if

      deallocate(buff)

      return
      end subroutine ! pcast_cyclic_real

      subroutine pcast_cyclic_int(u, a, nma, i_st, i_ed, comm)

      implicit NONE
      integer, intent(in)     :: nma, i_st, i_ed, comm
      integer, intent(inout)  :: u(*),a(nma,*)

      include'mpif.h'

      integer, pointer        :: buff(:)

      integer                 :: i_inod, i_nnod
      integer                 :: i_status(MPI_STATUS_SIZE), i_req
      integer, parameter      :: i_dtype = MPI_INTEGER
      integer                 :: i_stat, i_err

      integer                 :: i_1, j_1
      integer                 :: i1, i2
      integer                 :: j1, j2, j3, j4, j5, j6
      integer                 :: im0, im1, im2, im3
      integer                 :: imid0, imid2
      integer                 :: iwidth, idisp, ilength
      integer                 :: idispr, idisps, icross
      integer                 :: ilhs, irhs


      if ( i_st > i_ed ) return

      call MPI_Comm_size(comm, i_nnod, i_err)
      call MPI_Comm_rank(comm, i_inod, i_err)
      i_inod  = i_inod+1

      if ( i_nnod == 1 ) then
         do i_1=i_st,i_ed
            u(i_1) = a(1,i_1)
         end do! i_1
         return
      end if

      i1 =    ((i_st-1)/i_nnod)+1
      j1 = MOD((i_st-1),i_nnod)+1
      i2 =    ((i_ed-1)/i_nnod)+1
      j2 = MOD((i_ed-1),i_nnod)+1
      iwidth = i2-i1+1

      imid2 = 2**(INT(LOG(DBLE(2*i_nnod-1))/LOG(2.00D+00)))
      imid0 = imid2/2

      allocate(buff(iwidth*imid2), stat=i_stat)
      if ( i_stat /= 0 ) then
         print*,"memory allocation error pcast"
         call mpi_abort(comm,1,i_err)
      end if

      idisp = (i_inod-1)*2*iwidth
      if ( i_inod > imid0 ) idisp = 0
      do i_1=1,iwidth
         buff(i_1+idisp) = a(1,i_1+i1-1)
      end do! i_1

      if ( i_inod <= imid0 ) then
         if ( i_inod+imid0 <= i_nnod ) then
            call mpi_recv(
     1          buff(1+idisp+iwidth),
     2          iwidth, i_dtype, (i_inod+imid0)-1,
     3          90, comm, i_status, i_err)
         end if

         im0 = 1
         do
            if ( im0 >= imid0 ) exit

            im2 = im0
            im0 = im0*2
            im1 = MOD((i_inod-1),im0)+1
            im3 =    ((i_inod-1)/im0)+1
            ilength = (iwidth*im0)

            if ( im1 <= im2 ) then
               idisps = (im3-1)*ilength*2
               idispr = idisps +ilength
               icross = i_inod+im2-1
            else
               idispr = (im3-1)*ilength*2
               idisps = idispr +ilength
               icross = i_inod-im2-1
            end if

            call mpi_isend(
     1          buff(1+idisps),
     2          ilength, i_dtype, icross,
     3          100+im0, comm, i_req, i_err)
            call mpi_recv(
     1          buff(1+idispr),
     2          ilength, i_dtype, icross,
     3          100+im0, comm, i_status, i_err)
            call mpi_wait(i_req, i_status, i_err)

         end do!!

         if ( i_inod+imid0 <= i_nnod ) then
            ilength = iwidth*imid2
            call mpi_send(
     1          buff(1),
     2          ilength, i_dtype, (i_inod+imid0)-1,
     3          95, comm, i_err)
         endif
      else
            call mpi_send(
     1          buff(1),
     2          iwidth, i_dtype, (i_inod-imid0)-1,
     3          90, comm, i_err)
            ilength = iwidth*imid2
            call mpi_recv(
     1          buff(1),
     2          ilength, i_dtype, (i_inod-imid0)-1,
     3          95, comm, i_status, i_err)
      endif

      if ( iwidth /= 1 ) then

         do j_1=1,imid0
         do i_1=2,iwidth-1
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! i_1
         end do! j_1
         i_1=1
         do j_1=j1,imid0
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! j_1
         i_1=iwidth
         do j_1=1,MIN(imid0,j2)
            ilhs = (i_1-1)*i_nnod+j_1
            irhs = i_1+(j_1-1)*(2*iwidth)
            u(ilhs) = buff(irhs)
         end do! j_1

         j4 = i_nnod-imid0
         j5 = MAX(1,j1-imid0)
         j6 = MIN(j4,j2-imid0)

         do j_1=1,j4
         do i_1=2,iwidth-1
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! i_1
         end do! j_1
         i_1=1
         do j_1=j5,j4
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! j_1
         i_1=iwidth
         do j_1=1,j6
            ilhs = (i_1-1)*i_nnod+j_1+imid0
            irhs = i_1+(j_1-1)*(2*iwidth)+iwidth
            u(ilhs) = buff(irhs)
         end do! j_1

      else

         do i_1=j1,MIN(j2,imid0)
            u(i_1      ) = buff(2*i_1-1)
         end do! i_1
         do i_1=1,j2-imid0
            u(i_1+imid0) = buff(2*i_1  )
         end do! i_1

      end if

      deallocate(buff)

      return
      end subroutine ! pcast_cyclic_int

#ifdef HIUX
*OPTION MP(P(0))
#endif
!=======================================================================
!
!  PROGRAM  PHASE/0 2016.01 ($Rev: 570 $)
!
!  SUBROUINE: heap_sort, swap
!
!  AUTHOR: Takenori Yamamotoi   June/01/2003
!  
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!  
!
!
!=======================================================================
!
! coded by Takenori YAMAMOTO (Univ. Tokyo) for gen_rgrid in m_SpecialKpoints
! at Jun. 1, 2003
!
subroutine  heap_sort(m,n,a,key)
! $Id: heap_sort.F90 570 2017-04-21 20:34:50Z yamasaki $
!
! Heap sorting
! a(M,N) : array of M-componet vectors
! key    : key componet for sorting 
!
implicit none

integer(4), intent(in) :: m,n,key
real(8), intent(inout) :: a(m,n)

integer(4) :: i,j,k,itmp
real(8) :: tmp(m)

!*** initiation: heapify a ***
do i=2,n
  tmp(1:m)=a(1:m,i)
  j=i
10 itmp=j/2
  if(a(key,itmp).ge.tmp(key)) go to 20
  a(1:m,j)=a(1:m,itmp)
  j=itmp
  if(j.gt.1) go to 10
20 a(1:m,j)=tmp(1:m)
end do
!*** to be fully sort ***
do k=n-1,1,-1
  call swap(a(1,1),a(1,k+1))
  tmp(1:m)=a(1:m,1)
  j=1
  itmp=2
30 if(itmp.gt.k) go to 40
  if(itmp.lt.k) then
    if(a(key,itmp+1).gt.a(key,itmp)) itmp=itmp+1
  end if
  if(tmp(key).ge.a(key,itmp)) go to 40
  a(1:m,j)=a(1:m,itmp)
  j=itmp
  itmp=j*2
  go to 30
40 a(1:m,j)=tmp(1:m)
end do

return

contains

!*** swap ***
subroutine swap(a,b)

implicit none

real(8), intent(inout) :: a(m),b(m)
real(8) :: tmp(m)

tmp(1:m)=a(1:m)
a(1:m)=b(1:m)
b(1:m)=tmp(1:m)

return
end subroutine swap

end subroutine heap_sort

#!/bin/sh
nc=65
ic=3.3
dc=0.1
for v in `seq 1 $nc`; do
  c=$( echo \($v-1\)*$dc+$ic | bc -l )
  mkdir -p c$c
  cp -r file_names.data c$c/
  sed "s/__C__/${c}/g" nfinp.data > c$c/nfinp.data
  cd c$c/
  mpiexec -n 1 ../../../../../bin/phase
  cd ../
  echo -n $c >> nfefn.data ; tail -1 c$c/nfefn.data >> nfefn.data
done

#!/bin/bash
erange=" -erange -13,9" #energy range
einc="-einc 1.0" #scale of energy tics
imrfont="-imrfont Helvetica,18"#font of irreducible representation
ticsfont="-ticsfont Helvetica,10"
#color of irreducible representation (two methods)
#imrcolor="-imrcolor #545422" #1st way
imrcolor2="-imrcolor blue" #2nd way
#color of line (two methods)
#linecolor="-linecolor #545422" # 1st way
linecolor2="-linecolor red" #2nd way
imrtype="-imrtype mulliken" #type of representation
#nonecross="-nonecross" #turn off band crossing method 
#kgrouptype="-kgrouptype Schoenflies" #kgroup type
withfermi="-with_fermi nfefermi.data" #using fermi energy
numimr="-numimr 0.15" 
offset="-offset 0.5"
perl band_symm.pl reduce.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${nonecross} ${kgrouptype} ${withfermi} ${numimr} ${offset}
#perl ${HOME}/band_symm/perl/band_symm.pl reduce.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${noncross} ${kgrouptype} ${withfermi} ${numimr}

#!/bin/sh
#
E0=`tail -1 q_0/nfefn.data | awk '{print $3}'`
#
echo "# q  vbm [eV}"
for n in q*
do
    E1=`tail -1 $n/nfefn.data | awk '{print $3}'`
    dq=`echo $n | sed -e 's/q_//g'`
    if [ $dq != 0 ];then
	vbm=`echo $E0 $E1 $dq | awk '{print ($1-$2)/$3*27.2116}'`
	echo $dq $vbm
    fi
done

    

#!/bin/sh
# Shell script for checking PHASE and EKCAL
# Copyright (C) T.Yamamoto

echo "Checking total-energy calculation."
cd scf
rm -f cont*
rm -f output*
../../bin/phase
etot=`grep TH output000 | tail -1 | awk '{print $7}'`
eref="-7.897015064593"
echo " Total energy : ${etot} Hartree/cell"
echo " Reference    : ${eref} Hartree/cell"
rm -f cont* nfdynm* nfefn* nfstop* zaj*
mv -f nfchgt.data ../dos/

echo "Checking band-energy calculation."
cd ../dos
rm -f output*
../../bin/ekcal
vbme=`grep Valence nfenergy.data | awk '{print $5}'`
eref="0.233847"
echo " Valence band maximum : ${vbme} Hartree"
echo " Reference            : ${eref} Hartree"
rm -f cont* dos* nfchgt* nfenergy* nfstop* zaj*

#!/bin/bash

#PBS -q S
#PBS -l ncpus=1
#PBS -l nodes=1:ppn=1

cd $PBS_O_WORKDIR
#phase=$HOME/phase_v900/bin/phase
phase=/s0/home2/jkoga/phase_dev/phase_beta/phase_v900/bin/phase

# (1) DFT
cd PBE
$phase >& log

# (2) Hybrid DFT
cd ../PBE0
cp ../PBE/nfchgt.data .
cp ../PBE/zaj.data .
$phase >& log

#imrcolor,lincolorは2通りの指定方法(linecolor,linecolor2)のうち片方を使う
erange=" -erange -13,15"
#erange=" -erange 0,4"
einc="-einc 1.0"
imrfont="-imrfont Helvetica,14"
#ticsfont="-ticsfont Helvetica,10"
#imrcolor="-imrcolor #545422"
imrcolor2="-imrcolor blue"
#linecolor="-linecolor #545422"
linecolor2="-linecolor red"
imrtype="-imrtype mulliken"
-nonecross="-nonecross"
#kgrouptype="-kgrouptype Schoenflies"
withfermi="-with_fermi nfefermi.data"
numimr="-numimr 0.1"
perl ~/phase/band_symm.09.2016test/perl/band_symm.pl reduce_up.data ${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${nonecross} ${kgrouptype} ${withfermi} ${numimr}
echo "${erange} ${einc} ${imrfont} ${ticsfont} ${imrcolor} ${imrcolor2} ${linecolor} ${linecolor2} ${imrtype} ${nonecross} ${kgrouptype} ${withfermi} ${numimr}"
mv band_reduce.eps band_up.eps
